/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/platform","vs/base/common/errors","vs/base/common/lifecycle","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/event","vs/base/common/assert","vs/base/common/objects","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/types","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/editor/common/diff/linesDiffComputers","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],x=function(q){for(var n=[],D=0,t=q.length;D<t;D++)n[D]=J[q[D]];return n},Ce=this,Oe=typeof global=="object"?global:{},ue;(function(q){q.global=Ce;var n=function(){function D(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(D.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(D.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),D.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=D._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof q.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")},D._isWindows=function(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1},D}();q.Environment=n})(ue||(ue={}));var ue;(function(q){var n=function(){function P(u,_,m){this.type=u,this.detail=_,this.timestamp=m}return P}();q.LoaderEvent=n;var D=function(){function P(u){this._events=[new n(1,"",u)]}return P.prototype.record=function(u,_){this._events.push(new n(u,_,q.Utilities.getHighPerformanceTimestamp()))},P.prototype.getEvents=function(){return this._events},P}();q.LoaderEventRecorder=D;var t=function(){function P(){}return P.prototype.record=function(u,_){},P.prototype.getEvents=function(){return[]},P.INSTANCE=new P,P}();q.NullLoaderEventRecorder=t})(ue||(ue={}));var ue;(function(q){var n=function(){function D(){}return D.fileUriToFilePath=function(t,P){if(P=decodeURI(P).replace(/%23/g,"#"),t){if(/^file:\/\/\//.test(P))return P.substr(8);if(/^file:\/\//.test(P))return P.substr(5)}else if(/^file:\/\//.test(P))return P.substr(7);return P},D.startsWith=function(t,P){return t.length>=P.length&&t.substr(0,P.length)===P},D.endsWith=function(t,P){return t.length>=P.length&&t.substr(t.length-P.length)===P},D.containsQueryString=function(t){return/^[^\#]*\?/gi.test(t)},D.isAbsolutePath=function(t){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(t)},D.forEachProperty=function(t,P){if(t){var u=void 0;for(u in t)t.hasOwnProperty(u)&&P(u,t[u])}},D.isEmpty=function(t){var P=!0;return D.forEachProperty(t,function(){P=!1}),P},D.recursiveClone=function(t){if(!t||typeof t!="object"||t instanceof RegExp||!Array.isArray(t)&&Object.getPrototypeOf(t)!==Object.prototype)return t;var P=Array.isArray(t)?[]:{};return D.forEachProperty(t,function(u,_){_&&typeof _=="object"?P[u]=D.recursiveClone(_):P[u]=_}),P},D.generateAnonymousModule=function(){return"===anonymous"+D.NEXT_ANONYMOUS_ID+++"==="},D.isAnonymousModule=function(t){return D.startsWith(t,"===anonymous")},D.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=q.global.performance&&typeof q.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?q.global.performance.now():Date.now()},D.NEXT_ANONYMOUS_ID=1,D.PERFORMANCE_NOW_PROBED=!1,D.HAS_PERFORMANCE_NOW=!1,D}();q.Utilities=n})(ue||(ue={}));var ue;(function(q){function n(P){if(P instanceof Error)return P;var u=new Error(P.message||String(P)||"Unknown Error");return P.stack&&(u.stack=P.stack),u}q.ensureError=n;var D=function(){function P(){}return P.validateConfigurationOptions=function(u){function _(a){if(a.phase==="loading"){console.error('Loading "'+a.moduleId+'" failed'),console.error(a),console.error("Here are the modules that depend on it:"),console.error(a.neededBy);return}if(a.phase==="factory"){console.error('The factory function of "'+a.moduleId+'" has thrown an exception'),console.error(a),console.error("Here are the modules that depend on it:"),console.error(a.neededBy);return}}if(u=u||{},typeof u.baseUrl!="string"&&(u.baseUrl=""),typeof u.isBuild!="boolean"&&(u.isBuild=!1),typeof u.paths!="object"&&(u.paths={}),typeof u.config!="object"&&(u.config={}),typeof u.catchError>"u"&&(u.catchError=!1),typeof u.recordStats>"u"&&(u.recordStats=!1),typeof u.urlArgs!="string"&&(u.urlArgs=""),typeof u.onError!="function"&&(u.onError=_),Array.isArray(u.ignoreDuplicateModules)||(u.ignoreDuplicateModules=[]),u.baseUrl.length>0&&(q.Utilities.endsWith(u.baseUrl,"/")||(u.baseUrl+="/")),typeof u.cspNonce!="string"&&(u.cspNonce=""),typeof u.preferScriptTags>"u"&&(u.preferScriptTags=!1),u.nodeCachedData&&typeof u.nodeCachedData=="object"&&(typeof u.nodeCachedData.seed!="string"&&(u.nodeCachedData.seed="seed"),(typeof u.nodeCachedData.writeDelay!="number"||u.nodeCachedData.writeDelay<0)&&(u.nodeCachedData.writeDelay=1e3*7),!u.nodeCachedData.path||typeof u.nodeCachedData.path!="string")){var m=n(new Error("INVALID cached data configuration, 'path' MUST be set"));m.phase="configuration",u.onError(m),u.nodeCachedData=void 0}return u},P.mergeConfigurationOptions=function(u,_){u===void 0&&(u=null),_===void 0&&(_=null);var m=q.Utilities.recursiveClone(_||{});return q.Utilities.forEachProperty(u,function(a,h){a==="ignoreDuplicateModules"&&typeof m.ignoreDuplicateModules<"u"?m.ignoreDuplicateModules=m.ignoreDuplicateModules.concat(h):a==="paths"&&typeof m.paths<"u"?q.Utilities.forEachProperty(h,function(A,R){return m.paths[A]=R}):a==="config"&&typeof m.config<"u"?q.Utilities.forEachProperty(h,function(A,R){return m.config[A]=R}):m[a]=q.Utilities.recursiveClone(h)}),P.validateConfigurationOptions(m)},P}();q.ConfigurationOptionsUtil=D;var t=function(){function P(u,_){if(this._env=u,this.options=D.mergeConfigurationOptions(_),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var m=this.options.nodeRequire.main.filename,a=Math.max(m.lastIndexOf("/"),m.lastIndexOf("\\"));this.options.baseUrl=m.substring(0,a+1)}}return P.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var u=0;u<this.options.ignoreDuplicateModules.length;u++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[u]]=!0},P.prototype._createSortedPathsRules=function(){var u=this;this.sortedPathsRules=[],q.Utilities.forEachProperty(this.options.paths,function(_,m){Array.isArray(m)?u.sortedPathsRules.push({from:_,to:m}):u.sortedPathsRules.push({from:_,to:[m]})}),this.sortedPathsRules.sort(function(_,m){return m.from.length-_.from.length})},P.prototype.cloneAndMerge=function(u){return new P(this._env,D.mergeConfigurationOptions(u,this.options))},P.prototype.getOptionsLiteral=function(){return this.options},P.prototype._applyPaths=function(u){for(var _,m=0,a=this.sortedPathsRules.length;m<a;m++)if(_=this.sortedPathsRules[m],q.Utilities.startsWith(u,_.from)){for(var h=[],A=0,R=_.to.length;A<R;A++)h.push(_.to[A]+u.substr(_.from.length));return h}return[u]},P.prototype._addUrlArgsToUrl=function(u){return q.Utilities.containsQueryString(u)?u+"&"+this.options.urlArgs:u+"?"+this.options.urlArgs},P.prototype._addUrlArgsIfNecessaryToUrl=function(u){return this.options.urlArgs?this._addUrlArgsToUrl(u):u},P.prototype._addUrlArgsIfNecessaryToUrls=function(u){if(this.options.urlArgs)for(var _=0,m=u.length;_<m;_++)u[_]=this._addUrlArgsToUrl(u[_]);return u},P.prototype.moduleIdToPaths=function(u){if(this._env.isNode){var _=this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(u);if(_)return this.isBuild()?["empty:"]:["node|"+u]}var m=u,a;if(!q.Utilities.endsWith(m,".js")&&!q.Utilities.isAbsolutePath(m)){a=this._applyPaths(m);for(var h=0,A=a.length;h<A;h++)this.isBuild()&&a[h]==="empty:"||(q.Utilities.isAbsolutePath(a[h])||(a[h]=this.options.baseUrl+a[h]),!q.Utilities.endsWith(a[h],".js")&&!q.Utilities.containsQueryString(a[h])&&(a[h]=a[h]+".js"))}else!q.Utilities.endsWith(m,".js")&&!q.Utilities.containsQueryString(m)&&(m=m+".js"),a=[m];return this._addUrlArgsIfNecessaryToUrls(a)},P.prototype.requireToUrl=function(u){var _=u;return q.Utilities.isAbsolutePath(_)||(_=this._applyPaths(_)[0],q.Utilities.isAbsolutePath(_)||(_=this.options.baseUrl+_)),this._addUrlArgsIfNecessaryToUrl(_)},P.prototype.isBuild=function(){return this.options.isBuild},P.prototype.shouldInvokeFactory=function(u){return!!(!this.options.isBuild||q.Utilities.isAnonymousModule(u)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[u])},P.prototype.isDuplicateMessageIgnoredFor=function(u){return this.ignoreDuplicateModulesMap.hasOwnProperty(u)},P.prototype.getConfigForModule=function(u){if(this.options.config)return this.options.config[u]},P.prototype.shouldCatchError=function(){return this.options.catchError},P.prototype.shouldRecordStats=function(){return this.options.recordStats},P.prototype.onError=function(u){this.options.onError(u)},P}();q.Configuration=t})(ue||(ue={}));var ue;(function(q){var n=function(){function a(h){this._env=h,this._scriptLoader=null,this._callbackMap={}}return a.prototype.load=function(h,A,R,N){var v=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new P;else if(this._env.isElectronRenderer){var e=h.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new D:this._scriptLoader=new u(this._env)}else this._env.isNode?this._scriptLoader=new u(this._env):this._scriptLoader=new D;var E={callback:R,errorback:N};if(this._callbackMap.hasOwnProperty(A)){this._callbackMap[A].push(E);return}this._callbackMap[A]=[E],this._scriptLoader.load(h,A,function(){return v.triggerCallback(A)},function(F){return v.triggerErrorback(A,F)})},a.prototype.triggerCallback=function(h){var A=this._callbackMap[h];delete this._callbackMap[h];for(var R=0;R<A.length;R++)A[R].callback()},a.prototype.triggerErrorback=function(h,A){var R=this._callbackMap[h];delete this._callbackMap[h];for(var N=0;N<R.length;N++)R[N].errorback(A)},a}(),D=function(){function a(){}return a.prototype.attachListeners=function(h,A,R){var N=function(){h.removeEventListener("load",v),h.removeEventListener("error",e)},v=function(E){N(),A()},e=function(E){N(),R(E)};h.addEventListener("load",v),h.addEventListener("error",e)},a.prototype.load=function(h,A,R,N){if(/^node\|/.test(A)){var v=h.getConfig().getOptionsLiteral(),e=_(h.getRecorder(),v.nodeRequire||q.global.nodeRequire),E=A.split("|"),F=null;try{F=e(E[1])}catch(b){N(b);return}h.enqueueDefineAnonymousModule([],function(){return F}),R()}else{var y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript"),this.attachListeners(y,R,N);var L=h.getConfig().getOptionsLiteral().trustedTypesPolicy;L&&(A=L.createScriptURL(A)),y.setAttribute("src",A);var d=h.getConfig().getOptionsLiteral().cspNonce;d&&y.setAttribute("nonce",d),document.getElementsByTagName("head")[0].appendChild(y)}},a}();function t(a){var h=a.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var A=h?self.eval(h.createScript("","true")):new Function("true");return A.call(self),!0}catch{return!1}}var P=function(){function a(){this._cachedCanUseEval=null}return a.prototype._canUseEval=function(h){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=t(h)),this._cachedCanUseEval},a.prototype.load=function(h,A,R,N){if(/^node\|/.test(A)){var v=h.getConfig().getOptionsLiteral(),e=_(h.getRecorder(),v.nodeRequire||q.global.nodeRequire),E=A.split("|"),F=null;try{F=e(E[1])}catch(d){N(d);return}h.enqueueDefineAnonymousModule([],function(){return F}),R()}else{var y=h.getConfig().getOptionsLiteral().trustedTypesPolicy,L=/^((http:)|(https:)|(file:))/.test(A)&&A.substring(0,self.origin.length)!==self.origin;if(!L&&this._canUseEval(h)){fetch(A).then(function(d){if(d.status!==200)throw new Error(d.statusText);return d.text()}).then(function(d){d=d+`
//# sourceURL=`+A;var b=y?self.eval(y.createScript("",d)):new Function(d);b.call(self),R()}).then(void 0,N);return}try{y&&(A=y.createScriptURL(A)),importScripts(A),R()}catch(d){N(d)}}},a}(),u=function(){function a(h){this._env=h,this._didInitialize=!1,this._didPatchNodeRequire=!1}return a.prototype._init=function(h){this._didInitialize||(this._didInitialize=!0,this._fs=h("fs"),this._vm=h("vm"),this._path=h("path"),this._crypto=h("crypto"))},a.prototype._initNodeRequire=function(h,A){var R=A.getConfig().getOptionsLiteral().nodeCachedData;if(!R||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var N=this,v=h("module");function e(E){var F=E.constructor,y=function(d){try{return E.require(d)}finally{}};return y.resolve=function(d,b){return F._resolveFilename(d,E,!1,b)},y.resolve.paths=function(d){return F._resolveLookupPaths(d,E)},y.main=process.mainModule,y.extensions=F._extensions,y.cache=F._cache,y}v.prototype._compile=function(E,F){var y=v.wrap(E.replace(/^#!.*/,"")),L=A.getRecorder(),d=N._getCachedDataPath(R,F),b={filename:F},l;try{var r=N._fs.readFileSync(d);l=r.slice(0,16),b.cachedData=r.slice(16),L.record(60,d)}catch{L.record(61,d)}var s=new N._vm.Script(y,b),g=s.runInThisContext(b),c=N._path.dirname(F),p=e(this),w=[this.exports,p,this,F,c,process,Oe,Buffer],f=g.apply(this.exports,w);return N._handleCachedData(s,y,d,!b.cachedData,A),N._verifyCachedData(s,y,d,l,A),f}},a.prototype.load=function(h,A,R,N){var v=this,e=h.getConfig().getOptionsLiteral(),E=_(h.getRecorder(),e.nodeRequire||q.global.nodeRequire),F=e.nodeInstrumenter||function(g){return g};this._init(E),this._initNodeRequire(E,h);var y=h.getRecorder();if(/^node\|/.test(A)){var L=A.split("|"),d=null;try{d=E(L[1])}catch(g){N(g);return}h.enqueueDefineAnonymousModule([],function(){return d}),R()}else{A=q.Utilities.fileUriToFilePath(this._env.isWindows,A);var b=this._path.normalize(A),l=this._getElectronRendererScriptPathOrUri(b),r=Boolean(e.nodeCachedData),s=r?this._getCachedDataPath(e.nodeCachedData,A):void 0;this._readSourceAndCachedData(b,s,y,function(g,c,p,w){if(g){N(g);return}var f;c.charCodeAt(0)===a._BOM?f=a._PREFIX+c.substring(1)+a._SUFFIX:f=a._PREFIX+c+a._SUFFIX,f=F(f,b);var o={filename:l,cachedData:p},M=v._createAndEvalScript(h,f,o,R,N);v._handleCachedData(M,f,s,r&&!p,h),v._verifyCachedData(M,f,s,w,h)})}},a.prototype._createAndEvalScript=function(h,A,R,N,v){var e=h.getRecorder();e.record(31,R.filename);var E=new this._vm.Script(A,R),F=E.runInThisContext(R),y=h.getGlobalAMDDefineFunc(),L=!1,d=function(){return L=!0,y.apply(null,arguments)};return d.amd=y.amd,F.call(q.global,h.getGlobalAMDRequireFunc(),d,R.filename,this._path.dirname(R.filename)),e.record(32,R.filename),L?N():v(new Error("Didn't receive define call in "+R.filename+"!")),E},a.prototype._getElectronRendererScriptPathOrUri=function(h){if(!this._env.isElectronRenderer)return h;var A=h.match(/^([a-z])\:(.*)/i);return A?"file:///"+(A[1].toUpperCase()+":"+A[2]).replace(/\\/g,"/"):"file://"+h},a.prototype._getCachedDataPath=function(h,A){var R=this._crypto.createHash("md5").update(A,"utf8").update(h.seed,"utf8").update(process.arch,"").digest("hex"),N=this._path.basename(A).replace(/\.js$/,"");return this._path.join(h.path,N+"-"+R+".code")},a.prototype._handleCachedData=function(h,A,R,N,v){var e=this;h.cachedDataRejected?this._fs.unlink(R,function(E){v.getRecorder().record(62,R),e._createAndWriteCachedData(h,A,R,v),E&&v.getConfig().onError(E)}):N&&this._createAndWriteCachedData(h,A,R,v)},a.prototype._createAndWriteCachedData=function(h,A,R,N){var v=this,e=Math.ceil(N.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),E=-1,F=0,y=void 0,L=function(){setTimeout(function(){y||(y=v._crypto.createHash("md5").update(A,"utf8").digest());var d=h.createCachedData();if(!(d.length===0||d.length===E||F>=5)){if(d.length<E){L();return}E=d.length,v._fs.writeFile(R,Buffer.concat([y,d]),function(b){b&&N.getConfig().onError(b),N.getRecorder().record(63,R),L()})}},e*Math.pow(4,F++))};L()},a.prototype._readSourceAndCachedData=function(h,A,R,N){if(!A)this._fs.readFile(h,{encoding:"utf8"},N);else{var v=void 0,e=void 0,E=void 0,F=2,y=function(L){L?N(L):--F===0&&N(void 0,v,e,E)};this._fs.readFile(h,{encoding:"utf8"},function(L,d){v=d,y(L)}),this._fs.readFile(A,function(L,d){!L&&d&&d.length>0?(E=d.slice(0,16),e=d.slice(16),R.record(60,A)):R.record(61,A),y()})}},a.prototype._verifyCachedData=function(h,A,R,N,v){var e=this;!N||h.cachedDataRejected||setTimeout(function(){var E=e._crypto.createHash("md5").update(A,"utf8").digest();N.equals(E)||(v.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+R+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(R,function(F){F&&v.getConfig().onError(F)}))},Math.ceil(5e3*(1+Math.random())))},a._BOM=65279,a._PREFIX="(function (require, define, __filename, __dirname) { ",a._SUFFIX=`
});`,a}();function _(a,h){if(h.__$__isRecorded)return h;var A=function(N){a.record(33,N);try{return h(N)}finally{a.record(34,N)}};return A.__$__isRecorded=!0,A}q.ensureRecordedNodeRequire=_;function m(a){return new n(a)}q.createScriptLoader=m})(ue||(ue={}));var ue;(function(q){var n=function(){function m(a){var h=a.lastIndexOf("/");h!==-1?this.fromModulePath=a.substr(0,h+1):this.fromModulePath=""}return m._normalizeModuleId=function(a){var h=a,A;for(A=/\/\.\//;A.test(h);)h=h.replace(A,"/");for(h=h.replace(/^\.\//g,""),A=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;A.test(h);)h=h.replace(A,"/");return h=h.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),h},m.prototype.resolveModule=function(a){var h=a;return q.Utilities.isAbsolutePath(h)||(q.Utilities.startsWith(h,"./")||q.Utilities.startsWith(h,"../"))&&(h=m._normalizeModuleId(this.fromModulePath+h)),h},m.ROOT=new m(""),m}();q.ModuleIdResolver=n;var D=function(){function m(a,h,A,R,N,v){this.id=a,this.strId=h,this.dependencies=A,this._callback=R,this._errorback=N,this.moduleIdResolver=v,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return m._safeInvokeFunction=function(a,h){try{return{returnedValue:a.apply(q.global,h),producedError:null}}catch(A){return{returnedValue:null,producedError:A}}},m._invokeFactory=function(a,h,A,R){return a.shouldInvokeFactory(h)?a.shouldCatchError()?this._safeInvokeFunction(A,R):{returnedValue:A.apply(q.global,R),producedError:null}:{returnedValue:null,producedError:null}},m.prototype.complete=function(a,h,A,R){this._isComplete=!0;var N=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);var v=m._invokeFactory(h,this.strId,this._callback,A);N=v.producedError,a.record(22,this.strId),!N&&typeof v.returnedValue<"u"&&(!this.exportsPassedIn||q.Utilities.isEmpty(this.exports))&&(this.exports=v.returnedValue)}else this.exports=this._callback;if(N){var e=q.ensureError(N);e.phase="factory",e.moduleId=this.strId,e.neededBy=R(this.id),this.error=e,h.onError(e)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},m.prototype.onDependencyError=function(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1},m.prototype.isComplete=function(){return this._isComplete},m}();q.Module=D;var t=function(){function m(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return m.prototype.getMaxModuleId=function(){return this._nextId},m.prototype.getModuleId=function(a){var h=this._strModuleIdToIntModuleId.get(a);return typeof h>"u"&&(h=this._nextId++,this._strModuleIdToIntModuleId.set(a,h),this._intModuleIdToStrModuleId[h]=a),h},m.prototype.getStrModuleId=function(a){return this._intModuleIdToStrModuleId[a]},m}(),P=function(){function m(a){this.id=a}return m.EXPORTS=new m(0),m.MODULE=new m(1),m.REQUIRE=new m(2),m}();q.RegularDependency=P;var u=function(){function m(a,h,A){this.id=a,this.pluginId=h,this.pluginParam=A}return m}();q.PluginDependency=u;var _=function(){function m(a,h,A,R,N){N===void 0&&(N=0),this._env=a,this._scriptLoader=h,this._loaderAvailableTimestamp=N,this._defineFunc=A,this._requireFunc=R,this._moduleIdProvider=new t,this._config=new q.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return m.prototype.reset=function(){return new m(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},m.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},m.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},m._findRelevantLocationInStack=function(a,h){for(var A=function(b){return b.replace(/\\/g,"/")},R=A(a),N=h.split(/\n/),v=0;v<N.length;v++){var e=N[v].match(/(.*):(\d+):(\d+)\)?$/);if(e){var E=e[1],F=e[2],y=e[3],L=Math.max(E.lastIndexOf(" ")+1,E.lastIndexOf("(")+1);if(E=E.substr(L),E=A(E),E===R){var d={line:parseInt(F,10),col:parseInt(y,10)};return d.line===1&&(d.col-=53),d}}}throw new Error("Could not correlate define call site for needle "+a)},m.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var a=[],h=0,A=0,R=this._modules2.length;A<R;A++){var N=this._modules2[A];if(!!N){var v=this._buildInfoPath[N.id]||null,e=this._buildInfoDefineStack[N.id]||null,E=this._buildInfoDependencies[N.id];a[h++]={id:N.strId,path:v,defineLocation:v&&e?m._findRelevantLocationInStack(v,e):null,dependencies:E,shim:null,exports:N.exports}}}return a},m.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new q.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=q.NullLoaderEventRecorder.INSTANCE),this._recorder},m.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},m.prototype.enqueueDefineAnonymousModule=function(a,h){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var A=null;this._config.isBuild()&&(A=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:A,dependencies:a,callback:h}},m.prototype.defineModule=function(a,h,A,R,N,v){var e=this;v===void 0&&(v=new n(a));var E=this._moduleIdProvider.getModuleId(a);if(this._modules2[E]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}var F=new D(E,a,this._normalizeDependencies(h,v),A,R,v);this._modules2[E]=F,this._config.isBuild()&&(this._buildInfoDefineStack[E]=N,this._buildInfoDependencies[E]=(F.dependencies||[]).map(function(y){return e._moduleIdProvider.getStrModuleId(y.id)})),this._resolve(F)},m.prototype._normalizeDependency=function(a,h){if(a==="exports")return P.EXPORTS;if(a==="module")return P.MODULE;if(a==="require")return P.REQUIRE;var A=a.indexOf("!");if(A>=0){var R=h.resolveModule(a.substr(0,A)),N=h.resolveModule(a.substr(A+1)),v=this._moduleIdProvider.getModuleId(R+"!"+N),e=this._moduleIdProvider.getModuleId(R);return new u(v,e,N)}return new P(this._moduleIdProvider.getModuleId(h.resolveModule(a)))},m.prototype._normalizeDependencies=function(a,h){for(var A=[],R=0,N=0,v=a.length;N<v;N++)A[R++]=this._normalizeDependency(a[N],h);return A},m.prototype._relativeRequire=function(a,h,A,R){if(typeof h=="string")return this.synchronousRequire(h,a);this.defineModule(q.Utilities.generateAnonymousModule(),h,A,R,null,a)},m.prototype.synchronousRequire=function(a,h){h===void 0&&(h=new n(a));var A=this._normalizeDependency(a,h),R=this._modules2[A.id];if(!R)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!R.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(R.error)throw R.error;return R.exports},m.prototype.configure=function(a,h){var A=this._config.shouldRecordStats();h?this._config=new q.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!A&&(this._recorder=null)},m.prototype.getConfig=function(){return this._config},m.prototype._onLoad=function(a){if(this._currentAnonymousDefineCall!==null){var h=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),h.dependencies,h.callback,null,h.stack)}},m.prototype._createLoadError=function(a,h){var A=this,R=this._moduleIdProvider.getStrModuleId(a),N=(this._inverseDependencies2[a]||[]).map(function(e){return A._moduleIdProvider.getStrModuleId(e)}),v=q.ensureError(h);return v.phase="loading",v.moduleId=R,v.neededBy=N,v},m.prototype._onLoadError=function(a,h){var A=this._createLoadError(a,h);this._modules2[a]||(this._modules2[a]=new D(a,this._moduleIdProvider.getStrModuleId(a),[],function(){},null,null));for(var R=[],N=0,v=this._moduleIdProvider.getMaxModuleId();N<v;N++)R[N]=!1;var e=!1,E=[];for(E.push(a),R[a]=!0;E.length>0;){var F=E.shift(),y=this._modules2[F];y&&(e=y.onDependencyError(A)||e);var L=this._inverseDependencies2[F];if(L)for(var N=0,v=L.length;N<v;N++){var d=L[N];R[d]||(E.push(d),R[d]=!0)}}e||this._config.onError(A)},m.prototype._hasDependencyPath=function(a,h){var A=this._modules2[a];if(!A)return!1;for(var R=[],N=0,v=this._moduleIdProvider.getMaxModuleId();N<v;N++)R[N]=!1;var e=[];for(e.push(A),R[a]=!0;e.length>0;){var E=e.shift(),F=E.dependencies;if(F)for(var N=0,v=F.length;N<v;N++){var y=F[N];if(y.id===h)return!0;var L=this._modules2[y.id];L&&!R[y.id]&&(R[y.id]=!0,e.push(L))}}return!1},m.prototype._findCyclePath=function(a,h,A){if(a===h||A===50)return[a];var R=this._modules2[a];if(!R)return null;var N=R.dependencies;if(N)for(var v=0,e=N.length;v<e;v++){var E=this._findCyclePath(N[v].id,h,A+1);if(E!==null)return E.push(a),E}return null},m.prototype._createRequire=function(a){var h=this,A=function(R,N,v){return h._relativeRequire(a,R,N,v)};return A.toUrl=function(R){return h._config.requireToUrl(a.resolveModule(R))},A.getStats=function(){return h.getLoaderEvents()},A.hasDependencyCycle=function(){return h._hasDependencyCycle},A.config=function(R,N){N===void 0&&(N=!1),h.configure(R,N)},A.__$__nodeRequire=q.global.nodeRequire,A},m.prototype._loadModule=function(a){var h=this;if(!(this._modules2[a]||this._knownModules2[a])){this._knownModules2[a]=!0;var A=this._moduleIdProvider.getStrModuleId(a),R=this._config.moduleIdToPaths(A),N=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(A.indexOf("/")===-1||N.test(A))&&R.push("node|"+A);var v=-1,e=function(E){if(v++,v>=R.length)h._onLoadError(a,E);else{var F=R[v],y=h.getRecorder();if(h._config.isBuild()&&F==="empty:"){h._buildInfoPath[a]=F,h.defineModule(h._moduleIdProvider.getStrModuleId(a),[],null,null,null),h._onLoad(a);return}y.record(10,F),h._scriptLoader.load(h,F,function(){h._config.isBuild()&&(h._buildInfoPath[a]=F),y.record(11,F),h._onLoad(a)},function(L){y.record(12,F),e(L)})}};e(null)}},m.prototype._loadPluginDependency=function(a,h){var A=this;if(!(this._modules2[h.id]||this._knownModules2[h.id])){this._knownModules2[h.id]=!0;var R=function(N){A.defineModule(A._moduleIdProvider.getStrModuleId(h.id),[],N,null,null)};R.error=function(N){A._config.onError(A._createLoadError(h.id,N))},a.load(h.pluginParam,this._createRequire(n.ROOT),R,this._config.getOptionsLiteral())}},m.prototype._resolve=function(a){var h=this,A=a.dependencies;if(A)for(var R=0,N=A.length;R<N;R++){var v=A[R];if(v===P.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(v===P.MODULE){a.unresolvedDependenciesCount--;continue}if(v===P.REQUIRE){a.unresolvedDependenciesCount--;continue}var e=this._modules2[v.id];if(e&&e.isComplete()){if(e.error){a.onDependencyError(e.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(v.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(v.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");var E=this._findCyclePath(v.id,a.id,0)||[];E.reverse(),E.push(v.id),console.warn(E.map(function(L){return h._moduleIdProvider.getStrModuleId(L)}).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[v.id]=this._inverseDependencies2[v.id]||[],this._inverseDependencies2[v.id].push(a.id),v instanceof u){var F=this._modules2[v.pluginId];if(F&&F.isComplete()){this._loadPluginDependency(F.exports,v);continue}var y=this._inversePluginDependencies2.get(v.pluginId);y||(y=[],this._inversePluginDependencies2.set(v.pluginId,y)),y.push(v),this._loadModule(v.pluginId);continue}this._loadModule(v.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)},m.prototype._onModuleComplete=function(a){var h=this,A=this.getRecorder();if(!a.isComplete()){var R=a.dependencies,N=[];if(R)for(var v=0,e=R.length;v<e;v++){var E=R[v];if(E===P.EXPORTS){N[v]=a.exports;continue}if(E===P.MODULE){N[v]={id:a.strId,config:function(){return h._config.getConfigForModule(a.strId)}};continue}if(E===P.REQUIRE){N[v]=this._createRequire(a.moduleIdResolver);continue}var F=this._modules2[E.id];if(F){N[v]=F.exports;continue}N[v]=null}var y=function(r){return(h._inverseDependencies2[r]||[]).map(function(s){return h._moduleIdProvider.getStrModuleId(s)})};a.complete(A,this._config,N,y);var L=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,L)for(var v=0,e=L.length;v<e;v++){var d=L[v],b=this._modules2[d];b.unresolvedDependenciesCount--,b.unresolvedDependenciesCount===0&&this._onModuleComplete(b)}var l=this._inversePluginDependencies2.get(a.id);if(l){this._inversePluginDependencies2.delete(a.id);for(var v=0,e=l.length;v<e;v++)this._loadPluginDependency(a.exports,l[v])}}},m}();q.ModuleManager=_})(ue||(ue={}));var Z,ue;(function(q){var n=new q.Environment,D=null,t=function(m,a,h){typeof m!="string"&&(h=a,a=m,m=null),(typeof a!="object"||!Array.isArray(a))&&(h=a,a=null),a||(a=["require","exports","module"]),m?D.defineModule(m,a,h,null,null):D.enqueueDefineAnonymousModule(a,h)};t.amd={jQuery:!0};var P=function(m,a){a===void 0&&(a=!1),D.configure(m,a)},u=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){P(arguments[0]);return}if(typeof arguments[0]=="string")return D.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){D.defineModule(q.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};u.config=P,u.getConfig=function(){return D.getConfig().getOptionsLiteral()},u.reset=function(){D=D.reset()},u.getBuildInfo=function(){return D.getBuildInfo()},u.getStats=function(){return D.getLoaderEvents()},u.define=t;function _(){if(typeof q.global.require<"u"||typeof require<"u"){var m=q.global.require||require;if(typeof m=="function"&&typeof m.resolve=="function"){var a=q.ensureRecordedNodeRequire(D.getRecorder(),m);q.global.nodeRequire=a,u.nodeRequire=a,u.__$__nodeRequire=a}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=u:(n.isElectronRenderer||(q.global.define=t),q.global.require=u)}q.init=_,(typeof q.global.define!="function"||!q.global.define.amd)&&(D=new q.ModuleManager(n,q.createScriptLoader(n),t,u,q.Utilities.getHighPerformanceTimestamp()),typeof q.global.require<"u"&&typeof q.global.require!="function"&&u.config(q.global.require),Z=function(){return t.apply(null,arguments)},Z.amd=t.amd,typeof doNotInitLoader>"u"&&_())})(ue||(ue={})),Z(J[54],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=void 0;function D(m,a,h,A){if(A=A||{},(A["vs/css"]||{}).disabled){h({});return}const N=a.toUrl(m+".css");t(m,N,()=>{h({})},v=>{typeof h.error=="function"&&h.error("Could not find "+N+".")})}n.load=D;function t(m,a,h,A){if(P(m,a)){h();return}u(m,a,h,A)}function P(m,a){const h=document.getElementsByTagName("link");for(let A=0,R=h.length;A<R;A++){const N=h[A].getAttribute("data-name"),v=h[A].getAttribute("href");if(N===m||v===a)return!0}return!1}function u(m,a,h,A){const R=document.createElement("link");R.setAttribute("rel","stylesheet"),R.setAttribute("type","text/css"),R.setAttribute("data-name",m),_(m,R,h,A),R.setAttribute("href",a),(document.head||document.getElementsByTagName("head")[0]).appendChild(R)}function _(m,a,h,A){const R=()=>{a.removeEventListener("load",N),a.removeEventListener("error",v)},N=e=>{R(),h()},v=e=>{R(),A(e)};a.addEventListener("load",N),a.addEventListener("error",v)}}),Z("vs/nls",["require","exports"],function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let D=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const t="i-default";function P(e,E){let F;return E.length===0?F=e:F=e.replace(/\{(\d+)\}/g,(y,L)=>{const d=L[0],b=E[d];let l=y;return typeof b=="string"?l=b:(typeof b=="number"||typeof b=="boolean"||b===void 0||b===null)&&(l=String(b)),l}),D&&(F="\uFF3B"+F.replace(/[aouei]/g,"$&$&")+"\uFF3D"),F}function u(e,E){let F=e[E];return F||(F=e["*"],F)?F:null}function _(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function m(e,E,F){const y=_(e)+_(E)+"vscode/"+_(F),L=await fetch(y);if(L.ok)return await L.json();throw new Error(`${L.status} - ${L.statusText}`)}function a(e){return function(E,F){const y=Array.prototype.slice.call(arguments,2);return P(e[E],y)}}function h(e,E,...F){return P(E,F)}n.localize=h;function A(e){}n.getConfiguredDefaultLocale=A;function R(e){D=e}n.setPseudoTranslation=R;function N(e,E){return{localize:a(E[e]),getConfiguredDefaultLocale:E.getConfiguredDefaultLocale??(F=>{})}}n.create=N;function v(e,E,F,y){const L=y["vs/nls"]??{};if(!e||e.length===0)return F({localize:h,getConfiguredDefaultLocale:()=>L.availableLanguages?.["*"]});const d=L.availableLanguages?u(L.availableLanguages,e):null,b=d===null||d===t;let l=".nls";b||(l=l+"."+d);const r=s=>{Array.isArray(s)?s.localize=a(s):s.localize=a(s[e]),s.getConfiguredDefaultLocale=()=>L.availableLanguages?.["*"],F(s)};typeof L.loadBundle=="function"?L.loadBundle(e,d,(s,g)=>{s?E([e+".nls"],r):r(g)}):L.translationServiceUrl&&!b?(async()=>{try{const s=await m(L.translationServiceUrl,d,e);return r(s)}catch(s){if(!d.includes("-"))return console.error(s),E([e+".nls"],r);try{const g=d.split("-")[0],c=await m(L.translationServiceUrl,g,e);return L.availableLanguages??={},L.availableLanguages["*"]=g,r(c)}catch(g){return console.error(g),E([e+".nls"],r)}}})():E([e+l],r,s=>{if(l===".nls"){console.error("Failed trying to load default language strings",s);return}console.error(`Failed to load message bundle for language ${d}. Falling back to the default language:`,s),E([e+".nls"],r)})}n.load=v}),function(){const q=self.MonacoEnvironment,n=q&&q.baseUrl?q.baseUrl:"../../../",D=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:h=>h,createScript:(h,...A)=>{const R=A.slice(0,-1).join(","),N=A.pop().toString();return`(function anonymous(${R}) { ${N}
})`}}):void 0;function t(){try{return(D?self.eval(D.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function P(){return new Promise((h,A)=>{if(typeof self.define=="function"&&self.define.amd)return h();const R=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(R)&&R.substring(0,self.origin.length)!==self.origin)&&t()){fetch(R).then(v=>{if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(v=>{v=`${v}
//# sourceURL=${R}`,(D?self.eval(D.createScript("",v)):new Function(v)).call(self),h()}).then(void 0,A);return}D?importScripts(D.createScriptURL(R)):importScripts(R),h()})}function u(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//})}function _(h){P().then(()=>{u(),require([h],function(A){setTimeout(function(){const R=A.create((N,v)=>{self.postMessage(N,v)},null);for(self.onmessage=N=>R.onmessage(N.data,N.ports);a.length>0;)self.onmessage(a.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&u();let m=!0;const a=[];self.onmessage=h=>{if(!m){a.push(h);return}m=!1,_(h.data)}}(),Z(J[24],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CSSIcon=n.Codicon=n.getCodiconAriaLabel=void 0;function D(u){return u?u.replace(/\$\((.*?)\)/g,(_,m)=>` ${m} `).trim():""}n.getCodiconAriaLabel=D;class t{constructor(_,m,a){this.id=_,this.fontCharacter=m,this.description=a,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}n.Codicon=t,t.a=[],t.add=new t("add","\\ea60"),t.plus=new t("plus",t.add.fontCharacter),t.gistNew=new t("gist-new",t.add.fontCharacter),t.repoCreate=new t("repo-create",t.add.fontCharacter),t.lightbulb=new t("lightbulb","\\ea61"),t.lightBulb=new t("light-bulb","\\ea61"),t.repo=new t("repo","\\ea62"),t.repoDelete=new t("repo-delete","\\ea62"),t.gistFork=new t("gist-fork","\\ea63"),t.repoForked=new t("repo-forked","\\ea63"),t.gitPullRequest=new t("git-pull-request","\\ea64"),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned","\\ea64"),t.recordKeys=new t("record-keys","\\ea65"),t.keyboard=new t("keyboard","\\ea65"),t.tag=new t("tag","\\ea66"),t.tagAdd=new t("tag-add","\\ea66"),t.tagRemove=new t("tag-remove","\\ea66"),t.person=new t("person","\\ea67"),t.personFollow=new t("person-follow","\\ea67"),t.personOutline=new t("person-outline","\\ea67"),t.personFilled=new t("person-filled","\\ea67"),t.gitBranch=new t("git-branch","\\ea68"),t.gitBranchCreate=new t("git-branch-create","\\ea68"),t.gitBranchDelete=new t("git-branch-delete","\\ea68"),t.sourceControl=new t("source-control","\\ea68"),t.mirror=new t("mirror","\\ea69"),t.mirrorPublic=new t("mirror-public","\\ea69"),t.star=new t("star","\\ea6a"),t.starAdd=new t("star-add","\\ea6a"),t.starDelete=new t("star-delete","\\ea6a"),t.starEmpty=new t("star-empty","\\ea6a"),t.comment=new t("comment","\\ea6b"),t.commentAdd=new t("comment-add","\\ea6b"),t.alert=new t("alert","\\ea6c"),t.warning=new t("warning","\\ea6c"),t.search=new t("search","\\ea6d"),t.searchSave=new t("search-save","\\ea6d"),t.logOut=new t("log-out","\\ea6e"),t.signOut=new t("sign-out","\\ea6e"),t.logIn=new t("log-in","\\ea6f"),t.signIn=new t("sign-in","\\ea6f"),t.eye=new t("eye","\\ea70"),t.eyeUnwatch=new t("eye-unwatch","\\ea70"),t.eyeWatch=new t("eye-watch","\\ea70"),t.circleFilled=new t("circle-filled","\\ea71"),t.primitiveDot=new t("primitive-dot",t.circleFilled.fontCharacter),t.closeDirty=new t("close-dirty",t.circleFilled.fontCharacter),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.fontCharacter),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.fontCharacter),t.debugHint=new t("debug-hint",t.circleFilled.fontCharacter),t.primitiveSquare=new t("primitive-square","\\ea72"),t.edit=new t("edit","\\ea73"),t.pencil=new t("pencil","\\ea73"),t.info=new t("info","\\ea74"),t.issueOpened=new t("issue-opened","\\ea74"),t.gistPrivate=new t("gist-private","\\ea75"),t.gitForkPrivate=new t("git-fork-private","\\ea75"),t.lock=new t("lock","\\ea75"),t.mirrorPrivate=new t("mirror-private","\\ea75"),t.close=new t("close","\\ea76"),t.removeClose=new t("remove-close","\\ea76"),t.x=new t("x","\\ea76"),t.repoSync=new t("repo-sync","\\ea77"),t.sync=new t("sync","\\ea77"),t.clone=new t("clone","\\ea78"),t.desktopDownload=new t("desktop-download","\\ea78"),t.beaker=new t("beaker","\\ea79"),t.microscope=new t("microscope","\\ea79"),t.vm=new t("vm","\\ea7a"),t.deviceDesktop=new t("device-desktop","\\ea7a"),t.file=new t("file","\\ea7b"),t.fileText=new t("file-text","\\ea7b"),t.more=new t("more","\\ea7c"),t.ellipsis=new t("ellipsis","\\ea7c"),t.kebabHorizontal=new t("kebab-horizontal","\\ea7c"),t.mailReply=new t("mail-reply","\\ea7d"),t.reply=new t("reply","\\ea7d"),t.organization=new t("organization","\\ea7e"),t.organizationFilled=new t("organization-filled","\\ea7e"),t.organizationOutline=new t("organization-outline","\\ea7e"),t.newFile=new t("new-file","\\ea7f"),t.fileAdd=new t("file-add","\\ea7f"),t.newFolder=new t("new-folder","\\ea80"),t.fileDirectoryCreate=new t("file-directory-create","\\ea80"),t.trash=new t("trash","\\ea81"),t.trashcan=new t("trashcan","\\ea81"),t.history=new t("history","\\ea82"),t.clock=new t("clock","\\ea82"),t.folder=new t("folder","\\ea83"),t.fileDirectory=new t("file-directory","\\ea83"),t.symbolFolder=new t("symbol-folder","\\ea83"),t.logoGithub=new t("logo-github","\\ea84"),t.markGithub=new t("mark-github","\\ea84"),t.github=new t("github","\\ea84"),t.terminal=new t("terminal","\\ea85"),t.console=new t("console","\\ea85"),t.repl=new t("repl","\\ea85"),t.zap=new t("zap","\\ea86"),t.symbolEvent=new t("symbol-event","\\ea86"),t.error=new t("error","\\ea87"),t.stop=new t("stop","\\ea87"),t.variable=new t("variable","\\ea88"),t.symbolVariable=new t("symbol-variable","\\ea88"),t.array=new t("array","\\ea8a"),t.symbolArray=new t("symbol-array","\\ea8a"),t.symbolModule=new t("symbol-module","\\ea8b"),t.symbolPackage=new t("symbol-package","\\ea8b"),t.symbolNamespace=new t("symbol-namespace","\\ea8b"),t.symbolObject=new t("symbol-object","\\ea8b"),t.symbolMethod=new t("symbol-method","\\ea8c"),t.symbolFunction=new t("symbol-function","\\ea8c"),t.symbolConstructor=new t("symbol-constructor","\\ea8c"),t.symbolBoolean=new t("symbol-boolean","\\ea8f"),t.symbolNull=new t("symbol-null","\\ea8f"),t.symbolNumeric=new t("symbol-numeric","\\ea90"),t.symbolNumber=new t("symbol-number","\\ea90"),t.symbolStructure=new t("symbol-structure","\\ea91"),t.symbolStruct=new t("symbol-struct","\\ea91"),t.symbolParameter=new t("symbol-parameter","\\ea92"),t.symbolTypeParameter=new t("symbol-type-parameter","\\ea92"),t.symbolKey=new t("symbol-key","\\ea93"),t.symbolText=new t("symbol-text","\\ea93"),t.symbolReference=new t("symbol-reference","\\ea94"),t.goToFile=new t("go-to-file","\\ea94"),t.symbolEnum=new t("symbol-enum","\\ea95"),t.symbolValue=new t("symbol-value","\\ea95"),t.symbolRuler=new t("symbol-ruler","\\ea96"),t.symbolUnit=new t("symbol-unit","\\ea96"),t.activateBreakpoints=new t("activate-breakpoints","\\ea97"),t.archive=new t("archive","\\ea98"),t.arrowBoth=new t("arrow-both","\\ea99"),t.arrowDown=new t("arrow-down","\\ea9a"),t.arrowLeft=new t("arrow-left","\\ea9b"),t.arrowRight=new t("arrow-right","\\ea9c"),t.arrowSmallDown=new t("arrow-small-down","\\ea9d"),t.arrowSmallLeft=new t("arrow-small-left","\\ea9e"),t.arrowSmallRight=new t("arrow-small-right","\\ea9f"),t.arrowSmallUp=new t("arrow-small-up","\\eaa0"),t.arrowUp=new t("arrow-up","\\eaa1"),t.bell=new t("bell","\\eaa2"),t.bold=new t("bold","\\eaa3"),t.book=new t("book","\\eaa4"),t.bookmark=new t("bookmark","\\eaa5"),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified","\\eaa6"),t.debugBreakpointConditional=new t("debug-breakpoint-conditional","\\eaa7"),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled","\\eaa7"),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified","\\eaa8"),t.debugBreakpointData=new t("debug-breakpoint-data","\\eaa9"),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled","\\eaa9"),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified","\\eaaa"),t.debugBreakpointLog=new t("debug-breakpoint-log","\\eaab"),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled","\\eaab"),t.briefcase=new t("briefcase","\\eaac"),t.broadcast=new t("broadcast","\\eaad"),t.browser=new t("browser","\\eaae"),t.bug=new t("bug","\\eaaf"),t.calendar=new t("calendar","\\eab0"),t.caseSensitive=new t("case-sensitive","\\eab1"),t.check=new t("check","\\eab2"),t.checklist=new t("checklist","\\eab3"),t.chevronDown=new t("chevron-down","\\eab4"),t.dropDownButton=new t("drop-down-button",t.chevronDown.fontCharacter),t.chevronLeft=new t("chevron-left","\\eab5"),t.chevronRight=new t("chevron-right","\\eab6"),t.chevronUp=new t("chevron-up","\\eab7"),t.chromeClose=new t("chrome-close","\\eab8"),t.chromeMaximize=new t("chrome-maximize","\\eab9"),t.chromeMinimize=new t("chrome-minimize","\\eaba"),t.chromeRestore=new t("chrome-restore","\\eabb"),t.circle=new t("circle","\\eabc"),t.circleOutline=new t("circle-outline",t.circle.fontCharacter),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.fontCharacter),t.circleSlash=new t("circle-slash","\\eabd"),t.circuitBoard=new t("circuit-board","\\eabe"),t.clearAll=new t("clear-all","\\eabf"),t.clippy=new t("clippy","\\eac0"),t.closeAll=new t("close-all","\\eac1"),t.cloudDownload=new t("cloud-download","\\eac2"),t.cloudUpload=new t("cloud-upload","\\eac3"),t.code=new t("code","\\eac4"),t.collapseAll=new t("collapse-all","\\eac5"),t.colorMode=new t("color-mode","\\eac6"),t.commentDiscussion=new t("comment-discussion","\\eac7"),t.compareChanges=new t("compare-changes","\\eafd"),t.creditCard=new t("credit-card","\\eac9"),t.dash=new t("dash","\\eacc"),t.dashboard=new t("dashboard","\\eacd"),t.database=new t("database","\\eace"),t.debugContinue=new t("debug-continue","\\eacf"),t.debugDisconnect=new t("debug-disconnect","\\ead0"),t.debugPause=new t("debug-pause","\\ead1"),t.debugRestart=new t("debug-restart","\\ead2"),t.debugStart=new t("debug-start","\\ead3"),t.debugStepInto=new t("debug-step-into","\\ead4"),t.debugStepOut=new t("debug-step-out","\\ead5"),t.debugStepOver=new t("debug-step-over","\\ead6"),t.debugStop=new t("debug-stop","\\ead7"),t.debug=new t("debug","\\ead8"),t.deviceCameraVideo=new t("device-camera-video","\\ead9"),t.deviceCamera=new t("device-camera","\\eada"),t.deviceMobile=new t("device-mobile","\\eadb"),t.diffAdded=new t("diff-added","\\eadc"),t.diffIgnored=new t("diff-ignored","\\eadd"),t.diffModified=new t("diff-modified","\\eade"),t.diffRemoved=new t("diff-removed","\\eadf"),t.diffRenamed=new t("diff-renamed","\\eae0"),t.diff=new t("diff","\\eae1"),t.discard=new t("discard","\\eae2"),t.editorLayout=new t("editor-layout","\\eae3"),t.emptyWindow=new t("empty-window","\\eae4"),t.exclude=new t("exclude","\\eae5"),t.extensions=new t("extensions","\\eae6"),t.eyeClosed=new t("eye-closed","\\eae7"),t.fileBinary=new t("file-binary","\\eae8"),t.fileCode=new t("file-code","\\eae9"),t.fileMedia=new t("file-media","\\eaea"),t.filePdf=new t("file-pdf","\\eaeb"),t.fileSubmodule=new t("file-submodule","\\eaec"),t.fileSymlinkDirectory=new t("file-symlink-directory","\\eaed"),t.fileSymlinkFile=new t("file-symlink-file","\\eaee"),t.fileZip=new t("file-zip","\\eaef"),t.files=new t("files","\\eaf0"),t.filter=new t("filter","\\eaf1"),t.flame=new t("flame","\\eaf2"),t.foldDown=new t("fold-down","\\eaf3"),t.foldUp=new t("fold-up","\\eaf4"),t.fold=new t("fold","\\eaf5"),t.folderActive=new t("folder-active","\\eaf6"),t.folderOpened=new t("folder-opened","\\eaf7"),t.gear=new t("gear","\\eaf8"),t.gift=new t("gift","\\eaf9"),t.gistSecret=new t("gist-secret","\\eafa"),t.gist=new t("gist","\\eafb"),t.gitCommit=new t("git-commit","\\eafc"),t.gitCompare=new t("git-compare","\\eafd"),t.gitMerge=new t("git-merge","\\eafe"),t.githubAction=new t("github-action","\\eaff"),t.githubAlt=new t("github-alt","\\eb00"),t.globe=new t("globe","\\eb01"),t.grabber=new t("grabber","\\eb02"),t.graph=new t("graph","\\eb03"),t.gripper=new t("gripper","\\eb04"),t.heart=new t("heart","\\eb05"),t.home=new t("home","\\eb06"),t.horizontalRule=new t("horizontal-rule","\\eb07"),t.hubot=new t("hubot","\\eb08"),t.inbox=new t("inbox","\\eb09"),t.issueClosed=new t("issue-closed","\\eba4"),t.issueReopened=new t("issue-reopened","\\eb0b"),t.issues=new t("issues","\\eb0c"),t.italic=new t("italic","\\eb0d"),t.jersey=new t("jersey","\\eb0e"),t.json=new t("json","\\eb0f"),t.kebabVertical=new t("kebab-vertical","\\eb10"),t.key=new t("key","\\eb11"),t.law=new t("law","\\eb12"),t.lightbulbAutofix=new t("lightbulb-autofix","\\eb13"),t.linkExternal=new t("link-external","\\eb14"),t.link=new t("link","\\eb15"),t.listOrdered=new t("list-ordered","\\eb16"),t.listUnordered=new t("list-unordered","\\eb17"),t.liveShare=new t("live-share","\\eb18"),t.loading=new t("loading","\\eb19"),t.location=new t("location","\\eb1a"),t.mailRead=new t("mail-read","\\eb1b"),t.mail=new t("mail","\\eb1c"),t.markdown=new t("markdown","\\eb1d"),t.megaphone=new t("megaphone","\\eb1e"),t.mention=new t("mention","\\eb1f"),t.milestone=new t("milestone","\\eb20"),t.mortarBoard=new t("mortar-board","\\eb21"),t.move=new t("move","\\eb22"),t.multipleWindows=new t("multiple-windows","\\eb23"),t.mute=new t("mute","\\eb24"),t.noNewline=new t("no-newline","\\eb25"),t.note=new t("note","\\eb26"),t.octoface=new t("octoface","\\eb27"),t.openPreview=new t("open-preview","\\eb28"),t.package_=new t("package","\\eb29"),t.paintcan=new t("paintcan","\\eb2a"),t.pin=new t("pin","\\eb2b"),t.play=new t("play","\\eb2c"),t.run=new t("run","\\eb2c"),t.plug=new t("plug","\\eb2d"),t.preserveCase=new t("preserve-case","\\eb2e"),t.preview=new t("preview","\\eb2f"),t.project=new t("project","\\eb30"),t.pulse=new t("pulse","\\eb31"),t.question=new t("question","\\eb32"),t.quote=new t("quote","\\eb33"),t.radioTower=new t("radio-tower","\\eb34"),t.reactions=new t("reactions","\\eb35"),t.references=new t("references","\\eb36"),t.refresh=new t("refresh","\\eb37"),t.regex=new t("regex","\\eb38"),t.remoteExplorer=new t("remote-explorer","\\eb39"),t.remote=new t("remote","\\eb3a"),t.remove=new t("remove","\\eb3b"),t.replaceAll=new t("replace-all","\\eb3c"),t.replace=new t("replace","\\eb3d"),t.repoClone=new t("repo-clone","\\eb3e"),t.repoForcePush=new t("repo-force-push","\\eb3f"),t.repoPull=new t("repo-pull","\\eb40"),t.repoPush=new t("repo-push","\\eb41"),t.report=new t("report","\\eb42"),t.requestChanges=new t("request-changes","\\eb43"),t.rocket=new t("rocket","\\eb44"),t.rootFolderOpened=new t("root-folder-opened","\\eb45"),t.rootFolder=new t("root-folder","\\eb46"),t.rss=new t("rss","\\eb47"),t.ruby=new t("ruby","\\eb48"),t.saveAll=new t("save-all","\\eb49"),t.saveAs=new t("save-as","\\eb4a"),t.save=new t("save","\\eb4b"),t.screenFull=new t("screen-full","\\eb4c"),t.screenNormal=new t("screen-normal","\\eb4d"),t.searchStop=new t("search-stop","\\eb4e"),t.server=new t("server","\\eb50"),t.settingsGear=new t("settings-gear","\\eb51"),t.settings=new t("settings","\\eb52"),t.shield=new t("shield","\\eb53"),t.smiley=new t("smiley","\\eb54"),t.sortPrecedence=new t("sort-precedence","\\eb55"),t.splitHorizontal=new t("split-horizontal","\\eb56"),t.splitVertical=new t("split-vertical","\\eb57"),t.squirrel=new t("squirrel","\\eb58"),t.starFull=new t("star-full","\\eb59"),t.starHalf=new t("star-half","\\eb5a"),t.symbolClass=new t("symbol-class","\\eb5b"),t.symbolColor=new t("symbol-color","\\eb5c"),t.symbolCustomColor=new t("symbol-customcolor","\\eb5c"),t.symbolConstant=new t("symbol-constant","\\eb5d"),t.symbolEnumMember=new t("symbol-enum-member","\\eb5e"),t.symbolField=new t("symbol-field","\\eb5f"),t.symbolFile=new t("symbol-file","\\eb60"),t.symbolInterface=new t("symbol-interface","\\eb61"),t.symbolKeyword=new t("symbol-keyword","\\eb62"),t.symbolMisc=new t("symbol-misc","\\eb63"),t.symbolOperator=new t("symbol-operator","\\eb64"),t.symbolProperty=new t("symbol-property","\\eb65"),t.wrench=new t("wrench","\\eb65"),t.wrenchSubaction=new t("wrench-subaction","\\eb65"),t.symbolSnippet=new t("symbol-snippet","\\eb66"),t.tasklist=new t("tasklist","\\eb67"),t.telescope=new t("telescope","\\eb68"),t.textSize=new t("text-size","\\eb69"),t.threeBars=new t("three-bars","\\eb6a"),t.thumbsdown=new t("thumbsdown","\\eb6b"),t.thumbsup=new t("thumbsup","\\eb6c"),t.tools=new t("tools","\\eb6d"),t.triangleDown=new t("triangle-down","\\eb6e"),t.triangleLeft=new t("triangle-left","\\eb6f"),t.triangleRight=new t("triangle-right","\\eb70"),t.triangleUp=new t("triangle-up","\\eb71"),t.twitter=new t("twitter","\\eb72"),t.unfold=new t("unfold","\\eb73"),t.unlock=new t("unlock","\\eb74"),t.unmute=new t("unmute","\\eb75"),t.unverified=new t("unverified","\\eb76"),t.verified=new t("verified","\\eb77"),t.versions=new t("versions","\\eb78"),t.vmActive=new t("vm-active","\\eb79"),t.vmOutline=new t("vm-outline","\\eb7a"),t.vmRunning=new t("vm-running","\\eb7b"),t.watch=new t("watch","\\eb7c"),t.whitespace=new t("whitespace","\\eb7d"),t.wholeWord=new t("whole-word","\\eb7e"),t.window=new t("window","\\eb7f"),t.wordWrap=new t("word-wrap","\\eb80"),t.zoomIn=new t("zoom-in","\\eb81"),t.zoomOut=new t("zoom-out","\\eb82"),t.listFilter=new t("list-filter","\\eb83"),t.listFlat=new t("list-flat","\\eb84"),t.listSelection=new t("list-selection","\\eb85"),t.selection=new t("selection","\\eb85"),t.listTree=new t("list-tree","\\eb86"),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified","\\eb87"),t.debugBreakpointFunction=new t("debug-breakpoint-function","\\eb88"),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled","\\eb88"),t.debugStackframeActive=new t("debug-stackframe-active","\\eb89"),t.circleSmallFilled=new t("circle-small-filled","\\eb8a"),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.fontCharacter),t.debugStackframe=new t("debug-stackframe","\\eb8b"),t.debugStackframeFocused=new t("debug-stackframe-focused","\\eb8b"),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported","\\eb8c"),t.symbolString=new t("symbol-string","\\eb8d"),t.debugReverseContinue=new t("debug-reverse-continue","\\eb8e"),t.debugStepBack=new t("debug-step-back","\\eb8f"),t.debugRestartFrame=new t("debug-restart-frame","\\eb90"),t.callIncoming=new t("call-incoming","\\eb92"),t.callOutgoing=new t("call-outgoing","\\eb93"),t.menu=new t("menu","\\eb94"),t.expandAll=new t("expand-all","\\eb95"),t.feedback=new t("feedback","\\eb96"),t.groupByRefType=new t("group-by-ref-type","\\eb97"),t.ungroupByRefType=new t("ungroup-by-ref-type","\\eb98"),t.account=new t("account","\\eb99"),t.bellDot=new t("bell-dot","\\eb9a"),t.debugConsole=new t("debug-console","\\eb9b"),t.library=new t("library","\\eb9c"),t.output=new t("output","\\eb9d"),t.runAll=new t("run-all","\\eb9e"),t.syncIgnored=new t("sync-ignored","\\eb9f"),t.pinned=new t("pinned","\\eba0"),t.githubInverted=new t("github-inverted","\\eba1"),t.debugAlt=new t("debug-alt","\\eb91"),t.serverProcess=new t("server-process","\\eba2"),t.serverEnvironment=new t("server-environment","\\eba3"),t.pass=new t("pass","\\eba4"),t.stopCircle=new t("stop-circle","\\eba5"),t.playCircle=new t("play-circle","\\eba6"),t.record=new t("record","\\eba7"),t.debugAltSmall=new t("debug-alt-small","\\eba8"),t.vmConnect=new t("vm-connect","\\eba9"),t.cloud=new t("cloud","\\ebaa"),t.merge=new t("merge","\\ebab"),t.exportIcon=new t("export","\\ebac"),t.graphLeft=new t("graph-left","\\ebad"),t.magnet=new t("magnet","\\ebae"),t.notebook=new t("notebook","\\ebaf"),t.redo=new t("redo","\\ebb0"),t.checkAll=new t("check-all","\\ebb1"),t.pinnedDirty=new t("pinned-dirty","\\ebb2"),t.passFilled=new t("pass-filled","\\ebb3"),t.circleLargeFilled=new t("circle-large-filled","\\ebb4"),t.circleLarge=new t("circle-large","\\ebb5"),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.fontCharacter),t.combine=new t("combine","\\ebb6"),t.gather=new t("gather","\\ebb6"),t.table=new t("table","\\ebb7"),t.variableGroup=new t("variable-group","\\ebb8"),t.typeHierarchy=new t("type-hierarchy","\\ebb9"),t.typeHierarchySub=new t("type-hierarchy-sub","\\ebba"),t.typeHierarchySuper=new t("type-hierarchy-super","\\ebbb"),t.gitPullRequestCreate=new t("git-pull-request-create","\\ebbc"),t.runAbove=new t("run-above","\\ebbd"),t.runBelow=new t("run-below","\\ebbe"),t.notebookTemplate=new t("notebook-template","\\ebbf"),t.debugRerun=new t("debug-rerun","\\ebc0"),t.workspaceTrusted=new t("workspace-trusted","\\ebc1"),t.workspaceUntrusted=new t("workspace-untrusted","\\ebc2"),t.workspaceUnspecified=new t("workspace-unspecified","\\ebc3"),t.terminalCmd=new t("terminal-cmd","\\ebc4"),t.terminalDebian=new t("terminal-debian","\\ebc5"),t.terminalLinux=new t("terminal-linux","\\ebc6"),t.terminalPowershell=new t("terminal-powershell","\\ebc7"),t.terminalTmux=new t("terminal-tmux","\\ebc8"),t.terminalUbuntu=new t("terminal-ubuntu","\\ebc9"),t.terminalBash=new t("terminal-bash","\\ebca"),t.arrowSwap=new t("arrow-swap","\\ebcb"),t.copy=new t("copy","\\ebcc"),t.personAdd=new t("person-add","\\ebcd"),t.filterFilled=new t("filter-filled","\\ebce"),t.wand=new t("wand","\\ebcf"),t.debugLineByLine=new t("debug-line-by-line","\\ebd0"),t.inspect=new t("inspect","\\ebd1"),t.layers=new t("layers","\\ebd2"),t.layersDot=new t("layers-dot","\\ebd3"),t.layersActive=new t("layers-active","\\ebd4"),t.compass=new t("compass","\\ebd5"),t.compassDot=new t("compass-dot","\\ebd6"),t.compassActive=new t("compass-active","\\ebd7"),t.azure=new t("azure","\\ebd8"),t.issueDraft=new t("issue-draft","\\ebd9"),t.gitPullRequestClosed=new t("git-pull-request-closed","\\ebda"),t.gitPullRequestDraft=new t("git-pull-request-draft","\\ebdb"),t.debugAll=new t("debug-all","\\ebdc"),t.debugCoverage=new t("debug-coverage","\\ebdd"),t.runErrors=new t("run-errors","\\ebde"),t.folderLibrary=new t("folder-library","\\ebdf"),t.debugContinueSmall=new t("debug-continue-small","\\ebe0"),t.beakerStop=new t("beaker-stop","\\ebe1"),t.graphLine=new t("graph-line","\\ebe2"),t.graphScatter=new t("graph-scatter","\\ebe3"),t.pieChart=new t("pie-chart","\\ebe4"),t.bracket=new t("bracket",t.json.fontCharacter),t.bracketDot=new t("bracket-dot","\\ebe5"),t.bracketError=new t("bracket-error","\\ebe6"),t.lockSmall=new t("lock-small","\\ebe7"),t.azureDevops=new t("azure-devops","\\ebe8"),t.verifiedFilled=new t("verified-filled","\\ebe9"),t.newLine=new t("newline","\\ebea"),t.layout=new t("layout","\\ebeb"),t.layoutActivitybarLeft=new t("layout-activitybar-left","\\ebec"),t.layoutActivitybarRight=new t("layout-activitybar-right","\\ebed"),t.layoutPanelLeft=new t("layout-panel-left","\\ebee"),t.layoutPanelCenter=new t("layout-panel-center","\\ebef"),t.layoutPanelJustify=new t("layout-panel-justify","\\ebf0"),t.layoutPanelRight=new t("layout-panel-right","\\ebf1"),t.layoutPanel=new t("layout-panel","\\ebf2"),t.layoutSidebarLeft=new t("layout-sidebar-left","\\ebf3"),t.layoutSidebarRight=new t("layout-sidebar-right","\\ebf4"),t.layoutStatusbar=new t("layout-statusbar","\\ebf5"),t.layoutMenubar=new t("layout-menubar","\\ebf6"),t.layoutCentered=new t("layout-centered","\\ebf7"),t.layoutSidebarRightOff=new t("layout-sidebar-right-off","\\ec00"),t.layoutPanelOff=new t("layout-panel-off","\\ec01"),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off","\\ec02"),t.target=new t("target","\\ebf8"),t.indent=new t("indent","\\ebf9"),t.recordSmall=new t("record-small","\\ebfa"),t.errorSmall=new t("error-small","\\ebfb"),t.arrowCircleDown=new t("arrow-circle-down","\\ebfc"),t.arrowCircleLeft=new t("arrow-circle-left","\\ebfd"),t.arrowCircleRight=new t("arrow-circle-right","\\ebfe"),t.arrowCircleUp=new t("arrow-circle-up","\\ebff"),t.heartFilled=new t("heart-filled","\\ec04"),t.map=new t("map","\\ec05"),t.mapFilled=new t("map-filled","\\ec06"),t.circleSmall=new t("circle-small","\\ec07"),t.bellSlash=new t("bell-slash","\\ec08"),t.bellSlashDot=new t("bell-slash-dot","\\ec09"),t.commentUnresolved=new t("comment-unresolved","\\ec0a"),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes","\\ec0b"),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes","\\ec0c"),t.searchFuzzy=new t("search-fuzzy","\\ec0d"),t.commentDraft=new t("comment-draft","\\ec0e"),t.dialogError=new t("dialog-error",t.error.fontCharacter),t.dialogWarning=new t("dialog-warning",t.warning.fontCharacter),t.dialogInfo=new t("dialog-info",t.info.fontCharacter),t.dialogClose=new t("dialog-close",t.close.fontCharacter),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.fontCharacter),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.fontCharacter),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.fontCharacter),t.treeFilterClear=new t("tree-filter-clear",t.close.fontCharacter),t.treeItemLoading=new t("tree-item-loading",t.loading.fontCharacter),t.menuSelection=new t("menu-selection",t.check.fontCharacter),t.menuSubmenu=new t("menu-submenu",t.chevronRight.fontCharacter),t.menuBarMore=new t("menubar-more",t.more.fontCharacter),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.fontCharacter),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.fontCharacter),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.fontCharacter),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.fontCharacter),t.toolBarMore=new t("toolbar-more",t.more.fontCharacter),t.quickInputBack=new t("quick-input-back",t.arrowLeft.fontCharacter);var P;(function(u){u.iconNameSegment="[A-Za-z0-9]+",u.iconNameExpression="[A-Za-z0-9-]+",u.iconModifierExpression="~[A-Za-z]+",u.iconNameCharacter="[A-Za-z0-9~-]";const _=new RegExp(`^(${u.iconNameExpression})(${u.iconModifierExpression})?$`);function m(A){if(A instanceof t)return["codicon","codicon-"+A.id];const R=_.exec(A.id);if(!R)return m(t.error);const[,N,v]=R,e=["codicon","codicon-"+N];return v&&e.push("codicon-modifier-"+v.substring(1)),e}u.asClassNameArray=m;function a(A){return m(A).join(" ")}u.asClassName=a;function h(A){return"."+m(A).join(".")}u.asCSSSelector=h})(P=n.CSSIcon||(n.CSSIcon={}))}),Z(J[25],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class D{constructor(P,u,_,m){this.originalStart=P,this.originalLength=u,this.modifiedStart=_,this.modifiedLength=m}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=D}),Z(J[6],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.ExpectedError=n.NotSupportedError=n.NotImplementedError=n.getErrorMessage=n.disposed=n.readonly=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.setUnexpectedErrorHandler=n.errorHandler=n.ErrorHandler=void 0;class D{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?d.isErrorNoTelemetry(r)?new d(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(s=>{s(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}n.ErrorHandler=D,n.errorHandler=new D;function t(l){n.errorHandler.setUnexpectedErrorHandler(l)}n.setUnexpectedErrorHandler=t;function P(l){a(l)||n.errorHandler.onUnexpectedError(l)}n.onUnexpectedError=P;function u(l){a(l)||n.errorHandler.onUnexpectedExternalError(l)}n.onUnexpectedExternalError=u;function _(l){if(l instanceof Error){const{name:r,message:s}=l,g=l.stacktrace||l.stack;return{$isError:!0,name:r,message:s,stack:g,noTelemetry:d.isErrorNoTelemetry(l)}}return l}n.transformErrorForSerialization=_;const m="Canceled";function a(l){return l instanceof h?!0:l instanceof Error&&l.name===m&&l.message===m}n.isCancellationError=a;class h extends Error{constructor(){super(m),this.name=this.message}}n.CancellationError=h;function A(){const l=new Error(m);return l.name=l.message,l}n.canceled=A;function R(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}n.illegalArgument=R;function N(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}n.illegalState=N;function v(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}n.readonly=v;function e(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}n.disposed=e;function E(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}n.getErrorMessage=E;class F extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}n.NotImplementedError=F;class y extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}n.NotSupportedError=y;class L extends Error{constructor(){super(...arguments),this.isExpected=!0}}n.ExpectedError=L;class d extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof d)return r;const s=new d;return s.message=r.message,s.stack=r.stack,s}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}n.ErrorNoTelemetry=d;class b extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype);debugger}}n.BugIndicatingError=b}),Z(J[26],x([0,1,6]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.tieBreakComparators=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.mapFind=n.getRandomElement=n.asArray=n.mapArrayOrNot=n.pushMany=n.pushToEnd=n.pushToStart=n.shuffle=n.arrayInsert=n.remove=n.insert=n.index=n.range=n.flatten=n.commonPrefixLength=n.lastOrDefault=n.firstOrDefault=n.lastIndex=n.findLast=n.uniqueFilter=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.move=n.coalesceInPlace=n.coalesce=n.topAsync=n.top=n.delta=n.sortedDiff=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function t(S,I=0){return S[S.length-(1+I)]}n.tail=t;function P(S){if(S.length===0)throw new Error("Invalid tail call");return[S.slice(0,S.length-1),S[S.length-1]]}n.tail2=P;function u(S,I,U=(W,j)=>W===j){if(S===I)return!0;if(!S||!I||S.length!==I.length)return!1;for(let W=0,j=S.length;W<j;W++)if(!U(S[W],I[W]))return!1;return!0}n.equals=u;function _(S,I){const U=S.length-1;I<U&&(S[I]=S[U]),S.pop()}n.removeFastWithoutKeepingOrder=_;function m(S,I,U){return a(S.length,W=>U(S[W],I))}n.binarySearch=m;function a(S,I){let U=0,W=S-1;for(;U<=W;){const j=(U+W)/2|0,ie=I(j);if(ie<0)U=j+1;else if(ie>0)W=j-1;else return j}return-(U+1)}n.binarySearch2=a;function h(S,I){let U=0,W=S.length;if(W===0)return 0;for(;U<W;){const j=Math.floor((U+W)/2);I(S[j])?W=j:U=j+1}return U}n.findFirstInSorted=h;function A(S,I,U){if(S=S|0,S>=I.length)throw new TypeError("invalid index");const W=I[Math.floor(I.length*Math.random())],j=[],ie=[],re=[];for(const oe of I){const ae=U(oe,W);ae<0?j.push(oe):ae>0?ie.push(oe):re.push(oe)}return S<j.length?A(S,j,U):S<j.length+re.length?re[0]:A(S-(j.length+re.length),ie,U)}n.quickSelect=A;function R(S,I){const U=[];let W;for(const j of S.slice(0).sort(I))!W||I(W[0],j)!==0?(W=[j],U.push(W)):W.push(j);return U}n.groupBy=R;function N(S,I,U){const W=[];function j(oe,ae,fe){if(ae===0&&fe.length===0)return;const he=W[W.length-1];he&&he.start+he.deleteCount===oe?(he.deleteCount+=ae,he.toInsert.push(...fe)):W.push({start:oe,deleteCount:ae,toInsert:fe})}let ie=0,re=0;for(;;){if(ie===S.length){j(ie,0,I.slice(re));break}if(re===I.length){j(ie,S.length-ie,[]);break}const oe=S[ie],ae=I[re],fe=U(oe,ae);fe===0?(ie+=1,re+=1):fe<0?(j(ie,1,[]),ie+=1):fe>0&&(j(ie,0,[ae]),re+=1)}return W}n.sortedDiff=N;function v(S,I,U){const W=N(S,I,U),j=[],ie=[];for(const re of W)j.push(...S.slice(re.start,re.start+re.deleteCount)),ie.push(...re.toInsert);return{removed:j,added:ie}}n.delta=v;function e(S,I,U){if(U===0)return[];const W=S.slice(0,U).sort(I);return F(S,I,W,U,S.length),W}n.top=e;function E(S,I,U,W,j){return U===0?Promise.resolve([]):new Promise((ie,re)=>{(async()=>{const oe=S.length,ae=S.slice(0,U).sort(I);for(let fe=U,he=Math.min(U+W,oe);fe<oe;fe=he,he=Math.min(he+W,oe)){if(fe>U&&await new Promise(Se=>setTimeout(Se)),j&&j.isCancellationRequested)throw new D.CancellationError;F(S,I,ae,fe,he)}return ae})().then(ie,re)})}n.topAsync=E;function F(S,I,U,W,j){for(const ie=U.length;W<j;W++){const re=S[W];if(I(re,U[ie-1])<0){U.pop();const oe=h(U,ae=>I(re,ae)<0);U.splice(oe,0,re)}}}function y(S){return S.filter(I=>!!I)}n.coalesce=y;function L(S){let I=0;for(let U=0;U<S.length;U++)S[U]&&(S[I]=S[U],I+=1);S.length=I}n.coalesceInPlace=L;function d(S,I,U){S.splice(U,0,S.splice(I,1)[0])}n.move=d;function b(S){return!Array.isArray(S)||S.length===0}n.isFalsyOrEmpty=b;function l(S){return Array.isArray(S)&&S.length>0}n.isNonEmptyArray=l;function r(S,I=U=>U){const U=new Set;return S.filter(W=>{const j=I(W);return U.has(j)?!1:(U.add(j),!0)})}n.distinct=r;function s(S){const I=new Set;return U=>{const W=S(U);return I.has(W)?!1:(I.add(W),!0)}}n.uniqueFilter=s;function g(S,I){const U=c(S,I);if(U!==-1)return S[U]}n.findLast=g;function c(S,I){for(let U=S.length-1;U>=0;U--){const W=S[U];if(I(W))return U}return-1}n.lastIndex=c;function p(S,I){return S.length>0?S[0]:I}n.firstOrDefault=p;function w(S,I){return S.length>0?S[S.length-1]:I}n.lastOrDefault=w;function f(S,I,U=(W,j)=>W===j){let W=0;for(let j=0,ie=Math.min(S.length,I.length);j<ie&&U(S[j],I[j]);j++)W++;return W}n.commonPrefixLength=f;function o(S){return[].concat(...S)}n.flatten=o;function M(S,I){let U=typeof I=="number"?S:0;typeof I=="number"?U=S:(U=0,I=S);const W=[];if(U<=I)for(let j=U;j<I;j++)W.push(j);else for(let j=U;j>I;j--)W.push(j);return W}n.range=M;function T(S,I,U){return S.reduce((W,j)=>(W[I(j)]=U?U(j):j,W),Object.create(null))}n.index=T;function O(S,I){return S.push(I),()=>C(S,I)}n.insert=O;function C(S,I){const U=S.indexOf(I);if(U>-1)return S.splice(U,1),I}n.remove=C;function H(S,I,U){const W=S.slice(0,I),j=S.slice(I);return W.concat(U,j)}n.arrayInsert=H;function z(S,I){let U;if(typeof I=="number"){let W=I;U=()=>{const j=Math.sin(W++)*179426549;return j-Math.floor(j)}}else U=Math.random;for(let W=S.length-1;W>0;W-=1){const j=Math.floor(U()*(W+1)),ie=S[W];S[W]=S[j],S[j]=ie}}n.shuffle=z;function ee(S,I){const U=S.indexOf(I);U>-1&&(S.splice(U,1),S.unshift(I))}n.pushToStart=ee;function ne(S,I){const U=S.indexOf(I);U>-1&&(S.splice(U,1),S.push(I))}n.pushToEnd=ne;function Q(S,I){for(const U of I)S.push(U)}n.pushMany=Q;function K(S,I){return Array.isArray(S)?S.map(I):I(S)}n.mapArrayOrNot=K;function i(S){return Array.isArray(S)?S:[S]}n.asArray=i;function ve(S){return S[Math.floor(Math.random()*S.length)]}n.getRandomElement=ve;function Ae(S,I){for(const U of S){const W=I(U);if(W!==void 0)return W}}n.mapFind=Ae;function de(S,I,U){const W=Le(S,I),j=S.length,ie=U.length;S.length=j+ie;for(let re=j-1;re>=W;re--)S[re+ie]=S[re];for(let re=0;re<ie;re++)S[re+W]=U[re]}n.insertInto=de;function Ee(S,I,U,W){const j=Le(S,I),ie=S.splice(j,U);return de(S,j,W),ie}n.splice=Ee;function Le(S,I){return I<0?Math.max(I+S.length,0):Math.min(I,S.length)}var Ne;(function(S){function I(j){return j<0}S.isLessThan=I;function U(j){return j>0}S.isGreaterThan=U;function W(j){return j===0}S.isNeitherLessOrGreaterThan=W,S.greaterThan=1,S.lessThan=-1,S.neitherLessOrGreaterThan=0})(Ne=n.CompareResult||(n.CompareResult={}));function Re(S,I){return(U,W)=>I(S(U),S(W))}n.compareBy=Re;function De(...S){return(I,U)=>{for(const W of S){const j=W(I,U);if(!Ne.isNeitherLessOrGreaterThan(j))return j}return Ne.neitherLessOrGreaterThan}}n.tieBreakComparators=De;const Fe=(S,I)=>S-I;n.numberComparator=Fe;function ye(S,I){if(S.length===0)return;let U=S[0];for(let W=1;W<S.length;W++){const j=S[W];I(j,U)>0&&(U=j)}return U}n.findMaxBy=ye;function Pe(S,I){if(S.length===0)return;let U=S[0];for(let W=1;W<S.length;W++){const j=S[W];I(j,U)>=0&&(U=j)}return U}n.findLastMaxBy=Pe;function te(S,I){return ye(S,(U,W)=>-I(U,W))}n.findMinBy=te;class G{constructor(I){this.f=I,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(I){let U=this.c;for(;U<this.f.length&&I(this.f[U]);)U++;const W=U===this.c?null:this.f.slice(this.c,U);return this.c=U,W}takeFromEndWhile(I){let U=this.d;for(;U>=0&&I(this.f[U]);)U--;const W=U===this.d?null:this.f.slice(U+1,this.d+1);return this.d=U,W}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const I=this.f[this.c];return this.c++,I}removeLast(){const I=this.f[this.d];return this.d--,I}takeCount(I){const U=this.f.slice(this.c,this.c+I);return this.c+=I,U}}n.ArrayQueue=G;class Y{constructor(I){this.iterate=I}forEach(I){this.iterate(U=>(I(U),!0))}toArray(){const I=[];return this.iterate(U=>(I.push(U),!0)),I}filter(I){return new Y(U=>this.iterate(W=>I(W)?U(W):!0))}map(I){return new Y(U=>this.iterate(W=>U(I(W))))}some(I){let U=!1;return this.iterate(W=>(U=I(W),!U)),U}findFirst(I){let U;return this.iterate(W=>I(W)?(U=W,!1):!0),U}findLast(I){let U;return this.iterate(W=>(I(W)&&(U=W),!0)),U}findLastMaxBy(I){let U,W=!0;return this.iterate(j=>((W||Ne.isGreaterThan(I(j,U)))&&(W=!1,U=j),!0)),U}}n.CallbackIterable=Y,Y.empty=new Y(S=>{})}),Z(J[10],x([0,1,6]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assert=n.assertNever=n.ok=void 0;function t(a,h){if(!a)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}n.ok=t;function P(a,h="Unreachable"){throw new Error(h)}n.assertNever=P;function u(a){if(!a)throw new D.BugIndicatingError("Assertion Failed")}n.assert=u;function _(a){if(!a()){debugger;a(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}n.assertFn=_;function m(a,h){let A=0;for(;A<a.length-1;){const R=a[A],N=a[A+1];if(!h(R,N))return!1;A++}return!0}n.checkAdjacentItems=m}),Z(J[13],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function D(t){const P=this;let u=!1,_;return function(){return u||(u=!0,_=t.apply(P,arguments)),_}}n.once=D}),Z(J[14],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var D;(function(t){function P(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}t.is=P;const u=Object.freeze([]);function _(){return u}t.empty=_;function*m(b){yield b}t.single=m;function a(b){return P(b)?b:m(b)}t.wrap=a;function h(b){return b||u}t.from=h;function A(b){return!b||b[Symbol.iterator]().next().done===!0}t.isEmpty=A;function R(b){return b[Symbol.iterator]().next().value}t.first=R;function N(b,l){for(const r of b)if(l(r))return!0;return!1}t.some=N;function v(b,l){for(const r of b)if(l(r))return r}t.find=v;function*e(b,l){for(const r of b)l(r)&&(yield r)}t.filter=e;function*E(b,l){let r=0;for(const s of b)yield l(s,r++)}t.map=E;function*F(...b){for(const l of b)for(const r of l)yield r}t.concat=F;function y(b,l,r){let s=r;for(const g of b)s=l(s,g);return s}t.reduce=y;function*L(b,l,r=b.length){for(l<0&&(l+=b.length),r<0?r+=b.length:r>b.length&&(r=b.length);l<r;l++)yield b[l]}t.slice=L;function d(b,l=Number.POSITIVE_INFINITY){const r=[];if(l===0)return[r,b];const s=b[Symbol.iterator]();for(let g=0;g<l;g++){const c=s.next();if(c.done)return[r,t.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return s}}]}t.consume=d})(D=n.Iterable||(n.Iterable={}))}),Z(J[27],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyMod=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.ScanCodeUtils=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=n.ScanCode=n.KeyCode=void 0;var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(D=n.KeyCode||(n.KeyCode={}));var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(t=n.ScanCode||(n.ScanCode={}));class P{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(E,F){this._keyCodeToStr[E]=F,this._strToKeyCode[F.toLowerCase()]=E}keyCodeToStr(E){return this._keyCodeToStr[E]}strToKeyCode(E){return this._strToKeyCode[E.toLowerCase()]||0}}const u=new P,_=new P,m=new P;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const a=[],h=Object.create(null),A=Object.create(null);n.ScanCodeUtils={lowerCaseToEnum:e=>A[e]||0,toEnum:e=>h[e]||0,toString:e=>a[e]||"None"},n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",E=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],F=[],y=[];for(const L of E){const[d,b,l,r,s,g,c,p,w,f]=L;if(y[l]||(y[l]=!0,a[l]=r,h[r]=l,A[r.toLowerCase()]=l,b&&(n.IMMUTABLE_CODE_TO_KEY_CODE[l]=s,s!==0&&s!==3&&s!==5&&s!==4&&s!==6&&s!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[s]=l))),!F[s]){if(F[s]=!0,!g)throw new Error(`String representation missing for key code ${s} around scan code ${r}`);u.define(s,g),_.define(s,w||g),m.define(s,f||w||g)}c&&(n.EVENT_KEY_CODE_MAP[c]=s),p&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[p]=s)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var R;(function(e){function E(l){return u.keyCodeToStr(l)}e.toString=E;function F(l){return u.strToKeyCode(l)}e.fromString=F;function y(l){return _.keyCodeToStr(l)}e.toUserSettingsUS=y;function L(l){return m.keyCodeToStr(l)}e.toUserSettingsGeneral=L;function d(l){return _.strToKeyCode(l)||m.strToKeyCode(l)}e.fromUserSettings=d;function b(l){if(l>=93&&l<=108)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return u.keyCodeToStr(l)}e.toElectronAccelerator=b})(R=n.KeyCodeUtils||(n.KeyCodeUtils={}));var N;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(N=n.KeyMod||(n.KeyMod={}));function v(e,E){const F=(E&65535)<<16>>>0;return(e|F)>>>0}n.KeyChord=v}),Z(J[28],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class D{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}n.Lazy=D}),Z(J[7],x([0,1,13,14]),function(q,n,D,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.disposeOnReturn=n.ImmortalReference=n.AsyncReferenceCollection=n.ReferenceCollection=n.SafeDisposable=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.disposeIfDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const P=!1;let u=null;function _(w){u=w}if(n.setDisposableTracker=_,P){const w="__is_disposable_tracked__";_(new class{trackDisposable(f){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[w]||console.log(o)},3e3)}setParent(f,o){if(f&&f!==L.None)try{f[w]=!0}catch{}}markAsDisposed(f){if(f&&f!==L.None)try{f[w]=!0}catch{}}markAsSingleton(f){}})}function m(w){return u?.trackDisposable(w),w}function a(w){u?.markAsDisposed(w)}function h(w,f){u?.setParent(w,f)}function A(w,f){if(!!u)for(const o of w)u.setParent(o,f)}function R(w){return u?.markAsSingleton(w),w}n.markAsSingleton=R;function N(w){return typeof w.dispose=="function"&&w.dispose.length===0}n.isDisposable=N;function v(w){if(t.Iterable.is(w)){const f=[];for(const o of w)if(o)try{o.dispose()}catch(M){f.push(M)}if(f.length===1)throw f[0];if(f.length>1)throw new AggregateError(f,"Encountered errors while disposing of store");return Array.isArray(w)?[]:w}else if(w)return w.dispose(),w}n.dispose=v;function e(w){for(const f of w)N(f)&&f.dispose();return[]}n.disposeIfDisposable=e;function E(...w){const f=F(()=>v(w));return A(w,f),f}n.combinedDisposable=E;function F(w){const f=m({dispose:(0,D.once)(()=>{a(f),w()})});return f}n.toDisposable=F;class y{constructor(){this.c=new Set,this.f=!1,m(this)}dispose(){this.f||(a(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{v(this.c)}finally{this.c.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return h(f,this),this.f?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(f),f}}n.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class L{constructor(){this.q=new y,m(this),h(this.q,this)}dispose(){a(this),this.q.dispose()}B(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(f)}}n.Disposable=L,L.None=Object.freeze({dispose(){}});class d{constructor(){this.b=!1,m(this)}get value(){return this.b?void 0:this.a}set value(f){this.b||f===this.a||(this.a?.dispose(),f&&h(f,this),this.a=f)}clear(){this.value=void 0}dispose(){this.b=!0,a(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const f=this.a;return this.a=void 0,f&&h(f,null),f}}n.MutableDisposable=d;class b{constructor(f){this.b=f,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}n.RefCountedDisposable=b;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(f){let o=f;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,a(this))},this}}n.SafeDisposable=l;class r{constructor(){this.a=new Map}acquire(f,...o){let M=this.a.get(f);M||(M={counter:0,object:this.b(f,...o)},this.a.set(f,M));const{object:T}=M,O=(0,D.once)(()=>{--M.counter===0&&(this.c(f,M.object),this.a.delete(f))});return M.counter++,{object:T,dispose:O}}}n.ReferenceCollection=r;class s{constructor(f){this.a=f}async acquire(f,...o){const M=this.a.acquire(f,...o);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}n.AsyncReferenceCollection=s;class g{constructor(f){this.object=f}dispose(){}}n.ImmortalReference=g;function c(w){const f=new y;try{w(f)}finally{f.dispose()}}n.disposeOnReturn=c;class p{constructor(){this.a=new Map,this.b=!1,m(this)}dispose(){a(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{v(this.a.values())}finally{this.a.clear()}}has(f){return this.a.has(f)}get(f){return this.a.get(f)}set(f,o,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(f)?.dispose(),this.a.set(f,o)}deleteAndDispose(f){this.a.get(f)?.dispose(),this.a.delete(f)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}n.DisposableMap=p}),Z(J[15],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class D{constructor(u){this.element=u,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class t{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let u=this.a;for(;u!==D.Undefined;){const _=u.next;u.prev=D.Undefined,u.next=D.Undefined,u=_}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(u){return this.d(u,!1)}push(u){return this.d(u,!0)}d(u,_){const m=new D(u);if(this.a===D.Undefined)this.a=m,this.b=m;else if(_){const h=this.b;this.b=m,m.prev=h,h.next=m}else{const h=this.a;this.a=m,m.next=h,h.prev=m}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(m))}}shift(){if(this.a!==D.Undefined){const u=this.a.element;return this.e(this.a),u}}pop(){if(this.b!==D.Undefined){const u=this.b.element;return this.e(this.b),u}}e(u){if(u.prev!==D.Undefined&&u.next!==D.Undefined){const _=u.prev;_.next=u.next,u.next.prev=_}else u.prev===D.Undefined&&u.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):u.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):u.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let u=this.a;for(;u!==D.Undefined;)yield u.element,u=u.next}}n.LinkedList=t}),Z(J[29],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.withUndefinedAsNull=n.withNullAsUndefined=n.validateConstraint=n.validateConstraints=n.areFunctions=n.isFunction=n.isEmptyObject=n.assertAllDefined=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isStringArray=n.isString=void 0;function D(s){return typeof s=="string"}n.isString=D;function t(s){return Array.isArray(s)&&s.every(g=>D(g))}n.isStringArray=t;function P(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}n.isObject=P;function u(s){const g=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof g}n.isTypedArray=u;function _(s){return typeof s=="number"&&!isNaN(s)}n.isNumber=_;function m(s){return!!s&&typeof s[Symbol.iterator]=="function"}n.isIterable=m;function a(s){return s===!0||s===!1}n.isBoolean=a;function h(s){return typeof s>"u"}n.isUndefined=h;function A(s){return!R(s)}n.isDefined=A;function R(s){return h(s)||s===null}n.isUndefinedOrNull=R;function N(s,g){if(!s)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}n.assertType=N;function v(s){if(R(s))throw new Error("Assertion Failed: argument is undefined or null");return s}n.assertIsDefined=v;function e(...s){const g=[];for(let c=0;c<s.length;c++){const p=s[c];if(R(p))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);g.push(p)}return g}n.assertAllDefined=e;const E=Object.prototype.hasOwnProperty;function F(s){if(!P(s))return!1;for(const g in s)if(E.call(s,g))return!1;return!0}n.isEmptyObject=F;function y(s){return typeof s=="function"}n.isFunction=y;function L(...s){return s.length>0&&s.every(y)}n.areFunctions=L;function d(s,g){const c=Math.min(s.length,g.length);for(let p=0;p<c;p++)b(s[p],g[p])}n.validateConstraints=d;function b(s,g){if(D(g)){if(typeof s!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(y(g)){try{if(s instanceof g)return}catch{}if(!R(s)&&s.constructor===g||g.length===1&&g.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=b;function l(s){return s===null?void 0:s}n.withNullAsUndefined=l;function r(s){return typeof s>"u"?null:s}n.withUndefinedAsNull=r}),Z(J[11],x([0,1,29]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.filter=n.getCaseInsensitive=n.distinct=n.safeStringify=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function t(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const L=Array.isArray(y)?[]:{};return Object.entries(y).forEach(([d,b])=>{L[d]=b&&typeof b=="object"?t(b):b}),L}n.deepClone=t;function P(y){if(!y||typeof y!="object")return y;const L=[y];for(;L.length>0;){const d=L.shift();Object.freeze(d);for(const b in d)if(u.call(d,b)){const l=d[b];typeof l=="object"&&!Object.isFrozen(l)&&!(0,D.isTypedArray)(l)&&L.push(l)}}return y}n.deepFreeze=P;const u=Object.prototype.hasOwnProperty;function _(y,L){return m(y,L,new Set)}n.cloneAndChange=_;function m(y,L,d){if((0,D.isUndefinedOrNull)(y))return y;const b=L(y);if(typeof b<"u")return b;if(Array.isArray(y)){const l=[];for(const r of y)l.push(m(r,L,d));return l}if((0,D.isObject)(y)){if(d.has(y))throw new Error("Cannot clone recursive data-structure");d.add(y);const l={};for(const r in y)u.call(y,r)&&(l[r]=m(y[r],L,d));return d.delete(y),l}return y}function a(y,L,d=!0){return(0,D.isObject)(y)?((0,D.isObject)(L)&&Object.keys(L).forEach(b=>{b in y?d&&((0,D.isObject)(y[b])&&(0,D.isObject)(L[b])?a(y[b],L[b],d):y[b]=L[b]):y[b]=L[b]}),y):L}n.mixin=a;function h(y,L){if(y===L)return!0;if(y==null||L===null||L===void 0||typeof y!=typeof L||typeof y!="object"||Array.isArray(y)!==Array.isArray(L))return!1;let d,b;if(Array.isArray(y)){if(y.length!==L.length)return!1;for(d=0;d<y.length;d++)if(!h(y[d],L[d]))return!1}else{const l=[];for(b in y)l.push(b);l.sort();const r=[];for(b in L)r.push(b);if(r.sort(),!h(l,r))return!1;for(d=0;d<l.length;d++)if(!h(y[l[d]],L[l[d]]))return!1}return!0}n.equals=h;function A(y){const L=new Set;return JSON.stringify(y,(d,b)=>{if((0,D.isObject)(b)||Array.isArray(b)){if(L.has(b))return"[Circular]";L.add(b)}return b})}n.safeStringify=A;function R(y,L){const d=Object.create(null);return!y||!L||Object.keys(L).forEach(l=>{const r=y[l],s=L[l];h(r,s)||(d[l]=s)}),d}n.distinct=R;function N(y,L){const d=L.toLowerCase(),b=Object.keys(y).find(l=>l.toLowerCase()===d);return b?y[b]:y[L]}n.getCaseInsensitive=N;function v(y,L){const d=Object.create(null);for(const[b,l]of Object.entries(y))L(b,l)&&(d[b]=l);return d}n.filter=v;function e(y){let L=[],d=Object.getPrototypeOf(y);for(;Object.prototype!==d;)L=L.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return L}n.getAllPropertyNames=e;function E(y){const L=[];for(const d of e(y))typeof y[d]=="function"&&L.push(d);return L}n.getAllMethodNames=E;function F(y,L){const d=l=>function(){const r=Array.prototype.slice.call(arguments,0);return L(l,r)},b={};for(const l of y)b[l]=d(l);return b}n.createProxyObject=F}),Z(J[16],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=n.Constants=void 0;var D;(function(u){u[u.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",u[u.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",u[u.MAX_UINT_8=255]="MAX_UINT_8",u[u.MAX_UINT_16=65535]="MAX_UINT_16",u[u.MAX_UINT_32=4294967295]="MAX_UINT_32",u[u.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D=n.Constants||(n.Constants={}));function t(u){return u<0?0:u>255?255:u|0}n.toUint8=t;function P(u){return u<0?0:u>4294967295?4294967295:u|0}n.toUint32=P}),Z(J[17],x([0,1,16]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class t{constructor(m){const a=(0,D.toUint8)(m);this.c=a,this.a=t.d(a),this.b=new Map}static d(m){const a=new Uint8Array(256);return a.fill(m),a}set(m,a){const h=(0,D.toUint8)(a);m>=0&&m<256?this.a[m]=h:this.b.set(m,h)}get(m){return m>=0&&m<256?this.a[m]:this.b.get(m)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}n.CharacterClassifier=t;var P;(function(_){_[_.False=0]="False",_[_.True=1]="True"})(P||(P={}));class u{constructor(){this.a=new t(0)}add(m){this.a.set(m,1)}has(m){return this.a.get(m)===1}clear(){return this.a.clear()}}n.CharacterSet=u}),Z(J[3],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class D{constructor(P,u){this.lineNumber=P,this.column=u}with(P=this.lineNumber,u=this.column){return P===this.lineNumber&&u===this.column?this:new D(P,u)}delta(P=0,u=0){return this.with(this.lineNumber+P,this.column+u)}equals(P){return D.equals(this,P)}static equals(P,u){return!P&&!u?!0:!!P&&!!u&&P.lineNumber===u.lineNumber&&P.column===u.column}isBefore(P){return D.isBefore(this,P)}static isBefore(P,u){return P.lineNumber<u.lineNumber?!0:u.lineNumber<P.lineNumber?!1:P.column<u.column}isBeforeOrEqual(P){return D.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,u){return P.lineNumber<u.lineNumber?!0:u.lineNumber<P.lineNumber?!1:P.column<=u.column}static compare(P,u){const _=P.lineNumber|0,m=u.lineNumber|0;if(_===m){const a=P.column|0,h=u.column|0;return a-h}return _-m}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new D(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}}n.Position=D}),Z(J[2],x([0,1,3]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class t{constructor(u,_,m,a){u>m||u===m&&_>a?(this.startLineNumber=m,this.startColumn=a,this.endLineNumber=u,this.endColumn=_):(this.startLineNumber=u,this.startColumn=_,this.endLineNumber=m,this.endColumn=a)}isEmpty(){return t.isEmpty(this)}static isEmpty(u){return u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn}containsPosition(u){return t.containsPosition(this,u)}static containsPosition(u,_){return!(_.lineNumber<u.startLineNumber||_.lineNumber>u.endLineNumber||_.lineNumber===u.startLineNumber&&_.column<u.startColumn||_.lineNumber===u.endLineNumber&&_.column>u.endColumn)}static strictContainsPosition(u,_){return!(_.lineNumber<u.startLineNumber||_.lineNumber>u.endLineNumber||_.lineNumber===u.startLineNumber&&_.column<=u.startColumn||_.lineNumber===u.endLineNumber&&_.column>=u.endColumn)}containsRange(u){return t.containsRange(this,u)}static containsRange(u,_){return!(_.startLineNumber<u.startLineNumber||_.endLineNumber<u.startLineNumber||_.startLineNumber>u.endLineNumber||_.endLineNumber>u.endLineNumber||_.startLineNumber===u.startLineNumber&&_.startColumn<u.startColumn||_.endLineNumber===u.endLineNumber&&_.endColumn>u.endColumn)}strictContainsRange(u){return t.strictContainsRange(this,u)}static strictContainsRange(u,_){return!(_.startLineNumber<u.startLineNumber||_.endLineNumber<u.startLineNumber||_.startLineNumber>u.endLineNumber||_.endLineNumber>u.endLineNumber||_.startLineNumber===u.startLineNumber&&_.startColumn<=u.startColumn||_.endLineNumber===u.endLineNumber&&_.endColumn>=u.endColumn)}plusRange(u){return t.plusRange(this,u)}static plusRange(u,_){let m,a,h,A;return _.startLineNumber<u.startLineNumber?(m=_.startLineNumber,a=_.startColumn):_.startLineNumber===u.startLineNumber?(m=_.startLineNumber,a=Math.min(_.startColumn,u.startColumn)):(m=u.startLineNumber,a=u.startColumn),_.endLineNumber>u.endLineNumber?(h=_.endLineNumber,A=_.endColumn):_.endLineNumber===u.endLineNumber?(h=_.endLineNumber,A=Math.max(_.endColumn,u.endColumn)):(h=u.endLineNumber,A=u.endColumn),new t(m,a,h,A)}intersectRanges(u){return t.intersectRanges(this,u)}static intersectRanges(u,_){let m=u.startLineNumber,a=u.startColumn,h=u.endLineNumber,A=u.endColumn;const R=_.startLineNumber,N=_.startColumn,v=_.endLineNumber,e=_.endColumn;return m<R?(m=R,a=N):m===R&&(a=Math.max(a,N)),h>v?(h=v,A=e):h===v&&(A=Math.min(A,e)),m>h||m===h&&a>A?null:new t(m,a,h,A)}equalsRange(u){return t.equalsRange(this,u)}static equalsRange(u,_){return!u&&!_?!0:!!u&&!!_&&u.startLineNumber===_.startLineNumber&&u.startColumn===_.startColumn&&u.endLineNumber===_.endLineNumber&&u.endColumn===_.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(u){return new D.Position(u.endLineNumber,u.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(u){return new D.Position(u.startLineNumber,u.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(u,_){return new t(this.startLineNumber,this.startColumn,u,_)}setStartPosition(u,_){return new t(u,_,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(u){return new t(u.startLineNumber,u.startColumn,u.startLineNumber,u.startColumn)}collapseToEnd(){return t.collapseToEnd(this)}static collapseToEnd(u){return new t(u.endLineNumber,u.endColumn,u.endLineNumber,u.endColumn)}delta(u){return new t(this.startLineNumber+u,this.startColumn,this.endLineNumber+u,this.endColumn)}static fromPositions(u,_=u){return new t(u.lineNumber,u.column,_.lineNumber,_.column)}static lift(u){return u?new t(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):null}static isIRange(u){return u&&typeof u.startLineNumber=="number"&&typeof u.startColumn=="number"&&typeof u.endLineNumber=="number"&&typeof u.endColumn=="number"}static areIntersectingOrTouching(u,_){return!(u.endLineNumber<_.startLineNumber||u.endLineNumber===_.startLineNumber&&u.endColumn<_.startColumn||_.endLineNumber<u.startLineNumber||_.endLineNumber===u.startLineNumber&&_.endColumn<u.startColumn)}static areIntersecting(u,_){return!(u.endLineNumber<_.startLineNumber||u.endLineNumber===_.startLineNumber&&u.endColumn<=_.startColumn||_.endLineNumber<u.startLineNumber||_.endLineNumber===u.startLineNumber&&_.endColumn<=u.startColumn)}static compareRangesUsingStarts(u,_){if(u&&_){const h=u.startLineNumber|0,A=_.startLineNumber|0;if(h===A){const R=u.startColumn|0,N=_.startColumn|0;if(R===N){const v=u.endLineNumber|0,e=_.endLineNumber|0;if(v===e){const E=u.endColumn|0,F=_.endColumn|0;return E-F}return v-e}return R-N}return h-A}return(u?1:0)-(_?1:0)}static compareRangesUsingEnds(u,_){return u.endLineNumber===_.endLineNumber?u.endColumn===_.endColumn?u.startLineNumber===_.startLineNumber?u.startColumn-_.startColumn:u.startLineNumber-_.startLineNumber:u.endColumn-_.endColumn:u.endLineNumber-_.endLineNumber}static spansMultipleLines(u){return u.endLineNumber>u.startLineNumber}toJSON(){return this}}n.Range=t}),Z(J[30],x([0,1,3,2]),function(q,n,D,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=n.SelectionDirection=void 0;var P;(function(_){_[_.LTR=0]="LTR",_[_.RTL=1]="RTL"})(P=n.SelectionDirection||(n.SelectionDirection={}));class u extends t.Range{constructor(m,a,h,A){super(m,a,h,A),this.selectionStartLineNumber=m,this.selectionStartColumn=a,this.positionLineNumber=h,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return u.selectionsEqual(this,m)}static selectionsEqual(m,a){return m.selectionStartLineNumber===a.selectionStartLineNumber&&m.selectionStartColumn===a.selectionStartColumn&&m.positionLineNumber===a.positionLineNumber&&m.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,a){return this.getDirection()===0?new u(this.startLineNumber,this.startColumn,m,a):new u(m,a,this.startLineNumber,this.startColumn)}getPosition(){return new D.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,a){return this.getDirection()===0?new u(m,a,this.endLineNumber,this.endColumn):new u(this.endLineNumber,this.endColumn,m,a)}static fromPositions(m,a=m){return new u(m.lineNumber,m.column,a.lineNumber,a.column)}static fromRange(m,a){return a===0?new u(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new u(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new u(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,a){if(m&&!a||!m&&a)return!1;if(!m&&!a)return!0;if(m.length!==a.length)return!1;for(let h=0,A=m.length;h<A;h++)if(!this.selectionsEqual(m[h],a[h]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,a,h,A,R){return R===0?new u(m,a,h,A):new u(h,A,m,a)}}n.Selection=u}),Z(J[31],x([0,1,17]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=n.WordCharacterClass=void 0;var t;(function(_){_[_.Regular=0]="Regular",_[_.Whitespace=1]="Whitespace",_[_.WordSeparator=2]="WordSeparator"})(t=n.WordCharacterClass||(n.WordCharacterClass={}));class P extends D.CharacterClassifier{constructor(m){super(0);for(let a=0,h=m.length;a<h;a++)this.set(m.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=P;function u(_){const m={};return a=>(m.hasOwnProperty(a)||(m[a]=_(a)),m[a])}n.getMapForWordSeparators=u(_=>new P(_))}),Z(J[18],x([0,1,14,7,15]),function(q,n,D,t,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.setDefaultGetWordAtTextConfig=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function u(R=""){let N="(-?\\d*\\.\\d\\w*)|([^";for(const v of n.USUAL_WORD_SEPARATORS)R.indexOf(v)>=0||(N+="\\"+v);return N+="\\s]+)",new RegExp(N,"g")}n.DEFAULT_WORD_REGEXP=u();function _(R){let N=n.DEFAULT_WORD_REGEXP;if(R&&R instanceof RegExp)if(R.global)N=R;else{let v="g";R.ignoreCase&&(v+="i"),R.multiline&&(v+="m"),R.unicode&&(v+="u"),N=new RegExp(R.source,v)}return N.lastIndex=0,N}n.ensureValidWordDefinition=_;const m=new P.LinkedList;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(R){const N=m.unshift(R);return(0,t.toDisposable)(N)}n.setDefaultGetWordAtTextConfig=a;function h(R,N,v,e,E){if(E||(E=D.Iterable.first(m)),v.length>E.maxLen){let b=R-E.maxLen/2;return b<0?b=0:e+=b,v=v.substring(b,R+E.maxLen/2),h(R,N,v,e,E)}const F=Date.now(),y=R-1-e;let L=-1,d=null;for(let b=1;!(Date.now()-F>=E.timeBudget);b++){const l=y-E.windowSize*b;N.lastIndex=Math.max(0,l);const r=A(N,v,y,L);if(!r&&d||(d=r,l<=0))break;L=l}if(d){const b={word:d[0],startColumn:e+1+d.index,endColumn:e+1+d.index+d[0].length};return N.lastIndex=0,b}return null}n.getWordAtText=h;function A(R,N,v,e){let E;for(;E=R.exec(N);){const F=E.index||0;if(F<=v&&R.lastIndex>=v)return E;if(e>0&&F>e)return null}return null}}),Z(J[8],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRange=n.SequenceDiff=void 0;class D{constructor(u,_){this.seq1Range=u,this.seq2Range=_}reverse(){return new D(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}}n.SequenceDiff=D;class t{constructor(u,_){this.start=u,this.endExclusive=_}get isEmpty(){return this.start===this.endExclusive}delta(u){return new t(this.start+u,this.endExclusive+u)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}join(u){return new t(Math.min(this.start,u.start),Math.max(this.endExclusive,u.endExclusive))}}n.OffsetRange=t}),Z(J[32],x([0,1,8]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shiftSequenceDiffs=n.joinSequenceDiffs=n.smoothenSequenceDiffs=n.optimizeSequenceDiffs=void 0;function t(a,h,A){let R=A;return R=u(a,h,R),R=_(a,h,R),R}n.optimizeSequenceDiffs=t;function P(a,h,A){const R=[];for(const N of A){const v=R[R.length-1];if(!v){R.push(N);continue}N.seq1Range.start-v.seq1Range.endExclusive<=2||N.seq2Range.start-v.seq2Range.endExclusive<=2?R[R.length-1]=new D.SequenceDiff(v.seq1Range.join(N.seq1Range),v.seq2Range.join(N.seq2Range)):R.push(N)}return R}n.smoothenSequenceDiffs=P;function u(a,h,A){const R=[];A.length>0&&R.push(A[0]);for(let N=1;N<A.length;N++){const v=R[R.length-1],e=A[N];if(e.seq1Range.isEmpty){let E=!0;const F=e.seq1Range.start-v.seq1Range.endExclusive;for(let y=1;y<=F;y++)if(h.getElement(e.seq2Range.start-y)!==h.getElement(e.seq2Range.endExclusive-y)){E=!1;break}if(E){R[R.length-1]=new D.SequenceDiff(v.seq1Range,new D.OffsetRange(v.seq2Range.start,e.seq2Range.endExclusive-F));continue}}R.push(e)}return R}n.joinSequenceDiffs=u;function _(a,h,A){if(!a.getBoundaryScore||!h.getBoundaryScore)return A;for(let R=0;R<A.length;R++){const N=A[R];if(N.seq1Range.isEmpty){const v=R>0?A[R-1].seq2Range.endExclusive:-1,e=R+1<A.length?A[R+1].seq2Range.start:h.length;A[R]=m(N,a,h,e,v)}else if(N.seq2Range.isEmpty){const v=R>0?A[R-1].seq1Range.endExclusive:-1,e=R+1<A.length?A[R+1].seq1Range.start:a.length;A[R]=m(N.reverse(),h,a,e,v).reverse()}}return A}n.shiftSequenceDiffs=_;function m(a,h,A,R,N){let e=1;for(;a.seq2Range.start-e>N&&A.getElement(a.seq2Range.start-e)===A.getElement(a.seq2Range.endExclusive-e)&&e<20;)e++;e--;let E=0;for(;a.seq2Range.start+E<R&&A.getElement(a.seq2Range.start+E)===A.getElement(a.seq2Range.endExclusive+E)&&E<20;)E++;if(e===0&&E===0)return a;let F=0,y=-1;for(let L=-e;L<=E;L++){const d=a.seq2Range.start+L,b=a.seq2Range.endExclusive+L,l=a.seq1Range.start+L,r=h.getBoundaryScore(l)+A.getBoundaryScore(d)+A.getBoundaryScore(b);r>y&&(y=r,F=L)}return F!==0?new D.SequenceDiff(a.seq1Range.delta(F),a.seq2Range.delta(F)):a}}),Z(J[33],x([0,1,8]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class t{compute(a,h){if(a.length===0)return[new D.SequenceDiff(new D.OffsetRange(0,0),new D.OffsetRange(0,h.length))];if(h.length===0)return[new D.SequenceDiff(new D.OffsetRange(0,a.length),new D.OffsetRange(0,0))];function A(d,b){for(;d<a.length&&b<h.length&&a.getElement(d)===h.getElement(b);)d++,b++;return d}let R=0;const N=new u;N.set(0,A(0,0));const v=new _;v.set(0,N.get(0)===0?null:new P(null,0,0,N.get(0)));let e=0;e:for(;;)for(R++,e=-R;e<=R;e+=2){const d=e===R?-1:N.get(e+1),b=e===-R?-1:N.get(e-1)+1,l=Math.min(Math.max(d,b),a.length),r=l-e,s=A(l,r);N.set(e,s);const g=l===d?v.get(e+1):v.get(e-1);if(v.set(e,s!==l?new P(g,l,r,s-l):g),N.get(e)===a.length&&N.get(e)-e===h.length)break e}let E=v.get(e);const F=[];let y=a.length,L=h.length;for(;;){const d=E?E.x+E.length:0,b=E?E.y+E.length:0;if((d!==y||b!==L)&&F.push(new D.SequenceDiff(new D.OffsetRange(d,y),new D.OffsetRange(b,L))),!E)break;y=E.x,L=E.y,E=E.prev}return F.reverse(),F}}n.MyersDiffAlgorithm=t;class P{constructor(a,h,A,R){this.prev=a,this.x=h,this.y=A,this.length=R}}class u{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(a){return a<0?(a=-a-1,this.b[a]):this.a[a]}set(a,h){if(a<0){if(a=-a-1,a>=this.b.length){const A=this.b;this.b=new Int32Array(A.length*2),this.b.set(A)}this.b[a]=h}else{if(a>=this.a.length){const A=this.a;this.a=new Int32Array(A.length*2),this.a.set(A)}this.a[a]=h}}}class _{constructor(){this.a=[],this.b=[]}get(a){return a<0?(a=-a-1,this.b[a]):this.a[a]}set(a,h){a<0?(a=-a-1,this.b[a]=h):this.a[a]=h}}}),Z(J[34],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class D{constructor(P,u){this.width=P,this.height=u,this.a=[],this.a=new Array(P*u)}get(P,u){return this.a[P+u*this.width]}set(P,u,_){this.a[P+u*this.width]=_}}n.Array2D=D}),Z(J[35],x([0,1,8,34]),function(q,n,D,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class P{compute(_,m,a){const h=new t.Array2D(_.length,m.length),A=new t.Array2D(_.length,m.length),R=new t.Array2D(_.length,m.length);for(let L=0;L<_.length;L++)for(let d=0;d<m.length;d++){const b=L===0?0:h.get(L-1,d),l=d===0?0:h.get(L,d-1);let r;_.getElement(L)===m.getElement(d)?(L===0||d===0?r=0:r=h.get(L-1,d-1),L>0&&d>0&&A.get(L-1,d-1)===3&&(r+=R.get(L-1,d-1)),r+=a?a(L,d):1):r=-1;const s=Math.max(b,l,r);if(s===r){const g=L>0&&d>0?R.get(L-1,d-1):0;R.set(L,d,g+1),A.set(L,d,3)}else s===b?(R.set(L,d,0),A.set(L,d,1)):s===l&&(R.set(L,d,0),A.set(L,d,2));h.set(L,d,s)}const N=[];let v=_.length,e=m.length;function E(L,d){(L+1!==v||d+1!==e)&&N.push(new D.SequenceDiff(new D.OffsetRange(L+1,v),new D.OffsetRange(d+1,e))),v=L,e=d}let F=_.length-1,y=m.length-1;for(;F>=0&&y>=0;)A.get(F,y)===3?(E(F,y),F--,y--):A.get(F,y)===1?F--:y--;return E(-1,-1),N.reverse(),N}}n.DynamicProgrammingDiffing=P}),Z(J[19],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRange=n.RangeMapping=n.LineRangeMapping=void 0;class D{constructor(_,m,a){this.originalRange=_,this.modifiedRange=m,this.innerChanges=a}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.LineRangeMapping=D;class t{constructor(_,m){this.originalRange=_,this.modifiedRange=m}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.RangeMapping=t;class P{constructor(_,m){this.startLineNumber=_,this.endLineNumberExclusive=m}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(_){return new P(this.startLineNumber+_,this.endLineNumberExclusive+_)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(_){return new P(Math.min(this.startLineNumber,_.startLineNumber),Math.max(this.endLineNumberExclusive,_.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}n.LineRange=P}),Z(J[36],x([0,1,10,3,2,8,35,32,33,19]),function(q,n,D,t,P,u,_,m,a,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=n.lineRangeMappingFromRangeMappings=n.StandardLinesDiffComputer=void 0;class A{constructor(){this.b=new _.DynamicProgrammingDiffing,this.c=new a.MyersDiffAlgorithm}computeDiff(r,s,g){const c=new Map;function p(ne){let Q=c.get(ne);return Q===void 0&&(Q=c.size,c.set(ne,Q)),Q}const w=r.map(ne=>p(ne.trim())),f=s.map(ne=>p(ne.trim())),o=new v(w,r),M=new v(f,s);let T=(()=>o.length+M.length<1500?this.b.compute(o,M,(ne,Q)=>r[ne]===s[Q]?s[Q].length===0?.1:1+Math.log(1+s[Q].length):.99):this.c.compute(o,M))();T=(0,m.optimizeSequenceDiffs)(o,M,T);const O=[],C=ne=>{for(let Q=0;Q<ne;Q++){const K=H+Q,i=z+Q;if(r[K]!==s[i]){const ve=this.f(r,s,new u.SequenceDiff(new u.OffsetRange(K,K+1),new u.OffsetRange(i,i+1)));for(const Ae of ve)O.push(Ae)}}};let H=0,z=0;for(const ne of T){(0,D.assertFn)(()=>ne.seq1Range.start-H===ne.seq2Range.start-z);const Q=ne.seq1Range.start-H;C(Q),H=ne.seq1Range.endExclusive,z=ne.seq2Range.endExclusive;const K=this.f(r,s,ne);for(const i of K)O.push(i)}C(r.length-H);const ee=R(O);return{quitEarly:!1,changes:ee}}f(r,s,g){const c=new E(r,g.seq1Range),p=new E(s,g.seq2Range),w=c.length+p.length<500?this.b.compute(c,p):this.c.compute(c,p);let f=(0,m.optimizeSequenceDiffs)(c,p,w);return f=(0,m.smoothenSequenceDiffs)(c,p,f),f.map(M=>new h.RangeMapping(c.translateRange(M.seq1Range).delta(g.seq1Range.start),p.translateRange(M.seq2Range).delta(g.seq2Range.start)))}}n.StandardLinesDiffComputer=A;function R(l){const r=[];for(const s of N(l,(g,c)=>c.originalRange.startLineNumber-(g.originalRange.endLineNumber-(g.originalRange.endColumn>1?0:1))<=1||c.modifiedRange.startLineNumber-(g.modifiedRange.endLineNumber-(g.modifiedRange.endColumn>1?0:1))<=1)){const g=s[0],c=s[s.length-1];r.push(new h.LineRangeMapping(new h.LineRange(g.originalRange.startLineNumber,c.originalRange.endLineNumber+(c.originalRange.endColumn>1||c.modifiedRange.endColumn>1?1:0)),new h.LineRange(g.modifiedRange.startLineNumber,c.modifiedRange.endLineNumber+(c.originalRange.endColumn>1||c.modifiedRange.endColumn>1?1:0)),s))}return(0,D.assertFn)(()=>(0,D.checkAdjacentItems)(r,(s,g)=>g.originalRange.startLineNumber-s.originalRange.endLineNumberExclusive===g.modifiedRange.startLineNumber-s.modifiedRange.endLineNumberExclusive&&s.originalRange.endLineNumberExclusive<g.originalRange.startLineNumber&&s.modifiedRange.endLineNumberExclusive<g.modifiedRange.startLineNumber)),r}n.lineRangeMappingFromRangeMappings=R;function*N(l,r){let s,g;for(const c of l)g!==void 0&&r(g,c)?s.push(c):(s&&(yield s),s=[c]),g=c;s&&(yield s)}class v{constructor(r,s){this.b=r,this.c=s}getElement(r){return this.b[r]}get length(){return this.b.length}getBoundaryScore(r){const s=r===0?0:e(this.c[r-1]),g=r===this.c.length?0:e(this.c[r]);return 1e3-(s+g)}}n.LineSequence=v;function e(l){let r=0;for(;r<l.length&&(l.charCodeAt(r)===32||l.charCodeAt(r)===9);)r++;return r}class E{constructor(r,s){this.lines=r,this.lineRange=s;let g=0;this.c=new Int32Array(s.length);for(let p=s.start;p<s.endExclusive;p++)g+=r[p].length,this.c[p-s.start]=g+1,g++;this.b=new Int32Array(g);let c=0;for(let p=s.start;p<s.endExclusive;p++){const w=r[p];for(let f=0;f<w.length;f++)this.b[c+f]=w.charCodeAt(f);c+=w.length,p<r.length-1&&(this.b[c]=`
`.charCodeAt(0),c+=1)}}get text(){return[...this.b].map(r=>String.fromCharCode(r)).join("")}getElement(r){return this.b[r]}get length(){return this.b.length}getBoundaryScore(r){const s=d(r>0?this.b[r-1]:-1),g=d(r<this.b.length?this.b[r]:-1);if(s===6&&g===7)return 0;let c=0;return s!==g&&(c+=10,g===1&&(c+=1)),c+=L(s),c+=L(g),c}translateOffset(r){let s=0,g=this.c.length;for(;s<g;){const p=Math.floor((s+g)/2);this.c[p]>r?g=p:s=p+1}const c=s===0?0:this.c[s-1];return new t.Position(s+1,r-c+1)}translateRange(r){return P.Range.fromPositions(this.translateOffset(r.start),this.translateOffset(r.endExclusive))}}var F;(function(l){l[l.WordLower=0]="WordLower",l[l.WordUpper=1]="WordUpper",l[l.WordNumber=2]="WordNumber",l[l.End=3]="End",l[l.Other=4]="Other",l[l.Space=5]="Space",l[l.LineBreakCR=6]="LineBreakCR",l[l.LineBreakLF=7]="LineBreakLF"})(F||(F={}));const y={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function L(l){return y[l]}function d(l){return l===10?7:l===13?6:b(l)?5:l>=97&&l<=122?0:l>=65&&l<=90?1:l>=48&&l<=57?2:l===-1?3:4}function b(l){return l===32||l===9}}),Z(J[37],x([0,1,17]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.State=void 0;var t;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(t=n.State||(n.State={}));class P{constructor(e,E,F){const y=new Uint8Array(e*E);for(let L=0,d=e*E;L<d;L++)y[L]=F;this.a=y,this.rows=e,this.cols=E}get(e,E){return this.a[e*this.cols+E]}set(e,E,F){this.a[e*this.cols+E]=F}}class u{constructor(e){let E=0,F=0;for(let L=0,d=e.length;L<d;L++){const[b,l,r]=e[L];l>E&&(E=l),b>F&&(F=b),r>F&&(F=r)}E++,F++;const y=new P(F,E,0);for(let L=0,d=e.length;L<d;L++){const[b,l,r]=e[L];y.set(b,l,r)}this.a=y,this.b=E}nextState(e,E){return E<0||E>=this.b?0:this.a.get(e,E)}}n.StateMachine=u;let _=null;function m(){return _===null&&(_=new u([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),_}var a;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let h=null;function A(){if(h===null){h=new D.CharacterClassifier(0);const v=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<v.length;E++)h.set(v.charCodeAt(E),1);const e=".;:";for(let E=0;E<e.length;E++)h.set(e.charCodeAt(E),2)}return h}class R{static a(e,E,F,y,L){let d=L-1;do{const b=E.charCodeAt(d);if(e.get(b)!==2)break;d--}while(d>y);if(y>0){const b=E.charCodeAt(y-1),l=E.charCodeAt(d);(b===40&&l===41||b===91&&l===93||b===123&&l===125)&&d--}return{range:{startLineNumber:F,startColumn:y+1,endLineNumber:F,endColumn:d+2},url:E.substring(y,d+1)}}static computeLinks(e,E=m()){const F=A(),y=[];for(let L=1,d=e.getLineCount();L<=d;L++){const b=e.getLineContent(L),l=b.length;let r=0,s=0,g=0,c=1,p=!1,w=!1,f=!1,o=!1;for(;r<l;){let M=!1;const T=b.charCodeAt(r);if(c===13){let O;switch(T){case 40:p=!0,O=0;break;case 41:O=p?0:1;break;case 91:f=!0,w=!0,O=0;break;case 93:f=!1,O=w?0:1;break;case 123:o=!0,O=0;break;case 125:O=o?0:1;break;case 39:case 34:case 96:g===T?O=1:g===39||g===34||g===96?O=0:O=1;break;case 42:O=g===42?1:0;break;case 124:O=g===124?1:0;break;case 32:O=f?0:1;break;default:O=F.get(T)}O===1&&(y.push(R.a(F,b,L,s,r)),M=!0)}else if(c===12){let O;T===91?(w=!0,O=0):O=F.get(T),O===1?M=!0:c=13}else c=E.nextState(c,T),c===0&&(M=!0);M&&(c=1,p=!1,w=!1,o=!1,s=r+1,g=T),r++}c===13&&y.push(R.a(F,b,L,s,l))}return y}}n.LinkComputer=R;function N(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:R.computeLinks(v)}n.computeLinks=N}),Z(J[38],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class D{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(P,u,_,m,a){if(P&&u){const h=this.a(u,a);if(h)return{range:P,value:h}}if(_&&m){const h=this.a(m,a);if(h)return{range:_,value:h}}return null}a(P,u){const _=this.b(P,u);return _!==null?_:this.d(P,u)}b(P,u){const _=Math.pow(10,P.length-(P.lastIndexOf(".")+1));let m=Number(P);const a=parseFloat(P);return!isNaN(m)&&!isNaN(a)&&m===a?m===0&&!u?null:(m=Math.floor(m*_),m+=u?_:-_,String(m/_)):null}d(P,u){return this.e(this.c,P,u)}e(P,u,_){let m=null;for(let a=0,h=P.length;m===null&&a<h;a++)m=this.f(P[a],u,_);return m}f(P,u,_){let m=P.indexOf(u);return m>=0?(m+=_?1:-1,m<0?m=P.length-1:m%=P.length,P[m]):null}}n.BasicInplaceReplace=D,D.INSTANCE=new D}),Z(J[39],x([0,1,11]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.ModelConstants=n.PositionAffinity=n.isITextSnapshot=n.TrackedRangeStickiness=n.FindMatch=n.TextModelResolvedOptions=n.EndOfLineSequence=n.DefaultEndOfLine=n.EndOfLinePreference=n.InjectedTextCursorStops=n.MinimapPosition=n.OverviewRulerLane=void 0;var t;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(t=n.OverviewRulerLane||(n.OverviewRulerLane={}));var P;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(P=n.MinimapPosition||(n.MinimapPosition={}));var u;(function(d){d[d.Both=0]="Both",d[d.Right=1]="Right",d[d.Left=2]="Left",d[d.None=3]="None"})(u=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var _;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(_=n.EndOfLinePreference||(n.EndOfLinePreference={}));var m;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(m=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var a;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(a=n.EndOfLineSequence||(n.EndOfLineSequence={}));class h{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(b){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,b.tabSize|0),b.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,b.indentSize|0),this.a=!1),this.insertSpaces=Boolean(b.insertSpaces),this.defaultEOL=b.defaultEOL|0,this.trimAutoWhitespace=Boolean(b.trimAutoWhitespace),this.bracketPairColorizationOptions=b.bracketPairColorizationOptions}equals(b){return this.tabSize===b.tabSize&&this.a===b.a&&this.indentSize===b.indentSize&&this.insertSpaces===b.insertSpaces&&this.defaultEOL===b.defaultEOL&&this.trimAutoWhitespace===b.trimAutoWhitespace&&(0,D.equals)(this.bracketPairColorizationOptions,b.bracketPairColorizationOptions)}createChangeEvent(b){return{tabSize:this.tabSize!==b.tabSize,indentSize:this.indentSize!==b.indentSize,insertSpaces:this.insertSpaces!==b.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==b.trimAutoWhitespace}}}n.TextModelResolvedOptions=h;class A{constructor(b,l){this._findMatchBrand=void 0,this.range=b,this.matches=l}}n.FindMatch=A;var R;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(R=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));function N(d){return d&&typeof d.read=="function"}n.isITextSnapshot=N;var v;(function(d){d[d.Left=0]="Left",d[d.Right=1]="Right",d[d.None=2]="None",d[d.LeftOfInjectedText=3]="LeftOfInjectedText",d[d.RightOfInjectedText=4]="RightOfInjectedText"})(v=n.PositionAffinity||(n.PositionAffinity={}));var e;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(e=n.ModelConstants||(n.ModelConstants={}));class E{constructor(b,l,r,s,g,c){this.identifier=b,this.range=l,this.text=r,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=g,this._isTracked=c}}n.ValidAnnotatedEditOperation=E;class F{constructor(b,l,r){this.regex=b,this.wordSeparators=l,this.simpleSearch=r}}n.SearchData=F;class y{constructor(b,l,r){this.reverseEdits=b,this.changes=l,this.trimAutoWhitespaceLineNumbers=r}}n.ApplyEditsResult=y;function L(d){return!d.isTooLargeForSyncing()&&!d.isForSimpleWidget}n.shouldSynchronizeModel=L}),Z(J[40],x([0,1,26,16]),function(q,n,D,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class P{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,h){a=(0,t.toUint32)(a);const A=this.a,R=this.b,N=h.length;return N===0?!1:(this.a=new Uint32Array(A.length+N),this.a.set(A.subarray(0,a),0),this.a.set(A.subarray(a),a+N),this.a.set(h,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(R.subarray(0,this.c[0]+1)),!0)}setValue(a,h){return a=(0,t.toUint32)(a),h=(0,t.toUint32)(h),this.a[a]===h?!1:(this.a[a]=h,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,h){a=(0,t.toUint32)(a),h=(0,t.toUint32)(h);const A=this.a,R=this.b;if(a>=A.length)return!1;const N=A.length-a;return h>=N&&(h=N),h===0?!1:(this.a=new Uint32Array(A.length-h),this.a.set(A.subarray(0,a),0),this.a.set(A.subarray(a+h),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(R.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,t.toUint32)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let h=this.c[0]+1;h===0&&(this.b[0]=this.a[0],h++),a>=this.a.length&&(a=this.a.length-1);for(let A=h;A<=a;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let h=0,A=this.a.length-1,R=0,N=0,v=0;for(;h<=A;)if(R=h+(A-h)/2|0,N=this.b[R],v=N-this.a[R],a<v)A=R-1;else if(a>=N)h=R+1;else break;return new _(R,a-v)}}n.PrefixSumComputer=P;class u{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const h=this.e[a],A=h>0?this.d[h-1]:0;return new _(h,a-A)}removeValues(a,h){this.a.splice(a,h),this.f(a)}insertValues(a,h){this.a=(0,D.arrayInsert)(this.a,a,h),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,h=this.a.length;a<h;a++){const A=this.a[a],R=a>0?this.d[a-1]:0;this.d[a]=R+A;for(let N=0;N<A;N++)this.e[R+N]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,h){this.a[a]!==h&&(this.a[a]=h,this.f(a))}}n.ConstantTimePrefixSumComputer=u;class _{constructor(a,h){this.index=a,this.remainder=h,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=h}}n.PrefixSumIndexOfResult=_}),Z(J[41],x([0,1]),function(q,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var D;(function(i){i[i.Unknown=0]="Unknown",i[i.Disabled=1]="Disabled",i[i.Enabled=2]="Enabled"})(D=n.AccessibilitySupport||(n.AccessibilitySupport={}));var t;(function(i){i[i.Invoke=1]="Invoke",i[i.Auto=2]="Auto"})(t=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var P;(function(i){i[i.None=0]="None",i[i.KeepWhitespace=1]="KeepWhitespace",i[i.InsertAsSnippet=4]="InsertAsSnippet"})(P=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var u;(function(i){i[i.Method=0]="Method",i[i.Function=1]="Function",i[i.Constructor=2]="Constructor",i[i.Field=3]="Field",i[i.Variable=4]="Variable",i[i.Class=5]="Class",i[i.Struct=6]="Struct",i[i.Interface=7]="Interface",i[i.Module=8]="Module",i[i.Property=9]="Property",i[i.Event=10]="Event",i[i.Operator=11]="Operator",i[i.Unit=12]="Unit",i[i.Value=13]="Value",i[i.Constant=14]="Constant",i[i.Enum=15]="Enum",i[i.EnumMember=16]="EnumMember",i[i.Keyword=17]="Keyword",i[i.Text=18]="Text",i[i.Color=19]="Color",i[i.File=20]="File",i[i.Reference=21]="Reference",i[i.Customcolor=22]="Customcolor",i[i.Folder=23]="Folder",i[i.TypeParameter=24]="TypeParameter",i[i.User=25]="User",i[i.Issue=26]="Issue",i[i.Snippet=27]="Snippet"})(u=n.CompletionItemKind||(n.CompletionItemKind={}));var _;(function(i){i[i.Deprecated=1]="Deprecated"})(_=n.CompletionItemTag||(n.CompletionItemTag={}));var m;(function(i){i[i.Invoke=0]="Invoke",i[i.TriggerCharacter=1]="TriggerCharacter",i[i.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var a;(function(i){i[i.EXACT=0]="EXACT",i[i.ABOVE=1]="ABOVE",i[i.BELOW=2]="BELOW"})(a=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var h;(function(i){i[i.NotSet=0]="NotSet",i[i.ContentFlush=1]="ContentFlush",i[i.RecoverFromMarkers=2]="RecoverFromMarkers",i[i.Explicit=3]="Explicit",i[i.Paste=4]="Paste",i[i.Undo=5]="Undo",i[i.Redo=6]="Redo"})(h=n.CursorChangeReason||(n.CursorChangeReason={}));var A;(function(i){i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(A=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var R;(function(i){i[i.Text=0]="Text",i[i.Read=1]="Read",i[i.Write=2]="Write"})(R=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var N;(function(i){i[i.None=0]="None",i[i.Keep=1]="Keep",i[i.Brackets=2]="Brackets",i[i.Advanced=3]="Advanced",i[i.Full=4]="Full"})(N=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var v;(function(i){i[i.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",i[i.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",i[i.accessibilitySupport=2]="accessibilitySupport",i[i.accessibilityPageSize=3]="accessibilityPageSize",i[i.ariaLabel=4]="ariaLabel",i[i.autoClosingBrackets=5]="autoClosingBrackets",i[i.autoClosingDelete=6]="autoClosingDelete",i[i.autoClosingOvertype=7]="autoClosingOvertype",i[i.autoClosingQuotes=8]="autoClosingQuotes",i[i.autoIndent=9]="autoIndent",i[i.automaticLayout=10]="automaticLayout",i[i.autoSurround=11]="autoSurround",i[i.bracketPairColorization=12]="bracketPairColorization",i[i.guides=13]="guides",i[i.codeLens=14]="codeLens",i[i.codeLensFontFamily=15]="codeLensFontFamily",i[i.codeLensFontSize=16]="codeLensFontSize",i[i.colorDecorators=17]="colorDecorators",i[i.colorDecoratorsLimit=18]="colorDecoratorsLimit",i[i.columnSelection=19]="columnSelection",i[i.comments=20]="comments",i[i.contextmenu=21]="contextmenu",i[i.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",i[i.cursorBlinking=23]="cursorBlinking",i[i.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",i[i.cursorStyle=25]="cursorStyle",i[i.cursorSurroundingLines=26]="cursorSurroundingLines",i[i.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",i[i.cursorWidth=28]="cursorWidth",i[i.disableLayerHinting=29]="disableLayerHinting",i[i.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",i[i.domReadOnly=31]="domReadOnly",i[i.dragAndDrop=32]="dragAndDrop",i[i.dropIntoEditor=33]="dropIntoEditor",i[i.emptySelectionClipboard=34]="emptySelectionClipboard",i[i.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",i[i.extraEditorClassName=36]="extraEditorClassName",i[i.fastScrollSensitivity=37]="fastScrollSensitivity",i[i.find=38]="find",i[i.fixedOverflowWidgets=39]="fixedOverflowWidgets",i[i.folding=40]="folding",i[i.foldingStrategy=41]="foldingStrategy",i[i.foldingHighlight=42]="foldingHighlight",i[i.foldingImportsByDefault=43]="foldingImportsByDefault",i[i.foldingMaximumRegions=44]="foldingMaximumRegions",i[i.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",i[i.fontFamily=46]="fontFamily",i[i.fontInfo=47]="fontInfo",i[i.fontLigatures=48]="fontLigatures",i[i.fontSize=49]="fontSize",i[i.fontWeight=50]="fontWeight",i[i.fontVariations=51]="fontVariations",i[i.formatOnPaste=52]="formatOnPaste",i[i.formatOnType=53]="formatOnType",i[i.glyphMargin=54]="glyphMargin",i[i.gotoLocation=55]="gotoLocation",i[i.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",i[i.hover=57]="hover",i[i.inDiffEditor=58]="inDiffEditor",i[i.inlineSuggest=59]="inlineSuggest",i[i.letterSpacing=60]="letterSpacing",i[i.lightbulb=61]="lightbulb",i[i.lineDecorationsWidth=62]="lineDecorationsWidth",i[i.lineHeight=63]="lineHeight",i[i.lineNumbers=64]="lineNumbers",i[i.lineNumbersMinChars=65]="lineNumbersMinChars",i[i.linkedEditing=66]="linkedEditing",i[i.links=67]="links",i[i.matchBrackets=68]="matchBrackets",i[i.minimap=69]="minimap",i[i.mouseStyle=70]="mouseStyle",i[i.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",i[i.mouseWheelZoom=72]="mouseWheelZoom",i[i.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",i[i.multiCursorModifier=74]="multiCursorModifier",i[i.multiCursorPaste=75]="multiCursorPaste",i[i.multiCursorLimit=76]="multiCursorLimit",i[i.occurrencesHighlight=77]="occurrencesHighlight",i[i.overviewRulerBorder=78]="overviewRulerBorder",i[i.overviewRulerLanes=79]="overviewRulerLanes",i[i.padding=80]="padding",i[i.parameterHints=81]="parameterHints",i[i.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",i[i.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",i[i.quickSuggestions=84]="quickSuggestions",i[i.quickSuggestionsDelay=85]="quickSuggestionsDelay",i[i.readOnly=86]="readOnly",i[i.renameOnType=87]="renameOnType",i[i.renderControlCharacters=88]="renderControlCharacters",i[i.renderFinalNewline=89]="renderFinalNewline",i[i.renderLineHighlight=90]="renderLineHighlight",i[i.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",i[i.renderValidationDecorations=92]="renderValidationDecorations",i[i.renderWhitespace=93]="renderWhitespace",i[i.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",i[i.roundedSelection=95]="roundedSelection",i[i.rulers=96]="rulers",i[i.scrollbar=97]="scrollbar",i[i.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",i[i.scrollBeyondLastLine=99]="scrollBeyondLastLine",i[i.scrollPredominantAxis=100]="scrollPredominantAxis",i[i.selectionClipboard=101]="selectionClipboard",i[i.selectionHighlight=102]="selectionHighlight",i[i.selectOnLineNumbers=103]="selectOnLineNumbers",i[i.showFoldingControls=104]="showFoldingControls",i[i.showUnused=105]="showUnused",i[i.snippetSuggestions=106]="snippetSuggestions",i[i.smartSelect=107]="smartSelect",i[i.smoothScrolling=108]="smoothScrolling",i[i.stickyScroll=109]="stickyScroll",i[i.stickyTabStops=110]="stickyTabStops",i[i.stopRenderingLineAfter=111]="stopRenderingLineAfter",i[i.suggest=112]="suggest",i[i.suggestFontSize=113]="suggestFontSize",i[i.suggestLineHeight=114]="suggestLineHeight",i[i.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",i[i.suggestSelection=116]="suggestSelection",i[i.tabCompletion=117]="tabCompletion",i[i.tabIndex=118]="tabIndex",i[i.unicodeHighlighting=119]="unicodeHighlighting",i[i.unusualLineTerminators=120]="unusualLineTerminators",i[i.useShadowDOM=121]="useShadowDOM",i[i.useTabStops=122]="useTabStops",i[i.wordBreak=123]="wordBreak",i[i.wordSeparators=124]="wordSeparators",i[i.wordWrap=125]="wordWrap",i[i.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",i[i.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",i[i.wordWrapColumn=128]="wordWrapColumn",i[i.wordWrapOverride1=129]="wordWrapOverride1",i[i.wordWrapOverride2=130]="wordWrapOverride2",i[i.wrappingIndent=131]="wrappingIndent",i[i.wrappingStrategy=132]="wrappingStrategy",i[i.showDeprecated=133]="showDeprecated",i[i.inlayHints=134]="inlayHints",i[i.editorClassName=135]="editorClassName",i[i.pixelRatio=136]="pixelRatio",i[i.tabFocusMode=137]="tabFocusMode",i[i.layoutInfo=138]="layoutInfo",i[i.wrappingInfo=139]="wrappingInfo"})(v=n.EditorOption||(n.EditorOption={}));var e;(function(i){i[i.TextDefined=0]="TextDefined",i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(e=n.EndOfLinePreference||(n.EndOfLinePreference={}));var E;(function(i){i[i.LF=0]="LF",i[i.CRLF=1]="CRLF"})(E=n.EndOfLineSequence||(n.EndOfLineSequence={}));var F;(function(i){i[i.None=0]="None",i[i.Indent=1]="Indent",i[i.IndentOutdent=2]="IndentOutdent",i[i.Outdent=3]="Outdent"})(F=n.IndentAction||(n.IndentAction={}));var y;(function(i){i[i.Both=0]="Both",i[i.Right=1]="Right",i[i.Left=2]="Left",i[i.None=3]="None"})(y=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var L;(function(i){i[i.Type=1]="Type",i[i.Parameter=2]="Parameter"})(L=n.InlayHintKind||(n.InlayHintKind={}));var d;(function(i){i[i.Automatic=0]="Automatic",i[i.Explicit=1]="Explicit"})(d=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var b;(function(i){i[i.DependsOnKbLayout=-1]="DependsOnKbLayout",i[i.Unknown=0]="Unknown",i[i.Backspace=1]="Backspace",i[i.Tab=2]="Tab",i[i.Enter=3]="Enter",i[i.Shift=4]="Shift",i[i.Ctrl=5]="Ctrl",i[i.Alt=6]="Alt",i[i.PauseBreak=7]="PauseBreak",i[i.CapsLock=8]="CapsLock",i[i.Escape=9]="Escape",i[i.Space=10]="Space",i[i.PageUp=11]="PageUp",i[i.PageDown=12]="PageDown",i[i.End=13]="End",i[i.Home=14]="Home",i[i.LeftArrow=15]="LeftArrow",i[i.UpArrow=16]="UpArrow",i[i.RightArrow=17]="RightArrow",i[i.DownArrow=18]="DownArrow",i[i.Insert=19]="Insert",i[i.Delete=20]="Delete",i[i.Digit0=21]="Digit0",i[i.Digit1=22]="Digit1",i[i.Digit2=23]="Digit2",i[i.Digit3=24]="Digit3",i[i.Digit4=25]="Digit4",i[i.Digit5=26]="Digit5",i[i.Digit6=27]="Digit6",i[i.Digit7=28]="Digit7",i[i.Digit8=29]="Digit8",i[i.Digit9=30]="Digit9",i[i.KeyA=31]="KeyA",i[i.KeyB=32]="KeyB",i[i.KeyC=33]="KeyC",i[i.KeyD=34]="KeyD",i[i.KeyE=35]="KeyE",i[i.KeyF=36]="KeyF",i[i.KeyG=37]="KeyG",i[i.KeyH=38]="KeyH",i[i.KeyI=39]="KeyI",i[i.KeyJ=40]="KeyJ",i[i.KeyK=41]="KeyK",i[i.KeyL=42]="KeyL",i[i.KeyM=43]="KeyM",i[i.KeyN=44]="KeyN",i[i.KeyO=45]="KeyO",i[i.KeyP=46]="KeyP",i[i.KeyQ=47]="KeyQ",i[i.KeyR=48]="KeyR",i[i.KeyS=49]="KeyS",i[i.KeyT=50]="KeyT",i[i.KeyU=51]="KeyU",i[i.KeyV=52]="KeyV",i[i.KeyW=53]="KeyW",i[i.KeyX=54]="KeyX",i[i.KeyY=55]="KeyY",i[i.KeyZ=56]="KeyZ",i[i.Meta=57]="Meta",i[i.ContextMenu=58]="ContextMenu",i[i.F1=59]="F1",i[i.F2=60]="F2",i[i.F3=61]="F3",i[i.F4=62]="F4",i[i.F5=63]="F5",i[i.F6=64]="F6",i[i.F7=65]="F7",i[i.F8=66]="F8",i[i.F9=67]="F9",i[i.F10=68]="F10",i[i.F11=69]="F11",i[i.F12=70]="F12",i[i.F13=71]="F13",i[i.F14=72]="F14",i[i.F15=73]="F15",i[i.F16=74]="F16",i[i.F17=75]="F17",i[i.F18=76]="F18",i[i.F19=77]="F19",i[i.NumLock=78]="NumLock",i[i.ScrollLock=79]="ScrollLock",i[i.Semicolon=80]="Semicolon",i[i.Equal=81]="Equal",i[i.Comma=82]="Comma",i[i.Minus=83]="Minus",i[i.Period=84]="Period",i[i.Slash=85]="Slash",i[i.Backquote=86]="Backquote",i[i.BracketLeft=87]="BracketLeft",i[i.Backslash=88]="Backslash",i[i.BracketRight=89]="BracketRight",i[i.Quote=90]="Quote",i[i.OEM_8=91]="OEM_8",i[i.IntlBackslash=92]="IntlBackslash",i[i.Numpad0=93]="Numpad0",i[i.Numpad1=94]="Numpad1",i[i.Numpad2=95]="Numpad2",i[i.Numpad3=96]="Numpad3",i[i.Numpad4=97]="Numpad4",i[i.Numpad5=98]="Numpad5",i[i.Numpad6=99]="Numpad6",i[i.Numpad7=100]="Numpad7",i[i.Numpad8=101]="Numpad8",i[i.Numpad9=102]="Numpad9",i[i.NumpadMultiply=103]="NumpadMultiply",i[i.NumpadAdd=104]="NumpadAdd",i[i.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",i[i.NumpadSubtract=106]="NumpadSubtract",i[i.NumpadDecimal=107]="NumpadDecimal",i[i.NumpadDivide=108]="NumpadDivide",i[i.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",i[i.ABNT_C1=110]="ABNT_C1",i[i.ABNT_C2=111]="ABNT_C2",i[i.AudioVolumeMute=112]="AudioVolumeMute",i[i.AudioVolumeUp=113]="AudioVolumeUp",i[i.AudioVolumeDown=114]="AudioVolumeDown",i[i.BrowserSearch=115]="BrowserSearch",i[i.BrowserHome=116]="BrowserHome",i[i.BrowserBack=117]="BrowserBack",i[i.BrowserForward=118]="BrowserForward",i[i.MediaTrackNext=119]="MediaTrackNext",i[i.MediaTrackPrevious=120]="MediaTrackPrevious",i[i.MediaStop=121]="MediaStop",i[i.MediaPlayPause=122]="MediaPlayPause",i[i.LaunchMediaPlayer=123]="LaunchMediaPlayer",i[i.LaunchMail=124]="LaunchMail",i[i.LaunchApp2=125]="LaunchApp2",i[i.Clear=126]="Clear",i[i.MAX_VALUE=127]="MAX_VALUE"})(b=n.KeyCode||(n.KeyCode={}));var l;(function(i){i[i.Hint=1]="Hint",i[i.Info=2]="Info",i[i.Warning=4]="Warning",i[i.Error=8]="Error"})(l=n.MarkerSeverity||(n.MarkerSeverity={}));var r;(function(i){i[i.Unnecessary=1]="Unnecessary",i[i.Deprecated=2]="Deprecated"})(r=n.MarkerTag||(n.MarkerTag={}));var s;(function(i){i[i.Inline=1]="Inline",i[i.Gutter=2]="Gutter"})(s=n.MinimapPosition||(n.MinimapPosition={}));var g;(function(i){i[i.UNKNOWN=0]="UNKNOWN",i[i.TEXTAREA=1]="TEXTAREA",i[i.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",i[i.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",i[i.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",i[i.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",i[i.CONTENT_TEXT=6]="CONTENT_TEXT",i[i.CONTENT_EMPTY=7]="CONTENT_EMPTY",i[i.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",i[i.CONTENT_WIDGET=9]="CONTENT_WIDGET",i[i.OVERVIEW_RULER=10]="OVERVIEW_RULER",i[i.SCROLLBAR=11]="SCROLLBAR",i[i.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",i[i.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(g=n.MouseTargetType||(n.MouseTargetType={}));var c;(function(i){i[i.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",i[i.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",i[i.TOP_CENTER=2]="TOP_CENTER"})(c=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var p;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=4]="Right",i[i.Full=7]="Full"})(p=n.OverviewRulerLane||(n.OverviewRulerLane={}));var w;(function(i){i[i.Left=0]="Left",i[i.Right=1]="Right",i[i.None=2]="None",i[i.LeftOfInjectedText=3]="LeftOfInjectedText",i[i.RightOfInjectedText=4]="RightOfInjectedText"})(w=n.PositionAffinity||(n.PositionAffinity={}));var f;(function(i){i[i.Off=0]="Off",i[i.On=1]="On",i[i.Relative=2]="Relative",i[i.Interval=3]="Interval",i[i.Custom=4]="Custom"})(f=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var o;(function(i){i[i.None=0]="None",i[i.Text=1]="Text",i[i.Blocks=2]="Blocks"})(o=n.RenderMinimap||(n.RenderMinimap={}));var M;(function(i){i[i.Smooth=0]="Smooth",i[i.Immediate=1]="Immediate"})(M=n.ScrollType||(n.ScrollType={}));var T;(function(i){i[i.Auto=1]="Auto",i[i.Hidden=2]="Hidden",i[i.Visible=3]="Visible"})(T=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var O;(function(i){i[i.LTR=0]="LTR",i[i.RTL=1]="RTL"})(O=n.SelectionDirection||(n.SelectionDirection={}));var C;(function(i){i[i.Invoke=1]="Invoke",i[i.TriggerCharacter=2]="TriggerCharacter",i[i.ContentChange=3]="ContentChange"})(C=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var H;(function(i){i[i.File=0]="File",i[i.Module=1]="Module",i[i.Namespace=2]="Namespace",i[i.Package=3]="Package",i[i.Class=4]="Class",i[i.Method=5]="Method",i[i.Property=6]="Property",i[i.Field=7]="Field",i[i.Constructor=8]="Constructor",i[i.Enum=9]="Enum",i[i.Interface=10]="Interface",i[i.Function=11]="Function",i[i.Variable=12]="Variable",i[i.Constant=13]="Constant",i[i.String=14]="String",i[i.Number=15]="Number",i[i.Boolean=16]="Boolean",i[i.Array=17]="Array",i[i.Object=18]="Object",i[i.Key=19]="Key",i[i.Null=20]="Null",i[i.EnumMember=21]="EnumMember",i[i.Struct=22]="Struct",i[i.Event=23]="Event",i[i.Operator=24]="Operator",i[i.TypeParameter=25]="TypeParameter"})(H=n.SymbolKind||(n.SymbolKind={}));var z;(function(i){i[i.Deprecated=1]="Deprecated"})(z=n.SymbolTag||(n.SymbolTag={}));var ee;(function(i){i[i.Hidden=0]="Hidden",i[i.Blink=1]="Blink",i[i.Smooth=2]="Smooth",i[i.Phase=3]="Phase",i[i.Expand=4]="Expand",i[i.Solid=5]="Solid"})(ee=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var ne;(function(i){i[i.Line=1]="Line",i[i.Block=2]="Block",i[i.Underline=3]="Underline",i[i.LineThin=4]="LineThin",i[i.BlockOutline=5]="BlockOutline",i[i.UnderlineThin=6]="UnderlineThin"})(ne=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var Q;(function(i){i[i.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",i[i.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",i[i.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",i[i.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(Q=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var K;(function(i){i[i.None=0]="None",i[i.Same=1]="Same",i[i.Indent=2]="Indent",i[i.DeepIndent=3]="DeepIndent"})(K=n.WrappingIndent||(n.WrappingIndent={}))}),Z(J[42],x([55,56]),function(q,n){return q.create("vs/base/common/platform",n)}),Z(J[5],x([0,1,42]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.OperatingSystem=n.setTimeout0=n.setTimeout0IsFaster=n.translationsConfigFile=n.locale=n.Language=n.language=n.userAgent=n.platform=n.isCI=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isElectron=n.isNative=n.isLinuxSnap=n.isLinux=n.isMacintosh=n.isWindows=n.PlatformToString=n.Platform=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let t=!1,P=!1,u=!1,_=!1,m=!1,a=!1,h=!1,A=!1,R=!1,N=!1,v,e=n.LANGUAGE_DEFAULT,E,F;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let y;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?y=n.globals.vscode.process:typeof process<"u"&&(y=process);const L=typeof y?.versions?.electron=="string",d=L&&y?.type==="renderer";if(typeof navigator=="object"&&!d)F=navigator.userAgent,t=F.indexOf("Windows")>=0,P=F.indexOf("Macintosh")>=0,A=(F.indexOf("Macintosh")>=0||F.indexOf("iPad")>=0||F.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,u=F.indexOf("Linux")>=0,N=F?.indexOf("Mobi")>=0,a=!0,v=D.getConfiguredDefaultLocale(D.localize(0,null))||n.LANGUAGE_DEFAULT,e=v;else if(typeof y=="object"){t=y.platform==="win32",P=y.platform==="darwin",u=y.platform==="linux",_=u&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,h=L,R=!!y.env.CI||!!y.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=n.LANGUAGE_DEFAULT,e=n.LANGUAGE_DEFAULT;const f=y.env.VSCODE_NLS_CONFIG;if(f)try{const o=JSON.parse(f),M=o.availableLanguages["*"];v=o.locale,e=M||n.LANGUAGE_DEFAULT,E=o._translationsConfigFile}catch{}m=!0}else console.error("Unable to resolve platform.");var b;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(b=n.Platform||(n.Platform={}));function l(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}n.PlatformToString=l;let r=0;P?r=1:t?r=3:u&&(r=2),n.isWindows=t,n.isMacintosh=P,n.isLinux=u,n.isLinuxSnap=_,n.isNative=m,n.isElectron=h,n.isWeb=a,n.isWebWorker=a&&typeof n.globals.importScripts=="function",n.isIOS=A,n.isMobile=N,n.isCI=R,n.platform=r,n.userAgent=F,n.language=e;var s;(function(f){function o(){return n.language}f.value=o;function M(){return n.language.length===2?n.language==="en":n.language.length>=3?n.language[0]==="e"&&n.language[1]==="n"&&n.language[2]==="-":!1}f.isDefaultVariant=M;function T(){return n.language==="en"}f.isDefault=T})(s=n.Language||(n.Language={})),n.locale=v,n.translationsConfigFile=E,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const f=[];n.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,O=f.length;T<O;T++){const C=f[T];if(C.id===M.data.vscodeScheduleAsyncWork){f.splice(T,1),C.callback();return}}});let o=0;return M=>{const T=++o;f.push({id:T,callback:M}),n.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return f=>setTimeout(f)})();var g;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(g=n.OperatingSystem||(n.OperatingSystem={})),n.OS=P||A?2:t?1:3;let c=!0,p=!1;function w(){if(!p){p=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,c=new Uint16Array(f.buffer)[0]===(2<<8)+1}return c}n.isLittleEndian=w,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Z(J[43],x([0,1,5]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.arch=n.platform=n.env=n.cwd=void 0;let t;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const P=D.globals.vscode.process;t={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=t.cwd,n.env=t.env,n.platform=t.platform,n.arch=t.arch}),Z(J[44],x([0,1,43]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.delimiter=n.sep=n.toNamespacedPath=n.parse=n.format=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.join=n.isAbsolute=n.normalize=n.posix=n.win32=void 0;const t=65,P=97,u=90,_=122,m=46,a=47,h=92,A=58,R=63;class N extends Error{constructor(s,g,c){let p;typeof g=="string"&&g.indexOf("not ")===0?(p="must not be",g=g.replace(/^not /,"")):p="must be";const w=s.indexOf(".")!==-1?"property":"argument";let f=`The "${s}" ${w} ${p} of type ${g}`;f+=`. Received type ${typeof c}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function v(r,s){if(r===null||typeof r!="object")throw new N(s,"Object",r)}function e(r,s){if(typeof r!="string")throw new N(s,"string",r)}const E=D.platform==="win32";function F(r){return r===a||r===h}function y(r){return r===a}function L(r){return r>=t&&r<=u||r>=P&&r<=_}function d(r,s,g,c){let p="",w=0,f=-1,o=0,M=0;for(let T=0;T<=r.length;++T){if(T<r.length)M=r.charCodeAt(T);else{if(c(M))break;M=a}if(c(M)){if(!(f===T-1||o===1))if(o===2){if(p.length<2||w!==2||p.charCodeAt(p.length-1)!==m||p.charCodeAt(p.length-2)!==m){if(p.length>2){const O=p.lastIndexOf(g);O===-1?(p="",w=0):(p=p.slice(0,O),w=p.length-1-p.lastIndexOf(g)),f=T,o=0;continue}else if(p.length!==0){p="",w=0,f=T,o=0;continue}}s&&(p+=p.length>0?`${g}..`:"..",w=2)}else p.length>0?p+=`${g}${r.slice(f+1,T)}`:p=r.slice(f+1,T),w=T-f-1;f=T,o=0}else M===m&&o!==-1?++o:o=-1}return p}function b(r,s){v(s,"pathObject");const g=s.dir||s.root,c=s.base||`${s.name||""}${s.ext||""}`;return g?g===s.root?`${g}${c}`:`${g}${r}${c}`:c}n.win32={resolve(...r){let s="",g="",c=!1;for(let p=r.length-1;p>=-1;p--){let w;if(p>=0){if(w=r[p],e(w,"path"),w.length===0)continue}else s.length===0?w=D.cwd():(w=D.env[`=${s}`]||D.cwd(),(w===void 0||w.slice(0,2).toLowerCase()!==s.toLowerCase()&&w.charCodeAt(2)===h)&&(w=`${s}\\`));const f=w.length;let o=0,M="",T=!1;const O=w.charCodeAt(0);if(f===1)F(O)&&(o=1,T=!0);else if(F(O))if(T=!0,F(w.charCodeAt(1))){let C=2,H=C;for(;C<f&&!F(w.charCodeAt(C));)C++;if(C<f&&C!==H){const z=w.slice(H,C);for(H=C;C<f&&F(w.charCodeAt(C));)C++;if(C<f&&C!==H){for(H=C;C<f&&!F(w.charCodeAt(C));)C++;(C===f||C!==H)&&(M=`\\\\${z}\\${w.slice(H,C)}`,o=C)}}}else o=1;else L(O)&&w.charCodeAt(1)===A&&(M=w.slice(0,2),o=2,f>2&&F(w.charCodeAt(2))&&(T=!0,o=3));if(M.length>0)if(s.length>0){if(M.toLowerCase()!==s.toLowerCase())continue}else s=M;if(c){if(s.length>0)break}else if(g=`${w.slice(o)}\\${g}`,c=T,T&&s.length>0)break}return g=d(g,!c,"\\",F),c?`${s}\\${g}`:`${s}${g}`||"."},normalize(r){e(r,"path");const s=r.length;if(s===0)return".";let g=0,c,p=!1;const w=r.charCodeAt(0);if(s===1)return y(w)?"\\":r;if(F(w))if(p=!0,F(r.charCodeAt(1))){let o=2,M=o;for(;o<s&&!F(r.charCodeAt(o));)o++;if(o<s&&o!==M){const T=r.slice(M,o);for(M=o;o<s&&F(r.charCodeAt(o));)o++;if(o<s&&o!==M){for(M=o;o<s&&!F(r.charCodeAt(o));)o++;if(o===s)return`\\\\${T}\\${r.slice(M)}\\`;o!==M&&(c=`\\\\${T}\\${r.slice(M,o)}`,g=o)}}}else g=1;else L(w)&&r.charCodeAt(1)===A&&(c=r.slice(0,2),g=2,s>2&&F(r.charCodeAt(2))&&(p=!0,g=3));let f=g<s?d(r.slice(g),!p,"\\",F):"";return f.length===0&&!p&&(f="."),f.length>0&&F(r.charCodeAt(s-1))&&(f+="\\"),c===void 0?p?`\\${f}`:f:p?`${c}\\${f}`:`${c}${f}`},isAbsolute(r){e(r,"path");const s=r.length;if(s===0)return!1;const g=r.charCodeAt(0);return F(g)||s>2&&L(g)&&r.charCodeAt(1)===A&&F(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let s,g;for(let w=0;w<r.length;++w){const f=r[w];e(f,"path"),f.length>0&&(s===void 0?s=g=f:s+=`\\${f}`)}if(s===void 0)return".";let c=!0,p=0;if(typeof g=="string"&&F(g.charCodeAt(0))){++p;const w=g.length;w>1&&F(g.charCodeAt(1))&&(++p,w>2&&(F(g.charCodeAt(2))?++p:c=!1))}if(c){for(;p<s.length&&F(s.charCodeAt(p));)p++;p>=2&&(s=`\\${s.slice(p)}`)}return n.win32.normalize(s)},relative(r,s){if(e(r,"from"),e(s,"to"),r===s)return"";const g=n.win32.resolve(r),c=n.win32.resolve(s);if(g===c||(r=g.toLowerCase(),s=c.toLowerCase(),r===s))return"";let p=0;for(;p<r.length&&r.charCodeAt(p)===h;)p++;let w=r.length;for(;w-1>p&&r.charCodeAt(w-1)===h;)w--;const f=w-p;let o=0;for(;o<s.length&&s.charCodeAt(o)===h;)o++;let M=s.length;for(;M-1>o&&s.charCodeAt(M-1)===h;)M--;const T=M-o,O=f<T?f:T;let C=-1,H=0;for(;H<O;H++){const ee=r.charCodeAt(p+H);if(ee!==s.charCodeAt(o+H))break;ee===h&&(C=H)}if(H!==O){if(C===-1)return c}else{if(T>O){if(s.charCodeAt(o+H)===h)return c.slice(o+H+1);if(H===2)return c.slice(o+H)}f>O&&(r.charCodeAt(p+H)===h?C=H:H===2&&(C=3)),C===-1&&(C=0)}let z="";for(H=p+C+1;H<=w;++H)(H===w||r.charCodeAt(H)===h)&&(z+=z.length===0?"..":"\\..");return o+=C,z.length>0?`${z}${c.slice(o,M)}`:(c.charCodeAt(o)===h&&++o,c.slice(o,M))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const s=n.win32.resolve(r);if(s.length<=2)return r;if(s.charCodeAt(0)===h){if(s.charCodeAt(1)===h){const g=s.charCodeAt(2);if(g!==R&&g!==m)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(L(s.charCodeAt(0))&&s.charCodeAt(1)===A&&s.charCodeAt(2)===h)return`\\\\?\\${s}`;return r},dirname(r){e(r,"path");const s=r.length;if(s===0)return".";let g=-1,c=0;const p=r.charCodeAt(0);if(s===1)return F(p)?r:".";if(F(p)){if(g=c=1,F(r.charCodeAt(1))){let o=2,M=o;for(;o<s&&!F(r.charCodeAt(o));)o++;if(o<s&&o!==M){for(M=o;o<s&&F(r.charCodeAt(o));)o++;if(o<s&&o!==M){for(M=o;o<s&&!F(r.charCodeAt(o));)o++;if(o===s)return r;o!==M&&(g=c=o+1)}}}}else L(p)&&r.charCodeAt(1)===A&&(g=s>2&&F(r.charCodeAt(2))?3:2,c=g);let w=-1,f=!0;for(let o=s-1;o>=c;--o)if(F(r.charCodeAt(o))){if(!f){w=o;break}}else f=!1;if(w===-1){if(g===-1)return".";w=g}return r.slice(0,w)},basename(r,s){s!==void 0&&e(s,"ext"),e(r,"path");let g=0,c=-1,p=!0,w;if(r.length>=2&&L(r.charCodeAt(0))&&r.charCodeAt(1)===A&&(g=2),s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let f=s.length-1,o=-1;for(w=r.length-1;w>=g;--w){const M=r.charCodeAt(w);if(F(M)){if(!p){g=w+1;break}}else o===-1&&(p=!1,o=w+1),f>=0&&(M===s.charCodeAt(f)?--f===-1&&(c=w):(f=-1,c=o))}return g===c?c=o:c===-1&&(c=r.length),r.slice(g,c)}for(w=r.length-1;w>=g;--w)if(F(r.charCodeAt(w))){if(!p){g=w+1;break}}else c===-1&&(p=!1,c=w+1);return c===-1?"":r.slice(g,c)},extname(r){e(r,"path");let s=0,g=-1,c=0,p=-1,w=!0,f=0;r.length>=2&&r.charCodeAt(1)===A&&L(r.charCodeAt(0))&&(s=c=2);for(let o=r.length-1;o>=s;--o){const M=r.charCodeAt(o);if(F(M)){if(!w){c=o+1;break}continue}p===-1&&(w=!1,p=o+1),M===m?g===-1?g=o:f!==1&&(f=1):g!==-1&&(f=-1)}return g===-1||p===-1||f===0||f===1&&g===p-1&&g===c+1?"":r.slice(g,p)},format:b.bind(null,"\\"),parse(r){e(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const g=r.length;let c=0,p=r.charCodeAt(0);if(g===1)return F(p)?(s.root=s.dir=r,s):(s.base=s.name=r,s);if(F(p)){if(c=1,F(r.charCodeAt(1))){let C=2,H=C;for(;C<g&&!F(r.charCodeAt(C));)C++;if(C<g&&C!==H){for(H=C;C<g&&F(r.charCodeAt(C));)C++;if(C<g&&C!==H){for(H=C;C<g&&!F(r.charCodeAt(C));)C++;C===g?c=C:C!==H&&(c=C+1)}}}}else if(L(p)&&r.charCodeAt(1)===A){if(g<=2)return s.root=s.dir=r,s;if(c=2,F(r.charCodeAt(2))){if(g===3)return s.root=s.dir=r,s;c=3}}c>0&&(s.root=r.slice(0,c));let w=-1,f=c,o=-1,M=!0,T=r.length-1,O=0;for(;T>=c;--T){if(p=r.charCodeAt(T),F(p)){if(!M){f=T+1;break}continue}o===-1&&(M=!1,o=T+1),p===m?w===-1?w=T:O!==1&&(O=1):w!==-1&&(O=-1)}return o!==-1&&(w===-1||O===0||O===1&&w===o-1&&w===f+1?s.base=s.name=r.slice(f,o):(s.name=r.slice(f,w),s.base=r.slice(f,o),s.ext=r.slice(w,o))),f>0&&f!==c?s.dir=r.slice(0,f-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(E){const r=/\\/g;return()=>{const s=D.cwd().replace(r,"/");return s.slice(s.indexOf("/"))}}return()=>D.cwd()})();n.posix={resolve(...r){let s="",g=!1;for(let c=r.length-1;c>=-1&&!g;c--){const p=c>=0?r[c]:l();e(p,"path"),p.length!==0&&(s=`${p}/${s}`,g=p.charCodeAt(0)===a)}return s=d(s,!g,"/",y),g?`/${s}`:s.length>0?s:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===a,g=r.charCodeAt(r.length-1)===a;return r=d(r,!s,"/",y),r.length===0?s?"/":g?"./":".":(g&&(r+="/"),s?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===a},join(...r){if(r.length===0)return".";let s;for(let g=0;g<r.length;++g){const c=r[g];e(c,"path"),c.length>0&&(s===void 0?s=c:s+=`/${c}`)}return s===void 0?".":n.posix.normalize(s)},relative(r,s){if(e(r,"from"),e(s,"to"),r===s||(r=n.posix.resolve(r),s=n.posix.resolve(s),r===s))return"";const g=1,c=r.length,p=c-g,w=1,f=s.length-w,o=p<f?p:f;let M=-1,T=0;for(;T<o;T++){const C=r.charCodeAt(g+T);if(C!==s.charCodeAt(w+T))break;C===a&&(M=T)}if(T===o)if(f>o){if(s.charCodeAt(w+T)===a)return s.slice(w+T+1);if(T===0)return s.slice(w+T)}else p>o&&(r.charCodeAt(g+T)===a?M=T:T===0&&(M=0));let O="";for(T=g+M+1;T<=c;++T)(T===c||r.charCodeAt(T)===a)&&(O+=O.length===0?"..":"/..");return`${O}${s.slice(w+M)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===a;let g=-1,c=!0;for(let p=r.length-1;p>=1;--p)if(r.charCodeAt(p)===a){if(!c){g=p;break}}else c=!1;return g===-1?s?"/":".":s&&g===1?"//":r.slice(0,g)},basename(r,s){s!==void 0&&e(s,"ext"),e(r,"path");let g=0,c=-1,p=!0,w;if(s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let f=s.length-1,o=-1;for(w=r.length-1;w>=0;--w){const M=r.charCodeAt(w);if(M===a){if(!p){g=w+1;break}}else o===-1&&(p=!1,o=w+1),f>=0&&(M===s.charCodeAt(f)?--f===-1&&(c=w):(f=-1,c=o))}return g===c?c=o:c===-1&&(c=r.length),r.slice(g,c)}for(w=r.length-1;w>=0;--w)if(r.charCodeAt(w)===a){if(!p){g=w+1;break}}else c===-1&&(p=!1,c=w+1);return c===-1?"":r.slice(g,c)},extname(r){e(r,"path");let s=-1,g=0,c=-1,p=!0,w=0;for(let f=r.length-1;f>=0;--f){const o=r.charCodeAt(f);if(o===a){if(!p){g=f+1;break}continue}c===-1&&(p=!1,c=f+1),o===m?s===-1?s=f:w!==1&&(w=1):s!==-1&&(w=-1)}return s===-1||c===-1||w===0||w===1&&s===c-1&&s===g+1?"":r.slice(s,c)},format:b.bind(null,"/"),parse(r){e(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const g=r.charCodeAt(0)===a;let c;g?(s.root="/",c=1):c=0;let p=-1,w=0,f=-1,o=!0,M=r.length-1,T=0;for(;M>=c;--M){const O=r.charCodeAt(M);if(O===a){if(!o){w=M+1;break}continue}f===-1&&(o=!1,f=M+1),O===m?p===-1?p=M:T!==1&&(T=1):p!==-1&&(T=-1)}if(f!==-1){const O=w===0&&g?1:w;p===-1||T===0||T===1&&p===f-1&&p===w+1?s.base=s.name=r.slice(O,f):(s.name=r.slice(O,p),s.base=r.slice(O,f),s.ext=r.slice(p,f))}return w>0?s.dir=r.slice(0,w-1):g&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=E?n.win32.normalize:n.posix.normalize,n.isAbsolute=E?n.win32.isAbsolute:n.posix.isAbsolute,n.join=E?n.win32.join:n.posix.join,n.resolve=E?n.win32.resolve:n.posix.resolve,n.relative=E?n.win32.relative:n.posix.relative,n.dirname=E?n.win32.dirname:n.posix.dirname,n.basename=E?n.win32.basename:n.posix.basename,n.extname=E?n.win32.extname:n.posix.extname,n.format=E?n.win32.format:n.posix.format,n.parse=E?n.win32.parse:n.posix.parse,n.toNamespacedPath=E?n.win32.toNamespacedPath:n.posix.toNamespacedPath,n.sep=E?n.win32.sep:n.posix.sep,n.delimiter=E?n.win32.delimiter:n.posix.delimiter}),Z(J[20],x([0,1,5]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const t=D.globals.performance&&typeof D.globals.performance.now=="function";class P{static create(_=!0){return new P(_)}constructor(_){this.a=t&&_,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?D.globals.performance.now():Date.now()}}n.StopWatch=P}),Z(J[9],x([0,1,6,13,7,15,20]),function(q,n,D,t,P,u,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.AsyncEmitter=n.EventDeliveryQueue=n.Emitter=n.setGlobalLeakWarningThreshold=n.EventProfiling=n.Event=void 0;const m=!1,a=!1;var h;(function(w){w.None=()=>P.Disposable.None;function f(te){if(a){const{onDidAddListener:G}=te,Y=e.create();let S=0;te.onDidAddListener=()=>{++S===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),G?.()}}}function o(te,G){return Q(te,()=>{},0,void 0,void 0,G)}w.defer=o;function M(te){return(G,Y=null,S)=>{let I=!1,U;return U=te(W=>{if(!I)return U?U.dispose():I=!0,G.call(Y,W)},null,S),I&&U.dispose(),U}}w.once=M;function T(te,G,Y){return ne((S,I=null,U)=>te(W=>S.call(I,G(W)),null,U),Y)}w.map=T;function O(te,G,Y){return ne((S,I=null,U)=>te(W=>{G(W),S.call(I,W)},null,U),Y)}w.forEach=O;function C(te,G,Y){return ne((S,I=null,U)=>te(W=>G(W)&&S.call(I,W),null,U),Y)}w.filter=C;function H(te){return te}w.signal=H;function z(...te){return(G,Y=null,S)=>(0,P.combinedDisposable)(...te.map(I=>I(U=>G.call(Y,U),null,S)))}w.any=z;function ee(te,G,Y,S){let I=Y;return T(te,U=>(I=G(I,U),I),S)}w.reduce=ee;function ne(te,G){let Y;const S={onWillAddFirstListener(){Y=te(I.fire,I)},onDidRemoveLastListener(){Y?.dispose()}};G||f(S);const I=new F(S);return G?.add(I),I.event}function Q(te,G,Y=100,S=!1,I,U){let W,j,ie,re=0;const oe={leakWarningThreshold:I,onWillAddFirstListener(){W=te(fe=>{re++,j=G(j,fe),S&&!ie&&(ae.fire(j),j=void 0),clearTimeout(ie),ie=setTimeout(()=>{const he=j;j=void 0,ie=void 0,(!S||re>1)&&ae.fire(he),re=0},Y)})},onDidRemoveLastListener(){W.dispose()}};U||f(oe);const ae=new F(oe);return U?.add(ae),ae.event}w.debounce=Q;function K(te,G=0,Y){return w.debounce(te,(S,I)=>S?(S.push(I),S):[I],G,void 0,void 0,Y)}w.accumulate=K;function i(te,G=(S,I)=>S===I,Y){let S=!0,I;return C(te,U=>{const W=S||!G(U,I);return S=!1,I=U,W},Y)}w.latch=i;function ve(te,G,Y){return[w.filter(te,G,Y),w.filter(te,S=>!G(S),Y)]}w.split=ve;function Ae(te,G=!1,Y=[]){let S=Y.slice(),I=te(j=>{S?S.push(j):W.fire(j)});const U=()=>{S?.forEach(j=>W.fire(j)),S=null},W=new F({onWillAddFirstListener(){I||(I=te(j=>W.fire(j)))},onDidAddFirstListener(){S&&(G?setTimeout(U):U())},onDidRemoveLastListener(){I&&I.dispose(),I=null}});return W.event}w.buffer=Ae;class de{constructor(G){this.event=G,this.c=new P.DisposableStore}map(G){return new de(T(this.event,G,this.c))}forEach(G){return new de(O(this.event,G,this.c))}filter(G){return new de(C(this.event,G,this.c))}reduce(G,Y){return new de(ee(this.event,G,Y,this.c))}latch(){return new de(i(this.event,void 0,this.c))}debounce(G,Y=100,S=!1,I){return new de(Q(this.event,G,Y,S,I,this.c))}on(G,Y,S){return this.event(G,Y,S)}once(G,Y,S){return M(this.event)(G,Y,S)}dispose(){this.c.dispose()}}function Ee(te){return new de(te)}w.chain=Ee;function Le(te,G,Y=S=>S){const S=(...j)=>W.fire(Y(...j)),I=()=>te.on(G,S),U=()=>te.removeListener(G,S),W=new F({onWillAddFirstListener:I,onDidRemoveLastListener:U});return W.event}w.fromNodeEventEmitter=Le;function Ne(te,G,Y=S=>S){const S=(...j)=>W.fire(Y(...j)),I=()=>te.addEventListener(G,S),U=()=>te.removeEventListener(G,S),W=new F({onWillAddFirstListener:I,onDidRemoveLastListener:U});return W.event}w.fromDOMEventEmitter=Ne;function Re(te){return new Promise(G=>M(te)(G))}w.toPromise=Re;function De(te,G){return G(void 0),te(Y=>G(Y))}w.runAndSubscribe=De;function Fe(te,G){let Y=null;function S(U){Y?.dispose(),Y=new P.DisposableStore,G(U,Y)}S(void 0);const I=te(U=>S(U));return(0,P.toDisposable)(()=>{I.dispose(),Y?.dispose()})}w.runAndSubscribeWithStore=Fe;class ye{constructor(G,Y){this.obs=G,this.c=0,this.d=!1;const S={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};Y||f(S),this.emitter=new F(S),Y&&Y.add(this.emitter)}beginUpdate(G){this.c++}handleChange(G,Y){this.d=!0}endUpdate(G){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function Pe(te,G){return new ye(te,G).emitter.event}w.fromObservable=Pe})(h=n.Event||(n.Event={}));class A{constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${A.c++}`,A.all.add(this)}start(f){this.d=new _.StopWatch(!0),this.listenerCount=f}stop(){if(this.d){const f=this.d.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.d=void 0}}}n.EventProfiling=A,A.all=new Set,A.c=0;let R=-1;function N(w){const f=R;return R=w,{dispose(){R=f}}}n.setGlobalLeakWarningThreshold=N;class v{constructor(f,o=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=o,this.d=0}dispose(){this.c?.clear()}check(f,o){const M=this.threshold;if(M<=0||o<M)return;this.c||(this.c=new Map);const T=this.c.get(f.value)||0;if(this.c.set(f.value,T+1),this.d-=1,this.d<=0){this.d=M*.5;let O,C=0;for(const[H,z]of this.c)(!O||C<z)&&(O=H,C=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${C}):`),console.warn(O)}return()=>{const O=this.c.get(f.value)||0;this.c.set(f.value,O-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(f,o,M){this.callback=f,this.callbackThis=o,this.stack=M,this.subscription=new P.SafeDisposable}invoke(f){this.callback.call(this.callbackThis,f)}}class F{constructor(f){this.j=!1,this.d=f,this.f=R>0||this.d?.leakWarningThreshold?new v(this.d?.leakWarningThreshold??R):void 0,this.g=this.d?._profName?new A(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(m){const f=Array.from(this.q);queueMicrotask(()=>{for(const o of f)o.subscription.isset()&&(o.subscription.unset(),o.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(f,o,M)=>{if(this.q||(this.q=new u.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),P.Disposable.None;const T=this.q.isEmpty();T&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,C;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(C=e.create(),O=this.f.check(C,this.q.size+1)),m&&(C=C??e.create());const H=new E(f,o,C),z=this.q.push(H);T&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,f,o);const ee=H.subscription.set(()=>{O?.(),this.j||(z(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return M instanceof P.DisposableStore?M.add(ee):Array.isArray(M)&&M.push(ee),ee}),this.l}fire(f){if(this.q){this.m||(this.m=new L);for(const o of this.q)this.m.push(this,o,f);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}n.Emitter=F;class y{constructor(){this.c=new u.LinkedList}get size(){return this.c.size}push(f,o,M){this.c.push(new d(f,o,M))}clear(f){const o=new u.LinkedList;for(const M of this.c)M.emitter!==f&&o.push(M);this.c=o}deliver(){for(;this.c.size>0;){const f=this.c.shift();try{f.listener.invoke(f.event)}catch(o){(0,D.onUnexpectedError)(o)}}}}n.EventDeliveryQueue=y;class L extends y{clear(f){this.c.clear()}}class d{constructor(f,o,M){this.emitter=f,this.listener=o,this.event=M}}class b extends F{async fireAsync(f,o,M){if(!!this.q){this.c||(this.c=new u.LinkedList);for(const T of this.q)this.c.push([T,f]);for(;this.c.size>0&&!o.isCancellationRequested;){const[T,O]=this.c.shift(),C=[],H={...O,token:o,waitUntil:z=>{if(Object.isFrozen(C))throw new Error("waitUntil can NOT be called asynchronous");M&&(z=M(z,T.callback)),C.push(z)}};try{T.invoke(H)}catch(z){(0,D.onUnexpectedError)(z);continue}Object.freeze(C),await Promise.allSettled(C).then(z=>{for(const ee of z)ee.status==="rejected"&&(0,D.onUnexpectedError)(ee.reason)})}}}}n.AsyncEmitter=b;class l extends F{constructor(f){super(f),this.h=0,this.s=new u.LinkedList,this.t=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.t(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.q&&(this.h!==0?this.s.push(f):super.fire(f))}}n.PauseableEmitter=l;class r extends l{constructor(f){super(f),this.c=f.delay??100}fire(f){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(f)}}n.DebounceEmitter=r;class s extends F{constructor(f){super(f),this.c=[],this.h=f?.merge}fire(f){!this.hasListeners()||(this.c.push(f),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(o=>super.fire(o)),this.c=[]}))}}n.MicrotaskEmitter=s;class g{constructor(){this.d=!1,this.f=[],this.c=new F({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(f){const o={event:f,listener:null};this.f.push(o),this.d&&this.j(o);const M=()=>{this.d&&this.k(o);const T=this.f.indexOf(o);this.f.splice(T,1)};return(0,P.toDisposable)((0,t.once)(M))}g(){this.d=!0,this.f.forEach(f=>this.j(f))}h(){this.d=!1,this.f.forEach(f=>this.k(f))}j(f){f.listener=f.event(o=>this.c.fire(o))}k(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.c.dispose()}}n.EventMultiplexer=g;class c{constructor(){this.c=[]}wrapEvent(f){return(o,M,T)=>f(O=>{const C=this.c[this.c.length-1];C?C.push(()=>o.call(M,O)):o.call(M,O)},void 0,T)}bufferEvents(f){const o=[];this.c.push(o);const M=f();return this.c.pop(),o.forEach(T=>T()),M}}n.EventBufferer=c;class p{constructor(){this.c=!1,this.d=h.None,this.f=P.Disposable.None,this.g=new F({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(f){this.d=f,this.c&&(this.f.dispose(),this.f=f(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}n.Relay=p}),Z(J[21],x([0,1,9]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const t=Object.freeze(function(m,a){const h=setTimeout(m.bind(a),0);return{dispose(){clearTimeout(h)}}});var P;(function(m){function a(h){return h===m.None||h===m.Cancelled||h instanceof u?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}m.isCancellationToken=a,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(P=n.CancellationToken||(n.CancellationToken={}));class u{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new D.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class _{constructor(a){this.a=void 0,this.b=void 0,this.b=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new u),this.a}cancel(){this.a?this.a instanceof u&&this.a.cancel():this.a=P.Cancelled}dispose(a=!1){a&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof u&&this.a.dispose():this.a=P.None}}n.CancellationTokenSource=_}),Z(J[45],x([0,1,21]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=n.Cache=void 0;class t{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new D.CancellationTokenSource,a=this.b(m.token);return this.a={promise:a,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}n.Cache=t;class P{constructor(m){this.c=m,this.a=void 0,this.b=void 0}get(m){const a=JSON.stringify(m);return this.b!==a&&(this.b=a,this.a=this.c(m)),this.a}}n.LRUCachedFunction=P;class u{get cachedValues(){return this.a}constructor(m){this.b=m,this.a=new Map}get(m){if(this.a.has(m))return this.a.get(m);const a=this.b(m);return this.a.set(m,a),a}}n.CachedFunction=u}),Z(J[4],x([0,1,45,28]),function(q,n,D,t){"use strict";var P;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.GraphemeBreakType=n.getGraphemeBreakType=n.singleLetterHash=n.getNLines=n.uppercaseFirstLetter=n.containsUppercaseCharacter=n.fuzzyContains=n.stripUTF8BOM=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.removeAnsiEscapeCodes=n.lcut=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.charCount=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.replaceAsync=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpContainsBackreference=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.truncate=n.count=n.escapeRegExpCharacters=n.escape=n.format2=n.format=n.isFalsyOrWhitespace=void 0;function u(k){return!k||typeof k!="string"?!0:k.trim().length===0}n.isFalsyOrWhitespace=u;const _=/{(\d+)}/g;function m(k,...B){return B.length===0?k:k.replace(_,function(V,$){const X=parseInt($,10);return isNaN(X)||X<0||X>=B.length?V:B[X]})}n.format=m;const a=/{([^}]+)}/g;function h(k,B){return k.replace(a,(V,$)=>B[$]??V)}n.format2=h;function A(k){return k.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}n.escape=A;function R(k){return k.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=R;function N(k,B){let V=0;const $=B.charCodeAt(0);for(let X=k.length-1;X>=0;X--)k.charCodeAt(X)===$&&V++;return V}n.count=N;function v(k,B,V="\u2026"){return k.length<=B?k:`${k.substr(0,B)}${V}`}n.truncate=v;function e(k,B=" "){const V=E(k,B);return F(V,B)}n.trim=e;function E(k,B){if(!k||!B)return k;const V=B.length;if(V===0||k.length===0)return k;let $=0;for(;k.indexOf(B,$)===$;)$=$+V;return k.substring($)}n.ltrim=E;function F(k,B){if(!k||!B)return k;const V=B.length,$=k.length;if(V===0||$===0)return k;let X=$,se=-1;for(;se=k.lastIndexOf(B,X-1),!(se===-1||se+V!==X);){if(se===0)return"";X=se}return k.substring(0,X)}n.rtrim=F;function y(k){return k.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=y;function L(k){return k.replace(/\*/g,"")}n.stripWildcards=L;function d(k,B,V={}){if(!k)throw new Error("Cannot create regex from empty string");B||(k=R(k)),V.wholeWord&&(/\B/.test(k.charAt(0))||(k="\\b"+k),/\B/.test(k.charAt(k.length-1))||(k=k+"\\b"));let $="";return V.global&&($+="g"),V.matchCase||($+="i"),V.multiline&&($+="m"),V.unicode&&($+="u"),new RegExp(k,$)}n.createRegExp=d;function b(k){return k.source==="^"||k.source==="^$"||k.source==="$"||k.source==="^\\s*$"?!1:!!(k.exec("")&&k.lastIndex===0)}n.regExpLeadsToEndlessLoop=b;function l(k){return!!k.match(/([^\\]|^)(\\\\)*\\\d+/)}n.regExpContainsBackreference=l;function r(k){return(k.global?"g":"")+(k.ignoreCase?"i":"")+(k.multiline?"m":"")+(k.unicode?"u":"")}n.regExpFlags=r;function s(k){return k.split(/\r\n|\r|\n/)}n.splitLines=s;function g(k){for(let B=0,V=k.length;B<V;B++){const $=k.charCodeAt(B);if($!==32&&$!==9)return B}return-1}n.firstNonWhitespaceIndex=g;function c(k,B=0,V=k.length){for(let $=B;$<V;$++){const X=k.charCodeAt($);if(X!==32&&X!==9)return k.substring(B,$)}return k.substring(B,V)}n.getLeadingWhitespace=c;function p(k,B=k.length-1){for(let V=B;V>=0;V--){const $=k.charCodeAt(V);if($!==32&&$!==9)return V}return-1}n.lastNonWhitespaceIndex=p;function w(k,B,V){const $=[];let X=0;for(const se of k.matchAll(B)){if($.push(k.slice(X,se.index)),se.index===void 0)throw new Error("match.index should be defined");X=se.index+se[0].length,$.push(V(se[0],...se.slice(1),se.index,k,se.groups))}return $.push(k.slice(X)),Promise.all($).then(se=>se.join(""))}n.replaceAsync=w;function f(k,B){return k<B?-1:k>B?1:0}n.compare=f;function o(k,B,V=0,$=k.length,X=0,se=B.length){for(;V<$&&X<se;V++,X++){const be=k.charCodeAt(V),le=B.charCodeAt(X);if(be<le)return-1;if(be>le)return 1}const ce=$-V,_e=se-X;return ce<_e?-1:ce>_e?1:0}n.compareSubstring=o;function M(k,B){return T(k,B,0,k.length,0,B.length)}n.compareIgnoreCase=M;function T(k,B,V=0,$=k.length,X=0,se=B.length){for(;V<$&&X<se;V++,X++){let be=k.charCodeAt(V),le=B.charCodeAt(X);if(be===le)continue;if(be>=128||le>=128)return o(k.toLowerCase(),B.toLowerCase(),V,$,X,se);C(be)&&(be-=32),C(le)&&(le-=32);const ge=be-le;if(ge!==0)return ge}const ce=$-V,_e=se-X;return ce<_e?-1:ce>_e?1:0}n.compareSubstringIgnoreCase=T;function O(k){return k>=48&&k<=57}n.isAsciiDigit=O;function C(k){return k>=97&&k<=122}n.isLowerAsciiLetter=C;function H(k){return k>=65&&k<=90}n.isUpperAsciiLetter=H;function z(k,B){return k.length===B.length&&T(k,B)===0}n.equalsIgnoreCase=z;function ee(k,B){const V=B.length;return B.length>k.length?!1:T(k,B,0,V)===0}n.startsWithIgnoreCase=ee;function ne(k,B){const V=Math.min(k.length,B.length);let $;for($=0;$<V;$++)if(k.charCodeAt($)!==B.charCodeAt($))return $;return V}n.commonPrefixLength=ne;function Q(k,B){const V=Math.min(k.length,B.length);let $;const X=k.length-1,se=B.length-1;for($=0;$<V;$++)if(k.charCodeAt(X-$)!==B.charCodeAt(se-$))return $;return V}n.commonSuffixLength=Q;function K(k){return 55296<=k&&k<=56319}n.isHighSurrogate=K;function i(k){return 56320<=k&&k<=57343}n.isLowSurrogate=i;function ve(k,B){return(k-55296<<10)+(B-56320)+65536}n.computeCodePoint=ve;function Ae(k,B,V){const $=k.charCodeAt(V);if(K($)&&V+1<B){const X=k.charCodeAt(V+1);if(i(X))return ve($,X)}return $}n.getNextCodePoint=Ae;function de(k,B){const V=k.charCodeAt(B-1);if(i(V)&&B>1){const $=k.charCodeAt(B-2);if(K($))return ve($,V)}return V}class Ee{get offset(){return this.e}constructor(B,V=0){this.c=B,this.d=B.length,this.e=V}setOffset(B){this.e=B}prevCodePoint(){const B=de(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=Ae(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}n.CodePointIterator=Ee;class Le{get offset(){return this.c.offset}constructor(B,V=0){this.c=new Ee(B,V)}nextGraphemeLength(){const B=pe.getInstance(),V=this.c,$=V.offset;let X=B.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const se=V.offset,ce=B.getGraphemeBreakType(V.nextCodePoint());if(Ie(X,ce)){V.setOffset(se);break}X=ce}return V.offset-$}prevGraphemeLength(){const B=pe.getInstance(),V=this.c,$=V.offset;let X=B.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const se=V.offset,ce=B.getGraphemeBreakType(V.prevCodePoint());if(Ie(ce,X)){V.setOffset(se);break}X=ce}return $-V.offset}eol(){return this.c.eol()}}n.GraphemeIterator=Le;function Ne(k,B){return new Le(k,B).nextGraphemeLength()}n.nextCharLength=Ne;function Re(k,B){return new Le(k,B).prevGraphemeLength()}n.prevCharLength=Re;function De(k,B){B>0&&i(k.charCodeAt(B))&&B--;const V=B+Ne(k,B);return[V-Re(k,V),V]}n.getCharContainingOffset=De;function Fe(k){const B=new Le(k);let V=0;for(;!B.eol();)V++,B.nextGraphemeLength();return V}n.charCount=Fe;let ye;function Pe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function te(k){return ye||(ye=Pe()),ye.test(k)}n.containsRTL=te;const G=/^[\t\n\r\x20-\x7E]*$/;function Y(k){return G.test(k)}n.isBasicASCII=Y,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function S(k){return n.UNUSUAL_LINE_TERMINATORS.test(k)}n.containsUnusualLineTerminators=S;function I(k){return k>=11904&&k<=55215||k>=63744&&k<=64255||k>=65281&&k<=65374}n.isFullWidthCharacter=I;function U(k){return k>=127462&&k<=127487||k===8986||k===8987||k===9200||k===9203||k>=9728&&k<=10175||k===11088||k===11093||k>=127744&&k<=128591||k>=128640&&k<=128764||k>=128992&&k<=129008||k>=129280&&k<=129535||k>=129648&&k<=129782}n.isEmojiImprecise=U;function W(k,B){if(k.length<B)return k;const V=/\b/g;let $=0;for(;V.test(k)&&!(k.length-V.lastIndex<B);)$=V.lastIndex,V.lastIndex+=1;return k.substring($).replace(/^\s/,"")}n.lcut=W;const j=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function oe(k){return k&&(k=k.replace(j,""),k=k.replace(ie,""),k=k.replace(re,"")),k}n.removeAnsiEscapeCodes=oe,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ae(k){return!!(k&&k.length>0&&k.charCodeAt(0)===65279)}n.startsWithUTF8BOM=ae;function fe(k){return ae(k)?k.substr(1):k}n.stripUTF8BOM=fe;function he(k,B){if(!k||!B||k.length<B.length)return!1;const V=B.length,$=k.toLowerCase();let X=0,se=-1;for(;X<V;){const ce=$.indexOf(B[X],se+1);if(ce<0)return!1;se=ce,X++}return!0}n.fuzzyContains=he;function Se(k,B=!1){return k?(B&&(k=k.replace(/\\./g,"")),k.toLowerCase()!==k):!1}n.containsUppercaseCharacter=Se;function Be(k){return k.charAt(0).toUpperCase()+k.slice(1)}n.uppercaseFirstLetter=Be;function qe(k,B=1){if(B===0)return"";let V=-1;do V=k.indexOf(`
`,V+1),B--;while(B>0&&V>=0);return V===-1?k:(k[V-1]==="\r"&&V--,k.substr(0,V))}n.getNLines=qe;function We(k){return k=k%(2*26),k<26?String.fromCharCode(97+k):String.fromCharCode(65+k-26)}n.singleLetterHash=We;function Ve(k){return pe.getInstance().getGraphemeBreakType(k)}n.getGraphemeBreakType=Ve;function Ie(k,B){return k===0?B!==5&&B!==7:k===2&&B===3?!1:k===4||k===2||k===3||B===4||B===2||B===3?!0:!(k===8&&(B===8||B===9||B===11||B===12)||(k===11||k===9)&&(B===9||B===10)||(k===12||k===10)&&B===10||B===5||B===13||B===7||k===1||k===13&&B===14||k===6&&B===6)}var He;(function(k){k[k.Other=0]="Other",k[k.Prepend=1]="Prepend",k[k.CR=2]="CR",k[k.LF=3]="LF",k[k.Control=4]="Control",k[k.Extend=5]="Extend",k[k.Regional_Indicator=6]="Regional_Indicator",k[k.SpacingMark=7]="SpacingMark",k[k.L=8]="L",k[k.V=9]="V",k[k.T=10]="T",k[k.LV=11]="LV",k[k.LVT=12]="LVT",k[k.ZWJ=13]="ZWJ",k[k.Extended_Pictographic=14]="Extended_Pictographic"})(He=n.GraphemeBreakType||(n.GraphemeBreakType={}));class pe{static getInstance(){return pe.c||(pe.c=new pe),pe.c}constructor(){this.d=je()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const V=this.d,$=V.length/3;let X=1;for(;X<=$;)if(B<V[3*X])X=2*X;else if(B>V[3*X+1])X=2*X+1;else return V[3*X+2];return 0}}pe.c=null;function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(k,B){if(k===0)return 0;const V=$e(k,B);if(V!==void 0)return V;const $=new Ee(B,k);return $.prevCodePoint(),$.offset}n.getLeftDeleteOffset=ze;function $e(k,B){const V=new Ee(B,k);let $=V.prevCodePoint();for(;Ge($)||$===65039||$===8419;){if(V.offset===0)return;$=V.prevCodePoint()}if(!U($))return;let X=V.offset;return X>0&&V.prevCodePoint()===8205&&(X=V.offset),X}function Ge(k){return 127995<=k&&k<=127999}var Ue;(function(k){k[k.zwj=8205]="zwj",k[k.emojiVariantSelector=65039]="emojiVariantSelector",k[k.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),n.noBreakWhitespace="\xA0";class me{static getInstance(B){return me.d.get(Array.from(B))}static getLocales(){return me.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}n.AmbiguousCharacters=me,P=me,me.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),me.d=new D.LRUCachedFunction(k=>{function B(le){const ge=new Map;for(let we=0;we<le.length;we+=2)ge.set(le[we],le[we+1]);return ge}function V(le,ge){const we=new Map(le);for(const[ke,Te]of ge)we.set(ke,Te);return we}function $(le,ge){if(!le)return ge;const we=new Map;for(const[ke,Te]of le)ge.has(ke)&&we.set(ke,Te);return we}const X=P.c.value;let se=k.filter(le=>!le.startsWith("_")&&le in X);se.length===0&&(se=["_default"]);let ce;for(const le of se){const ge=B(X[le]);ce=$(ce,ge)}const _e=B(X._common),be=V(_e,ce);return new me(be)}),me.e=new t.Lazy(()=>Object.keys(me.c.value).filter(k=>!k.startsWith("_")));class Me{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Me.c())),this.d}static isInvisibleCharacter(B){return Me.e().has(B)}static get codePoints(){return Me.e()}}n.InvisibleCharacters=Me,Me.d=void 0}),Z(J[46],x([0,1,4]),function(q,n,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.Hasher=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function t(y){return P(y,0)}n.hash=t;function P(y,L){switch(typeof y){case"object":return y===null?u(349,L):Array.isArray(y)?a(y,L):h(y,L);case"string":return m(y,L);case"boolean":return _(y,L);case"number":return u(y,L);case"undefined":return u(937,L);default:return u(617,L)}}n.doHash=P;function u(y,L){return(L<<5)-L+y|0}n.numberHash=u;function _(y,L){return u(y?433:863,L)}function m(y,L){L=u(149417,L);for(let d=0,b=y.length;d<b;d++)L=u(y.charCodeAt(d),L);return L}n.stringHash=m;function a(y,L){return L=u(104579,L),y.reduce((d,b)=>P(b,d),L)}function h(y,L){return L=u(181387,L),Object.keys(y).sort().reduce((d,b)=>(d=m(b,d),P(y[b],d)),L)}class A{constructor(){this.g=0}get value(){return this.g}hash(L){return this.g=P(L,this.g),this.g}}n.Hasher=A;var R;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function N(y,L,d=32){const b=d-L,l=~((1<<b)-1);return(y<<L|(l&y)>>>b)>>>0}function v(y,L=0,d=y.byteLength,b=0){for(let l=0;l<d;l++)y[L+l]=b}function e(y,L,d="0"){for(;y.length<L;)y=d+y;return y}function E(y,L=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(d=>d.toString(16).padStart(2,"0")).join(""):e((y>>>0).toString(16),L/4)}n.toHexString=E;class F{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(L){const d=L.length;if(d===0)return;const b=this.p;let l=this.r,r=this.u,s,g;for(r!==0?(s=r,g=-1,r=0):(s=L.charCodeAt(0),g=0);;){let c=s;if(D.isHighSurrogate(s))if(g+1<d){const p=L.charCodeAt(g+1);D.isLowSurrogate(p)?(g++,c=D.computeCodePoint(s,p)):c=65533}else{r=s;break}else D.isLowSurrogate(s)&&(c=65533);if(l=this.w(b,l,c),g++,g<d)s=L.charCodeAt(g);else break}this.r=l,this.u=r}w(L,d,b){return b<128?L[d++]=b:b<2048?(L[d++]=192|(b&1984)>>>6,L[d++]=128|(b&63)>>>0):b<65536?(L[d++]=224|(b&61440)>>>12,L[d++]=128|(b&4032)>>>6,L[d++]=128|(b&63)>>>0):(L[d++]=240|(b&1835008)>>>18,L[d++]=128|(b&258048)>>>12,L[d++]=128|(b&4032)>>>6,L[d++]=128|(b&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,L[0]=L[64+0],L[1]=L[64+1],L[2]=L[64+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,v(this.p,this.r),this.r>56&&(this.y(),v(this.p));const L=8*this.t;this.q.setUint32(56,Math.floor(L/4294967296),!1),this.q.setUint32(60,L%4294967296,!1),this.y()}y(){const L=F.g,d=this.q;for(let f=0;f<64;f+=4)L.setUint32(f,d.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)L.setUint32(f,N(L.getUint32(f-12,!1)^L.getUint32(f-32,!1)^L.getUint32(f-56,!1)^L.getUint32(f-64,!1),1),!1);let b=this.h,l=this.l,r=this.m,s=this.n,g=this.o,c,p,w;for(let f=0;f<80;f++)f<20?(c=l&r|~l&s,p=1518500249):f<40?(c=l^r^s,p=1859775393):f<60?(c=l&r|l&s|r&s,p=2400959708):(c=l^r^s,p=3395469782),w=N(b,5)+c+g+p+L.getUint32(f*4,!1)&4294967295,g=s,s=r,r=N(l,30),l=b,b=w;this.h=this.h+b&4294967295,this.l=this.l+l&4294967295,this.m=this.m+r&4294967295,this.n=this.n+s&4294967295,this.o=this.o+g&4294967295}}n.StringSHA1=F,F.g=new DataView(new ArrayBuffer(320))}),Z(J[22],x([0,1,25,46]),function(q,n,D,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class P{constructor(N){this.a=N}getElements(){const N=this.a,v=new Int32Array(N.length);for(let e=0,E=N.length;e<E;e++)v[e]=N.charCodeAt(e);return v}}n.StringDiffSequence=P;function u(R,N,v){return new A(new P(R),new P(N)).ComputeDiff(v).changes}n.stringDiff=u;class _{static Assert(N,v){if(!N)throw new Error(v)}}class m{static Copy(N,v,e,E,F){for(let y=0;y<F;y++)e[E+y]=N[v+y]}static Copy2(N,v,e,E,F){for(let y=0;y<F;y++)e[E+y]=N[v+y]}}var a;(function(R){R[R.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class h{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new D.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(N,v){this.b=Math.min(this.b,N),this.c=Math.min(this.c,v),this.d++}AddModifiedElement(N,v){this.b=Math.min(this.b,N),this.c=Math.min(this.c,v),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class A{constructor(N,v,e=null){this.a=e,this.b=N,this.c=v;const[E,F,y]=A.o(N),[L,d,b]=A.o(v);this.d=y&&b,this.e=E,this.f=F,this.g=L,this.h=d,this.k=[],this.m=[]}static n(N){return N.length>0&&typeof N[0]=="string"}static o(N){const v=N.getElements();if(A.n(v)){const e=new Int32Array(v.length);for(let E=0,F=v.length;E<F;E++)e[E]=(0,t.stringHash)(v[E],0);return[v,e,!0]}return v instanceof Int32Array?[[],v,!1]:[[],new Int32Array(v),!1]}p(N,v){return this.f[N]!==this.h[v]?!1:this.d?this.e[N]===this.g[v]:!0}q(N,v){if(!this.p(N,v))return!1;const e=A.r(this.b,N),E=A.r(this.c,v);return e===E}static r(N,v){return typeof N.getStrictElement=="function"?N.getStrictElement(v):null}s(N,v){return this.f[N]!==this.f[v]?!1:this.d?this.e[N]===this.e[v]:!0}u(N,v){return this.h[N]!==this.h[v]?!1:this.d?this.g[N]===this.g[v]:!0}ComputeDiff(N){return this.v(0,this.f.length-1,0,this.h.length-1,N)}v(N,v,e,E,F){const y=[!1];let L=this.w(N,v,e,E,y);return F&&(L=this.z(L)),{quitEarly:y[0],changes:L}}w(N,v,e,E,F){for(F[0]=!1;N<=v&&e<=E&&this.p(N,e);)N++,e++;for(;v>=N&&E>=e&&this.p(v,E);)v--,E--;if(N>v||e>E){let r;return e<=E?(_.Assert(N===v+1,"originalStart should only be one more than originalEnd"),r=[new D.DiffChange(N,0,e,E-e+1)]):N<=v?(_.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),r=[new D.DiffChange(N,v-N+1,e,0)]):(_.Assert(N===v+1,"originalStart should only be one more than originalEnd"),_.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const y=[0],L=[0],d=this.y(N,v,e,E,y,L,F),b=y[0],l=L[0];if(d!==null)return d;if(!F[0]){const r=this.w(N,b,e,l,F);let s=[];return F[0]?s=[new D.DiffChange(b+1,v-(b+1)+1,l+1,E-(l+1)+1)]:s=this.w(b+1,v,l+1,E,F),this.H(r,s)}return[new D.DiffChange(N,v-N+1,e,E-e+1)]}x(N,v,e,E,F,y,L,d,b,l,r,s,g,c,p,w,f,o){let M=null,T=null,O=new h,C=v,H=e,z=g[0]-w[0]-E,ee=-1073741824,ne=this.k.length-1;do{const Q=z+N;Q===C||Q<H&&b[Q-1]<b[Q+1]?(r=b[Q+1],c=r-z-E,r<ee&&O.MarkNextChange(),ee=r,O.AddModifiedElement(r+1,c),z=Q+1-N):(r=b[Q-1]+1,c=r-z-E,r<ee&&O.MarkNextChange(),ee=r-1,O.AddOriginalElement(r,c+1),z=Q-1-N),ne>=0&&(b=this.k[ne],N=b[0],C=1,H=b.length-1)}while(--ne>=-1);if(M=O.getReverseChanges(),o[0]){let Q=g[0]+1,K=w[0]+1;if(M!==null&&M.length>0){const i=M[M.length-1];Q=Math.max(Q,i.getOriginalEnd()),K=Math.max(K,i.getModifiedEnd())}T=[new D.DiffChange(Q,s-Q+1,K,p-K+1)]}else{O=new h,C=y,H=L,z=g[0]-w[0]-d,ee=1073741824,ne=f?this.m.length-1:this.m.length-2;do{const Q=z+F;Q===C||Q<H&&l[Q-1]>=l[Q+1]?(r=l[Q+1]-1,c=r-z-d,r>ee&&O.MarkNextChange(),ee=r+1,O.AddOriginalElement(r+1,c+1),z=Q+1-F):(r=l[Q-1],c=r-z-d,r>ee&&O.MarkNextChange(),ee=r,O.AddModifiedElement(r+1,c+1),z=Q-1-F),ne>=0&&(l=this.m[ne],F=l[0],C=1,H=l.length-1)}while(--ne>=-1);T=O.getChanges()}return this.H(M,T)}y(N,v,e,E,F,y,L){let d=0,b=0,l=0,r=0,s=0,g=0;N--,e--,F[0]=0,y[0]=0,this.k=[],this.m=[];const c=v-N+(E-e),p=c+1,w=new Int32Array(p),f=new Int32Array(p),o=E-e,M=v-N,T=N-e,O=v-E,H=(M-o)%2===0;w[o]=N,f[M]=v,L[0]=!1;for(let z=1;z<=c/2+1;z++){let ee=0,ne=0;l=this.J(o-z,z,o,p),r=this.J(o+z,z,o,p);for(let K=l;K<=r;K+=2){K===l||K<r&&w[K-1]<w[K+1]?d=w[K+1]:d=w[K-1]+1,b=d-(K-o)-T;const i=d;for(;d<v&&b<E&&this.p(d+1,b+1);)d++,b++;if(w[K]=d,d+b>ee+ne&&(ee=d,ne=b),!H&&Math.abs(K-M)<=z-1&&d>=f[K])return F[0]=d,y[0]=b,i<=f[K]&&1447>0&&z<=1447+1?this.x(o,l,r,T,M,s,g,O,w,f,d,v,F,b,E,y,H,L):null}const Q=(ee-N+(ne-e)-z)/2;if(this.a!==null&&!this.a(ee,Q))return L[0]=!0,F[0]=ee,y[0]=ne,Q>0&&1447>0&&z<=1447+1?this.x(o,l,r,T,M,s,g,O,w,f,d,v,F,b,E,y,H,L):(N++,e++,[new D.DiffChange(N,v-N+1,e,E-e+1)]);s=this.J(M-z,z,M,p),g=this.J(M+z,z,M,p);for(let K=s;K<=g;K+=2){K===s||K<g&&f[K-1]>=f[K+1]?d=f[K+1]-1:d=f[K-1],b=d-(K-M)-O;const i=d;for(;d>N&&b>e&&this.p(d,b);)d--,b--;if(f[K]=d,H&&Math.abs(K-o)<=z&&d<=w[K])return F[0]=d,y[0]=b,i>=w[K]&&1447>0&&z<=1447+1?this.x(o,l,r,T,M,s,g,O,w,f,d,v,F,b,E,y,H,L):null}if(z<=1447){let K=new Int32Array(r-l+2);K[0]=o-l+1,m.Copy2(w,l,K,1,r-l+1),this.k.push(K),K=new Int32Array(g-s+2),K[0]=M-s+1,m.Copy2(f,s,K,1,g-s+1),this.m.push(K)}}return this.x(o,l,r,T,M,s,g,O,w,f,d,v,F,b,E,y,H,L)}z(N){for(let v=0;v<N.length;v++){const e=N[v],E=v<N.length-1?N[v+1].originalStart:this.f.length,F=v<N.length-1?N[v+1].modifiedStart:this.h.length,y=e.originalLength>0,L=e.modifiedLength>0;for(;e.originalStart+e.originalLength<E&&e.modifiedStart+e.modifiedLength<F&&(!y||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!L||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const b=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!b)break;e.originalStart++,e.modifiedStart++}const d=[null];if(v<N.length-1&&this.I(N[v],N[v+1],d)){N[v]=d[0],N.splice(v+1,1),v--;continue}}for(let v=N.length-1;v>=0;v--){const e=N[v];let E=0,F=0;if(v>0){const r=N[v-1];E=r.originalStart+r.originalLength,F=r.modifiedStart+r.modifiedLength}const y=e.originalLength>0,L=e.modifiedLength>0;let d=0,b=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const s=e.originalStart-r,g=e.modifiedStart-r;if(s<E||g<F||y&&!this.s(s,s+e.originalLength)||L&&!this.u(g,g+e.modifiedLength))break;const p=(s===E&&g===F?5:0)+this.G(s,e.originalLength,g,e.modifiedLength);p>b&&(b=p,d=r)}e.originalStart-=d,e.modifiedStart-=d;const l=[null];if(v>0&&this.I(N[v-1],N[v],l)){N[v-1]=l[0],N.splice(v,1),v++;continue}}if(this.d)for(let v=1,e=N.length;v<e;v++){const E=N[v-1],F=N[v],y=F.originalStart-E.originalStart-E.originalLength,L=E.originalStart,d=F.originalStart+F.originalLength,b=d-L,l=E.modifiedStart,r=F.modifiedStart+F.modifiedLength,s=r-l;if(y<5&&b<20&&s<20){const g=this.A(L,b,l,s,y);if(g){const[c,p]=g;(c!==E.originalStart+E.originalLength||p!==E.modifiedStart+E.modifiedLength)&&(E.originalLength=c-E.originalStart,E.modifiedLength=p-E.modifiedStart,F.originalStart=c+y,F.modifiedStart=p+y,F.originalLength=d-F.originalStart,F.modifiedLength=r-F.modifiedStart)}}}return N}A(N,v,e,E,F){if(v<F||E<F)return null;const y=N+v-F+1,L=e+E-F+1;let d=0,b=0,l=0;for(let r=N;r<y;r++)for(let s=e;s<L;s++){const g=this.B(r,s,F);g>0&&g>d&&(d=g,b=r,l=s)}return d>0?[b,l]:null}B(N,v,e){let E=0;for(let F=0;F<e;F++){if(!this.p(N+F,v+F))return 0;E+=this.e[N+F].length}return E}C(N){return N<=0||N>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[N])}D(N,v){if(this.C(N)||this.C(N-1))return!0;if(v>0){const e=N+v;if(this.C(e-1)||this.C(e))return!0}return!1}E(N){return N<=0||N>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[N])}F(N,v){if(this.E(N)||this.E(N-1))return!0;if(v>0){const e=N+v;if(this.E(e-1)||this.E(e))return!0}return!1}G(N,v,e,E){const F=this.D(N,v)?1:0,y=this.F(e,E)?1:0;return F+y}H(N,v){const e=[];if(N.length===0||v.length===0)return v.length>0?v:N;if(this.I(N[N.length-1],v[0],e)){const E=new Array(N.length+v.length-1);return m.Copy(N,0,E,0,N.length-1),E[N.length-1]=e[0],m.Copy(v,1,E,N.length,v.length-1),E}else{const E=new Array(N.length+v.length);return m.Copy(N,0,E,0,N.length),m.Copy(v,0,E,N.length,v.length),E}}I(N,v,e){if(_.Assert(N.originalStart<=v.originalStart,"Left change is not less than or equal to right change"),_.Assert(N.modifiedStart<=v.modifiedStart,"Left change is not less than or equal to right change"),N.originalStart+N.originalLength>=v.originalStart||N.modifiedStart+N.modifiedLength>=v.modifiedStart){const E=N.originalStart;let F=N.originalLength;const y=N.modifiedStart;let L=N.modifiedLength;return N.originalStart+N.originalLength>=v.originalStart&&(F=v.originalStart+v.originalLength-N.originalStart),N.modifiedStart+N.modifiedLength>=v.modifiedStart&&(L=v.modifiedStart+v.modifiedLength-N.modifiedStart),e[0]=new D.DiffChange(E,F,y,L),!0}else return e[0]=null,!1}J(N,v,e,E){if(N>=0&&N<E)return N;const F=e,y=E-e-1,L=v%2===0;if(N<0){const d=F%2===0;return L===d?0:1}else{const d=y%2===0;return L===d?E-1:E-2}}}n.LcsDiff=A}),Z(J[12],x([0,1,44,5]),function(q,n,D,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const P=/^\w[\w\d+.-]*$/,u=/^\//,_=/^\/\//;function m(g,c){if(!g.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${g.authority}", path: "${g.path}", query: "${g.query}", fragment: "${g.fragment}"}`);if(g.scheme&&!P.test(g.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(g.path){if(g.authority){if(!u.test(g.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(g.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(g,c){return!g&&!c?"file":g}function h(g,c){switch(g){case"https":case"http":case"file":c?c[0]!==R&&(c=R+c):c=R;break}return c}const A="",R="/",N=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(c){return c instanceof v?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,p,w,f,o,M=!1){typeof c=="object"?(this.scheme=c.scheme||A,this.authority=c.authority||A,this.path=c.path||A,this.query=c.query||A,this.fragment=c.fragment||A):(this.scheme=a(c,M),this.authority=p||A,this.path=h(this.scheme,w||A),this.query=f||A,this.fragment=o||A,m(this,M))}get fsPath(){return d(this,!1)}with(c){if(!c)return this;let{scheme:p,authority:w,path:f,query:o,fragment:M}=c;return p===void 0?p=this.scheme:p===null&&(p=A),w===void 0?w=this.authority:w===null&&(w=A),f===void 0?f=this.path:f===null&&(f=A),o===void 0?o=this.query:o===null&&(o=A),M===void 0?M=this.fragment:M===null&&(M=A),p===this.scheme&&w===this.authority&&f===this.path&&o===this.query&&M===this.fragment?this:new E(p,w,f,o,M)}static parse(c,p=!1){const w=N.exec(c);return w?new E(w[2]||A,s(w[4]||A),s(w[5]||A),s(w[7]||A),s(w[9]||A),p):new E(A,A,A,A,A)}static file(c){let p=A;if(t.isWindows&&(c=c.replace(/\\/g,R)),c[0]===R&&c[1]===R){const w=c.indexOf(R,2);w===-1?(p=c.substring(2),c=R):(p=c.substring(2,w),c=c.substring(w)||R)}return new E("file",p,c,A,A)}static from(c){const p=new E(c.scheme,c.authority,c.path,c.query,c.fragment);return m(p,!0),p}static joinPath(c,...p){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return t.isWindows&&c.scheme==="file"?w=v.file(D.win32.join(d(c,!0),...p)).path:w=D.posix.join(c.path,...p),c.with({path:w})}toString(c=!1){return b(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof v)return c;{const p=new E(c);return p._formatted=c.external,p._fsPath=c._sep===e?c.fsPath:null,p}}else return c}}n.URI=v;const e=t.isWindows?1:void 0;class E extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(c=!1){return c?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=e),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const F={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(g,c,p){let w,f=-1;for(let o=0;o<g.length;o++){const M=g.charCodeAt(o);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||c&&M===47||p&&M===91||p&&M===93||p&&M===58)f!==-1&&(w+=encodeURIComponent(g.substring(f,o)),f=-1),w!==void 0&&(w+=g.charAt(o));else{w===void 0&&(w=g.substr(0,o));const T=F[M];T!==void 0?(f!==-1&&(w+=encodeURIComponent(g.substring(f,o)),f=-1),w+=T):f===-1&&(f=o)}}return f!==-1&&(w+=encodeURIComponent(g.substring(f))),w!==void 0?w:g}function L(g){let c;for(let p=0;p<g.length;p++){const w=g.charCodeAt(p);w===35||w===63?(c===void 0&&(c=g.substr(0,p)),c+=F[w]):c!==void 0&&(c+=g[p])}return c!==void 0?c:g}function d(g,c){let p;return g.authority&&g.path.length>1&&g.scheme==="file"?p=`//${g.authority}${g.path}`:g.path.charCodeAt(0)===47&&(g.path.charCodeAt(1)>=65&&g.path.charCodeAt(1)<=90||g.path.charCodeAt(1)>=97&&g.path.charCodeAt(1)<=122)&&g.path.charCodeAt(2)===58?c?p=g.path.substr(1):p=g.path[1].toLowerCase()+g.path.substr(2):p=g.path,t.isWindows&&(p=p.replace(/\//g,"\\")),p}n.uriToFsPath=d;function b(g,c){const p=c?L:y;let w="",{scheme:f,authority:o,path:M,query:T,fragment:O}=g;if(f&&(w+=f,w+=":"),(o||f==="file")&&(w+=R,w+=R),o){let C=o.indexOf("@");if(C!==-1){const H=o.substr(0,C);o=o.substr(C+1),C=H.lastIndexOf(":"),C===-1?w+=p(H,!1,!1):(w+=p(H.substr(0,C),!1,!1),w+=":",w+=p(H.substr(C+1),!1,!0)),w+="@"}o=o.toLowerCase(),C=o.lastIndexOf(":"),C===-1?w+=p(o,!1,!0):(w+=p(o.substr(0,C),!1,!0),w+=o.substr(C))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const C=M.charCodeAt(1);C>=65&&C<=90&&(M=`/${String.fromCharCode(C+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const C=M.charCodeAt(0);C>=65&&C<=90&&(M=`${String.fromCharCode(C+32)}:${M.substr(2)}`)}w+=p(M,!0,!1)}return T&&(w+="?",w+=p(T,!1,!1)),O&&(w+="#",w+=c?O:y(O,!1,!1)),w}function l(g){try{return decodeURIComponent(g)}catch{return g.length>3?g.substr(0,3)+l(g.substr(3)):g}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(g){return g.match(r)?g.replace(r,c=>l(c)):g}}),Z(J[57],x([0,1,6,9,7,11,5,4]),function(q,n,D,t,P,u,_,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const a="$initialize";let h=!1;function A(g){!_.isWeb||(h||(h=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(g.message))}n.logOnceWebWorkerWarning=A;var R;(function(g){g[g.Request=0]="Request",g[g.Reply=1]="Reply",g[g.SubscribeEvent=2]="SubscribeEvent",g[g.Event=3]="Event",g[g.UnsubscribeEvent=4]="UnsubscribeEvent"})(R||(R={}));class N{constructor(c,p,w,f){this.vsWorker=c,this.req=p,this.method=w,this.args=f,this.type=0}}class v{constructor(c,p,w,f){this.vsWorker=c,this.seq=p,this.res=w,this.err=f,this.type=1}}class e{constructor(c,p,w,f){this.vsWorker=c,this.req=p,this.eventName=w,this.arg=f,this.type=2}}class E{constructor(c,p,w){this.vsWorker=c,this.req=p,this.event=w,this.type=3}}class F{constructor(c,p){this.vsWorker=c,this.req=p,this.type=4}}class y{constructor(c){this.a=-1,this.g=c,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(c){this.a=c}sendMessage(c,p){const w=String(++this.b);return new Promise((f,o)=>{this.c[w]={resolve:f,reject:o},this.o(new N(this.a,w,c,p))})}listen(c,p){let w=null;const f=new t.Emitter({onWillAddFirstListener:()=>{w=String(++this.b),this.d.set(w,f),this.o(new e(this.a,w,c,p))},onDidRemoveLastListener:()=>{this.d.delete(w),this.o(new F(this.a,w)),w=null}});return f.event}handleMessage(c){!c||!c.vsWorker||this.a!==-1&&c.vsWorker!==this.a||this.h(c)}h(c){switch(c.type){case 1:return this.j(c);case 0:return this.k(c);case 2:return this.l(c);case 3:return this.m(c);case 4:return this.n(c)}}j(c){if(!this.c[c.seq]){console.warn("Got reply to unknown seq");return}const p=this.c[c.seq];if(delete this.c[c.seq],c.err){let w=c.err;c.err.$isError&&(w=new Error,w.name=c.err.name,w.message=c.err.message,w.stack=c.err.stack),p.reject(w);return}p.resolve(c.res)}k(c){const p=c.req;this.g.handleMessage(c.method,c.args).then(f=>{this.o(new v(this.a,p,f,void 0))},f=>{f.detail instanceof Error&&(f.detail=(0,D.transformErrorForSerialization)(f.detail)),this.o(new v(this.a,p,void 0,(0,D.transformErrorForSerialization)(f)))})}l(c){const p=c.req,w=this.g.handleEvent(c.eventName,c.arg)(f=>{this.o(new E(this.a,p,f))});this.f.set(p,w)}m(c){if(!this.d.has(c.req)){console.warn("Got event for unknown req");return}this.d.get(c.req).fire(c.event)}n(c){if(!this.f.has(c.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(c.req).dispose(),this.f.delete(c.req)}o(c){const p=[];if(c.type===0)for(let w=0;w<c.args.length;w++)c.args[w]instanceof ArrayBuffer&&p.push(c.args[w]);else c.type===1&&c.res instanceof ArrayBuffer&&p.push(c.res);this.g.sendMessage(c,p)}}class L extends P.Disposable{constructor(c,p,w){super();let f=null;this.a=this.B(c.create("vs/base/common/worker/simpleWorker",C=>{this.c.handleMessage(C)},C=>{f?.(C)})),this.c=new y({sendMessage:(C,H)=>{this.a.postMessage(C,H)},handleMessage:(C,H)=>{if(typeof w[C]!="function")return Promise.reject(new Error("Missing method "+C+" on main thread host."));try{return Promise.resolve(w[C].apply(w,H))}catch(z){return Promise.reject(z)}},handleEvent:(C,H)=>{if(b(C)){const z=w[C].call(w,H);if(typeof z!="function")throw new Error(`Missing dynamic event ${C} on main thread host.`);return z}if(d(C)){const z=w[C];if(typeof z!="function")throw new Error(`Missing event ${C} on main thread host.`);return z}throw new Error(`Malformed event name ${C}`)}}),this.c.setWorkerId(this.a.getId());let o=null;typeof _.globals.require<"u"&&typeof _.globals.require.getConfig=="function"?o=_.globals.require.getConfig():typeof _.globals.requirejs<"u"&&(o=_.globals.requirejs.s.contexts._.config);const M=(0,u.getAllMethodNames)(w);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(o)),p,M]);const T=(C,H)=>this.g(C,H),O=(C,H)=>this.c.listen(C,H);this.f=new Promise((C,H)=>{f=H,this.b.then(z=>{C(l(z,T,O))},z=>{H(z),this.h("Worker failed to load "+p,z)})})}getProxyObject(){return this.f}g(c,p){return new Promise((w,f)=>{this.b.then(()=>{this.c.sendMessage(c,p).then(w,f)},f)})}h(c,p){console.error(c),console.info(p)}}n.SimpleWorkerClient=L;function d(g){return g[0]==="o"&&g[1]==="n"&&m.isUpperAsciiLetter(g.charCodeAt(2))}function b(g){return/^onDynamic/.test(g)&&m.isUpperAsciiLetter(g.charCodeAt(9))}function l(g,c,p){const w=M=>function(){const T=Array.prototype.slice.call(arguments,0);return c(M,T)},f=M=>function(T){return p(M,T)},o={};for(const M of g){if(b(M)){o[M]=f(M);continue}if(d(M)){o[M]=p(M,void 0);continue}o[M]=w(M)}return o}class r{constructor(c,p){this.a=p,this.b=null,this.c=new y({sendMessage:(w,f)=>{c(w,f)},handleMessage:(w,f)=>this.d(w,f),handleEvent:(w,f)=>this.f(w,f)})}onmessage(c){this.c.handleMessage(c)}d(c,p){if(c===a)return this.g(p[0],p[1],p[2],p[3]);if(!this.b||typeof this.b[c]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+c));try{return Promise.resolve(this.b[c].apply(this.b,p))}catch(w){return Promise.reject(w)}}f(c,p){if(!this.b)throw new Error("Missing requestHandler");if(b(c)){const w=this.b[c].call(this.b,p);if(typeof w!="function")throw new Error(`Missing dynamic event ${c} on request handler.`);return w}if(d(c)){const w=this.b[c];if(typeof w!="function")throw new Error(`Missing event ${c} on request handler.`);return w}throw new Error(`Malformed event name ${c}`)}g(c,p,w,f){this.c.setWorkerId(c);const T=l(f,(O,C)=>this.c.sendMessage(O,C),(O,C)=>this.c.listen(O,C));return this.a?(this.b=this.a(T),Promise.resolve((0,u.getAllMethodNames)(this.b))):(p&&(typeof p.baseUrl<"u"&&delete p.baseUrl,typeof p.paths<"u"&&typeof p.paths.vs<"u"&&delete p.paths.vs,typeof p.trustedTypesPolicy!==void 0&&delete p.trustedTypesPolicy,p.catchError=!0,_.globals.require.config(p)),new Promise((O,C)=>{(_.globals.require||q)([w],z=>{if(this.b=z.create(T),!this.b){C(new Error("No RequestHandler!"));return}O((0,u.getAllMethodNames)(this.b))},C)}))}}n.SimpleWorkerServer=r;function s(g){return new r(g,null)}n.create=s}),Z(J[23],x([0,1,22,19,4,2,10]),function(q,n,D,t,P,u,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.SmartLinesDiffComputer=void 0;const m=3;class a{computeDiff(b,l,r){const g=new E(b,l,{maxComputationTime:r.maxComputationTimeMs,shouldIgnoreTrimWhitespace:r.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),c=[];let p=null;for(const w of g.changes){let f;w.originalEndLineNumber===0?f=new t.LineRange(w.originalStartLineNumber+1,w.originalStartLineNumber+1):f=new t.LineRange(w.originalStartLineNumber,w.originalEndLineNumber+1);let o;w.modifiedEndLineNumber===0?o=new t.LineRange(w.modifiedStartLineNumber+1,w.modifiedStartLineNumber+1):o=new t.LineRange(w.modifiedStartLineNumber,w.modifiedEndLineNumber+1);let M=new t.LineRangeMapping(f,o,w.charChanges?.map(T=>new t.RangeMapping(new u.Range(T.originalStartLineNumber,T.originalStartColumn,T.originalEndLineNumber,T.originalEndColumn),new u.Range(T.modifiedStartLineNumber,T.modifiedStartColumn,T.modifiedEndLineNumber,T.modifiedEndColumn))));p&&(p.modifiedRange.endLineNumberExclusive===M.modifiedRange.startLineNumber||p.originalRange.endLineNumberExclusive===M.originalRange.startLineNumber)&&(M=new t.LineRangeMapping(p.originalRange.join(M.originalRange),p.modifiedRange.join(M.modifiedRange),p.innerChanges&&M.innerChanges?p.innerChanges.concat(M.innerChanges):void 0),c.pop()),c.push(M),p=M}return(0,_.assertFn)(()=>(0,_.checkAdjacentItems)(c,(w,f)=>f.originalRange.startLineNumber-w.originalRange.endLineNumberExclusive===f.modifiedRange.startLineNumber-w.modifiedRange.endLineNumberExclusive&&w.originalRange.endLineNumberExclusive<f.originalRange.startLineNumber&&w.modifiedRange.endLineNumberExclusive<f.modifiedRange.startLineNumber)),{quitEarly:g.quitEarly,changes:c}}}n.SmartLinesDiffComputer=a;function h(d,b,l,r){return new D.LcsDiff(d,b,l).ComputeDiff(r)}class A{constructor(b){const l=[],r=[];for(let s=0,g=b.length;s<g;s++)l[s]=F(b[s],1),r[s]=y(b[s],1);this.lines=b,this.a=l,this.b=r}getElements(){const b=[];for(let l=0,r=this.lines.length;l<r;l++)b[l]=this.lines[l].substring(this.a[l]-1,this.b[l]-1);return b}getStrictElement(b){return this.lines[b]}getStartLineNumber(b){return b+1}getEndLineNumber(b){return b+1}createCharSequence(b,l,r){const s=[],g=[],c=[];let p=0;for(let w=l;w<=r;w++){const f=this.lines[w],o=b?this.a[w]:1,M=b?this.b[w]:f.length+1;for(let T=o;T<M;T++)s[p]=f.charCodeAt(T-1),g[p]=w+1,c[p]=T,p++;!b&&w<r&&(s[p]=10,g[p]=w+1,c[p]=f.length+1,p++)}return new R(s,g,c)}}class R{constructor(b,l,r){this.a=b,this.b=l,this.d=r}toString(){return"["+this.a.map((b,l)=>(b===10?"\\n":String.fromCharCode(b))+`-(${this.b[l]},${this.d[l]})`).join(", ")+"]"}e(b,l){if(b<0||b>=l.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(b){return b>0&&b===this.b.length?this.getEndLineNumber(b-1):(this.e(b,this.b),this.b[b])}getEndLineNumber(b){return b===-1?this.getStartLineNumber(b+1):(this.e(b,this.b),this.a[b]===10?this.b[b]+1:this.b[b])}getStartColumn(b){return b>0&&b===this.d.length?this.getEndColumn(b-1):(this.e(b,this.d),this.d[b])}getEndColumn(b){return b===-1?this.getStartColumn(b+1):(this.e(b,this.d),this.a[b]===10?1:this.d[b]+1)}}class N{constructor(b,l,r,s,g,c,p,w){this.originalStartLineNumber=b,this.originalStartColumn=l,this.originalEndLineNumber=r,this.originalEndColumn=s,this.modifiedStartLineNumber=g,this.modifiedStartColumn=c,this.modifiedEndLineNumber=p,this.modifiedEndColumn=w}static createFromDiffChange(b,l,r){const s=l.getStartLineNumber(b.originalStart),g=l.getStartColumn(b.originalStart),c=l.getEndLineNumber(b.originalStart+b.originalLength-1),p=l.getEndColumn(b.originalStart+b.originalLength-1),w=r.getStartLineNumber(b.modifiedStart),f=r.getStartColumn(b.modifiedStart),o=r.getEndLineNumber(b.modifiedStart+b.modifiedLength-1),M=r.getEndColumn(b.modifiedStart+b.modifiedLength-1);return new N(s,g,c,p,w,f,o,M)}}function v(d){if(d.length<=1)return d;const b=[d[0]];let l=b[0];for(let r=1,s=d.length;r<s;r++){const g=d[r],c=g.originalStart-(l.originalStart+l.originalLength),p=g.modifiedStart-(l.modifiedStart+l.modifiedLength);Math.min(c,p)<m?(l.originalLength=g.originalStart+g.originalLength-l.originalStart,l.modifiedLength=g.modifiedStart+g.modifiedLength-l.modifiedStart):(b.push(g),l=g)}return b}class e{constructor(b,l,r,s,g){this.originalStartLineNumber=b,this.originalEndLineNumber=l,this.modifiedStartLineNumber=r,this.modifiedEndLineNumber=s,this.charChanges=g}static createFromDiffResult(b,l,r,s,g,c,p){let w,f,o,M,T;if(l.originalLength===0?(w=r.getStartLineNumber(l.originalStart)-1,f=0):(w=r.getStartLineNumber(l.originalStart),f=r.getEndLineNumber(l.originalStart+l.originalLength-1)),l.modifiedLength===0?(o=s.getStartLineNumber(l.modifiedStart)-1,M=0):(o=s.getStartLineNumber(l.modifiedStart),M=s.getEndLineNumber(l.modifiedStart+l.modifiedLength-1)),c&&l.originalLength>0&&l.originalLength<20&&l.modifiedLength>0&&l.modifiedLength<20&&g()){const O=r.createCharSequence(b,l.originalStart,l.originalStart+l.originalLength-1),C=s.createCharSequence(b,l.modifiedStart,l.modifiedStart+l.modifiedLength-1);if(O.getElements().length>0&&C.getElements().length>0){let H=h(O,C,g,!0).changes;p&&(H=v(H)),T=[];for(let z=0,ee=H.length;z<ee;z++)T.push(N.createFromDiffChange(H[z],O,C))}}return new e(w,f,o,M,T)}}class E{constructor(b,l,r){this.a=r.shouldComputeCharChanges,this.b=r.shouldPostProcessCharChanges,this.d=r.shouldIgnoreTrimWhitespace,this.e=r.shouldMakePrettyDiff,this.f=b,this.g=l,this.h=new A(b),this.j=new A(l),this.k=L(r.maxComputationTime),this.l=L(r.maxComputationTime===0?0:Math.min(r.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const b=h(this.h,this.j,this.k,this.e),l=b.changes,r=b.quitEarly;if(this.d){const p=[];for(let w=0,f=l.length;w<f;w++)p.push(e.createFromDiffResult(this.d,l[w],this.h,this.j,this.l,this.a,this.b));return{quitEarly:r,changes:p}}const s=[];let g=0,c=0;for(let p=-1,w=l.length;p<w;p++){const f=p+1<w?l[p+1]:null,o=f?f.originalStart:this.f.length,M=f?f.modifiedStart:this.g.length;for(;g<o&&c<M;){const T=this.f[g],O=this.g[c];if(T!==O){{let C=F(T,1),H=F(O,1);for(;C>1&&H>1;){const z=T.charCodeAt(C-2),ee=O.charCodeAt(H-2);if(z!==ee)break;C--,H--}(C>1||H>1)&&this.m(s,g+1,1,C,c+1,1,H)}{let C=y(T,1),H=y(O,1);const z=T.length+1,ee=O.length+1;for(;C<z&&H<ee;){const ne=T.charCodeAt(C-1),Q=T.charCodeAt(H-1);if(ne!==Q)break;C++,H++}(C<z||H<ee)&&this.m(s,g+1,C,z,c+1,H,ee)}}g++,c++}f&&(s.push(e.createFromDiffResult(this.d,f,this.h,this.j,this.l,this.a,this.b)),g+=f.originalLength,c+=f.modifiedLength)}return{quitEarly:r,changes:s}}m(b,l,r,s,g,c,p){if(this.n(b,l,r,s,g,c,p))return;let w;this.a&&(w=[new N(l,r,l,s,g,c,g,p)]),b.push(new e(l,l,g,g,w))}n(b,l,r,s,g,c,p){const w=b.length;if(w===0)return!1;const f=b[w-1];return f.originalEndLineNumber===0||f.modifiedEndLineNumber===0?!1:f.originalEndLineNumber===l&&f.modifiedEndLineNumber===g?(this.a&&f.charChanges&&f.charChanges.push(new N(l,r,l,s,g,c,g,p)),!0):f.originalEndLineNumber+1===l&&f.modifiedEndLineNumber+1===g?(f.originalEndLineNumber=l,f.modifiedEndLineNumber=g,this.a&&f.charChanges&&f.charChanges.push(new N(l,r,l,s,g,c,g,p)),!0):!1}}n.DiffComputer=E;function F(d,b){const l=P.firstNonWhitespaceIndex(d);return l===-1?b:l+1}function y(d,b){const l=P.lastNonWhitespaceIndex(d);return l===-1?b:l+2}function L(d){if(d===0)return()=>!0;const b=Date.now();return()=>Date.now()-b<d}}),Z(J[47],x([0,1,23,36]),function(q,n,D,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={smart:new D.SmartLinesDiffComputer,experimental:new t.StandardLinesDiffComputer}}),Z(J[48],x([0,1,4,3,40]),function(q,n,D,t,P){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class u{constructor(m,a,h,A){this.c=m,this.d=a,this.f=h,this.g=A,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(m){m.eol&&m.eol!==this.f&&(this.f=m.eol,this.h=null);const a=m.changes;for(const h of a)this.n(h.range),this.o(new t.Position(h.range.startLineNumber,h.range.startColumn),h.text);this.g=m.versionId,this.j=null}k(){if(!this.h){const m=this.f.length,a=this.d.length,h=new Uint32Array(a);for(let A=0;A<a;A++)h[A]=this.d[A].length+m;this.h=new P.PrefixSumComputer(h)}}l(m,a){this.d[m]=a,this.h&&this.h.setValue(m,this.d[m].length+this.f.length)}n(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this.l(m.startLineNumber-1,this.d[m.startLineNumber-1].substring(0,m.startColumn-1)+this.d[m.startLineNumber-1].substring(m.endColumn-1));return}this.l(m.startLineNumber-1,this.d[m.startLineNumber-1].substring(0,m.startColumn-1)+this.d[m.endLineNumber-1].substring(m.endColumn-1)),this.d.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this.h&&this.h.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}o(m,a){if(a.length===0)return;const h=(0,D.splitLines)(a);if(h.length===1){this.l(m.lineNumber-1,this.d[m.lineNumber-1].substring(0,m.column-1)+h[0]+this.d[m.lineNumber-1].substring(m.column-1));return}h[h.length-1]+=this.d[m.lineNumber-1].substring(m.column-1),this.l(m.lineNumber-1,this.d[m.lineNumber-1].substring(0,m.column-1)+h[0]);const A=new Uint32Array(h.length-1);for(let R=1;R<h.length;R++)this.d.splice(m.lineNumber+R-1,0,h[R]),A[R-1]=h[R].length+this.f.length;this.h&&this.h.insertValues(m.lineNumber,A)}}n.MirrorTextModel=u}),Z(J[49],x([0,1,4,31,3,2,39]),function(q,n,D,t,P,u,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const m=999;class a{constructor(L,d,b,l){this.searchString=L,this.isRegex=d,this.matchCase=b,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let L;this.isRegex?L=h(this.searchString):L=this.searchString.indexOf(`
`)>=0;let d=null;try{d=D.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:L,global:!0,unicode:!0})}catch{return null}if(!d)return null;let b=!this.isRegex&&!L;return b&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(b=this.matchCase),new _.SearchData(d,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,b?this.searchString:null)}}n.SearchParams=a;function h(y){if(!y||y.length===0)return!1;for(let L=0,d=y.length;L<d;L++){const b=y.charCodeAt(L);if(b===10)return!0;if(b===92){if(L++,L>=d)break;const l=y.charCodeAt(L);if(l===110||l===114||l===87)return!0}}return!1}n.isMultilineRegexSource=h;function A(y,L,d){if(!d)return new _.FindMatch(y,null);const b=[];for(let l=0,r=L.length;l<r;l++)b[l]=L[l];return new _.FindMatch(y,b)}n.createFindMatch=A;class R{constructor(L){const d=[];let b=0;for(let l=0,r=L.length;l<r;l++)L.charCodeAt(l)===10&&(d[b++]=l);this.a=d}findLineFeedCountBeforeOffset(L){const d=this.a;let b=0,l=d.length-1;if(l===-1||L<=d[0])return 0;for(;b<l;){const r=b+((l-b)/2>>0);d[r]>=L?l=r-1:d[r+1]>=L?(b=r,l=r):b=r+1}return b+1}}class N{static findMatches(L,d,b,l,r){const s=d.parseSearchRequest();return s?s.regex.multiline?this.b(L,b,new F(s.wordSeparators,s.regex),l,r):this.c(L,b,s,l,r):[]}static a(L,d,b,l,r,s){let g,c=0;l?(c=l.findLineFeedCountBeforeOffset(r),g=d+r+c):g=d+r;let p;if(l){const M=l.findLineFeedCountBeforeOffset(r+s.length)-c;p=g+s.length+M}else p=g+s.length;const w=L.getPositionAt(g),f=L.getPositionAt(p);return new u.Range(w.lineNumber,w.column,f.lineNumber,f.column)}static b(L,d,b,l,r){const s=L.getOffsetAt(d.getStartPosition()),g=L.getValueInRange(d,1),c=L.getEOL()===`\r
`?new R(g):null,p=[];let w=0,f;for(b.reset(0);f=b.next(g);)if(p[w++]=A(this.a(L,s,g,c,f.index,f[0]),f,l),w>=r)return p;return p}static c(L,d,b,l,r){const s=[];let g=0;if(d.startLineNumber===d.endLineNumber){const p=L.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return g=this.d(b,p,d.startLineNumber,d.startColumn-1,g,s,l,r),s}const c=L.getLineContent(d.startLineNumber).substring(d.startColumn-1);g=this.d(b,c,d.startLineNumber,d.startColumn-1,g,s,l,r);for(let p=d.startLineNumber+1;p<d.endLineNumber&&g<r;p++)g=this.d(b,L.getLineContent(p),p,0,g,s,l,r);if(g<r){const p=L.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);g=this.d(b,p,d.endLineNumber,0,g,s,l,r)}return s}static d(L,d,b,l,r,s,g,c){const p=L.wordSeparators;if(!g&&L.simpleSearch){const o=L.simpleSearch,M=o.length,T=d.length;let O=-M;for(;(O=d.indexOf(o,O+M))!==-1;)if((!p||E(p,d,T,O,M))&&(s[r++]=new _.FindMatch(new u.Range(b,O+1+l,b,O+1+M+l),null),r>=c))return r;return r}const w=new F(L.wordSeparators,L.regex);let f;w.reset(0);do if(f=w.next(d),f&&(s[r++]=A(new u.Range(b,f.index+1+l,b,f.index+1+f[0].length+l),f,g),r>=c))return r;while(f);return r}static findNextMatch(L,d,b,l){const r=d.parseSearchRequest();if(!r)return null;const s=new F(r.wordSeparators,r.regex);return r.regex.multiline?this.e(L,b,s,l):this.f(L,b,s,l)}static e(L,d,b,l){const r=new P.Position(d.lineNumber,1),s=L.getOffsetAt(r),g=L.getLineCount(),c=L.getValueInRange(new u.Range(r.lineNumber,r.column,g,L.getLineMaxColumn(g)),1),p=L.getEOL()===`\r
`?new R(c):null;b.reset(d.column-1);const w=b.next(c);return w?A(this.a(L,s,c,p,w.index,w[0]),w,l):d.lineNumber!==1||d.column!==1?this.e(L,new P.Position(1,1),b,l):null}static f(L,d,b,l){const r=L.getLineCount(),s=d.lineNumber,g=L.getLineContent(s),c=this.g(b,g,s,d.column,l);if(c)return c;for(let p=1;p<=r;p++){const w=(s+p-1)%r,f=L.getLineContent(w+1),o=this.g(b,f,w+1,1,l);if(o)return o}return null}static g(L,d,b,l,r){L.reset(l-1);const s=L.next(d);return s?A(new u.Range(b,s.index+1,b,s.index+1+s[0].length),s,r):null}static findPreviousMatch(L,d,b,l){const r=d.parseSearchRequest();if(!r)return null;const s=new F(r.wordSeparators,r.regex);return r.regex.multiline?this.h(L,b,s,l):this.j(L,b,s,l)}static h(L,d,b,l){const r=this.b(L,new u.Range(1,1,d.lineNumber,d.column),b,l,10*m);if(r.length>0)return r[r.length-1];const s=L.getLineCount();return d.lineNumber!==s||d.column!==L.getLineMaxColumn(s)?this.h(L,new P.Position(s,L.getLineMaxColumn(s)),b,l):null}static j(L,d,b,l){const r=L.getLineCount(),s=d.lineNumber,g=L.getLineContent(s).substring(0,d.column-1),c=this.k(b,g,s,l);if(c)return c;for(let p=1;p<=r;p++){const w=(r+s-p-1)%r,f=L.getLineContent(w+1),o=this.k(b,f,w+1,l);if(o)return o}return null}static k(L,d,b,l){let r=null,s;for(L.reset(0);s=L.next(d);)r=A(new u.Range(b,s.index+1,b,s.index+1+s[0].length),s,l);return r}}n.TextModelSearch=N;function v(y,L,d,b,l){if(b===0)return!0;const r=L.charCodeAt(b-1);if(y.get(r)!==0||r===13||r===10)return!0;if(l>0){const s=L.charCodeAt(b);if(y.get(s)!==0)return!0}return!1}function e(y,L,d,b,l){if(b+l===d)return!0;const r=L.charCodeAt(b+l);if(y.get(r)!==0||r===13||r===10)return!0;if(l>0){const s=L.charCodeAt(b+l-1);if(y.get(s)!==0)return!0}return!1}function E(y,L,d,b,l){return v(y,L,d,b,l)&&e(y,L,d,b,l)}n.isValidMatch=E;class F{constructor(L,d){this._wordSeparators=L,this.a=d,this.b=-1,this.c=0}reset(L){this.a.lastIndex=L,this.b=-1,this.c=0}next(L){const d=L.length;let b;do{if(this.b+this.c===d||(b=this.a.exec(L),!b))return null;const l=b.index,r=b[0].length;if(l===this.b&&r===this.c){if(r===0){D.getNextCodePoint(L,d,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=l,this.c=r,!this._wordSeparators||E(this._wordSeparators,L,d,l,r))return b}while(b);return null}}n.Searcher=F}),Z(J[50],x([0,1,2,49,4,10,18]),function(q,n,D,t,P,u,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeHighlighterReasonKind=n.UnicodeTextModelHighlighter=void 0;class m{static computeUnicodeHighlights(e,E,F){const y=F?F.startLineNumber:1,L=F?F.endLineNumber:e.getLineCount(),d=new A(E),b=d.getCandidateCodePoints();let l;b==="allNonBasicAscii"?l=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):l=new RegExp(`${a(Array.from(b))}`,"g");const r=new t.Searcher(null,l),s=[];let g=!1,c,p=0,w=0,f=0;e:for(let o=y,M=L;o<=M;o++){const T=e.getLineContent(o),O=T.length;r.reset(0);do if(c=r.next(T),c){let C=c.index,H=c.index+c[0].length;if(C>0){const Q=T.charCodeAt(C-1);P.isHighSurrogate(Q)&&C--}if(H+1<O){const Q=T.charCodeAt(H-1);P.isHighSurrogate(Q)&&H++}const z=T.substring(C,H);let ee=(0,_.getWordAtText)(C+1,_.DEFAULT_WORD_REGEXP,T,0);ee&&ee.endColumn<=C+1&&(ee=null);const ne=d.shouldHighlightNonBasicASCII(z,ee?ee.word:null);if(ne!==0){ne===3?p++:ne===2?w++:ne===1?f++:(0,u.assertNever)(ne);const Q=1e3;if(s.length>=Q){g=!0;break e}s.push(new D.Range(o,C+1,o,H+1))}}while(c)}return{ranges:s,hasMore:g,ambiguousCharacterCount:p,invisibleCharacterCount:w,nonBasicAsciiCharacterCount:f}}static computeUnicodeHighlightReason(e,E){const F=new A(E);switch(F.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const L=e.codePointAt(0),d=F.ambiguousCharacters.getPrimaryConfusable(L),b=P.AmbiguousCharacters.getLocales().filter(l=>!P.AmbiguousCharacters.getInstance(new Set([...E.allowedLocales,l])).isAmbiguous(L));return{kind:0,confusableWith:String.fromCodePoint(d),notAmbiguousInLocales:b}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=m;function a(v,e){return`[${P.escapeRegExpCharacters(v.map(F=>String.fromCodePoint(F)).join(""))}]`}var h;(function(v){v[v.Ambiguous=0]="Ambiguous",v[v.Invisible=1]="Invisible",v[v.NonBasicAscii=2]="NonBasicAscii"})(h=n.UnicodeHighlighterReasonKind||(n.UnicodeHighlighterReasonKind={}));class A{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=P.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const E of P.InvisibleCharacters.codePoints)R(String.fromCodePoint(E))||e.add(E);if(this.b.ambiguousCharacters)for(const E of this.ambiguousCharacters.getConfusableCodePoints())e.add(E);for(const E of this.a)e.delete(E);return e}shouldHighlightNonBasicASCII(e,E){const F=e.codePointAt(0);if(this.a.has(F))return 0;if(this.b.nonBasicASCII)return 1;let y=!1,L=!1;if(E)for(const d of E){const b=d.codePointAt(0),l=P.isBasicASCII(d);y=y||l,!l&&!this.ambiguousCharacters.isAmbiguous(b)&&!P.InvisibleCharacters.isInvisibleCharacter(b)&&(L=!0)}return!y&&L?0:this.b.invisibleCharacters&&!R(e)&&P.InvisibleCharacters.isInvisibleCharacter(F)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(F)?3:0}}function R(v){return v===" "||v===`
`||v==="	"}var N;(function(v){v[v.None=0]="None",v[v.NonBasicASCII=1]="NonBasicASCII",v[v.Invisible=2]="Invisible",v[v.Ambiguous=3]="Ambiguous"})(N||(N={}))}),Z(J[51],x([0,1,9,7]),function(q,n,D,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class P{constructor(){this.a=new Map,this.b=new Map,this.c=new D.Emitter,this.onDidChange=this.c.event,this.d=null}fire(m){this.c.fire({changedLanguages:m,changedColorMap:!1})}register(m,a){return this.a.set(m,a),this.fire([m]),(0,t.toDisposable)(()=>{this.a.get(m)===a&&(this.a.delete(m),this.fire([m]))})}registerFactory(m,a){this.b.get(m)?.dispose();const h=new u(this,m,a);return this.b.set(m,h),(0,t.toDisposable)(()=>{const A=this.b.get(m);!A||A!==h||(this.b.delete(m),A.dispose())})}async getOrCreate(m){const a=this.get(m);if(a)return a;const h=this.b.get(m);return!h||h.isResolved?null:(await h.resolve(),this.get(m))}get(m){return this.a.get(m)||null}isResolved(m){if(this.get(m))return!0;const h=this.b.get(m);return!!(!h||h.isResolved)}setColorMap(m){this.d=m,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}n.TokenizationRegistry=P;class u extends t.Disposable{get isResolved(){return this.c}constructor(m,a,h){super(),this.f=m,this.g=a,this.h=h,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const m=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,m&&!this.a&&this.B(this.f.register(this.g,m))}}}),Z(J[52],x([0,1,24,12,2,51]),function(q,n,D,t,P,u){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ExternalUriOpenerPriority=n.TokenizationRegistry=n.InlayHintKind=n.CommentMode=n.CommentThreadState=n.CommentThreadCollapsibleState=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.SymbolTag=n.SymbolKind=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.CodeActionTriggerType=n.InlineCompletionTriggerKind=n.CompletionTriggerKind=n.CompletionItemInsertTextRule=n.CompletionItemTag=n.CompletionItemKinds=n.CompletionItemKind=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class _{constructor(M,T,O){this._tokenBrand=void 0,this.offset=M,this.type=T,this.language=O}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=_;class m{constructor(M,T){this._tokenizationResultBrand=void 0,this.tokens=M,this.endState=T}}n.TokenizationResult=m;class a{constructor(M,T){this._encodedTokenizationResultBrand=void 0,this.tokens=M,this.endState=T}}n.EncodedTokenizationResult=a;var h;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(h=n.CompletionItemKind||(n.CompletionItemKind={}));var A;(function(o){const M=new Map;M.set(0,D.Codicon.symbolMethod),M.set(1,D.Codicon.symbolFunction),M.set(2,D.Codicon.symbolConstructor),M.set(3,D.Codicon.symbolField),M.set(4,D.Codicon.symbolVariable),M.set(5,D.Codicon.symbolClass),M.set(6,D.Codicon.symbolStruct),M.set(7,D.Codicon.symbolInterface),M.set(8,D.Codicon.symbolModule),M.set(9,D.Codicon.symbolProperty),M.set(10,D.Codicon.symbolEvent),M.set(11,D.Codicon.symbolOperator),M.set(12,D.Codicon.symbolUnit),M.set(13,D.Codicon.symbolValue),M.set(15,D.Codicon.symbolEnum),M.set(14,D.Codicon.symbolConstant),M.set(15,D.Codicon.symbolEnum),M.set(16,D.Codicon.symbolEnumMember),M.set(17,D.Codicon.symbolKeyword),M.set(27,D.Codicon.symbolSnippet),M.set(18,D.Codicon.symbolText),M.set(19,D.Codicon.symbolColor),M.set(20,D.Codicon.symbolFile),M.set(21,D.Codicon.symbolReference),M.set(22,D.Codicon.symbolCustomColor),M.set(23,D.Codicon.symbolFolder),M.set(24,D.Codicon.symbolTypeParameter),M.set(25,D.Codicon.account),M.set(26,D.Codicon.issues);function T(H){let z=M.get(H);return z||(console.info("No codicon found for CompletionItemKind "+H),z=D.Codicon.symbolProperty),z}o.toIcon=T;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function C(H,z){let ee=O.get(H);return typeof ee>"u"&&!z&&(ee=9),ee}o.fromString=C})(A=n.CompletionItemKinds||(n.CompletionItemKinds={}));var R;(function(o){o[o.Deprecated=1]="Deprecated"})(R=n.CompletionItemTag||(n.CompletionItemTag={}));var N;(function(o){o[o.None=0]="None",o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(N=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var v;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var e;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(e=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var E;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(E=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var F;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(F=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var y;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(y=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));function L(o){return o&&t.URI.isUri(o.uri)&&P.Range.isIRange(o.range)&&(P.Range.isIRange(o.originSelectionRange)||P.Range.isIRange(o.targetSelectionRange))}n.isLocationLink=L;var d;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(d=n.SymbolKind||(n.SymbolKind={}));var b;(function(o){o[o.Deprecated=1]="Deprecated"})(b=n.SymbolTag||(n.SymbolTag={}));var l;(function(o){const M=new Map;M.set(0,D.Codicon.symbolFile),M.set(1,D.Codicon.symbolModule),M.set(2,D.Codicon.symbolNamespace),M.set(3,D.Codicon.symbolPackage),M.set(4,D.Codicon.symbolClass),M.set(5,D.Codicon.symbolMethod),M.set(6,D.Codicon.symbolProperty),M.set(7,D.Codicon.symbolField),M.set(8,D.Codicon.symbolConstructor),M.set(9,D.Codicon.symbolEnum),M.set(10,D.Codicon.symbolInterface),M.set(11,D.Codicon.symbolFunction),M.set(12,D.Codicon.symbolVariable),M.set(13,D.Codicon.symbolConstant),M.set(14,D.Codicon.symbolString),M.set(15,D.Codicon.symbolNumber),M.set(16,D.Codicon.symbolBoolean),M.set(17,D.Codicon.symbolArray),M.set(18,D.Codicon.symbolObject),M.set(19,D.Codicon.symbolKey),M.set(20,D.Codicon.symbolNull),M.set(21,D.Codicon.symbolEnumMember),M.set(22,D.Codicon.symbolStruct),M.set(23,D.Codicon.symbolEvent),M.set(24,D.Codicon.symbolOperator),M.set(25,D.Codicon.symbolTypeParameter);function T(O){let C=M.get(O);return C||(console.info("No codicon found for SymbolKind "+O),C=D.Codicon.symbolProperty),C}o.toIcon=T})(l=n.SymbolKinds||(n.SymbolKinds={}));class r{constructor(M){this.value=M}}n.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var s;(function(o){function M(T){return!T||typeof T!="object"?!1:typeof T.id=="string"&&typeof T.title=="string"}o.is=M})(s=n.Command||(n.Command={}));var g;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(g=n.CommentThreadCollapsibleState||(n.CommentThreadCollapsibleState={}));var c;(function(o){o[o.Unresolved=0]="Unresolved",o[o.Resolved=1]="Resolved"})(c=n.CommentThreadState||(n.CommentThreadState={}));var p;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(p=n.CommentMode||(n.CommentMode={}));var w;(function(o){o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(w=n.InlayHintKind||(n.InlayHintKind={})),n.TokenizationRegistry=new u.TokenizationRegistry;var f;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(f=n.ExternalUriOpenerPriority||(n.ExternalUriOpenerPriority={}))}),Z(J[53],x([0,1,21,9,27,12,3,2,30,52,41]),function(q,n,D,t,P,u,_,m,a,h,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class R{static chord(e,E){return(0,P.KeyChord)(e,E)}}n.KeyMod=R,R.CtrlCmd=2048,R.Shift=1024,R.Alt=512,R.WinCtrl=256;function N(){return{editor:void 0,languages:void 0,CancellationTokenSource:D.CancellationTokenSource,Emitter:t.Emitter,KeyCode:A.KeyCode,KeyMod:R,Position:_.Position,Range:m.Range,Selection:a.Selection,SelectionDirection:A.SelectionDirection,MarkerSeverity:A.MarkerSeverity,MarkerTag:A.MarkerTag,Uri:u.URI,Token:h.Token}}n.createMonacoBaseAPI=N}),Z(J[58],x([0,1,22,5,12,3,2,48,18,37,38,53,20,50,23,47,11]),function(q,n,D,t,P,u,_,m,a,h,A,R,N,v,e,E,F){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class y extends m.MirrorTextModel{get uri(){return this.c}get eol(){return this.f}getValue(){return this.getText()}getLinesContent(){return this.d.slice(0)}getLineCount(){return this.d.length}getLineContent(l){return this.d[l-1]}getWordAtPosition(l,r){const s=(0,a.getWordAtText)(l.column,(0,a.ensureValidWordDefinition)(r),this.d[l.lineNumber-1],0);return s?new _.Range(l.lineNumber,s.startColumn,l.lineNumber,s.endColumn):null}getWordUntilPosition(l,r){const s=this.getWordAtPosition(l,r);return s?{word:this.d[l.lineNumber-1].substring(s.startColumn-1,l.column-1),startColumn:s.startColumn,endColumn:l.column}:{word:"",startColumn:l.column,endColumn:l.column}}words(l){const r=this.d,s=this.p.bind(this);let g=0,c="",p=0,w=[];return{*[Symbol.iterator](){for(;;)if(p<w.length){const f=c.substring(w[p].start,w[p].end);p+=1,yield f}else if(g<r.length)c=r[g],w=s(c,l),p=0,g+=1;else break}}}getLineWords(l,r){const s=this.d[l-1],g=this.p(s,r),c=[];for(const p of g)c.push({word:s.substring(p.start,p.end),startColumn:p.start+1,endColumn:p.end+1});return c}p(l,r){const s=[];let g;for(r.lastIndex=0;(g=r.exec(l))&&g[0].length!==0;)s.push({start:g.index,end:g.index+g[0].length});return s}getValueInRange(l){if(l=this.q(l),l.startLineNumber===l.endLineNumber)return this.d[l.startLineNumber-1].substring(l.startColumn-1,l.endColumn-1);const r=this.f,s=l.startLineNumber-1,g=l.endLineNumber-1,c=[];c.push(this.d[s].substring(l.startColumn-1));for(let p=s+1;p<g;p++)c.push(this.d[p]);return c.push(this.d[g].substring(0,l.endColumn-1)),c.join(r)}offsetAt(l){return l=this.r(l),this.k(),this.h.getPrefixSum(l.lineNumber-2)+(l.column-1)}positionAt(l){l=Math.floor(l),l=Math.max(0,l),this.k();const r=this.h.getIndexOf(l),s=this.d[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,s)}}q(l){const r=this.r({lineNumber:l.startLineNumber,column:l.startColumn}),s=this.r({lineNumber:l.endLineNumber,column:l.endColumn});return r.lineNumber!==l.startLineNumber||r.column!==l.startColumn||s.lineNumber!==l.endLineNumber||s.column!==l.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:s.lineNumber,endColumn:s.column}:l}r(l){if(!u.Position.isIPosition(l))throw new Error("bad position");let{lineNumber:r,column:s}=l,g=!1;if(r<1)r=1,s=1,g=!0;else if(r>this.d.length)r=this.d.length,s=this.d[r-1].length+1,g=!0;else{const c=this.d[r-1].length+1;s<1?(s=1,g=!0):s>c&&(s=c,g=!0)}return g?{lineNumber:r,column:s}:l}}class L{constructor(l,r){this.c=l,this.d=Object.create(null),this.f=r,this.g=null}dispose(){this.d=Object.create(null)}h(l){return this.d[l]}j(){const l=[];return Object.keys(this.d).forEach(r=>l.push(this.d[r])),l}acceptNewModel(l){this.d[l.url]=new y(P.URI.parse(l.url),l.lines,l.EOL,l.versionId)}acceptModelChanged(l,r){if(!this.d[l])return;this.d[l].onEvents(r)}acceptRemovedModel(l){!this.d[l]||delete this.d[l]}async computeUnicodeHighlights(l,r,s){const g=this.h(l);return g?v.UnicodeTextModelHighlighter.computeUnicodeHighlights(g,r,s):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(l,r,s,g){const c=this.h(l),p=this.h(r);return!c||!p?null:L.k(c,p,s,g)}static k(l,r,s,g){const c=g==="experimental"?E.linesDiffComputers.experimental:E.linesDiffComputers.smart,p=l.getLinesContent(),w=r.getLinesContent(),f=c.computeDiff(p,w,s);return{identical:f.changes.length>0?!1:this.l(l,r),quitEarly:f.quitEarly,changes:f.changes.map(M=>[M.originalRange.startLineNumber,M.originalRange.endLineNumberExclusive,M.modifiedRange.startLineNumber,M.modifiedRange.endLineNumberExclusive,M.innerChanges?.map(T=>[T.originalRange.startLineNumber,T.originalRange.startColumn,T.originalRange.endLineNumber,T.originalRange.endColumn,T.modifiedRange.startLineNumber,T.modifiedRange.startColumn,T.modifiedRange.endLineNumber,T.modifiedRange.endColumn])])}}static l(l,r){const s=l.getLineCount(),g=r.getLineCount();if(s!==g)return!1;for(let c=1;c<=s;c++){const p=l.getLineContent(c),w=r.getLineContent(c);if(p!==w)return!1}return!0}async computeDirtyDiff(l,r,s){const g=this.h(l),c=this.h(r);if(!g||!c)return null;const p=g.getLinesContent(),w=c.getLinesContent();return new e.DiffComputer(p,w,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:s,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(l,r){const s=this.h(l);if(!s)return r;const g=[];let c;r=r.slice(0).sort((p,w)=>{if(p.range&&w.range)return _.Range.compareRangesUsingStarts(p.range,w.range);const f=p.range?0:1,o=w.range?0:1;return f-o});for(let{range:p,text:w,eol:f}of r){if(typeof f=="number"&&(c=f),_.Range.isEmpty(p)&&!w)continue;const o=s.getValueInRange(p);if(w=w.replace(/\r\n|\n|\r/g,s.eol),o===w)continue;if(Math.max(w.length,o.length)>L.n){g.push({range:p,text:w});continue}const M=(0,D.stringDiff)(o,w,!1),T=s.offsetAt(_.Range.lift(p).getStartPosition());for(const O of M){const C=s.positionAt(T+O.originalStart),H=s.positionAt(T+O.originalStart+O.originalLength),z={text:w.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:C.lineNumber,startColumn:C.column,endLineNumber:H.lineNumber,endColumn:H.column}};s.getValueInRange(z.range)!==z.text&&g.push(z)}}return typeof c=="number"&&g.push({eol:c,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),g}async computeLinks(l){const r=this.h(l);return r?(0,h.computeLinks)(r):null}async textualSuggest(l,r,s,g){const c=new N.StopWatch(!0),p=new RegExp(s,g),w=new Set;e:for(const f of l){const o=this.h(f);if(!!o){for(const M of o.words(p))if(!(M===r||!isNaN(Number(M)))&&(w.add(M),w.size>L.o))break e}}return{words:Array.from(w),duration:c.elapsed()}}async computeWordRanges(l,r,s,g){const c=this.h(l);if(!c)return Object.create(null);const p=new RegExp(s,g),w=Object.create(null);for(let f=r.startLineNumber;f<r.endLineNumber;f++){const o=c.getLineWords(f,p);for(const M of o){if(!isNaN(Number(M.word)))continue;let T=w[M.word];T||(T=[],w[M.word]=T),T.push({startLineNumber:f,startColumn:M.startColumn,endLineNumber:f,endColumn:M.endColumn})}}return w}async navigateValueSet(l,r,s,g,c){const p=this.h(l);if(!p)return null;const w=new RegExp(g,c);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});const f=p.getValueInRange(r),o=p.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},w);if(!o)return null;const M=p.getValueInRange(o);return A.BasicInplaceReplace.INSTANCE.navigateValueSet(r,f,o,M,s)}loadForeignModule(l,r,s){const g=(w,f)=>this.c.fhr(w,f),p={host:(0,F.createProxyObject)(s,g),getMirrorModels:()=>this.j()};return this.f?(this.g=this.f(p,r),Promise.resolve((0,F.getAllMethodNames)(this.g))):new Promise((w,f)=>{q([l],o=>{this.g=o.create(p,r),w((0,F.getAllMethodNames)(this.g))},f)})}fmr(l,r){if(!this.g||typeof this.g[l]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+l));try{return Promise.resolve(this.g[l].apply(this.g,r))}catch(s){return Promise.reject(s)}}}n.EditorSimpleWorker=L,L.n=1e5,L.o=1e4;function d(b){return new L(b,null)}n.create=d,typeof importScripts=="function"&&(t.globals.monaco=(0,R.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/89e427274e1c9e555f8bfa21bd1e9c50c0225403/core/vs/base/worker/workerMain.js.map
