/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/nls","vs/base/common/codicons","vs/base/common/arrays","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/platform/instantiation/common/instantiation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/network","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/color","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/list/listWidget","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/platform/instantiation/common/descriptors","vs/platform/theme/common/themeService","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],me=function(J){for(var t=[],w=0,i=J.length;w<i;w++)t[w]=ge[J[w]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function _t(J){if(Array.isArray(J)){for(var t=0,w=Array(J.length);t<J.length;t++)w[t]=J[t];return w}else return Array.from(J)}var jt=Object.hasOwnProperty,Nt=Object.setPrototypeOf,Kt=Object.isFrozen,qt=Object.getPrototypeOf,Vt=Object.getOwnPropertyDescriptor,et=Object.freeze,ot=Object.seal,Gt=Object.create,It=typeof Reflect<"u"&&Reflect,vt=It.apply,At=It.construct;vt||(vt=function(t,w,i){return t.apply(w,i)}),et||(et=function(t){return t}),ot||(ot=function(t){return t}),At||(At=function(t,w){return new(Function.prototype.bind.apply(t,[null].concat(_t(w))))});var Yt=nt(Array.prototype.forEach),Mt=nt(Array.prototype.pop),mt=nt(Array.prototype.push),ht=nt(String.prototype.toLowerCase),Pt=nt(String.prototype.match),lt=nt(String.prototype.replace),Xt=nt(String.prototype.indexOf),Zt=nt(String.prototype.trim),at=nt(RegExp.prototype.test),Rt=Qt(TypeError);function nt(J){return function(t){for(var w=arguments.length,i=Array(w>1?w-1:0),U=1;U<w;U++)i[U-1]=arguments[U];return vt(J,t,i)}}function Qt(J){return function(){for(var t=arguments.length,w=Array(t),i=0;i<t;i++)w[i]=arguments[i];return At(J,w)}}function He(J,t){Nt&&Nt(J,null);for(var w=t.length;w--;){var i=t[w];if(typeof i=="string"){var U=ht(i);U!==i&&(Kt(t)||(t[w]=U),i=U)}J[i]=!0}return J}function ct(J){var t=Gt(null),w=void 0;for(w in J)vt(jt,J,[w])&&(t[w]=J[w]);return t}function Dt(J,t){for(;J!==null;){var w=Vt(J,t);if(w){if(w.get)return nt(w.get);if(typeof w.value=="function")return nt(w.value)}J=qt(J)}function i(U){return console.warn("fallback value for",U),null}return i}var Ot=et(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),St=et(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ct=et(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Jt=et(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),kt=et(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),xt=et(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Bt=et(["#text"]),Ht=et(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ft=et(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),zt=et(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=et(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ei=ot(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ti=ot(/<%[\s\S]*|[\s\S]*%>/gm),ii=ot(/^data-[\-\w.\u00B7-\uFFFF]/),ni=ot(/^aria-[\-\w]+$/),si=ot(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),ri=ot(/^(?:\w+script|data):/i),oi=ot(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),bt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(J){return typeof J}:function(J){return J&&typeof Symbol=="function"&&J.constructor===Symbol&&J!==Symbol.prototype?"symbol":typeof J};function rt(J){if(Array.isArray(J)){for(var t=0,w=Array(J.length);t<J.length;t++)w[t]=J[t];return w}else return Array.from(J)}var ai=function(){return typeof window>"u"?null:window},li=function(t,w){if((typeof t>"u"?"undefined":bt(t))!=="object"||typeof t.createPolicy!="function")return null;var i=null,U="data-tt-policy-suffix";w.currentScript&&w.currentScript.hasAttribute(U)&&(i=w.currentScript.getAttribute(U));var z="dompurify"+(i?"#"+i:"");try{return t.createPolicy(z,{createHTML:function(b){return b}})}catch{return console.warn("TrustedTypes policy "+z+" could not be created."),null}};function Ut(){var J=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ai(),t=function(oe){return Ut(oe)};if(t.version="2.3.1",t.removed=[],!J||!J.document||J.document.nodeType!==9)return t.isSupported=!1,t;var w=J.document,i=J.document,U=J.DocumentFragment,z=J.HTMLTemplateElement,y=J.Node,b=J.Element,f=J.NodeFilter,d=J.NamedNodeMap,h=d===void 0?J.NamedNodeMap||J.MozNamedAttrMap:d,N=J.Text,a=J.Comment,s=J.DOMParser,e=J.trustedTypes,r=b.prototype,o=Dt(r,"cloneNode"),l=Dt(r,"nextSibling"),u=Dt(r,"childNodes"),D=Dt(r,"parentNode");if(typeof z=="function"){var S=i.createElement("template");S.content&&S.content.ownerDocument&&(i=S.content.ownerDocument)}var k=li(e,w),g=k&&K?k.createHTML(""):"",A=i,L=A.implementation,F=A.createNodeIterator,c=A.createDocumentFragment,p=A.getElementsByTagName,m=w.importNode,v={};try{v=ct(i).documentMode?i.documentMode:{}}catch{}var M={};t.isSupported=typeof D=="function"&&L&&typeof L.createHTMLDocument<"u"&&v!==9;var V=ei,x=ti,Z=ii,ee=ni,se=ri,he=oi,ue=si,de=null,we=He({},[].concat(rt(Ot),rt(St),rt(Ct),rt(kt),rt(Bt))),Te=null,Me=He({},[].concat(rt(Ht),rt(Ft),rt(zt),rt(yt))),Oe=null,j=null,Y=!0,ie=!0,ne=!1,ae=!1,te=!1,W=!1,n=!1,E=!1,P=!1,$=!0,K=!1,C=!0,I=!0,R=!1,T={},O=null,B=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),H=null,_=He({},["audio","video","img","source","image","track"]),Q=null,re=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),ce="http://www.w3.org/1998/Math/MathML",ve="http://www.w3.org/2000/svg",De="http://www.w3.org/1999/xhtml",Le=De,Ae=!1,pe=null,Pe=i.createElement("form"),Ie=function(oe){pe&&pe===oe||((!oe||(typeof oe>"u"?"undefined":bt(oe))!=="object")&&(oe={}),oe=ct(oe),de="ALLOWED_TAGS"in oe?He({},oe.ALLOWED_TAGS):we,Te="ALLOWED_ATTR"in oe?He({},oe.ALLOWED_ATTR):Me,Q="ADD_URI_SAFE_ATTR"in oe?He(ct(re),oe.ADD_URI_SAFE_ATTR):re,H="ADD_DATA_URI_TAGS"in oe?He(ct(_),oe.ADD_DATA_URI_TAGS):_,O="FORBID_CONTENTS"in oe?He({},oe.FORBID_CONTENTS):B,Oe="FORBID_TAGS"in oe?He({},oe.FORBID_TAGS):{},j="FORBID_ATTR"in oe?He({},oe.FORBID_ATTR):{},T="USE_PROFILES"in oe?oe.USE_PROFILES:!1,Y=oe.ALLOW_ARIA_ATTR!==!1,ie=oe.ALLOW_DATA_ATTR!==!1,ne=oe.ALLOW_UNKNOWN_PROTOCOLS||!1,ae=oe.SAFE_FOR_TEMPLATES||!1,te=oe.WHOLE_DOCUMENT||!1,E=oe.RETURN_DOM||!1,P=oe.RETURN_DOM_FRAGMENT||!1,$=oe.RETURN_DOM_IMPORT!==!1,K=oe.RETURN_TRUSTED_TYPE||!1,n=oe.FORCE_BODY||!1,C=oe.SANITIZE_DOM!==!1,I=oe.KEEP_CONTENT!==!1,R=oe.IN_PLACE||!1,ue=oe.ALLOWED_URI_REGEXP||ue,Le=oe.NAMESPACE||De,ae&&(ie=!1),P&&(E=!0),T&&(de=He({},[].concat(rt(Bt))),Te=[],T.html===!0&&(He(de,Ot),He(Te,Ht)),T.svg===!0&&(He(de,St),He(Te,Ft),He(Te,yt)),T.svgFilters===!0&&(He(de,Ct),He(Te,Ft),He(Te,yt)),T.mathMl===!0&&(He(de,kt),He(Te,zt),He(Te,yt))),oe.ADD_TAGS&&(de===we&&(de=ct(de)),He(de,oe.ADD_TAGS)),oe.ADD_ATTR&&(Te===Me&&(Te=ct(Te)),He(Te,oe.ADD_ATTR)),oe.ADD_URI_SAFE_ATTR&&He(Q,oe.ADD_URI_SAFE_ATTR),oe.FORBID_CONTENTS&&(O===B&&(O=ct(O)),He(O,oe.FORBID_CONTENTS)),I&&(de["#text"]=!0),te&&He(de,["html","head","body"]),de.table&&(He(de,["tbody"]),delete Oe.tbody),et&&et(oe),pe=oe)},_e=He({},["mi","mo","mn","ms","mtext"]),ze=He({},["foreignobject","desc","title","annotation-xml"]),We=He({},St);He(We,Ct),He(We,Jt);var xe=He({},kt);He(xe,xt);var it=function(oe){var Ee=D(oe);(!Ee||!Ee.tagName)&&(Ee={namespaceURI:De,tagName:"template"});var Fe=ht(oe.tagName),Ue=ht(Ee.tagName);if(oe.namespaceURI===ve)return Ee.namespaceURI===De?Fe==="svg":Ee.namespaceURI===ce?Fe==="svg"&&(Ue==="annotation-xml"||_e[Ue]):Boolean(We[Fe]);if(oe.namespaceURI===ce)return Ee.namespaceURI===De?Fe==="math":Ee.namespaceURI===ve?Fe==="math"&&ze[Ue]:Boolean(xe[Fe]);if(oe.namespaceURI===De){if(Ee.namespaceURI===ve&&!ze[Ue]||Ee.namespaceURI===ce&&!_e[Ue])return!1;var Ge=He({},["title","style","font","a","script"]);return!xe[Fe]&&(Ge[Fe]||!We[Fe])}return!1},Be=function(oe){mt(t.removed,{element:oe});try{oe.parentNode.removeChild(oe)}catch{try{oe.outerHTML=g}catch{oe.remove()}}},Ke=function(oe,Ee){try{mt(t.removed,{attribute:Ee.getAttributeNode(oe),from:Ee})}catch{mt(t.removed,{attribute:null,from:Ee})}if(Ee.removeAttribute(oe),oe==="is"&&!Te[oe])if(E||P)try{Be(Ee)}catch{}else try{Ee.setAttribute(oe,"")}catch{}},Ye=function(oe){var Ee=void 0,Fe=void 0;if(n)oe="<remove></remove>"+oe;else{var Ue=Pt(oe,/^[\r\n\t ]+/);Fe=Ue&&Ue[0]}var Ge=k?k.createHTML(oe):oe;if(Le===De)try{Ee=new s().parseFromString(Ge,"text/html")}catch{}if(!Ee||!Ee.documentElement){Ee=L.createDocument(Le,"template",null);try{Ee.documentElement.innerHTML=Ae?"":Ge}catch{}}var Ze=Ee.body||Ee.documentElement;return oe&&Fe&&Ze.insertBefore(i.createTextNode(Fe),Ze.childNodes[0]||null),Le===De?p.call(Ee,te?"html":"body")[0]:te?Ee.documentElement:Ze},q=function(oe){return F.call(oe.ownerDocument||oe,oe,f.SHOW_ELEMENT|f.SHOW_COMMENT|f.SHOW_TEXT,null,!1)},le=function(oe){return oe instanceof N||oe instanceof a?!1:typeof oe.nodeName!="string"||typeof oe.textContent!="string"||typeof oe.removeChild!="function"||!(oe.attributes instanceof h)||typeof oe.removeAttribute!="function"||typeof oe.setAttribute!="function"||typeof oe.namespaceURI!="string"||typeof oe.insertBefore!="function"},be=function(oe){return(typeof y>"u"?"undefined":bt(y))==="object"?oe instanceof y:oe&&(typeof oe>"u"?"undefined":bt(oe))==="object"&&typeof oe.nodeType=="number"&&typeof oe.nodeName=="string"},ye=function(oe,Ee,Fe){!M[oe]||Yt(M[oe],function(Ue){Ue.call(t,Ee,Fe,pe)})},Ce=function(oe){var Ee=void 0;if(ye("beforeSanitizeElements",oe,null),le(oe)||Pt(oe.nodeName,/[\u0080-\uFFFF]/))return Be(oe),!0;var Fe=ht(oe.nodeName);if(ye("uponSanitizeElement",oe,{tagName:Fe,allowedTags:de}),!be(oe.firstElementChild)&&(!be(oe.content)||!be(oe.content.firstElementChild))&&at(/<[/\w]/g,oe.innerHTML)&&at(/<[/\w]/g,oe.textContent)||Fe==="select"&&at(/<template/i,oe.innerHTML))return Be(oe),!0;if(!de[Fe]||Oe[Fe]){if(I&&!O[Fe]){var Ue=D(oe)||oe.parentNode,Ge=u(oe)||oe.childNodes;if(Ge&&Ue)for(var Ze=Ge.length,Qe=Ze-1;Qe>=0;--Qe)Ue.insertBefore(o(Ge[Qe],!0),l(oe))}return Be(oe),!0}return oe instanceof b&&!it(oe)||(Fe==="noscript"||Fe==="noembed")&&at(/<\/no(script|embed)/i,oe.innerHTML)?(Be(oe),!0):(ae&&oe.nodeType===3&&(Ee=oe.textContent,Ee=lt(Ee,V," "),Ee=lt(Ee,x," "),oe.textContent!==Ee&&(mt(t.removed,{element:oe.cloneNode()}),oe.textContent=Ee)),ye("afterSanitizeElements",oe,null),!1)},Re=function(oe,Ee,Fe){if(C&&(Ee==="id"||Ee==="name")&&(Fe in i||Fe in Pe))return!1;if(!(ie&&!j[Ee]&&at(Z,Ee))){if(!(Y&&at(ee,Ee))){if(!Te[Ee]||j[Ee])return!1;if(!Q[Ee]){if(!at(ue,lt(Fe,he,""))){if(!((Ee==="src"||Ee==="xlink:href"||Ee==="href")&&oe!=="script"&&Xt(Fe,"data:")===0&&H[oe])){if(!(ne&&!at(se,lt(Fe,he,"")))){if(Fe)return!1}}}}}}return!0},je=function(oe){var Ee=void 0,Fe=void 0,Ue=void 0,Ge=void 0;ye("beforeSanitizeAttributes",oe,null);var Ze=oe.attributes;if(!!Ze){var Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:Te};for(Ge=Ze.length;Ge--;){Ee=Ze[Ge];var st=Ee,ut=st.name,Et=st.namespaceURI;if(Fe=Zt(Ee.value),Ue=ht(ut),Qe.attrName=Ue,Qe.attrValue=Fe,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,ye("uponSanitizeAttribute",oe,Qe),Fe=Qe.attrValue,!Qe.forceKeepAttr&&(Ke(ut,oe),!!Qe.keepAttr)){if(at(/\/>/i,Fe)){Ke(ut,oe);continue}ae&&(Fe=lt(Fe,V," "),Fe=lt(Fe,x," "));var Tt=oe.nodeName.toLowerCase();if(!!Re(Tt,Ue,Fe))try{Et?oe.setAttributeNS(Et,ut,Fe):oe.setAttribute(ut,Fe),Mt(t.removed)}catch{}}}ye("afterSanitizeAttributes",oe,null)}},tt=function Ne(oe){var Ee=void 0,Fe=q(oe);for(ye("beforeSanitizeShadowDOM",oe,null);Ee=Fe.nextNode();)ye("uponSanitizeShadowNode",Ee,null),!Ce(Ee)&&(Ee.content instanceof U&&Ne(Ee.content),je(Ee));ye("afterSanitizeShadowDOM",oe,null)};return t.sanitize=function(Ne,oe){var Ee=void 0,Fe=void 0,Ue=void 0,Ge=void 0,Ze=void 0;if(Ae=!Ne,Ae&&(Ne="<!-->"),typeof Ne!="string"&&!be(Ne)){if(typeof Ne.toString!="function")throw Rt("toString is not a function");if(Ne=Ne.toString(),typeof Ne!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(bt(J.toStaticHTML)==="object"||typeof J.toStaticHTML=="function"){if(typeof Ne=="string")return J.toStaticHTML(Ne);if(be(Ne))return J.toStaticHTML(Ne.outerHTML)}return Ne}if(W||Ie(oe),t.removed=[],typeof Ne=="string"&&(R=!1),!R)if(Ne instanceof y)Ee=Ye("<!---->"),Fe=Ee.ownerDocument.importNode(Ne,!0),Fe.nodeType===1&&Fe.nodeName==="BODY"||Fe.nodeName==="HTML"?Ee=Fe:Ee.appendChild(Fe);else{if(!E&&!ae&&!te&&Ne.indexOf("<")===-1)return k&&K?k.createHTML(Ne):Ne;if(Ee=Ye(Ne),!Ee)return E?null:g}Ee&&n&&Be(Ee.firstChild);for(var Qe=q(R?Ne:Ee);Ue=Qe.nextNode();)Ue.nodeType===3&&Ue===Ge||Ce(Ue)||(Ue.content instanceof U&&tt(Ue.content),je(Ue),Ge=Ue);if(Ge=null,R)return Ne;if(E){if(P)for(Ze=c.call(Ee.ownerDocument);Ee.firstChild;)Ze.appendChild(Ee.firstChild);else Ze=Ee;return $&&(Ze=m.call(w,Ze,!0)),Ze}var st=te?Ee.outerHTML:Ee.innerHTML;return ae&&(st=lt(st,V," "),st=lt(st,x," ")),k&&K?k.createHTML(st):st},t.setConfig=function(Ne){Ie(Ne),W=!0},t.clearConfig=function(){pe=null,W=!1},t.isValidAttribute=function(Ne,oe,Ee){pe||Ie({});var Fe=ht(Ne),Ue=ht(oe);return Re(Fe,Ue,Ee)},t.addHook=function(Ne,oe){typeof oe=="function"&&(M[Ne]=M[Ne]||[],mt(M[Ne],oe))},t.removeHook=function(Ne){M[Ne]&&Mt(M[Ne])},t.removeHooks=function(Ne){M[Ne]&&(M[Ne]=[])},t.removeAllHooks=function(){M={}},t}var ui=Ut();define("vs/base/browser/dompurify/dompurify",function(){return ui}),define(ge[39],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class w{constructor(y){this.domNode=y,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(y){const b=i(y);this.a!==b&&(this.a=b,this.domNode.style.maxWidth=this.a)}setWidth(y){const b=i(y);this.b!==b&&(this.b=b,this.domNode.style.width=this.b)}setHeight(y){const b=i(y);this.c!==b&&(this.c=b,this.domNode.style.height=this.c)}setTop(y){const b=i(y);this.d!==b&&(this.d=b,this.domNode.style.top=this.d)}setLeft(y){const b=i(y);this.e!==b&&(this.e=b,this.domNode.style.left=this.e)}setBottom(y){const b=i(y);this.f!==b&&(this.f=b,this.domNode.style.bottom=this.f)}setRight(y){const b=i(y);this.g!==b&&(this.g=b,this.domNode.style.right=this.g)}setPaddingTop(y){const b=i(y);this.h!==b&&(this.h=b,this.domNode.style.paddingTop=this.h)}setPaddingLeft(y){const b=i(y);this.i!==b&&(this.i=b,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(y){const b=i(y);this.j!==b&&(this.j=b,this.domNode.style.paddingBottom=this.j)}setPaddingRight(y){const b=i(y);this.k!==b&&(this.k=b,this.domNode.style.paddingRight=this.k)}setFontFamily(y){this.l!==y&&(this.l=y,this.domNode.style.fontFamily=this.l)}setFontWeight(y){this.m!==y&&(this.m=y,this.domNode.style.fontWeight=this.m)}setFontSize(y){const b=i(y);this.n!==b&&(this.n=b,this.domNode.style.fontSize=this.n)}setFontStyle(y){this.o!==y&&(this.o=y,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(y){this.p!==y&&(this.p=y,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(y){this.q!==y&&(this.q=y,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(y){this.r!==y&&(this.r=y,this.domNode.style.textDecoration=this.r)}setLineHeight(y){const b=i(y);this.s!==b&&(this.s=b,this.domNode.style.lineHeight=this.s)}setLetterSpacing(y){const b=i(y);this.t!==b&&(this.t=b,this.domNode.style.letterSpacing=this.t)}setClassName(y){this.u!==y&&(this.u=y,this.domNode.className=this.u)}toggleClassName(y,b){this.domNode.classList.toggle(y,b),this.u=this.domNode.className}setDisplay(y){this.v!==y&&(this.v=y,this.domNode.style.display=this.v)}setPosition(y){this.w!==y&&(this.w=y,this.domNode.style.position=this.w)}setVisibility(y){this.x!==y&&(this.x=y,this.domNode.style.visibility=this.x)}setColor(y){this.y!==y&&(this.y=y,this.domNode.style.color=this.y)}setBackgroundColor(y){this.z!==y&&(this.z=y,this.domNode.style.backgroundColor=this.z)}setLayerHinting(y){this.A!==y&&(this.A=y,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(y){this.C!==y&&(this.C=y,this.domNode.style.boxShadow=y)}setContain(y){this.B!==y&&(this.B=y,this.domNode.style.contain=this.B)}setAttribute(y,b){this.domNode.setAttribute(y,b)}removeAttribute(y){this.domNode.removeAttribute(y)}appendChild(y){this.domNode.appendChild(y.domNode)}removeChild(y){this.domNode.removeChild(y.domNode)}}t.FastDomNode=w;function i(z){return typeof z=="number"?`${z}px`:z}function U(z){return new w(z)}t.createFastDomNode=U}),define(ge[67],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let w=!1,i=null;function U(y){if(!y.parent||y.parent===y)return null;try{const b=y.location,f=y.parent.location;if(b.origin!=="null"&&f.origin!=="null"&&b.origin!==f.origin)return w=!0,null}catch{return w=!0,null}return y.parent}class z{static getSameOriginWindowChain(){if(!i){i=[];let b=window,f;do f=U(b),f?i.push({window:b,iframeElement:b.frameElement||null}):i.push({window:b,iframeElement:null}),b=f;while(b)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),w}static getPositionOfChildWindowRelativeToAncestorWindow(b,f){if(!f||b===f)return{top:0,left:0};let d=0,h=0;const N=this.getSameOriginWindowChain();for(const a of N){if(d+=a.window.scrollY,h+=a.window.scrollX,a.window===f||!a.iframeElement)break;const s=a.iframeElement.getBoundingClientRect();d+=s.top,h+=s.left}return{top:d,left:h}}}t.IframeUtils=z}),define(ge[68],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var w;(function(z){z[z.Copy=0]="Copy",z[z.Move=1]="Move"})(w=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class i extends Error{constructor(y,b){super(`ListError [${y}] ${b}`)}}t.ListError=i;class U{constructor(){this.c=new WeakMap}getHeight(y){return this.c.get(y)??this.d(y)}setDynamicHeight(y,b){b>0&&this.c.set(y,b)}}t.CachedListVirtualDelegate=U}),define(ge[69],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class w{constructor(U){this.a=U}splice(U,z,y){this.a.forEach(b=>b.splice(U,z,y))}}t.CombinedSpliceable=w}),define(ge[40],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const w=20;class i{constructor(z,y,b,f,d,h){this.a=Math.round(y),this.b=Math.round(b),this.c=Math.round(z),this.d=f,this.e=d,this.f=h,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new i(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(z){const y=Math.round(z);return this.d!==y?(this.d=y,this.m(),!0):!1}setScrollSize(z){const y=Math.round(z);return this.e!==y?(this.e=y,this.m(),!0):!1}setScrollPosition(z){const y=Math.round(z);return this.f!==y?(this.f=y,this.m(),!0):!1}setScrollbarSize(z){this.a=Math.round(z)}setOppositeScrollbarSize(z){this.b=Math.round(z)}static l(z,y,b,f,d){const h=Math.max(0,b-z),N=Math.max(0,h-2*y),a=f>0&&f>b;if(!a)return{computedAvailableSize:Math.round(h),computedIsNeeded:a,computedSliderSize:Math.round(N),computedSliderRatio:0,computedSliderPosition:0};const s=Math.round(Math.max(w,Math.floor(b*N/f))),e=(N-s)/(f-b),r=d*e;return{computedAvailableSize:Math.round(h),computedIsNeeded:a,computedSliderSize:Math.round(s),computedSliderRatio:e,computedSliderPosition:Math.round(r)}}m(){const z=i.l(this.b,this.c,this.d,this.e,this.f);this.g=z.computedAvailableSize,this.h=z.computedIsNeeded,this.i=z.computedSliderSize,this.j=z.computedSliderRatio,this.k=z.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(z){if(!this.h)return 0;const y=z-this.c-this.i/2;return Math.round(y/this.j)}getDesiredScrollPositionFromOffsetPaged(z){if(!this.h)return 0;const y=z-this.c;let b=this.f;return y<this.k?b-=this.d:b+=this.d,b}getDesiredScrollPositionFromDelta(z){if(!this.h)return 0;const y=this.k+z;return Math.round(y/this.j)}}t.ScrollbarState=i}),define(ge[23],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var w;(function(b){b[b.Hidden=0]="Hidden",b[b.Visible=1]="Visible",b[b.Recurse=2]="Recurse"})(w=t.TreeVisibility||(t.TreeVisibility={}));var i;(function(b){b[b.Unknown=0]="Unknown",b[b.Twistie=1]="Twistie",b[b.Element=2]="Element",b[b.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var U;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})(U=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(b=!1){return{accept:!0,bubble:0,autoExpand:b}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(b=!1){return{accept:!0,bubble:0,effect:0,autoExpand:b}}};class z extends Error{constructor(f,d){super(`TreeError [${f}] ${d}`)}}t.TreeError=z;class y{constructor(f){this.a=f,this.b=new WeakMap}map(f){let d=this.b.get(f);return d||(d=this.a(f),this.b.set(f,d)),d}}t.WeakMapper=y}),define(ge[13],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.Codicon=t.getCodiconAriaLabel=void 0;function w(z){return z?z.replace(/\$\((.*?)\)/g,(y,b)=>` ${b} `).trim():""}t.getCodiconAriaLabel=w;class i{constructor(y,b,f){this.id=y,this.fontCharacter=b,this.description=f,i.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i.a}}t.Codicon=i,i.a=[],i.add=new i("add","\\ea60"),i.plus=new i("plus",i.add.fontCharacter),i.gistNew=new i("gist-new",i.add.fontCharacter),i.repoCreate=new i("repo-create",i.add.fontCharacter),i.lightbulb=new i("lightbulb","\\ea61"),i.lightBulb=new i("light-bulb","\\ea61"),i.repo=new i("repo","\\ea62"),i.repoDelete=new i("repo-delete","\\ea62"),i.gistFork=new i("gist-fork","\\ea63"),i.repoForked=new i("repo-forked","\\ea63"),i.gitPullRequest=new i("git-pull-request","\\ea64"),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned","\\ea64"),i.recordKeys=new i("record-keys","\\ea65"),i.keyboard=new i("keyboard","\\ea65"),i.tag=new i("tag","\\ea66"),i.tagAdd=new i("tag-add","\\ea66"),i.tagRemove=new i("tag-remove","\\ea66"),i.person=new i("person","\\ea67"),i.personFollow=new i("person-follow","\\ea67"),i.personOutline=new i("person-outline","\\ea67"),i.personFilled=new i("person-filled","\\ea67"),i.gitBranch=new i("git-branch","\\ea68"),i.gitBranchCreate=new i("git-branch-create","\\ea68"),i.gitBranchDelete=new i("git-branch-delete","\\ea68"),i.sourceControl=new i("source-control","\\ea68"),i.mirror=new i("mirror","\\ea69"),i.mirrorPublic=new i("mirror-public","\\ea69"),i.star=new i("star","\\ea6a"),i.starAdd=new i("star-add","\\ea6a"),i.starDelete=new i("star-delete","\\ea6a"),i.starEmpty=new i("star-empty","\\ea6a"),i.comment=new i("comment","\\ea6b"),i.commentAdd=new i("comment-add","\\ea6b"),i.alert=new i("alert","\\ea6c"),i.warning=new i("warning","\\ea6c"),i.search=new i("search","\\ea6d"),i.searchSave=new i("search-save","\\ea6d"),i.logOut=new i("log-out","\\ea6e"),i.signOut=new i("sign-out","\\ea6e"),i.logIn=new i("log-in","\\ea6f"),i.signIn=new i("sign-in","\\ea6f"),i.eye=new i("eye","\\ea70"),i.eyeUnwatch=new i("eye-unwatch","\\ea70"),i.eyeWatch=new i("eye-watch","\\ea70"),i.circleFilled=new i("circle-filled","\\ea71"),i.primitiveDot=new i("primitive-dot",i.circleFilled.fontCharacter),i.closeDirty=new i("close-dirty",i.circleFilled.fontCharacter),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.fontCharacter),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.fontCharacter),i.debugHint=new i("debug-hint",i.circleFilled.fontCharacter),i.primitiveSquare=new i("primitive-square","\\ea72"),i.edit=new i("edit","\\ea73"),i.pencil=new i("pencil","\\ea73"),i.info=new i("info","\\ea74"),i.issueOpened=new i("issue-opened","\\ea74"),i.gistPrivate=new i("gist-private","\\ea75"),i.gitForkPrivate=new i("git-fork-private","\\ea75"),i.lock=new i("lock","\\ea75"),i.mirrorPrivate=new i("mirror-private","\\ea75"),i.close=new i("close","\\ea76"),i.removeClose=new i("remove-close","\\ea76"),i.x=new i("x","\\ea76"),i.repoSync=new i("repo-sync","\\ea77"),i.sync=new i("sync","\\ea77"),i.clone=new i("clone","\\ea78"),i.desktopDownload=new i("desktop-download","\\ea78"),i.beaker=new i("beaker","\\ea79"),i.microscope=new i("microscope","\\ea79"),i.vm=new i("vm","\\ea7a"),i.deviceDesktop=new i("device-desktop","\\ea7a"),i.file=new i("file","\\ea7b"),i.fileText=new i("file-text","\\ea7b"),i.more=new i("more","\\ea7c"),i.ellipsis=new i("ellipsis","\\ea7c"),i.kebabHorizontal=new i("kebab-horizontal","\\ea7c"),i.mailReply=new i("mail-reply","\\ea7d"),i.reply=new i("reply","\\ea7d"),i.organization=new i("organization","\\ea7e"),i.organizationFilled=new i("organization-filled","\\ea7e"),i.organizationOutline=new i("organization-outline","\\ea7e"),i.newFile=new i("new-file","\\ea7f"),i.fileAdd=new i("file-add","\\ea7f"),i.newFolder=new i("new-folder","\\ea80"),i.fileDirectoryCreate=new i("file-directory-create","\\ea80"),i.trash=new i("trash","\\ea81"),i.trashcan=new i("trashcan","\\ea81"),i.history=new i("history","\\ea82"),i.clock=new i("clock","\\ea82"),i.folder=new i("folder","\\ea83"),i.fileDirectory=new i("file-directory","\\ea83"),i.symbolFolder=new i("symbol-folder","\\ea83"),i.logoGithub=new i("logo-github","\\ea84"),i.markGithub=new i("mark-github","\\ea84"),i.github=new i("github","\\ea84"),i.terminal=new i("terminal","\\ea85"),i.console=new i("console","\\ea85"),i.repl=new i("repl","\\ea85"),i.zap=new i("zap","\\ea86"),i.symbolEvent=new i("symbol-event","\\ea86"),i.error=new i("error","\\ea87"),i.stop=new i("stop","\\ea87"),i.variable=new i("variable","\\ea88"),i.symbolVariable=new i("symbol-variable","\\ea88"),i.array=new i("array","\\ea8a"),i.symbolArray=new i("symbol-array","\\ea8a"),i.symbolModule=new i("symbol-module","\\ea8b"),i.symbolPackage=new i("symbol-package","\\ea8b"),i.symbolNamespace=new i("symbol-namespace","\\ea8b"),i.symbolObject=new i("symbol-object","\\ea8b"),i.symbolMethod=new i("symbol-method","\\ea8c"),i.symbolFunction=new i("symbol-function","\\ea8c"),i.symbolConstructor=new i("symbol-constructor","\\ea8c"),i.symbolBoolean=new i("symbol-boolean","\\ea8f"),i.symbolNull=new i("symbol-null","\\ea8f"),i.symbolNumeric=new i("symbol-numeric","\\ea90"),i.symbolNumber=new i("symbol-number","\\ea90"),i.symbolStructure=new i("symbol-structure","\\ea91"),i.symbolStruct=new i("symbol-struct","\\ea91"),i.symbolParameter=new i("symbol-parameter","\\ea92"),i.symbolTypeParameter=new i("symbol-type-parameter","\\ea92"),i.symbolKey=new i("symbol-key","\\ea93"),i.symbolText=new i("symbol-text","\\ea93"),i.symbolReference=new i("symbol-reference","\\ea94"),i.goToFile=new i("go-to-file","\\ea94"),i.symbolEnum=new i("symbol-enum","\\ea95"),i.symbolValue=new i("symbol-value","\\ea95"),i.symbolRuler=new i("symbol-ruler","\\ea96"),i.symbolUnit=new i("symbol-unit","\\ea96"),i.activateBreakpoints=new i("activate-breakpoints","\\ea97"),i.archive=new i("archive","\\ea98"),i.arrowBoth=new i("arrow-both","\\ea99"),i.arrowDown=new i("arrow-down","\\ea9a"),i.arrowLeft=new i("arrow-left","\\ea9b"),i.arrowRight=new i("arrow-right","\\ea9c"),i.arrowSmallDown=new i("arrow-small-down","\\ea9d"),i.arrowSmallLeft=new i("arrow-small-left","\\ea9e"),i.arrowSmallRight=new i("arrow-small-right","\\ea9f"),i.arrowSmallUp=new i("arrow-small-up","\\eaa0"),i.arrowUp=new i("arrow-up","\\eaa1"),i.bell=new i("bell","\\eaa2"),i.bold=new i("bold","\\eaa3"),i.book=new i("book","\\eaa4"),i.bookmark=new i("bookmark","\\eaa5"),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified","\\eaa6"),i.debugBreakpointConditional=new i("debug-breakpoint-conditional","\\eaa7"),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled","\\eaa7"),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified","\\eaa8"),i.debugBreakpointData=new i("debug-breakpoint-data","\\eaa9"),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled","\\eaa9"),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified","\\eaaa"),i.debugBreakpointLog=new i("debug-breakpoint-log","\\eaab"),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled","\\eaab"),i.briefcase=new i("briefcase","\\eaac"),i.broadcast=new i("broadcast","\\eaad"),i.browser=new i("browser","\\eaae"),i.bug=new i("bug","\\eaaf"),i.calendar=new i("calendar","\\eab0"),i.caseSensitive=new i("case-sensitive","\\eab1"),i.check=new i("check","\\eab2"),i.checklist=new i("checklist","\\eab3"),i.chevronDown=new i("chevron-down","\\eab4"),i.dropDownButton=new i("drop-down-button",i.chevronDown.fontCharacter),i.chevronLeft=new i("chevron-left","\\eab5"),i.chevronRight=new i("chevron-right","\\eab6"),i.chevronUp=new i("chevron-up","\\eab7"),i.chromeClose=new i("chrome-close","\\eab8"),i.chromeMaximize=new i("chrome-maximize","\\eab9"),i.chromeMinimize=new i("chrome-minimize","\\eaba"),i.chromeRestore=new i("chrome-restore","\\eabb"),i.circle=new i("circle","\\eabc"),i.circleOutline=new i("circle-outline",i.circle.fontCharacter),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.fontCharacter),i.circleSlash=new i("circle-slash","\\eabd"),i.circuitBoard=new i("circuit-board","\\eabe"),i.clearAll=new i("clear-all","\\eabf"),i.clippy=new i("clippy","\\eac0"),i.closeAll=new i("close-all","\\eac1"),i.cloudDownload=new i("cloud-download","\\eac2"),i.cloudUpload=new i("cloud-upload","\\eac3"),i.code=new i("code","\\eac4"),i.collapseAll=new i("collapse-all","\\eac5"),i.colorMode=new i("color-mode","\\eac6"),i.commentDiscussion=new i("comment-discussion","\\eac7"),i.compareChanges=new i("compare-changes","\\eafd"),i.creditCard=new i("credit-card","\\eac9"),i.dash=new i("dash","\\eacc"),i.dashboard=new i("dashboard","\\eacd"),i.database=new i("database","\\eace"),i.debugContinue=new i("debug-continue","\\eacf"),i.debugDisconnect=new i("debug-disconnect","\\ead0"),i.debugPause=new i("debug-pause","\\ead1"),i.debugRestart=new i("debug-restart","\\ead2"),i.debugStart=new i("debug-start","\\ead3"),i.debugStepInto=new i("debug-step-into","\\ead4"),i.debugStepOut=new i("debug-step-out","\\ead5"),i.debugStepOver=new i("debug-step-over","\\ead6"),i.debugStop=new i("debug-stop","\\ead7"),i.debug=new i("debug","\\ead8"),i.deviceCameraVideo=new i("device-camera-video","\\ead9"),i.deviceCamera=new i("device-camera","\\eada"),i.deviceMobile=new i("device-mobile","\\eadb"),i.diffAdded=new i("diff-added","\\eadc"),i.diffIgnored=new i("diff-ignored","\\eadd"),i.diffModified=new i("diff-modified","\\eade"),i.diffRemoved=new i("diff-removed","\\eadf"),i.diffRenamed=new i("diff-renamed","\\eae0"),i.diff=new i("diff","\\eae1"),i.discard=new i("discard","\\eae2"),i.editorLayout=new i("editor-layout","\\eae3"),i.emptyWindow=new i("empty-window","\\eae4"),i.exclude=new i("exclude","\\eae5"),i.extensions=new i("extensions","\\eae6"),i.eyeClosed=new i("eye-closed","\\eae7"),i.fileBinary=new i("file-binary","\\eae8"),i.fileCode=new i("file-code","\\eae9"),i.fileMedia=new i("file-media","\\eaea"),i.filePdf=new i("file-pdf","\\eaeb"),i.fileSubmodule=new i("file-submodule","\\eaec"),i.fileSymlinkDirectory=new i("file-symlink-directory","\\eaed"),i.fileSymlinkFile=new i("file-symlink-file","\\eaee"),i.fileZip=new i("file-zip","\\eaef"),i.files=new i("files","\\eaf0"),i.filter=new i("filter","\\eaf1"),i.flame=new i("flame","\\eaf2"),i.foldDown=new i("fold-down","\\eaf3"),i.foldUp=new i("fold-up","\\eaf4"),i.fold=new i("fold","\\eaf5"),i.folderActive=new i("folder-active","\\eaf6"),i.folderOpened=new i("folder-opened","\\eaf7"),i.gear=new i("gear","\\eaf8"),i.gift=new i("gift","\\eaf9"),i.gistSecret=new i("gist-secret","\\eafa"),i.gist=new i("gist","\\eafb"),i.gitCommit=new i("git-commit","\\eafc"),i.gitCompare=new i("git-compare","\\eafd"),i.gitMerge=new i("git-merge","\\eafe"),i.githubAction=new i("github-action","\\eaff"),i.githubAlt=new i("github-alt","\\eb00"),i.globe=new i("globe","\\eb01"),i.grabber=new i("grabber","\\eb02"),i.graph=new i("graph","\\eb03"),i.gripper=new i("gripper","\\eb04"),i.heart=new i("heart","\\eb05"),i.home=new i("home","\\eb06"),i.horizontalRule=new i("horizontal-rule","\\eb07"),i.hubot=new i("hubot","\\eb08"),i.inbox=new i("inbox","\\eb09"),i.issueClosed=new i("issue-closed","\\eba4"),i.issueReopened=new i("issue-reopened","\\eb0b"),i.issues=new i("issues","\\eb0c"),i.italic=new i("italic","\\eb0d"),i.jersey=new i("jersey","\\eb0e"),i.json=new i("json","\\eb0f"),i.kebabVertical=new i("kebab-vertical","\\eb10"),i.key=new i("key","\\eb11"),i.law=new i("law","\\eb12"),i.lightbulbAutofix=new i("lightbulb-autofix","\\eb13"),i.linkExternal=new i("link-external","\\eb14"),i.link=new i("link","\\eb15"),i.listOrdered=new i("list-ordered","\\eb16"),i.listUnordered=new i("list-unordered","\\eb17"),i.liveShare=new i("live-share","\\eb18"),i.loading=new i("loading","\\eb19"),i.location=new i("location","\\eb1a"),i.mailRead=new i("mail-read","\\eb1b"),i.mail=new i("mail","\\eb1c"),i.markdown=new i("markdown","\\eb1d"),i.megaphone=new i("megaphone","\\eb1e"),i.mention=new i("mention","\\eb1f"),i.milestone=new i("milestone","\\eb20"),i.mortarBoard=new i("mortar-board","\\eb21"),i.move=new i("move","\\eb22"),i.multipleWindows=new i("multiple-windows","\\eb23"),i.mute=new i("mute","\\eb24"),i.noNewline=new i("no-newline","\\eb25"),i.note=new i("note","\\eb26"),i.octoface=new i("octoface","\\eb27"),i.openPreview=new i("open-preview","\\eb28"),i.package_=new i("package","\\eb29"),i.paintcan=new i("paintcan","\\eb2a"),i.pin=new i("pin","\\eb2b"),i.play=new i("play","\\eb2c"),i.run=new i("run","\\eb2c"),i.plug=new i("plug","\\eb2d"),i.preserveCase=new i("preserve-case","\\eb2e"),i.preview=new i("preview","\\eb2f"),i.project=new i("project","\\eb30"),i.pulse=new i("pulse","\\eb31"),i.question=new i("question","\\eb32"),i.quote=new i("quote","\\eb33"),i.radioTower=new i("radio-tower","\\eb34"),i.reactions=new i("reactions","\\eb35"),i.references=new i("references","\\eb36"),i.refresh=new i("refresh","\\eb37"),i.regex=new i("regex","\\eb38"),i.remoteExplorer=new i("remote-explorer","\\eb39"),i.remote=new i("remote","\\eb3a"),i.remove=new i("remove","\\eb3b"),i.replaceAll=new i("replace-all","\\eb3c"),i.replace=new i("replace","\\eb3d"),i.repoClone=new i("repo-clone","\\eb3e"),i.repoForcePush=new i("repo-force-push","\\eb3f"),i.repoPull=new i("repo-pull","\\eb40"),i.repoPush=new i("repo-push","\\eb41"),i.report=new i("report","\\eb42"),i.requestChanges=new i("request-changes","\\eb43"),i.rocket=new i("rocket","\\eb44"),i.rootFolderOpened=new i("root-folder-opened","\\eb45"),i.rootFolder=new i("root-folder","\\eb46"),i.rss=new i("rss","\\eb47"),i.ruby=new i("ruby","\\eb48"),i.saveAll=new i("save-all","\\eb49"),i.saveAs=new i("save-as","\\eb4a"),i.save=new i("save","\\eb4b"),i.screenFull=new i("screen-full","\\eb4c"),i.screenNormal=new i("screen-normal","\\eb4d"),i.searchStop=new i("search-stop","\\eb4e"),i.server=new i("server","\\eb50"),i.settingsGear=new i("settings-gear","\\eb51"),i.settings=new i("settings","\\eb52"),i.shield=new i("shield","\\eb53"),i.smiley=new i("smiley","\\eb54"),i.sortPrecedence=new i("sort-precedence","\\eb55"),i.splitHorizontal=new i("split-horizontal","\\eb56"),i.splitVertical=new i("split-vertical","\\eb57"),i.squirrel=new i("squirrel","\\eb58"),i.starFull=new i("star-full","\\eb59"),i.starHalf=new i("star-half","\\eb5a"),i.symbolClass=new i("symbol-class","\\eb5b"),i.symbolColor=new i("symbol-color","\\eb5c"),i.symbolCustomColor=new i("symbol-customcolor","\\eb5c"),i.symbolConstant=new i("symbol-constant","\\eb5d"),i.symbolEnumMember=new i("symbol-enum-member","\\eb5e"),i.symbolField=new i("symbol-field","\\eb5f"),i.symbolFile=new i("symbol-file","\\eb60"),i.symbolInterface=new i("symbol-interface","\\eb61"),i.symbolKeyword=new i("symbol-keyword","\\eb62"),i.symbolMisc=new i("symbol-misc","\\eb63"),i.symbolOperator=new i("symbol-operator","\\eb64"),i.symbolProperty=new i("symbol-property","\\eb65"),i.wrench=new i("wrench","\\eb65"),i.wrenchSubaction=new i("wrench-subaction","\\eb65"),i.symbolSnippet=new i("symbol-snippet","\\eb66"),i.tasklist=new i("tasklist","\\eb67"),i.telescope=new i("telescope","\\eb68"),i.textSize=new i("text-size","\\eb69"),i.threeBars=new i("three-bars","\\eb6a"),i.thumbsdown=new i("thumbsdown","\\eb6b"),i.thumbsup=new i("thumbsup","\\eb6c"),i.tools=new i("tools","\\eb6d"),i.triangleDown=new i("triangle-down","\\eb6e"),i.triangleLeft=new i("triangle-left","\\eb6f"),i.triangleRight=new i("triangle-right","\\eb70"),i.triangleUp=new i("triangle-up","\\eb71"),i.twitter=new i("twitter","\\eb72"),i.unfold=new i("unfold","\\eb73"),i.unlock=new i("unlock","\\eb74"),i.unmute=new i("unmute","\\eb75"),i.unverified=new i("unverified","\\eb76"),i.verified=new i("verified","\\eb77"),i.versions=new i("versions","\\eb78"),i.vmActive=new i("vm-active","\\eb79"),i.vmOutline=new i("vm-outline","\\eb7a"),i.vmRunning=new i("vm-running","\\eb7b"),i.watch=new i("watch","\\eb7c"),i.whitespace=new i("whitespace","\\eb7d"),i.wholeWord=new i("whole-word","\\eb7e"),i.window=new i("window","\\eb7f"),i.wordWrap=new i("word-wrap","\\eb80"),i.zoomIn=new i("zoom-in","\\eb81"),i.zoomOut=new i("zoom-out","\\eb82"),i.listFilter=new i("list-filter","\\eb83"),i.listFlat=new i("list-flat","\\eb84"),i.listSelection=new i("list-selection","\\eb85"),i.selection=new i("selection","\\eb85"),i.listTree=new i("list-tree","\\eb86"),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified","\\eb87"),i.debugBreakpointFunction=new i("debug-breakpoint-function","\\eb88"),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled","\\eb88"),i.debugStackframeActive=new i("debug-stackframe-active","\\eb89"),i.circleSmallFilled=new i("circle-small-filled","\\eb8a"),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.fontCharacter),i.debugStackframe=new i("debug-stackframe","\\eb8b"),i.debugStackframeFocused=new i("debug-stackframe-focused","\\eb8b"),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported","\\eb8c"),i.symbolString=new i("symbol-string","\\eb8d"),i.debugReverseContinue=new i("debug-reverse-continue","\\eb8e"),i.debugStepBack=new i("debug-step-back","\\eb8f"),i.debugRestartFrame=new i("debug-restart-frame","\\eb90"),i.callIncoming=new i("call-incoming","\\eb92"),i.callOutgoing=new i("call-outgoing","\\eb93"),i.menu=new i("menu","\\eb94"),i.expandAll=new i("expand-all","\\eb95"),i.feedback=new i("feedback","\\eb96"),i.groupByRefType=new i("group-by-ref-type","\\eb97"),i.ungroupByRefType=new i("ungroup-by-ref-type","\\eb98"),i.account=new i("account","\\eb99"),i.bellDot=new i("bell-dot","\\eb9a"),i.debugConsole=new i("debug-console","\\eb9b"),i.library=new i("library","\\eb9c"),i.output=new i("output","\\eb9d"),i.runAll=new i("run-all","\\eb9e"),i.syncIgnored=new i("sync-ignored","\\eb9f"),i.pinned=new i("pinned","\\eba0"),i.githubInverted=new i("github-inverted","\\eba1"),i.debugAlt=new i("debug-alt","\\eb91"),i.serverProcess=new i("server-process","\\eba2"),i.serverEnvironment=new i("server-environment","\\eba3"),i.pass=new i("pass","\\eba4"),i.stopCircle=new i("stop-circle","\\eba5"),i.playCircle=new i("play-circle","\\eba6"),i.record=new i("record","\\eba7"),i.debugAltSmall=new i("debug-alt-small","\\eba8"),i.vmConnect=new i("vm-connect","\\eba9"),i.cloud=new i("cloud","\\ebaa"),i.merge=new i("merge","\\ebab"),i.exportIcon=new i("export","\\ebac"),i.graphLeft=new i("graph-left","\\ebad"),i.magnet=new i("magnet","\\ebae"),i.notebook=new i("notebook","\\ebaf"),i.redo=new i("redo","\\ebb0"),i.checkAll=new i("check-all","\\ebb1"),i.pinnedDirty=new i("pinned-dirty","\\ebb2"),i.passFilled=new i("pass-filled","\\ebb3"),i.circleLargeFilled=new i("circle-large-filled","\\ebb4"),i.circleLarge=new i("circle-large","\\ebb5"),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.fontCharacter),i.combine=new i("combine","\\ebb6"),i.gather=new i("gather","\\ebb6"),i.table=new i("table","\\ebb7"),i.variableGroup=new i("variable-group","\\ebb8"),i.typeHierarchy=new i("type-hierarchy","\\ebb9"),i.typeHierarchySub=new i("type-hierarchy-sub","\\ebba"),i.typeHierarchySuper=new i("type-hierarchy-super","\\ebbb"),i.gitPullRequestCreate=new i("git-pull-request-create","\\ebbc"),i.runAbove=new i("run-above","\\ebbd"),i.runBelow=new i("run-below","\\ebbe"),i.notebookTemplate=new i("notebook-template","\\ebbf"),i.debugRerun=new i("debug-rerun","\\ebc0"),i.workspaceTrusted=new i("workspace-trusted","\\ebc1"),i.workspaceUntrusted=new i("workspace-untrusted","\\ebc2"),i.workspaceUnspecified=new i("workspace-unspecified","\\ebc3"),i.terminalCmd=new i("terminal-cmd","\\ebc4"),i.terminalDebian=new i("terminal-debian","\\ebc5"),i.terminalLinux=new i("terminal-linux","\\ebc6"),i.terminalPowershell=new i("terminal-powershell","\\ebc7"),i.terminalTmux=new i("terminal-tmux","\\ebc8"),i.terminalUbuntu=new i("terminal-ubuntu","\\ebc9"),i.terminalBash=new i("terminal-bash","\\ebca"),i.arrowSwap=new i("arrow-swap","\\ebcb"),i.copy=new i("copy","\\ebcc"),i.personAdd=new i("person-add","\\ebcd"),i.filterFilled=new i("filter-filled","\\ebce"),i.wand=new i("wand","\\ebcf"),i.debugLineByLine=new i("debug-line-by-line","\\ebd0"),i.inspect=new i("inspect","\\ebd1"),i.layers=new i("layers","\\ebd2"),i.layersDot=new i("layers-dot","\\ebd3"),i.layersActive=new i("layers-active","\\ebd4"),i.compass=new i("compass","\\ebd5"),i.compassDot=new i("compass-dot","\\ebd6"),i.compassActive=new i("compass-active","\\ebd7"),i.azure=new i("azure","\\ebd8"),i.issueDraft=new i("issue-draft","\\ebd9"),i.gitPullRequestClosed=new i("git-pull-request-closed","\\ebda"),i.gitPullRequestDraft=new i("git-pull-request-draft","\\ebdb"),i.debugAll=new i("debug-all","\\ebdc"),i.debugCoverage=new i("debug-coverage","\\ebdd"),i.runErrors=new i("run-errors","\\ebde"),i.folderLibrary=new i("folder-library","\\ebdf"),i.debugContinueSmall=new i("debug-continue-small","\\ebe0"),i.beakerStop=new i("beaker-stop","\\ebe1"),i.graphLine=new i("graph-line","\\ebe2"),i.graphScatter=new i("graph-scatter","\\ebe3"),i.pieChart=new i("pie-chart","\\ebe4"),i.bracket=new i("bracket",i.json.fontCharacter),i.bracketDot=new i("bracket-dot","\\ebe5"),i.bracketError=new i("bracket-error","\\ebe6"),i.lockSmall=new i("lock-small","\\ebe7"),i.azureDevops=new i("azure-devops","\\ebe8"),i.verifiedFilled=new i("verified-filled","\\ebe9"),i.newLine=new i("newline","\\ebea"),i.layout=new i("layout","\\ebeb"),i.layoutActivitybarLeft=new i("layout-activitybar-left","\\ebec"),i.layoutActivitybarRight=new i("layout-activitybar-right","\\ebed"),i.layoutPanelLeft=new i("layout-panel-left","\\ebee"),i.layoutPanelCenter=new i("layout-panel-center","\\ebef"),i.layoutPanelJustify=new i("layout-panel-justify","\\ebf0"),i.layoutPanelRight=new i("layout-panel-right","\\ebf1"),i.layoutPanel=new i("layout-panel","\\ebf2"),i.layoutSidebarLeft=new i("layout-sidebar-left","\\ebf3"),i.layoutSidebarRight=new i("layout-sidebar-right","\\ebf4"),i.layoutStatusbar=new i("layout-statusbar","\\ebf5"),i.layoutMenubar=new i("layout-menubar","\\ebf6"),i.layoutCentered=new i("layout-centered","\\ebf7"),i.layoutSidebarRightOff=new i("layout-sidebar-right-off","\\ec00"),i.layoutPanelOff=new i("layout-panel-off","\\ec01"),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off","\\ec02"),i.target=new i("target","\\ebf8"),i.indent=new i("indent","\\ebf9"),i.recordSmall=new i("record-small","\\ebfa"),i.errorSmall=new i("error-small","\\ebfb"),i.arrowCircleDown=new i("arrow-circle-down","\\ebfc"),i.arrowCircleLeft=new i("arrow-circle-left","\\ebfd"),i.arrowCircleRight=new i("arrow-circle-right","\\ebfe"),i.arrowCircleUp=new i("arrow-circle-up","\\ebff"),i.heartFilled=new i("heart-filled","\\ec04"),i.map=new i("map","\\ec05"),i.mapFilled=new i("map-filled","\\ec06"),i.circleSmall=new i("circle-small","\\ec07"),i.bellSlash=new i("bell-slash","\\ec08"),i.bellSlashDot=new i("bell-slash-dot","\\ec09"),i.commentUnresolved=new i("comment-unresolved","\\ec0a"),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes","\\ec0b"),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes","\\ec0c"),i.searchFuzzy=new i("search-fuzzy","\\ec0d"),i.commentDraft=new i("comment-draft","\\ec0e"),i.dialogError=new i("dialog-error",i.error.fontCharacter),i.dialogWarning=new i("dialog-warning",i.warning.fontCharacter),i.dialogInfo=new i("dialog-info",i.info.fontCharacter),i.dialogClose=new i("dialog-close",i.close.fontCharacter),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.fontCharacter),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.fontCharacter),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.fontCharacter),i.treeFilterClear=new i("tree-filter-clear",i.close.fontCharacter),i.treeItemLoading=new i("tree-item-loading",i.loading.fontCharacter),i.menuSelection=new i("menu-selection",i.check.fontCharacter),i.menuSubmenu=new i("menu-submenu",i.chevronRight.fontCharacter),i.menuBarMore=new i("menubar-more",i.more.fontCharacter),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.fontCharacter),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.fontCharacter),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.fontCharacter),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.fontCharacter),i.toolBarMore=new i("toolbar-more",i.more.fontCharacter),i.quickInputBack=new i("quick-input-back",i.arrowLeft.fontCharacter);var U;(function(z){z.iconNameSegment="[A-Za-z0-9]+",z.iconNameExpression="[A-Za-z0-9-]+",z.iconModifierExpression="~[A-Za-z]+",z.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${z.iconNameExpression})(${z.iconModifierExpression})?$`);function b(h){if(h instanceof i)return["codicon","codicon-"+h.id];const N=y.exec(h.id);if(!N)return b(i.error);const[,a,s]=N,e=["codicon","codicon-"+a];return s&&e.push("codicon-modifier-"+s.substring(1)),e}z.asClassNameArray=b;function f(h){return b(h).join(" ")}z.asClassName=f;function d(h){return"."+b(h).join(".")}z.asCSSSelector=d})(U=t.CSSIcon||(t.CSSIcon={}))}),define(ge[70],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function w(y,b){const f=Object.create(null);for(const d of y){const h=b(d);let N=f[h];N||(N=f[h]=[]),N.push(d)}return f}t.groupBy=w;function i(y,b){const f=[],d=[];for(const h of y)b.has(h)||f.push(h);for(const h of b)y.has(h)||d.push(h);return{removed:f,added:d}}t.diffSets=i;function U(y,b){const f=[],d=[];for(const[h,N]of y)b.has(h)||f.push(N);for(const[h,N]of b)y.has(h)||d.push(N);return{removed:f,added:d}}t.diffMaps=U;class z{constructor(){this.a=new Map}add(b,f){let d=this.a.get(b);d||(d=new Set,this.a.set(b,d)),d.add(f)}delete(b,f){const d=this.a.get(b);!d||(d.delete(f),d.size===0&&this.a.delete(b))}forEach(b,f){const d=this.a.get(b);!d||d.forEach(f)}}t.SetMap=z}),define(ge[41],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function w(b,f){const d=Math.pow(10,f);return Math.round(b*d)/d}class i{constructor(f,d,h,N=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,d))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=w(Math.max(Math.min(1,N),0),3)}static equals(f,d){return f.r===d.r&&f.g===d.g&&f.b===d.b&&f.a===d.a}}t.RGBA=i;class U{constructor(f,d,h,N){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=w(Math.max(Math.min(1,d),0),3),this.l=w(Math.max(Math.min(1,h),0),3),this.a=w(Math.max(Math.min(1,N),0),3)}static equals(f,d){return f.h===d.h&&f.s===d.s&&f.l===d.l&&f.a===d.a}static fromRGBA(f){const d=f.r/255,h=f.g/255,N=f.b/255,a=f.a,s=Math.max(d,h,N),e=Math.min(d,h,N);let r=0,o=0;const l=(e+s)/2,u=s-e;if(u>0){switch(o=Math.min(l<=.5?u/(2*l):u/(2-2*l),1),s){case d:r=(h-N)/u+(h<N?6:0);break;case h:r=(N-d)/u+2;break;case N:r=(d-h)/u+4;break}r*=60,r=Math.round(r)}return new U(r,o,l,a)}static i(f,d,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?f+(d-f)*6*h:h<1/2?d:h<2/3?f+(d-f)*(2/3-h)*6:f}static toRGBA(f){const d=f.h/360,{s:h,l:N,a}=f;let s,e,r;if(h===0)s=e=r=N;else{const o=N<.5?N*(1+h):N+h-N*h,l=2*N-o;s=U.i(l,o,d+1/3),e=U.i(l,o,d),r=U.i(l,o,d-1/3)}return new i(Math.round(s*255),Math.round(e*255),Math.round(r*255),a)}}t.HSLA=U;class z{constructor(f,d,h,N){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=w(Math.max(Math.min(1,d),0),3),this.v=w(Math.max(Math.min(1,h),0),3),this.a=w(Math.max(Math.min(1,N),0),3)}static equals(f,d){return f.h===d.h&&f.s===d.s&&f.v===d.v&&f.a===d.a}static fromRGBA(f){const d=f.r/255,h=f.g/255,N=f.b/255,a=Math.max(d,h,N),s=Math.min(d,h,N),e=a-s,r=a===0?0:e/a;let o;return e===0?o=0:a===d?o=((h-N)/e%6+6)%6:a===h?o=(N-d)/e+2:o=(d-h)/e+4,new z(Math.round(o*60),r,a,f.a)}static toRGBA(f){const{h:d,s:h,v:N,a}=f,s=N*h,e=s*(1-Math.abs(d/60%2-1)),r=N-s;let[o,l,u]=[0,0,0];return d<60?(o=s,l=e):d<120?(o=e,l=s):d<180?(l=s,u=e):d<240?(l=e,u=s):d<300?(o=e,u=s):d<=360&&(o=s,u=e),o=Math.round((o+r)*255),l=Math.round((l+r)*255),u=Math.round((u+r)*255),new i(o,l,u,a)}}t.HSVA=z;class y{static fromHex(f){return y.Format.CSS.parseHex(f)||y.red}static equals(f,d){return!f&&!d?!0:!f||!d?!1:f.equals(d)}get hsla(){return this.i?this.i:U.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:z.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof i)this.rgba=f;else if(f instanceof U)this.i=f,this.rgba=U.toRGBA(f);else if(f instanceof z)this.j=f,this.rgba=z.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&i.equals(this.rgba,f.rgba)&&U.equals(this.hsla,f.hsla)&&z.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=y.k(this.rgba.r),d=y.k(this.rgba.g),h=y.k(this.rgba.b),N=.2126*f+.7152*d+.0722*h;return w(N,4)}static k(f){const d=f/255;return d<=.03928?d/12.92:Math.pow((d+.055)/1.055,2.4)}getContrastRatio(f){const d=this.getRelativeLuminance(),h=f.getRelativeLuminance();return d>h?(d+.05)/(h+.05):(h+.05)/(d+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const d=this.getRelativeLuminance(),h=f.getRelativeLuminance();return d>h}isDarkerThan(f){const d=this.getRelativeLuminance(),h=f.getRelativeLuminance();return d<h}lighten(f){return new y(new U(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new y(new U(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:d,g:h,b:N,a}=this.rgba;return new y(new i(d,h,N,a*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new y(new i(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const d=f.rgba,h=this.rgba.a,N=d.a,a=h+N*(1-h);if(a<1e-6)return y.transparent;const s=this.rgba.r*h/a+d.r*N*(1-h)/a,e=this.rgba.g*h/a+d.g*N*(1-h)/a,r=this.rgba.b*h/a+d.b*N*(1-h)/a;return new y(new i(s,e,r,a))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:d,g:h,b:N,a}=this.rgba;return new y(new i(f.rgba.r-a*(f.rgba.r-d),f.rgba.g-a*(f.rgba.g-h),f.rgba.b-a*(f.rgba.b-N),1))}flatten(...f){const d=f.reduceRight((h,N)=>y.o(N,h));return y.o(this,d)}static o(f,d){const h=1-f.rgba.a;return new y(new i(h*d.rgba.r+f.rgba.a*f.rgba.r,h*d.rgba.g+f.rgba.a*f.rgba.g,h*d.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=y.Format.CSS.format(this)),this.u}static getLighterColor(f,d,h){if(f.isLighterThan(d))return f;h=h||.5;const N=f.getRelativeLuminance(),a=d.getRelativeLuminance();return h=h*(a-N)/a,f.lighten(h)}static getDarkerColor(f,d,h){if(f.isDarkerThan(d))return f;h=h||.5;const N=f.getRelativeLuminance(),a=d.getRelativeLuminance();return h=h*(N-a)/N,f.darken(h)}}t.Color=y,y.white=new y(new i(255,255,255,1)),y.black=new y(new i(0,0,0,1)),y.red=new y(new i(255,0,0,1)),y.blue=new y(new i(0,0,255,1)),y.green=new y(new i(0,255,0,1)),y.cyan=new y(new i(0,255,255,1)),y.lightgrey=new y(new i(211,211,211,1)),y.transparent=new y(new i(0,0,0,0)),function(b){let f;(function(d){let h;(function(N){function a(g){return g.rgba.a===1?`rgb(${g.rgba.r}, ${g.rgba.g}, ${g.rgba.b})`:b.Format.CSS.formatRGBA(g)}N.formatRGB=a;function s(g){return`rgba(${g.rgba.r}, ${g.rgba.g}, ${g.rgba.b}, ${+g.rgba.a.toFixed(2)})`}N.formatRGBA=s;function e(g){return g.hsla.a===1?`hsl(${g.hsla.h}, ${(g.hsla.s*100).toFixed(2)}%, ${(g.hsla.l*100).toFixed(2)}%)`:b.Format.CSS.formatHSLA(g)}N.formatHSL=e;function r(g){return`hsla(${g.hsla.h}, ${(g.hsla.s*100).toFixed(2)}%, ${(g.hsla.l*100).toFixed(2)}%, ${g.hsla.a.toFixed(2)})`}N.formatHSLA=r;function o(g){const A=g.toString(16);return A.length!==2?"0"+A:A}function l(g){return`#${o(g.rgba.r)}${o(g.rgba.g)}${o(g.rgba.b)}`}N.formatHex=l;function u(g,A=!1){return A&&g.rgba.a===1?b.Format.CSS.formatHex(g):`#${o(g.rgba.r)}${o(g.rgba.g)}${o(g.rgba.b)}${o(Math.round(g.rgba.a*255))}`}N.formatHexA=u;function D(g){return g.isOpaque()?b.Format.CSS.formatHex(g):b.Format.CSS.formatRGBA(g)}N.format=D;function S(g){const A=g.length;if(A===0||g.charCodeAt(0)!==35)return null;if(A===7){const L=16*k(g.charCodeAt(1))+k(g.charCodeAt(2)),F=16*k(g.charCodeAt(3))+k(g.charCodeAt(4)),c=16*k(g.charCodeAt(5))+k(g.charCodeAt(6));return new b(new i(L,F,c,1))}if(A===9){const L=16*k(g.charCodeAt(1))+k(g.charCodeAt(2)),F=16*k(g.charCodeAt(3))+k(g.charCodeAt(4)),c=16*k(g.charCodeAt(5))+k(g.charCodeAt(6)),p=16*k(g.charCodeAt(7))+k(g.charCodeAt(8));return new b(new i(L,F,c,p/255))}if(A===4){const L=k(g.charCodeAt(1)),F=k(g.charCodeAt(2)),c=k(g.charCodeAt(3));return new b(new i(16*L+L,16*F+F,16*c+c))}if(A===5){const L=k(g.charCodeAt(1)),F=k(g.charCodeAt(2)),c=k(g.charCodeAt(3)),p=k(g.charCodeAt(4));return new b(new i(16*L+L,16*F+F,16*c+c,(16*p+p)/255))}return null}N.parseHex=S;function k(g){switch(g){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(h=d.CSS||(d.CSS={}))})(f=b.Format||(b.Format={}))}(y=t.Color||(t.Color={}))}),define(ge[24],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=void 0;function w(y){return(b,f,d)=>{let h=null,N=null;if(typeof d.value=="function"?(h="value",N=d.value):typeof d.get=="function"&&(h="get",N=d.get),!N)throw new Error("not supported");d[h]=y(N,f)}}function i(y,b,f){let d=null,h=null;if(typeof f.value=="function"?(d="value",h=f.value,h.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(d="get",h=f.get),!h)throw new Error("not supported");const N=`$memoize$${b}`;f[d]=function(...a){return this.hasOwnProperty(N)||Object.defineProperty(this,N,{configurable:!1,enumerable:!1,writable:!1,value:h.apply(this,a)}),this[N]}}t.memoize=i;function U(y,b,f){return w((d,h)=>{const N=`$debounce$${h}`,a=`$debounce$result$${h}`;return function(...s){this[a]||(this[a]=f?f():void 0),clearTimeout(this[N]),b&&(this[a]=b(this[a],...s),s=[this[a]]),this[N]=setTimeout(()=>{d.apply(this,s),this[a]=f?f():void 0},y)}})}t.debounce=U;function z(y,b,f){return w((d,h)=>{const N=`$throttle$timer$${h}`,a=`$throttle$result$${h}`,s=`$throttle$lastRun$${h}`,e=`$throttle$pending$${h}`;return function(...r){if(this[a]||(this[a]=f?f():void 0),(this[s]===null||this[s]===void 0)&&(this[s]=-Number.MAX_VALUE),b&&(this[a]=b(this[a],...r)),this[e])return;const o=this[s]+y;o<=Date.now()?(this[s]=Date.now(),d.apply(this,[this[a]]),this[a]=f?f():void 0):(this[e]=!0,this[N]=setTimeout(()=>{this[e]=!1,this[s]=Date.now(),d.apply(this,[this[a]]),this[a]=f?f():void 0},o-Date.now()))}})}t.throttle=z}),define(ge[71],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class w{constructor(U,z,y,b){this.originalStart=U,this.originalLength=z,this.modifiedStart=y,this.modifiedLength=b}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=w}),define(ge[6],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class w{constructor(){this.b=[],this.a=function(g){setTimeout(()=>{throw g.stack?D.isErrorNoTelemetry(g)?new D(g.message+`

`+g.stack):new Error(g.message+`

`+g.stack):g},0)}}addListener(g){return this.b.push(g),()=>{this.d(g)}}c(g){this.b.forEach(A=>{A(g)})}d(g){this.b.splice(this.b.indexOf(g),1)}setUnexpectedErrorHandler(g){this.a=g}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(g){this.a(g),this.c(g)}onUnexpectedExternalError(g){this.a(g)}}t.ErrorHandler=w,t.errorHandler=new w;function i(k){t.errorHandler.setUnexpectedErrorHandler(k)}t.setUnexpectedErrorHandler=i;function U(k){f(k)||t.errorHandler.onUnexpectedError(k)}t.onUnexpectedError=U;function z(k){f(k)||t.errorHandler.onUnexpectedExternalError(k)}t.onUnexpectedExternalError=z;function y(k){if(k instanceof Error){const{name:g,message:A}=k,L=k.stacktrace||k.stack;return{$isError:!0,name:g,message:A,stack:L,noTelemetry:D.isErrorNoTelemetry(k)}}return k}t.transformErrorForSerialization=y;const b="Canceled";function f(k){return k instanceof d?!0:k instanceof Error&&k.name===b&&k.message===b}t.isCancellationError=f;class d extends Error{constructor(){super(b),this.name=this.message}}t.CancellationError=d;function h(){const k=new Error(b);return k.name=k.message,k}t.canceled=h;function N(k){return k?new Error(`Illegal argument: ${k}`):new Error("Illegal argument")}t.illegalArgument=N;function a(k){return k?new Error(`Illegal state: ${k}`):new Error("Illegal state")}t.illegalState=a;function s(k){return k?new Error(`readonly property '${k} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=s;function e(k){const g=new Error(`${k} has been disposed`);return g.name="DISPOSED",g}t.disposed=e;function r(k){return k?k.message?k.message:k.stack?k.stack.split(`
`)[0]:String(k):"Error"}t.getErrorMessage=r;class o extends Error{constructor(g){super("NotImplemented"),g&&(this.message=g)}}t.NotImplementedError=o;class l extends Error{constructor(g){super("NotSupported"),g&&(this.message=g)}}t.NotSupportedError=l;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=u;class D extends Error{constructor(g){super(g),this.name="CodeExpectedError"}static fromError(g){if(g instanceof D)return g;const A=new D;return A.message=g.message,A.stack=g.stack,A}static isErrorNoTelemetry(g){return g.name==="CodeExpectedError"}}t.ErrorNoTelemetry=D;class S extends Error{constructor(g){super(g||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype);debugger}}t.BugIndicatingError=S}),define(ge[14],me([1,0,6]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function i(C,I=0){return C[C.length-(1+I)]}t.tail=i;function U(C){if(C.length===0)throw new Error("Invalid tail call");return[C.slice(0,C.length-1),C[C.length-1]]}t.tail2=U;function z(C,I,R=(T,O)=>T===O){if(C===I)return!0;if(!C||!I||C.length!==I.length)return!1;for(let T=0,O=C.length;T<O;T++)if(!R(C[T],I[T]))return!1;return!0}t.equals=z;function y(C,I){const R=C.length-1;I<R&&(C[I]=C[R]),C.pop()}t.removeFastWithoutKeepingOrder=y;function b(C,I,R){return f(C.length,T=>R(C[T],I))}t.binarySearch=b;function f(C,I){let R=0,T=C-1;for(;R<=T;){const O=(R+T)/2|0,B=I(O);if(B<0)R=O+1;else if(B>0)T=O-1;else return O}return-(R+1)}t.binarySearch2=f;function d(C,I){let R=0,T=C.length;if(T===0)return 0;for(;R<T;){const O=Math.floor((R+T)/2);I(C[O])?T=O:R=O+1}return R}t.findFirstInSorted=d;function h(C,I,R){if(C=C|0,C>=I.length)throw new TypeError("invalid index");const T=I[Math.floor(I.length*Math.random())],O=[],B=[],H=[];for(const _ of I){const Q=R(_,T);Q<0?O.push(_):Q>0?B.push(_):H.push(_)}return C<O.length?h(C,O,R):C<O.length+H.length?H[0]:h(C-(O.length+H.length),B,R)}t.quickSelect=h;function N(C,I){const R=[];let T;for(const O of C.slice(0).sort(I))!T||I(T[0],O)!==0?(T=[O],R.push(T)):T.push(O);return R}t.groupBy=N;function a(C,I,R){const T=[];function O(_,Q,re){if(Q===0&&re.length===0)return;const ce=T[T.length-1];ce&&ce.start+ce.deleteCount===_?(ce.deleteCount+=Q,ce.toInsert.push(...re)):T.push({start:_,deleteCount:Q,toInsert:re})}let B=0,H=0;for(;;){if(B===C.length){O(B,0,I.slice(H));break}if(H===I.length){O(B,C.length-B,[]);break}const _=C[B],Q=I[H],re=R(_,Q);re===0?(B+=1,H+=1):re<0?(O(B,1,[]),B+=1):re>0&&(O(B,0,[Q]),H+=1)}return T}t.sortedDiff=a;function s(C,I,R){const T=a(C,I,R),O=[],B=[];for(const H of T)O.push(...C.slice(H.start,H.start+H.deleteCount)),B.push(...H.toInsert);return{removed:O,added:B}}t.delta=s;function e(C,I,R){if(R===0)return[];const T=C.slice(0,R).sort(I);return o(C,I,T,R,C.length),T}t.top=e;function r(C,I,R,T,O){return R===0?Promise.resolve([]):new Promise((B,H)=>{(async()=>{const _=C.length,Q=C.slice(0,R).sort(I);for(let re=R,ce=Math.min(R+T,_);re<_;re=ce,ce=Math.min(ce+T,_)){if(re>R&&await new Promise(ve=>setTimeout(ve)),O&&O.isCancellationRequested)throw new w.CancellationError;o(C,I,Q,re,ce)}return Q})().then(B,H)})}t.topAsync=r;function o(C,I,R,T,O){for(const B=R.length;T<O;T++){const H=C[T];if(I(H,R[B-1])<0){R.pop();const _=d(R,Q=>I(H,Q)<0);R.splice(_,0,H)}}}function l(C){return C.filter(I=>!!I)}t.coalesce=l;function u(C){let I=0;for(let R=0;R<C.length;R++)C[R]&&(C[I]=C[R],I+=1);C.length=I}t.coalesceInPlace=u;function D(C,I,R){C.splice(R,0,C.splice(I,1)[0])}t.move=D;function S(C){return!Array.isArray(C)||C.length===0}t.isFalsyOrEmpty=S;function k(C){return Array.isArray(C)&&C.length>0}t.isNonEmptyArray=k;function g(C,I=R=>R){const R=new Set;return C.filter(T=>{const O=I(T);return R.has(O)?!1:(R.add(O),!0)})}t.distinct=g;function A(C){const I=new Set;return R=>{const T=C(R);return I.has(T)?!1:(I.add(T),!0)}}t.uniqueFilter=A;function L(C,I){const R=F(C,I);if(R!==-1)return C[R]}t.findLast=L;function F(C,I){for(let R=C.length-1;R>=0;R--){const T=C[R];if(I(T))return R}return-1}t.lastIndex=F;function c(C,I){return C.length>0?C[0]:I}t.firstOrDefault=c;function p(C,I){return C.length>0?C[C.length-1]:I}t.lastOrDefault=p;function m(C,I,R=(T,O)=>T===O){let T=0;for(let O=0,B=Math.min(C.length,I.length);O<B&&R(C[O],I[O]);O++)T++;return T}t.commonPrefixLength=m;function v(C){return[].concat(...C)}t.flatten=v;function M(C,I){let R=typeof I=="number"?C:0;typeof I=="number"?R=C:(R=0,I=C);const T=[];if(R<=I)for(let O=R;O<I;O++)T.push(O);else for(let O=R;O>I;O--)T.push(O);return T}t.range=M;function V(C,I,R){return C.reduce((T,O)=>(T[I(O)]=R?R(O):O,T),Object.create(null))}t.index=V;function x(C,I){return C.push(I),()=>Z(C,I)}t.insert=x;function Z(C,I){const R=C.indexOf(I);if(R>-1)return C.splice(R,1),I}t.remove=Z;function ee(C,I,R){const T=C.slice(0,I),O=C.slice(I);return T.concat(R,O)}t.arrayInsert=ee;function se(C,I){let R;if(typeof I=="number"){let T=I;R=()=>{const O=Math.sin(T++)*179426549;return O-Math.floor(O)}}else R=Math.random;for(let T=C.length-1;T>0;T-=1){const O=Math.floor(R()*(T+1)),B=C[T];C[T]=C[O],C[O]=B}}t.shuffle=se;function he(C,I){const R=C.indexOf(I);R>-1&&(C.splice(R,1),C.unshift(I))}t.pushToStart=he;function ue(C,I){const R=C.indexOf(I);R>-1&&(C.splice(R,1),C.push(I))}t.pushToEnd=ue;function de(C,I){for(const R of I)C.push(R)}t.pushMany=de;function we(C,I){return Array.isArray(C)?C.map(I):I(C)}t.mapArrayOrNot=we;function Te(C){return Array.isArray(C)?C:[C]}t.asArray=Te;function Me(C){return C[Math.floor(Math.random()*C.length)]}t.getRandomElement=Me;function Oe(C,I){for(const R of C){const T=I(R);if(T!==void 0)return T}}t.mapFind=Oe;function j(C,I,R){const T=ie(C,I),O=C.length,B=R.length;C.length=O+B;for(let H=O-1;H>=T;H--)C[H+B]=C[H];for(let H=0;H<B;H++)C[H+T]=R[H]}t.insertInto=j;function Y(C,I,R,T){const O=ie(C,I),B=C.splice(O,R);return j(C,O,T),B}t.splice=Y;function ie(C,I){return I<0?Math.max(I+C.length,0):Math.min(I,C.length)}var ne;(function(C){function I(O){return O<0}C.isLessThan=I;function R(O){return O>0}C.isGreaterThan=R;function T(O){return O===0}C.isNeitherLessOrGreaterThan=T,C.greaterThan=1,C.lessThan=-1,C.neitherLessOrGreaterThan=0})(ne=t.CompareResult||(t.CompareResult={}));function ae(C,I){return(R,T)=>I(C(R),C(T))}t.compareBy=ae;function te(...C){return(I,R)=>{for(const T of C){const O=T(I,R);if(!ne.isNeitherLessOrGreaterThan(O))return O}return ne.neitherLessOrGreaterThan}}t.tieBreakComparators=te;const W=(C,I)=>C-I;t.numberComparator=W;function n(C,I){if(C.length===0)return;let R=C[0];for(let T=1;T<C.length;T++){const O=C[T];I(O,R)>0&&(R=O)}return R}t.findMaxBy=n;function E(C,I){if(C.length===0)return;let R=C[0];for(let T=1;T<C.length;T++){const O=C[T];I(O,R)>=0&&(R=O)}return R}t.findLastMaxBy=E;function P(C,I){return n(C,(R,T)=>-I(R,T))}t.findMinBy=P;class ${constructor(I){this.f=I,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(I){let R=this.c;for(;R<this.f.length&&I(this.f[R]);)R++;const T=R===this.c?null:this.f.slice(this.c,R);return this.c=R,T}takeFromEndWhile(I){let R=this.d;for(;R>=0&&I(this.f[R]);)R--;const T=R===this.d?null:this.f.slice(R+1,this.d+1);return this.d=R,T}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const I=this.f[this.c];return this.c++,I}removeLast(){const I=this.f[this.d];return this.d--,I}takeCount(I){const R=this.f.slice(this.c,this.c+I);return this.c+=I,R}}t.ArrayQueue=$;class K{constructor(I){this.iterate=I}forEach(I){this.iterate(R=>(I(R),!0))}toArray(){const I=[];return this.iterate(R=>(I.push(R),!0)),I}filter(I){return new K(R=>this.iterate(T=>I(T)?R(T):!0))}map(I){return new K(R=>this.iterate(T=>R(I(T))))}some(I){let R=!1;return this.iterate(T=>(R=I(T),!R)),R}findFirst(I){let R;return this.iterate(T=>I(T)?(R=T,!1):!0),R}findLast(I){let R;return this.iterate(T=>(I(T)&&(R=T),!0)),R}findLastMaxBy(I){let R,T=!0;return this.iterate(O=>((T||ne.isGreaterThan(I(O,R)))&&(T=!1,R=O),!0)),R}}t.CallbackIterable=K,K.empty=new K(C=>{})}),define(ge[72],me([1,0,6]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function i(f,d){if(!f)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}t.ok=i;function U(f,d="Unreachable"){throw new Error(d)}t.assertNever=U;function z(f){if(!f)throw new w.BugIndicatingError("Assertion Failed")}t.assert=z;function y(f){if(!f()){debugger;f(),(0,w.onUnexpectedError)(new w.BugIndicatingError("Assertion Failed"))}}t.assertFn=y;function b(f,d){let h=0;for(;h<f.length-1;){const N=f[h],a=f[h+1];if(!d(N,a))return!1;h++}return!0}t.checkAdjacentItems=b}),define(ge[42],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function w(i){const U=this;let z=!1,y;return function(){return z||(z=!0,y=i.apply(U,arguments)),y}}t.once=w}),define(ge[73],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class w{constructor(U){this.a=U,this.b=0}nextId(){return this.a+ ++this.b}}t.IdGenerator=w,t.defaultGenerator=new w("id#")}),define(ge[25],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var w;(function(i){function U(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}i.is=U;const z=Object.freeze([]);function y(){return z}i.empty=y;function*b(S){yield S}i.single=b;function f(S){return U(S)?S:b(S)}i.wrap=f;function d(S){return S||z}i.from=d;function h(S){return!S||S[Symbol.iterator]().next().done===!0}i.isEmpty=h;function N(S){return S[Symbol.iterator]().next().value}i.first=N;function a(S,k){for(const g of S)if(k(g))return!0;return!1}i.some=a;function s(S,k){for(const g of S)if(k(g))return g}i.find=s;function*e(S,k){for(const g of S)k(g)&&(yield g)}i.filter=e;function*r(S,k){let g=0;for(const A of S)yield k(A,g++)}i.map=r;function*o(...S){for(const k of S)for(const g of k)yield g}i.concat=o;function l(S,k,g){let A=g;for(const L of S)A=k(A,L);return A}i.reduce=l;function*u(S,k,g=S.length){for(k<0&&(k+=S.length),g<0?g+=S.length:g>S.length&&(g=S.length);k<g;k++)yield S[k]}i.slice=u;function D(S,k=Number.POSITIVE_INFINITY){const g=[];if(k===0)return[g,S];const A=S[Symbol.iterator]();for(let L=0;L<k;L++){const F=A.next();if(F.done)return[g,i.empty()];g.push(F.value)}return[g,{[Symbol.iterator](){return A}}]}i.consume=D})(w=t.Iterable||(t.Iterable={}))}),define(ge[43],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var w;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(w=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i=t.ScanCode||(t.ScanCode={}));class U{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(r,o){this._keyCodeToStr[r]=o,this._strToKeyCode[o.toLowerCase()]=r}keyCodeToStr(r){return this._keyCodeToStr[r]}strToKeyCode(r){return this._strToKeyCode[r.toLowerCase()]||0}}const z=new U,y=new U,b=new U;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const f=[],d=Object.create(null),h=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>h[e]||0,toEnum:e=>d[e]||0,toString:e=>f[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",r=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],o=[],l=[];for(const u of r){const[D,S,k,g,A,L,F,c,p,m]=u;if(l[k]||(l[k]=!0,f[k]=g,d[g]=k,h[g.toLowerCase()]=k,S&&(t.IMMUTABLE_CODE_TO_KEY_CODE[k]=A,A!==0&&A!==3&&A!==5&&A!==4&&A!==6&&A!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[A]=k))),!o[A]){if(o[A]=!0,!L)throw new Error(`String representation missing for key code ${A} around scan code ${g}`);z.define(A,L),y.define(A,p||L),b.define(A,m||p||L)}F&&(t.EVENT_KEY_CODE_MAP[F]=A),c&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[c]=A)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var N;(function(e){function r(k){return z.keyCodeToStr(k)}e.toString=r;function o(k){return z.strToKeyCode(k)}e.fromString=o;function l(k){return y.keyCodeToStr(k)}e.toUserSettingsUS=l;function u(k){return b.keyCodeToStr(k)}e.toUserSettingsGeneral=u;function D(k){return y.strToKeyCode(k)||b.strToKeyCode(k)}e.fromUserSettings=D;function S(k){if(k>=93&&k<=108)return null;switch(k){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return z.keyCodeToStr(k)}e.toElectronAccelerator=S})(N=t.KeyCodeUtils||(t.KeyCodeUtils={}));var a;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(a=t.KeyMod||(t.KeyMod={}));function s(e,r){const o=(r&65535)<<16>>>0;return(e|o)>>>0}t.KeyChord=s}),define(ge[74],me([1,0,6]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedChord=t.Keybinding=t.ScanCodeChord=t.KeyCodeChord=t.createSimpleKeybinding=t.decodeKeybinding=void 0;var i;(function(N){N[N.CtrlCmd=2048]="CtrlCmd",N[N.Shift=1024]="Shift",N[N.Alt=512]="Alt",N[N.WinCtrl=256]="WinCtrl",N[N.KeyCode=255]="KeyCode"})(i||(i={}));function U(N,a){if(N===0)return null;const s=(N&65535)>>>0,e=(N&4294901760)>>>16;return e!==0?new f([z(s,a),z(e,a)]):new f([z(s,a)])}t.decodeKeybinding=U;function z(N,a){const s=!!(N&2048),e=!!(N&256),r=a===2?e:s,o=!!(N&1024),l=!!(N&512),u=a===2?s:e,D=N&255;return new y(r,o,l,u,D)}t.createSimpleKeybinding=z;class y{constructor(a,s,e,r,o){this.ctrlKey=a,this.shiftKey=s,this.altKey=e,this.metaKey=r,this.keyCode=o}equals(a){return a instanceof y&&this.ctrlKey===a.ctrlKey&&this.shiftKey===a.shiftKey&&this.altKey===a.altKey&&this.metaKey===a.metaKey&&this.keyCode===a.keyCode}getHashCode(){const a=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",e=this.altKey?"1":"0",r=this.metaKey?"1":"0";return`${a}${s}${e}${r}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new f([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.KeyCodeChord=y;class b{constructor(a,s,e,r,o){this.ctrlKey=a,this.shiftKey=s,this.altKey=e,this.metaKey=r,this.scanCode=o}equals(a){return a instanceof b&&this.ctrlKey===a.ctrlKey&&this.shiftKey===a.shiftKey&&this.altKey===a.altKey&&this.metaKey===a.metaKey&&this.scanCode===a.scanCode}getHashCode(){const a=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",e=this.altKey?"1":"0",r=this.metaKey?"1":"0";return`${a}${s}${e}${r}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeChord=b;class f{constructor(a){if(a.length===0)throw(0,w.illegalArgument)("chords");this.chords=a}getHashCode(){let a="";for(let s=0,e=this.chords.length;s<e;s++)s!==0&&(a+=";"),a+=this.chords[s].getHashCode();return a}equals(a){if(a===null||this.chords.length!==a.chords.length)return!1;for(let s=0;s<this.chords.length;s++)if(!this.chords[s].equals(a.chords[s]))return!1;return!0}}t.Keybinding=f;class d{constructor(a,s,e,r,o,l){this.ctrlKey=a,this.shiftKey=s,this.altKey=e,this.metaKey=r,this.keyLabel=o,this.keyAriaLabel=l}}t.ResolvedChord=d;class h{}t.ResolvedKeybinding=h}),define(ge[44],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class w{constructor(U){this.d=U,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(U){this.c=U}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.Lazy=w}),define(ge[2],me([1,0,42,25]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const U=!1;let z=null;function y(p){z=p}if(t.setDisposableTracker=y,U){const p="__is_disposable_tracked__";y(new class{trackDisposable(m){const v=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[p]||console.log(v)},3e3)}setParent(m,v){if(m&&m!==u.None)try{m[p]=!0}catch{}}markAsDisposed(m){if(m&&m!==u.None)try{m[p]=!0}catch{}}markAsSingleton(m){}})}function b(p){return z?.trackDisposable(p),p}function f(p){z?.markAsDisposed(p)}function d(p,m){z?.setParent(p,m)}function h(p,m){if(!!z)for(const v of p)z.setParent(v,m)}function N(p){return z?.markAsSingleton(p),p}t.markAsSingleton=N;function a(p){return typeof p.dispose=="function"&&p.dispose.length===0}t.isDisposable=a;function s(p){if(i.Iterable.is(p)){const m=[];for(const v of p)if(v)try{v.dispose()}catch(M){m.push(M)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}t.dispose=s;function e(p){for(const m of p)a(m)&&m.dispose();return[]}t.disposeIfDisposable=e;function r(...p){const m=o(()=>s(p));return h(p,m),m}t.combinedDisposable=r;function o(p){const m=b({dispose:(0,w.once)(()=>{f(m),p()})});return m}t.toDisposable=o;class l{constructor(){this.c=new Set,this.f=!1,b(this)}dispose(){this.f||(f(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{s(this.c)}finally{this.c.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return d(m,this),this.f?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(m),m}}t.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this.q=new l,b(this),d(this.q,this)}dispose(){f(this),this.q.dispose()}B(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(m)}}t.Disposable=u,u.None=Object.freeze({dispose(){}});class D{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(m){this.b||m===this.a||(this.a?.dispose(),m&&d(m,this),this.a=m)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const m=this.a;return this.a=void 0,m&&d(m,null),m}}t.MutableDisposable=D;class S{constructor(m){this.b=m,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=S;class k{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(m){let v=m;return this.unset=()=>v=void 0,this.isset=()=>v!==void 0,this.dispose=()=>{v&&(v(),v=void 0,f(this))},this}}t.SafeDisposable=k;class g{constructor(){this.a=new Map}acquire(m,...v){let M=this.a.get(m);M||(M={counter:0,object:this.b(m,...v)},this.a.set(m,M));const{object:V}=M,x=(0,w.once)(()=>{--M.counter===0&&(this.c(m,M.object),this.a.delete(m))});return M.counter++,{object:V,dispose:x}}}t.ReferenceCollection=g;class A{constructor(m){this.a=m}async acquire(m,...v){const M=this.a.acquire(m,...v);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(V){throw M.dispose(),V}}}t.AsyncReferenceCollection=A;class L{constructor(m){this.object=m}dispose(){}}t.ImmortalReference=L;function F(p){const m=new l;try{p(m)}finally{m.dispose()}}t.disposeOnReturn=F;class c{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{s(this.a.values())}finally{this.a.clear()}}has(m){return this.a.has(m)}get(m){return this.a.get(m)}set(m,v,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(m)?.dispose(),this.a.set(m,v)}deleteAndDispose(m){this.a.get(m)?.dispose(),this.a.delete(m)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=c}),define(ge[45],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class w{constructor(z){this.element=z,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class i{constructor(){this.a=w.Undefined,this.b=w.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===w.Undefined}clear(){let z=this.a;for(;z!==w.Undefined;){const y=z.next;z.prev=w.Undefined,z.next=w.Undefined,z=y}this.a=w.Undefined,this.b=w.Undefined,this.c=0}unshift(z){return this.d(z,!1)}push(z){return this.d(z,!0)}d(z,y){const b=new w(z);if(this.a===w.Undefined)this.a=b,this.b=b;else if(y){const d=this.b;this.b=b,b.prev=d,d.next=b}else{const d=this.a;this.a=b,b.next=d,d.prev=b}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(b))}}shift(){if(this.a!==w.Undefined){const z=this.a.element;return this.e(this.a),z}}pop(){if(this.b!==w.Undefined){const z=this.b.element;return this.e(this.b),z}}e(z){if(z.prev!==w.Undefined&&z.next!==w.Undefined){const y=z.prev;y.next=z.next,z.next.prev=y}else z.prev===w.Undefined&&z.next===w.Undefined?(this.a=w.Undefined,this.b=w.Undefined):z.next===w.Undefined?(this.b=this.b.prev,this.b.next=w.Undefined):z.prev===w.Undefined&&(this.a=this.a.next,this.a.prev=w.Undefined);this.c-=1}*[Symbol.iterator](){let z=this.a;for(;z!==w.Undefined;)yield z.element,z=z.next}}t.LinkedList=i}),define(ge[75],me([1,0]),function(J,t){"use strict";var w,i,U;Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function z(e,r,o){let l=e.get(r);return l===void 0&&(l=o,e.set(r,l)),l}t.getOrSet=z;function y(e){const r=[];return e.forEach((o,l)=>{r.push(`${l} => ${o}`)}),`Map(${e.size}) {${r.join(", ")}}`}t.mapToString=y;function b(e){const r=[];return e.forEach(o=>{r.push(o)}),`Set(${e.size}) {${r.join(", ")}}`}t.setToString=b;class f{constructor(r,o){this.uri=r,this.value=o}}class d{constructor(r,o){this[w]="ResourceMap",r instanceof d?(this.b=new Map(r.b),this.c=o??d.a):(this.b=new Map,this.c=r??d.a)}set(r,o){return this.b.set(this.c(r),new f(r,o)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,o){typeof o<"u"&&(r=r.bind(o));for(const[l,u]of this.b)r(u.value,u.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}t.ResourceMap=d,d.a=e=>e.toString();class h{constructor(r,o){this[i]="ResourceSet",!r||typeof r=="function"?this.a=new d(r):(this.a=new d(o),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,o){this.a.forEach((l,u)=>r.call(o,u,u,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=h;var N;(function(e){e[e.None=0]="None",e[e.AsOld=1]="AsOld",e[e.AsNew=2]="AsNew"})(N=t.Touch||(t.Touch={}));class a{constructor(){this[U]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,o=0){const l=this.a.get(r);if(!!l)return o!==0&&this.j(l,o),l.value}set(r,o,l=0){let u=this.a.get(r);if(u)u.value=o,l!==0&&this.j(u,l);else{switch(u={key:r,value:o,next:void 0,previous:void 0},l){case 0:this.h(u);break;case 1:this.g(u);break;case 2:this.h(u);break;default:this.h(u);break}this.a.set(r,u),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const o=this.a.get(r);if(!!o)return this.a.delete(r),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,o){const l=this.e;let u=this.b;for(;u;){if(o?r.bind(o)(u.value,u.key,this):r(u.value,u.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,o=this.e;let l=this.b;const u={[Symbol.iterator](){return u},next(){if(r.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const D={value:l.key,done:!1};return l=l.next,D}else return{value:void 0,done:!0}}};return u}values(){const r=this,o=this.e;let l=this.b;const u={[Symbol.iterator](){return u},next(){if(r.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const D={value:l.value,done:!1};return l=l.next,D}else return{value:void 0,done:!0}}};return u}entries(){const r=this,o=this.e;let l=this.b;const u={[Symbol.iterator](){return u},next(){if(r.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const D={value:[l.key,l.value],done:!1};return l=l.next,D}else return{value:void 0,done:!0}}};return u}[(U=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let o=this.b,l=this.size;for(;o&&l>r;)this.a.delete(o.key),o=o.next,l--;this.b=o,this.d=l,o&&(o.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const o=r.next,l=r.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}r.next=void 0,r.previous=void 0,this.e++}j(r,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(r===this.b)return;const l=r.next,u=r.previous;r===this.c?(u.next=void 0,this.c=u):(l.previous=u,u.next=l),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(o===2){if(r===this.c)return;const l=r.next,u=r.previous;r===this.b?(l.previous=void 0,this.b=l):(l.previous=u,u.next=l),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((o,l)=>{r.push([l,o])}),r}fromJSON(r){this.clear();for(const[o,l]of r)this.set(o,l)}}t.LinkedMap=a;class s extends a{constructor(r,o=1){super(),this.k=r,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,o=2){return super.get(r,o)}peek(r){return super.get(r,0)}set(r,o){return super.set(r,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.LRUCache=s}),function(J,t){typeof exports=="object"&&typeof module<"u"?t(exports):typeof define=="function"&&define.amd?define(ge[76],me([0]),t):(J=typeof globalThis<"u"?globalThis:J||self,t(J.marked={}))}(this,function(J){"use strict";function t(C,I){for(var R=0;R<I.length;R++){var T=I[R];T.enumerable=T.enumerable||!1,T.configurable=!0,"value"in T&&(T.writable=!0),Object.defineProperty(C,T.key,T)}}function w(C,I,R){return I&&t(C.prototype,I),R&&t(C,R),Object.defineProperty(C,"prototype",{writable:!1}),C}function i(C,I){if(!!C){if(typeof C=="string")return U(C,I);var R=Object.prototype.toString.call(C).slice(8,-1);if(R==="Object"&&C.constructor&&(R=C.constructor.name),R==="Map"||R==="Set")return Array.from(C);if(R==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(R))return U(C,I)}}function U(C,I){(I==null||I>C.length)&&(I=C.length);for(var R=0,T=new Array(I);R<I;R++)T[R]=C[R];return T}function z(C,I){var R=typeof Symbol<"u"&&C[Symbol.iterator]||C["@@iterator"];if(R)return(R=R.call(C)).next.bind(R);if(Array.isArray(C)||(R=i(C))||I&&C&&typeof C.length=="number"){R&&(C=R);var T=0;return function(){return T>=C.length?{done:!0}:{done:!1,value:C[T++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=y();function b(C){J.defaults=C}var f=/[&<>"']/,d=/[&<>"']/g,h=/[<>"']|&(?!#?\w+;)/,N=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},s=function(I){return a[I]};function e(C,I){if(I){if(f.test(C))return C.replace(d,s)}else if(h.test(C))return C.replace(N,s);return C}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(C){return C.replace(r,function(I,R){return R=R.toLowerCase(),R==="colon"?":":R.charAt(0)==="#"?R.charAt(1)==="x"?String.fromCharCode(parseInt(R.substring(2),16)):String.fromCharCode(+R.substring(1)):""})}var l=/(^|[^\[])\^/g;function u(C,I){C=typeof C=="string"?C:C.source,I=I||"";var R={replace:function(O,B){return B=B.source||B,B=B.replace(l,"$1"),C=C.replace(O,B),R},getRegex:function(){return new RegExp(C,I)}};return R}var D=/[^\w:]/g,S=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function k(C,I,R){if(C){var T;try{T=decodeURIComponent(o(R)).replace(D,"").toLowerCase()}catch{return null}if(T.indexOf("javascript:")===0||T.indexOf("vbscript:")===0||T.indexOf("data:")===0)return null}I&&!S.test(R)&&(R=c(I,R));try{R=encodeURI(R).replace(/%25/g,"%")}catch{return null}return R}var g={},A=/^[^:]+:\/*[^/]*$/,L=/^([^:]+:)[\s\S]*$/,F=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(C,I){g[" "+C]||(A.test(C)?g[" "+C]=C+"/":g[" "+C]=M(C,"/",!0)),C=g[" "+C];var R=C.indexOf(":")===-1;return I.substring(0,2)==="//"?R?I:C.replace(L,"$1")+I:I.charAt(0)==="/"?R?I:C.replace(F,"$1")+I:C+I}var p={exec:function(){}};function m(C){for(var I=1,R,T;I<arguments.length;I++){R=arguments[I];for(T in R)Object.prototype.hasOwnProperty.call(R,T)&&(C[T]=R[T])}return C}function v(C,I){var R=C.replace(/\|/g,function(B,H,_){for(var Q=!1,re=H;--re>=0&&_[re]==="\\";)Q=!Q;return Q?"|":" |"}),T=R.split(/ \|/),O=0;if(T[0].trim()||T.shift(),T.length>0&&!T[T.length-1].trim()&&T.pop(),T.length>I)T.splice(I);else for(;T.length<I;)T.push("");for(;O<T.length;O++)T[O]=T[O].trim().replace(/\\\|/g,"|");return T}function M(C,I,R){var T=C.length;if(T===0)return"";for(var O=0;O<T;){var B=C.charAt(T-O-1);if(B===I&&!R)O++;else if(B!==I&&R)O++;else break}return C.slice(0,T-O)}function V(C,I){if(C.indexOf(I[1])===-1)return-1;for(var R=C.length,T=0,O=0;O<R;O++)if(C[O]==="\\")O++;else if(C[O]===I[0])T++;else if(C[O]===I[1]&&(T--,T<0))return O;return-1}function x(C){C&&C.sanitize&&!C.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function Z(C,I){if(I<1)return"";for(var R="";I>1;)I&1&&(R+=C),I>>=1,C+=C;return R+C}function ee(C,I,R,T){var O=I.href,B=I.title?e(I.title):null,H=C[1].replace(/\\([\[\]])/g,"$1");if(C[0].charAt(0)!=="!"){T.state.inLink=!0;var _={type:"link",raw:R,href:O,title:B,text:H,tokens:T.inlineTokens(H)};return T.state.inLink=!1,_}return{type:"image",raw:R,href:O,title:B,text:e(H)}}function se(C,I){var R=C.match(/^(\s+)(?:```)/);if(R===null)return I;var T=R[1];return I.split(`
`).map(function(O){var B=O.match(/^\s+/);if(B===null)return O;var H=B[0];return H.length>=T.length?O.slice(T.length):O}).join(`
`)}var he=function(){function C(R){this.options=R||J.defaults}var I=C.prototype;return I.space=function(T){var O=this.rules.block.newline.exec(T);if(O&&O[0].length>0)return{type:"space",raw:O[0]}},I.code=function(T){var O=this.rules.block.code.exec(T);if(O){var B=O[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:O[0],codeBlockStyle:"indented",text:this.options.pedantic?B:M(B,`
`)}}},I.fences=function(T){var O=this.rules.block.fences.exec(T);if(O){var B=O[0],H=se(B,O[3]||"");return{type:"code",raw:B,lang:O[2]?O[2].trim():O[2],text:H}}},I.heading=function(T){var O=this.rules.block.heading.exec(T);if(O){var B=O[2].trim();if(/#$/.test(B)){var H=M(B,"#");(this.options.pedantic||!H||/ $/.test(H))&&(B=H.trim())}return{type:"heading",raw:O[0],depth:O[1].length,text:B,tokens:this.lexer.inline(B)}}},I.hr=function(T){var O=this.rules.block.hr.exec(T);if(O)return{type:"hr",raw:O[0]}},I.blockquote=function(T){var O=this.rules.block.blockquote.exec(T);if(O){var B=O[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:O[0],tokens:this.lexer.blockTokens(B,[]),text:B}}},I.list=function(T){var O=this.rules.block.list.exec(T);if(O){var B,H,_,Q,re,ce,ve,De,Le,Ae,pe,Pe,Ie=O[1].trim(),_e=Ie.length>1,ze={type:"list",raw:"",ordered:_e,start:_e?+Ie.slice(0,-1):"",loose:!1,items:[]};Ie=_e?"\\d{1,9}\\"+Ie.slice(-1):"\\"+Ie,this.options.pedantic&&(Ie=_e?Ie:"[*+-]");for(var We=new RegExp("^( {0,3}"+Ie+")((?:[	 ][^\\n]*)?(?:\\n|$))");T&&(Pe=!1,!(!(O=We.exec(T))||this.rules.block.hr.test(T)));){if(B=O[0],T=T.substring(B.length),De=O[2].split(`
`,1)[0],Le=T.split(`
`,1)[0],this.options.pedantic?(Q=2,pe=De.trimLeft()):(Q=O[2].search(/[^ ]/),Q=Q>4?1:Q,pe=De.slice(Q),Q+=O[1].length),ce=!1,!De&&/^ *$/.test(Le)&&(B+=Le+`
`,T=T.substring(Le.length+1),Pe=!0),!Pe)for(var xe=new RegExp("^ {0,"+Math.min(3,Q-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,Q-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Be=new RegExp("^ {0,"+Math.min(3,Q-1)+"}(?:```|~~~)"),Ke=new RegExp("^ {0,"+Math.min(3,Q-1)+"}#");T&&(Ae=T.split(`
`,1)[0],De=Ae,this.options.pedantic&&(De=De.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Be.test(De)||Ke.test(De)||xe.test(De)||it.test(T)));){if(De.search(/[^ ]/)>=Q||!De.trim())pe+=`
`+De.slice(Q);else if(!ce)pe+=`
`+De;else break;!ce&&!De.trim()&&(ce=!0),B+=Ae+`
`,T=T.substring(Ae.length+1)}ze.loose||(ve?ze.loose=!0:/\n *\n *$/.test(B)&&(ve=!0)),this.options.gfm&&(H=/^\[[ xX]\] /.exec(pe),H&&(_=H[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:B,task:!!H,checked:_,loose:!1,text:pe}),ze.raw+=B}ze.items[ze.items.length-1].raw=B.trimRight(),ze.items[ze.items.length-1].text=pe.trimRight(),ze.raw=ze.raw.trimRight();var Ye=ze.items.length;for(re=0;re<Ye;re++){this.lexer.state.top=!1,ze.items[re].tokens=this.lexer.blockTokens(ze.items[re].text,[]);var q=ze.items[re].tokens.filter(function(be){return be.type==="space"}),le=q.every(function(be){for(var ye=be.raw.split(""),Ce=0,Re=z(ye),je;!(je=Re()).done;){var tt=je.value;if(tt===`
`&&(Ce+=1),Ce>1)return!0}return!1});!ze.loose&&q.length&&le&&(ze.loose=!0,ze.items[re].loose=!0)}return ze}},I.html=function(T){var O=this.rules.block.html.exec(T);if(O){var B={type:"html",raw:O[0],pre:!this.options.sanitizer&&(O[1]==="pre"||O[1]==="script"||O[1]==="style"),text:O[0]};if(this.options.sanitize){var H=this.options.sanitizer?this.options.sanitizer(O[0]):e(O[0]);B.type="paragraph",B.text=H,B.tokens=this.lexer.inline(H)}return B}},I.def=function(T){var O=this.rules.block.def.exec(T);if(O){O[3]&&(O[3]=O[3].substring(1,O[3].length-1));var B=O[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:B,raw:O[0],href:O[2],title:O[3]}}},I.table=function(T){var O=this.rules.block.table.exec(T);if(O){var B={type:"table",header:v(O[1]).map(function(ve){return{text:ve}}),align:O[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:O[3]&&O[3].trim()?O[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(B.header.length===B.align.length){B.raw=O[0];var H=B.align.length,_,Q,re,ce;for(_=0;_<H;_++)/^ *-+: *$/.test(B.align[_])?B.align[_]="right":/^ *:-+: *$/.test(B.align[_])?B.align[_]="center":/^ *:-+ *$/.test(B.align[_])?B.align[_]="left":B.align[_]=null;for(H=B.rows.length,_=0;_<H;_++)B.rows[_]=v(B.rows[_],B.header.length).map(function(ve){return{text:ve}});for(H=B.header.length,Q=0;Q<H;Q++)B.header[Q].tokens=this.lexer.inline(B.header[Q].text);for(H=B.rows.length,Q=0;Q<H;Q++)for(ce=B.rows[Q],re=0;re<ce.length;re++)ce[re].tokens=this.lexer.inline(ce[re].text);return B}}},I.lheading=function(T){var O=this.rules.block.lheading.exec(T);if(O)return{type:"heading",raw:O[0],depth:O[2].charAt(0)==="="?1:2,text:O[1],tokens:this.lexer.inline(O[1])}},I.paragraph=function(T){var O=this.rules.block.paragraph.exec(T);if(O){var B=O[1].charAt(O[1].length-1)===`
`?O[1].slice(0,-1):O[1];return{type:"paragraph",raw:O[0],text:B,tokens:this.lexer.inline(B)}}},I.text=function(T){var O=this.rules.block.text.exec(T);if(O)return{type:"text",raw:O[0],text:O[0],tokens:this.lexer.inline(O[0])}},I.escape=function(T){var O=this.rules.inline.escape.exec(T);if(O)return{type:"escape",raw:O[0],text:e(O[1])}},I.tag=function(T){var O=this.rules.inline.tag.exec(T);if(O)return!this.lexer.state.inLink&&/^<a /i.test(O[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(O[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(O[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(O[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:O[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(O[0]):e(O[0]):O[0]}},I.link=function(T){var O=this.rules.inline.link.exec(T);if(O){var B=O[2].trim();if(!this.options.pedantic&&/^</.test(B)){if(!/>$/.test(B))return;var H=M(B.slice(0,-1),"\\");if((B.length-H.length)%2===0)return}else{var _=V(O[2],"()");if(_>-1){var Q=O[0].indexOf("!")===0?5:4,re=Q+O[1].length+_;O[2]=O[2].substring(0,_),O[0]=O[0].substring(0,re).trim(),O[3]=""}}var ce=O[2],ve="";if(this.options.pedantic){var De=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ce);De&&(ce=De[1],ve=De[3])}else ve=O[3]?O[3].slice(1,-1):"";return ce=ce.trim(),/^</.test(ce)&&(this.options.pedantic&&!/>$/.test(B)?ce=ce.slice(1):ce=ce.slice(1,-1)),ee(O,{href:ce&&ce.replace(this.rules.inline._escapes,"$1"),title:ve&&ve.replace(this.rules.inline._escapes,"$1")},O[0],this.lexer)}},I.reflink=function(T,O){var B;if((B=this.rules.inline.reflink.exec(T))||(B=this.rules.inline.nolink.exec(T))){var H=(B[2]||B[1]).replace(/\s+/g," ");if(H=O[H.toLowerCase()],!H||!H.href){var _=B[0].charAt(0);return{type:"text",raw:_,text:_}}return ee(B,H,B[0],this.lexer)}},I.emStrong=function(T,O,B){B===void 0&&(B="");var H=this.rules.inline.emStrong.lDelim.exec(T);if(!!H&&!(H[3]&&B.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var _=H[1]||H[2]||"";if(!_||_&&(B===""||this.rules.inline.punctuation.exec(B))){var Q=H[0].length-1,re,ce,ve=Q,De=0,Le=H[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Le.lastIndex=0,O=O.slice(-1*T.length+Q);(H=Le.exec(O))!=null;)if(re=H[1]||H[2]||H[3]||H[4]||H[5]||H[6],!!re){if(ce=re.length,H[3]||H[4]){ve+=ce;continue}else if((H[5]||H[6])&&Q%3&&!((Q+ce)%3)){De+=ce;continue}if(ve-=ce,!(ve>0)){if(ce=Math.min(ce,ce+ve+De),Math.min(Q,ce)%2){var Ae=T.slice(1,Q+H.index+ce);return{type:"em",raw:T.slice(0,Q+H.index+ce+1),text:Ae,tokens:this.lexer.inlineTokens(Ae)}}var pe=T.slice(2,Q+H.index+ce-1);return{type:"strong",raw:T.slice(0,Q+H.index+ce+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}}}}},I.codespan=function(T){var O=this.rules.inline.code.exec(T);if(O){var B=O[2].replace(/\n/g," "),H=/[^ ]/.test(B),_=/^ /.test(B)&&/ $/.test(B);return H&&_&&(B=B.substring(1,B.length-1)),B=e(B,!0),{type:"codespan",raw:O[0],text:B}}},I.br=function(T){var O=this.rules.inline.br.exec(T);if(O)return{type:"br",raw:O[0]}},I.del=function(T){var O=this.rules.inline.del.exec(T);if(O)return{type:"del",raw:O[0],text:O[2],tokens:this.lexer.inlineTokens(O[2])}},I.autolink=function(T,O){var B=this.rules.inline.autolink.exec(T);if(B){var H,_;return B[2]==="@"?(H=e(this.options.mangle?O(B[1]):B[1]),_="mailto:"+H):(H=e(B[1]),_=H),{type:"link",raw:B[0],text:H,href:_,tokens:[{type:"text",raw:H,text:H}]}}},I.url=function(T,O){var B;if(B=this.rules.inline.url.exec(T)){var H,_;if(B[2]==="@")H=e(this.options.mangle?O(B[0]):B[0]),_="mailto:"+H;else{var Q;do Q=B[0],B[0]=this.rules.inline._backpedal.exec(B[0])[0];while(Q!==B[0]);H=e(B[0]),B[1]==="www."?_="http://"+H:_=H}return{type:"link",raw:B[0],text:H,href:_,tokens:[{type:"text",raw:H,text:H}]}}},I.inlineText=function(T,O){var B=this.rules.inline.text.exec(T);if(B){var H;return this.lexer.state.inRawBlock?H=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(B[0]):e(B[0]):B[0]:H=e(this.options.smartypants?O(B[0]):B[0]),{type:"text",raw:B[0],text:H}}},C}(),ue={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ue._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ue._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ue.def=u(ue.def).replace("label",ue._label).replace("title",ue._title).getRegex(),ue.bullet=/(?:[*+-]|\d{1,9}[.)])/,ue.listItemStart=u(/^( *)(bull) */).replace("bull",ue.bullet).getRegex(),ue.list=u(ue.list).replace(/bull/g,ue.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ue.def.source+")").getRegex(),ue._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ue._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ue.html=u(ue.html,"i").replace("comment",ue._comment).replace("tag",ue._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ue.paragraph=u(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.blockquote=u(ue.blockquote).replace("paragraph",ue.paragraph).getRegex(),ue.normal=m({},ue),ue.gfm=m({},ue.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ue.gfm.table=u(ue.gfm.table).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.gfm.paragraph=u(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ue.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.pedantic=m({},ue.normal,{html:u(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ue._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:u(ue.normal._paragraph).replace("hr",ue.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ue.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var de={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};de._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",de.punctuation=u(de.punctuation).replace(/punctuation/g,de._punctuation).getRegex(),de.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,de.escapedEmSt=/\\\*|\\_/g,de._comment=u(ue._comment).replace("(?:-->|$)","-->").getRegex(),de.emStrong.lDelim=u(de.emStrong.lDelim).replace(/punct/g,de._punctuation).getRegex(),de.emStrong.rDelimAst=u(de.emStrong.rDelimAst,"g").replace(/punct/g,de._punctuation).getRegex(),de.emStrong.rDelimUnd=u(de.emStrong.rDelimUnd,"g").replace(/punct/g,de._punctuation).getRegex(),de._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,de._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,de._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,de.autolink=u(de.autolink).replace("scheme",de._scheme).replace("email",de._email).getRegex(),de._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,de.tag=u(de.tag).replace("comment",de._comment).replace("attribute",de._attribute).getRegex(),de._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,de._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,de._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,de.link=u(de.link).replace("label",de._label).replace("href",de._href).replace("title",de._title).getRegex(),de.reflink=u(de.reflink).replace("label",de._label).replace("ref",ue._label).getRegex(),de.nolink=u(de.nolink).replace("ref",ue._label).getRegex(),de.reflinkSearch=u(de.reflinkSearch,"g").replace("reflink",de.reflink).replace("nolink",de.nolink).getRegex(),de.normal=m({},de),de.pedantic=m({},de.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:u(/^!?\[(label)\]\((.*?)\)/).replace("label",de._label).getRegex(),reflink:u(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",de._label).getRegex()}),de.gfm=m({},de.normal,{escape:u(de.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),de.gfm.url=u(de.gfm.url,"i").replace("email",de.gfm._extended_email).getRegex(),de.breaks=m({},de.gfm,{br:u(de.br).replace("{2,}","*").getRegex(),text:u(de.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function we(C){return C.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Te(C){var I="",R,T,O=C.length;for(R=0;R<O;R++)T=C.charCodeAt(R),Math.random()>.5&&(T="x"+T.toString(16)),I+="&#"+T+";";return I}var Me=function(){function C(R){this.tokens=[],this.tokens.links=Object.create(null),this.options=R||J.defaults,this.options.tokenizer=this.options.tokenizer||new he,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var T={block:ue.normal,inline:de.normal};this.options.pedantic?(T.block=ue.pedantic,T.inline=de.pedantic):this.options.gfm&&(T.block=ue.gfm,this.options.breaks?T.inline=de.breaks:T.inline=de.gfm),this.tokenizer.rules=T}C.lex=function(T,O){var B=new C(O);return B.lex(T)},C.lexInline=function(T,O){var B=new C(O);return B.inlineTokens(T)};var I=C.prototype;return I.lex=function(T){T=T.replace(/\r\n|\r/g,`
`),this.blockTokens(T,this.tokens);for(var O;O=this.inlineQueue.shift();)this.inlineTokens(O.src,O.tokens);return this.tokens},I.blockTokens=function(T,O){var B=this;O===void 0&&(O=[]),this.options.pedantic?T=T.replace(/\t/g,"    ").replace(/^ +$/gm,""):T=T.replace(/^( *)(\t+)/gm,function(ve,De,Le){return De+"    ".repeat(Le.length)});for(var H,_,Q,re;T;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ve){return(H=ve.call({lexer:B},T,O))?(T=T.substring(H.raw.length),O.push(H),!0):!1}))){if(H=this.tokenizer.space(T)){T=T.substring(H.raw.length),H.raw.length===1&&O.length>0?O[O.length-1].raw+=`
`:O.push(H);continue}if(H=this.tokenizer.code(T)){T=T.substring(H.raw.length),_=O[O.length-1],_&&(_.type==="paragraph"||_.type==="text")?(_.raw+=`
`+H.raw,_.text+=`
`+H.text,this.inlineQueue[this.inlineQueue.length-1].src=_.text):O.push(H);continue}if(H=this.tokenizer.fences(T)){T=T.substring(H.raw.length),O.push(H);continue}if(H=this.tokenizer.heading(T)){T=T.substring(H.raw.length),O.push(H);continue}if(H=this.tokenizer.hr(T)){T=T.substring(H.raw.length),O.push(H);continue}if(H=this.tokenizer.blockquote(T)){T=T.substring(H.raw.length),O.push(H);continue}if(H=this.tokenizer.list(T)){T=T.substring(H.raw.length),O.push(H);continue}if(H=this.tokenizer.html(T)){T=T.substring(H.raw.length),O.push(H);continue}if(H=this.tokenizer.def(T)){T=T.substring(H.raw.length),_=O[O.length-1],_&&(_.type==="paragraph"||_.type==="text")?(_.raw+=`
`+H.raw,_.text+=`
`+H.raw,this.inlineQueue[this.inlineQueue.length-1].src=_.text):this.tokens.links[H.tag]||(this.tokens.links[H.tag]={href:H.href,title:H.title});continue}if(H=this.tokenizer.table(T)){T=T.substring(H.raw.length),O.push(H);continue}if(H=this.tokenizer.lheading(T)){T=T.substring(H.raw.length),O.push(H);continue}if(Q=T,this.options.extensions&&this.options.extensions.startBlock&&function(){var ve=1/0,De=T.slice(1),Le=void 0;B.options.extensions.startBlock.forEach(function(Ae){Le=Ae.call({lexer:this},De),typeof Le=="number"&&Le>=0&&(ve=Math.min(ve,Le))}),ve<1/0&&ve>=0&&(Q=T.substring(0,ve+1))}(),this.state.top&&(H=this.tokenizer.paragraph(Q))){_=O[O.length-1],re&&_.type==="paragraph"?(_.raw+=`
`+H.raw,_.text+=`
`+H.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=_.text):O.push(H),re=Q.length!==T.length,T=T.substring(H.raw.length);continue}if(H=this.tokenizer.text(T)){T=T.substring(H.raw.length),_=O[O.length-1],_&&_.type==="text"?(_.raw+=`
`+H.raw,_.text+=`
`+H.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=_.text):O.push(H);continue}if(T){var ce="Infinite loop on byte: "+T.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return this.state.top=!0,O},I.inline=function(T,O){return O===void 0&&(O=[]),this.inlineQueue.push({src:T,tokens:O}),O},I.inlineTokens=function(T,O){var B=this;O===void 0&&(O=[]);var H,_,Q,re=T,ce,ve,De;if(this.tokens.links){var Le=Object.keys(this.tokens.links);if(Le.length>0)for(;(ce=this.tokenizer.rules.inline.reflinkSearch.exec(re))!=null;)Le.includes(ce[0].slice(ce[0].lastIndexOf("[")+1,-1))&&(re=re.slice(0,ce.index)+"["+Z("a",ce[0].length-2)+"]"+re.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ce=this.tokenizer.rules.inline.blockSkip.exec(re))!=null;)re=re.slice(0,ce.index)+"["+Z("a",ce[0].length-2)+"]"+re.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ce=this.tokenizer.rules.inline.escapedEmSt.exec(re))!=null;)re=re.slice(0,ce.index)+"++"+re.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;T;)if(ve||(De=""),ve=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(pe){return(H=pe.call({lexer:B},T,O))?(T=T.substring(H.raw.length),O.push(H),!0):!1}))){if(H=this.tokenizer.escape(T)){T=T.substring(H.raw.length),O.push(H);continue}if(H=this.tokenizer.tag(T)){T=T.substring(H.raw.length),_=O[O.length-1],_&&H.type==="text"&&_.type==="text"?(_.raw+=H.raw,_.text+=H.text):O.push(H);continue}if(H=this.tokenizer.link(T)){T=T.substring(H.raw.length),O.push(H);continue}if(H=this.tokenizer.reflink(T,this.tokens.links)){T=T.substring(H.raw.length),_=O[O.length-1],_&&H.type==="text"&&_.type==="text"?(_.raw+=H.raw,_.text+=H.text):O.push(H);continue}if(H=this.tokenizer.emStrong(T,re,De)){T=T.substring(H.raw.length),O.push(H);continue}if(H=this.tokenizer.codespan(T)){T=T.substring(H.raw.length),O.push(H);continue}if(H=this.tokenizer.br(T)){T=T.substring(H.raw.length),O.push(H);continue}if(H=this.tokenizer.del(T)){T=T.substring(H.raw.length),O.push(H);continue}if(H=this.tokenizer.autolink(T,Te)){T=T.substring(H.raw.length),O.push(H);continue}if(!this.state.inLink&&(H=this.tokenizer.url(T,Te))){T=T.substring(H.raw.length),O.push(H);continue}if(Q=T,this.options.extensions&&this.options.extensions.startInline&&function(){var pe=1/0,Pe=T.slice(1),Ie=void 0;B.options.extensions.startInline.forEach(function(_e){Ie=_e.call({lexer:this},Pe),typeof Ie=="number"&&Ie>=0&&(pe=Math.min(pe,Ie))}),pe<1/0&&pe>=0&&(Q=T.substring(0,pe+1))}(),H=this.tokenizer.inlineText(Q,we)){T=T.substring(H.raw.length),H.raw.slice(-1)!=="_"&&(De=H.raw.slice(-1)),ve=!0,_=O[O.length-1],_&&_.type==="text"?(_.raw+=H.raw,_.text+=H.text):O.push(H);continue}if(T){var Ae="Infinite loop on byte: "+T.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return O},w(C,null,[{key:"rules",get:function(){return{block:ue,inline:de}}}]),C}(),Oe=function(){function C(R){this.options=R||J.defaults}var I=C.prototype;return I.code=function(T,O,B){var H=(O||"").match(/\S*/)[0];if(this.options.highlight){var _=this.options.highlight(T,H);_!=null&&_!==T&&(B=!0,T=_)}return T=T.replace(/\n$/,"")+`
`,H?'<pre><code class="'+this.options.langPrefix+e(H,!0)+'">'+(B?T:e(T,!0))+`</code></pre>
`:"<pre><code>"+(B?T:e(T,!0))+`</code></pre>
`},I.blockquote=function(T){return`<blockquote>
`+T+`</blockquote>
`},I.html=function(T){return T},I.heading=function(T,O,B,H){if(this.options.headerIds){var _=this.options.headerPrefix+H.slug(B);return"<h"+O+' id="'+_+'">'+T+"</h"+O+`>
`}return"<h"+O+">"+T+"</h"+O+`>
`},I.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},I.list=function(T,O,B){var H=O?"ol":"ul",_=O&&B!==1?' start="'+B+'"':"";return"<"+H+_+`>
`+T+"</"+H+`>
`},I.listitem=function(T){return"<li>"+T+`</li>
`},I.checkbox=function(T){return"<input "+(T?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},I.paragraph=function(T){return"<p>"+T+`</p>
`},I.table=function(T,O){return O&&(O="<tbody>"+O+"</tbody>"),`<table>
<thead>
`+T+`</thead>
`+O+`</table>
`},I.tablerow=function(T){return`<tr>
`+T+`</tr>
`},I.tablecell=function(T,O){var B=O.header?"th":"td",H=O.align?"<"+B+' align="'+O.align+'">':"<"+B+">";return H+T+("</"+B+`>
`)},I.strong=function(T){return"<strong>"+T+"</strong>"},I.em=function(T){return"<em>"+T+"</em>"},I.codespan=function(T){return"<code>"+T+"</code>"},I.br=function(){return this.options.xhtml?"<br/>":"<br>"},I.del=function(T){return"<del>"+T+"</del>"},I.link=function(T,O,B){if(T=k(this.options.sanitize,this.options.baseUrl,T),T===null)return B;var H='<a href="'+e(T)+'"';return O&&(H+=' title="'+O+'"'),H+=">"+B+"</a>",H},I.image=function(T,O,B){if(T=k(this.options.sanitize,this.options.baseUrl,T),T===null)return B;var H='<img src="'+T+'" alt="'+B+'"';return O&&(H+=' title="'+O+'"'),H+=this.options.xhtml?"/>":">",H},I.text=function(T){return T},C}(),j=function(){function C(){}var I=C.prototype;return I.strong=function(T){return T},I.em=function(T){return T},I.codespan=function(T){return T},I.del=function(T){return T},I.html=function(T){return T},I.text=function(T){return T},I.link=function(T,O,B){return""+B},I.image=function(T,O,B){return""+B},I.br=function(){return""},C}(),Y=function(){function C(){this.seen={}}var I=C.prototype;return I.serialize=function(T){return T.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},I.getNextSafeSlug=function(T,O){var B=T,H=0;if(this.seen.hasOwnProperty(B)){H=this.seen[T];do H++,B=T+"-"+H;while(this.seen.hasOwnProperty(B))}return O||(this.seen[T]=H,this.seen[B]=0),B},I.slug=function(T,O){O===void 0&&(O={});var B=this.serialize(T);return this.getNextSafeSlug(B,O.dryrun)},C}(),ie=function(){function C(R){this.options=R||J.defaults,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new j,this.slugger=new Y}C.parse=function(T,O){var B=new C(O);return B.parse(T)},C.parseInline=function(T,O){var B=new C(O);return B.parseInline(T)};var I=C.prototype;return I.parse=function(T,O){O===void 0&&(O=!0);var B="",H,_,Q,re,ce,ve,De,Le,Ae,pe,Pe,Ie,_e,ze,We,xe,it,Be,Ke,Ye=T.length;for(H=0;H<Ye;H++){if(pe=T[H],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(Ke=this.options.extensions.renderers[pe.type].call({parser:this},pe),Ke!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(pe.type))){B+=Ke||"";continue}switch(pe.type){case"space":continue;case"hr":{B+=this.renderer.hr();continue}case"heading":{B+=this.renderer.heading(this.parseInline(pe.tokens),pe.depth,o(this.parseInline(pe.tokens,this.textRenderer)),this.slugger);continue}case"code":{B+=this.renderer.code(pe.text,pe.lang,pe.escaped);continue}case"table":{for(Le="",De="",re=pe.header.length,_=0;_<re;_++)De+=this.renderer.tablecell(this.parseInline(pe.header[_].tokens),{header:!0,align:pe.align[_]});for(Le+=this.renderer.tablerow(De),Ae="",re=pe.rows.length,_=0;_<re;_++){for(ve=pe.rows[_],De="",ce=ve.length,Q=0;Q<ce;Q++)De+=this.renderer.tablecell(this.parseInline(ve[Q].tokens),{header:!1,align:pe.align[Q]});Ae+=this.renderer.tablerow(De)}B+=this.renderer.table(Le,Ae);continue}case"blockquote":{Ae=this.parse(pe.tokens),B+=this.renderer.blockquote(Ae);continue}case"list":{for(Pe=pe.ordered,Ie=pe.start,_e=pe.loose,re=pe.items.length,Ae="",_=0;_<re;_++)We=pe.items[_],xe=We.checked,it=We.task,ze="",We.task&&(Be=this.renderer.checkbox(xe),_e?We.tokens.length>0&&We.tokens[0].type==="paragraph"?(We.tokens[0].text=Be+" "+We.tokens[0].text,We.tokens[0].tokens&&We.tokens[0].tokens.length>0&&We.tokens[0].tokens[0].type==="text"&&(We.tokens[0].tokens[0].text=Be+" "+We.tokens[0].tokens[0].text)):We.tokens.unshift({type:"text",text:Be}):ze+=Be),ze+=this.parse(We.tokens,_e),Ae+=this.renderer.listitem(ze,it,xe);B+=this.renderer.list(Ae,Pe,Ie);continue}case"html":{B+=this.renderer.html(pe.text);continue}case"paragraph":{B+=this.renderer.paragraph(this.parseInline(pe.tokens));continue}case"text":{for(Ae=pe.tokens?this.parseInline(pe.tokens):pe.text;H+1<Ye&&T[H+1].type==="text";)pe=T[++H],Ae+=`
`+(pe.tokens?this.parseInline(pe.tokens):pe.text);B+=O?this.renderer.paragraph(Ae):Ae;continue}default:{var q='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return B},I.parseInline=function(T,O){O=O||this.renderer;var B="",H,_,Q,re=T.length;for(H=0;H<re;H++){if(_=T[H],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_.type]&&(Q=this.options.extensions.renderers[_.type].call({parser:this},_),Q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(_.type))){B+=Q||"";continue}switch(_.type){case"escape":{B+=O.text(_.text);break}case"html":{B+=O.html(_.text);break}case"link":{B+=O.link(_.href,_.title,this.parseInline(_.tokens,O));break}case"image":{B+=O.image(_.href,_.title,_.text);break}case"strong":{B+=O.strong(this.parseInline(_.tokens,O));break}case"em":{B+=O.em(this.parseInline(_.tokens,O));break}case"codespan":{B+=O.codespan(_.text);break}case"br":{B+=O.br();break}case"del":{B+=O.del(this.parseInline(_.tokens,O));break}case"text":{B+=O.text(_.text);break}default:{var ce='Token with "'+_.type+'" type was not found.';if(this.options.silent){console.error(ce);return}else throw new Error(ce)}}}return B},C}();function ne(C,I,R){if(typeof C>"u"||C===null)throw new Error("marked(): input parameter is undefined or null");if(typeof C!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(C)+", string expected");if(typeof I=="function"&&(R=I,I=null),I=m({},ne.defaults,I||{}),x(I),R){var T=I.highlight,O;try{O=Me.lex(C,I)}catch(re){return R(re)}var B=function(ce){var ve;if(!ce)try{I.walkTokens&&ne.walkTokens(O,I.walkTokens),ve=ie.parse(O,I)}catch(De){ce=De}return I.highlight=T,ce?R(ce):R(null,ve)};if(!T||T.length<3||(delete I.highlight,!O.length))return B();var H=0;ne.walkTokens(O,function(re){re.type==="code"&&(H++,setTimeout(function(){T(re.text,re.lang,function(ce,ve){if(ce)return B(ce);ve!=null&&ve!==re.text&&(re.text=ve,re.escaped=!0),H--,H===0&&B()})},0))}),H===0&&B();return}function _(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,I.silent)return"<p>An error occurred:</p><pre>"+e(re.message+"",!0)+"</pre>";throw re}try{var Q=Me.lex(C,I);if(I.walkTokens){if(I.async)return Promise.all(ne.walkTokens(Q,I.walkTokens)).then(function(){return ie.parse(Q,I)}).catch(_);ne.walkTokens(Q,I.walkTokens)}return ie.parse(Q,I)}catch(re){_(re)}}ne.options=ne.setOptions=function(C){return m(ne.defaults,C),b(ne.defaults),ne},ne.getDefaults=y,ne.defaults=J.defaults,ne.use=function(){for(var C=arguments.length,I=new Array(C),R=0;R<C;R++)I[R]=arguments[R];var T=m.apply(void 0,[{}].concat(I)),O=ne.defaults.extensions||{renderers:{},childTokens:{}},B;I.forEach(function(H){if(H.extensions&&(B=!0,H.extensions.forEach(function(Q){if(!Q.name)throw new Error("extension name required");if(Q.renderer){var re=O.renderers?O.renderers[Q.name]:null;re?O.renderers[Q.name]=function(){for(var ce=arguments.length,ve=new Array(ce),De=0;De<ce;De++)ve[De]=arguments[De];var Le=Q.renderer.apply(this,ve);return Le===!1&&(Le=re.apply(this,ve)),Le}:O.renderers[Q.name]=Q.renderer}if(Q.tokenizer){if(!Q.level||Q.level!=="block"&&Q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");O[Q.level]?O[Q.level].unshift(Q.tokenizer):O[Q.level]=[Q.tokenizer],Q.start&&(Q.level==="block"?O.startBlock?O.startBlock.push(Q.start):O.startBlock=[Q.start]:Q.level==="inline"&&(O.startInline?O.startInline.push(Q.start):O.startInline=[Q.start]))}Q.childTokens&&(O.childTokens[Q.name]=Q.childTokens)})),H.renderer&&function(){var Q=ne.defaults.renderer||new Oe,re=function(De){var Le=Q[De];Q[De]=function(){for(var Ae=arguments.length,pe=new Array(Ae),Pe=0;Pe<Ae;Pe++)pe[Pe]=arguments[Pe];var Ie=H.renderer[De].apply(Q,pe);return Ie===!1&&(Ie=Le.apply(Q,pe)),Ie}};for(var ce in H.renderer)re(ce);T.renderer=Q}(),H.tokenizer&&function(){var Q=ne.defaults.tokenizer||new he,re=function(De){var Le=Q[De];Q[De]=function(){for(var Ae=arguments.length,pe=new Array(Ae),Pe=0;Pe<Ae;Pe++)pe[Pe]=arguments[Pe];var Ie=H.tokenizer[De].apply(Q,pe);return Ie===!1&&(Ie=Le.apply(Q,pe)),Ie}};for(var ce in H.tokenizer)re(ce);T.tokenizer=Q}(),H.walkTokens){var _=ne.defaults.walkTokens;T.walkTokens=function(Q){var re=[];return re.push(H.walkTokens.call(this,Q)),_&&(re=re.concat(_.call(this,Q))),re}}B&&(T.extensions=O),ne.setOptions(T)})},ne.walkTokens=function(C,I){for(var R=[],T=function(){var _=B.value;switch(R=R.concat(I.call(ne,_)),_.type){case"table":{for(var Q=z(_.header),re;!(re=Q()).done;){var ce=re.value;R=R.concat(ne.walkTokens(ce.tokens,I))}for(var ve=z(_.rows),De;!(De=ve()).done;)for(var Le=De.value,Ae=z(Le),pe;!(pe=Ae()).done;){var Pe=pe.value;R=R.concat(ne.walkTokens(Pe.tokens,I))}break}case"list":{R=R.concat(ne.walkTokens(_.items,I));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[_.type]?ne.defaults.extensions.childTokens[_.type].forEach(function(Ie){R=R.concat(ne.walkTokens(_[Ie],I))}):_.tokens&&(R=R.concat(ne.walkTokens(_.tokens,I)))}},O=z(C),B;!(B=O()).done;)T();return R},ne.parseInline=function(C,I){if(typeof C>"u"||C===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof C!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(C)+", string expected");I=m({},ne.defaults,I||{}),x(I);try{var R=Me.lexInline(C,I);return I.walkTokens&&ne.walkTokens(R,I.walkTokens),ie.parseInline(R,I)}catch(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,I.silent)return"<p>An error occurred:</p><pre>"+e(T.message+"",!0)+"</pre>";throw T}},ne.Parser=ie,ne.parser=ie.parse,ne.Renderer=Oe,ne.TextRenderer=j,ne.Lexer=Me,ne.lexer=Me.lex,ne.Tokenizer=he,ne.Slugger=Y,ne.parse=ne;var ae=ne.options,te=ne.setOptions,W=ne.use,n=ne.walkTokens,E=ne.parseInline,P=ne,$=ie.parse,K=Me.lex;J.Lexer=Me,J.Parser=ie,J.Renderer=Oe,J.Slugger=Y,J.TextRenderer=j,J.Tokenizer=he,J.getDefaults=y,J.lexer=K,J.marked=ne,J.options=ae,J.parse=P,J.parseInline=E,J.parser=$,J.setOptions=te,J.use=W,J.walkTokens=n,Object.defineProperty(J,"__esModule",{value:!0})}),define(ge[77],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class w{constructor(U,z=0,y=U.length,b=z-1){this.a=U,this.b=z,this.c=y,this.d=b}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.ArrayNavigator=w}),define(ge[78],me([1,0,77]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class i{constructor(y=[],b=10){this.h(y),this.b=b,this.d()}getHistory(){return this.j}add(y){this.a.delete(y),this.a.add(y),this.d()}next(){return this.g()!==this.j.length-1?this.c.next():null}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()===this.j.length-1}isNowhere(){return this.c.current()===null}has(y){return this.a.has(y)}clear(){this.h([]),this.d()}d(){this.f();const y=this.j;this.c=new w.ArrayNavigator(y,0,y.length,y.length)}f(){const y=this.j;y.length>this.b&&this.h(y.slice(y.length-this.b))}g(){const y=this.c.current();return y?this.j.indexOf(y):-1}h(y){this.a=new Set;for(const b of y)this.a.add(b)}get j(){const y=[];return this.a.forEach(b=>y.push(b)),y}}t.HistoryNavigator=i;class U{constructor(y,b=10){if(this.f=b,y.length<1)throw new Error("not supported");this.d=1,this.a=this.b=this.c={value:y[0],previous:void 0,next:void 0};for(let f=1;f<y.length;f++)this.add(y[f])}add(y){const b={value:y,previous:this.b,next:void 0};for(this.b.next=b,this.b=b,this.c=this.b,this.d++;this.d>this.f;)this.a=this.a.next,this.a.previous=void 0,this.d--}replaceLast(y){const b=this.b.value;return this.b.value=y,b}isAtEnd(){return this.c===this.b}current(){return this.c.value}previous(){return this.c.previous&&(this.c=this.c.previous),this.c.value}next(){return this.c.next&&(this.c=this.c.next),this.c.value}has(y){let b=this.a;for(;b;){if(b.value===y)return!0;b=b.next}return!1}resetCursor(){return this.c=this.b,this.c.value}*[Symbol.iterator](){let y=this.a;for(;y;)yield y.value,y=y.next}}t.HistoryNavigator2=U}),define(ge[46],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function w(b,f,d){return Math.min(Math.max(b,f),d)}t.clamp=w;function i(b,f){return(f+b%f)%f}t.rot=i;class U{constructor(){this.a=0}getNext(){return this.a++}}t.Counter=U;class z{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.MovingAverage=z;class y{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const d=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.SlidingWindowAverage=y}),define(ge[47],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var w;(function(i){function U(f,d){if(f.start>=d.end||d.start>=f.end)return{start:0,end:0};const h=Math.max(f.start,d.start),N=Math.min(f.end,d.end);return N-h<=0?{start:0,end:0}:{start:h,end:N}}i.intersect=U;function z(f){return f.end-f.start<=0}i.isEmpty=z;function y(f,d){return!z(U(f,d))}i.intersects=y;function b(f,d){const h=[],N={start:f.start,end:Math.min(d.start,f.end)},a={start:Math.max(d.end,f.start),end:f.end};return z(N)||h.push(N),z(a)||h.push(a),h}i.relativeComplement=b})(w=t.Range||(t.Range={}))}),define(ge[79],me([1,0,47]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function i(f,d){const h=[];for(const N of d){if(f.start>=N.range.end)continue;if(f.end<N.range.start)break;const a=w.Range.intersect(f,N.range);w.Range.isEmpty(a)||h.push({range:a,size:N.size})}return h}t.groupIntersect=i;function U({start:f,end:d},h){return{start:f+h,end:d+h}}t.shift=U;function z(f){const d=[];let h=null;for(const N of f){const a=N.range.start,s=N.range.end,e=N.size;if(h&&e===h.size){h.range.end=s;continue}h={range:{start:a,end:s},size:e},d.push(h)}return d}t.consolidate=z;function y(...f){return z(f.reduce((d,h)=>d.concat(h),[]))}class b{constructor(){this.a=[],this.b=0}splice(d,h,N=[]){const a=N.length-h,s=i({start:0,end:d},this.a),e=i({start:d+h,end:Number.POSITIVE_INFINITY},this.a).map(o=>({range:U(o.range,a),size:o.size})),r=N.map((o,l)=>({range:{start:d+l,end:d+l+1},size:o.size}));this.a=y(s,r,e),this.b=this.a.reduce((o,l)=>o+l.size*(l.range.end-l.range.start),0)}get count(){const d=this.a.length;return d?this.a[d-1].range.end:0}get size(){return this.b}indexAt(d){if(d<0)return-1;let h=0,N=0;for(const a of this.a){const s=a.range.end-a.range.start,e=N+s*a.size;if(d<e)return h+Math.floor((d-N)/a.size);h+=s,N=e}return h}indexAfter(d){return Math.min(this.indexAt(d)+1,this.count)}positionAt(d){if(d<0)return-1;let h=0,N=0;for(const a of this.a){const s=a.range.end-a.range.start,e=N+s;if(d<e)return h+(d-N)*a.size;h+=s*a.size,N=e}return-1}}t.RangeMap=b}),define(ge[80],me([1,0,6,2]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function U(S){const k=S;return k?typeof k.read=="function":!1}t.isReadable=U;function z(S){const k=S;return k?[k.on,k.pause,k.resume,k.destroy].every(g=>typeof g=="function"):!1}t.isReadableStream=z;function y(S){const k=S;return k?z(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}t.isReadableBufferedStream=y;function b(S,k){return new f(S,k)}t.newWriteableStream=b;class f{constructor(k,g){this.e=k,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(g=>g(k))}h(k){this.c.error.length===0?(0,w.onUnexpectedError)(k):this.c.error.slice(0).forEach(g=>g(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,g){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(k,g){if(this.a.destroyed)return;let A;switch(k){case"data":A=this.c.data;break;case"end":A=this.c.end;break;case"error":A=this.c.error;break}if(A){const L=A.indexOf(g);L>=0&&A.splice(L,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(A=>A())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(S,k){const g=[];let A;for(;(A=S.read())!==null;)g.push(A);return k(g)}t.consumeReadable=d;function h(S,k,g){const A=[];let L;for(;(L=S.read())!==null&&A.length<g;)A.push(L);return L===null&&A.length>0?k(A):{read:()=>{if(A.length>0)return A.shift();if(typeof L<"u"){const F=L;return L=void 0,F}return S.read()}}}t.peekReadable=h;function N(S,k){return new Promise((g,A)=>{const L=[];a(S,{onData:F=>{k&&L.push(F)},onError:F=>{k?A(F):g(void 0)},onEnd:()=>{g(k?k(L):void 0)}})})}t.consumeStream=N;function a(S,k){let g=!1;return S.on("error",A=>{g||k.onError(A)}),S.on("end",()=>{g||k.onEnd()}),S.on("data",A=>{g||k.onData(A)}),(0,i.toDisposable)(()=>g=!0)}t.listenStream=a;function s(S,k){return new Promise((g,A)=>{const L=new i.DisposableStore,F=[],c=v=>{if(F.push(v),F.length>k)return L.dispose(),S.pause(),g({stream:S,buffer:F,ended:!1})},p=v=>A(v),m=()=>g({stream:S,buffer:F,ended:!0});L.add((0,i.toDisposable)(()=>S.removeListener("error",p))),S.on("error",p),L.add((0,i.toDisposable)(()=>S.removeListener("end",m))),S.on("end",m),L.add((0,i.toDisposable)(()=>S.removeListener("data",c))),S.on("data",c)})}t.peekStream=s;function e(S,k){const g=b(k);return g.end(S),g}t.toStream=e;function r(){const S=b(()=>{throw new Error("not supported")});return S.end(),S}t.emptyStream=r;function o(S){let k=!1;return{read:()=>k?null:(k=!0,S)}}t.toReadable=o;function l(S,k,g){const A=b(g);return a(S,{onData:L=>A.write(k.data(L)),onError:L=>A.error(k.error?k.error(L):L),onEnd:()=>A.end()}),A}t.transform=l;function u(S,k,g){let A=!1;return{read:()=>{const L=k.read();return A?L:(A=!0,L!==null?g([S,L]):S)}}}t.prefixedReadable=u;function D(S,k,g){let A=!1;const L=b(g);return a(k,{onData:F=>A?L.write(F):(A=!0,L.write(g([S,F]))),onError:F=>L.error(F),onEnd:()=>{A||(A=!0,L.write(S)),L.end()}}),L}t.prefixedStream=D}),define(ge[29],me([1,0,80]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer<"u";let U,z;class y{static alloc(v){return i?new y(Buffer.allocUnsafe(v)):new y(new Uint8Array(v))}static wrap(v){return i&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new y(v)}static fromString(v,M){return!(M?.dontUseNodeBuffer||!1)&&i?new y(Buffer.from(v)):(U||(U=new TextEncoder),new y(U.encode(v)))}static fromByteArray(v){const M=y.alloc(v.length);for(let V=0,x=v.length;V<x;V++)M.buffer[V]=v[V];return M}static concat(v,M){if(typeof M>"u"){M=0;for(let Z=0,ee=v.length;Z<ee;Z++)M+=v[Z].byteLength}const V=y.alloc(M);let x=0;for(let Z=0,ee=v.length;Z<ee;Z++){const se=v[Z];V.set(se,x),x+=se.byteLength}return V}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=y.alloc(this.byteLength);return v.set(this),v}toString(){return i?this.buffer.toString():(z||(z=new TextDecoder),z.decode(this.buffer))}slice(v,M){return new y(this.buffer.subarray(v,M))}set(v,M){if(v instanceof y)this.buffer.set(v.buffer,M);else if(v instanceof Uint8Array)this.buffer.set(v,M);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),M);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return d(this.buffer,v)}writeUInt32BE(v,M){h(this.buffer,v,M)}readUInt32LE(v){return N(this.buffer,v)}writeUInt32LE(v,M){a(this.buffer,v,M)}readUInt8(v){return s(this.buffer,v)}writeUInt8(v,M){e(this.buffer,v,M)}}t.VSBuffer=y;function b(m,v){return m[v+0]<<0>>>0|m[v+1]<<8>>>0}t.readUInt16LE=b;function f(m,v,M){m[M+0]=v&255,v=v>>>8,m[M+1]=v&255}t.writeUInt16LE=f;function d(m,v){return m[v]*2**24+m[v+1]*2**16+m[v+2]*2**8+m[v+3]}t.readUInt32BE=d;function h(m,v,M){m[M+3]=v,v=v>>>8,m[M+2]=v,v=v>>>8,m[M+1]=v,v=v>>>8,m[M]=v}t.writeUInt32BE=h;function N(m,v){return m[v+0]<<0>>>0|m[v+1]<<8>>>0|m[v+2]<<16>>>0|m[v+3]<<24>>>0}t.readUInt32LE=N;function a(m,v,M){m[M+0]=v&255,v=v>>>8,m[M+1]=v&255,v=v>>>8,m[M+2]=v&255,v=v>>>8,m[M+3]=v&255}t.writeUInt32LE=a;function s(m,v){return m[v]}t.readUInt8=s;function e(m,v,M){m[M]=v}t.writeUInt8=e;function r(m){return w.consumeReadable(m,v=>y.concat(v))}t.readableToBuffer=r;function o(m){return w.toReadable(m)}t.bufferToReadable=o;function l(m){return w.consumeStream(m,v=>y.concat(v))}t.streamToBuffer=l;async function u(m){return m.ended?y.concat(m.buffer):y.concat([...m.buffer,await l(m.stream)])}t.bufferedStreamToBuffer=u;function D(m){return w.toStream(m,v=>y.concat(v))}t.bufferToStream=D;function S(m){return w.transform(m,{data:v=>typeof v=="string"?y.fromString(v):y.wrap(v)},v=>y.concat(v))}t.streamToBufferReadableStream=S;function k(m){return w.newWriteableStream(v=>y.concat(v),m)}t.newWriteableBufferStream=k;function g(m,v){return w.prefixedReadable(m,v,M=>y.concat(M))}t.prefixedBufferReadable=g;function A(m,v){return w.prefixedStream(m,v,M=>y.concat(M))}t.prefixedBufferStream=A;function L(m){let v=0,M=0,V=0;const x=new Uint8Array(Math.floor(m.length/4*3)),Z=se=>{switch(M){case 3:x[V++]=v|se,M=0;break;case 2:x[V++]=v|se>>>2,v=se<<6,M=3;break;case 1:x[V++]=v|se>>>4,v=se<<4,M=2;break;default:v=se<<2,M=1}};for(let se=0;se<m.length;se++){const he=m.charCodeAt(se);if(he>=65&&he<=90)Z(he-65);else if(he>=97&&he<=122)Z(he-97+26);else if(he>=48&&he<=57)Z(he-48+52);else if(he===43||he===45)Z(62);else if(he===47||he===95)Z(63);else{if(he===61)break;throw new SyntaxError(`Unexpected base64 character ${m[se]}`)}}const ee=V;for(;M>0;)Z(0);return y.wrap(x).slice(0,ee)}t.decodeBase64=L;const F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:m},v=!0,M=!1){const V=M?c:F;let x="";const Z=m.byteLength%3;let ee=0;for(;ee<m.byteLength-Z;ee+=3){const se=m[ee+0],he=m[ee+1],ue=m[ee+2];x+=V[se>>>2],x+=V[(se<<4|he>>>4)&63],x+=V[(he<<2|ue>>>6)&63],x+=V[ue&63]}if(Z===1){const se=m[ee+0];x+=V[se>>>2],x+=V[se<<4&63],v&&(x+="==")}else if(Z===2){const se=m[ee+0],he=m[ee+1];x+=V[se>>>2],x+=V[(se<<4|he>>>4)&63],x+=V[he<<2&63],v&&(x+="=")}return x}t.encodeBase64=p}),define(ge[7],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function w(A){return typeof A=="string"}t.isString=w;function i(A){return Array.isArray(A)&&A.every(L=>w(L))}t.isStringArray=i;function U(A){return typeof A=="object"&&A!==null&&!Array.isArray(A)&&!(A instanceof RegExp)&&!(A instanceof Date)}t.isObject=U;function z(A){const L=Object.getPrototypeOf(Uint8Array);return typeof A=="object"&&A instanceof L}t.isTypedArray=z;function y(A){return typeof A=="number"&&!isNaN(A)}t.isNumber=y;function b(A){return!!A&&typeof A[Symbol.iterator]=="function"}t.isIterable=b;function f(A){return A===!0||A===!1}t.isBoolean=f;function d(A){return typeof A>"u"}t.isUndefined=d;function h(A){return!N(A)}t.isDefined=h;function N(A){return d(A)||A===null}t.isUndefinedOrNull=N;function a(A,L){if(!A)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}t.assertType=a;function s(A){if(N(A))throw new Error("Assertion Failed: argument is undefined or null");return A}t.assertIsDefined=s;function e(...A){const L=[];for(let F=0;F<A.length;F++){const c=A[F];if(N(c))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);L.push(c)}return L}t.assertAllDefined=e;const r=Object.prototype.hasOwnProperty;function o(A){if(!U(A))return!1;for(const L in A)if(r.call(A,L))return!1;return!0}t.isEmptyObject=o;function l(A){return typeof A=="function"}t.isFunction=l;function u(...A){return A.length>0&&A.every(l)}t.areFunctions=u;function D(A,L){const F=Math.min(A.length,L.length);for(let c=0;c<F;c++)S(A[c],L[c])}t.validateConstraints=D;function S(A,L){if(w(L)){if(typeof A!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(l(L)){try{if(A instanceof L)return}catch{}if(!N(A)&&A.constructor===L||L.length===1&&L.call(void 0,A)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=S;function k(A){return A===null?void 0:A}t.withNullAsUndefined=k;function g(A){return typeof A>"u"?null:A}t.withUndefinedAsNull=g}),define(ge[30],me([1,0,7]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function i(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([D,S])=>{u[D]=S&&typeof S=="object"?i(S):S}),u}t.deepClone=i;function U(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const D=u.shift();Object.freeze(D);for(const S in D)if(z.call(D,S)){const k=D[S];typeof k=="object"&&!Object.isFrozen(k)&&!(0,w.isTypedArray)(k)&&u.push(k)}}return l}t.deepFreeze=U;const z=Object.prototype.hasOwnProperty;function y(l,u){return b(l,u,new Set)}t.cloneAndChange=y;function b(l,u,D){if((0,w.isUndefinedOrNull)(l))return l;const S=u(l);if(typeof S<"u")return S;if(Array.isArray(l)){const k=[];for(const g of l)k.push(b(g,u,D));return k}if((0,w.isObject)(l)){if(D.has(l))throw new Error("Cannot clone recursive data-structure");D.add(l);const k={};for(const g in l)z.call(l,g)&&(k[g]=b(l[g],u,D));return D.delete(l),k}return l}function f(l,u,D=!0){return(0,w.isObject)(l)?((0,w.isObject)(u)&&Object.keys(u).forEach(S=>{S in l?D&&((0,w.isObject)(l[S])&&(0,w.isObject)(u[S])?f(l[S],u[S],D):l[S]=u[S]):l[S]=u[S]}),l):u}t.mixin=f;function d(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let D,S;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(D=0;D<l.length;D++)if(!d(l[D],u[D]))return!1}else{const k=[];for(S in l)k.push(S);k.sort();const g=[];for(S in u)g.push(S);if(g.sort(),!d(k,g))return!1;for(D=0;D<k.length;D++)if(!d(l[k[D]],u[k[D]]))return!1}return!0}t.equals=d;function h(l){const u=new Set;return JSON.stringify(l,(D,S)=>{if((0,w.isObject)(S)||Array.isArray(S)){if(u.has(S))return"[Circular]";u.add(S)}return S})}t.safeStringify=h;function N(l,u){const D=Object.create(null);return!l||!u||Object.keys(u).forEach(k=>{const g=l[k],A=u[k];d(g,A)||(D[k]=A)}),D}t.distinct=N;function a(l,u){const D=u.toLowerCase(),S=Object.keys(l).find(k=>k.toLowerCase()===D);return S?l[S]:l[u]}t.getCaseInsensitive=a;function s(l,u){const D=Object.create(null);for(const[S,k]of Object.entries(l))u(S,k)&&(D[S]=k);return D}t.filter=s;function e(l){let u=[],D=Object.getPrototypeOf(l);for(;Object.prototype!==D;)u=u.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return u}t.getAllPropertyNames=e;function r(l){const u=[];for(const D of e(l))typeof l[D]=="function"&&u.push(D);return u}t.getAllMethodNames=r;function o(l,u){const D=k=>function(){const g=Array.prototype.slice.call(arguments,0);return u(k,g)},S={};for(const k of l)S[k]=D(k);return S}t.createProxyObject=o}),define(ge[81],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ge[82],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class w{constructor(U,z){this.a=U,this.onMessage=z}send(U){try{this.a.send("vscode:message",U.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.Protocol=w}),define(ge[48],me([8]),{}),define(ge[83],me([8]),{}),define(ge[84],me([8]),{}),define(ge[85],me([8]),{}),define(ge[86],me([1,0,84,85]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.formatRule=void 0;function w(i){return`.codicon-${i.id}:before { content: '${i.fontCharacter}'; }`}t.formatRule=w}),define(ge[87],me([8]),{}),define(ge[88],me([8]),{}),define(ge[89],me([8]),{}),define(ge[90],me([8]),{}),define(ge[91],me([8]),{}),define(ge[92],me([8]),{}),define(ge[93],me([8]),{}),define(ge[94],me([8]),{}),define(ge[95],me([8]),{}),define(ge[96],me([12,10]),function(J,t){return J.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(ge[97],me([12,10]),function(J,t){return J.create("vs/base/browser/ui/findinput/findInput",t)}),define(ge[98],me([12,10]),function(J,t){return J.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(ge[99],me([12,10]),function(J,t){return J.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(ge[100],me([12,10]),function(J,t){return J.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(ge[101],me([12,10]),function(J,t){return J.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(ge[102],me([12,10]),function(J,t){return J.create("vs/base/browser/ui/tree/abstractTree",t)}),define(ge[103],me([12,10]),function(J,t){return J.create("vs/base/common/actions",t)}),define(ge[104],me([12,10]),function(J,t){return J.create("vs/base/common/platform",t)}),define(ge[5],me([1,0,104]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let i=!1,U=!1,z=!1,y=!1,b=!1,f=!1,d=!1,h=!1,N=!1,a=!1,s,e=t.LANGUAGE_DEFAULT,r,o;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?l=t.globals.vscode.process:typeof process<"u"&&(l=process);const u=typeof l?.versions?.electron=="string",D=u&&l?.type==="renderer";if(typeof navigator=="object"&&!D)o=navigator.userAgent,i=o.indexOf("Windows")>=0,U=o.indexOf("Macintosh")>=0,h=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,z=o.indexOf("Linux")>=0,a=o?.indexOf("Mobi")>=0,f=!0,s=w.getConfiguredDefaultLocale(w.localize(0,null))||t.LANGUAGE_DEFAULT,e=s;else if(typeof l=="object"){i=l.platform==="win32",U=l.platform==="darwin",z=l.platform==="linux",y=z&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,d=u,N=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,s=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const m=l.env.VSCODE_NLS_CONFIG;if(m)try{const v=JSON.parse(m),M=v.availableLanguages["*"];s=v.locale,e=M||t.LANGUAGE_DEFAULT,r=v._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var S;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(S=t.Platform||(t.Platform={}));function k(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=k;let g=0;U?g=1:i?g=3:z&&(g=2),t.isWindows=i,t.isMacintosh=U,t.isLinux=z,t.isLinuxSnap=y,t.isNative=b,t.isElectron=d,t.isWeb=f,t.isWebWorker=f&&typeof t.globals.importScripts=="function",t.isIOS=h,t.isMobile=a,t.isCI=N,t.platform=g,t.userAgent=o,t.language=e;var A;(function(m){function v(){return t.language}m.value=v;function M(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}m.isDefaultVariant=M;function V(){return t.language==="en"}m.isDefault=V})(A=t.Language||(t.Language={})),t.locale=s,t.translationsConfigFile=r,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const m=[];t.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let V=0,x=m.length;V<x;V++){const Z=m[V];if(Z.id===M.data.vscodeScheduleAsyncWork){m.splice(V,1),Z.callback();return}}});let v=0;return M=>{const V=++v;m.push({id:V,callback:M}),t.globals.postMessage({vscodeScheduleAsyncWork:V},"*")}}return m=>setTimeout(m)})();var L;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(L=t.OperatingSystem||(t.OperatingSystem={})),t.OS=U||h?2:i?1:3;let F=!0,c=!1;function p(){if(!c){c=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,F=new Uint16Array(m.buffer)[0]===(2<<8)+1}return F}t.isLittleEndian=p,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(ge[105],me([1,0,5]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let i;if(typeof w.globals.vscode<"u"&&typeof w.globals.vscode.process<"u"){const U=w.globals.vscode.process;i={get platform(){return U.platform},get arch(){return U.arch},get env(){return U.env},cwd(){return U.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.arch=i.arch}),define(ge[21],me([1,0,105]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const i=65,U=97,z=90,y=122,b=46,f=47,d=92,h=58,N=63;class a extends Error{constructor(A,L,F){let c;typeof L=="string"&&L.indexOf("not ")===0?(c="must not be",L=L.replace(/^not /,"")):c="must be";const p=A.indexOf(".")!==-1?"property":"argument";let m=`The "${A}" ${p} ${c} of type ${L}`;m+=`. Received type ${typeof F}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function s(g,A){if(g===null||typeof g!="object")throw new a(A,"Object",g)}function e(g,A){if(typeof g!="string")throw new a(A,"string",g)}const r=w.platform==="win32";function o(g){return g===f||g===d}function l(g){return g===f}function u(g){return g>=i&&g<=z||g>=U&&g<=y}function D(g,A,L,F){let c="",p=0,m=-1,v=0,M=0;for(let V=0;V<=g.length;++V){if(V<g.length)M=g.charCodeAt(V);else{if(F(M))break;M=f}if(F(M)){if(!(m===V-1||v===1))if(v===2){if(c.length<2||p!==2||c.charCodeAt(c.length-1)!==b||c.charCodeAt(c.length-2)!==b){if(c.length>2){const x=c.lastIndexOf(L);x===-1?(c="",p=0):(c=c.slice(0,x),p=c.length-1-c.lastIndexOf(L)),m=V,v=0;continue}else if(c.length!==0){c="",p=0,m=V,v=0;continue}}A&&(c+=c.length>0?`${L}..`:"..",p=2)}else c.length>0?c+=`${L}${g.slice(m+1,V)}`:c=g.slice(m+1,V),p=V-m-1;m=V,v=0}else M===b&&v!==-1?++v:v=-1}return c}function S(g,A){s(A,"pathObject");const L=A.dir||A.root,F=A.base||`${A.name||""}${A.ext||""}`;return L?L===A.root?`${L}${F}`:`${L}${g}${F}`:F}t.win32={resolve(...g){let A="",L="",F=!1;for(let c=g.length-1;c>=-1;c--){let p;if(c>=0){if(p=g[c],e(p,"path"),p.length===0)continue}else A.length===0?p=w.cwd():(p=w.env[`=${A}`]||w.cwd(),(p===void 0||p.slice(0,2).toLowerCase()!==A.toLowerCase()&&p.charCodeAt(2)===d)&&(p=`${A}\\`));const m=p.length;let v=0,M="",V=!1;const x=p.charCodeAt(0);if(m===1)o(x)&&(v=1,V=!0);else if(o(x))if(V=!0,o(p.charCodeAt(1))){let Z=2,ee=Z;for(;Z<m&&!o(p.charCodeAt(Z));)Z++;if(Z<m&&Z!==ee){const se=p.slice(ee,Z);for(ee=Z;Z<m&&o(p.charCodeAt(Z));)Z++;if(Z<m&&Z!==ee){for(ee=Z;Z<m&&!o(p.charCodeAt(Z));)Z++;(Z===m||Z!==ee)&&(M=`\\\\${se}\\${p.slice(ee,Z)}`,v=Z)}}}else v=1;else u(x)&&p.charCodeAt(1)===h&&(M=p.slice(0,2),v=2,m>2&&o(p.charCodeAt(2))&&(V=!0,v=3));if(M.length>0)if(A.length>0){if(M.toLowerCase()!==A.toLowerCase())continue}else A=M;if(F){if(A.length>0)break}else if(L=`${p.slice(v)}\\${L}`,F=V,V&&A.length>0)break}return L=D(L,!F,"\\",o),F?`${A}\\${L}`:`${A}${L}`||"."},normalize(g){e(g,"path");const A=g.length;if(A===0)return".";let L=0,F,c=!1;const p=g.charCodeAt(0);if(A===1)return l(p)?"\\":g;if(o(p))if(c=!0,o(g.charCodeAt(1))){let v=2,M=v;for(;v<A&&!o(g.charCodeAt(v));)v++;if(v<A&&v!==M){const V=g.slice(M,v);for(M=v;v<A&&o(g.charCodeAt(v));)v++;if(v<A&&v!==M){for(M=v;v<A&&!o(g.charCodeAt(v));)v++;if(v===A)return`\\\\${V}\\${g.slice(M)}\\`;v!==M&&(F=`\\\\${V}\\${g.slice(M,v)}`,L=v)}}}else L=1;else u(p)&&g.charCodeAt(1)===h&&(F=g.slice(0,2),L=2,A>2&&o(g.charCodeAt(2))&&(c=!0,L=3));let m=L<A?D(g.slice(L),!c,"\\",o):"";return m.length===0&&!c&&(m="."),m.length>0&&o(g.charCodeAt(A-1))&&(m+="\\"),F===void 0?c?`\\${m}`:m:c?`${F}\\${m}`:`${F}${m}`},isAbsolute(g){e(g,"path");const A=g.length;if(A===0)return!1;const L=g.charCodeAt(0);return o(L)||A>2&&u(L)&&g.charCodeAt(1)===h&&o(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let A,L;for(let p=0;p<g.length;++p){const m=g[p];e(m,"path"),m.length>0&&(A===void 0?A=L=m:A+=`\\${m}`)}if(A===void 0)return".";let F=!0,c=0;if(typeof L=="string"&&o(L.charCodeAt(0))){++c;const p=L.length;p>1&&o(L.charCodeAt(1))&&(++c,p>2&&(o(L.charCodeAt(2))?++c:F=!1))}if(F){for(;c<A.length&&o(A.charCodeAt(c));)c++;c>=2&&(A=`\\${A.slice(c)}`)}return t.win32.normalize(A)},relative(g,A){if(e(g,"from"),e(A,"to"),g===A)return"";const L=t.win32.resolve(g),F=t.win32.resolve(A);if(L===F||(g=L.toLowerCase(),A=F.toLowerCase(),g===A))return"";let c=0;for(;c<g.length&&g.charCodeAt(c)===d;)c++;let p=g.length;for(;p-1>c&&g.charCodeAt(p-1)===d;)p--;const m=p-c;let v=0;for(;v<A.length&&A.charCodeAt(v)===d;)v++;let M=A.length;for(;M-1>v&&A.charCodeAt(M-1)===d;)M--;const V=M-v,x=m<V?m:V;let Z=-1,ee=0;for(;ee<x;ee++){const he=g.charCodeAt(c+ee);if(he!==A.charCodeAt(v+ee))break;he===d&&(Z=ee)}if(ee!==x){if(Z===-1)return F}else{if(V>x){if(A.charCodeAt(v+ee)===d)return F.slice(v+ee+1);if(ee===2)return F.slice(v+ee)}m>x&&(g.charCodeAt(c+ee)===d?Z=ee:ee===2&&(Z=3)),Z===-1&&(Z=0)}let se="";for(ee=c+Z+1;ee<=p;++ee)(ee===p||g.charCodeAt(ee)===d)&&(se+=se.length===0?"..":"\\..");return v+=Z,se.length>0?`${se}${F.slice(v,M)}`:(F.charCodeAt(v)===d&&++v,F.slice(v,M))},toNamespacedPath(g){if(typeof g!="string"||g.length===0)return g;const A=t.win32.resolve(g);if(A.length<=2)return g;if(A.charCodeAt(0)===d){if(A.charCodeAt(1)===d){const L=A.charCodeAt(2);if(L!==N&&L!==b)return`\\\\?\\UNC\\${A.slice(2)}`}}else if(u(A.charCodeAt(0))&&A.charCodeAt(1)===h&&A.charCodeAt(2)===d)return`\\\\?\\${A}`;return g},dirname(g){e(g,"path");const A=g.length;if(A===0)return".";let L=-1,F=0;const c=g.charCodeAt(0);if(A===1)return o(c)?g:".";if(o(c)){if(L=F=1,o(g.charCodeAt(1))){let v=2,M=v;for(;v<A&&!o(g.charCodeAt(v));)v++;if(v<A&&v!==M){for(M=v;v<A&&o(g.charCodeAt(v));)v++;if(v<A&&v!==M){for(M=v;v<A&&!o(g.charCodeAt(v));)v++;if(v===A)return g;v!==M&&(L=F=v+1)}}}}else u(c)&&g.charCodeAt(1)===h&&(L=A>2&&o(g.charCodeAt(2))?3:2,F=L);let p=-1,m=!0;for(let v=A-1;v>=F;--v)if(o(g.charCodeAt(v))){if(!m){p=v;break}}else m=!1;if(p===-1){if(L===-1)return".";p=L}return g.slice(0,p)},basename(g,A){A!==void 0&&e(A,"ext"),e(g,"path");let L=0,F=-1,c=!0,p;if(g.length>=2&&u(g.charCodeAt(0))&&g.charCodeAt(1)===h&&(L=2),A!==void 0&&A.length>0&&A.length<=g.length){if(A===g)return"";let m=A.length-1,v=-1;for(p=g.length-1;p>=L;--p){const M=g.charCodeAt(p);if(o(M)){if(!c){L=p+1;break}}else v===-1&&(c=!1,v=p+1),m>=0&&(M===A.charCodeAt(m)?--m===-1&&(F=p):(m=-1,F=v))}return L===F?F=v:F===-1&&(F=g.length),g.slice(L,F)}for(p=g.length-1;p>=L;--p)if(o(g.charCodeAt(p))){if(!c){L=p+1;break}}else F===-1&&(c=!1,F=p+1);return F===-1?"":g.slice(L,F)},extname(g){e(g,"path");let A=0,L=-1,F=0,c=-1,p=!0,m=0;g.length>=2&&g.charCodeAt(1)===h&&u(g.charCodeAt(0))&&(A=F=2);for(let v=g.length-1;v>=A;--v){const M=g.charCodeAt(v);if(o(M)){if(!p){F=v+1;break}continue}c===-1&&(p=!1,c=v+1),M===b?L===-1?L=v:m!==1&&(m=1):L!==-1&&(m=-1)}return L===-1||c===-1||m===0||m===1&&L===c-1&&L===F+1?"":g.slice(L,c)},format:S.bind(null,"\\"),parse(g){e(g,"path");const A={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return A;const L=g.length;let F=0,c=g.charCodeAt(0);if(L===1)return o(c)?(A.root=A.dir=g,A):(A.base=A.name=g,A);if(o(c)){if(F=1,o(g.charCodeAt(1))){let Z=2,ee=Z;for(;Z<L&&!o(g.charCodeAt(Z));)Z++;if(Z<L&&Z!==ee){for(ee=Z;Z<L&&o(g.charCodeAt(Z));)Z++;if(Z<L&&Z!==ee){for(ee=Z;Z<L&&!o(g.charCodeAt(Z));)Z++;Z===L?F=Z:Z!==ee&&(F=Z+1)}}}}else if(u(c)&&g.charCodeAt(1)===h){if(L<=2)return A.root=A.dir=g,A;if(F=2,o(g.charCodeAt(2))){if(L===3)return A.root=A.dir=g,A;F=3}}F>0&&(A.root=g.slice(0,F));let p=-1,m=F,v=-1,M=!0,V=g.length-1,x=0;for(;V>=F;--V){if(c=g.charCodeAt(V),o(c)){if(!M){m=V+1;break}continue}v===-1&&(M=!1,v=V+1),c===b?p===-1?p=V:x!==1&&(x=1):p!==-1&&(x=-1)}return v!==-1&&(p===-1||x===0||x===1&&p===v-1&&p===m+1?A.base=A.name=g.slice(m,v):(A.name=g.slice(m,p),A.base=g.slice(m,v),A.ext=g.slice(p,v))),m>0&&m!==F?A.dir=g.slice(0,m-1):A.dir=A.root,A},sep:"\\",delimiter:";",win32:null,posix:null};const k=(()=>{if(r){const g=/\\/g;return()=>{const A=w.cwd().replace(g,"/");return A.slice(A.indexOf("/"))}}return()=>w.cwd()})();t.posix={resolve(...g){let A="",L=!1;for(let F=g.length-1;F>=-1&&!L;F--){const c=F>=0?g[F]:k();e(c,"path"),c.length!==0&&(A=`${c}/${A}`,L=c.charCodeAt(0)===f)}return A=D(A,!L,"/",l),L?`/${A}`:A.length>0?A:"."},normalize(g){if(e(g,"path"),g.length===0)return".";const A=g.charCodeAt(0)===f,L=g.charCodeAt(g.length-1)===f;return g=D(g,!A,"/",l),g.length===0?A?"/":L?"./":".":(L&&(g+="/"),A?`/${g}`:g)},isAbsolute(g){return e(g,"path"),g.length>0&&g.charCodeAt(0)===f},join(...g){if(g.length===0)return".";let A;for(let L=0;L<g.length;++L){const F=g[L];e(F,"path"),F.length>0&&(A===void 0?A=F:A+=`/${F}`)}return A===void 0?".":t.posix.normalize(A)},relative(g,A){if(e(g,"from"),e(A,"to"),g===A||(g=t.posix.resolve(g),A=t.posix.resolve(A),g===A))return"";const L=1,F=g.length,c=F-L,p=1,m=A.length-p,v=c<m?c:m;let M=-1,V=0;for(;V<v;V++){const Z=g.charCodeAt(L+V);if(Z!==A.charCodeAt(p+V))break;Z===f&&(M=V)}if(V===v)if(m>v){if(A.charCodeAt(p+V)===f)return A.slice(p+V+1);if(V===0)return A.slice(p+V)}else c>v&&(g.charCodeAt(L+V)===f?M=V:V===0&&(M=0));let x="";for(V=L+M+1;V<=F;++V)(V===F||g.charCodeAt(V)===f)&&(x+=x.length===0?"..":"/..");return`${x}${A.slice(p+M)}`},toNamespacedPath(g){return g},dirname(g){if(e(g,"path"),g.length===0)return".";const A=g.charCodeAt(0)===f;let L=-1,F=!0;for(let c=g.length-1;c>=1;--c)if(g.charCodeAt(c)===f){if(!F){L=c;break}}else F=!1;return L===-1?A?"/":".":A&&L===1?"//":g.slice(0,L)},basename(g,A){A!==void 0&&e(A,"ext"),e(g,"path");let L=0,F=-1,c=!0,p;if(A!==void 0&&A.length>0&&A.length<=g.length){if(A===g)return"";let m=A.length-1,v=-1;for(p=g.length-1;p>=0;--p){const M=g.charCodeAt(p);if(M===f){if(!c){L=p+1;break}}else v===-1&&(c=!1,v=p+1),m>=0&&(M===A.charCodeAt(m)?--m===-1&&(F=p):(m=-1,F=v))}return L===F?F=v:F===-1&&(F=g.length),g.slice(L,F)}for(p=g.length-1;p>=0;--p)if(g.charCodeAt(p)===f){if(!c){L=p+1;break}}else F===-1&&(c=!1,F=p+1);return F===-1?"":g.slice(L,F)},extname(g){e(g,"path");let A=-1,L=0,F=-1,c=!0,p=0;for(let m=g.length-1;m>=0;--m){const v=g.charCodeAt(m);if(v===f){if(!c){L=m+1;break}continue}F===-1&&(c=!1,F=m+1),v===b?A===-1?A=m:p!==1&&(p=1):A!==-1&&(p=-1)}return A===-1||F===-1||p===0||p===1&&A===F-1&&A===L+1?"":g.slice(A,F)},format:S.bind(null,"/"),parse(g){e(g,"path");const A={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return A;const L=g.charCodeAt(0)===f;let F;L?(A.root="/",F=1):F=0;let c=-1,p=0,m=-1,v=!0,M=g.length-1,V=0;for(;M>=F;--M){const x=g.charCodeAt(M);if(x===f){if(!v){p=M+1;break}continue}m===-1&&(v=!1,m=M+1),x===b?c===-1?c=M:V!==1&&(V=1):c!==-1&&(V=-1)}if(m!==-1){const x=p===0&&L?1:p;c===-1||V===0||V===1&&c===m-1&&c===p+1?A.base=A.name=g.slice(x,m):(A.name=g.slice(x,c),A.base=g.slice(x,m),A.ext=g.slice(c,m))}return p>0?A.dir=g.slice(0,p-1):L&&(A.dir="/"),A},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=r?t.win32.normalize:t.posix.normalize,t.isAbsolute=r?t.win32.isAbsolute:t.posix.isAbsolute,t.join=r?t.win32.join:t.posix.join,t.resolve=r?t.win32.resolve:t.posix.resolve,t.relative=r?t.win32.relative:t.posix.relative,t.dirname=r?t.win32.dirname:t.posix.dirname,t.basename=r?t.win32.basename:t.posix.basename,t.extname=r?t.win32.extname:t.posix.extname,t.format=r?t.win32.format:t.posix.format,t.parse=r?t.win32.parse:t.posix.parse,t.toNamespacedPath=r?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=r?t.win32.sep:t.posix.sep,t.delimiter=r?t.win32.delimiter:t.posix.delimiter}),define(ge[106],me([1,0,21]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},U={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function z(h){const N=(0,w.extname)(h),a=i[N.toLowerCase()];return a!==void 0?a:y(h)}t.getMediaOrTextMime=z;function y(h){const N=(0,w.extname)(h);return U[N.toLowerCase()]}t.getMediaMime=y;function b(h){for(const N in U)if(U[N]===h)return N}t.getExtensionForMimeType=b;const f=/^(.+)\/(.+?)(;.+)?$/;function d(h,N){const a=f.exec(h);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:N?void 0:h}t.normalizeMimeType=d}),define(ge[107],me([1,0,5]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=w.globals.performance&&typeof w.globals.performance.now=="function";class U{static create(y=!0){return new U(y)}constructor(y){this.a=i&&y,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?w.globals.performance.now():Date.now()}}t.StopWatch=U}),define(ge[3],me([1,0,6,42,2,45,107]),function(J,t,w,i,U,z,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const b=!1,f=!1;var d;(function(p){p.None=()=>U.Disposable.None;function m(P){if(f){const{onDidAddListener:$}=P,K=e.create();let C=0;P.onDidAddListener=()=>{++C===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),K.print()),$?.()}}}function v(P,$){return de(P,()=>{},0,void 0,void 0,$)}p.defer=v;function M(P){return($,K=null,C)=>{let I=!1,R;return R=P(T=>{if(!I)return R?R.dispose():I=!0,$.call(K,T)},null,C),I&&R.dispose(),R}}p.once=M;function V(P,$,K){return ue((C,I=null,R)=>P(T=>C.call(I,$(T)),null,R),K)}p.map=V;function x(P,$,K){return ue((C,I=null,R)=>P(T=>{$(T),C.call(I,T)},null,R),K)}p.forEach=x;function Z(P,$,K){return ue((C,I=null,R)=>P(T=>$(T)&&C.call(I,T),null,R),K)}p.filter=Z;function ee(P){return P}p.signal=ee;function se(...P){return($,K=null,C)=>(0,U.combinedDisposable)(...P.map(I=>I(R=>$.call(K,R),null,C)))}p.any=se;function he(P,$,K,C){let I=K;return V(P,R=>(I=$(I,R),I),C)}p.reduce=he;function ue(P,$){let K;const C={onWillAddFirstListener(){K=P(I.fire,I)},onDidRemoveLastListener(){K?.dispose()}};$||m(C);const I=new o(C);return $?.add(I),I.event}function de(P,$,K=100,C=!1,I,R){let T,O,B,H=0;const _={leakWarningThreshold:I,onWillAddFirstListener(){T=P(re=>{H++,O=$(O,re),C&&!B&&(Q.fire(O),O=void 0),clearTimeout(B),B=setTimeout(()=>{const ce=O;O=void 0,B=void 0,(!C||H>1)&&Q.fire(ce),H=0},K)})},onDidRemoveLastListener(){T.dispose()}};R||m(_);const Q=new o(_);return R?.add(Q),Q.event}p.debounce=de;function we(P,$=0,K){return p.debounce(P,(C,I)=>C?(C.push(I),C):[I],$,void 0,void 0,K)}p.accumulate=we;function Te(P,$=(C,I)=>C===I,K){let C=!0,I;return Z(P,R=>{const T=C||!$(R,I);return C=!1,I=R,T},K)}p.latch=Te;function Me(P,$,K){return[p.filter(P,$,K),p.filter(P,C=>!$(C),K)]}p.split=Me;function Oe(P,$=!1,K=[]){let C=K.slice(),I=P(O=>{C?C.push(O):T.fire(O)});const R=()=>{C?.forEach(O=>T.fire(O)),C=null},T=new o({onWillAddFirstListener(){I||(I=P(O=>T.fire(O)))},onDidAddFirstListener(){C&&($?setTimeout(R):R())},onDidRemoveLastListener(){I&&I.dispose(),I=null}});return T.event}p.buffer=Oe;class j{constructor($){this.event=$,this.c=new U.DisposableStore}map($){return new j(V(this.event,$,this.c))}forEach($){return new j(x(this.event,$,this.c))}filter($){return new j(Z(this.event,$,this.c))}reduce($,K){return new j(he(this.event,$,K,this.c))}latch(){return new j(Te(this.event,void 0,this.c))}debounce($,K=100,C=!1,I){return new j(de(this.event,$,K,C,I,this.c))}on($,K,C){return this.event($,K,C)}once($,K,C){return M(this.event)($,K,C)}dispose(){this.c.dispose()}}function Y(P){return new j(P)}p.chain=Y;function ie(P,$,K=C=>C){const C=(...O)=>T.fire(K(...O)),I=()=>P.on($,C),R=()=>P.removeListener($,C),T=new o({onWillAddFirstListener:I,onDidRemoveLastListener:R});return T.event}p.fromNodeEventEmitter=ie;function ne(P,$,K=C=>C){const C=(...O)=>T.fire(K(...O)),I=()=>P.addEventListener($,C),R=()=>P.removeEventListener($,C),T=new o({onWillAddFirstListener:I,onDidRemoveLastListener:R});return T.event}p.fromDOMEventEmitter=ne;function ae(P){return new Promise($=>M(P)($))}p.toPromise=ae;function te(P,$){return $(void 0),P(K=>$(K))}p.runAndSubscribe=te;function W(P,$){let K=null;function C(R){K?.dispose(),K=new U.DisposableStore,$(R,K)}C(void 0);const I=P(R=>C(R));return(0,U.toDisposable)(()=>{I.dispose(),K?.dispose()})}p.runAndSubscribeWithStore=W;class n{constructor($,K){this.obs=$,this.c=0,this.d=!1;const C={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};K||m(C),this.emitter=new o(C),K&&K.add(this.emitter)}beginUpdate($){this.c++}handleChange($,K){this.d=!0}endUpdate($){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function E(P,$){return new n(P,$).emitter.event}p.fromObservable=E})(d=t.Event||(t.Event={}));class h{constructor(m){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${m}_${h.c++}`,h.all.add(this)}start(m){this.d=new y.StopWatch(!0),this.listenerCount=m}stop(){if(this.d){const m=this.d.elapsed();this.durations.push(m),this.elapsedOverall+=m,this.invocationCount+=1,this.d=void 0}}}t.EventProfiling=h,h.all=new Set,h.c=0;let N=-1;function a(p){const m=N;return N=p,{dispose(){N=m}}}t.setGlobalLeakWarningThreshold=a;class s{constructor(m,v=Math.random().toString(18).slice(2,5)){this.threshold=m,this.name=v,this.d=0}dispose(){this.c?.clear()}check(m,v){const M=this.threshold;if(M<=0||v<M)return;this.c||(this.c=new Map);const V=this.c.get(m.value)||0;if(this.c.set(m.value,V+1),this.d-=1,this.d<=0){this.d=M*.5;let x,Z=0;for(const[ee,se]of this.c)(!x||Z<se)&&(x=ee,Z=se);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${Z}):`),console.warn(x)}return()=>{const x=this.c.get(m.value)||0;this.c.set(m.value,x-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(m){this.value=m}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class r{constructor(m,v,M){this.callback=m,this.callbackThis=v,this.stack=M,this.subscription=new U.SafeDisposable}invoke(m){this.callback.call(this.callbackThis,m)}}class o{constructor(m){this.j=!1,this.d=m,this.f=N>0||this.d?.leakWarningThreshold?new s(this.d?.leakWarningThreshold??N):void 0,this.g=this.d?._profName?new h(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(b){const m=Array.from(this.q);queueMicrotask(()=>{for(const v of m)v.subscription.isset()&&(v.subscription.unset(),v.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(m,v,M)=>{if(this.q||(this.q=new z.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),U.Disposable.None;const V=this.q.isEmpty();V&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let x,Z;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(Z=e.create(),x=this.f.check(Z,this.q.size+1)),b&&(Z=Z??e.create());const ee=new r(m,v,Z),se=this.q.push(ee);V&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,m,v);const he=ee.subscription.set(()=>{x?.(),this.j||(se(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return M instanceof U.DisposableStore?M.add(he):Array.isArray(M)&&M.push(he),he}),this.l}fire(m){if(this.q){this.m||(this.m=new u);for(const v of this.q)this.m.push(this,v,m);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=o;class l{constructor(){this.c=new z.LinkedList}get size(){return this.c.size}push(m,v,M){this.c.push(new D(m,v,M))}clear(m){const v=new z.LinkedList;for(const M of this.c)M.emitter!==m&&v.push(M);this.c=v}deliver(){for(;this.c.size>0;){const m=this.c.shift();try{m.listener.invoke(m.event)}catch(v){(0,w.onUnexpectedError)(v)}}}}t.EventDeliveryQueue=l;class u extends l{clear(m){this.c.clear()}}class D{constructor(m,v,M){this.emitter=m,this.listener=v,this.event=M}}class S extends o{async fireAsync(m,v,M){if(!!this.q){this.c||(this.c=new z.LinkedList);for(const V of this.q)this.c.push([V,m]);for(;this.c.size>0&&!v.isCancellationRequested;){const[V,x]=this.c.shift(),Z=[],ee={...x,token:v,waitUntil:se=>{if(Object.isFrozen(Z))throw new Error("waitUntil can NOT be called asynchronous");M&&(se=M(se,V.callback)),Z.push(se)}};try{V.invoke(ee)}catch(se){(0,w.onUnexpectedError)(se);continue}Object.freeze(Z),await Promise.allSettled(Z).then(se=>{for(const he of se)he.status==="rejected"&&(0,w.onUnexpectedError)(he.reason)})}}}}t.AsyncEmitter=S;class k extends o{constructor(m){super(m),this.h=0,this.s=new z.LinkedList,this.t=m?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const m=Array.from(this.s);this.s.clear(),super.fire(this.t(m))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(m){this.q&&(this.h!==0?this.s.push(m):super.fire(m))}}t.PauseableEmitter=k;class g extends k{constructor(m){super(m),this.c=m.delay??100}fire(m){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(m)}}t.DebounceEmitter=g;class A extends o{constructor(m){super(m),this.c=[],this.h=m?.merge}fire(m){!this.hasListeners()||(this.c.push(m),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(v=>super.fire(v)),this.c=[]}))}}t.MicrotaskEmitter=A;class L{constructor(){this.d=!1,this.f=[],this.c=new o({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(m){const v={event:m,listener:null};this.f.push(v),this.d&&this.j(v);const M=()=>{this.d&&this.k(v);const V=this.f.indexOf(v);this.f.splice(V,1)};return(0,U.toDisposable)((0,i.once)(M))}g(){this.d=!0,this.f.forEach(m=>this.j(m))}h(){this.d=!1,this.f.forEach(m=>this.k(m))}j(m){m.listener=m.event(v=>this.c.fire(v))}k(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=L;class F{constructor(){this.c=[]}wrapEvent(m){return(v,M,V)=>m(x=>{const Z=this.c[this.c.length-1];Z?Z.push(()=>v.call(M,x)):v.call(M,x)},void 0,V)}bufferEvents(m){const v=[];this.c.push(v);const M=m();return this.c.pop(),v.forEach(V=>V()),M}}t.EventBufferer=F;class c{constructor(){this.c=!1,this.d=d.None,this.f=U.Disposable.None,this.g=new o({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(m){this.d=m,this.c&&(this.f.dispose(),this.f=m(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=c}),define(ge[17],me([1,0,3,2]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWCOEnabled=t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class U{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new w.Emitter,this.onDidChangeFullscreen=this.d.event}getZoomLevel(){return this.a}setZoomLevel(S,k){this.a!==S&&(this.a=S)}getZoomFactor(){return this.b}setZoomFactor(S){this.b=S}setFullscreen(S){this.c!==S&&(this.c=S,this.d.fire())}isFullscreen(){return this.c}}U.INSTANCE=new U;class z extends i.Disposable{constructor(){super(),this.a=this.B(new w.Emitter),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(S){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),S&&this.a.fire()}}class y extends i.Disposable{get value(){return this.b}constructor(){super(),this.a=this.B(new w.Emitter),this.onDidChange=this.a.event,this.b=this.c();const S=this.B(new z);this.B(S.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const S=document.createElement("canvas").getContext("2d"),k=window.devicePixelRatio||1,g=S.webkitBackingStorePixelRatio||S.mozBackingStorePixelRatio||S.msBackingStorePixelRatio||S.oBackingStorePixelRatio||S.backingStorePixelRatio||1;return k/g}}class b{constructor(){this.a=null}b(){return this.a||(this.a=(0,i.markAsSingleton)(new y)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function f(D,S){typeof D=="string"&&(D=window.matchMedia(D)),D.addEventListener("change",S)}t.addMatchMediaChangeListener=f,t.PixelRatio=new b;function d(D,S){U.INSTANCE.setZoomLevel(D,S)}t.setZoomLevel=d;function h(){return U.INSTANCE.getZoomLevel()}t.getZoomLevel=h;function N(){return U.INSTANCE.getZoomFactor()}t.getZoomFactor=N;function a(D){U.INSTANCE.setZoomFactor(D)}t.setZoomFactor=a;function s(D){U.INSTANCE.setFullscreen(D)}t.setFullscreen=s;function e(){return U.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=U.INSTANCE.onDidChangeFullscreen;const r=navigator.userAgent;t.isFirefox=r.indexOf("Firefox")>=0,t.isWebKit=r.indexOf("AppleWebKit")>=0,t.isChrome=r.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&r.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=r.indexOf("Electron/")>=0,t.isAndroid=r.indexOf("Android")>=0;let o=!1;if(window.matchMedia){const D=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),S=window.matchMedia("(display-mode: fullscreen)");o=D.matches,f(D,({matches:k})=>{o&&S.matches||(o=k)})}function l(){return o}t.isStandalone=l;function u(){return navigator?.windowControlsOverlay?.visible}t.isWCOEnabled=u}),define(ge[108],me([1,0,17,5]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var U;(function(z){z[z.Always=0]="Always",z[z.FullScreen=1]="FullScreen",z[z.None=2]="None"})(U=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:i.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.isNative||w.isStandalone()?0:navigator.keyboard||w.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(ge[19],me([1,0,3]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class i{get event(){return this.a.event}constructor(z,y,b){const f=d=>this.a.fire(d);this.a=new w.Emitter({onWillAddFirstListener:()=>z.addEventListener(y,f,b),onDidRemoveLastListener:()=>z.removeEventListener(y,f,b)})}dispose(){this.a.dispose()}}t.DomEmitter=i}),define(ge[15],me([1,0,17,43,74,5]),function(J,t,w,i,U,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function y(e){if(e.charCode){const o=String.fromCharCode(e.charCode).toUpperCase();return i.KeyCodeUtils.fromString(o)}const r=e.keyCode;if(r===3)return 7;if(w.isFirefox){if(r===59)return 80;if(r===107)return 81;if(r===109)return 83;if(z.isMacintosh&&r===224)return 57}else if(w.isWebKit){if(r===91)return 57;if(z.isMacintosh&&r===93)return 57;if(!z.isMacintosh&&r===92)return 57}return i.EVENT_KEY_CODE_MAP[r]||0}const b=z.isMacintosh?256:2048,f=512,d=1024,h=z.isMacintosh?2048:256;function N(e){const r=[];return e.ctrlKey&&r.push("ctrl"),e.shiftKey&&r.push("shift"),e.altKey&&r.push("alt"),e.metaKey&&r.push("meta"),`modifiers: [${r.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=N;function a(e){const r=[];return e.ctrlKey&&r.push("ctrl"),e.shiftKey&&r.push("shift"),e.altKey&&r.push("alt"),e.metaKey&&r.push("meta"),`modifiers: [${r.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${i.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=a;class s{constructor(r){this._standardKeyboardEventBrand=!0;const o=r;this.browserEvent=o,this.target=o.target,this.ctrlKey=o.ctrlKey,this.shiftKey=o.shiftKey,this.altKey=o.altKey,this.metaKey=o.metaKey,this.altGraphKey=o.getModifierState("AltGraph"),this.keyCode=y(o),this.code=o.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(r){return this.a===r}c(){let r=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(r=this.keyCode);let o=0;return this.ctrlKey&&(o|=b),this.altKey&&(o|=f),this.shiftKey&&(o|=d),this.metaKey&&(o|=h),o|=r,o}d(){let r=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(r=this.keyCode),new U.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,r)}}t.StandardKeyboardEvent=s}),define(ge[20],me([1,0,17,67,5]),function(J,t,w,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class z{constructor(d){this.timestamp=Date.now(),this.browserEvent=d,this.leftButton=d.button===0,this.middleButton=d.button===1,this.rightButton=d.button===2,this.buttons=d.buttons,this.target=d.target,this.detail=d.detail||1,d.type==="dblclick"&&(this.detail=2),this.ctrlKey=d.ctrlKey,this.shiftKey=d.shiftKey,this.altKey=d.altKey,this.metaKey=d.metaKey,typeof d.pageX=="number"?(this.posx=d.pageX,this.posy=d.pageY):(this.posx=d.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=d.clientY+document.body.scrollTop+document.documentElement.scrollTop);const h=i.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,d.view);this.posx-=h.left,this.posy-=h.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=z;class y extends z{constructor(d){super(d),this.dataTransfer=d.dataTransfer}}t.DragMouseEvent=y;class b{constructor(d,h=0,N=0){if(this.browserEvent=d||null,this.target=d?d.target||d.targetNode||d.srcElement:null,this.deltaY=N,this.deltaX=h,d){const a=d,s=d;if(typeof a.wheelDeltaY<"u")this.deltaY=a.wheelDeltaY/120;else if(typeof s.VERTICAL_AXIS<"u"&&s.axis===s.VERTICAL_AXIS)this.deltaY=-s.detail/3;else if(d.type==="wheel"){const e=d;e.deltaMode===e.DOM_DELTA_LINE?w.isFirefox&&!U.isMacintosh?this.deltaY=-d.deltaY/3:this.deltaY=-d.deltaY:this.deltaY=-d.deltaY/40}if(typeof a.wheelDeltaX<"u")w.isSafari&&U.isWindows?this.deltaX=-(a.wheelDeltaX/120):this.deltaX=a.wheelDeltaX/120;else if(typeof s.HORIZONTAL_AXIS<"u"&&s.axis===s.HORIZONTAL_AXIS)this.deltaX=-d.detail/3;else if(d.type==="wheel"){const e=d;e.deltaMode===e.DOM_DELTA_LINE?w.isFirefox&&!U.isMacintosh?this.deltaX=-d.deltaX/3:this.deltaX=-d.deltaX:this.deltaX=-d.deltaX/40}this.deltaY===0&&this.deltaX===0&&d.wheelDelta&&(this.deltaY=d.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=b}),define(ge[31],me([1,0,3,2,103]),function(J,t,w,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class z extends i.Disposable{constructor(a,s="",e="",r=!0,o){super(),this.h=this.B(new w.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=a,this.m=s,this.u=e,this.w=r,this.C=o}get id(){return this.j}get label(){return this.m}set label(a){this.D(a)}D(a){this.m!==a&&(this.m=a,this.h.fire({label:a}))}get tooltip(){return this.n||""}set tooltip(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.h.fire({tooltip:a}))}get class(){return this.u}set class(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.h.fire({class:a}))}get enabled(){return this.w}set enabled(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.h.fire({enabled:a}))}get checked(){return this.z}set checked(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.h.fire({checked:a}))}async run(a,s){this.C&&await this.C(a)}}t.Action=z;class y extends i.Disposable{constructor(){super(...arguments),this.f=this.B(new w.Emitter),this.onWillRun=this.f.event,this.h=this.B(new w.Emitter),this.onDidRun=this.h.event}async run(a,s){if(!a.enabled)return;this.f.fire({action:a});let e;try{await this.runAction(a,s)}catch(r){e=r}this.h.fire({action:a,error:e})}async runAction(a,s){await a.run(s)}}t.ActionRunner=y;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let s=[];for(const e of a)e.length&&(s.length?s=[...s,new b,...e]:s=e);return s}async run(){}}t.Separator=b,b.ID="vs.actions.separator";class f{get actions(){return this.a}constructor(a,s,e,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=s,this.class=r,this.a=e}async run(){}}t.SubmenuAction=f;class d extends z{constructor(){super(d.ID,U.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=d,d.ID="vs.actions.empty";function h(N){return{id:N.id,label:N.label,class:void 0,enabled:N.enabled??!0,checked:N.checked??!1,run:async()=>N.run(),tooltip:N.label}}t.toAction=h}),define(ge[26],me([1,0,3]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const i=Object.freeze(function(b,f){const d=setTimeout(b.bind(f),0);return{dispose(){clearTimeout(d)}}});var U;(function(b){function f(d){return d===b.None||d===b.Cancelled||d instanceof z?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}b.isCancellationToken=f,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(U=t.CancellationToken||(t.CancellationToken={}));class z{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new w.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class y{constructor(f){this.a=void 0,this.b=void 0,this.b=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new z),this.a}cancel(){this.a?this.a instanceof z&&this.a.cancel():this.a=U.Cancelled}dispose(f=!1){f&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof z&&this.a.dispose():this.a=U.None}}t.CancellationTokenSource=y}),define(ge[109],me([1,0,26]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class i{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new w.CancellationTokenSource,f=this.b(b.token);return this.a={promise:f,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}t.Cache=i;class U{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const f=JSON.stringify(b);return this.b!==f&&(this.b=f,this.a=this.c(b)),this.a}}t.LRUCachedFunction=U;class z{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const f=this.b(b);return this.a.set(b,f),f}}t.CachedFunction=z}),define(ge[49],me([1,0,3,2]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var U;(function(s){s[s.Auto=1]="Auto",s[s.Hidden=2]="Hidden",s[s.Visible=3]="Visible"})(U=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class z{constructor(e,r,o,l,u,D,S){this.c=e,this._scrollStateBrand=void 0,this.c&&(r=r|0,o=o|0,l=l|0,u=u|0,D=D|0,S=S|0),this.rawScrollLeft=l,this.rawScrollTop=S,r<0&&(r=0),l+r>o&&(l=o-r),l<0&&(l=0),u<0&&(u=0),S+u>D&&(S=D-u),S<0&&(S=0),this.width=r,this.scrollWidth=o,this.scrollLeft=l,this.height=u,this.scrollHeight=D,this.scrollTop=S}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,r){return new z(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new z(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,r){const o=this.width!==e.width,l=this.scrollWidth!==e.scrollWidth,u=this.scrollLeft!==e.scrollLeft,D=this.height!==e.height,S=this.scrollHeight!==e.scrollHeight,k=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:r,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:l,scrollLeftChanged:u,heightChanged:D,scrollHeightChanged:S,scrollTopChanged:k}}}t.ScrollState=z;class y extends i.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this.i=this.B(new w.Emitter),this.onScroll=this.i.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new z(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,r){const o=this.g.withScrollDimensions(e,r);this.k(o,Boolean(this.h)),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const r=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.k(r,!1)}setScrollPositionSmooth(e,r){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const o=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let l;r?l=new h(this.h.from,o,this.h.startTime,this.h.duration):l=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=l}else{const o=this.g.withScrollPosition(e);this.h=h.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}j(){if(!this.h)return;const e=this.h.tick(),r=this.g.withScrollPosition(e);if(this.k(r,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}}k(e,r){const o=this.g;o.equals(e)||(this.g=e,this.i.fire(this.g.createScrollEvent(o,r)))}}t.Scrollable=y;class b{constructor(e,r,o){this.scrollLeft=e,this.scrollTop=r,this.isDone=o}}t.SmoothScrollingUpdate=b;function f(s,e){const r=e-s;return function(o){return s+r*a(o)}}function d(s,e,r){return function(o){return o<r?s(o/r):e((o-r)/(1-r))}}class h{constructor(e,r,o,l){this.from=e,this.to=r,this.duration=l,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,r,o){if(Math.abs(e-r)>2.5*o){let u,D;return e<r?(u=e+.75*o,D=r-.75*o):(u=e-.75*o,D=r+.75*o),d(f(e,u),f(D,r),.33)}return f(e,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const r=(e-this.startTime)/this.duration;if(r<1){const o=this.c(r),l=this.d(r);return new b(o,l,!1)}return new b(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,r,o){return h.start(e,r,o)}static start(e,r,o){o=o+10;const l=Date.now()-10;return new h(e,r,l,o)}}t.SmoothScrollingOperation=h;function N(s){return Math.pow(s,3)}function a(s){return 1-N(1-s)}}),define(ge[11],me([1,0,109,44]),function(J,t,w,i){"use strict";var U;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function z(q){return!q||typeof q!="string"?!0:q.trim().length===0}t.isFalsyOrWhitespace=z;const y=/{(\d+)}/g;function b(q,...le){return le.length===0?q:q.replace(y,function(be,ye){const Ce=parseInt(ye,10);return isNaN(Ce)||Ce<0||Ce>=le.length?be:le[Ce]})}t.format=b;const f=/{([^}]+)}/g;function d(q,le){return q.replace(f,(be,ye)=>le[ye]??be)}t.format2=d;function h(q){return q.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}t.escape=h;function N(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=N;function a(q,le){let be=0;const ye=le.charCodeAt(0);for(let Ce=q.length-1;Ce>=0;Ce--)q.charCodeAt(Ce)===ye&&be++;return be}t.count=a;function s(q,le,be="\u2026"){return q.length<=le?q:`${q.substr(0,le)}${be}`}t.truncate=s;function e(q,le=" "){const be=r(q,le);return o(be,le)}t.trim=e;function r(q,le){if(!q||!le)return q;const be=le.length;if(be===0||q.length===0)return q;let ye=0;for(;q.indexOf(le,ye)===ye;)ye=ye+be;return q.substring(ye)}t.ltrim=r;function o(q,le){if(!q||!le)return q;const be=le.length,ye=q.length;if(be===0||ye===0)return q;let Ce=ye,Re=-1;for(;Re=q.lastIndexOf(le,Ce-1),!(Re===-1||Re+be!==Ce);){if(Re===0)return"";Ce=Re}return q.substring(0,Ce)}t.rtrim=o;function l(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=l;function u(q){return q.replace(/\*/g,"")}t.stripWildcards=u;function D(q,le,be={}){if(!q)throw new Error("Cannot create regex from empty string");le||(q=N(q)),be.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let ye="";return be.global&&(ye+="g"),be.matchCase||(ye+="i"),be.multiline&&(ye+="m"),be.unicode&&(ye+="u"),new RegExp(q,ye)}t.createRegExp=D;function S(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}t.regExpLeadsToEndlessLoop=S;function k(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=k;function g(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}t.regExpFlags=g;function A(q){return q.split(/\r\n|\r|\n/)}t.splitLines=A;function L(q){for(let le=0,be=q.length;le<be;le++){const ye=q.charCodeAt(le);if(ye!==32&&ye!==9)return le}return-1}t.firstNonWhitespaceIndex=L;function F(q,le=0,be=q.length){for(let ye=le;ye<be;ye++){const Ce=q.charCodeAt(ye);if(Ce!==32&&Ce!==9)return q.substring(le,ye)}return q.substring(le,be)}t.getLeadingWhitespace=F;function c(q,le=q.length-1){for(let be=le;be>=0;be--){const ye=q.charCodeAt(be);if(ye!==32&&ye!==9)return be}return-1}t.lastNonWhitespaceIndex=c;function p(q,le,be){const ye=[];let Ce=0;for(const Re of q.matchAll(le)){if(ye.push(q.slice(Ce,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Ce=Re.index+Re[0].length,ye.push(be(Re[0],...Re.slice(1),Re.index,q,Re.groups))}return ye.push(q.slice(Ce)),Promise.all(ye).then(Re=>Re.join(""))}t.replaceAsync=p;function m(q,le){return q<le?-1:q>le?1:0}t.compare=m;function v(q,le,be=0,ye=q.length,Ce=0,Re=le.length){for(;be<ye&&Ce<Re;be++,Ce++){const Ne=q.charCodeAt(be),oe=le.charCodeAt(Ce);if(Ne<oe)return-1;if(Ne>oe)return 1}const je=ye-be,tt=Re-Ce;return je<tt?-1:je>tt?1:0}t.compareSubstring=v;function M(q,le){return V(q,le,0,q.length,0,le.length)}t.compareIgnoreCase=M;function V(q,le,be=0,ye=q.length,Ce=0,Re=le.length){for(;be<ye&&Ce<Re;be++,Ce++){let Ne=q.charCodeAt(be),oe=le.charCodeAt(Ce);if(Ne===oe)continue;if(Ne>=128||oe>=128)return v(q.toLowerCase(),le.toLowerCase(),be,ye,Ce,Re);Z(Ne)&&(Ne-=32),Z(oe)&&(oe-=32);const Ee=Ne-oe;if(Ee!==0)return Ee}const je=ye-be,tt=Re-Ce;return je<tt?-1:je>tt?1:0}t.compareSubstringIgnoreCase=V;function x(q){return q>=48&&q<=57}t.isAsciiDigit=x;function Z(q){return q>=97&&q<=122}t.isLowerAsciiLetter=Z;function ee(q){return q>=65&&q<=90}t.isUpperAsciiLetter=ee;function se(q,le){return q.length===le.length&&V(q,le)===0}t.equalsIgnoreCase=se;function he(q,le){const be=le.length;return le.length>q.length?!1:V(q,le,0,be)===0}t.startsWithIgnoreCase=he;function ue(q,le){const be=Math.min(q.length,le.length);let ye;for(ye=0;ye<be;ye++)if(q.charCodeAt(ye)!==le.charCodeAt(ye))return ye;return be}t.commonPrefixLength=ue;function de(q,le){const be=Math.min(q.length,le.length);let ye;const Ce=q.length-1,Re=le.length-1;for(ye=0;ye<be;ye++)if(q.charCodeAt(Ce-ye)!==le.charCodeAt(Re-ye))return ye;return be}t.commonSuffixLength=de;function we(q){return 55296<=q&&q<=56319}t.isHighSurrogate=we;function Te(q){return 56320<=q&&q<=57343}t.isLowSurrogate=Te;function Me(q,le){return(q-55296<<10)+(le-56320)+65536}t.computeCodePoint=Me;function Oe(q,le,be){const ye=q.charCodeAt(be);if(we(ye)&&be+1<le){const Ce=q.charCodeAt(be+1);if(Te(Ce))return Me(ye,Ce)}return ye}t.getNextCodePoint=Oe;function j(q,le){const be=q.charCodeAt(le-1);if(Te(be)&&le>1){const ye=q.charCodeAt(le-2);if(we(ye))return Me(ye,be)}return be}class Y{get offset(){return this.e}constructor(le,be=0){this.c=le,this.d=le.length,this.e=be}setOffset(le){this.e=le}prevCodePoint(){const le=j(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=Oe(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}t.CodePointIterator=Y;class ie{get offset(){return this.c.offset}constructor(le,be=0){this.c=new Y(le,be)}nextGraphemeLength(){const le=_e.getInstance(),be=this.c,ye=be.offset;let Ce=le.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Re=be.offset,je=le.getGraphemeBreakType(be.nextCodePoint());if(Pe(Ce,je)){be.setOffset(Re);break}Ce=je}return be.offset-ye}prevGraphemeLength(){const le=_e.getInstance(),be=this.c,ye=be.offset;let Ce=le.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Re=be.offset,je=le.getGraphemeBreakType(be.prevCodePoint());if(Pe(je,Ce)){be.setOffset(Re);break}Ce=je}return ye-be.offset}eol(){return this.c.eol()}}t.GraphemeIterator=ie;function ne(q,le){return new ie(q,le).nextGraphemeLength()}t.nextCharLength=ne;function ae(q,le){return new ie(q,le).prevGraphemeLength()}t.prevCharLength=ae;function te(q,le){le>0&&Te(q.charCodeAt(le))&&le--;const be=le+ne(q,le);return[be-ae(q,be),be]}t.getCharContainingOffset=te;function W(q){const le=new ie(q);let be=0;for(;!le.eol();)be++,le.nextGraphemeLength();return be}t.charCount=W;let n;function E(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function P(q){return n||(n=E()),n.test(q)}t.containsRTL=P;const $=/^[\t\n\r\x20-\x7E]*$/;function K(q){return $.test(q)}t.isBasicASCII=K,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function C(q){return t.UNUSUAL_LINE_TERMINATORS.test(q)}t.containsUnusualLineTerminators=C;function I(q){return q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}t.isFullWidthCharacter=I;function R(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129008||q>=129280&&q<=129535||q>=129648&&q<=129782}t.isEmojiImprecise=R;function T(q,le){if(q.length<le)return q;const be=/\b/g;let ye=0;for(;be.test(q)&&!(q.length-be.lastIndex<le);)ye=be.lastIndex,be.lastIndex+=1;return q.substring(ye).replace(/^\s/,"")}t.lcut=T;const O=/\x1B\x5B[12]?K/g,B=/\x1b\[\d+m/g,H=/\x1b\[0?m/g;function _(q){return q&&(q=q.replace(O,""),q=q.replace(B,""),q=q.replace(H,"")),q}t.removeAnsiEscapeCodes=_,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Q(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}t.startsWithUTF8BOM=Q;function re(q){return Q(q)?q.substr(1):q}t.stripUTF8BOM=re;function ce(q,le){if(!q||!le||q.length<le.length)return!1;const be=le.length,ye=q.toLowerCase();let Ce=0,Re=-1;for(;Ce<be;){const je=ye.indexOf(le[Ce],Re+1);if(je<0)return!1;Re=je,Ce++}return!0}t.fuzzyContains=ce;function ve(q,le=!1){return q?(le&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}t.containsUppercaseCharacter=ve;function De(q){return q.charAt(0).toUpperCase()+q.slice(1)}t.uppercaseFirstLetter=De;function Le(q,le=1){if(le===0)return"";let be=-1;do be=q.indexOf(`
`,be+1),le--;while(le>0&&be>=0);return be===-1?q:(q[be-1]==="\r"&&be--,q.substr(0,be))}t.getNLines=Le;function Ae(q){return q=q%(2*26),q<26?String.fromCharCode(97+q):String.fromCharCode(65+q-26)}t.singleLetterHash=Ae;function pe(q){return _e.getInstance().getGraphemeBreakType(q)}t.getGraphemeBreakType=pe;function Pe(q,le){return q===0?le!==5&&le!==7:q===2&&le===3?!1:q===4||q===2||q===3||le===4||le===2||le===3?!0:!(q===8&&(le===8||le===9||le===11||le===12)||(q===11||q===9)&&(le===9||le===10)||(q===12||q===10)&&le===10||le===5||le===13||le===7||q===1||q===13&&le===14||q===6&&le===6)}var Ie;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=t.GraphemeBreakType||(t.GraphemeBreakType={}));class _e{static getInstance(){return _e.c||(_e.c=new _e),_e.c}constructor(){this.d=ze()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const be=this.d,ye=be.length/3;let Ce=1;for(;Ce<=ye;)if(le<be[3*Ce])Ce=2*Ce;else if(le>be[3*Ce+1])Ce=2*Ce+1;else return be[3*Ce+2];return 0}}_e.c=null;function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(q,le){if(q===0)return 0;const be=xe(q,le);if(be!==void 0)return be;const ye=new Y(le,q);return ye.prevCodePoint(),ye.offset}t.getLeftDeleteOffset=We;function xe(q,le){const be=new Y(le,q);let ye=be.prevCodePoint();for(;it(ye)||ye===65039||ye===8419;){if(be.offset===0)return;ye=be.prevCodePoint()}if(!R(ye))return;let Ce=be.offset;return Ce>0&&be.prevCodePoint()===8205&&(Ce=be.offset),Ce}function it(q){return 127995<=q&&q<=127999}var Be;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),t.noBreakWhitespace="\xA0";class Ke{static getInstance(le){return Ke.d.get(Array.from(le))}static getLocales(){return Ke.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.AmbiguousCharacters=Ke,U=Ke,Ke.c=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ke.d=new w.LRUCachedFunction(q=>{function le(oe){const Ee=new Map;for(let Fe=0;Fe<oe.length;Fe+=2)Ee.set(oe[Fe],oe[Fe+1]);return Ee}function be(oe,Ee){const Fe=new Map(oe);for(const[Ue,Ge]of Ee)Fe.set(Ue,Ge);return Fe}function ye(oe,Ee){if(!oe)return Ee;const Fe=new Map;for(const[Ue,Ge]of oe)Ee.has(Ue)&&Fe.set(Ue,Ge);return Fe}const Ce=U.c.value;let Re=q.filter(oe=>!oe.startsWith("_")&&oe in Ce);Re.length===0&&(Re=["_default"]);let je;for(const oe of Re){const Ee=le(Ce[oe]);je=ye(je,Ee)}const tt=le(Ce._common),Ne=be(tt,je);return new Ke(Ne)}),Ke.e=new i.Lazy(()=>Object.keys(Ke.c.value).filter(q=>!q.startsWith("_")));class Ye{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ye.c())),this.d}static isInvisibleCharacter(le){return Ye.e().has(le)}static get codePoints(){return Ye.e()}}t.InvisibleCharacters=Ye,Ye.d=void 0}),define(ge[110],me([1,0,21,5,11,7]),function(J,t,w,i,U,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function y(c){return c===47||c===92}t.isPathSeparator=y;function b(c){return c.replace(/[\\/]/g,w.posix.sep)}t.toSlashes=b;function f(c){return c.indexOf("/")===-1&&(c=b(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}t.toPosixPath=f;function d(c,p=w.posix.sep){if(!c)return"";const m=c.length,v=c.charCodeAt(0);if(y(v)){if(y(c.charCodeAt(1))&&!y(c.charCodeAt(2))){let V=3;const x=V;for(;V<m&&!y(c.charCodeAt(V));V++);if(x!==V&&!y(c.charCodeAt(V+1))){for(V+=1;V<m;V++)if(y(c.charCodeAt(V)))return c.slice(0,V+1).replace(/[\\/]/g,p)}}return p}else if(l(v)&&c.charCodeAt(1)===58)return y(c.charCodeAt(2))?c.slice(0,2)+p:c.slice(0,2);let M=c.indexOf("://");if(M!==-1){for(M+=3;M<m;M++)if(y(c.charCodeAt(M)))return c.slice(0,M+1)}return""}t.getRoot=d;function h(c){if(!i.isWindows||!c||c.length<5)return!1;let p=c.charCodeAt(0);if(p!==92||(p=c.charCodeAt(1),p!==92))return!1;let m=2;const v=m;for(;m<c.length&&(p=c.charCodeAt(m),p!==92);m++);return!(v===m||(p=c.charCodeAt(m+1),isNaN(p)||p===92))}t.isUNC=h;const N=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,s=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(c,p=i.isWindows){const m=p?N:a;return!(!c||c.length===0||/^\s+$/.test(c)||(m.lastIndex=0,m.test(c))||p&&s.test(c)||c==="."||c===".."||p&&c[c.length-1]==="."||p&&c.length!==c.trim().length||c.length>255)}t.isValidBasename=e;function r(c,p,m){const v=c===p;return!m||v?v:!c||!p?!1:(0,U.equalsIgnoreCase)(c,p)}t.isEqual=r;function o(c,p,m,v=w.sep){if(c===p)return!0;if(!c||!p||p.length>c.length)return!1;if(m){if(!(0,U.startsWithIgnoreCase)(c,p))return!1;if(p.length===c.length)return!0;let V=p.length;return p.charAt(p.length-1)===v&&V--,c.charAt(V)===v}return p.charAt(p.length-1)!==v&&(p+=v),c.indexOf(p)===0}t.isEqualOrParent=o;function l(c){return c>=65&&c<=90||c>=97&&c<=122}t.isWindowsDriveLetter=l;function u(c,p){return i.isWindows&&c.endsWith(":")&&(c+=w.sep),(0,w.isAbsolute)(c)||(c=(0,w.join)(p,c)),c=(0,w.normalize)(c),i.isWindows?(c=(0,U.rtrim)(c,w.sep),c.endsWith(":")&&(c+=w.sep)):(c=(0,U.rtrim)(c,w.sep),c||(c=w.sep)),c}t.sanitizeFilePath=u;function D(c){const p=(0,w.normalize)(c);return i.isWindows?c.length>3?!1:S(p)&&(c.length===2||p.charCodeAt(2)===92):p===w.posix.sep}t.isRootOrDriveLetter=D;function S(c,p=i.isWindows){return p?l(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}t.hasDriveLetter=S;function k(c){return S(c)?c[0]:void 0}t.getDriveLetter=k;function g(c,p,m){return p.length>c.length?-1:c===p?0:(m&&(c=c.toLowerCase(),p=p.toLowerCase()),c.indexOf(p))}t.indexOfPath=g;function A(c){const p=c.split(":");let m,v,M;for(const V of p){const x=Number(V);(0,z.isNumber)(x)?v===void 0?v=x:M===void 0&&(M=x):m=m?[m,V].join(":"):V}if(!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:v!==void 0?v:void 0,column:M!==void 0?M:v!==void 0?1:void 0}}t.parseLineAndColumnAware=A;const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function F(c,p,m=8){let v="";for(let V=0;V<m;V++)v+=L.charAt(Math.floor(Math.random()*L.length));let M;return p?M=`${p}-${v}`:M=v,c?(0,w.join)(c,M):M}t.randomPath=F}),define(ge[32],me([1,0,75,11]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function U(...B){return function(H,_){for(let Q=0,re=B.length;Q<re;Q++){const ce=B[Q](H,_);if(ce)return ce}return null}}t.or=U,t.matchesStrictPrefix=z.bind(void 0,!1),t.matchesPrefix=z.bind(void 0,!0);function z(B,H,_){if(!_||_.length<H.length)return null;let Q;return B?Q=i.startsWithIgnoreCase(_,H):Q=_.indexOf(H)===0,Q?H.length>0?[{start:0,end:H.length}]:[]:null}function y(B,H){const _=H.toLowerCase().indexOf(B.toLowerCase());return _===-1?null:[{start:_,end:_+B.length}]}t.matchesContiguousSubString=y;function b(B,H){return f(B.toLowerCase(),H.toLowerCase(),0,0)}t.matchesSubString=b;function f(B,H,_,Q){if(_===B.length)return[];if(Q===H.length)return null;if(B[_]===H[Q]){let re=null;return(re=f(B,H,_+1,Q+1))?l({start:Q,end:Q+1},re):null}return f(B,H,_,Q+1)}function d(B){return 97<=B&&B<=122}function h(B){return 65<=B&&B<=90}t.isUpper=h;function N(B){return 48<=B&&B<=57}function a(B){return B===32||B===9||B===10||B===13}const s=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(B=>s.add(B.charCodeAt(0)));function e(B){return a(B)||s.has(B)}function r(B,H){return B===H||e(B)&&e(H)}function o(B){return d(B)||h(B)||N(B)}function l(B,H){return H.length===0?H=[B]:B.end===H[0].start?H[0].start=B.start:H.unshift(B),H}function u(B,H){for(let _=H;_<B.length;_++){const Q=B.charCodeAt(_);if(h(Q)||N(Q)||_>0&&!o(B.charCodeAt(_-1)))return _}return B.length}function D(B,H,_,Q){if(_===B.length)return[];if(Q===H.length)return null;if(B[_]!==H[Q].toLowerCase())return null;{let re=null,ce=Q+1;for(re=D(B,H,_+1,Q+1);!re&&(ce=u(H,ce))<H.length;)re=D(B,H,_+1,ce),ce++;return re===null?null:l({start:Q,end:Q+1},re)}}function S(B){let H=0,_=0,Q=0,re=0,ce=0;for(let pe=0;pe<B.length;pe++)ce=B.charCodeAt(pe),h(ce)&&H++,d(ce)&&_++,o(ce)&&Q++,N(ce)&&re++;const ve=H/B.length,De=_/B.length,Le=Q/B.length,Ae=re/B.length;return{upperPercent:ve,lowerPercent:De,alphaPercent:Le,numericPercent:Ae}}function k(B){const{upperPercent:H,lowerPercent:_}=B;return _===0&&H>.6}function g(B){const{upperPercent:H,lowerPercent:_,alphaPercent:Q,numericPercent:re}=B;return _>.2&&H<.8&&Q>.6&&re<.2}function A(B){let H=0,_=0,Q=0,re=0;for(let ce=0;ce<B.length;ce++)Q=B.charCodeAt(ce),h(Q)&&H++,d(Q)&&_++,a(Q)&&re++;return(H===0||_===0)&&re===0?B.length<=30:H<=5}function L(B,H){if(!H||(H=H.trim(),H.length===0)||!A(B)||H.length>60)return null;const _=S(H);if(!g(_)){if(!k(_))return null;H=H.toLowerCase()}let Q=null,re=0;for(B=B.toLowerCase();re<H.length&&(Q=D(B,H,0,re))===null;)re=u(H,re+1);return Q}t.matchesCamelCase=L;function F(B,H,_=!1){if(!H||H.length===0)return null;let Q=null,re=0;for(B=B.toLowerCase(),H=H.toLowerCase();re<H.length&&(Q=c(B,H,0,re,_))===null;)re=p(H,re+1);return Q}t.matchesWords=F;function c(B,H,_,Q,re){if(_===B.length)return[];if(Q===H.length)return null;if(r(B.charCodeAt(_),H.charCodeAt(Q))){let ce=null,ve=Q+1;if(ce=c(B,H,_+1,Q+1,re),!re)for(;!ce&&(ve=p(H,ve))<H.length;)ce=c(B,H,_+1,ve,re),ve++;return ce?B.charCodeAt(_)!==H.charCodeAt(Q)?ce:l({start:Q,end:Q+1},ce):null}else return null}function p(B,H){for(let _=H;_<B.length;_++)if(e(B.charCodeAt(_))||_>0&&e(B.charCodeAt(_-1)))return _;return B.length}const m=U(t.matchesPrefix,L,y),v=U(t.matchesPrefix,L,b),M=new w.LRUCache(1e4);function V(B,H,_=!1){if(typeof B!="string"||typeof H!="string")return null;let Q=M.get(B);Q||(Q=new RegExp(i.convertSimple2RegExpPattern(B),"i"),M.set(B,Q));const re=Q.exec(H);return re?[{start:re.index,end:re.index+re[0].length}]:_?v(B,H):m(B,H)}t.matchesFuzzy=V;function x(B,H){const _=$(B,B.toLowerCase(),0,H,H.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?ee(_):null}t.matchesFuzzy2=x;function Z(B,H,_,Q,re,ce){const ve=Math.min(13,B.length);for(;_<ve;_++){const De=$(B,H,_,Q,re,ce,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(De)return De}return[0,ce]}t.anyScore=Z;function ee(B){if(typeof B>"u")return[];const H=[],_=B[1];for(let Q=B.length-1;Q>1;Q--){const re=B[Q]+_,ce=H[H.length-1];ce&&ce.end===re?ce.end=re+1:H.push({start:re,end:re+1})}return H}t.createMatches=ee;const se=128;function he(){const B=[],H=[];for(let _=0;_<=se;_++)H[_]=0;for(let _=0;_<=se;_++)B.push(H.slice(0));return B}function ue(B){const H=[];for(let _=0;_<=B;_++)H[_]=0;return H}const de=ue(2*se),we=ue(2*se),Te=he(),Me=he(),Oe=he(),j=!1;function Y(B,H,_,Q,re){function ce(De,Le,Ae=" "){for(;De.length<Le;)De=Ae+De;return De}let ve=` |   |${Q.split("").map(De=>ce(De,3)).join("|")}
`;for(let De=0;De<=_;De++)De===0?ve+=" |":ve+=`${H[De-1]}|`,ve+=B[De].slice(0,re+1).map(Le=>ce(Le.toString(),3)).join("|")+`
`;return ve}function ie(B,H,_,Q){B=B.substr(H),_=_.substr(Q),console.log(Y(Me,B,B.length,_,_.length)),console.log(Y(Oe,B,B.length,_,_.length)),console.log(Y(Te,B,B.length,_,_.length))}function ne(B,H){if(H<0||H>=B.length)return!1;const _=B.codePointAt(H);switch(_){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(_)}}function ae(B,H){if(H<0||H>=B.length)return!1;switch(B.charCodeAt(H)){case 32:case 9:return!0;default:return!1}}function te(B,H,_){return H[B]!==_[B]}function W(B,H,_,Q,re,ce,ve=!1){for(;H<_&&re<ce;)B[H]===Q[re]&&(ve&&(de[H]=re),H+=1),re+=1;return H===_}t.isPatternInWord=W;var n;(function(B){B[B.Diag=1]="Diag",B[B.Left=2]="Left",B[B.LeftLeft=3]="LeftLeft"})(n||(n={}));var E;(function(B){B.Default=[-100,0];function H(_){return!_||_.length===2&&_[0]===-100&&_[1]===0}B.isDefault=H})(E=t.FuzzyScore||(t.FuzzyScore={}));class P{constructor(H,_){this.firstMatchCanBeWeak=H,this.boostFullMatch=_}}t.FuzzyScoreOptions=P,P.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function $(B,H,_,Q,re,ce,ve=P.default){const De=B.length>se?se:B.length,Le=Q.length>se?se:Q.length;if(_>=De||ce>=Le||De-_>Le-ce||!W(H,_,De,re,ce,Le,!0))return;K(De,Le,_,ce,H,re);let Ae=1,pe=1,Pe=_,Ie=ce;const _e=[!1];for(Ae=1,Pe=_;Pe<De;Ae++,Pe++){const Be=de[Pe],Ke=we[Pe],Ye=Pe+1<De?we[Pe+1]:Le;for(pe=Be-ce+1,Ie=Be;Ie<Ye;pe++,Ie++){let q=Number.MIN_SAFE_INTEGER,le=!1;Ie<=Ke&&(q=C(B,H,Pe,_,Q,re,Ie,Le,ce,Te[Ae-1][pe-1]===0,_e));let be=0;q!==Number.MAX_SAFE_INTEGER&&(le=!0,be=q+Me[Ae-1][pe-1]);const ye=Ie>Be,Ce=ye?Me[Ae][pe-1]+(Te[Ae][pe-1]>0?-5:0):0,Re=Ie>Be+1&&Te[Ae][pe-1]>0,je=Re?Me[Ae][pe-2]+(Te[Ae][pe-2]>0?-5:0):0;if(Re&&(!ye||je>=Ce)&&(!le||je>=be))Me[Ae][pe]=je,Oe[Ae][pe]=3,Te[Ae][pe]=0;else if(ye&&(!le||Ce>=be))Me[Ae][pe]=Ce,Oe[Ae][pe]=2,Te[Ae][pe]=0;else if(le)Me[Ae][pe]=be,Oe[Ae][pe]=1,Te[Ae][pe]=Te[Ae-1][pe-1]+1;else throw new Error("not possible")}}if(j&&ie(B,_,Q,ce),!_e[0]&&!ve.firstMatchCanBeWeak)return;Ae--,pe--;const ze=[Me[Ae][pe],ce];let We=0,xe=0;for(;Ae>=1;){let Be=pe;do{const Ke=Oe[Ae][Be];if(Ke===3)Be=Be-2;else if(Ke===2)Be=Be-1;else break}while(Be>=1);We>1&&H[_+Ae-1]===re[ce+pe-1]&&!te(Be+ce-1,Q,re)&&We+1>Te[Ae][Be]&&(Be=pe),Be===pe?We++:We=1,xe||(xe=Be),Ae--,pe=Be-1,ze.push(pe)}Le===De&&ve.boostFullMatch&&(ze[0]+=2);const it=xe-De;return ze[0]-=it,ze}t.fuzzyScore=$;function K(B,H,_,Q,re,ce){let ve=B-1,De=H-1;for(;ve>=_&&De>=Q;)re[ve]===ce[De]&&(we[ve]=De,ve--),De--}function C(B,H,_,Q,re,ce,ve,De,Le,Ae,pe){if(H[_]!==ce[ve])return Number.MIN_SAFE_INTEGER;let Pe=1,Ie=!1;return ve===_-Q?Pe=B[_]===re[ve]?7:5:te(ve,re,ce)&&(ve===0||!te(ve-1,re,ce))?(Pe=B[_]===re[ve]?7:5,Ie=!0):ne(ce,ve)&&(ve===0||!ne(ce,ve-1))?Pe=5:(ne(ce,ve-1)||ae(ce,ve-1))&&(Pe=5,Ie=!0),Pe>1&&_===Q&&(pe[0]=!0),Ie||(Ie=te(ve,re,ce)||ne(ce,ve-1)||ae(ce,ve-1)),_===Q?ve>Le&&(Pe-=Ie?3:5):Ae?Pe+=Ie?2:0:Pe+=Ie?0:1,ve+1===De&&(Pe-=Ie?3:5),Pe}function I(B,H,_,Q,re,ce,ve){return T(B,H,_,Q,re,ce,!0,ve)}t.fuzzyScoreGracefulAggressive=I;function R(B,H,_,Q,re,ce,ve){return T(B,H,_,Q,re,ce,!1,ve)}t.fuzzyScoreGraceful=R;function T(B,H,_,Q,re,ce,ve,De){let Le=$(B,H,_,Q,re,ce,De);if(Le&&!ve)return Le;if(B.length>=3){const Ae=Math.min(7,B.length-1);for(let pe=_+1;pe<Ae;pe++){const Pe=O(B,pe);if(Pe){const Ie=$(Pe,Pe.toLowerCase(),_,Q,re,ce,De);Ie&&(Ie[0]-=3,(!Le||Ie[0]>Le[0])&&(Le=Ie))}}}return Le}function O(B,H){if(H+1>=B.length)return;const _=B[H],Q=B[H+1];if(_!==Q)return B.slice(0,H)+Q+_+B.slice(H+2)}}),define(ge[111],me([1,0,11]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function i(l){return U(l,0)}t.hash=i;function U(l,u){switch(typeof l){case"object":return l===null?z(349,u):Array.isArray(l)?f(l,u):d(l,u);case"string":return b(l,u);case"boolean":return y(l,u);case"number":return z(l,u);case"undefined":return z(937,u);default:return z(617,u)}}t.doHash=U;function z(l,u){return(u<<5)-u+l|0}t.numberHash=z;function y(l,u){return z(l?433:863,u)}function b(l,u){u=z(149417,u);for(let D=0,S=l.length;D<S;D++)u=z(l.charCodeAt(D),u);return u}t.stringHash=b;function f(l,u){return u=z(104579,u),l.reduce((D,S)=>U(S,D),u)}function d(l,u){return u=z(181387,u),Object.keys(l).sort().reduce((D,S)=>(D=b(S,D),U(l[S],D)),u)}class h{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=U(u,this.g),this.g}}t.Hasher=h;var N;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(N||(N={}));function a(l,u,D=32){const S=D-u,k=~((1<<S)-1);return(l<<u|(k&l)>>>S)>>>0}function s(l,u=0,D=l.byteLength,S=0){for(let k=0;k<D;k++)l[u+k]=S}function e(l,u,D="0"){for(;l.length<u;)l=D+l;return l}function r(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(D=>D.toString(16).padStart(2,"0")).join(""):e((l>>>0).toString(16),u/4)}t.toHexString=r;class o{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const D=u.length;if(D===0)return;const S=this.p;let k=this.r,g=this.u,A,L;for(g!==0?(A=g,L=-1,g=0):(A=u.charCodeAt(0),L=0);;){let F=A;if(w.isHighSurrogate(A))if(L+1<D){const c=u.charCodeAt(L+1);w.isLowSurrogate(c)?(L++,F=w.computeCodePoint(A,c)):F=65533}else{g=A;break}else w.isLowSurrogate(A)&&(F=65533);if(k=this.w(S,k,F),L++,L<D)A=u.charCodeAt(L);else break}this.r=k,this.u=g}w(u,D,S){return S<128?u[D++]=S:S<2048?(u[D++]=192|(S&1984)>>>6,u[D++]=128|(S&63)>>>0):S<65536?(u[D++]=224|(S&61440)>>>12,u[D++]=128|(S&4032)>>>6,u[D++]=128|(S&63)>>>0):(u[D++]=240|(S&1835008)>>>18,u[D++]=128|(S&258048)>>>12,u[D++]=128|(S&4032)>>>6,u[D++]=128|(S&63)>>>0),D>=64&&(this.y(),D-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),D}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),r(this.h)+r(this.l)+r(this.m)+r(this.n)+r(this.o)}x(){this.p[this.r++]=128,s(this.p,this.r),this.r>56&&(this.y(),s(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=o.g,D=this.q;for(let m=0;m<64;m+=4)u.setUint32(m,D.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)u.setUint32(m,a(u.getUint32(m-12,!1)^u.getUint32(m-32,!1)^u.getUint32(m-56,!1)^u.getUint32(m-64,!1),1),!1);let S=this.h,k=this.l,g=this.m,A=this.n,L=this.o,F,c,p;for(let m=0;m<80;m++)m<20?(F=k&g|~k&A,c=1518500249):m<40?(F=k^g^A,c=1859775393):m<60?(F=k&g|k&A|g&A,c=2400959708):(F=k^g^A,c=3395469782),p=a(S,5)+F+L+c+u.getUint32(m*4,!1)&4294967295,L=A,A=g,g=a(k,30),k=S,S=p;this.h=this.h+S&4294967295,this.l=this.l+k&4294967295,this.m=this.m+g&4294967295,this.n=this.n+A&4294967295,this.o=this.o+L&4294967295}}t.StringSHA1=o,o.g=new DataView(new ArrayBuffer(320))}),define(ge[112],me([1,0,71,111]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class U{constructor(a){this.a=a}getElements(){const a=this.a,s=new Int32Array(a.length);for(let e=0,r=a.length;e<r;e++)s[e]=a.charCodeAt(e);return s}}t.StringDiffSequence=U;function z(N,a,s){return new h(new U(N),new U(a)).ComputeDiff(s).changes}t.stringDiff=z;class y{static Assert(a,s){if(!a)throw new Error(s)}}class b{static Copy(a,s,e,r,o){for(let l=0;l<o;l++)e[r+l]=a[s+l]}static Copy2(a,s,e,r,o){for(let l=0;l<o;l++)e[r+l]=a[s+l]}}var f;(function(N){N[N.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(f||(f={}));class d{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new w.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(a,s){this.b=Math.min(this.b,a),this.c=Math.min(this.c,s),this.d++}AddModifiedElement(a,s){this.b=Math.min(this.b,a),this.c=Math.min(this.c,s),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class h{constructor(a,s,e=null){this.a=e,this.b=a,this.c=s;const[r,o,l]=h.o(a),[u,D,S]=h.o(s);this.d=l&&S,this.e=r,this.f=o,this.g=u,this.h=D,this.k=[],this.m=[]}static n(a){return a.length>0&&typeof a[0]=="string"}static o(a){const s=a.getElements();if(h.n(s)){const e=new Int32Array(s.length);for(let r=0,o=s.length;r<o;r++)e[r]=(0,i.stringHash)(s[r],0);return[s,e,!0]}return s instanceof Int32Array?[[],s,!1]:[[],new Int32Array(s),!1]}p(a,s){return this.f[a]!==this.h[s]?!1:this.d?this.e[a]===this.g[s]:!0}q(a,s){if(!this.p(a,s))return!1;const e=h.r(this.b,a),r=h.r(this.c,s);return e===r}static r(a,s){return typeof a.getStrictElement=="function"?a.getStrictElement(s):null}s(a,s){return this.f[a]!==this.f[s]?!1:this.d?this.e[a]===this.e[s]:!0}u(a,s){return this.h[a]!==this.h[s]?!1:this.d?this.g[a]===this.g[s]:!0}ComputeDiff(a){return this.v(0,this.f.length-1,0,this.h.length-1,a)}v(a,s,e,r,o){const l=[!1];let u=this.w(a,s,e,r,l);return o&&(u=this.z(u)),{quitEarly:l[0],changes:u}}w(a,s,e,r,o){for(o[0]=!1;a<=s&&e<=r&&this.p(a,e);)a++,e++;for(;s>=a&&r>=e&&this.p(s,r);)s--,r--;if(a>s||e>r){let g;return e<=r?(y.Assert(a===s+1,"originalStart should only be one more than originalEnd"),g=[new w.DiffChange(a,0,e,r-e+1)]):a<=s?(y.Assert(e===r+1,"modifiedStart should only be one more than modifiedEnd"),g=[new w.DiffChange(a,s-a+1,e,0)]):(y.Assert(a===s+1,"originalStart should only be one more than originalEnd"),y.Assert(e===r+1,"modifiedStart should only be one more than modifiedEnd"),g=[]),g}const l=[0],u=[0],D=this.y(a,s,e,r,l,u,o),S=l[0],k=u[0];if(D!==null)return D;if(!o[0]){const g=this.w(a,S,e,k,o);let A=[];return o[0]?A=[new w.DiffChange(S+1,s-(S+1)+1,k+1,r-(k+1)+1)]:A=this.w(S+1,s,k+1,r,o),this.H(g,A)}return[new w.DiffChange(a,s-a+1,e,r-e+1)]}x(a,s,e,r,o,l,u,D,S,k,g,A,L,F,c,p,m,v){let M=null,V=null,x=new d,Z=s,ee=e,se=L[0]-p[0]-r,he=-1073741824,ue=this.k.length-1;do{const de=se+a;de===Z||de<ee&&S[de-1]<S[de+1]?(g=S[de+1],F=g-se-r,g<he&&x.MarkNextChange(),he=g,x.AddModifiedElement(g+1,F),se=de+1-a):(g=S[de-1]+1,F=g-se-r,g<he&&x.MarkNextChange(),he=g-1,x.AddOriginalElement(g,F+1),se=de-1-a),ue>=0&&(S=this.k[ue],a=S[0],Z=1,ee=S.length-1)}while(--ue>=-1);if(M=x.getReverseChanges(),v[0]){let de=L[0]+1,we=p[0]+1;if(M!==null&&M.length>0){const Te=M[M.length-1];de=Math.max(de,Te.getOriginalEnd()),we=Math.max(we,Te.getModifiedEnd())}V=[new w.DiffChange(de,A-de+1,we,c-we+1)]}else{x=new d,Z=l,ee=u,se=L[0]-p[0]-D,he=1073741824,ue=m?this.m.length-1:this.m.length-2;do{const de=se+o;de===Z||de<ee&&k[de-1]>=k[de+1]?(g=k[de+1]-1,F=g-se-D,g>he&&x.MarkNextChange(),he=g+1,x.AddOriginalElement(g+1,F+1),se=de+1-o):(g=k[de-1],F=g-se-D,g>he&&x.MarkNextChange(),he=g,x.AddModifiedElement(g+1,F+1),se=de-1-o),ue>=0&&(k=this.m[ue],o=k[0],Z=1,ee=k.length-1)}while(--ue>=-1);V=x.getChanges()}return this.H(M,V)}y(a,s,e,r,o,l,u){let D=0,S=0,k=0,g=0,A=0,L=0;a--,e--,o[0]=0,l[0]=0,this.k=[],this.m=[];const F=s-a+(r-e),c=F+1,p=new Int32Array(c),m=new Int32Array(c),v=r-e,M=s-a,V=a-e,x=s-r,ee=(M-v)%2===0;p[v]=a,m[M]=s,u[0]=!1;for(let se=1;se<=F/2+1;se++){let he=0,ue=0;k=this.J(v-se,se,v,c),g=this.J(v+se,se,v,c);for(let we=k;we<=g;we+=2){we===k||we<g&&p[we-1]<p[we+1]?D=p[we+1]:D=p[we-1]+1,S=D-(we-v)-V;const Te=D;for(;D<s&&S<r&&this.p(D+1,S+1);)D++,S++;if(p[we]=D,D+S>he+ue&&(he=D,ue=S),!ee&&Math.abs(we-M)<=se-1&&D>=m[we])return o[0]=D,l[0]=S,Te<=m[we]&&1447>0&&se<=1447+1?this.x(v,k,g,V,M,A,L,x,p,m,D,s,o,S,r,l,ee,u):null}const de=(he-a+(ue-e)-se)/2;if(this.a!==null&&!this.a(he,de))return u[0]=!0,o[0]=he,l[0]=ue,de>0&&1447>0&&se<=1447+1?this.x(v,k,g,V,M,A,L,x,p,m,D,s,o,S,r,l,ee,u):(a++,e++,[new w.DiffChange(a,s-a+1,e,r-e+1)]);A=this.J(M-se,se,M,c),L=this.J(M+se,se,M,c);for(let we=A;we<=L;we+=2){we===A||we<L&&m[we-1]>=m[we+1]?D=m[we+1]-1:D=m[we-1],S=D-(we-M)-x;const Te=D;for(;D>a&&S>e&&this.p(D,S);)D--,S--;if(m[we]=D,ee&&Math.abs(we-v)<=se&&D<=p[we])return o[0]=D,l[0]=S,Te>=p[we]&&1447>0&&se<=1447+1?this.x(v,k,g,V,M,A,L,x,p,m,D,s,o,S,r,l,ee,u):null}if(se<=1447){let we=new Int32Array(g-k+2);we[0]=v-k+1,b.Copy2(p,k,we,1,g-k+1),this.k.push(we),we=new Int32Array(L-A+2),we[0]=M-A+1,b.Copy2(m,A,we,1,L-A+1),this.m.push(we)}}return this.x(v,k,g,V,M,A,L,x,p,m,D,s,o,S,r,l,ee,u)}z(a){for(let s=0;s<a.length;s++){const e=a[s],r=s<a.length-1?a[s+1].originalStart:this.f.length,o=s<a.length-1?a[s+1].modifiedStart:this.h.length,l=e.originalLength>0,u=e.modifiedLength>0;for(;e.originalStart+e.originalLength<r&&e.modifiedStart+e.modifiedLength<o&&(!l||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!u||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const S=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!S)break;e.originalStart++,e.modifiedStart++}const D=[null];if(s<a.length-1&&this.I(a[s],a[s+1],D)){a[s]=D[0],a.splice(s+1,1),s--;continue}}for(let s=a.length-1;s>=0;s--){const e=a[s];let r=0,o=0;if(s>0){const g=a[s-1];r=g.originalStart+g.originalLength,o=g.modifiedStart+g.modifiedLength}const l=e.originalLength>0,u=e.modifiedLength>0;let D=0,S=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let g=1;;g++){const A=e.originalStart-g,L=e.modifiedStart-g;if(A<r||L<o||l&&!this.s(A,A+e.originalLength)||u&&!this.u(L,L+e.modifiedLength))break;const c=(A===r&&L===o?5:0)+this.G(A,e.originalLength,L,e.modifiedLength);c>S&&(S=c,D=g)}e.originalStart-=D,e.modifiedStart-=D;const k=[null];if(s>0&&this.I(a[s-1],a[s],k)){a[s-1]=k[0],a.splice(s,1),s++;continue}}if(this.d)for(let s=1,e=a.length;s<e;s++){const r=a[s-1],o=a[s],l=o.originalStart-r.originalStart-r.originalLength,u=r.originalStart,D=o.originalStart+o.originalLength,S=D-u,k=r.modifiedStart,g=o.modifiedStart+o.modifiedLength,A=g-k;if(l<5&&S<20&&A<20){const L=this.A(u,S,k,A,l);if(L){const[F,c]=L;(F!==r.originalStart+r.originalLength||c!==r.modifiedStart+r.modifiedLength)&&(r.originalLength=F-r.originalStart,r.modifiedLength=c-r.modifiedStart,o.originalStart=F+l,o.modifiedStart=c+l,o.originalLength=D-o.originalStart,o.modifiedLength=g-o.modifiedStart)}}}return a}A(a,s,e,r,o){if(s<o||r<o)return null;const l=a+s-o+1,u=e+r-o+1;let D=0,S=0,k=0;for(let g=a;g<l;g++)for(let A=e;A<u;A++){const L=this.B(g,A,o);L>0&&L>D&&(D=L,S=g,k=A)}return D>0?[S,k]:null}B(a,s,e){let r=0;for(let o=0;o<e;o++){if(!this.p(a+o,s+o))return 0;r+=this.e[a+o].length}return r}C(a){return a<=0||a>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[a])}D(a,s){if(this.C(a)||this.C(a-1))return!0;if(s>0){const e=a+s;if(this.C(e-1)||this.C(e))return!0}return!1}E(a){return a<=0||a>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[a])}F(a,s){if(this.E(a)||this.E(a-1))return!0;if(s>0){const e=a+s;if(this.E(e-1)||this.E(e))return!0}return!1}G(a,s,e,r){const o=this.D(a,s)?1:0,l=this.F(e,r)?1:0;return o+l}H(a,s){const e=[];if(a.length===0||s.length===0)return s.length>0?s:a;if(this.I(a[a.length-1],s[0],e)){const r=new Array(a.length+s.length-1);return b.Copy(a,0,r,0,a.length-1),r[a.length-1]=e[0],b.Copy(s,1,r,a.length,s.length-1),r}else{const r=new Array(a.length+s.length);return b.Copy(a,0,r,0,a.length),b.Copy(s,0,r,a.length,s.length),r}}I(a,s,e){if(y.Assert(a.originalStart<=s.originalStart,"Left change is not less than or equal to right change"),y.Assert(a.modifiedStart<=s.modifiedStart,"Left change is not less than or equal to right change"),a.originalStart+a.originalLength>=s.originalStart||a.modifiedStart+a.modifiedLength>=s.modifiedStart){const r=a.originalStart;let o=a.originalLength;const l=a.modifiedStart;let u=a.modifiedLength;return a.originalStart+a.originalLength>=s.originalStart&&(o=s.originalStart+s.originalLength-a.originalStart),a.modifiedStart+a.modifiedLength>=s.modifiedStart&&(u=s.modifiedStart+s.modifiedLength-a.modifiedStart),e[0]=new w.DiffChange(r,o,l,u),!0}else return e[0]=null,!1}J(a,s,e,r){if(a>=0&&a<r)return a;const o=e,l=r-e-1,u=s%2===0;if(a<0){const D=o%2===0;return u===D?0:1}else{const D=l%2===0;return u===D?r-1:r-2}}}t.LcsDiff=h}),define(ge[33],me([1,0,13,32,11]),function(J,t,w,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=void 0;const z="$(",y=new RegExp(`\\$\\(${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${y.source}`,"g");function f(o){return o.replace(b,(l,u)=>u?l:`\\${l}`)}t.escapeIcons=f;const d=new RegExp(`\\\\${y.source}`,"g");function h(o){return o.replace(d,l=>`\\${l}`)}t.markdownEscapeEscapedIcons=h;const N=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function a(o){return o.indexOf(z)===-1?o:o.replace(N,(l,u,D,S)=>D?l:u||S||"")}t.stripIcons=a;const s=new RegExp(`\\$\\(${w.CSSIcon.iconNameCharacter}+\\)`,"g");function e(o){s.lastIndex=0;let l="";const u=[];let D=0;for(;;){const S=s.lastIndex,k=s.exec(o),g=o.substring(S,k?.index);if(g.length>0){l+=g;for(let A=0;A<g.length;A++)u.push(D)}if(!k)break;D+=k[0].length}return{text:l,iconOffsets:u}}t.parseLabelWithIcons=e;function r(o,l,u=!1){const{text:D,iconOffsets:S}=l;if(!S||S.length===0)return(0,i.matchesFuzzy)(o,D,u);const k=(0,U.ltrim)(D," "),g=D.length-k.length,A=(0,i.matchesFuzzy)(o,k,u);if(A)for(const L of A){const F=S[L.start+g]+g;L.start+=F,L.end+=F}return A}t.matchesFuzzyIconAware=r}),define(ge[113],me([1,0,14,11]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class U{constructor(){this.b="",this.c=0}reset(s){return this.b=s,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(s){const e=s.charCodeAt(0),r=this.b.charCodeAt(this.c);return e-r}value(){return this.b[this.c]}}t.StringIterator=U;class z{constructor(s=!0){this.e=s}reset(s){return this.b=s,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let s=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(s)this.c++;else break;else s=!1;return this}cmp(s){return this.e?(0,i.compareSubstring)(s,this.b,0,s.length,this.c,this.d):(0,i.compareSubstringIgnoreCase)(s,this.b,0,s.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.ConfigKeysIterator=z;class y{constructor(s=!0,e=!0){this.f=s,this.g=e}reset(s){this.d=0,this.e=0,this.b=s,this.c=s.length;for(let e=s.length-1;e>=0;e--,this.c--){const r=this.b.charCodeAt(e);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let s=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(s)this.d++;else break;else s=!1}return this}cmp(s){return this.g?(0,i.compareSubstring)(s,this.b,0,s.length,this.d,this.e):(0,i.compareSubstringIgnoreCase)(s,this.b,0,s.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.PathIterator=y;var b;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(b||(b={}));class f{constructor(s,e){this.f=s,this.g=e,this.d=[],this.e=0}reset(s){return this.c=s,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new y(!1,!this.f(s)),this.b.reset(s.path),this.b.value()&&this.d.push(3)),this.g(s)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(s){if(this.d[this.e]===1)return(0,i.compareIgnoreCase)(s,this.c.scheme);if(this.d[this.e]===2)return(0,i.compareIgnoreCase)(s,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(s);if(this.d[this.e]===4)return(0,i.compare)(s,this.c.query);if(this.d[this.e]===5)return(0,i.compare)(s,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.UriIterator=f;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const s=this.right;return this.right=s.left,s.left=this,this.updateHeight(),s.updateHeight(),s}rotateRight(){const s=this.left;return this.left=s.right,s.right=this,this.updateHeight(),s.updateHeight(),s}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(h||(h={}));class N{static forUris(s=()=>!1,e=()=>!1){return new N(new f(s,e))}static forPaths(s=!1){return new N(new y(void 0,!s))}static forStrings(){return new N(new U)}static forConfigKeys(){return new N(new z)}constructor(s){this.b=s}clear(){this.c=void 0}fill(s,e){if(e){const r=e.slice(0);(0,w.shuffle)(r);for(const o of r)this.set(o,s)}else{const r=s.slice(0);(0,w.shuffle)(r);for(const o of r)this.set(o[0],o[1])}}set(s,e){const r=this.b.reset(s);let o;this.c||(this.c=new d,this.c.segment=r.value());const l=[];for(o=this.c;;){const D=r.cmp(o.segment);if(D>0)o.left||(o.left=new d,o.left.segment=r.value()),l.push([-1,o]),o=o.left;else if(D<0)o.right||(o.right=new d,o.right.segment=r.value()),l.push([1,o]),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new d,o.mid.segment=r.value()),l.push([0,o]),o=o.mid;else break}const u=o.value;o.value=e,o.key=s;for(let D=l.length-1;D>=0;D--){const S=l[D][1];S.updateHeight();const k=S.balanceFactor();if(k<-1||k>1){const g=l[D][0],A=l[D+1][0];if(g===1&&A===1)l[D][1]=S.rotateLeft();else if(g===-1&&A===-1)l[D][1]=S.rotateRight();else if(g===1&&A===-1)S.right=l[D+1][1]=l[D+1][1].rotateRight(),l[D][1]=S.rotateLeft();else if(g===-1&&A===1)S.left=l[D+1][1]=l[D+1][1].rotateLeft(),l[D][1]=S.rotateRight();else throw new Error;if(D>0)switch(l[D-1][0]){case-1:l[D-1][1].left=l[D][1];break;case 1:l[D-1][1].right=l[D][1];break;case 0:l[D-1][1].mid=l[D][1];break}else this.c=l[0][1]}}return u}get(s){return this.d(s)?.value}d(s){const e=this.b.reset(s);let r=this.c;for(;r;){const o=e.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(e.hasNext())e.next(),r=r.mid;else break}return r}has(s){const e=this.d(s);return!(e?.value===void 0&&e?.mid===void 0)}delete(s){return this.e(s,!1)}deleteSuperstr(s){return this.e(s,!0)}e(s,e){const r=this.b.reset(s),o=[];let l=this.c;for(;l;){const u=r.cmp(l.segment);if(u>0)o.push([-1,l]),l=l.left;else if(u<0)o.push([1,l]),l=l.right;else if(r.hasNext())r.next(),o.push([0,l]),l=l.mid;else break}if(!!l){if(e?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const u=this.f(l.right);if(u.key){const{key:D,value:S,segment:k}=u;this.e(u.key,!1),l.key=D,l.value=S,l.segment=k}}else{const u=l.left??l.right;if(o.length>0){const[D,S]=o[o.length-1];switch(D){case-1:S.left=u;break;case 0:S.mid=u;break;case 1:S.right=u;break}}else this.c=u}for(let u=o.length-1;u>=0;u--){const D=o[u][1];D.updateHeight();const S=D.balanceFactor();if(S>1?(D.right.balanceFactor()>=0||(D.right=D.right.rotateRight()),o[u][1]=D.rotateLeft()):S<-1&&(D.left.balanceFactor()<=0||(D.left=D.left.rotateLeft()),o[u][1]=D.rotateRight()),u>0)switch(o[u-1][0]){case-1:o[u-1][1].left=o[u][1];break;case 1:o[u-1][1].right=o[u][1];break;case 0:o[u-1][1].mid=o[u][1];break}else this.c=o[0][1]}}}f(s){for(;s.left;)s=s.left;return s}findSubstr(s){const e=this.b.reset(s);let r=this.c,o;for(;r;){const l=e.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(e.hasNext())e.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(s){return this.g(s,!1)}g(s,e){const r=this.b.reset(s);let o=this.c;for(;o;){const l=r.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this.h(o.mid):e?o.value:void 0}}hasElementOrSubtree(s){return this.g(s,!0)!==void 0}forEach(s){for(const[e,r]of this)s(r,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(s){const e=[];return this.j(s,e),e[Symbol.iterator]()}j(s,e){!s||(s.left&&this.j(s.left,e),s.value&&e.push([s.key,s.value]),s.mid&&this.j(s.mid,e),s.right&&this.j(s.right,e))}_isBalanced(){const s=e=>{if(!e)return!0;const r=e.balanceFactor();return r<-1||r>1?!1:s(e.left)&&s(e.right)};return s(this.c)}}t.TernarySearchTree=N}),define(ge[16],me([1,0,21,5]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const U=/^\w[\w\d+.-]*$/,z=/^\//,y=/^\/\//;function b(L,F){if(!L.scheme&&F)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${L.authority}", path: "${L.path}", query: "${L.query}", fragment: "${L.fragment}"}`);if(L.scheme&&!U.test(L.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(L.path){if(L.authority){if(!z.test(L.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(L.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(L,F){return!L&&!F?"file":L}function d(L,F){switch(L){case"https":case"http":case"file":F?F[0]!==N&&(F=N+F):F=N;break}return F}const h="",N="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(F){return F instanceof s?!0:F?typeof F.authority=="string"&&typeof F.fragment=="string"&&typeof F.path=="string"&&typeof F.query=="string"&&typeof F.scheme=="string"&&typeof F.fsPath=="string"&&typeof F.with=="function"&&typeof F.toString=="function":!1}constructor(F,c,p,m,v,M=!1){typeof F=="object"?(this.scheme=F.scheme||h,this.authority=F.authority||h,this.path=F.path||h,this.query=F.query||h,this.fragment=F.fragment||h):(this.scheme=f(F,M),this.authority=c||h,this.path=d(this.scheme,p||h),this.query=m||h,this.fragment=v||h,b(this,M))}get fsPath(){return D(this,!1)}with(F){if(!F)return this;let{scheme:c,authority:p,path:m,query:v,fragment:M}=F;return c===void 0?c=this.scheme:c===null&&(c=h),p===void 0?p=this.authority:p===null&&(p=h),m===void 0?m=this.path:m===null&&(m=h),v===void 0?v=this.query:v===null&&(v=h),M===void 0?M=this.fragment:M===null&&(M=h),c===this.scheme&&p===this.authority&&m===this.path&&v===this.query&&M===this.fragment?this:new r(c,p,m,v,M)}static parse(F,c=!1){const p=a.exec(F);return p?new r(p[2]||h,A(p[4]||h),A(p[5]||h),A(p[7]||h),A(p[9]||h),c):new r(h,h,h,h,h)}static file(F){let c=h;if(i.isWindows&&(F=F.replace(/\\/g,N)),F[0]===N&&F[1]===N){const p=F.indexOf(N,2);p===-1?(c=F.substring(2),F=N):(c=F.substring(2,p),F=F.substring(p)||N)}return new r("file",c,F,h,h)}static from(F){const c=new r(F.scheme,F.authority,F.path,F.query,F.fragment);return b(c,!0),c}static joinPath(F,...c){if(!F.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return i.isWindows&&F.scheme==="file"?p=s.file(w.win32.join(D(F,!0),...c)).path:p=w.posix.join(F.path,...c),F.with({path:p})}toString(F=!1){return S(this,F)}toJSON(){return this}static revive(F){if(F){if(F instanceof s)return F;{const c=new r(F);return c._formatted=F.external,c._fsPath=F._sep===e?F.fsPath:null,c}}else return F}}t.URI=s;const e=i.isWindows?1:void 0;class r extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=D(this,!1)),this._fsPath}toString(F=!1){return F?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const F={$mid:1};return this._fsPath&&(F.fsPath=this._fsPath,F._sep=e),this._formatted&&(F.external=this._formatted),this.path&&(F.path=this.path),this.scheme&&(F.scheme=this.scheme),this.authority&&(F.authority=this.authority),this.query&&(F.query=this.query),this.fragment&&(F.fragment=this.fragment),F}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(L,F,c){let p,m=-1;for(let v=0;v<L.length;v++){const M=L.charCodeAt(v);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||F&&M===47||c&&M===91||c&&M===93||c&&M===58)m!==-1&&(p+=encodeURIComponent(L.substring(m,v)),m=-1),p!==void 0&&(p+=L.charAt(v));else{p===void 0&&(p=L.substr(0,v));const V=o[M];V!==void 0?(m!==-1&&(p+=encodeURIComponent(L.substring(m,v)),m=-1),p+=V):m===-1&&(m=v)}}return m!==-1&&(p+=encodeURIComponent(L.substring(m))),p!==void 0?p:L}function u(L){let F;for(let c=0;c<L.length;c++){const p=L.charCodeAt(c);p===35||p===63?(F===void 0&&(F=L.substr(0,c)),F+=o[p]):F!==void 0&&(F+=L[c])}return F!==void 0?F:L}function D(L,F){let c;return L.authority&&L.path.length>1&&L.scheme==="file"?c=`//${L.authority}${L.path}`:L.path.charCodeAt(0)===47&&(L.path.charCodeAt(1)>=65&&L.path.charCodeAt(1)<=90||L.path.charCodeAt(1)>=97&&L.path.charCodeAt(1)<=122)&&L.path.charCodeAt(2)===58?F?c=L.path.substr(1):c=L.path[1].toLowerCase()+L.path.substr(2):c=L.path,i.isWindows&&(c=c.replace(/\//g,"\\")),c}t.uriToFsPath=D;function S(L,F){const c=F?u:l;let p="",{scheme:m,authority:v,path:M,query:V,fragment:x}=L;if(m&&(p+=m,p+=":"),(v||m==="file")&&(p+=N,p+=N),v){let Z=v.indexOf("@");if(Z!==-1){const ee=v.substr(0,Z);v=v.substr(Z+1),Z=ee.lastIndexOf(":"),Z===-1?p+=c(ee,!1,!1):(p+=c(ee.substr(0,Z),!1,!1),p+=":",p+=c(ee.substr(Z+1),!1,!0)),p+="@"}v=v.toLowerCase(),Z=v.lastIndexOf(":"),Z===-1?p+=c(v,!1,!0):(p+=c(v.substr(0,Z),!1,!0),p+=v.substr(Z))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const Z=M.charCodeAt(1);Z>=65&&Z<=90&&(M=`/${String.fromCharCode(Z+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const Z=M.charCodeAt(0);Z>=65&&Z<=90&&(M=`${String.fromCharCode(Z+32)}:${M.substr(2)}`)}p+=c(M,!0,!1)}return V&&(p+="?",p+=c(V,!1,!1)),x&&(p+="#",p+=F?x:l(x,!1,!1)),p}function k(L){try{return decodeURIComponent(L)}catch{return L.length>3?L.substr(0,3)+k(L.substr(3)):L}}const g=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function A(L){return L.match(g)?L.replace(g,F=>k(F)):L}}),define(ge[50],me([1,0,29,11,16]),function(J,t,w,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function z(d){return JSON.stringify(d,b)}t.stringify=z;function y(d){let h=JSON.parse(d);return h=f(h),h}t.parse=y;function b(d,h){return h instanceof RegExp?{$mid:2,source:h.source,flags:(0,i.regExpFlags)(h)}:h}function f(d,h=0){if(!d||h>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return U.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 16:return new Date(d.source)}if(d instanceof w.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let N=0;N<d.length;++N)d[N]=f(d[N],h+1);else for(const N in d)Object.hasOwnProperty.call(d,N)&&(d[N]=f(d[N],h+1))}return d}t.revive=f}),define(ge[34],me([1,0,6,5,16]),function(J,t,w,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var z;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebook="vscode-notebook",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractive="vscode-interactive",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(z=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${z.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${z.vscodeRemoteResource}`}set(h,N,a){this.a[h]=N,this.b[h]=a}setConnectionToken(h,N){this.c[h]=N}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(o){return w.onUnexpectedError(o),h}const N=h.authority;let a=this.a[N];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const s=this.b[N],e=this.c[N];let r=`path=${encodeURIComponent(h.path)}`;return typeof e=="string"&&(r+=`&${t.connectionTokenQueryName}=${encodeURIComponent(e)}`),U.URI.from({scheme:i.isWeb?this.d:z.vscodeRemoteResource,authority:`${a}:${s}`,path:this.f,query:r})}}t.RemoteAuthorities=new y,t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class b{asBrowserUri(h){const N=this.b(h,J);return this.uriToBrowserUri(N)}uriToBrowserUri(h){return h.scheme===z.vscodeRemote?t.RemoteAuthorities.rewrite(h):h.scheme===z.file&&(i.isNative||i.isWebWorker&&i.globals.origin===`${z.vscodeFileResource}://${b.a}`)?h.with({scheme:z.vscodeFileResource,authority:h.authority||b.a,query:null,fragment:null}):h}asFileUri(h){const N=this.b(h,J);return this.uriToFileUri(N)}uriToFileUri(h){return h.scheme===z.vscodeFileResource?h.with({scheme:z.file,authority:h.authority!==b.a?h.authority:null,query:null,fragment:null}):h}b(h,N){return U.URI.isUri(h)?h:U.URI.parse(N.toUrl(h))}}b.a="vscode-app",t.FileAccess=new b;var f;(function(d){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(h.get("3"));const N="vscode-coi";function a(e){let r;typeof e=="string"?r=new URL(e).searchParams:e instanceof URL?r=e.searchParams:U.URI.isUri(e)&&(r=new URL(e.toString(!0)).searchParams);const o=r?.get(N);if(!!o)return h.get(o)}d.getHeadersFromQuery=a;function s(e,r,o){if(!globalThis.crossOriginIsolated)return;const l=r&&o?"3":o?"2":"1";e instanceof URLSearchParams?e.set(N,l):e[N]=l}d.addSearchParam=s})(f=t.COI||(t.COI={}))}),define(ge[35],me([1,0,110,34,21,5,11,16]),function(J,t,w,i,U,z,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function f(s){return(0,b.uriToFsPath)(s,!0)}t.originalFSPath=f;class d{constructor(e){this.a=e}compare(e,r,o=!1){return e===r?0:(0,y.compare)(this.getComparisonKey(e,o),this.getComparisonKey(r,o))}isEqual(e,r,o=!1){return e===r?!0:!e||!r?!1:this.getComparisonKey(e,o)===this.getComparisonKey(r,o)}getComparisonKey(e,r=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,r,o=!1){if(e.scheme===r.scheme){if(e.scheme===i.Schemas.file)return w.isEqualOrParent(f(e),f(r),this.a(e))&&e.query===r.query&&(o||e.fragment===r.fragment);if((0,t.isEqualAuthority)(e.authority,r.authority))return w.isEqualOrParent(e.path,r.path,this.a(e),"/")&&e.query===r.query&&(o||e.fragment===r.fragment)}return!1}joinPath(e,...r){return b.URI.joinPath(e,...r)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return U.posix.basename(e.path)}extname(e){return U.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let r;return e.scheme===i.Schemas.file?r=b.URI.file(U.dirname(f(e))).path:(r=U.posix.dirname(e.path),e.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),r="/")),e.with({path:r})}normalizePath(e){if(!e.path.length)return e;let r;return e.scheme===i.Schemas.file?r=b.URI.file(U.normalize(f(e))).path:r=U.posix.normalize(e.path),e.with({path:r})}relativePath(e,r){if(e.scheme!==r.scheme||!(0,t.isEqualAuthority)(e.authority,r.authority))return;if(e.scheme===i.Schemas.file){const u=U.relative(f(e),f(r));return z.isWindows?w.toSlashes(u):u}let o=e.path||"/";const l=r.path||"/";if(this.a(e)){let u=0;for(const D=Math.min(o.length,l.length);u<D&&!(o.charCodeAt(u)!==l.charCodeAt(u)&&o.charAt(u).toLowerCase()!==l.charAt(u).toLowerCase());u++);o=l.substr(0,u)+o.substr(u)}return U.posix.relative(o,l)}resolvePath(e,r){if(e.scheme===i.Schemas.file){const o=b.URI.file(U.resolve(f(e),r));return e.with({authority:o.authority,path:o.path})}return r=w.toPosixPath(r),e.with({path:U.posix.resolve(e.path,r)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,r){return e===r||e!==void 0&&r!==void 0&&(0,y.equalsIgnoreCase)(e,r)}hasTrailingPathSeparator(e,r=U.sep){if(e.scheme===i.Schemas.file){const o=f(e);return o.length>w.getRoot(o).length&&o[o.length-1]===r}else{const o=e.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,r=U.sep){return(0,t.hasTrailingPathSeparator)(e,r)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,r=U.sep){let o=!1;if(e.scheme===i.Schemas.file){const l=f(e);o=l!==void 0&&l.length===w.getRoot(l).length&&l[l.length-1]===r}else{r="/";const l=e.path;o=l.length===1&&l.charCodeAt(l.length-1)===47}return!o&&!(0,t.hasTrailingPathSeparator)(e,r)?e.with({path:e.path+"/"}):e}}t.ExtUri=d,t.extUri=new d(()=>!1),t.extUriBiasedIgnorePathCase=new d(s=>s.scheme===i.Schemas.file?!z.isLinux:!0),t.extUriIgnorePathCase=new d(s=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function h(s,e){const r=[];for(let o=0;o<s.length;o++){const l=e(s[o]);s.some((u,D)=>D===o?!1:(0,t.isEqualOrParent)(l,e(u)))||r.push(s[o])}return r}t.distinctParents=h;var N;(function(s){s.META_DATA_LABEL="label",s.META_DATA_DESCRIPTION="description",s.META_DATA_SIZE="size",s.META_DATA_MIME="mime";function e(r){const o=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(D=>{const[S,k]=D.split(":");S&&k&&o.set(S,k)});const u=r.path.substring(0,r.path.indexOf(";"));return u&&o.set(s.META_DATA_MIME,u),o}s.parseMetaData=e})(N=t.DataUri||(t.DataUri={}));function a(s,e,r){if(e){let o=s.path;return o&&o[0]!==U.posix.sep&&(o=U.posix.sep+o),s.with({scheme:r,authority:e,path:o})}return s.with({scheme:r})}t.toLocalResource=a}),define(ge[9],me([1,0,26,6,3,2,35,5]),function(J,t,w,i,U,z,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function f(te){return!!te&&typeof te.then=="function"}t.isThenable=f;function d(te){const W=new w.CancellationTokenSource,n=te(W.token),E=new Promise((P,$)=>{const K=W.token.onCancellationRequested(()=>{K.dispose(),W.dispose(),$(new i.CancellationError)});Promise.resolve(n).then(C=>{K.dispose(),W.dispose(),P(C)},C=>{K.dispose(),W.dispose(),$(C)})});return new class{cancel(){W.cancel()}then(P,$){return E.then(P,$)}catch(P){return this.then(void 0,P)}finally(P){return E.finally(P)}}}t.createCancelablePromise=d;function h(te,W,n){return new Promise((E,P)=>{const $=W.onCancellationRequested(()=>{$.dispose(),E(n)});te.then(E,P).finally(()=>$.dispose())})}t.raceCancellation=h;function N(te,W){return new Promise((n,E)=>{const P=W.onCancellationRequested(()=>{P.dispose(),E(new i.CancellationError)});te.then(n,E).finally(()=>P.dispose())})}t.raceCancellationError=N;async function a(te){let W=-1;const n=te.map((P,$)=>P.then(K=>(W=$,K))),E=await Promise.race(n);return te.forEach((P,$)=>{$!==W&&P.cancel()}),E}t.raceCancellablePromises=a;function s(te,W,n){let E;const P=setTimeout(()=>{E?.(void 0),n?.()},W);return Promise.race([te.finally(()=>clearTimeout(P)),new Promise($=>E=$)])}t.raceTimeout=s;function e(te){return new Promise((W,n)=>{const E=te();f(E)?E.then(W,n):W(E)})}t.asPromise=e;class r{constructor(){this.a=null,this.b=null,this.d=null}queue(W){if(this.a){if(this.d=W,!this.b){const n=()=>{this.b=null;const E=this.queue(this.d);return this.d=null,E};this.b=new Promise(E=>{this.a.then(n,n).then(E)})}return new Promise((n,E)=>{this.b.then(n,E)})}return this.a=W(),new Promise((n,E)=>{this.a.then(P=>{this.a=null,n(P)},P=>{this.a=null,E(P)})})}}t.Throttler=r;class o{constructor(){this.a=Promise.resolve(null)}queue(W){return this.a=this.a.then(()=>W(),()=>W())}}t.Sequencer=o;class l{constructor(){this.a=new Map}queue(W,n){const P=(this.a.get(W)??Promise.resolve()).catch(()=>{}).then(n).finally(()=>{this.a.get(W)===P&&this.a.delete(W)});return this.a.set(W,P),P}}t.SequencerByKey=l;const u=(te,W)=>{let n=!0;const E=setTimeout(()=>{n=!1,W()},te);return{isTriggered:()=>n,dispose:()=>{clearTimeout(E),n=!1}}},D=te=>{let W=!0;return queueMicrotask(()=>{W&&(W=!1,te())}),{isTriggered:()=>W,dispose:()=>{W=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class S{constructor(W){this.defaultDelay=W,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(W,n=this.defaultDelay){this.g=W,this.h(),this.b||(this.b=new Promise((P,$)=>{this.d=P,this.f=$}).then(()=>{if(this.b=null,this.d=null,this.g){const P=this.g;return this.g=null,P()}}));const E=()=>{this.a=null,this.d?.(null)};return this.a=n===t.MicrotaskDelay?D(E):u(n,E),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.Delayer=S;class k{constructor(W){this.a=new S(W),this.b=new r}trigger(W,n){return this.a.trigger(()=>this.b.queue(W),n)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}t.ThrottledDelayer=k;class g{constructor(){this.a=!1,this.b=new Promise((W,n)=>{this.d=W})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.Barrier=g;class A extends g{constructor(W){super(),this.f=setTimeout(()=>this.open(),W)}open(){clearTimeout(this.f),super.open()}}t.AutoOpenBarrier=A;function L(te,W){return W?new Promise((n,E)=>{const P=setTimeout(()=>{$.dispose(),n()},te),$=W.onCancellationRequested(()=>{clearTimeout(P),$.dispose(),E(new i.CancellationError)})}):d(n=>L(te,n))}t.timeout=L;function F(te,W=0){const n=setTimeout(te,W);return(0,z.toDisposable)(()=>clearTimeout(n))}t.disposableTimeout=F;function c(te){const W=[];let n=0;const E=te.length;function P(){return n<E?te[n++]():null}function $(K){K!=null&&W.push(K);const C=P();return C?C.then($):Promise.resolve(W)}return Promise.resolve(null).then($)}t.sequence=c;function p(te,W=E=>!!E,n=null){let E=0;const P=te.length,$=()=>{if(E>=P)return Promise.resolve(n);const K=te[E++];return Promise.resolve(K()).then(I=>W(I)?Promise.resolve(I):$())};return $()}t.first=p;function m(te,W=E=>!!E,n=null){if(te.length===0)return Promise.resolve(n);let E=te.length;const P=()=>{E=-1;for(const $ of te)$.cancel?.()};return new Promise(($,K)=>{for(const C of te)C.then(I=>{--E>=0&&W(I)?(P(),$(I)):E===0&&$(n)}).catch(I=>{--E>=0&&(P(),K(I))})})}t.firstParallel=m;class v{constructor(W){this.a=0,this.d=W,this.f=[],this.b=0,this.g=new U.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(W){return this.a++,new Promise((n,E)=>{this.f.push({factory:W,c:n,e:E}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const W=this.f.shift();this.b++;const n=W.factory();n.then(W.c,W.e),n.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.Limiter=v;class M extends v{constructor(){super(1)}}t.Queue=M;class V{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const W=new Oe;return this.b.add(W),W.p}d(){for(const[,W]of this.a)if(W.size>0)return!1;return!0}queueFor(W,n=y.extUri){const E=n.getComparisonKey(W);let P=this.a.get(E);return P||(P=new M,U.Event.once(P.onDrained)(()=>{P?.dispose(),this.a.delete(E),this.f()}),this.a.set(E,P)),P}f(){!this.d()||this.g()}g(){for(const W of this.b)W.complete();this.b.clear()}dispose(){for(const[,W]of this.a)W.dispose();this.a.clear(),this.g()}}t.ResourceQueue=V;class x{constructor(W,n){this.a=-1,typeof W=="function"&&typeof n=="number"&&this.setIfNotSet(W,n)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(W,n){this.cancel(),this.a=setTimeout(()=>{this.a=-1,W()},n)}setIfNotSet(W,n){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,W()},n))}}t.TimeoutTimer=x;class Z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(W,n){this.cancel(),this.a=setInterval(()=>{W()},n)}}t.IntervalTimer=Z;class ee{constructor(W,n){this.b=-1,this.a=W,this.d=n,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(W=this.d){this.cancel(),this.b=setTimeout(this.f,W)}get delay(){return this.d}set delay(W){this.d=W}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.RunOnceScheduler=ee;class se{constructor(W,n){n%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${n}ms is not a multiple of 1000ms.`),this.a=W,this.b=n,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(W=this.b){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(W/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.ProcessTimeRunOnceScheduler=se;class he extends ee{constructor(W,n){super(W,n),this.j=[]}work(W){this.j.push(W),this.isScheduled()||this.schedule()}h(){const W=this.j;this.j=[],this.a?.(W)}dispose(){this.j=[],super.dispose()}}t.RunOnceWorker=he;class ue extends z.Disposable{constructor(W,n){super(),this.g=W,this.h=n,this.a=[],this.b=this.B(new z.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(W){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+W.length>this.g.maxBufferedWork)return!1}else if(this.pending+W.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const n of W)this.a.push(n);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.ThrottledWorker=ue,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=te=>{(0,b.setTimeout0)(()=>{if(W)return;const n=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,n-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0)}}}:t.runWhenIdle=(te,W)=>{const n=requestIdleCallback(te,typeof W=="number"?{timeout:W}:void 0);let E=!1;return{dispose(){E||(E=!0,cancelIdleCallback(n))}}}}();class de{constructor(W){this.d=!1,this.a=()=>{try{this.f=W()}catch(n){this.g=n}finally{this.d=!0}},this.b=(0,t.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.IdleValue=de;async function we(te,W,n){let E;for(let P=0;P<n;P++)try{return await te()}catch($){E=$,await L(W)}throw E}t.retry=we;class Te{hasPending(W){return this.a?typeof W=="number"?this.a.taskId===W:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(W,n,E){return this.a={taskId:W,cancel:()=>E?.(),promise:n},n.then(()=>this.d(W),()=>this.d(W)),n}d(W){this.a&&W===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const W=this.b;this.b=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}setNext(W){if(this.b)this.b.run=W;else{let n,E;const P=new Promise(($,K)=>{n=$,E=K});this.b={run:W,promise:P,promiseResolve:n,promiseReject:E}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.TaskSequentializer=Te;class Me{constructor(W,n=()=>Date.now()){this.d=W,this.f=n,this.a=0,this.b=0}increment(){const W=this.f();return W-this.a>this.d&&(this.a=W,this.b=0),this.b++,this.b}}t.IntervalCounter=Me;class Oe{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((W,n)=>{this.a=W,this.b=n})}complete(W){return new Promise(n=>{this.a(W),this.f=!0,n()})}error(W){return new Promise(n=>{this.b(W),this.d=!0,n()})}cancel(){new Promise(W=>{this.b(new i.CancellationError),this.d=!0,W()})}}t.DeferredPromise=Oe;var j;(function(te){async function W(E){let P;const $=await Promise.all(E.map(K=>K.then(C=>C,C=>{P||(P=C)})));if(typeof P<"u")throw P;return $}te.settled=W;function n(E){return new Promise(async(P,$)=>{try{await E(P,$)}catch(K){$(K)}})}te.withAsyncBody=n})(j=t.Promises||(t.Promises={}));var Y;(function(te){te[te.Initial=0]="Initial",te[te.DoneOK=1]="DoneOK",te[te.DoneError=2]="DoneError"})(Y||(Y={}));class ie{static fromArray(W){return new ie(n=>{n.emitMany(W)})}static fromPromise(W){return new ie(async n=>{n.emitMany(await W)})}static fromPromises(W){return new ie(async n=>{await Promise.all(W.map(async E=>n.emitOne(await E)))})}static merge(W){return new ie(async n=>{await Promise.all(W.map(async E=>{for await(const P of E)n.emitOne(P)}))})}constructor(W){this.a=0,this.b=[],this.d=null,this.f=new U.Emitter,queueMicrotask(async()=>{const n={emitOne:E=>this.g(E),emitMany:E=>this.h(E),reject:E=>this.k(E)};try{await Promise.resolve(W(n)),this.j()}catch(E){this.k(E)}finally{n.emitOne=void 0,n.emitMany=void 0,n.reject=void 0}})}[Symbol.asyncIterator](){let W=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(W<this.b.length)return{done:!1,value:this.b[W++]};if(this.a===1)return{done:!0,value:void 0};await U.Event.toPromise(this.f.event)}while(!0)}}}static map(W,n){return new ie(async E=>{for await(const P of W)E.emitOne(n(P))})}map(W){return ie.map(this,W)}static filter(W,n){return new ie(async E=>{for await(const P of W)n(P)&&E.emitOne(P)})}filter(W){return ie.filter(this,W)}static coalesce(W){return ie.filter(W,n=>!!n)}coalesce(){return ie.coalesce(this)}static async toPromise(W){const n=[];for await(const E of W)n.push(E);return n}toPromise(){return ie.toPromise(this)}g(W){this.a===0&&(this.b.push(W),this.f.fire())}h(W){this.a===0&&(this.b=this.b.concat(W),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(W){this.a===0&&(this.a=2,this.d=W,this.f.fire())}}t.AsyncIterableObject=ie,ie.EMPTY=ie.fromArray([]);class ne extends ie{constructor(W,n){super(n),this.l=W}cancel(){this.l.cancel()}}t.CancelableAsyncIterableObject=ne;function ae(te){const W=new w.CancellationTokenSource,n=te(W.token);return new ne(W,async E=>{const P=W.token.onCancellationRequested(()=>{P.dispose(),W.dispose(),E.reject(new i.CancellationError)});try{for await(const $ of n){if(W.token.isCancellationRequested)return;E.emitOne($)}P.dispose(),W.dispose()}catch($){P.dispose(),W.dispose(),E.reject($)}})}t.createCancelableAsyncIterable=ae}),define(ge[4],me([1,0,17,108,15,20,9,6,3,114,2,34,5,7,16]),function(J,t,w,i,U,z,y,b,f,d,h,N,a,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCssValueWithDefault=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.isEventLike=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function r(X){for(;X.firstChild;)X.firstChild.remove()}t.clearNode=r;function o(X){return X?.isConnected??!1}t.isInDOM=o;class l{constructor(G,fe,Se,ke){this.f=G,this.g=fe,this.d=Se,this.j=ke||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){!this.d||(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function u(X,G,fe,Se){return new l(X,G,fe,Se)}t.addDisposableListener=u;function D(X){return function(G){return X(new z.StandardMouseEvent(G))}}function S(X){return function(G){return X(new U.StandardKeyboardEvent(G))}}const k=function(G,fe,Se,ke){let qe=Se;return fe==="click"||fe==="mousedown"?qe=D(Se):(fe==="keydown"||fe==="keypress"||fe==="keyup")&&(qe=S(Se)),u(G,fe,qe,ke)};t.addStandardDisposableListener=k;const g=function(G,fe,Se){const ke=D(fe);return L(G,ke,Se)};t.addStandardDisposableGenericMouseDownListener=g;const A=function(G,fe,Se){const ke=D(fe);return c(G,ke,Se)};t.addStandardDisposableGenericMouseUpListener=A;function L(X,G,fe){return u(X,a.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,G,fe)}t.addDisposableGenericMouseDownListener=L;function F(X,G,fe){return u(X,a.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,G,fe)}t.addDisposableGenericMouseMoveListener=F;function c(X,G,fe){return u(X,a.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,G,fe)}t.addDisposableGenericMouseUpListener=c;class p{constructor(G,fe=0){this.d=G,this.priority=fe,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(G){(0,b.onUnexpectedError)(G)}}static sort(G,fe){return fe.priority-G.priority}}(function(){let X=[],G=null,fe=!1,Se=!1;const ke=()=>{for(fe=!1,G=X,X=[],Se=!0;G.length>0;)G.sort(p.sort),G.shift().execute();Se=!1};t.scheduleAtNextAnimationFrame=(qe,$e=0)=>{const Xe=new p(qe,$e);return X.push(Xe),fe||(fe=!0,requestAnimationFrame(ke)),Xe},t.runAtThisOrScheduleAtNextAnimationFrame=(qe,$e)=>{if(Se){const Xe=new p(qe,$e);return G.push(Xe),Xe}else return(0,t.scheduleAtNextAnimationFrame)(qe,$e)}})();function m(X){return(0,t.scheduleAtNextAnimationFrame)(X,1e4)}t.measure=m;function v(X){return(0,t.scheduleAtNextAnimationFrame)(X,-1e4)}t.modify=v;const M=8,V=function(X,G){return G};class x extends h.Disposable{constructor(G,fe,Se,ke=V,qe=M){super();let $e=null,Xe=0;const Je=this.B(new y.TimeoutTimer),ft=()=>{Xe=new Date().getTime(),Se($e),$e=null};this.B(u(G,fe,Lt=>{$e=ke($e,Lt);const gt=new Date().getTime()-Xe;gt>=qe?(Je.cancel(),ft()):Je.setIfNotSet(ft,qe-gt)}))}}function Z(X,G,fe,Se,ke){return new x(X,G,fe,Se,ke)}t.addDisposableThrottledListener=Z;function ee(X){return document.defaultView.getComputedStyle(X,null)}t.getComputedStyle=ee;function se(X){if(X!==document.body)return new ue(X.clientWidth,X.clientHeight);if(a.isIOS&&window.visualViewport)return new ue(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new ue(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new ue(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new ue(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=se;class he{static d(G,fe){return parseFloat(fe)||0}static f(G,fe,Se){const ke=ee(G),qe=ke?ke.getPropertyValue(fe):"0";return he.d(G,qe)}static getBorderLeftWidth(G){return he.f(G,"border-left-width","borderLeftWidth")}static getBorderRightWidth(G){return he.f(G,"border-right-width","borderRightWidth")}static getBorderTopWidth(G){return he.f(G,"border-top-width","borderTopWidth")}static getBorderBottomWidth(G){return he.f(G,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(G){return he.f(G,"padding-left","paddingLeft")}static getPaddingRight(G){return he.f(G,"padding-right","paddingRight")}static getPaddingTop(G){return he.f(G,"padding-top","paddingTop")}static getPaddingBottom(G){return he.f(G,"padding-bottom","paddingBottom")}static getMarginLeft(G){return he.f(G,"margin-left","marginLeft")}static getMarginTop(G){return he.f(G,"margin-top","marginTop")}static getMarginRight(G){return he.f(G,"margin-right","marginRight")}static getMarginBottom(G){return he.f(G,"margin-bottom","marginBottom")}}class ue{constructor(G,fe){this.width=G,this.height=fe}with(G=this.width,fe=this.height){return G!==this.width||fe!==this.height?new ue(G,fe):this}static is(G){return typeof G=="object"&&typeof G.height=="number"&&typeof G.width=="number"}static lift(G){return G instanceof ue?G:new ue(G.width,G.height)}static equals(G,fe){return G===fe?!0:!G||!fe?!1:G.width===fe.width&&G.height===fe.height}}t.Dimension=ue,ue.None=new ue(0,0);function de(X){let G=X.offsetParent,fe=X.offsetTop,Se=X.offsetLeft;for(;(X=X.parentNode)!==null&&X!==document.body&&X!==document.documentElement;){fe-=X.scrollTop;const ke=R(X)?null:ee(X);ke&&(Se-=ke.direction!=="rtl"?X.scrollLeft:-X.scrollLeft),X===G&&(Se+=he.getBorderLeftWidth(X),fe+=he.getBorderTopWidth(X),fe+=X.offsetTop,Se+=X.offsetLeft,G=X.offsetParent)}return{left:Se,top:fe}}t.getTopLeftOffset=de;function we(X,G,fe){typeof G=="number"&&(X.style.width=`${G}px`),typeof fe=="number"&&(X.style.height=`${fe}px`)}t.size=we;function Te(X,G,fe,Se,ke,qe="absolute"){typeof G=="number"&&(X.style.top=`${G}px`),typeof fe=="number"&&(X.style.right=`${fe}px`),typeof Se=="number"&&(X.style.bottom=`${Se}px`),typeof ke=="number"&&(X.style.left=`${ke}px`),X.style.position=qe}t.position=Te;function Me(X){const G=X.getBoundingClientRect();return{left:G.left+window.scrollX,top:G.top+window.scrollY,width:G.width,height:G.height}}t.getDomNodePagePosition=Me;function Oe(X){let G=X,fe=1;do{const Se=ee(G).zoom;Se!=null&&Se!=="1"&&(fe*=Se),G=G.parentElement}while(G!==null&&G!==document.documentElement);return fe}t.getDomNodeZoomLevel=Oe;function j(X){const G=he.getMarginLeft(X)+he.getMarginRight(X);return X.offsetWidth+G}t.getTotalWidth=j;function Y(X){const G=he.getBorderLeftWidth(X)+he.getBorderRightWidth(X),fe=he.getPaddingLeft(X)+he.getPaddingRight(X);return X.offsetWidth-G-fe}t.getContentWidth=Y;function ie(X){const G=he.getMarginLeft(X)+he.getMarginRight(X);return X.scrollWidth+G}t.getTotalScrollWidth=ie;function ne(X){const G=he.getBorderTopWidth(X)+he.getBorderBottomWidth(X),fe=he.getPaddingTop(X)+he.getPaddingBottom(X);return X.offsetHeight-G-fe}t.getContentHeight=ne;function ae(X){const G=he.getMarginTop(X)+he.getMarginBottom(X);return X.offsetHeight+G}t.getTotalHeight=ae;function te(X,G){if(X===null)return 0;const fe=de(X),Se=de(G);return fe.left-Se.left}function W(X,G){const fe=G.map(ke=>Math.max(ie(ke),j(ke))+te(ke,X)||0);return Math.max(...fe)}t.getLargestChildWidth=W;function n(X,G){for(;X;){if(X===G)return!0;X=X.parentNode}return!1}t.isAncestor=n;const E="parentFlowToElementId";function P(X,G){X.dataset[E]=G.id}t.setParentFlowTo=P;function $(X){const G=X.dataset[E];return typeof G=="string"?document.getElementById(G):null}function K(X,G){let fe=X;for(;fe;){if(fe===G)return!0;if(fe instanceof HTMLElement){const Se=$(fe);if(Se){fe=Se;continue}}fe=fe.parentNode}return!1}t.isAncestorUsingFlowTo=K;function C(X,G,fe){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X.classList.contains(G))return X;if(fe){if(typeof fe=="string"){if(X.classList.contains(fe))return null}else if(X===fe)return null}X=X.parentNode}return null}t.findParentWithClass=C;function I(X,G,fe){return!!C(X,G,fe)}t.hasParentWithClass=I;function R(X){return X&&!!X.host&&!!X.mode}t.isShadowRoot=R;function T(X){return!!O(X)}t.isInShadowDOM=T;function O(X){for(;X.parentNode;){if(X===document.body)return null;X=X.parentNode}return R(X)?X:null}t.getShadowRoot=O;function B(){let X=document.activeElement;for(;X?.shadowRoot;)X=X.shadowRoot.activeElement;return X}t.getActiveElement=B;function H(X=document.getElementsByTagName("head")[0]){const G=document.createElement("style");return G.type="text/css",G.media="screen",X.appendChild(G),G}t.createStyleSheet=H;function _(X=document.getElementsByTagName("head")[0]){const G=document.createElement("meta");return X.appendChild(G),G}t.createMetaElement=_;let Q=null;function re(){return Q||(Q=H()),Q}function ce(X){return X?.sheet?.rules?X.sheet.rules:X?.sheet?.cssRules?X.sheet.cssRules:[]}function ve(X,G,fe=re()){!fe||!G||fe.sheet.insertRule(X+"{"+G+"}",0)}t.createCSSRule=ve;function De(X,G=re()){if(!G)return;const fe=ce(G),Se=[];for(let ke=0;ke<fe.length;ke++)fe[ke].selectorText.indexOf(X)!==-1&&Se.push(ke);for(let ke=Se.length-1;ke>=0;ke--)G.sheet.deleteRule(Se[ke])}t.removeCSSRulesContainingSelector=De;function Le(X){return typeof HTMLElement=="object"?X instanceof HTMLElement:X&&typeof X=="object"&&X.nodeType===1&&typeof X.nodeName=="string"}t.isHTMLElement=Le,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:w.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:w.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:w.isWebKit?"webkitAnimationIteration":"animationiteration"};function Ae(X){const G=X;return!!(G&&typeof G.preventDefault=="function"&&typeof G.stopPropagation=="function")}t.isEventLike=Ae,t.EventHelper={stop:(X,G)=>(X.preventDefault(),G&&X.stopPropagation(),X)};function pe(X){const G=[];for(let fe=0;X&&X.nodeType===X.ELEMENT_NODE;fe++)G[fe]=X.scrollTop,X=X.parentNode;return G}t.saveParentsScrollTop=pe;function Pe(X,G){for(let fe=0;X&&X.nodeType===X.ELEMENT_NODE;fe++)X.scrollTop!==G[fe]&&(X.scrollTop=G[fe]),X=X.parentNode}t.restoreParentsScrollTop=Pe;class Ie extends h.Disposable{static l(G){const fe=O(G),Se=fe?fe.activeElement:document.activeElement;return n(Se,G)}constructor(G){super(),this.f=this.B(new f.Emitter),this.onDidFocus=this.f.event,this.g=this.B(new f.Emitter),this.onDidBlur=this.g.event;let fe=Ie.l(G),Se=!1;const ke=()=>{Se=!1,fe||(fe=!0,this.f.fire())},qe=()=>{fe&&(Se=!0,window.setTimeout(()=>{Se&&(Se=!1,fe=!1,this.g.fire())},0))};this.j=()=>{Ie.l(G)!==fe&&(fe?qe():ke())},this.B(u(G,t.EventType.FOCUS,ke,!0)),this.B(u(G,t.EventType.BLUR,qe,!0)),this.B(u(G,t.EventType.FOCUS_IN,()=>this.j())),this.B(u(G,t.EventType.FOCUS_OUT,()=>this.j()))}refreshState(){this.j()}}function _e(X){return new Ie(X)}t.trackFocus=_e;function ze(X,G){return X.after(G),G}t.after=ze;function We(X,...G){if(X.append(...G),G.length===1&&typeof G[0]!="string")return G[0]}t.append=We;function xe(X,G){return X.insertBefore(G,X.firstChild),G}t.prepend=xe;function it(X,...G){X.innerText="",We(X,...G)}t.reset=it;const Be=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Ke;(function(X){X.HTML="http://www.w3.org/1999/xhtml",X.SVG="http://www.w3.org/2000/svg"})(Ke=t.Namespace||(t.Namespace={}));function Ye(X,G,fe,...Se){const ke=Be.exec(G);if(!ke)throw new Error("Bad use of emmet");const qe=ke[1]||"div";let $e;return X!==Ke.HTML?$e=document.createElementNS(X,qe):$e=document.createElement(qe),ke[3]&&($e.id=ke[3]),ke[4]&&($e.className=ke[4].replace(/\./g," ").trim()),fe&&Object.entries(fe).forEach(([Xe,Je])=>{typeof Je>"u"||(/^on\w+$/.test(Xe)?$e[Xe]=Je:Xe==="selected"?Je&&$e.setAttribute(Xe,"true"):$e.setAttribute(Xe,Je))}),$e.append(...Se),$e}function q(X,G,...fe){return Ye(Ke.HTML,X,G,...fe)}t.$=q,q.SVG=function(X,G,...fe){return Ye(Ke.SVG,X,G,...fe)};function le(X,G){const fe=[];return X.forEach((Se,ke)=>{ke>0&&(G instanceof Node?fe.push(G.cloneNode()):fe.push(document.createTextNode(G))),fe.push(Se)}),fe}t.join=le;function be(...X){for(const G of X)G.style.display="",G.removeAttribute("aria-hidden")}t.show=be;function ye(...X){for(const G of X)G.style.display="none",G.setAttribute("aria-hidden","true")}t.hide=ye;function Ce(X,G){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X instanceof HTMLElement&&X.hasAttribute(G))return X;X=X.parentNode}return null}function Re(X){!X||!X.hasAttribute("tabIndex")||(document.activeElement===X&&Ce(X.parentElement,"tabIndex")?.focus(),X.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Re;function je(X){return G=>{G.preventDefault(),G.stopPropagation(),X(G)}}t.finalHandler=je;function tt(){return new Promise(X=>{document.readyState==="complete"||document&&document.body!==null?X(void 0):window.addEventListener("DOMContentLoaded",X,!1)})}t.domContentLoaded=tt;function Ne(X){const G=window.devicePixelRatio*X;return Math.max(1,Math.floor(G))/window.devicePixelRatio}t.computeScreenAwareSize=Ne;function oe(X){window.open(X,"_blank","noopener")}t.windowOpenNoOpener=oe;const Ee=780,Fe=640;function Ue(X){const G=Math.floor(window.screenLeft+window.innerWidth/2-Ee/2),fe=Math.floor(window.screenTop+window.innerHeight/2-Fe/2);window.open(X,"_blank",`width=${Ee},height=${Fe},top=${fe},left=${G}`)}t.windowOpenPopup=Ue;function Ge(X,G=!0){const fe=window.open();return fe?(G&&(fe.opener=null),fe.location.href=X,!0):!1}t.windowOpenWithSuccess=Ge;function Ze(X){const G=()=>{X(),fe=(0,t.scheduleAtNextAnimationFrame)(G)};let fe=(0,t.scheduleAtNextAnimationFrame)(G);return(0,h.toDisposable)(()=>fe.dispose())}t.animate=Ze,N.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Qe(X){return X?`url('${N.FileAccess.uriToBrowserUri(X).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=Qe;function st(X){return`'${X.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=st;function ut(X,G){if(X!==void 0){const fe=X.match(/^\s*var\((.+)\)$/);if(fe){const Se=fe[1].split(",",2);return Se.length===2&&(G=ut(Se[1].trim(),G)),`var(${Se[0]}, ${G})`}return X}return G}t.asCssValueWithDefault=ut;function Et(X,G){let fe;if(e.URI.isUri(X))fe=X.toString(!0);else{const ke=new Blob([X]);fe=URL.createObjectURL(ke),setTimeout(()=>URL.revokeObjectURL(fe))}const Se=document.createElement("a");document.body.appendChild(Se),Se.download=G,Se.href=fe,Se.click(),setTimeout(()=>document.body.removeChild(Se))}t.triggerDownload=Et;function Tt(){return new Promise(X=>{const G=document.createElement("input");document.body.appendChild(G),G.type="file",G.multiple=!0,f.Event.once(f.Event.fromDOMEventEmitter(G,"input"))(()=>{X((0,s.withNullAsUndefined)(G.files))}),G.click(),setTimeout(()=>document.body.removeChild(G))})}t.triggerUpload=Tt;var wt;(function(X){X[X.DOCUMENT=1]="DOCUMENT",X[X.BROWSER=2]="BROWSER"})(wt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function hi(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:wt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:wt.BROWSER,guess:!1}:(a.isMacintosh||a.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:wt.BROWSER,guess:!0}:null}t.detectFullscreen=hi;function Wt(X,G=!1){const fe=document.createElement("a");return d.addHook("afterSanitizeAttributes",Se=>{for(const ke of["href","src"])if(Se.hasAttribute(ke)){const qe=Se.getAttribute(ke);if(ke==="href"&&qe.startsWith("#"))continue;if(fe.href=qe,!X.includes(fe.protocol.replace(/:$/,""))){if(G&&ke==="src"&&fe.href.startsWith("data:"))continue;Se.removeAttribute(ke)}}}),(0,h.toDisposable)(()=>{d.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Wt;const ci=[N.Schemas.http,N.Schemas.https,N.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const di=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function fi(X,G){const fe=Wt(ci);try{const Se=d.sanitize(G,di);X.innerHTML=Se}finally{fe.dispose()}}t.safeInnerHtml=fi;function gi(X){const G=new Uint16Array(X.length);for(let ke=0;ke<G.length;ke++)G[ke]=X.charCodeAt(ke);let fe="";const Se=new Uint8Array(G.buffer);for(let ke=0;ke<Se.length;ke++)fe+=String.fromCharCode(Se[ke]);return fe}function mi(X){return btoa(gi(X))}t.multibyteAwareBtoa=mi;class dt extends f.Emitter{constructor(){super(),this.s=new h.DisposableStore,this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.s.add(u(window,"keydown",G=>{if(G.defaultPrevented)return;const fe=new U.StandardKeyboardEvent(G);if(!(fe.keyCode===6&&G.repeat)){if(G.altKey&&!this.t.altKey)this.t.lastKeyPressed="alt";else if(G.ctrlKey&&!this.t.ctrlKey)this.t.lastKeyPressed="ctrl";else if(G.metaKey&&!this.t.metaKey)this.t.lastKeyPressed="meta";else if(G.shiftKey&&!this.t.shiftKey)this.t.lastKeyPressed="shift";else if(fe.keyCode!==6)this.t.lastKeyPressed=void 0;else return;this.t.altKey=G.altKey,this.t.ctrlKey=G.ctrlKey,this.t.metaKey=G.metaKey,this.t.shiftKey=G.shiftKey,this.t.lastKeyPressed&&(this.t.event=G,this.fire(this.t))}},!0)),this.s.add(u(window,"keyup",G=>{G.defaultPrevented||(!G.altKey&&this.t.altKey?this.t.lastKeyReleased="alt":!G.ctrlKey&&this.t.ctrlKey?this.t.lastKeyReleased="ctrl":!G.metaKey&&this.t.metaKey?this.t.lastKeyReleased="meta":!G.shiftKey&&this.t.shiftKey?this.t.lastKeyReleased="shift":this.t.lastKeyReleased=void 0,this.t.lastKeyPressed!==this.t.lastKeyReleased&&(this.t.lastKeyPressed=void 0),this.t.altKey=G.altKey,this.t.ctrlKey=G.ctrlKey,this.t.metaKey=G.metaKey,this.t.shiftKey=G.shiftKey,this.t.lastKeyReleased&&(this.t.event=G,this.fire(this.t)))},!0)),this.s.add(u(document.body,"mousedown",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(u(document.body,"mouseup",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(u(document.body,"mousemove",G=>{G.buttons&&(this.t.lastKeyPressed=void 0)},!0)),this.s.add(u(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.t}get isModifierPressed(){return this.t.altKey||this.t.ctrlKey||this.t.metaKey||this.t.shiftKey}resetKeyStatus(){this.v(),this.fire(this.t)}v(){this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return dt.u||(dt.u=new dt),dt.u}dispose(){super.dispose(),this.s.dispose()}}t.ModifierKeyEmitter=dt;function bi(X){const G=document.cookie.match("(^|[^;]+)\\s*"+X+"\\s*=\\s*([^;]+)");return G?G.pop():void 0}t.getCookieValue=bi;class pi extends h.Disposable{constructor(G,fe){super(),this.j=G,this.l=fe,this.f=0,this.g=0,this.m()}m(){this.B(u(this.j,t.EventType.DRAG_ENTER,G=>{this.f++,this.g=G.timeStamp,this.l.onDragEnter(G)})),this.B(u(this.j,t.EventType.DRAG_OVER,G=>{G.preventDefault(),this.l.onDragOver?.(G,G.timeStamp-this.g)})),this.B(u(this.j,t.EventType.DRAG_LEAVE,G=>{this.f--,this.f===0&&(this.g=0,this.l.onDragLeave(G))})),this.B(u(this.j,t.EventType.DRAG_END,G=>{this.f=0,this.g=0,this.l.onDragEnd(G)})),this.B(u(this.j,t.EventType.DROP,G=>{this.f=0,this.g=0,this.l.onDrop(G)}))}}t.DragAndDropObserver=pi;const wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function vi(X,...G){let fe,Se;Array.isArray(G[0])?(fe={},Se=G[0]):(fe=G[0]||{},Se=G[1]);const ke=wi.exec(X);if(!ke||!ke.groups)throw new Error("Bad use of h");const qe=ke.groups.tag||"div",$e=document.createElement(qe);ke.groups.id&&($e.id=ke.groups.id),ke.groups.class&&($e.className=ke.groups.class.replace(/\./g," ").trim());const Xe={};if(ke.groups.name&&(Xe[ke.groups.name]=$e),Se)for(const Je of Se)Je instanceof HTMLElement?$e.appendChild(Je):typeof Je=="string"?$e.append(Je):(Object.assign(Xe,Je),$e.appendChild(Je.root));for(const[Je,ft]of Object.entries(fe))if(Je==="style")for(const[Lt,gt]of Object.entries(ft))$e.style.setProperty($t(Lt),typeof gt=="number"?gt+"px":""+gt);else Je==="tabIndex"?$e.tabIndex=ft:$e.setAttribute($t(Je),ft.toString());return Xe.root=$e,Xe}t.h=vi;function $t(X){return X.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(ge[51],me([1,0,4,2,106]),function(J,t,w,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class z extends i.Disposable{constructor(f,d){super(),this.B((0,w.addDisposableListener)(f,"dragover",h=>{h.preventDefault(),this.a||(this.a=setTimeout(()=>{d(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(h=>{this.B((0,w.addDisposableListener)(f,h,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.DelayedDragHandler=z,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:U.Mimes.text};function y(b,f,d,h,N){const a=document.createElement("div");a.className=d,a.textContent=f,N&&(a.style.color=N),h&&(a.style.background=h),b.dataTransfer&&(document.body.appendChild(a),b.dataTransfer.setDragImage(a,-10,-10),setTimeout(()=>document.body.removeChild(a),0))}t.applyDragImage=y}),define(ge[52],me([1,0,4]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function i(a,s={}){const e=z(s);return e.textContent=a,e}t.renderText=i;function U(a,s={}){const e=z(s);return f(e,d(a,!!s.renderCodeSegments),s.actionHandler,s.renderCodeSegments),e}t.renderFormattedText=U;function z(a){const s=a.inline?"span":"div",e=document.createElement(s);return a.className&&(e.className=a.className),e}t.createElement=z;class y{constructor(s){this.b=s,this.c=0}eos(){return this.c>=this.b.length}next(){const s=this.peek();return this.advance(),s}peek(){return this.b[this.c]}advance(){this.c++}}var b;(function(a){a[a.Invalid=0]="Invalid",a[a.Root=1]="Root",a[a.Text=2]="Text",a[a.Bold=3]="Bold",a[a.Italics=4]="Italics",a[a.Action=5]="Action",a[a.ActionClose=6]="ActionClose",a[a.Code=7]="Code",a[a.NewLine=8]="NewLine"})(b||(b={}));function f(a,s,e,r){let o;if(s.type===2)o=document.createTextNode(s.content||"");else if(s.type===3)o=document.createElement("b");else if(s.type===4)o=document.createElement("i");else if(s.type===7&&r)o=document.createElement("code");else if(s.type===5&&e){const l=document.createElement("a");e.disposables.add(w.addStandardDisposableListener(l,"click",u=>{e.callback(String(s.index),u)})),o=l}else s.type===8?o=document.createElement("br"):s.type===1&&(o=a);o&&a!==o&&a.appendChild(o),o&&Array.isArray(s.children)&&s.children.forEach(l=>{f(o,l,e,r)})}function d(a,s){const e={type:1,children:[]};let r=0,o=e;const l=[],u=new y(a);for(;!u.eos();){let D=u.next();const S=D==="\\"&&N(u.peek(),s)!==0;if(S&&(D=u.next()),!S&&h(D,s)&&D===u.peek()){u.advance(),o.type===2&&(o=l.pop());const k=N(D,s);if(o.type===k||o.type===5&&k===6)o=l.pop();else{const g={type:k,children:[]};k===5&&(g.index=r,r++),o.children.push(g),l.push(o),o=g}}else if(D===`
`)o.type===2&&(o=l.pop()),o.children.push({type:8});else if(o.type!==2){const k={type:2,content:D};o.children.push(k),l.push(o),o=k}else o.content+=D}return o.type===2&&(o=l.pop()),l.length,e}function h(a,s){return N(a,s)!==0}function N(a,s){switch(a){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return s?7:0;default:return 0}}}),define(ge[53],me([1,0,4,2]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class U{constructor(){this.a=new i.DisposableStore,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(y,b){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const f=this.c;this.c=null,y&&f&&f(b)}isMonitoring(){return!!this.b}startMonitoring(y,b,f,d,h){this.isMonitoring()&&this.stopMonitoring(!1),this.b=d,this.c=h;let N=y;try{y.setPointerCapture(b),this.a.add((0,i.toDisposable)(()=>{try{y.releasePointerCapture(b)}catch{}}))}catch{N=window}this.a.add(w.addDisposableListener(N,w.EventType.POINTER_MOVE,a=>{if(a.buttons!==f){this.stopMonitoring(!0);return}a.preventDefault(),this.b(a)})),this.a.add(w.addDisposableListener(N,w.EventType.POINTER_UP,a=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=U});var Ve=this&&this.__decorate||function(J,t,w,i){var U=arguments.length,z=U<3?t:i===null?i=Object.getOwnPropertyDescriptor(t,w):i,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")z=Reflect.decorate(J,t,w,i);else for(var b=J.length-1;b>=0;b--)(y=J[b])&&(z=(U<3?y(z):U>3?y(t,w,z):y(t,w))||z);return U>3&&z&&Object.defineProperty(t,w,z),z};define(ge[22],me([1,0,4,14,24,2,45]),function(J,t,w,i,U,z,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var b;(function(d){d.Tap="-monaco-gesturetap",d.Change="-monaco-gesturechange",d.Start="-monaco-gesturestart",d.End="-monaco-gesturesend",d.Contextmenu="-monaco-gesturecontextmenu"})(b=t.EventType||(t.EventType={}));class f extends z.Disposable{constructor(){super(),this.f=!1,this.g=new y.LinkedList,this.h=new y.LinkedList,this.k={},this.j=null,this.l=0,this.B(w.addDisposableListener(document,"touchstart",h=>this.n(h),{passive:!1})),this.B(w.addDisposableListener(document,"touchend",h=>this.p(h))),this.B(w.addDisposableListener(document,"touchmove",h=>this.v(h),{passive:!1}))}static addTarget(h){if(!f.isTouchDevice())return z.Disposable.None;f.b||(f.b=new f);const N=f.b.g.push(h);return(0,z.toDisposable)(N)}static ignoreTarget(h){if(!f.isTouchDevice())return z.Disposable.None;f.b||(f.b=new f);const N=f.b.h.push(h);return(0,z.toDisposable)(N)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}n(h){const N=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let a=0,s=h.targetTouches.length;a<s;a++){const e=h.targetTouches.item(a);this.k[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:N,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[N],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const r=this.r(b.Start,e.target);r.pageX=e.pageX,r.pageY=e.pageY,this.s(r)}this.f&&(h.preventDefault(),h.stopPropagation(),this.f=!1)}p(h){const N=Date.now(),a=Object.keys(this.k).length;for(let s=0,e=h.changedTouches.length;s<e;s++){const r=h.changedTouches.item(s);if(!this.k.hasOwnProperty(String(r.identifier))){console.warn("move of an UNKNOWN touch",r);continue}const o=this.k[r.identifier],l=Date.now()-o.initialTimeStamp;if(l<f.c&&Math.abs(o.initialPageX-i.tail(o.rollingPageX))<30&&Math.abs(o.initialPageY-i.tail(o.rollingPageY))<30){const u=this.r(b.Tap,o.initialTarget);u.pageX=i.tail(o.rollingPageX),u.pageY=i.tail(o.rollingPageY),this.s(u)}else if(l>=f.c&&Math.abs(o.initialPageX-i.tail(o.rollingPageX))<30&&Math.abs(o.initialPageY-i.tail(o.rollingPageY))<30){const u=this.r(b.Contextmenu,o.initialTarget);u.pageX=i.tail(o.rollingPageX),u.pageY=i.tail(o.rollingPageY),this.s(u)}else if(a===1){const u=i.tail(o.rollingPageX),D=i.tail(o.rollingPageY),S=i.tail(o.rollingTimestamps)-o.rollingTimestamps[0],k=u-o.rollingPageX[0],g=D-o.rollingPageY[0],A=[...this.g].filter(L=>o.initialTarget instanceof Node&&L.contains(o.initialTarget));this.u(A,N,Math.abs(k)/S,k>0?1:-1,u,Math.abs(g)/S,g>0?1:-1,D)}this.s(this.r(b.End,o.initialTarget)),delete this.k[r.identifier]}this.f&&(h.preventDefault(),h.stopPropagation(),this.f=!1)}r(h,N){const a=document.createEvent("CustomEvent");return a.initEvent(h,!1,!0),a.initialTarget=N,a.tapCount=0,a}s(h){if(h.type===b.Tap){const N=new Date().getTime();let a=0;N-this.l>f.m?a=1:a=2,this.l=N,h.tapCount=a}else(h.type===b.Change||h.type===b.Contextmenu)&&(this.l=0);if(h.initialTarget instanceof Node){for(const N of this.h)if(N.contains(h.initialTarget))return;for(const N of this.g)N.contains(h.initialTarget)&&(N.dispatchEvent(h),this.f=!0)}}u(h,N,a,s,e,r,o,l){this.j=w.scheduleAtNextAnimationFrame(()=>{const u=Date.now(),D=u-N;let S=0,k=0,g=!0;a+=f.a*D,r+=f.a*D,a>0&&(g=!1,S=s*a*D),r>0&&(g=!1,k=o*r*D);const A=this.r(b.Change);A.translationX=S,A.translationY=k,h.forEach(L=>L.dispatchEvent(A)),g||this.u(h,u,a,s,e+S,r,o,l+k)})}v(h){const N=Date.now();for(let a=0,s=h.changedTouches.length;a<s;a++){const e=h.changedTouches.item(a);if(!this.k.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const r=this.k[e.identifier],o=this.r(b.Change,r.initialTarget);o.translationX=e.pageX-i.tail(r.rollingPageX),o.translationY=e.pageY-i.tail(r.rollingPageY),o.pageX=e.pageX,o.pageY=e.pageY,this.s(o),r.rollingPageX.length>3&&(r.rollingPageX.shift(),r.rollingPageY.shift(),r.rollingTimestamps.shift()),r.rollingPageX.push(e.pageX),r.rollingPageY.push(e.pageY),r.rollingTimestamps.push(N)}this.f&&(h.preventDefault(),h.stopPropagation(),this.f=!1)}}f.a=-.005,f.c=700,f.m=400,Ve([U.memoize],f,"isTouchDevice",null),t.Gesture=f}),define(ge[54],me([1,0,4,5,83]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const U=2e4;let z,y,b,f,d;function h(e){z=document.createElement("div"),z.className="monaco-aria-container";const r=()=>{const l=document.createElement("div");return l.className="monaco-alert",l.setAttribute("role","alert"),l.setAttribute("aria-atomic","true"),z.appendChild(l),l};y=r(),b=r();const o=()=>{const l=document.createElement("div");return l.className="monaco-status",l.setAttribute("role","complementary"),l.setAttribute("aria-live","polite"),l.setAttribute("aria-atomic","true"),z.appendChild(l),l};f=o(),d=o(),e.appendChild(z)}t.setARIAContainer=h;function N(e){!z||(y.textContent!==e?(w.clearNode(b),s(y,e)):(w.clearNode(y),s(b,e)))}t.alert=N;function a(e){!z||(i.isMacintosh?N(e):f.textContent!==e?(w.clearNode(d),s(f,e)):(w.clearNode(f),s(d,e)))}t.status=a;function s(e,r){w.clearNode(e),r.length>U&&(r=r.substr(0,U)),e.textContent=r,e.style.visibility="hidden",e.style.visibility="visible"}}),define(ge[115],me([1,0,4,13]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const U=new RegExp(`(\\\\)?\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)`,"g");function z(b){const f=new Array;let d,h=0,N=0;for(;(d=U.exec(b))!==null;){N=d.index||0,h<N&&f.push(b.substring(h,N)),h=(d.index||0)+d[0].length;const[,a,s]=d;f.push(a?`$(${s})`:y({id:s}))}return h<b.length&&f.push(b.substring(h)),f}t.renderLabelWithIcons=z;function y(b){const f=w.$("span");return f.classList.add(...i.CSSIcon.asClassNameArray(b)),f}t.renderIcon=y}),define(ge[116],me([1,0,4]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function i(z){try{z.parentElement?.removeChild(z)}catch{}}class U{constructor(y){this.d=y,this.a=new Map,this.b=new Set,this.c=!1}alloc(y){let b=this.h(y).pop(),f=!1;if(b)f=this.b.has(b.domNode),f&&this.b.delete(b.domNode);else{const d=(0,w.$)(".monaco-list-row"),N=this.i(y).renderTemplate(d);b={domNode:d,templateId:y,templateData:N}}return{row:b,isReusingConnectedDomNode:f}}release(y){!y||this.f(y)}transact(y){if(this.c)throw new Error("Already in transaction");this.c=!0;try{y()}finally{for(const b of this.b)this.g(b);this.b.clear(),this.c=!1}}f(y){const{domNode:b,templateId:f}=y;b&&(this.c?this.b.add(b):this.g(b)),this.h(f).push(y)}g(y){y.classList.remove("scrolling"),i(y)}h(y){let b=this.a.get(y);return b||(b=[],this.a.set(y,b)),b}dispose(){this.a.forEach((y,b)=>{for(const f of y)this.i(b).disposeTemplate(f.templateData),f.templateData=null}),this.a.clear(),this.b.clear()}i(y){const b=this.d.get(y);if(!b)throw new Error(`No renderer found for ${y}`);return b}}t.RowCache=U}),define(ge[117],me([1,0,9,2]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class U extends i.Disposable{constructor(y,b,f){super(),this.a=y,this.b=b,this.c=f,this.f=null,this.j=!1,this.i=!1,this.g=!1,this.h=!1,this.k=this.B(new w.TimeoutTimer)}setVisibility(y){this.a!==y&&(this.a=y,this.m())}setShouldBeVisible(y){this.g=y,this.m()}l(){return this.a===2?!1:this.a===3?!0:this.g}m(){const y=this.l();this.h!==y&&(this.h=y,this.ensureVisibility())}setIsNeeded(y){this.i!==y&&(this.i=y,this.ensureVisibility())}setDomNode(y){this.f=y,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.i){this.p(!1);return}this.h?this.n():this.p(!0)}n(){this.j||(this.j=!0,this.k.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}p(y){this.k.cancel(),this.j&&(this.j=!1,this.f?.setClassName(this.c+(y?" fade":"")))}}t.ScrollbarVisibilityController=U}),define(ge[118],me([1,0,4,22,14,3,2,5]),function(J,t,w,i,U,z,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class f extends y.Disposable{constructor(h,N,a,s){super(),this.f=0,this.b=s||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new z.Emitter),this.h=a,this.i(),this.setOptions(h,N)}i(){this.B(i.Gesture.addTarget(this.a)),[i.EventType.Tap].forEach(h=>{this.B(w.addDisposableListener(this.a,h,N=>{this.a.focus()}))}),this.B(w.addStandardDisposableListener(this.a,"click",h=>{w.EventHelper.stop(h,!0)})),this.B(w.addStandardDisposableListener(this.a,"change",h=>{this.a.title=h.target.value,this.g.fire({index:h.target.selectedIndex,selected:h.target.value})})),this.B(w.addStandardDisposableListener(this.a,"keydown",h=>{let N=!1;b.isMacintosh?(h.keyCode===18||h.keyCode===16||h.keyCode===10)&&(N=!0):(h.keyCode===18&&h.altKey||h.keyCode===10||h.keyCode===3)&&(N=!0),N&&h.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(h,N){(!this.c||!U.equals(this.c,h))&&(this.c=h,this.a.options.length=0,this.c.forEach((a,s)=>{this.a.add(this.j(a.text,s,a.isDisabled))})),N!==void 0&&this.select(N)}select(h){this.c.length===0?this.f=0:h>=0&&h<this.c.length?this.f=h:h>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(h){this.b.ariaLabel=h,this.a.setAttribute("aria-label",h)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(h){this.a.tabIndex=h?0:-1}render(h){h.classList.add("select-container"),h.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(h){this.h=h,this.applyStyles()}applyStyles(){if(this.a){const h=this.h.selectBackground?this.h.selectBackground.toString():"",N=this.h.selectForeground?this.h.selectForeground.toString():"",a=this.h.selectBorder?this.h.selectBorder.toString():"";this.a.style.backgroundColor=h,this.a.style.color=N,this.a.style.borderColor=a}}j(h,N,a){const s=document.createElement("option");return s.value=h,s.text=h,s.disabled=!!a,s}}t.SelectBoxNative=f}),define(ge[55],me([1,0,23,14,9,112,3,25]),function(J,t,w,i,U,z,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function f(a){return typeof a=="object"&&"visibility"in a&&"data"in a}t.isFilterResult=f;function d(a){switch(a){case!0:return 1;case!1:return 0;default:return a}}t.getVisibleState=d;function h(a){return typeof a.collapsible=="boolean"}class N{constructor(s,e,r,o={}){this.o=s,this.p=e,this.rootRef=[],this.d=new y.EventBufferer,this.f=new y.Emitter,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new y.Emitter,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new y.Emitter,this.onDidSplice=this.l.event,this.m=new U.Delayer(U.MicrotaskDelay),this.h=typeof o.collapseByDefault>"u"?!1:o.collapseByDefault,this.j=o.filter,this.k=typeof o.autoExpandSingleChildren>"u"?!1:o.autoExpandSingleChildren,this.c={parent:void 0,element:r,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(s,e,r=b.Iterable.empty(),o={}){if(s.length===0)throw new w.TreeError(this.o,"Invalid tree location");o.diffIdentityProvider?this.q(o.diffIdentityProvider,s,e,r,o):this.s(s,e,r,o)}q(s,e,r,o=b.Iterable.empty(),l,u=l.diffDepth??0){const{parentNode:D}=this.G(e);if(!D.lastDiffIds)return this.s(e,r,o,l);const S=[...o],k=e[e.length-1],g=new z.LcsDiff({getElements:()=>D.lastDiffIds},{getElements:()=>[...D.children.slice(0,k),...S,...D.children.slice(k+r)].map(p=>s.getId(p.element).toString())}).ComputeDiff(!1);if(g.quitEarly)return D.lastDiffIds=void 0,this.s(e,r,S,l);const A=e.slice(0,-1),L=(p,m,v)=>{if(u>0)for(let M=0;M<v;M++)p--,m--,this.q(s,[...A,p,0],Number.MAX_SAFE_INTEGER,S[m].children,l,u-1)};let F=Math.min(D.children.length,k+r),c=S.length;for(const p of g.changes.sort((m,v)=>v.originalStart-m.originalStart))L(F,c,F-(p.originalStart+p.originalLength)),F=p.originalStart,c=p.modifiedStart-k,this.s([...A,F],p.originalLength,b.Iterable.slice(S,c,c+p.modifiedLength),l);L(F,c,F)}s(s,e,r=b.Iterable.empty(),{onDidCreateNode:o,onDidDeleteNode:l,diffIdentityProvider:u}){const{parentNode:D,listIndex:S,revealed:k,visible:g}=this.G(s),A=[],L=b.Iterable.map(r,se=>this.w(se,D,D.visible?1:0,k,A,o)),F=s[s.length-1],c=D.children.length>0;let p=0;for(let se=F;se>=0&&se<D.children.length;se--){const he=D.children[se];if(he.visible){p=he.visibleChildIndex;break}}const m=[];let v=0,M=0;for(const se of L)m.push(se),M+=se.renderNodeCount,se.visible&&(se.visibleChildIndex=p+v++);const V=(0,i.splice)(D.children,F,e,m);u?D.lastDiffIds?(0,i.splice)(D.lastDiffIds,F,e,m.map(se=>u.getId(se.element).toString())):D.lastDiffIds=D.children.map(se=>u.getId(se.element).toString()):D.lastDiffIds=void 0;let x=0;for(const se of V)se.visible&&x++;if(x!==0)for(let se=F+m.length;se<D.children.length;se++){const he=D.children[se];he.visible&&(he.visibleChildIndex-=x)}if(D.visibleChildrenCount+=v-x,k&&g){const se=V.reduce((he,ue)=>he+(ue.visible?ue.renderNodeCount:0),0);this.B(D,M-se),this.p.splice(S,se,A)}if(V.length>0&&l){const se=he=>{l(he),he.children.forEach(se)};V.forEach(se)}this.l.fire({insertedNodes:m,deletedNodes:V});const Z=D.children.length>0;c!==Z&&this.setCollapsible(s.slice(0,-1),Z);let ee=D;for(;ee;){if(ee.visibility===2){this.m.trigger(()=>this.refilter());break}ee=ee.parent}}rerender(s){if(s.length===0)throw new w.TreeError(this.o,"Invalid tree location");const{node:e,listIndex:r,revealed:o}=this.F(s);e.visible&&o&&this.p.splice(r,1,[e])}updateElementHeight(s,e){if(s.length===0)throw new w.TreeError(this.o,"Invalid tree location");const{listIndex:r}=this.F(s);this.p.updateElementHeight(r,e)}has(s){return this.D(s)}getListIndex(s){const{listIndex:e,visible:r,revealed:o}=this.F(s);return r&&o?e:-1}getListRenderCount(s){return this.E(s).renderNodeCount}isCollapsible(s){return this.E(s).collapsible}setCollapsible(s,e){const r=this.E(s);typeof e>"u"&&(e=!r.collapsible);const o={collapsible:e};return this.d.bufferEvents(()=>this.t(s,o))}isCollapsed(s){return this.E(s).collapsed}setCollapsed(s,e,r){const o=this.E(s);typeof e>"u"&&(e=!o.collapsed);const l={collapsed:e,recursive:r||!1};return this.d.bufferEvents(()=>this.t(s,l))}t(s,e){const{node:r,listIndex:o,revealed:l}=this.F(s),u=this.u(r,o,l,e);if(r!==this.c&&this.k&&u&&!h(e)&&r.collapsible&&!r.collapsed&&!e.recursive){let D=-1;for(let S=0;S<r.children.length;S++)if(r.children[S].visible)if(D>-1){D=-1;break}else D=S;D>-1&&this.t([...s,D],e)}return u}u(s,e,r,o){const l=this.v(s,o,!1);if(!r||!s.visible||!l)return l;const u=s.renderNodeCount,D=this.x(s),S=u-(e===-1?0:1);return this.p.splice(e+1,S,D.slice(1)),l}v(s,e,r){let o;if(s===this.c?o=!1:(h(e)?(o=s.collapsible!==e.collapsible,s.collapsible=e.collapsible):s.collapsible?(o=s.collapsed!==e.collapsed,s.collapsed=e.collapsed):o=!1,o&&this.f.fire({node:s,deep:r})),!h(e)&&e.recursive)for(const l of s.children)o=this.v(l,e,!0)||o;return o}expandTo(s){this.d.bufferEvents(()=>{let e=this.E(s);for(;e.parent;)e=e.parent,s=s.slice(0,s.length-1),e.collapsed&&this.t(s,{collapsed:!1,recursive:!1})})}refilter(){const s=this.c.renderNodeCount,e=this.z(this.c);this.p.splice(0,s,e),this.m.cancel()}w(s,e,r,o,l,u){const D={parent:e,element:s.element,children:[],depth:e.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof s.collapsible=="boolean"?s.collapsible:typeof s.collapsed<"u",collapsed:typeof s.collapsed>"u"?this.h:s.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},S=this.C(D,r);D.visibility=S,o&&l.push(D);const k=s.children||b.Iterable.empty(),g=o&&S!==0&&!D.collapsed;let A=0,L=1;for(const F of k){const c=this.w(F,D,S,g,l,u);D.children.push(c),L+=c.renderNodeCount,c.visible&&(c.visibleChildIndex=A++)}return D.collapsible=D.collapsible||D.children.length>0,D.visibleChildrenCount=A,D.visible=S===2?A>0:S===1,D.visible?D.collapsed||(D.renderNodeCount=L):(D.renderNodeCount=0,o&&l.pop()),u?.(D),D}x(s){const e=s.renderNodeCount,r=[];return this.y(s,r),this.B(s.parent,r.length-e),r}y(s,e){if(s.visible===!1)return 0;if(e.push(s),s.renderNodeCount=1,!s.collapsed)for(const r of s.children)s.renderNodeCount+=this.y(r,e);return this.g.fire(s),s.renderNodeCount}z(s){const e=s.renderNodeCount,r=[];return this.A(s,s.visible?1:0,r),this.B(s.parent,r.length-e),r}A(s,e,r,o=!0){let l;if(s!==this.c){if(l=this.C(s,e),l===0)return s.visible=!1,s.renderNodeCount=0,!1;o&&r.push(s)}const u=r.length;s.renderNodeCount=s===this.c?0:1;let D=!1;if(!s.collapsed||l!==0){let S=0;for(const k of s.children)D=this.A(k,l,r,o&&!s.collapsed)||D,k.visible&&(k.visibleChildIndex=S++);s.visibleChildrenCount=S}else s.visibleChildrenCount=0;return s!==this.c&&(s.visible=l===2?D:l===1,s.visibility=l),s.visible?s.collapsed||(s.renderNodeCount+=r.length-u):(s.renderNodeCount=0,o&&r.pop()),this.g.fire(s),s.visible}B(s,e){if(e!==0)for(;s;)s.renderNodeCount+=e,this.g.fire(s),s=s.parent}C(s,e){const r=this.j?this.j.filter(s.element,e):1;return typeof r=="boolean"?(s.filterData=void 0,r?1:0):f(r)?(s.filterData=r.data,d(r.visibility)):(s.filterData=void 0,d(r))}D(s,e=this.c){if(!s||s.length===0)return!0;const[r,...o]=s;return r<0||r>e.children.length?!1:this.D(o,e.children[r])}E(s,e=this.c){if(!s||s.length===0)return e;const[r,...o]=s;if(r<0||r>e.children.length)throw new w.TreeError(this.o,"Invalid tree location");return this.E(o,e.children[r])}F(s){if(s.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:e,listIndex:r,revealed:o,visible:l}=this.G(s),u=s[s.length-1];if(u<0||u>e.children.length)throw new w.TreeError(this.o,"Invalid tree location");const D=e.children[u];return{node:D,listIndex:r,revealed:o,visible:l&&D.visible}}G(s,e=this.c,r=0,o=!0,l=!0){const[u,...D]=s;if(u<0||u>e.children.length)throw new w.TreeError(this.o,"Invalid tree location");for(let S=0;S<u;S++)r+=e.children[S].renderNodeCount;return o=o&&!e.collapsed,l=l&&e.visible,D.length===0?{parentNode:e,listIndex:r,revealed:o,visible:l}:this.G(D,e.children[u],r+1,o,l)}getNode(s=[]){return this.E(s)}getNodeLocation(s){const e=[];let r=s;for(;r.parent;)e.push(r.parent.children.indexOf(r)),r=r.parent;return e.reverse()}getParentNodeLocation(s){if(s.length!==0)return s.length===1?[]:(0,i.tail2)(s)[0]}getFirstElementChild(s){const e=this.E(s);if(e.children.length!==0)return e.children[0].element}getLastElementAncestor(s=[]){const e=this.E(s);if(e.children.length!==0)return this.H(e)}H(s){return s.children.length===0?s.element:this.H(s.children[s.children.length-1])}}t.IndexTreeModel=N}),define(ge[119],me([1,0,55,23,25]),function(J,t,w,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class z{get size(){return this.d.size}constructor(b,f,d={}){this.k=b,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new w.IndexTreeModel(b,f,null,d),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,d.sorter&&(this.j={compare(h,N){return d.sorter.compare(h.element,N.element)}}),this.h=d.identityProvider}setChildren(b,f=U.Iterable.empty(),d={}){const h=this.o(b);this.l(h,this.m(f),d)}l(b,f=U.Iterable.empty(),d){const h=new Set,N=new Set,a=e=>{if(e.element===null)return;const r=e;if(h.add(r.element),this.d.set(r.element,r),this.h){const o=this.h.getId(r.element).toString();N.add(o),this.f.set(o,r)}d.onDidCreateNode?.(r)},s=e=>{if(e.element===null)return;const r=e;if(h.has(r.element)||this.d.delete(r.element),this.h){const o=this.h.getId(r.element).toString();N.has(o)||this.f.delete(o)}d.onDidDeleteNode?.(r)};this.c.splice([...b,0],Number.MAX_VALUE,f,{...d,onDidCreateNode:a,onDidDeleteNode:s})}m(b=U.Iterable.empty()){return this.j&&(b=[...b].sort(this.j.compare.bind(this.j))),U.Iterable.map(b,f=>{let d=this.d.get(f.element);if(!d&&this.h){const a=this.h.getId(f.element).toString();d=this.f.get(a)}if(!d)return{...f,children:this.m(f.children)};const h=typeof f.collapsible=="boolean"?f.collapsible:d.collapsible,N=typeof f.collapsed<"u"?f.collapsed:d.collapsed;return{...f,collapsible:h,collapsed:N,children:this.m(f.children)}})}rerender(b){const f=this.o(b);this.c.rerender(f)}updateElementHeight(b,f){const d=this.o(b);this.c.updateElementHeight(d,f)}resort(b=null,f=!0){if(!this.j)return;const d=this.o(b),h=this.c.getNode(d);this.l(d,this.n(h,f),{})}n(b,f,d=!0){let h=[...b.children];return(f||d)&&(h=h.sort(this.j.compare.bind(this.j))),U.Iterable.map(h,N=>({element:N.element,collapsible:N.collapsible,collapsed:N.collapsed,children:this.n(N,f,!1)}))}getFirstElementChild(b=null){const f=this.o(b);return this.c.getFirstElementChild(f)}getLastElementAncestor(b=null){const f=this.o(b);return this.c.getLastElementAncestor(f)}has(b){return this.d.has(b)}getListIndex(b){const f=this.o(b);return this.c.getListIndex(f)}getListRenderCount(b){const f=this.o(b);return this.c.getListRenderCount(f)}isCollapsible(b){const f=this.o(b);return this.c.isCollapsible(f)}setCollapsible(b,f){const d=this.o(b);return this.c.setCollapsible(d,f)}isCollapsed(b){const f=this.o(b);return this.c.isCollapsed(f)}setCollapsed(b,f,d){const h=this.o(b);return this.c.setCollapsed(h,f,d)}expandTo(b){const f=this.o(b);this.c.expandTo(f)}refilter(){this.c.refilter()}getNode(b=null){if(b===null)return this.c.getNode(this.c.rootRef);const f=this.d.get(b);if(!f)throw new i.TreeError(this.k,`Tree element not found: ${b}`);return f}getNodeLocation(b){return b.element}getParentNodeLocation(b){if(b===null)throw new i.TreeError(this.k,"Invalid getParentNodeLocation call");const f=this.d.get(b);if(!f)throw new i.TreeError(this.k,`Tree element not found: ${b}`);const d=this.c.getNodeLocation(f),h=this.c.getParentNodeLocation(d);return this.c.getNode(h).element}o(b){if(b===null)return[];const f=this.d.get(b);if(!f)throw new i.TreeError(this.k,`Tree element not found: ${b}`);return this.c.getNodeLocation(f)}}t.ObjectTreeModel=z}),define(ge[18],me([1,0,4,15,20,22,2]),function(J,t,w,i,U,z,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class b extends y.Disposable{f(d,h){this.B(w.addDisposableListener(d,w.EventType.CLICK,N=>h(new U.StandardMouseEvent(N))))}j(d,h){this.B(w.addDisposableListener(d,w.EventType.MOUSE_DOWN,N=>h(new U.StandardMouseEvent(N))))}k(d,h){this.B(w.addDisposableListener(d,w.EventType.MOUSE_OVER,N=>h(new U.StandardMouseEvent(N))))}m(d,h){this.B(w.addDisposableListener(d,w.EventType.MOUSE_LEAVE,N=>h(new U.StandardMouseEvent(N))))}p(d,h){this.B(w.addDisposableListener(d,w.EventType.KEY_DOWN,N=>h(new i.StandardKeyboardEvent(N))))}u(d,h){this.B(w.addDisposableListener(d,w.EventType.KEY_UP,N=>h(new i.StandardKeyboardEvent(N))))}z(d,h){this.B(w.addDisposableListener(d,w.EventType.INPUT,h))}C(d,h){this.B(w.addDisposableListener(d,w.EventType.BLUR,h))}D(d,h){this.B(w.addDisposableListener(d,w.EventType.FOCUS,h))}F(d,h){this.B(w.addDisposableListener(d,w.EventType.CHANGE,h))}G(d){return z.Gesture.ignoreTarget(d)}}t.Widget=b}),define(ge[36],me([1,0,53,18,9,4]),function(J,t,w,i,U,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class y extends i.Widget{constructor(f){super(),this.a=f.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=f.bgWidth+"px",this.bgDomNode.style.height=f.bgHeight+"px",typeof f.top<"u"&&(this.bgDomNode.style.top="0px"),typeof f.left<"u"&&(this.bgDomNode.style.left="0px"),typeof f.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof f.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=f.className,this.domNode.classList.add(...f.icon.classNamesArray),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof f.top<"u"&&(this.domNode.style.top=f.top+"px"),typeof f.left<"u"&&(this.domNode.style.left=f.left+"px"),typeof f.bottom<"u"&&(this.domNode.style.bottom=f.bottom+"px"),typeof f.right<"u"&&(this.domNode.style.right=f.right+"px"),this.g=this.B(new w.GlobalPointerMoveMonitor),this.B(z.addStandardDisposableListener(this.bgDomNode,z.EventType.POINTER_DOWN,d=>this.h(d))),this.B(z.addStandardDisposableListener(this.domNode,z.EventType.POINTER_DOWN,d=>this.h(d))),this.b=this.B(new U.IntervalTimer),this.c=this.B(new U.TimeoutTimer)}h(f){if(!f.target||!(f.target instanceof Element))return;const d=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(d,200),this.g.startMonitoring(f.target,f.pointerId,f.buttons,h=>{},()=>{this.b.cancel(),this.c.cancel()}),f.preventDefault()}}t.ScrollbarArrow=y}),define(ge[56],me([1,0,4,39,53,36,117,18,5]),function(J,t,w,i,U,z,y,b,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const d=140;class h extends b.Widget{constructor(a){super(),this.g=a.lazyRender,this.a=a.host,this.b=a.scrollable,this.c=a.scrollByPage,this.h=a.scrollbarState,this.i=this.B(new y.ScrollbarVisibilityController(a.visibility,"visible scrollbar "+a.extraScrollbarClassName,"invisible scrollbar "+a.extraScrollbarClassName)),this.i.setIsNeeded(this.h.isNeeded()),this.l=this.B(new U.GlobalPointerMoveMonitor),this.n=!0,this.domNode=(0,i.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.i.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(w.addDisposableListener(this.domNode.domNode,w.EventType.POINTER_DOWN,s=>this.y(s)))}r(a){const s=this.B(new z.ScrollbarArrow(a));this.domNode.domNode.appendChild(s.bgDomNode),this.domNode.domNode.appendChild(s.domNode)}s(a,s,e,r){this.slider=(0,i.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(a),this.slider.setLeft(s),typeof e=="number"&&this.slider.setWidth(e),typeof r=="number"&&this.slider.setHeight(r),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(w.addDisposableListener(this.slider.domNode,w.EventType.POINTER_DOWN,o=>{o.button===0&&(o.preventDefault(),this.I(o))})),this.f(this.slider.domNode,o=>{o.leftButton&&o.stopPropagation()})}t(a){return this.h.setVisibleSize(a)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}v(a){return this.h.setScrollSize(a)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}w(a){return this.h.setScrollPosition(a)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}beginReveal(){this.i.setShouldBeVisible(!0)}beginHide(){this.i.setShouldBeVisible(!1)}render(){!this.n||(this.n=!1,this.L(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.M(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}y(a){a.target===this.domNode.domNode&&this.H(a)}delegatePointerDown(a){const s=this.domNode.domNode.getClientRects()[0].top,e=s+this.h.getSliderPosition(),r=s+this.h.getSliderPosition()+this.h.getSliderSize(),o=this.O(a);e<=o&&o<=r?a.button===0&&(a.preventDefault(),this.I(a)):this.H(a)}H(a){let s,e;if(a.target===this.domNode.domNode&&typeof a.offsetX=="number"&&typeof a.offsetY=="number")s=a.offsetX,e=a.offsetY;else{const o=w.getDomNodePagePosition(this.domNode.domNode);s=a.pageX-o.left,e=a.pageY-o.top}const r=this.N(s,e);this.J(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(r):this.h.getDesiredScrollPositionFromOffset(r)),a.button===0&&(a.preventDefault(),this.I(a))}I(a){if(!a.target||!(a.target instanceof Element))return;const s=this.O(a),e=this.P(a),r=this.h.clone();this.slider.toggleClassName("active",!0),this.l.startMonitoring(a.target,a.pointerId,a.buttons,o=>{const l=this.P(o),u=Math.abs(l-e);if(f.isWindows&&u>d){this.J(r.getScrollPosition());return}const S=this.O(o)-s;this.J(r.getDesiredScrollPositionFromDelta(S))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}J(a){const s={};this.writeScrollPosition(s,a),this.b.setScrollPositionNow(s)}updateScrollbarSize(a){this.Q(a),this.h.setScrollbarSize(a),this.n=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.AbstractScrollbar=h}),define(ge[120],me([1,0,20,56,36,40,13]),function(J,t,w,i,U,z,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class b extends i.AbstractScrollbar{constructor(d,h,N){const a=d.getScrollDimensions(),s=d.getCurrentScrollPosition();if(super({lazyRender:h.lazyRender,host:N,scrollbarState:new z.ScrollbarState(h.horizontalHasArrows?h.arrowSize:0,h.horizontal===2?0:h.horizontalScrollbarSize,h.vertical===2?0:h.verticalScrollbarSize,a.width,a.scrollWidth,s.scrollLeft),visibility:h.horizontal,extraScrollbarClassName:"horizontal",scrollable:d,scrollByPage:h.scrollByPage}),h.horizontalHasArrows){const e=(h.arrowSize-U.ARROW_IMG_SIZE)/2,r=(h.horizontalScrollbarSize-U.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:y.Codicon.scrollbarButtonLeft,top:r,left:e,bottom:void 0,right:void 0,bgWidth:h.arrowSize,bgHeight:h.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new w.StandardWheelEvent(null,1,0))}),this.r({className:"scra",icon:y.Codicon.scrollbarButtonRight,top:r,left:void 0,bottom:void 0,right:e,bgWidth:h.arrowSize,bgHeight:h.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new w.StandardWheelEvent(null,-1,0))})}this.s(Math.floor((h.horizontalScrollbarSize-h.horizontalSliderSize)/2),0,void 0,h.horizontalSliderSize)}M(d,h){this.slider.setWidth(d),this.slider.setLeft(h)}L(d,h){this.domNode.setWidth(d),this.domNode.setHeight(h),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(d){return this.n=this.v(d.scrollWidth)||this.n,this.n=this.w(d.scrollLeft)||this.n,this.n=this.t(d.width)||this.n,this.n}N(d,h){return d}O(d){return d.pageX}P(d){return d.pageY}Q(d){this.slider.setHeight(d)}writeScrollPosition(d,h){d.scrollLeft=h}updateOptions(d){this.updateScrollbarSize(d.horizontal===2?0:d.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(d.vertical===2?0:d.verticalScrollbarSize),this.i.setVisibility(d.horizontal),this.c=d.scrollByPage}}t.HorizontalScrollbar=b}),define(ge[121],me([1,0,20,56,36,40,13]),function(J,t,w,i,U,z,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class b extends i.AbstractScrollbar{constructor(d,h,N){const a=d.getScrollDimensions(),s=d.getCurrentScrollPosition();if(super({lazyRender:h.lazyRender,host:N,scrollbarState:new z.ScrollbarState(h.verticalHasArrows?h.arrowSize:0,h.vertical===2?0:h.verticalScrollbarSize,0,a.height,a.scrollHeight,s.scrollTop),visibility:h.vertical,extraScrollbarClassName:"vertical",scrollable:d,scrollByPage:h.scrollByPage}),h.verticalHasArrows){const e=(h.arrowSize-U.ARROW_IMG_SIZE)/2,r=(h.verticalScrollbarSize-U.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:y.Codicon.scrollbarButtonUp,top:e,left:r,bottom:void 0,right:void 0,bgWidth:h.verticalScrollbarSize,bgHeight:h.arrowSize,onActivate:()=>this.a.onMouseWheel(new w.StandardWheelEvent(null,0,1))}),this.r({className:"scra",icon:y.Codicon.scrollbarButtonDown,top:void 0,left:r,bottom:e,right:void 0,bgWidth:h.verticalScrollbarSize,bgHeight:h.arrowSize,onActivate:()=>this.a.onMouseWheel(new w.StandardWheelEvent(null,0,-1))})}this.s(0,Math.floor((h.verticalScrollbarSize-h.verticalSliderSize)/2),h.verticalSliderSize,void 0)}M(d,h){this.slider.setHeight(d),this.slider.setTop(h)}L(d,h){this.domNode.setWidth(h),this.domNode.setHeight(d),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(d){return this.n=this.v(d.scrollHeight)||this.n,this.n=this.w(d.scrollTop)||this.n,this.n=this.t(d.height)||this.n,this.n}N(d,h){return h}O(d){return d.pageY}P(d){return d.pageX}Q(d){this.slider.setWidth(d)}writeScrollPosition(d,h){d.scrollTop=h}updateOptions(d){this.updateScrollbarSize(d.vertical===2?0:d.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.i.setVisibility(d.vertical),this.c=d.scrollByPage}}t.VerticalScrollbar=b}),define(ge[57],me([1,0,17,4,39,20,120,121,18,9,3,2,5,49,90]),function(J,t,w,i,U,z,y,b,f,d,h,N,a,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,r=50,o=!0;class l{constructor(F,c,p){this.timestamp=F,this.deltaX=c,this.deltaY=p,this.score=0}}class u{constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let F=1,c=0,p=1,m=this.d;do{const v=m===this.c?F:Math.pow(2,-p);if(F-=v,c+=this.b[m].score*v,m===this.c)break;m=(this.a+m-1)%this.a,p++}while(!0);return c<=.5}acceptStandardWheelEvent(F){const c=window.devicePixelRatio/(0,w.getZoomFactor)();a.isWindows||a.isLinux?this.accept(Date.now(),F.deltaX/c,F.deltaY/c):this.accept(Date.now(),F.deltaX,F.deltaY)}accept(F,c,p){const m=new l(F,c,p);m.score=this.f(m),this.c===-1&&this.d===-1?(this.b[0]=m,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=m)}f(F){if(Math.abs(F.deltaX)>0&&Math.abs(F.deltaY)>0)return 1;let c=.5;const p=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(F.deltaX)||!this.g(F.deltaY))&&(c+=.25),Math.min(Math.max(c,0),1)}g(F){return Math.abs(Math.round(F)-F)<.01}}t.MouseWheelClassifier=u,u.INSTANCE=new u;class D extends f.Widget{get options(){return this.a}constructor(F,c,p){super(),this.I=this.B(new h.Emitter),this.onScroll=this.I.event,this.J=this.B(new h.Emitter),this.onWillScroll=this.J.event,F.style.overflow="hidden",this.a=A(c),this.b=p,this.B(this.b.onScroll(v=>{this.J.fire(v),this.N(v),this.I.fire(v)}));const m={onMouseWheel:v=>this.M(v),onDragStart:()=>this.P(),onDragEnd:()=>this.Q()};this.c=this.B(new b.VerticalScrollbar(this.b,this.a,m)),this.g=this.B(new y.HorizontalScrollbar(this.b,this.a,m)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(F),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.i=(0,U.createFastDomNode)(document.createElement("div")),this.i.setClassName("shadow"),this.h.appendChild(this.i.domNode),this.l=(0,U.createFastDomNode)(document.createElement("div")),this.l.setClassName("shadow"),this.h.appendChild(this.l.domNode),this.n=(0,U.createFastDomNode)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode)):(this.i=null,this.l=null,this.n=null),this.r=this.a.listenOnDomNode||this.h,this.s=[],this.L(this.a.handleMouseWheel),this.k(this.r,v=>this.S(v)),this.m(this.r,v=>this.R(v)),this.w=this.B(new d.TimeoutTimer),this.t=!1,this.v=!1,this.y=!0,this.H=!0}dispose(){this.s=(0,N.dispose)(this.s),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(F){this.c.delegatePointerDown(F)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(F){this.b.setScrollDimensions(F,!1)}updateClassName(F){this.a.className=F,a.isMacintosh&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(F){typeof F.handleMouseWheel<"u"&&(this.a.handleMouseWheel=F.handleMouseWheel,this.L(this.a.handleMouseWheel)),typeof F.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=F.mouseWheelScrollSensitivity),typeof F.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=F.fastScrollSensitivity),typeof F.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=F.scrollPredominantAxis),typeof F.horizontal<"u"&&(this.a.horizontal=F.horizontal),typeof F.vertical<"u"&&(this.a.vertical=F.vertical),typeof F.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=F.horizontalScrollbarSize),typeof F.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=F.verticalScrollbarSize),typeof F.scrollByPage<"u"&&(this.a.scrollByPage=F.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.O()}setRevealOnScroll(F){this.H=F}delegateScrollFromMouseWheelEvent(F){this.M(new z.StandardWheelEvent(F))}L(F){if(this.s.length>0!==F&&(this.s=(0,N.dispose)(this.s),F)){const p=m=>{this.M(new z.StandardWheelEvent(m))};this.s.push(i.addDisposableListener(this.r,i.EventType.MOUSE_WHEEL,p,{passive:!1}))}}M(F){const c=u.INSTANCE;o&&c.acceptStandardWheelEvent(F);let p=!1;if(F.deltaY||F.deltaX){let v=F.deltaY*this.a.mouseWheelScrollSensitivity,M=F.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(Math.abs(v)>=Math.abs(M)?M=0:v=0),this.a.flipAxes&&([v,M]=[M,v]);const V=!a.isMacintosh&&F.browserEvent&&F.browserEvent.shiftKey;(this.a.scrollYToX||V)&&!M&&(M=v,v=0),F.browserEvent&&F.browserEvent.altKey&&(M=M*this.a.fastScrollSensitivity,v=v*this.a.fastScrollSensitivity);const x=this.b.getFutureScrollPosition();let Z={};if(v){const ee=r*v,se=x.scrollTop-(ee<0?Math.floor(ee):Math.ceil(ee));this.c.writeScrollPosition(Z,se)}if(M){const ee=r*M,se=x.scrollLeft-(ee<0?Math.floor(ee):Math.ceil(ee));this.g.writeScrollPosition(Z,se)}Z=this.b.validateScrollPosition(Z),(x.scrollLeft!==Z.scrollLeft||x.scrollTop!==Z.scrollTop)&&(o&&this.a.mouseWheelSmoothScroll&&c.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(Z):this.b.setScrollPositionNow(Z),p=!0)}let m=p;!m&&this.a.alwaysConsumeMouseWheel&&(m=!0),!m&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(m=!0),m&&(F.preventDefault(),F.stopPropagation())}N(F){this.y=this.g.onDidScroll(F)||this.y,this.y=this.c.onDidScroll(F)||this.y,this.a.useShadows&&(this.y=!0),this.H&&this.U(),this.a.lazyRender||this.O()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.O()}O(){if(!!this.y&&(this.y=!1,this.g.render(),this.c.render(),this.a.useShadows)){const F=this.b.getCurrentScrollPosition(),c=F.scrollTop>0,p=F.scrollLeft>0,m=p?" left":"",v=c?" top":"",M=p||c?" top-left-corner":"";this.i.setClassName(`shadow${m}`),this.l.setClassName(`shadow${v}`),this.n.setClassName(`shadow${M}${v}${m}`)}}P(){this.t=!0,this.U()}Q(){this.t=!1,this.W()}R(F){this.v=!1,this.W()}S(F){this.v=!0,this.U()}U(){this.c.beginReveal(),this.g.beginReveal(),this.X()}W(){!this.v&&!this.t&&(this.c.beginHide(),this.g.beginHide())}X(){!this.v&&!this.t&&this.w.cancelAndSet(()=>this.W(),e)}}t.AbstractScrollableElement=D;class S extends D{constructor(F,c){c=c||{},c.mouseWheelSmoothScroll=!1;const p=new s.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:m=>i.scheduleAtNextAnimationFrame(m)});super(F,c,p),this.B(p)}setScrollPosition(F){this.b.setScrollPositionNow(F)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.ScrollableElement=S;class k extends D{constructor(F,c,p){super(F,c,p)}setScrollPosition(F){F.reuseAnimation?this.b.setScrollPositionSmooth(F,F.reuseAnimation):this.b.setScrollPositionNow(F)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.SmoothScrollableElement=k;class g extends D{constructor(F,c){c=c||{},c.mouseWheelSmoothScroll=!1;const p=new s.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:m=>i.scheduleAtNextAnimationFrame(m)});super(F,c,p),this.B(p),this.Y=F,this.onScroll(m=>{m.scrollTopChanged&&(this.Y.scrollTop=m.scrollTop),m.scrollLeftChanged&&(this.Y.scrollLeft=m.scrollLeft)}),this.scanDomNode()}setScrollPosition(F){this.b.setScrollPositionNow(F)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.Y.clientWidth,scrollWidth:this.Y.scrollWidth,height:this.Y.clientHeight,scrollHeight:this.Y.scrollHeight}),this.setScrollPosition({scrollLeft:this.Y.scrollLeft,scrollTop:this.Y.scrollTop})}}t.DomScrollableElement=g;function A(L){const F={lazyRender:typeof L.lazyRender<"u"?L.lazyRender:!1,className:typeof L.className<"u"?L.className:"",useShadows:typeof L.useShadows<"u"?L.useShadows:!0,handleMouseWheel:typeof L.handleMouseWheel<"u"?L.handleMouseWheel:!0,flipAxes:typeof L.flipAxes<"u"?L.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof L.consumeMouseWheelIfScrollbarIsNeeded<"u"?L.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof L.alwaysConsumeMouseWheel<"u"?L.alwaysConsumeMouseWheel:!1,scrollYToX:typeof L.scrollYToX<"u"?L.scrollYToX:!1,mouseWheelScrollSensitivity:typeof L.mouseWheelScrollSensitivity<"u"?L.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof L.fastScrollSensitivity<"u"?L.fastScrollSensitivity:5,scrollPredominantAxis:typeof L.scrollPredominantAxis<"u"?L.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof L.mouseWheelSmoothScroll<"u"?L.mouseWheelSmoothScroll:!0,arrowSize:typeof L.arrowSize<"u"?L.arrowSize:11,listenOnDomNode:typeof L.listenOnDomNode<"u"?L.listenOnDomNode:null,horizontal:typeof L.horizontal<"u"?L.horizontal:1,horizontalScrollbarSize:typeof L.horizontalScrollbarSize<"u"?L.horizontalScrollbarSize:10,horizontalSliderSize:typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:0,horizontalHasArrows:typeof L.horizontalHasArrows<"u"?L.horizontalHasArrows:!1,vertical:typeof L.vertical<"u"?L.vertical:1,verticalScrollbarSize:typeof L.verticalScrollbarSize<"u"?L.verticalScrollbarSize:10,verticalHasArrows:typeof L.verticalHasArrows<"u"?L.verticalHasArrows:!1,verticalSliderSize:typeof L.verticalSliderSize<"u"?L.verticalSliderSize:0,scrollByPage:typeof L.scrollByPage<"u"?L.scrollByPage:!1};return F.horizontalSliderSize=typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:F.horizontalScrollbarSize,F.verticalSliderSize=typeof L.verticalSliderSize<"u"?L.verticalSliderSize:F.verticalScrollbarSize,a.isMacintosh&&(F.className+=" mac"),F}}),define(ge[58],me([1,0,51,4,19,22,57,14,9,24,3,2,47,49,79,116,6]),function(J,t,w,i,U,z,y,b,f,d,h,N,a,s,e,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const l={CurrentDragAndDropData:void 0},u={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(F){return[F]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class D{get context(){return this.d}set context(c){this.d=c}constructor(c){this.elements=c}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=D;class S{constructor(c){this.elements=c}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=S;class k{constructor(){this.types=[],this.files=[]}update(c){if(c.types&&this.types.splice(0,this.types.length,...c.types),c.files){this.files.splice(0,this.files.length);for(let p=0;p<c.files.length;p++){const m=c.files.item(p);m&&(m.size||m.type)&&this.files.push(m)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=k;function g(F,c){return Array.isArray(F)&&Array.isArray(c)?(0,b.equals)(F,c):F===c}class A{constructor(c){c?.getSetSize?this.getSetSize=c.getSetSize.bind(c):this.getSetSize=(p,m,v)=>v,c?.getPosInSet?this.getPosInSet=c.getPosInSet.bind(c):this.getPosInSet=(p,m)=>m+1,c?.getRole?this.getRole=c.getRole.bind(c):this.getRole=p=>"listitem",c?.isChecked?this.isChecked=c.isChecked.bind(c):this.isChecked=p=>{}}}class L{get contentHeight(){return this.g.size}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get O(){return this.N}set O(c){if(c!==this.N){if(c&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.N=c,this.domNode.classList.toggle("horizontal-scrolling",this.N),this.N){for(const p of this.d)this.X(p);this.U(),this.q.setScrollDimensions({width:(0,i.getContentWidth)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(c,p,m,v=u){if(this.P=p,this.domId=`list_id_${++L.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new f.Delayer(50),this.v=!1,this.x=N.Disposable.None,this.y=0,this.G=!1,this.J=N.Disposable.None,this.K=N.Disposable.None,this.L=new N.DisposableStore,this.M=new h.Emitter,this.onDidChangeContentHeight=h.Event.latch(this.M.event,void 0,this.L),this.N=!1,v.horizontalScrolling&&v.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.RangeMap;for(const V of m)this.j.set(V.templateId,V);this.h=this.L.add(new r.RowCache(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof v.mouseSupport=="boolean"?v.mouseSupport:!0),this.N=v.horizontalScrolling??u.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.N),this.C=typeof v.additionalScrollHeight>"u"?0:v.additionalScrollHeight,this.D=new A(v.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(v.transformOptimization??u.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(z.Gesture.addTarget(this.o)),this.p=new s.Scrollable({forceIntegerValues:!0,smoothScrollDuration:v.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:V=>(0,i.scheduleAtNextAnimationFrame)(V)}),this.q=this.L.add(new y.SmoothScrollableElement(this.o,{alwaysConsumeMouseWheel:v.alwaysConsumeMouseWheel??u.alwaysConsumeMouseWheel,horizontal:1,vertical:v.verticalScrollMode??u.verticalScrollMode,useShadows:v.useShadows??u.useShadows,mouseWheelScrollSensitivity:v.mouseWheelScrollSensitivity,fastScrollSensitivity:v.fastScrollSensitivity,scrollByPage:v.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),c.appendChild(this.domNode),this.q.onScroll(this.fb,this,this.L),this.L.add((0,i.addDisposableListener)(this.o,z.EventType.Change,V=>this.gb(V))),this.L.add((0,i.addDisposableListener)(this.q.getDomNode(),"scroll",V=>V.target.scrollTop=0)),this.L.add((0,i.addDisposableListener)(this.domNode,"dragover",V=>this.ib(this.eb(V)))),this.L.add((0,i.addDisposableListener)(this.domNode,"drop",V=>this.kb(this.eb(V)))),this.L.add((0,i.addDisposableListener)(this.domNode,"dragleave",V=>this.jb(this.eb(V)))),this.L.add((0,i.addDisposableListener)(this.domNode,"dragend",V=>this.lb(V))),this.z=v.setRowLineHeight??u.setRowLineHeight,this.A=v.setRowHeight??u.setRowHeight,this.B=v.supportDynamicHeights??u.supportDynamicHeights,this.F=v.dnd??u.dnd,this.layout(v.initialSize?.height,v.initialSize?.width)}updateOptions(c){c.additionalScrollHeight!==void 0&&(this.C=c.additionalScrollHeight,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),c.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(c.smoothScrolling?125:0),c.horizontalScrolling!==void 0&&(this.O=c.horizontalScrolling);let p;c.scrollByPage!==void 0&&(p={...p??{},scrollByPage:c.scrollByPage}),c.mouseWheelScrollSensitivity!==void 0&&(p={...p??{},mouseWheelScrollSensitivity:c.mouseWheelScrollSensitivity}),c.fastScrollSensitivity!==void 0&&(p={...p??{},fastScrollSensitivity:c.fastScrollSensitivity}),p&&this.q.updateOptions(p)}delegateScrollFromMouseWheelEvent(c){this.q.delegateScrollFromMouseWheelEvent(c)}delegateVerticalScrollbarPointerDown(c){this.q.delegateVerticalScrollbarPointerDown(c)}updateElementHeight(c,p,m){if(c<0||c>=this.d.length)return;const v=this.d[c].size;if(typeof p>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[c].lastDynamicHeightWidth=void 0,p=v+this.tb(c)}if(v===p)return;const M=this.rb(this.k,this.m);let V=0;c<M.start||m!==null&&m>c&&m<=M.end?V=p-v:V=0,this.g.splice(c,1,[{size:p}]),this.d[c].size=p,this.V(M,Math.max(0,this.k+V),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.R(),this.B&&this.sb(this.k,this.m)}splice(c,p,m=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.Q(c,p,m)}finally{this.v=!1,this.M.fire(this.contentHeight)}}Q(c,p,m=[]){const v=this.rb(this.k,this.m),M={start:c,end:c+p},V=a.Range.intersect(v,M),x=new Map;for(let ae=V.end-1;ae>=V.start;ae--){const te=this.d[ae];if(te.dragStartDisposable.dispose(),te.checkedDisposable.dispose(),te.row){let W=x.get(te.templateId);W||(W=[],x.set(te.templateId,W));const n=this.j.get(te.templateId);n&&n.disposeElement&&n.disposeElement(te.element,ae,te.row.templateData,te.size),W.push(te.row)}te.row=null}const Z={start:c+p,end:this.d.length},ee=a.Range.intersect(Z,v),se=a.Range.relativeComplement(Z,v),he=m.map(ae=>({id:String(this.f++),element:ae,templateId:this.P.getTemplateId(ae),size:this.P.getHeight(ae),width:void 0,hasDynamicHeight:!!this.P.hasDynamicHeight&&this.P.hasDynamicHeight(ae),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:N.Disposable.None,checkedDisposable:N.Disposable.None}));let ue;c===0&&p>=this.d.length?(this.g=new e.RangeMap,this.g.splice(0,0,he),ue=this.d,this.d=he):(this.g.splice(c,p,he),ue=this.d.splice(c,p,...he));const de=m.length-p,we=this.rb(this.k,this.m),Te=(0,e.shift)(ee,de),Me=a.Range.intersect(we,Te);for(let ae=Me.start;ae<Me.end;ae++)this.Y(this.d[ae],ae);const Oe=a.Range.relativeComplement(Te,we);for(const ae of Oe)for(let te=ae.start;te<ae.end;te++)this.Z(te);const j=se.map(ae=>(0,e.shift)(ae,de)),ie=[{start:c,end:c+m.length},...j].map(ae=>a.Range.intersect(we,ae)),ne=this.ub(ie);for(const ae of ie)for(let te=ae.start;te<ae.end;te++){const W=this.d[te],E=x.get(W.templateId)?.pop();this.W(te,ne,E)}for(const ae of x.values())for(const te of ae)this.h.release(te);return this.R(),this.B&&this.sb(this.scrollTop,this.renderHeight),ue.map(ae=>ae.element)}R(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,i.scheduleAtNextAnimationFrame)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.U(),this.t=null}))}S(){if(!this.O){this.u.cancel();return}this.u.trigger(()=>this.U())}U(){if(!this.O)return;let c=0;for(const p of this.d)typeof p.width<"u"&&(c=Math.max(c,p.width));this.E=c,this.q.setScrollDimensions({scrollWidth:c===0?0:c+10})}updateWidth(c){if(!this.O||typeof this.E>"u")return;const p=this.d[c];this.X(p),typeof p.width<"u"&&p.width>this.E&&(this.E=p.width,this.q.setScrollDimensions({scrollWidth:this.E+10}))}rerender(){if(!!this.B){for(const c of this.d)c.lastDynamicHeightWidth=void 0;this.sb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const c=this.rb(this.k,this.m),p=this.g.positionAt(c.start),m=this.g.positionAt(c.start+1);return m!==-1&&(m-p)/2+p<this.scrollTop?c.start+1:c.start}get lastVisibleIndex(){return this.rb(this.k,this.m).end-1}element(c){return this.d[c].element}indexOf(c){return this.d.findIndex(p=>p.element===c)}domElement(c){const p=this.d[c].row;return p&&p.domNode}elementHeight(c){return this.d[c].size}elementTop(c){return this.g.positionAt(c)}indexAt(c){return this.g.indexAt(c)}indexAfter(c){return this.g.indexAfter(c)}layout(c,p){const m={height:typeof c=="number"?c:(0,i.getContentHeight)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,m.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(m),typeof p<"u"&&(this.n=p,this.B&&this.sb(this.scrollTop,this.renderHeight)),this.O&&this.q.setScrollDimensions({width:typeof p=="number"?p:(0,i.getContentWidth)(this.domNode)})}V(c,p,m,v,M,V=!1){const x=this.rb(p,m),Z=a.Range.relativeComplement(x,c),ee=a.Range.relativeComplement(c,x),se=this.ub(Z);if(V){const he=a.Range.intersect(c,x);for(let ue=he.start;ue<he.end;ue++)this.Y(this.d[ue],ue)}this.h.transact(()=>{for(const he of ee)for(let ue=he.start;ue<he.end;ue++)this.Z(ue);for(const he of Z)for(let ue=he.start;ue<he.end;ue++)this.W(ue,se)}),v!==void 0&&(this.o.style.left=`-${v}px`),this.o.style.top=`-${p}px`,this.O&&M!==void 0&&(this.o.style.width=`${Math.max(M,this.n)}px`),this.k=p,this.m=m}W(c,p,m){const v=this.d[c];let M=!1;if(!v.row)if(m)v.row=m;else{const se=this.h.alloc(v.templateId);v.row=se.row,M=se.isReusingConnectedDomNode}const V=this.D.getRole(v.element)||"listitem";v.row.domNode.setAttribute("role",V);const x=this.D.isChecked(v.element);if(typeof x=="boolean")v.row.domNode.setAttribute("aria-checked",String(!!x));else if(x){const se=he=>v.row.domNode.setAttribute("aria-checked",String(!!he));se(x.value),v.checkedDisposable=x.onDidChange(se)}(M||!v.row.domNode.parentElement)&&(p?this.o.insertBefore(v.row.domNode,p):this.o.appendChild(v.row.domNode)),this.Y(v,c);const Z=this.j.get(v.templateId);if(!Z)throw new Error(`No renderer found for template id ${v.templateId}`);Z?.renderElement(v.element,c,v.row.templateData,v.size);const ee=this.F.getDragURI(v.element);v.dragStartDisposable.dispose(),v.row.domNode.draggable=!!ee,ee&&(v.dragStartDisposable=(0,i.addDisposableListener)(v.row.domNode,"dragstart",se=>this.hb(v.element,ee,se))),this.O&&(this.X(v),this.S())}X(c){if(!c.row||!c.row.domNode)return;c.row.domNode.style.width="fit-content",c.width=(0,i.getContentWidth)(c.row.domNode);const p=window.getComputedStyle(c.row.domNode);p.paddingLeft&&(c.width+=parseFloat(p.paddingLeft)),p.paddingRight&&(c.width+=parseFloat(p.paddingRight)),c.row.domNode.style.width=""}Y(c,p){c.row.domNode.style.top=`${this.elementTop(p)}px`,this.A&&(c.row.domNode.style.height=`${c.size}px`),this.z&&(c.row.domNode.style.lineHeight=`${c.size}px`),c.row.domNode.setAttribute("data-index",`${p}`),c.row.domNode.setAttribute("data-last-element",p===this.length-1?"true":"false"),c.row.domNode.setAttribute("data-parity",p%2===0?"even":"odd"),c.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(c.element,p,this.length))),c.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(c.element,p))),c.row.domNode.setAttribute("id",this.getElementDomId(p)),c.row.domNode.classList.toggle("drop-target",c.dropTarget)}Z(c){const p=this.d[c];if(p.dragStartDisposable.dispose(),p.checkedDisposable.dispose(),p.row){const m=this.j.get(p.templateId);m&&m.disposeElement&&m.disposeElement(p.element,c,p.row.templateData,p.size),this.h.release(p.row),p.row=null}this.O&&this.S()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(c,p){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:c,reuseAnimation:p})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(c){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:c})}get scrollTop(){return this.getScrollTop()}set scrollTop(c){this.setScrollTop(c)}get scrollHeight(){return this.s+(this.O?10:0)+this.C}get onMouseClick(){return h.Event.map(this.L.add(new U.DomEmitter(this.domNode,"click")).event,c=>this.ab(c),this.L)}get onMouseDblClick(){return h.Event.map(this.L.add(new U.DomEmitter(this.domNode,"dblclick")).event,c=>this.ab(c),this.L)}get onMouseMiddleClick(){return h.Event.filter(h.Event.map(this.L.add(new U.DomEmitter(this.domNode,"auxclick")).event,c=>this.ab(c),this.L),c=>c.browserEvent.button===1,this.L)}get onMouseUp(){return h.Event.map(this.L.add(new U.DomEmitter(this.domNode,"mouseup")).event,c=>this.ab(c),this.L)}get onMouseDown(){return h.Event.map(this.L.add(new U.DomEmitter(this.domNode,"mousedown")).event,c=>this.ab(c),this.L)}get onMouseOver(){return h.Event.map(this.L.add(new U.DomEmitter(this.domNode,"mouseover")).event,c=>this.ab(c),this.L)}get onMouseMove(){return h.Event.map(this.L.add(new U.DomEmitter(this.domNode,"mousemove")).event,c=>this.ab(c),this.L)}get onMouseOut(){return h.Event.map(this.L.add(new U.DomEmitter(this.domNode,"mouseout")).event,c=>this.ab(c),this.L)}get onContextMenu(){return h.Event.any(h.Event.map(this.L.add(new U.DomEmitter(this.domNode,"contextmenu")).event,c=>this.ab(c),this.L),h.Event.map(this.L.add(new U.DomEmitter(this.domNode,z.EventType.Contextmenu)).event,c=>this.db(c),this.L))}get onTouchStart(){return h.Event.map(this.L.add(new U.DomEmitter(this.domNode,"touchstart")).event,c=>this.bb(c),this.L)}get onTap(){return h.Event.map(this.L.add(new U.DomEmitter(this.o,z.EventType.Tap)).event,c=>this.db(c),this.L)}ab(c){const p=this.qb(c.target||null),m=typeof p>"u"?void 0:this.d[p],v=m&&m.element;return{browserEvent:c,index:p,element:v}}bb(c){const p=this.qb(c.target||null),m=typeof p>"u"?void 0:this.d[p],v=m&&m.element;return{browserEvent:c,index:p,element:v}}db(c){const p=this.qb(c.initialTarget||null),m=typeof p>"u"?void 0:this.d[p],v=m&&m.element;return{browserEvent:c,index:p,element:v}}eb(c){const p=this.qb(c.target||null),m=typeof p>"u"?void 0:this.d[p],v=m&&m.element;return{browserEvent:c,index:p,element:v}}fb(c){try{const p=this.rb(this.k,this.m);this.V(p,c.scrollTop,c.height,c.scrollLeft,c.scrollWidth),this.B&&this.sb(c.scrollTop,c.height,c.inSmoothScrolling)}catch(p){throw console.error("Got bad scroll event:",c),p}}gb(c){c.preventDefault(),c.stopPropagation(),this.scrollTop-=c.translationY}hb(c,p,m){if(!m.dataTransfer)return;const v=this.F.getDragElements(c);if(m.dataTransfer.effectAllowed="copyMove",m.dataTransfer.setData(w.DataTransfers.TEXT,p),m.dataTransfer.setDragImage){let M;this.F.getDragLabel&&(M=this.F.getDragLabel(v,m)),typeof M>"u"&&(M=String(v.length));const V=(0,i.$)(".monaco-drag-image");V.textContent=M,document.body.appendChild(V),m.dataTransfer.setDragImage(V,-10,-10),setTimeout(()=>document.body.removeChild(V),0)}this.domNode.classList.add("dragging"),this.H=new D(v),l.CurrentDragAndDropData=new S(v),this.F.onDragStart?.(this.H,m)}ib(c){if(c.browserEvent.preventDefault(),this.K.dispose(),l.CurrentDragAndDropData&&l.CurrentDragAndDropData.getData()==="vscode-ui"||(this.nb(c.browserEvent),!c.browserEvent.dataTransfer))return!1;if(!this.H)if(l.CurrentDragAndDropData)this.H=l.CurrentDragAndDropData;else{if(!c.browserEvent.dataTransfer.types)return!1;this.H=new k}const p=this.F.onDragOver(this.H,c.element,c.index,c.browserEvent);if(this.G=typeof p=="boolean"?p:p.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;c.browserEvent.dataTransfer.dropEffect=typeof p!="boolean"&&p.effect===0?"copy":"move";let m;if(typeof p!="boolean"&&p.feedback?m=p.feedback:typeof c.index>"u"?m=[-1]:m=[c.index],m=(0,b.distinct)(m).filter(v=>v>=-1&&v<this.length).sort((v,M)=>v-M),m=m[0]===-1?[-1]:m,g(this.I,m))return!0;if(this.I=m,this.J.dispose(),m[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,N.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const v of m){const M=this.d[v];M.dropTarget=!0,M.row?.domNode.classList.add("drop-target")}this.J=(0,N.toDisposable)(()=>{for(const v of m){const M=this.d[v];M.dropTarget=!1,M.row?.domNode.classList.remove("drop-target")}})}return!0}jb(c){this.K.dispose(),this.K=(0,f.disposableTimeout)(()=>this.mb(),100),this.H&&this.F.onDragLeave?.(this.H,c.element,c.index,c.browserEvent)}kb(c){if(!this.G)return;const p=this.H;this.pb(),this.mb(),this.domNode.classList.remove("dragging"),this.H=void 0,l.CurrentDragAndDropData=void 0,!(!p||!c.browserEvent.dataTransfer)&&(c.browserEvent.preventDefault(),p.update(c.browserEvent.dataTransfer),this.F.drop(p,c.element,c.index,c.browserEvent))}lb(c){this.G=!1,this.pb(),this.mb(),this.domNode.classList.remove("dragging"),this.H=void 0,l.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(c)}mb(){this.I=void 0,this.J.dispose(),this.J=N.Disposable.None}nb(c){if(!this.w){const p=(0,i.getTopLeftOffset)(this.domNode).top;this.w=(0,i.animate)(this.ob.bind(this,p))}this.x.dispose(),this.x=(0,f.disposableTimeout)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3),this.y=c.pageY}ob(c){if(this.y===void 0)return;const p=this.y-c,m=this.renderHeight-35;p<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(p-35))):p>m&&(this.scrollTop+=Math.min(14,Math.floor(.3*(p-m))))}pb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}qb(c){const p=this.q.getDomNode();let m=c;for(;m instanceof HTMLElement&&m!==this.o&&p.contains(m);){const v=m.getAttribute("data-index");if(v){const M=Number(v);if(!isNaN(M))return M}m=m.parentElement}}rb(c,p){return{start:this.g.indexAt(c),end:this.g.indexAfter(c+p-1)}}sb(c,p,m){const v=this.rb(c,p);let M,V;c===this.elementTop(v.start)?(M=v.start,V=0):v.end-v.start>1&&(M=v.start+1,V=this.elementTop(M)-c);let x=0;for(;;){const Z=this.rb(c,p);let ee=!1;for(let se=Z.start;se<Z.end;se++){const he=this.tb(se);he!==0&&this.g.splice(se,1,[this.d[se]]),x+=he,ee=ee||he!==0}if(!ee){x!==0&&this.R();const se=a.Range.relativeComplement(v,Z);for(const ue of se)for(let de=ue.start;de<ue.end;de++)this.d[de].row&&this.Z(de);const he=a.Range.relativeComplement(Z,v);for(const ue of he)for(let de=ue.start;de<ue.end;de++){const we=de+1,Te=we<this.d.length?this.d[we].row:null,Me=Te?Te.domNode:null;this.W(de,Me)}for(let ue=Z.start;ue<Z.end;ue++)this.d[ue].row&&this.Y(this.d[ue],ue);if(typeof M=="number"){const ue=this.p.getFutureScrollPosition().scrollTop-c,de=this.elementTop(M)-V+ue;this.setScrollTop(de,m)}this.M.fire(this.contentHeight);return}}}tb(c){const p=this.d[c];if(this.P.getDynamicHeight){const V=this.P.getDynamicHeight(p.element);if(V!==null){const x=p.size;return p.size=V,p.lastDynamicHeightWidth=this.n,V-x}}if(!p.hasDynamicHeight||p.lastDynamicHeightWidth===this.n||!!this.P.hasDynamicHeight&&!this.P.hasDynamicHeight(p.element))return 0;const m=p.size;if(p.row)return p.row.domNode.style.height="",p.size=p.row.domNode.offsetHeight,p.lastDynamicHeightWidth=this.n,p.size-m;const{row:v}=this.h.alloc(p.templateId);v.domNode.style.height="",this.o.appendChild(v.domNode);const M=this.j.get(p.templateId);if(!M)throw new o.BugIndicatingError("Missing renderer for templateId: "+p.templateId);return M.renderElement(p.element,c,v.templateData,void 0),p.size=v.domNode.offsetHeight,M.disposeElement?.(p.element,c,v.templateData,void 0),this.P.setDynamicHeight?.(p.element,p.size),p.lastDynamicHeightWidth=this.n,this.o.removeChild(v.domNode),this.h.release(v),p.size-m}ub(c){const p=c[c.length-1];if(!p)return null;const m=this.d[p.end];return!m||!m.row?null:m.row.domNode}getElementDomId(c){return`${this.domId}_${c}`}dispose(){if(this.d){for(const c of this.d)if(c.row){const p=this.j.get(c.row.templateId);p&&(p.disposeElement?.(c.element,-1,c.row.templateData,void 0),p.disposeTemplate(c.row.templateData))}this.d=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,N.dispose)(this.L)}}L.c=0,Ve([d.memoize],L.prototype,"onMouseClick",null),Ve([d.memoize],L.prototype,"onMouseDblClick",null),Ve([d.memoize],L.prototype,"onMouseMiddleClick",null),Ve([d.memoize],L.prototype,"onMouseUp",null),Ve([d.memoize],L.prototype,"onMouseDown",null),Ve([d.memoize],L.prototype,"onMouseOver",null),Ve([d.memoize],L.prototype,"onMouseMove",null),Ve([d.memoize],L.prototype,"onMouseOut",null),Ve([d.memoize],L.prototype,"onContextMenu",null),Ve([d.memoize],L.prototype,"onTouchStart",null),Ve([d.memoize],L.prototype,"onTap",null),t.ListView=L}),define(ge[59],me([1,0,4,19,15,22,54,69,14,9,41,24,3,32,2,46,30,5,7,68,58,89]),function(J,t,w,i,U,z,y,b,f,d,h,N,a,s,e,r,o,l,u,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class k{constructor(n){this.d=n,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(n){return n}renderElement(n,E,P){const $=this.c.findIndex(K=>K.templateData===P);if($>=0){const K=this.c[$];this.d.unrender(P),K.index=E}else{const K={index:E,templateData:P};this.c.push(K)}this.d.renderIndex(E,P)}splice(n,E,P){const $=[];for(const K of this.c)K.index<n?$.push(K):K.index>=n+E&&$.push({index:K.index+P-E,templateData:K.templateData});this.c=$}renderIndexes(n){for(const{index:E,templateData:P}of this.c)n.indexOf(E)>-1&&this.d.renderIndex(E,P)}disposeTemplate(n){const E=this.c.findIndex(P=>P.templateData===n);E<0||this.c.splice(E,1)}}class g{get name(){return this.h}get renderer(){return new k(this)}constructor(n){this.h=n,this.c=0,this.d=[],this.f=[],this.g=new a.Emitter,this.onChange=this.g.event}splice(n,E,P){E=Math.max(0,Math.min(E,this.c-n));const $=P.length-E,K=n+E,C=[...this.f.filter(R=>R<n),...P.map((R,T)=>R?T+n:-1).filter(R=>R!==-1),...this.f.filter(R=>R>=K).map(R=>R+$)],I=this.c+$;if(this.f.length>0&&C.length===0&&I>0){const R=this.f.find(T=>T>=n)??I-1;C.push(Math.min(R,I-1))}this.renderer.splice(n,E,P.length),this.k(C,C),this.c=I}renderIndex(n,E){E.classList.toggle(this.h,this.contains(n))}unrender(n){n.classList.remove(this.h)}set(n,E){return this.k(n,[...n].sort(Y),E)}k(n,E,P){const $=this.d,K=this.f;this.d=n,this.f=E;const C=Oe(K,n);return this.renderer.renderIndexes(C),this.g.fire({indexes:n,browserEvent:P}),$}get(){return this.d}contains(n){return(0,f.binarySearch)(this.f,n,Y)>=0}dispose(){(0,e.dispose)(this.g)}}Ve([N.memoize],g.prototype,"renderer",null);class A extends g{constructor(n){super("selected"),this.l=n}renderIndex(n,E){super.renderIndex(n,E),this.l&&(this.contains(n)?E.setAttribute("aria-selected","true"):E.setAttribute("aria-selected","false"))}}class L{constructor(n,E,P){this.c=n,this.d=E,this.f=P}splice(n,E,P){if(!this.f)return this.c.splice(n,E,P.map(()=>!1));const $=this.c.get().map(C=>this.f.getId(this.d.element(C)).toString()),K=P.map(C=>$.indexOf(this.f.getId(C).toString())>-1);this.c.splice(n,E,K)}}function F(W){return W.tagName==="INPUT"||W.tagName==="TEXTAREA"}t.isInputElement=F;function c(W){return W.classList.contains("monaco-editor")?!0:W.classList.contains("monaco-list")||!W.parentElement?!1:c(W.parentElement)}t.isMonacoEditor=c;function p(W){return W.tagName==="A"&&W.classList.contains("monaco-button")||W.tagName==="DIV"&&W.classList.contains("monaco-button-dropdown")?!0:W.classList.contains("monaco-list")||!W.parentElement?!1:p(W.parentElement)}t.isButton=p;class m{get f(){return this.c.add(a.Event.chain(this.c.add(new i.DomEmitter(this.h.domNode,"keydown")).event).filter(n=>!F(n.target)).map(n=>new U.StandardKeyboardEvent(n)))}constructor(n,E,P){this.g=n,this.h=E,this.c=new e.DisposableStore,this.d=new e.DisposableStore,this.f.filter($=>$.keyCode===3).on(this.k,this,this.c),this.f.filter($=>$.keyCode===16).on(this.l,this,this.c),this.f.filter($=>$.keyCode===18).on(this.o,this,this.c),this.f.filter($=>$.keyCode===11).on(this.p,this,this.c),this.f.filter($=>$.keyCode===12).on(this.q,this,this.c),this.f.filter($=>$.keyCode===9).on(this.t,this,this.c),P.multipleSelectionSupport!==!1&&this.f.filter($=>(l.isMacintosh?$.metaKey:$.ctrlKey)&&$.keyCode===31).on(this.s,this,this.d)}updateOptions(n){n.multipleSelectionSupport!==void 0&&(this.d.clear(),n.multipleSelectionSupport&&this.f.filter(E=>(l.isMacintosh?E.metaKey:E.ctrlKey)&&E.keyCode===31).on(this.s,this,this.d))}k(n){n.preventDefault(),n.stopPropagation(),this.g.setSelection(this.g.getFocus(),n.browserEvent)}l(n){n.preventDefault(),n.stopPropagation(),this.g.focusPrevious(1,!1,n.browserEvent);const E=this.g.getFocus()[0];this.g.setAnchor(E),this.g.reveal(E),this.h.domNode.focus()}o(n){n.preventDefault(),n.stopPropagation(),this.g.focusNext(1,!1,n.browserEvent);const E=this.g.getFocus()[0];this.g.setAnchor(E),this.g.reveal(E),this.h.domNode.focus()}p(n){n.preventDefault(),n.stopPropagation(),this.g.focusPreviousPage(n.browserEvent);const E=this.g.getFocus()[0];this.g.setAnchor(E),this.g.reveal(E),this.h.domNode.focus()}q(n){n.preventDefault(),n.stopPropagation(),this.g.focusNextPage(n.browserEvent);const E=this.g.getFocus()[0];this.g.setAnchor(E),this.g.reveal(E),this.h.domNode.focus()}s(n){n.preventDefault(),n.stopPropagation(),this.g.setSelection((0,f.range)(this.g.length),n.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus()}t(n){this.g.getSelection().length&&(n.preventDefault(),n.stopPropagation(),this.g.setSelection([],n.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ve([N.memoize],m.prototype,"f",null);var v;(function(W){W[W.Automatic=0]="Automatic",W[W.Trigger=1]="Trigger"})(v=t.TypeNavigationMode||(t.TypeNavigationMode={}));var M;(function(W){W[W.Idle=0]="Idle",W[W.Typing=1]="Typing"})(M||(M={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(W){return W.ctrlKey||W.metaKey||W.altKey?!1:W.keyCode>=31&&W.keyCode<=56||W.keyCode>=21&&W.keyCode<=30||W.keyCode>=93&&W.keyCode<=102||W.keyCode>=80&&W.keyCode<=90}};class V{constructor(n,E,P,$,K){this.o=n,this.p=E,this.q=P,this.s=$,this.t=K,this.c=!1,this.d=M.Idle,this.f=v.Automatic,this.g=!1,this.h=-1,this.k=new e.DisposableStore,this.l=new e.DisposableStore,this.updateOptions(n.options)}updateOptions(n){n.typeNavigationEnabled??!0?this.u():this.v(),this.f=n.typeNavigationMode??v.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let n=!1;const E=this.k.add(a.Event.chain(this.k.add(new i.DomEmitter(this.p.domNode,"keydown")).event)).filter(K=>!F(K.target)).filter(()=>this.f===v.Automatic||this.g).map(K=>new U.StandardKeyboardEvent(K)).filter(K=>n||this.s(K)).filter(K=>this.t.mightProducePrintableCharacter(K)).forEach(K=>w.EventHelper.stop(K,!0)).map(K=>K.browserEvent.key).event,P=a.Event.debounce(E,()=>null,800,void 0,void 0,this.k);a.Event.reduce(a.Event.any(E,P),(K,C)=>C===null?null:(K||"")+C,void 0,this.k)(this.z,this,this.k),P(this.w,this,this.k),E(()=>n=!0,void 0,this.k),P(()=>n=!1,void 0,this.k),this.c=!0,this.g=!1}v(){!this.c||(this.k.clear(),this.c=!1,this.g=!1)}w(){const n=this.o.getFocus();if(n.length>0&&n[0]===this.h){const E=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(n[0]));E&&(0,y.alert)(E)}this.h=-1}z(n){if(!n){this.d=M.Idle,this.g=!1;return}const E=this.o.getFocus(),P=E.length>0?E[0]:0,$=this.d===M.Idle?1:0;this.d=M.Typing;for(let K=0;K<this.o.length;K++){const C=(P+K+$)%this.o.length,I=this.q.getKeyboardNavigationLabel(this.p.element(C)),R=I&&I.toString();if(typeof R>"u"||(0,s.matchesPrefix)(n,R)){this.h=P,this.o.setFocus([C]),this.o.reveal(C);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class x{constructor(n,E){this.d=n,this.f=E,this.c=new e.DisposableStore,this.c.add(a.Event.chain(this.c.add(new i.DomEmitter(E.domNode,"keydown")).event)).filter($=>!F($.target)).map($=>new U.StandardKeyboardEvent($)).filter($=>$.keyCode===2&&!$.ctrlKey&&!$.metaKey&&!$.shiftKey&&!$.altKey).on(this.g,this,this.c)}g(n){if(n.target!==this.f.domNode)return;const E=this.d.getFocus();if(E.length===0)return;const P=this.f.domElement(E[0]);if(!P)return;const $=P.querySelector("[tabIndex]");if(!$||!($ instanceof HTMLElement)||$.tabIndex===-1)return;const K=window.getComputedStyle($);K.visibility==="hidden"||K.display==="none"||(n.preventDefault(),n.stopPropagation(),$.focus())}dispose(){this.c.dispose()}}function Z(W){return l.isMacintosh?W.browserEvent.metaKey:W.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=Z;function ee(W){return W.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=ee;function se(W){return W instanceof MouseEvent&&W.button===2}const he={isSelectionSingleChangeEvent:Z,isSelectionRangeChangeEvent:ee};class ue{constructor(n){this.k=n,this.f=new e.DisposableStore,this.g=new a.Emitter,this.onPointer=this.g.event,n.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||he),this.d=typeof n.options.mouseSupport>"u"||!!n.options.mouseSupport,this.d&&(n.onMouseDown(this.s,this,this.f),n.onContextMenu(this.t,this,this.f),n.onMouseDblClick(this.v,this,this.f),n.onTouchStart(this.s,this,this.f),this.f.add(z.Gesture.addTarget(n.getHTMLElement()))),a.Event.any(n.onMouseClick,n.onMouseMiddleClick,n.onTap)(this.u,this,this.f)}updateOptions(n){n.multipleSelectionSupport!==void 0&&(this.c=void 0,n.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||he))}o(n){return this.c?this.c.isSelectionSingleChangeEvent(n):!1}p(n){return this.c?this.c.isSelectionRangeChangeEvent(n):!1}q(n){return this.o(n)||this.p(n)}s(n){c(n.browserEvent.target)||document.activeElement!==n.browserEvent.target&&this.k.domFocus()}t(n){if(F(n.browserEvent.target)||c(n.browserEvent.target))return;const E=typeof n.index>"u"?[]:[n.index];this.k.setFocus(E,n.browserEvent)}u(n){if(!this.d||F(n.browserEvent.target)||c(n.browserEvent.target))return;const E=n.index;if(typeof E>"u"){this.k.setFocus([],n.browserEvent),this.k.setSelection([],n.browserEvent),this.k.setAnchor(void 0);return}if(this.p(n))return this.w(n);if(this.q(n))return this.w(n);this.k.setFocus([E],n.browserEvent),this.k.setAnchor(E),se(n.browserEvent)||this.k.setSelection([E],n.browserEvent),this.g.fire(n)}v(n){if(F(n.browserEvent.target)||c(n.browserEvent.target)||this.q(n))return;const E=this.k.getFocus();this.k.setSelection(E,n.browserEvent)}w(n){const E=n.index;let P=this.k.getAnchor();if(this.p(n)){typeof P>"u"&&(P=this.k.getFocus()[0]??E,this.k.setAnchor(P));const $=Math.min(P,E),K=Math.max(P,E),C=(0,f.range)($,K+1),I=this.k.getSelection(),R=Me(Oe(I,[P]),P);if(R.length===0)return;const T=Oe(C,j(I,R));this.k.setSelection(T,n.browserEvent),this.k.setFocus([E],n.browserEvent)}else if(this.o(n)){const $=this.k.getSelection(),K=$.filter(C=>C!==E);this.k.setFocus([E]),this.k.setAnchor(E),$.length===K.length?this.k.setSelection([...K,E],n.browserEvent):this.k.setSelection(K,n.browserEvent)}}dispose(){this.f.dispose()}}t.MouseController=ue;class de{constructor(n,E){this.c=n,this.d=E}style(n){const E=this.d&&`.${this.d}`,P=[];n.listBackground&&(n.listBackground.isOpaque()?P.push(`.monaco-list${E} .monaco-list-rows { background: ${n.listBackground}; }`):l.isMacintosh||console.warn(`List with id '${this.d}' was styled with a non-opaque background color. This will break sub-pixel antialiasing.`)),n.listFocusBackground&&(P.push(`.monaco-list${E}:focus .monaco-list-row.focused { background-color: ${n.listFocusBackground}; }`),P.push(`.monaco-list${E}:focus .monaco-list-row.focused:hover { background-color: ${n.listFocusBackground}; }`)),n.listFocusForeground&&P.push(`.monaco-list${E}:focus .monaco-list-row.focused { color: ${n.listFocusForeground}; }`),n.listActiveSelectionBackground&&(P.push(`.monaco-list${E}:focus .monaco-list-row.selected { background-color: ${n.listActiveSelectionBackground}; }`),P.push(`.monaco-list${E}:focus .monaco-list-row.selected:hover { background-color: ${n.listActiveSelectionBackground}; }`)),n.listActiveSelectionForeground&&P.push(`.monaco-list${E}:focus .monaco-list-row.selected { color: ${n.listActiveSelectionForeground}; }`),n.listActiveSelectionIconForeground&&P.push(`.monaco-list${E}:focus .monaco-list-row.selected .codicon { color: ${n.listActiveSelectionIconForeground}; }`),n.listFocusAndSelectionOutline&&P.push(`.monaco-list${E}:focus .monaco-list-row.selected { outline-color: ${n.listFocusAndSelectionOutline} !important; }`),n.listFocusAndSelectionBackground&&P.push(`
				.monaco-drag-image,
				.monaco-list${E}:focus .monaco-list-row.selected.focused { background-color: ${n.listFocusAndSelectionBackground}; }
			`),n.listFocusAndSelectionForeground&&P.push(`
				.monaco-drag-image,
				.monaco-list${E}:focus .monaco-list-row.selected.focused { color: ${n.listFocusAndSelectionForeground}; }
			`),n.listInactiveFocusForeground&&(P.push(`.monaco-list${E} .monaco-list-row.focused { color:  ${n.listInactiveFocusForeground}; }`),P.push(`.monaco-list${E} .monaco-list-row.focused:hover { color:  ${n.listInactiveFocusForeground}; }`)),n.listInactiveSelectionIconForeground&&P.push(`.monaco-list${E} .monaco-list-row.focused .codicon { color:  ${n.listInactiveSelectionIconForeground}; }`),n.listInactiveFocusBackground&&(P.push(`.monaco-list${E} .monaco-list-row.focused { background-color:  ${n.listInactiveFocusBackground}; }`),P.push(`.monaco-list${E} .monaco-list-row.focused:hover { background-color:  ${n.listInactiveFocusBackground}; }`)),n.listInactiveSelectionBackground&&(P.push(`.monaco-list${E} .monaco-list-row.selected { background-color:  ${n.listInactiveSelectionBackground}; }`),P.push(`.monaco-list${E} .monaco-list-row.selected:hover { background-color:  ${n.listInactiveSelectionBackground}; }`)),n.listInactiveSelectionForeground&&P.push(`.monaco-list${E} .monaco-list-row.selected { color: ${n.listInactiveSelectionForeground}; }`),n.listHoverBackground&&P.push(`.monaco-list${E}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${n.listHoverBackground}; }`),n.listHoverForeground&&P.push(`.monaco-list${E}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${n.listHoverForeground}; }`),n.listSelectionOutline&&P.push(`.monaco-list${E} .monaco-list-row.selected { outline: 1px dotted ${n.listSelectionOutline}; outline-offset: -1px; }`),n.listFocusOutline&&P.push(`
				.monaco-drag-image,
				.monaco-list${E}:focus .monaco-list-row.focused { outline: 1px solid ${n.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused .monaco-list-row.focused { outline: 1px solid ${n.listFocusOutline}; outline-offset: -1px; }
			`),n.listInactiveFocusOutline&&P.push(`.monaco-list${E} .monaco-list-row.focused { outline: 1px dotted ${n.listInactiveFocusOutline}; outline-offset: -1px; }`),n.listHoverOutline&&P.push(`.monaco-list${E} .monaco-list-row:hover { outline: 1px dashed ${n.listHoverOutline}; outline-offset: -1px; }`),n.listDropBackground&&P.push(`
				.monaco-list${E}.drop-target,
				.monaco-list${E} .monaco-list-rows.drop-target,
				.monaco-list${E} .monaco-list-row.drop-target { background-color: ${n.listDropBackground} !important; color: inherit !important; }
			`),n.tableColumnsBorder&&P.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${n.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),n.tableOddRowsBackgroundColor&&P.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${n.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=P.join(`
`)}}t.DefaultStyleController=de;const we={listFocusBackground:h.Color.fromHex("#7FB0D0"),listActiveSelectionBackground:h.Color.fromHex("#0E639C"),listActiveSelectionForeground:h.Color.fromHex("#FFFFFF"),listActiveSelectionIconForeground:h.Color.fromHex("#FFFFFF"),listFocusAndSelectionOutline:h.Color.fromHex("#90C2F9"),listFocusAndSelectionBackground:h.Color.fromHex("#094771"),listFocusAndSelectionForeground:h.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:h.Color.fromHex("#3F3F46"),listInactiveSelectionIconForeground:h.Color.fromHex("#FFFFFF"),listHoverBackground:h.Color.fromHex("#2A2D2E"),listDropBackground:h.Color.fromHex("#383B3D"),treeIndentGuidesStroke:h.Color.fromHex("#a9a9a9"),tableColumnsBorder:h.Color.fromHex("#cccccc").transparent(.2),tableOddRowsBackgroundColor:h.Color.fromHex("#cccccc").transparent(.04)},Te={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function Me(W,n){const E=W.indexOf(n);if(E===-1)return[];const P=[];let $=E-1;for(;$>=0&&W[$]===n-(E-$);)P.push(W[$--]);for(P.reverse(),$=E;$<W.length&&W[$]===n+($-E);)P.push(W[$++]);return P}function Oe(W,n){const E=[];let P=0,$=0;for(;P<W.length||$<n.length;)if(P>=W.length)E.push(n[$++]);else if($>=n.length)E.push(W[P++]);else if(W[P]===n[$]){E.push(W[P]),P++,$++;continue}else W[P]<n[$]?E.push(W[P++]):E.push(n[$++]);return E}function j(W,n){const E=[];let P=0,$=0;for(;P<W.length||$<n.length;)if(P>=W.length)E.push(n[$++]);else if($>=n.length)E.push(W[P++]);else if(W[P]===n[$]){P++,$++;continue}else W[P]<n[$]?E.push(W[P++]):$++;return E}const Y=(W,n)=>W-n;class ie{constructor(n,E){this.c=n,this.d=E}get templateId(){return this.c}renderTemplate(n){return this.d.map(E=>E.renderTemplate(n))}renderElement(n,E,P,$){let K=0;for(const C of this.d)C.renderElement(n,E,P[K++],$)}disposeElement(n,E,P,$){let K=0;for(const C of this.d)C.disposeElement?.(n,E,P[K],$),K+=1}disposeTemplate(n){let E=0;for(const P of this.d)P.disposeTemplate(n[E++])}}class ne{constructor(n){this.c=n,this.templateId="a18n"}renderTemplate(n){return n}renderElement(n,E,P){const $=this.c.getAriaLabel(n);$?P.setAttribute("aria-label",$):P.removeAttribute("aria-label");const K=this.c.getAriaLevel&&this.c.getAriaLevel(n);typeof K=="number"?P.setAttribute("aria-level",`${K}`):P.removeAttribute("aria-level")}disposeTemplate(n){}}class ae{constructor(n,E){this.c=n,this.d=E}getDragElements(n){const E=this.c.getSelectedElements();return E.indexOf(n)>-1?E:[n]}getDragURI(n){return this.d.getDragURI(n)}getDragLabel(n,E){if(this.d.getDragLabel)return this.d.getDragLabel(n,E)}onDragStart(n,E){this.d.onDragStart?.(n,E)}onDragOver(n,E,P,$){return this.d.onDragOver(n,E,P,$)}onDragLeave(n,E,P,$){this.d.onDragLeave?.(n,E,P,$)}onDragEnd(n){this.d.onDragEnd?.(n)}drop(n,E,P,$){this.d.drop(n,E,P,$)}}class te{get onDidChangeFocus(){return a.Event.map(this.g.wrapEvent(this.c.onChange),n=>this.H(n),this.A)}get onDidChangeSelection(){return a.Event.map(this.g.wrapEvent(this.d.onChange),n=>this.H(n),this.A)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let n=!1;const E=this.A.add(a.Event.chain(this.A.add(new i.DomEmitter(this.k.domNode,"keydown")).event)).map(K=>new U.StandardKeyboardEvent(K)).filter(K=>n=K.keyCode===58||K.shiftKey&&K.keyCode===68).map(K=>w.EventHelper.stop(K,!0)).filter(()=>!1).event,P=this.A.add(a.Event.chain(this.A.add(new i.DomEmitter(this.k.domNode,"keyup")).event)).forEach(()=>n=!1).map(K=>new U.StandardKeyboardEvent(K)).filter(K=>K.keyCode===58||K.shiftKey&&K.keyCode===68).map(K=>w.EventHelper.stop(K,!0)).map(({browserEvent:K})=>{const C=this.getFocus(),I=C.length?C[0]:void 0,R=typeof I<"u"?this.k.element(I):void 0,T=typeof I<"u"?this.k.domElement(I):this.k.domNode;return{index:I,element:R,anchor:T,browserEvent:K}}).event,$=this.A.add(a.Event.chain(this.k.onContextMenu)).filter(K=>!n).map(({element:K,index:C,browserEvent:I})=>({element:K,index:C,anchor:{x:I.pageX+1,y:I.pageY},browserEvent:I})).event;return a.Event.any(E,P,$)}get onKeyDown(){return this.A.add(new i.DomEmitter(this.k.domNode,"keydown")).event}get onKeyUp(){return this.A.add(new i.DomEmitter(this.k.domNode,"keyup")).event}get onKeyPress(){return this.A.add(new i.DomEmitter(this.k.domNode,"keypress")).event}get onDidFocus(){return a.Event.signal(this.A.add(new i.DomEmitter(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return a.Event.signal(this.A.add(new i.DomEmitter(this.k.domNode,"blur",!0)).event)}constructor(n,E,P,$,K=Te){this.C=n,this.D=K,this.c=new g("focused"),this.f=new g("anchor"),this.g=new a.EventBufferer,this.z="",this.A=new e.DisposableStore,this.B=new a.Emitter,this.onDidDispose=this.B.event;const C=this.D.accessibilityProvider&&this.D.accessibilityProvider.getWidgetRole?this.D.accessibilityProvider?.getWidgetRole():"list";this.d=new A(C!=="listbox"),(0,o.mixin)(K,we,!1);const I=[this.c.renderer,this.d.renderer];this.u=K.accessibilityProvider,this.u&&(I.push(new ne(this.u)),this.u.onDidChangeActiveDescendant?.(this.J,this,this.A)),$=$.map(T=>new ie(T.templateId,[...I,T]));const R={...K,dnd:K.dnd&&new ae(this,K.dnd)};if(this.k=new S.ListView(E,P,$,R),this.k.domNode.setAttribute("role",C),K.styleController)this.q=K.styleController(this.k.domId);else{const T=(0,w.createStyleSheet)(this.k.domNode);this.q=new de(T,this.k.domId)}if(this.o=new b.CombinedSpliceable([new L(this.c,this.k,K.identityProvider),new L(this.d,this.k,K.identityProvider),new L(this.f,this.k,K.identityProvider),this.k]),this.A.add(this.c),this.A.add(this.d),this.A.add(this.f),this.A.add(this.k),this.A.add(this.B),this.A.add(new x(this,this.k)),(typeof K.keyboardSupport!="boolean"||K.keyboardSupport)&&(this.v=new m(this,this.k,K),this.A.add(this.v)),K.keyboardNavigationLabelProvider){const T=K.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.t=new V(this,this.k,K.keyboardNavigationLabelProvider,K.keyboardNavigationEventFilter??(()=>!0),T),this.A.add(this.t)}this.w=this.E(K),this.A.add(this.w),this.onDidChangeFocus(this.I,this,this.A),this.onDidChangeSelection(this.K,this,this.A),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.D.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}E(n){return new ue(this)}updateOptions(n={}){this.D={...this.D,...n},this.t?.updateOptions(this.D),this.D.multipleSelectionController!==void 0&&(this.D.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(n),this.v?.updateOptions(n),this.k.updateOptions(n)}get options(){return this.D}splice(n,E,P=[]){if(n<0||n>this.k.length)throw new D.ListError(this.C,`Invalid start index: ${n}`);if(E<0)throw new D.ListError(this.C,`Invalid delete count: ${E}`);E===0&&P.length===0||this.g.bufferEvents(()=>this.o.splice(n,E,P))}updateWidth(n){this.k.updateWidth(n)}updateElementHeight(n,E){this.k.updateElementHeight(n,E,null)}rerender(){this.k.rerender()}element(n){return this.k.element(n)}indexOf(n){return this.k.indexOf(n)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get scrollTop(){return this.k.getScrollTop()}set scrollTop(n){this.k.setScrollTop(n)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(n){this.k.setScrollLeft(n)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.z}set ariaLabel(n){this.z=n,this.k.domNode.setAttribute("aria-label",n)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(n,E){this.k.layout(n,E)}triggerTypeNavigation(){this.t?.trigger()}setSelection(n,E){for(const P of n)if(P<0||P>=this.length)throw new D.ListError(this.C,`Invalid index ${P}`);this.d.set(n,E)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(n=>this.k.element(n))}setAnchor(n){if(typeof n>"u"){this.f.set([]);return}if(n<0||n>=this.length)throw new D.ListError(this.C,`Invalid index ${n}`);this.f.set([n])}getAnchor(){return(0,f.firstOrDefault)(this.f.get(),void 0)}getAnchorElement(){const n=this.getAnchor();return typeof n>"u"?void 0:this.element(n)}setFocus(n,E){for(const P of n)if(P<0||P>=this.length)throw new D.ListError(this.C,`Invalid index ${P}`);this.c.set(n,E)}focusNext(n=1,E=!1,P,$){if(this.length===0)return;const K=this.c.get(),C=this.F(K.length>0?K[0]+n:0,E,$);C>-1&&this.setFocus([C],P)}focusPrevious(n=1,E=!1,P,$){if(this.length===0)return;const K=this.c.get(),C=this.G(K.length>0?K[0]-n:0,E,$);C>-1&&this.setFocus([C],P)}async focusNextPage(n,E){let P=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);P=P===0?0:P-1;const $=this.getFocus()[0];if($!==P&&($===void 0||P>$)){const K=this.G(P,!1,E);K>-1&&$!==K?this.setFocus([K],n):this.setFocus([P],n)}else{const K=this.k.getScrollTop();let C=K+this.k.renderHeight;P>$&&(C-=this.k.elementHeight(P)),this.k.setScrollTop(C),this.k.getScrollTop()!==K&&(this.setFocus([]),await(0,d.timeout)(0),await this.focusNextPage(n,E))}}async focusPreviousPage(n,E){let P;const $=this.k.getScrollTop();$===0?P=this.k.indexAt($):P=this.k.indexAfter($-1);const K=this.getFocus()[0];if(K!==P&&(K===void 0||K>=P)){const C=this.F(P,!1,E);C>-1&&K!==C?this.setFocus([C],n):this.setFocus([P],n)}else{const C=$;this.k.setScrollTop($-this.k.renderHeight),this.k.getScrollTop()!==C&&(this.setFocus([]),await(0,d.timeout)(0),await this.focusPreviousPage(n,E))}}focusLast(n,E){if(this.length===0)return;const P=this.G(this.length-1,!1,E);P>-1&&this.setFocus([P],n)}focusFirst(n,E){this.focusNth(0,n,E)}focusNth(n,E,P){if(this.length===0)return;const $=this.F(n,!1,P);$>-1&&this.setFocus([$],E)}F(n,E=!1,P){for(let $=0;$<this.length;$++){if(n>=this.length&&!E)return-1;if(n=n%this.length,!P||P(this.element(n)))return n;n++}return-1}G(n,E=!1,P){for(let $=0;$<this.length;$++){if(n<0&&!E)return-1;if(n=(this.length+n%this.length)%this.length,!P||P(this.element(n)))return n;n--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(n=>this.k.element(n))}reveal(n,E){if(n<0||n>=this.length)throw new D.ListError(this.C,`Invalid index ${n}`);const P=this.k.getScrollTop(),$=this.k.elementTop(n),K=this.k.elementHeight(n);if((0,u.isNumber)(E)){const C=K-this.k.renderHeight;this.k.setScrollTop(C*(0,r.clamp)(E,0,1)+$)}else{const C=$+K,I=P+this.k.renderHeight;$<P&&C>=I||($<P||C>=I&&K>=this.k.renderHeight?this.k.setScrollTop($):C>=I&&this.k.setScrollTop(C-this.k.renderHeight))}}getRelativeTop(n){if(n<0||n>=this.length)throw new D.ListError(this.C,`Invalid index ${n}`);const E=this.k.getScrollTop(),P=this.k.elementTop(n),$=this.k.elementHeight(n);if(P<E||P+$>E+this.k.renderHeight)return null;const K=$-this.k.renderHeight;return Math.abs((E-P)/K)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(n){return this.k.getElementDomId(n)}style(n){this.q.style(n)}H({indexes:n,browserEvent:E}){return{indexes:n,elements:n.map(P=>this.k.element(P)),browserEvent:E}}I(){const n=this.c.get();this.k.domNode.classList.toggle("element-focused",n.length>0),this.J()}J(){const n=this.c.get();if(n.length>0){let E;this.u?.getActiveDescendantId&&(E=this.u.getActiveDescendantId(this.k.element(n[0]))),this.k.domNode.setAttribute("aria-activedescendant",E||this.k.getElementDomId(n[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}K(){const n=this.d.get();this.k.domNode.classList.toggle("selection-none",n.length===0),this.k.domNode.classList.toggle("selection-single",n.length===1),this.k.domNode.classList.toggle("selection-multiple",n.length>1)}dispose(){this.B.fire(),this.A.dispose(),this.B.dispose()}}Ve([N.memoize],te.prototype,"onDidChangeFocus",null),Ve([N.memoize],te.prototype,"onDidChangeSelection",null),Ve([N.memoize],te.prototype,"onContextMenu",null),Ve([N.memoize],te.prototype,"onKeyDown",null),Ve([N.memoize],te.prototype,"onKeyUp",null),Ve([N.memoize],te.prototype,"onKeyPress",null),Ve([N.memoize],te.prototype,"onDidFocus",null),Ve([N.memoize],te.prototype,"onDidBlur",null),t.List=te}),define(ge[60],me([1,0,6,33,35,11,16]),function(J,t,w,i,U,z,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var b;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(b=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class f{constructor(l="",u=!1){if(this.value=l,typeof this.value!="string")throw(0,w.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1,this.supportHtml=u.supportHtml??!1)}appendText(l,u=0){return this.value+=a(this.supportThemeIcons?(0,i.escapeIcons)(l):l).replace(/([ \t]+)/g,(D,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,u){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}appendLink(l,u,D){return this.value+="[",this.value+=this.c(u,"]"),this.value+="](",this.value+=this.c(String(l),")"),D&&(this.value+=` "${this.c(this.c(D,'"'),")")}"`),this.value+=")",this}c(l,u){const D=new RegExp((0,z.escapeRegExpCharacters)(u),"g");return l.replace(D,(S,k)=>l.charAt(k-1)!=="\\"?`\\${S}`:S)}}t.MarkdownString=f;function d(o){return h(o)?!o.value:Array.isArray(o)?o.every(d):!0}t.isEmptyMarkdownString=d;function h(o){return o instanceof f?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}t.isMarkdownString=h;function N(o,l){return o===l?!0:!o||!l?!1:o.value===l.value&&o.isTrusted===l.isTrusted&&o.supportThemeIcons===l.supportThemeIcons&&o.supportHtml===l.supportHtml&&(o.baseUri===l.baseUri||!!o.baseUri&&!!l.baseUri&&(0,U.isEqual)(y.URI.from(o.baseUri),y.URI.from(l.baseUri)))}t.markdownStringEqual=N;function a(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=a;function s(o){return o.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=s;function e(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.removeMarkdownEscapes=e;function r(o){const l=[],u=o.split("|").map(S=>S.trim());o=u[0];const D=u[1];if(D){const S=/height=(\d+)/.exec(D),k=/width=(\d+)/.exec(D),g=S?S[1]:"",A=k?k[1]:"",L=isFinite(parseInt(A)),F=isFinite(parseInt(g));L&&l.push(`width="${A}"`),F&&l.push(`height="${g}"`)}return{href:o,dimensions:l}}t.parseHrefAndDimensions=r}),define(ge[122],me([1,0,4,114,19,52,15,20,115,6,3,60,33,73,44,2,76,50,34,30,35,11,16]),function(J,t,w,i,U,z,y,b,f,d,h,N,a,s,e,r,o,l,u,D,S,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const A=Object.freeze({image:(Z,ee,se)=>{let he=[],ue=[];return Z&&({href:Z,dimensions:he}=(0,N.parseHrefAndDimensions)(Z),ue.push(`src="${(0,N.escapeDoubleQuotes)(Z)}"`)),se&&ue.push(`alt="${(0,N.escapeDoubleQuotes)(se)}"`),ee&&ue.push(`title="${(0,N.escapeDoubleQuotes)(ee)}"`),he.length&&(ue=ue.concat(he)),"<img "+ue.join(" ")+">"},paragraph:Z=>`<p>${Z}</p>`,link:(Z,ee,se)=>typeof Z!="string"?"":(Z===se&&(se=(0,N.removeMarkdownEscapes)(se)),ee=typeof ee=="string"?(0,N.escapeDoubleQuotes)((0,N.removeMarkdownEscapes)(ee)):"",Z=(0,N.removeMarkdownEscapes)(Z),Z=Z.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Z}" title="${ee||Z}">${se}</a>`)});function L(Z,ee={},se={}){const he=new r.DisposableStore;let ue=!1;const de=(0,z.createElement)(ee),we=function(ae){let te;try{te=(0,l.parse)(decodeURIComponent(ae))}catch{}return te?(te=(0,D.cloneAndChange)(te,W=>{if(Z.uris&&Z.uris[W])return g.URI.revive(Z.uris[W])}),encodeURIComponent(JSON.stringify(te))):ae},Te=function(ae,te){const W=Z.uris&&Z.uris[ae];let n=g.URI.revive(W);return te?ae.startsWith(u.Schemas.data+":")?ae:(n||(n=g.URI.parse(ae)),u.FileAccess.uriToBrowserUri(n).toString(!0)):!n||g.URI.parse(ae).toString()===n.toString()?ae:(n.query&&(n=n.with({query:we(n.query)})),n.toString())},Me=new o.marked.Renderer;Me.image=A.image,Me.link=A.link,Me.paragraph=A.paragraph;const Oe=[];if(ee.codeBlockRenderer&&(Me.code=(ae,te)=>{const W=s.defaultGenerator.nextId(),n=ee.codeBlockRenderer(F(te),ae);return Oe.push(n.then(E=>[W,E])),`<div class="code" data-code="${W}">${(0,k.escape)(ae)}</div>`}),ee.actionHandler){const ae=function(n){let E=n.target;if(!(E.tagName!=="A"&&(E=E.parentElement,!E||E.tagName!=="A")))try{let P=E.dataset.href;P&&(Z.baseUri&&(P=c(g.URI.from(Z.baseUri),P)),ee.actionHandler.callback(P,n))}catch(P){(0,d.onUnexpectedError)(P)}finally{n.preventDefault()}},te=ee.actionHandler.disposables.add(new U.DomEmitter(de,"click")),W=ee.actionHandler.disposables.add(new U.DomEmitter(de,"auxclick"));ee.actionHandler.disposables.add(h.Event.any(te.event,W.event)(n=>{const E=new b.StandardMouseEvent(n);!E.leftButton&&!E.middleButton||ae(E)})),ee.actionHandler.disposables.add(w.addDisposableListener(de,"keydown",n=>{const E=new y.StandardKeyboardEvent(n);!E.equals(10)&&!E.equals(3)||ae(E)}))}Z.supportHtml||(se.sanitizer=ae=>(Z.isTrusted?ae.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?ae:"",se.sanitize=!0,se.silent=!0),se.renderer=Me;let j=Z.value??"";j.length>1e5&&(j=`${j.substr(0,1e5)}\u2026`),Z.supportThemeIcons&&(j=(0,a.markdownEscapeEscapedIcons)(j));let Y=o.marked.parse(j,se);Z.supportThemeIcons&&(Y=(0,f.renderLabelWithIcons)(Y).map(te=>typeof te=="string"?te:te.outerHTML).join(""));const ne=new DOMParser().parseFromString(p(Z,Y),"text/html");if(ne.body.querySelectorAll("img").forEach(ae=>{const te=ae.getAttribute("src");if(te){let W=te;try{Z.baseUri&&(W=c(g.URI.from(Z.baseUri),W))}catch{}ae.src=Te(W,!0)}}),ne.body.querySelectorAll("a").forEach(ae=>{const te=ae.getAttribute("href");if(ae.removeAttribute("href"),!te||/^data:|javascript:/i.test(te)||/^command:/i.test(te)&&!Z.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(te))ae.replaceWith(...ae.childNodes);else{let W=Te(te,!1);Z.baseUri&&(W=c(g.URI.from(Z.baseUri),te)),ae.dataset.href=W}}),de.innerHTML=p(Z,ne.body.innerHTML),Oe.length>0&&Promise.all(Oe).then(ae=>{if(ue)return;const te=new Map(ae),W=de.querySelectorAll("div[data-code]");for(const n of W){const E=te.get(n.dataset.code??"");E&&w.reset(n,E)}ee.asyncRenderCallback?.()}),ee.asyncRenderCallback)for(const ae of de.getElementsByTagName("img")){const te=he.add(w.addDisposableListener(ae,"load",()=>{te.dispose(),ee.asyncRenderCallback()}))}return{element:de,dispose:()=>{ue=!0,he.dispose()}}}t.renderMarkdown=L;function F(Z){if(!Z)return"";const ee=Z.split(/[\s+|:|,|\{|\?]/,1);return ee.length?ee[0]:Z}function c(Z,ee){return/^\w[\w\d+.-]*:/.test(ee)?ee:Z.path.endsWith("/")?(0,S.resolvePath)(Z,ee).toString():(0,S.resolvePath)((0,S.dirname)(Z),ee).toString()}function p(Z,ee){const{config:se,allowedSchemes:he}=m(Z);i.addHook("uponSanitizeAttribute",(de,we)=>{if(we.attrName==="style"||we.attrName==="class"){if(de.tagName==="SPAN"){if(we.attrName==="style"){we.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(we.attrValue);return}else if(we.attrName==="class"){we.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(we.attrValue);return}}we.keepAttr=!1;return}});const ue=w.hookDomPurifyHrefAndSrcSanitizer(he);try{return i.sanitize(ee,{...se,RETURN_TRUSTED_TYPE:!0})}finally{i.removeHook("uponSanitizeAttribute"),ue.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width"];function m(Z){const ee=[u.Schemas.http,u.Schemas.https,u.Schemas.mailto,u.Schemas.data,u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemote,u.Schemas.vscodeRemoteResource];return Z.isTrusted&&ee.push(u.Schemas.command),{config:{ALLOWED_TAGS:[...w.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:ee}}function v(Z){return typeof Z=="string"?Z:M(Z)}t.renderStringAsPlaintext=v;function M(Z){let ee=Z.value??"";ee.length>1e5&&(ee=`${ee.substr(0,1e5)}\u2026`);const se=o.marked.parse(ee,{renderer:x.value}).replace(/&(#\d+|[a-zA-Z]+);/g,he=>V.get(he)??he);return p({isTrusted:!1},se).toString()}t.renderMarkdownAsPlaintext=M;const V=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),x=new e.Lazy(()=>{const Z=new o.marked.Renderer;return Z.code=ee=>ee,Z.blockquote=ee=>ee,Z.html=ee=>"",Z.heading=(ee,se,he)=>ee+`
`,Z.hr=()=>"",Z.list=(ee,se)=>ee,Z.listitem=ee=>ee+`
`,Z.paragraph=ee=>ee+`
`,Z.table=(ee,se)=>ee+se+`
`,Z.tablerow=ee=>ee,Z.tablecell=(ee,se)=>ee+" ",Z.strong=ee=>ee,Z.em=ee=>ee,Z.codespan=ee=>ee,Z.br=()=>`
`,Z.del=ee=>ee,Z.image=(ee,se,he)=>"",Z.text=ee=>ee,Z.link=(ee,se,he)=>he,Z})}),define(ge[123],me([1,0,4,9,26,60,33,2,7,99]),function(J,t,w,i,U,z,y,b,f,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function h(s,e){(0,f.isString)(e)?s.title=(0,y.stripIcons)(e):e?.markdownNotSupportedFallback?s.title=e.markdownNotSupportedFallback:s.removeAttribute("title")}t.setupNativeHover=h;class N{constructor(e,r,o){this.c=e,this.d=r,this.f=o}async update(e,r,o){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let l;if(e===void 0||(0,f.isString)(e)||e instanceof HTMLElement)l=e;else if(!(0,f.isFunction)(e.markdown))l=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,d.localize)(0,null),r),this.b=new U.CancellationTokenSource;const u=this.b.token;if(l=await e.markdown(u),l===void 0&&(l=e.markdownNotSupportedFallback),this.isDisposed||u.isCancellationRequested)return}this.g(l,r,o)}g(e,r,o){const l=this.a;if(this.h(e)){const u={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!l,...o};this.a=this.c.showHover(u,r)}l?.dispose()}h(e){return e?(0,z.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function a(s,e,r,o){let l,u;const D=(L,F)=>{L&&(u?.dispose(),u=void 0),F&&(l?.dispose(),l=void 0),s.onDidHideHover?.()},S=(L,F,c)=>new i.TimeoutTimer(async()=>{(!u||u.isDisposed)&&(u=new N(s,c||e,L>0),await u.update(r,F,o))},L),k=()=>{if(l)return;const L=new b.DisposableStore,F=m=>D(!1,m.fromElement===e);L.add(w.addDisposableListener(e,w.EventType.MOUSE_LEAVE,F,!0));const c=()=>D(!0,!0);L.add(w.addDisposableListener(e,w.EventType.MOUSE_DOWN,c,!0));const p={targetElements:[e],dispose:()=>{}};if(s.placement===void 0||s.placement==="mouse"){const m=v=>{p.x=v.x+10,v.target instanceof HTMLElement&&v.target.classList.contains("action-label")&&D(!0,!0)};L.add(w.addDisposableListener(e,w.EventType.MOUSE_MOVE,m,!0))}L.add(S(s.delay,!1,p)),l=L},g=w.addDisposableListener(e,w.EventType.MOUSE_OVER,k,!0);return{show:L=>{D(!1,!0),S(0,L)},hide:()=>{D(!0,!0)},update:async(L,F)=>{r=L,await u?.update(r,void 0,F)},dispose:()=>{g.dispose(),D(!0,!0)}}}t.setupCustomHover=a}),define(ge[124],me([1,0,4,19,15,122,59,14,3,43,2,5,101,92]),function(J,t,w,i,U,z,y,b,f,d,h,N,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const s=w.$,e="selectOption.entry.template";class r{get templateId(){return e}renderTemplate(u){const D=Object.create(null);return D.root=u,D.text=w.append(u,s(".option-text")),D.detail=w.append(u,s(".option-detail")),D.decoratorRight=w.append(u,s(".option-decorator-right")),D}renderElement(u,D,S){const k=S,g=u.text,A=u.detail,L=u.decoratorRight,F=u.isDisabled;k.text.textContent=g,k.detail.textContent=A||"",k.decoratorRight.innerText=L||"",F?k.root.classList.add("option-disabled"):k.root.classList.remove("option-disabled")}disposeTemplate(u){}}class o extends h.Disposable{constructor(u,D,S,k,g){super(),this.k=[],this.y=0,this.C=!1,this.F=!1,this.G=!1,this.f=!1,this.g=g||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=o.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.m=new f.Emitter,this.B(this.m),this.n=k,this.I(),this.H(S),this.l=D||0,u&&this.setOptions(u,D)}getHeight(){return 22}getTemplateId(){return e}H(u){this.r=u,this.s=w.$(".monaco-select-box-dropdown-container"),this.s.classList.add("monaco-select-box-dropdown-padding"),this.D=w.append(this.s,s(".select-box-details-pane"));const D=w.append(this.s,s(".select-box-dropdown-container-width-control")),S=w.append(D,s(".width-control-div"));this.w=document.createElement("span"),this.w.className="option-text-width-control",w.append(S,this.w),this.z=0,this.t=w.createStyleSheet(this.s),this.s.setAttribute("draggable","true"),this.B(w.addDisposableListener(this.s,w.EventType.DRAG_START,k=>{w.EventHelper.stop(k,!0)}))}I(){this.B(w.addStandardDisposableListener(this.h,"change",D=>{this.l=D.target.selectedIndex,this.m.fire({index:D.target.selectedIndex,selected:D.target.value}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)})),this.B(w.addDisposableListener(this.h,w.EventType.CLICK,D=>{w.EventHelper.stop(D),this.f?this.O(!0):this.N()})),this.B(w.addDisposableListener(this.h,w.EventType.MOUSE_DOWN,D=>{w.EventHelper.stop(D)}));let u;this.B(w.addDisposableListener(this.h,"touchstart",D=>{u=this.f})),this.B(w.addDisposableListener(this.h,"touchend",D=>{w.EventHelper.stop(D),u?this.O(!0):this.N()})),this.B(w.addDisposableListener(this.h,w.EventType.KEY_DOWN,D=>{const S=new U.StandardKeyboardEvent(D);let k=!1;N.isMacintosh?(S.keyCode===18||S.keyCode===16||S.keyCode===10||S.keyCode===3)&&(k=!0):(S.keyCode===18&&S.altKey||S.keyCode===16&&S.altKey||S.keyCode===10||S.keyCode===3)&&(k=!0),k&&(this.N(),w.EventHelper.stop(D,!0))}))}get onDidSelect(){return this.m.event}setOptions(u,D){b.equals(this.k,u)||(this.k=u,this.h.options.length=0,this.C=!1,this.k.forEach((S,k)=>{this.h.add(this.M(S.text,k,S.isDisabled)),typeof S.description=="string"&&(this.C=!0)})),D!==void 0&&(this.select(D),this.y=this.l)}J(){this.u?.splice(0,this.u.length,this.k)}select(u){u>=0&&u<this.k.length?this.l=u:u>this.k.length-1?this.select(this.k.length-1):this.l<0&&(this.l=0),this.h.selectedIndex=this.l,!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)}setAriaLabel(u){this.g.ariaLabel=u,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(u){this.h.tabIndex=u?0:-1}render(u){this.j=u,u.classList.add("select-container"),u.appendChild(this.h),this.applyStyles()}style(u){const D=[];this.n=u,this.n.listFocusBackground&&D.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.n.listFocusBackground} !important; }`),this.n.listFocusForeground&&D.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.n.listFocusForeground} !important; }`),this.n.decoratorRightForeground&&D.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.n.decoratorRightForeground}; }`),this.n.selectBackground&&this.n.selectBorder&&!this.n.selectBorder.equals(this.n.selectBackground)?(D.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.n.selectBorder} } `),D.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectBorder} } `),D.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectBorder} } `)):this.n.selectListBorder&&(D.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectListBorder} } `),D.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectListBorder} } `)),this.n.listHoverForeground&&D.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.n.listHoverForeground} !important; }`),this.n.listHoverBackground&&D.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.n.listHoverBackground} !important; }`),this.n.listFocusOutline&&D.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.n.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.n.listHoverOutline&&D.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.n.listHoverOutline} !important; outline-offset: -1.6px !important; }`),D.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),D.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.t.textContent=D.join(`
`),this.applyStyles()}applyStyles(){if(this.h){const u=this.n.selectBackground?this.n.selectBackground.toString():"",D=this.n.selectForeground?this.n.selectForeground.toString():"",S=this.n.selectBorder?this.n.selectBorder.toString():"";this.h.style.backgroundColor=u,this.h.style.color=D,this.h.style.borderColor=S}this.u&&this.L()}L(){if(this.u){const u=this.n.selectBackground?this.n.selectBackground.toString():"";this.u.style({});const D=this.n.selectListBackground?this.n.selectListBackground.toString():u;this.v.style.backgroundColor=D,this.D.style.backgroundColor=D;const S=this.n.focusBorder?this.n.focusBorder.toString():"";this.s.style.outlineColor=S,this.s.style.outlineOffset="-1px"}}M(u,D,S){const k=document.createElement("option");return k.value=u,k.text=u,k.disabled=!!S,k}N(){this.D.innerText="",!(!this.r||this.f)&&(this.U(this.s),this.J(),this.r.showContextView({getAnchor:()=>this.h,render:u=>this.P(u,!0),layout:()=>{this.R()},onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.O(!1),this.r.showContextView({getAnchor:()=>this.h,render:u=>this.P(u),layout:()=>this.R(),onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.y=this.l,this.f=!0,this.h.setAttribute("aria-expanded","true"))}O(u){!this.r||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),u&&this.h.focus(),this.r.hideContextView())}P(u,D){return u.appendChild(this.s),this.R(D),{dispose:()=>{try{u.removeChild(this.s)}catch{}}}}Q(){let u=0;return this.k.forEach((D,S)=>{this.ab(S),this.D.offsetHeight>u&&(u=this.D.offsetHeight)}),u}R(u){if(this.F)return!1;if(this.u){this.s.classList.add("visible");const D=w.getDomNodePagePosition(this.h),S=getComputedStyle(this.h),k=parseFloat(S.getPropertyValue("--dropdown-padding-top"))+parseFloat(S.getPropertyValue("--dropdown-padding-bottom")),g=window.innerHeight-D.top-D.height-(this.g.minBottomMargin||0),A=D.top-o.b,L=this.h.offsetWidth,F=this.S(this.w),c=Math.max(F,Math.round(L)).toString()+"px";this.s.style.width=c,this.u.getHTMLElement().style.height="",this.u.layout();let p=this.u.contentHeight;const m=this.C?this.Q():0,v=p+k+m,M=Math.floor((g-k-m)/this.getHeight()),V=Math.floor((A-k-m)/this.getHeight());if(u)return D.top+D.height>window.innerHeight-22||D.top<o.b||M<1&&V<1?!1:(M<o.c&&V>M&&this.k.length>M?(this.z=1,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.D),this.s.appendChild(this.v),this.D.classList.remove("border-top"),this.D.classList.add("border-bottom")):(this.z=0,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.v),this.s.appendChild(this.D),this.D.classList.remove("border-bottom"),this.D.classList.add("border-top")),!0);if(D.top+D.height>window.innerHeight-22||D.top<o.b||this.z===0&&M<1||this.z===1&&V<1)return this.O(!0),!1;if(this.z===0){if(this.f&&M+V<1)return this.O(!0),!1;v>g&&(p=M*this.getHeight())}else v>A&&(p=V*this.getHeight());return this.u.layout(p),this.u.domFocus(),this.u.length>0&&(this.u.setFocus([this.l||0]),this.u.reveal(this.u.getFocus()[0]||0)),this.C?(this.u.getHTMLElement().style.height=p+k+"px",this.s.style.height=""):this.s.style.height=p+k+"px",this.ab(this.l),this.s.style.width=c,this.v.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.s.classList.add("synthetic-focus"),!0}else return!1}S(u){let D=0;if(u){let S=0,k=0;this.k.forEach((g,A)=>{const L=g.detail?g.detail.length:0,F=g.decoratorRight?g.decoratorRight.length:0,c=g.text.length+L+F;c>k&&(S=A,k=c)}),u.textContent=this.k[S].text+(this.k[S].decoratorRight?this.k[S].decoratorRight+" ":""),D=w.getTotalWidth(u)}return D}U(u){if(this.u)return;this.v=w.append(u,s(".select-box-dropdown-list-container")),this.p=new r,this.u=new y.List("SelectBoxCustom",this.v,this,[this.p],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:k=>{let g=k.text;return k.detail&&(g+=`. ${k.detail}`),k.decoratorRight&&(g+=`. ${k.decoratorRight}`),k.description&&(g+=`. ${k.description}`),g},getWidgetAriaLabel:()=>(0,a.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.u.ariaLabel=this.g.ariaLabel);const D=this.B(new i.DomEmitter(this.v,"keydown")),S=f.Event.chain(D.event).filter(()=>this.u.length>0).map(k=>new U.StandardKeyboardEvent(k));this.B(S.filter(k=>k.keyCode===3).on(k=>this.cb(k),this)),this.B(S.filter(k=>k.keyCode===2).on(k=>this.cb(k),this)),this.B(S.filter(k=>k.keyCode===9).on(k=>this.bb(k),this)),this.B(S.filter(k=>k.keyCode===16).on(k=>this.eb(k),this)),this.B(S.filter(k=>k.keyCode===18).on(k=>this.db(k),this)),this.B(S.filter(k=>k.keyCode===12).on(this.gb,this)),this.B(S.filter(k=>k.keyCode===11).on(this.fb,this)),this.B(S.filter(k=>k.keyCode===14).on(this.hb,this)),this.B(S.filter(k=>k.keyCode===13).on(this.ib,this)),this.B(S.filter(k=>k.keyCode>=21&&k.keyCode<=56||k.keyCode>=80&&k.keyCode<=108).on(this.jb,this)),this.B(w.addDisposableListener(this.u.getHTMLElement(),w.EventType.POINTER_UP,k=>this.W(k))),this.B(this.u.onMouseOver(k=>typeof k.index<"u"&&this.u.setFocus([k.index]))),this.B(this.u.onDidChangeFocus(k=>this.Z(k))),this.B(w.addDisposableListener(this.s,w.EventType.FOCUS_OUT,k=>{!this.f||w.isAncestor(k.relatedTarget,this.s)||this.X()})),this.u.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.u.getHTMLElement().setAttribute("aria-expanded","true"),this.L()}W(u){if(!this.u.length)return;w.EventHelper.stop(u);const D=u.target;if(!D||D.classList.contains("slider"))return;const S=D.closest(".monaco-list-row");if(!S)return;const k=Number(S.getAttribute("data-index")),g=S.classList.contains("option-disabled");k>=0&&k<this.k.length&&!g&&(this.l=k,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.O(!0))}X(){this.G||(this.l!==this.y&&this.select(this.y),this.O(!1))}Y(u,D){const S=g=>{for(let A=0;A<g.childNodes.length;A++){const L=g.childNodes.item(A);(L.tagName&&L.tagName.toLowerCase())==="img"?g.removeChild(L):S(L)}},k=(0,z.renderMarkdown)({value:u,supportThemeIcons:!0},{actionHandler:D});return k.element.classList.add("select-box-description-markdown"),S(k.element),k.element}Z(u){!this.f||!this.C||this.ab(u.indexes[0])}ab(u){this.D.innerText="";const D=this.k[u],S=D?.description??"",k=D?.descriptionIsMarkdown??!1;if(S){if(k){const g=D.descriptionMarkdownActionHandler;this.D.appendChild(this.Y(S,g))}else this.D.innerText=S;this.D.style.display="block"}else this.D.style.display="none";this.F=!0,this.r.layout(),this.F=!1}bb(u){w.EventHelper.stop(u),this.select(this.y),this.O(!0)}cb(u){w.EventHelper.stop(u),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.O(!0)}db(u){if(this.l<this.k.length-1){w.EventHelper.stop(u,!0);const D=this.k[this.l+1].isDisabled;if(D&&this.k.length>this.l+2)this.l+=2;else{if(D)return;this.l++}this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0])}}eb(u){this.l>0&&(w.EventHelper.stop(u,!0),this.k[this.l-1].isDisabled&&this.l>1?this.l-=2:this.l--,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]))}fb(u){w.EventHelper.stop(u),this.u.focusPreviousPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l<this.k.length-1&&(this.l++,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}gb(u){w.EventHelper.stop(u),this.u.focusNextPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l>0&&(this.l--,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}hb(u){w.EventHelper.stop(u),!(this.k.length<2)&&(this.l=0,this.k[this.l].isDisabled&&this.l>1&&this.l++,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}ib(u){w.EventHelper.stop(u),!(this.k.length<2)&&(this.l=this.k.length-1,this.k[this.l].isDisabled&&this.l>1&&this.l--,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}jb(u){const D=d.KeyCodeUtils.toString(u.keyCode);let S=-1;for(let k=0;k<this.k.length-1;k++)if(S=(k+this.l+1)%this.k.length,this.k[S].text.charAt(0).toUpperCase()===D&&!this.k[S].isDisabled){this.select(S),this.u.setFocus([S]),this.u.reveal(this.u.getFocus()[0]),w.EventHelper.stop(u);break}}dispose(){this.O(!1),super.dispose()}}t.SelectBoxList=o,o.a=32,o.b=2,o.c=3}),define(ge[125],me([1,0,124,118,18,41,30,5,91]),function(J,t,w,i,U,z,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.defaultStyles=void 0,t.defaultStyles={selectBackground:z.Color.fromHex("#3C3C3C"),selectForeground:z.Color.fromHex("#F0F0F0"),selectBorder:z.Color.fromHex("#3C3C3C")};class f extends U.Widget{constructor(h,N,a,s=(0,y.deepClone)(t.defaultStyles),e){super(),b.isMacintosh&&!e?.useCustomDrawn?this.a=new i.SelectBoxNative(h,N,s,e):this.a=new w.SelectBoxList(h,N,a,s,e),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(h,N){this.a.setOptions(h,N)}select(h){this.a.select(h)}setAriaLabel(h){this.a.setAriaLabel(h)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(h){this.a.setFocusable(h)}render(h){this.a.render(h)}style(h){this.a.style(h)}applyStyles(){this.a.applyStyles()}}t.SelectBox=f}),define(ge[61],me([1,0,17,51,4,22,123,125,31,2,5,7,96,48]),function(J,t,w,i,U,z,y,b,f,d,h,N,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class s extends d.Disposable{get action(){return this._action}constructor(l,u,D={}){super(),this.k=D,this._context=l||this,this._action=u,u instanceof f.Action&&this.B(u.onDidChange(S=>{!this.element||this.m(S)}))}m(l){l.enabled!==void 0&&this.t(),l.checked!==void 0&&this.C(),l.class!==void 0&&this.updateClass(),l.label!==void 0&&(this.updateLabel(),this.w()),l.tooltip!==void 0&&this.w()}get actionRunner(){return this.j||(this.j=this.B(new f.ActionRunner)),this.j}set actionRunner(l){this.j=l}isEnabled(){return this._action.enabled}setActionContext(l){this._context=l}render(l){const u=this.element=l;this.B(z.Gesture.addTarget(l));const D=this.k&&this.k.draggable;D&&(l.draggable=!0,w.isFirefox&&this.B((0,U.addDisposableListener)(l,U.EventType.DRAG_START,S=>S.dataTransfer?.setData(i.DataTransfers.TEXT,this._action.label)))),this.B((0,U.addDisposableListener)(u,z.EventType.Tap,S=>this.onClick(S,!0))),this.B((0,U.addDisposableListener)(u,U.EventType.MOUSE_DOWN,S=>{D||U.EventHelper.stop(S,!0),this._action.enabled&&S.button===0&&u.classList.add("active")})),h.isMacintosh&&this.B((0,U.addDisposableListener)(u,U.EventType.CONTEXT_MENU,S=>{S.button===0&&S.ctrlKey===!0&&this.onClick(S)})),this.B((0,U.addDisposableListener)(u,U.EventType.CLICK,S=>{U.EventHelper.stop(S,!0),this.k&&this.k.isMenu||this.onClick(S)})),this.B((0,U.addDisposableListener)(u,U.EventType.DBLCLICK,S=>{U.EventHelper.stop(S,!0)})),[U.EventType.MOUSE_UP,U.EventType.MOUSE_OUT].forEach(S=>{this.B((0,U.addDisposableListener)(u,S,k=>{U.EventHelper.stop(k),u.classList.remove("active")}))})}onClick(l,u=!1){U.EventHelper.stop(l,!0);const D=N.isUndefinedOrNull(this._context)?this.k?.useEventAsContext?l:{preserveFocus:u}:this._context;this.actionRunner.run(this._action,D)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(l){this.element&&(this.element.tabIndex=l?0:-1)}get trapsArrowNavigation(){return!1}t(){}updateLabel(){}u(){return this.action.tooltip}w(){if(!this.element)return;const l=this.u()??"";this.z(),this.k.hoverDelegate?(this.element.title="",this.f?this.f.update(l):(this.f=(0,y.setupCustomHover)(this.k.hoverDelegate,this.element,l),this.q.add(this.f))):this.element.title=l}z(){if(this.element){const l=this.u()??"";this.element.setAttribute("aria-label",l)}}updateClass(){}C(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=s;class e extends s{constructor(l,u,D){super(l,u,D),this.k=D,this.k.icon=D.icon!==void 0?D.icon:!1,this.k.label=D.label!==void 0?D.label:!0,this.D=""}render(l){super.render(l),this.element&&(this.g=(0,U.append)(this.element,(0,U.$)("a.action-label"))),this.g&&(this._action.id===f.Separator.ID?this.g.setAttribute("role","presentation"):this.k.isMenu?this.g.setAttribute("role","menuitem"):this.g.setAttribute("role","button")),this.k.label&&this.k.keybinding&&this.element&&((0,U.append)(this.element,(0,U.$)("span.keybinding")).textContent=this.k.keybinding),this.updateClass(),this.updateLabel(),this.w(),this.t(),this.C()}focus(){this.g&&(this.g.tabIndex=0,this.g.focus())}isFocused(){return!!this.g&&this.g?.tabIndex===0}blur(){this.g&&(this.g.tabIndex=-1)}setFocusable(l){this.g&&(this.g.tabIndex=l?0:-1)}updateLabel(){this.k.label&&this.g&&(this.g.textContent=this.action.label)}u(){let l=null;return this.action.tooltip?l=this.action.tooltip:!this.k.label&&this.action.label&&this.k.icon&&(l=this.action.label,this.k.keybinding&&(l=a.localize(0,null,l,this.k.keybinding))),l??void 0}updateClass(){this.D&&this.g&&this.g.classList.remove(...this.D.split(" ")),this.k.icon?(this.D=this.action.class,this.g&&(this.g.classList.add("codicon"),this.D&&this.g.classList.add(...this.D.split(" "))),this.t()):this.g?.classList.remove("codicon")}t(){this.action.enabled?(this.g&&(this.g.removeAttribute("aria-disabled"),this.g.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.g&&(this.g.setAttribute("aria-disabled","true"),this.g.classList.add("disabled")),this.element?.classList.add("disabled"))}z(){if(this.g){const l=this.u()??"";this.g.setAttribute("aria-label",l)}}C(){this.g&&(this.action.checked?this.g.classList.add("checked"):this.g.classList.remove("checked"))}}t.ActionViewItem=e;class r extends s{constructor(l,u,D,S,k,g){super(l,u),this.b=new b.SelectBox(D,S,k,void 0,g),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(l,u){this.b.setOptions(l,u)}select(l){this.b.select(l)}g(){this.B(this.b.onDidSelect(l=>this.n(l.selected,l.index)))}n(l,u){this.actionRunner.run(this._action,this.r(l,u))}r(l,u){return l}setFocusable(l){this.b.setFocusable(l)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(l){this.b.render(l)}}t.SelectActionViewItem=r}),define(ge[62],me([1,0,4,15,61,31,3,2,7,48]),function(J,t,w,i,U,z,y,b,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var d;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(d=t.ActionsOrientation||(t.ActionsOrientation={}));class h extends b.Disposable{constructor(s,e={}){super(),this.f=this.B(new b.DisposableStore),this.m=this.B(new b.DisposableMap),this.s=!1,this.t=!0,this.v=this.B(new y.Emitter),this.onDidBlur=this.v.event,this.w=this.B(new y.Emitter({onWillAddFirstListener:()=>this.y=!0})),this.onDidCancel=this.w.event,this.y=!1,this.z=this.B(new y.Emitter),this.onDidRun=this.z.event,this.C=this.B(new y.Emitter),this.onWillRun=this.C.event,this.b=e,this.g=e.context??null,this.j=this.b.orientation??0,this.l={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.c=this.b.actionRunner:(this.c=new z.ActionRunner,this.f.add(this.c)),this.f.add(this.c.onDidRun(l=>this.z.fire(l))),this.f.add(this.c.onWillRun(l=>this.C.fire(l))),this.viewItems=[],this.p=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let r,o;switch(this.j){case 0:r=[15],o=[17];break;case 1:r=[16],o=[18],this.domNode.className+=" vertical";break}this.B(w.addDisposableListener(this.domNode,w.EventType.KEY_DOWN,l=>{const u=new i.StandardKeyboardEvent(l);let D=!0;const S=typeof this.p=="number"?this.viewItems[this.p]:void 0;r&&(u.equals(r[0])||u.equals(r[1]))?D=this.L():o&&(u.equals(o[0])||u.equals(o[1]))?D=this.J():u.equals(9)&&this.y?this.w.fire():u.equals(14)?D=this.H():u.equals(13)?D=this.I():u.equals(2)&&S instanceof U.BaseActionViewItem&&S.trapsArrowNavigation?D=this.J():this.F(u)?this.l.keyDown?this.N(u):this.s=!0:D=!1,D&&(u.preventDefault(),u.stopPropagation())})),this.B(w.addDisposableListener(this.domNode,w.EventType.KEY_UP,l=>{const u=new i.StandardKeyboardEvent(l);this.F(u)?(!this.l.keyDown&&this.s&&(this.s=!1,this.N(u)),u.preventDefault(),u.stopPropagation()):(u.equals(2)||u.equals(1026))&&this.G()})),this.r=this.B(w.trackFocus(this.domNode)),this.B(this.r.onDidBlur(()=>{(w.getActiveElement()===this.domNode||!w.isAncestor(w.getActiveElement(),this.domNode))&&(this.v.fire(),this.p=void 0,this.n=void 0,this.s=!1)})),this.B(this.r.onDidFocus(()=>this.G())),this.u=document.createElement("ul"),this.u.className="actions-container",this.u.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.u.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.u),s.appendChild(this.domNode)}D(){this.length()>=2?this.u.setAttribute("role",this.b.ariaRole||"toolbar"):this.u.setAttribute("role","presentation")}setAriaLabel(s){s?this.u.setAttribute("aria-label",s):this.u.removeAttribute("aria-label")}setFocusable(s){if(this.t=s,this.t){const e=this.viewItems.find(r=>r instanceof U.BaseActionViewItem&&r.isEnabled());e instanceof U.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof U.BaseActionViewItem&&e.setFocusable(!1)})}F(s){let e=!1;return this.l.keys.forEach(r=>{e=e||s.equals(r)}),e}G(){for(let s=0;s<this.u.children.length;s++){const e=this.u.children[s];if(w.isAncestor(w.getActiveElement(),e)){this.p=s;break}}}get context(){return this.g}set context(s){this.g=s,this.viewItems.forEach(e=>e.setActionContext(s))}get actionRunner(){return this.c}set actionRunner(s){this.c=s,this.f.clear(),this.f.add(this.c.onDidRun(e=>this.z.fire(e))),this.f.add(this.c.onWillRun(e=>this.C.fire(e))),this.viewItems.forEach(e=>e.actionRunner=s)}getContainer(){return this.domNode}hasAction(s){return this.viewItems.findIndex(e=>e.action.id===s.id)!==-1}getAction(s){if(typeof s=="number")return this.viewItems[s]?.action;if(s instanceof HTMLElement){for(;s.parentElement!==this.u;){if(!s.parentElement)return;s=s.parentElement}for(let e=0;e<this.u.childNodes.length;e++)if(this.u.childNodes[e]===s)return this.viewItems[e].action}}push(s,e={}){const r=Array.isArray(s)?s:[s];let o=f.isNumber(e.index)?e.index:null;r.forEach(l=>{const u=document.createElement("li");u.className="action-item",u.setAttribute("role","presentation");let D;this.b.actionViewItemProvider&&(D=this.b.actionViewItemProvider(l)),D||(D=new U.ActionViewItem(this.context,l,{hoverDelegate:this.b.hoverDelegate,...e})),this.b.allowContextMenu||this.m.set(D,w.addDisposableListener(u,w.EventType.CONTEXT_MENU,S=>{w.EventHelper.stop(S,!0)})),D.actionRunner=this.c,D.setActionContext(this.context),D.render(u),this.t&&D instanceof U.BaseActionViewItem&&this.viewItems.length===0&&D.setFocusable(!0),o===null||o<0||o>=this.u.children.length?(this.u.appendChild(u),this.viewItems.push(D)):(this.u.insertBefore(u,this.u.children[o]),this.viewItems.splice(o,0,D),o++)}),typeof this.p=="number"&&this.focus(this.p),this.D()}getWidth(s){if(s>=0&&s<this.u.children.length){const e=this.u.children.item(s);if(e)return e.clientWidth}return 0}getHeight(s){if(s>=0&&s<this.u.children.length){const e=this.u.children.item(s);if(e)return e.clientHeight}return 0}pull(s){s>=0&&s<this.viewItems.length&&(this.u.removeChild(this.u.childNodes[s]),this.m.deleteAndDispose(this.viewItems[s]),(0,b.dispose)(this.viewItems.splice(s,1)),this.D())}clear(){this.isEmpty()||(this.viewItems=(0,b.dispose)(this.viewItems),this.m.clearAndDisposeAll(),w.clearNode(this.u),this.D())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(s){let e=!1,r;if(s===void 0?e=!0:typeof s=="number"?r=s:typeof s=="boolean"&&(e=s),e&&typeof this.p>"u"){const o=this.viewItems.findIndex(l=>l.isEnabled());this.p=o===-1?void 0:o,this.M(void 0,void 0,!0)}else r!==void 0&&(this.p=r),this.M(void 0,void 0,!0)}H(){return this.p=this.length()-1,this.J(!0)}I(){return this.p=0,this.L(!0)}J(s){if(typeof this.p>"u")this.p=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.p;let r;do{if(!s&&this.b.preventLoopNavigation&&this.p+1>=this.viewItems.length)return this.p=e,!1;this.p=(this.p+1)%this.viewItems.length,r=this.viewItems[this.p]}while(this.p!==e&&(this.b.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===z.Separator.ID));return this.M(),!0}L(s){if(typeof this.p>"u")this.p=0;else if(this.viewItems.length<=1)return!1;const e=this.p;let r;do{if(this.p=this.p-1,this.p<0){if(!s&&this.b.preventLoopNavigation)return this.p=e,!1;this.p=this.viewItems.length-1}r=this.viewItems[this.p]}while(this.p!==e&&(this.b.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===z.Separator.ID));return this.M(!0),!0}M(s,e,r=!1){typeof this.p>"u"&&this.u.focus({preventScroll:e}),this.n!==void 0&&this.n!==this.p&&this.viewItems[this.n]?.blur();const o=this.p!==void 0&&this.viewItems[this.p];if(o){let l=!0;f.isFunction(o.focus)||(l=!1),this.b.focusOnlyEnabledItems&&f.isFunction(o.isEnabled)&&!o.isEnabled()&&(l=!1),o.action.id===z.Separator.ID&&(l=!1),l?(r||this.n!==this.p)&&(o.focus(s),this.n=this.p):(this.u.focus({preventScroll:e}),this.n=void 0)}}N(s){if(typeof this.p>"u")return;const e=this.viewItems[this.p];if(e instanceof U.BaseActionViewItem){const r=e._context===null||e._context===void 0?s:e._context;this.run(e._action,r)}}async run(s,e){await this.c.run(s,e)}dispose(){this.g=void 0,this.viewItems=(0,b.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=h;function N(a){if(!a.length)return a;let s=-1;for(let r=0;r<a.length;r++)if(a[r].id!==z.Separator.ID){s=r;break}if(s===-1)return[];a=a.slice(s);for(let r=a.length-1;r>=0&&a[r].id===z.Separator.ID;r--)a.splice(r,1);let e=!1;for(let r=a.length-1;r>=0;r--){const o=a[r].id===z.Separator.ID;o&&!e?a.splice(r,1):o?o&&(e=!1):e=!0}return a}t.prepareActions=N}),define(ge[63],me([1,0,4,19,52,62,54,57,18,3,78,100,88]),function(J,t,w,i,U,z,y,b,f,d,h,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const a=w.$;var s;(function(o){o[o.INFO=1]="INFO",o[o.WARNING=2]="WARNING",o[o.ERROR=3]="ERROR"})(s=t.MessageType||(t.MessageType={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class e extends f.Widget{constructor(l,u,D){super(),this.s="idle",this.y=Number.POSITIVE_INFINITY,this.I=this.B(new d.Emitter),this.onDidChange=this.I.event,this.J=this.B(new d.Emitter),this.onDidHeightChange=this.J.event,this.a=u,this.g=D,this.h=null,this.i=this.g.placeholder||"",this.l=this.g.tooltip??(this.i||""),this.n=this.g.ariaLabel||"",this.g.validationOptions&&(this.r=this.g.validationOptions.validation),this.element=w.append(l,a(".monaco-inputbox.idle"));const S=this.g.flexibleHeight?"textarea":"input",k=w.append(this.element,a(".ibwrapper"));if(this.b=w.append(k,a(S+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.D(this.b,()=>this.element.classList.add("synthetic-focus")),this.C(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.y=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.t=w.append(k,a("div.mirror")),this.t.innerText="\xA0",this.H=new b.ScrollableElement(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.t.style.whiteSpace="pre",this.t.style.wordWrap="initial"),w.append(l,this.H.getDomNode()),this.B(this.H),this.B(this.H.onScroll(L=>this.b.scrollTop=L.scrollTop));const g=this.B(new i.DomEmitter(document,"selectionchange")),A=d.Event.filter(g.event,()=>document.getSelection()?.anchorNode===k);this.B(A(this.N,this)),this.B(this.onDidHeightChange(this.N,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.n&&this.b.setAttribute("aria-label",this.n),this.i&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.i),this.l&&this.setTooltip(this.l),this.z(this.b,()=>this.R()),this.C(this.b,()=>this.L()),this.D(this.b,()=>this.M()),this.B(this.G(this.b)),setTimeout(()=>this.S(),0),this.g.actions&&(this.c=this.B(new z.ActionBar(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.U()}L(){this.Q(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}M(){this.P(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.i||"")}setPlaceHolder(l){this.i=l,this.b.setAttribute("placeholder",l)}setTooltip(l){this.l=l,this.b.title=l}setAriaLabel(l){this.n=l,l?this.b.setAttribute("aria-label",this.n):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.n}get mirrorElement(){return this.t}get inputElement(){return this.b}get value(){return this.b.value}set value(l){this.b.value!==l&&(this.b.value=l,this.R())}get step(){return this.b.step}set step(l){this.b.step=l}get height(){return typeof this.v=="number"?this.v:w.getTotalHeight(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(l=null){this.b.select(),l&&(this.b.setSelectionRange(l.start,l.end),l.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Q()}setEnabled(l){l?this.enable():this.disable()}get width(){return w.getTotalWidth(this.b)}set width(l){if(this.g.flexibleHeight&&this.g.flexibleWidth){let u=0;if(this.t){const D=parseFloat(this.t.style.paddingLeft||"")||0,S=parseFloat(this.t.style.paddingRight||"")||0;u=D+S}this.b.style.width=l-u+"px"}else this.b.style.width=l+"px";this.t&&(this.t.style.width=l+"px")}set paddingRight(l){this.b.style.width=`calc(100% - ${l}px)`,this.t&&(this.t.style.paddingRight=l+"px")}N(){if(typeof this.w!="number"||typeof this.v!="number"||!this.H)return;const l=this.w,u=this.v,D=this.b.scrollTop;this.H.setScrollDimensions({scrollHeight:l,height:u}),this.H.setScrollPosition({scrollTop:D})}showMessage(l,u){this.h=l,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.O(l.type));const D=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${w.asCssValueWithDefault(D.border,"transparent")}`,this.h.content&&(this.hasFocus()||u)&&this.P()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Q(),this.U()}isInputValid(){return!!this.r&&!this.r(this.value)}validate(){let l=null;return this.r&&(l=this.r(this.value),l?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(l)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),l?.type}stylesForType(l){const u=this.g.inputBoxStyles;switch(l){case 1:return{border:u.inputValidationInfoBorder,background:u.inputValidationInfoBackground,foreground:u.inputValidationInfoForeground};case 2:return{border:u.inputValidationWarningBorder,background:u.inputValidationWarningBackground,foreground:u.inputValidationWarningForeground};default:return{border:u.inputValidationErrorBorder,background:u.inputValidationErrorBackground,foreground:u.inputValidationErrorForeground}}}O(l){switch(l){case 1:return"info";case 2:return"warning";default:return"error"}}P(){if(!this.a||!this.h)return;let l;const u=()=>l.style.width=w.getTotalWidth(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:S=>{if(!this.h)return null;l=w.append(S,a(".monaco-inputbox-container")),u();const k={inline:!0,className:"monaco-inputbox-message"},g=this.h.formatContent?(0,U.renderFormattedText)(this.h.content,k):(0,U.renderText)(this.h.content,k);g.classList.add(this.O(this.h.type));const A=this.stylesForType(this.h.type);return g.style.backgroundColor=A.background?A.background.toString():"",g.style.color=A.foreground?A.foreground.toString():"",g.style.border=A.border?`1px solid ${A.border}`:"",w.append(l,g),null},onHide:()=>{this.s="closed"},layout:u});let D;this.h.type===3?D=N.localize(0,null,this.h.content):this.h.type===2?D=N.localize(1,null,this.h.content):D=N.localize(2,null,this.h.content),y.alert(D),this.s="open"}Q(){!this.a||(this.s==="open"&&this.a.hideContextView(),this.s="idle")}R(){this.I.fire(this.value),this.validate(),this.S(),this.b.classList.toggle("empty",!this.value),this.s==="open"&&this.a&&this.a.layout()}S(){if(!this.t)return;const l=this.value,D=l.charCodeAt(l.length-1)===10?" ":"";(l+D).replace(/\u000c/g,"")?this.t.textContent=l+D:this.t.innerText="\xA0",this.layout()}U(){const l=this.g.inputBoxStyles,u=l.inputBackground??"",D=l.inputForeground??"",S=l.inputBorder??"";this.element.style.backgroundColor=u,this.element.style.color=D,this.b.style.backgroundColor="inherit",this.b.style.color=D,this.element.style.border=`1px solid ${w.asCssValueWithDefault(S,"transparent")}`}layout(){if(!this.t)return;const l=this.w;this.w=w.getTotalHeight(this.t),l!==this.w&&(this.v=Math.min(this.w,this.y),this.b.style.height=this.v+"px",this.J.fire(this.w))}insertAtCursor(l){const u=this.inputElement,D=u.selectionStart,S=u.selectionEnd,k=u.value;D!==null&&S!==null&&(this.value=k.substr(0,D)+l+k.substr(S),u.setSelectionRange(D+1,D+1),this.layout())}dispose(){this.Q(),this.h=null,this.c?.dispose(),super.dispose()}}t.InputBox=e;class r extends e{constructor(l,u,D){const S=N.localize(3,null),k=` or \u21C5 ${S}`,g=` (\u21C5 ${S})`;super(l,u,D),this.Y=this.B(new d.Emitter),this.onDidFocus=this.Y.event,this.Z=this.B(new d.Emitter),this.onDidBlur=this.Z.event,this.W=new h.HistoryNavigator(D.history,100);const A=()=>{if(D.showHistoryHint&&D.showHistoryHint()&&!this.i.endsWith(k)&&!this.i.endsWith(g)&&this.W.getHistory().length){const L=this.i.endsWith(")")?k:g,F=this.i+L;D.showPlaceholderOnFocus&&document.activeElement!==this.b?this.i=F:this.setPlaceHolder(F)}};this.X=new MutationObserver((L,F)=>{L.forEach(c=>{c.target.textContent||A()})}),this.X.observe(this.b,{attributeFilter:["class"]}),this.D(this.b,()=>A()),this.C(this.b,()=>{const L=F=>{if(this.i.endsWith(F)){const c=this.i.slice(0,this.i.length-F.length);return D.showPlaceholderOnFocus?this.i=c:this.setPlaceHolder(c),!0}else return!1};L(g)||L(k)})}dispose(){super.dispose(),this.X&&(this.X.disconnect(),this.X=void 0)}addToHistory(l){this.value&&(l||this.value!==this.cb())&&this.W.add(this.value)}getHistory(){return this.W.getHistory()}isAtFirstInHistory(){return this.W.isFirst()}isAtLastInHistory(){return this.W.isLast()}isNowhereInHistory(){return this.W.isNowhere()}showNextValue(){this.W.has(this.value)||this.addToHistory();let l=this.eb();l&&(l=l===this.value?this.eb():l),l&&(this.value=l,y.status(this.value))}showPreviousValue(){this.W.has(this.value)||this.addToHistory();let l=this.db();l&&(l=l===this.value?this.db():l),l&&(this.value=l,y.status(this.value))}clearHistory(){this.W.clear()}L(){super.L(),this.Z.fire()}M(){super.M(),this.Y.fire()}cb(){let l=this.W.current();return l||(l=this.W.last(),this.W.next()),l}db(){return this.W.previous()||this.W.first()}eb(){return this.W.next()||this.W.last()}}t.HistoryInputBox=r}),define(ge[64],me([1,0,61,18,13,3,93]),function(J,t,w,i,U,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class y extends w.BaseActionViewItem{constructor(h,N,a){super(h,N,a),this.a=this.B(new b({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.k.keybinding?`${this._action.label} (${this.k.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:a.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:a.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:a.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(h){this.element=h,this.element.appendChild(this.a.domNode)}t(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}C(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(h){this.a.domNode.tabIndex=h?0:-1}}t.ToggleActionViewItem=y;class b extends i.Widget{constructor(h){super(),this.a=this.B(new z.Emitter),this.onChange=this.a.event,this.b=this.B(new z.Emitter),this.onKeyDown=this.b.event,this.c=h,this.s=this.c.isChecked;const N=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,N.push(...U.CSSIcon.asClassNameArray(this.g))),this.c.actionClassName&&N.push(...this.c.actionClassName.split(" ")),this.s&&N.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...N),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,a=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),a.preventDefault())}),this.B(this.G(this.domNode)),this.p(this.domNode,a=>{if(a.keyCode===10||a.keyCode===3){this.checked=!this.s,this.a.fire(!0),a.preventDefault(),a.stopPropagation();return}this.b.fire(a)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(h){this.s=h,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(h){this.g&&this.domNode.classList.remove(...U.CSSIcon.asClassNameArray(this.g)),this.g=h,this.g&&this.domNode.classList.add(...U.CSSIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(h){this.domNode.title=h,this.domNode.setAttribute("aria-label",h)}}t.Toggle=b;class f extends i.Widget{constructor(h,N,a){super(),this.c=h,this.g=N,this.a=new b({title:this.c,isChecked:this.g,icon:U.Codicon.check,actionClassName:"monaco-checkbox",...t.unthemedToggleStyles}),this.domNode=this.a.domNode,this.b=a,this.h()}get checked(){return this.a.checked}set checked(h){this.a.checked=h}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.Checkbox=f}),define(ge[126],me([1,0,64,13,98]),function(J,t,w,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const z=U.localize(0,null),y=U.localize(1,null),b=U.localize(2,null);class f extends w.Toggle{constructor(a){super({icon:i.Codicon.caseSensitive,title:z+a.appendTitle,isChecked:a.isChecked,inputActiveOptionBorder:a.inputActiveOptionBorder,inputActiveOptionForeground:a.inputActiveOptionForeground,inputActiveOptionBackground:a.inputActiveOptionBackground})}}t.CaseSensitiveToggle=f;class d extends w.Toggle{constructor(a){super({icon:i.Codicon.wholeWord,title:y+a.appendTitle,isChecked:a.isChecked,inputActiveOptionBorder:a.inputActiveOptionBorder,inputActiveOptionForeground:a.inputActiveOptionForeground,inputActiveOptionBackground:a.inputActiveOptionBackground})}}t.WholeWordsToggle=d;class h extends w.Toggle{constructor(a){super({icon:i.Codicon.regex,title:b+a.appendTitle,isChecked:a.isChecked,inputActiveOptionBorder:a.inputActiveOptionBorder,inputActiveOptionForeground:a.inputActiveOptionForeground,inputActiveOptionBackground:a.inputActiveOptionBackground})}}t.RegexToggle=h}),define(ge[127],me([1,0,4,126,63,18,3,97,2,87]),function(J,t,w,i,U,z,y,b,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const d=b.localize(0,null);class h extends z.Widget{constructor(a,s,e){super(),this.i=!0,this.l=!1,this.n=new f.DisposableStore,this.H=[],this.I=this.B(new y.Emitter),this.onDidOptionChange=this.I.event,this.J=this.B(new y.Emitter),this.onKeyDown=this.J.event,this.L=this.B(new y.Emitter),this.onMouseDown=this.L.event,this.M=this.B(new y.Emitter),this.onInput=this.M.event,this.N=this.B(new y.Emitter),this.onKeyUp=this.N.event,this.O=this.B(new y.Emitter),this.onCaseSensitiveKeyDown=this.O.event,this.P=this.B(new y.Emitter),this.onRegexKeyDown=this.P.event,this.Q=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||d,this.h=!!e.showCommonFindToggles;const r=e.appendCaseSensitiveLabel||"",o=e.appendWholeWordsLabel||"",l=e.appendRegexLabel||"",u=e.history||[],D=!!e.flexibleHeight,S=!!e.flexibleWidth,k=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new U.HistoryInputBox(this.domNode,s,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:u,showHistoryHint:e.showHistoryHint,flexibleHeight:D,flexibleWidth:S,flexibleMaxHeight:k,inputBoxStyles:e.inputBoxStyles})),this.h){this.v=this.B(new i.RegexToggle({appendTitle:l,isChecked:!1,...e.toggleStyles})),this.B(this.v.onChange(A=>{this.I.fire(A),!A&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.v.onKeyDown(A=>{this.P.fire(A)})),this.w=this.B(new i.WholeWordsToggle({appendTitle:o,isChecked:!1,...e.toggleStyles})),this.B(this.w.onChange(A=>{this.I.fire(A),!A&&this.i&&this.inputBox.focus(),this.validate()})),this.y=this.B(new i.CaseSensitiveToggle({appendTitle:r,isChecked:!1,...e.toggleStyles})),this.B(this.y.onChange(A=>{this.I.fire(A),!A&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.y.onKeyDown(A=>{this.O.fire(A)}));const g=[this.y.domNode,this.w.domNode,this.v.domNode];this.p(this.domNode,A=>{if(A.equals(15)||A.equals(17)||A.equals(9)){const L=g.indexOf(document.activeElement);if(L>=0){let F=-1;A.equals(17)?F=(L+1)%g.length:A.equals(15)&&(L===0?F=g.length-1:F=L-1),A.equals(9)?(g[L].blur(),this.inputBox.focus()):F>=0&&g[F].focus(),w.EventHelper.stop(A,!0)}}})}this.s=document.createElement("div"),this.s.className="controls",this.s.style.display=this.h?"block":"none",this.y&&this.s.append(this.y.domNode),this.w&&this.s.appendChild(this.w.domNode),this.v&&this.s.appendChild(this.v.domNode),this.setAdditionalToggles(e?.additionalToggles),this.s&&this.domNode.appendChild(this.s),a?.appendChild(this.domNode),this.B(w.addDisposableListener(this.inputBox.inputElement,"compositionstart",g=>{this.l=!0})),this.B(w.addDisposableListener(this.inputBox.inputElement,"compositionend",g=>{this.l=!1,this.M.fire()})),this.p(this.inputBox.inputElement,g=>this.J.fire(g)),this.u(this.inputBox.inputElement,g=>this.N.fire(g)),this.z(this.inputBox.inputElement,g=>this.M.fire()),this.j(this.inputBox.inputElement,g=>this.L.fire(g))}get isImeSessionInProgress(){return this.l}get onDidChange(){return this.inputBox.onDidChange}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.v?.enable(),this.w?.enable(),this.y?.enable();for(const a of this.H)a.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.v?.disable(),this.w?.disable(),this.y?.disable();for(const a of this.H)a.disable()}setFocusInputOnOptionClick(a){this.i=a}setEnabled(a){a?this.enable():this.disable()}setAdditionalToggles(a){for(const s of this.H)s.domNode.remove();this.H=[],this.n.dispose(),this.n=new f.DisposableStore;for(const s of a??[])this.n.add(s),this.s.appendChild(s.domNode),this.n.add(s.onChange(e=>{this.I.fire(e),!e&&this.i&&this.inputBox.focus()})),this.H.push(s);this.H.length>0&&(this.s.style.display="block"),this.inputBox.paddingRight=(this.y?.width()??0)+(this.w?.width()??0)+(this.v?.width()??0)+this.H.reduce((s,e)=>s+e.width(),0)}clear(){this.R(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(a){this.inputBox.value!==a&&(this.inputBox.value=a)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.y?.checked??!1}setCaseSensitive(a){this.y&&(this.y.checked=a)}getWholeWords(){return this.w?.checked??!1}setWholeWords(a){this.w&&(this.w.checked=a)}getRegex(){return this.v?.checked??!1}setRegex(a){this.v&&(this.v.checked=a,this.validate())}focusOnCaseSensitive(){this.y?.focus()}focusOnRegex(){this.v?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Q),this.Q=1-this.Q,this.domNode.classList.add("highlight-"+this.Q)}validate(){this.inputBox.validate()}showMessage(a){this.inputBox.showMessage(a)}clearMessage(){this.inputBox.hideMessage()}R(){this.inputBox.hideMessage()}}t.FindInput=h,h.OPTION_CHANGE="optionChange"}),define(ge[128],me([1,0,4,19,15,62,127,63,58,59,64,55,23,31,14,9,13,70,3,32,2,46,7,102,94]),function(J,t,w,i,U,z,y,b,f,d,h,N,a,s,e,r,o,l,u,D,S,k,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMatchType=t.TreeFindMode=t.FuzzyToggle=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class L extends f.ElementsDragAndDropData{set context(n){this.c.context=n}get context(){return this.c.context}constructor(n){super(n.elements.map(E=>E.element)),this.c=n}}function F(W){return W instanceof f.ElementsDragAndDropData?new L(W):W}class c{constructor(n,E){this.c=n,this.d=E,this.b=S.Disposable.None}getDragURI(n){return this.d.getDragURI(n.element)}getDragLabel(n,E){if(this.d.getDragLabel)return this.d.getDragLabel(n.map(P=>P.element),E)}onDragStart(n,E){this.d.onDragStart?.(F(n),E)}onDragOver(n,E,P,$,K=!0){const C=this.d.onDragOver(F(n),E&&E.element,P,$),I=this.a!==E;if(I&&(this.b.dispose(),this.a=E),typeof E>"u")return C;if(I&&typeof C!="boolean"&&C.autoExpand&&(this.b=(0,r.disposableTimeout)(()=>{const H=this.c(),_=H.getNodeLocation(E);H.isCollapsed(_)&&H.setCollapsed(_,!1),this.a=void 0},500)),typeof C=="boolean"||!C.accept||typeof C.bubble>"u"||C.feedback){if(!K){const H=typeof C=="boolean"?C:C.accept,_=typeof C=="boolean"?void 0:C.effect;return{accept:H,effect:_,feedback:[P]}}return C}if(C.bubble===1){const H=this.c(),_=H.getNodeLocation(E),Q=H.getParentNodeLocation(_),re=H.getNode(Q),ce=Q&&H.getListIndex(Q);return this.onDragOver(n,re,ce,$,!1)}const R=this.c(),T=R.getNodeLocation(E),O=R.getListIndex(T),B=R.getListRenderCount(T);return{...C,feedback:(0,e.range)(O,O+B)}}drop(n,E,P,$){this.b.dispose(),this.a=void 0,this.d.drop(F(n),E&&E.element,P,$)}onDragEnd(n){this.d.onDragEnd?.(n)}}function p(W,n){return n&&{...n,identityProvider:n.identityProvider&&{getId(E){return n.identityProvider.getId(E.element)}},dnd:n.dnd&&new c(W,n.dnd),multipleSelectionController:n.multipleSelectionController&&{isSelectionSingleChangeEvent(E){return n.multipleSelectionController.isSelectionSingleChangeEvent({...E,element:E.element})},isSelectionRangeChangeEvent(E){return n.multipleSelectionController.isSelectionRangeChangeEvent({...E,element:E.element})}},accessibilityProvider:n.accessibilityProvider&&{...n.accessibilityProvider,getSetSize(E){const P=W(),$=P.getNodeLocation(E),K=P.getParentNodeLocation($);return P.getNode(K).visibleChildrenCount},getPosInSet(E){return E.visibleChildIndex+1},isChecked:n.accessibilityProvider&&n.accessibilityProvider.isChecked?E=>n.accessibilityProvider.isChecked(E.element):void 0,getRole:n.accessibilityProvider&&n.accessibilityProvider.getRole?E=>n.accessibilityProvider.getRole(E.element):()=>"treeitem",getAriaLabel(E){return n.accessibilityProvider.getAriaLabel(E.element)},getWidgetAriaLabel(){return n.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:n.accessibilityProvider&&n.accessibilityProvider.getWidgetRole?()=>n.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:n.accessibilityProvider&&n.accessibilityProvider.getAriaLevel?E=>n.accessibilityProvider.getAriaLevel(E.element):E=>E.depth,getActiveDescendantId:n.accessibilityProvider.getActiveDescendantId&&(E=>n.accessibilityProvider.getActiveDescendantId(E.element))},keyboardNavigationLabelProvider:n.keyboardNavigationLabelProvider&&{...n.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(E){return n.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(E.element)}}}}class m{constructor(n){this.a=n}getHeight(n){return this.a.getHeight(n.element)}getTemplateId(n){return this.a.getTemplateId(n.element)}hasDynamicHeight(n){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(n.element)}setDynamicHeight(n,E){this.a.setDynamicHeight?.(n.element,E)}}t.ComposedTreeDelegate=m;class v{static lift(n){return n instanceof v?n:new v(n)}static empty(n=0){return new v({focus:[],selection:[],expanded:Object.create(null),scrollTop:n})}constructor(n){if(this.focus=new Set(n.focus),this.selection=new Set(n.selection),n.expanded instanceof Array){this.expanded=Object.create(null);for(const E of n.expanded)this.expanded[E]=1}else this.expanded=n.expanded;this.expanded=n.expanded,this.scrollTop=n.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=v;var M;(function(W){W.None="none",W.OnHover="onHover",W.Always="always"})(M=t.RenderIndentGuides||(t.RenderIndentGuides={}));class V{get elements(){return this.b}constructor(n,E=[]){this.b=E,this.a=new S.DisposableStore,this.onDidChange=u.Event.forEach(n,P=>this.b=P,this.a)}dispose(){this.a.dispose()}}class x{constructor(n,E,P,$,K,C={}){this.o=n,this.p=E,this.q=$,this.s=K,this.b=new Map,this.c=new Map,this.d=x.a,this.f=!1,this.g=!1,this.j=new Set,this.k=S.Disposable.None,this.m=new S.DisposableStore,this.templateId=n.templateId,this.updateOptions(C),u.Event.map(P,I=>I.node)(this.u,this,this.m),n.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(n={}){if(typeof n.indent<"u"){const E=(0,k.clamp)(n.indent,0,40);if(E!==this.d){this.d=E;for(const[P,$]of this.c)this.v(P,$)}}if(typeof n.renderIndentGuides<"u"){const E=n.renderIndentGuides!==M.None;if(E!==this.g){this.g=E;for(const[P,$]of this.c)this.w(P,$);if(this.k.dispose(),E){const P=new S.DisposableStore;this.q.onDidChange(this.x,this,P),this.k=P,this.x(this.q.elements)}}}typeof n.hideTwistiesOfChildlessElements<"u"&&(this.f=n.hideTwistiesOfChildlessElements)}renderTemplate(n){const E=(0,w.append)(n,(0,w.$)(".monaco-tl-row")),P=(0,w.append)(E,(0,w.$)(".monaco-tl-indent")),$=(0,w.append)(E,(0,w.$)(".monaco-tl-twistie")),K=(0,w.append)(E,(0,w.$)(".monaco-tl-contents")),C=this.o.renderTemplate(K);return{container:n,indent:P,twistie:$,indentGuidesDisposable:S.Disposable.None,templateData:C}}renderElement(n,E,P,$){this.c.set(n,P),this.b.set(n.element,n),this.v(n,P),this.o.renderElement(n,E,P.templateData,$)}disposeElement(n,E,P,$){P.indentGuidesDisposable.dispose(),this.o.disposeElement?.(n,E,P.templateData,$),typeof $=="number"&&(this.c.delete(n),this.b.delete(n.element))}disposeTemplate(n){this.o.disposeTemplate(n.templateData)}t(n){const E=this.b.get(n);!E||this.u(E)}u(n){const E=this.c.get(n);!E||(this.x(this.q.elements),this.v(n,E))}v(n,E){const P=x.a+(n.depth-1)*this.d;E.twistie.style.paddingLeft=`${P}px`,E.indent.style.width=`${P+this.d-16}px`,n.collapsible?E.container.setAttribute("aria-expanded",String(!n.collapsed)):E.container.removeAttribute("aria-expanded"),E.twistie.classList.remove(...o.Codicon.treeItemExpanded.classNamesArray);let $=!1;this.o.renderTwistie&&($=this.o.renderTwistie(n.element,E.twistie)),n.collapsible&&(!this.f||n.visibleChildrenCount>0)?($||E.twistie.classList.add(...o.Codicon.treeItemExpanded.classNamesArray),E.twistie.classList.add("collapsible"),E.twistie.classList.toggle("collapsed",n.collapsed)):E.twistie.classList.remove("collapsible","collapsed"),this.w(n,E)}w(n,E){if((0,w.clearNode)(E.indent),E.indentGuidesDisposable.dispose(),!this.g)return;const P=new S.DisposableStore,$=this.p();for(;;){const K=$.getNodeLocation(n),C=$.getParentNodeLocation(K);if(!C)break;const I=$.getNode(C),R=(0,w.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(I)&&R.classList.add("active"),E.indent.childElementCount===0?E.indent.appendChild(R):E.indent.insertBefore(R,E.indent.firstElementChild),this.s.add(I,R),P.add((0,S.toDisposable)(()=>this.s.delete(I,R))),n=I}E.indentGuidesDisposable=P}x(n){if(!this.g)return;const E=new Set,P=this.p();n.forEach($=>{const K=P.getNodeLocation($);try{const C=P.getParentNodeLocation(K);$.collapsible&&$.children.length>0&&!$.collapsed?E.add($):C&&E.add(P.getNode(C))}catch{}}),this.j.forEach($=>{E.has($)||this.s.forEach($,K=>K.classList.remove("active"))}),E.forEach($=>{this.j.has($)||this.s.forEach($,K=>K.classList.add("active"))}),this.j=E}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,S.dispose)(this.m)}}x.a=8;class Z{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(n){this.c=n,this.d=n.toLowerCase()}constructor(n,E,P){this.g=n,this.j=E,this.k=P,this.a=0,this.b=0,this.c="",this.d="",this.f=new S.DisposableStore,n.onWillRefilter(this.m,this,this.f)}filter(n,E){let P=1;if(this.k){const C=this.k.filter(n,E);if(typeof C=="boolean"?P=C?1:0:(0,N.isFilterResult)(C)?P=(0,N.getVisibleState)(C.visibility):P=C,P===0)return!1}if(this.a++,!this.c)return this.b++,{data:D.FuzzyScore.Default,visibility:P};const $=this.j.getKeyboardNavigationLabel(n),K=Array.isArray($)?$:[$];for(const C of K){const I=C&&C.toString();if(typeof I>"u")return{data:D.FuzzyScore.Default,visibility:P};let R;if(this.g.findMatchType===de.Contiguous){const T=I.toLowerCase().indexOf(this.d);if(T>-1){R=[Number.MAX_SAFE_INTEGER,0];for(let O=this.d.length;O>0;O--)R.push(T+O-1)}}else R=(0,D.fuzzyScore)(this.c,this.d,0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(R)return this.b++,K.length===1?{data:R,visibility:P}:{data:{label:I,score:R},visibility:P}}return this.g.findMode===ue.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(n):2:{data:D.FuzzyScore.Default,visibility:P}}m(){this.a=0,this.b=0}dispose(){(0,S.dispose)(this.f)}}class ee extends h.Toggle{constructor(n){super({icon:o.Codicon.listFilter,title:(0,A.localize)(0,null),isChecked:n.isChecked??!1,inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}t.ModeToggle=ee;class se extends h.Toggle{constructor(n){super({icon:o.Codicon.searchFuzzy,title:(0,A.localize)(1,null),isChecked:n.isChecked??!1,inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}t.FuzzyToggle=se;const he={inputBoxStyles:b.unthemedInboxStyles,toggleStyles:h.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ue;(function(W){W[W.Highlight=0]="Highlight",W[W.Filter=1]="Filter"})(ue=t.TreeFindMode||(t.TreeFindMode={}));var de;(function(W){W[W.Fuzzy=0]="Fuzzy",W[W.Contiguous=1]="Contiguous"})(de=t.TreeFindMatchType||(t.TreeFindMatchType={}));class we extends S.Disposable{set mode(n){this.b.checked=n===ue.Filter,this.f.inputBox.setPlaceHolder(n===ue.Filter?(0,A.localize)(2,null):(0,A.localize)(3,null))}set matchType(n){this.c.checked=n===de.Fuzzy}get value(){return this.f.inputBox.value}set value(n){this.f.inputBox.value=n}constructor(n,E,P,$,K,C){super(),this.p=E,this.a=(0,w.h)(".monaco-tree-type-filter",[(0,w.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,w.h)(".monaco-tree-type-filter-input@findInput"),(0,w.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.k=0,this.m=0,this._onDidDisable=new u.Emitter,this.onDidDisable=this._onDidDisable.event,n.appendChild(this.a.root),this.B((0,S.toDisposable)(()=>n.removeChild(this.a.root)));const I=C?.styles??he;I.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=I.listFilterWidgetBackground),I.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${I.listFilterWidgetShadow}`),this.b=this.B(new ee({...I.toggleStyles,isChecked:$===ue.Filter})),this.c=this.B(new se({...I.toggleStyles,isChecked:K===de.Fuzzy})),this.onDidChangeMode=u.Event.map(this.b.onChange,()=>this.b.checked?ue.Filter:ue.Highlight,this.q),this.onDidChangeMatchType=u.Event.map(this.c.onChange,()=>this.c.checked?de.Fuzzy:de.Contiguous,this.q),this.f=this.B(new y.FindInput(this.a.findInput,P,{label:(0,A.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:I.inputBoxStyles,toggleStyles:I.toggleStyles,history:C?.history})),this.g=this.B(new z.ActionBar(this.a.actionbar)),this.mode=$;const R=this.B(new i.DomEmitter(this.f.inputBox.inputElement,"keydown")),T=this.B(u.Event.chain(R.event)).map(_=>new U.StandardKeyboardEvent(_)).event;this.B(T(_=>{if(_.equals(3)){_.preventDefault(),_.stopPropagation(),this.f.inputBox.addToHistory(),this.p.domFocus();return}if(_.equals(18)){_.preventDefault(),_.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.p.domFocus()):this.f.inputBox.showNextValue();return}if(_.equals(16)){_.preventDefault(),_.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const O=this.B(new s.Action("close",(0,A.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(O,{icon:!0,label:!1});const B=this.B(new i.DomEmitter(this.a.grab,"mousedown"));this.B(B.event(_=>{const Q=new S.DisposableStore,re=Q.add(new i.DomEmitter(window,"mousemove")),ce=Q.add(new i.DomEmitter(window,"mouseup")),ve=this.k,De=_.pageX,Le=this.m,Ae=_.pageY;this.a.grab.classList.add("grabbing");const pe=this.a.root.style.transition;this.a.root.style.transition="unset";const Pe=Ie=>{const _e=Ie.pageX-De;this.k=ve-_e;const ze=Ie.pageY-Ae;this.m=Le+ze,this.layout()};Q.add(re.event(Pe)),Q.add(ce.event(Ie=>{Pe(Ie),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=pe,Q.dispose()}))}));const H=this.B(u.Event.chain(this.B(new i.DomEmitter(this.a.grab,"keydown")).event)).map(_=>new U.StandardKeyboardEvent(_)).event;this.B(H(_=>{let Q,re;if(_.keyCode===15?Q=Number.POSITIVE_INFINITY:_.keyCode===17?Q=0:_.keyCode===10&&(Q=this.k===0?Number.POSITIVE_INFINITY:0),_.keyCode===16?re=0:_.keyCode===18&&(re=Number.POSITIVE_INFINITY),Q!==void 0&&(_.preventDefault(),_.stopPropagation(),this.k=Q,this.layout()),re!==void 0){_.preventDefault(),_.stopPropagation(),this.m=re;const ce=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=ce},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(n=this.j){this.j=n,this.k=(0,k.clamp)(this.k,0,Math.max(0,n-212)),this.a.root.style.right=`${this.k}px`,this.m=(0,k.clamp)(this.m,0,24),this.a.root.style.top=`${this.m}px`}showMessage(n){this.f.showMessage(n)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,r.timeout)(300),super.dispose()}}class Te{get pattern(){return this.b}get mode(){return this.d}set mode(n){n!==this.d&&(this.d=n,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(n))}get matchType(){return this.f}set matchType(n){n!==this.f&&(this.f=n,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(n))}constructor(n,E,P,$,K,C={}){this.t=n,this.u=P,this.v=$,this.w=K,this.x=C,this.b="",this.c="",this.j=0,this.k=new u.Emitter,this.onDidChangeMode=this.k.event,this.m=new u.Emitter,this.onDidChangeMatchType=this.m.event,this.o=new u.Emitter,this.onDidChangePattern=this.o.event,this.p=new u.Emitter,this.onDidChangeOpenState=this.p.event,this.q=new S.DisposableStore,this.s=new S.DisposableStore,this.d=n.options.defaultFindMode??ue.Highlight,this.f=n.options.defaultFindMatchType??de.Fuzzy,E.onDidSplice(this.z,this,this.s)}updateOptions(n={}){n.defaultFindMode!==void 0&&(this.mode=n.defaultFindMode),n.defaultFindMatchType!==void 0&&(this.matchType=n.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new we(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(n=>this.mode=n,void 0,this.q),this.g.onDidChangeMatchType(n=>this.matchType=n,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){!this.g||(this.a=this.g.getHistory(),this.g=void 0,this.q.dispose(),this.q=new S.DisposableStore,this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(n){this.b=n,this.o.fire(n),this.v.pattern=n,this.t.refilter(),n&&this.t.focusNext(0,!0,void 0,P=>!D.FuzzyScore.isDefault(P.filterData));const E=this.t.getFocus();if(E.length>0){const P=E[0];this.t.getRelativeTop(P)===null&&this.t.reveal(P,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const n=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&n?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,A.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(n){return!this.g||!this.pattern||this.d===ue.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!D.FuzzyScore.isDefault(n.filterData)}layout(n){this.j=n,this.g?.layout(n)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Me(W){let n=a.TreeMouseEventTarget.Unknown;return(0,w.hasParentWithClass)(W.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?n=a.TreeMouseEventTarget.Twistie:(0,w.hasParentWithClass)(W.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?n=a.TreeMouseEventTarget.Element:(0,w.hasParentWithClass)(W.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(n=a.TreeMouseEventTarget.Filter),{browserEvent:W.browserEvent,element:W.element?W.element.element:null,target:n}}function Oe(W){return{element:W.element?W.element.element:null,browserEvent:W.browserEvent,anchor:W.anchor}}function j(W,n){n(W),W.children.forEach(E=>j(E,n))}class Y{get f(){return this.d||(this.d=this.m()),this.d}constructor(n,E){this.g=n,this.j=E,this.a=[],this.c=new u.Emitter,this.onDidChange=this.c.event}set(n,E){!E?.__forceEvent&&(0,e.equals)(this.a,n)||this.k(n,!1,E)}k(n,E,P){if(this.a=[...n],this.b=void 0,this.d=void 0,!E){const $=this;this.c.fire({get elements(){return $.get()},browserEvent:P})}}get(){return this.b||(this.b=this.a.map(n=>n.element)),[...this.b]}getNodes(){return this.a}has(n){return this.f.has(n)}onDidModelSplice({insertedNodes:n,deletedNodes:E}){if(!this.j){const R=this.m(),T=O=>R.delete(O);E.forEach(O=>j(O,T)),this.set([...R.values()]);return}const P=new Set,$=R=>P.add(this.j.getId(R.element).toString());E.forEach(R=>j(R,$));const K=new Map,C=R=>K.set(this.j.getId(R.element).toString(),R);n.forEach(R=>j(R,C));const I=[];for(const R of this.a){const T=this.j.getId(R.element).toString();if(!P.has(T))I.push(R);else{const B=K.get(T);B&&I.push(B)}}if(this.a.length>0&&I.length===0){const R=this.g();R&&I.push(R)}this.k(I,!0)}m(){const n=new Set;for(const E of this.a)n.add(E);return n}}class ie extends d.MouseController{constructor(n,E){super(n),this.z=E}u(n){if((0,d.isButton)(n.browserEvent.target)||(0,d.isInputElement)(n.browserEvent.target)||(0,d.isMonacoEditor)(n.browserEvent.target))return;const E=n.element;if(!E)return super.u(n);if(this.p(n)||this.o(n))return super.u(n);const P=n.browserEvent.target,$=P.classList.contains("monaco-tl-twistie")||P.classList.contains("monaco-icon-label")&&P.classList.contains("folder-icon")&&n.browserEvent.offsetX<16;let K=!1;if(typeof this.z.expandOnlyOnTwistieClick=="function"?K=this.z.expandOnlyOnTwistieClick(E.element):K=!!this.z.expandOnlyOnTwistieClick,K&&!$&&n.browserEvent.detail!==2)return super.u(n);if(!this.z.expandOnDoubleClick&&n.browserEvent.detail===2)return super.u(n);if(E.collapsible){const C=this.z.getNodeLocation(E),I=n.browserEvent.altKey;if(this.z.setFocus([C]),this.z.toggleCollapsed(C,I),K&&$)return}super.u(n)}v(n){n.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.z.expandOnDoubleClick||super.v(n)}}class ne extends d.List{constructor(n,E,P,$,K,C,I,R){super(n,E,P,$,R),this.p=K,this.s=C,this.L=I}E(n){return new ie(this,n.tree)}splice(n,E,P=[]){if(super.splice(n,E,P),P.length===0)return;const $=[],K=[];let C;P.forEach((I,R)=>{this.p.has(I)&&$.push(n+R),this.s.has(I)&&K.push(n+R),this.L.has(I)&&(C=n+R)}),$.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...$])),K.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...K])),typeof C=="number"&&super.setAnchor(C)}setFocus(n,E,P=!1){super.setFocus(n,E),P||this.p.set(n.map($=>this.element($)),E)}setSelection(n,E,P=!1){super.setSelection(n,E),P||this.s.set(n.map($=>this.element($)),E)}setAnchor(n,E=!1){super.setAnchor(n),E||(typeof n>"u"?this.L.set([]):this.L.set([this.element(n)]))}}class ae{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return u.Event.map(this.j.onMouseClick,Me)}get onMouseDblClick(){return u.Event.filter(u.Event.map(this.j.onMouseDblClick,Me),n=>n.target!==a.TreeMouseEventTarget.Filter)}get onContextMenu(){return u.Event.map(this.j.onContextMenu,Oe)}get onTap(){return u.Event.map(this.j.onTap,Me)}get onPointer(){return u.Event.map(this.j.onPointer,Me)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return u.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??ue.Highlight}set findMode(n){this.x&&(this.x.mode=n)}get findMatchType(){return this.x?.matchType??de.Fuzzy}set findMatchType(n){this.x&&(this.x.matchType=n)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:u.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(n,E,P,$,K={}){this.D=n,this.E=K,this.w=new u.EventBufferer,this.onDidChangeFindOpenState=u.Event.None,this.A=new S.DisposableStore,this.B=new u.Emitter,this.onWillRefilter=this.B.event,this.C=new u.Emitter,this.onDidUpdateOptions=this.C.event;const C=new m(P),I=new u.Relay,R=new u.Relay,T=this.A.add(new V(R.event)),O=new l.SetMap;this.k=$.map(_=>new x(_,()=>this.o,I.event,T,O,K));for(const _ of this.k)this.A.add(_);let B;K.keyboardNavigationLabelProvider&&(B=new Z(this,K.keyboardNavigationLabelProvider,K.filter),K={...K,filter:B},this.A.add(B)),this.p=new Y(()=>this.j.getFocusedElements()[0],K.identityProvider),this.q=new Y(()=>this.j.getSelectedElements()[0],K.identityProvider),this.u=new Y(()=>this.j.getAnchorElement(),K.identityProvider),this.j=new ne(n,E,C,this.k,this.p,this.q,this.u,{...p(()=>this.o,K),tree:this}),this.o=this.I(n,this.j,K),I.input=this.o.onDidChangeCollapseState;const H=u.Event.forEach(this.o.onDidSplice,_=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(_),this.q.onDidModelSplice(_)})},this.A);if(H(()=>null,null,this.A),R.input=u.Event.chain(u.Event.any(H,this.p.onDidChange,this.q.onDidChange)).debounce(()=>null,0).map(()=>{const _=new Set;for(const Q of this.p.getNodes())_.add(Q);for(const Q of this.q.getNodes())_.add(Q);return[..._.values()]}).event,K.keyboardSupport!==!1){const _=u.Event.chain(this.j.onKeyDown).filter(Q=>!(0,d.isInputElement)(Q.target)).map(Q=>new U.StandardKeyboardEvent(Q));_.filter(Q=>Q.keyCode===15).on(this.F,this,this.A),_.filter(Q=>Q.keyCode===17).on(this.G,this,this.A),_.filter(Q=>Q.keyCode===10).on(this.H,this,this.A)}if((K.findWidgetEnabled??!0)&&K.keyboardNavigationLabelProvider&&K.contextViewProvider){const _=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Te(this,this.o,this.j,B,K.contextViewProvider,_),this.y=Q=>this.x.shouldAllowFocus(Q),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=u.Event.None,this.onDidChangeFindMatchType=u.Event.None;this.z=(0,w.createStyleSheet)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===M.Always)}updateOptions(n={}){this.E={...this.E,...n};for(const E of this.k)E.updateOptions(n);this.j.updateOptions(this.E),this.x?.updateOptions(n),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===M.Always)}get options(){return this.E}updateWidth(n){const E=this.o.getListIndex(n);E!==-1&&this.j.updateWidth(E)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get scrollTop(){return this.j.scrollTop}set scrollTop(n){this.j.scrollTop=n}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(n){this.j.scrollLeft=n}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const n=this.j.firstVisibleIndex;return n<0||n>=this.j.length?void 0:this.j.element(n).element}get lastVisibleElement(){const n=this.j.lastVisibleIndex;return this.j.element(n).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(n){this.j.ariaLabel=n}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(n,E){this.j.layout(n,E),(0,g.isNumber)(E)&&this.x?.layout(E)}style(n){const E=`.${this.j.domId}`,P=[];n.treeIndentGuidesStroke&&(P.push(`.monaco-list${E}:hover .monaco-tl-indent > .indent-guide, .monaco-list${E}.always .monaco-tl-indent > .indent-guide  { border-color: ${n.treeIndentGuidesStroke.transparent(.4)}; }`),P.push(`.monaco-list${E} .monaco-tl-indent > .indent-guide.active { border-color: ${n.treeIndentGuidesStroke}; }`)),this.z.textContent=P.join(`
`),this.j.style(n)}getParentElement(n){const E=this.o.getParentNodeLocation(n);return this.o.getNode(E).element}getFirstElementChild(n){return this.o.getFirstElementChild(n)}getNode(n){return this.o.getNode(n)}getNodeLocation(n){return this.o.getNodeLocation(n)}collapse(n,E=!1){return this.o.setCollapsed(n,!0,E)}expand(n,E=!1){return this.o.setCollapsed(n,!1,E)}toggleCollapsed(n,E=!1){return this.o.setCollapsed(n,void 0,E)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(n){return this.o.isCollapsible(n)}setCollapsible(n,E){return this.o.setCollapsible(n,E)}isCollapsed(n){return this.o.isCollapsed(n)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(n){if(typeof n>"u")return this.j.setAnchor(void 0);const E=this.o.getNode(n);this.u.set([E]);const P=this.o.getListIndex(n);P>-1&&this.j.setAnchor(P,!0)}getAnchor(){return(0,e.firstOrDefault)(this.u.get(),void 0)}setSelection(n,E){const P=n.map(K=>this.o.getNode(K));this.q.set(P,E);const $=n.map(K=>this.o.getListIndex(K)).filter(K=>K>-1);this.j.setSelection($,E,!0)}getSelection(){return this.q.get()}setFocus(n,E){const P=n.map(K=>this.o.getNode(K));this.p.set(P,E);const $=n.map(K=>this.o.getListIndex(K)).filter(K=>K>-1);this.j.setFocus($,E,!0)}focusNext(n=1,E=!1,P,$=this.y){this.j.focusNext(n,E,P,$)}focusPrevious(n=1,E=!1,P,$=this.y){this.j.focusPrevious(n,E,P,$)}focusNextPage(n,E=this.y){return this.j.focusNextPage(n,E)}focusPreviousPage(n,E=this.y){return this.j.focusPreviousPage(n,E)}focusLast(n,E=this.y){this.j.focusLast(n,E)}focusFirst(n,E=this.y){this.j.focusFirst(n,E)}getFocus(){return this.p.get()}reveal(n,E){this.o.expandTo(n);const P=this.o.getListIndex(n);P!==-1&&this.j.reveal(P,E)}getRelativeTop(n){const E=this.o.getListIndex(n);return E===-1?null:this.j.getRelativeTop(E)}getViewState(n=this.options.identityProvider){if(!n)throw new a.TreeError(this.D,"Can't get tree view state without an identity provider");const E=C=>n.getId(C).toString(),P=v.empty(this.scrollTop);for(const C of this.getFocus())P.focus.add(E(C));for(const C of this.getSelection())P.selection.add(E(C));const $=this.o.getNode(),K=[$];for(;K.length>0;){const C=K.shift();C!==$&&C.collapsible&&(P.expanded[E(C.element)]=C.collapsed?0:1),K.push(...C.children)}return P}F(n){n.preventDefault(),n.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const P=E[0],$=this.o.getNodeLocation(P);if(!this.o.setCollapsed($,!0)){const C=this.o.getParentNodeLocation($);if(!C)return;const I=this.o.getListIndex(C);this.j.reveal(I),this.j.setFocus([I])}}G(n){n.preventDefault(),n.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const P=E[0],$=this.o.getNodeLocation(P);if(!this.o.setCollapsed($,!1)){if(!P.children.some(R=>R.visible))return;const[C]=this.j.getFocus(),I=C+1;this.j.reveal(I),this.j.setFocus([I])}}H(n){n.preventDefault(),n.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const P=E[0],$=this.o.getNodeLocation(P),K=n.browserEvent.altKey;this.o.setCollapsed($,void 0,K)}navigate(n){return new te(this.j,this.o,n)}dispose(){(0,S.dispose)(this.A),this.j.dispose()}}t.AbstractTree=ae;class te{constructor(n,E,P){this.b=n,this.c=E,P?this.a=this.c.getListIndex(P):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(ge[129],me([1,0,128,119,23,25]),function(J,t,w,i,U,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class y extends w.AbstractTree{constructor(f,d,h,N,a,s={}){super(f,d,h,N,s),this.f=f,this.g=a,this.d=new Map,this.c=s.identityProvider}getInput(){return this.b}setInput(f,d){if(d&&!this.c)throw new U.TreeError(this.f,"Can't restore tree view state without an identity provider");if(this.b=f,!f){this.d.clear(),this.o.setChildren(null,z.Iterable.empty());return}if(!d){this.m(f);return}const h=[],N=[],a=e=>{const r=this.c.getId(e).toString();return!d.expanded[r]},s=e=>{const r=this.c.getId(e.element).toString();d.focus.has(r)&&h.push(e.element),d.selection.has(r)&&N.push(e.element)};this.m(f,a,s),this.setFocus(h),this.setSelection(N),d&&typeof d.scrollTop=="number"&&(this.scrollTop=d.scrollTop)}updateChildren(f=this.b){if(typeof this.b>"u")throw new U.TreeError(this.f,"Tree input not set");let d;this.c&&(d=h=>{const N=this.c.getId(h).toString(),a=this.d.get(N);if(!!a)return a.collapsed}),this.m(f,d)}resort(f=this.b,d=!0){this.o.resort(f===this.b?null:f,d)}refresh(f){if(f===void 0){this.j.rerender();return}this.o.rerender(f)}m(f,d,h){let N;if(this.c){const a=new Set,s=h;h=e=>{const r=this.c.getId(e.element).toString();a.add(r),this.d.set(r,e),s?.(e)},N=e=>{const r=this.c.getId(e.element).toString();a.has(r)||this.d.delete(r)}}this.o.setChildren(f===this.b?null:f,this.s(f,d).elements,{onDidCreateNode:h,onDidDeleteNode:N})}s(f,d){const h=[...this.g.getChildren(f)];return{elements:z.Iterable.map(h,a=>{const{elements:s,size:e}=this.s(a,d),r=this.g.hasChildren?this.g.hasChildren(a):void 0,o=e===0?void 0:d&&d(a);return{element:a,children:s,collapsible:r,collapsed:o}}),size:h.length}}I(f,d,h){return new i.ObjectTreeModel(f,d,h)}}t.DataTree=y}),define(ge[37],me([1,0,14,9,29,26,24,6,3,2,50,11,7]),function(J,t,w,i,U,z,y,b,f,d,h,N,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.deserialize=t.serialize=t.BufferWriter=t.BufferReader=void 0;var s;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(s||(s={}));function e(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var r;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(r||(r={}));function o(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(l||(l={}));function u(j){let Y=0;for(let ie=0;;ie+=7){const ne=j.read(1);if(Y|=(ne.buffer[0]&127)<<ie,!(ne.buffer[0]&128))return Y}}const D=L(0);function S(j,Y){if(Y===0){j.write(D);return}let ie=0;for(let ae=Y;ae!==0;ae=ae>>>7)ie++;const ne=U.VSBuffer.alloc(ie);for(let ae=0;Y!==0;ae++)ne.buffer[ae]=Y&127,Y=Y>>>7,Y>0&&(ne.buffer[ae]|=128);j.write(ne)}class k{constructor(Y){this.b=Y,this.a=0}read(Y){const ie=this.b.slice(this.a,this.a+Y);return this.a+=ie.byteLength,ie}}t.BufferReader=k;class g{constructor(){this.a=[]}get buffer(){return U.VSBuffer.concat(this.a)}write(Y){this.a.push(Y)}}t.BufferWriter=g;var A;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(A||(A={}));function L(j){const Y=U.VSBuffer.alloc(1);return Y.writeUInt8(j,0),Y}const F={Undefined:L(A.Undefined),String:L(A.String),Buffer:L(A.Buffer),VSBuffer:L(A.VSBuffer),Array:L(A.Array),Object:L(A.Object),Uint:L(A.Int)},c=typeof Buffer<"u";function p(j,Y){if(typeof Y>"u")j.write(F.Undefined);else if(typeof Y=="string"){const ie=U.VSBuffer.fromString(Y);j.write(F.String),S(j,ie.byteLength),j.write(ie)}else if(c&&Buffer.isBuffer(Y)){const ie=U.VSBuffer.wrap(Y);j.write(F.Buffer),S(j,ie.byteLength),j.write(ie)}else if(Y instanceof U.VSBuffer)j.write(F.VSBuffer),S(j,Y.byteLength),j.write(Y);else if(Array.isArray(Y)){j.write(F.Array),S(j,Y.length);for(const ie of Y)p(j,ie)}else if(typeof Y=="number"&&(Y|0)===Y)j.write(F.Uint),S(j,Y);else{const ie=U.VSBuffer.fromString(JSON.stringify(Y));j.write(F.Object),S(j,ie.byteLength),j.write(ie)}}t.serialize=p;function m(j){switch(j.read(1).readUInt8(0)){case A.Undefined:return;case A.String:return j.read(u(j)).toString();case A.Buffer:return j.read(u(j)).buffer;case A.VSBuffer:return j.read(u(j));case A.Array:{const ie=u(j),ne=[];for(let ae=0;ae<ie;ae++)ne.push(m(j));return ne}case A.Object:return JSON.parse(j.read(u(j)).toString());case A.Int:return u(j)}}t.deserialize=m;class v{constructor(Y,ie,ne=null,ae=1e3){this.h=Y,this.j=ie,this.k=ne,this.l=ae,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(Y,ie){this.b.set(Y,ie),setTimeout(()=>this.w(Y),0)}m(Y){switch(Y.type){case 200:{const ie=this.o([Y.type]);this.k?.logOutgoing(ie,0,1,o(Y.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([Y.type,Y.id],Y.data);this.k?.logOutgoing(ie,Y.id,1,o(Y.type),Y.data);return}}}o(Y,ie=void 0){const ne=new g;return p(ne,Y),p(ne,ie),this.p(ne.buffer)}p(Y){try{return this.h.send(Y),Y.byteLength}catch{return 0}}q(Y){const ie=new k(Y),ne=m(ie),ae=m(ie),te=ne[0];switch(te){case 100:return this.k?.logIncoming(Y.byteLength,ne[1],1,`${e(te)}: ${ne[2]}.${ne[3]}`,ae),this.s({type:te,id:ne[1],channelName:ne[2],name:ne[3],arg:ae});case 102:return this.k?.logIncoming(Y.byteLength,ne[1],1,`${e(te)}: ${ne[2]}.${ne[3]}`,ae),this.t({type:te,id:ne[1],channelName:ne[2],name:ne[3],arg:ae});case 101:return this.k?.logIncoming(Y.byteLength,ne[1],1,`${e(te)}`),this.u({type:te,id:ne[1]});case 103:return this.k?.logIncoming(Y.byteLength,ne[1],1,`${e(te)}`),this.u({type:te,id:ne[1]})}}s(Y){const ie=this.b.get(Y.channelName);if(!ie){this.v(Y);return}const ne=new z.CancellationTokenSource;let ae;try{ae=ie.call(this.j,Y.name,Y.arg,ne.token)}catch(n){ae=Promise.reject(n)}const te=Y.id;ae.then(n=>{this.m({id:te,data:n,type:201}),this.d.delete(Y.id)},n=>{n instanceof Error?this.m({id:te,data:{message:n.message,name:n.name,stack:n.stack?n.stack.split?n.stack.split(`
`):n.stack:void 0},type:202}):this.m({id:te,data:n,type:203}),this.d.delete(Y.id)});const W=(0,d.toDisposable)(()=>ne.cancel());this.d.set(Y.id,W)}t(Y){const ie=this.b.get(Y.channelName);if(!ie){this.v(Y);return}const ne=Y.id,te=ie.listen(this.j,Y.name,Y.arg)(W=>this.m({id:ne,data:W,type:204}));this.d.set(Y.id,te)}u(Y){const ie=this.d.get(Y.id);ie&&(ie.dispose(),this.d.delete(Y.id))}v(Y){let ie=this.g.get(Y.channelName);ie||(ie=[],this.g.set(Y.channelName,ie));const ne=setTimeout(()=>{console.error(`Unknown channel: ${Y.channelName}`),Y.type===100&&this.m({id:Y.id,data:{name:"Unknown channel",message:`Channel name '${Y.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:Y,timeoutTimer:ne})}w(Y){const ie=this.g.get(Y);if(ie){for(const ne of ie)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(Y)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.dispose)(this.d.values()),this.d.clear()}}t.ChannelServer=v;var M;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(M=t.RequestInitiator||(t.RequestInitiator={}));class V{constructor(Y,ie=null){this.l=Y,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=ie}getChannel(Y){const ie=this;return{call(ne,ae,te){return ie.a?Promise.reject(new b.CancellationError):ie.m(Y,ne,ae,te)},listen(ne,ae){return ie.a?f.Event.None:ie.o(Y,ne,ae)}}}m(Y,ie,ne,ae=z.CancellationToken.None){const te=this.g++,n={id:te,type:100,channelName:Y,name:ie,arg:ne};if(ae.isCancellationRequested)return Promise.reject(new b.CancellationError);let E;return new Promise(($,K)=>{if(ae.isCancellationRequested)return K(new b.CancellationError);const C=()=>{const O=B=>{switch(B.type){case 201:this.f.delete(te),$(B.data);break;case 202:{this.f.delete(te);const H=new Error(B.data.message);H.stack=Array.isArray(B.data.stack)?B.data.stack.join(`
`):B.data.stack,H.name=B.data.name,K(H);break}case 203:this.f.delete(te),K(B.data);break}};this.f.set(te,O),this.p(n)};let I=null;this.b===l.Idle?C():(I=(0,i.createCancelablePromise)(O=>this.u()),I.then(()=>{I=null,C()}));const R=()=>{I?(I.cancel(),I=null):this.p({id:te,type:101}),K(new b.CancellationError)},T=ae.onCancellationRequested(R);E=(0,d.combinedDisposable)((0,d.toDisposable)(R),T),this.d.add(E)}).finally(()=>{this.d.delete(E)})}o(Y,ie,ne){const ae=this.g++,W={id:ae,type:102,channelName:Y,name:ie,arg:ne};let n=null;const E=new f.Emitter({onWillAddFirstListener:()=>{n=(0,i.createCancelablePromise)($=>this.u()),n.then(()=>{n=null,this.d.add(E),this.p(W)})},onDidRemoveLastListener:()=>{n?(n.cancel(),n=null):(this.d.delete(E),this.p({id:ae,type:103}))}}),P=$=>E.fire($.data);return this.f.set(ae,P),E.event}p(Y){switch(Y.type){case 100:case 102:{const ie=this.q([Y.type,Y.id,Y.channelName,Y.name],Y.arg);this.j?.logOutgoing(ie,Y.id,0,`${e(Y.type)}: ${Y.channelName}.${Y.name}`,Y.arg);return}case 101:case 103:{const ie=this.q([Y.type,Y.id]);this.j?.logOutgoing(ie,Y.id,0,e(Y.type));return}}}q(Y,ie=void 0){const ne=new g;return p(ne,Y),p(ne,ie),this.r(ne.buffer)}r(Y){try{return this.l.send(Y),Y.byteLength}catch{return 0}}s(Y){const ie=new k(Y),ne=m(ie),ae=m(ie),te=ne[0];switch(te){case 200:return this.j?.logIncoming(Y.byteLength,0,0,o(te)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Y.byteLength,ne[1],0,o(te),ae),this.t({type:ne[0],id:ne[1],data:ae})}}t(Y){if(Y.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(Y.id)?.(Y)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.dispose)(this.d.values()),this.d.clear()}}Ve([y.memoize],V.prototype,"onDidInitializePromise",null),t.ChannelClient=V;class x{get connections(){const Y=[];return this.f.forEach(ie=>Y.push(ie)),Y}constructor(Y){this.a=new Map,this.f=new Set,this.g=new f.Emitter,this.onDidAddConnection=this.g.event,this.h=new f.Emitter,this.onDidRemoveConnection=this.h.event,Y(({protocol:ie,onDidClientDisconnect:ne})=>{f.Event.once(ie.onMessage)(te=>{const W=new k(te),n=m(W),E=new v(ie,n),P=new V(ie);this.a.forEach((K,C)=>E.registerChannel(C,K));const $={channelServer:E,channelClient:P,ctx:n};this.f.add($),this.g.fire($),ne(()=>{E.dispose(),P.dispose(),this.f.delete($),this.h.fire($)})})})}getChannel(Y,ie){const ne=this;return{call(ae,te,W){let n;if((0,a.isFunction)(ie)){const P=(0,w.getRandomElement)(ne.connections.filter(ie));n=P?Promise.resolve(P):f.Event.toPromise(f.Event.filter(ne.onDidAddConnection,ie))}else n=ie.routeCall(ne,ae,te);const E=n.then(P=>P.channelClient.getChannel(Y));return ee(E).call(ae,te,W)},listen(ae,te){if((0,a.isFunction)(ie))return ne.j(Y,ie,ae,te);const W=ie.routeEvent(ne,ae,te).then(n=>n.channelClient.getChannel(Y));return ee(W).listen(ae,te)}}}j(Y,ie,ne,ae){const te=this;let W=new d.DisposableStore;const n=new f.Emitter({onWillAddFirstListener:()=>{W=new d.DisposableStore;const E=new f.EventMultiplexer,P=new Map,$=C=>{const R=C.channelClient.getChannel(Y).listen(ne,ae),T=E.add(R);P.set(C,T)},K=C=>{const I=P.get(C);!I||(I.dispose(),P.delete(C))};te.connections.filter(ie).forEach($),f.Event.filter(te.onDidAddConnection,ie)($,void 0,W),te.onDidRemoveConnection(K,void 0,W),E.event(n.fire,n,W),W.add(E)},onDidRemoveLastListener:()=>{W.dispose()}});return n.event}registerChannel(Y,ie){this.a.set(Y,ie),this.f.forEach(ne=>{ne.channelServer.registerChannel(Y,ie)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}t.IPCServer=x;class Z{constructor(Y,ie,ne=null){const ae=new g;p(ae,ie),Y.send(ae.buffer),this.a=new V(Y,ne),this.d=new v(Y,ie,ne)}getChannel(Y){return this.a.getChannel(Y)}registerChannel(Y,ie){this.d.registerChannel(Y,ie)}dispose(){this.a.dispose(),this.d.dispose()}}t.IPCClient=Z;function ee(j){return{call(Y,ie,ne){return j.then(ae=>ae.call(Y,ie,ne))},listen(Y,ie){const ne=new f.Relay;return j.then(ae=>ne.input=ae.listen(Y,ie)),ne.event}}}t.getDelayedChannel=ee;function se(j){let Y=!1;return{call(ie,ne,ae){return Y?j.call(ie,ne,ae):(0,i.timeout)(0).then(()=>Y=!0).then(()=>j.call(ie,ne,ae))},listen(ie,ne){if(Y)return j.listen(ie,ne);const ae=new f.Relay;return(0,i.timeout)(0).then(()=>Y=!0).then(()=>ae.input=j.listen(ie,ne)),ae.event}}}t.getNextTickChannel=se;class he{constructor(Y){this.a=Y}routeCall(Y){return this.b(Y)}routeEvent(Y){return this.b(Y)}async b(Y){for(const ie of Y.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await f.Event.toPromise(Y.onDidAddConnection),await this.b(Y)}}t.StaticRouter=he;var ue;(function(j){function Y(te,W){const n=te,E=W&&W.disableMarshalling,P=new Map;for(const $ in n)ne($)&&P.set($,f.Event.buffer(n[$],!0));return new class{listen($,K,C){const I=P.get(K);if(I)return I;if(ae(K)){const R=n[K];if(typeof R=="function")return R.call(n,C)}throw new Error(`Event not found: ${K}`)}call($,K,C){const I=n[K];if(typeof I=="function"){if(!E&&Array.isArray(C))for(let R=0;R<C.length;R++)C[R]=(0,h.revive)(C[R]);return I.apply(n,C)}throw new Error(`Method not found: ${K}`)}}}j.fromService=Y;function ie(te,W){const n=W&&W.disableMarshalling;return new Proxy({},{get(E,P){if(typeof P=="string")return W?.properties?.has(P)?W.properties.get(P):ae(P)?function($){return te.listen(P,$)}:ne(P)?te.listen(P):async function(...$){let K;W&&!(0,a.isUndefinedOrNull)(W.context)?K=[W.context,...$]:K=$;const C=await te.call(P,K);return n?C:(0,h.revive)(C)};throw new Error(`Property not found: ${String(P)}`)}})}j.toService=ie;function ne(te){return te[0]==="o"&&te[1]==="n"&&N.isUpperAsciiLetter(te.charCodeAt(2))}function ae(te){return/^onDynamic/.test(te)&&N.isUpperAsciiLetter(te.charCodeAt(9))}})(ue=t.ProxyChannel||(t.ProxyChannel={}));const de=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function we(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const Y=j.toString();if(Y!=="[object Object]")return Y}return j}function Te(j){return Array.isArray(j)?j.map(we):we(j)}function Me(j,Y,ie,ne,ae,te,W){W=Te(W);const n=de[ae],E=n[ne%n.length];let P=[`%c[${j}]%c[${String(Y).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${E}`];/\($/.test(te)?(P=P.concat(W),P.push(")")):P.push(W),console.log.apply(console,P)}class Oe{constructor(Y,ie){this.d=Y,this.f=ie,this.a=0,this.b=0}logOutgoing(Y,ie,ne,ae,te){this.b+=Y,Me(this.d,this.b,Y,ie,ne,ae,te)}logIncoming(Y,ie,ne,ae,te){this.a+=Y,Me(this.f,this.a,Y,ie,ne,ae,te)}}t.IPCLogger=Oe}),define(ge[27],me([1,0,5]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=w.globals.vscode.ipcRenderer,t.ipcMessagePort=w.globals.vscode.ipcMessagePort,t.webFrame=w.globals.vscode.webFrame,t.process=w.globals.vscode.process,t.context=w.globals.vscode.context}),define(ge[130],me([1,0,81,27]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let U=0;function z(b,f,d){const h=[],N=U++,a=`vscode:onContextMenu${N}`,s=(e,r,o)=>{h[r].click?.(o)};i.ipcRenderer.once(a,s),i.ipcRenderer.once(w.CONTEXT_MENU_CLOSE_CHANNEL,(e,r)=>{r===N&&(i.ipcRenderer.removeListener(a,s),d?.())}),i.ipcRenderer.send(w.CONTEXT_MENU_CHANNEL,N,b.map(e=>y(e,h)),a,f)}t.popup=z;function y(b,f){const d={id:f.length,label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:typeof b.enabled=="boolean"?b.enabled:!0,visible:typeof b.visible=="boolean"?b.visible:!0};return f.push(b),Array.isArray(b.submenu)&&(d.submenu=b.submenu.map(h=>y(h,f))),d}}),define(ge[131],me([1,0,29,3,37,82,27]),function(J,t,w,i,U,z,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class b extends U.IPCClient{static f(){const d=i.Event.fromNodeEventEmitter(y.ipcRenderer,"vscode:message",(h,N)=>w.VSBuffer.wrap(N));return y.ipcRenderer.send("vscode:hello"),new z.Protocol(y.ipcRenderer,d)}constructor(d){const h=b.f();super(h,d),this.b=h}dispose(){this.b.disconnect()}}t.Client=b}),define(ge[132],me([12,10]),function(J,t){return J.create("vs/platform/files/common/files",t)}),define(ge[133],me([12,10]),function(J,t){return J.create("vs/platform/theme/common/iconRegistry",t)}),define(ge[65],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class w{constructor(U,z=[],y=!1){this.ctor=U,this.staticArguments=z,this.supportsDelayedInstantiation=y}}t.SyncDescriptor=w}),define(ge[134],me([1,0,65]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=t.InstantiationType=void 0;const i=[];var U;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(U=t.InstantiationType||(t.InstantiationType={}));function z(b,f,d){f instanceof w.SyncDescriptor||(f=new w.SyncDescriptor(f,[],Boolean(d))),i.push([b,f])}t.registerSingleton=z;function y(){return i}t.getSingletonServiceDescriptors=y}),define(ge[28],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var w;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function b(f){return f[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=b})(w=t._util||(t._util={})),t.IInstantiationService=U("instantiationService");function i(y,b,f){b[w.DI_TARGET]===b?b[w.DI_DEPENDENCIES].push({id:y,index:f}):(b[w.DI_DEPENDENCIES]=[{id:y,index:f}],b[w.DI_TARGET]=b)}function U(y){if(w.serviceIds.has(y))return w.serviceIds.get(y);const b=function(f,d,h){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(b,f,h)};return b.toString=()=>y,w.serviceIds.set(y,b),b}t.createDecorator=U;function z(y){return y}t.refineServiceDecorator=z}),define(ge[135],me([1,0,28]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,w.createDecorator)(t.ID);function i(z){return!!z.hostName&&!!z.errorMessage}t.isRemoteDiagnosticError=i;class U{async getPerformanceInfo(y,b){return{}}async getSystemInfo(y,b){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(y,b){return""}async getWorkspaceFileExtensions(y){return{extensions:[]}}async reportWorkspaceStats(y){}}t.NullDiagnosticsService=U}),define(ge[136],me([1,0,113,21,11,7,16,132,28,5]),function(J,t,w,i,U,z,y,b,f,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLargeFileConfirmationLimit=t.getPlatformFileLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.TooLargeFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,f.createDecorator)("fileService");function h(j){return j.create===!0}t.isFileOpenForWriteOptions=h;var N;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(N=t.FileType||(t.FileType={}));var a;(function(j){j[j.Readonly=1]="Readonly"})(a=t.FilePermission||(t.FilePermission={}));var s;(function(j){j[j.None=0]="None",j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead",j[j.FileClone=32768]="FileClone"})(s=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function e(j){return!!(j.capabilities&2)}t.hasReadWriteCapability=e;function r(j){return!!(j.capabilities&8)}t.hasFileFolderCopyCapability=r;function o(j){return!!(j.capabilities&32768)}t.hasFileCloneCapability=o;function l(j){return!!(j.capabilities&4)}t.hasOpenReadWriteCloseCapability=l;function u(j){return!!(j.capabilities&16)}t.hasFileReadStreamCapability=u;function D(j){return e(j)?!!(j.capabilities&16384):!1}t.hasFileAtomicReadCapability=D;var S;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(S=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class k extends Error{constructor(Y,ie){super(Y),this.code=ie}}t.FileSystemProviderError=k;function g(j,Y){const ie=new k(j.toString(),Y);return L(ie,Y),ie}t.createFileSystemProviderError=g;function A(j){return j||g((0,b.localize)(0,null),S.Unknown)}t.ensureFileSystemProviderError=A;function L(j,Y){return j.name=Y?`${Y} (FileSystemError)`:"FileSystemError",j}t.markAsFileSystemProviderError=L;function F(j){if(!j)return S.Unknown;if(j instanceof k)return j.code;const Y=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!Y)return S.Unknown;switch(Y[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}t.toFileSystemProviderErrorCode=F;function c(j){if(j instanceof x)return j.fileOperationResult;switch(F(j)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=c;var p;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(p=t.FileOperation||(t.FileOperation={}));class m{constructor(Y,ie,ne){this.resource=Y,this.operation=ie,this.target=ne}isOperation(Y){return this.operation===Y}}t.FileOperationEvent=m;var v;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(v=t.FileChangeType||(t.FileChangeType={}));class M{constructor(Y,ie){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ne=new Map;for(const ae of Y){const te=ne.get(ae.type);switch(te?te.push([ae.resource,ae]):ne.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,te]of ne)switch(ae){case 1:this.a=w.TernarySearchTree.forUris(()=>ie),this.a.fill(te);break;case 0:this.b=w.TernarySearchTree.forUris(()=>ie),this.b.fill(te);break;case 2:this.c=w.TernarySearchTree.forUris(()=>ie),this.c.fill(te);break}}contains(Y,...ie){return this.d(Y,{includeChildren:!1},...ie)}affects(Y,...ie){return this.d(Y,{includeChildren:!0},...ie)}d(Y,ie,...ne){if(!Y)return!1;const ae=ne.length>0;return!!((!ae||ne.includes(1))&&(this.a?.get(Y)||ie.includeChildren&&this.a?.findSuperstr(Y))||(!ae||ne.includes(0))&&(this.b?.get(Y)||ie.includeChildren&&this.b?.findSuperstr(Y))||(!ae||ne.includes(2))&&(this.c?.findSubstr(Y)||ie.includeChildren&&this.c?.findSuperstr(Y)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}t.FileChangesEvent=M;function V(j,Y,ie){return!j||!Y||j===Y||Y.length>j.length?!1:(Y.charAt(Y.length-1)!==i.sep&&(Y+=i.sep),ie?(0,U.startsWithIgnoreCase)(j,Y):j.indexOf(Y)===0)}t.isParent=V;class x extends Error{constructor(Y,ie,ne){super(Y),this.fileOperationResult=ie,this.options=ne}}t.FileOperationError=x;class Z extends x{constructor(Y,ie,ne,ae){super(Y,ie,ae),this.fileOperationResult=ie,this.size=ne}}t.TooLargeFileOperationError=Z;class ee extends x{constructor(Y,ie,ne){super(Y,2,ne),this.stat=ie}}t.NotModifiedSinceFileOperationError=ee;var se;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(se=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var he;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(he=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function ue(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}t.etag=ue;async function de(j,Y){if(!Y.hasProvider(y.URI.from({scheme:j.scheme})))return new Promise(ie=>{const ne=Y.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===j.scheme&&ae.added&&(ne.dispose(),ie())})})}t.whenProviderRegistered=de,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class we{static formatSize(Y){return(0,z.isNumber)(Y)||(Y=0),Y<we.KB?(0,b.localize)(1,null,Y.toFixed(0)):Y<we.MB?(0,b.localize)(2,null,(Y/we.KB).toFixed(2)):Y<we.GB?(0,b.localize)(3,null,(Y/we.MB).toFixed(2)):Y<we.TB?(0,b.localize)(4,null,(Y/we.GB).toFixed(2)):(0,b.localize)(5,null,(Y/we.TB).toFixed(2))}}t.ByteSize=we,we.KB=1024,we.MB=we.KB*we.KB,we.GB=we.MB*we.KB,we.TB=we.GB*we.KB;var Te;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(Te=t.Arch||(t.Arch={}));function Me(j){return{maxFileSize:j===0?300*we.MB:16*we.GB,maxHeapSize:j===0?700*we.MB:2*700*we.MB}}t.getPlatformFileLimits=Me;function Oe(j){return d.isWeb?j?10*we.MB:50*we.MB:j?100*we.MB:1024*we.MB}t.getLargeFileConfirmationLimit=Oe}),define(ge[137],me([1,0,2,131]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class U extends w.Disposable{constructor(y){super(),this.a=this.B(new i.Client(`window:${y}`))}getChannel(y){return this.a.getChannel(y)}registerChannel(y,b){this.a.registerChannel(y,b)}}t.ElectronIPCMainProcessService=U});var pt=this&&this.__param||function(J,t){return function(w,i){t(w,i,J)}};define(ge[138],me([1,0,37,65,134,28]),function(J,t,w,i,U,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerSharedProcessRemoteService=t.ISharedProcessService=t.registerMainProcessRemoteService=t.IMainProcessService=void 0;class y{constructor(s,e,r,o){const l=r.getChannel(s);return b(e)?o.createInstance(new i.SyncDescriptor(e.channelClientCtor,[l])):w.ProxyChannel.toService(l,e?.proxyOptions)}}function b(a){return!!a?.channelClientCtor}t.IMainProcessService=(0,z.createDecorator)("mainProcessService");let f=class extends y{constructor(s,e,r,o){super(s,e,r,o)}};f=Ve([pt(2,t.IMainProcessService),pt(3,z.IInstantiationService)],f);function d(a,s,e){(0,U.registerSingleton)(a,new i.SyncDescriptor(f,[s,e],!0))}t.registerMainProcessRemoteService=d,t.ISharedProcessService=(0,z.createDecorator)("sharedProcessService");let h=class extends y{constructor(s,e,r,o){super(s,e,r,o)}};h=Ve([pt(2,t.ISharedProcessService),pt(3,z.IInstantiationService)],h);function N(a,s,e){(0,U.registerSingleton)(a,new i.SyncDescriptor(h,[s,e],!0))}t.registerSharedProcessRemoteService=N}),define(ge[139],me([1,0,37,138]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let U=class{constructor(y,b){return this.windowId=y,w.ProxyChannel.toService(b.getChannel("nativeHost"),{context:y,properties:(()=>{const f=new Map;return f.set("windowId",y),f})()})}};U=Ve([pt(1,i.IMainProcessService)],U),t.NativeHostService=U}),define(ge[38],me([1,0,72,7]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class U{constructor(){this.a=new Map}add(y,b){w.ok(i.isString(y)),w.ok(i.isObject(b)),w.ok(!this.a.has(y),"There is already an extension with this id"),this.a.set(y,b)}knows(y){return this.a.has(y)}as(y){return this.a.get(y)||null}}t.Registry=new U}),define(ge[140],me([1,0,3,38]),function(J,t,w,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function U(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class z{constructor(){this.b=new w.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,d){this.a[U(f)]=d,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const y=new z;i.Registry.add(t.Extensions.JSONContribution,y)}),define(ge[141],me([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isDark=t.isHighContrast=t.ColorScheme=void 0;var w;(function(z){z.DARK="dark",z.LIGHT="light",z.HIGH_CONTRAST_DARK="hcDark",z.HIGH_CONTRAST_LIGHT="hcLight"})(w=t.ColorScheme||(t.ColorScheme={}));function i(z){return z===w.HIGH_CONTRAST_DARK||z===w.HIGH_CONTRAST_LIGHT}t.isHighContrast=i;function U(z){return z===w.DARK||z===w.HIGH_CONTRAST_DARK}t.isDark=U}),define(ge[66],me([1,0,13,3,2,28,38,141]),function(J,t,w,i,U,z,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Themable=t.registerThemingParticipant=t.Extensions=t.getThemeTypeSelector=t.FolderThemeIcon=t.FileThemeIcon=t.ThemeIcon=t.themeColorFromId=t.ThemeColor=t.IThemeService=void 0,t.IThemeService=(0,z.createDecorator)("themeService");var f;(function(o){function l(u){return u&&typeof u=="object"&&typeof u.id=="string"}o.isThemeColor=l})(f=t.ThemeColor||(t.ThemeColor={}));function d(o){return{id:o}}t.themeColorFromId=d;var h;(function(o){function l(F){return F&&typeof F=="object"&&typeof F.id=="string"&&(typeof F.color>"u"||f.isThemeColor(F.color))}o.isThemeIcon=l;const u=new RegExp(`^\\$\\((${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?)\\)$`);function D(F){const c=u.exec(F);if(!c)return;const[,p]=c;return{id:p}}o.fromString=D;function S(F){return{id:F}}o.fromId=S;function k(F,c){let p=F.id;const m=p.lastIndexOf("~");return m!==-1&&(p=p.substring(0,m)),c&&(p=`${p}~${c}`),{id:p}}o.modify=k;function g(F){const c=F.id.lastIndexOf("~");if(c!==-1)return F.id.substring(c+1)}o.getModifier=g;function A(F,c){return F.id===c.id&&F.color?.id===c.color?.id}o.isEqual=A;function L(F,c){return{id:F.id,color:c?d(c):void 0}}o.asThemeIcon=L,o.asClassNameArray=w.CSSIcon.asClassNameArray,o.asClassName=w.CSSIcon.asClassName,o.asCSSSelector=w.CSSIcon.asCSSSelector})(h=t.ThemeIcon||(t.ThemeIcon={})),t.FileThemeIcon=w.Codicon.file,t.FolderThemeIcon=w.Codicon.folder;function N(o){switch(o){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case b.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}t.getThemeTypeSelector=N,t.Extensions={ThemingContribution:"base.contributions.theming"};class a{constructor(){this.a=[],this.a=[],this.b=new i.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,U.toDisposable)(()=>{const u=this.a.indexOf(l);this.a.splice(u,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const s=new a;y.Registry.add(t.Extensions.ThemingContribution,s);function e(o){return s.onColorThemeChange(o)}t.registerThemingParticipant=e;class r extends U.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(u=>this.n(u)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,u){let D=this.h.getColor(l);return D&&u&&(D=u(D,this.h)),D?D.toString():null}}t.Themable=r}),define(ge[142],me([1,0,9,13,3,7,16,133,140,38,66]),function(J,t,w,i,U,z,y,b,f,d,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var N;(function(S){function k(g,A){let L=g.defaults;for(;h.ThemeIcon.isThemeIcon(L);){const F=e.getIcon(L.id);if(!F)return;L=F.defaults}return L}S.getDefinition=k})(N=t.IconContribution||(t.IconContribution={}));var a;(function(S){function k(A){return{weight:A.weight,style:A.style,src:A.src.map(L=>({format:L.format,location:L.location.toString()}))}}S.toJSONObject=k;function g(A){const L=F=>(0,z.isString)(F)?F:void 0;if(A&&Array.isArray(A.src)&&A.src.every(F=>(0,z.isString)(F.format)&&(0,z.isString)(F.location)))return{weight:L(A.weight),style:L(A.style),src:A.src.map(F=>({format:F.format,location:y.URI.parse(F.location)}))}}S.fromJSONObject=g})(a=t.IconFontDefinition||(t.IconFontDefinition={}));class s{constructor(){this.a=new U.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,b.localize)(0,null)},fontCharacter:{type:"string",description:(0,b.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(k,g,A,L){const F=this.b[k];if(F){if(A&&!F.description){F.description=A,this.d.properties[k].markdownDescription=`${A} $(${k})`;const m=this.e.enum.indexOf(k);m!==-1&&(this.e.enumDescriptions[m]=A),this.a.fire()}return F}const c={id:k,description:A,defaults:g,deprecationMessage:L};this.b[k]=c;const p={$ref:"#/definitions/icons"};return L&&(p.deprecationMessage=L),A&&(p.markdownDescription=`${A}: $(${k})`),this.d.properties[k]=p,this.e.enum.push(k),this.e.enumDescriptions.push(A||""),this.a.fire(),{id:k}}deregisterIcon(k){delete this.b[k],delete this.d.properties[k];const g=this.e.enum.indexOf(k);g!==-1&&(this.e.enum.splice(g,1),this.e.enumDescriptions.splice(g,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(k=>this.b[k])}getIcon(k){return this.b[k]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(k,g){const A=this.f[k];return A||(this.f[k]=g,this.a.fire(),g)}deregisterIconFont(k){delete this.f[k]}getIconFont(k){return this.f[k]}toString(){const k=(F,c)=>F.id.localeCompare(c.id),g=F=>{for(;h.ThemeIcon.isThemeIcon(F.defaults);)F=this.b[F.defaults.id];return`codicon codicon-${F?F.id:""}`},A=[];A.push("| preview     | identifier                        | default codicon ID                | description"),A.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const L=Object.keys(this.b).map(F=>this.b[F]);for(const F of L.filter(c=>!!c.description).sort(k))A.push(`|<i class="${g(F)}"></i>|${F.id}|${h.ThemeIcon.isThemeIcon(F.defaults)?F.defaults.id:F.id}|${F.description||""}|`);A.push("| preview     | identifier                        "),A.push("| ----------- | --------------------------------- |");for(const F of L.filter(c=>!h.ThemeIcon.isThemeIcon(c.defaults)).sort(k))A.push(`|<i class="${g(F)}"></i>|${F.id}|`);return A.join(`
`)}}const e=new s;d.Registry.add(t.Extensions.IconContribution,e);function r(S,k,g,A){return e.registerIcon(S,k,g,A)}t.registerIcon=r;function o(){return e}t.getIconRegistry=o;function l(){for(const S of i.Codicon.getAll())e.registerIcon(S.id,{fontCharacter:S.fontCharacter},S.description)}l(),t.iconsSchemaId="vscode://schemas/icons";const u=d.Registry.as(f.Extensions.JSONContribution);u.registerSchema(t.iconsSchemaId,e.getIconSchema());const D=new w.RunOnceScheduler(()=>u.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{D.isScheduled()||D.schedule()}),t.widgetClose=r("widget-close",i.Codicon.close,(0,b.localize)(2,null)),t.gotoPreviousLocation=r("goto-previous-location",i.Codicon.arrowUp,(0,b.localize)(3,null)),t.gotoNextLocation=r("goto-next-location",i.Codicon.arrowDown,(0,b.localize)(4,null)),t.syncing=h.ThemeIcon.modify(i.Codicon.sync,"spin"),t.spinningLoading=h.ThemeIcon.modify(i.Codicon.loading,"spin")}),define(ge[143],me([1,0,4,3,142,66]),function(J,t,w,i,U,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function y(f){const d=new i.Emitter,h=(0,U.getIconRegistry)();return h.onDidChange(()=>d.fire()),f?.onDidProductIconThemeChange(()=>d.fire()),{onDidChange:d.event,getCSS(){const N=f?f.getProductIconTheme():new b,a={},s=r=>{const o=N.getIcon(r);if(!o)return;const l=o.font;return l?(a[l.id]=l.definition,`.codicon-${r.id}:before { content: '${o.fontCharacter}'; font-family: ${(0,w.asCSSPropertyValue)(l.id)}; }`):`.codicon-${r.id}:before { content: '${o.fontCharacter}'; }`},e=[];for(const r of h.getIcons()){const o=s(r);o&&e.push(o)}for(const r in a){const o=a[r],l=o.weight?`font-weight: ${o.weight};`:"",u=o.style?`font-style: ${o.style};`:"",D=o.src.map(S=>`${(0,w.asCSSUrl)(S.location)} format('${S.format}')`).join(", ");e.push(`@font-face { src: ${D}; font-family: ${(0,w.asCSSPropertyValue)(r)};${l}${u} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=y;class b{getIcon(d){const h=(0,U.getIconRegistry)();let N=d.defaults;for(;z.ThemeIcon.isThemeIcon(N);){const a=h.getIcon(N.id);if(!a)return;N=a.defaults}return N}}t.UnthemedProductIconTheme=b}),define(ge[144],me([1,0,5]),function(J,t,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function i(h){return!!h.workspaceUri}t.isWorkspaceToOpen=i;function U(h){return!!h.folderUri}t.isFolderToOpen=U;function z(h){return!!h.fileUri}t.isFileToOpen=z;function y(h){const N=b(h),a=h.getValue("window.menuBarVisibility");return a==="default"||N==="native"&&a==="compact"||w.isMacintosh&&w.isNative?"classic":a}t.getMenuBarVisibility=y;function b(h){if(w.isWeb)return"custom";const N=h.getValue("window");if(N){if(w.isMacintosh&&N.nativeTabs===!0||w.isMacintosh&&N.nativeFullScreen===!1)return"native";const e=N.titleBarStyle;if(e==="native"||e==="custom")return e}return w.isLinux?"native":"custom"}t.getTitleBarStyle=b;function f(h){if(!w.isWindows||w.isWeb||b(h)==="native")return!1;const N=h.getValue("window.experimental.windowControlsOverlay.enabled");return typeof N=="boolean"?N:!0}t.useWindowControlsOverlay=f;function d(h=0){return Math.pow(1.2,h)}t.zoomLevelToZoomFactor=d}),define(ge[145],me([1,0,17,27,144]),function(J,t,w,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function z(f){i.webFrame.setZoomLevel(f),(0,w.setZoomFactor)((0,U.zoomLevelToZoomFactor)(f)),(0,w.setZoomLevel)(f,!1)}t.applyZoom=z;function y(){z((0,w.getZoomLevel)()+1)}t.zoomIn=y;function b(){z((0,w.getZoomLevel)()-1)}t.zoomOut=b}),define(ge[146],me([1,0,10,4,129,9,130,27,135,136,137,139,143,145,15,95,86]),function(J,t,w,i,U,z,y,b,f,d,h,N,a,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const r=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,o=/\s--inspect-port=(?<port>\d+)/;class l{getHeight(M){return 22}getTemplateId(M){return F(M)?"process":A(M)?"machine":(0,f.isRemoteDiagnosticError)(M)?"error":L(M)?"header":""}}class u{hasChildren(M){return(0,f.isRemoteDiagnosticError)(M)?!1:F(M)?!!M.children?.length:!0}getChildren(M){return F(M)?M.children?M.children:[]:(0,f.isRemoteDiagnosticError)(M)?[]:L(M)?M.processRoots.length>1?M.processRoots:[M.processRoots[0].rootProcess]:A(M)?[M.rootProcess]:[M.processes]}}class D{constructor(){this.templateId="header"}renderTemplate(M){const V=Object.create(null),x=(0,i.append)(M,(0,i.$)(".row"));return V.name=(0,i.append)(x,(0,i.$)(".nameLabel")),V.CPU=(0,i.append)(x,(0,i.$)(".cpu")),V.memory=(0,i.append)(x,(0,i.$)(".memory")),V.PID=(0,i.append)(x,(0,i.$)(".pid")),V}renderElement(M,V,x,Z){x.name.textContent=(0,w.localize)(0,null),x.CPU.textContent=(0,w.localize)(1,null),x.PID.textContent=(0,w.localize)(2,null),x.memory.textContent=(0,w.localize)(3,null)}disposeTemplate(M){}}class S{constructor(){this.templateId="machine"}renderTemplate(M){const V=Object.create(null),x=(0,i.append)(M,(0,i.$)(".row"));return V.name=(0,i.append)(x,(0,i.$)(".nameLabel")),V}renderElement(M,V,x,Z){x.name.textContent=M.element.name}disposeTemplate(M){}}class k{constructor(){this.templateId="error"}renderTemplate(M){const V=Object.create(null),x=(0,i.append)(M,(0,i.$)(".row"));return V.name=(0,i.append)(x,(0,i.$)(".nameLabel")),V}renderElement(M,V,x,Z){x.name.textContent=M.element.errorMessage}disposeTemplate(M){}}class g{constructor(M,V,x){this.a=M,this.b=V,this.c=x,this.templateId="process"}renderTemplate(M){const V=Object.create(null),x=(0,i.append)(M,(0,i.$)(".row"));return V.name=(0,i.append)(x,(0,i.$)(".nameLabel")),V.CPU=(0,i.append)(x,(0,i.$)(".cpu")),V.memory=(0,i.append)(x,(0,i.$)(".memory")),V.PID=(0,i.append)(x,(0,i.$)(".pid")),V}renderElement(M,V,x,Z){const{element:ee}=M;let se=ee.name;se==="window"&&(se=this.c.get(ee.pid)!==void 0?`${se} (${this.c.get(ee.pid)})`:se);const he=ee.pid.toFixed(0);x.name.textContent=se,x.name.title=ee.cmd,x.CPU.textContent=ee.load.toFixed(0),x.PID.textContent=he,x.PID.parentElement.id=`pid-${he}`;const ue=this.a==="win32"?ee.mem:this.b*(ee.mem/100);x.memory.textContent=(ue/d.ByteSize.MB).toFixed(0)}disposeTemplate(M){}}function A(v){return!!v.name&&!!v.rootProcess}function L(v){return!!v.processRoots}function F(v){return!!v.pid}class c{constructor(M,V){this.f=V,this.b=new Map;const x=new h.ElectronIPCMainProcessService(M);this.c=new N.NativeHostService(M,x),this.k(V.styles),this.g(V),b.ipcRenderer.on("vscode:windowsInfoResponse",(Z,ee)=>{this.b=new Map,ee.forEach(se=>this.b.set(se.pid,se.title))}),b.ipcRenderer.on("vscode:listProcessesResponse",async(Z,ee)=>{ee.forEach((se,he)=>{F(se.rootProcess)&&(se.rootProcess.name=he===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:ee}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(ee),this.m(0)}),this.a=Date.now(),b.ipcRenderer.send("vscode:windowsInfoRequest"),b.ipcRenderer.send("vscode:listProcesses")}g(M){document.onkeydown=V=>{const x=M.platform==="darwin"?V.metaKey:V.ctrlKey;x&&V.keyCode===87&&(V.stopPropagation(),V.preventDefault(),b.ipcRenderer.send("vscode:closeProcessExplorer")),x&&V.keyCode===187&&(0,s.zoomIn)(),x&&V.keyCode===189&&(0,s.zoomOut)()}}async h(M){const V=document.getElementById("process-list");if(!V)return;const{totalmem:x}=await this.c.getOSStatistics(),Z=[new g(this.f.platform,x,this.b),new D,new S,new k];this.d=new U.DataTree("processExplorer",V,new l,Z,new u,{identityProvider:{getId:ee=>F(ee)?ee.pid.toString():(0,f.isRemoteDiagnosticError)(ee)?ee.hostName:L(ee)?"processes":A(ee)?ee.name:"header"}}),this.d.setInput({processes:{processRoots:M}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(ee=>{const se=new e.StandardKeyboardEvent(ee);if(se.keyCode===35&&se.altKey){const he=this.n();Promise.all(he.map(ue=>this.c.killProcess(ue,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(ee=>{F(ee.element)&&this.l(ee.element,!0)}),V.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{V.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(M){const V=r.exec(M);return V&&V.groups.port!=="0"||M.indexOf("node ")>=0||M.indexOf("node.exe")>=0}j(M){const V={type:"node",request:"attach",name:`process ${M.pid}`};let x=r.exec(M.cmd);x?V.port=Number(x.groups.port):V.processId=String(M.pid),x=o.exec(M.cmd),x&&(V.port=Number(x.groups.port)),b.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[V]})}k(M){const V=(0,i.createStyleSheet)(),x=[];M.listFocusBackground&&(x.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${M.listFocusBackground}; }`),x.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${M.listFocusBackground}; }`)),M.listFocusForeground&&x.push(`.monaco-list:focus .monaco-list-row.focused { color: ${M.listFocusForeground}; }`),M.listActiveSelectionBackground&&(x.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${M.listActiveSelectionBackground}; }`),x.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${M.listActiveSelectionBackground}; }`)),M.listActiveSelectionForeground&&x.push(`.monaco-list:focus .monaco-list-row.selected { color: ${M.listActiveSelectionForeground}; }`),M.listHoverBackground&&x.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${M.listHoverBackground}; }`),M.listHoverForeground&&x.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${M.listHoverForeground}; }`),M.listFocusOutline&&x.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${M.listFocusOutline}; outline-offset: -1px; }`),M.listHoverOutline&&x.push(`.monaco-list-row:hover { outline: 1px dashed ${M.listHoverOutline}; outline-offset: -1px; }`),M.scrollbarShadowColor&&x.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${M.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${M.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${M.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),M.scrollbarSliderBackgroundColor&&x.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${M.scrollbarSliderBackgroundColor};
				}
			`),M.scrollbarSliderHoverBackgroundColor&&x.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${M.scrollbarSliderHoverBackgroundColor};
				}
			`),M.scrollbarSliderActiveBackgroundColor&&x.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${M.scrollbarSliderActiveBackgroundColor};
				}
			`),V.textContent=x.join(`
`),M.color&&(document.body.style.color=M.color)}l(M,V){const x=[],Z=Number(M.pid);V&&(x.push({label:(0,w.localize)(4,null),click:()=>{this.c.killProcess(Z,"SIGTERM")}}),x.push({label:(0,w.localize)(5,null),click:()=>{this.c.killProcess(Z,"SIGKILL")}}),x.push({type:"separator"})),x.push({label:(0,w.localize)(6,null),click:()=>{const ee=this.n();ee?.includes(Z)||(ee.length=0,ee.push(Z));const se=ee?.map(he=>document.getElementById(`pid-${he}`)).filter(he=>!!he);if(se){const he=se.map(ue=>ue.innerText).filter(ue=>!!ue);this.c.writeClipboardText(he.join(`
`))}}}),x.push({label:(0,w.localize)(7,null),click:()=>{const ee=document.getElementById("process-list");ee&&this.c.writeClipboardText(ee.innerText)}}),M&&V&&this.i(M.cmd)&&(x.push({type:"separator"}),x.push({label:(0,w.localize)(8,null),click:()=>{this.j(M)}})),(0,y.popup)(x)}m(M){setTimeout(()=>{const V=Date.now(),x=M+V-this.a;this.a=V,x>1e3?(b.ipcRenderer.send("vscode:windowsInfoRequest"),b.ipcRenderer.send("vscode:listProcesses")):this.m(x)},200)}n(){return this.d?.getSelection()?.map(M=>{if(!(!M||!("pid"in M)))return M.pid}).filter(M=>!!M)}}function p(){const v=(0,i.createStyleSheet)();v.id="codiconStyles";const M=(0,a.getIconsStyleSheet)(void 0);function V(){v.textContent=M.getCSS()}const x=new z.RunOnceScheduler(V,0);M.onDidChange(()=>x.schedule()),x.schedule()}function m(v){const M=v.data.platform==="win32"?"windows":v.data.platform==="linux"?"linux":"mac";document.body.classList.add(M),p(),(0,s.applyZoom)(v.data.zoomLevel),new c(v.windowId,v.data)}t.startup=m})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/89e427274e1c9e555f8bfa21bd1e9c50c0225403/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
