/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/platform/environment/common/environment","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(x){for(var e=[],T=0,O=x.length;T<O;T++)e[T]=Z[x[T]];return e};define(Z[49],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function T(N){return(S,h,u)=>{let v=null,p=null;if(typeof u.value=="function"?(v="value",p=u.value):typeof u.get=="function"&&(v="get",p=u.get),!p)throw new Error("not supported");u[v]=N(p,h)}}function O(N,S,h){let u=null,v=null;if(typeof h.value=="function"?(u="value",v=h.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(u="get",v=h.get),!v)throw new Error("not supported");const p=`$memoize$${S}`;h[u]=function(...g){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,g)}),this[p]}}e.memoize=O;function R(N,S,h){return T((u,v)=>{const p=`$debounce$${v}`,g=`$debounce$result$${v}`;return function(...k){this[g]||(this[g]=h?h():void 0),clearTimeout(this[p]),S&&(this[g]=S(this[g],...k),k=[this[g]]),this[p]=setTimeout(()=>{u.apply(this,k),this[g]=h?h():void 0},N)}})}e.debounce=R;function D(N,S,h){return T((u,v)=>{const p=`$throttle$timer$${v}`,g=`$throttle$result$${v}`,k=`$throttle$lastRun$${v}`,E=`$throttle$pending$${v}`;return function(...L){if(this[g]||(this[g]=h?h():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),S&&(this[g]=S(this[g],...L)),this[E])return;const f=this[k]+N;f<=Date.now()?(this[k]=Date.now(),u.apply(this,[this[g]]),this[g]=h?h():void 0):(this[E]=!0,this[p]=setTimeout(()=>{this[E]=!1,this[k]=Date.now(),u.apply(this,[this[g]]),this[g]=h?h():void 0},f-Date.now()))}})}e.throttle=D}),define(Z[70],Q([0,1,6]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(h,u){if(!h)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=O;function R(h,u="Unreachable"){throw new Error(u)}e.assertNever=R;function D(h){if(!h)throw new T.BugIndicatingError("Assertion Failed")}e.assert=D;function N(h){if(!h()){debugger;h(),(0,T.onUnexpectedError)(new T.BugIndicatingError("Assertion Failed"))}}e.assertFn=N;function S(h,u){let v=0;for(;v<h.length-1;){const p=h[v],g=h[v+1];if(!u(p,g))return!1;v++}return!0}e.checkAdjacentItems=S}),define(Z[50],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(T=e.ScanError||(e.ScanError={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function N(t,o=!1){let i=0;const n=t.length;let r="",a=0,s=16,l=0;function w(ne){let ae=0,fe=0;for(;ae<ne;){const re=t.charCodeAt(i);if(re>=48&&re<=57)fe=fe*16+re-48;else if(re>=65&&re<=70)fe=fe*16+re-65+10;else if(re>=97&&re<=102)fe=fe*16+re-97+10;else break;i++,ae++}return ae<ne&&(fe=-1),fe}function A(ne){i=ne,r="",a=0,s=16,l=0}function U(){const ne=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&u(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&u(t.charCodeAt(i)))for(i++;i<t.length&&u(t.charCodeAt(i));)i++;else return l=3,t.substring(ne,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&u(t.charCodeAt(i))){for(i++;i<t.length&&u(t.charCodeAt(i));)i++;ae=i}else l=3;return t.substring(ne,ae)}function Y(){let ne="",ae=i;for(;;){if(i>=n){ne+=t.substring(ae,i),l=2;break}const fe=t.charCodeAt(i);if(fe===34){ne+=t.substring(ae,i),i++;break}if(fe===92){if(ne+=t.substring(ae,i),i++,i>=n){l=2;break}switch(t.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const me=w(4);me>=0?ne+=String.fromCharCode(me):l=4;break}default:l=5}ae=i;continue}if(fe>=0&&fe<=31)if(h(fe)){ne+=t.substring(ae,i),l=2;break}else l=6;i++}return ne}function X(){if(r="",l=0,a=i,i>=n)return a=n,s=17;let ne=t.charCodeAt(i);if(S(ne)){do i++,r+=String.fromCharCode(ne),ne=t.charCodeAt(i);while(S(ne));return s=15}if(h(ne))return i++,r+=String.fromCharCode(ne),ne===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),s=14;switch(ne){case 123:return i++,s=1;case 125:return i++,s=2;case 91:return i++,s=3;case 93:return i++,s=4;case 58:return i++,s=6;case 44:return i++,s=5;case 34:return i++,r=Y(),s=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!h(t.charCodeAt(i));)i++;return r=t.substring(ae,i),s=12}if(t.charCodeAt(i+1)===42){i+=2;const fe=n-1;let re=!1;for(;i<fe;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,re=!0;break}i++}return re||(i++,l=1),r=t.substring(ae,i),s=13}return r+=String.fromCharCode(ne),i++,s=16}case 45:if(r+=String.fromCharCode(ne),i++,i===n||!u(t.charCodeAt(i)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=U(),s=11;default:for(;i<n&&ee(ne);)i++,ne=t.charCodeAt(i);if(a!==i){switch(r=t.substring(a,i),r){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return r+=String.fromCharCode(ne),i++,s=16}}function ee(ne){if(S(ne)||h(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let ne;do ne=X();while(ne>=12&&ne<=15);return ne}return{setPosition:A,getPosition:()=>i,scan:o?ie:X,getToken:()=>s,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>l}}e.createScanner=N;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var v;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(v||(v={}));function p(t,o){const i=[],n=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function l(w,A,U,Y){a.value=w,a.offset=A,a.length=U,a.type=Y,a.colonOffset=void 0,r=a}try{b(t,{onObjectBegin:(w,A)=>{if(o<=w)throw n;r=void 0,s=o>w,i.push("")},onObjectProperty:(w,A,U)=>{if(o<A||(l(w,A,U,"property"),i[i.length-1]=w,o<=A+U))throw n},onObjectEnd:(w,A)=>{if(o<=w)throw n;r=void 0,i.pop()},onArrayBegin:(w,A)=>{if(o<=w)throw n;r=void 0,i.push(0)},onArrayEnd:(w,A)=>{if(o<=w)throw n;r=void 0,i.pop()},onLiteralValue:(w,A,U)=>{if(o<A||(l(w,A,U,y(w)),o<=A+U))throw n},onSeparator:(w,A,U)=>{if(o<=A)throw n;if(w===":"&&r&&r.type==="property")r.colonOffset=A,s=!1,r=void 0;else if(w===","){const Y=i[i.length-1];typeof Y=="number"?i[i.length-1]=Y+1:(s=!0,i[i.length-1]=""),r=void 0}}})}catch(w){if(w!==n)throw w}return{path:i,previousNode:r,isAtPropertyKey:s,matches:w=>{let A=0;for(let U=0;A<w.length&&U<i.length;U++)if(w[A]===i[U]||w[A]==="*")A++;else if(w[A]!=="**")return!1;return A===w.length}}}e.getLocation=p;function g(t,o=[],i=D.DEFAULT){let n=null,r=[];const a=[];function s(w){Array.isArray(r)?r.push(w):n!==null&&(r[n]=w)}return b(t,{onObjectBegin:()=>{const w={};s(w),a.push(r),r=w,n=null},onObjectProperty:w=>{n=w},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const w=[];s(w),a.push(r),r=w,n=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:s,onError:(w,A,U)=>{o.push({error:w,offset:A,length:U})}},i),r[0]}e.parse=g;function k(t,o=[],i=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(w){n.type==="property"&&(n.length=w-n.offset,n=n.parent)}function a(w){return n.children.push(w),w}b(t,{onObjectBegin:w=>{n=a({type:"object",offset:w,length:-1,parent:n,children:[]})},onObjectProperty:(w,A,U)=>{n=a({type:"property",offset:A,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:w,offset:A,length:U,parent:n})},onObjectEnd:(w,A)=>{n.length=w+A-n.offset,n=n.parent,r(w+A)},onArrayBegin:(w,A)=>{n=a({type:"array",offset:w,length:-1,parent:n,children:[]})},onArrayEnd:(w,A)=>{n.length=w+A-n.offset,n=n.parent,r(w+A)},onLiteralValue:(w,A,U)=>{a({type:y(w),offset:A,length:U,parent:n,value:w}),r(A+U)},onSeparator:(w,A,U)=>{n.type==="property"&&(w===":"?n.colonOffset=A:w===","&&r(A))},onError:(w,A,U)=>{o.push({error:w,offset:A,length:U})}},i);const l=n.children[0];return l&&delete l.parent,l}e.parseTree=k;function E(t,o){if(!t)return;let i=t;for(const n of o)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===n){i=a.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=E;function L(t){if(!t.parent||!t.parent.children)return[];const o=L(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;o.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&o.push(i)}return o}e.getNodePath=L;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const o=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(o[i.children[0].value]=f(n))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=f;function c(t,o,i=!1){return o>=t.offset&&o<t.offset+t.length||i&&o===t.offset+t.length}e.contains=c;function m(t,o,i=!1){if(c(t,o,i)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=o;r++){const a=m(n[r],o,i);if(a)return a}return t}}e.findNodeAtOffset=m;function b(t,o,i=D.DEFAULT){const n=N(t,!1);function r(q){return q?()=>q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(q){return q?K=>q(K,n.getTokenOffset(),n.getTokenLength()):()=>!0}const s=r(o.onObjectBegin),l=a(o.onObjectProperty),w=r(o.onObjectEnd),A=r(o.onArrayBegin),U=r(o.onArrayEnd),Y=a(o.onLiteralValue),X=a(o.onSeparator),ee=r(o.onComment),ie=a(o.onError),ne=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function fe(){for(;;){const q=n.scan();switch(n.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:ne||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(q){case 12:case 13:ne?re(10):ee();break;case 16:re(1);break;case 15:case 14:break;default:return q}}}function re(q,K=[],P=[]){if(ie(q),K.length+P.length>0){let I=n.getToken();for(;I!==17;){if(K.indexOf(I)!==-1){fe();break}else if(P.indexOf(I)!==-1)break;I=fe()}}}function me(q){const K=n.getTokenValue();return q?Y(K):l(K),fe(),!0}function B(){switch(n.getToken()){case 11:{let q=0;try{q=JSON.parse(n.getTokenValue()),typeof q!="number"&&(re(2),q=0)}catch{re(2)}Y(q);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return fe(),!0}function j(){return n.getToken()!==10?(re(3,[],[2,5]),!1):(me(!1),n.getToken()===6?(X(":"),fe(),W()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function M(){s(),fe();let q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(q||re(4,[],[]),X(","),fe(),n.getToken()===2&&ae)break}else q&&re(6,[],[]);j()||re(4,[],[2,5]),q=!0}return w(),n.getToken()!==2?re(7,[2],[]):fe(),!0}function V(){A(),fe();let q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(q||re(4,[],[]),X(","),fe(),n.getToken()===4&&ae)break}else q&&re(6,[],[]);W()||re(4,[],[4,5]),q=!0}return U(),n.getToken()!==4?re(8,[4],[]):fe(),!0}function W(){switch(n.getToken()){case 3:return V();case 1:return M();case 10:return me(!0);default:return B()}}return fe(),n.getToken()===17?i.allowEmptyContent?!0:(re(4,[],[]),!1):W()?(n.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}e.visit=b;function d(t,o){const i=N(t),n=[];let r,a=0,s;do switch(s=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:a!==s&&n.push(t.substring(a,s)),o!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,o)),a=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=d;function y(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=y}),define(Z[71],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function T(S,h,u){return Math.min(Math.max(S,h),u)}e.clamp=T;function O(S,h){return(h+S%h)%h}e.rot=O;class R{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=R;class D{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=D;class N{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const u=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=N}),function(){function x(R){const D=[];typeof R=="number"&&D.push("code/timeOrigin",R);function N(h){D.push(h,Date.now())}function S(){const h=[];for(let u=0;u<D.length;u+=2)h.push({name:D[u],startTime:D[u+1]});return h}return{mark:N,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const N of performance.getEntriesByType("mark"))D.push({name:N.name,startTime:Math.round(R+N.startTime)});return D}};if(typeof process=="object"){const R=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function T(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=T(O))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var O in T)(typeof exports=="object"?exports:x)[O]=T[O]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function T(O){if(e[O])return e[O].exports;var R=e[O]={i:O,l:!1,exports:{}};return x[O].call(R.exports,R,R.exports,T),R.l=!0,R.exports}return T.m=x,T.c=e,T.d=function(O,R,D){T.o(O,R)||Object.defineProperty(O,R,{enumerable:!0,get:D})},T.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},T.t=function(O,R){if(1&R&&(O=T(O)),8&R||4&R&&typeof O=="object"&&O&&O.__esModule)return O;var D=Object.create(null);if(T.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:O}),2&R&&typeof O!="string")for(var N in O)T.d(D,N,function(S){return O[S]}.bind(null,N));return D},T.n=function(O){var R=O&&O.__esModule?function(){return O.default}:function(){return O};return T.d(R,"a",R),R},T.o=function(O,R){return Object.prototype.hasOwnProperty.call(O,R)},T.p="",T(T.s=0)}([function(x,e,T){(function(O){var R;e=x.exports=P,R=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],h=e.src=[],u=0,v=u++;h[v]="0|[1-9]\\d*";var p=u++;h[p]="[0-9]+";var g=u++;h[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=u++;h[k]="("+h[v]+")\\.("+h[v]+")\\.("+h[v]+")";var E=u++;h[E]="("+h[p]+")\\.("+h[p]+")\\.("+h[p]+")";var L=u++;h[L]="(?:"+h[v]+"|"+h[g]+")";var f=u++;h[f]="(?:"+h[p]+"|"+h[g]+")";var c=u++;h[c]="(?:-("+h[L]+"(?:\\."+h[L]+")*))";var m=u++;h[m]="(?:-?("+h[f]+"(?:\\."+h[f]+")*))";var b=u++;h[b]="[0-9A-Za-z-]+";var d=u++;h[d]="(?:\\+("+h[b]+"(?:\\."+h[b]+")*))";var y=u++,t="v?"+h[k]+h[c]+"?"+h[d]+"?";h[y]="^"+t+"$";var o="[v=\\s]*"+h[E]+h[m]+"?"+h[d]+"?",i=u++;h[i]="^"+o+"$";var n=u++;h[n]="((?:<|>)?=?)";var r=u++;h[r]=h[p]+"|x|X|\\*";var a=u++;h[a]=h[v]+"|x|X|\\*";var s=u++;h[s]="[v=\\s]*("+h[a]+")(?:\\.("+h[a]+")(?:\\.("+h[a]+")(?:"+h[c]+")?"+h[d]+"?)?)?";var l=u++;h[l]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[m]+")?"+h[d]+"?)?)?";var w=u++;h[w]="^"+h[n]+"\\s*"+h[s]+"$";var A=u++;h[A]="^"+h[n]+"\\s*"+h[l]+"$";var U=u++;h[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=u++;h[Y]="(?:~>?)";var X=u++;h[X]="(\\s*)"+h[Y]+"\\s+",S[X]=new RegExp(h[X],"g");var ee=u++;h[ee]="^"+h[Y]+h[s]+"$";var ie=u++;h[ie]="^"+h[Y]+h[l]+"$";var ne=u++;h[ne]="(?:\\^)";var ae=u++;h[ae]="(\\s*)"+h[ne]+"\\s+",S[ae]=new RegExp(h[ae],"g");var fe=u++;h[fe]="^"+h[ne]+h[s]+"$";var re=u++;h[re]="^"+h[ne]+h[l]+"$";var me=u++;h[me]="^"+h[n]+"\\s*("+o+")$|^$";var B=u++;h[B]="^"+h[n]+"\\s*("+t+")$|^$";var j=u++;h[j]="(\\s*)"+h[n]+"\\s*("+o+"|"+h[s]+")",S[j]=new RegExp(h[j],"g");var M=u++;h[M]="^\\s*("+h[s]+")\\s+-\\s+("+h[s]+")\\s*$";var V=u++;h[V]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var W=u++;h[W]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)R(q,h[q]),S[q]||(S[q]=new RegExp(h[q]));function K(z,H){if(z instanceof P)return z;if(typeof z!="string"||z.length>D||!(H?S[i]:S[y]).test(z))return null;try{return new P(z,H)}catch{return null}}function P(z,H){if(z instanceof P){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof P))return new P(z,H);R("SemVer",z,H),this.loose=H;var J=z.trim().match(H?S[i]:S[y]);if(!J)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var pe=+he;if(pe>=0&&pe<N)return pe}return he}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=K,e.valid=function(z,H){var J=K(z,H);return J?J.version:null},e.clean=function(z,H){var J=K(z.trim().replace(/^[=v]+/,""),H);return J?J.version:null},e.SemVer=P,P.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},P.prototype.toString=function(){return this.version},P.prototype.compare=function(z){return R("SemVer.compare",this.version,this.loose,z),z instanceof P||(z=new P(z,this.loose)),this.compareMain(z)||this.comparePre(z)},P.prototype.compareMain=function(z){return z instanceof P||(z=new P(z,this.loose)),C(this.major,z.major)||C(this.minor,z.minor)||C(this.patch,z.patch)},P.prototype.comparePre=function(z){if(z instanceof P||(z=new P(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var J=this.prerelease[H],he=z.prerelease[H];if(R("prerelease compare",H,J,he),J===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(J===void 0)return-1;if(J!==he)return C(J,he)}while(++H)},P.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,H,J,he){typeof J=="string"&&(he=J,J=void 0);try{return new P(z,J).inc(H,he).version}catch{return null}},e.diff=function(z,H){if(te(z,H))return null;var J=K(z),he=K(H);if(J.prerelease.length||he.prerelease.length){for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==he[pe])return"pre"+pe;return"prerelease"}for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==he[pe])return pe},e.compareIdentifiers=C;var I=/^[0-9]+$/;function C(z,H){var J=I.test(z),he=I.test(H);return J&&he&&(z=+z,H=+H),J&&!he?-1:he&&!J?1:z<H?-1:z>H?1:0}function F(z,H,J){return new P(z,J).compare(new P(H,J))}function $(z,H,J){return F(z,H,J)>0}function G(z,H,J){return F(z,H,J)<0}function te(z,H,J){return F(z,H,J)===0}function oe(z,H,J){return F(z,H,J)!==0}function ge(z,H,J){return F(z,H,J)>=0}function ve(z,H,J){return F(z,H,J)<=0}function le(z,H,J,he){var pe;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),pe=z===J;break;case"!==":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),pe=z!==J;break;case"":case"=":case"==":pe=te(z,J,he);break;case"!=":pe=oe(z,J,he);break;case">":pe=$(z,J,he);break;case">=":pe=ge(z,J,he);break;case"<":pe=G(z,J,he);break;case"<=":pe=ve(z,J,he);break;default:throw new TypeError("Invalid operator: "+H)}return pe}function ce(z,H){if(z instanceof ce){if(z.loose===H)return z;z=z.value}if(!(this instanceof ce))return new ce(z,H);R("comparator",z,H),this.loose=H,this.parse(z),this.semver===we?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(z,H){return C(H,z)},e.major=function(z,H){return new P(z,H).major},e.minor=function(z,H){return new P(z,H).minor},e.patch=function(z,H){return new P(z,H).patch},e.compare=F,e.compareLoose=function(z,H){return F(z,H,!0)},e.rcompare=function(z,H,J){return F(H,z,J)},e.sort=function(z,H){return z.sort(function(J,he){return e.compare(J,he,H)})},e.rsort=function(z,H){return z.sort(function(J,he){return e.rcompare(J,he,H)})},e.gt=$,e.lt=G,e.eq=te,e.neq=oe,e.gte=ge,e.lte=ve,e.cmp=le,e.Comparator=ce;var we={};function se(z,H){if(z instanceof se)return z.loose===H?z:new se(z.raw,H);if(z instanceof ce)return new se(z.value,H);if(!(this instanceof se))return new se(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function ue(z){return!z||z.toLowerCase()==="x"||z==="*"}function be(z,H,J,he,pe,Oe,Se,Le,Pe,De,Fe,Re,Te){return((H=ue(J)?"":ue(he)?">="+J+".0.0":ue(pe)?">="+J+"."+he+".0":">="+H)+" "+(Le=ue(Pe)?"":ue(De)?"<"+(+Pe+1)+".0.0":ue(Fe)?"<"+Pe+"."+(+De+1)+".0":Re?"<="+Pe+"."+De+"."+Fe+"-"+Re:"<="+Le)).trim()}function je(z,H){for(var J=0;J<z.length;J++)if(!z[J].test(H))return!1;if(H.prerelease.length){for(J=0;J<z.length;J++)if(R(z[J].semver),z[J].semver!==we&&z[J].semver.prerelease.length>0){var he=z[J].semver;if(he.major===H.major&&he.minor===H.minor&&he.patch===H.patch)return!0}return!1}return!0}function Ce(z,H,J){try{H=new se(H,J)}catch{return!1}return H.test(z)}function Ne(z,H,J,he){var pe,Oe,Se,Le,Pe;switch(z=new P(z,he),H=new se(H,he),J){case">":pe=$,Oe=ve,Se=G,Le=">",Pe=">=";break;case"<":pe=G,Oe=ge,Se=$,Le="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(z,H,he))return!1;for(var De=0;De<H.set.length;++De){var Fe=H.set[De],Re=null,Te=null;if(Fe.forEach(function(Me){Me.semver===we&&(Me=new ce(">=0.0.0")),Re=Re||Me,Te=Te||Me,pe(Me.semver,Re.semver,he)?Re=Me:Se(Me.semver,Te.semver,he)&&(Te=Me)}),Re.operator===Le||Re.operator===Pe||(!Te.operator||Te.operator===Le)&&Oe(z,Te.semver)||Te.operator===Pe&&Se(z,Te.semver))return!1}return!0}ce.prototype.parse=function(z){var H=this.loose?S[me]:S[B],J=z.match(H);if(!J)throw new TypeError("Invalid comparator: "+z);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new P(J[2],this.loose):this.semver=we},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(z){return R("Comparator.test",z,this.loose),this.semver===we||(typeof z=="string"&&(z=new P(z,this.loose)),le(z,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(z,H){if(!(z instanceof ce))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new se(z.value,H),Ce(this.value,J,H);if(z.operator==="")return J=new se(this.value,H),Ce(z.semver,J,H);var he=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Oe=this.semver.version===z.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Le=le(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Pe=le(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return he||pe||Oe&&Se||Le||Pe},e.Range=se,se.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},se.prototype.toString=function(){return this.range},se.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),R("range",z,H);var J=H?S[V]:S[M];z=z.replace(J,be),R("hyphen replace",z),z=z.replace(S[j],"$1$2$3"),R("comparator trim",z,S[j]),z=(z=(z=z.replace(S[X],"$1~")).replace(S[ae],"$1^")).split(/\s+/).join(" ");var he=H?S[me]:S[B],pe=z.split(" ").map(function(Oe){return function(Se,Le){return R("comp",Se),Se=function(Pe,De){return Pe.trim().split(/\s+/).map(function(Fe){return function(Re,Te){R("caret",Re,Te);var Me=Te?S[re]:S[fe];return Re.replace(Me,function(Ue,Ee,ye,Ie,ke){var Ae;return R("caret",Re,Ue,Ee,ye,Ie,ke),ue(Ee)?Ae="":ue(ye)?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ue(Ie)?Ae=Ee==="0"?">="+Ee+"."+ye+".0 <"+Ee+"."+(+ye+1)+".0":">="+Ee+"."+ye+".0 <"+(+Ee+1)+".0.0":ke?(R("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=Ee==="0"?ye==="0"?">="+Ee+"."+ye+"."+Ie+ke+" <"+Ee+"."+ye+"."+(+Ie+1):">="+Ee+"."+ye+"."+Ie+ke+" <"+Ee+"."+(+ye+1)+".0":">="+Ee+"."+ye+"."+Ie+ke+" <"+(+Ee+1)+".0.0"):(R("no pr"),Ae=Ee==="0"?ye==="0"?">="+Ee+"."+ye+"."+Ie+" <"+Ee+"."+ye+"."+(+Ie+1):">="+Ee+"."+ye+"."+Ie+" <"+Ee+"."+(+ye+1)+".0":">="+Ee+"."+ye+"."+Ie+" <"+(+Ee+1)+".0.0"),R("caret return",Ae),Ae})}(Fe,De)}).join(" ")}(Se,Le),R("caret",Se),Se=function(Pe,De){return Pe.trim().split(/\s+/).map(function(Fe){return function(Re,Te){var Me=Te?S[ie]:S[ee];return Re.replace(Me,function(Ue,Ee,ye,Ie,ke){var Ae;return R("tilde",Re,Ue,Ee,ye,Ie,ke),ue(Ee)?Ae="":ue(ye)?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ue(Ie)?Ae=">="+Ee+"."+ye+".0 <"+Ee+"."+(+ye+1)+".0":ke?(R("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=">="+Ee+"."+ye+"."+Ie+ke+" <"+Ee+"."+(+ye+1)+".0"):Ae=">="+Ee+"."+ye+"."+Ie+" <"+Ee+"."+(+ye+1)+".0",R("tilde return",Ae),Ae})}(Fe,De)}).join(" ")}(Se,Le),R("tildes",Se),Se=function(Pe,De){return R("replaceXRanges",Pe,De),Pe.split(/\s+/).map(function(Fe){return function(Re,Te){Re=Re.trim();var Me=Te?S[A]:S[w];return Re.replace(Me,function(Ue,Ee,ye,Ie,ke,Ae){R("xRange",Re,Ue,Ee,ye,Ie,ke,Ae);var We=ue(ye),ze=We||ue(Ie),Be=ze||ue(ke);return Ee==="="&&Be&&(Ee=""),We?Ue=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Be?(ze&&(Ie=0),Be&&(ke=0),Ee===">"?(Ee=">=",ze?(ye=+ye+1,Ie=0,ke=0):Be&&(Ie=+Ie+1,ke=0)):Ee==="<="&&(Ee="<",ze?ye=+ye+1:Ie=+Ie+1),Ue=Ee+ye+"."+Ie+"."+ke):ze?Ue=">="+ye+".0.0 <"+(+ye+1)+".0.0":Be&&(Ue=">="+ye+"."+Ie+".0 <"+ye+"."+(+Ie+1)+".0"),R("xRange return",Ue),Ue})}(Fe,De)}).join(" ")}(Se,Le),R("xrange",Se),Se=function(Pe,De){return R("replaceStars",Pe,De),Pe.trim().replace(S[W],"")}(Se,Le),R("stars",Se),Se}(Oe,H)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Oe){return!!Oe.match(he)})),pe=pe.map(function(Oe){return new ce(Oe,H)})},se.prototype.intersects=function(z,H){if(!(z instanceof se))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(he){return z.set.some(function(pe){return pe.every(function(Oe){return he.intersects(Oe,H)})})})})},e.toComparators=function(z,H){return new se(z,H).set.map(function(J){return J.map(function(he){return he.value}).join(" ").trim().split(" ")})},se.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new P(z,this.loose));for(var H=0;H<this.set.length;H++)if(je(this.set[H],z))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(z,H,J){var he=null,pe=null;try{var Oe=new se(H,J)}catch{return null}return z.forEach(function(Se){Oe.test(Se)&&(he&&pe.compare(Se)!==-1||(pe=new P(he=Se,J)))}),he},e.minSatisfying=function(z,H,J){var he=null,pe=null;try{var Oe=new se(H,J)}catch{return null}return z.forEach(function(Se){Oe.test(Se)&&(he&&pe.compare(Se)!==1||(pe=new P(he=Se,J)))}),he},e.validRange=function(z,H){try{return new se(z,H).range||"*"}catch{return null}},e.ltr=function(z,H,J){return Ne(z,H,"<",J)},e.gtr=function(z,H,J){return Ne(z,H,">",J)},e.outside=Ne,e.prerelease=function(z,H){var J=K(z,H);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(z,H,J){return z=new se(z,J),H=new se(H,J),z.intersects(H)},e.coerce=function(z){if(z instanceof P)return z;if(typeof z!="string")return null;var H=z.match(S[U]);return H==null?null:K((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,T(1))},function(x,e){var T,O,R=x.exports={};function D(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function S(f){if(T===setTimeout)return setTimeout(f,0);if((T===D||!T)&&setTimeout)return T=setTimeout,setTimeout(f,0);try{return T(f,0)}catch{try{return T.call(null,f,0)}catch{return T.call(this,f,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:D}catch{T=D}try{O=typeof clearTimeout=="function"?clearTimeout:N}catch{O=N}})();var h,u=[],v=!1,p=-1;function g(){v&&h&&(v=!1,h.length?u=h.concat(u):p=-1,u.length&&k())}function k(){if(!v){var f=S(g);v=!0;for(var c=u.length;c;){for(h=u,u=[];++p<c;)h&&h[p].run();p=-1,c=u.length}h=null,v=!1,function(m){if(O===clearTimeout)return clearTimeout(m);if((O===N||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(m);try{O(m)}catch{try{return O.call(null,m)}catch{return O.call(this,m)}}}(f)}}function E(f,c){this.fun=f,this.array=c}function L(){}R.nextTick=function(f){var c=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)c[m-1]=arguments[m];u.push(new E(f,c)),u.length!==1||v||S(k)},E.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=L,R.addListener=L,R.once=L,R.off=L,R.removeListener=L,R.removeAllListeners=L,R.emit=L,R.prependListener=L,R.prependOnceListener=L,R.listeners=function(f){return[]},R.binding=function(f){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(f){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Z[72],Q([0,1]),function(x,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(S,h,u){this.level=S,this.key=h,this.value=u,this.forward=[]}}const R=void 0;class D{constructor(S,h=2**16){this.comparator=S,this[T]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new O(this.c,R,R)}get size(){return this.f}clear(){this.e=new O(this.c,R,R)}has(S){return Boolean(D.g(this,S,this.comparator))}get(S){return D.g(this,S,this.comparator)?.value}set(S,h){return D.h(this,S,h,this.comparator)&&(this.f+=1),this}delete(S){const h=D.k(this,S,this.comparator);return h&&(this.f-=1),h}forEach(S,h){let u=this.e.forward[0];for(;u;)S.call(h,u.value,u.key,this),u=u.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",h=this.e.forward[0];for(;h;)S+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return S}static g(S,h,u){let v=S.e;for(let p=S.d-1;p>=0;p--)for(;v.forward[p]&&u(v.forward[p].key,h)<0;)v=v.forward[p];if(v=v.forward[0],v&&u(v.key,h)===0)return v}static h(S,h,u,v){const p=[];let g=S.e;for(let k=S.d-1;k>=0;k--){for(;g.forward[k]&&v(g.forward[k].key,h)<0;)g=g.forward[k];p[k]=g}if(g=g.forward[0],g&&v(g.key,h)===0)return g.value=u,!1;{const k=D.j(S);if(k>S.d){for(let E=S.d;E<k;E++)p[E]=S.e;S.d=k}g=new O(k,h,u);for(let E=0;E<k;E++)g.forward[E]=p[E].forward[E],p[E].forward[E]=g;return!0}}static j(S,h=.5){let u=1;for(;Math.random()<h&&u<S.c;)u+=1;return u}static k(S,h,u){const v=[];let p=S.e;for(let g=S.d-1;g>=0;g--){for(;p.forward[g]&&u(p.forward[g].key,h)<0;)p=p.forward[g];v[g]=p}if(p=p.forward[0],!p||u(p.key,h)!==0)return!1;for(let g=0;g<S.d&&v[g].forward[g]===p;g++)v[g].forward[g]=p.forward[g];for(;S.d>0&&S.e.forward[S.d-1]===R;)S.d-=1;return!0}}e.SkipList=D}),define(Z[43],Q([0,1,6,2]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(d){const y=d;return y?typeof y.read=="function":!1}e.isReadable=R;function D(d){const y=d;return y?[y.on,y.pause,y.resume,y.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=D;function N(d){const y=d;return y?D(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}e.isReadableBufferedStream=N;function S(d,y){return new h(d,y)}e.newWriteableStream=S;class h{constructor(y,t){this.e=y,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(y){if(!this.a.destroyed){if(this.a.flowing)this.g(y);else if(this.b.data.push(y),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(y){this.a.destroyed||(this.a.flowing?this.h(y):this.b.error.push(y))}end(y){this.a.destroyed||(typeof y<"u"&&this.write(y),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(y){this.c.data.slice(0).forEach(t=>t(y))}h(y){this.c.error.length===0?(0,T.onUnexpectedError)(y):this.c.error.slice(0).forEach(t=>t(y))}i(){this.c.end.slice(0).forEach(y=>y())}on(y,t){if(!this.a.destroyed)switch(y){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(y,t){if(this.a.destroyed)return;let o;switch(y){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const i=o.indexOf(t);i>=0&&o.splice(i,1)}}j(){if(this.b.data.length>0){const y=this.e(this.b.data);this.g(y),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const y of this.b.error)this.h(y);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(d,y){const t=[];let o;for(;(o=d.read())!==null;)t.push(o);return y(t)}e.consumeReadable=u;function v(d,y,t){const o=[];let i;for(;(i=d.read())!==null&&o.length<t;)o.push(i);return i===null&&o.length>0?y(o):{read:()=>{if(o.length>0)return o.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return d.read()}}}e.peekReadable=v;function p(d,y){return new Promise((t,o)=>{const i=[];g(d,{onData:n=>{y&&i.push(n)},onError:n=>{y?o(n):t(void 0)},onEnd:()=>{t(y?y(i):void 0)}})})}e.consumeStream=p;function g(d,y){let t=!1;return d.on("error",o=>{t||y.onError(o)}),d.on("end",()=>{t||y.onEnd()}),d.on("data",o=>{t||y.onData(o)}),(0,O.toDisposable)(()=>t=!0)}e.listenStream=g;function k(d,y){return new Promise((t,o)=>{const i=new O.DisposableStore,n=[],r=l=>{if(n.push(l),n.length>y)return i.dispose(),d.pause(),t({stream:d,buffer:n,ended:!1})},a=l=>o(l),s=()=>t({stream:d,buffer:n,ended:!0});i.add((0,O.toDisposable)(()=>d.removeListener("error",a))),d.on("error",a),i.add((0,O.toDisposable)(()=>d.removeListener("end",s))),d.on("end",s),i.add((0,O.toDisposable)(()=>d.removeListener("data",r))),d.on("data",r)})}e.peekStream=k;function E(d,y){const t=S(y);return t.end(d),t}e.toStream=E;function L(){const d=S(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=L;function f(d){let y=!1;return{read:()=>y?null:(y=!0,d)}}e.toReadable=f;function c(d,y,t){const o=S(t);return g(d,{onData:i=>o.write(y.data(i)),onError:i=>o.error(y.error?y.error(i):i),onEnd:()=>o.end()}),o}e.transform=c;function m(d,y,t){let o=!1;return{read:()=>{const i=y.read();return o?i:(o=!0,i!==null?t([d,i]):d)}}}e.prefixedReadable=m;function b(d,y,t){let o=!1;const i=S(t);return g(y,{onData:n=>o?i.write(n):(o=!0,i.write(t([d,n]))),onError:n=>i.error(n),onEnd:()=>{o||(o=!0,i.write(d)),i.end()}}),i}e.prefixedStream=b}),define(Z[15],Q([0,1,43]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const O=typeof Buffer<"u";let R,D;class N{static alloc(l){return O?new N(Buffer.allocUnsafe(l)):new N(new Uint8Array(l))}static wrap(l){return O&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new N(l)}static fromString(l,w){return!(w?.dontUseNodeBuffer||!1)&&O?new N(Buffer.from(l)):(R||(R=new TextEncoder),new N(R.encode(l)))}static fromByteArray(l){const w=N.alloc(l.length);for(let A=0,U=l.length;A<U;A++)w.buffer[A]=l[A];return w}static concat(l,w){if(typeof w>"u"){w=0;for(let Y=0,X=l.length;Y<X;Y++)w+=l[Y].byteLength}const A=N.alloc(w);let U=0;for(let Y=0,X=l.length;Y<X;Y++){const ee=l[Y];A.set(ee,U),U+=ee.byteLength}return A}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=N.alloc(this.byteLength);return l.set(this),l}toString(){return O?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(l,w){return new N(this.buffer.subarray(l,w))}set(l,w){if(l instanceof N)this.buffer.set(l.buffer,w);else if(l instanceof Uint8Array)this.buffer.set(l,w);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),w);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return u(this.buffer,l)}writeUInt32BE(l,w){v(this.buffer,l,w)}readUInt32LE(l){return p(this.buffer,l)}writeUInt32LE(l,w){g(this.buffer,l,w)}readUInt8(l){return k(this.buffer,l)}writeUInt8(l,w){E(this.buffer,l,w)}}e.VSBuffer=N;function S(s,l){return s[l+0]<<0>>>0|s[l+1]<<8>>>0}e.readUInt16LE=S;function h(s,l,w){s[w+0]=l&255,l=l>>>8,s[w+1]=l&255}e.writeUInt16LE=h;function u(s,l){return s[l]*2**24+s[l+1]*2**16+s[l+2]*2**8+s[l+3]}e.readUInt32BE=u;function v(s,l,w){s[w+3]=l,l=l>>>8,s[w+2]=l,l=l>>>8,s[w+1]=l,l=l>>>8,s[w]=l}e.writeUInt32BE=v;function p(s,l){return s[l+0]<<0>>>0|s[l+1]<<8>>>0|s[l+2]<<16>>>0|s[l+3]<<24>>>0}e.readUInt32LE=p;function g(s,l,w){s[w+0]=l&255,l=l>>>8,s[w+1]=l&255,l=l>>>8,s[w+2]=l&255,l=l>>>8,s[w+3]=l&255}e.writeUInt32LE=g;function k(s,l){return s[l]}e.readUInt8=k;function E(s,l,w){s[w]=l}e.writeUInt8=E;function L(s){return T.consumeReadable(s,l=>N.concat(l))}e.readableToBuffer=L;function f(s){return T.toReadable(s)}e.bufferToReadable=f;function c(s){return T.consumeStream(s,l=>N.concat(l))}e.streamToBuffer=c;async function m(s){return s.ended?N.concat(s.buffer):N.concat([...s.buffer,await c(s.stream)])}e.bufferedStreamToBuffer=m;function b(s){return T.toStream(s,l=>N.concat(l))}e.bufferToStream=b;function d(s){return T.transform(s,{data:l=>typeof l=="string"?N.fromString(l):N.wrap(l)},l=>N.concat(l))}e.streamToBufferReadableStream=d;function y(s){return T.newWriteableStream(l=>N.concat(l),s)}e.newWriteableBufferStream=y;function t(s,l){return T.prefixedReadable(s,l,w=>N.concat(w))}e.prefixedBufferReadable=t;function o(s,l){return T.prefixedStream(s,l,w=>N.concat(w))}e.prefixedBufferStream=o;function i(s){let l=0,w=0,A=0;const U=new Uint8Array(Math.floor(s.length/4*3)),Y=ee=>{switch(w){case 3:U[A++]=l|ee,w=0;break;case 2:U[A++]=l|ee>>>2,l=ee<<6,w=3;break;case 1:U[A++]=l|ee>>>4,l=ee<<4,w=2;break;default:l=ee<<2,w=1}};for(let ee=0;ee<s.length;ee++){const ie=s.charCodeAt(ee);if(ie>=65&&ie<=90)Y(ie-65);else if(ie>=97&&ie<=122)Y(ie-97+26);else if(ie>=48&&ie<=57)Y(ie-48+52);else if(ie===43||ie===45)Y(62);else if(ie===47||ie===95)Y(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${s[ee]}`)}}const X=A;for(;w>0;)Y(0);return N.wrap(U).slice(0,X)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:s},l=!0,w=!1){const A=w?r:n;let U="";const Y=s.byteLength%3;let X=0;for(;X<s.byteLength-Y;X+=3){const ee=s[X+0],ie=s[X+1],ne=s[X+2];U+=A[ee>>>2],U+=A[(ee<<4|ie>>>4)&63],U+=A[(ie<<2|ne>>>6)&63],U+=A[ne&63]}if(Y===1){const ee=s[X+0];U+=A[ee>>>2],U+=A[ee<<4&63],l&&(U+="==")}else if(Y===2){const ee=s[X+0],ie=s[X+1];U+=A[ee>>>2],U+=A[(ee<<4|ie>>>4)&63],U+=A[ie<<2&63],l&&(U+="=")}return U}e.encodeBase64=a}),define(Z[30],Q([0,1,4]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const m=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([b,d])=>{m[b]=d&&typeof d=="object"?O(d):d}),m}e.deepClone=O;function R(c){if(!c||typeof c!="object")return c;const m=[c];for(;m.length>0;){const b=m.shift();Object.freeze(b);for(const d in b)if(D.call(b,d)){const y=b[d];typeof y=="object"&&!Object.isFrozen(y)&&!(0,T.isTypedArray)(y)&&m.push(y)}}return c}e.deepFreeze=R;const D=Object.prototype.hasOwnProperty;function N(c,m){return S(c,m,new Set)}e.cloneAndChange=N;function S(c,m,b){if((0,T.isUndefinedOrNull)(c))return c;const d=m(c);if(typeof d<"u")return d;if(Array.isArray(c)){const y=[];for(const t of c)y.push(S(t,m,b));return y}if((0,T.isObject)(c)){if(b.has(c))throw new Error("Cannot clone recursive data-structure");b.add(c);const y={};for(const t in c)D.call(c,t)&&(y[t]=S(c[t],m,b));return b.delete(c),y}return c}function h(c,m,b=!0){return(0,T.isObject)(c)?((0,T.isObject)(m)&&Object.keys(m).forEach(d=>{d in c?b&&((0,T.isObject)(c[d])&&(0,T.isObject)(m[d])?h(c[d],m[d],b):c[d]=m[d]):c[d]=m[d]}),c):m}e.mixin=h;function u(c,m){if(c===m)return!0;if(c==null||m===null||m===void 0||typeof c!=typeof m||typeof c!="object"||Array.isArray(c)!==Array.isArray(m))return!1;let b,d;if(Array.isArray(c)){if(c.length!==m.length)return!1;for(b=0;b<c.length;b++)if(!u(c[b],m[b]))return!1}else{const y=[];for(d in c)y.push(d);y.sort();const t=[];for(d in m)t.push(d);if(t.sort(),!u(y,t))return!1;for(b=0;b<y.length;b++)if(!u(c[y[b]],m[y[b]]))return!1}return!0}e.equals=u;function v(c){const m=new Set;return JSON.stringify(c,(b,d)=>{if((0,T.isObject)(d)||Array.isArray(d)){if(m.has(d))return"[Circular]";m.add(d)}return d})}e.safeStringify=v;function p(c,m){const b=Object.create(null);return!c||!m||Object.keys(m).forEach(y=>{const t=c[y],o=m[y];u(t,o)||(b[y]=o)}),b}e.distinct=p;function g(c,m){const b=m.toLowerCase(),d=Object.keys(c).find(y=>y.toLowerCase()===b);return d?c[d]:c[m]}e.getCaseInsensitive=g;function k(c,m){const b=Object.create(null);for(const[d,y]of Object.entries(c))m(d,y)&&(b[d]=y);return b}e.filter=k;function E(c){let m=[],b=Object.getPrototypeOf(c);for(;Object.prototype!==b;)m=m.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return m}e.getAllPropertyNames=E;function L(c){const m=[];for(const b of E(c))typeof c[b]=="function"&&m.push(b);return m}e.getAllMethodNames=L;function f(c,m){const b=y=>function(){const t=Array.prototype.slice.call(arguments,0);return m(y,t)},d={};for(const y of c)d[y]=b(y);return d}e.createProxyObject=f}),define(Z[31],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(R){return T.test(R)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(S){for(let h=0;h<S.length;h++)S[h]=Math.floor(Math.random()*256);return S};const D=new Uint8Array(16),N=[];for(let S=0;S<256;S++)N.push(S.toString(16).padStart(2,"0"));return function(){R(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let h=0,u="";return u+=N[D[h++]],u+=N[D[h++]],u+=N[D[h++]],u+=N[D[h++]],u+="-",u+=N[D[h++]],u+=N[D[h++]],u+="-",u+=N[D[h++]],u+=N[D[h++]],u+="-",u+=N[D[h++]],u+=N[D[h++]],u+="-",u+=N[D[h++]],u+=N[D[h++]],u+=N[D[h++]],u+=N[D[h++]],u+=N[D[h++]],u+=N[D[h++]],u}}()}),define(Z[73],Q([0,1,33]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(N){const S=N.replace(/\-/g,":").toLowerCase();return!O.has(S)}function D(){const N=(0,T.networkInterfaces)();for(const S in N){const h=N[S];if(h){for(const{mac:u}of h)if(R(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=D}),define(Z[74],Q([7,8]),function(x,e){return x.create("vs/base/common/date",e)}),define(Z[75],Q([0,1,74]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,R=O*60,D=R*24,N=D*7,S=D*30,h=D*365;function u(p,g,k,E){typeof p!="number"&&(p=p.getTime());const L=Math.round((new Date().getTime()-p)/1e3);if(L<-30)return(0,T.localize)(0,null,u(new Date().getTime()+L*1e3,!1));if(!E&&L<30)return(0,T.localize)(1,null);let f;return L<O?(f=L,g?f===1?k?(0,T.localize)(2,null,f):(0,T.localize)(3,null,f):k?(0,T.localize)(4,null,f):(0,T.localize)(5,null,f):f===1?k?(0,T.localize)(6,null,f):(0,T.localize)(7,null,f):k?(0,T.localize)(8,null,f):(0,T.localize)(9,null,f)):L<R?(f=Math.floor(L/O),g?f===1?k?(0,T.localize)(10,null,f):(0,T.localize)(11,null,f):k?(0,T.localize)(12,null,f):(0,T.localize)(13,null,f):f===1?k?(0,T.localize)(14,null,f):(0,T.localize)(15,null,f):k?(0,T.localize)(16,null,f):(0,T.localize)(17,null,f)):L<D?(f=Math.floor(L/R),g?f===1?k?(0,T.localize)(18,null,f):(0,T.localize)(19,null,f):k?(0,T.localize)(20,null,f):(0,T.localize)(21,null,f):f===1?k?(0,T.localize)(22,null,f):(0,T.localize)(23,null,f):k?(0,T.localize)(24,null,f):(0,T.localize)(25,null,f)):L<N?(f=Math.floor(L/D),g?f===1?(0,T.localize)(26,null,f):(0,T.localize)(27,null,f):f===1?(0,T.localize)(28,null,f):(0,T.localize)(29,null,f)):L<S?(f=Math.floor(L/N),g?f===1?k?(0,T.localize)(30,null,f):(0,T.localize)(31,null,f):k?(0,T.localize)(32,null,f):(0,T.localize)(33,null,f):f===1?k?(0,T.localize)(34,null,f):(0,T.localize)(35,null,f):k?(0,T.localize)(36,null,f):(0,T.localize)(37,null,f)):L<h?(f=Math.floor(L/S),g?f===1?k?(0,T.localize)(38,null,f):(0,T.localize)(39,null,f):k?(0,T.localize)(40,null,f):(0,T.localize)(41,null,f):f===1?k?(0,T.localize)(42,null,f):(0,T.localize)(43,null,f):k?(0,T.localize)(44,null,f):(0,T.localize)(45,null,f)):(f=Math.floor(L/h),g?f===1?k?(0,T.localize)(46,null,f):(0,T.localize)(47,null,f):k?(0,T.localize)(48,null,f):(0,T.localize)(49,null,f):f===1?k?(0,T.localize)(50,null,f):(0,T.localize)(51,null,f):k?(0,T.localize)(52,null,f):(0,T.localize)(53,null,f))}e.fromNow=u;function v(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=v}),define(Z[76],Q([7,8]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(Z[34],Q([0,1,19,4,76]),function(x,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function D(p,g){return g&&(p.stack||p.stacktrace)?R.localize(0,null,S(p),N(p.stack)||N(p.stacktrace)):S(p)}function N(p){return Array.isArray(p)?p.join(`
`):p}function S(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?R.localize(1,null,p.message):p.message||R.localize(2,null)}function h(p=null,g=!1){if(!p)return R.localize(3,null);if(Array.isArray(p)){const k=T.coalesce(p),E=h(k[0],g);return k.length>1?R.localize(4,null,E,k.length):E}if(O.isString(p))return p;if(p.detail){const k=p.detail;if(k.error)return D(k.error,g);if(k.exception)return D(k.exception,g)}return p.stack?D(p,g):p.message?p.message:R.localize(5,null)}e.toErrorMessage=h;function u(p){const g=p;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=u;function v(p,g){let k;return typeof p=="string"?k=new Error(p):k=p,k.actions=g,k}e.createErrorWithActions=v}),define(Z[77],Q([7,8]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(Z[78],Q([0,1,77]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(R){switch(R){case 1:return(0,T.localize)(0,null);case 2:return(0,T.localize)(1,null);case 3:return(0,T.localize)(2,null);case 4:return(0,T.localize)(3,null);case 5:return(0,T.localize)(4,null);case 6:return(0,T.localize)(5,null);case 7:return(0,T.localize)(6,null);case 8:return(0,T.localize)(7,null);case 9:return(0,T.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(Z[51],Q([0,1,12]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(O=e.Source||(e.Source={}));var R;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(S,...h){const u=h.reduce((g,k)=>(g[k]=!0,g),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(g=>!u[g]).forEach(g=>{for(let k=0;k<v.length;k++)if(g.search(v[k])!==-1){delete S[g];break}})}e.sanitizeProcessEnvironment=D;function N(S){!S||(delete S.DEBUG,T.isMacintosh&&delete S.DYLD_LIBRARY_PATH,T.isLinux&&delete S.LD_PRELOAD)}e.removeDangerousEnvVariables=N}),define(Z[52],Q([0,1,32]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(c){return R(c,0)}e.hash=O;function R(c,m){switch(typeof c){case"object":return c===null?D(349,m):Array.isArray(c)?h(c,m):u(c,m);case"string":return S(c,m);case"boolean":return N(c,m);case"number":return D(c,m);case"undefined":return D(937,m);default:return D(617,m)}}e.doHash=R;function D(c,m){return(m<<5)-m+c|0}e.numberHash=D;function N(c,m){return D(c?433:863,m)}function S(c,m){m=D(149417,m);for(let b=0,d=c.length;b<d;b++)m=D(c.charCodeAt(b),m);return m}e.stringHash=S;function h(c,m){return m=D(104579,m),c.reduce((b,d)=>R(d,b),m)}function u(c,m){return m=D(181387,m),Object.keys(c).sort().reduce((b,d)=>(b=S(d,b),R(c[d],b)),m)}class v{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=R(m,this.g),this.g}}e.Hasher=v;var p;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function g(c,m,b=32){const d=b-m,y=~((1<<d)-1);return(c<<m|(y&c)>>>d)>>>0}function k(c,m=0,b=c.byteLength,d=0){for(let y=0;y<b;y++)c[m+y]=d}function E(c,m,b="0"){for(;c.length<m;)c=b+c;return c}function L(c,m=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(b=>b.toString(16).padStart(2,"0")).join(""):E((c>>>0).toString(16),m/4)}e.toHexString=L;class f{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const b=m.length;if(b===0)return;const d=this.p;let y=this.r,t=this.u,o,i;for(t!==0?(o=t,i=-1,t=0):(o=m.charCodeAt(0),i=0);;){let n=o;if(T.isHighSurrogate(o))if(i+1<b){const r=m.charCodeAt(i+1);T.isLowSurrogate(r)?(i++,n=T.computeCodePoint(o,r)):n=65533}else{t=o;break}else T.isLowSurrogate(o)&&(n=65533);if(y=this.w(d,y,n),i++,i<b)o=m.charCodeAt(i);else break}this.r=y,this.u=t}w(m,b,d){return d<128?m[b++]=d:d<2048?(m[b++]=192|(d&1984)>>>6,m[b++]=128|(d&63)>>>0):d<65536?(m[b++]=224|(d&61440)>>>12,m[b++]=128|(d&4032)>>>6,m[b++]=128|(d&63)>>>0):(m[b++]=240|(d&1835008)>>>18,m[b++]=128|(d&258048)>>>12,m[b++]=128|(d&4032)>>>6,m[b++]=128|(d&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),L(this.h)+L(this.l)+L(this.m)+L(this.n)+L(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=f.g,b=this.q;for(let s=0;s<64;s+=4)m.setUint32(s,b.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)m.setUint32(s,g(m.getUint32(s-12,!1)^m.getUint32(s-32,!1)^m.getUint32(s-56,!1)^m.getUint32(s-64,!1),1),!1);let d=this.h,y=this.l,t=this.m,o=this.n,i=this.o,n,r,a;for(let s=0;s<80;s++)s<20?(n=y&t|~y&o,r=1518500249):s<40?(n=y^t^o,r=1859775393):s<60?(n=y&t|y&o|t&o,r=2400959708):(n=y^t^o,r=3395469782),a=g(d,5)+n+i+r+m.getUint32(s*4,!1)&4294967295,i=o,o=t,t=g(y,30),y=d,d=a;this.h=this.h+d&4294967295,this.l=this.l+y&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=f,f.g=new DataView(new ArrayBuffer(320))}),define(Z[53],Q([0,1,32]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(O||(O={})),function(R){const D="error",N="warning",S="warn",h="info",u="ignore";function v(g){return g?T.equalsIgnoreCase(D,g)?R.Error:T.equalsIgnoreCase(N,g)||T.equalsIgnoreCase(S,g)?R.Warning:T.equalsIgnoreCase(h,g)?R.Info:R.Ignore:R.Ignore}R.fromValue=v;function p(g){switch(g){case R.Error:return D;case R.Warning:return N;case R.Info:return h;default:return u}}R.toString=p}(O||(O={})),e.default=O}),define(Z[79],Q([0,1,11]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(u){const v=u;return v&&typeof v.type=="string"&&typeof v.severity=="string"}e.isRemoteConsoleLog=O;function R(u){const v=[];let p;try{const g=JSON.parse(u.arguments),k=g[g.length-1];k&&k.__$stack&&(g.pop(),p=k.__$stack),v.push(...g)}catch{v.push("Unable to log remote console arguments",u.arguments)}return{args:v,stack:p}}e.parse=R;function D(u){if(typeof u!="string")return D(R(u).stack);const v=u;if(v){const p=N(v),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(g&&g.length===4)return{uri:T.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=D;function N(u){if(!u)return u;const v=u.indexOf(`
`);return v===-1?u:u.substring(0,v)}function S(u,v){const{args:p,stack:g}=R(u),k=typeof p[0]=="string"&&p.length===1;let E=N(g);E&&(E=`(${E.trim()})`);let L=[];if(typeof p[0]=="string"?E&&k?L=[`%c[${v}] %c${p[0]} %c${E}`,h("blue"),h(""),h("grey")]:L=[`%c[${v}] %c${p[0]}`,h("blue"),h(""),...p.slice(1)]:L=[`%c[${v}]%`,h("blue"),...p],E&&!k&&L.push(E),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,L)}e.log=S;function h(u){return`color: ${u}`}}),define(Z[44],Q([0,1,15,32,11]),function(x,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(u){return JSON.stringify(u,S)}e.stringify=D;function N(u){let v=JSON.parse(u);return v=h(v),v}e.parse=N;function S(u,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:(0,O.regExpFlags)(v)}:v}function h(u,v=0){if(!u||v>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return R.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof T.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let p=0;p<u.length;++p)u[p]=h(u[p],v+1);else for(const p in u)Object.hasOwnProperty.call(u,p)&&(u[p]=h(u[p],v+1))}return u}e.revive=h}),define(Z[80],Q([0,1,33,6,54,31,73]),function(x,e,T,O,R,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(v){return this.a||(this.a=R.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(v)}value(){if(this.b===void 0){let v=0,p=0;const g=(0,T.networkInterfaces)();for(const k in g){const E=g[k];if(E)for(const{mac:L,internal:f}of E)f||(p+=1,this.c(L.toUpperCase())&&(v+=1))}this.b=p>0?v/p:0}return this.b}};let S;async function h(){return S||(S=(async()=>await u()||D.generateUuid())()),S}e.getMachineId=h;async function u(){try{const v=await new Promise((g,k)=>{x(["crypto"],g,k)}),p=(0,N.getMac)();return v.createHash("sha256").update(p,"utf8").digest("hex")}catch(v){O.onUnexpectedError(v);return}}}),define(Z[81],Q([0,1,33,14,20]),function(x,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,N=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var h;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(h||(h={}));let u;switch(process.arch){case"ia32":case"x32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=1:v=0;class p{constructor(y,t,o){this.exePath=y,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:d=!1}={}){return d?u===0?process.env["ProgramFiles(x86)"]||null:v===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function k({useAlternateBitness:d=!1,findPreview:y=!1}={}){const t=g({useAlternateBitness:d});if(!t)return null;const o=O.join(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(o))return null;let i=-1,n=null;for(const s of await R.Promises.readdir(o)){let l=-1;if(y){const A=s.indexOf("-");if(A<0)continue;const U=s.substring(0,A);if(!D.test(U)||s.substring(A+1)!=="preview")continue;l=parseInt(U,10)}else{if(!D.test(s))continue;l=parseInt(s,10)}if(l<=i)continue;const w=O.join(o,s,"pwsh.exe");!await R.SymlinkSupport.existsFile(w)||(n=w,i=l)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",a=y?" Preview":"";return new p(n,`PowerShell${a}${r}`,!0)}async function E({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const y=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(y))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=d?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const i of await R.Promises.readdir(y))if(t.test(i)){const n=O.join(y,i,"pwsh.exe");return new p(n,o)}return null}function L(){const d=O.join(T.homedir(),".dotnet","tools","pwsh.exe");return new p(d,".NET Core PowerShell Global Tool")}function f(){const d=O.join(process.env.windir,u===1&&v!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(d,"Windows PowerShell",!0)}async function*c(){let d=await k();d&&(yield d),d=await k({useAlternateBitness:!0}),d&&(yield d),d=await E(),d&&(yield d),d=L(),d&&(yield d),d=await k({findPreview:!0}),d&&(yield d),d=await E({findPreview:!0}),d&&(yield d),d=await k({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=f(),d&&(yield d)}async function*m(){for await(const d of c())await d.exists()&&(yield d)}e.enumeratePowerShellInstallations=m;async function b(){for await(const d of m())return d;return null}e.getFirstAvailablePowerShellInstallation=b}),define(Z[55],Q([0,1,14,12,35,51,4,20]),function(x,e,T,O,R,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function h(p=R.env){return p.comspec||"cmd.exe"}e.getWindowsShell=h;function u(p){let g=[],k=!1;const E=function(L){if(k){g.push(L);return}(!p.send(L,c=>{if(c&&console.error(c),k=!1,g.length>0){const m=g.slice(0);g=[],m.forEach(b=>E(b))}})||O.isWindows)&&(k=!0)};return{send:E}}e.createQueuedSender=u;var v;(function(p){async function g(k,E,L){if(T.isAbsolute(k))return k;if(E===void 0&&(E=R.cwd()),T.dirname(k)!=="."||(L===void 0&&N.isString(R.env.PATH)&&(L=R.env.PATH.split(T.delimiter)),L===void 0||L.length===0))return T.join(E,k);async function c(m){if(await S.Promises.exists(m)){let b;try{b=await S.Promises.stat(m)}catch(d){d.message.startsWith("EACCES")&&(b=await S.Promises.lstat(m))}return b?!b.isDirectory():!1}return!1}for(const m of L){let b;if(T.isAbsolute(m)?b=T.join(m,k):b=T.join(E,m,k),await c(b))return b;let d=b+".com";if(await c(d)||(d=b+".exe",await c(d)))return d}return T.join(E,k)}p.findExecutable=g})(v=e.win32||(e.win32={}))}),define(Z[82],Q([0,1,33,12,81,55]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function N(p,g){return p===1?O.isWindows?v():D.getWindowsShell(g):h(p,g)}e.getSystemShell=N;let S=null;function h(p,g){if(O.isLinux&&p===2||O.isMacintosh&&p===3)return"/bin/bash";if(!S){let k;if(O.isWindows)k="/bin/bash";else{if(k=g.SHELL,!k)try{k=(0,T.userInfo)().shell}catch{}k||(k="sh"),k==="/bin/false"&&(k="/bin/bash")}S=k}return S}let u=null;async function v(){return u||(u=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),u}});var de=this&&this.__decorate||function(x,e,T,O){var R=arguments.length,D=R<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,T):O,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(x,e,T,O);else for(var S=x.length-1;S>=0;S--)(N=x[S])&&(D=(R<3?N(D):R>3?N(e,T,D):N(e,T))||D);return R>3&&D&&Object.defineProperty(e,T,D),D};define(Z[56],Q([0,1,19,5,15,22,49,6,3,2,44,32,4]),function(x,e,T,O,R,D,N,S,h,u,v,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var k;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(k||(k={}));function E(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var L;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(L||(L={}));function f(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(c||(c={}));function m(j){let M=0;for(let V=0;;V+=7){const W=j.read(1);if(M|=(W.buffer[0]&127)<<V,!(W.buffer[0]&128))return M}}const b=i(0);function d(j,M){if(M===0){j.write(b);return}let V=0;for(let q=M;q!==0;q=q>>>7)V++;const W=R.VSBuffer.alloc(V);for(let q=0;M!==0;q++)W.buffer[q]=M&127,M=M>>>7,M>0&&(W.buffer[q]|=128);j.write(W)}class y{constructor(M){this.b=M,this.a=0}read(M){const V=this.b.slice(this.a,this.a+M);return this.a+=V.byteLength,V}}e.BufferReader=y;class t{constructor(){this.a=[]}get buffer(){return R.VSBuffer.concat(this.a)}write(M){this.a.push(M)}}e.BufferWriter=t;var o;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(o||(o={}));function i(j){const M=R.VSBuffer.alloc(1);return M.writeUInt8(j,0),M}const n={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object),Uint:i(o.Int)},r=typeof Buffer<"u";function a(j,M){if(typeof M>"u")j.write(n.Undefined);else if(typeof M=="string"){const V=R.VSBuffer.fromString(M);j.write(n.String),d(j,V.byteLength),j.write(V)}else if(r&&Buffer.isBuffer(M)){const V=R.VSBuffer.wrap(M);j.write(n.Buffer),d(j,V.byteLength),j.write(V)}else if(M instanceof R.VSBuffer)j.write(n.VSBuffer),d(j,M.byteLength),j.write(M);else if(Array.isArray(M)){j.write(n.Array),d(j,M.length);for(const V of M)a(j,V)}else if(typeof M=="number"&&(M|0)===M)j.write(n.Uint),d(j,M);else{const V=R.VSBuffer.fromString(JSON.stringify(M));j.write(n.Object),d(j,V.byteLength),j.write(V)}}e.serialize=a;function s(j){switch(j.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return j.read(m(j)).toString();case o.Buffer:return j.read(m(j)).buffer;case o.VSBuffer:return j.read(m(j));case o.Array:{const V=m(j),W=[];for(let q=0;q<V;q++)W.push(s(j));return W}case o.Object:return JSON.parse(j.read(m(j)).toString());case o.Int:return m(j)}}e.deserialize=s;class l{constructor(M,V,W=null,q=1e3){this.h=M,this.j=V,this.k=W,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(M,V){this.b.set(M,V),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const V=this.o([M.type]);this.k?.logOutgoing(V,0,1,f(M.type));return}case 201:case 202:case 204:case 203:{const V=this.o([M.type,M.id],M.data);this.k?.logOutgoing(V,M.id,1,f(M.type),M.data);return}}}o(M,V=void 0){const W=new t;return a(W,M),a(W,V),this.p(W.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const V=new y(M),W=s(V),q=s(V),K=W[0];switch(K){case 100:return this.k?.logIncoming(M.byteLength,W[1],1,`${E(K)}: ${W[2]}.${W[3]}`,q),this.s({type:K,id:W[1],channelName:W[2],name:W[3],arg:q});case 102:return this.k?.logIncoming(M.byteLength,W[1],1,`${E(K)}: ${W[2]}.${W[3]}`,q),this.t({type:K,id:W[1],channelName:W[2],name:W[3],arg:q});case 101:return this.k?.logIncoming(M.byteLength,W[1],1,`${E(K)}`),this.u({type:K,id:W[1]});case 103:return this.k?.logIncoming(M.byteLength,W[1],1,`${E(K)}`),this.u({type:K,id:W[1]})}}s(M){const V=this.b.get(M.channelName);if(!V){this.v(M);return}const W=new D.CancellationTokenSource;let q;try{q=V.call(this.j,M.name,M.arg,W.token)}catch(I){q=Promise.reject(I)}const K=M.id;q.then(I=>{this.m({id:K,data:I,type:201}),this.d.delete(M.id)},I=>{I instanceof Error?this.m({id:K,data:{message:I.message,name:I.name,stack:I.stack?I.stack.split?I.stack.split(`
`):I.stack:void 0},type:202}):this.m({id:K,data:I,type:203}),this.d.delete(M.id)});const P=(0,u.toDisposable)(()=>W.cancel());this.d.set(M.id,P)}t(M){const V=this.b.get(M.channelName);if(!V){this.v(M);return}const W=M.id,K=V.listen(this.j,M.name,M.arg)(P=>this.m({id:W,data:P,type:204}));this.d.set(M.id,K)}u(M){const V=this.d.get(M.id);V&&(V.dispose(),this.d.delete(M.id))}v(M){let V=this.g.get(M.channelName);V||(V=[],this.g.set(M.channelName,V));const W=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:M,timeoutTimer:W})}w(M){const V=this.g.get(M);if(V){for(const W of V)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.s(W.request);break;case 102:this.t(W.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=l;var w;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(M,V=null){this.l=M,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(W=>this.s(W)),this.j=V}getChannel(M){const V=this;return{call(W,q,K){return V.a?Promise.reject(new S.CancellationError):V.m(M,W,q,K)},listen(W,q){return V.a?h.Event.None:V.o(M,W,q)}}}m(M,V,W,q=D.CancellationToken.None){const K=this.g++,I={id:K,type:100,channelName:M,name:V,arg:W};if(q.isCancellationRequested)return Promise.reject(new S.CancellationError);let C;return new Promise(($,G)=>{if(q.isCancellationRequested)return G(new S.CancellationError);const te=()=>{const le=ce=>{switch(ce.type){case 201:this.f.delete(K),$(ce.data);break;case 202:{this.f.delete(K);const we=new Error(ce.data.message);we.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,we.name=ce.data.name,G(we);break}case 203:this.f.delete(K),G(ce.data);break}};this.f.set(K,le),this.p(I)};let oe=null;this.b===c.Idle?te():(oe=(0,O.createCancelablePromise)(le=>this.u()),oe.then(()=>{oe=null,te()}));const ge=()=>{oe?(oe.cancel(),oe=null):this.p({id:K,type:101}),G(new S.CancellationError)},ve=q.onCancellationRequested(ge);C=(0,u.combinedDisposable)((0,u.toDisposable)(ge),ve),this.d.add(C)}).finally(()=>{this.d.delete(C)})}o(M,V,W){const q=this.g++,P={id:q,type:102,channelName:M,name:V,arg:W};let I=null;const C=new h.Emitter({onWillAddFirstListener:()=>{I=(0,O.createCancelablePromise)($=>this.u()),I.then(()=>{I=null,this.d.add(C),this.p(P)})},onDidRemoveLastListener:()=>{I?(I.cancel(),I=null):(this.d.delete(C),this.p({id:q,type:103}))}}),F=$=>C.fire($.data);return this.f.set(q,F),C.event}p(M){switch(M.type){case 100:case 102:{const V=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(V,M.id,0,`${E(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const V=this.q([M.type,M.id]);this.j?.logOutgoing(V,M.id,0,E(M.type));return}}}q(M,V=void 0){const W=new t;return a(W,M),a(W,V),this.r(W.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const V=new y(M),W=s(V),q=s(V),K=W[0];switch(K){case 200:return this.j?.logIncoming(M.byteLength,0,0,f(K)),this.t({type:W[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,W[1],0,f(K),q),this.t({type:W[0],id:W[1],data:q})}}t(M){if(M.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.dispose)(this.d.values()),this.d.clear()}}de([N.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class U{get connections(){const M=[];return this.f.forEach(V=>M.push(V)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new h.Emitter,this.onDidAddConnection=this.g.event,this.h=new h.Emitter,this.onDidRemoveConnection=this.h.event,M(({protocol:V,onDidClientDisconnect:W})=>{h.Event.once(V.onMessage)(K=>{const P=new y(K),I=s(P),C=new l(V,I),F=new A(V);this.a.forEach((G,te)=>C.registerChannel(te,G));const $={channelServer:C,channelClient:F,ctx:I};this.f.add($),this.g.fire($),W(()=>{C.dispose(),F.dispose(),this.f.delete($),this.h.fire($)})})})}getChannel(M,V){const W=this;return{call(q,K,P){let I;if((0,g.isFunction)(V)){const F=(0,T.getRandomElement)(W.connections.filter(V));I=F?Promise.resolve(F):h.Event.toPromise(h.Event.filter(W.onDidAddConnection,V))}else I=V.routeCall(W,q,K);const C=I.then(F=>F.channelClient.getChannel(M));return X(C).call(q,K,P)},listen(q,K){if((0,g.isFunction)(V))return W.j(M,V,q,K);const P=V.routeEvent(W,q,K).then(I=>I.channelClient.getChannel(M));return X(P).listen(q,K)}}}j(M,V,W,q){const K=this;let P=new u.DisposableStore;const I=new h.Emitter({onWillAddFirstListener:()=>{P=new u.DisposableStore;const C=new h.EventMultiplexer,F=new Map,$=te=>{const ge=te.channelClient.getChannel(M).listen(W,q),ve=C.add(ge);F.set(te,ve)},G=te=>{const oe=F.get(te);!oe||(oe.dispose(),F.delete(te))};K.connections.filter(V).forEach($),h.Event.filter(K.onDidAddConnection,V)($,void 0,P),K.onDidRemoveConnection(G,void 0,P),C.event(I.fire,I,P),P.add(C)},onDidRemoveLastListener:()=>{P.dispose()}});return I.event}registerChannel(M,V){this.a.set(M,V),this.f.forEach(W=>{W.channelServer.registerChannel(M,V)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=U;class Y{constructor(M,V,W=null){const q=new t;a(q,V),M.send(q.buffer),this.a=new A(M,W),this.d=new l(M,V,W)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,V){this.d.registerChannel(M,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=Y;function X(j){return{call(M,V,W){return j.then(q=>q.call(M,V,W))},listen(M,V){const W=new h.Relay;return j.then(q=>W.input=q.listen(M,V)),W.event}}}e.getDelayedChannel=X;function ee(j){let M=!1;return{call(V,W,q){return M?j.call(V,W,q):(0,O.timeout)(0).then(()=>M=!0).then(()=>j.call(V,W,q))},listen(V,W){if(M)return j.listen(V,W);const q=new h.Relay;return(0,O.timeout)(0).then(()=>M=!0).then(()=>q.input=j.listen(V,W)),q.event}}}e.getNextTickChannel=ee;class ie{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const V of M.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await h.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.StaticRouter=ie;var ne;(function(j){function M(K,P){const I=K,C=P&&P.disableMarshalling,F=new Map;for(const $ in I)W($)&&F.set($,h.Event.buffer(I[$],!0));return new class{listen($,G,te){const oe=F.get(G);if(oe)return oe;if(q(G)){const ge=I[G];if(typeof ge=="function")return ge.call(I,te)}throw new Error(`Event not found: ${G}`)}call($,G,te){const oe=I[G];if(typeof oe=="function"){if(!C&&Array.isArray(te))for(let ge=0;ge<te.length;ge++)te[ge]=(0,v.revive)(te[ge]);return oe.apply(I,te)}throw new Error(`Method not found: ${G}`)}}}j.fromService=M;function V(K,P){const I=P&&P.disableMarshalling;return new Proxy({},{get(C,F){if(typeof F=="string")return P?.properties?.has(F)?P.properties.get(F):q(F)?function($){return K.listen(F,$)}:W(F)?K.listen(F):async function(...$){let G;P&&!(0,g.isUndefinedOrNull)(P.context)?G=[P.context,...$]:G=$;const te=await K.call(F,G);return I?te:(0,v.revive)(te)};throw new Error(`Property not found: ${String(F)}`)}})}j.toService=V;function W(K){return K[0]==="o"&&K[1]==="n"&&p.isUpperAsciiLetter(K.charCodeAt(2))}function q(K){return/^onDynamic/.test(K)&&p.isUpperAsciiLetter(K.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const M=j.toString();if(M!=="[object Object]")return M}return j}function re(j){return Array.isArray(j)?j.map(fe):fe(j)}function me(j,M,V,W,q,K,P){P=re(P);const I=ae[q],C=I[W%I.length];let F=[`%c[${j}]%c[${String(M).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(K)?(F=F.concat(P),F.push(")")):F.push(P),console.log.apply(console,F)}class B{constructor(M,V){this.d=M,this.f=V,this.a=0,this.b=0}logOutgoing(M,V,W,q,K){this.b+=M,me(this.d,this.b,M,V,W,q,K)}logIncoming(M,V,W,q,K){this.a+=M,me(this.f,this.a,M,V,W,q,K)}}e.IPCLogger=B}),define(Z[83],Q([0,1,57,5,15,22,79,6,3,2,30,55,51,56]),function(x,e,T,O,R,D,N,S,h,u,v,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class E extends k.ChannelServer{constructor(c){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",m=>R.VSBuffer.wrap(Buffer.from(m,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.Server=E;class L{constructor(c,m){this.i=c,this.j=m,this.c=new Set,this.g=new Map,this.h=new h.Emitter,this.onDidProcessExit=this.h.event;const b=m&&m.timeout?m.timeout:6e4;this.b=new O.Delayer(b),this.d=null,this.f=null}getChannel(c){const m=this;return{call(b,d,y){return m.k(c,b,d,y)},listen(b,d){return m.l(c,b,d)}}}k(c,m,b,d=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(S.canceled());this.b.cancel();const y=this.n(c),t=(0,O.createCancelablePromise)(n=>y.call(m,b,n)),o=d.onCancellationRequested(()=>t.cancel()),i=(0,u.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{o.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,m,b){if(!this.b)return h.Event.None;this.b.cancel();let d;const y=new h.Emitter({onWillAddFirstListener:()=>{d=this.n(c).listen(m,b)(y.fire,y),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return y.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,v.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,g.removeDangerousEnvVariables)(m.env),this.d=(0,T.fork)(this.i,c,m);const b=new h.Emitter;h.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,N.isRemoteConsoleLog)(r)){(0,N.log)(r,`IPC Library: ${this.j.serverName}`);return}b.fire(R.VSBuffer.wrap(Buffer.from(r,"base64")))});const y=this.j.useQueue?(0,p.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&y.send(r.buffer.toString("base64")),o=b.event,i={send:t,onMessage:o};this.f=new k.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,a)=>{process.removeListener("exit",n),this.c.forEach(s=>(0,u.dispose)(s)),this.c.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:a})})}return this.f}n(c){let m=this.g.get(c);return m||(m=this.m.getChannel(c),this.g.set(c,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=L}),define(Z[84],Q([0,1,5,3,2,4]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var N;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(N=e.StorageHint||(e.StorageHint={}));function S(p){const g=p;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=S;var h;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(h=e.StorageState||(e.StorageState={}));class u extends R.Disposable{constructor(g,k=Object.create(null)){super(),this.m=g,this.n=k,this.b=this.B(new O.Emitter),this.onDidChangeStorage=this.b.event,this.c=h.None,this.f=new Map,this.g=new T.ThrottledDelayer(u.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(g=>this.r(g)))}r(g){g.changed?.forEach((k,E)=>this.s(E,k)),g.deleted?.forEach(k=>this.s(k,void 0))}s(g,k){if(this.c===h.Closed)return;let E=!1;(0,D.isUndefinedOrNull)(k)?E=this.f.delete(g):this.f.get(g)!==k&&(this.f.set(g,k),E=!0),E&&this.b.fire(g)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===h.None&&(this.c=h.Initialized,this.n.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(g,k){const E=this.f.get(g);return(0,D.isUndefinedOrNull)(E)?k:E}getBoolean(g,k){const E=this.get(g);return(0,D.isUndefinedOrNull)(E)?k:E==="true"}getNumber(g,k){const E=this.get(g);return(0,D.isUndefinedOrNull)(E)?k:parseInt(E,10)}async set(g,k){if(this.c===h.Closed)return;if((0,D.isUndefinedOrNull)(k))return this.delete(g);const E=String(k);if(this.f.get(g)!==E)return this.f.set(g,E),this.j.set(g,E),this.h.delete(g),this.b.fire(g),this.w()}async delete(g){if(!(this.c===h.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire(g),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=h.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(g).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(g){if(!!this.u)return this.w(g)}async w(g){return this.g.trigger(()=>this.v(),g)}async whenFlushed(){if(!!this.u)return new Promise(g=>this.l.push(g))}isInMemory(){return this.n.hint===N.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=u,u.a=100;class v{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((k,E)=>this.a.set(E,k)),g.delete?.forEach(k=>this.a.delete(k))}async close(){}}e.InMemoryStorageDatabase=v}),define(Z[85],Q([7,8]),function(x,e){return x.create("vs/base/node/zip",e)}),define(Z[86],Q([7,8]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[87],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[88],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[89],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Z[90],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Z[91],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[92],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[93],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[94],Q([7,8]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[95],Q([7,8]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(Z[96],Q([7,8]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(Z[97],Q([7,8]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[98],Q([7,8]),function(x,e){return x.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Z[99],Q([7,8]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(Z[100],Q([7,8]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(Z[101],Q([7,8]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[102],Q([7,8]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[103],Q([7,8]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(Z[104],Q([0,1,75,49,16,14,35,18,11]),function(x,e,T,O,R,D,N,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,D.dirname)(R.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,S.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,S.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const E=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",E)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return h.URI.file((0,D.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.joinPath)(h.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=N.env.VSCODE_PORTABLE;return E?h.URI.file((0,D.join)(E,"argv.json")):(0,S.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const E=this.args["builtin-extensions-dir"];return E?(0,D.resolve)(E):(0,D.normalize)((0,D.join)(R.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const E=this.args["extensions-download-dir"];return E?h.URI.file((0,D.resolve)(E)):h.URI.file((0,D.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const E=this.args["extensions-dir"];if(E)return(0,D.resolve)(E);const L=N.env.VSCODE_EXTENSIONS;if(L)return L;const f=N.env.VSCODE_PORTABLE;return f?(0,D.join)(f,"extensions"):(0,S.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this.args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(L=>/^[^:/?#]+?:\/\//.test(L)?h.URI.parse(L):h.URI.file((0,D.normalize)(L)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const E=this.args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?h.URI.parse(E):h.URI.file((0,D.normalize)(E))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const E=this.args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(E=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(E))}get extensionLogLevel(){const E=[];for(const L of this.args.log||[]){const f=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(L);f&&f[1]&&f[2]&&E.push([f[1],f[2]])}return E.length?E:void 0}get serviceMachineIdResource(){return(0,S.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return h.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const E=N.env.VSCODE_PORTABLE;return E?h.URI.file((0,D.join)(E,"policy.json")):(0,S.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(E){this.args.continueOn=E}get args(){return this.a}constructor(E,L,f){this.a=E,this.b=L,this.c=f,this.editSessionId=this.args.editSessionId}}de([O.memoize],u.prototype,"appRoot",null),de([O.memoize],u.prototype,"userHome",null),de([O.memoize],u.prototype,"userDataPath",null),de([O.memoize],u.prototype,"appSettingsHome",null),de([O.memoize],u.prototype,"tmpDir",null),de([O.memoize],u.prototype,"cacheHome",null),de([O.memoize],u.prototype,"stateResource",null),de([O.memoize],u.prototype,"userRoamingDataHome",null),de([O.memoize],u.prototype,"userDataSyncHome",null),de([O.memoize],u.prototype,"userDataSyncLogResource",null),de([O.memoize],u.prototype,"editSessionsLogResource",null),de([O.memoize],u.prototype,"sync",null),de([O.memoize],u.prototype,"machineSettingsResource",null),de([O.memoize],u.prototype,"workspaceStorageHome",null),de([O.memoize],u.prototype,"localHistoryHome",null),de([O.memoize],u.prototype,"keyboardLayoutResource",null),de([O.memoize],u.prototype,"argvResource",null),de([O.memoize],u.prototype,"isExtensionDevelopment",null),de([O.memoize],u.prototype,"untitledWorkspacesHome",null),de([O.memoize],u.prototype,"installSourcePath",null),de([O.memoize],u.prototype,"builtinExtensionsPath",null),de([O.memoize],u.prototype,"extensionsPath",null),de([O.memoize],u.prototype,"extensionDevelopmentLocationURI",null),de([O.memoize],u.prototype,"extensionDevelopmentKind",null),de([O.memoize],u.prototype,"extensionTestsLocationURI",null),de([O.memoize],u.prototype,"debugExtensionHost",null),de([O.memoize],u.prototype,"logLevel",null),de([O.memoize],u.prototype,"extensionLogLevel",null),de([O.memoize],u.prototype,"serviceMachineIdResource",null),de([O.memoize],u.prototype,"telemetryLogResource",null),de([O.memoize],u.prototype,"disableWorkspaceTrust",null),de([O.memoize],u.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=u;function v(k,E){return g(k["inspect-extensions"],k["inspect-brk-extensions"],5870,E,k.debugId,k.extensionEnvironment)}e.parseExtensionHostPort=v;function p(k,E){return g(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,E,k.extensionEnvironment)}e.parsePtyHostPort=p;function g(k,E,L,f,c,m){const d=Number(E||k)||(f?null:L),y=d?Boolean(!!E):!1;let t;if(m)try{t=JSON.parse(m)}catch{}return{port:d,break:y,debugId:c,env:t}}}),function(){"use strict";function x(e,T,O){function R(N,S){const h=D(N,S),u=[h];return e.isAbsolute(h)||u.unshift(O),e.resolve(...u)}function D(N,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,S);const v=N["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(p,"AppData","Roaming")}break;case"darwin":u=e.join(T.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,S)}return{getUserDataPath:R}}if(typeof define=="function")define(Z[105],Q([156,33,35]),function(e,T,O){return x(e,T,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),T=require("os");module.exports=x(e,T,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[106],Q([0,1,33,104,105]),function(x,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class D extends O.AbstractNativeEnvironmentService{constructor(S,h){super(S,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,R.getUserDataPath)(S,h.nameShort)},h)}}e.NativeEnvironmentService=D}),define(Z[107],Q([0,1,4,90]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function R(N,S,h){try{D(N,S,h)}catch(u){console.error(u?.message??u)}return N}e.localizeManifest=R;function D(N,S,h){const u=(v,p,g)=>{const k=v[p];if((0,T.isString)(k)){const E=k,L=E.length;if(L>1&&E[0]==="%"&&E[L-1]==="%"){const f=E.substr(1,L-2);let c=S[f];c===void 0&&h&&(c=h[f]);const m=typeof c=="string"?c:c?.message,b=h?.[f],d=typeof b=="string"?b:b?.message;if(!m){d||console.warn(`[${N.name}]: ${(0,O.localize)(0,null,f)}`);return}if(g&&(p==="title"||p==="category")&&d&&d!==m){const y={value:m,original:d};v[p]=y}else v[p]=m}}else if((0,T.isObject)(k))for(const E in k)k.hasOwnProperty(E)&&(E==="commands"?u(k,E,!0):u(k,E,g));else if(Array.isArray(k))for(let E=0;E<k.length;E++)u(k,E,g)};for(const v in N)N.hasOwnProperty(v)&&u(N,v)}}),define(Z[108],Q([0,1,6]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class O{constructor(){this.a=new Map}register(D,N){this.a.set(D,N)}updateManifest(D){if(!(typeof D.main>"u"&&typeof D.browser>"u")&&(D.activationEvents===void 0&&Object.assign(D,{activationEvents:[]}),!(!Array.isArray(D.activationEvents)||!D.contributes)))for(const N in D.contributes){const S=this.a.get(N);if(!S)continue;const h=D.contributes[N],u=Array.isArray(h)?h:[h];try{S(u,D.activationEvents)}catch(v){(0,T.onUnexpectedError)(v)}}}}e.ImplicitActivationEventsImpl=O,e.ImplicitActivationEvents=new O}),define(Z[45],Q([0,1,18,53,94,41]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function h(c){return c=c.trim(),c==="*"||N.test(c)}e.isValidVersionStr=h;function u(c){if(!h(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=c.match(N);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=u;function v(c){if(!c)return null;const m=c.majorBase,b=c.majorMustEqual,d=c.minorBase;let y=c.minorMustEqual;const t=c.patchBase;let o=c.patchMustEqual;c.hasCaret&&(m===0||(y=!1),o=!1);let i=0;if(c.preRelease){const n=S.exec(c.preRelease);if(n){const[,r,a,s]=n;i=Date.UTC(Number(r),Number(a)-1,Number(s))}}return{majorBase:m,majorMustEqual:b,minorBase:d,minorMustEqual:y,patchBase:t,patchMustEqual:o,isMinimum:c.hasGreaterEquals,notBefore:i}}e.normalizeVersion=v;function p(c,m,b){let d;typeof c=="string"?d=v(u(c)):d=c;let y;m instanceof Date?y=m.getTime():typeof m=="string"&&(y=new Date(m).getTime());let t;if(typeof b=="string"?t=v(u(b)):t=b,!d||!t)return!1;const o=d.majorBase,i=d.minorBase,n=d.patchBase;let r=t.majorBase,a=t.minorBase,s=t.patchBase;const l=t.notBefore;let w=t.majorMustEqual,A=t.minorMustEqual,U=t.patchMustEqual;return t.isMinimum?o>r?!0:o<r?!1:i>a?!0:i<a||y&&y<l?!1:n>=s:(o===1&&r===0&&(!w||!A||!U)&&(r=1,a=0,s=0,w=!0,A=!1,U=!1),o<r?!1:o>r?!w:i<a?!1:i>a?!A:n<s?!1:n>s?!U:!(y&&y<l))}e.isValidVersion=p;function g(c,m,b,d,y){const t=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return t.push([O.default.Error,R.localize(0,null)]),t;if(typeof d.name!="string")return t.push([O.default.Error,R.localize(1,null,"name")]),t;if(typeof d.version!="string")return t.push([O.default.Error,R.localize(2,null,"version")]),t;if(!d.engines)return t.push([O.default.Error,R.localize(3,null,"engines")]),t;if(typeof d.engines.vscode!="string")return t.push([O.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof d.extensionDependencies<"u"&&!f(d.extensionDependencies))return t.push([O.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof d.activationEvents<"u"){if(!f(d.activationEvents))return t.push([O.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof d.main>"u"&&typeof d.browser>"u")return t.push([O.default.Error,R.localize(7,null,"activationEvents","main")]),t}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&t.push([O.default.Warning,R.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return t.push([O.default.Error,R.localize(9,null,"main")]),t;{const n=(0,T.joinPath)(b,d.main);(0,T.isEqualOrParent)(n,b)||t.push([O.default.Warning,R.localize(10,null,n.path,b.path)])}if(typeof d.activationEvents>"u")return t.push([O.default.Error,R.localize(11,null,"activationEvents","main")]),t}if(typeof d.browser<"u"){if(typeof d.browser!="string")return t.push([O.default.Error,R.localize(12,null,"browser")]),t;{const n=(0,T.joinPath)(b,d.browser);(0,T.isEqualOrParent)(n,b)||t.push([O.default.Warning,R.localize(13,null,n.path,b.path)])}if(typeof d.activationEvents>"u")return t.push([O.default.Error,R.localize(14,null,"activationEvents","browser")]),t}if(!D.valid(d.version))return t.push([O.default.Error,R.localize(15,null)]),t;const o=[];if(!k(c,m,d,y,o))for(const n of o)t.push([O.default.Error,n]);return t}e.validateExtensionManifest=g;function k(c,m,b,d,y){return d||typeof b.main>"u"&&typeof b.browser>"u"?!0:L(c,m,b.engines.vscode,y)}e.isValidExtensionVersion=k;function E(c,m,b){return c==="*"||L(m,b,c)}e.isEngineValid=E;function L(c,m,b,d=[]){const y=v(u(b));if(!y)return d.push(R.localize(16,null,b)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return d.push(R.localize(17,null,b)),!1}else if(!y.majorMustEqual)return d.push(R.localize(18,null,b)),!1;return p(c,m,y)?!0:(d.push(R.localize(19,null,c,b)),!1)}function f(c){if(!Array.isArray(c))return!1;for(let m=0,b=c.length;m<b;m++)if(typeof c[m]!="string")return!1;return!0}}),define(Z[109],Q([0,1,15,31]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(D,N,S){let h=S&&S.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const v=(await N.readFile(D.serviceMachineIdResource)).value.toString();h=(0,O.isUUID)(v)?v:null}catch{h=null}if(!h){h=(0,O.generateUuid)();try{await N.writeFile(D.serviceMachineIdResource,T.VSBuffer.fromString(h))}catch{}}return S?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=R}),define(Z[46],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(R,D=[],N=!1){this.ctor=R,this.staticArguments=D,this.supportsDelayedInstantiation=N}}e.SyncDescriptor=T}),define(Z[110],Q([0,1,46]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var R;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(R=e.InstantiationType||(e.InstantiationType={}));function D(S,h,u){h instanceof T.SyncDescriptor||(h=new T.SyncDescriptor(h,[],Boolean(u))),O.push([S,h])}e.registerSingleton=D;function N(){return O}e.getSingletonServiceDescriptors=N}),define(Z[111],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(D,N){this.key=D,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.Node=T;class O{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const N of this.a.values())N.outgoing.size===0&&D.push(N);return D}insertEdge(D,N){const S=this.lookupOrInsertNode(D),h=this.lookupOrInsertNode(N);S.outgoing.set(h.key,h),h.incoming.set(S.key,S)}removeNode(D){const N=this.b(D);this.a.delete(N);for(const S of this.a.values())S.outgoing.delete(N),S.incoming.delete(N)}lookupOrInsertNode(D){const N=this.b(D);let S=this.a.get(N);return S||(S=new T(N,D),this.a.set(N,S)),S}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[N,S]of this.a)D.push(`${N}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,N]of this.a){const S=new Set([D]),h=this.c(N,S);if(h)return h}}c(D,N){for(const[S,h]of D.outgoing){if(N.has(S))return[...N,S].join(" -> ");N.add(S);const u=this.c(h,N);if(u)return u;N.delete(S)}}}e.Graph=O}),define(Z[23],Q([0,1,4,11,9]),function(x,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function D(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof O.URI)}e.isConfigurationOverrides=D;function N(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=N;var S;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(S=e.ConfigurationTarget||(e.ConfigurationTarget={}));function h(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function u(c,m){const b=Object.create(null);for(const d in c)v(b,d,c[d],m);return b}e.toValuesTree=u;function v(c,m,b,d){const y=m.split("."),t=y.pop();let o=c;for(let i=0;i<y.length;i++){const n=y[i];let r=o[n];switch(typeof r){case"undefined":r=o[n]=Object.create(null);break;case"object":break;default:d(`Ignoring ${m} as ${y.slice(0,i+1).join(".")} is ${JSON.stringify(r)}`);return}o=r}if(typeof o=="object"&&o!==null)try{o[t]=b}catch{d(`Ignoring ${m} as ${y.join(".")} is ${JSON.stringify(o)}`)}else d(`Ignoring ${m} as ${y.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=v;function p(c,m){const b=m.split(".");g(c,b)}e.removeFromValueTree=p;function g(c,m){const b=m.shift();if(m.length===0){delete c[b];return}if(Object.keys(c).indexOf(b)!==-1){const d=c[b];typeof d=="object"&&!Array.isArray(d)&&(g(d,m),Object.keys(d).length===0&&delete c[b])}}function k(c,m,b){function d(o,i){let n=o;for(const r of i){if(typeof n!="object"||n===null)return;n=n[r]}return n}const y=m.split("."),t=d(c,y);return typeof t>"u"?b:t}e.getConfigurationValue=k;function E(c,m,b){Object.keys(m).forEach(d=>{d!=="__proto__"&&(d in c?T.isObject(c[d])&&T.isObject(m[d])?E(c[d],m[d],b):b&&(c[d]=m[d]):c[d]=m[d])})}e.merge=E;function L(c,m,b){const d=c.inspect(m),y=c.inspect(b);return typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:typeof y.userValue<"u"||typeof y.workspaceValue<"u"||typeof y.workspaceFolderValue<"u"?y.value:d.defaultValue}e.getMigratedSettingValue=L;function f(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(Z[58],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(Z[17],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[24],Q([0,1,88,9]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function R(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function D(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function N(c,m){switch(c){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=N;function S(c,m){return m==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=S;function h(c,m,b){return S(m,b)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===b?!0:u(b).includes(c)}e.isTargetPlatformCompatible=h;function u(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=u;function v(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=v;var p;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var g;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(g=e.SortOrder||(e.SortOrder={}));var k;(function(c){c.Install="install",c.Uninstall="uninstall"})(k=e.StatisticType||(e.StatisticType={}));var E;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var L;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal",c.Signature="Signature"})(L=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(m,b){super(m),this.code=b,this.name=b}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,T.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Z[59],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,T.createDecorator)("IExtensionSignatureVerificationService");class O{b(){return this.a||(this.a=new Promise((D,N)=>x(["node-vsce-sign"],async S=>D(S),N))),this.a}async verify(D,N){let S;try{S=await this.b()}catch{return!1}return S.verify(D,N)}}e.ExtensionSignatureVerificationService=O}),define(Z[60],Q([0,1,15,6,96,13]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function N(v,p,g,k,E,L){let f;try{await S(v,p,g,k,E,L)}catch(c){f=c}finally{f&&E.errorTransformer&&(f=E.errorTransformer(f)),typeof f<"u"&&g.error(f),g.end()}}e.readFileIntoStream=N;async function S(v,p,g,k,E,L){h(L);const f=await v.open(p,{create:!1});try{h(L);let c=0,m=0,b=E&&typeof E.length=="number"?E.length:void 0,d=T.VSBuffer.alloc(Math.min(E.bufferSize,typeof b=="number"?b:E.bufferSize)),y=E&&typeof E.position=="number"?E.position:0,t=0;do m=await v.read(f,y,d.buffer,t,d.byteLength-t),y+=m,t+=m,c+=m,typeof b=="number"&&(b-=m),t===d.byteLength&&(await g.write(k(d)),d=T.VSBuffer.alloc(Math.min(E.bufferSize,typeof b=="number"?b:E.bufferSize)),t=0);while(m>0&&(typeof b!="number"||b>0)&&h(L)&&u(c,E));if(t>0){let o=t;typeof b=="number"&&(o=Math.min(t,b)),g.write(k(d.slice(0,o)))}}catch(c){throw(0,D.ensureFileSystemProviderError)(c)}finally{await v.close(f)}}function h(v){if(v.isCancellationRequested)throw(0,O.canceled)();return!0}function u(v,p){if(p?.limits){if(typeof p.limits.memory=="number"&&v>p.limits.memory)throw(0,D.createFileSystemProviderError)((0,R.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof p.limits.size=="number"&&v>p.limits.size)throw(0,D.createFileSystemProviderError)((0,R.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[112],Q([0,1,3,157,2,12,158]),function(x,e,T,O,R,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class S extends R.Disposable{constructor(){super(...arguments),this.a=this.B(new T.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new T.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=T.Event.None,this.c=new Map,this.f=!1}async watch(u){const v=this.i(u),p=v.filter(k=>{const E=this.c.get(k.path);return E?!(0,O.patternsEquals)(E.request.excludes,k.excludes)||!(0,O.patternsEquals)(E.request.includes,k.includes):!0}),g=Array.from(this.c.values()).filter(({request:k})=>!v.find(E=>E.path===k.path&&(0,O.patternsEquals)(E.excludes,k.excludes)&&(0,O.patternsEquals)(E.includes,k.includes))).map(({request:k})=>k.path);p.length&&this.j(`Request to start watching: ${p.map(k=>`${k.path} (excludes: ${k.excludes.length>0?k.excludes:"<none>"}, includes: ${k.includes&&k.includes.length>0?JSON.stringify(k.includes):"<all>"})`).join(",")}`),g.length&&this.j(`Request to stop watching: ${g.join(",")}`);for(const k of g)this.h(k);for(const k of p)this.g(k)}g(u){const v=new N.NodeJSFileWatcherLibrary(u,g=>this.a.fire(g),g=>this.b.fire(g),this.f),p={request:u,instance:v};this.c.set(u.path,p)}async stop(){for(const[u]of this.c)this.h(u);this.c.clear()}h(u){const v=this.c.get(u);v&&(this.c.delete(u),v.instance.dispose())}i(u){const v=new Map;for(const p of u){const g=D.isLinux?p.path:p.path.toLowerCase();v.set(g,p)}return Array.from(v.values())}async setVerboseLogging(u){this.f=u;for(const[,v]of this.c)v.instance.setVerboseLogging(u)}j(u){this.f&&this.b.fire({type:"trace",message:this.k(u)})}k(u,v){return v?`[File Watcher (node.js)] ${u} (path: ${v.request.path})`:`[File Watcher (node.js)] ${u}`}}e.NodeJSWatcher=S}),define(Z[113],Q([0,1,61,112]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends T.AbstractNonRecursiveWatcherClient{constructor(N,S,h){super(N,S,h),this.m()}l(){return new O.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(Z[114],Q([0,1,16,56,83,61]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class N extends D.AbstractUniversalWatcherClient{constructor(h,u,v){super(h,u,v),this.m()}l(h){const u=h.add(new R.Client(T.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(u.onDidProcessExit(({code:v,signal:p})=>this.n(`terminated by itself with code ${v}, signal: ${p}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(u.getChannel("watcher")))}}e.UniversalWatcherClient=N}),define(Z[62],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...R){this.a=new Map;for(const[D,N]of R)this.set(D,N)}set(R,D){const N=this.a.get(R);return this.a.set(R,D),N}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.ServiceCollection=T}),define(Z[115],Q([0,1,5,6,2,46,111,9,62,159]),function(x,e,T,O,R,D,N,S,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const v=!1;class p extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class g{constructor(f=new h.ServiceCollection,c=!1,m,b=v){this.f=f,this.g=c,this.h=m,this.i=b,this.o=new Set,this.f.set(S.IInstantiationService,this),this._globalGraph=b?m?._globalGraph??new N.Graph(d=>d):void 0}createChild(f){return new g(f,this.g,this,this.i)}invokeFunction(f,...c){const m=E.traceInvocation(this.i,f);let b=!1;try{return f({get:y=>{if(b)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(y,m);if(!t)throw new Error(`[invokeFunction] unknown service '${y}'`);return t}},...c)}finally{b=!0,m.stop()}}createInstance(f,...c){let m,b;return f instanceof D.SyncDescriptor?(m=E.traceCreation(this.i,f.ctor),b=this.j(f.ctor,f.staticArguments.concat(c),m)):(m=E.traceCreation(this.i,f),b=this.j(f,c,m)),m.stop(),b}j(f,c=[],m){const b=S._util.getServiceDependencies(f).sort((t,o)=>t.index-o.index),d=[];for(const t of b){const o=this.m(t.id,m);o||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),d.push(o)}const y=b.length>0?b[0].index:c.length;if(c.length!==y){console.trace(`[createInstance] First service dependency of ${f.name} at position ${y+1} conflicts with ${c.length} static arguments`);const t=y-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,y)}return Reflect.construct(f,c.concat(d))}k(f,c){if(this.f.get(f)instanceof D.SyncDescriptor)this.f.set(f,c);else if(this.h)this.h.k(f,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const c=this.f.get(f);return!c&&this.h?this.h.l(f):c}m(f,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const m=this.l(f);return m instanceof D.SyncDescriptor?this.q(f,m,c.branch(f,!0)):(c.branch(f,!1),m)}q(f,c,m){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,c,m)}finally{this.o.delete(f)}}r(f,c,m){const b=new N.Graph(t=>t.id.toString());let d=0;const y=[{id:f,desc:c,_trace:m}];for(;y.length;){const t=y.pop();if(b.lookupOrInsertNode(t),d++>1e3)throw new p(b);for(const o of S._util.getServiceDependencies(t.desc.ctor)){const i=this.l(o.id);if(i||this.u(`[createInstance] ${f} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),i instanceof D.SyncDescriptor){const n={id:o.id,desc:i,_trace:t._trace.branch(o.id,!0)};b.insertEdge(t,n),y.push(n)}}}for(;;){const t=b.roots();if(t.length===0){if(!b.isEmpty())throw new p(b);break}for(const{data:o}of t){if(this.l(o.id)instanceof D.SyncDescriptor){const n=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,n)}b.removeNode(o)}}return this.l(f)}s(f,c,m=[],b,d){if(this.f.get(f)instanceof D.SyncDescriptor)return this.t(f,c,m,b,d);if(this.h)return this.h.s(f,c,m,b,d);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(f,c,m=[],b,d){if(b){const y=new g(void 0,this.g,this,this.i);y.c=String(f);const t=new Map,o=new T.IdleValue(()=>{const i=y.j(c,m,d);for(const[n,r]of t){const a=i[n];if(typeof a=="function")for(const s of r)a.apply(i,s)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!o.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let s=t.get(n);return s||(s=new u.LinkedList,t.set(n,s)),(w,A,U)=>{const Y=s.push([w,A,U]);return(0,R.toDisposable)(Y)}}if(n in i)return i[n];const r=o.value;let a=r[n];return typeof a!="function"||(a=a.bind(r),i[n]=a),a},set(i,n,r){return o.value[n]=r,!0},getPrototypeOf(i){return c.prototype}})}else return this.j(c,m,d)}u(f,c){if(c&&console.warn(f),this.g)throw new Error(f)}}e.InstantiationService=g;var k;(function(L){L[L.None=0]="None",L[L.Creation=1]="Creation",L[L.Invocation=2]="Invocation",L[L.Branch=3]="Branch"})(k||(k={}));class E{static traceInvocation(f,c){return f?new E(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(f,c){return f?new E(1,c.name):E.c}constructor(f,c){this.type=f,this.name=c,this.g=Date.now(),this.h=[]}branch(f,c){const m=new E(3,f.toString());return this.h.push([f,c,m]),m}stop(){const f=Date.now()-this.g;E.f+=f;let c=!1;function m(d,y){const t=[],o=new Array(d+1).join("	");for(const[i,n,r]of y.h)if(n&&r){c=!0,t.push(`${o}CREATES -> ${i}`);const a=m(d+1,r);a&&t.push(a)}else t.push(`${o}uses -> ${i}`);return t.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(f>2||c)&&E.all.add(b.join(`
`))}}e.Trace=E,E.all=new Set,E.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}},E.f=0});var _=this&&this.__param||function(x,e){return function(T,O){e(T,O,x)}};define(Z[63],Q([0,1,22,2,12,98,24,9]),function(x,e,T,O,R,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function h(v){return v.tags.find(p=>p.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=h,e.ILanguagePackService=(0,S.createDecorator)("languagePackService");let u=class extends O.Disposable{constructor(p){super(),this.c=p}async getAvailableLanguages(){const p=new T.CancellationTokenSource;setTimeout(()=>p.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},p.token)}catch{return[]}const E=g.firstPage.filter(L=>L.properties.localizedLanguages?.length&&L.tags.some(f=>f.startsWith("lp-"))).map(L=>{const f=L.properties.localizedLanguages?.[0],c=h(L);return{...this.f(c,f,L),extensionId:L.identifier.id,galleryExtension:L}});return E.push({...this.f("en","English"),extensionId:"default"}),E}f(p,g,k){const E=g??p;let L;if(E!==p&&(L=`(${p})`),p.toLowerCase()===R.language.toLowerCase()&&(L??="",L+=(0,D.localize)(0,null)),k?.installCount){L??="";const f=k.installCount;let c;f>1e6?c=`${Math.floor(f/1e5)/10}M`:f>1e3?c=`${Math.floor(f/1e3)}K`:c=String(f),L+=` $(cloud-download) ${c}`}return{id:p,label:E,description:L}}};u=de([_(0,N.IExtensionGalleryService)],u),e.LanguagePackBaseService=u}),define(Z[10],Q([0,1,34,3,2,36,12,11,9]),function(x,e,T,O,R,D,N,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,h.createDecorator)("logService"),e.ILoggerService=(0,h.createDecorator)("loggerService");function u(){return new Date().toISOString()}var v;(function(a){a[a.Off=0]="Off",a[a.Trace=1]="Trace",a[a.Debug=2]="Debug",a[a.Info=3]="Info",a[a.Warning=4]="Warning",a[a.Error=5]="Error"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function p(a,s,l){switch(s){case v.Trace:a.trace(l);break;case v.Debug:a.debug(l);break;case v.Info:a.info(l);break;case v.Warning:a.warn(l);break;case v.Error:a.error(l);break;case v.Off:break;default:throw new Error(`Invalid log level ${s}`)}}e.log=p;function g(a){let s="";for(let l=0;l<a.length;l++){let w=a[l];if(typeof w=="object")try{w=JSON.stringify(w)}catch{}s+=(l>0?" ":"")+w}return s}e.format=g;class k extends R.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new O.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(s){this.b!==s&&(this.b=s,this.c.fire(this.b))}getLevel(){return this.b}f(s){return this.b!==v.Off&&this.b<=s}}e.AbstractLogger=k;class E extends k{constructor(s){super(),this.h=s}f(s){return this.h||super.f(s)}trace(s,...l){this.f(v.Trace)&&this.g(v.Trace,g([s,...l]))}debug(s,...l){this.f(v.Debug)&&this.g(v.Debug,g([s,...l]))}info(s,...l){this.f(v.Info)&&this.g(v.Info,g([s,...l]))}warn(s,...l){this.f(v.Warning)&&this.g(v.Warning,g([s,...l]))}error(s,...l){if(this.f(v.Error))if(s instanceof Error){const w=Array.prototype.slice.call(arguments);w[0]=s.stack,this.g(v.Error,g(w))}else this.g(v.Error,g([s,...l]))}flush(){}}e.AbstractMessageLogger=E;class L extends k{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.g=!N.isWindows}trace(s,...l){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,s,...l):console.log(`[main ${u()}]`,s,...l))}debug(s,...l){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,s,...l):console.log(`[main ${u()}]`,s,...l))}info(s,...l){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,s,...l):console.log(`[main ${u()}]`,s,...l))}warn(s,...l){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,s,...l):console.warn(`[main ${u()}]`,s,...l))}error(s,...l){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,s,...l):console.error(`[main ${u()}]`,s,...l))}dispose(){}flush(){}}e.ConsoleMainLogger=L;class f extends k{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...l){this.f(v.Trace)&&console.log("%cTRACE","color: #888",s,...l)}debug(s,...l){this.f(v.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",s,...l)}info(s,...l){this.f(v.Info)&&console.log("%c INFO","color: #33f",s,...l)}warn(s,...l){this.f(v.Warning)&&console.log("%c WARN","color: #993",s,...l)}error(s,...l){this.f(v.Error)&&console.log("%c  ERR","color: #f33",s,...l)}dispose(){}flush(){}}e.ConsoleLogger=f;class c extends k{constructor(s,l=e.DEFAULT_LOG_LEVEL){super(),this.g=s,this.setLevel(l)}trace(s,...l){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(s),...l])}debug(s,...l){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(s),...l])}info(s,...l){this.f(v.Info)&&this.g.log(v.Info,[this.h(s),...l])}warn(s,...l){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(s),...l])}error(s,...l){this.f(v.Error)&&this.g.log(v.Error,[this.h(s),...l])}h(s){return typeof s=="string"?s:(0,T.toErrorMessage)(s,this.f(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=c;class m extends k{constructor(s){super(),this.g=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const l of this.g)l.setLevel(s);super.setLevel(s)}trace(s,...l){for(const w of this.g)w.trace(s,...l)}debug(s,...l){for(const w of this.g)w.debug(s,...l)}info(s,...l){for(const w of this.g)w.info(s,...l)}warn(s,...l){for(const w of this.g)w.warn(s,...l)}error(s,...l){for(const w of this.g)w.error(s,...l)}flush(){for(const s of this.g)s.flush()}dispose(){for(const s of this.g)s.dispose()}}e.MultiplexLogService=m;class b extends R.Disposable{constructor(s){super(),this.b=s,this.B(s)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(s){this.b.setLevel(s)}getLevel(){return this.b.getLevel()}trace(s,...l){this.b.trace(s,...l)}debug(s,...l){this.b.debug(s,...l)}info(s,...l){this.b.info(s,...l)}warn(s,...l){this.b.warn(s,...l)}error(s,...l){this.b.error(s,...l)}flush(){this.b.flush()}}e.LogService=b;class d extends R.Disposable{constructor(s,l){super(),this.c=s,this.b=new D.ResourceMap,this.B(l(w=>this.setLevel(w)))}getLoggers(){return[...this.b.values()].map(({logger:s})=>s)}getLogger(s){return this.b.get(s)?.logger}createLogger(s,l,w){let A=this.b.get(s)?.logger;return A||(w=l?.always?v.Trace:w,A=this.f(s,w??this.c,l),this.b.set(s,{logger:A,logLevel:w})),A}setLevel(s,l){const w=S.URI.isUri(s)?s:void 0,A=w?l:s;if(w){const U=this.b.get(w);U&&U.logLevel!==A&&(U.logLevel=A,U.logger.setLevel(A))}else this.c=A,this.b.forEach(({logLevel:U,logger:Y})=>{U===void 0&&Y.setLevel(this.c)})}getLogLevel(s){return this.b.get(s)?.logLevel}dispose(){this.b.forEach(({logger:s})=>s.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=d;class y{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(s){}getLevel(){return v.Info}trace(s,...l){}debug(s,...l){}info(s,...l){}warn(s,...l){}error(s,...l){}critical(s,...l){}dispose(){}flush(){}}e.NullLogger=y;class t extends y{}e.NullLogService=t;class o extends d{constructor(){super(v.Info,O.Event.None)}f(s,l,w){return new y}}e.NullLoggerService=o;function i(a){if(a.verbose)return v.Trace;if(typeof a.logLevel=="string"){const s=r(a.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function n(a){switch(a){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=n;function r(a){switch(a){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=r}),define(Z[116],Q([0,1,19,5,6,3,2,14,61,10]),function(x,e,T,O,R,D,N,S,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class v extends N.Disposable{constructor(g,k){super(),this.a=g,this.b=k,this.c=this.B(new D.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new O.ThrottledDelayer(0)),this.s=[],this.t=this.B(new O.ThrottledDelayer(0))}watch(g,k){return k.recursive||this.b?.watcher?.forceUniversal?this.l(g,k):this.u(g,k)}l(g,k){const E={path:this.C(g),excludes:k.excludes,includes:k.includes,recursive:k.recursive},L=(0,T.insert)(this.j,E);return this.m(),(0,N.toDisposable)(()=>{L(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(g=>(0,R.onUnexpectedError)(g))}n(){this.h||(this.h=this.B(this.p(k=>this.c.fire((0,h.toFileChanges)(k)),k=>this.z(k),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const k of this.j)(0,h.isRecursiveWatchRequest)(k)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const k of this.j)(0,h.isRecursiveWatchRequest)(k)&&g.includes(k.path)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(g,k){const E={path:this.C(g),excludes:k.excludes,includes:k.includes,recursive:!1},L=(0,T.insert)(this.s,E);return this.v(),(0,N.toDisposable)(()=>{L(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(g=>(0,R.onUnexpectedError)(g))}w(){return this.r||(this.r=this.B(this.y(g=>this.c.fire((0,h.toFileChanges)(g)),g=>this.z(g),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.r.watch(this.s)}z(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}C(g){return(0,S.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=v}),define(Z[117],Q([0,1,19,5,15,22,3,52,64,2,54,16,118,18,43,95,13,60,10,6]),function(x,e,T,O,R,D,N,S,h,u,v,p,g,k,E,L,f,c,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let d=class extends u.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new N.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new N.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new N.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new N.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new O.ResourceQueue)}registerProvider(t,o){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${t}`);const i=new u.DisposableStore;return this.h.set(t,o),this.c.fire({added:!0,scheme:t,provider:o}),i.add(o.onDidChangeFile(n=>this.R.fire(new f.FileChangesEvent(n,!this.O(o))))),typeof o.onDidWatchError=="function"&&i.add(o.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:t}))),(0,u.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:o}),this.h.delete(t),(0,u.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const o=[];this.f.fire({scheme:t,join(i){o.push(i)}}),!this.h.has(t)&&await O.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,o){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&o)}listCapabilities(){return h.Iterable.map(this.h,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async j(t){if(!(0,k.isAbsolutePath)(t))throw new f.FileOperationError((0,L.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const o=this.h.get(t.scheme);if(!o){const i=new b.ErrorNoTelemetry;throw i.message=(0,L.localize)(1,null,t.toString()),i}return o}async k(t){const o=await this.j(t);if((0,f.hasOpenReadWriteCloseCapability)(o)||(0,f.hasReadWriteCapability)(o)||(0,f.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const o=await this.j(t);if((0,f.hasOpenReadWriteCloseCapability)(o)||(0,f.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.n(t,o)}catch(i){throw(0,f.toFileSystemProviderErrorCode)(i)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,L.localize)(2,null,this.nb(t)),1):(0,f.ensureFileSystemProviderError)(i)}}async n(t,o){const i=await this.j(t),n=this.O(i),r=o?.resolveTo,a=o?.resolveSingleChildDescendants,s=o?.resolveMetadata,l=await i.stat(t);let w;return this.p(i,t,l,void 0,!!s,(A,U)=>(w||(w=v.TernarySearchTree.forUris(()=>!n),w.set(t,!0),r&&w.fill(!0,r)),w.get(A.resource)||w.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&a?U===1:!1))}async p(t,o,i,n,r,a){const{providerExtUri:s}=this.N(t),l={resource:o,name:s.basename(o),isFile:(i.type&f.FileType.File)!==0,isDirectory:(i.type&f.FileType.Directory)!==0,isSymbolicLink:(i.type&f.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&f.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,f.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(l.isDirectory&&a(l,n)){try{const w=await t.readdir(o),A=await O.Promises.settled(w.map(async([U,Y])=>{try{const X=s.joinPath(o,U),ee=r?await t.stat(X):{type:Y};return await this.p(t,X,ee,w.length,r,a)}catch(X){return this.b.trace(X),null}}));l.children=(0,T.coalesce)(A)}catch(w){this.b.trace(w),l.children=[]}return l}return l}async resolveAll(t){return O.Promises.settled(t.map(async o=>{try{return{stat:await this.n(o.resource,o.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.j(t),i=await o.stat(t);return this.p(o,t,i,void 0,!0,()=>!1)}async exists(t){const o=await this.j(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.r(t,o)}catch(i){return i}return!0}async r(t,o){if(!o?.overwrite&&await this.exists(t))throw new f.FileOperationError((0,L.localize)(3,null,this.nb(t)),3,o)}async createFile(t,o=R.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,o);return this.m.fire(new f.FileOperationEvent(t,0,n)),n}async writeFile(t,o,i){const n=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(n);try{await this.s(n,t,i)||await this.P(n,r.dirname(t));let s;if((0,f.hasReadWriteCapability)(n)&&!(o instanceof R.VSBuffer))if((0,E.isReadableStream)(o)){const l=await(0,E.peekStream)(o,3);l.ended?s=R.VSBuffer.concat(l.buffer):s=l}else s=(0,E.peekReadable)(o,l=>R.VSBuffer.concat(l),3);else s=o;!(0,f.hasOpenReadWriteCloseCapability)(n)||(0,f.hasReadWriteCapability)(n)&&s instanceof R.VSBuffer?await this.cb(n,t,i,s):await this.Y(n,t,i,s instanceof R.VSBuffer?(0,R.bufferToReadable)(s):s),this.m.fire(new f.FileOperationEvent(t,4))}catch(a){throw new f.FileOperationError((0,L.localize)(4,null,this.nb(t),(0,f.ensureFileSystemProviderError)(a).toString()),(0,f.toFileOperationResult)(a),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,o,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,L.localize)(5,null,this.nb(o)));let r;try{r=await t.stat(o)}catch{return}if((r.type&f.FileType.Directory)!==0)throw new f.FileOperationError((0,L.localize)(6,null,this.nb(o)),0,i);if(this.mb(o,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==f.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,f.etag)({mtime:i.mtime,size:r.size}))throw new f.FileOperationError((0,L.localize)(7,null),3,i);return r}async readFile(t,o,i){const n=await this.k(t);return o?.atomic?this.t(n,t,o,i):this.u(n,t,o,i)}async t(t,o,i,n){return new Promise((r,a)=>{this.X.queueFor(o,this.N(t).providerExtUri).queue(async()=>{try{const s=await this.u(t,o,i,n);r(s)}catch(s){a(s)}})})}async u(t,o,i,n){const r=await this.v(t,o,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,R.streamToBuffer)(r.value)}}async readFileStream(t,o,i){const n=await this.k(t);return this.v(n,t,o,i)}async v(t,o,i,n){const r=new D.CancellationTokenSource(n),a=this.F(o,i).then(l=>l,l=>{throw r.cancel(),l});let s;try{return typeof i?.etag=="string"&&i.etag!==f.ETAG_DISABLED&&await a,i?.atomic&&(0,f.hasFileAtomicReadCapability)(t)||!((0,f.hasOpenReadWriteCloseCapability)(t)||(0,f.hasFileReadStreamCapability)(t))||(0,f.hasReadWriteCapability)(t)&&i?.preferUnbuffered?s=this.D(t,o,i):(0,f.hasFileReadStreamCapability)(t)?s=this.z(t,o,r.token,i):s=this.C(t,o,r.token,i),{...await a,value:s}}catch(l){throw s&&await(0,E.consumeStream)(s),this.w(l,o,i)}}w(t,o,i){const n=(0,L.localize)(8,null,this.nb(o),(0,f.ensureFileSystemProviderError)(t).toString());return t instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof f.TooLargeFileOperationError?new f.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new f.FileOperationError(n,(0,f.toFileOperationResult)(t),i)}z(t,o,i,n=Object.create(null)){const r=t.readFileStream(o,n,i);return(0,E.transform)(r,{data:a=>a instanceof R.VSBuffer?a:R.VSBuffer.wrap(a),error:a=>this.w(a,o,n)},a=>R.VSBuffer.concat(a))}C(t,o,i,n=Object.create(null)){const r=(0,R.newWriteableBufferStream)();return(0,c.readFileIntoStream)(t,o,r,a=>a,{...n,bufferSize:this.a,errorTransformer:a=>this.w(a,o,n)},i),r}D(t,o,i){const n=(0,E.newWriteableStream)(r=>R.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,f.hasFileAtomicReadCapability)(t)?r=await t.readFile(o,{atomic:!0}):r=await t.readFile(o),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.G(o,r.byteLength,i),n.end(R.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async F(t,o){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new f.FileOperationError((0,L.localize)(9,null,this.nb(t)),0,o);if(typeof o?.etag=="string"&&o.etag!==f.ETAG_DISABLED&&o.etag===i.etag)throw new f.NotModifiedSinceFileOperationError((0,L.localize)(10,null),i,o);return this.G(t,i.size,o),i}G(t,o,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&o>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&o>i.limits.size&&(n=7),typeof n=="number")throw new f.TooLargeFileOperationError((0,L.localize)(11,null,this.nb(t)),n,o,i)}}async canMove(t,o,i){return this.H(t,o,"move",i)}async canCopy(t,o,i){return this.H(t,o,"copy",i)}async H(t,o,i,n){if(t.toString()!==o.toString())try{const r=i==="move"?this.lb(await this.l(t),t):await this.k(t),a=this.lb(await this.l(o),o);await this.M(r,t,a,o,i,n)}catch(r){return r}return!0}async move(t,o,i){const n=this.lb(await this.l(t),t),r=this.lb(await this.l(o),o),a=await this.I(n,t,r,o,"move",!!i),s=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(t,a==="move"?2:3,s)),s}async copy(t,o,i){const n=await this.k(t),r=this.lb(await this.l(o),o),a=await this.I(n,t,r,o,"copy",!!i),s=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(t,a==="copy"?3:2,s)),s}async I(t,o,i,n,r,a){if(o.toString()===n.toString())return r;const{exists:s,isSameResourceWithDifferentPathCase:l}=await this.M(t,o,i,n,r,a);if(s&&!l&&a&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),r==="copy"){if(t===i&&(0,f.hasFileFolderCopyCapability)(t))await t.copy(o,n,{overwrite:a});else{const w=await this.resolve(o);w.isDirectory?await this.L(t,w,i,n):await this.J(t,o,i,n)}return r}else return t===i?(await t.rename(o,n,{overwrite:a}),r):(await this.I(t,o,i,n,"copy",a),await this.del(o,{recursive:!0}),"copy")}async J(t,o,i,n){if((0,f.hasOpenReadWriteCloseCapability)(t)&&(0,f.hasOpenReadWriteCloseCapability)(i))return this.eb(t,o,i,n);if((0,f.hasOpenReadWriteCloseCapability)(t)&&(0,f.hasReadWriteCapability)(i))return this.kb(t,o,i,n);if((0,f.hasReadWriteCapability)(t)&&(0,f.hasOpenReadWriteCloseCapability)(i))return this.ib(t,o,i,n);if((0,f.hasReadWriteCapability)(t)&&(0,f.hasReadWriteCapability)(i))return this.gb(t,o,i,n)}async L(t,o,i,n){await i.mkdir(n),Array.isArray(o.children)&&await O.Promises.settled(o.children.map(async r=>{const a=this.N(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),i,a):this.J(t,r.resource,i,a)}))}async M(t,o,i,n,r,a){let s=!1;if(t===i){const{providerExtUri:w,isPathCaseSensitive:A}=this.N(t);if(A||(s=w.isEqual(o,n)),s&&r==="copy")throw new Error((0,L.localize)(12,null,this.nb(o),this.nb(n)));if(!s&&w.isEqualOrParent(n,o))throw new Error((0,L.localize)(13,null,this.nb(o),this.nb(n)))}const l=await this.exists(n);if(l&&!s){if(!a)throw new f.FileOperationError((0,L.localize)(14,null,this.nb(o),this.nb(n)),4);if(t===i){const{providerExtUri:w}=this.N(t);if(w.isEqualOrParent(o,n))throw new Error((0,L.localize)(15,null,this.nb(o),this.nb(n)))}}return{exists:l,isSameResourceWithDifferentPathCase:s}}N(t){const o=this.O(t);return{providerExtUri:o?k.extUri:k.extUriIgnorePathCase,isPathCaseSensitive:o}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const o=this.lb(await this.j(t),t);await this.P(o,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(t,0,i)),i}async P(t,o){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(o,n.dirname(o));)try{if(((await t.stat(o)).type&f.FileType.Directory)===0)throw new Error((0,L.localize)(16,null,this.nb(o)));break}catch(r){if((0,f.toFileSystemProviderErrorCode)(r)!==f.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(o)),o=n.dirname(o)}for(let r=i.length-1;r>=0;r--){o=n.joinPath(o,i[r]);try{await t.mkdir(o)}catch(a){if((0,f.toFileSystemProviderErrorCode)(a)!==f.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(t,o){try{await this.Q(t,o)}catch(i){return i}return!0}async Q(t,o){const i=this.lb(await this.j(t),t);if(!!o?.useTrash&&!(i.capabilities&4096))throw new Error((0,L.localize)(17,null,this.nb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.mb(t,r);else throw new f.FileOperationError((0,L.localize)(18,null,this.nb(t)),1);if(!!!o?.recursive){const s=await this.resolve(t);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,L.localize)(19,null,this.nb(t)))}return i}async del(t,o){const i=await this.Q(t,o),n=!!o?.useTrash,r=!!o?.recursive;await i.delete(t,{recursive:r,useTrash:n}),this.m.fire(new f.FileOperationEvent(t,1))}async cloneFile(t,o){const i=await this.j(t),n=this.lb(await this.l(o),o);if(i===n&&this.N(i).providerExtUri.isEqual(t,o))return;if(i===n&&(0,f.hasFileCloneCapability)(i))return i.cloneFile(t,o);await this.P(n,this.N(n).providerExtUri.dirname(o));const r=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,f.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,o,{overwrite:!0})):r.queue(()=>this.J(i,t,n,o))}watch(t,o={recursive:!1,excludes:[]}){const i=new u.DisposableStore;let n=!1,r=()=>{n=!0};return i.add((0,u.toDisposable)(()=>r())),(async()=>{try{const a=await this.W(t,o);n?(0,u.dispose)(a):r=()=>(0,u.dispose)(a)}catch(a){this.b.error(a)}})(),i}async W(t,o){const i=await this.j(t),n=(0,S.hash)([this.N(i).providerExtUri.getComparisonKey(t),o]);let r=this.U.get(n);return r||(r={count:0,disposable:i.watch(t,o)},this.U.set(n,r)),r.count+=1,(0,u.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,u.dispose)(r.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,u.dispose)(t.disposable);this.U.clear()}async Y(t,o,i,n){return this.X.queueFor(o,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(o,{create:!0,unlock:i?.unlock??!1});try{(0,E.isReadableStream)(n)||(0,E.isReadableBufferedStream)(n)?await this.Z(t,r,n):await this.ab(t,r,n)}catch(a){throw(0,f.ensureFileSystemProviderError)(a)}finally{await t.close(r)}})}async Z(t,o,i){let n=0,r;if((0,E.isReadableBufferedStream)(i)){if(i.buffer.length>0){const a=R.VSBuffer.concat(i.buffer);await this.bb(t,o,a,a.byteLength,n,0),n+=a.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((a,s)=>{(0,E.listenStream)(r,{onData:async l=>{r.pause();try{await this.bb(t,o,l,l.byteLength,n,0)}catch(w){return s(w)}n+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>s(l),onEnd:()=>a()})})}async ab(t,o,i){let n=0,r;for(;(r=i.read())!==null;)await this.bb(t,o,r,r.byteLength,n,0),n+=r.byteLength}async bb(t,o,i,n,r,a){let s=0;for(;s<n;)s+=await t.write(o,r+s,i.buffer,a+s,n-s)}async cb(t,o,i,n){return this.X.queueFor(o,this.N(t).providerExtUri).queue(()=>this.db(t,o,i,n))}async db(t,o,i,n){let r;n instanceof R.VSBuffer?r=n:(0,E.isReadableStream)(n)?r=await(0,R.streamToBuffer)(n):(0,E.isReadableBufferedStream)(n)?r=await(0,R.bufferedStreamToBuffer)(n):r=(0,R.readableToBuffer)(n),await t.writeFile(o,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,o,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,o,i,n))}async fb(t,o,i,n){let r,a;try{r=await t.open(o,{create:!1}),a=await i.open(n,{create:!0,unlock:!1});const s=R.VSBuffer.alloc(this.a);let l=0,w=0,A=0;do A=await t.read(r,l,s.buffer,w,s.byteLength-w),await this.bb(i,a,s,A,l,w),l+=A,w+=A,w===s.byteLength&&(w=0);while(A>0)}catch(s){throw(0,f.ensureFileSystemProviderError)(s)}finally{await O.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof a=="number"?i.close(a):Promise.resolve()])}}async gb(t,o,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,o,i,n))}async hb(t,o,i,n){return i.writeFile(n,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async ib(t,o,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,o,i,n))}async jb(t,o,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const a=await t.readFile(o);await this.bb(i,r,R.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,f.ensureFileSystemProviderError)(a)}finally{await i.close(r)}}async kb(t,o,i,n){const r=await(0,R.streamToBuffer)(this.C(t,o,D.CancellationToken.None));await this.cb(i,n,void 0,r)}lb(t,o){if(t.capabilities&2048)throw new f.FileOperationError((0,L.localize)(20,null,this.nb(o)),6);return t}mb(t,o){if((o.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,L.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===p.Schemas.file?t.fsPath:t.toString(!0)}};d=de([_(0,m.ILogService)],d),e.FileService=d}),define(Z[119],Q([0,1,120,160,5,36,15,3,161,2,14,12,18,43,20,97,13,60,116,34,114,113]),function(x,e,T,O,R,D,N,S,h,u,v,p,g,k,E,L,f,c,m,b,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(T)}catch(o){console.error(`Error enabling graceful-fs: ${(0,b.toErrorMessage)(o)}`)}})();class t extends m.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=S.Event.None,this.H=new D.ResourceMap(r=>g.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,p.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:r}=await E.SymlinkSupport.stat(this.C(i));return{type:this.G(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await E.Promises.readdir(this.C(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async a=>{try{let s;a.isSymbolicLink()?s=(await this.stat((0,g.joinPath)(i,a.name))).type:s=this.G(a),r.push([a.name,s])}catch(s){this.a.trace(s)}})),r}catch(n){throw this.Y(n)}}G(i,n){let r;return n?.dangling?r=f.FileType.Unknown:i.isFile()?r=f.FileType.File:i.isDirectory()?r=f.FileType.Directory:r=f.FileType.Unknown,n&&(r|=f.FileType.SymbolicLink),r}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const a=new R.Barrier;return this.H.set(i,a),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,u.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===a&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),r=await this.I(i));const a=this.C(i);return await E.Promises.readFile(a)}catch(a){throw this.Y(a)}finally{r?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,r){const a=(0,k.newWriteableStream)(s=>N.VSBuffer.concat(s.map(l=>N.VSBuffer.wrap(l))).buffer);return(0,c.readFileIntoStream)(this,i,a,s=>s.buffer,{...n,bufferSize:256*1024},r),a}async writeFile(i,n,r){let a;try{const s=this.C(i);if(!r.create||!r.overwrite){if(await E.Promises.exists(s)){if(!r.overwrite)throw(0,f.createFileSystemProviderError)((0,L.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,f.createFileSystemProviderError)((0,L.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(s){throw await this.Z(i,s)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const r=this.C(i);let a;(0,f.isFileOpenForWriteOptions)(n)&&(a=await this.I(i));let s;try{if((0,f.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:w}=await E.SymlinkSupport.stat(r);w.mode&128||await E.Promises.chmod(r,w.mode|128)}catch(w){this.a.trace(w)}let l;if((0,f.isFileOpenForWriteOptions)(n)){if(p.isWindows)try{await E.Promises.truncate(r,0),l="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}l||(l="w")}else l="r";s=await E.Promises.open(r,l)}catch(l){throw a?.dispose(),(0,f.isFileOpenForWriteOptions)(n)?await this.Z(i,l):this.Y(l)}if(this.L.set(s,0),(0,f.isFileOpenForWriteOptions)(n)&&this.N.set(s,i),a){const l=this.M.get(s);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${r})`),this.M.set(s,a),l&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${r})`),l.dispose())}return s}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await E.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await E.Promises.close(i)}catch(r){throw this.Y(r)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,a,s){const l=this.P(i,n);let w=null;try{w=(await E.Promises.read(i,r,a,s,l)).bytesRead}catch(A){throw this.Y(A)}finally{this.Q(i,l,w)}return w}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,r){const a=this.L.get(i);typeof a=="number"&&(typeof n=="number"||(typeof r=="number"?this.L.set(i,a+r):this.L.delete(i)))}async write(i,n,r,a,s){return(0,R.retry)(()=>this.R(i,n,r,a,s),100,3)}async R(i,n,r,a,s){const l=this.P(i,n);let w=null;try{w=(await E.Promises.write(i,r,a,s,l)).bytesWritten}catch(A){throw await this.Z(this.N.get(i),A)}finally{this.Q(i,l,w)}return w}async mkdir(i){try{await E.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const r=this.C(i);n.recursive?await E.Promises.rm(r,E.RimRafMode.MOVE):await E.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(i,n,r){const a=this.C(i),s=this.C(n);if(a!==s)try{await this.S(i,n,"move",r.overwrite),await E.Promises.move(a,s)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,L.localize)(2,null,(0,v.basename)(a),(0,v.basename)((0,v.dirname)(s)),l.toString()))),this.Y(l)}}async copy(i,n,r){const a=this.C(i),s=this.C(n);if(a!==s)try{await this.S(i,n,"copy",r.overwrite),await E.Promises.copy(a,s,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,L.localize)(3,null,(0,v.basename)(a),(0,v.basename)((0,v.dirname)(s)),l.toString()))),this.Y(l)}}async S(i,n,r,a){const s=this.C(i),l=this.C(n);let w=!1;if(!!(this.capabilities&1024)||(w=(0,h.isEqual)(s,l,!0)),w&&r==="copy")throw(0,f.createFileSystemProviderError)((0,L.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!w&&await E.Promises.exists(l)){if(!a)throw(0,f.createFileSystemProviderError)((0,L.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,r){const a=this.C(i),s=this.C(n),l=!!(this.capabilities&1024);if((0,h.isEqual)(a,s,!l))return;const w=new u.DisposableStore;try{const[A,U]=await Promise.all([this.I(i),this.I(n)]);w.add(A),w.add(U),r&&await E.Promises.mkdir((0,v.dirname)(s),{recursive:!0}),await E.Promises.copyFile(a,s)}catch(A){if(A.code==="ENOENT"&&!r)return this.U(i,n,!0);throw this.Y(A)}finally{w.dispose()}}p(i,n,r){return new d.UniversalWatcherClient(a=>i(a),a=>n(a),r)}y(i,n,r){return new y.NodeJSWatcherClient(a=>i(a),a=>n(a),r)}Y(i){if(i instanceof f.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=f.FileSystemProviderErrorCode.NoPermissions;break;default:n=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(i,n)}async Z(i,n){let r=this.Y(n);if(i&&r.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await E.SymlinkSupport.stat(this.C(i));a.mode&128||(r=(0,f.createFileSystemProviderError)(n,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return r}}e.DiskFileSystemProvider=t,t.D=!1,t.O=!0}),define(Z[121],Q([0,1,13,10]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var R;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(R||(R={}));async function D(u,v,p,g,k){try{const E=await new Promise((f,c)=>{x(["spdlog"],f,c)});E.setFlushOn(R.Trace);const L=await E.createAsyncRotatingLogger(u,v,p,g);return k?L.clearFormatters():L.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),L}catch(E){console.error(E)}return null}function N(u,v,p){switch(v){case O.LogLevel.Trace:u.trace(p);break;case O.LogLevel.Debug:u.debug(p);break;case O.LogLevel.Info:u.info(p);break;case O.LogLevel.Warning:u.warn(p);break;case O.LogLevel.Error:u.error(p);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function S(u,v){switch(v){case O.LogLevel.Trace:u.setLevel(R.Trace);break;case O.LogLevel.Debug:u.setLevel(R.Debug);break;case O.LogLevel.Info:u.setLevel(R.Info);break;case O.LogLevel.Warning:u.setLevel(R.Warning);break;case O.LogLevel.Error:u.setLevel(R.Error);break;case O.LogLevel.Off:u.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${v}`)}}class h extends O.AbstractMessageLogger{constructor(v,p,g,k,E){super(),this.k=[],this.setLevel(E),this.l=this.n(v,p,g,k),this.B(this.onDidChangeLogLevel(L=>{this.m&&S(this.m,L)}))}async n(v,p,g,k){const E=g?6:1,L=30/E*T.ByteSize.MB,f=await D(v,p,L,E,k);if(f){this.m=f,S(this.m,this.getLevel());for(const{level:c,message:m}of this.k)N(this.m,c,m);this.k=[]}}g(v,p){this.m?N(this.m,v,p):this.getLevel()<=v&&this.k.push({level:v,message:p})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=h}),define(Z[38],Q([0,1,3,64,2,9]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,D.createDecorator)("policy");class N extends R.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new T.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const v=Object.keys(this.f).length;return this.f={...u,...this.f},v!==Object.keys(this.f).length&&await this.i(u),O.Iterable.reduce(this.g.entries(),(p,[g,k])=>({...p,[g]:k}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(u,[v,p])=>({...u,[v]:{definition:p,value:this.g.get(v)}}),{})}}e.AbstractPolicyService=N;class S{constructor(){this.onDidChange=T.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=S}),define(Z[122],Q([0,1,5,3,64,4,13,10,38]),function(x,e,T,O,R,D,N,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function u(p,g){const k=[];for(const E of new Set(R.Iterable.concat(p.keys(),g.keys())))p.get(E)!==g.get(E)&&k.push(E);return k}let v=class extends h.AbstractPolicyService{constructor(g,k,E){super(),this.j=g,this.k=k,this.l=E,this.c=this.B(new T.ThrottledDelayer(500));const L=O.Event.filter(k.onDidFilesChange,f=>f.affects(g));this.B(k.watch(g)),this.B(L(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const g=new Map;try{const k=await this.k.readFile(this.j),E=JSON.parse(k.value.toString());if(!(0,D.isObject)(E))throw new Error("Policy file isn't a JSON object");for(const L of Object.keys(E))this.f[L]&&g.set(L,E[L])}catch(k){k.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",k)}return g}async p(){const g=await this.n(),k=u(this.g,g);this.g=g,k.length>0&&this.h.fire(k)}};v=de([_(1,N.IFileService),_(2,S.ILogService)],v),e.FilePolicyService=v}),define(Z[28],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[37],Q([0,1,70,4]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.a=new Map}add(N,S){T.ok(O.isString(N)),T.ok(O.isObject(S)),T.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,S)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.Registry=new R}),define(Z[123],Q([0,1,3,37]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class D{constructor(){this.b=new T.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,u){this.a[R(h)]=u,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const N=new D;O.Registry.add(e.Extensions.JSONContribution,N)}),define(Z[42],Q([0,1,19,3,4,86,23,123,37]),function(x,e,T,O,R,D,N,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var u;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(u=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var v;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const p=h.Registry.as(S.Extensions.JSONContribution);class g{constructor(){this.h=new Set,this.i=new O.Emitter,this.onDidSchemaChange=this.i.event,this.j=new O.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const i=new Set;this.n(t,o,i),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const o=new Set;this.o(t,o),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const i=new Set;this.o(o,i),this.n(t,!1,i),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const i=[];for(const{overrides:n,source:r}of t)for(const a in n)if(o.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const s=this.a.get(a),l=s?.valuesSources??new Map;if(r)for(const Y of Object.keys(n[a]))l.set(Y,r);const w={...s?.value||{},...n[a]};this.a.set(a,{source:r,value:w,valuesSources:l});const A=(0,N.getLanguageTagSettingPlainKey)(a),U={type:"object",default:w,description:D.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:R.isString(r)?void 0:r,defaultValueSource:r};i.push(...L(a)),this.d[a]=U,this.b.properties[a]=U}else{this.a.set(a,{value:n[a],source:r});const s=this.d[a];s&&(this.w(a,s),this.r(a,s))}this.m(i)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:i,source:n}of t)for(const r in i){const a=this.a.get(r),s=R.isString(n)?n:n?.id,l=R.isString(a?.source)?a?.source:a?.source?.id;if(s===l)if(o.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const w=this.d[r];w&&(this.w(r,w),this.r(r,w))}}this.u()}deltaConfiguration(t){let o=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,i){t.forEach(n=>{this.p(n,o,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,o){const i=n=>{if(n.properties)for(const r in n.properties){o.add(r);const a=this.d[r];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>i(r))};for(const n of t){i(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,o=!0,i,n,r=3,a){r=R.isUndefinedOrNull(t.scope)?r:t.scope;const s=t.properties;if(s)for(const w in s){const A=s[w];if(o&&b(w,A)){delete s[w];continue}if(A.source=i,A.defaultDefaultValue=s[w].default,this.w(w,A),e.OVERRIDE_PROPERTY_REGEX.test(w)?A.scope=void 0:(A.scope=R.isUndefinedOrNull(A.scope)?r:A.scope,A.restricted=R.isUndefinedOrNull(A.restricted)?!!n?.includes(w):A.restricted),s[w].hasOwnProperty("included")&&!s[w].included){this.f[w]=s[w],delete s[w];continue}else this.d[w]=s[w],s[w].policy?.name&&this.e.set(s[w].policy.name,w);!s[w].deprecationMessage&&s[w].markdownDeprecationMessage&&(s[w].deprecationMessage=s[w].markdownDeprecationMessage),a.add(w)}const l=t.allOf;if(l)for(const w of l)this.p(w,o,i,n,r,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=i=>{const n=i.properties;if(n)for(const a in n)this.r(a,n[a]);i.allOf?.forEach(o)};o(t)}r(t,o){switch(e.allSettings.properties[t]=o,o.scope){case 1:e.applicationSettings.properties[t]=o;break;case 2:e.machineSettings.properties[t]=o;break;case 6:e.machineOverridableSettings.properties[t]=o;break;case 3:e.windowSettings.properties[t]=o;break;case 4:e.resourceSettings.properties[t]=o;break;case 5:e.resourceSettings.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.allSettings.properties[t],o.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,i={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(o,i),e.allSettings.properties[o]=i,e.applicationSettings.properties[o]=i,e.machineSettings.properties[o]=i,e.machineOverridableSettings.properties[o]=i,e.windowSettings.properties[o]=i,e.resourceSettings.properties[o]=i}}v(){const t={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,o){const i=this.a.get(t);let n=i?.value,r=i?.source;R.isUndefined(n)&&(n=o.defaultDefaultValue,r=void 0),R.isUndefined(n)&&(n=c(o.type)),o.default=n,o.defaultValueSource=r}}const k="\\[([^\\]]+)\\]",E=new RegExp(k,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${k})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function L(y){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(y)){let o=E.exec(y);for(;o?.length;){const i=o[1].trim();i&&t.push(i),o=E.exec(y)}}return(0,T.distinct)(t)}e.overrideIdentifiersFromKey=L;function f(y){return y.reduce((t,o)=>`${t}[${o}]`,"")}e.keyFromOverrideIdentifiers=f;function c(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const m=new g;h.Registry.add(e.Extensions.Configuration,m);function b(y,t){return y.trim()?e.OVERRIDE_PROPERTY_REGEX.test(y)?D.localize(7,null,y):m.getConfigurationProperties()[y]!==void 0?D.localize(8,null,y):t.policy?.name&&m.getPolicyConfigurations().get(t.policy?.name)!==void 0?D.localize(9,null,y,t.policy?.name,m.getPolicyConfigurations().get(t.policy?.name)):null:D.localize(6,null)}e.validateProperty=b;function d(){const y=[],t=m.getConfigurationProperties();for(const o of Object.keys(t))y.push([o,t[o].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=d}),define(Z[65],Q([0,1,19,3,50,2,36,30,4,11,23,42,37]),function(x,e,T,O,R,D,N,S,h,u,v,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function k(o){return Object.isFrozen(o)?o:S.deepFreeze(o)}class E{constructor(i={},n=[],r=[],a){this.b=i,this.c=n,this.d=r,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof E)return n;const r=new L("");return r.parseRaw(n),r.configurationModel});this.f=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,v.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const r=this.rawConfiguration.getValue(i),a=n?this.rawConfiguration.getOverrideValue(i,n):void 0,s=n?this.rawConfiguration.override(n).getValue(i):r;return{value:r,override:a,merged:s}}getOverrideValue(i,n){const r=this.i(n);return r?i?(0,v.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return T.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return T.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=S.deepClone(this.contents),r=S.deepClone(this.overrides),a=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const l of i)if(s.push(...l.raw?.length?l.raw:[l]),!l.isEmpty()){this.h(n,l.contents);for(const w of l.overrides){const[A]=r.filter(U=>T.equals(U.identifiers,w.identifiers));A?(this.h(A.contents,w.contents),A.keys.push(...w.keys),A.keys=T.distinct(A.keys)):r.push(S.deepClone(w))}for(const w of l.keys)a.indexOf(w)===-1&&a.push(w)}return new E(n,a,r,s.every(l=>l instanceof E)?void 0:s)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const a of T.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[a];const l=n[a];l&&(typeof s=="object"&&typeof l=="object"?(s=S.deepClone(s),this.h(s,l)):s=l),r[a]=s}return new E(r,this.keys,this.overrides)}h(i,n){for(const r of Object.keys(n)){if(r in i&&h.isObject(i[r])&&h.isObject(n[r])){this.h(i[r],n[r]);continue}i[r]=S.deepClone(n[r])}}i(i){let n=null,r=null;const a=s=>{s&&(r?this.h(r,s):r=S.deepClone(s))};for(const s of this.overrides)T.equals(s.identifiers,[i])?n=s.contents:s.identifiers.includes(i)&&a(s.contents);return a(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,v.removeFromValueTree)(this.contents,i),p.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>T.equals(r.identifiers,(0,p.overrideIdentifiersFromKey)(i))),1))}j(i,n,r){(0,v.addToValueTree)(this.contents,i,n,a=>console.error(a)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),p.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,p.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,v.toValuesTree)(this.contents[i],a=>console.error(a))})}}e.ConfigurationModel=E;class L{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!h.isUndefinedOrNull(i)){const r=this.g(i);this.parseRaw(r,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:r,keys:a,overrides:s,restricted:l,hasExcludedProperties:w}=this.h(i,n);this.b=new E(r,a,s,w?[i]:void 0),this.c=l||[]}g(i){let n={},r=null,a=[];const s=[],l=[];function w(U){Array.isArray(a)?a.push(U):r!==null&&(a[r]=U)}const A={onObjectBegin:()=>{const U={};w(U),s.push(a),a=U,r=null},onObjectProperty:U=>{r=U},onObjectEnd:()=>{a=s.pop()},onArrayBegin:()=>{const U=[];w(U),s.push(a),a=U,r=null},onArrayEnd:()=>{a=s.pop()},onLiteralValue:w,onError:(U,Y,X)=>{l.push({error:U,offset:Y,length:X})}};if(i)try{R.visit(i,A),n=a[0]||{}}catch(U){console.error(`Error while parsing settings file ${this.f}: ${U}`),this.d=[U]}return n}h(i,n){const r=g.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),a=this.i(i,r,!0,n);i=a.raw;const s=(0,v.toValuesTree)(i,A=>console.error(`Conflict in settings file ${this.f}: ${A}`)),l=Object.keys(i),w=this.j(i,A=>console.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:s,keys:l,overrides:w,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(i,n,r,a){let s=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:s};const l={},w=[];for(const A in i)if(p.OVERRIDE_PROPERTY_REGEX.test(A)&&r){const U=this.i(i[A],n,!1,a);l[A]=U.raw,s=s||U.hasExcludedProperties,w.push(...U.restricted)}else{const U=n[A],Y=U?typeof U.scope<"u"?U.scope:3:void 0;U?.restricted&&w.push(A),(Y===void 0||a.scopes===void 0||a.scopes.includes(Y))&&!(a.skipRestricted&&U?.restricted)?l[A]=i[A]:s=!0}return{raw:l,restricted:w,hasExcludedProperties:s}}j(i,n){const r=[];for(const a of Object.keys(i))if(p.OVERRIDE_PROPERTY_REGEX.test(a)){const s={};for(const l in i[a])s[l]=i[a][l];r.push({identifiers:(0,p.overrideIdentifiersFromKey)(a),keys:Object.keys(s),contents:(0,v.toValuesTree)(s,n)})}return r}}e.ConfigurationModelParser=L;class f extends D.Disposable{constructor(i,n,r,a){super(),this.f=i,this.g=n,this.h=a,this.c=this.B(new O.Emitter),this.onDidChange=this.c.event,this.a=new L(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(O.Event.any(O.Event.filter(this.h.onDidFilesChange,s=>s.contains(this.f)),O.Event.filter(this.h.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&r.isEqual(s.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new E}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=f;class c{constructor(i,n,r,a,s,l,w,A,U,Y,X,ee,ie){this.a=i,this.b=n,this.c=r,this.overrideIdentifiers=a,this.d=s,this.f=l,this.g=w,this.h=A,this.i=U,this.j=Y,this.k=X,this.l=ee,this.m=ie}get value(){return k(this.c)}n(i,n,r){const a=i.inspect(n,r);return{get value(){return k(a.value)},get override(){return k(a.override)},get merged(){return k(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class m{constructor(i,n,r,a,s=new E,l=new E,w=new N.ResourceMap,A=new E,U=new N.ResourceMap){this.c=i,this.d=n,this.f=r,this.g=a,this.h=s,this.i=l,this.j=w,this.l=A,this.m=U,this.a=null,this.b=new N.ResourceMap,this.n=null}getValue(i,n,r){return this.q(i,n,r).getValue(i)}updateValue(i,n,r={}){let a;r.resource?(a=this.m.get(r.resource),a||(a=new E,this.m.set(r.resource,a))):a=this.l,n===void 0?a.removeValue(i):a.setValue(i,n),r.resource||(this.a=null)}inspect(i,n,r){const a=this.q(i,n,r),s=this.u(n.resource,r),l=n.resource?this.m.get(n.resource)||this.l:this.l,w=new Set;for(const A of a.overrides)for(const U of A.identifiers)a.getOverrideValue(i,U)!==void 0&&w.add(U);return new c(i,n,a.getValue(i),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,s||void 0,l)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:a,updated:s,removed:l}=y(this.c,i);n=[...a,...s,...l]}for(const a of n)for(const s of(0,p.overrideIdentifiersFromKey)(a)){const l=this.c.getKeysForOverrideIdentifier(s),w=i.getKeysForOverrideIdentifier(s),A=[...w.filter(U=>l.indexOf(U)===-1),...l.filter(U=>w.indexOf(U)===-1),...l.filter(U=>!S.equals(this.c.override(s).getValue(U),i.override(s).getValue(U)))];r.push([s,A])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:a}=y(this.d,i),s=[...n,...r,...a];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:a,overrides:s}=y(this.applicationConfiguration,i),l=[...n,...r,...a];return l.length&&this.updateApplicationConfiguration(i),{keys:l,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:a,overrides:s}=y(this.localUserConfiguration,i),l=[...n,...r,...a];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:a,overrides:s}=y(this.remoteUserConfiguration,i),l=[...n,...r,...a];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:a,overrides:s}=y(this.workspaceConfiguration,i),l=[...n,...r,...a];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:s}}compareAndUpdateFolderConfiguration(i,n){const r=this.p.get(i),{added:a,updated:s,removed:l,overrides:w}=y(r,n),A=[...a,...s,...l];return(A.length||!r)&&this.updateFolderConfiguration(i,n),{keys:A,overrides:w}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:a,removed:s,overrides:l}=y(n,void 0);return{keys:[...r,...a,...s],overrides:l}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,r){let a=this.r(n,r);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(a=a.merge(this.d)),a}r({resource:i},n){let r=this.s();if(n&&i){const a=n.getFolder(i);a&&(r=this.t(a.uri)||r);const s=this.m.get(i);s&&(r=r.merge(s))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const r=this.s(),a=this.j.get(i);a?(n=r.merge(a),this.b.set(i,n)):n=r}return n}u(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:r,overrides:a,keys:s}=this.j.get(n);return i.push([n,{contents:r,overrides:a,keys:s}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(a=>n.add(a))),[...n.values()]}static parse(i){const n=this.x(i.defaults),r=this.x(i.policy),a=this.x(i.application),s=this.x(i.user),l=this.x(i.workspace),w=i.folders.reduce((A,U)=>(A.set(u.URI.revive(U[0]),this.x(U[1])),A),new N.ResourceMap);return new m(n,r,a,s,new E,l,w,new E,new N.ResourceMap)}static x(i){return new E(i.contents,i.keys,i.overrides)}}e.Configuration=m;function b(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const i=new Set,n=new Map;for(const a of o)a.keys.forEach(s=>i.add(s)),a.overrides.forEach(([s,l])=>{const w=(0,N.getOrSet)(n,s,new Set);l.forEach(A=>w.add(A))});const r=[];return n.forEach((a,s)=>r.push([s,[...a.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=b;class d{constructor(i,n,r,a){this.change=i,this.f=n,this.g=r,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const s of i.keys)this.affectedKeys.add(s);for(const[,s]of i.overrides)for(const l of s)this.affectedKeys.add(l);this.d=this.a;for(const s of this.affectedKeys)this.d+=s+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=m.parse(this.f.data)),this.i}affectsConfiguration(i,n){const r=this.a+i,a=this.d.indexOf(r);if(a<0)return!1;const s=a+r.length;if(s>=this.d.length)return!1;const l=this.d.charCodeAt(s);if(l!==this.b&&l!==this.c)return!1;if(n){const w=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,A=this.g.getValue(i,n,this.h);return!S.equals(w,A)}return!0}}e.ConfigurationChangeEvent=d;function y(o,i){const{added:n,removed:r,updated:a}=t(i?.rawConfiguration,o?.rawConfiguration),s=[],l=o?.getAllOverrideIdentifiers()||[],w=i?.getAllOverrideIdentifiers()||[];if(i){const A=w.filter(U=>!l.includes(U));for(const U of A)s.push([U,i.getKeysForOverrideIdentifier(U)])}if(o){const A=l.filter(U=>!w.includes(U));for(const U of A)s.push([U,o.getKeysForOverrideIdentifier(U)])}if(i&&o){for(const A of l)if(w.includes(A)){const U=t({contents:o.getOverrideValue(void 0,A)||{},keys:o.getKeysForOverrideIdentifier(A)},{contents:i.getOverrideValue(void 0,A)||{},keys:i.getKeysForOverrideIdentifier(A)});s.push([A,[...U.added,...U.removed,...U.updated]])}}return{added:n,removed:r,updated:a,overrides:s}}function t(o,i){const n=o?i?o.keys.filter(s=>i.keys.indexOf(s)===-1):[...o.keys]:[],r=i?o?i.keys.filter(s=>o.keys.indexOf(s)===-1):[...i.keys]:[],a=[];if(o&&i){for(const s of i.keys)if(o.keys.indexOf(s)!==-1){const l=(0,v.getConfigurationValue)(i.contents,s),w=(0,v.getConfigurationValue)(o.contents,s);S.equals(l,w)||a.push(s)}}return{added:n,removed:r,updated:a}}}),define(Z[124],Q([0,1,19,3,2,30,4,65,42,10,38,37]),function(x,e,T,O,R,D,N,S,h,u,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class g extends R.Disposable{constructor(){super(...arguments),this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new S.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(p.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:c})=>this.c(Array.from(f),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(f,c){this.h(f,p.Registry.as(h.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:f})}f(){return{}}g(){this.b=new S.ConfigurationModel;const f=p.Registry.as(h.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(f),f)}h(f,c){const m=this.f();for(const b of f){const d=m[b],y=c[b];d!==void 0?this.b.addValue(b,d):y?this.b.addValue(b,y.default):this.b.removeValue(b)}}}e.DefaultConfiguration=g;class k{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new S.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=k;let E=class extends R.Disposable{get configurationModel(){return this.b}constructor(f,c,m){super(),this.c=f,this.f=c,this.g=m,this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new S.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(f=>this.i(f))),this.B(this.c.onDidChangeConfiguration(async({properties:f})=>this.j(await this.h(f),!0))),this.b}async h(f){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",f);const c={},m=[],b=p.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const d of f){const y=b[d];if(!y){m.push(d);continue}if(y.policy){if(y.type!=="string"&&y.type!=="number"){this.g.warn(`Policy ${y.policy.name} has unsupported type ${y.type}`);continue}m.push(d),c[y.policy.name]={type:y.type}}}return(0,N.isEmptyObject)(c)||await this.f.updatePolicyDefinitions(c),m}i(f){this.g.trace("PolicyConfiguration#onDidChangePolicies",f);const c=p.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),m=(0,T.coalesce)(f.map(b=>c.get(b)));this.j(m,!0)}j(f,c){this.g.trace("PolicyConfiguration#update",f);const m=p.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),b=[],d=this.b.isEmpty();for(const y of f){const t=m[y]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(d?o!==void 0:!(0,D.equals)(this.b.getValue(y),o))&&b.push([y,o])}else this.b.getValue(y)!==void 0&&b.push([y,void 0])}if(b.length){this.g.trace("PolicyConfiguration#changed",b);const y=this.b;this.b=new S.ConfigurationModel;for(const t of y.keys)this.b.setValue(t,y.getValue(t));for(const[t,o]of b)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);c&&this.a.fire(this.b)}}};E=de([_(1,v.IPolicyService),_(2,u.ILogService)],E),e.PolicyConfiguration=E}),define(Z[125],Q([0,1,5,3,2,18,23,65,124,38]),function(x,e,T,O,R,D,N,S,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class v extends R.Disposable{constructor(g,k,E,L){super(),this.i=g,this.h=this.B(new O.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.DefaultConfiguration),this.c=E instanceof u.NullPolicyService?new h.NullPolicyConfiguration:this.B(new h.PolicyConfiguration(this.b,E,L)),this.f=this.B(new S.UserSettings(this.i,void 0,D.extUriBiasedIgnorePathCase,k)),this.a=new S.Configuration(this.b.configurationModel,this.c.configurationModel,new S.ConfigurationModel,new S.ConfigurationModel),this.g=this.B(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:f,properties:c})=>this.k(f,c))),this.B(this.c.onDidChangeConfiguration(f=>this.l(f))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,k,E]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.Configuration(g,k,new S.ConfigurationModel,E)}getConfigurationData(){return this.a.toData()}getValue(g,k){const E=typeof g=="string"?g:void 0,L=(0,N.isConfigurationOverrides)(g)?g:(0,N.isConfigurationOverrides)(k)?k:{};return this.a.getValue(E,L,void 0)}updateValue(g,k,E,L){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.j(g)}j(g){const k=this.a.toData(),E=this.a.compareAndUpdateLocalUserConfiguration(g);this.m(E,k,2)}k(g,k){const E=this.a.toData(),L=this.a.compareAndUpdateDefaultConfiguration(g,k);this.m(L,E,7)}l(g){const k=this.a.toData(),E=this.a.compareAndUpdatePolicyConfiguration(g);this.m(E,k,7)}m(g,k,E){const L=new S.ConfigurationChangeEvent(g,{data:k},this.a);L.source=E,L.sourceConfig=this.n(E),this.h.fire(L)}n(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=v}),define(Z[66],Q([0,1,16]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(u){return u.scheme===T.Schemas.vscodeRemote?u.authority:void 0}e.getRemoteAuthority=O;function R(u){if(!u)return;const v=u.indexOf("+");return v<0?u:u.substr(0,v)}e.getRemoteName=R;function D(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.getRemoteServerRootPath=D;function N(u){const{host:v,port:p}=h(u);if(typeof p>"u")throw new Error("Remote authority doesn't contain a port!");return{host:v,port:p}}e.parseAuthorityWithPort=N;function S(u,v){let{host:p,port:g}=h(u);return typeof g>"u"&&(g=v),{host:p,port:g}}e.parseAuthorityWithOptionalPort=S;function h(u){const v=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(v)return{host:v[1],port:parseInt(v[2],10)};const p=u.match(/^(\[[0-9a-z:]+\])$/);if(p)return{host:p[1],port:void 0};const g=u.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:u,port:void 0}}}),define(Z[29],Q([0,1,32,9,66]),function(x,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=D;function N(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(S=e.ExtensionType||(e.ExtensionType={}));var h;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(h=e.TargetPlatform||(e.TargetPlatform={}));class u{constructor(L){this.value=L,this.c=L.toLowerCase()}static equals(L,f){if(typeof L>"u"||L===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof L=="string"||typeof f=="string"){const c=typeof L=="string"?L:L.value,m=typeof f=="string"?f:f.value;return T.equalsIgnoreCase(c,m)}return L.c===f.c}static toKey(L){return typeof L=="string"?L.toLowerCase():L.c}}e.ExtensionIdentifier=u;function v(E){return p(E)}e.isApplicationScopedExtension=v;function p(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function g(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=g;function k(E,L){if(L){const f=`onResolveRemoteAuthority:${(0,R.getRemoteName)(L)}`;return E.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=k,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[126],Q([0,1,2,14,20,29]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends T.Disposable{constructor(h,u){super(),this.b=h,this.a=(0,O.join)(this.b.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this.B(u.onDidInstallExtensions(v=>this.c(v))),this.B(u.onDidUninstallExtension(v=>this.f(v)))}c(h){h.some(u=>!!u.local)&&this.invalidate()}f(h){h.error||this.invalidate()}invalidate(){R.Promises.rm(this.a,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=N}),define(Z[47],Q([0,1,15,99,42,9,37]),function(x,e,T,O,R,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function S(L){return L.res.statusCode&&L.res.statusCode>=200&&L.res.statusCode<300||L.res.statusCode===1223}e.isSuccess=S;function h(L){return L.res.statusCode===204}async function u(L){return h(L)?null:(await(0,T.streamToBuffer)(L.stream)).toString()}e.asText=u;async function v(L){if(!S(L))throw new Error("Server returned "+L.res.statusCode);return u(L)}e.asTextOrError=v;async function p(L){if(!S(L))throw new Error("Server returned "+L.res.statusCode);if(h(L))return null;const c=(await(0,T.streamToBuffer)(L.stream)).toString();try{return JSON.parse(c)}catch(m){throw m.message+=`:
`+c,m}}e.asJson=p;function g(L){E(L)}e.updateProxyConfigurationsScope=g;let k;function E(L){const f=N.Registry.as(R.Extensions.Configuration),c=k;k={id:"http",order:15,title:(0,O.localize)(0,null),type:"object",scope:L,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(4,null),(0,O.localize)(5,null),(0,O.localize)(6,null),(0,O.localize)(7,null)],default:"override",description:(0,O.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[k],remove:c?[c]:[]})}E(2)}),define(Z[127],Q([0,1,22,16,13,47]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let N=class{constructor(h,u){this.a=h,this.b=u}async download(h,u,v=T.CancellationToken.None){if(h.scheme===O.Schemas.file||h.scheme===O.Schemas.vscodeRemote){await this.b.copy(h,u);return}const p={type:"GET",url:h.toString(!0)},g=await this.a.request(p,v);if(g.res.statusCode===200)await this.b.writeFile(u,g.stream);else{const k=await(0,D.asTextOrError)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${k}`)}}};N=de([_(0,D.IRequestService),_(1,R.IFileService)],N),e.DownloadService=N}),define(Z[128],Q([0,1,129,4]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function R(N,S){return N.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:N.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function D(N,S,h={}){const u=(0,T.parse)(N),v=h.proxyUrl||R(u,S);if(!v)return null;const p=(0,T.parse)(v);if(!/^https?:$/.test(p.protocol||""))return null;const g={host:p.hostname||"",port:p.port||(p.protocol==="https"?"443":"80"),auth:p.auth,rejectUnauthorized:(0,O.isBoolean)(h.strictSSL)?h.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((k,E)=>{x(["http-proxy-agent"],k,E)}))(g):new(await new Promise((k,E)=>{x(["https-proxy-agent"],k,E)}))(g)}e.getProxyAgent=D}),define(Z[130],Q([0,1,57,14,100,22,34,6,12,31,82,162,5,71]),function(x,e,T,O,R,D,N,S,h,u,v,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let E;async function L(c,m,b,d){return b["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,p.isLaunchedFromCli)(d)&&!b["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,p.isLaunchedFromCli)(d)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=g.Promises.withAsyncBody(async(y,t)=>{const o=new D.CancellationTokenSource;let i=1e4;const n=c.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,k.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{o.dispose(!0),t(new Error((0,R.localize)(0,null)))},i);try{y(await f(m,o.token))}catch(a){!(0,S.isCancellationError)(a)&&!o.token.isCancellationRequested?t(new Error((0,R.localize)(1,null,(0,N.toErrorMessage)(a)))):y({})}finally{clearTimeout(r),o.dispose()}})),E)}e.getResolvedShellEnv=L;async function f(c,m){const b=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",b);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",d);const y=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(y+"({.*})"+y),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",o);const i=await(0,v.getSystemShell)(h.OS,o);return c.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(m.isCancellationRequested)return r(new S.CancellationError);const a=(0,O.basename)(i);let s,l;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(s=`& '${process.execPath}' ${w} -p '''${y}'' + JSON.stringify(process.env) + ''${y}'''`,l=["-Login","-Command"]):(s=`'${process.execPath}' ${w} -p '"${y}" + JSON.stringify(process.env) + "${y}"'`,a==="tcsh"||a==="csh"?l=["-ic"]:l=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),s);const A=(0,T.spawn)(i,[...l,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});m.onCancellationRequested(()=>(A.kill(),r(new S.CancellationError))),A.on("error",X=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,N.toErrorMessage)(X)),r(X)});const U=[];A.stdout.on("data",X=>U.push(X));const Y=[];A.stderr.on("data",X=>Y.push(X)),A.on("close",(X,ee)=>{const ie=Buffer.concat(U).toString("utf8");c.trace("getUnixShellEnvironment#raw",ie);const ne=Buffer.concat(Y).toString("utf8");if(ne.trim()&&c.trace("getUnixShellEnvironment#stderr",ne),X||ee)return r(new Error((0,R.localize)(2,null,X,ee)));const ae=t.exec(ie),fe=ae?ae[1]:"{}";try{const re=JSON.parse(fe);b?re.ELECTRON_RUN_AS_NODE=b:delete re.ELECTRON_RUN_AS_NODE,d?re.ELECTRON_NO_ATTACH_CONSOLE=d:delete re.ELECTRON_NO_ATTACH_CONSOLE,delete re.VSCODE_RESOLVING_ENVIRONMENT,delete re.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",re),n(re)}catch(re){c.error("getUnixShellEnvironment#errorCaught",(0,N.toErrorMessage)(re)),r(re)}})})}}),define(Z[67],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,T.createDecorator)("stateService")}),define(Z[131],Q([0,1,5,15,4,17,13,10]),function(x,e,T,O,R,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class h{constructor(p,g,k){this.f=p,this.g=g,this.h=k,this.a=Object.create(null),this.b="",this.c=new T.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==1&&this.g.error(p)}}getItem(p,g){const k=this.a[p];return(0,R.isUndefinedOrNull)(k)?g:k}setItem(p,g){this.setItems([{key:p,data:g}])}setItems(p){let g=!1;for(const{key:k,data:E}of p)this.a[k]!==E&&((0,R.isUndefinedOrNull)(E)?(0,R.isUndefined)(this.a[k])||(this.a[k]=void 0,g=!0):(this.a[k]=E,g=!0));g&&this.j()}removeItem(p){(0,R.isUndefined)(this.a[p])||(this.a[p]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.h.writeFile(this.f,O.VSBuffer.fromString(p)),this.b=p}catch(g){this.g.error(g)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=h;let u=class{constructor(p,g,k){this.a=new h(p.stateResource,g,k)}async init(){await this.a.init()}getItem(p,g){return this.a.getItem(p,g)}};u=de([_(0,D.IEnvironmentService),_(1,S.ILogService),_(2,N.IFileService)],u),e.StateService=u}),define(Z[68],Q([0,1,12,35,11,31]),function(x,e,T,O,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(u){if(T.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}async function S(u,v,p,g,k,E,L,f,c,m){const b=Object.create(null);b["common.machineId"]=L,b.sessionID=(0,D.generateUuid)()+Date.now(),b.commitHash=k,b.version=E,b["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,T.PlatformToString)(T.platform),b["common.nodePlatform"]=O.platform,b["common.nodeArch"]=g,b["common.product"]=m||"desktop",f&&(b["common.msftInternal"]=f);let d=0;const y=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-y,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),T.isLinuxSnap&&(b["common.snap"]="true");const t=N(p);t&&(b["common.platformDetail"]=t);try{const o=await u.readFile(R.URI.file(c));b["common.source"]=o.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=S;function h(u){const v=O.env.USERDNSDOMAIN;if(!v)return!1;const p=v.toLowerCase();return u.some(g=>p===g)}e.verifyMicrosoftInternalDomain=h}),define(Z[25],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(O=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[39],Q([0,1,30,4,3,23,66,68,25]),function(x,e,T,O,R,D,N,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class u{constructor(s){this.value=s}}e.TelemetryTrustedValue=u;class v{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(s,l){return Promise.resolve(void 0)}publicLog2(s,l){return this.publicLog(s,l)}publicLogError(s,l){return Promise.resolve(void 0)}publicLogError2(s,l){return this.publicLogError(s,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=v,e.NullTelemetryService=new v;class p{async publicLog(s,l,w){}async publicLogError(s,l,w){}}e.NullEndpointTelemetryService=p,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(a,s){return R.Event.debounce(s.onDidChangeConfiguration,(w,A)=>{const U=w?new Set([...w.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:U}},1e3,!0)(w=>{w.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(w.source),configurationKeys:d(w.affectedKeys)})})}e.configurationTelemetry=g;function k(a,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!a.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=k;function E(a,s){return!(s.isBuilt||s.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=E;function L(a){const s=a.getValue(h.TELEMETRY_SETTING_ID),l=a.getValue(h.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(h.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=L;function f(a){const s={},l={},w={};b(a,w);for(let A in w){A=A.length>150?A.substr(A.length-149):A;const U=w[A];typeof U=="number"?l[A]=U:typeof U=="boolean"?l[A]=U?1:0:typeof U=="string"?(U.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${U.length}`),s[A]=U.substring(0,8191)):typeof U<"u"&&U!==null&&(s[A]=U)}return{properties:s,measurements:l}}e.validateTelemetryData=f;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function m(a){if(!a)return"none";const s=(0,N.getRemoteName)(a);return c.has(s)?s:"other"}e.cleanRemoteAuthority=m;function b(a,s,l=0,w){if(!!a)for(const A of Object.getOwnPropertyNames(a)){const U=a[A],Y=w?w+A:A;Array.isArray(U)?s[Y]=(0,T.safeStringify)(U):U instanceof Date?s[Y]=U.toISOString():(0,O.isObject)(U)?l<2?b(U,s,l+1,Y+"."):s[Y]=(0,T.safeStringify)(U):s[Y]=U}}function d(a){if(!a)return[];const s=[];return y(s,"",a),s}function y(a,s,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(w=>y(a,s?`${s}.${w}`:w,l[w])):a.push(s)}function t(a,s){const l=a.msftInternalDomains||[],w=s.getValue("telemetry.internalTesting");return(0,S.verifyMicrosoftInternalDomain)(l)||w}e.isInternalTelemetry=t;function o(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=o;function i(a,s){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let l=a;const w=[];for(const X of s)for(;;){const ee=X.exec(a);if(!ee)break;w.push([ee.index,X.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,U=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let Y=0;for(l="";;){const X=U.exec(a);if(!X)break;const ee=w.some(([ie,ne])=>X.index<ne&&ie<U.lastIndex);!A.test(X[0])&&!ee&&(l+=a.substring(Y,X.index)+"<REDACTED: user-file-path>",Y=U.lastIndex)}return Y<a.length&&(l+=a.substr(Y)),l}function n(a){if(!a)return a;const s=a.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const w of l)if(w.regex.test(s))return`<REDACTED: ${w.label}>`;return a}function r(a,s){return(0,T.cloneAndChange)(a,l=>{if(l instanceof u)return l.value;if(typeof l=="string"){let w=l.replaceAll("%20"," ");w=i(w,s);for(const A of s)w=w.replace(A,"");return w=n(w),w}})}e.cleanData=r}),define(Z[26],Q([0,1,32,24,29,12,11,6,35,39]),function(x,e,T,O,R,D,N,S,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function v(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,T.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=v;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(n){const r=n.manifest?n.manifest.version:n.version,a=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new g(n.identifier,r,a)}static parse(n){const r=p.exec(n);return r&&r[1]&&r[2]?new g({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,a="undefined"){this.version=r,this.targetPlatform=a,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof g?v(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=g;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(i){const n=k.exec(i);return n&&n[1]?[f(n[1]),n[2]]:[f(i),void 0]}e.getIdAndVersion=E;function L(i,n){return`${i}.${n}`}e.getExtensionId=L;function f(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=f;function c(i,n){return f(L(i,n))}e.getGalleryExtensionId=c;function m(i,n){const r=[],a=s=>{for(const l of r)if(l.some(w=>v(n(w),n(s))))return l;return null};for(const s of i){const l=a(s);l?l.push(s):r.push([s])}return r}e.groupByExtension=m;function b(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function d(i){return{id:new u.TelemetryTrustedValue(i.identifier.id),name:new u.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=d,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function y(i,n){const r=[],a=n.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const s=a.shift();if(s&&r.every(l=>!v(l.identifier,{id:s}))){const l=i.filter(w=>v(w.identifier,{id:s}));l.length===1&&(r.push(l[0]),a.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=y;async function t(i,n){if(!D.isLinux)return!1;let r;try{r=(await i.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){n.debug("Error while getting the os-release file.",(0,S.getErrorMessage)(s))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function o(i,n){const r=await t(i,n),a=(0,O.getTargetPlatform)(r?"alpine":D.platform,h.arch);return n.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=o}),define(Z[132],Q([0,1,22,6,16,18,41,11,89,24,26,29]),function(x,e,T,O,R,D,N,S,h,u,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const g=f=>(0,h.localize)(0,null,f),k=(0,h.localize)(1,null,"ms-dotnettools.csharp");function E(f,c){return c?`${f.publisher}.${f.name}@${f.version}`:`${f.publisher}.${f.name}`}let L=class{constructor(c,m){this.a=c,this.b=m}get d(){}async listExtensions(c,m,b,d=console){let y=await this.a.getInstalled(1,b);const t=p.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(m&&m!==""){if(t.indexOf(m.toLowerCase())<0){d.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}y=y.filter(i=>i.manifest.categories?i.manifest.categories.map(r=>r.toLowerCase()).indexOf(m.toLowerCase())>-1:!1)}else if(m===""){d.log("Possible Categories: "),t.forEach(i=>{d.log(i)});return}this.d&&d.log((0,h.localize)(2,null,this.d)),y=y.sort((i,n)=>i.identifier.id.localeCompare(n.identifier.id));let o;for(const i of y)o!==i.identifier.id&&(o=i.identifier.id,d.log(E(i.manifest,c)))}async installExtensions(c,m,b,d,y=console){const t=[],o=[];c.length&&y.log(this.d?(0,h.localize)(3,null,this.d):(0,h.localize)(4,null));const i=await this.a.getInstalled(1,b.profileLocation),n=(l,w)=>{const A=i.find(U=>(0,v.areSameExtensions)(U.identifier,{id:l}));if(A){if(!d&&(!w||w==="prerelease"&&A.preRelease))return y.log((0,h.localize)(5,null,l,A.manifest.version,l)),!1;if(w&&A.manifest.version===w)return y.log((0,h.localize)(6,null,`${l}@${w}`)),!1}return!0},r=(l,w,A)=>{s.push({id:l,version:w!=="prerelease"?w:void 0,installOptions:{...b,isBuiltin:A,installPreReleaseVersion:w==="prerelease"||b.installPreReleaseVersion}})},a=[],s=[];for(const l of c)if(l instanceof S.URI)a.push(l);else{const[w,A]=(0,v.getIdAndVersion)(l);n(w,A)&&r(w,A,!1)}for(const l of m){const[w,A]=(0,v.getIdAndVersion)(l);n(w,A)&&r(w,A,!0)}if(a.length&&await Promise.all(a.map(async l=>{try{const w=await this.f(l,{...b,isBuiltin:!1},d,y);w&&o.push(w)}catch(w){y.error(w.message||w.stack||w),t.push(l.toString())}})),s.length){const l=await this.g(s);await Promise.all(s.map(async w=>{const A=l.get(w.id.toLowerCase());if(A)try{const U=await this.h(w,A,i,d,y);U&&o.push(U)}catch(U){y.error(U.message||U.stack||U),t.push(w.id)}else y.error(`${g(w.version?`${w.id}@${w.version}`:w.id)}
${k}`),t.push(w.id)}))}if(t.length)throw new Error((0,h.localize)(7,null,t.join(", ")))}async f(c,m,b,d){const y=await this.a.getManifest(c);if(!y)throw new Error("Invalid vsix");if(await this.k(y,b,m.profileLocation,d))try{return await this.a.install(c,m),d.log((0,h.localize)(8,null,(0,D.basename)(c))),y}catch(o){if((0,O.isCancellationError)(o))return d.log((0,h.localize)(9,null,(0,D.basename)(c))),null;throw o}return null}async g(c){const m=new Map,b=c.some(y=>y.installOptions.installPreReleaseVersion),d=await this.b.getExtensions(c.map(y=>({...y,preRelease:b})),T.CancellationToken.None);for(const y of d)m.set(y.identifier.id.toLowerCase(),y);return m}async h({id:c,version:m,installOptions:b},d,y,t,o){const i=await this.b.getManifest(d,T.CancellationToken.None);if(i&&!this.j(i,o))return null;const n=y.find(r=>(0,v.areSameExtensions)(r.identifier,d.identifier));if(n){if(d.version===n.manifest.version)return o.log((0,h.localize)(10,null,m?`${c}@${m}`:c)),null;o.log((0,h.localize)(11,null,c,d.version))}try{b.isBuiltin?o.log(m?(0,h.localize)(12,null,c,m):(0,h.localize)(13,null,c)):o.log(m?(0,h.localize)(14,null,c,m):(0,h.localize)(15,null,c));const r=await this.a.installFromGallery(d,{...b,installGivenVersion:!!m});return o.log((0,h.localize)(16,null,c,r.manifest.version)),i}catch(r){if((0,O.isCancellationError)(r))return o.log((0,h.localize)(17,null,c)),null;throw r}}j(c,m){return!0}async k(c,m,b,d){const y={id:(0,v.getGalleryExtensionId)(c.publisher,c.name)},o=(await this.a.getInstalled(1,b)).find(i=>(0,v.areSameExtensions)(y,i.identifier)&&(0,N.gt)(i.manifest.version,c.version));return o&&!m?(d.log((0,h.localize)(18,null,o.identifier.id,o.manifest.version,c.version)),!1):this.j(c,d)}async uninstallExtensions(c,m,b,d=console){const y=async o=>{if(o instanceof S.URI){const i=await this.a.getManifest(o);return E(i)}return o},t=[];for(const o of c){const i=await y(o),r=(await this.a.getInstalled(void 0,b)).filter(a=>(0,v.areSameExtensions)(a.identifier,{id:i}));if(!r.length)throw new Error(`${this.l(i)}
${k}`);if(r.some(a=>a.type===0)){d.log((0,h.localize)(19,null,i));return}if(!m&&r.some(a=>a.isBuiltin)){d.log((0,h.localize)(20,null,i));return}d.log((0,h.localize)(21,null,i));for(const a of r)await this.a.uninstall(a,{profileLocation:b}),t.push(a);this.d?d.log((0,h.localize)(22,null,i,this.d)):d.log((0,h.localize)(23,null,i))}}async locateExtension(c,m=console){const b=await this.a.getInstalled();c.forEach(d=>{b.forEach(y=>{if(y.identifier.id===d&&y.location.scheme===R.Schemas.file){m.log(y.location.fsPath);return}})})}l(c){return this.d?(0,h.localize)(24,null,c,this.d):(0,h.localize)(25,null,c)}};L=de([_(0,u.IExtensionManagementService),_(1,u.IExtensionGalleryService)],L),e.ExtensionManagementCLI=L}),define(Z[133],Q([0,1,5,6,2,16,12,18,41,4,31,20,23,17,24,26,59,13,10,28]),function(x,e,T,O,R,D,N,S,h,u,v,p,g,k,E,L,f,c,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let d=class Ve extends R.Disposable{constructor(t,o,i,n,r,a,s){super(),this.h=o,this.i=i,this.j=n,this.k=r,this.l=a,this.m=s,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.v()}async download(t,o){await this.g;const i=(0,S.joinPath)(this.extensionsDownloadDir,this.w(t));try{await this.t(t,i,r=>this.i.download(t,r,o))}catch(r){throw new E.ExtensionManagementError(r.message,E.ExtensionManagementErrorCode.Download)}let n="Unverified";if(await this.n(t)){const r=await this.r(t);try{await this.l.verify(i.fsPath,r.fsPath)&&(n="Verified"),this.m.info(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`)}catch(a){const s=a.code;if(s==="UnknownError")n="UnknownError",this.m.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`);else throw await this.delete(r),await this.delete(i),new E.ExtensionManagementError(s,E.ExtensionManagementErrorCode.Signature)}}return{location:i,verificationStatus:n}}async n(t){if(!t.isSigned)return!1;const o=this.j.getValue("extensions.verifySignature");return(0,u.isBoolean)(o)?o:this.k.quality!=="stable"}async r(t){await this.g;const o=(0,S.joinPath)(this.extensionsDownloadDir,`${this.w(t)}${Ve.c}`);return await this.t(t,o,i=>this.i.downloadSignatureArchive(t,i)),o}async t(t,o,i){if(await this.h.exists(o))return;if(o.scheme!==D.Schemas.file){await i(o);return}const n=(0,S.joinPath)(this.extensionsDownloadDir,`.${(0,v.generateUuid)()}`);await this.h.exists(n)||await i(n);try{await this.u(n,o,Date.now()+2*60*1e3)}catch(r){try{await this.h.del(n)}catch{}if(r.code==="ENOTEMPTY")this.m.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,o.path);else throw this.m.info(`Rename failed because of ${(0,O.getErrorMessage)(r)}. Deleted the file from downloaded location`,n.path),r}}async delete(t){await this.g,await this.h.del(t)}async u(t,o,i){try{await p.Promises.rename(t.fsPath,o.fsPath)}catch(n){if(N.isWindows&&n&&n.code==="EPERM"&&Date.now()<i)return this.m.info(`Failed renaming ${t} to ${o} with 'EPERM' error. Trying again...`),this.u(t,o,i);throw n}}async v(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.m.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const o=[],i=[],n=[];for(const s of t.children)if(s.name.endsWith(Ve.c))n.push(s.resource);else{const l=L.ExtensionKey.parse(s.name);l&&i.push([l,s])}const r=(0,L.groupByExtension)(i,([s])=>s),a=[];for(const s of r)s.sort((l,w)=>h.rcompare(l[0].version,w[0].version)),o.push(...s.slice(1).map(l=>l[1].resource)),a.push(s[0][1]);a.sort((s,l)=>s.mtime-l.mtime),o.push(...a.slice(0,Math.max(0,a.length-this.f)).map(s=>s.resource)),o.push(...n),await T.Promises.settled(o.map(s=>(this.m.trace("Deleting from cache",s.path),this.h.del(s))))}}catch(t){this.m.error(t)}}w(t){return this.f?L.ExtensionKey.create(t).toString().toLowerCase():(0,v.generateUuid)()}};d.c=".sigzip",d=de([_(0,k.INativeEnvironmentService),_(1,c.IFileService),_(2,E.IExtensionGalleryService),_(3,g.IConfigurationService),_(4,b.IProductService),_(5,f.IExtensionSignatureVerificationService),_(6,m.ILogService)],d),e.ExtensionsDownloader=d}),define(Z[134],Q([0,1,3,2,36,26,29]),function(x,e,T,O,R,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class S extends O.Disposable{constructor(u,v,p,g,k,E,L){super(),this.f=u,this.g=v,this.h=p,this.i=g,this.j=k,this.k=E,this.l=L,this.a=this.B(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.DisposableMap),this.m().then(null,f=>L.error(f))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(u=>this.p(u.added,u.removed))),this.B(this.i.onAddExtensions(u=>this.r(u))),this.B(this.i.onDidAddExtensions(u=>this.s(u))),this.B(this.i.onRemoveExtensions(u=>this.t(u))),this.B(this.i.onDidRemoveExtensions(u=>this.u(u))),this.B(this.k.onDidFilesChange(u=>this.v(u)))}async p(u,v){try{await Promise.all(v.map(p=>(this.c.deleteAndDispose(p.id),this.z(p.extensionsResource)))),u.length&&await Promise.all(u.map(p=>(this.c.set(p.id,(0,O.combinedDisposable)(this.k.watch(this.j.extUri.dirname(p.extensionsResource)),this.k.watch(p.extensionsResource))),this.y(p.extensionsResource))))}catch(p){throw this.l.error(p),p}}async r(u){for(const v of u.extensions)this.D(this.G(v.identifier,v.version),u.profileLocation)}async s(u){for(const v of u.extensions){const p=this.G(v.identifier,v.version);u.error?this.F(p,u.profileLocation):this.D(p,u.profileLocation)}}async t(u){for(const v of u.extensions)this.F(this.G(v.identifier,v.version),u.profileLocation)}async u(u){let v=!1;for(const p of u.extensions){const g=this.G(p.identifier,p.version);u.error?this.D(g,u.profileLocation):(this.F(g,u.profileLocation),v=v||!this.b.has(g))}v&&await this.C()}v(u){for(const v of this.h.profiles)u.contains(v.extensionsResource,0,1)&&this.w(v.extensionsResource)}async w(u){const v=[],p=[],g=await this.i.scanProfileExtensions(u),k=new Set,E=new Set;for(const[L,f]of this.b)f.has(u)&&E.add(L);for(const L of g){const f=this.G(L.identifier,L.version);k.add(f),E.has(f)||(v.push(L.identifier),this.D(f,u))}for(const L of E)if(!k.has(L)){const f=this.H(L);f&&(p.push(f.identifier),this.F(L,u))}(v.length||p.length)&&this.a.fire({added:v.length?{extensions:v,profileLocation:u}:void 0,removed:p.length?{extensions:p,profileLocation:u}:void 0})}async y(u){const v=await this.i.scanProfileExtensions(u);for(const p of v)this.D(this.G(p.identifier,p.version),u)}async z(u){for(const v of[...this.b.keys()])this.F(v,u);await this.C()}async C(){const v=(await this.f.getAllUserInstalled()).filter(p=>p.installedTimestamp&&!this.b.has(this.G(p.identifier,p.manifest.version)));v.length&&await this.f.markAsUninstalled(...v)}D(u,v){let p=this.b.get(u);p||this.b.set(u,p=new R.ResourceSet(g=>this.j.extUri.getComparisonKey(g))),p.add(v)}F(u,v){const p=this.b.get(u);p&&p.delete(v),p?.size||this.b.delete(u)}G(u,v){return`${N.ExtensionIdentifier.toKey(u.id)}@${v}`}H(u){const[v,p]=(0,D.getIdAndVersion)(u);return p?{identifier:{id:v},version:p}:void 0}}e.ExtensionsWatcher=S}),define(Z[135],Q([0,1,109,39]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(D,N,S,h,u,v,p){const g={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${N.nameShort})`};if((0,O.supportsTelemetry)(N,S)&&(0,O.getTelemetryLevel)(h)===3){const k=await(0,T.getServiceMachineId)(S,u,v),{machineId:E}=await p.getTelemetryInfo();g["X-Market-User-Id"]=k,g["VSCode-SessionId"]=E||k}return g}e.resolveMarketplaceHeaders=R}),define(Z[136],Q([0,1,163,19,5,2,16,14,20,17,24,26,10,63,12,11]),function(x,e,T,O,R,D,N,S,h,u,v,p,g,k,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let f=class extends k.LanguagePackBaseService{constructor(d,y,t,o){super(t),this.h=d,this.i=o,this.g=this.B(new c(y,o)),this.h.registerParticipant({postInstall:async i=>this.j(i),postUninstall:async i=>this.k(i)})}async getBuiltInExtensionTranslationsUri(d){const t=(await this.g.getLanguagePacks())[E.Language.value()];if(!t){this.i.warn(`No language pack found for ${E.Language.value()}`);return}const o=t.translations[d];return o?L.URI.file(o):void 0}async getInstalledLanguages(){const d=await this.g.getLanguagePacks(),y=Object.keys(d).map(t=>{const o=d[t];return{...this.f(t,o.label),extensionId:o.extensions[0].extensionIdentifier.id}});return y.push({...this.f("en","English"),extensionId:"default"}),y.sort((t,o)=>t.label.localeCompare(o.label)),y}async j(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",d.identifier.id),await this.update())}async k(d){const y=await this.g.getLanguagePacks();Object.keys(y).some(t=>y[t]&&y[t].extensions.some(o=>(0,p.areSameExtensions)(o.extensionIdentifier,d.identifier)))&&(this.i.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,y]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(y);return!(0,O.equals)(Object.keys(d),Object.keys(t))}};f=de([_(0,v.IExtensionManagementService),_(1,u.INativeEnvironmentService),_(2,v.IExtensionGalleryService),_(3,g.ILogService)],f),e.NativeLanguagePackService=f;let c=class extends D.Disposable{constructor(d,y){super(),this.i=y,this.c={},this.f=(0,S.join)(d.userDataPath,"languagepacks.json"),this.g=new R.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(d){return this.m(y=>{Object.keys(y).forEach(t=>delete y[t]),this.j(y,...d)}).then(()=>this.c)}j(d,...y){for(const t of y)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.k(d,t);Object.keys(d).forEach(t=>this.l(d[t]))}k(d,y){const t=y.identifier,o=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const i of o)if(y.location.scheme===N.Schemas.file&&m(i)){let n=d[i.languageId];n||(n={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},d[i.languageId]=n);const r=n.extensions.filter(a=>(0,p.areSameExtensions)(a.extensionIdentifier,t))[0];r?r.version=y.manifest.version:n.extensions.push({extensionIdentifier:t,version:y.manifest.version});for(const a of i.translations)n.translations[a.id]=(0,S.join)(y.location.fsPath,a.path)}}l(d){if(d){const y=(0,T.createHash)("md5");for(const t of d.extensions)y.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);d.hash=y.digest("hex")}}m(d=()=>null){return this.g.queue(()=>{let y=null;return h.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(y=d(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.c=t,this.h=!0;const o=JSON.stringify(this.c);return this.i.debug("Writing language packs",o),h.Promises.writeFile(this.f,o)}).then(()=>y,t=>this.i.error(t))})}};c=de([_(0,u.INativeEnvironmentService),_(1,g.ILogService)],c);function m(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const d of b.translations)if(typeof d.id!="string"||typeof d.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}}),define(Z[137],Q([0,1,6,30,39]),function(x,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",N="https://mobile.events.data.microsoft.com/ping";async function S(u,v,p){const g=await new Promise((c,m)=>{x(["@microsoft/1ds-core-js"],c,m)}),k=await new Promise((c,m)=>{x(["@microsoft/1ds-post-js"],c,m)}),E=new g.AppInsightsCore,L=new k.PostChannel,f={instrumentationKey:u,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[L]]};if(p){f.extensionConfig={};const c={alwaysUseXhrOverride:!0,httpXHROverride:p};f.extensionConfig[L.identifier]=c}return E.initialize(f,[]),E.addTelemetryInitializer(c=>{v&&(c.ext=c.ext??{},c.ext.utc=c.ext.utc??{},c.ext.utc.flags=8462029)}),E}class h{constructor(v,p,g,k,E){this.e=v,this.f=p,this.g=g,this.h=E,this.c=D,this.d=N,this.g||(this.g={}),typeof k=="function"?this.a=k():this.a=k,this.b=null}i(v){if(!!this.a){if(typeof this.a!="string"){v(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(p=>{v(p)},p=>{(0,T.onUnexpectedError)(p),console.error(p)})}}log(v,p){if(!this.a)return;p=(0,O.mixin)(p,this.g),p=(0,R.validateTelemetryData)(p);const g=this.f+"/"+v;try{this.i(k=>{k.pluginVersionString=p?.properties.version??"Unknown",k.track({name:g,baseData:{name:g,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this.a?new Promise(v=>{this.i(p=>{p.unload(!0,()=>{this.a=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=h}),define(Z[138],Q([0,1,2,30,12,32,101,23,42,139,28,37,25,39]),function(x,e,T,O,R,D,N,S,h,u,v,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(c,m,b){this.k=m,this.l=b,this.d={},this.i=new T.DisposableStore,this.j=[],this.b=c.appenders,this.c=c.commonProperties||Promise.resolve({}),this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,D.escapeRegExpCharacters)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.escapeRegExpCharacters)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration(g.TELEMETRY_SETTING_ID)||d.affectsConfiguration(g.TELEMETRY_OLD_SETTING_ID)||d.affectsConfiguration(g.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(c,m){this.d[c]=m}m(){let c=(0,k.getTelemetryLevel)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const b=m.usage?3:m.error?2:0;c=Math.min(c,b)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const c=await this.c,m=c.sessionID,b=c["common.machineId"],d=c["common.firstSessionDate"],y=c["common.msftInternal"];return{sessionId:m,machineId:b,firstSessionDate:d,msftInternal:y}}dispose(){this.i.dispose()}n(c,m,b){return this.g<m?Promise.resolve(void 0):this.c.then(d=>{b=(0,O.mixin)(b,this.d),b=(0,k.cleanData)(b,this.j),b=(0,O.mixin)(b,d),this.b.forEach(y=>y.log(c,b))},d=>{console.error(d)})}publicLog(c,m){return this.n(c,3,m)}publicLog2(c,m){return this.publicLog(c,m)}publicLogError(c,m){return this.h?this.n(c,2,m):Promise.resolve(void 0)}publicLogError2(c,m){return this.publicLogError(c,m)}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=de([_(1,S.IConfigurationService),_(2,v.IProductService)],E),e.TelemetryService=E;function L(){const f=(0,N.localize)(0,null,u.default.nameLong),c=u.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=R.isWeb?"":(0,N.localize)(3,null),b=(0,N.localize)(4,null),d=(0,N.localize)(5,null),y=(0,N.localize)(6,null),t=(0,N.localize)(7,null),o=`
|       | ${b} | ${d} | ${y} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,N.localize)(8,null);return`
${f} ${c} ${m}

&nbsp;

${t}
${o}

&nbsp;

${i}
`}p.Registry.as(h.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:L(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(h.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,N.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,N.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[140],Q([0,1,164,137]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class R extends O.AbstractOneDataSystemAppender{constructor(N,S,h,u){const v={sendPOST:(p,g)=>{const k={method:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data)}};try{const E=T.request(p.urlString,k,L=>{L.on("data",function(f){g(L.statusCode??200,L.headers,f.toString())}),L.on("error",function(f){g(0,{})})});E.write(p.data),E.end()}catch{g(0,{})}}};super(N,S,h,u,v)}}e.OneDataSystemAppender=R}),define(Z[141],Q([0,1,14,20]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function R(D,N){const S=Object.create(null),h=(v,p)=>{const g=JSON.parse(v);S[p]=g};if(N){const v=[],p=await O.Promises.readdir(N);for(const k of p)try{(await O.Promises.stat((0,T.join)(N,k))).isDirectory()&&v.push(k)}catch{}const g=[];for(const k of v)(await O.Promises.readdir((0,T.join)(N,k))).filter(L=>L==="telemetry.json").length===1&&g.push(k);for(const k of g){const E=(await O.Promises.readFile((0,T.join)(N,k,"telemetry.json"))).toString();h(E,k)}}let u=(await O.Promises.readFile((0,T.join)(D,"telemetry-core.json"))).toString();return h(u,"vscode-core"),u=(await O.Promises.readFile((0,T.join)(D,"telemetry-extensions.json"))).toString(),h(u,"vscode-extensions"),JSON.stringify(S,null,4)}e.buildTelemetryMessage=R}),define(Z[142],Q([0,1,12,80,25]),function(x,e,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function D(N){let S=N.getItem(R.machineIdKey);return(typeof S!="string"||T.isMacintosh&&S==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(S=await(0,O.getMachineId)()),S}e.resolveMachineId=D}),define(Z[27],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(Z[143],Q([0,1,27,110,13,18,72,3,2]),function(x,e,T,O,R,D,N,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class u{constructor(g){this.uri=g,this.time=u._clock++}touch(){return this.time=u._clock++,this}}u._clock=0;let v=class{constructor(g){this.g=g,this.c=new h.DisposableStore,this.f=2**16;const k=new Map,E=L=>{let f=k.get(L.scheme);return f===void 0&&(f=g.hasProvider(L)&&!this.g.hasCapability(L,1024),k.set(L.scheme,f)),f};this.c.add(S.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(L=>{k.delete(L.scheme)})),this.extUri=new D.ExtUri(E),this.d=new N.SkipList((L,f)=>this.extUri.compare(L,f,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,D.normalizePath)(g));const k=this.d.get(g);return k?k.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new u(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((E,L)=>E[1].touch<L[1].touch?1:E[1].touch>L[1].touch?-1:0);u._clock=0,this.d.clear();const k=this.f*.5;for(let E=0;E<k;E++)this.d.set(g[E][0],g[E][1].touch())}};v=de([_(0,R.IFileService)],v),e.UriIdentityService=v,(0,O.registerSingleton)(T.IUriIdentityService,v,1)}),define(Z[144],Q([0,1,103,14,54,18,11,9,16]),function(x,e,T,O,R,D,N,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");function u(i){const n=i;return typeof n?.id=="string"&&N.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=u;function v(i){return typeof i?.id=="string"&&!u(i)&&!g(i)}e.isEmptyWorkspaceIdentifier=v,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function p(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=p;function g(i){const n=i;return typeof n?.id=="string"&&N.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=g;function k(i){const n=i;if(n?.uri)return{id:n.id,uri:N.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=k;var E;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function L(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=L;function f(i){const n=i;return!!(n&&typeof n=="object"&&N.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=f;class c{constructor(n,r,a,s,l){this.h=n,this.j=a,this.k=s,this.l=l,this.c=R.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=R.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=c;class m{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,D.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function b(i){return new m({uri:i,index:0,name:(0,D.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function d(i,n){return D.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=d;function y(i){let n;return N.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=y;function t(i,n){return!d(i,n)&&!y(i)}e.isSavedWorkspace=t;function o(i){return(typeof i=="string"?(0,O.extname)(i):(0,D.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=o}),define(Z[21],Q([0,1,52,3,2,18,11,102,17,13,9,10,144,36,27,5,31,32,4]),function(x,e,T,O,R,D,N,S,h,u,v,p,g,k,E,L,f,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function b(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&N.URI.isUri(n.location)&&N.URI.isUri(n.globalStorageHome)&&N.URI.isUri(n.settingsResource)&&N.URI.isUri(n.keybindingsResource)&&N.URI.isUri(n.tasksResource)&&N.URI.isUri(n.snippetsHome)&&N.URI.isUri(n.extensionsResource))}e.isUserDataProfile=b,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,v.createDecorator)("IUserDataProfilesService");function d(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:N.URI.revive(i.location).with({scheme:n}),globalStorageHome:N.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:N.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:N.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:N.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:N.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:N.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=d;function y(i,n,r,a){return{id:i,name:n,location:r,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,D.joinPath)(r,"globalStorage"),settingsResource:(0,D.joinPath)(r,"settings.json"),keybindingsResource:(0,D.joinPath)(r,"keybindings.json"),tasksResource:(0,D.joinPath)(r,"tasks.json"),snippetsHome:(0,D.joinPath)(r,"snippets"),extensionsResource:(0,D.joinPath)(r,"extensions.json"),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=y;let t=class extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,r,a,s){super(),this.m=n,this.n=r,this.r=a,this.s=s,this.f=!1,this.g=this.B(new O.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new O.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new O.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new O.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new k.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,D.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)for(const l of this.G()){if(!l.name||!(0,m.isString)(l.name)||!l.location){this.s.warn("Skipping the invalid stored profile",l.location||l.name);continue}n.push(y((0,D.basename)(l.location),l.name,l.location,{shortName:l.shortName,useDefaultFlags:l.useDefaultFlags}))}const r=new k.ResourceMap,a=new Map,s=y((0,T.hash)(this.m.userRoamingDataHome.path).toString(16),(0,S.localize)(0,null),this.m.userRoamingDataHome);if(n.unshift({...s,extensionsResource:this.L()??s.extensionsResource,isDefault:!0}),n.length){const l=this.I();if(l.workspaces)for(const[w,A]of Object.entries(l.workspaces)){const U=N.URI.parse(w),Y=N.URI.parse(A),X=n.find(ee=>this.r.extUri.isEqual(ee.location,Y));X&&r.set(U,X)}if(l.emptyWindows)for(const[w,A]of Object.entries(l.emptyWindows)){const U=N.URI.parse(A),Y=n.find(X=>this.r.extUri.isEqual(X.location,U));Y&&a.set(w,Y)}}this.t={profiles:n,workspaces:r,emptyWindows:a}}return this.t}async createTransientProfile(n){const r="Temp",a=new RegExp(`${(0,c.escapeRegExpCharacters)(r)}\\s(\\d+)`);let s=0;for(const w of this.profiles){const A=a.exec(w.name),U=A?parseInt(A[1]):0;s=U>s?U:s}const l=`${r} ${s+1}`;return this.createProfile((0,T.hash)((0,f.generateUuid)()).toString(16),l,{transient:!0},n)}async createNamedProfile(n,r,a){return this.createProfile((0,T.hash)((0,f.generateUuid)()).toString(16),n,r,a)}async createProfile(n,r,a,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const l=await this.v(n,r,a);return s&&await this.setProfileForWorkspace(s,l),l}async v(n,r,a){if(!(0,m.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.k.get(r);return s||(s=(async()=>{try{const l=this.profiles.find(U=>U.name===r||U.id===n);if(l)return l;const w=y(n,r,(0,D.joinPath)(this.profilesHome,n),a);await this.n.createFolder(w.location);const A=[];return this.h.fire({profile:w,join(U){A.push(U)}}),await L.Promises.settled(A),this.z([w],[],[]),w}finally{this.k.delete(r)}})(),this.k.set(r,s)),s}async updateProfile(n,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let a=this.profiles.find(s=>s.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);return a=y(a.id,r.name??a.name,a.location,{shortName:r.shortName??a.shortName,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags}),this.z([],[],[a]),a}async removeProfile(n){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(s=>s.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const a=[];this.i.fire({profile:r,join(s){a.push(s)}});try{await Promise.allSettled(a)}catch(s){this.s.error(s)}for(const s of[...this.u.emptyWindows.keys()])r.id===this.u.emptyWindows.get(s)?.id&&this.u.emptyWindows.delete(s);for(const s of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(s)?.id&&this.u.workspaces.delete(s);this.F(),this.z([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(s){this.s.error(s)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=this.profiles.find(s=>s.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.D(n,a)}unsetWorkspace(n,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(n,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.r.extUri.isEqual(a.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(r=>!this.y(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.w(n);return N.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindows.get(r)??this.u.emptyWindows.get(r)}w(n){return(0,g.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,g.isWorkspaceIdentifier)(n)?n.configPath:n.id}y(n){return!!([...this.l.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location)))}z(n,r,a){const s=[...this.profiles,...n],l=[];this.l.profiles=[];for(let w of s)w.isDefault||r.some(A=>w.id===A.id)||(w=a.find(A=>w.id===A.id)??w,w.isTransient?this.l.profiles.push(w):l.push({location:w.location,name:w.name,shortName:w.shortName,useDefaultFlags:w.useDefaultFlags}));this.H(l),this.t=void 0,this.C(n,r,a)}C(n,r,a){this.g.fire({added:n,removed:r,updated:a,all:this.profiles})}D(n,r,a){a=r?.isTransient?!0:a,a||this.D(n,void 0,!0);const s=this.w(n),l=a?this.l:this.u;N.URI.isUri(s)?(l.workspaces.delete(s),r&&l.workspaces.set(s,r)):(l.emptyWindows.delete(s),r&&l.emptyWindows.set(s,r)),a||this.F()}F(){const n={};for(const[a,s]of this.u.workspaces.entries())n[a.toString()]=s.location.toString();const r={};for(const[a,s]of this.u.emptyWindows.entries())r[a.toString()]=s.location.toString();this.J({workspaces:n,emptyWindows:r}),this.t=void 0}G(){return[]}H(n){throw new Error("not implemented")}I(){return{}}J(n){throw new Error("not implemented")}L(){}};t.b="userDataProfiles",t.c="profileAssociations",t=de([_(0,h.IEnvironmentService),_(1,u.IFileService),_(2,E.IUriIdentityService),_(3,p.ILogService)],t),e.UserDataProfilesService=t;class o extends t{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(n){this.a=n}I(){return this.O}J(n){this.O=n}}e.InMemoryUserDataProfilesService=o}),define(Z[145],Q([0,1,19,5,22,6,3,2,12,11,87,24,26,29,10,28,25,21]),function(x,e,T,O,R,D,N,S,h,u,v,p,g,k,E,L,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var m;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(m=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let b=class extends S.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,r,a,s,l){super(),this.t=n,this.u=r,this.v=a,this.w=s,this.y=l,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new N.Emitter),this.m=this.B(new N.Emitter),this.n=this.B(new N.Emitter),this.p=this.B(new N.Emitter),this.s=[],this.B((0,S.toDisposable)(()=>{this.j.forEach(({task:w})=>w.cancel()),this.k.forEach(w=>w.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(a=>(0,p.isTargetPlatformCompatible)(a,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{if(!this.t.isEnabled())throw new p.ExtensionManagementError(v.localize(0,null),p.ExtensionManagementErrorCode.Internal);const a=await this.G(n,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(a.manifest,a.extension,r)}catch(a){throw t(this.u,"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(n),error:a}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(a),y(a)}}async uninstall(n,r={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,r,a){const s={...a,installOnlyNewlyAddedFromExtensionPack:u.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,k.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},l=ee=>`${g.ExtensionKey.create(ee).toString()}${s.profileLocation?`-${s.profileLocation.toString()}`:""}`;if(!u.URI.isUri(r)){const ee=this.j.get(l(r));if(ee){this.v.info("Extensions is already requested to install",r.identifier.id);const{local:ie}=await ee.task.waitUntilTaskIsFinished();return ie}}const w=[],A=[],U=[],Y=this.Q(n,r,s);u.URI.isUri(r)||this.j.set(l(r),{task:Y,waitingTasks:[]}),this.l.fire({identifier:Y.identifier,source:r,profileLocation:s.profileLocation}),this.v.info("Installing extension:",Y.identifier.id),w.push({task:Y,manifest:n});let X=!1;try{if(s.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",Y.identifier.id);else try{const ie=await this.F(Y.identifier,n,!!s.installOnlyNewlyAddedFromExtensionPack,!!s.installPreReleaseVersion,s.profileLocation),ne=await this.getInstalled(void 0,s.profileLocation);for(const{gallery:ae,manifest:fe}of(0,T.distinct)(ie,({gallery:re})=>re.identifier.id)){X=X||!!fe.extensionDependencies?.some(B=>(0,g.areSameExtensions)({id:B},Y.identifier));const re=l(ae),me=this.j.get(re);if(me){if(this.C(Y,me.task)){const B=me.task.identifier;this.v.info("Waiting for already requested installing extension",B.id,Y.identifier.id),me.waitingTasks.push(Y),A.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,j=>j.some(M=>(0,g.areSameExtensions)(M.identifier,B)))).then(j=>{if(this.v.info("Finished waiting for already requested installing extension",B.id,Y.identifier.id),!j.find(V=>(0,g.areSameExtensions)(V.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!ne.some(({identifier:B})=>(0,g.areSameExtensions)(B,ae.identifier))){const B=this.Q(fe,ae,{...s,donotIncludePackAndDependencies:!0});this.j.set(re,{task:B,waitingTasks:[Y]}),this.l.fire({identifier:B.identifier,source:ae,profileLocation:s.profileLocation}),this.v.info("Installing extension:",B.identifier.id,Y.identifier.id),w.push({task:B,manifest:fe})}}}catch(ie){if(u.URI.isUri(Y.source))(0,T.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",Y.identifier.id,ie.message),(0,T.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",Y.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",Y.identifier.id),ie}const ee=w.reduce((ie,{task:ne,manifest:ae})=>(ie.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:ae}),ie),new Map);for(;ee.size;){let ie;const ne=[...ee.values()].filter(({manifest:ae})=>!ae.extensionDependencies?.some(fe=>ee.has(fe.toLowerCase())));ne.length?ie=ee.size===1?ne:ne.filter(({task:ae})=>!(ae===Y&&!X)):(this.v.info("Found extensions with circular dependencies",ne.map(({task:ae})=>ae.identifier.id)),ie=[...ee.values()]),await this.D(ie.map(async({task:ae})=>{const fe=new Date().getTime();try{const{local:re}=await ae.run();if(await this.D(this.s.map(me=>me.postInstall(re,ae.source,s,R.CancellationToken.None))),!u.URI.isUri(ae.source)){const me=ae.operation===3,B=me?void 0:(new Date().getTime()-ae.source.lastUpdated)/1e3;if(t(this.u,me?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-fe,durationSinceUpdate:B}),h.isWeb&&ae.operation!==3)try{await this.t.reportStatistic(re.manifest.publisher,re.manifest.name,re.manifest.version,"install")}catch{}}U.push({local:re,identifier:ae.identifier,operation:ae.operation,source:ae.source,context:s.context,profileLocation:s.profileLocation,applicationScoped:re.isApplicationScoped})}catch(re){throw u.URI.isUri(ae.source)||t(this.u,ae.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-fe,error:re}),this.v.error("Error while installing the extension:",ae.identifier.id),re}finally{ee.delete(ae.identifier.id.toLowerCase())}}))}return A.length&&await this.D(A),U.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire(U),U.filter(({identifier:ie})=>(0,g.areSameExtensions)(ie,Y.identifier))[0].local}catch(ee){if(w.forEach(({task:ie})=>ie.cancel()),U.length)try{const ie=await Promise.allSettled(U.map(({local:ne})=>this.R(ne,{versionOnly:!0,profileLocation:s.profileLocation}).run()));for(let ne=0;ne<ie.length;ne++){const ae=ie[ne],{identifier:fe}=U[ne];ae.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",fe.id):this.v.warn("Rollback: Error while uninstalling extension",fe.id,(0,D.getErrorMessage)(ae.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,D.getErrorMessage)(ie),U.map(({identifier:ne})=>ne.id))}throw this.m.fire(w.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:s.context,profileLocation:s.profileLocation}))),ee}finally{for(const{task:ee}of w)ee.source&&!u.URI.isUri(ee.source)&&this.j.delete(l(ee.source))}}C(n,r){for(const[,{task:a,waitingTasks:s}]of this.j.entries())if(a===n&&(s.includes(r)||s.some(l=>this.C(l,r)))||a===r&&s[0]&&!this.C(n,s[0]))return!1;return!0}async D(n){const r=[],a=[],s=await Promise.allSettled(n);for(const l of s)l.status==="fulfilled"?r.push(l.value):a.push(l.reason);if(a.length)throw d(a);return r}async F(n,r,a,s,l){if(!this.t.isEnabled())return[];const w=await this.getInstalled(void 0,l),A=[],U=[],Y=async(X,ee)=>{A.push(X);const ie=ee.extensionDependencies||[],ne=[...ie];if(ee.extensionPack){const ae=a?w.find(fe=>(0,g.areSameExtensions)(fe.identifier,X)):void 0;for(const fe of ee.extensionPack)ae&&ae.manifest.extensionPack&&ae.manifest.extensionPack.some(re=>(0,g.areSameExtensions)({id:re},{id:fe}))||ne.every(re=>!(0,g.areSameExtensions)({id:re},{id:fe}))&&ne.push(fe)}if(ne.length){const ae=ne.filter(fe=>A.every(re=>!(0,g.areSameExtensions)(re,{id:fe})));if(ae.length){const fe=await this.t.getExtensions(ae.map(re=>({id:re,preRelease:s})),R.CancellationToken.None);for(const re of fe){if(A.find(j=>(0,g.areSameExtensions)(j,re.identifier)))continue;const me=ie.some(j=>(0,g.areSameExtensions)({id:j},re.identifier));let B;try{B=await this.G(re,!1,s)}catch(j){if(j instanceof p.ExtensionManagementError&&j.code===p.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!me){this.v.info("Skipping the packed extension as it cannot be installed",re.identifier.id);continue}else throw j}U.push({gallery:B.extension,manifest:B.manifest}),await Y(B.extension.identifier,B.manifest)}}}};return await Y(n,r),U}async G(n,r,a){if((await this.getExtensionsControlManifest()).malicious.some(A=>(0,g.areSameExtensions)(n.identifier,A)))throw new p.ExtensionManagementError(v.localize(1,null,n.identifier.id),p.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const A=await this.getTargetPlatform();throw new p.ExtensionManagementError(v.localize(2,null,n.identifier.id,this.w.nameLong,(0,p.TargetPlatformToString)(A)),p.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.H(n,r,a);if(l){if(a&&!r&&n.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new p.ExtensionManagementError(v.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),p.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],R.CancellationToken.None))[0]?new p.ExtensionManagementError(v.localize(4,null,n.identifier.id),p.ExtensionManagementErrorCode.ReleaseVersionNotFound):new p.ExtensionManagementError(v.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),p.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",l.identifier.id);const w=await this.t.getManifest(l,R.CancellationToken.None);if(w===null)throw new p.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,p.ExtensionManagementErrorCode.Invalid);if(w.version!==l.version)throw new p.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,p.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:w}}async H(n,r,a){const s=await this.getTargetPlatform();let l=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==a&&(l=(await this.t.getExtensions([{...n.identifier,preRelease:a}],{targetPlatform:s,compatible:!0},R.CancellationToken.None))[0]||null),!l&&await this.t.isExtensionCompatible(n,a,s)&&(l=n),l||(r?l=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:s,compatible:!0},R.CancellationToken.None))[0]||null:l=await this.t.getCompatibleExtension(n,a,s)),l}async I(n,r){const a={...r,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},s=X=>`${X.id.toLowerCase()}${a.versionOnly?`-${n.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,l=this.k.get(s(n.identifier));if(l)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),l.waitUntilTaskIsFinished();const w=X=>{const ee=this.R(X,a);return this.k.set(s(ee.extension.identifier),ee),a.profileLocation?this.v.info("Uninstalling extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,a.profileLocation.toString()):this.v.info("Uninstalling extension:",`${X.identifier.id}@${X.manifest.version}`),this.n.fire({identifier:X.identifier,profileLocation:a.profileLocation,applicationScoped:X.isApplicationScoped}),ee},A=(X,ee)=>{ee?a.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,a.profileLocation.toString(),ee.message):this.v.error("Failed to uninstall extension:",`${X.identifier.id}@${X.manifest.version}`,ee.message):a.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${X.identifier.id}@${X.manifest.version}`,a.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${X.identifier.id}@${X.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,g.getLocalExtensionTelemetryData)(X),error:ee}),this.p.fire({identifier:X.identifier,error:ee?.code,profileLocation:a.profileLocation,applicationScoped:X.isApplicationScoped})},U=[],Y=[];try{U.push(w(n));const X=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const ee=this.M(n,X);for(const ie of ee)this.k.has(s(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):U.push(w(ie))}a.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(U.map(ee=>ee.extension),X,n),await this.D(U.map(async ee=>{try{if(await ee.run(),await this.D(this.s.map(ie=>ie.postUninstall(ee.extension,a,R.CancellationToken.None))),ee.extension.identifier.uuid)try{await this.t.reportStatistic(ee.extension.manifest.publisher,ee.extension.manifest.name,ee.extension.manifest.version,"uninstall")}catch{}A(ee.extension)}catch(ie){const ne=ie instanceof p.ExtensionManagementError?ie:new p.ExtensionManagementError((0,D.getErrorMessage)(ie),p.ExtensionManagementErrorCode.Internal);throw A(ee.extension,ne),ne}finally{Y.push(ee)}}))}catch(X){const ee=X instanceof p.ExtensionManagementError?X:new p.ExtensionManagementError((0,D.getErrorMessage)(X),p.ExtensionManagementErrorCode.Internal);for(const ie of U){try{ie.cancel()}catch{}Y.includes(ie)||A(ie.extension,ee)}throw ee}finally{for(const X of U)this.k.delete(s(X.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",X.extension.identifier.id)}}J(n,r,a){for(const s of n){const l=this.N(s,r);if(l.length){const w=l.filter(A=>!n.some(U=>(0,g.areSameExtensions)(U.identifier,A.identifier)));if(w.length)throw new Error(this.L(s,w,a))}}}L(n,r,a){return a===n?r.length===1?v.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?v.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):v.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?v.localize(9,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?v.localize(10,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):v.localize(11,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(n,r,a=[]){if(a.indexOf(n)!==-1)return[];a.push(n);const s=n.manifest.extensionPack?n.manifest.extensionPack:[];if(s.length){const l=r.filter(A=>!A.isBuiltin&&s.some(U=>(0,g.areSameExtensions)({id:U},A.identifier))),w=[];for(const A of l)w.push(...this.M(A,r,a));return[...l,...w]}return[]}N(n,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(s=>(0,g.areSameExtensions)({id:s},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};b=de([_(0,p.IExtensionGalleryService),_(1,f.ITelemetryService),_(2,E.ILogService),_(3,L.IProductService),_(4,c.IUserDataProfilesService)],b),e.AbstractExtensionManagementService=b;function d(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=d;function y(i){if(i instanceof p.ExtensionManagementError)return i;const n=new p.ExtensionManagementError(i.message,p.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}function t(i,n,{extensionData:r,verificationStatus:a,duration:s,error:l,durationSinceUpdate:w}){let A,U;l&&(l instanceof p.ExtensionManagementError?(A=l.code,l.code===p.ExtensionManagementErrorCode.Signature&&(U=l.message)):A=p.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:a,success:!l,duration:s,errorcode:A,errorcodeDetail:U,durationSinceUpdate:w})}e.reportTelemetry=t;class o{constructor(){this.d=new O.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,O.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.createCancelablePromise)(n=>new Promise((r,a)=>{const s=n.onCancellationRequested(()=>{s.dispose(),a(new D.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=o}),define(Z[40],Q([0,1,5,15,2,3,36,11,26,29,13,9,10,21,27,4,6,25]),function(x,e,T,O,R,D,N,S,h,u,v,p,g,k,E,L,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class b extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=b,e.IExtensionsProfileScannerService=(0,p.createDecorator)("IExtensionsProfileScannerService");let d=class extends R.Disposable{constructor(i,n,r,a,s,l){super(),this.h=i,this.i=n,this.j=r,this.k=a,this.l=s,this.m=l,this.a=this.B(new D.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new D.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new D.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new D.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new N.ResourceMap}scanProfileExtensions(i,n){return this.n(i,void 0,n)}async addExtensionsToProfile(i,n){const r=[],a=[];try{return await this.n(n,s=>{const l=[];for(const w of s)i.some(([A])=>(0,h.areSameExtensions)(A.identifier,w.identifier)&&A.manifest.version!==w.version)?r.push(w):l.push(w);for(const[w,A]of i)if(!l.some(U=>(0,h.areSameExtensions)(U.identifier,w.identifier)&&U.version===w.manifest.version)){const U={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:A};a.push(U),l.push(U)}return a.length&&this.a.fire({extensions:a,profileLocation:n}),r.length&&this.c.fire({extensions:r,profileLocation:n}),l}),a.length&&this.b.fire({extensions:a,profileLocation:n}),r.length&&this.f.fire({extensions:r,profileLocation:n}),a}catch(s){throw a.length&&this.b.fire({extensions:a,error:s,profileLocation:n}),r.length&&this.f.fire({extensions:r,error:s,profileLocation:n}),s}}async removeExtensionFromProfile(i,n){const r=[];this.c.fire({extensions:r,profileLocation:n});try{await this.n(n,a=>{const s=[];for(const l of a)(0,h.areSameExtensions)(l.identifier,i.identifier)?r.push(l):s.push(l);return r.length&&this.c.fire({extensions:r,profileLocation:n}),s}),r.length&&this.f.fire({extensions:r,profileLocation:n})}catch(a){throw r.length&&this.f.fire({extensions:r,error:a,profileLocation:n}),a}}async n(i,n,r){return this.v(i).queue(async()=>{let a=[],s;try{const l=await this.i.readFile(i);s=JSON.parse(l.value.toString())}catch(l){if((0,v.toFileOperationResult)(l)!==1)throw l;if(this.k.extUri.isEqual(i,this.j.defaultProfile.extensionsResource)&&(s=await this.u()),!s&&r?.bailOutWhenFileNotFound)throw new b((0,f.getErrorMessage)(l),"ERROR_PROFILE_NOT_FOUND")}if(s){Array.isArray(s)||this.p(i);let l=!1;for(const w of s){y(w)||this.p(i);let A;if((0,L.isString)(w.location))A=this.s(w.location);else{A=S.URI.revive(w.location);const U=this.r(A);U&&(l=!0,w.location=U)}a.push({identifier:w.identifier,location:A,version:w.version,metadata:w.metadata})}l&&await this.i.writeFile(i,O.VSBuffer.fromString(JSON.stringify(s)))}if(n){a=n(a);const l=a.map(w=>({identifier:w.identifier,version:w.version,location:this.r(w.location)??w.location.toJSON(),metadata:w.metadata}));await this.i.writeFile(i,O.VSBuffer.fromString(JSON.stringify(l)))}return a})}p(i){const n=new b(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}r(i){return this.k.extUri.isEqualOrParent(i,this.h)?this.k.extUri.relativePath(this.h,i):void 0}s(i){return this.k.extUri.joinPath(this.h,i)}async u(){return this.t||(this.t=(async()=>{const i=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let n;try{n=(await this.i.readFile(i)).value.toString()}catch(a){if((0,v.toFileOperationResult)(a)===1)return;throw a}this.m.info("Migrating extensions from old default profile location",i.toString());let r;try{const a=JSON.parse(n);Array.isArray(a)&&a.every(s=>y(s))?r=a:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.m.error(a)}if(r)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",i.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(a){if((0,v.toFileOperationResult)(a)===3)this.m.info("Migration from old default profile location to new location is done by another window",i.toString(),this.j.defaultProfile.extensionsResource.toString());else throw a}try{await this.i.del(i)}catch(a){(0,v.toFileOperationResult)(a)!==1&&this.m.error(a)}return r})()),this.t}v(i){let n=this.g.get(i);return n||(n=new T.Queue,this.g.set(i,n)),n}};d=de([_(1,v.IFileService),_(2,k.IUserDataProfilesService),_(3,E.IUriIdentityService),_(4,c.ITelemetryService),_(5,g.ILogService)],d),e.AbstractExtensionsProfileScannerService=d;function y(o){return(0,L.isObject)(o)&&(0,u.isIExtensionIdentifier)(o.identifier)&&(t(o.location)||(0,L.isString)(o.location))&&o.version&&(0,L.isString)(o.version)}function t(o){return o?(0,L.isString)(o.path)&&(0,L.isString)(o.scheme):!1}}),define(Z[48],Q([0,1,19,5,30,15,6,50,78,2,16,14,12,18,41,53,4,11,91,17,26,29,45,13,9,10,28,3,44,40,21,27,107,108]),function(x,e,T,O,R,D,N,S,h,u,v,p,g,k,E,L,f,c,m,b,d,y,t,o,i,n,r,a,s,l,w,A,U,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var X;(function(me){function B(j,M){if(j===M)return!0;const V=Object.keys(j),W=new Set;for(const q of Object.keys(M))W.add(q);if(V.length!==W.size)return!1;for(const q of V){if(j[q]!==M[q])return!1;W.delete(q)}return W.size===0}me.equals=B})(X=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let ee=class extends u.Disposable{constructor(B,j,M,V,W,q,K,P,I,C,F,$){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=j,this.l=M,this.m=V,this.n=W,this.p=q,this.r=K,this.s=P,this.t=I,this.u=C,this.v=F,this.w=$,this.g=this.B(new a.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,k.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(ae,(0,k.joinPath)(this.m,y.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(ae,(0,k.joinPath)(this.m,y.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(ne,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,d.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(B,j,M){const[V,W]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(j)]),q=M?await this.scanExtensionsUnderDevelopment(B,[...V,...W]):[];return this.F(V,W,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const j=[];j.push(this.G(!!B.useCache,B.language)),j.push(this.H(B.language,!!B.checkControlFile));const[M,V]=await Promise.all(j);return this.D([...M,...V],0,B,!1)}async scanUserExtensions(B){const j=B.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",j);const M=this.v.extUri.isEqual(B.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.J(j,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,M),W=B.useCache&&!V.devMode&&V.excludeObsolete?this.j:this.k;let q;try{q=await W.scanExtensions(V)}catch(K){if(K instanceof l.ExtensionsProfileScanningError&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),q=await W.scanExtensions(V);else throw K}return q=await this.D(q,1,B,!0),this.s.trace("Scanned user extensions:",q.length),q}async scanExtensionsUnderDevelopment(B,j){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const M=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(V=>V.scheme===v.Schemas.file).map(async V=>{const W=await this.J(V,!1,1,!0,B.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(W)).map(K=>(K.type=j.find(P=>(0,d.areSameExtensions)(P.identifier,K.identifier))?.type??K.type,this.k.validate(K,W)))}))).flat();return this.D(M,"development",B,!0)}return[]}async scanExistingExtension(B,j,M){const V=await this.J(B,!1,j,!0,M.language,!0,void 0),W=await this.k.scanExtension(V);return!W||!M.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(B,j,M){const V=await this.J(B,!1,j,!0,M.language,!0,void 0),W=await this.k.scanOneOrMultipleExtensions(V);return this.D(W,j,M,!0)}async scanMetadata(B){const j=(0,k.joinPath)(B,"package.json"),M=(await this.r.readFile(j)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(B,j){const M=(0,k.joinPath)(B,"package.json"),V=(await this.r.readFile(M)).value.toString(),W=JSON.parse(V);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0,W.__metadata={...W.__metadata,...j},await this.r.writeFile((0,k.joinPath)(B,"package.json"),D.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof l.ExtensionsProfileScanningError&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw B}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.p.addExtensionsToProfile(B.map(j=>[j,j.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify([])))}catch(j){(0,o.toFileOperationResult)(j)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.getErrorMessage)(j))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.s.error(B)}finally{this.z=void 0}})()),this.z}async D(B,j,M,V){return M.includeAllVersions||(B=this.F(j===0?B:void 0,j===1?B:void 0,j==="development"?B:void 0,await this.getTargetPlatform(),V)),M.includeInvalid||(B=B.filter(W=>W.isValid)),B.sort((W,q)=>{const K=p.basename(W.location.fsPath),P=p.basename(q.location.fsPath);return K<P?-1:K>P?1:0})}F(B,j,M,V,W){const q=(P,I,C)=>{if(P.isValid&&!I.isValid)return!1;if(P.isValid===I.isValid){if(W&&E.gt(P.manifest.version,I.manifest.version))return this.s.debug(`Skipping extension ${I.location.path} with lower version ${I.manifest.version} in favour of ${P.location.path} with version ${P.manifest.version}`),!1;if(E.eq(P.manifest.version,I.manifest.version)){if(P.type===0)return this.s.debug(`Skipping extension ${I.location.path} in favour of system extension ${P.location.path} with same version`),!1;if(P.targetPlatform===V)return this.s.debug(`Skipping extension ${I.location.path} from different target platform ${I.targetPlatform}`),!1}}return C?this.s.warn(`Overwriting user extension ${P.location.path} with ${I.location.path}.`):this.s.debug(`Overwriting user extension ${P.location.path} with ${I.location.path}.`),!0},K=new Map;return B?.forEach(P=>{const I=y.ExtensionIdentifier.toKey(P.identifier.id),C=K.get(I);(!C||q(C,P,!1))&&K.set(I,P)}),j?.forEach(P=>{const I=y.ExtensionIdentifier.toKey(P.identifier.id),C=K.get(I);if(!C&&B&&P.type===0){this.s.debug(`Skipping obsolete system extension ${P.location.path}.`);return}(!C||q(C,P,!1))&&K.set(I,P)}),M?.forEach(P=>{const I=y.ExtensionIdentifier.toKey(P.identifier.id),C=K.get(I);(!C||q(C,P,!0))&&K.set(I,P),K.set(I,P)}),[...K.values()]}async G(B,j){this.s.trace("Started scanning system extensions");const M=await this.J(this.systemExtensionsLocation,!1,0,!0,j,!0,void 0),W=await(B&&!M.devMode?this.i:this.k).scanExtensions(M);return this.s.trace("Scanned system extensions:",W.length),W}async H(B,j){const M=this.t.isBuilt?[]:this.u.builtInExtensions;if(!M?.length)return[];this.s.trace("Started scanning dev system extensions");const V=j?await this.I():{},W=[],q=c.URI.file(p.normalize(p.join(v.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const P of M){const I=V[P.name]||"marketplace";switch(I){case"disabled":break;case"marketplace":W.push((0,k.joinPath)(q,P.name));break;default:W.push(c.URI.file(I));break}}const K=await Promise.all(W.map(async P=>this.k.scanExtension(await this.J(P,!1,0,!0,B,!0,void 0))));return this.s.trace("Scanned dev system extensions:",K.length),(0,T.coalesce)(K)}async I(){try{const B=await this.r.readFile(this.l);return JSON.parse(B.value.toString())}catch{return{}}}async J(B,j,M,V,W,q,K){const P=await this.f(W??g.language),I=await this.L(B),C=j&&!this.v.extUri.isEqual(B,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,F=C?await this.L(C):void 0;return new ie(B,I,C,F,j,K,M,V,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,W,P)}async L(B){try{const j=await this.r.stat(B);if(typeof j.mtime=="number")return j.mtime}catch{}}};ee=de([_(4,w.IUserDataProfilesService),_(5,l.IExtensionsProfileScannerService),_(6,o.IFileService),_(7,n.ILogService),_(8,b.IEnvironmentService),_(9,r.IProductService),_(10,A.IUriIdentityService),_(11,i.IInstantiationService)],ee),e.AbstractExtensionsScannerService=ee;class ie{constructor(B,j,M,V,W,q,K,P,I,C,F,$,G,te,oe){this.location=B,this.mtime=j,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=V,this.profile=W,this.profileScanOptions=q,this.type=K,this.excludeObsolete=P,this.validate=I,this.productVersion=C,this.productDate=F,this.productCommit=$,this.devMode=G,this.language=te,this.translations=oe}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,j){return(0,k.isEqual)(B.location,j.location)&&B.mtime===j.mtime&&(0,k.isEqual)(B.applicationExtensionslocation,j.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&B.profile===j.profile&&R.equals(B.profileScanOptions,j.profileScanOptions)&&B.type===j.type&&B.excludeObsolete===j.excludeObsolete&&B.validate===j.validate&&B.productVersion===j.productVersion&&B.productDate===j.productDate&&B.productCommit===j.productCommit&&B.devMode===j.devMode&&B.language===j.language&&X.equals(B.translations,j.translations)}}e.ExtensionScannerInput=ie;let ne=class extends u.Disposable{constructor(B,j,M,V,W){super(),this.f=B,this.g=j,this.h=M,this.i=V,this.j=W}async scanExtensions(B){const j=B.profile?await this.l(B):await this.k(B);let M={};if(B.excludeObsolete&&B.type===1)try{const V=(await this.i.readFile(this.f)).value.toString();M=JSON.parse(V)}catch{}return(0,f.isEmptyObject)(M)?j:j.filter(V=>!M[d.ExtensionKey.create(V).toString()])}async k(B){const j=await this.i.resolve(B.location);if(!j.children?.length)return[];const M=await Promise.all(j.children.map(async V=>{if(!V.isDirectory||B.type===1&&(0,k.basename)(V.resource).indexOf(".")===0)return null;const W=new ie(V.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(W)}));return(0,T.coalesce)(M).sort((V,W)=>V.location.path<W.location.path?-1:1)}async l(B){let j=await this.m(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){j=j.filter(V=>!V.metadata?.isApplicationScoped);const M=await this.m(B.applicationExtensionslocation,V=>!!V.metadata?.isApplicationScoped,B);j.push(...M)}return j}async m(B,j,M){const V=await this.g.scanProfileExtensions(B,M.profileScanOptions);if(!V.length)return[];const W=await Promise.all(V.map(async q=>{if(j(q)){const K=new ie(q.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(K,q.metadata)}return null}));return(0,T.coalesce)(W)}async scanOneOrMultipleExtensions(B){try{if(await this.i.exists((0,k.joinPath)(B.location,"package.json"))){const j=await this.scanExtension(B);return j?[j]:[]}else return await this.scanExtensions(B)}catch(j){return this.j.error(`Error scanning extensions at ${B.location.path}:`,(0,N.getErrorMessage)(j)),[]}}async scanExtension(B,j){try{let M=await this.scanExtensionManifest(B.location);if(M){M.publisher||(M.publisher=y.UNDEFINED_PUBLISHER),j=j??M.__metadata,delete M.__metadata;const V=(0,d.getGalleryExtensionId)(M.publisher,M.name),W=j?.id?{id:V,uuid:j.id}:{id:V},q=j?.isSystem?0:B.type,K=q===0||!!j?.isBuiltin;Y.ImplicitActivationEvents.updateManifest(M),M=await this.n(B.location,M,ie.createNlsConfiguration(B));const P={type:q,identifier:W,manifest:M,location:B.location,isBuiltin:K,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return B.validate?this.validate(P,B):P}}catch(M){B.type!==0&&this.j.error(M)}return null}validate(B,j){let M=!0;const V=(0,t.validateExtensionManifest)(j.productVersion,j.productDate,j.location,B.manifest,B.isBuiltin);for(const[W,q]of V)W===L.default.Error&&(M=!1,this.j.error(this.t(j.location,q)));return B.isValid=M,B.validations=V,B}async scanExtensionManifest(B){const j=(0,k.joinPath)(B,"package.json");let M;try{M=(await this.i.readFile(j)).value.toString()}catch(W){return(0,o.toFileOperationResult)(W)!==1&&this.j.error(this.t(B,(0,m.localize)(0,null,j.path,W.message))),null}let V;try{V=JSON.parse(M)}catch{const q=[];(0,S.parse)(M,q);for(const K of q)this.j.error(this.t(B,(0,m.localize)(1,null,j.path,K.offset,K.length,(0,h.getParseErrorMessage)(K.error))));return null}return(0,S.getNodeType)(V)!=="object"?(this.j.error(this.t(B,(0,m.localize)(2,null,j.path))),null):V}async n(B,j,M){const V=await this.p(B,j,M);if(V)try{const W=[],q=await this.r(V.default,W);if(W.length>0)return W.forEach(P=>{this.j.error(this.t(B,(0,m.localize)(3,null,V.default?.path,(0,h.getParseErrorMessage)(P.error))))}),j;if((0,S.getNodeType)(V)!=="object")return this.j.error(this.t(B,(0,m.localize)(4,null,V.default?.path))),j;const K=V.values||Object.create(null);return(0,U.localizeManifest)(j,K,q)}catch{}return j}async p(B,j,M){const V=(0,k.joinPath)(B,"package.nls.json"),W=(I,C)=>{C.forEach(F=>{this.j.error(this.t(B,(0,m.localize)(5,null,I?.path,(0,h.getParseErrorMessage)(F.error))))})},q=I=>{this.j.error(this.t(B,(0,m.localize)(6,null,I?.path)))},K=`${j.publisher}.${j.name}`,P=M.translations[K];if(P)try{const I=c.URI.file(P),C=(await this.i.readFile(I)).value.toString(),F=[],$=(0,S.parse)(C,F);return F.length>0?(W(I,F),{values:void 0,default:V}):(0,S.getNodeType)($)!=="object"?(q(I),{values:void 0,default:V}):{values:$.contents?$.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.i.exists(V))return;let C;try{C=await this.s(B,M)}catch{return}if(!C.localized)return{values:void 0,default:C.original};try{const F=(await this.i.readFile(C.localized)).value.toString(),$=[],G=(0,S.parse)(F,$);return $.length>0?(W(C.localized,$),{values:void 0,default:C.original}):(0,S.getNodeType)(G)!=="object"?(q(C.localized),{values:void 0,default:C.original}):{values:G,default:C.original}}catch{return{values:void 0,default:C.original}}}}async r(B,j){if(B)try{const M=(await this.i.readFile(B)).value.toString();return(0,S.parse)(M,j)}catch{}}s(B,j){return new Promise((M,V)=>{const W=q=>{const K=(0,k.joinPath)(B,`package.nls.${q}.json`);this.i.exists(K).then(P=>{P&&M({localized:K,original:(0,k.joinPath)(B,"package.nls.json")});const I=q.lastIndexOf("-");I===-1?M({localized:(0,k.joinPath)(B,"package.nls.json"),original:null}):(q=q.substring(0,I),W(q))})};if(j.devMode||j.pseudo||!j.language)return M({localized:(0,k.joinPath)(B,"package.nls.json"),original:null});W(j.language)})}t(B,j){return`[${B.path}]: ${j}`}};ne=de([_(1,l.IExtensionsProfileScannerService),_(2,A.IUriIdentityService),_(3,o.IFileService),_(4,n.ILogService)],ne);let ae=class extends ne{constructor(B,j,M,V,W,q){super(j,M,V,W,q),this.y=B,this.v=this.B(new O.ThrottledDelayer(3e3)),this.w=this.B(new a.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(B){const j=await this.z();if(this.u=B,j&&j.input&&ie.equals(j.input,this.u))return this.j.debug("Using cached extensions scan result",B.location.toString()),this.v.trigger(()=>this.D()),j.result.map(V=>(V.location=c.URI.revive(V.location),V));const M=await super.scanExtensions(B);return await this.C({input:B,result:M}),M}async z(){try{const B=await this.i.readFile(this.y),j=JSON.parse(B.value.toString());return{result:j.result,input:(0,s.revive)(j.input)}}catch(B){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,N.getErrorMessage)(B))}return null}async C(B){try{await this.i.writeFile(this.y,D.VSBuffer.fromString(JSON.stringify(B)))}catch(j){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,N.getErrorMessage)(j))}}async D(){if(!this.u)return;const B=await this.z();if(!B)return;const j=B.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!R.equals(M,j))try{await this.i.del(this.y),this.w.fire()}catch(V){this.j.error(V)}}};ae=de([_(2,l.IExtensionsProfileScannerService),_(3,A.IUriIdentityService),_(4,o.IFileService),_(5,n.ILogService)],ae);function fe(me,B){const j=(0,d.getExtensionId)(me.manifest.publisher,me.manifest.name);return{id:j,identifier:new y.ExtensionIdentifier(j),isBuiltin:me.type===0,isUserBuiltin:me.type===1&&me.isBuiltin,isUnderDevelopment:B,extensionLocation:me.location,uuid:me.identifier.uuid,targetPlatform:me.targetPlatform,...me.manifest}}e.toExtensionDescription=fe;class re extends ee{constructor(B,j,M,V,W,q,K,P,I,C,F,$){super(B,j,(0,k.joinPath)(M,".vscode-oss-dev","extensions","control.json"),(0,k.joinPath)(V,y.MANIFEST_CACHE_FOLDER),W,q,K,P,I,C,F,$),this.M=(async()=>{if(g.translationsConfigFile)try{const G=await this.r.readFile(c.URI.file(g.translationsConfigFile));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(B){return this.M}}e.NativeExtensionsScannerService=re}),define(Z[146],Q([0,1,57,5,34,3,2,16,14,20,10,21]),function(x,e,T,O,R,D,N,S,h,u,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends N.Disposable{constructor(E,L){super(),this.b=E,this.f=L,this.a=new O.Limiter(5)}async postUninstall(E){const L=this.g(E,"uninstall");return L&&(this.f.info(E.identifier.id,E.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(L.script,"uninstall",L.args,!0,E).then(()=>this.f.info(E.identifier.id,E.manifest.version,"Finished running post uninstall script"),f=>this.f.error(E.identifier.id,E.manifest.version,`Failed to run post uninstall script: ${f}`)))),u.Promises.rm(this.j(E)).then(void 0,f=>this.f.error("Error while removing extension storage path",f))}g(E,L){const f=`vscode:${L}`;if(E.location.scheme===S.Schemas.file&&E.manifest&&E.manifest.scripts&&typeof E.manifest.scripts[f]=="string"){const c=E.manifest.scripts[f].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(E.identifier.id,E.manifest.version,`${f} should be a node script`),null):{script:(0,h.join)(E.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(E,L,f,c,m){return new Promise((b,d)=>{const y=this.i(E,L,f,m);let t;const o=i=>{t&&(clearTimeout(t),t=null),i?d(i):b(void 0)};y.on("error",i=>{o((0,R.toErrorMessage)(i)||"Unknown")}),y.on("exit",(i,n)=>{o(i?`post-${L} process exited with code ${i}`:void 0)}),c&&(t=setTimeout(()=>{t=null,y.kill(),d("timed out")},5e3))})}i(E,L,f,c){const m={silent:!0,execArgv:void 0},b=(0,T.fork)(E,[`--type=extension-post-${L}`,...f],m);b.stdout.setEncoding("utf8"),b.stderr.setEncoding("utf8");const d=D.Event.fromNodeEventEmitter(b.stdout,"data"),y=D.Event.fromNodeEventEmitter(b.stderr,"data");d(i=>this.f.info(c.identifier.id,c.manifest.version,`post-${L}`,i)),y(i=>this.f.error(c.identifier.id,c.manifest.version,`post-${L}`,i));const t=D.Event.any(D.Event.map(d,i=>({data:`%c${i}`,format:[""]})),D.Event.map(y,i=>({data:`%c${i}`,format:["color: red"]})));return D.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(c.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),b}j(E){return(0,h.join)(this.b.defaultProfile.globalStorageHome.fsPath,E.identifier.id.toLowerCase())}};g=de([_(0,p.IUserDataProfilesService),_(1,v.ILogService)],g),e.ExtensionsLifecycle=g}),define(Z[147],Q([0,1,10,21,27,25,40,13,17,11]),function(x,e,T,O,R,D,N,S,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let v=class extends N.AbstractExtensionsProfileScannerService{constructor(g,k,E,L,f,c){super(u.URI.file(g.extensionsPath),k,E,L,f,c)}};v=de([_(0,h.INativeEnvironmentService),_(1,S.IFileService),_(2,O.IUserDataProfilesService),_(3,R.IUriIdentityService),_(4,D.ITelemetryService),_(5,T.ILogService)],v),e.ExtensionsProfileScannerService=v}),define(Z[148],Q([0,1,11,17,40,48,13,9,10,28,27,21]),function(x,e,T,O,R,D,N,S,h,u,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=class extends D.NativeExtensionsScannerService{constructor(E,L,f,c,m,b,d,y){super(T.URI.file(m.builtinExtensionsPath),T.URI.file(m.extensionsPath),m.userHome,T.URI.file(m.userDataPath),E,L,f,c,m,b,d,y)}};g=de([_(0,p.IUserDataProfilesService),_(1,R.IExtensionsProfileScannerService),_(2,N.IFileService),_(3,h.ILogService),_(4,O.INativeEnvironmentService),_(5,u.IProductService),_(6,v.IUriIdentityService),_(7,S.IInstantiationService)],g),e.ExtensionsScannerService=g}),define(Z[149],Q([0,1,5,3,2,118,4,84,9,21]),function(x,e,T,O,R,D,N,S,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,h.createDecorator)("storageService");var v;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(v=e.WillSaveStateReason||(e.WillSaveStateReason={}));var p;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(p=e.StorageScope||(e.StorageScope={}));var g;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));function k(m){const b=m.get(e.TARGET_KEY);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}e.loadKeyTargets=k;class E extends R.Disposable{constructor(b={flushInterval:E.a}){super(),this.j=b,this.b=this.B(new O.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new O.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new T.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new R.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,T.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,R.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.J()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(b,d){if(d===e.TARGET_KEY){switch(b){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:b})}else this.b.fire({scope:b,key:d,target:this.F(b)[d]})}r(b){this.f.fire({reason:b})}get(b,d,y){return this.L(d)?.get(b,y)}getBoolean(b,d,y){return this.L(d)?.getBoolean(b,y)}getNumber(b,d,y){return this.L(d)?.getNumber(b,y)}store(b,d,y,t){if((0,N.isUndefinedOrNull)(d)){this.remove(b,y);return}this.t(()=>{this.u(b,y,t),this.L(y)?.set(b,d)})}remove(b,d){this.t(()=>{this.u(b,d,void 0),this.L(d)?.delete(b)})}t(b){this.b.pause(),this.c.pause();try{b()}finally{this.b.resume(),this.c.resume()}}keys(b,d){const y=[],t=this.F(b);for(const o of Object.keys(t))t[o]===d&&y.push(o);return y}u(b,d,y){const t=this.F(d);typeof y=="number"?t[b]!==y&&(t[b]=y,this.L(d)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[b]=="number"&&(delete t[b],this.L(d)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(b){switch(b){case-1:return this.D;case 0:return this.z;default:return this.w}}G(b){const d=this.L(b);return d?k(d):Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=v.NONE){this.f.fire({reason:b});const d=this.L(-1),y=this.L(0),t=this.L(1);switch(b){case v.NONE:await T.Promises.settled([d?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case v.SHUTDOWN:await T.Promises.settled([d?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.L(-1)?.items??new Map,d=this.L(0)?.items??new Map,y=this.L(1)?.items??new Map;return c(b,d,y,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(b,d){return this.r(v.NONE),(0,u.isUserDataProfile)(b)?this.N(b,d):this.O(b,d)}H(b,d){return!(b.id===d.id||L(d)&&L(b))}I(b,d,y,t){this.t(()=>{if(t)for(const[o,i]of b)d.set(o,i);else{const o=new Set;for(const[i,n]of b)o.add(i),d.get(i)!==n&&this.n(y,i);for(const[i]of d.items)o.has(i)||this.n(y,i)}})}}e.AbstractStorageService=E,E.a=60*1e3;function L(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=L;class f extends E{constructor(){super(),this.p=this.B(new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(b=>this.n(1,b))),this.B(this.P.onDidChangeStorage(b=>this.n(0,b))),this.B(this.p.onDidChangeStorage(b=>this.n(-1,b)))}L(b){switch(b){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(b){switch(b){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(b){return!1}}e.InMemoryStorageService=f;async function c(m,b,d,y,t,o){const i=Y=>{try{return JSON.parse(Y)}catch{return Y}},n=new Map,r=new Map;m.forEach((Y,X)=>{n.set(X,Y),r.set(X,i(Y))});const a=new Map,s=new Map;b.forEach((Y,X)=>{a.set(X,Y),s.set(X,i(Y))});const l=new Map,w=new Map;d.forEach((Y,X)=>{l.set(X,Y),w.set(X,i(Y))}),console.group(y!==t?`Storage: Application (path: ${y})`:`Storage: Application & Profile (path: ${y}, default profile)`);const A=[];if(n.forEach((Y,X)=>{A.push({key:X,value:Y})}),console.table(A),console.groupEnd(),console.log(r),y!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const Y=[];a.forEach((X,ee)=>{Y.push({key:ee,value:X})}),console.table(Y),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${o})`);const U=[];l.forEach((Y,X)=>{U.push({key:X,value:Y})}),console.table(U),console.groupEnd(),console.log(w)}e.logStorage=c}),define(Z[150],Q([0,1,19,22,6,12,35,4,11,23,17,24,26,45,13,10,28,47,135,149,25]),function(x,e,T,O,R,D,N,S,h,u,v,p,g,k,E,L,f,c,m,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const y=D.isWeb?"web":(0,p.getTargetPlatform)(D.platform,N.arch);var t;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function o(...P){return String(P.reduce((I,C)=>I|C,0))}var i;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class l{constructor(I=s){this.d=I}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(I,C=this.d.pageSize){return new l({...this.d,pageNumber:I,pageSize:C})}withFilter(I,...C){const F=[...this.d.criteria,...C.length?C.map($=>({filterType:I,value:$})):[{filterType:I}]];return new l({...this.d,criteria:F})}withSortBy(I){return new l({...this.d,sortBy:I})}withSortOrder(I){return new l({...this.d,sortOrder:I})}withFlags(...I){return new l({...this.d,flags:I.reduce((C,F)=>C|F,0)})}withAssetTypes(...I){return new l({...this.d,assetTypes:I})}withSource(I){return new l({...this.d,source:I})}get raw(){const{criteria:I,pageNumber:C,pageSize:F,sortBy:$,sortOrder:G,flags:te,assetTypes:oe}=this.d;return{filters:[{criteria:I,pageNumber:C,pageSize:F,sortBy:$,sortOrder:G}],assetTypes:oe,flags:te}}get searchText(){const I=this.d.criteria.filter(C=>C.filterType===i.SearchText)[0];return I&&I.value?I.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(I=>String(I.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function w(P,I){const C=(P||[]).filter(F=>F.statisticName===I)[0];return C?C.value:0}function A(P){const I="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(F=>F.assetType.indexOf(I)===0).reduce((F,$)=>{const G=X(P,$.assetType);return G&&F.push([$.assetType.substring(I.length),G]),F},[])}function U(P){if(P.properties){const I=P.properties.filter($=>$.key===n.Repository),C=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=I.filter($=>C.test($.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return X(P,n.Repository)}function Y(P){return{uri:`${P.fallbackAssetUri}/${n.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${n.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function X(P,I){return P.files.filter(F=>F.assetType===I)[0]?{uri:`${P.assetUri}/${I}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${I}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function ee(P,I){const C=P.properties?P.properties.filter($=>$.key===I):[],F=C.length>0&&C[0].value;return F?F.split(",").map($=>(0,g.adoptToGalleryExtensionId)($)):[]}function ie(P){const I=P.properties?P.properties.filter(C=>C.key===r.Engine):[];return I.length>0&&I[0].value||""}function ne(P){const I=P.properties?P.properties.filter(C=>C.key===r.PreRelease):[];return I.length>0&&I[0].value==="true"}function ae(P){const I=P.properties?P.properties.filter(F=>F.key===r.LocalizedLanguages):[],C=I.length>0&&I[0].value||"";return C?C.split(","):[]}function fe(P){return P.properties?.find(I=>I.key===r.SponsorLink)?.value}function re(P){return P.indexOf("preview")!==-1}function me(P){return P.targetPlatform?(0,p.toTargetPlatform)(P.targetPlatform):"undefined"}function B(P){const I=(0,T.distinct)(P.versions.map(me)),C=!!P.tags?.includes(p.WEB_EXTENSION_TAG),F=I.indexOf("web");return C?F===-1&&I.push("web"):F!==-1&&I.splice(F,1),I}function j(P,I){const C=(0,p.getFallbackTargetPlarforms)(I);for(let F=0;F<P.length;F++){const $=P[F];if($.version===P[F-1]?.version){let G=F;const te=me($);if(te===I)for(;G>0&&P[G-1].version===$.version;)G--;else if(C.includes(te))for(;G>0&&P[G-1].version===$.version&&me(P[G-1])!==I;)G--;G!==F&&(P.splice(F,1),P.splice(G,0,$))}}return P}e.sortExtensionVersions=j;function M(P,I,C){P.telemetryData={index:I,querySource:C}}function V(P,I,C){const F=P.versions[0],$={manifest:X(I,n.Manifest),readme:X(I,n.Details),changelog:X(I,n.Changelog),license:X(I,n.License),repository:U(I),download:Y(I),icon:X(I,n.Icon),signature:X(I,n.Signature),coreTranslations:A(I)};return{identifier:{id:(0,g.getGalleryExtensionId)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:I.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:fe(F),description:P.shortDescription||"",installCount:w(P.statistics,"install"),rating:w(P.statistics,"averagerating"),ratingCount:w(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:C,assets:$,properties:{dependencies:ee(I,r.Dependency),extensionPack:ee(I,r.ExtensionPack),engine:ie(I),localizedLanguages:ae(I),targetPlatform:me(I),isPreReleaseVersion:ne(I)},hasPreReleaseVersion:ne(F),hasReleaseVersion:!0,preview:re(P.flags),isSigned:!!$.signature}}let W=class{constructor(I,C,F,$,G,te,oe,ge){this.k=C,this.l=F,this.n=$,this.o=G,this.q=te,this.u=oe,this.w=ge;const ve=oe.extensionsGallery,le=ve?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=le?ve.servicePPEUrl:ve?.serviceUrl,this.g=le?void 0:ve?.searchUrl,this.h=ve?.controlUrl,this.j=(0,m.resolveMarketplaceHeaders)(oe.version,oe,this.n,this.w,this.q,I,this.o)}x(I=""){return`${this.d}${I}`}isEnabled(){return!!this.d}async getExtensions(I,C,F){const $=O.CancellationToken.isCancellationToken(C)?{}:C,G=O.CancellationToken.isCancellationToken(C)?C:F,te=[],oe=[],ge=[],ve=[];let le=!0;for(const se of I){se.uuid?oe.push(se.uuid):te.push(se.id);const ue=!!(se.version||se.preRelease);ge.push({id:se.id,uuid:se.uuid,includePreRelease:ue}),se.version&&ve.push({id:se.id,uuid:se.uuid,version:se.version}),le=le&&!!se.hasPreRelease&&!ue}if(!oe.length&&!te.length)return[];let ce=new l().withPage(1,I.length);oe.length&&(ce=ce.withFilter(i.ExtensionId,...oe)),te.length&&(ce=ce.withFilter(i.ExtensionName,...te)),($.queryAllVersions||le)&&(ce=ce.withFlags(ce.flags,t.IncludeVersions)),$.source&&(ce=ce.withSource($.source));const{extensions:we}=await this.z(ce,{targetPlatform:$.targetPlatform??y,includePreRelease:ge,versions:ve,compatible:!!$.compatible},G);return $.source&&we.forEach((se,ue)=>M(se,ue,$.source)),we}async getCompatibleExtension(I,C,F){if((0,p.isNotWebExtensionInWebTargetPlatform)(I.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(I,C,F))return I;const $=new l().withFlags(t.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,I.identifier.uuid),{extensions:G}=await this.z($,{targetPlatform:F,compatible:!0,includePreRelease:C},O.CancellationToken.None);return G[0]||null}async isExtensionCompatible(I,C,F){if(!(0,p.isTargetPlatformCompatible)(I.properties.targetPlatform,I.allTargetPlatforms,F)||!C&&I.properties.isPreReleaseVersion)return!1;let $=I.properties.engine;if(!$){const G=await this.getManifest(I,O.CancellationToken.None);if(!G)throw new Error("Manifest was not found");$=G.engines.vscode}return(0,k.isEngineValid)($,this.u.version,this.u.date)}async y(I,C,F,$,G){if(!(0,p.isTargetPlatformCompatible)(me(I),$,G)||C!=="any"&&ne(I)!==(C==="prerelease"))return!1;if(F)try{const te=await this.E(I);if(!(0,k.isEngineValid)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${I.version}.`,(0,R.getErrorMessage)(te)),!1}return!0}async query(I,C){let F=I.text||"";const $=I.pageSize??50;let G=new l().withPage(1,$);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ce,we)=>(G=G.withFilter(i.Category,we||ce),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ce,we)=>(G=G.withFilter(i.Tag,we||ce),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(i.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),G=G.withFilter(i.SearchText,F)),G=G.withSortBy(0)):I.ids?G=G.withFilter(i.ExtensionId,...I.ids):I.names?G=G.withFilter(i.ExtensionName,...I.names):G=G.withSortBy(4),typeof I.sortBy=="number"&&(G=G.withSortBy(I.sortBy)),typeof I.sortOrder=="number"&&(G=G.withSortOrder(I.sortOrder)),I.source&&(G=G.withSource(I.source));const te=async(le,ce)=>{const{extensions:we,total:se}=await this.z(le,{targetPlatform:y,compatible:!1,includePreRelease:!!I.includePreRelease},ce);return we.forEach((ue,be)=>M(ue,(le.pageNumber-1)*le.pageSize+be,I.source)),{extensions:we,total:se}},{extensions:oe,total:ge}=await te(G,C),ve=async(le,ce)=>{if(ce.isCancellationRequested)throw new R.CancellationError;const{extensions:we}=await te(G.withPage(le+1),ce);return we};return{firstPage:oe,total:ge,pageSize:G.pageSize,getPage:ve}}async z(I,C,F){const $=I.flags;!!(I.flags&t.IncludeLatestVersionOnly)&&!!(I.flags&t.IncludeVersions)&&(I=I.withFlags(I.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(I.flags&t.IncludeLatestVersionOnly)&&!(I.flags&t.IncludeVersions)&&(I=I.withFlags(I.flags,t.IncludeLatestVersionOnly)),C.versions?.length&&(I=I.withFlags(I.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),I=I.withFlags(I.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:G,total:te}=await this.B(I,F);if(!(I.flags&t.IncludeLatestVersionOnly)){const le=[];for(const ce of G){const we=await this.A(ce,C);we&&le.push(we)}return{extensions:le,total:te}}const ge=[],ve=new Map;for(let le=0;le<G.length;le++){const ce=G[le],we={id:(0,g.getGalleryExtensionId)(ce.publisher.publisherName,ce.extensionName),uuid:ce.extensionId},se=(0,S.isBoolean)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(be=>(0,g.areSameExtensions)(be,we))?.includePreRelease;if(C.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(B(ce),C.targetPlatform))continue;const ue=await this.A(ce,C);!ue||ue.properties.isPreReleaseVersion&&(!se||!ue.hasReleaseVersion)||!ue.properties.isPreReleaseVersion&&ue.properties.targetPlatform!==C.targetPlatform&&ue.hasPreReleaseVersion?ve.set(ce.extensionId,le):ge.push([le,ue])}if(ve.size){const le=new Date().getTime(),ce=new l().withFlags($&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ve.size).withFilter(i.ExtensionId,...ve.keys()),{extensions:we}=await this.z(ce,C,F);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-le,count:ve.size});for(const se of we){const ue=ve.get(se.identifier.uuid);ge.push([ue,se])}}return{extensions:ge.sort((le,ce)=>le[0]-ce[0]).map(([,le])=>le),total:te}}async A(I,C){const F={id:(0,g.getGalleryExtensionId)(I.publisher.publisherName,I.extensionName),uuid:I.extensionId},$=C.versions?.find(ge=>(0,g.areSameExtensions)(ge,F))?.version,G=(0,S.isBoolean)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(ge=>(0,g.areSameExtensions)(ge,F))?.includePreRelease,te=B(I),oe=j(I.versions,C.targetPlatform);if(C.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(te,C.targetPlatform))return null;for(let ge=0;ge<oe.length;ge++){const ve=oe[ge];if(!($&&ve.version!==$)){if(await this.y(ve,G?"any":"release",C.compatible,te,C.targetPlatform))return V(I,ve,te);if($&&ve.version===$)return null}}return $||C.compatible?null:V(I,I.versions[0],te)}async B(I,C){if(!this.isEnabled())throw new Error("No extension gallery service configured.");I=I.withFlags(I.flags,t.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,o(t.Unpublished));const F=await this.j,$=JSON.stringify(I.raw),G={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String($.length)},te=new Date().getTime();let oe,ge,ve=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&I.criteria.some(ce=>ce.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:$,headers:G},C),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:ve};const le=await(0,c.asJson)(oe);if(le){const ce=le.results[0],we=ce.extensions,se=ce.resultMetadata&&ce.resultMetadata.filter(ue=>ue.metadataType==="ResultCount")[0];return ve=se&&se.metadataItems.filter(ue=>ue.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ve}}return{galleryExtensions:[],total:ve}}catch(le){throw ge=le,le}finally{this.o.publicLog2("galleryService:query",{...I.telemetryData,requestBodySize:String($.length),duration:new Date().getTime()-te,success:!!oe&&(0,c.isSuccess)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:ge?(0,R.isCancellationError)(ge)?"canceled":(0,R.getErrorMessage)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(I,C,F,$){if(!this.isEnabled())return;const G=D.isWeb?this.x(`/itemName/${I}.${C}/version/${F}/statType/${$==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${I}/extensions/${C}/${F}/stats?statType=${$}`),te=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:G,headers:ge},O.CancellationToken.None)}catch{}}async download(I,C,F){this.l.trace("ExtensionGalleryService#download",I.identifier.id);const $=(0,g.getGalleryExtensionTelemetryData)(I),G=new Date().getTime(),te=le=>this.o.publicLog("galleryService:downloadVSIX",{...$,duration:le}),oe=F===2?"install":F===3?"update":"",ge=oe?{uri:`${I.assets.download.uri}${h.URI.parse(I.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${I.assets.download.fallbackUri}${h.URI.parse(I.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:I.assets.download,ve=await this.D(ge);await this.q.writeFile(C,ve.stream),te(new Date().getTime()-G)}async downloadSignatureArchive(I,C){if(!I.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",I.identifier.id);const F=await this.D(I.assets.signature);await this.q.writeFile(C,F.stream)}async getReadme(I,C){if(I.assets.readme){const F=await this.D(I.assets.readme,{},C);return await(0,c.asTextOrError)(F)||""}return""}async getManifest(I,C){if(I.assets.manifest){const F=await this.D(I.assets.manifest,{},C),$=await(0,c.asTextOrError)(F);return $?JSON.parse($):null}return null}async C(I,C){const F=X(I,n.Manifest);if(!F)throw new Error("Manifest was not found");const $={"Accept-Encoding":"gzip"},G=await this.D(F,{headers:$});return await(0,c.asJson)(G)}async getCoreTranslation(I,C){const F=I.assets.coreTranslations.filter($=>$[0]===C.toUpperCase())[0];if(F){const $=await this.D(F[1]),G=await(0,c.asTextOrError)($);return G?JSON.parse(G):null}return null}async getChangelog(I,C){if(I.assets.changelog){const F=await this.D(I.assets.changelog,{},C);return await(0,c.asTextOrError)(F)||""}return""}async getAllCompatibleVersions(I,C,F){let $=new l().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);I.identifier.uuid?$=$.withFilter(i.ExtensionId,I.identifier.uuid):$=$.withFilter(i.ExtensionName,I.identifier.id);const{galleryExtensions:G}=await this.B($,O.CancellationToken.None);if(!G.length)return[];const te=B(G[0]);if((0,p.isNotWebExtensionInWebTargetPlatform)(te,F))return[];const oe=[];await Promise.all(G[0].versions.map(async le=>{try{await this.y(le,C?"any":"release",!0,te,F)&&oe.push(le)}catch{}}));const ge=[],ve=new Set;for(const le of j(oe,F))ve.has(le.version)||(ve.add(le.version),ge.push({version:le.version,date:le.lastUpdated,isPreReleaseVersion:ne(le)}));return ge}async D(I,C={},F=O.CancellationToken.None){const $=await this.j,G={type:"GET"},te={...$,...C.headers||{}};C={...C,...G,headers:te};const oe=I.uri,ge=I.fallbackUri,ve={...C,url:oe};try{const le=await this.k.request(ve,F);if(le.res.statusCode===200)return le;const ce=await(0,c.asTextOrError)(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${ce}`)}catch(le){if((0,R.isCancellationError)(le))throw le;const ce=(0,R.getErrorMessage)(le);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:ce});const we={...C,url:ge};return this.k.request(we,F)}}async E(I){let C=ie(I);if(!C){const F=await this.C(I,O.CancellationToken.None);if(!F)throw new Error("Manifest was not found");C=F.engines.vscode}return C}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const I=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(I.res.statusCode!==200)throw new Error("Could not get extensions report.");const C=await(0,c.asJson)(I),F=[],$={};if(C){for(const G of C.malicious)F.push({id:G});if(C.migrateToPreRelease)for(const[G,te]of Object.entries(C.migrateToPreRelease))(!te.engine||(0,k.isEngineValid)(te.engine,this.u.version,this.u.date))&&($[G.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(C.deprecated)for(const[G,te]of Object.entries(C.deprecated))te&&($[G.toLowerCase()]=(0,S.isBoolean)(te)?{}:te)}return{malicious:F,deprecated:$}}};W=de([_(1,c.IRequestService),_(2,L.ILogService),_(3,v.IEnvironmentService),_(4,d.ITelemetryService),_(5,E.IFileService),_(6,f.IProductService),_(7,u.IConfigurationService)],W);let q=class extends W{constructor(I,C,F,$,G,te,oe,ge){super(I,C,F,$,G,te,oe,ge)}};q=de([_(0,b.IStorageService),_(1,c.IRequestService),_(2,L.ILogService),_(3,v.IEnvironmentService),_(4,d.ITelemetryService),_(5,E.IFileService),_(6,f.IProductService),_(7,u.IConfigurationService)],q),e.ExtensionGalleryService=q;let K=class extends W{constructor(I,C,F,$,G,te,oe){super(void 0,I,C,F,$,G,te,oe)}};K=de([_(0,c.IRequestService),_(1,L.ILogService),_(2,v.IEnvironmentService),_(3,d.ITelemetryService),_(4,E.IFileService),_(5,f.IProductService),_(6,u.IConfigurationService)],K),e.ExtensionGalleryServiceWithNoStorageService=K}),define(Z[151],Q([0,1,44,11,17,13,10,67,27,21]),function(x,e,T,O,R,D,N,S,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let v=class extends u.UserDataProfilesService{constructor(k,E,L,f){super(E,L,k,f),this.a=E}L(){return this.r.extUri.joinPath(O.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};v=de([_(0,h.IUriIdentityService),_(1,R.INativeEnvironmentService),_(2,D.IFileService),_(3,N.ILogService)],v),e.ServerUserDataProfilesService=v;let p=class $e extends v{constructor(k,E,L,f,c){super(E,L,f,c),this.N=k}G(){return(0,T.revive)(this.N.getItem($e.b,[]))}I(){return(0,T.revive)(this.N.getItem($e.c,{}))}L(){return this.r.extUri.joinPath(O.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};p=de([_(0,S.IStateService),_(1,h.IUriIdentityService),_(2,R.INativeEnvironmentService),_(3,D.IFileService),_(4,N.ILogService)],p),e.UserDataProfilesService=p}),define(Z[152],Q([0,1,38,5,165,2,10]),function(x,e,T,O,R,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let S=class extends T.AbstractPolicyService{constructor(u,v){super(),this.j=u,this.k=v,this.a=new O.Throttler,this.b=this.B(new D.MutableDisposable)}async i(u){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`),await this.a.queue(()=>new Promise((v,p)=>{try{this.b.value=(0,R.createWatcher)(this.k,u,g=>{this.m(g),v()})}catch(g){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),p(g)}}))}m(u){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const v in u){const p=u[v];p===void 0?this.g.delete(v):this.g.set(v,p)}this.h.fire(Object.keys(u))}};S=de([_(0,N.ILogService)],S),e.NativePolicyService=S}),define(Z[69],Q([0,1,120,5,14,4,20,85,166,167]),function(x,e,T,O,R,D,N,S,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class v extends Error{constructor(t,o){let i=o.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=o}}e.ExtractError=v;function p(y){const t=y.externalFileAttributes>>16||33188;return[448,56,7].map(o=>t&o).reduce((o,i)=>o+i,t&61440)}function g(y){if(y instanceof v)return y;let t;return/end of central directory record signature not found/.test(y.message)&&(t="CorruptZip"),new v(t,y)}function k(y,t,o,i,n,r){const a=R.dirname(t),s=R.join(i,a);if(!s.startsWith(i))return Promise.reject(new Error(S.localize(0,null,t)));const l=R.join(i,t);let w;return r.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(N.Promises.mkdir(s,{recursive:!0})).then(()=>new Promise((A,U)=>{if(!r.isCancellationRequested)try{w=(0,T.createWriteStream)(l,{mode:o}),w.once("close",()=>A()),w.once("error",U),y.once("error",U),y.pipe(w)}catch(Y){U(Y)}}))}function E(y,t,o,i){let n=(0,O.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{n.cancel(),y.close()}),new Promise((a,s)=>{const l=new O.Sequencer,w=A=>{A.isCancellationRequested||(r++,y.readEntry())};y.once("error",s),y.once("close",()=>n.then(()=>{i.isCancellationRequested||y.entryCount===r?a():s(new v("Incomplete",new Error(S.localize(1,null,r,y.entryCount))))},s)),y.readEntry(),y.on("entry",A=>{if(i.isCancellationRequested)return;if(!o.sourcePathRegex.test(A.fileName)){w(i);return}const U=A.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(U)){const ee=R.join(t,U);n=(0,O.createCancelablePromise)(ie=>N.Promises.mkdir(ee,{recursive:!0}).then(()=>w(ie)).then(void 0,s));return}const Y=f(y,A),X=p(A);n=(0,O.createCancelablePromise)(ee=>l.queue(()=>Y.then(ie=>k(ie,U,X,t,o,ee).then(()=>w(ee)))).then(null,s))})})}function L(y,t=!1){return new Promise((o,i)=>{(0,h.open)(y,t?{lazyEntries:!0}:void 0,(n,r)=>{n?i(g(n)):o((0,D.assertIsDefined)(r))})})}function f(y,t){return new Promise((o,i)=>{y.openReadStream(t,(n,r)=>{n?i(g(n)):o((0,D.assertIsDefined)(r))})})}function c(y,t){return new Promise((o,i)=>{const n=new u.ZipFile;t.forEach(a=>{a.contents?n.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&n.addFile(a.localPath,a.path)}),n.end();const r=(0,T.createWriteStream)(y);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>o(y))})}e.zip=c;function m(y,t,o={},i){const n=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let r=L(y,!0);return o.overwrite&&(r=r.then(a=>N.Promises.rm(t).then(()=>a))),r.then(a=>E(a,t,{sourcePathRegex:n},i))}e.extract=m;function b(y,t){return L(y).then(o=>new Promise((i,n)=>{o.on("entry",r=>{r.fileName===t&&f(o,r).then(a=>i(a),a=>n(a))}),o.once("close",()=>n(new Error(S.localize(2,null,t))))}))}function d(y,t){return b(y,t).then(o=>new Promise((i,n)=>{const r=[];o.once("error",n),o.on("data",a=>r.push(a)),o.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=d}),define(Z[153],Q([0,1,69,93]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(D){return(0,T.buffer)(D,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=R}),define(Z[154],Q([0,1,5,22,34,6,3,2,36,16,14,12,18,41,4,11,31,20,69,92,58,17,145,24,26,40,48,133,146,153,126,134,29,45,13,9,10,28,25,27,21]),function(x,e,T,O,R,D,N,S,h,u,v,p,g,k,E,L,f,c,m,b,d,y,t,o,i,n,r,a,s,l,w,A,U,Y,X,ee,ie,ne,ae,fe,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ee.refineServiceDecorator)(o.IExtensionManagementService);let me=class extends t.AbstractExtensionManagementService{constructor(P,I,C,F,$,G,te,oe,ge,ve,le,ce){super(P,I,C,ve,ce),this.Y=$,this.Z=G,this.ab=te,this.bb=ge,this.cb=le,this.X=new Map,this.kb=new h.ResourceSet;const we=this.B(oe.createInstance(s.ExtensionsLifecycle));this.S=this.B(oe.createInstance(B,ue=>we.postUninstall(ue))),this.U=this.B(new w.ExtensionsManifestCache(F,this)),this.W=this.B(oe.createInstance(a.ExtensionsDownloader));const se=this.B(new A.ExtensionsWatcher(this,this.Y,ce,G,le,ge,C));this.B(se.onDidChangeExtensionsByAnotherSource(ue=>this.jb(ue))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,i.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(P){this.v.trace("ExtensionManagementService#zip",P.identifier.id);const I=await this.ib(P),C=await(0,m.zip)((0,g.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,I);return L.URI.file(C)}async unzip(P){return this.v.trace("ExtensionManagementService#unzip",P.toString()),(await this.install(P)).identifier}async getManifest(P){const{location:I,cleanup:C}=await this.eb(P),F=v.resolve(I.fsPath);try{return await(0,l.getManifest)(F)}finally{await C()}}getInstalled(P,I){return this.S.scanExtensions(P??null,I)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(P,I={}){this.v.trace("ExtensionManagementService#install",P.toString());const{location:C,cleanup:F}=await this.eb(P);try{const $=await(0,l.getManifest)(v.resolve(C.fsPath));if($.engines&&$.engines.vscode&&!(0,Y.isEngineValid)($.engines.vscode,this.w.version,this.w.date))throw new Error(b.localize(0,null,(0,i.getGalleryExtensionId)($.publisher,$.name),this.w.version));return await this.z($,C,I)}finally{await F()}}async installFromLocation(P,I){this.v.trace("ExtensionManagementService#installFromLocation",P.toString());const C=await this.S.scanUserExtensionAtLocation(P);if(!C)throw new Error(`Cannot find a valid extension from the location ${P.toString()}`);return await this.nb([C],I),this.v.info("Successfully installed extension",C.identifier.id,I.toString()),C}getMetadata(P){return this.Y.scanMetadata(P.location)}async updateMetadata(P,I){this.v.trace("ExtensionManagementService#updateMetadata",P.identifier.id);const C={...I};return I.isPreReleaseVersion&&(C.preRelease=!0),P=await this.S.updateMetadata(P,C),this.U.invalidate(),P}async updateExtensionScope(P,I){return this.v.trace("ExtensionManagementService#updateExtensionScope",P.identifier.id),P=await this.S.updateMetadata(P,{isMachineScoped:I}),this.U.invalidate(),P}async reinstallFromGallery(P){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",P.identifier.id),!this.t.isEnabled())throw new Error(b.localize(1,null));const I=await this.getTargetPlatform(),[C]=await this.t.getExtensions([{...P.identifier,preRelease:P.preRelease}],{targetPlatform:I,compatible:!0},O.CancellationToken.None);if(!C)throw new Error(b.localize(2,null));await this.S.setUninstalled(P);try{await this.S.removeUninstalledExtension(P)}catch(F){throw new Error(b.localize(3,null,(0,R.toErrorMessage)(F)))}return this.installFromGallery(C)}markAsUninstalled(...P){return this.S.setUninstalled(...P)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(P,I){const{location:C}=await this.W.download(P,I);return C}async eb(P){if(P.scheme===u.Schemas.file)return{location:P,async cleanup(){}};this.v.trace("Downloading extension from",P.toString());const I=(0,g.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)());return await this.ab.download(P,I),this.v.info("Downloaded extension to",I.toString()),{location:I,cleanup:async()=>{try{await this.bb.del(I)}catch(F){this.v.error(F)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(P,I,C){let F;if(L.URI.isUri(I))F=new V(P,I,C,this.t,this.S,this.v);else{const $=i.ExtensionKey.create(I).toString();F=this.X.get($),F||(this.X.set($,F=new M(P,I,C,this.W,this.S,this.v)),F.waitUntilTaskIsFinished().then(()=>this.X.delete($)))}return new W(F,C.profileLocation,this.cb,this.y,this.Y,this.Z)}R(P,I){return new q(P,I.profileLocation,this.Z)}async ib(P){const I=async F=>{let $=await c.Promises.readdir(F);$=$.map(oe=>v.join(F,oe));const G=await Promise.all($.map(oe=>c.Promises.stat(oe)));let te=Promise.resolve([]);return G.forEach((oe,ge)=>{const ve=$[ge];oe.isFile()&&(te=te.then(le=>[...le,ve])),oe.isDirectory()&&(te=te.then(le=>I(ve).then(ce=>[...le,...ce])))}),te};return(await I(P.location.fsPath)).map(F=>({path:`extension/${v.relative(P.location.fsPath,F)}`,localPath:F}))}async jb({added:P,removed:I}){if(I)for(const C of I.extensions)this.v.info("Extensions removed from another source",C.id,I.profileLocation.toString()),this.p.fire({identifier:C,profileLocation:I.profileLocation});if(P){const F=(await this.S.scanExtensions(1,P.profileLocation)).filter($=>P.extensions.some(G=>(0,i.areSameExtensions)(G,$.identifier)));this.m.fire(F.map($=>(this.v.info("Extensions added from another source",$.identifier.id,P.profileLocation.toString()),{identifier:$.identifier,local:$,profileLocation:P.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(I=>this.kb.add(I)));const P=await this.bb.resolve(this.Y.userExtensionsLocation);for(const I of P.children??[])I.isDirectory&&this.kb.add(I.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(I=>this.mb(I)))}async mb(P){if(!P.affects(this.Y.userExtensionsLocation,1))return;const I=[];for(const C of P.rawAdded){if(this.kb.has(C)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(C),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(C,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(C).startsWith(".")||!(await this.bb.stat(C)).isDirectory)continue;const F=await this.S.scanUserExtensionAtLocation(C);F&&F.installedTimestamp===void 0&&(this.kb.add(C),I.push(F))}I.length&&(await this.nb(I,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",I.map(C=>C.identifier.id)))}async nb(P,I){await this.Z.addExtensionsToProfile(P.map(C=>[C,void 0]),I),this.m.fire(P.map(C=>({local:C,identifier:C.identifier,operation:1,profileLocation:I})))}};me=de([_(0,o.IExtensionGalleryService),_(1,ae.ITelemetryService),_(2,ie.ILogService),_(3,y.INativeEnvironmentService),_(4,r.IExtensionsScannerService),_(5,n.IExtensionsProfileScannerService),_(6,d.IDownloadService),_(7,ee.IInstantiationService),_(8,X.IFileService),_(9,ne.IProductService),_(10,fe.IUriIdentityService),_(11,re.IUserDataProfilesService)],me),e.ExtensionManagementService=me;let B=class extends S.Disposable{constructor(P,I,C,F){super(),this.j=P,this.k=I,this.l=C,this.m=F,this.h=this.B(new N.Emitter),this.onExtract=this.h.event,this.c=(0,g.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new T.Queue}async cleanUp(){await this.v()}async scanExtensions(P,I){const C={includeInvalid:!0,profileLocation:I};let F=[];return P===null||P===0?F.push(...await this.l.scanAllExtensions({includeInvalid:!0},C,!1)):P===1&&F.push(...await this.l.scanUserExtensions(C)),F=P!==null?F.filter($=>$.type===P):F,Promise.all(F.map($=>this.u($)))}async scanAllUserExtensions(P){const I=await this.l.scanUserExtensions({includeAllVersions:!P,includeInvalid:!0});return Promise.all(I.map(C=>this.u(C)))}async scanUserExtensionAtLocation(P){try{const I=await this.l.scanExistingExtension(P,1,{includeInvalid:!0});if(I)return await this.u(I)}catch(I){this.m.error(I)}return null}async extractUserExtension(P,I,C,F){const $=P.toString(),G=v.join(this.l.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`),te=v.join(this.l.userExtensionsLocation.fsPath,$);try{await c.Promises.rm(te)}catch{throw new o.ExtensionManagementError(b.localize(4,null,te,P.id),o.ExtensionManagementErrorCode.Delete)}await this.p(P,I,G,F),await this.l.updateMetadata(L.URI.file(G),C);try{this.h.fire(L.URI.file(te)),await this.s(P,G,te,Date.now()+2*60*1e3),this.m.info("Renamed to",te)}catch(oe){try{await c.Promises.rm(G)}catch{}if(oe.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",P.id);else throw this.m.info(`Rename failed because of ${(0,D.getErrorMessage)(oe)}. Deleted from extracted location`,G),oe}return this.t(L.URI.file(te),1)}async updateMetadata(P,I){return await this.l.updateMetadata(P.location,I),this.t(P.location,P.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...P){const I=P.map(C=>i.ExtensionKey.create(C));await this.n(C=>I.forEach(F=>{C[F.toString()]=!0,this.m.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(P){await this.n(F=>delete F[P.toString()]);const C=(await this.scanAllUserExtensions(!0)).find(F=>i.ExtensionKey.create(F).equals(P))||null;return C?this.updateMetadata(C,{installedTimestamp:Date.now()}):null}async removeExtension(P,I){this.m.trace(`Deleting ${I} extension from disk`,P.identifier.id,P.location.fsPath),await c.Promises.rm(P.location.fsPath),this.m.info("Deleted from disk",P.identifier.id,P.location.fsPath)}async removeUninstalledExtension(P){await this.removeExtension(P,"uninstalled"),await this.n(I=>delete I[i.ExtensionKey.create(P).toString()])}async n(P){return this.g.queue(async()=>{let I;try{I=await c.Promises.readFile(this.c,"utf8")}catch(F){if(F.code!=="ENOENT")throw F}let C={};if(I)try{C=JSON.parse(I)}catch{}return P&&(P(C),Object.keys(C).length?await c.Promises.writeFile(this.c,JSON.stringify(C)):await c.Promises.rm(this.c)),C})}async p(P,I,C,F){this.m.trace(`Started extracting the extension from ${I} to ${C}`);try{await c.Promises.rm(C)}catch($){throw new o.ExtensionManagementError(this.w($).message,o.ExtensionManagementErrorCode.Delete)}try{await(0,m.extract)(I,C,{sourcePath:"extension",overwrite:!0},F),this.m.info(`Extracted extension to ${C}:`,P.id)}catch($){try{await c.Promises.rm(C)}catch{}let G=o.ExtensionManagementErrorCode.Extract;throw $ instanceof m.ExtractError&&($.type==="CorruptZip"?G=o.ExtensionManagementErrorCode.CorruptZip:$.type==="Incomplete"&&(G=o.ExtensionManagementErrorCode.IncompleteZip)),new o.ExtensionManagementError($.message,G)}}async s(P,I,C,F){try{await c.Promises.rename(I,C)}catch($){if(p.isWindows&&$&&$.code==="EPERM"&&Date.now()<F)return this.m.info(`Failed renaming ${I} to ${C} with 'EPERM' error. Trying again...`,P.id),this.s(P,I,C,F);throw new o.ExtensionManagementError($.message||b.localize(5,null,I,C),$.code||o.ExtensionManagementErrorCode.Rename)}}async t(P,I){const C=await this.l.scanExistingExtension(P,I,{includeInvalid:!0});if(C)return this.u(C);throw new Error(b.localize(6,null,P.path))}async u(P){const I=await this.k.resolve(P.location);let C,F;return I.children&&(C=I.children.find(({name:$})=>/^readme(\.txt|\.md|)$/i.test($))?.resource,F=I.children.find(({name:$})=>/^changelog(\.txt|\.md|)$/i.test($))?.resource),{identifier:P.identifier,type:P.type,isBuiltin:P.isBuiltin||!!P.metadata?.isBuiltin,location:P.location,manifest:P.manifest,targetPlatform:P.targetPlatform,validations:P.validations,isValid:P.isValid,readmeUrl:C,changelogUrl:F,publisherDisplayName:P.metadata?.publisherDisplayName||null,publisherId:P.metadata?.publisherId||null,isApplicationScoped:!!P.metadata?.isApplicationScoped,isMachineScoped:!!P.metadata?.isMachineScoped,isPreReleaseVersion:!!P.metadata?.isPreReleaseVersion,preRelease:!!P.metadata?.preRelease,installedTimestamp:P.metadata?.installedTimestamp,updated:!!P.metadata?.updated}}async v(){const P=await this.getUninstalledExtensions(),I=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),C=new Set;for(const G of I)P[i.ExtensionKey.create(G).toString()]||C.add(G.identifier.id.toLowerCase());const F=(0,i.groupByExtension)(I,G=>G.identifier);await T.Promises.settled(F.map(async G=>{const te=G.sort((oe,ge)=>k.rcompare(oe.manifest.version,ge.manifest.version))[0];C.has(te.identifier.id.toLowerCase())||await this.j(await this.u(te))}));const $=I.filter(G=>G.metadata&&P[i.ExtensionKey.create(G).toString()]);await T.Promises.settled($.map(G=>this.removeUninstalledExtension(G)))}w(P){const I=Array.isArray(P)?P:[P];return I.length===1?I[0]instanceof Error?I[0]:new Error(I[0]):I.reduce((C,F)=>new Error(`${C.message}${C.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}};B=de([_(1,X.IFileService),_(2,r.IExtensionsScannerService),_(3,ie.ILogService)],B),e.ExtensionsScanner=B;class j extends t.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,E.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(P,I,C,F,$){super(),this.identifier=P,this.source=I,this.l=C,this.m=F,this.n=$,this.j="Unverified",this.k=2}async o(P,I){try{const C=await this.p(P.key);if(C)return this.m.updateMetadata(C,P.metadata)}catch{throw p.isMacintosh?new o.ExtensionManagementError(b.localize(7,null),o.ExtensionManagementErrorCode.Internal):new o.ExtensionManagementError(b.localize(8,null),o.ExtensionManagementErrorCode.Internal)}return this.s(P,I)}async p(P){if(!await this.q(P))return null;this.n.trace("Removing the extension from uninstalled list:",P.id);const C=await this.m.setInstalled(P);return this.n.info("Removed the extension from uninstalled list:",P.id),C}async q(P){return!!(await this.m.getUninstalledExtensions())[P.toString()]}async s({zipPath:P,key:I,metadata:C},F){const $=await this.m.extractUserExtension(I,P,C,F);return this.n.info("Extracting completed.",I.id),$}}class M extends j{constructor(P,I,C,F,$,G){super(I.identifier,I,C,$,G),this.t=P,this.u=I,this.v=F}async h(P){const C=(await this.m.scanExtensions(null,void 0)).find(te=>(0,i.areSameExtensions)(te.identifier,this.u.identifier));C&&(this.k=3);const F={id:this.u.identifier.uuid,publisherId:this.u.publisherId,publisherDisplayName:this.u.publisherDisplayName,targetPlatform:this.u.properties.targetPlatform,isApplicationScoped:(0,U.isApplicationScopedExtension)(this.t),isMachineScoped:this.l.isMachineScoped||C?.isMachineScoped,isBuiltin:this.l.isBuiltin||C?.isBuiltin,isSystem:C?.type===0?!0:void 0,updated:!!C,isPreReleaseVersion:this.u.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.u.properties.isPreReleaseVersion||((0,E.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:C?.preRelease)};if(C?.manifest.version===this.u.version)return{local:await this.m.updateMetadata(C,F),metadata:F};const{location:$,verificationStatus:G}=await this.v.download(this.u,this.k);try{return this.j=G,this.x($.fsPath),{local:await this.o({zipPath:$.fsPath,key:i.ExtensionKey.create(this.u),metadata:F},P),metadata:F}}catch(te){try{await this.v.delete($)}catch(oe){this.n.warn("Error while deleting the downloaded file",$.toString(),(0,D.getErrorMessage)(oe))}throw te}}async x(P){try{await(0,l.getManifest)(P)}catch(I){throw new o.ExtensionManagementError((0,t.joinErrors)(I).message,o.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=M;class V extends j{constructor(P,I,C,F,$,G){super({id:(0,i.getGalleryExtensionId)(P.publisher,P.name)},I,C,$,G),this.t=P,this.u=I,this.v=F}async h(P){const I=new i.ExtensionKey(this.identifier,this.t.version),F=(await this.m.scanExtensions(1,void 0)).find(te=>(0,i.areSameExtensions)(this.identifier,te.identifier)),$=await this.x(this.identifier.id,this.t.version,P);if($.isApplicationScoped=(0,U.isApplicationScopedExtension)(this.t),$.isMachineScoped=this.l.isMachineScoped||F?.isMachineScoped,$.isBuiltin=this.l.isBuiltin||F?.isBuiltin,$.installedTimestamp=Date.now(),F)if(this.k=3,I.equals(new i.ExtensionKey(F.identifier,F.manifest.version)))try{await this.m.removeExtension(F,"existing")}catch{throw new Error(b.localize(9,null,this.t.displayName||this.t.name))}else!this.l.profileLocation&&k.gt(F.manifest.version,this.t.version)&&await this.m.setUninstalled(F);else{const te=await this.p(I);if(te)try{await this.m.removeExtension(te,"existing")}catch{throw new Error(b.localize(10,null,this.t.displayName||this.t.name))}}return{local:await this.o({zipPath:v.resolve(this.u.fsPath),key:I,metadata:$},P),metadata:$}}async x(P,I,C){try{let[F]=await this.v.getExtensions([{id:P,version:I}],C);if(F||([F]=await this.v.getExtensions([{id:P}],C)),F)return{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId,isPreReleaseVersion:F.properties.isPreReleaseVersion,preRelease:F.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class W{get verificationStatus(){return this.d.verificationStatus}constructor(P,I,C,F,$,G){this.d=P,this.g=I,this.h=C,this.j=F,this.k=$,this.l=G,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.m()}async m(){const P=await this.d.waitUntilTaskIsFinished();return this.h.extUri.isEqual(this.j.defaultProfile.extensionsResource,this.g)&&await this.k.initializeDefaultProfileExtensions(),await this.l.addExtensionsToProfile([[P.local,P.metadata]],this.g),P}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class q extends t.AbstractExtensionTask{constructor(P,I,C){super(),this.extension=P,this.j=I,this.k=C}async h(P){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Z[155],Q([0,1,129,5,15,6,2,4,23,17,130,10,128,168]),function(x,e,T,O,R,D,N,S,h,u,v,p,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let E=class extends N.Disposable{constructor(f,c,m){super(),this.h=f,this.i=c,this.j=m,this.k(),this.B(f.onDidChangeConfiguration(b=>{b.affectsConfiguration("http")&&this.k()}))}k(){const f=this.h.getValue("http");this.a=f?.proxy,this.b=!!f?.proxyStrictSSL,this.f=f?.proxyAuthorization}async request(f,c){this.j.trace("RequestService#request (node) - begin",f.url);const{a:m,b}=this;let d;try{d=await(0,v.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(o){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",o))}const y={...process.env,...d},t=f.agent?f.agent:await(0,g.getProxyAgent)(f.url||"",y,{proxyUrl:m,strictSSL:b});f.agent=t,f.strictSSL=b,this.f&&(f.headers={...f.headers||{},"Proxy-Authorization":this.f});try{const o=await this.m(f,c);return this.j.trace("RequestService#request (node) - success",f.url),o}catch(o){throw this.j.trace("RequestService#request (node) - error",f.url,o),o}}async l(f){return((0,T.parse)(f.url).protocol==="https:"?await new Promise((b,d)=>{x(["https"],b,d)}):await new Promise((b,d)=>{x(["http"],b,d)})).request}m(f,c){return O.Promises.withAsyncBody(async(m,b)=>{const d=(0,T.parse)(f.url),y=f.getRawRequest?f.getRawRequest(f):await this.l(f),t={hostname:d.hostname,port:d.port?parseInt(d.port):d.protocol==="https:"?443:80,protocol:d.protocol,path:d.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,S.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(t.auth=f.user+":"+f.password);const o=y(t,i=>{const n=(0,S.isNumber)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this.m({...f,url:i.headers.location,followRedirects:n-1},c).then(m,b);else{let r=i;!f.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,k.createGunzip)())),m({res:i,stream:(0,R.streamToBufferReadableStream)(r)})}});o.on("error",b),f.timeout&&o.setTimeout(f.timeout),f.isChromiumNetwork&&o.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&o.write(f.data),o.end(),c.onCancellationRequested(()=>{o.abort(),b(new D.CancellationError)})})}async resolveProxy(f){}};E=de([_(0,h.IConfigurationService),_(1,u.INativeEnvironmentService),_(2,p.ILogService)],E),e.RequestService=E}),define(Z[169],Q([0,1,33,5,15,34,6,2,16,14,12,35,11,20,23,125,58,127,17,106,150,24,59,132,40,48,154,148,13,117,119,46,115,62,63,136,10,121,122,38,152,139,28,47,155,67,131,68,25,138,39,140,141,27,143,21,151,142,147]),function(x,e,T,O,R,D,N,S,h,u,v,p,g,k,E,L,f,c,m,b,d,y,t,o,i,n,r,a,s,l,w,A,U,Y,X,ee,ie,ne,ae,fe,re,me,B,j,M,V,W,q,K,P,I,C,F,$,G,te,oe,ge,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class le extends S.Disposable{constructor(se){super(),this.b=se,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[se,ue]=await this.f();return se.invokeFunction(async be=>{const je=be.get(ie.ILogService),Ce=be.get(s.IFileService),Ne=be.get(m.INativeEnvironmentService),z=be.get(te.IUserDataProfilesService);je.info("CLI main",this.b),this.g(je),await this.h(Ne,Ce,z,se),await Promise.all(ue.map(H=>{(0,O.raceTimeout)(H.flush(),1e3)}))})}async f(){const se=new Y.ServiceCollection,ue={_serviceBrand:void 0,...me.default};se.set(B.IProductService,ue);const be=new b.NativeEnvironmentService(this.b,ue);se.set(m.INativeEnvironmentService,be),await Promise.all([be.appSettingsHome.fsPath,be.extensionsPath].map(De=>De?k.Promises.mkdir(De,{recursive:!0}):void 0));const je=(0,ie.getLogLevel)(be),Ce=[];Ce.push(new ne.SpdLogLogger("cli",(0,u.join)(be.logsPath,"cli.log"),!0,!1,je)),je===ie.LogLevel.Trace&&Ce.push(new ie.ConsoleLogger(je));const Ne=this.B(new ie.MultiplexLogService(Ce));se.set(ie.ILogService,Ne);const z=this.B(new l.FileService(Ne));se.set(s.IFileService,z);const H=this.B(new w.DiskFileSystemProvider(Ne));z.registerProvider(h.Schemas.file,H);const J=new W.StateService(be,Ne,z);se.set(V.IStateService,J);const he=new G.UriIdentityService(z);se.set($.IUriIdentityService,he);const pe=new oe.UserDataProfilesService(J,he,be,z,Ne);se.set(te.IUserDataProfilesService,pe);const Oe=v.isWindows&&ue.win32RegValueName?this.B(new re.NativePolicyService(Ne,ue.win32RegValueName)):be.policyFile?this.B(new ae.FilePolicyService(be.policyFile,z,Ne)):new fe.NullPolicyService;se.set(fe.IPolicyService,Oe);const Se=this.B(new L.ConfigurationService(pe.defaultProfile.settingsResource,z,Oe,Ne));se.set(E.IConfigurationService,Se),await Promise.all([J.init(),Se.initialize()]),pe.setEnablement(ue.quality!=="stable"||Se.getValue(te.PROFILES_ENABLEMENT_CONFIG)),se.set($.IUriIdentityService,new G.UriIdentityService(z)),se.set(j.IRequestService,new A.SyncDescriptor(M.RequestService,void 0,!0)),se.set(f.IDownloadService,new A.SyncDescriptor(c.DownloadService,void 0,!0)),se.set(i.IExtensionsProfileScannerService,new A.SyncDescriptor(ve.ExtensionsProfileScannerService,void 0,!0)),se.set(n.IExtensionsScannerService,new A.SyncDescriptor(a.ExtensionsScannerService,void 0,!0)),se.set(t.IExtensionSignatureVerificationService,new A.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),se.set(r.INativeServerExtensionManagementService,new A.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),se.set(y.IExtensionGalleryService,new A.SyncDescriptor(d.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),se.set(X.ILanguagePackService,new A.SyncDescriptor(ee.NativeLanguagePackService,void 0,!1));const Le=[],Pe=(0,I.isInternalTelemetry)(ue,Se);if((0,I.supportsTelemetry)(ue,be)){ue.aiConfig&&ue.aiConfig.ariaKey&&Le.push(new C.OneDataSystemAppender(Pe,"monacoworkbench",null,ue.aiConfig.ariaKey));const{installSourcePath:De}=be,Fe={appenders:Le,sendErrorTelemetry:!1,commonProperties:(async()=>{let Re;try{Re=await(0,ge.resolveMachineId)(J)}catch(Te){Te.code!=="ENOENT"&&Ne.error(Te)}return(0,q.resolveCommonProperties)(z,(0,T.release)(),(0,T.hostname)(),process.arch,ue.commit,ue.version,Re,Pe,De)})(),piiPaths:(0,I.getPiiPathsFromEnvironment)(be)};se.set(K.ITelemetryService,new A.SyncDescriptor(P.TelemetryService,[Fe],!1))}else se.set(K.ITelemetryService,I.NullTelemetryService);return[new U.InstantiationService(se),Le]}g(se){(0,N.setUnexpectedErrorHandler)(ue=>{const be=(0,D.toErrorMessage)(ue,!0);!be||se.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",ue=>(0,N.onUnexpectedError)(ue)),process.on("unhandledRejection",ue=>(0,N.onUnexpectedError)(ue))}async h(se,ue,be,je){const Ce=(se.args.profile?be.profiles.find(Ne=>Ne.name===se.args.profile)??be.defaultProfile:be.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(se,ue,this.b["install-source"]);if(this.b["list-extensions"])return je.createInstance(o.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,Ce);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Ne={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Ce};return je.createInstance(o.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],Ne,!!this.b.force)}else{if(this.b["uninstall-extension"])return je.createInstance(o.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Ce);if(this.b["locate-extension"])return je.createInstance(o.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.buildTelemetryMessage)(se.appRoot,se.extensionsPath))}}i(se){return se.map(ue=>/\.vsix$/i.test(ue)?g.URI.file((0,u.isAbsolute)(ue)?ue:(0,u.join)((0,p.cwd)(),ue)):ue)}async j(se,ue,be){await ue.writeFile(g.URI.file(se.installSourcePath),R.VSBuffer.fromString(be.slice(0,30)))}}async function ce(we){const se=new le(we);try{await se.run()}finally{se.dispose()}}e.main=ce})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/89e427274e1c9e555f8bfa21bd1e9c50c0225403/core/vs/code/node/cliProcessMain.js.map
