/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/platform/log/common/log","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/resources","vs/base/common/buffer","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/codicons","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/lazy","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(te){for(var e=[],n=0,C=te.length;n<C;n++)e[n]=Ie[te[n]];return e};define(Ie[62],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function n(I,A){const y=Object.create(null);for(const k of I){const O=A(k);let w=y[O];w||(w=y[O]=[]),w.push(k)}return y}e.groupBy=n;function C(I,A){const y=[],k=[];for(const O of I)A.has(O)||y.push(O);for(const O of A)I.has(O)||k.push(O);return{removed:y,added:k}}e.diffSets=C;function S(I,A){const y=[],k=[];for(const[O,w]of I)A.has(O)||y.push(w);for(const[O,w]of A)I.has(O)||k.push(w);return{removed:y,added:k}}e.diffMaps=S;class M{constructor(){this.a=new Map}add(A,y){let k=this.a.get(A);k||(k=new Set,this.a.set(A,k)),k.add(y)}delete(A,y){const k=this.a.get(A);!k||(k.delete(y),k.size===0&&this.a.delete(A))}forEach(A,y){const k=this.a.get(A);!k||k.forEach(y)}}e.SetMap=M}),define(Ie[63],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function n(I){return(A,y,k)=>{let O=null,w=null;if(typeof k.value=="function"?(O="value",w=k.value):typeof k.get=="function"&&(O="get",w=k.get),!w)throw new Error("not supported");k[O]=I(w,y)}}function C(I,A,y){let k=null,O=null;if(typeof y.value=="function"?(k="value",O=y.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(k="get",O=y.get),!O)throw new Error("not supported");const w=`$memoize$${A}`;y[k]=function(...m){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,m)}),this[w]}}e.memoize=C;function S(I,A,y){return n((k,O)=>{const w=`$debounce$${O}`,m=`$debounce$result$${O}`;return function(...b){this[m]||(this[m]=y?y():void 0),clearTimeout(this[w]),A&&(this[m]=A(this[m],...b),b=[this[m]]),this[w]=setTimeout(()=>{k.apply(this,b),this[m]=y?y():void 0},I)}})}e.debounce=S;function M(I,A,y){return n((k,O)=>{const w=`$throttle$timer$${O}`,m=`$throttle$result$${O}`,b=`$throttle$lastRun$${O}`,f=`$throttle$pending$${O}`;return function(...s){if(this[m]||(this[m]=y?y():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),A&&(this[m]=A(this[m],...s)),this[f])return;const o=this[b]+I;o<=Date.now()?(this[b]=Date.now(),k.apply(this,[this[m]]),this[m]=y?y():void 0):(this[f]=!0,this[w]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),k.apply(this,[this[m]]),this[m]=y?y():void 0},o-Date.now()))}})}e.throttle=M}),define(Ie[83],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(S){this.a=S,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(Ie[111],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(n=e.ScanError||(e.ScanError={}));var C;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(C=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(r){r.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function I(r,d=!1){let i=0;const c=r.length;let t="",h=0,a=16,u=0;function g($){let T=0,L=0;for(;T<$;){const V=r.charCodeAt(i);if(V>=48&&V<=57)L=L*16+V-48;else if(V>=65&&V<=70)L=L*16+V-65+10;else if(V>=97&&V<=102)L=L*16+V-97+10;else break;i++,T++}return T<$&&(L=-1),L}function R($){i=$,t="",h=0,a=16,u=0}function F(){const $=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&k(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&k(r.charCodeAt(i)))for(i++;i<r.length&&k(r.charCodeAt(i));)i++;else return u=3,r.substring($,i);let T=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&k(r.charCodeAt(i))){for(i++;i<r.length&&k(r.charCodeAt(i));)i++;T=i}else u=3;return r.substring($,T)}function q(){let $="",T=i;for(;;){if(i>=c){$+=r.substring(T,i),u=2;break}const L=r.charCodeAt(i);if(L===34){$+=r.substring(T,i),i++;break}if(L===92){if($+=r.substring(T,i),i++,i>=c){u=2;break}switch(r.charCodeAt(i++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const j=g(4);j>=0?$+=String.fromCharCode(j):u=4;break}default:u=5}T=i;continue}if(L>=0&&L<=31)if(y(L)){$+=r.substring(T,i),u=2;break}else u=6;i++}return $}function Z(){if(t="",u=0,h=i,i>=c)return h=c,a=17;let $=r.charCodeAt(i);if(A($)){do i++,t+=String.fromCharCode($),$=r.charCodeAt(i);while(A($));return a=15}if(y($))return i++,t+=String.fromCharCode($),$===13&&r.charCodeAt(i)===10&&(i++,t+=`
`),a=14;switch($){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,t=q(),a=10;case 47:{const T=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<c&&!y(r.charCodeAt(i));)i++;return t=r.substring(T,i),a=12}if(r.charCodeAt(i+1)===42){i+=2;const L=c-1;let V=!1;for(;i<L;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,V=!0;break}i++}return V||(i++,u=1),t=r.substring(T,i),a=13}return t+=String.fromCharCode($),i++,a=16}case 45:if(t+=String.fromCharCode($),i++,i===c||!k(r.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=F(),a=11;default:for(;i<c&&x($);)i++,$=r.charCodeAt(i);if(h!==i){switch(t=r.substring(h,i),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode($),i++,a=16}}function x($){if(A($)||y($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let $;do $=Z();while($>=12&&$<=15);return $}return{setPosition:R,getPosition:()=>i,scan:d?N:Z,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>h,getTokenLength:()=>i-h,getTokenError:()=>u}}e.createScanner=I;function A(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function y(r){return r===10||r===13||r===8232||r===8233}function k(r){return r>=48&&r<=57}var O;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(O||(O={}));function w(r,d){const i=[],c=new Object;let t;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function u(g,R,F,q){h.value=g,h.offset=R,h.length=F,h.type=q,h.colonOffset=void 0,t=h}try{E(r,{onObjectBegin:(g,R)=>{if(d<=g)throw c;t=void 0,a=d>g,i.push("")},onObjectProperty:(g,R,F)=>{if(d<R||(u(g,R,F,"property"),i[i.length-1]=g,d<=R+F))throw c},onObjectEnd:(g,R)=>{if(d<=g)throw c;t=void 0,i.pop()},onArrayBegin:(g,R)=>{if(d<=g)throw c;t=void 0,i.push(0)},onArrayEnd:(g,R)=>{if(d<=g)throw c;t=void 0,i.pop()},onLiteralValue:(g,R,F)=>{if(d<R||(u(g,R,F,p(g)),d<=R+F))throw c},onSeparator:(g,R,F)=>{if(d<=R)throw c;if(g===":"&&t&&t.type==="property")t.colonOffset=R,a=!1,t=void 0;else if(g===","){const q=i[i.length-1];typeof q=="number"?i[i.length-1]=q+1:(a=!0,i[i.length-1]=""),t=void 0}}})}catch(g){if(g!==c)throw g}return{path:i,previousNode:t,isAtPropertyKey:a,matches:g=>{let R=0;for(let F=0;R<g.length&&F<i.length;F++)if(g[R]===i[F]||g[R]==="*")R++;else if(g[R]!=="**")return!1;return R===g.length}}}e.getLocation=w;function m(r,d=[],i=M.DEFAULT){let c=null,t=[];const h=[];function a(g){Array.isArray(t)?t.push(g):c!==null&&(t[c]=g)}return E(r,{onObjectBegin:()=>{const g={};a(g),h.push(t),t=g,c=null},onObjectProperty:g=>{c=g},onObjectEnd:()=>{t=h.pop()},onArrayBegin:()=>{const g=[];a(g),h.push(t),t=g,c=null},onArrayEnd:()=>{t=h.pop()},onLiteralValue:a,onError:(g,R,F)=>{d.push({error:g,offset:R,length:F})}},i),t[0]}e.parse=m;function b(r,d=[],i=M.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(g){c.type==="property"&&(c.length=g-c.offset,c=c.parent)}function h(g){return c.children.push(g),g}E(r,{onObjectBegin:g=>{c=h({type:"object",offset:g,length:-1,parent:c,children:[]})},onObjectProperty:(g,R,F)=>{c=h({type:"property",offset:R,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:g,offset:R,length:F,parent:c})},onObjectEnd:(g,R)=>{c.length=g+R-c.offset,c=c.parent,t(g+R)},onArrayBegin:(g,R)=>{c=h({type:"array",offset:g,length:-1,parent:c,children:[]})},onArrayEnd:(g,R)=>{c.length=g+R-c.offset,c=c.parent,t(g+R)},onLiteralValue:(g,R,F)=>{h({type:p(g),offset:R,length:F,parent:c,value:g}),t(R+F)},onSeparator:(g,R,F)=>{c.type==="property"&&(g===":"?c.colonOffset=R:g===","&&t(R))},onError:(g,R,F)=>{d.push({error:g,offset:R,length:F})}},i);const u=c.children[0];return u&&delete u.parent,u}e.parseTree=b;function f(r,d){if(!r)return;let i=r;for(const c of d)if(typeof c=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let t=!1;for(const h of i.children)if(Array.isArray(h.children)&&h.children[0].value===c){i=h.children[1],t=!0;break}if(!t)return}else{const t=c;if(i.type!=="array"||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i}e.findNodeAtLocation=f;function s(r){if(!r.parent||!r.parent.children)return[];const d=s(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;d.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&d.push(i)}return d}e.getNodePath=s;function o(r){switch(r.type){case"array":return r.children.map(o);case"object":{const d=Object.create(null);for(const i of r.children){const c=i.children[1];c&&(d[i.children[0].value]=o(c))}return d}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=o;function l(r,d,i=!1){return d>=r.offset&&d<r.offset+r.length||i&&d===r.offset+r.length}e.contains=l;function v(r,d,i=!1){if(l(r,d,i)){const c=r.children;if(Array.isArray(c))for(let t=0;t<c.length&&c[t].offset<=d;t++){const h=v(c[t],d,i);if(h)return h}return r}}e.findNodeAtOffset=v;function E(r,d,i=M.DEFAULT){const c=I(r,!1);function t(re){return re?()=>re(c.getTokenOffset(),c.getTokenLength()):()=>!0}function h(re){return re?G=>re(G,c.getTokenOffset(),c.getTokenLength()):()=>!0}const a=t(d.onObjectBegin),u=h(d.onObjectProperty),g=t(d.onObjectEnd),R=t(d.onArrayBegin),F=t(d.onArrayEnd),q=h(d.onLiteralValue),Z=h(d.onSeparator),x=t(d.onComment),N=h(d.onError),$=i&&i.disallowComments,T=i&&i.allowTrailingComma;function L(){for(;;){const re=c.scan();switch(c.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:$||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(re){case 12:case 13:$?V(10):x();break;case 16:V(1);break;case 15:case 14:break;default:return re}}}function V(re,G=[],H=[]){if(N(re),G.length+H.length>0){let oe=c.getToken();for(;oe!==17;){if(G.indexOf(oe)!==-1){L();break}else if(H.indexOf(oe)!==-1)break;oe=L()}}}function j(re){const G=c.getTokenValue();return re?q(G):u(G),L(),!0}function le(){switch(c.getToken()){case 11:{let re=0;try{re=JSON.parse(c.getTokenValue()),typeof re!="number"&&(V(2),re=0)}catch{V(2)}q(re);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return L(),!0}function Y(){return c.getToken()!==10?(V(3,[],[2,5]),!1):(j(!1),c.getToken()===6?(Z(":"),L(),de()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function pe(){a(),L();let re=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(re||V(4,[],[]),Z(","),L(),c.getToken()===2&&T)break}else re&&V(6,[],[]);Y()||V(4,[],[2,5]),re=!0}return g(),c.getToken()!==2?V(7,[2],[]):L(),!0}function ue(){R(),L();let re=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(re||V(4,[],[]),Z(","),L(),c.getToken()===4&&T)break}else re&&V(6,[],[]);de()||V(4,[],[4,5]),re=!0}return F(),c.getToken()!==4?V(8,[4],[]):L(),!0}function de(){switch(c.getToken()){case 3:return ue();case 1:return pe();case 10:return j(!0);default:return le()}}return L(),c.getToken()===17?i.allowEmptyContent?!0:(V(4,[],[]),!1):de()?(c.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=E;function P(r,d){const i=I(r),c=[];let t,h=0,a;do switch(a=i.getPosition(),t=i.scan(),t){case 12:case 13:case 17:h!==a&&c.push(r.substring(h,a)),d!==void 0&&c.push(i.getTokenValue().replace(/[^\r\n]/g,d)),h=i.getPosition();break}while(t!==17);return c.join("")}e.stripComments=P;function p(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(Ie[28],Ce([1,0]),function(te,e){"use strict";var n,C,S;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(f,s,o){let l=f.get(s);return l===void 0&&(l=o,f.set(s,l)),l}e.getOrSet=M;function I(f){const s=[];return f.forEach((o,l)=>{s.push(`${l} => ${o}`)}),`Map(${f.size}) {${s.join(", ")}}`}e.mapToString=I;function A(f){const s=[];return f.forEach(o=>{s.push(o)}),`Set(${f.size}) {${s.join(", ")}}`}e.setToString=A;class y{constructor(s,o){this.uri=s,this.value=o}}class k{constructor(s,o){this[n]="ResourceMap",s instanceof k?(this.b=new Map(s.b),this.c=o??k.a):(this.b=new Map,this.c=s??k.a)}set(s,o){return this.b.set(this.c(s),new y(s,o)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,o){typeof o<"u"&&(s=s.bind(o));for(const[l,v]of this.b)s(v.value,v.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}e.ResourceMap=k,k.a=f=>f.toString();class O{constructor(s,o){this[C]="ResourceSet",!s||typeof s=="function"?this.a=new k(s):(this.a=new k(o),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,o){this.a.forEach((l,v)=>s.call(o,v,v,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var w;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class m{constructor(){this[S]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,o=0){const l=this.a.get(s);if(!!l)return o!==0&&this.j(l,o),l.value}set(s,o,l=0){let v=this.a.get(s);if(v)v.value=o,l!==0&&this.j(v,l);else{switch(v={key:s,value:o,next:void 0,previous:void 0},l){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(s,v),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const o=this.a.get(s);if(!!o)return this.a.delete(s),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,o){const l=this.e;let v=this.b;for(;v;){if(o?s.bind(o)(v.value,v.key,this):s(v.value,v.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const s=this,o=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(s.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.key,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return v}values(){const s=this,o=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(s.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.value,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return v}entries(){const s=this,o=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(s.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:[l.key,l.value],done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return v}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let o=this.b,l=this.size;for(;o&&l>s;)this.a.delete(o.key),o=o.next,l--;this.b=o,this.d=l,o&&(o.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const o=s.next,l=s.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}s.next=void 0,s.previous=void 0,this.e++}j(s,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(s===this.b)return;const l=s.next,v=s.previous;s===this.c?(v.next=void 0,this.c=v):(l.previous=v,v.next=l),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(o===2){if(s===this.c)return;const l=s.next,v=s.previous;s===this.b?(l.previous=void 0,this.b=l):(l.previous=v,v.next=l),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((o,l)=>{s.push([l,o])}),s}fromJSON(s){this.clear();for(const[o,l]of s)this.set(o,l)}}e.LinkedMap=m;class b extends m{constructor(s,o=1){super(),this.k=s,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,o=2){return super.get(s,o)}peek(s){return super.get(s,0)}set(s,o){return super.set(s,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=b}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ie[112],Ce([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(Te,Se){for(var ke=0;ke<Se.length;ke++){var se=Se[ke];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Te,se.key,se)}}function n(Te,Se,ke){return Se&&e(Te.prototype,Se),ke&&e(Te,ke),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function C(Te,Se){if(!!Te){if(typeof Te=="string")return S(Te,Se);var ke=Object.prototype.toString.call(Te).slice(8,-1);if(ke==="Object"&&Te.constructor&&(ke=Te.constructor.name),ke==="Map"||ke==="Set")return Array.from(Te);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return S(Te,Se)}}function S(Te,Se){(Se==null||Se>Te.length)&&(Se=Te.length);for(var ke=0,se=new Array(Se);ke<Se;ke++)se[ke]=Te[ke];return se}function M(Te,Se){var ke=typeof Symbol<"u"&&Te[Symbol.iterator]||Te["@@iterator"];if(ke)return(ke=ke.call(Te)).next.bind(ke);if(Array.isArray(Te)||(ke=C(Te))||Se&&Te&&typeof Te.length=="number"){ke&&(Te=ke);var se=0;return function(){return se>=Te.length?{done:!0}:{done:!1,value:Te[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=I();function A(Te){te.defaults=Te}var y=/[&<>"']/,k=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Se){return m[Se]};function f(Te,Se){if(Se){if(y.test(Te))return Te.replace(k,b)}else if(O.test(Te))return Te.replace(w,b);return Te}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Te){return Te.replace(s,function(Se,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var l=/(^|[^\[])\^/g;function v(Te,Se){Te=typeof Te=="string"?Te:Te.source,Se=Se||"";var ke={replace:function(ce,J){return J=J.source||J,J=J.replace(l,"$1"),Te=Te.replace(ce,J),ke},getRegex:function(){return new RegExp(Te,Se)}};return ke}var E=/[^\w:]/g,P=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Te,Se,ke){if(Te){var se;try{se=decodeURIComponent(o(ke)).replace(E,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Se&&!P.test(ke)&&(ke=t(Se,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var r={},d=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function t(Te,Se){r[" "+Te]||(d.test(Te)?r[" "+Te]=Te+"/":r[" "+Te]=g(Te,"/",!0)),Te=r[" "+Te];var ke=Te.indexOf(":")===-1;return Se.substring(0,2)==="//"?ke?Se:Te.replace(i,"$1")+Se:Se.charAt(0)==="/"?ke?Se:Te.replace(c,"$1")+Se:Te+Se}var h={exec:function(){}};function a(Te){for(var Se=1,ke,se;Se<arguments.length;Se++){ke=arguments[Se];for(se in ke)Object.prototype.hasOwnProperty.call(ke,se)&&(Te[se]=ke[se])}return Te}function u(Te,Se){var ke=Te.replace(/\|/g,function(J,D,B){for(var W=!1,K=D;--K>=0&&B[K]==="\\";)W=!W;return W?"|":" |"}),se=ke.split(/ \|/),ce=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>Se)se.splice(Se);else for(;se.length<Se;)se.push("");for(;ce<se.length;ce++)se[ce]=se[ce].trim().replace(/\\\|/g,"|");return se}function g(Te,Se,ke){var se=Te.length;if(se===0)return"";for(var ce=0;ce<se;){var J=Te.charAt(se-ce-1);if(J===Se&&!ke)ce++;else if(J!==Se&&ke)ce++;else break}return Te.slice(0,se-ce)}function R(Te,Se){if(Te.indexOf(Se[1])===-1)return-1;for(var ke=Te.length,se=0,ce=0;ce<ke;ce++)if(Te[ce]==="\\")ce++;else if(Te[ce]===Se[0])se++;else if(Te[ce]===Se[1]&&(se--,se<0))return ce;return-1}function F(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function q(Te,Se){if(Se<1)return"";for(var ke="";Se>1;)Se&1&&(ke+=Te),Se>>=1,Te+=Te;return ke+Te}function Z(Te,Se,ke,se){var ce=Se.href,J=Se.title?f(Se.title):null,D=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){se.state.inLink=!0;var B={type:"link",raw:ke,href:ce,title:J,text:D,tokens:se.inlineTokens(D)};return se.state.inLink=!1,B}return{type:"image",raw:ke,href:ce,title:J,text:f(D)}}function x(Te,Se){var ke=Te.match(/^(\s+)(?:```)/);if(ke===null)return Se;var se=ke[1];return Se.split(`
`).map(function(ce){var J=ce.match(/^\s+/);if(J===null)return ce;var D=J[0];return D.length>=se.length?ce.slice(se.length):ce}).join(`
`)}var N=function(){function Te(ke){this.options=ke||te.defaults}var Se=Te.prototype;return Se.space=function(se){var ce=this.rules.block.newline.exec(se);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},Se.code=function(se){var ce=this.rules.block.code.exec(se);if(ce){var J=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?J:g(J,`
`)}}},Se.fences=function(se){var ce=this.rules.block.fences.exec(se);if(ce){var J=ce[0],D=x(J,ce[3]||"");return{type:"code",raw:J,lang:ce[2]?ce[2].trim():ce[2],text:D}}},Se.heading=function(se){var ce=this.rules.block.heading.exec(se);if(ce){var J=ce[2].trim();if(/#$/.test(J)){var D=g(J,"#");(this.options.pedantic||!D||/ $/.test(D))&&(J=D.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:J,tokens:this.lexer.inline(J)}}},Se.hr=function(se){var ce=this.rules.block.hr.exec(se);if(ce)return{type:"hr",raw:ce[0]}},Se.blockquote=function(se){var ce=this.rules.block.blockquote.exec(se);if(ce){var J=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},Se.list=function(se){var ce=this.rules.block.list.exec(se);if(ce){var J,D,B,W,K,ee,he,ye,ae,be,Ee,We,He=ce[1].trim(),tt=He.length>1,Xe={type:"list",raw:"",ordered:tt,start:tt?+He.slice(0,-1):"",loose:!1,items:[]};He=tt?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=tt?He:"[*+-]");for(var et=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(We=!1,!(!(ce=et.exec(se))||this.rules.block.hr.test(se)));){if(J=ce[0],se=se.substring(J.length),ye=ce[2].split(`
`,1)[0],ae=se.split(`
`,1)[0],this.options.pedantic?(W=2,Ee=ye.trimLeft()):(W=ce[2].search(/[^ ]/),W=W>4?1:W,Ee=ye.slice(W),W+=ce[1].length),ee=!1,!ye&&/^ *$/.test(ae)&&(J+=ae+`
`,se=se.substring(ae.length+1),We=!0),!We)for(var it=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,W-1)+"}#");se&&(be=se.split(`
`,1)[0],ye=be,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(ye)||st.test(ye)||it.test(ye)||dt.test(se)));){if(ye.search(/[^ ]/)>=W||!ye.trim())Ee+=`
`+ye.slice(W);else if(!ee)Ee+=`
`+ye;else break;!ee&&!ye.trim()&&(ee=!0),J+=be+`
`,se=se.substring(be.length+1)}Xe.loose||(he?Xe.loose=!0:/\n *\n *$/.test(J)&&(he=!0)),this.options.gfm&&(D=/^\[[ xX]\] /.exec(Ee),D&&(B=D[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:J,task:!!D,checked:B,loose:!1,text:Ee}),Xe.raw+=J}Xe.items[Xe.items.length-1].raw=J.trimRight(),Xe.items[Xe.items.length-1].text=Ee.trimRight(),Xe.raw=Xe.raw.trimRight();var _=Xe.items.length;for(K=0;K<_;K++){this.lexer.state.top=!1,Xe.items[K].tokens=this.lexer.blockTokens(Xe.items[K].text,[]);var Q=Xe.items[K].tokens.filter(function(Le){return Le.type==="space"}),ge=Q.every(function(Le){for(var $e=Le.raw.split(""),je=0,_e=M($e),nt;!(nt=_e()).done;){var wt=nt.value;if(wt===`
`&&(je+=1),je>1)return!0}return!1});!Xe.loose&&Q.length&&ge&&(Xe.loose=!0,Xe.items[K].loose=!0)}return Xe}},Se.html=function(se){var ce=this.rules.block.html.exec(se);if(ce){var J={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var D=this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]);J.type="paragraph",J.text=D,J.tokens=this.lexer.inline(D)}return J}},Se.def=function(se){var ce=this.rules.block.def.exec(se);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var J=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:ce[0],href:ce[2],title:ce[3]}}},Se.table=function(se){var ce=this.rules.block.table.exec(se);if(ce){var J={type:"table",header:u(ce[1]).map(function(he){return{text:he}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=ce[0];var D=J.align.length,B,W,K,ee;for(B=0;B<D;B++)/^ *-+: *$/.test(J.align[B])?J.align[B]="right":/^ *:-+: *$/.test(J.align[B])?J.align[B]="center":/^ *:-+ *$/.test(J.align[B])?J.align[B]="left":J.align[B]=null;for(D=J.rows.length,B=0;B<D;B++)J.rows[B]=u(J.rows[B],J.header.length).map(function(he){return{text:he}});for(D=J.header.length,W=0;W<D;W++)J.header[W].tokens=this.lexer.inline(J.header[W].text);for(D=J.rows.length,W=0;W<D;W++)for(ee=J.rows[W],K=0;K<ee.length;K++)ee[K].tokens=this.lexer.inline(ee[K].text);return J}}},Se.lheading=function(se){var ce=this.rules.block.lheading.exec(se);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},Se.paragraph=function(se){var ce=this.rules.block.paragraph.exec(se);if(ce){var J=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:J,tokens:this.lexer.inline(J)}}},Se.text=function(se){var ce=this.rules.block.text.exec(se);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},Se.escape=function(se){var ce=this.rules.inline.escape.exec(se);if(ce)return{type:"escape",raw:ce[0],text:f(ce[1])}},Se.tag=function(se){var ce=this.rules.inline.tag.exec(se);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]):ce[0]}},Se.link=function(se){var ce=this.rules.inline.link.exec(se);if(ce){var J=ce[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var D=g(J.slice(0,-1),"\\");if((J.length-D.length)%2===0)return}else{var B=R(ce[2],"()");if(B>-1){var W=ce[0].indexOf("!")===0?5:4,K=W+ce[1].length+B;ce[2]=ce[2].substring(0,B),ce[0]=ce[0].substring(0,K).trim(),ce[3]=""}}var ee=ce[2],he="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ee);ye&&(ee=ye[1],he=ye[3])}else he=ce[3]?ce[3].slice(1,-1):"";return ee=ee.trim(),/^</.test(ee)&&(this.options.pedantic&&!/>$/.test(J)?ee=ee.slice(1):ee=ee.slice(1,-1)),Z(ce,{href:ee&&ee.replace(this.rules.inline._escapes,"$1"),title:he&&he.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},Se.reflink=function(se,ce){var J;if((J=this.rules.inline.reflink.exec(se))||(J=this.rules.inline.nolink.exec(se))){var D=(J[2]||J[1]).replace(/\s+/g," ");if(D=ce[D.toLowerCase()],!D||!D.href){var B=J[0].charAt(0);return{type:"text",raw:B,text:B}}return Z(J,D,J[0],this.lexer)}},Se.emStrong=function(se,ce,J){J===void 0&&(J="");var D=this.rules.inline.emStrong.lDelim.exec(se);if(!!D&&!(D[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var B=D[1]||D[2]||"";if(!B||B&&(J===""||this.rules.inline.punctuation.exec(J))){var W=D[0].length-1,K,ee,he=W,ye=0,ae=D[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ae.lastIndex=0,ce=ce.slice(-1*se.length+W);(D=ae.exec(ce))!=null;)if(K=D[1]||D[2]||D[3]||D[4]||D[5]||D[6],!!K){if(ee=K.length,D[3]||D[4]){he+=ee;continue}else if((D[5]||D[6])&&W%3&&!((W+ee)%3)){ye+=ee;continue}if(he-=ee,!(he>0)){if(ee=Math.min(ee,ee+he+ye),Math.min(W,ee)%2){var be=se.slice(1,W+D.index+ee);return{type:"em",raw:se.slice(0,W+D.index+ee+1),text:be,tokens:this.lexer.inlineTokens(be)}}var Ee=se.slice(2,W+D.index+ee-1);return{type:"strong",raw:se.slice(0,W+D.index+ee+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},Se.codespan=function(se){var ce=this.rules.inline.code.exec(se);if(ce){var J=ce[2].replace(/\n/g," "),D=/[^ ]/.test(J),B=/^ /.test(J)&&/ $/.test(J);return D&&B&&(J=J.substring(1,J.length-1)),J=f(J,!0),{type:"codespan",raw:ce[0],text:J}}},Se.br=function(se){var ce=this.rules.inline.br.exec(se);if(ce)return{type:"br",raw:ce[0]}},Se.del=function(se){var ce=this.rules.inline.del.exec(se);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},Se.autolink=function(se,ce){var J=this.rules.inline.autolink.exec(se);if(J){var D,B;return J[2]==="@"?(D=f(this.options.mangle?ce(J[1]):J[1]),B="mailto:"+D):(D=f(J[1]),B=D),{type:"link",raw:J[0],text:D,href:B,tokens:[{type:"text",raw:D,text:D}]}}},Se.url=function(se,ce){var J;if(J=this.rules.inline.url.exec(se)){var D,B;if(J[2]==="@")D=f(this.options.mangle?ce(J[0]):J[0]),B="mailto:"+D;else{var W;do W=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while(W!==J[0]);D=f(J[0]),J[1]==="www."?B="http://"+D:B=D}return{type:"link",raw:J[0],text:D,href:B,tokens:[{type:"text",raw:D,text:D}]}}},Se.inlineText=function(se,ce){var J=this.rules.inline.text.exec(se);if(J){var D;return this.lexer.state.inRawBlock?D=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):f(J[0]):J[0]:D=f(this.options.smartypants?ce(J[0]):J[0]),{type:"text",raw:J[0],text:D}}},Te}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=v($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=v(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=v($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=v($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=v($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=v($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=a({},$),$.gfm=a({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=v($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=v($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=a({},$.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:v($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var T={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};T._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",T.punctuation=v(T.punctuation).replace(/punctuation/g,T._punctuation).getRegex(),T.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,T.escapedEmSt=/\\\*|\\_/g,T._comment=v($._comment).replace("(?:-->|$)","-->").getRegex(),T.emStrong.lDelim=v(T.emStrong.lDelim).replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimAst=v(T.emStrong.rDelimAst,"g").replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimUnd=v(T.emStrong.rDelimUnd,"g").replace(/punct/g,T._punctuation).getRegex(),T._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,T._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,T._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,T.autolink=v(T.autolink).replace("scheme",T._scheme).replace("email",T._email).getRegex(),T._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,T.tag=v(T.tag).replace("comment",T._comment).replace("attribute",T._attribute).getRegex(),T._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,T._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,T._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,T.link=v(T.link).replace("label",T._label).replace("href",T._href).replace("title",T._title).getRegex(),T.reflink=v(T.reflink).replace("label",T._label).replace("ref",$._label).getRegex(),T.nolink=v(T.nolink).replace("ref",$._label).getRegex(),T.reflinkSearch=v(T.reflinkSearch,"g").replace("reflink",T.reflink).replace("nolink",T.nolink).getRegex(),T.normal=a({},T),T.pedantic=a({},T.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",T._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",T._label).getRegex()}),T.gfm=a({},T.normal,{escape:v(T.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),T.gfm.url=v(T.gfm.url,"i").replace("email",T.gfm._extended_email).getRegex(),T.breaks=a({},T.gfm,{br:v(T.br).replace("{2,}","*").getRegex(),text:v(T.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function L(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Te){var Se="",ke,se,ce=Te.length;for(ke=0;ke<ce;ke++)se=Te.charCodeAt(ke),Math.random()>.5&&(se="x"+se.toString(16)),Se+="&#"+se+";";return Se}var j=function(){function Te(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||te.defaults,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:$.normal,inline:T.normal};this.options.pedantic?(se.block=$.pedantic,se.inline=T.pedantic):this.options.gfm&&(se.block=$.gfm,this.options.breaks?se.inline=T.breaks:se.inline=T.gfm),this.tokenizer.rules=se}Te.lex=function(se,ce){var J=new Te(ce);return J.lex(se)},Te.lexInline=function(se,ce){var J=new Te(ce);return J.inlineTokens(se)};var Se=Te.prototype;return Se.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},Se.blockTokens=function(se,ce){var J=this;ce===void 0&&(ce=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(he,ye,ae){return ye+"    ".repeat(ae.length)});for(var D,B,W,K;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(he){return(D=he.call({lexer:J},se,ce))?(se=se.substring(D.raw.length),ce.push(D),!0):!1}))){if(D=this.tokenizer.space(se)){se=se.substring(D.raw.length),D.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(D);continue}if(D=this.tokenizer.code(se)){se=se.substring(D.raw.length),B=ce[ce.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+D.raw,B.text+=`
`+D.text,this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(D);continue}if(D=this.tokenizer.fences(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.heading(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.hr(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.blockquote(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.list(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.html(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.def(se)){se=se.substring(D.raw.length),B=ce[ce.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+D.raw,B.text+=`
`+D.raw,this.inlineQueue[this.inlineQueue.length-1].src=B.text):this.tokens.links[D.tag]||(this.tokens.links[D.tag]={href:D.href,title:D.title});continue}if(D=this.tokenizer.table(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.lheading(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(W=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var he=1/0,ye=se.slice(1),ae=void 0;J.options.extensions.startBlock.forEach(function(be){ae=be.call({lexer:this},ye),typeof ae=="number"&&ae>=0&&(he=Math.min(he,ae))}),he<1/0&&he>=0&&(W=se.substring(0,he+1))}(),this.state.top&&(D=this.tokenizer.paragraph(W))){B=ce[ce.length-1],K&&B.type==="paragraph"?(B.raw+=`
`+D.raw,B.text+=`
`+D.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(D),K=W.length!==se.length,se=se.substring(D.raw.length);continue}if(D=this.tokenizer.text(se)){se=se.substring(D.raw.length),B=ce[ce.length-1],B&&B.type==="text"?(B.raw+=`
`+D.raw,B.text+=`
`+D.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(D);continue}if(se){var ee="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return this.state.top=!0,ce},Se.inline=function(se,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:se,tokens:ce}),ce},Se.inlineTokens=function(se,ce){var J=this;ce===void 0&&(ce=[]);var D,B,W,K=se,ee,he,ye;if(this.tokens.links){var ae=Object.keys(this.tokens.links);if(ae.length>0)for(;(ee=this.tokenizer.rules.inline.reflinkSearch.exec(K))!=null;)ae.includes(ee[0].slice(ee[0].lastIndexOf("[")+1,-1))&&(K=K.slice(0,ee.index)+"["+q("a",ee[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ee=this.tokenizer.rules.inline.blockSkip.exec(K))!=null;)K=K.slice(0,ee.index)+"["+q("a",ee[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ee=this.tokenizer.rules.inline.escapedEmSt.exec(K))!=null;)K=K.slice(0,ee.index)+"++"+K.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(he||(ye=""),he=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(D=Ee.call({lexer:J},se,ce))?(se=se.substring(D.raw.length),ce.push(D),!0):!1}))){if(D=this.tokenizer.escape(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.tag(se)){se=se.substring(D.raw.length),B=ce[ce.length-1],B&&D.type==="text"&&B.type==="text"?(B.raw+=D.raw,B.text+=D.text):ce.push(D);continue}if(D=this.tokenizer.link(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(D.raw.length),B=ce[ce.length-1],B&&D.type==="text"&&B.type==="text"?(B.raw+=D.raw,B.text+=D.text):ce.push(D);continue}if(D=this.tokenizer.emStrong(se,K,ye)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.codespan(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.br(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.del(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.autolink(se,V)){se=se.substring(D.raw.length),ce.push(D);continue}if(!this.state.inLink&&(D=this.tokenizer.url(se,V))){se=se.substring(D.raw.length),ce.push(D);continue}if(W=se,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,We=se.slice(1),He=void 0;J.options.extensions.startInline.forEach(function(tt){He=tt.call({lexer:this},We),typeof He=="number"&&He>=0&&(Ee=Math.min(Ee,He))}),Ee<1/0&&Ee>=0&&(W=se.substring(0,Ee+1))}(),D=this.tokenizer.inlineText(W,L)){se=se.substring(D.raw.length),D.raw.slice(-1)!=="_"&&(ye=D.raw.slice(-1)),he=!0,B=ce[ce.length-1],B&&B.type==="text"?(B.raw+=D.raw,B.text+=D.text):ce.push(D);continue}if(se){var be="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return ce},n(Te,null,[{key:"rules",get:function(){return{block:$,inline:T}}}]),Te}(),le=function(){function Te(ke){this.options=ke||te.defaults}var Se=Te.prototype;return Se.code=function(se,ce,J){var D=(ce||"").match(/\S*/)[0];if(this.options.highlight){var B=this.options.highlight(se,D);B!=null&&B!==se&&(J=!0,se=B)}return se=se.replace(/\n$/,"")+`
`,D?'<pre><code class="'+this.options.langPrefix+f(D,!0)+'">'+(J?se:f(se,!0))+`</code></pre>
`:"<pre><code>"+(J?se:f(se,!0))+`</code></pre>
`},Se.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Se.html=function(se){return se},Se.heading=function(se,ce,J,D){if(this.options.headerIds){var B=this.options.headerPrefix+D.slug(J);return"<h"+ce+' id="'+B+'">'+se+"</h"+ce+`>
`}return"<h"+ce+">"+se+"</h"+ce+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(se,ce,J){var D=ce?"ol":"ul",B=ce&&J!==1?' start="'+J+'"':"";return"<"+D+B+`>
`+se+"</"+D+`>
`},Se.listitem=function(se){return"<li>"+se+`</li>
`},Se.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(se){return"<p>"+se+`</p>
`},Se.table=function(se,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ce+`</table>
`},Se.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Se.tablecell=function(se,ce){var J=ce.header?"th":"td",D=ce.align?"<"+J+' align="'+ce.align+'">':"<"+J+">";return D+se+("</"+J+`>
`)},Se.strong=function(se){return"<strong>"+se+"</strong>"},Se.em=function(se){return"<em>"+se+"</em>"},Se.codespan=function(se){return"<code>"+se+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(se){return"<del>"+se+"</del>"},Se.link=function(se,ce,J){if(se=p(this.options.sanitize,this.options.baseUrl,se),se===null)return J;var D='<a href="'+f(se)+'"';return ce&&(D+=' title="'+ce+'"'),D+=">"+J+"</a>",D},Se.image=function(se,ce,J){if(se=p(this.options.sanitize,this.options.baseUrl,se),se===null)return J;var D='<img src="'+se+'" alt="'+J+'"';return ce&&(D+=' title="'+ce+'"'),D+=this.options.xhtml?"/>":">",D},Se.text=function(se){return se},Te}(),Y=function(){function Te(){}var Se=Te.prototype;return Se.strong=function(se){return se},Se.em=function(se){return se},Se.codespan=function(se){return se},Se.del=function(se){return se},Se.html=function(se){return se},Se.text=function(se){return se},Se.link=function(se,ce,J){return""+J},Se.image=function(se,ce,J){return""+J},Se.br=function(){return""},Te}(),pe=function(){function Te(){this.seen={}}var Se=Te.prototype;return Se.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(se,ce){var J=se,D=0;if(this.seen.hasOwnProperty(J)){D=this.seen[se];do D++,J=se+"-"+D;while(this.seen.hasOwnProperty(J))}return ce||(this.seen[se]=D,this.seen[J]=0),J},Se.slug=function(se,ce){ce===void 0&&(ce={});var J=this.serialize(se);return this.getNextSafeSlug(J,ce.dryrun)},Te}(),ue=function(){function Te(ke){this.options=ke||te.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new pe}Te.parse=function(se,ce){var J=new Te(ce);return J.parse(se)},Te.parseInline=function(se,ce){var J=new Te(ce);return J.parseInline(se)};var Se=Te.prototype;return Se.parse=function(se,ce){ce===void 0&&(ce=!0);var J="",D,B,W,K,ee,he,ye,ae,be,Ee,We,He,tt,Xe,et,it,dt,Fe,st,_=se.length;for(D=0;D<_;D++){if(Ee=se[D],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(st=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){J+=st||"";continue}switch(Ee.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,o(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(ae="",ye="",K=Ee.header.length,B=0;B<K;B++)ye+=this.renderer.tablecell(this.parseInline(Ee.header[B].tokens),{header:!0,align:Ee.align[B]});for(ae+=this.renderer.tablerow(ye),be="",K=Ee.rows.length,B=0;B<K;B++){for(he=Ee.rows[B],ye="",ee=he.length,W=0;W<ee;W++)ye+=this.renderer.tablecell(this.parseInline(he[W].tokens),{header:!1,align:Ee.align[W]});be+=this.renderer.tablerow(ye)}J+=this.renderer.table(ae,be);continue}case"blockquote":{be=this.parse(Ee.tokens),J+=this.renderer.blockquote(be);continue}case"list":{for(We=Ee.ordered,He=Ee.start,tt=Ee.loose,K=Ee.items.length,be="",B=0;B<K;B++)et=Ee.items[B],it=et.checked,dt=et.task,Xe="",et.task&&(Fe=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Fe+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Fe+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Fe}):Xe+=Fe),Xe+=this.parse(et.tokens,tt),be+=this.renderer.listitem(Xe,dt,it);J+=this.renderer.list(be,We,He);continue}case"html":{J+=this.renderer.html(Ee.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(be=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;D+1<_&&se[D+1].type==="text";)Ee=se[++D],be+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);J+=ce?this.renderer.paragraph(be):be;continue}default:{var Q='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return J},Se.parseInline=function(se,ce){ce=ce||this.renderer;var J="",D,B,W,K=se.length;for(D=0;D<K;D++){if(B=se[D],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[B.type]&&(W=this.options.extensions.renderers[B.type].call({parser:this},B),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(B.type))){J+=W||"";continue}switch(B.type){case"escape":{J+=ce.text(B.text);break}case"html":{J+=ce.html(B.text);break}case"link":{J+=ce.link(B.href,B.title,this.parseInline(B.tokens,ce));break}case"image":{J+=ce.image(B.href,B.title,B.text);break}case"strong":{J+=ce.strong(this.parseInline(B.tokens,ce));break}case"em":{J+=ce.em(this.parseInline(B.tokens,ce));break}case"codespan":{J+=ce.codespan(B.text);break}case"br":{J+=ce.br();break}case"del":{J+=ce.del(this.parseInline(B.tokens,ce));break}case"text":{J+=ce.text(B.text);break}default:{var ee='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(ee);return}else throw new Error(ee)}}}return J},Te}();function de(Te,Se,ke){if(typeof Te>"u"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof Se=="function"&&(ke=Se,Se=null),Se=a({},de.defaults,Se||{}),F(Se),ke){var se=Se.highlight,ce;try{ce=j.lex(Te,Se)}catch(K){return ke(K)}var J=function(ee){var he;if(!ee)try{Se.walkTokens&&de.walkTokens(ce,Se.walkTokens),he=ue.parse(ce,Se)}catch(ye){ee=ye}return Se.highlight=se,ee?ke(ee):ke(null,he)};if(!se||se.length<3||(delete Se.highlight,!ce.length))return J();var D=0;de.walkTokens(ce,function(K){K.type==="code"&&(D++,setTimeout(function(){se(K.text,K.lang,function(ee,he){if(ee)return J(ee);he!=null&&he!==K.text&&(K.text=he,K.escaped=!0),D--,D===0&&J()})},0))}),D===0&&J();return}function B(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(K.message+"",!0)+"</pre>";throw K}try{var W=j.lex(Te,Se);if(Se.walkTokens){if(Se.async)return Promise.all(de.walkTokens(W,Se.walkTokens)).then(function(){return ue.parse(W,Se)}).catch(B);de.walkTokens(W,Se.walkTokens)}return ue.parse(W,Se)}catch(K){B(K)}}de.options=de.setOptions=function(Te){return a(de.defaults,Te),A(de.defaults),de},de.getDefaults=I,de.defaults=te.defaults,de.use=function(){for(var Te=arguments.length,Se=new Array(Te),ke=0;ke<Te;ke++)Se[ke]=arguments[ke];var se=a.apply(void 0,[{}].concat(Se)),ce=de.defaults.extensions||{renderers:{},childTokens:{}},J;Se.forEach(function(D){if(D.extensions&&(J=!0,D.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var K=ce.renderers?ce.renderers[W.name]:null;K?ce.renderers[W.name]=function(){for(var ee=arguments.length,he=new Array(ee),ye=0;ye<ee;ye++)he[ye]=arguments[ye];var ae=W.renderer.apply(this,he);return ae===!1&&(ae=K.apply(this,he)),ae}:ce.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[W.level]?ce[W.level].unshift(W.tokenizer):ce[W.level]=[W.tokenizer],W.start&&(W.level==="block"?ce.startBlock?ce.startBlock.push(W.start):ce.startBlock=[W.start]:W.level==="inline"&&(ce.startInline?ce.startInline.push(W.start):ce.startInline=[W.start]))}W.childTokens&&(ce.childTokens[W.name]=W.childTokens)})),D.renderer&&function(){var W=de.defaults.renderer||new le,K=function(ye){var ae=W[ye];W[ye]=function(){for(var be=arguments.length,Ee=new Array(be),We=0;We<be;We++)Ee[We]=arguments[We];var He=D.renderer[ye].apply(W,Ee);return He===!1&&(He=ae.apply(W,Ee)),He}};for(var ee in D.renderer)K(ee);se.renderer=W}(),D.tokenizer&&function(){var W=de.defaults.tokenizer||new N,K=function(ye){var ae=W[ye];W[ye]=function(){for(var be=arguments.length,Ee=new Array(be),We=0;We<be;We++)Ee[We]=arguments[We];var He=D.tokenizer[ye].apply(W,Ee);return He===!1&&(He=ae.apply(W,Ee)),He}};for(var ee in D.tokenizer)K(ee);se.tokenizer=W}(),D.walkTokens){var B=de.defaults.walkTokens;se.walkTokens=function(W){var K=[];return K.push(D.walkTokens.call(this,W)),B&&(K=K.concat(B.call(this,W))),K}}J&&(se.extensions=ce),de.setOptions(se)})},de.walkTokens=function(Te,Se){for(var ke=[],se=function(){var B=J.value;switch(ke=ke.concat(Se.call(de,B)),B.type){case"table":{for(var W=M(B.header),K;!(K=W()).done;){var ee=K.value;ke=ke.concat(de.walkTokens(ee.tokens,Se))}for(var he=M(B.rows),ye;!(ye=he()).done;)for(var ae=ye.value,be=M(ae),Ee;!(Ee=be()).done;){var We=Ee.value;ke=ke.concat(de.walkTokens(We.tokens,Se))}break}case"list":{ke=ke.concat(de.walkTokens(B.items,Se));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[B.type]?de.defaults.extensions.childTokens[B.type].forEach(function(He){ke=ke.concat(de.walkTokens(B[He],Se))}):B.tokens&&(ke=ke.concat(de.walkTokens(B.tokens,Se)))}},ce=M(Te),J;!(J=ce()).done;)se();return ke},de.parseInline=function(Te,Se){if(typeof Te>"u"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");Se=a({},de.defaults,Se||{}),F(Se);try{var ke=j.lexInline(Te,Se);return Se.walkTokens&&de.walkTokens(ke,Se.walkTokens),ue.parseInline(ke,Se)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(se.message+"",!0)+"</pre>";throw se}},de.Parser=ue,de.parser=ue.parse,de.Renderer=le,de.TextRenderer=Y,de.Lexer=j,de.lexer=j.lex,de.Tokenizer=N,de.Slugger=pe,de.parse=de;var re=de.options,G=de.setOptions,H=de.use,oe=de.walkTokens,ve=de.parseInline,Ae=de,Be=ue.parse,xe=j.lex;te.Lexer=j,te.Parser=ue,te.Renderer=le,te.Slugger=pe,te.TextRenderer=Y,te.Tokenizer=N,te.getDefaults=I,te.lexer=xe,te.marked=de,te.options=re,te.parse=Ae,te.parseInline=ve,te.parser=Be,te.setOptions=G,te.use=H,te.walkTokens=oe,Object.defineProperty(te,"__esModule",{value:!0})}),define(Ie[113],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(A,y,k){return Math.min(Math.max(A,y),k)}e.clamp=n;function C(A,y){return(y+A%y)%y}e.rot=C;class S{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=S;class M{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=M;class I{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const k=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=I}),function(){function te(S){const M=[];typeof S=="number"&&M.push("code/timeOrigin",S);function I(y){M.push(y,Date.now())}function A(){const y=[];for(let k=0;k<M.length;k+=2)y.push({name:M[k],startTime:M[k+1]});return y}return{mark:I,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const I of performance.getEntriesByType("mark"))M.push({name:I.name,startTime:Math.round(S+I.startTime)});return M}};if(typeof process=="object"){const S=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function n(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=n(C))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var C in n)(typeof exports=="object"?exports:te)[C]=n[C]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function n(C){if(e[C])return e[C].exports;var S=e[C]={i:C,l:!1,exports:{}};return te[C].call(S.exports,S,S.exports,n),S.l=!0,S.exports}return n.m=te,n.c=e,n.d=function(C,S,M){n.o(C,S)||Object.defineProperty(C,S,{enumerable:!0,get:M})},n.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},n.t=function(C,S){if(1&S&&(C=n(C)),8&S||4&S&&typeof C=="object"&&C&&C.__esModule)return C;var M=Object.create(null);if(n.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:C}),2&S&&typeof C!="string")for(var I in C)n.d(M,I,function(A){return C[A]}.bind(null,I));return M},n.n=function(C){var S=C&&C.__esModule?function(){return C.default}:function(){return C};return n.d(S,"a",S),S},n.o=function(C,S){return Object.prototype.hasOwnProperty.call(C,S)},n.p="",n(n.s=0)}([function(te,e,n){(function(C){var S;e=te.exports=H,S=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],k=0,O=k++;y[O]="0|[1-9]\\d*";var w=k++;y[w]="[0-9]+";var m=k++;y[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=k++;y[b]="("+y[O]+")\\.("+y[O]+")\\.("+y[O]+")";var f=k++;y[f]="("+y[w]+")\\.("+y[w]+")\\.("+y[w]+")";var s=k++;y[s]="(?:"+y[O]+"|"+y[m]+")";var o=k++;y[o]="(?:"+y[w]+"|"+y[m]+")";var l=k++;y[l]="(?:-("+y[s]+"(?:\\."+y[s]+")*))";var v=k++;y[v]="(?:-?("+y[o]+"(?:\\."+y[o]+")*))";var E=k++;y[E]="[0-9A-Za-z-]+";var P=k++;y[P]="(?:\\+("+y[E]+"(?:\\."+y[E]+")*))";var p=k++,r="v?"+y[b]+y[l]+"?"+y[P]+"?";y[p]="^"+r+"$";var d="[v=\\s]*"+y[f]+y[v]+"?"+y[P]+"?",i=k++;y[i]="^"+d+"$";var c=k++;y[c]="((?:<|>)?=?)";var t=k++;y[t]=y[w]+"|x|X|\\*";var h=k++;y[h]=y[O]+"|x|X|\\*";var a=k++;y[a]="[v=\\s]*("+y[h]+")(?:\\.("+y[h]+")(?:\\.("+y[h]+")(?:"+y[l]+")?"+y[P]+"?)?)?";var u=k++;y[u]="[v=\\s]*("+y[t]+")(?:\\.("+y[t]+")(?:\\.("+y[t]+")(?:"+y[v]+")?"+y[P]+"?)?)?";var g=k++;y[g]="^"+y[c]+"\\s*"+y[a]+"$";var R=k++;y[R]="^"+y[c]+"\\s*"+y[u]+"$";var F=k++;y[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=k++;y[q]="(?:~>?)";var Z=k++;y[Z]="(\\s*)"+y[q]+"\\s+",A[Z]=new RegExp(y[Z],"g");var x=k++;y[x]="^"+y[q]+y[a]+"$";var N=k++;y[N]="^"+y[q]+y[u]+"$";var $=k++;y[$]="(?:\\^)";var T=k++;y[T]="(\\s*)"+y[$]+"\\s+",A[T]=new RegExp(y[T],"g");var L=k++;y[L]="^"+y[$]+y[a]+"$";var V=k++;y[V]="^"+y[$]+y[u]+"$";var j=k++;y[j]="^"+y[c]+"\\s*("+d+")$|^$";var le=k++;y[le]="^"+y[c]+"\\s*("+r+")$|^$";var Y=k++;y[Y]="(\\s*)"+y[c]+"\\s*("+d+"|"+y[a]+")",A[Y]=new RegExp(y[Y],"g");var pe=k++;y[pe]="^\\s*("+y[a]+")\\s+-\\s+("+y[a]+")\\s*$";var ue=k++;y[ue]="^\\s*("+y[u]+")\\s+-\\s+("+y[u]+")\\s*$";var de=k++;y[de]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)S(re,y[re]),A[re]||(A[re]=new RegExp(y[re]));function G(ae,be){if(ae instanceof H)return ae;if(typeof ae!="string"||ae.length>M||!(be?A[i]:A[p]).test(ae))return null;try{return new H(ae,be)}catch{return null}}function H(ae,be){if(ae instanceof H){if(ae.loose===be)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof H))return new H(ae,be);S("SemVer",ae,be),this.loose=be;var Ee=ae.trim().match(be?A[i]:A[p]);if(!Ee)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var He=+We;if(He>=0&&He<I)return He}return We}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=G,e.valid=function(ae,be){var Ee=G(ae,be);return Ee?Ee.version:null},e.clean=function(ae,be){var Ee=G(ae.trim().replace(/^[=v]+/,""),be);return Ee?Ee.version:null},e.SemVer=H,H.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},H.prototype.toString=function(){return this.version},H.prototype.compare=function(ae){return S("SemVer.compare",this.version,this.loose,ae),ae instanceof H||(ae=new H(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},H.prototype.compareMain=function(ae){return ae instanceof H||(ae=new H(ae,this.loose)),ve(this.major,ae.major)||ve(this.minor,ae.minor)||ve(this.patch,ae.patch)},H.prototype.comparePre=function(ae){if(ae instanceof H||(ae=new H(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var be=0;do{var Ee=this.prerelease[be],We=ae.prerelease[be];if(S("prerelease compare",be,Ee,We),Ee===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==We)return ve(Ee,We)}while(++be)},H.prototype.inc=function(ae,be){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",be);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",be);break;case"prepatch":this.prerelease.length=0,this.inc("patch",be),this.inc("pre",be);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",be),this.inc("pre",be);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}be&&(this.prerelease[0]===be?isNaN(this.prerelease[1])&&(this.prerelease=[be,0]):this.prerelease=[be,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,be,Ee,We){typeof Ee=="string"&&(We=Ee,Ee=void 0);try{return new H(ae,Ee).inc(be,We).version}catch{return null}},e.diff=function(ae,be){if(Te(ae,be))return null;var Ee=G(ae),We=G(be);if(Ee.prerelease.length||We.prerelease.length){for(var He in Ee)if((He==="major"||He==="minor"||He==="patch")&&Ee[He]!==We[He])return"pre"+He;return"prerelease"}for(var He in Ee)if((He==="major"||He==="minor"||He==="patch")&&Ee[He]!==We[He])return He},e.compareIdentifiers=ve;var oe=/^[0-9]+$/;function ve(ae,be){var Ee=oe.test(ae),We=oe.test(be);return Ee&&We&&(ae=+ae,be=+be),Ee&&!We?-1:We&&!Ee?1:ae<be?-1:ae>be?1:0}function Ae(ae,be,Ee){return new H(ae,Ee).compare(new H(be,Ee))}function Be(ae,be,Ee){return Ae(ae,be,Ee)>0}function xe(ae,be,Ee){return Ae(ae,be,Ee)<0}function Te(ae,be,Ee){return Ae(ae,be,Ee)===0}function Se(ae,be,Ee){return Ae(ae,be,Ee)!==0}function ke(ae,be,Ee){return Ae(ae,be,Ee)>=0}function se(ae,be,Ee){return Ae(ae,be,Ee)<=0}function ce(ae,be,Ee,We){var He;switch(be){case"===":typeof ae=="object"&&(ae=ae.version),typeof Ee=="object"&&(Ee=Ee.version),He=ae===Ee;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof Ee=="object"&&(Ee=Ee.version),He=ae!==Ee;break;case"":case"=":case"==":He=Te(ae,Ee,We);break;case"!=":He=Se(ae,Ee,We);break;case">":He=Be(ae,Ee,We);break;case">=":He=ke(ae,Ee,We);break;case"<":He=xe(ae,Ee,We);break;case"<=":He=se(ae,Ee,We);break;default:throw new TypeError("Invalid operator: "+be)}return He}function J(ae,be){if(ae instanceof J){if(ae.loose===be)return ae;ae=ae.value}if(!(this instanceof J))return new J(ae,be);S("comparator",ae,be),this.loose=be,this.parse(ae),this.semver===D?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(ae,be){return ve(be,ae)},e.major=function(ae,be){return new H(ae,be).major},e.minor=function(ae,be){return new H(ae,be).minor},e.patch=function(ae,be){return new H(ae,be).patch},e.compare=Ae,e.compareLoose=function(ae,be){return Ae(ae,be,!0)},e.rcompare=function(ae,be,Ee){return Ae(be,ae,Ee)},e.sort=function(ae,be){return ae.sort(function(Ee,We){return e.compare(Ee,We,be)})},e.rsort=function(ae,be){return ae.sort(function(Ee,We){return e.rcompare(Ee,We,be)})},e.gt=Be,e.lt=xe,e.eq=Te,e.neq=Se,e.gte=ke,e.lte=se,e.cmp=ce,e.Comparator=J;var D={};function B(ae,be){if(ae instanceof B)return ae.loose===be?ae:new B(ae.raw,be);if(ae instanceof J)return new B(ae.value,be);if(!(this instanceof B))return new B(ae,be);if(this.loose=be,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function W(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function K(ae,be,Ee,We,He,tt,Xe,et,it,dt,Fe,st,_){return((be=W(Ee)?"":W(We)?">="+Ee+".0.0":W(He)?">="+Ee+"."+We+".0":">="+be)+" "+(et=W(it)?"":W(dt)?"<"+(+it+1)+".0.0":W(Fe)?"<"+it+"."+(+dt+1)+".0":st?"<="+it+"."+dt+"."+Fe+"-"+st:"<="+et)).trim()}function ee(ae,be){for(var Ee=0;Ee<ae.length;Ee++)if(!ae[Ee].test(be))return!1;if(be.prerelease.length){for(Ee=0;Ee<ae.length;Ee++)if(S(ae[Ee].semver),ae[Ee].semver!==D&&ae[Ee].semver.prerelease.length>0){var We=ae[Ee].semver;if(We.major===be.major&&We.minor===be.minor&&We.patch===be.patch)return!0}return!1}return!0}function he(ae,be,Ee){try{be=new B(be,Ee)}catch{return!1}return be.test(ae)}function ye(ae,be,Ee,We){var He,tt,Xe,et,it;switch(ae=new H(ae,We),be=new B(be,We),Ee){case">":He=Be,tt=se,Xe=xe,et=">",it=">=";break;case"<":He=xe,tt=ke,Xe=Be,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(he(ae,be,We))return!1;for(var dt=0;dt<be.set.length;++dt){var Fe=be.set[dt],st=null,_=null;if(Fe.forEach(function(Q){Q.semver===D&&(Q=new J(">=0.0.0")),st=st||Q,_=_||Q,He(Q.semver,st.semver,We)?st=Q:Xe(Q.semver,_.semver,We)&&(_=Q)}),st.operator===et||st.operator===it||(!_.operator||_.operator===et)&&tt(ae,_.semver)||_.operator===it&&Xe(ae,_.semver))return!1}return!0}J.prototype.parse=function(ae){var be=this.loose?A[j]:A[le],Ee=ae.match(be);if(!Ee)throw new TypeError("Invalid comparator: "+ae);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new H(Ee[2],this.loose):this.semver=D},J.prototype.toString=function(){return this.value},J.prototype.test=function(ae){return S("Comparator.test",ae,this.loose),this.semver===D||(typeof ae=="string"&&(ae=new H(ae,this.loose)),ce(ae,this.operator,this.semver,this.loose))},J.prototype.intersects=function(ae,be){if(!(ae instanceof J))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new B(ae.value,be),he(this.value,Ee,be);if(ae.operator==="")return Ee=new B(this.value,be),he(ae.semver,Ee,be);var We=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),tt=this.semver.version===ae.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),et=ce(this.semver,"<",ae.semver,be)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),it=ce(this.semver,">",ae.semver,be)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return We||He||tt&&Xe||et||it},e.Range=B,B.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},B.prototype.toString=function(){return this.range},B.prototype.parseRange=function(ae){var be=this.loose;ae=ae.trim(),S("range",ae,be);var Ee=be?A[ue]:A[pe];ae=ae.replace(Ee,K),S("hyphen replace",ae),ae=ae.replace(A[Y],"$1$2$3"),S("comparator trim",ae,A[Y]),ae=(ae=(ae=ae.replace(A[Z],"$1~")).replace(A[T],"$1^")).split(/\s+/).join(" ");var We=be?A[j]:A[le],He=ae.split(" ").map(function(tt){return function(Xe,et){return S("comp",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,_){S("caret",st,_);var Q=_?A[V]:A[L];return st.replace(Q,function(ge,Le,$e,je,_e){var nt;return S("caret",st,ge,Le,$e,je,_e),W(Le)?nt="":W($e)?nt=">="+Le+".0.0 <"+(+Le+1)+".0.0":W(je)?nt=Le==="0"?">="+Le+"."+$e+".0 <"+Le+"."+(+$e+1)+".0":">="+Le+"."+$e+".0 <"+(+Le+1)+".0.0":_e?(S("replaceCaret pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),nt=Le==="0"?$e==="0"?">="+Le+"."+$e+"."+je+_e+" <"+Le+"."+$e+"."+(+je+1):">="+Le+"."+$e+"."+je+_e+" <"+Le+"."+(+$e+1)+".0":">="+Le+"."+$e+"."+je+_e+" <"+(+Le+1)+".0.0"):(S("no pr"),nt=Le==="0"?$e==="0"?">="+Le+"."+$e+"."+je+" <"+Le+"."+$e+"."+(+je+1):">="+Le+"."+$e+"."+je+" <"+Le+"."+(+$e+1)+".0":">="+Le+"."+$e+"."+je+" <"+(+Le+1)+".0.0"),S("caret return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),S("caret",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,_){var Q=_?A[N]:A[x];return st.replace(Q,function(ge,Le,$e,je,_e){var nt;return S("tilde",st,ge,Le,$e,je,_e),W(Le)?nt="":W($e)?nt=">="+Le+".0.0 <"+(+Le+1)+".0.0":W(je)?nt=">="+Le+"."+$e+".0 <"+Le+"."+(+$e+1)+".0":_e?(S("replaceTilde pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),nt=">="+Le+"."+$e+"."+je+_e+" <"+Le+"."+(+$e+1)+".0"):nt=">="+Le+"."+$e+"."+je+" <"+Le+"."+(+$e+1)+".0",S("tilde return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),S("tildes",Xe),Xe=function(it,dt){return S("replaceXRanges",it,dt),it.split(/\s+/).map(function(Fe){return function(st,_){st=st.trim();var Q=_?A[R]:A[g];return st.replace(Q,function(ge,Le,$e,je,_e,nt){S("xRange",st,ge,Le,$e,je,_e,nt);var wt=W($e),St=wt||W(je),Ct=St||W(_e);return Le==="="&&Ct&&(Le=""),wt?ge=Le===">"||Le==="<"?"<0.0.0":"*":Le&&Ct?(St&&(je=0),Ct&&(_e=0),Le===">"?(Le=">=",St?($e=+$e+1,je=0,_e=0):Ct&&(je=+je+1,_e=0)):Le==="<="&&(Le="<",St?$e=+$e+1:je=+je+1),ge=Le+$e+"."+je+"."+_e):St?ge=">="+$e+".0.0 <"+(+$e+1)+".0.0":Ct&&(ge=">="+$e+"."+je+".0 <"+$e+"."+(+je+1)+".0"),S("xRange return",ge),ge})}(Fe,dt)}).join(" ")}(Xe,et),S("xrange",Xe),Xe=function(it,dt){return S("replaceStars",it,dt),it.trim().replace(A[de],"")}(Xe,et),S("stars",Xe),Xe}(tt,be)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(tt){return!!tt.match(We)})),He=He.map(function(tt){return new J(tt,be)})},B.prototype.intersects=function(ae,be){if(!(ae instanceof B))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(We){return ae.set.some(function(He){return He.every(function(tt){return We.intersects(tt,be)})})})})},e.toComparators=function(ae,be){return new B(ae,be).set.map(function(Ee){return Ee.map(function(We){return We.value}).join(" ").trim().split(" ")})},B.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new H(ae,this.loose));for(var be=0;be<this.set.length;be++)if(ee(this.set[be],ae))return!0;return!1},e.satisfies=he,e.maxSatisfying=function(ae,be,Ee){var We=null,He=null;try{var tt=new B(be,Ee)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==-1||(He=new H(We=Xe,Ee)))}),We},e.minSatisfying=function(ae,be,Ee){var We=null,He=null;try{var tt=new B(be,Ee)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==1||(He=new H(We=Xe,Ee)))}),We},e.validRange=function(ae,be){try{return new B(ae,be).range||"*"}catch{return null}},e.ltr=function(ae,be,Ee){return ye(ae,be,"<",Ee)},e.gtr=function(ae,be,Ee){return ye(ae,be,">",Ee)},e.outside=ye,e.prerelease=function(ae,be){var Ee=G(ae,be);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(ae,be,Ee){return ae=new B(ae,Ee),be=new B(be,Ee),ae.intersects(be)},e.coerce=function(ae){if(ae instanceof H)return ae;if(typeof ae!="string")return null;var be=ae.match(A[F]);return be==null?null:G((be[1]||"0")+"."+(be[2]||"0")+"."+(be[3]||"0"))}}).call(this,n(1))},function(te,e){var n,C,S=te.exports={};function M(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function A(o){if(n===setTimeout)return setTimeout(o,0);if((n===M||!n)&&setTimeout)return n=setTimeout,setTimeout(o,0);try{return n(o,0)}catch{try{return n.call(null,o,0)}catch{return n.call(this,o,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:M}catch{n=M}try{C=typeof clearTimeout=="function"?clearTimeout:I}catch{C=I}})();var y,k=[],O=!1,w=-1;function m(){O&&y&&(O=!1,y.length?k=y.concat(k):w=-1,k.length&&b())}function b(){if(!O){var o=A(m);O=!0;for(var l=k.length;l;){for(y=k,k=[];++w<l;)y&&y[w].run();w=-1,l=k.length}y=null,O=!1,function(v){if(C===clearTimeout)return clearTimeout(v);if((C===I||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(v);try{C(v)}catch{try{return C.call(null,v)}catch{return C.call(this,v)}}}(o)}}function f(o,l){this.fun=o,this.array=l}function s(){}S.nextTick=function(o){var l=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)l[v-1]=arguments[v];k.push(new f(o,l)),k.length!==1||O||A(b)},f.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=s,S.addListener=s,S.once=s,S.off=s,S.removeListener=s,S.removeAllListeners=s,S.emit=s,S.prependListener=s,S.prependOnceListener=s,S.listeners=function(o){return[]},S.binding=function(o){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(o){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Ie[114],Ce([1,0,11,6]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function S(P){const p=P;return p?typeof p.read=="function":!1}e.isReadable=S;function M(P){const p=P;return p?[p.on,p.pause,p.resume,p.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=M;function I(P){const p=P;return p?M(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=I;function A(P,p){return new y(P,p)}e.newWriteableStream=A;class y{constructor(p,r){this.e=p,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(r=>r(p))}h(p){this.c.error.length===0?(0,n.onUnexpectedError)(p):this.c.error.slice(0).forEach(r=>r(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,r){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(p,r){if(this.a.destroyed)return;let d;switch(p){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const i=d.indexOf(r);i>=0&&d.splice(i,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(P,p){const r=[];let d;for(;(d=P.read())!==null;)r.push(d);return p(r)}e.consumeReadable=k;function O(P,p,r){const d=[];let i;for(;(i=P.read())!==null&&d.length<r;)d.push(i);return i===null&&d.length>0?p(d):{read:()=>{if(d.length>0)return d.shift();if(typeof i<"u"){const c=i;return i=void 0,c}return P.read()}}}e.peekReadable=O;function w(P,p){return new Promise((r,d)=>{const i=[];m(P,{onData:c=>{p&&i.push(c)},onError:c=>{p?d(c):r(void 0)},onEnd:()=>{r(p?p(i):void 0)}})})}e.consumeStream=w;function m(P,p){let r=!1;return P.on("error",d=>{r||p.onError(d)}),P.on("end",()=>{r||p.onEnd()}),P.on("data",d=>{r||p.onData(d)}),(0,C.toDisposable)(()=>r=!0)}e.listenStream=m;function b(P,p){return new Promise((r,d)=>{const i=new C.DisposableStore,c=[],t=u=>{if(c.push(u),c.length>p)return i.dispose(),P.pause(),r({stream:P,buffer:c,ended:!1})},h=u=>d(u),a=()=>r({stream:P,buffer:c,ended:!0});i.add((0,C.toDisposable)(()=>P.removeListener("error",h))),P.on("error",h),i.add((0,C.toDisposable)(()=>P.removeListener("end",a))),P.on("end",a),i.add((0,C.toDisposable)(()=>P.removeListener("data",t))),P.on("data",t)})}e.peekStream=b;function f(P,p){const r=A(p);return r.end(P),r}e.toStream=f;function s(){const P=A(()=>{throw new Error("not supported")});return P.end(),P}e.emptyStream=s;function o(P){let p=!1;return{read:()=>p?null:(p=!0,P)}}e.toReadable=o;function l(P,p,r){const d=A(r);return m(P,{onData:i=>d.write(p.data(i)),onError:i=>d.error(p.error?p.error(i):i),onEnd:()=>d.end()}),d}e.transform=l;function v(P,p,r){let d=!1;return{read:()=>{const i=p.read();return d?i:(d=!0,i!==null?r([P,i]):P)}}}e.prefixedReadable=v;function E(P,p,r){let d=!1;const i=A(r);return m(p,{onData:c=>d?i.write(c):(d=!0,i.write(r([P,c]))),onError:c=>i.error(c),onEnd:()=>{d||(d=!0,i.write(P)),i.end()}}),i}e.prefixedStream=E}),define(Ie[24],Ce([1,0,114]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer<"u";let S,M;class I{static alloc(u){return C?new I(Buffer.allocUnsafe(u)):new I(new Uint8Array(u))}static wrap(u){return C&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new I(u)}static fromString(u,g){return!(g?.dontUseNodeBuffer||!1)&&C?new I(Buffer.from(u)):(S||(S=new TextEncoder),new I(S.encode(u)))}static fromByteArray(u){const g=I.alloc(u.length);for(let R=0,F=u.length;R<F;R++)g.buffer[R]=u[R];return g}static concat(u,g){if(typeof g>"u"){g=0;for(let q=0,Z=u.length;q<Z;q++)g+=u[q].byteLength}const R=I.alloc(g);let F=0;for(let q=0,Z=u.length;q<Z;q++){const x=u[q];R.set(x,F),F+=x.byteLength}return R}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=I.alloc(this.byteLength);return u.set(this),u}toString(){return C?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(u,g){return new I(this.buffer.subarray(u,g))}set(u,g){if(u instanceof I)this.buffer.set(u.buffer,g);else if(u instanceof Uint8Array)this.buffer.set(u,g);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),g);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return k(this.buffer,u)}writeUInt32BE(u,g){O(this.buffer,u,g)}readUInt32LE(u){return w(this.buffer,u)}writeUInt32LE(u,g){m(this.buffer,u,g)}readUInt8(u){return b(this.buffer,u)}writeUInt8(u,g){f(this.buffer,u,g)}}e.VSBuffer=I;function A(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0}e.readUInt16LE=A;function y(a,u,g){a[g+0]=u&255,u=u>>>8,a[g+1]=u&255}e.writeUInt16LE=y;function k(a,u){return a[u]*2**24+a[u+1]*2**16+a[u+2]*2**8+a[u+3]}e.readUInt32BE=k;function O(a,u,g){a[g+3]=u,u=u>>>8,a[g+2]=u,u=u>>>8,a[g+1]=u,u=u>>>8,a[g]=u}e.writeUInt32BE=O;function w(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0|a[u+2]<<16>>>0|a[u+3]<<24>>>0}e.readUInt32LE=w;function m(a,u,g){a[g+0]=u&255,u=u>>>8,a[g+1]=u&255,u=u>>>8,a[g+2]=u&255,u=u>>>8,a[g+3]=u&255}e.writeUInt32LE=m;function b(a,u){return a[u]}e.readUInt8=b;function f(a,u,g){a[g]=u}e.writeUInt8=f;function s(a){return n.consumeReadable(a,u=>I.concat(u))}e.readableToBuffer=s;function o(a){return n.toReadable(a)}e.bufferToReadable=o;function l(a){return n.consumeStream(a,u=>I.concat(u))}e.streamToBuffer=l;async function v(a){return a.ended?I.concat(a.buffer):I.concat([...a.buffer,await l(a.stream)])}e.bufferedStreamToBuffer=v;function E(a){return n.toStream(a,u=>I.concat(u))}e.bufferToStream=E;function P(a){return n.transform(a,{data:u=>typeof u=="string"?I.fromString(u):I.wrap(u)},u=>I.concat(u))}e.streamToBufferReadableStream=P;function p(a){return n.newWriteableStream(u=>I.concat(u),a)}e.newWriteableBufferStream=p;function r(a,u){return n.prefixedReadable(a,u,g=>I.concat(g))}e.prefixedBufferReadable=r;function d(a,u){return n.prefixedStream(a,u,g=>I.concat(g))}e.prefixedBufferStream=d;function i(a){let u=0,g=0,R=0;const F=new Uint8Array(Math.floor(a.length/4*3)),q=x=>{switch(g){case 3:F[R++]=u|x,g=0;break;case 2:F[R++]=u|x>>>2,u=x<<6,g=3;break;case 1:F[R++]=u|x>>>4,u=x<<4,g=2;break;default:u=x<<2,g=1}};for(let x=0;x<a.length;x++){const N=a.charCodeAt(x);if(N>=65&&N<=90)q(N-65);else if(N>=97&&N<=122)q(N-97+26);else if(N>=48&&N<=57)q(N-48+52);else if(N===43||N===45)q(62);else if(N===47||N===95)q(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${a[x]}`)}}const Z=R;for(;g>0;)q(0);return I.wrap(F).slice(0,Z)}e.decodeBase64=i;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:a},u=!0,g=!1){const R=g?t:c;let F="";const q=a.byteLength%3;let Z=0;for(;Z<a.byteLength-q;Z+=3){const x=a[Z+0],N=a[Z+1],$=a[Z+2];F+=R[x>>>2],F+=R[(x<<4|N>>>4)&63],F+=R[(N<<2|$>>>6)&63],F+=R[$&63]}if(q===1){const x=a[Z+0];F+=R[x>>>2],F+=R[x<<4&63],u&&(F+="==")}else if(q===2){const x=a[Z+0],N=a[Z+1];F+=R[x>>>2],F+=R[(x<<4|N>>>4)&63],F+=R[N<<2&63],u&&(F+="=")}return F}e.encodeBase64=h}),define(Ie[34],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(S){return n.test(S)}e.isUUID=C,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const M=new Uint8Array(16),I=[];for(let A=0;A<256;A++)I.push(A.toString(16).padStart(2,"0"));return function(){S(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let y=0,k="";return k+=I[M[y++]],k+=I[M[y++]],k+=I[M[y++]],k+=I[M[y++]],k+="-",k+=I[M[y++]],k+=I[M[y++]],k+="-",k+=I[M[y++]],k+=I[M[y++]],k+="-",k+=I[M[y++]],k+=I[M[y++]],k+="-",k+=I[M[y++]],k+=I[M[y++]],k+=I[M[y++]],k+=I[M[y++]],k+=I[M[y++]],k+=I[M[y++]],k}}()}),define(Ie[115],Ce([1,0,18,34]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function S(A){return{id:(0,C.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=S;function M(A,y,k){return{id:(0,C.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:y,data:k}),value:void 0}}e.createFileDataTransferItem=M;class I{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,k){const O=this.a.get(y);O?O.push(k):this.a.set(this.b(y),[k])}replace(y,k){this.a.set(this.b(y),[k])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,k]of this.a.entries())for(const O of k)yield[y,O]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[k,O]of this.entries())y(O,k)}b(y){return y.toLowerCase()}}e.VSDataTransfer=I,e.UriList=Object.freeze({create:A=>(0,n.distinct)(A.map(y=>y.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(y=>!y.startsWith("#"))})}),define(Ie[116],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[117],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(n=e.IndentAction||(e.IndentAction={}));class C{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let y=0,k=A.notIn.length;y<k;y++)switch(A.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const k=A.findTokenIndexAtOffset(y-2),O=A.getStandardTokenType(k);return this.isOK(O)}g(A,y){for(let k=A;k<=y;k++){const O=String.fromCharCode(k);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=C;class S{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)M(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),M(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),M(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),M(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&M(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=S;function M(I,A,y){I.has(A)?I.get(A).push(y):I.set(A,[y])}}),define(Ie[118],Ce([13,14]),function(te,e){return te.create("vs/base/common/actions",e)}),define(Ie[119],Ce([13,14]),function(te,e){return te.create("vs/base/common/date",e)}),define(Ie[120],Ce([1,0,119]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const C=60,S=C*60,M=S*24,I=M*7,A=M*30,y=M*365;function k(w,m,b,f){typeof w!="number"&&(w=w.getTime());const s=Math.round((new Date().getTime()-w)/1e3);if(s<-30)return(0,n.localize)(0,null,k(new Date().getTime()+s*1e3,!1));if(!f&&s<30)return(0,n.localize)(1,null);let o;return s<C?(o=s,m?o===1?b?(0,n.localize)(2,null,o):(0,n.localize)(3,null,o):b?(0,n.localize)(4,null,o):(0,n.localize)(5,null,o):o===1?b?(0,n.localize)(6,null,o):(0,n.localize)(7,null,o):b?(0,n.localize)(8,null,o):(0,n.localize)(9,null,o)):s<S?(o=Math.floor(s/C),m?o===1?b?(0,n.localize)(10,null,o):(0,n.localize)(11,null,o):b?(0,n.localize)(12,null,o):(0,n.localize)(13,null,o):o===1?b?(0,n.localize)(14,null,o):(0,n.localize)(15,null,o):b?(0,n.localize)(16,null,o):(0,n.localize)(17,null,o)):s<M?(o=Math.floor(s/S),m?o===1?b?(0,n.localize)(18,null,o):(0,n.localize)(19,null,o):b?(0,n.localize)(20,null,o):(0,n.localize)(21,null,o):o===1?b?(0,n.localize)(22,null,o):(0,n.localize)(23,null,o):b?(0,n.localize)(24,null,o):(0,n.localize)(25,null,o)):s<I?(o=Math.floor(s/M),m?o===1?(0,n.localize)(26,null,o):(0,n.localize)(27,null,o):o===1?(0,n.localize)(28,null,o):(0,n.localize)(29,null,o)):s<A?(o=Math.floor(s/I),m?o===1?b?(0,n.localize)(30,null,o):(0,n.localize)(31,null,o):b?(0,n.localize)(32,null,o):(0,n.localize)(33,null,o):o===1?b?(0,n.localize)(34,null,o):(0,n.localize)(35,null,o):b?(0,n.localize)(36,null,o):(0,n.localize)(37,null,o)):s<y?(o=Math.floor(s/A),m?o===1?b?(0,n.localize)(38,null,o):(0,n.localize)(39,null,o):b?(0,n.localize)(40,null,o):(0,n.localize)(41,null,o):o===1?b?(0,n.localize)(42,null,o):(0,n.localize)(43,null,o):b?(0,n.localize)(44,null,o):(0,n.localize)(45,null,o)):(o=Math.floor(s/y),m?o===1?b?(0,n.localize)(46,null,o):(0,n.localize)(47,null,o):b?(0,n.localize)(48,null,o):(0,n.localize)(49,null,o):o===1?b?(0,n.localize)(50,null,o):(0,n.localize)(51,null,o):b?(0,n.localize)(52,null,o):(0,n.localize)(53,null,o))}e.fromNow=k;function O(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Ie[121],Ce([13,14]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Ie[39],Ce([1,0,18,9,121]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(w,m){return m&&(w.stack||w.stacktrace)?S.localize(0,null,A(w),I(w.stack)||I(w.stacktrace)):A(w)}function I(w){return Array.isArray(w)?w.join(`
`):w}function A(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?S.localize(1,null,w.message):w.message||S.localize(2,null)}function y(w=null,m=!1){if(!w)return S.localize(3,null);if(Array.isArray(w)){const b=n.coalesce(w),f=y(b[0],m);return b.length>1?S.localize(4,null,f,b.length):f}if(C.isString(w))return w;if(w.detail){const b=w.detail;if(b.error)return M(b.error,m);if(b.exception)return M(b.exception,m)}return w.stack?M(w,m):w.message?w.message:S.localize(5,null)}e.toErrorMessage=y;function k(w){const m=w;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=k;function O(w,m){let b;return typeof w=="string"?b=new Error(w):b=w,b.actions=m,b}e.createErrorWithActions=O}),define(Ie[122],Ce([1,0,84,19]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new n.Lazy(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),M=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(u,g,R=!1){const F=u||"",q=g||"",Z=S.value.collator.compare(F,q);return S.value.collatorIsNumeric&&Z===0&&F!==q?F<q?-1:1:Z}e.compareFileNames=A;function y(u,g){const R=M.value.collator;return u=u||"",g=g||"",P(R,u,g)}e.compareFileNamesDefault=y;function k(u,g){const R=M.value.collator;return u=u||"",g=g||"",i(u,g)||P(R,u,g)}e.compareFileNamesUpper=k;function O(u,g){const R=M.value.collator;return u=u||"",g=g||"",d(u,g)||P(R,u,g)}e.compareFileNamesLower=O;function w(u,g){return u=u||"",g=g||"",u===g?0:u<g?-1:1}e.compareFileNamesUnicode=w;function m(u,g){const[R,F]=v(u),[q,Z]=v(g);let x=S.value.collator.compare(F,Z);if(x===0){if(S.value.collatorIsNumeric&&F!==Z)return F<Z?-1:1;if(x=S.value.collator.compare(R,q),S.value.collatorIsNumeric&&x===0&&R!==q)return R<q?-1:1}return x}e.compareFileExtensions=m;function b(u,g){u=u||"",g=g||"";const R=E(u),F=E(g),q=M.value.collator,Z=I.value.collator;return P(Z,R,F)||P(q,u,g)}e.compareFileExtensionsDefault=b;function f(u,g){u=u||"",g=g||"";const R=E(u),F=E(g),q=M.value.collator,Z=I.value.collator;return P(Z,R,F)||i(u,g)||P(q,u,g)}e.compareFileExtensionsUpper=f;function s(u,g){u=u||"",g=g||"";const R=E(u),F=E(g),q=M.value.collator,Z=I.value.collator;return P(Z,R,F)||d(u,g)||P(q,u,g)}e.compareFileExtensionsLower=s;function o(u,g){u=u||"",g=g||"";const R=E(u).toLowerCase(),F=E(g).toLowerCase();return R!==F?R<F?-1:1:u!==g?u<g?-1:1:0}e.compareFileExtensionsUnicode=o;const l=/^(.*?)(\.([^.]*))?$/;function v(u,g=!1){const R=u?l.exec(u):[];let F=[R&&R[1]||"",R&&R[3]||""];return g&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function E(u){const g=u?l.exec(u):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function P(u,g,R){const F=u.compare(g,R);return F!==0?F:g.length!==R.length?g.length<R.length?-1:1:0}function p(u){const g=u.charAt(0);return g.toLocaleUpperCase()!==g}function r(u){const g=u.charAt(0);return g.toLocaleLowerCase()!==g}function d(u,g){return p(u)&&r(g)?-1:r(u)&&p(g)?1:0}function i(u,g){return r(u)&&p(g)?-1:p(u)&&r(g)?1:0}function c(u,g,R=!1){return R||(u=u&&u.toLowerCase(),g=g&&g.toLowerCase()),u===g?0:u<g?-1:1}function t(u,g,R=!1){const F=u.split(C.sep),q=g.split(C.sep),Z=F.length-1,x=q.length-1;let N,$;for(let T=0;;T++){if(N=Z===T,$=x===T,N&&$)return A(F[T],q[T],R);if(N)return-1;if($)return 1;const L=c(F[T],q[T],R);if(L!==0)return L}}e.comparePaths=t;function h(u,g,R){const F=u.toLowerCase(),q=g.toLowerCase(),Z=a(u,g,R);if(Z)return Z;const x=F.endsWith(R),N=q.endsWith(R);if(x!==N)return x?-1:1;const $=A(F,q);return $!==0?$:F.localeCompare(q)}e.compareAnything=h;function a(u,g,R){const F=u.toLowerCase(),q=g.toLowerCase(),Z=F.startsWith(R),x=q.startsWith(R);if(Z!==x)return Z?-1:1;if(Z&&x){if(F.length<q.length)return-1;if(F.length>q.length)return 1}return 0}e.compareByPrefix=a}),define(Ie[64],Ce([1,0,19]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(O){const w=(0,n.extname)(O),m=C[w.toLowerCase()];return m!==void 0?m:I(O)}e.getMediaOrTextMime=M;function I(O){const w=(0,n.extname)(O);return S[w.toLowerCase()]}e.getMediaMime=I;function A(O){for(const w in S)if(S[w]===O)return w}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function k(O,w){const m=y.exec(O);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:w?void 0:O}e.normalizeMimeType=k}),define(Ie[123],Ce([1,0,4,6,118]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class M extends C.Disposable{constructor(m,b="",f="",s=!0,o){super(),this.h=this.B(new n.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=b,this.u=f,this.w=s,this.C=o}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,b){this.C&&await this.C(m)}}e.Action=M;class I extends C.Disposable{constructor(){super(...arguments),this.f=this.B(new n.Emitter),this.onWillRun=this.f.event,this.h=this.B(new n.Emitter),this.onDidRun=this.h.event}async run(m,b){if(!m.enabled)return;this.f.fire({action:m});let f;try{await this.runAction(m,b)}catch(s){f=s}this.h.fire({action:m,error:f})}async runAction(m,b){await m.run(b)}}e.ActionRunner=I;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let b=[];for(const f of m)f.length&&(b.length?b=[...b,new A,...f]:b=f);return b}async run(){}}e.Separator=A,A.ID="vs.actions.separator";class y{get actions(){return this.a}constructor(m,b,f,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=b,this.class=s,this.a=f}async run(){}}e.SubmenuAction=y;class k extends M{constructor(){super(k.ID,S.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=k,k.ID="vs.actions.empty";function O(w){return{id:w.id,label:w.label,class:void 0,enabled:w.enabled??!0,checked:w.checked??!1,run:async()=>w.run(),tooltip:w.label}}e.toAction=O}),define(Ie[40],Ce([1,0,19,20,10,9]),function(te,e,n,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(t){return t===47||t===92}e.isPathSeparator=I;function A(t){return t.replace(/[\\/]/g,n.posix.sep)}e.toSlashes=A;function y(t){return t.indexOf("/")===-1&&(t=A(t)),/^[a-zA-Z]:(\/|$)/.test(t)&&(t="/"+t),t}e.toPosixPath=y;function k(t,h=n.posix.sep){if(!t)return"";const a=t.length,u=t.charCodeAt(0);if(I(u)){if(I(t.charCodeAt(1))&&!I(t.charCodeAt(2))){let R=3;const F=R;for(;R<a&&!I(t.charCodeAt(R));R++);if(F!==R&&!I(t.charCodeAt(R+1))){for(R+=1;R<a;R++)if(I(t.charCodeAt(R)))return t.slice(0,R+1).replace(/[\\/]/g,h)}}return h}else if(l(u)&&t.charCodeAt(1)===58)return I(t.charCodeAt(2))?t.slice(0,2)+h:t.slice(0,2);let g=t.indexOf("://");if(g!==-1){for(g+=3;g<a;g++)if(I(t.charCodeAt(g)))return t.slice(0,g+1)}return""}e.getRoot=k;function O(t){if(!C.isWindows||!t||t.length<5)return!1;let h=t.charCodeAt(0);if(h!==92||(h=t.charCodeAt(1),h!==92))return!1;let a=2;const u=a;for(;a<t.length&&(h=t.charCodeAt(a),h!==92);a++);return!(u===a||(h=t.charCodeAt(a+1),isNaN(h)||h===92))}e.isUNC=O;const w=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(t,h=C.isWindows){const a=h?w:m;return!(!t||t.length===0||/^\s+$/.test(t)||(a.lastIndex=0,a.test(t))||h&&b.test(t)||t==="."||t===".."||h&&t[t.length-1]==="."||h&&t.length!==t.trim().length||t.length>255)}e.isValidBasename=f;function s(t,h,a){const u=t===h;return!a||u?u:!t||!h?!1:(0,S.equalsIgnoreCase)(t,h)}e.isEqual=s;function o(t,h,a,u=n.sep){if(t===h)return!0;if(!t||!h||h.length>t.length)return!1;if(a){if(!(0,S.startsWithIgnoreCase)(t,h))return!1;if(h.length===t.length)return!0;let R=h.length;return h.charAt(h.length-1)===u&&R--,t.charAt(R)===u}return h.charAt(h.length-1)!==u&&(h+=u),t.indexOf(h)===0}e.isEqualOrParent=o;function l(t){return t>=65&&t<=90||t>=97&&t<=122}e.isWindowsDriveLetter=l;function v(t,h){return C.isWindows&&t.endsWith(":")&&(t+=n.sep),(0,n.isAbsolute)(t)||(t=(0,n.join)(h,t)),t=(0,n.normalize)(t),C.isWindows?(t=(0,S.rtrim)(t,n.sep),t.endsWith(":")&&(t+=n.sep)):(t=(0,S.rtrim)(t,n.sep),t||(t=n.sep)),t}e.sanitizeFilePath=v;function E(t){const h=(0,n.normalize)(t);return C.isWindows?t.length>3?!1:P(h)&&(t.length===2||h.charCodeAt(2)===92):h===n.posix.sep}e.isRootOrDriveLetter=E;function P(t,h=C.isWindows){return h?l(t.charCodeAt(0))&&t.charCodeAt(1)===58:!1}e.hasDriveLetter=P;function p(t){return P(t)?t[0]:void 0}e.getDriveLetter=p;function r(t,h,a){return h.length>t.length?-1:t===h?0:(a&&(t=t.toLowerCase(),h=h.toLowerCase()),t.indexOf(h))}e.indexOfPath=r;function d(t){const h=t.split(":");let a,u,g;for(const R of h){const F=Number(R);(0,M.isNumber)(F)?u===void 0?u=F:g===void 0&&(g=F):a=a?[a,R].join(":"):R}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:u!==void 0?u:void 0,column:g!==void 0?g:u!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function c(t,h,a=8){let u="";for(let R=0;R<a;R++)u+=i.charAt(Math.floor(Math.random()*i.length));let g;return h?g=`${h}-${u}`:g=u,t?(0,n.join)(t,g):g}e.randomPath=c}),define(Ie[124],Ce([1,0,28,10]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...J){return function(D,B){for(let W=0,K=J.length;W<K;W++){const ee=J[W](D,B);if(ee)return ee}return null}}e.or=S,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(J,D,B){if(!B||B.length<D.length)return null;let W;return J?W=C.startsWithIgnoreCase(B,D):W=B.indexOf(D)===0,W?D.length>0?[{start:0,end:D.length}]:[]:null}function I(J,D){const B=D.toLowerCase().indexOf(J.toLowerCase());return B===-1?null:[{start:B,end:B+J.length}]}e.matchesContiguousSubString=I;function A(J,D){return y(J.toLowerCase(),D.toLowerCase(),0,0)}e.matchesSubString=A;function y(J,D,B,W){if(B===J.length)return[];if(W===D.length)return null;if(J[B]===D[W]){let K=null;return(K=y(J,D,B+1,W+1))?l({start:W,end:W+1},K):null}return y(J,D,B,W+1)}function k(J){return 97<=J&&J<=122}function O(J){return 65<=J&&J<=90}e.isUpper=O;function w(J){return 48<=J&&J<=57}function m(J){return J===32||J===9||J===10||J===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>b.add(J.charCodeAt(0)));function f(J){return m(J)||b.has(J)}function s(J,D){return J===D||f(J)&&f(D)}function o(J){return k(J)||O(J)||w(J)}function l(J,D){return D.length===0?D=[J]:J.end===D[0].start?D[0].start=J.start:D.unshift(J),D}function v(J,D){for(let B=D;B<J.length;B++){const W=J.charCodeAt(B);if(O(W)||w(W)||B>0&&!o(J.charCodeAt(B-1)))return B}return J.length}function E(J,D,B,W){if(B===J.length)return[];if(W===D.length)return null;if(J[B]!==D[W].toLowerCase())return null;{let K=null,ee=W+1;for(K=E(J,D,B+1,W+1);!K&&(ee=v(D,ee))<D.length;)K=E(J,D,B+1,ee),ee++;return K===null?null:l({start:W,end:W+1},K)}}function P(J){let D=0,B=0,W=0,K=0,ee=0;for(let Ee=0;Ee<J.length;Ee++)ee=J.charCodeAt(Ee),O(ee)&&D++,k(ee)&&B++,o(ee)&&W++,w(ee)&&K++;const he=D/J.length,ye=B/J.length,ae=W/J.length,be=K/J.length;return{upperPercent:he,lowerPercent:ye,alphaPercent:ae,numericPercent:be}}function p(J){const{upperPercent:D,lowerPercent:B}=J;return B===0&&D>.6}function r(J){const{upperPercent:D,lowerPercent:B,alphaPercent:W,numericPercent:K}=J;return B>.2&&D<.8&&W>.6&&K<.2}function d(J){let D=0,B=0,W=0,K=0;for(let ee=0;ee<J.length;ee++)W=J.charCodeAt(ee),O(W)&&D++,k(W)&&B++,m(W)&&K++;return(D===0||B===0)&&K===0?J.length<=30:D<=5}function i(J,D){if(!D||(D=D.trim(),D.length===0)||!d(J)||D.length>60)return null;const B=P(D);if(!r(B)){if(!p(B))return null;D=D.toLowerCase()}let W=null,K=0;for(J=J.toLowerCase();K<D.length&&(W=E(J,D,0,K))===null;)K=v(D,K+1);return W}e.matchesCamelCase=i;function c(J,D,B=!1){if(!D||D.length===0)return null;let W=null,K=0;for(J=J.toLowerCase(),D=D.toLowerCase();K<D.length&&(W=t(J,D,0,K,B))===null;)K=h(D,K+1);return W}e.matchesWords=c;function t(J,D,B,W,K){if(B===J.length)return[];if(W===D.length)return null;if(s(J.charCodeAt(B),D.charCodeAt(W))){let ee=null,he=W+1;if(ee=t(J,D,B+1,W+1,K),!K)for(;!ee&&(he=h(D,he))<D.length;)ee=t(J,D,B+1,he,K),he++;return ee?J.charCodeAt(B)!==D.charCodeAt(W)?ee:l({start:W,end:W+1},ee):null}else return null}function h(J,D){for(let B=D;B<J.length;B++)if(f(J.charCodeAt(B))||B>0&&f(J.charCodeAt(B-1)))return B;return J.length}const a=S(e.matchesPrefix,i,I),u=S(e.matchesPrefix,i,A),g=new n.LRUCache(1e4);function R(J,D,B=!1){if(typeof J!="string"||typeof D!="string")return null;let W=g.get(J);W||(W=new RegExp(C.convertSimple2RegExpPattern(J),"i"),g.set(J,W));const K=W.exec(D);return K?[{start:K.index,end:K.index+K[0].length}]:B?u(J,D):a(J,D)}e.matchesFuzzy=R;function F(J,D){const B=Be(J,J.toLowerCase(),0,D,D.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?Z(B):null}e.matchesFuzzy2=F;function q(J,D,B,W,K,ee){const he=Math.min(13,J.length);for(;B<he;B++){const ye=Be(J,D,B,W,K,ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,ee]}e.anyScore=q;function Z(J){if(typeof J>"u")return[];const D=[],B=J[1];for(let W=J.length-1;W>1;W--){const K=J[W]+B,ee=D[D.length-1];ee&&ee.end===K?ee.end=K+1:D.push({start:K,end:K+1})}return D}e.createMatches=Z;const x=128;function N(){const J=[],D=[];for(let B=0;B<=x;B++)D[B]=0;for(let B=0;B<=x;B++)J.push(D.slice(0));return J}function $(J){const D=[];for(let B=0;B<=J;B++)D[B]=0;return D}const T=$(2*x),L=$(2*x),V=N(),j=N(),le=N(),Y=!1;function pe(J,D,B,W,K){function ee(ye,ae,be=" "){for(;ye.length<ae;)ye=be+ye;return ye}let he=` |   |${W.split("").map(ye=>ee(ye,3)).join("|")}
`;for(let ye=0;ye<=B;ye++)ye===0?he+=" |":he+=`${D[ye-1]}|`,he+=J[ye].slice(0,K+1).map(ae=>ee(ae.toString(),3)).join("|")+`
`;return he}function ue(J,D,B,W){J=J.substr(D),B=B.substr(W),console.log(pe(j,J,J.length,B,B.length)),console.log(pe(le,J,J.length,B,B.length)),console.log(pe(V,J,J.length,B,B.length))}function de(J,D){if(D<0||D>=J.length)return!1;const B=J.codePointAt(D);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise(B)}}function re(J,D){if(D<0||D>=J.length)return!1;switch(J.charCodeAt(D)){case 32:case 9:return!0;default:return!1}}function G(J,D,B){return D[J]!==B[J]}function H(J,D,B,W,K,ee,he=!1){for(;D<B&&K<ee;)J[D]===W[K]&&(he&&(T[D]=K),D+=1),K+=1;return D===B}e.isPatternInWord=H;var oe;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(oe||(oe={}));var ve;(function(J){J.Default=[-100,0];function D(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}J.isDefault=D})(ve=e.FuzzyScore||(e.FuzzyScore={}));class Ae{constructor(D,B){this.firstMatchCanBeWeak=D,this.boostFullMatch=B}}e.FuzzyScoreOptions=Ae,Ae.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Be(J,D,B,W,K,ee,he=Ae.default){const ye=J.length>x?x:J.length,ae=W.length>x?x:W.length;if(B>=ye||ee>=ae||ye-B>ae-ee||!H(D,B,ye,K,ee,ae,!0))return;xe(ye,ae,B,ee,D,K);let be=1,Ee=1,We=B,He=ee;const tt=[!1];for(be=1,We=B;We<ye;be++,We++){const Fe=T[We],st=L[We],_=We+1<ye?L[We+1]:ae;for(Ee=Fe-ee+1,He=Fe;He<_;Ee++,He++){let Q=Number.MIN_SAFE_INTEGER,ge=!1;He<=st&&(Q=Te(J,D,We,B,W,K,He,ae,ee,V[be-1][Ee-1]===0,tt));let Le=0;Q!==Number.MAX_SAFE_INTEGER&&(ge=!0,Le=Q+j[be-1][Ee-1]);const $e=He>Fe,je=$e?j[be][Ee-1]+(V[be][Ee-1]>0?-5:0):0,_e=He>Fe+1&&V[be][Ee-1]>0,nt=_e?j[be][Ee-2]+(V[be][Ee-2]>0?-5:0):0;if(_e&&(!$e||nt>=je)&&(!ge||nt>=Le))j[be][Ee]=nt,le[be][Ee]=3,V[be][Ee]=0;else if($e&&(!ge||je>=Le))j[be][Ee]=je,le[be][Ee]=2,V[be][Ee]=0;else if(ge)j[be][Ee]=Le,le[be][Ee]=1,V[be][Ee]=V[be-1][Ee-1]+1;else throw new Error("not possible")}}if(Y&&ue(J,B,W,ee),!tt[0]&&!he.firstMatchCanBeWeak)return;be--,Ee--;const Xe=[j[be][Ee],ee];let et=0,it=0;for(;be>=1;){let Fe=Ee;do{const st=le[be][Fe];if(st===3)Fe=Fe-2;else if(st===2)Fe=Fe-1;else break}while(Fe>=1);et>1&&D[B+be-1]===K[ee+Ee-1]&&!G(Fe+ee-1,W,K)&&et+1>V[be][Fe]&&(Fe=Ee),Fe===Ee?et++:et=1,it||(it=Fe),be--,Ee=Fe-1,Xe.push(Ee)}ae===ye&&he.boostFullMatch&&(Xe[0]+=2);const dt=it-ye;return Xe[0]-=dt,Xe}e.fuzzyScore=Be;function xe(J,D,B,W,K,ee){let he=J-1,ye=D-1;for(;he>=B&&ye>=W;)K[he]===ee[ye]&&(L[he]=ye,he--),ye--}function Te(J,D,B,W,K,ee,he,ye,ae,be,Ee){if(D[B]!==ee[he])return Number.MIN_SAFE_INTEGER;let We=1,He=!1;return he===B-W?We=J[B]===K[he]?7:5:G(he,K,ee)&&(he===0||!G(he-1,K,ee))?(We=J[B]===K[he]?7:5,He=!0):de(ee,he)&&(he===0||!de(ee,he-1))?We=5:(de(ee,he-1)||re(ee,he-1))&&(We=5,He=!0),We>1&&B===W&&(Ee[0]=!0),He||(He=G(he,K,ee)||de(ee,he-1)||re(ee,he-1)),B===W?he>ae&&(We-=He?3:5):be?We+=He?2:0:We+=He?0:1,he+1===ye&&(We-=He?3:5),We}function Se(J,D,B,W,K,ee,he){return se(J,D,B,W,K,ee,!0,he)}e.fuzzyScoreGracefulAggressive=Se;function ke(J,D,B,W,K,ee,he){return se(J,D,B,W,K,ee,!1,he)}e.fuzzyScoreGraceful=ke;function se(J,D,B,W,K,ee,he,ye){let ae=Be(J,D,B,W,K,ee,ye);if(ae&&!he)return ae;if(J.length>=3){const be=Math.min(7,J.length-1);for(let Ee=B+1;Ee<be;Ee++){const We=ce(J,Ee);if(We){const He=Be(We,We.toLowerCase(),B,W,K,ee,ye);He&&(He[0]-=3,(!ae||He[0]>ae[0])&&(ae=He))}}}return ae}function ce(J,D){if(D+1>=J.length)return;const B=J[D],W=J[D+1];if(B!==W)return J.slice(0,D)+W+B+J.slice(D+2)}}),define(Ie[125],Ce([1,0,65,124,10]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",I=new RegExp(`\\$\\(${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${I.source}`,"g");function y(o){return o.replace(A,(l,v)=>v?l:`\\${l}`)}e.escapeIcons=y;const k=new RegExp(`\\\\${I.source}`,"g");function O(o){return o.replace(k,l=>`\\${l}`)}e.markdownEscapeEscapedIcons=O;const w=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function m(o){return o.indexOf(M)===-1?o:o.replace(w,(l,v,E,P)=>E?l:v||P||"")}e.stripIcons=m;const b=new RegExp(`\\$\\(${n.CSSIcon.iconNameCharacter}+\\)`,"g");function f(o){b.lastIndex=0;let l="";const v=[];let E=0;for(;;){const P=b.lastIndex,p=b.exec(o),r=o.substring(P,p?.index);if(r.length>0){l+=r;for(let d=0;d<r.length;d++)v.push(E)}if(!p)break;E+=p[0].length}return{text:l,iconOffsets:v}}e.parseLabelWithIcons=f;function s(o,l,v=!1){const{text:E,iconOffsets:P}=l;if(!P||P.length===0)return(0,C.matchesFuzzy)(o,E,v);const p=(0,S.ltrim)(E," "),r=E.length-p.length,d=(0,C.matchesFuzzy)(o,p,v);if(d)for(const i of d){const c=P[i.start+r]+r;i.start+=c,i.end+=c}return d}e.matchesFuzzyIconAware=s}),define(Ie[30],Ce([1,0,10]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(C||(C={})),function(S){const M="error",I="warning",A="warn",y="info",k="ignore";function O(m){return m?n.equalsIgnoreCase(M,m)?S.Error:n.equalsIgnoreCase(I,m)||n.equalsIgnoreCase(A,m)?S.Warning:n.equalsIgnoreCase(y,m)?S.Info:S.Ignore:S.Ignore}S.fromValue=O;function w(m){switch(m){case S.Error:return M;case S.Warning:return I;case S.Info:return y;default:return k}}S.toString=w}(C||(C={})),e.default=C}),define(Ie[46],Ce([1,0,18,10]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class S{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const f=b.charCodeAt(0),s=this.b.charCodeAt(this.c);return f-s}value(){return this.b[this.c]}}e.StringIterator=S;class M{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,C.compareSubstring)(b,this.b,0,b.length,this.c,this.d):(0,C.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=M;class I{constructor(b=!0,f=!0){this.f=b,this.g=f}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let f=b.length-1;f>=0;f--,this.c--){const s=this.b.charCodeAt(f);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,C.compareSubstring)(b,this.b,0,b.length,this.d,this.e):(0,C.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=I;var A;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(A||(A={}));class y{constructor(b,f){this.f=b,this.g=f,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,C.compareIgnoreCase)(b,this.c.scheme);if(this.d[this.e]===2)return(0,C.compareIgnoreCase)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,C.compare)(b,this.c.query);if(this.d[this.e]===5)return(0,C.compare)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(O||(O={}));class w{static forUris(b=()=>!1,f=()=>!1){return new w(new y(b,f))}static forPaths(b=!1){return new w(new I(void 0,!b))}static forStrings(){return new w(new S)}static forConfigKeys(){return new w(new M)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,f){if(f){const s=f.slice(0);(0,n.shuffle)(s);for(const o of s)this.set(o,b)}else{const s=b.slice(0);(0,n.shuffle)(s);for(const o of s)this.set(o[0],o[1])}}set(b,f){const s=this.b.reset(b);let o;this.c||(this.c=new k,this.c.segment=s.value());const l=[];for(o=this.c;;){const E=s.cmp(o.segment);if(E>0)o.left||(o.left=new k,o.left.segment=s.value()),l.push([-1,o]),o=o.left;else if(E<0)o.right||(o.right=new k,o.right.segment=s.value()),l.push([1,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new k,o.mid.segment=s.value()),l.push([0,o]),o=o.mid;else break}const v=o.value;o.value=f,o.key=b;for(let E=l.length-1;E>=0;E--){const P=l[E][1];P.updateHeight();const p=P.balanceFactor();if(p<-1||p>1){const r=l[E][0],d=l[E+1][0];if(r===1&&d===1)l[E][1]=P.rotateLeft();else if(r===-1&&d===-1)l[E][1]=P.rotateRight();else if(r===1&&d===-1)P.right=l[E+1][1]=l[E+1][1].rotateRight(),l[E][1]=P.rotateLeft();else if(r===-1&&d===1)P.left=l[E+1][1]=l[E+1][1].rotateLeft(),l[E][1]=P.rotateRight();else throw new Error;if(E>0)switch(l[E-1][0]){case-1:l[E-1][1].left=l[E][1];break;case 1:l[E-1][1].right=l[E][1];break;case 0:l[E-1][1].mid=l[E][1];break}else this.c=l[0][1]}}return v}get(b){return this.d(b)?.value}d(b){const f=this.b.reset(b);let s=this.c;for(;s;){const o=f.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(f.hasNext())f.next(),s=s.mid;else break}return s}has(b){const f=this.d(b);return!(f?.value===void 0&&f?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,f){const s=this.b.reset(b),o=[];let l=this.c;for(;l;){const v=s.cmp(l.segment);if(v>0)o.push([-1,l]),l=l.left;else if(v<0)o.push([1,l]),l=l.right;else if(s.hasNext())s.next(),o.push([0,l]),l=l.mid;else break}if(!!l){if(f?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const v=this.f(l.right);if(v.key){const{key:E,value:P,segment:p}=v;this.e(v.key,!1),l.key=E,l.value=P,l.segment=p}}else{const v=l.left??l.right;if(o.length>0){const[E,P]=o[o.length-1];switch(E){case-1:P.left=v;break;case 0:P.mid=v;break;case 1:P.right=v;break}}else this.c=v}for(let v=o.length-1;v>=0;v--){const E=o[v][1];E.updateHeight();const P=E.balanceFactor();if(P>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),o[v][1]=E.rotateLeft()):P<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),o[v][1]=E.rotateRight()),v>0)switch(o[v-1][0]){case-1:o[v-1][1].left=o[v][1];break;case 1:o[v-1][1].right=o[v][1];break;case 0:o[v-1][1].mid=o[v][1];break}else this.c=o[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const f=this.b.reset(b);let s=this.c,o;for(;s;){const l=f.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(f.hasNext())f.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(b){return this.g(b,!1)}g(b,f){const s=this.b.reset(b);let o=this.c;for(;o;){const l=s.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this.h(o.mid):f?o.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[f,s]of this)b(s,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const f=[];return this.j(b,f),f[Symbol.iterator]()}j(b,f){!b||(b.left&&this.j(b.left,f),b.value&&f.push([b.key,b.value]),b.mid&&this.j(b.mid,f),b.right&&this.j(b.right,f))}_isBalanced(){const b=f=>{if(!f)return!0;const s=f.balanceFactor();return s<-1||s>1?!1:b(f.left)&&b(f.right)};return b(this.c)}}e.TernarySearchTree=w}),define(Ie[85],Ce([1,0,24,10,2]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(k){return JSON.stringify(k,A)}e.stringify=M;function I(k){let O=JSON.parse(k);return O=y(O),O}e.parse=I;function A(k,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,C.regExpFlags)(O)}:O}function y(k,O=0){if(!k||O>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return S.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof n.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let w=0;w<k.length;++w)k[w]=y(k[w],O+1);else for(const w in k)Object.hasOwnProperty.call(k,w)&&(k[w]=y(k[w],O+1))}return k}e.revive=y}),define(Ie[15],Ce([1,0,11,20,2]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.vscodeUserData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls",k.vscodeSourceControl="vscode-scm"})(M=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(O){this.d=O}setDelegate(O){this.e=O}setServerRootPath(O){this.f=`${O}/${M.vscodeRemoteResource}`}set(O,w,m){this.a[O]=w,this.b[O]=m}setConnectionToken(O,w){this.c[O]=w}getPreferredWebSchema(){return this.d}rewrite(O){if(this.e)try{return this.e(O)}catch(o){return n.onUnexpectedError(o),O}const w=O.authority;let m=this.a[w];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const b=this.b[w],f=this.c[w];let s=`path=${encodeURIComponent(O.path)}`;return typeof f=="string"&&(s+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),S.URI.from({scheme:C.isWeb?this.d:M.vscodeRemoteResource,authority:`${m}:${b}`,path:this.f,query:s})}}e.RemoteAuthorities=new I,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(O){const w=this.b(O,te);return this.uriToBrowserUri(w)}uriToBrowserUri(O){return O.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===M.file&&(C.isNative||C.isWebWorker&&C.globals.origin===`${M.vscodeFileResource}://${A.a}`)?O.with({scheme:M.vscodeFileResource,authority:O.authority||A.a,query:null,fragment:null}):O}asFileUri(O){const w=this.b(O,te);return this.uriToFileUri(w)}uriToFileUri(O){return O.scheme===M.vscodeFileResource?O.with({scheme:M.file,authority:O.authority!==A.a?O.authority:null,query:null,fragment:null}):O}b(O,w){return S.URI.isUri(O)?O:S.URI.parse(w.toUrl(O))}}A.a="vscode-app",e.FileAccess=new A;var y;(function(k){const O=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);k.CoopAndCoep=Object.freeze(O.get("3"));const w="vscode-coi";function m(f){let s;typeof f=="string"?s=new URL(f).searchParams:f instanceof URL?s=f.searchParams:S.URI.isUri(f)&&(s=new URL(f.toString(!0)).searchParams);const o=s?.get(w);if(!!o)return O.get(o)}k.getHeadersFromQuery=m;function b(f,s,o){if(!globalThis.crossOriginIsolated)return;const l=s&&o?"3":o?"2":"1";f instanceof URLSearchParams?f.set(w,l):f[w]=l}k.addSearchParam=b})(y=e.COI||(e.COI={}))}),define(Ie[23],Ce([1,0,40,15,19,20,10,2]),function(te,e,n,C,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(b){return(0,A.uriToFsPath)(b,!0)}e.originalFSPath=y;class k{constructor(f){this.a=f}compare(f,s,o=!1){return f===s?0:(0,I.compare)(this.getComparisonKey(f,o),this.getComparisonKey(s,o))}isEqual(f,s,o=!1){return f===s?!0:!f||!s?!1:this.getComparisonKey(f,o)===this.getComparisonKey(s,o)}getComparisonKey(f,s=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,s,o=!1){if(f.scheme===s.scheme){if(f.scheme===C.Schemas.file)return n.isEqualOrParent(y(f),y(s),this.a(f))&&f.query===s.query&&(o||f.fragment===s.fragment);if((0,e.isEqualAuthority)(f.authority,s.authority))return n.isEqualOrParent(f.path,s.path,this.a(f),"/")&&f.query===s.query&&(o||f.fragment===s.fragment)}return!1}joinPath(f,...s){return A.URI.joinPath(f,...s)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return S.posix.basename(f.path)}extname(f){return S.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let s;return f.scheme===C.Schemas.file?s=A.URI.file(S.dirname(y(f))).path:(s=S.posix.dirname(f.path),f.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),s="/")),f.with({path:s})}normalizePath(f){if(!f.path.length)return f;let s;return f.scheme===C.Schemas.file?s=A.URI.file(S.normalize(y(f))).path:s=S.posix.normalize(f.path),f.with({path:s})}relativePath(f,s){if(f.scheme!==s.scheme||!(0,e.isEqualAuthority)(f.authority,s.authority))return;if(f.scheme===C.Schemas.file){const v=S.relative(y(f),y(s));return M.isWindows?n.toSlashes(v):v}let o=f.path||"/";const l=s.path||"/";if(this.a(f)){let v=0;for(const E=Math.min(o.length,l.length);v<E&&!(o.charCodeAt(v)!==l.charCodeAt(v)&&o.charAt(v).toLowerCase()!==l.charAt(v).toLowerCase());v++);o=l.substr(0,v)+o.substr(v)}return S.posix.relative(o,l)}resolvePath(f,s){if(f.scheme===C.Schemas.file){const o=A.URI.file(S.resolve(y(f),s));return f.with({authority:o.authority,path:o.path})}return s=n.toPosixPath(s),f.with({path:S.posix.resolve(f.path,s)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,s){return f===s||f!==void 0&&s!==void 0&&(0,I.equalsIgnoreCase)(f,s)}hasTrailingPathSeparator(f,s=S.sep){if(f.scheme===C.Schemas.file){const o=y(f);return o.length>n.getRoot(o).length&&o[o.length-1]===s}else{const o=f.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,s=S.sep){return(0,e.hasTrailingPathSeparator)(f,s)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,s=S.sep){let o=!1;if(f.scheme===C.Schemas.file){const l=y(f);o=l!==void 0&&l.length===n.getRoot(l).length&&l[l.length-1]===s}else{s="/";const l=f.path;o=l.length===1&&l.charCodeAt(l.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(f,s)?f.with({path:f.path+"/"}):f}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(b=>b.scheme===C.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new k(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(b,f){const s=[];for(let o=0;o<b.length;o++){const l=f(b[o]);b.some((v,E)=>E===o?!1:(0,e.isEqualOrParent)(l,f(v)))||s.push(b[o])}return s}e.distinctParents=O;var w;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function f(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(E=>{const[P,p]=E.split(":");P&&p&&o.set(P,p)});const v=s.path.substring(0,s.path.indexOf(";"));return v&&o.set(b.META_DATA_MIME,v),o}b.parseMetaData=f})(w=e.DataUri||(e.DataUri={}));function m(b,f,s){if(f){let o=b.path;return o&&o[0]!==S.posix.sep&&(o=S.posix.sep+o),b.with({scheme:s,authority:f,path:o})}return b.with({scheme:s})}e.toLocalResource=m}),define(Ie[16],Ce([1,0,21,11,4,6,23,20]),function(te,e,n,C,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(G){return!!G&&typeof G.then=="function"}e.isThenable=y;function k(G){const H=new n.CancellationTokenSource,oe=G(H.token),ve=new Promise((Ae,Be)=>{const xe=H.token.onCancellationRequested(()=>{xe.dispose(),H.dispose(),Be(new C.CancellationError)});Promise.resolve(oe).then(Te=>{xe.dispose(),H.dispose(),Ae(Te)},Te=>{xe.dispose(),H.dispose(),Be(Te)})});return new class{cancel(){H.cancel()}then(Ae,Be){return ve.then(Ae,Be)}catch(Ae){return this.then(void 0,Ae)}finally(Ae){return ve.finally(Ae)}}}e.createCancelablePromise=k;function O(G,H,oe){return new Promise((ve,Ae)=>{const Be=H.onCancellationRequested(()=>{Be.dispose(),ve(oe)});G.then(ve,Ae).finally(()=>Be.dispose())})}e.raceCancellation=O;function w(G,H){return new Promise((oe,ve)=>{const Ae=H.onCancellationRequested(()=>{Ae.dispose(),ve(new C.CancellationError)});G.then(oe,ve).finally(()=>Ae.dispose())})}e.raceCancellationError=w;async function m(G){let H=-1;const oe=G.map((Ae,Be)=>Ae.then(xe=>(H=Be,xe))),ve=await Promise.race(oe);return G.forEach((Ae,Be)=>{Be!==H&&Ae.cancel()}),ve}e.raceCancellablePromises=m;function b(G,H,oe){let ve;const Ae=setTimeout(()=>{ve?.(void 0),oe?.()},H);return Promise.race([G.finally(()=>clearTimeout(Ae)),new Promise(Be=>ve=Be)])}e.raceTimeout=b;function f(G){return new Promise((H,oe)=>{const ve=G();y(ve)?ve.then(H,oe):H(ve)})}e.asPromise=f;class s{constructor(){this.a=null,this.b=null,this.d=null}queue(H){if(this.a){if(this.d=H,!this.b){const oe=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(oe,oe).then(ve)})}return new Promise((oe,ve)=>{this.b.then(oe,ve)})}return this.a=H(),new Promise((oe,ve)=>{this.a.then(Ae=>{this.a=null,oe(Ae)},Ae=>{this.a=null,ve(Ae)})})}}e.Throttler=s;class o{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.Sequencer=o;class l{constructor(){this.a=new Map}queue(H,oe){const Ae=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.a.get(H)===Ae&&this.a.delete(H)});return this.a.set(H,Ae),Ae}}e.SequencerByKey=l;const v=(G,H)=>{let oe=!0;const ve=setTimeout(()=>{oe=!1,H()},G);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(ve),oe=!1}}},E=G=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,G())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class P{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,oe=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((Ae,Be)=>{this.d=Ae,this.f=Be}).then(()=>{if(this.b=null,this.d=null,this.g){const Ae=this.g;return this.g=null,Ae()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=oe===e.MicrotaskDelay?E(ve):v(oe,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=P;class p{constructor(H){this.a=new P(H),this.b=new s}trigger(H,oe){return this.a.trigger(()=>this.b.queue(H),oe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=p;class r{constructor(){this.a=!1,this.b=new Promise((H,oe)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=r;class d extends r{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=d;function i(G,H){return H?new Promise((oe,ve)=>{const Ae=setTimeout(()=>{Be.dispose(),oe()},G),Be=H.onCancellationRequested(()=>{clearTimeout(Ae),Be.dispose(),ve(new C.CancellationError)})}):k(oe=>i(G,oe))}e.timeout=i;function c(G,H=0){const oe=setTimeout(G,H);return(0,M.toDisposable)(()=>clearTimeout(oe))}e.disposableTimeout=c;function t(G){const H=[];let oe=0;const ve=G.length;function Ae(){return oe<ve?G[oe++]():null}function Be(xe){xe!=null&&H.push(xe);const Te=Ae();return Te?Te.then(Be):Promise.resolve(H)}return Promise.resolve(null).then(Be)}e.sequence=t;function h(G,H=ve=>!!ve,oe=null){let ve=0;const Ae=G.length,Be=()=>{if(ve>=Ae)return Promise.resolve(oe);const xe=G[ve++];return Promise.resolve(xe()).then(Se=>H(Se)?Promise.resolve(Se):Be())};return Be()}e.first=h;function a(G,H=ve=>!!ve,oe=null){if(G.length===0)return Promise.resolve(oe);let ve=G.length;const Ae=()=>{ve=-1;for(const Be of G)Be.cancel?.()};return new Promise((Be,xe)=>{for(const Te of G)Te.then(Se=>{--ve>=0&&H(Se)?(Ae(),Be(Se)):ve===0&&Be(oe)}).catch(Se=>{--ve>=0&&(Ae(),xe(Se))})})}e.firstParallel=a;class u{constructor(H){this.a=0,this.d=H,this.f=[],this.b=0,this.g=new S.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(H){return this.a++,new Promise((oe,ve)=>{this.f.push({factory:H,c:oe,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const H=this.f.shift();this.b++;const oe=H.factory();oe.then(H.c,H.e),oe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=u;class g extends u{constructor(){super(1)}}e.Queue=g;class R{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const H=new le;return this.b.add(H),H.p}d(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueFor(H,oe=I.extUri){const ve=oe.getComparisonKey(H);let Ae=this.a.get(ve);return Ae||(Ae=new g,S.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,Ae)),Ae}f(){!this.d()||this.g()}g(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.g()}}e.ResourceQueue=R;class F{constructor(H,oe){this.a=-1,typeof H=="function"&&typeof oe=="number"&&this.setIfNotSet(H,oe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,oe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},oe)}setIfNotSet(H,oe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},oe))}}e.TimeoutTimer=F;class q{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(H,oe){this.cancel(),this.a=setInterval(()=>{H()},oe)}}e.IntervalTimer=q;class Z{constructor(H,oe){this.b=-1,this.a=H,this.d=oe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=Z;class x{constructor(H,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.a=H,this.b=oe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=x;class N extends Z{constructor(H,oe){super(H,oe),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=N;class $ extends M.Disposable{constructor(H,oe){super(),this.g=H,this.h=oe,this.a=[],this.b=this.B(new M.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const oe of H)this.a.push(oe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=G=>{(0,A.setTimeout0)(()=>{if(H)return;const oe=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,oe-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.runWhenIdle=(G,H)=>{const oe=requestIdleCallback(G,typeof H=="number"?{timeout:H}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(oe))}}}}();class T{constructor(H){this.d=!1,this.a=()=>{try{this.f=H()}catch(oe){this.g=oe}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=T;async function L(G,H,oe){let ve;for(let Ae=0;Ae<oe;Ae++)try{return await G()}catch(Be){ve=Be,await i(H)}throw ve}e.retry=L;class V{hasPending(H){return this.a?typeof H=="number"?this.a.taskId===H:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(H,oe,ve){return this.a={taskId:H,cancel:()=>ve?.(),promise:oe},oe.then(()=>this.d(H),()=>this.d(H)),oe}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}setNext(H){if(this.b)this.b.run=H;else{let oe,ve;const Ae=new Promise((Be,xe)=>{oe=Be,ve=xe});this.b={run:H,promise:Ae,promiseResolve:oe,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=V;class j{constructor(H,oe=()=>Date.now()){this.d=H,this.f=oe,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.IntervalCounter=j;class le{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((H,oe)=>{this.a=H,this.b=oe})}complete(H){return new Promise(oe=>{this.a(H),this.f=!0,oe()})}error(H){return new Promise(oe=>{this.b(H),this.d=!0,oe()})}cancel(){new Promise(H=>{this.b(new C.CancellationError),this.d=!0,H()})}}e.DeferredPromise=le;var Y;(function(G){async function H(ve){let Ae;const Be=await Promise.all(ve.map(xe=>xe.then(Te=>Te,Te=>{Ae||(Ae=Te)})));if(typeof Ae<"u")throw Ae;return Be}G.settled=H;function oe(ve){return new Promise(async(Ae,Be)=>{try{await ve(Ae,Be)}catch(xe){Be(xe)}})}G.withAsyncBody=oe})(Y=e.Promises||(e.Promises={}));var pe;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(pe||(pe={}));class ue{static fromArray(H){return new ue(oe=>{oe.emitMany(H)})}static fromPromise(H){return new ue(async oe=>{oe.emitMany(await H)})}static fromPromises(H){return new ue(async oe=>{await Promise.all(H.map(async ve=>oe.emitOne(await ve)))})}static merge(H){return new ue(async oe=>{await Promise.all(H.map(async ve=>{for await(const Ae of ve)oe.emitOne(Ae)}))})}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new S.Emitter,queueMicrotask(async()=>{const oe={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(H(oe)),this.j()}catch(ve){this.k(ve)}finally{oe.emitOne=void 0,oe.emitMany=void 0,oe.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await S.Event.toPromise(this.f.event)}while(!0)}}}static map(H,oe){return new ue(async ve=>{for await(const Ae of H)ve.emitOne(oe(Ae))})}map(H){return ue.map(this,H)}static filter(H,oe){return new ue(async ve=>{for await(const Ae of H)oe(Ae)&&ve.emitOne(Ae)})}filter(H){return ue.filter(this,H)}static coalesce(H){return ue.filter(H,oe=>!!oe)}coalesce(){return ue.coalesce(this)}static async toPromise(H){const oe=[];for await(const ve of H)oe.push(ve);return oe}toPromise(){return ue.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class de extends ue{constructor(H,oe){super(oe),this.l=H}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=de;function re(G){const H=new n.CancellationTokenSource,oe=G(H.token);return new de(H,async ve=>{const Ae=H.token.onCancellationRequested(()=>{Ae.dispose(),H.dispose(),ve.reject(new C.CancellationError)});try{for await(const Be of oe){if(H.token.isCancellationRequested)return;ve.emitOne(Be)}Ae.dispose(),H.dispose()}catch(Be){Ae.dispose(),H.dispose(),ve.reject(Be)}})}e.createCancelableAsyncIterable=re}),define(Ie[35],Ce([1,0,18,16,40,28,19,20,10]),function(te,e,n,C,S,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",w="[^/\\\\]",m=/\//g;function b(le,Y){switch(le){case 0:return"";case 1:return`${w}*?`;default:return`(?:${O}|${w}+${O}${Y?`|${O}${w}+`:""})*?`}}function f(le,Y){if(!le)return[];const pe=[];let ue=!1,de=!1,re="";for(const G of le){switch(G){case Y:if(!ue&&!de){pe.push(re),re="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":de=!0;break;case"]":de=!1;break}re+=G}return re&&pe.push(re),pe}e.splitGlobAware=f;function s(le){if(!le)return"";let Y="";const pe=f(le,e.GLOB_SPLIT);if(pe.every(ue=>ue===e.GLOBSTAR))Y=".*";else{let ue=!1;pe.forEach((de,re)=>{if(de===e.GLOBSTAR){if(ue)return;Y+=b(2,re===pe.length-1)}else{let G=!1,H="",oe=!1,ve="";for(const Ae of de){if(Ae!=="}"&&G){H+=Ae;continue}if(oe&&(Ae!=="]"||!ve)){let Be;Ae==="-"?Be=Ae:(Ae==="^"||Ae==="!")&&!ve?Be="^":Ae===e.GLOB_SPLIT?Be="":Be=(0,y.escapeRegExpCharacters)(Ae),ve+=Be;continue}switch(Ae){case"{":G=!0;continue;case"[":oe=!0;continue;case"}":{Y+=`(?:${f(H,",").map(Te=>s(Te)).join("|")})`,G=!1,H="";break}case"]":{Y+="["+ve+"]",oe=!1,ve="";break}case"?":Y+=w;continue;case"*":Y+=b(1);continue;default:Y+=(0,y.escapeRegExpCharacters)(Ae)}}re<pe.length-1&&(pe[re+1]!==e.GLOBSTAR||re+2<pe.length)&&(Y+=O)}ue=de===e.GLOBSTAR})}return Y}const o=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,P=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new M.LRUCache(1e4),d=function(){return!1},i=function(){return null};function c(le,Y){if(!le)return i;let pe;typeof le!="string"?pe=le.pattern:pe=le,pe=pe.trim();const ue=`${pe}_${!!Y.trimForExclusions}`;let de=r.get(ue);if(de)return t(de,le);let re;return o.test(pe)?de=a(pe.substr(4),pe):(re=l.exec(h(pe,Y)))?de=u(re[1],pe):(Y.trimForExclusions?E:v).test(pe)?de=g(pe,Y):(re=P.exec(h(pe,Y)))?de=R(re[1].substr(1),pe,!0):(re=p.exec(h(pe,Y)))?de=R(re[1],pe,!1):de=F(pe),r.set(ue,de),t(de,le)}function t(le,Y){if(typeof Y=="string")return le;const pe=function(ue,de){return(0,S.isEqualOrParent)(ue,Y.base,!A.isLinux)?le((0,y.ltrim)(ue.substr(Y.base.length),I.sep),de):null};return pe.allBasenames=le.allBasenames,pe.allPaths=le.allPaths,pe.basenames=le.basenames,pe.patterns=le.patterns,pe}function h(le,Y){return Y.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function a(le,Y){return function(pe,ue){return typeof pe=="string"&&pe.endsWith(le)?Y:null}}function u(le,Y){const pe=`/${le}`,ue=`\\${le}`,de=function(G,H){return typeof G!="string"?null:H?H===le?Y:null:G===le||G.endsWith(pe)||G.endsWith(ue)?Y:null},re=[le];return de.basenames=re,de.patterns=[Y],de.allBasenames=re,de}function g(le,Y){const pe=V(le.slice(1,-1).split(",").map(H=>c(H,Y)).filter(H=>H!==i),le),ue=pe.length;if(!ue)return i;if(ue===1)return pe[0];const de=function(H,oe){for(let ve=0,Ae=pe.length;ve<Ae;ve++)if(pe[ve](H,oe))return le;return null},re=pe.find(H=>!!H.allBasenames);re&&(de.allBasenames=re.allBasenames);const G=pe.reduce((H,oe)=>oe.allPaths?H.concat(oe.allPaths):H,[]);return G.length&&(de.allPaths=G),de}function R(le,Y,pe){const ue=I.sep===I.posix.sep,de=ue?le:le.replace(m,I.sep),re=I.sep+de,G=I.posix.sep+le;let H;return pe?H=function(oe,ve){return typeof oe=="string"&&(oe===de||oe.endsWith(re)||!ue&&(oe===le||oe.endsWith(G)))?Y:null}:H=function(oe,ve){return typeof oe=="string"&&(oe===de||!ue&&oe===le)?Y:null},H.allPaths=[(pe?"*/":"./")+le],H}function F(le){try{const Y=new RegExp(`^${s(le)}$`);return function(pe){return Y.lastIndex=0,typeof pe=="string"&&Y.test(pe)?le:null}}catch{return i}}function q(le,Y,pe){return!le||typeof Y!="string"?!1:Z(le)(Y,void 0,pe)}e.match=q;function Z(le,Y={}){if(!le)return d;if(typeof le=="string"||x(le)){const pe=c(le,Y);if(pe===i)return d;const ue=function(de,re){return!!pe(de,re)};return pe.allBasenames&&(ue.allBasenames=pe.allBasenames),pe.allPaths&&(ue.allPaths=pe.allPaths),ue}return T(le,Y)}e.parse=Z;function x(le){const Y=le;return Y?typeof Y.base=="string"&&typeof Y.pattern=="string":!1}e.isRelativePattern=x;function N(le){return le.allBasenames||[]}e.getBasenameTerms=N;function $(le){return le.allPaths||[]}e.getPathTerms=$;function T(le,Y){const pe=V(Object.getOwnPropertyNames(le).map(H=>L(H,le[H],Y)).filter(H=>H!==i)),ue=pe.length;if(!ue)return i;if(!pe.some(H=>!!H.requiresSiblings)){if(ue===1)return pe[0];const H=function(Ae,Be){let xe;for(let Te=0,Se=pe.length;Te<Se;Te++){const ke=pe[Te](Ae,Be);if(typeof ke=="string")return ke;(0,C.isThenable)(ke)&&(xe||(xe=[]),xe.push(ke))}return xe?(async()=>{for(const Te of xe){const Se=await Te;if(typeof Se=="string")return Se}return null})():null},oe=pe.find(Ae=>!!Ae.allBasenames);oe&&(H.allBasenames=oe.allBasenames);const ve=pe.reduce((Ae,Be)=>Be.allPaths?Ae.concat(Be.allPaths):Ae,[]);return ve.length&&(H.allPaths=ve),H}const de=function(H,oe,ve){let Ae,Be;for(let xe=0,Te=pe.length;xe<Te;xe++){const Se=pe[xe];Se.requiresSiblings&&ve&&(oe||(oe=(0,I.basename)(H)),Ae||(Ae=oe.substr(0,oe.length-(0,I.extname)(H).length)));const ke=Se(H,oe,Ae,ve);if(typeof ke=="string")return ke;(0,C.isThenable)(ke)&&(Be||(Be=[]),Be.push(ke))}return Be?(async()=>{for(const xe of Be){const Te=await xe;if(typeof Te=="string")return Te}return null})():null},re=pe.find(H=>!!H.allBasenames);re&&(de.allBasenames=re.allBasenames);const G=pe.reduce((H,oe)=>oe.allPaths?H.concat(oe.allPaths):H,[]);return G.length&&(de.allPaths=G),de}function L(le,Y,pe){if(Y===!1)return i;const ue=c(le,pe);if(ue===i)return i;if(typeof Y=="boolean")return ue;if(Y){const de=Y.when;if(typeof de=="string"){const re=(G,H,oe,ve)=>{if(!ve||!ue(G,H))return null;const Ae=de.replace("$(basename)",()=>oe),Be=ve(Ae);return(0,C.isThenable)(Be)?Be.then(xe=>xe?le:null):Be?le:null};return re.requiresSiblings=!0,re}}return ue}function V(le,Y){const pe=le.filter(H=>!!H.basenames);if(pe.length<2)return le;const ue=pe.reduce((H,oe)=>{const ve=oe.basenames;return ve?H.concat(ve):H},[]);let de;if(Y){de=[];for(let H=0,oe=ue.length;H<oe;H++)de.push(Y)}else de=pe.reduce((H,oe)=>{const ve=oe.patterns;return ve?H.concat(ve):H},[]);const re=function(H,oe){if(typeof H!="string")return null;if(!oe){let Ae;for(Ae=H.length;Ae>0;Ae--){const Be=H.charCodeAt(Ae-1);if(Be===47||Be===92)break}oe=H.substr(Ae)}const ve=ue.indexOf(oe);return ve!==-1?de[ve]:null};re.basenames=ue,re.patterns=de,re.allBasenames=ue;const G=le.filter(H=>!H.basenames);return G.push(re),G}function j(le,Y){return(0,n.equals)(le,Y,(pe,ue)=>typeof pe=="string"&&typeof ue=="string"?pe===ue:typeof pe!="string"&&typeof ue!="string"?pe.base===ue.base&&pe.pattern===ue.pattern:!1)}e.patternsEquals=j}),define(Ie[86],Ce([1,0,11,125,23,10,2]),function(te,e,n,C,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(l="",v=!1){if(this.value=l,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(l,v=0){return this.value+=m(this.supportThemeIcons?(0,C.escapeIcons)(l):l).replace(/([ \t]+)/g,(E,P)=>"&nbsp;".repeat(P.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,v){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(l,v,E){return this.value+="[",this.value+=this.c(v,"]"),this.value+="](",this.value+=this.c(String(l),")"),E&&(this.value+=` "${this.c(this.c(E,'"'),")")}"`),this.value+=")",this}c(l,v){const E=new RegExp((0,M.escapeRegExpCharacters)(v),"g");return l.replace(E,(P,p)=>l.charAt(p-1)!=="\\"?`\\${P}`:P)}}e.MarkdownString=y;function k(o){return O(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.isEmptyMarkdownString=k;function O(o){return o instanceof y?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function w(o,l){return o===l?!0:!o||!l?!1:o.value===l.value&&o.isTrusted===l.isTrusted&&o.supportThemeIcons===l.supportThemeIcons&&o.supportHtml===l.supportHtml&&(o.baseUri===l.baseUri||!!o.baseUri&&!!l.baseUri&&(0,S.isEqual)(I.URI.from(o.baseUri),I.URI.from(l.baseUri)))}e.markdownStringEqual=w;function m(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function b(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=b;function f(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=f;function s(o){const l=[],v=o.split("|").map(P=>P.trim());o=v[0];const E=v[1];if(E){const P=/height=(\d+)/.exec(E),p=/width=(\d+)/.exec(E),r=P?P[1]:"",d=p?p[1]:"",i=isFinite(parseInt(d)),c=isFinite(parseInt(r));i&&l.push(`width="${d}"`),c&&l.push(`height="${r}"`)}return{href:o,dimensions:l}}e.parseHrefAndDimensions=s}),define(Ie[87],Ce([1,0,18,40,19,20,23,10]),function(te,e,n,C,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(i,c){const{os:t,tildify:h,relative:a}=c;if(a){const R=k(i,a,t);if(typeof R=="string")return R}let u=i.fsPath;if(t===1&&!M.isWindows?u=u.replace(/\//g,"\\"):t!==1&&M.isWindows&&(u=u.replace(/\\/g,"/")),t!==1&&h?.userHome){const R=h.userHome.fsPath;let F;i.scheme!==h.userHome.scheme&&i.path.startsWith(S.posix.sep)?F=h.userHome.with({path:i.path}).fsPath:F=i.fsPath,u=m(F,R,t)}return(t===1?S.win32:S.posix).normalize(O(u,t===1))}e.getPathLabel=y;function k(i,c,t){const h=t===1?S.win32:S.posix,a=t===3?I.extUri:I.extUriIgnorePathCase,u=c.getWorkspace(),g=(0,n.firstOrDefault)(u.folders);if(!g)return;i.scheme!==g.uri.scheme&&i.path.startsWith(S.posix.sep)&&(i=g.uri.with({path:i.path}));const R=c.getWorkspaceFolder(i);if(!R)return;let F;if(a.isEqual(R.uri,i)?F="":F=a.relativePath(R.uri,i)??"",F&&(F=h.normalize(F)),u.folders.length>1&&!c.noPrefix){const q=R.name?R.name:a.basenameOrAuthority(R.uri);F=F?`${q} \u2022 ${F}`:q}return F}function O(i,c=M.isWindows){return(0,C.hasDriveLetter)(i,c)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=O;let w=Object.create(null);function m(i,c,t=M.OS){if(t===1||!i||!c)return i;let h=w.original===c?w.normalized:void 0;h||(h=c,M.isWindows&&(h=(0,C.toSlashes)(h)),h=`${(0,A.rtrim)(h,S.posix.sep)}${S.posix.sep}`,w={original:c,normalized:h});let a=i;return M.isWindows&&(a=(0,C.toSlashes)(a)),(t===3?a.startsWith(h):(0,A.startsWithIgnoreCase)(a,h))?`~/${a.substr(h.length)}`:i}e.tildify=m;function b(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=b;const f="\u2026",s="\\\\",o="~";function l(i,c=S.sep){const t=new Array(i.length);let h=!1;for(let a=0;a<i.length;a++){const u=i[a];if(u===""){t[a]=`.${c}`;continue}if(!u){t[a]=u;continue}h=!0;let g="",R=u;R.indexOf(s)===0?(g=R.substr(0,R.indexOf(s)+s.length),R=R.substr(R.indexOf(s)+s.length)):R.indexOf(c)===0?(g=R.substr(0,R.indexOf(c)+c.length),R=R.substr(R.indexOf(c)+c.length)):R.indexOf(o)===0&&(g=R.substr(0,R.indexOf(o)+o.length),R=R.substr(R.indexOf(o)+o.length));const F=R.split(c);for(let q=1;h&&q<=F.length;q++)for(let Z=F.length-q;h&&Z>=0;Z--){h=!1;let x=F.slice(Z,Z+q).join(c);for(let N=0;!h&&N<i.length;N++)if(N!==a&&i[N]&&i[N].indexOf(x)>-1){const $=Z+q===F.length,T=Z>0&&i[N].indexOf(c)>-1?c+x:x,L=i[N].endsWith(T);h=!$||L}if(!h){let N="";(F[0].endsWith(":")||g!=="")&&(Z===1&&(Z=0,q++,x=F[0]+c+x),Z>0&&(N=F[0]+c),N=g+N),Z>0&&(N=N+f+c),N=N+x,Z+q<F.length&&(N=N+c+f),t[a]=N}}h&&(t[a]=u)}return t}e.shorten=l;var v;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function E(i,c=Object.create(null)){const t=[];let h=!1,a="";for(const u of i)if(u==="$"||h&&u==="{")a&&t.push({value:a,type:v.TEXT}),a="",h=!0;else if(u==="}"&&h){const g=c[a];if(typeof g=="string")g.length&&t.push({value:g,type:v.VARIABLE});else if(g){const R=t[t.length-1];(!R||R.type!==v.SEPARATOR)&&t.push({value:g.label,type:v.SEPARATOR})}a="",h=!1}else a+=u;return a&&!h&&t.push({value:a,type:v.TEXT}),t.filter((u,g)=>{if(u.type===v.SEPARATOR){const R=t[g-1],F=t[g+1];return[R,F].every(q=>q&&(q.type===v.VARIABLE||q.type===v.TEXT)&&q.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=E;function P(i,c){return M.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):i.replace(/&&|&/g,t=>t==="&"?"&&":"&")}e.mnemonicMenuLabel=P;function p(i,c){return M.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,""):M.isWindows?i.replace(/&&|&/g,t=>t==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function d(i){const c=i.indexOf("/")!==-1?S.posix:S.win32,t=c.basename(i),h=c.dirname(i);return t.length?{name:t,parentPath:h}:{name:h,parentPath:""}}e.splitName=d}),define(Ie[126],Ce([1,0,2]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(O){return O.toJSON()}class S{constructor(w){this.a=w}transformIncoming(w){const m=this.a.transformIncoming(w);return m===w?w:C(n.URI.from(m))}transformOutgoing(w){const m=this.a.transformOutgoing(w);return m===w?w:C(n.URI.from(m))}transformOutgoingURI(w){const m=this.a.transformOutgoing(w);return m===w?w:n.URI.from(m)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function M(O,w,m){if(!O||m>200)return null;if(typeof O=="object"){if(O instanceof n.URI)return w.transformOutgoing(O);for(const b in O)if(Object.hasOwnProperty.call(O,b)){const f=M(O[b],w,m+1);f!==null&&(O[b]=f)}}return null}function I(O,w){const m=M(O,w,0);return m===null?O:m}e.transformOutgoingURIs=I;function A(O,w,m,b){if(!O||b>200)return null;if(typeof O=="object"){if(O.$mid===1)return m?n.URI.revive(w.transformIncoming(O)):w.transformIncoming(O);for(const f in O)if(Object.hasOwnProperty.call(O,f)){const s=A(O[f],w,m,b+1);s!==null&&(O[f]=s)}}return null}function y(O,w){const m=A(O,w,!1,0);return m===null?O:m}e.transformIncomingURIs=y;function k(O,w){const m=A(O,w,!0,0);return m===null?O:m}e.transformAndReviveIncomingURIs=k}),define(Ie[127],Ce([1,0,35,19]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(M,I,A,y,k,O){if(Array.isArray(M)){let w=0;for(const m of M){const b=S(m,I,A,y,k,O);if(b===10)return b;b>w&&(w=b)}return w}else{if(typeof M=="string")return y?M==="*"?5:M===A?10:0:0;if(M){const{language:w,pattern:m,scheme:b,hasAccessToAllModels:f,notebookType:s}=M;if(!y&&!f)return 0;s&&k&&(I=k);let o=0;if(b)if(b===I.scheme)o=10;else if(b==="*")o=5;else return 0;if(w)if(w===A)o=10;else if(w==="*")o=Math.max(o,5);else return 0;if(s)if(s===O)o=10;else if(s==="*"&&O!==void 0)o=Math.max(o,5);else return 0;if(m){let l;if(typeof m=="string"?l=m:l={...m,base:(0,C.normalize)(m.base)},l===I.fsPath||(0,n.match)(l,I.fsPath))o=10;else return 0}return o}else return 0}}e.score=S}),define(Ie[88],Ce([1,0,24,20]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(S||(S={}));function M(w){for(let m=0,b=w.length;m<b;m+=4){const f=w[m+0],s=w[m+1],o=w[m+2],l=w[m+3];w[m+0]=l,w[m+1]=o,w[m+2]=s,w[m+3]=f}}function I(w){const m=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return C.isLittleEndian()||M(m),n.VSBuffer.wrap(m)}function A(w){const m=w.buffer;if(C.isLittleEndian()||M(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const b=new Uint8Array(m.byteLength);return b.set(m),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function y(w){const m=new Uint32Array(k(w));let b=0;if(m[b++]=w.id,w.type==="full")m[b++]=1,m[b++]=w.data.length,m.set(w.data,b),b+=w.data.length;else{m[b++]=2,m[b++]=w.deltas.length;for(const f of w.deltas)m[b++]=f.start,m[b++]=f.deleteCount,f.data?(m[b++]=f.data.length,m.set(f.data,b),b+=f.data.length):m[b++]=0}return I(m)}e.encodeSemanticTokensDto=y;function k(w){let m=0;if(m+=1+1,w.type==="full")m+=1+w.data.length;else{m+=1,m+=(1+1+1)*w.deltas.length;for(const b of w.deltas)b.data&&(m+=b.data.length)}return m}function O(w){const m=A(w);let b=0;const f=m[b++];if(m[b++]===1){const v=m[b++],E=m.subarray(b,b+v);return b+=v,{id:f,type:"full",data:E}}const o=m[b++],l=[];for(let v=0;v<o;v++){const E=m[b++],P=m[b++],p=m[b++];let r;p>0&&(r=m.subarray(b,b+p),b+=p),l[v]={start:E,deleteCount:P,data:r}}return{id:f,type:"delta",deltas:l}}e.decodeSemanticTokensDto=O}),define(Ie[128],Ce([13,14]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Ie[129],Ce([1,0,128,20,130,18,22,116]),function(te,e,n,C,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=k;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class w{constructor(Q,ge,Le,$e){this.id=Q,this.name=ge,this.defaultValue=Le,this.schema=$e}applyUpdate(Q,ge){return b(Q,ge)}compute(Q,ge,Le){return Le}}class m{constructor(Q,ge){this.newValue=Q,this.didChange=ge}}e.ApplyUpdateResult=m;function b(_,Q){if(typeof _!="object"||typeof Q!="object"||!_||!Q)return new m(Q,_!==Q);if(Array.isArray(_)||Array.isArray(Q)){const Le=Array.isArray(_)&&Array.isArray(Q)&&M.equals(_,Q);return new m(Q,!Le)}let ge=!1;for(const Le in Q)if(Q.hasOwnProperty(Le)){const $e=b(_[Le],Q[Le]);$e.didChange&&(_[Le]=$e.newValue,ge=!0)}return new m(_,ge)}class f{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,ge){return b(Q,ge)}validate(Q){return this.defaultValue}}class s{constructor(Q,ge,Le,$e){this.id=Q,this.name=ge,this.defaultValue=Le,this.schema=$e}applyUpdate(Q,ge){return b(Q,ge)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,ge,Le){return Le}}function o(_,Q){return typeof _>"u"?Q:_==="false"?!1:Boolean(_)}e.boolean=o;class l extends s{constructor(Q,ge,Le,$e=void 0){typeof $e<"u"&&($e.type="boolean",$e.default=Le),super(Q,ge,Le,$e)}validate(Q){return o(Q,this.defaultValue)}}function v(_,Q,ge,Le){if(typeof _>"u")return Q;let $e=parseInt(_,10);return isNaN($e)?Q:($e=Math.max(ge,$e),$e=Math.min(Le,$e),$e|0)}e.clampedInt=v;class E extends s{static clampedInt(Q,ge,Le,$e){return v(Q,ge,Le,$e)}constructor(Q,ge,Le,$e,je,_e=void 0){typeof _e<"u"&&(_e.type="integer",_e.default=Le,_e.minimum=$e,_e.maximum=je),super(Q,ge,Le,_e),this.minimum=$e,this.maximum=je}validate(Q){return E.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class P extends s{static clamp(Q,ge,Le){return Q<ge?ge:Q>Le?Le:Q}static float(Q,ge){if(typeof Q=="number")return Q;if(typeof Q>"u")return ge;const Le=parseFloat(Q);return isNaN(Le)?ge:Le}constructor(Q,ge,Le,$e,je){typeof je<"u"&&(je.type="number",je.default=Le),super(Q,ge,Le,je),this.validationFn=$e}validate(Q){return this.validationFn(P.float(Q,this.defaultValue))}}class p extends s{static string(Q,ge){return typeof Q!="string"?ge:Q}constructor(Q,ge,Le,$e=void 0){typeof $e<"u"&&($e.type="string",$e.default=Le),super(Q,ge,Le,$e)}validate(Q){return p.string(Q,this.defaultValue)}}function r(_,Q,ge){return typeof _!="string"||ge.indexOf(_)===-1?Q:_}e.stringSet=r;class d extends s{constructor(Q,ge,Le,$e,je=void 0){typeof je<"u"&&(je.type="string",je.enum=$e,je.default=Le),super(Q,ge,Le,je),this.c=$e}validate(Q){return r(Q,this.defaultValue,this.c)}}class i extends w{constructor(Q,ge,Le,$e,je,_e,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=je,nt.default=$e),super(Q,ge,Le,nt),this.c=je,this.d=_e}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function c(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class t extends w{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",tags:["accessibility"],description:n.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,ge,Le){return Le===0?Q.accessibilitySupport:Le}}class h extends w{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:n.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertSpace:o(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function R(_){switch(_){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=R;function F(_){switch(_){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class q extends f{constructor(){super(135)}compute(Q,ge,Le){const $e=["monaco-editor"];return ge.get(36)&&$e.push(ge.get(36)),Q.extraEditorClassName&&$e.push(Q.extraEditorClassName),ge.get(70)==="default"?$e.push("mouse-default"):ge.get(70)==="copy"&&$e.push("mouse-copy"),ge.get(105)&&$e.push("showUnused"),ge.get(133)&&$e.push("showDeprecated"),$e.join(" ")}}class Z extends l{constructor(){super(34,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(Q,ge,Le){return Le&&Q.emptySelectionClipboard}}class x extends w{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:n.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:n.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{cursorMoveOnType:o(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":r(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":r(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(ge.loop,this.defaultValue.loop)}}}class N extends w{constructor(){super(48,"fontLigatures",N.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?N.OFF:Q==="true"?N.ON:Q:Boolean(Q)?N.ON:N.OFF}}e.EditorFontLigatures=N,N.OFF='"liga" off, "calt" off',N.ON='"liga" on, "calt" on';class $ extends w{constructor(){super(51,"fontVariations",$.OFF,{anyOf:[{type:"boolean",description:n.localize(22,null)},{type:"string",description:n.localize(23,null)}],description:n.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?$.OFF:Q==="true"?$.TRANSLATE:Q:Boolean(Q)?$.TRANSLATE:$.OFF}compute(Q,ge,Le){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=$,$.OFF="normal",$.TRANSLATE="translate";class T extends f{constructor(){super(47)}compute(Q,ge,Le){return Q.fontInfo}}class L extends s{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(25,null)})}validate(Q){const ge=P.float(Q,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:P.clamp(ge,6,100)}compute(Q,ge,Le){return Q.fontInfo.fontSize}}class V extends w{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:n.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(E.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}V.c=["normal","bold","100","200","300","400","500","600","700","800","900"],V.d=1,V.e=1e3;class j extends w{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[n.localize(28,null),n.localize(29,null),n.localize(30,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:n.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:n.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:n.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Le,description:n.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Le,description:n.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Le,description:n.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Le,description:n.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Le,description:n.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{multiple:r(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??r(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??r(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??r(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??r(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??r(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends w{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:n.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:n.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:n.localize(44,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:n.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),delay:E.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:o(ge.sticky,this.defaultValue.sticky),above:o(ge.above,this.defaultValue.above)}}}var Y;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(Y=e.RenderMinimap||(e.RenderMinimap={}));class pe extends f{constructor(){super(138)}compute(Q,ge,Le){return pe.computeLayout(ge,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const ge=Q.height/Q.lineHeight,Le=Math.floor(Q.paddingTop/Q.lineHeight);let $e=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&($e=Math.max($e,ge-1));const je=(Le+Q.viewLineCount+$e)/(Q.pixelRatio*Q.height),_e=Math.floor(Q.viewLineCount/je);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:Le,extraLinesBeyondLastLine:$e,desiredRatio:je,minimapLineCount:_e}}static c(Q,ge){const Le=Q.outerWidth,$e=Q.outerHeight,je=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(je*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const _e=ge.stableMinimapLayoutInput,nt=_e&&Q.outerHeight===_e.outerHeight&&Q.lineHeight===_e.lineHeight&&Q.typicalHalfwidthCharacterWidth===_e.typicalHalfwidthCharacterWidth&&Q.pixelRatio===_e.pixelRatio&&Q.scrollBeyondLastLine===_e.scrollBeyondLastLine&&Q.paddingTop===_e.paddingTop&&Q.paddingBottom===_e.paddingBottom&&Q.minimap.enabled===_e.minimap.enabled&&Q.minimap.side===_e.minimap.side&&Q.minimap.size===_e.minimap.size&&Q.minimap.showSlider===_e.minimap.showSlider&&Q.minimap.renderCharacters===_e.minimap.renderCharacters&&Q.minimap.maxColumn===_e.minimap.maxColumn&&Q.minimap.scale===_e.minimap.scale&&Q.verticalScrollbarWidth===_e.verticalScrollbarWidth&&Q.isViewportWrapping===_e.isViewportWrapping,wt=Q.lineHeight,St=Q.typicalHalfwidthCharacterWidth,Ct=Q.scrollBeyondLastLine,lt=Q.minimap.renderCharacters;let at=je>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Bt=Q.minimap.maxColumn,Ot=Q.minimap.size,Ft=Q.minimap.side,ft=Q.verticalScrollbarWidth,Dt=Q.viewLineCount,$t=Q.remainingWidth,Nt=Q.isViewportWrapping,Ge=lt?2:3;let Lt=Math.floor(je*$e);const Mt=Lt/je;let Ut=!1,gt=!1,kt=Ge*at,De=at/je,Pe=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeforeFirstLine:bt,extraLinesBeyondLastLine:vt,desiredRatio:At,minimapLineCount:pt}=pe.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Ct,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:$e,lineHeight:wt,pixelRatio:je});if(Dt/pt>1)Ut=!0,gt=!0,at=1,kt=1,De=at/je;else{let ht=!1,Kt=at+1;if(Ot==="fit"){const Vt=Math.ceil((bt+Dt+vt)*kt);Nt&&nt&&$t<=ge.stableFitRemainingWidth?(ht=!0,Kt=ge.stableFitMaxMinimapScale):ht=Vt>Lt}if(Ot==="fill"||ht){Ut=!0;const Vt=at;kt=Math.min(wt*je,Math.max(1,Math.floor(1/At))),Nt&&nt&&$t<=ge.stableFitRemainingWidth&&(Kt=ge.stableFitMaxMinimapScale),at=Math.min(Kt,Math.max(1,Math.floor(kt/Ge))),at>Vt&&(Pe=Math.min(2,at/Vt)),De=at/je/Pe,Lt=Math.ceil(Math.max(Ze,bt+Dt+vt)*kt),Nt?(ge.stableMinimapLayoutInput=Q,ge.stableFitRemainingWidth=$t,ge.stableFitMaxMinimapScale=at):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const me=Math.floor(Bt*De),X=Math.min(me,Math.max(0,Math.floor(($t-ft-2)*De/(St+De)))+e.MINIMAP_GUTTER_WIDTH);let Re=Math.floor(je*X);const Me=Re/je;Re=Math.floor(Re*Pe);const Qe=lt?1:2,ze=Ft==="left"?0:Le-X-ft;return{renderMinimap:Qe,minimapLeft:ze,minimapWidth:X,minimapHeightIsEditorHeight:Ut,minimapIsSampling:gt,minimapScale:at,minimapLineHeight:kt,minimapCanvasInnerWidth:Re,minimapCanvasInnerHeight:Lt,minimapCanvasOuterWidth:Me,minimapCanvasOuterHeight:Mt}}static computeLayout(Q,ge){const Le=ge.outerWidth|0,$e=ge.outerHeight|0,je=ge.lineHeight|0,_e=ge.lineNumbersDigitCount|0,nt=ge.typicalHalfwidthCharacterWidth,wt=ge.maxDigitWidth,St=ge.pixelRatio,Ct=ge.viewLineCount,lt=Q.get(130),at=lt==="inherit"?Q.get(129):lt,Bt=at==="inherit"?Q.get(125):at,Ot=Q.get(128),Ft=ge.isDominatedByLongLines,ft=Q.get(54),Dt=Q.get(64).renderType!==0,$t=Q.get(65),Nt=Q.get(99),Ge=Q.get(80),Lt=Q.get(69),Mt=Q.get(97),Ut=Mt.verticalScrollbarSize,gt=Mt.verticalHasArrows,kt=Mt.arrowSize,De=Mt.horizontalScrollbarSize,Pe=Q.get(40),me=Q.get(104)!=="never";let X=Q.get(62);Pe&&me&&(X+=16);let Re=0;if(Dt){const Qt=Math.max(_e,$t);Re=Math.round(Qt*wt)}let Me=0;ft&&(Me=je);let Qe=0,ze=Qe+Me,Ze=ze+Re,bt=Ze+X;const vt=Le-Me-Re-X;let At=!1,pt=!1,It=-1;at==="inherit"&&Ft?(At=!0,pt=!0):Bt==="on"||Bt==="bounded"?pt=!0:Bt==="wordWrapColumn"&&(It=Ot);const ht=pe.c({outerWidth:Le,outerHeight:$e,lineHeight:je,typicalHalfwidthCharacterWidth:nt,pixelRatio:St,scrollBeyondLastLine:Nt,paddingTop:Ge.top,paddingBottom:Ge.bottom,minimap:Lt,verticalScrollbarWidth:Ut,viewLineCount:Ct,remainingWidth:vt,isViewportWrapping:pt},ge.memory||new O);ht.renderMinimap!==0&&ht.minimapLeft===0&&(Qe+=ht.minimapWidth,ze+=ht.minimapWidth,Ze+=ht.minimapWidth,bt+=ht.minimapWidth);const Kt=vt-ht.minimapWidth,Vt=Math.max(1,Math.floor((Kt-Ut-2)/nt)),Et=gt?kt:0;return pt&&(It=Math.max(1,Vt),Bt==="bounded"&&(It=Math.min(It,Ot))),{width:Le,height:$e,glyphMarginLeft:Qe,glyphMarginWidth:Me,lineNumbersLeft:ze,lineNumbersWidth:Re,decorationsLeft:Ze,decorationsWidth:X,contentLeft:bt,contentWidth:Kt,minimap:ht,viewportColumn:Vt,isWordWrapMinified:At,isViewportWrapping:pt,wrappingColumn:It,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:De,overviewRuler:{top:Et,width:Ut,height:$e-2*Et,right:0}}}}e.EditorLayoutInfoComputer=pe;class ue extends w{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[n.localize(46,null),n.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:n.localize(48,null)}})}validate(Q){return r(Q,"simple",["simple","advanced"])}compute(Q,ge,Le){return ge.get(2)===2?"advanced":Le}}class de extends w{constructor(){const Q={enabled:!0};super(61,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:n.localize(49,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}class re extends w{constructor(){const Q={enabled:!1,maxLineCount:5};super(109,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:n.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:n.localize(51,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),maxLineCount:E.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class G extends w{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:n.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[n.localize(53,null),n.localize(54,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(55,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:n.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:n.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:n.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:r(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:E.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(ge.fontFamily,this.defaultValue.fontFamily),padding:o(ge.padding,this.defaultValue.padding)}}}class H extends w{constructor(){super(62,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):E.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,ge,Le){return Le<0?E.clampedInt(-Le*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Le}}class oe extends P{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>P.clamp(Q,0,150),{markdownDescription:n.localize(60,null)})}compute(Q,ge,Le){return Q.fontInfo.lineHeight}}class ve extends w{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:n.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:n.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(63,null),n.localize(64,null),n.localize(65,null)],default:Q.size,description:n.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:n.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:n.localize(68,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:n.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:n.localize(71,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),autohide:o(ge.autohide,this.defaultValue.autohide),size:r(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(ge.side,this.defaultValue.side,["right","left"]),showSlider:r(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(ge.renderCharacters,this.defaultValue.renderCharacters),scale:E.clampedInt(ge.scale,1,1,3),maxColumn:E.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ae(_){return _==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Be extends w{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(73,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{top:E.clampedInt(ge.top,0,0,1e3),bottom:E.clampedInt(ge.bottom,0,0,1e3)}}}class xe extends w{constructor(){const Q={enabled:!0,cycle:!0};super(81,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:n.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:n.localize(75,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),cycle:o(ge.cycle,this.defaultValue.cycle)}}}class Te extends f{constructor(){super(136)}compute(Q,ge,Le){return Q.pixelRatio}}class Se extends w{constructor(){const Q={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[n.localize(76,null),n.localize(77,null),n.localize(78,null)]}];super(84,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:Q.strings,description:n.localize(79,null)},comments:{anyOf:ge,default:Q.comments,description:n.localize(80,null)},other:{anyOf:ge,default:Q.other,description:n.localize(81,null)}},default:Q,markdownDescription:n.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const St=Q?"on":"off";return{comments:St,strings:St,other:St}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:ge,comments:Le,strings:$e}=Q,je=["on","inline","off"];let _e,nt,wt;return typeof ge=="boolean"?_e=ge?"on":"off":_e=r(ge,this.defaultValue.other,je),typeof Le=="boolean"?nt=Le?"on":"off":nt=r(Le,this.defaultValue.comments,je),typeof $e=="boolean"?wt=$e?"on":"off":wt=r($e,this.defaultValue.strings,je),{other:_e,comments:nt,strings:wt}}}var ke;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class se extends w{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(83,null),n.localize(84,null),n.localize(85,null),n.localize(86,null)],default:"on",description:n.localize(87,null)})}validate(Q){let ge=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(ge=4,Le=Q):Q==="interval"?ge=3:Q==="relative"?ge=2:Q==="on"?ge=1:ge=0),{renderType:ge,renderFn:Le}}}function ce(_){const Q=_.get(92);return Q==="editable"?_.get(86):Q!=="on"}e.filterValidationDecorations=ce;class J extends w{constructor(){const Q=[],ge={type:"number",description:n.localize(88,null)};super(96,"rulers",Q,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:n.localize(89,null),format:"color-hex"}}}]},default:Q,description:n.localize(90,null)})}validate(Q){if(Array.isArray(Q)){const ge=[];for(const Le of Q)if(typeof Le=="number")ge.push({column:E.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const $e=Le;ge.push({column:E.clampedInt($e.column,0,0,1e4),color:$e.color})}return ge.sort((Le,$e)=>Le.column-$e.column),ge}return this.defaultValue}}function D(_,Q){if(typeof _!="string")return Q;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends w{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(91,null),n.localize(92,null),n.localize(93,null)],default:"auto",description:n.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(95,null),n.localize(96,null),n.localize(97,null)],default:"auto",description:n.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:n.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:n.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:n.localize(101,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q,Le=E.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=E.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:E.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:D(ge.vertical,this.defaultValue.vertical),horizontal:D(ge.horizontal,this.defaultValue.horizontal),useShadows:o(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:E.clampedInt(ge.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:E.clampedInt(ge.verticalSliderSize,$e,0,1e3),scrollByPage:o(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends w{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:n.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:n.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:n.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:n.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:n.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:n.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:n.localize(108,null)}})}applyUpdate(Q,ge){let Le=!1;ge.allowedCharacters&&Q&&(I.equals(Q.allowedCharacters,ge.allowedCharacters)||(Q={...Q,allowedCharacters:ge.allowedCharacters},Le=!0)),ge.allowedLocales&&Q&&(I.equals(Q.allowedLocales,ge.allowedLocales)||(Q={...Q,allowedLocales:ge.allowedLocales},Le=!0));const $e=super.applyUpdate(Q,ge);return Le?new m($e.newValue,!0):$e}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{nonBasicASCII:ye(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ye(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ye(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,ge){if(typeof Q!="object"||!Q)return ge;const Le={};for(const[$e,je]of Object.entries(Q))je===!0&&(Le[$e]=!0);return Le}}class K extends w{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:n.localize(109,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),mode:r(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends w{constructor(){const Q={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:n.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:n.localize(111,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class he extends w{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(112,null),n.localize(113,null),n.localize(114,null)],default:Q.bracketPairs,description:n.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(116,null),n.localize(117,null),n.localize(118,null)],default:Q.bracketPairsHorizontal,description:n.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:n.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:n.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[n.localize(122,null),n.localize(123,null),n.localize(124,null)],default:Q.highlightActiveIndentation,description:n.localize(125,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{bracketPairs:ye(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ye(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:ye(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ye(_,Q,ge){const Le=ge.indexOf(_);return Le===-1?Q:ge[Le]}class ae extends w{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(126,null),n.localize(127,null)],default:Q.insertMode,description:n.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:n.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:n.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:n.localize(131,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[n.localize(132,null),n.localize(133,null),n.localize(134,null),n.localize(135,null)],default:Q.selectionMode,markdownDescription:n.localize(136,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:n.localize(137,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:n.localize(138,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:n.localize(139,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:n.localize(140,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:n.localize(141,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(142,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(143,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(144,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(145,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(146,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(147,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:n.localize(148,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(149,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(150,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(151,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(152,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(153,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(154,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(155,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(156,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(157,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(158,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(159,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(160,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(161,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(162,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(163,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(164,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(165,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(166,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(167,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(168,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(169,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(170,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(171,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(172,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(173,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertMode:r(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(ge.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(ge.showIcons,this.defaultValue.showIcons),showStatusBar:o(ge.showStatusBar,this.defaultValue.showStatusBar),preview:o(ge.preview,this.defaultValue.preview),previewMode:r(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(ge.showMethods,this.defaultValue.showMethods),showFunctions:o(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:o(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(ge.showFields,this.defaultValue.showFields),showVariables:o(ge.showVariables,this.defaultValue.showVariables),showClasses:o(ge.showClasses,this.defaultValue.showClasses),showStructs:o(ge.showStructs,this.defaultValue.showStructs),showInterfaces:o(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:o(ge.showModules,this.defaultValue.showModules),showProperties:o(ge.showProperties,this.defaultValue.showProperties),showEvents:o(ge.showEvents,this.defaultValue.showEvents),showOperators:o(ge.showOperators,this.defaultValue.showOperators),showUnits:o(ge.showUnits,this.defaultValue.showUnits),showValues:o(ge.showValues,this.defaultValue.showValues),showConstants:o(ge.showConstants,this.defaultValue.showConstants),showEnums:o(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:o(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(ge.showKeywords,this.defaultValue.showKeywords),showWords:o(ge.showWords,this.defaultValue.showWords),showColors:o(ge.showColors,this.defaultValue.showColors),showFiles:o(ge.showFiles,this.defaultValue.showFiles),showReferences:o(ge.showReferences,this.defaultValue.showReferences),showFolders:o(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:o(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(ge.showSnippets,this.defaultValue.showSnippets),showUsers:o(ge.showUsers,this.defaultValue.showUsers),showIssues:o(ge.showIssues,this.defaultValue.showIssues)}}}class be extends w{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(174,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ee extends f{constructor(){super(137)}compute(Q,ge,Le){return ge.get(86)?!0:Q.tabFocusMode}}var We;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(We=e.WrappingIndent||(e.WrappingIndent={}));class He extends w{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[n.localize(175,null),n.localize(176,null),n.localize(177,null),n.localize(178,null)],description:n.localize(179,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,ge,Le){return ge.get(2)===2?0:Le}}class tt extends f{constructor(){super(139)}compute(Q,ge,Le){const $e=ge.get(138);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}class Xe extends w{constructor(){const Q={enabled:!0};super(33,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:n.localize(180,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?it:C.isLinux?dt:et,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(_){return e.editorOptionsRegistry[_.id]=_,_}var st;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.autoClosingBrackets=5]="autoClosingBrackets",_[_.autoClosingDelete=6]="autoClosingDelete",_[_.autoClosingOvertype=7]="autoClosingOvertype",_[_.autoClosingQuotes=8]="autoClosingQuotes",_[_.autoIndent=9]="autoIndent",_[_.automaticLayout=10]="automaticLayout",_[_.autoSurround=11]="autoSurround",_[_.bracketPairColorization=12]="bracketPairColorization",_[_.guides=13]="guides",_[_.codeLens=14]="codeLens",_[_.codeLensFontFamily=15]="codeLensFontFamily",_[_.codeLensFontSize=16]="codeLensFontSize",_[_.colorDecorators=17]="colorDecorators",_[_.colorDecoratorsLimit=18]="colorDecoratorsLimit",_[_.columnSelection=19]="columnSelection",_[_.comments=20]="comments",_[_.contextmenu=21]="contextmenu",_[_.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",_[_.cursorBlinking=23]="cursorBlinking",_[_.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",_[_.cursorStyle=25]="cursorStyle",_[_.cursorSurroundingLines=26]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",_[_.cursorWidth=28]="cursorWidth",_[_.disableLayerHinting=29]="disableLayerHinting",_[_.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",_[_.domReadOnly=31]="domReadOnly",_[_.dragAndDrop=32]="dragAndDrop",_[_.dropIntoEditor=33]="dropIntoEditor",_[_.emptySelectionClipboard=34]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",_[_.extraEditorClassName=36]="extraEditorClassName",_[_.fastScrollSensitivity=37]="fastScrollSensitivity",_[_.find=38]="find",_[_.fixedOverflowWidgets=39]="fixedOverflowWidgets",_[_.folding=40]="folding",_[_.foldingStrategy=41]="foldingStrategy",_[_.foldingHighlight=42]="foldingHighlight",_[_.foldingImportsByDefault=43]="foldingImportsByDefault",_[_.foldingMaximumRegions=44]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=46]="fontFamily",_[_.fontInfo=47]="fontInfo",_[_.fontLigatures=48]="fontLigatures",_[_.fontSize=49]="fontSize",_[_.fontWeight=50]="fontWeight",_[_.fontVariations=51]="fontVariations",_[_.formatOnPaste=52]="formatOnPaste",_[_.formatOnType=53]="formatOnType",_[_.glyphMargin=54]="glyphMargin",_[_.gotoLocation=55]="gotoLocation",_[_.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",_[_.hover=57]="hover",_[_.inDiffEditor=58]="inDiffEditor",_[_.inlineSuggest=59]="inlineSuggest",_[_.letterSpacing=60]="letterSpacing",_[_.lightbulb=61]="lightbulb",_[_.lineDecorationsWidth=62]="lineDecorationsWidth",_[_.lineHeight=63]="lineHeight",_[_.lineNumbers=64]="lineNumbers",_[_.lineNumbersMinChars=65]="lineNumbersMinChars",_[_.linkedEditing=66]="linkedEditing",_[_.links=67]="links",_[_.matchBrackets=68]="matchBrackets",_[_.minimap=69]="minimap",_[_.mouseStyle=70]="mouseStyle",_[_.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=72]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",_[_.multiCursorModifier=74]="multiCursorModifier",_[_.multiCursorPaste=75]="multiCursorPaste",_[_.multiCursorLimit=76]="multiCursorLimit",_[_.occurrencesHighlight=77]="occurrencesHighlight",_[_.overviewRulerBorder=78]="overviewRulerBorder",_[_.overviewRulerLanes=79]="overviewRulerLanes",_[_.padding=80]="padding",_[_.parameterHints=81]="parameterHints",_[_.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",_[_.quickSuggestions=84]="quickSuggestions",_[_.quickSuggestionsDelay=85]="quickSuggestionsDelay",_[_.readOnly=86]="readOnly",_[_.renameOnType=87]="renameOnType",_[_.renderControlCharacters=88]="renderControlCharacters",_[_.renderFinalNewline=89]="renderFinalNewline",_[_.renderLineHighlight=90]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=92]="renderValidationDecorations",_[_.renderWhitespace=93]="renderWhitespace",_[_.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",_[_.roundedSelection=95]="roundedSelection",_[_.rulers=96]="rulers",_[_.scrollbar=97]="scrollbar",_[_.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=99]="scrollBeyondLastLine",_[_.scrollPredominantAxis=100]="scrollPredominantAxis",_[_.selectionClipboard=101]="selectionClipboard",_[_.selectionHighlight=102]="selectionHighlight",_[_.selectOnLineNumbers=103]="selectOnLineNumbers",_[_.showFoldingControls=104]="showFoldingControls",_[_.showUnused=105]="showUnused",_[_.snippetSuggestions=106]="snippetSuggestions",_[_.smartSelect=107]="smartSelect",_[_.smoothScrolling=108]="smoothScrolling",_[_.stickyScroll=109]="stickyScroll",_[_.stickyTabStops=110]="stickyTabStops",_[_.stopRenderingLineAfter=111]="stopRenderingLineAfter",_[_.suggest=112]="suggest",_[_.suggestFontSize=113]="suggestFontSize",_[_.suggestLineHeight=114]="suggestLineHeight",_[_.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",_[_.suggestSelection=116]="suggestSelection",_[_.tabCompletion=117]="tabCompletion",_[_.tabIndex=118]="tabIndex",_[_.unicodeHighlighting=119]="unicodeHighlighting",_[_.unusualLineTerminators=120]="unusualLineTerminators",_[_.useShadowDOM=121]="useShadowDOM",_[_.useTabStops=122]="useTabStops",_[_.wordBreak=123]="wordBreak",_[_.wordSeparators=124]="wordSeparators",_[_.wordWrap=125]="wordWrap",_[_.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=128]="wordWrapColumn",_[_.wordWrapOverride1=129]="wordWrapOverride1",_[_.wordWrapOverride2=130]="wordWrapOverride2",_[_.wrappingIndent=131]="wrappingIndent",_[_.wrappingStrategy=132]="wrappingStrategy",_[_.showDeprecated=133]="showDeprecated",_[_.inlayHints=134]="inlayHints",_[_.editorClassName=135]="editorClassName",_[_.pixelRatio=136]="pixelRatio",_[_.tabFocusMode=137]="tabFocusMode",_[_.layoutInfo=138]="layoutInfo",_[_.wrappingInfo=139]="wrappingInfo"})(st=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(181,null)})),acceptSuggestionOnEnter:Fe(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(182,null),""],markdownDescription:n.localize(183,null)})),accessibilitySupport:Fe(new t),accessibilityPageSize:Fe(new E(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(184,null),tags:["accessibility"]})),ariaLabel:Fe(new p(4,"ariaLabel",n.localize(185,null))),autoClosingBrackets:Fe(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(186,null),n.localize(187,null),""],description:n.localize(188,null)})),autoClosingDelete:Fe(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(189,null),""],description:n.localize(190,null)})),autoClosingOvertype:Fe(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(191,null),""],description:n.localize(192,null)})),autoClosingQuotes:Fe(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(193,null),n.localize(194,null),""],description:n.localize(195,null)})),autoIndent:Fe(new i(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[n.localize(196,null),n.localize(197,null),n.localize(198,null),n.localize(199,null),n.localize(200,null)],description:n.localize(201,null)})),automaticLayout:Fe(new l(10,"automaticLayout",!1)),autoSurround:Fe(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(202,null),n.localize(203,null),n.localize(204,null),""],description:n.localize(205,null)})),bracketPairColorization:Fe(new ee),bracketPairGuides:Fe(new he),stickyTabStops:Fe(new l(110,"stickyTabStops",!1,{description:n.localize(206,null)})),codeLens:Fe(new l(14,"codeLens",!0,{description:n.localize(207,null)})),codeLensFontFamily:Fe(new p(15,"codeLensFontFamily","",{description:n.localize(208,null)})),codeLensFontSize:Fe(new E(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(209,null)})),colorDecorators:Fe(new l(17,"colorDecorators",!0,{description:n.localize(210,null)})),colorDecoratorsLimit:Fe(new E(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:n.localize(211,null)})),columnSelection:Fe(new l(19,"columnSelection",!1,{description:n.localize(212,null)})),comments:Fe(new h),contextmenu:Fe(new l(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new l(22,"copyWithSyntaxHighlighting",!0,{description:n.localize(213,null)})),cursorBlinking:Fe(new i(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:n.localize(214,null)})),cursorSmoothCaretAnimation:Fe(new d(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[n.localize(215,null),n.localize(216,null),n.localize(217,null)],description:n.localize(218,null)})),cursorStyle:Fe(new i(25,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:n.localize(219,null)})),cursorSurroundingLines:Fe(new E(26,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(220,null)})),cursorSurroundingLinesStyle:Fe(new d(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(221,null),n.localize(222,null)],description:n.localize(223,null)})),cursorWidth:Fe(new E(28,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(224,null)})),disableLayerHinting:Fe(new l(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new l(30,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new l(31,"domReadOnly",!1)),dragAndDrop:Fe(new l(32,"dragAndDrop",!0,{description:n.localize(225,null)})),emptySelectionClipboard:Fe(new Z),dropIntoEditor:Fe(new Xe),stickyScroll:Fe(new re),experimentalWhitespaceRendering:Fe(new d(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[n.localize(226,null),n.localize(227,null),n.localize(228,null)],description:n.localize(229,null)})),extraEditorClassName:Fe(new p(36,"extraEditorClassName","")),fastScrollSensitivity:Fe(new P(37,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:n.localize(230,null)})),find:Fe(new x),fixedOverflowWidgets:Fe(new l(39,"fixedOverflowWidgets",!1)),folding:Fe(new l(40,"folding",!0,{description:n.localize(231,null)})),foldingStrategy:Fe(new d(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(232,null),n.localize(233,null)],description:n.localize(234,null)})),foldingHighlight:Fe(new l(42,"foldingHighlight",!0,{description:n.localize(235,null)})),foldingImportsByDefault:Fe(new l(43,"foldingImportsByDefault",!1,{description:n.localize(236,null)})),foldingMaximumRegions:Fe(new E(44,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(237,null)})),unfoldOnClickAfterEndOfLine:Fe(new l(45,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(238,null)})),fontFamily:Fe(new p(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:n.localize(239,null)})),fontInfo:Fe(new T),fontLigatures2:Fe(new N),fontSize:Fe(new L),fontWeight:Fe(new V),fontVariations:Fe(new $),formatOnPaste:Fe(new l(52,"formatOnPaste",!1,{description:n.localize(240,null)})),formatOnType:Fe(new l(53,"formatOnType",!1,{description:n.localize(241,null)})),glyphMargin:Fe(new l(54,"glyphMargin",!0,{description:n.localize(242,null)})),gotoLocation:Fe(new j),hideCursorInOverviewRuler:Fe(new l(56,"hideCursorInOverviewRuler",!1,{description:n.localize(243,null)})),hover:Fe(new le),inDiffEditor:Fe(new l(58,"inDiffEditor",!1)),letterSpacing:Fe(new P(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>P.clamp(_,-5,20),{description:n.localize(244,null)})),lightbulb:Fe(new de),lineDecorationsWidth:Fe(new H),lineHeight:Fe(new oe),lineNumbers:Fe(new se),lineNumbersMinChars:Fe(new E(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new l(66,"linkedEditing",!1,{description:n.localize(245,null)})),links:Fe(new l(67,"links",!0,{description:n.localize(246,null)})),matchBrackets:Fe(new d(68,"matchBrackets","always",["always","near","never"],{description:n.localize(247,null)})),minimap:Fe(new ve),mouseStyle:Fe(new d(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new P(71,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:n.localize(248,null)})),mouseWheelZoom:Fe(new l(72,"mouseWheelZoom",!1,{markdownDescription:n.localize(249,null)})),multiCursorMergeOverlapping:Fe(new l(73,"multiCursorMergeOverlapping",!0,{description:n.localize(250,null)})),multiCursorModifier:Fe(new i(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ae,{markdownEnumDescriptions:[n.localize(251,null),n.localize(252,null)],markdownDescription:n.localize(253,null)})),multiCursorPaste:Fe(new d(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(254,null),n.localize(255,null)],markdownDescription:n.localize(256,null)})),multiCursorLimit:Fe(new E(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:n.localize(257,null)})),occurrencesHighlight:Fe(new l(77,"occurrencesHighlight",!0,{description:n.localize(258,null)})),overviewRulerBorder:Fe(new l(78,"overviewRulerBorder",!0,{description:n.localize(259,null)})),overviewRulerLanes:Fe(new E(79,"overviewRulerLanes",3,0,3)),padding:Fe(new Be),parameterHints:Fe(new xe),peekWidgetDefaultFocus:Fe(new d(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(260,null),n.localize(261,null)],description:n.localize(262,null)})),definitionLinkOpensInPeek:Fe(new l(83,"definitionLinkOpensInPeek",!1,{description:n.localize(263,null)})),quickSuggestions:Fe(new Se),quickSuggestionsDelay:Fe(new E(85,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(264,null)})),readOnly:Fe(new l(86,"readOnly",!1)),renameOnType:Fe(new l(87,"renameOnType",!1,{description:n.localize(265,null),markdownDeprecationMessage:n.localize(266,null)})),renderControlCharacters:Fe(new l(88,"renderControlCharacters",!0,{description:n.localize(267,null),restricted:!0})),renderFinalNewline:Fe(new d(89,"renderFinalNewline",C.isLinux?"dimmed":"on",["off","on","dimmed"],{description:n.localize(268,null)})),renderLineHighlight:Fe(new d(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(269,null)],description:n.localize(270,null)})),renderLineHighlightOnlyWhenFocus:Fe(new l(91,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(271,null)})),renderValidationDecorations:Fe(new d(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new d(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(272,null),n.localize(273,null),n.localize(274,null),""],description:n.localize(275,null)})),revealHorizontalRightPadding:Fe(new E(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new l(95,"roundedSelection",!0,{description:n.localize(276,null)})),rulers:Fe(new J),scrollbar:Fe(new B),scrollBeyondLastColumn:Fe(new E(98,"scrollBeyondLastColumn",4,0,1073741824,{description:n.localize(277,null)})),scrollBeyondLastLine:Fe(new l(99,"scrollBeyondLastLine",!0,{description:n.localize(278,null)})),scrollPredominantAxis:Fe(new l(100,"scrollPredominantAxis",!0,{description:n.localize(279,null)})),selectionClipboard:Fe(new l(101,"selectionClipboard",!0,{description:n.localize(280,null),included:C.isLinux})),selectionHighlight:Fe(new l(102,"selectionHighlight",!0,{description:n.localize(281,null)})),selectOnLineNumbers:Fe(new l(103,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new d(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[n.localize(282,null),n.localize(283,null),n.localize(284,null)],description:n.localize(285,null)})),showUnused:Fe(new l(105,"showUnused",!0,{description:n.localize(286,null)})),showDeprecated:Fe(new l(133,"showDeprecated",!0,{description:n.localize(287,null)})),inlayHints:Fe(new G),snippetSuggestions:Fe(new d(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(288,null),n.localize(289,null),n.localize(290,null),n.localize(291,null)],description:n.localize(292,null)})),smartSelect:Fe(new be),smoothScrolling:Fe(new l(108,"smoothScrolling",!1,{description:n.localize(293,null)})),stopRenderingLineAfter:Fe(new E(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ae),inlineSuggest:Fe(new K),suggestFontSize:Fe(new E(113,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(294,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new E(114,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(295,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new l(115,"suggestOnTriggerCharacters",!0,{description:n.localize(296,null)})),suggestSelection:Fe(new d(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(297,null),n.localize(298,null),n.localize(299,null)],description:n.localize(300,null)})),tabCompletion:Fe(new d(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(301,null),n.localize(302,null),n.localize(303,null)],description:n.localize(304,null)})),tabIndex:Fe(new E(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new W),unusualLineTerminators:Fe(new d(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(305,null),n.localize(306,null),n.localize(307,null)],description:n.localize(308,null)})),useShadowDOM:Fe(new l(121,"useShadowDOM",!0)),useTabStops:Fe(new l(122,"useTabStops",!0,{description:n.localize(309,null)})),wordBreak:Fe(new d(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[n.localize(310,null),n.localize(311,null)],description:n.localize(312,null)})),wordSeparators:Fe(new p(124,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:n.localize(313,null)})),wordWrap:Fe(new d(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(314,null),n.localize(315,null),n.localize(316,null),n.localize(317,null)],description:n.localize(318,null)})),wordWrapBreakAfterCharacters:Fe(new p(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new p(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new E(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(319,null)})),wordWrapOverride1:Fe(new d(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new d(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new q),pixelRatio:Fe(new Te),tabFocusMode:Fe(new Ee),layoutInfo:Fe(new pe),wrappingInfo:Fe(new tt),wrappingIndent:Fe(new He),wrappingStrategy:Fe(new ue)}}),define(Ie[131],Ce([13,14]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[132],Ce([13,14]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[133],Ce([13,14]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[134],Ce([13,14]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Ie[135],Ce([13,14]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Ie[136],Ce([13,14]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(Ie[137],Ce([13,14]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Ie[138],Ce([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[139],Ce([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[140],Ce([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[141],Ce([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[142],Ce([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[143],Ce([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[144],Ce([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[145],Ce([13,14]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Ie[146],Ce([13,14]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(Ie[147],Ce([13,14]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[148],Ce([13,14]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[149],Ce([13,14]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[150],Ce([13,14]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[151],Ce([13,14]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[152],Ce([13,14]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[153],Ce([13,14]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[154],Ce([1,0,11]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class C{constructor(){this.a=new Map}register(M,I){this.a.set(M,I)}updateManifest(M){if(!(typeof M.main>"u"&&typeof M.browser>"u")&&(M.activationEvents===void 0&&Object.assign(M,{activationEvents:[]}),!(!Array.isArray(M.activationEvents)||!M.contributes)))for(const I in M.contributes){const A=this.a.get(I);if(!A)continue;const y=M.contributes[I],k=Array.isArray(y)?y:[y];try{A(k,M.activationEvents)}catch(O){(0,n.onUnexpectedError)(O)}}}}e.ImplicitActivationEventsImpl=C,e.ImplicitActivationEvents=new C}),define(Ie[155],Ce([1,0,23,30,133,254]),function(te,e,n,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(l){return l=l.trim(),l==="*"||I.test(l)}e.isValidVersionStr=y;function k(l){if(!y(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=l.match(I);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=k;function O(l){if(!l)return null;const v=l.majorBase,E=l.majorMustEqual,P=l.minorBase;let p=l.minorMustEqual;const r=l.patchBase;let d=l.patchMustEqual;l.hasCaret&&(v===0||(p=!1),d=!1);let i=0;if(l.preRelease){const c=A.exec(l.preRelease);if(c){const[,t,h,a]=c;i=Date.UTC(Number(t),Number(h)-1,Number(a))}}return{majorBase:v,majorMustEqual:E,minorBase:P,minorMustEqual:p,patchBase:r,patchMustEqual:d,isMinimum:l.hasGreaterEquals,notBefore:i}}e.normalizeVersion=O;function w(l,v,E){let P;typeof l=="string"?P=O(k(l)):P=l;let p;v instanceof Date?p=v.getTime():typeof v=="string"&&(p=new Date(v).getTime());let r;if(typeof E=="string"?r=O(k(E)):r=E,!P||!r)return!1;const d=P.majorBase,i=P.minorBase,c=P.patchBase;let t=r.majorBase,h=r.minorBase,a=r.patchBase;const u=r.notBefore;let g=r.majorMustEqual,R=r.minorMustEqual,F=r.patchMustEqual;return r.isMinimum?d>t?!0:d<t?!1:i>h?!0:i<h||p&&p<u?!1:c>=a:(d===1&&t===0&&(!g||!R||!F)&&(t=1,h=0,a=0,g=!0,R=!1,F=!1),d<t?!1:d>t?!g:i<h?!1:i>h?!R:c<a?!1:c>a?!F:!(p&&p<u))}e.isValidVersion=w;function m(l,v,E,P,p){const r=[];if(typeof P.publisher<"u"&&typeof P.publisher!="string")return r.push([C.default.Error,S.localize(0,null)]),r;if(typeof P.name!="string")return r.push([C.default.Error,S.localize(1,null,"name")]),r;if(typeof P.version!="string")return r.push([C.default.Error,S.localize(2,null,"version")]),r;if(!P.engines)return r.push([C.default.Error,S.localize(3,null,"engines")]),r;if(typeof P.engines.vscode!="string")return r.push([C.default.Error,S.localize(4,null,"engines.vscode")]),r;if(typeof P.extensionDependencies<"u"&&!o(P.extensionDependencies))return r.push([C.default.Error,S.localize(5,null,"extensionDependencies")]),r;if(typeof P.activationEvents<"u"){if(!o(P.activationEvents))return r.push([C.default.Error,S.localize(6,null,"activationEvents")]),r;if(typeof P.main>"u"&&typeof P.browser>"u")return r.push([C.default.Error,S.localize(7,null,"activationEvents","main")]),r}if(typeof P.extensionKind<"u"&&typeof P.main>"u"&&r.push([C.default.Warning,S.localize(8,null,"extensionKind")]),typeof P.main<"u"){if(typeof P.main!="string")return r.push([C.default.Error,S.localize(9,null,"main")]),r;{const c=(0,n.joinPath)(E,P.main);(0,n.isEqualOrParent)(c,E)||r.push([C.default.Warning,S.localize(10,null,c.path,E.path)])}if(typeof P.activationEvents>"u")return r.push([C.default.Error,S.localize(11,null,"activationEvents","main")]),r}if(typeof P.browser<"u"){if(typeof P.browser!="string")return r.push([C.default.Error,S.localize(12,null,"browser")]),r;{const c=(0,n.joinPath)(E,P.browser);(0,n.isEqualOrParent)(c,E)||r.push([C.default.Warning,S.localize(13,null,c.path,E.path)])}if(typeof P.activationEvents>"u")return r.push([C.default.Error,S.localize(14,null,"activationEvents","browser")]),r}if(!M.valid(P.version))return r.push([C.default.Error,S.localize(15,null)]),r;const d=[];if(!b(l,v,P,p,d))for(const c of d)r.push([C.default.Error,c]);return r}e.validateExtensionManifest=m;function b(l,v,E,P,p){return P||typeof E.main>"u"&&typeof E.browser>"u"?!0:s(l,v,E.engines.vscode,p)}e.isValidExtensionVersion=b;function f(l,v,E){return l==="*"||s(v,E,l)}e.isEngineValid=f;function s(l,v,E,P=[]){const p=O(k(E));if(!p)return P.push(S.localize(16,null,E)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return P.push(S.localize(17,null,E)),!1}else if(!p.majorMustEqual)return P.push(S.localize(18,null,E)),!1;return w(l,v,p)?!0:(P.push(S.localize(19,null,l,E)),!1)}function o(l){if(!Array.isArray(l))return!1;for(let v=0,E=l.length;v<E;v++)if(typeof l[v]!="string")return!1;return!0}}),define(Ie[89],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(S,M=[],I=!1){this.ctor=S,this.staticArguments=M,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=n}),define(Ie[66],Ce([1,0,89]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const C=[];var S;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(S=e.InstantiationType||(e.InstantiationType={}));function M(A,y,k){y instanceof n.SyncDescriptor||(y=new n.SyncDescriptor(y,[],Boolean(k))),C.push([A,y])}e.registerSingleton=M;function I(){return C}e.getSingletonServiceDescriptors=I}),define(Ie[156],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(M,I){this.key=M,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class C{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const I of this.a.values())I.outgoing.size===0&&M.push(I);return M}insertEdge(M,I){const A=this.lookupOrInsertNode(M),y=this.lookupOrInsertNode(I);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(M){const I=this.b(M);this.a.delete(I);for(const A of this.a.values())A.outgoing.delete(I),A.incoming.delete(I)}lookupOrInsertNode(M){const I=this.b(M);let A=this.a.get(I);return A||(A=new n(I,M),this.a.set(I,A)),A}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[I,A]of this.a)M.push(`${I}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,I]of this.a){const A=new Set([M]),y=this.c(I,A);if(y)return y}}c(M,I){for(const[A,y]of M.outgoing){if(I.has(A))return[...I,A].join(" -> ");I.add(A);const k=this.c(y,I);if(k)return k;I.delete(A)}}}e.Graph=C}),define(Ie[3],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=A})(n=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function C(I,A,y){A[n.DI_TARGET]===A?A[n.DI_DEPENDENCIES].push({id:I,index:y}):(A[n.DI_DEPENDENCIES]=[{id:I,index:y}],A[n.DI_TARGET]=A)}function S(I){if(n.serviceIds.has(I))return n.serviceIds.get(I);const A=function(y,k,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(A,y,O)};return A.toString=()=>I,n.serviceIds.set(I,A),A}e.createDecorator=S;function M(I){return I}e.refineServiceDecorator=M}),define(Ie[41],Ce([1,0,9,2,3]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function M(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof C.URI)}e.isConfigurationOverrides=M;function I(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof C.URI)}e.isConfigurationUpdateOverrides=I;var A;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function k(l,v){const E=Object.create(null);for(const P in l)O(E,P,l[P],v);return E}e.toValuesTree=k;function O(l,v,E,P){const p=v.split("."),r=p.pop();let d=l;for(let i=0;i<p.length;i++){const c=p[i];let t=d[c];switch(typeof t){case"undefined":t=d[c]=Object.create(null);break;case"object":break;default:P(`Ignoring ${v} as ${p.slice(0,i+1).join(".")} is ${JSON.stringify(t)}`);return}d=t}if(typeof d=="object"&&d!==null)try{d[r]=E}catch{P(`Ignoring ${v} as ${p.join(".")} is ${JSON.stringify(d)}`)}else P(`Ignoring ${v} as ${p.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=O;function w(l,v){const E=v.split(".");m(l,E)}e.removeFromValueTree=w;function m(l,v){const E=v.shift();if(v.length===0){delete l[E];return}if(Object.keys(l).indexOf(E)!==-1){const P=l[E];typeof P=="object"&&!Array.isArray(P)&&(m(P,v),Object.keys(P).length===0&&delete l[E])}}function b(l,v,E){function P(d,i){let c=d;for(const t of i){if(typeof c!="object"||c===null)return;c=c[t]}return c}const p=v.split("."),r=P(l,p);return typeof r>"u"?E:r}e.getConfigurationValue=b;function f(l,v,E){Object.keys(v).forEach(P=>{P!=="__proto__"&&(P in l?n.isObject(l[P])&&n.isObject(v[P])?f(l[P],v[P],E):E&&(l[P]=v[P]):l[P]=v[P])})}e.merge=f;function s(l,v,E){const P=l.inspect(v),p=l.inspect(E);return typeof P.userValue<"u"||typeof P.workspaceValue<"u"||typeof P.workspaceFolderValue<"u"?P.value:typeof p.userValue<"u"||typeof p.workspaceValue<"u"||typeof p.workspaceFolderValue<"u"?p.value:P.defaultValue}e.getMigratedSettingValue=s;function o(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=o}),define(Ie[42],Ce([1,0,20,10,3]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",n.isMacintosh),M.set("isLinux",n.isLinux),M.set("isWindows",n.isWindows),M.set("isWeb",n.isWeb),M.set("isMacNative",n.isMacintosh&&!n.isWeb),M.set("isEdge",n.isEdge),M.set("isFirefox",n.isFirefox),M.set("isChrome",n.isChrome),M.set("isSafari",n.isSafari);const I=Object.prototype.hasOwnProperty;var A;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return w.INSTANCE}static true(){return m.INSTANCE}static has(N){return b.create(N)}static equals(N,$){return f.create(N,$)}static notEquals(N,$){return l.create(N,$)}static regex(N,$){return i.create(N,$)}static in(N,$){return s.create(N,$)}static notIn(N,$){return o.create(N,$)}static not(N){return v.create(N)}static and(...N){return h.create(N,null,!0)}static or(...N){return a.create(N,null,!0)}static greater(N,$){return P.create(N,$)}static greaterEquals(N,$){return p.create(N,$)}static smaller(N,$){return r.create(N,$)}static smallerEquals(N,$){return d.create(N,$)}static deserialize(N,$=!1){if(!!N)return this.c(N,$)}static c(N,$){const T=N.split("||");return a.create(T.map(L=>this.d(L,$)),null,!0)}static d(N,$){const T=N.split("&&");return h.create(T.map(L=>this.f(L,$)),null,!0)}static f(N,$){if(N=N.trim(),N.indexOf("!=")>=0){const T=N.split("!=");return l.create(T[0].trim(),this.g(T[1],$))}if(N.indexOf("==")>=0){const T=N.split("==");return f.create(T[0].trim(),this.g(T[1],$))}if(N.indexOf("=~")>=0){const T=N.split("=~");return i.create(T[0].trim(),this.h(T[1],$))}if(N.indexOf(" not in ")>=0){const T=N.split(" not in ");return o.create(T[0].trim(),this.g(T[1],$))}if(N.indexOf(" in ")>=0){const T=N.split(" in ");return s.create(T[0].trim(),this.g(T[1],$))}if(/^[^<=>]+>=[^<=>]+$/.test(N)){const T=N.split(">=");return p.create(T[0].trim(),T[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(N)){const T=N.split(">");return P.create(T[0].trim(),T[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(N)){const T=N.split("<=");return d.create(T[0].trim(),T[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(N)){const T=N.split("<");return r.create(T[0].trim(),T[1].trim())}return/^\!\s*/.test(N)?v.create(N.substr(1).trim()):b.create(N)}static g(N,$){if(N=N.trim(),N==="true")return!0;if(N==="false")return!1;const T=/^'([^']*)'$/.exec(N);return T?T[1].trim():N}static h(N,$){if((0,C.isFalsyOrWhitespace)(N)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const T=N.indexOf("/"),L=N.lastIndexOf("/");if(T===L||T<0){if($)throw new Error(`bad regexp-value '${N}', missing /-enclosure`);return console.warn(`bad regexp-value '${N}', missing /-enclosure`),null}const V=N.slice(T+1,L),j=N[L+1]==="i"?"i":"";try{return new RegExp(V,j)}catch(le){if($)throw new Error(`bad regexp-value '${N}', parse error: ${le}`);return console.warn(`bad regexp-value '${N}', parse error: ${le}`),null}}}e.ContextKeyExpr=y;function k(x,N){const $=x?x.substituteConstants():void 0,T=N?N.substituteConstants():void 0;return!$&&!T?!0:!$||!T?!1:$.equals(T)}e.expressionsAreEqualWithConstantSubstitution=k;function O(x,N){return x.cmp(N)}class w{constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class m{constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class b{static create(N,$=null){const T=M.get(N);return typeof T=="boolean"?T?m.INSTANCE:w.INSTANCE:new b(N,$)}constructor(N,$){this.key=N,this.c=$,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:g(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=M.get(this.key);return typeof N=="boolean"?N?m.INSTANCE:w.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=v.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=b;class f{static create(N,$,T=null){if(typeof $=="boolean")return $?b.create(N,T):v.create(N,T);const L=M.get(N);return typeof L=="boolean"?$===(L?"true":"false")?m.INSTANCE:w.INSTANCE:new f(N,$,T)}constructor(N,$,T){this.c=N,this.d=$,this.f=T,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:R(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=M.get(this.c);if(typeof N=="boolean"){const $=N?"true":"false";return this.d===$?m.INSTANCE:w.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=f;class s{static create(N,$){return new s(N,$)}constructor(N,$){this.d=N,this.f=$,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:R(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const $=N.getValue(this.f),T=N.getValue(this.d);return Array.isArray($)?$.includes(T):typeof T=="string"&&typeof $=="object"&&$!==null?I.call($,T):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=o.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=s;class o{static create(N,$){return new o(N,$)}constructor(N,$){this.d=N,this.f=$,this.type=11,this.c=s.create(N,$)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=o;class l{static create(N,$,T=null){if(typeof $=="boolean")return $?v.create(N,T):b.create(N,T);const L=M.get(N);return typeof L=="boolean"?$===(L?"true":"false")?w.INSTANCE:m.INSTANCE:new l(N,$,T)}constructor(N,$,T){this.c=N,this.d=$,this.f=T,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:R(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=M.get(this.c);if(typeof N=="boolean"){const $=N?"true":"false";return this.d===$?w.INSTANCE:m.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class v{static create(N,$=null){const T=M.get(N);return typeof T=="boolean"?T?w.INSTANCE:m.INSTANCE:new v(N,$)}constructor(N,$){this.c=N,this.d=$,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:g(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=M.get(this.c);return typeof N=="boolean"?N?w.INSTANCE:m.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.ContextKeyNotExpr=v;function E(x,N){if(typeof x=="string"){const $=parseFloat(x);isNaN($)||(x=$)}return typeof x=="string"||typeof x=="number"?N(x):w.INSTANCE}class P{static create(N,$,T=null){return E($,L=>new P(N,L,T))}constructor(N,$,T){this.c=N,this.d=$,this.f=T,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:R(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=P;class p{static create(N,$,T=null){return E($,L=>new p(N,L,T))}constructor(N,$,T){this.c=N,this.d=$,this.f=T,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:R(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=p;class r{static create(N,$,T=null){return E($,L=>new r(N,L,T))}constructor(N,$,T){this.c=N,this.d=$,this.f=T,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:R(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=r;class d{static create(N,$,T=null){return E($,L=>new d(N,L,T))}constructor(N,$,T){this.c=N,this.d=$,this.f=T,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:R(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=d;class i{static create(N,$){return new i(N,$)}constructor(N,$){this.d=N,this.f=$,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const $=this.f?this.f.source:"",T=N.f?N.f.source:"";return $<T?-1:$>T?1:0}equals(N){if(N.type===this.type){const $=this.f?this.f.source:"",T=N.f?N.f.source:"";return this.d===N.d&&$===T}return!1}substituteConstants(){return this}evaluate(N){const $=N.getValue(this.d);return this.f?this.f.test($):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=c.create(this)),this.c}}e.ContextKeyRegexExpr=i;class c{static create(N){return new c(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(N){return new c(this.c.map(N))}negate(){return this.c}}e.ContextKeyNotRegexExpr=c;function t(x){let N=null;for(let $=0,T=x.length;$<T;$++){const L=x[$].substituteConstants();if(x[$]!==L&&N===null){N=[];for(let V=0;V<$;V++)N[V]=x[V]}N!==null&&(N[$]=L)}return N===null?x:N}class h{static create(N,$,T){return h.d(N,$,T)}constructor(N,$){this.expr=N,this.c=$,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let $=0,T=this.expr.length;$<T;$++){const L=O(this.expr[$],N.expr[$]);if(L!==0)return L}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let $=0,T=this.expr.length;$<T;$++)if(!this.expr[$].equals(N.expr[$]))return!1;return!0}return!1}substituteConstants(){const N=t(this.expr);return N===this.expr?this:h.create(N,this.c,!1)}evaluate(N){for(let $=0,T=this.expr.length;$<T;$++)if(!this.expr[$].evaluate(N))return!1;return!0}static d(N,$,T){const L=[];let V=!1;for(const j of N)if(!!j){if(j.type===1){V=!0;continue}if(j.type===0)return w.INSTANCE;if(j.type===6){L.push(...j.expr);continue}L.push(j)}if(L.length===0&&V)return m.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];L.sort(O);for(let j=1;j<L.length;j++)L[j-1].equals(L[j])&&(L.splice(j,1),j--);if(L.length===1)return L[0];for(;L.length>1;){const j=L[L.length-1];if(j.type!==9)break;L.pop();const le=L.pop(),Y=L.length===0,pe=a.create(j.expr.map(ue=>h.create([ue,le],null,T)),null,Y);pe&&(L.push(pe),L.sort(O))}if(L.length===1)return L[0];if(T){for(let j=0;j<L.length;j++)for(let le=j+1;le<L.length;le++)if(L[j].negate().equals(L[le]))return w.INSTANCE;if(L.length===1)return L[0]}return new h(L,$)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const $ of this.expr)N.push(...$.keys());return N}map(N){return new h(this.expr.map($=>$.map(N)),null)}negate(){if(!this.c){const N=[];for(const $ of this.expr)N.push($.negate());this.c=a.create(N,this,!0)}return this.c}}class a{static create(N,$,T){return a.d(N,$,T)}constructor(N,$){this.expr=N,this.c=$,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let $=0,T=this.expr.length;$<T;$++){const L=O(this.expr[$],N.expr[$]);if(L!==0)return L}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let $=0,T=this.expr.length;$<T;$++)if(!this.expr[$].equals(N.expr[$]))return!1;return!0}return!1}substituteConstants(){const N=t(this.expr);return N===this.expr?this:a.create(N,this.c,!1)}evaluate(N){for(let $=0,T=this.expr.length;$<T;$++)if(this.expr[$].evaluate(N))return!0;return!1}static d(N,$,T){let L=[],V=!1;if(N){for(let j=0,le=N.length;j<le;j++){const Y=N[j];if(!!Y){if(Y.type===0){V=!0;continue}if(Y.type===1)return m.INSTANCE;if(Y.type===9){L=L.concat(Y.expr);continue}L.push(Y)}}if(L.length===0&&V)return w.INSTANCE;L.sort(O)}if(L.length!==0){if(L.length===1)return L[0];for(let j=1;j<L.length;j++)L[j-1].equals(L[j])&&(L.splice(j,1),j--);if(L.length===1)return L[0];if(T){for(let j=0;j<L.length;j++)for(let le=j+1;le<L.length;le++)if(L[j].negate().equals(L[le]))return m.INSTANCE;if(L.length===1)return L[0]}return new a(L,$)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const $ of this.expr)N.push(...$.keys());return N}map(N){return new a(this.expr.map($=>$.map(N)),null)}negate(){if(!this.c){const N=[];for(const $ of this.expr)N.push($.negate());for(;N.length>1;){const $=N.shift(),T=N.shift(),L=[];for(const V of Z($))for(const j of Z(T))L.push(h.create([V,j],null,!1));N.unshift(a.create(L,null,!1))}this.c=a.create(N,this,!0)}return this.c}}class u extends b{static all(){return u.d.values()}constructor(N,$,T){super(N,null),this.f=$,typeof T=="object"?u.d.push({...T,key:N}):T!==!0&&u.d.push({key:N,description:T,type:$!=null?typeof $:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return f.create(this.key,N)}notEqualsTo(N){return l.create(this.key,N)}}e.RawContextKey=u,u.d=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService");function g(x,N){return x<N?-1:x>N?1:0}function R(x,N,$,T){return x<$?-1:x>$?1:N<T?-1:N>T?1:0}function F(x,N){if(x.type===0||N.type===1)return!0;if(x.type===9)return N.type===9?q(x.expr,N.expr):!1;if(N.type===9){for(const $ of N.expr)if(F(x,$))return!0;return!1}if(x.type===6){if(N.type===6)return q(N.expr,x.expr);for(const $ of x.expr)if(F($,N))return!0;return!1}return x.equals(N)}e.implies=F;function q(x,N){let $=0,T=0;for(;$<x.length&&T<N.length;){const L=x[$].cmp(N[T]);if(L<0)return!1;L===0&&$++,T++}return $===x.length}function Z(x){return x.type===9?x.expr:[x]}}),define(Ie[157],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[90],Ce([1,0,132,3]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function S(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=S;function M(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function I(l,v){switch(l){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function A(l,v){return v==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(l,v,E){return A(v,E)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===E?!0:k(E).includes(l)}e.isTargetPlatformCompatible=y;function k(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function O(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=O;var w;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var m;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var b;(function(l){l.Install="install",l.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var s;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(s=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(v,E){super(v),this.code=E,this.name=E}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ie[36],Ce([1,0,46,19,10,9,2,134,3,20]),function(te,e,n,C,S,M,I,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function O(Y){return Y.create===!0}e.isFileOpenForWriteOptions=O;var w;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(w=e.FileType||(e.FileType={}));var m;(function(Y){Y[Y.Readonly=1]="Readonly"})(m=e.FilePermission||(e.FilePermission={}));var b;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileClone=32768]="FileClone"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(Y){return!!(Y.capabilities&2)}e.hasReadWriteCapability=f;function s(Y){return!!(Y.capabilities&8)}e.hasFileFolderCopyCapability=s;function o(Y){return!!(Y.capabilities&32768)}e.hasFileCloneCapability=o;function l(Y){return!!(Y.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function v(Y){return!!(Y.capabilities&16)}e.hasFileReadStreamCapability=v;function E(Y){return f(Y)?!!(Y.capabilities&16384):!1}e.hasFileAtomicReadCapability=E;var P;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(pe,ue){super(pe),this.code=ue}}e.FileSystemProviderError=p;function r(Y,pe){const ue=new p(Y.toString(),pe);return i(ue,pe),ue}e.createFileSystemProviderError=r;function d(Y){return Y||r((0,A.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=d;function i(Y,pe){return Y.name=pe?`${pe} (FileSystemError)`:"FileSystemError",Y}e.markAsFileSystemProviderError=i;function c(Y){if(!Y)return P.Unknown;if(Y instanceof p)return Y.code;const pe=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!pe)return P.Unknown;switch(pe[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=c;function t(Y){if(Y instanceof F)return Y.fileOperationResult;switch(c(Y)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var h;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(h=e.FileOperation||(e.FileOperation={}));class a{constructor(pe,ue,de){this.resource=pe,this.operation=ue,this.target=de}isOperation(pe){return this.operation===pe}}e.FileOperationEvent=a;var u;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class g{constructor(pe,ue){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const de=new Map;for(const re of pe){const G=de.get(re.type);switch(G?G.push([re.resource,re]):de.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,G]of de)switch(re){case 1:this.a=n.TernarySearchTree.forUris(()=>ue),this.a.fill(G);break;case 0:this.b=n.TernarySearchTree.forUris(()=>ue),this.b.fill(G);break;case 2:this.c=n.TernarySearchTree.forUris(()=>ue),this.c.fill(G);break}}contains(pe,...ue){return this.d(pe,{includeChildren:!1},...ue)}affects(pe,...ue){return this.d(pe,{includeChildren:!0},...ue)}d(pe,ue,...de){if(!pe)return!1;const re=de.length>0;return!!((!re||de.includes(1))&&(this.a?.get(pe)||ue.includeChildren&&this.a?.findSuperstr(pe))||(!re||de.includes(0))&&(this.b?.get(pe)||ue.includeChildren&&this.b?.findSuperstr(pe))||(!re||de.includes(2))&&(this.c?.findSubstr(pe)||ue.includeChildren&&this.c?.findSuperstr(pe)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=g;function R(Y,pe,ue){return!Y||!pe||Y===pe||pe.length>Y.length?!1:(pe.charAt(pe.length-1)!==C.sep&&(pe+=C.sep),ue?(0,S.startsWithIgnoreCase)(Y,pe):Y.indexOf(pe)===0)}e.isParent=R;class F extends Error{constructor(pe,ue,de){super(pe),this.fileOperationResult=ue,this.options=de}}e.FileOperationError=F;class q extends F{constructor(pe,ue,de,re){super(pe,ue,re),this.fileOperationResult=ue,this.size=de}}e.TooLargeFileOperationError=q;class Z extends F{constructor(pe,ue,de){super(pe,2,de),this.stat=ue}}e.NotModifiedSinceFileOperationError=Z;var x;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",Y[Y.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(x=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var N;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(N=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}e.etag=$;async function T(Y,pe){if(!pe.hasProvider(I.URI.from({scheme:Y.scheme})))return new Promise(ue=>{const de=pe.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===Y.scheme&&re.added&&(de.dispose(),ue())})})}e.whenProviderRegistered=T,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(pe){return(0,M.isNumber)(pe)||(pe=0),pe<L.KB?(0,A.localize)(1,null,pe.toFixed(0)):pe<L.MB?(0,A.localize)(2,null,(pe/L.KB).toFixed(2)):pe<L.GB?(0,A.localize)(3,null,(pe/L.MB).toFixed(2)):pe<L.TB?(0,A.localize)(4,null,(pe/L.GB).toFixed(2)):(0,A.localize)(5,null,(pe/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var V;(function(Y){Y[Y.IA32=0]="IA32",Y[Y.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function j(Y){return{maxFileSize:Y===0?300*L.MB:16*L.GB,maxHeapSize:Y===0?700*L.MB:2*700*L.MB}}e.getPlatformFileLimits=j;function le(Y){return k.isWeb?Y?10*L.MB:50*L.MB:Y?100*L.MB:1024*L.MB}e.getLargeFileConfirmationLimit=le}),define(Ie[67],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...S){this.a=new Map;for(const[M,I]of S)this.set(M,I)}set(S,M){const I=this.a.get(S);return this.a.set(S,M),I}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.ServiceCollection=n}),define(Ie[158],Ce([1,0,16,11,6,89,156,3,67,159]),function(te,e,n,C,S,M,I,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class w extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class m{constructor(o=new y.ServiceCollection,l=!1,v,E=O){this.f=o,this.g=l,this.h=v,this.i=E,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=E?v?._globalGraph??new I.Graph(P=>P):void 0}createChild(o){return new m(o,this.g,this,this.i)}invokeFunction(o,...l){const v=f.traceInvocation(this.i,o);let E=!1;try{return o({get:p=>{if(E)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const r=this.m(p,v);if(!r)throw new Error(`[invokeFunction] unknown service '${p}'`);return r}},...l)}finally{E=!0,v.stop()}}createInstance(o,...l){let v,E;return o instanceof M.SyncDescriptor?(v=f.traceCreation(this.i,o.ctor),E=this.j(o.ctor,o.staticArguments.concat(l),v)):(v=f.traceCreation(this.i,o),E=this.j(o,l,v)),v.stop(),E}j(o,l=[],v){const E=A._util.getServiceDependencies(o).sort((r,d)=>r.index-d.index),P=[];for(const r of E){const d=this.m(r.id,v);d||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${r.id}.`,!1),P.push(d)}const p=E.length>0?E[0].index:l.length;if(l.length!==p){console.trace(`[createInstance] First service dependency of ${o.name} at position ${p+1} conflicts with ${l.length} static arguments`);const r=p-l.length;r>0?l=l.concat(new Array(r)):l=l.slice(0,p)}return Reflect.construct(o,l.concat(P))}k(o,l){if(this.f.get(o)instanceof M.SyncDescriptor)this.f.set(o,l);else if(this.h)this.h.k(o,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const l=this.f.get(o);return!l&&this.h?this.h.l(o):l}m(o,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const v=this.l(o);return v instanceof M.SyncDescriptor?this.q(o,v,l.branch(o,!0)):(l.branch(o,!1),v)}q(o,l,v){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,l,v)}finally{this.o.delete(o)}}r(o,l,v){const E=new I.Graph(r=>r.id.toString());let P=0;const p=[{id:o,desc:l,_trace:v}];for(;p.length;){const r=p.pop();if(E.lookupOrInsertNode(r),P++>1e3)throw new w(E);for(const d of A._util.getServiceDependencies(r.desc.ctor)){const i=this.l(d.id);if(i||this.u(`[createInstance] ${o} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(d.id)),i instanceof M.SyncDescriptor){const c={id:d.id,desc:i,_trace:r._trace.branch(d.id,!0)};E.insertEdge(r,c),p.push(c)}}}for(;;){const r=E.roots();if(r.length===0){if(!E.isEmpty())throw new w(E);break}for(const{data:d}of r){if(this.l(d.id)instanceof M.SyncDescriptor){const c=this.s(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.k(d.id,c)}E.removeNode(d)}}return this.l(o)}s(o,l,v=[],E,P){if(this.f.get(o)instanceof M.SyncDescriptor)return this.t(o,l,v,E,P);if(this.h)return this.h.s(o,l,v,E,P);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(o,l,v=[],E,P){if(E){const p=new m(void 0,this.g,this,this.i);p.c=String(o);const r=new Map,d=new n.IdleValue(()=>{const i=p.j(l,v,P);for(const[c,t]of r){const h=i[c];if(typeof h=="function")for(const a of t)h.apply(i,a)}return r.clear(),i});return new Proxy(Object.create(null),{get(i,c){if(!d.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let a=r.get(c);return a||(a=new k.LinkedList,r.set(c,a)),(g,R,F)=>{const q=a.push([g,R,F]);return(0,S.toDisposable)(q)}}if(c in i)return i[c];const t=d.value;let h=t[c];return typeof h!="function"||(h=h.bind(t),i[c]=h),h},set(i,c,t){return d.value[c]=t,!0},getPrototypeOf(i){return l.prototype}})}else return this.j(l,v,P)}u(o,l){if(l&&console.warn(o),this.g)throw new Error(o)}}e.InstantiationService=m;var b;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(b||(b={}));class f{static traceInvocation(o,l){return o?new f(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(o,l){return o?new f(1,l.name):f.c}constructor(o,l){this.type=o,this.name=l,this.g=Date.now(),this.h=[]}branch(o,l){const v=new f(3,o.toString());return this.h.push([o,l,v]),v}stop(){const o=Date.now()-this.g;f.f+=o;let l=!1;function v(P,p){const r=[],d=new Array(P+1).join("	");for(const[i,c,t]of p.h)if(c&&t){l=!0,r.push(`${d}CREATES -> ${i}`);const h=v(P+1,t);h&&r.push(h)}else r.push(`${d}uses -> ${i}`);return r.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(o>2||l)&&f.all.add(E.join(`
`))}}e.Trace=f,f.all=new Set,f.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f.f=0}),define(Ie[12],Ce([1,0,39,4,6,28,20,2,3]),function(te,e,n,C,S,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function k(){return new Date().toISOString()}var O;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(O=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=O.Info;function w(h,a,u){switch(a){case O.Trace:h.trace(u);break;case O.Debug:h.debug(u);break;case O.Info:h.info(u);break;case O.Warning:h.warn(u);break;case O.Error:h.error(u);break;case O.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=w;function m(h){let a="";for(let u=0;u<h.length;u++){let g=h[u];if(typeof g=="object")try{g=JSON.stringify(g)}catch{}a+=(u>0?" ":"")+g}return a}e.format=m;class b extends S.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new C.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}f(a){return this.b!==O.Off&&this.b<=a}}e.AbstractLogger=b;class f extends b{constructor(a){super(),this.h=a}f(a){return this.h||super.f(a)}trace(a,...u){this.f(O.Trace)&&this.g(O.Trace,m([a,...u]))}debug(a,...u){this.f(O.Debug)&&this.g(O.Debug,m([a,...u]))}info(a,...u){this.f(O.Info)&&this.g(O.Info,m([a,...u]))}warn(a,...u){this.f(O.Warning)&&this.g(O.Warning,m([a,...u]))}error(a,...u){if(this.f(O.Error))if(a instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=a.stack,this.g(O.Error,m(g))}else this.g(O.Error,m([a,...u]))}flush(){}}e.AbstractMessageLogger=f;class s extends b{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.g=!I.isWindows}trace(a,...u){this.f(O.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,a,...u):console.log(`[main ${k()}]`,a,...u))}debug(a,...u){this.f(O.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,a,...u):console.log(`[main ${k()}]`,a,...u))}info(a,...u){this.f(O.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,a,...u):console.log(`[main ${k()}]`,a,...u))}warn(a,...u){this.f(O.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,a,...u):console.warn(`[main ${k()}]`,a,...u))}error(a,...u){this.f(O.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,a,...u):console.error(`[main ${k()}]`,a,...u))}dispose(){}flush(){}}e.ConsoleMainLogger=s;class o extends b{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...u){this.f(O.Trace)&&console.log("%cTRACE","color: #888",a,...u)}debug(a,...u){this.f(O.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",a,...u)}info(a,...u){this.f(O.Info)&&console.log("%c INFO","color: #33f",a,...u)}warn(a,...u){this.f(O.Warning)&&console.log("%c WARN","color: #993",a,...u)}error(a,...u){this.f(O.Error)&&console.log("%c  ERR","color: #f33",a,...u)}dispose(){}flush(){}}e.ConsoleLogger=o;class l extends b{constructor(a,u=e.DEFAULT_LOG_LEVEL){super(),this.g=a,this.setLevel(u)}trace(a,...u){this.f(O.Trace)&&this.g.log(O.Trace,[this.h(a),...u])}debug(a,...u){this.f(O.Debug)&&this.g.log(O.Debug,[this.h(a),...u])}info(a,...u){this.f(O.Info)&&this.g.log(O.Info,[this.h(a),...u])}warn(a,...u){this.f(O.Warning)&&this.g.log(O.Warning,[this.h(a),...u])}error(a,...u){this.f(O.Error)&&this.g.log(O.Error,[this.h(a),...u])}h(a){return typeof a=="string"?a:(0,n.toErrorMessage)(a,this.f(O.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class v extends b{constructor(a){super(),this.g=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const u of this.g)u.setLevel(a);super.setLevel(a)}trace(a,...u){for(const g of this.g)g.trace(a,...u)}debug(a,...u){for(const g of this.g)g.debug(a,...u)}info(a,...u){for(const g of this.g)g.info(a,...u)}warn(a,...u){for(const g of this.g)g.warn(a,...u)}error(a,...u){for(const g of this.g)g.error(a,...u)}flush(){for(const a of this.g)a.flush()}dispose(){for(const a of this.g)a.dispose()}}e.MultiplexLogService=v;class E extends S.Disposable{constructor(a){super(),this.b=a,this.B(a)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(a){this.b.setLevel(a)}getLevel(){return this.b.getLevel()}trace(a,...u){this.b.trace(a,...u)}debug(a,...u){this.b.debug(a,...u)}info(a,...u){this.b.info(a,...u)}warn(a,...u){this.b.warn(a,...u)}error(a,...u){this.b.error(a,...u)}flush(){this.b.flush()}}e.LogService=E;class P extends S.Disposable{constructor(a,u){super(),this.c=a,this.b=new M.ResourceMap,this.B(u(g=>this.setLevel(g)))}getLoggers(){return[...this.b.values()].map(({logger:a})=>a)}getLogger(a){return this.b.get(a)?.logger}createLogger(a,u,g){let R=this.b.get(a)?.logger;return R||(g=u?.always?O.Trace:g,R=this.f(a,g??this.c,u),this.b.set(a,{logger:R,logLevel:g})),R}setLevel(a,u){const g=A.URI.isUri(a)?a:void 0,R=g?u:a;if(g){const F=this.b.get(g);F&&F.logLevel!==R&&(F.logLevel=R,F.logger.setLevel(R))}else this.c=R,this.b.forEach(({logLevel:F,logger:q})=>{F===void 0&&q.setLevel(this.c)})}getLogLevel(a){return this.b.get(a)?.logLevel}dispose(){this.b.forEach(({logger:a})=>a.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=P;class p{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(a){}getLevel(){return O.Info}trace(a,...u){}debug(a,...u){}info(a,...u){}warn(a,...u){}error(a,...u){}critical(a,...u){}dispose(){}flush(){}}e.NullLogger=p;class r extends p{}e.NullLogService=r;class d extends P{constructor(){super(O.Info,C.Event.None)}f(a,u,g){return new p}}e.NullLoggerService=d;function i(h){if(h.verbose)return O.Trace;if(typeof h.logLevel=="string"){const a=t(h.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function c(h){switch(h){case O.Trace:return"trace";case O.Debug:return"debug";case O.Info:return"info";case O.Warning:return"warn";case O.Error:return"error";case O.Off:return"off"}}e.LogLevelToString=c;function t(h){switch(h){case"trace":return O.Trace;case"debug":return O.Debug;case"info":return O.Info;case"warn":return O.Warning;case"error":return O.Error;case"critical":return O.Error;case"off":return O.Off}}e.parseLogLevel=t}),define(Ie[91],Ce([1,0,30,135,3]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var I;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function k(f,s){return s-f}y.compare=k;const O=Object.create(null);O[y.Error]=(0,C.localize)(0,null),O[y.Warning]=(0,C.localize)(1,null),O[y.Info]=(0,C.localize)(2,null);function w(f){return O[f]||""}y.toString=w;function m(f){switch(f){case n.default.Error:return y.Error;case n.default.Warning:return y.Warning;case n.default.Info:return y.Info;case n.default.Ignore:return y.Hint}}y.fromSeverity=m;function b(f){switch(f){case y.Error:return n.default.Error;case y.Warning:return n.default.Warning;case y.Info:return n.default.Info;case y.Hint:return n.default.Ignore}}y.toSeverity=b}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const k="";function O(m){return w(m,!0)}y.makeKey=O;function w(m,b){const f=[k];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(k),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(k),m.severity!==void 0&&m.severity!==null?f.push(I.toString(m.severity)):f.push(k),m.message&&b?f.push(m.message.replace("\xA6","\\\xA6")):f.push(k),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(k),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(k),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(k),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(k),f.push(k),f.join("\xA6")}y.makeKeyOptionalMessage=w})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,S.createDecorator)("markerService")}),define(Ie[160],Ce([1,0,4,30,3]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=C.default,e.INotificationService=(0,S.createDecorator)("notificationService");var M;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=y}),define(Ie[92],Ce([1,0,10,2,3]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,S.createDecorator)("openerService");function M(k,O){return C.URI.isUri(k)?(0,n.equalsIgnoreCase)(k.scheme,O):(0,n.startsWithIgnoreCase)(k,O+":")}e.matchesScheme=M;function I(k,...O){return O.some(w=>M(k,w))}e.matchesSomeScheme=I;function A(k,O){return k.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=A;function y(k){let O;const w=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return w&&(O={startLineNumber:parseInt(w[1]),startColumn:w[2]?parseInt(w[2]):1,endLineNumber:w[4]?parseInt(w[4]):void 0,endColumn:w[4]?w[5]?parseInt(w[5]):1:void 0},k=k.with({fragment:""})),{selection:O,uri:k}}e.extractSelection=y}),define(Ie[161],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(te,e,n,C){var S=arguments.length,M=S<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,n):C,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(te,e,n,C);else for(var A=te.length-1;A>=0;A--)(I=te[A])&&(M=(S<3?I(M):S>3?I(e,n,M):I(e,n))||M);return S>3&&M&&Object.defineProperty(e,n,M),M},Ve=this&&this.__param||function(te,e){return function(n,C){e(n,C,te)}};define(Ie[162],Ce([1,0,16,21,6,3]),function(te,e,n,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var I;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(w){this.b=w}report(w){this.a=w,this.b(this.a)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends S.Disposable{constructor(w,m){super(),this.a=new n.DeferredPromise,m.withProgress(w,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,S.toDisposable)(()=>this.a.complete()))}report(w){this.b?this.b.report(w):this.c=w}};y=qe([Ve(1,e.IProgressService)],y),e.UnmanagedProgress=y;class k extends S.Disposable{constructor(w){super(),this.g=w,this.a=0,this.b=this.B(new S.DisposableStore)}start(w){this.stop();const m=++this.a,b=new C.CancellationTokenSource;return this.f=setTimeout(()=>{m===this.a&&(this.c=this.g.show(!0))},w),this.b.add((0,S.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,S.toDisposable)(()=>b.cancel())),this.b.add((0,S.toDisposable)(()=>this.c?this.c.done():void 0)),{id:m,token:b.token,stop:()=>this.h(m),isCurrent:()=>this.a===m}}stop(){this.h(this.a)}h(w){this.a===w&&this.b.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Ie[29],Ce([1,0,47,9]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.a=new Map}add(I,A){n.ok(C.isString(I)),n.ok(C.isObject(A)),n.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,A)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.Registry=new S}),define(Ie[68],Ce([1,0,4,29]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class M{constructor(){this.b=new n.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,k){this.a[S(y)]=k,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const I=new M;C.Registry.add(e.Extensions.JSONContribution,I)}),define(Ie[93],Ce([1,0,18,4,9,131,41,68,29]),function(te,e,n,C,S,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=y.Registry.as(A.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new C.Emitter,this.onDidSchemaChange=this.i.event,this.j=new C.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(r,d=!0){this.registerConfigurations([r],d)}registerConfigurations(r,d=!0){const i=new Set;this.n(r,d,i),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(r){const d=new Set;this.o(r,d),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:r,remove:d}){const i=new Set;this.o(d,i),this.n(r,!1,i),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(r){const d=new Set;this.k(r,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(r,d){const i=[];for(const{overrides:c,source:t}of r)for(const h in c)if(d.add(h),e.OVERRIDE_PROPERTY_REGEX.test(h)){const a=this.a.get(h),u=a?.valuesSources??new Map;if(t)for(const q of Object.keys(c[h]))u.set(q,t);const g={...a?.value||{},...c[h]};this.a.set(h,{source:t,value:g,valuesSources:u});const R=(0,I.getLanguageTagSettingPlainKey)(h),F={type:"object",default:g,description:M.localize(1,null,R),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:S.isString(t)?void 0:t,defaultValueSource:t};i.push(...s(h)),this.d[h]=F,this.b.properties[h]=F}else{this.a.set(h,{value:c[h],source:t});const a=this.d[h];a&&(this.w(h,a),this.r(h,a))}this.m(i)}deregisterDefaultConfigurations(r){const d=new Set;this.l(r,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(r,d){for(const{overrides:i,source:c}of r)for(const t in i){const h=this.a.get(t),a=S.isString(c)?c:c?.id,u=S.isString(h?.source)?h?.source:h?.source?.id;if(a===u)if(d.add(t),this.a.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.d[t],delete this.b.properties[t];else{const g=this.d[t];g&&(this.w(t,g),this.r(t,g))}}this.u()}deltaConfiguration(r){let d=!1;const i=new Set;r.removedDefaults&&(this.l(r.removedDefaults,i),d=!0),r.addedDefaults&&(this.k(r.addedDefaults,i),d=!0),r.removedConfigurations&&this.o(r.removedConfigurations,i),r.addedConfigurations&&this.n(r.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const d of r)this.h.add(d);this.u()}n(r,d,i){r.forEach(c=>{this.p(c,d,c.extensionInfo,c.restrictedProperties,void 0,i),this.c.push(c),this.q(c)})}o(r,d){const i=c=>{if(c.properties)for(const t in c.properties){d.add(t);const h=this.d[t];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[t],this.s(t,c.properties[t])}c.allOf?.forEach(t=>i(t))};for(const c of r){i(c);const t=this.c.indexOf(c);t!==-1&&this.c.splice(t,1)}}p(r,d=!0,i,c,t=3,h){t=S.isUndefinedOrNull(r.scope)?t:r.scope;const a=r.properties;if(a)for(const g in a){const R=a[g];if(d&&E(g,R)){delete a[g];continue}if(R.source=i,R.defaultDefaultValue=a[g].default,this.w(g,R),e.OVERRIDE_PROPERTY_REGEX.test(g)?R.scope=void 0:(R.scope=S.isUndefinedOrNull(R.scope)?t:R.scope,R.restricted=S.isUndefinedOrNull(R.restricted)?!!c?.includes(g):R.restricted),a[g].hasOwnProperty("included")&&!a[g].included){this.f[g]=a[g],delete a[g];continue}else this.d[g]=a[g],a[g].policy?.name&&this.e.set(a[g].policy.name,g);!a[g].deprecationMessage&&a[g].markdownDeprecationMessage&&(a[g].deprecationMessage=a[g].markdownDeprecationMessage),h.add(g)}const u=r.allOf;if(u)for(const g of u)this.p(g,d,i,c,t,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const d=i=>{const c=i.properties;if(c)for(const h in c)this.r(h,c[h]);i.allOf?.forEach(d)};d(r)}r(r,d){switch(e.allSettings.properties[r]=d,d.scope){case 1:e.applicationSettings.properties[r]=d;break;case 2:e.machineSettings.properties[r]=d;break;case 6:e.machineOverridableSettings.properties[r]=d;break;case 3:e.windowSettings.properties[r]=d;break;case 4:e.resourceSettings.properties[r]=d;break;case 5:e.resourceSettings.properties[r]=d,this.g.properties[r]=d;break}}s(r,d){switch(delete e.allSettings.properties[r],d.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const d=`[${r}]`,i={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(d,i),e.allSettings.properties[d]=i,e.applicationSettings.properties[d]=i,e.machineSettings.properties[d]=i,e.machineOverridableSettings.properties[d]=i,e.windowSettings.properties[d]=i,e.resourceSettings.properties[d]=i}}v(){const r={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this.i.fire()}w(r,d){const i=this.a.get(r);let c=i?.value,t=i?.source;S.isUndefined(c)&&(c=d.defaultDefaultValue,t=void 0),S.isUndefined(c)&&(c=l(d.type)),d.default=c,d.defaultValueSource=t}}const b="\\[([^\\]]+)\\]",f=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function s(p){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let d=f.exec(p);for(;d?.length;){const i=d[1].trim();i&&r.push(i),d=f.exec(p)}}return(0,n.distinct)(r)}e.overrideIdentifiersFromKey=s;function o(p){return p.reduce((r,d)=>`${r}[${d}]`,"")}e.keyFromOverrideIdentifiers=o;function l(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const v=new m;y.Registry.add(e.Extensions.Configuration,v);function E(p,r){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?M.localize(7,null,p):v.getConfigurationProperties()[p]!==void 0?M.localize(8,null,p):r.policy?.name&&v.getPolicyConfigurations().get(r.policy?.name)!==void 0?M.localize(9,null,p,r.policy?.name,v.getPolicyConfigurations().get(r.policy?.name)):null:M.localize(6,null)}e.validateProperty=E;function P(){const p=[],r=v.getConfigurationProperties();for(const d of Object.keys(r))p.push([d,r[d].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=P}),define(Ie[163],Ce([1,0,18,4,111,6,28,22,9,2,41,93,29]),function(te,e,n,C,S,M,I,A,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function b(d){return Object.isFrozen(d)?d:A.deepFreeze(d)}class f{constructor(i={},c=[],t=[],h){this.b=i,this.c=c,this.d=t,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(c=>{if(c instanceof f)return c;const t=new s("");return t.parseRaw(c),t.configurationModel});this.f=i.reduce((c,t)=>t===c?t:c.merge(t),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,O.getConfigurationValue)(this.contents,i):this.contents}inspect(i,c){const t=this.rawConfiguration.getValue(i),h=c?this.rawConfiguration.getOverrideValue(i,c):void 0,a=c?this.rawConfiguration.override(c).getValue(i):t;return{value:t,override:h,merged:a}}getOverrideValue(i,c){const t=this.i(c);return t?i?(0,O.getConfigurationValue)(t,i):t:void 0}getKeysForOverrideIdentifier(i){const c=[];for(const t of this.overrides)t.identifiers.includes(i)&&c.push(...t.keys);return n.distinct(c)}getAllOverrideIdentifiers(){const i=[];for(const c of this.overrides)i.push(...c.identifiers);return n.distinct(i)}override(i){let c=this.a.get(i);return c||(c=this.g(i),this.a.set(i,c)),c}merge(...i){const c=A.deepClone(this.contents),t=A.deepClone(this.overrides),h=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const u of i)if(a.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.h(c,u.contents);for(const g of u.overrides){const[R]=t.filter(F=>n.equals(F.identifiers,g.identifiers));R?(this.h(R.contents,g.contents),R.keys.push(...g.keys),R.keys=n.distinct(R.keys)):t.push(A.deepClone(g))}for(const g of u.keys)h.indexOf(g)===-1&&h.push(g)}return new f(c,h,t,a.every(u=>u instanceof f)?void 0:a)}g(i){const c=this.i(i);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const t={};for(const h of n.distinct([...Object.keys(this.contents),...Object.keys(c)])){let a=this.contents[h];const u=c[h];u&&(typeof a=="object"&&typeof u=="object"?(a=A.deepClone(a),this.h(a,u)):a=u),t[h]=a}return new f(t,this.keys,this.overrides)}h(i,c){for(const t of Object.keys(c)){if(t in i&&y.isObject(i[t])&&y.isObject(c[t])){this.h(i[t],c[t]);continue}i[t]=A.deepClone(c[t])}}i(i){let c=null,t=null;const h=a=>{a&&(t?this.h(t,a):t=A.deepClone(a))};for(const a of this.overrides)n.equals(a.identifiers,[i])?c=a.contents:a.identifiers.includes(i)&&h(a.contents);return h(c),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,c){this.j(i,c,!0)}setValue(i,c){this.j(i,c,!1)}removeValue(i){const c=this.keys.indexOf(i);c!==-1&&(this.keys.splice(c,1),(0,O.removeFromValueTree)(this.contents,i),w.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(t=>n.equals(t.identifiers,(0,w.overrideIdentifiersFromKey)(i))),1))}j(i,c,t){(0,O.addToValueTree)(this.contents,i,c,h=>console.error(h)),t=t||this.keys.indexOf(i)===-1,t&&this.keys.push(i),w.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,O.toValuesTree)(this.contents[i],h=>console.error(h))})}}e.ConfigurationModel=f;class s{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,c){if(!y.isUndefinedOrNull(i)){const t=this.g(i);this.parseRaw(t,c)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,c){this.a=i;const{contents:t,keys:h,overrides:a,restricted:u,hasExcludedProperties:g}=this.h(i,c);this.b=new f(t,h,a,g?[i]:void 0),this.c=u||[]}g(i){let c={},t=null,h=[];const a=[],u=[];function g(F){Array.isArray(h)?h.push(F):t!==null&&(h[t]=F)}const R={onObjectBegin:()=>{const F={};g(F),a.push(h),h=F,t=null},onObjectProperty:F=>{t=F},onObjectEnd:()=>{h=a.pop()},onArrayBegin:()=>{const F=[];g(F),a.push(h),h=F,t=null},onArrayEnd:()=>{h=a.pop()},onLiteralValue:g,onError:(F,q,Z)=>{u.push({error:F,offset:q,length:Z})}};if(i)try{S.visit(i,R),c=h[0]||{}}catch(F){console.error(`Error while parsing settings file ${this.f}: ${F}`),this.d=[F]}return c}h(i,c){const t=m.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),h=this.i(i,t,!0,c);i=h.raw;const a=(0,O.toValuesTree)(i,R=>console.error(`Conflict in settings file ${this.f}: ${R}`)),u=Object.keys(i),g=this.j(i,R=>console.error(`Conflict in settings file ${this.f}: ${R}`));return{contents:a,keys:u,overrides:g,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(i,c,t,h){let a=!1;if(!h?.scopes&&!h?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:a};const u={},g=[];for(const R in i)if(w.OVERRIDE_PROPERTY_REGEX.test(R)&&t){const F=this.i(i[R],c,!1,h);u[R]=F.raw,a=a||F.hasExcludedProperties,g.push(...F.restricted)}else{const F=c[R],q=F?typeof F.scope<"u"?F.scope:3:void 0;F?.restricted&&g.push(R),(q===void 0||h.scopes===void 0||h.scopes.includes(q))&&!(h.skipRestricted&&F?.restricted)?u[R]=i[R]:a=!0}return{raw:u,restricted:g,hasExcludedProperties:a}}j(i,c){const t=[];for(const h of Object.keys(i))if(w.OVERRIDE_PROPERTY_REGEX.test(h)){const a={};for(const u in i[h])a[u]=i[h][u];t.push({identifiers:(0,w.overrideIdentifiersFromKey)(h),keys:Object.keys(a),contents:(0,O.toValuesTree)(a,c)})}return t}}e.ConfigurationModelParser=s;class o extends M.Disposable{constructor(i,c,t,h){super(),this.f=i,this.g=c,this.h=h,this.c=this.B(new C.Emitter),this.onDidChange=this.c.event,this.a=new s(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(t.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(C.Event.any(C.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),C.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new f}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=o;class l{constructor(i,c,t,h,a,u,g,R,F,q,Z,x,N){this.a=i,this.b=c,this.c=t,this.overrideIdentifiers=h,this.d=a,this.f=u,this.g=g,this.h=R,this.i=F,this.j=q,this.k=Z,this.l=x,this.m=N}get value(){return b(this.c)}n(i,c,t){const h=i.inspect(c,t);return{get value(){return b(h.value)},get override(){return b(h.override)},get merged(){return b(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class v{constructor(i,c,t,h,a=new f,u=new f,g=new I.ResourceMap,R=new f,F=new I.ResourceMap){this.c=i,this.d=c,this.f=t,this.g=h,this.h=a,this.i=u,this.j=g,this.l=R,this.m=F,this.a=null,this.b=new I.ResourceMap,this.n=null}getValue(i,c,t){return this.q(i,c,t).getValue(i)}updateValue(i,c,t={}){let h;t.resource?(h=this.m.get(t.resource),h||(h=new f,this.m.set(t.resource,h))):h=this.l,c===void 0?h.removeValue(i):h.setValue(i,c),t.resource||(this.a=null)}inspect(i,c,t){const h=this.q(i,c,t),a=this.u(c.resource,t),u=c.resource?this.m.get(c.resource)||this.l:this.l,g=new Set;for(const R of h.overrides)for(const F of R.identifiers)h.getOverrideValue(i,F)!==void 0&&g.add(F);return new l(i,c,h.getValue(i),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,u)}keys(i){const c=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,c){this.j.set(i,c),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,c){const t=[];if(!c){const{added:h,updated:a,removed:u}=p(this.c,i);c=[...h,...a,...u]}for(const h of c)for(const a of(0,w.overrideIdentifiersFromKey)(h)){const u=this.c.getKeysForOverrideIdentifier(a),g=i.getKeysForOverrideIdentifier(a),R=[...g.filter(F=>u.indexOf(F)===-1),...u.filter(F=>g.indexOf(F)===-1),...u.filter(F=>!A.equals(this.c.override(a).getValue(F),i.override(a).getValue(F)))];t.push([a,R])}return this.updateDefaultConfiguration(i),{keys:c,overrides:t}}compareAndUpdatePolicyConfiguration(i){const{added:c,updated:t,removed:h}=p(this.d,i),a=[...c,...t,...h];return a.length&&this.updatePolicyConfiguration(i),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:c,updated:t,removed:h,overrides:a}=p(this.applicationConfiguration,i),u=[...c,...t,...h];return u.length&&this.updateApplicationConfiguration(i),{keys:u,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:c,updated:t,removed:h,overrides:a}=p(this.localUserConfiguration,i),u=[...c,...t,...h];return u.length&&this.updateLocalUserConfiguration(i),{keys:u,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:c,updated:t,removed:h,overrides:a}=p(this.remoteUserConfiguration,i),u=[...c,...t,...h];return u.length&&this.updateRemoteUserConfiguration(i),{keys:u,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:c,updated:t,removed:h,overrides:a}=p(this.workspaceConfiguration,i),u=[...c,...t,...h];return u.length&&this.updateWorkspaceConfiguration(i),{keys:u,overrides:a}}compareAndUpdateFolderConfiguration(i,c){const t=this.p.get(i),{added:h,updated:a,removed:u,overrides:g}=p(t,c),R=[...h,...a,...u];return(R.length||!t)&&this.updateFolderConfiguration(i,c),{keys:R,overrides:g}}compareAndDeleteFolderConfiguration(i){const c=this.p.get(i);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:t,updated:h,removed:a,overrides:u}=p(c,void 0);return{keys:[...t,...h,...a],overrides:u}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,c,t){let h=this.r(c,t);return c.overrideIdentifier&&(h=h.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(h=h.merge(this.d)),h}r({resource:i},c){let t=this.s();if(c&&i){const h=c.getFolder(i);h&&(t=this.t(h.uri)||t);const a=this.m.get(i);a&&(t=t.merge(a))}return t}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let c=this.b.get(i);if(!c){const t=this.s(),h=this.j.get(i);h?(c=t.merge(h),this.b.set(i,c)):c=t}return c}u(i,c){if(c&&i){const t=c.getFolder(i);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,c)=>{const{contents:t,overrides:h,keys:a}=this.j.get(c);return i.push([c,{contents:t,overrides:h,keys:a}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(c=>i.add(c)),this.userConfiguration.keys.forEach(c=>i.add(c)),this.i.keys.forEach(c=>i.add(c)),this.j.forEach(c=>c.keys.forEach(t=>i.add(t))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(c=>i.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>i.add(c)),this.i.getAllOverrideIdentifiers().forEach(c=>i.add(c)),this.j.forEach(c=>c.getAllOverrideIdentifiers().forEach(t=>i.add(t))),[...i.values()]}w(i){const c=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(t=>c.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>c.add(t)),this.i.getKeysForOverrideIdentifier(i).forEach(t=>c.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(i).forEach(h=>c.add(h))),[...c.values()]}static parse(i){const c=this.x(i.defaults),t=this.x(i.policy),h=this.x(i.application),a=this.x(i.user),u=this.x(i.workspace),g=i.folders.reduce((R,F)=>(R.set(k.URI.revive(F[0]),this.x(F[1])),R),new I.ResourceMap);return new v(c,t,h,a,new f,u,g,new f,new I.ResourceMap)}static x(i){return new f(i.contents,i.keys,i.overrides)}}e.Configuration=v;function E(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const i=new Set,c=new Map;for(const h of d)h.keys.forEach(a=>i.add(a)),h.overrides.forEach(([a,u])=>{const g=(0,I.getOrSet)(c,a,new Set);u.forEach(R=>g.add(R))});const t=[];return c.forEach((h,a)=>t.push([a,[...h.values()]])),{keys:[...i.values()],overrides:t}}e.mergeChanges=E;class P{constructor(i,c,t,h){this.change=i,this.f=c,this.g=t,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of i.keys)this.affectedKeys.add(a);for(const[,a]of i.overrides)for(const u of a)this.affectedKeys.add(u);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=v.parse(this.f.data)),this.i}affectsConfiguration(i,c){const t=this.a+i,h=this.d.indexOf(t);if(h<0)return!1;const a=h+t.length;if(a>=this.d.length)return!1;const u=this.d.charCodeAt(a);if(u!==this.b&&u!==this.c)return!1;if(c){const g=this.previousConfiguration?this.previousConfiguration.getValue(i,c,this.f?.workspace):void 0,R=this.g.getValue(i,c,this.h);return!A.equals(g,R)}return!0}}e.ConfigurationChangeEvent=P;function p(d,i){const{added:c,removed:t,updated:h}=r(i?.rawConfiguration,d?.rawConfiguration),a=[],u=d?.getAllOverrideIdentifiers()||[],g=i?.getAllOverrideIdentifiers()||[];if(i){const R=g.filter(F=>!u.includes(F));for(const F of R)a.push([F,i.getKeysForOverrideIdentifier(F)])}if(d){const R=u.filter(F=>!g.includes(F));for(const F of R)a.push([F,d.getKeysForOverrideIdentifier(F)])}if(i&&d){for(const R of u)if(g.includes(R)){const F=r({contents:d.getOverrideValue(void 0,R)||{},keys:d.getKeysForOverrideIdentifier(R)},{contents:i.getOverrideValue(void 0,R)||{},keys:i.getKeysForOverrideIdentifier(R)});a.push([R,[...F.added,...F.removed,...F.updated]])}}return{added:c,removed:t,updated:h,overrides:a}}function r(d,i){const c=d?i?d.keys.filter(a=>i.keys.indexOf(a)===-1):[...d.keys]:[],t=i?d?i.keys.filter(a=>d.keys.indexOf(a)===-1):[...i.keys]:[],h=[];if(d&&i){for(const a of i.keys)if(d.keys.indexOf(a)!==-1){const u=(0,O.getConfigurationValue)(i.contents,a),g=(0,O.getConfigurationValue)(d.contents,a);A.equals(u,g)||h.push(a)}}return{added:c,removed:t,updated:h}}}),define(Ie[94],Ce([1,0,11,3]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,C.createDecorator)("remoteAuthorityResolverService");var S;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(S=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends n.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof M&&y._code===S.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof M&&y._code===S.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof M&&y._code===S.NoResolverFound}static isHandled(y){return y instanceof M&&y.isHandled}constructor(y,k=S.Unknown,O){super(y),this._message=y,this._code=k,this._detail=O,this.isHandled=k===S.NotAvailable&&O===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M;function I(A){const y=A.indexOf("+");return y===-1?A:A.substring(0,y)}e.getRemoteAuthorityPrefix=I}),define(Ie[48],Ce([1,0,15]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function C(k){return k.scheme===n.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=C;function S(k){if(!k)return;const O=k.indexOf("+");return O<0?k:k.substr(0,O)}e.getRemoteName=S;function M(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=M;function I(k){const{host:O,port:w}=y(k);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:w}}e.parseAuthorityWithPort=I;function A(k,O){let{host:w,port:m}=y(k);return typeof m>"u"&&(m=O),{host:w,port:m}}e.parseAuthorityWithOptionalPort=A;function y(k){const O=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const w=k.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const m=k.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:k,port:void 0}}}),define(Ie[25],Ce([1,0,10,3,48]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=M;function I(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var y;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(s){this.value=s,this.c=s.toLowerCase()}static equals(s,o){if(typeof s>"u"||s===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof s=="string"||typeof o=="string"){const l=typeof s=="string"?s:s.value,v=typeof o=="string"?o:o.value;return n.equalsIgnoreCase(l,v)}return s.c===o.c}static toKey(s){return typeof s=="string"?s.toLowerCase():s.c}}e.ExtensionIdentifier=k;function O(f){return w(f)}e.isApplicationScopedExtension=O;function w(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function b(f,s){if(s){const o=`onResolveRemoteAuthority:${(0,S.getRemoteName)(s)}`;return f.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[164],Ce([1,0,20,49,2,34]),function(te,e,n,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(k){if(n.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function A(k,O,w,m,b,f,s,o,l,v){const E=Object.create(null);E["common.machineId"]=s,E.sessionID=(0,M.generateUuid)()+Date.now(),E.commitHash=b,E.version=f,E["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,n.PlatformToString)(n.platform),E["common.nodePlatform"]=C.platform,E["common.nodeArch"]=m,E["common.product"]=v||"desktop",o&&(E["common.msftInternal"]=o);let P=0;const p=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),n.isLinuxSnap&&(E["common.snap"]="true");const r=I(w);r&&(E["common.platformDetail"]=r);try{const d=await k.readFile(S.URI.file(l));E["common.source"]=d.value.toString().slice(0,30)}catch{}return E}e.resolveCommonProperties=A;function y(k){const O=C.env.USERDNSDOMAIN;if(!O)return!1;const w=O.toLowerCase();return k.some(m=>w===m)}e.verifyMicrosoftInternalDomain=y}),define(Ie[165],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var C;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(C=e.TelemetryLevel||(e.TelemetryLevel={}));var S;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(S=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ie[50],Ce([1,0,22,9,4,41,48,164,165]),function(te,e,n,C,S,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class k{constructor(a){this.value=a}}e.TelemetryTrustedValue=k;class O{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,u){return Promise.resolve(void 0)}publicLog2(a,u){return this.publicLog(a,u)}publicLogError(a,u){return Promise.resolve(void 0)}publicLogError2(a,u){return this.publicLogError(a,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=O,e.NullTelemetryService=new O;class w{async publicLog(a,u,g){}async publicLogError(a,u,g){}}e.NullEndpointTelemetryService=w,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(h,a){return S.Event.debounce(a.onDidChangeConfiguration,(g,R)=>{const F=g?new Set([...g.affectedKeys,...R.affectedKeys]):R.affectedKeys;return{...R,affectedKeys:F}},1e3,!0)(g=>{g.source!==7&&h.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(g.source),configurationKeys:P(g.affectedKeys)})})}e.configurationTelemetry=m;function b(h,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!h.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=b;function f(h,a){return!(a.isBuilt||a.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}e.isLoggingOnly=f;function s(h){const a=h.getValue(y.TELEMETRY_SETTING_ID),u=h.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(h.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=s;function o(h){const a={},u={},g={};E(h,g);for(let R in g){R=R.length>150?R.substr(R.length-149):R;const F=g[R];typeof F=="number"?u[R]=F:typeof F=="boolean"?u[R]=F?1:0:typeof F=="string"?(F.length>8192&&console.warn(`Telemetry property: ${R} has been trimmed to 8192, the original length is ${F.length}`),a[R]=F.substring(0,8191)):typeof F<"u"&&F!==null&&(a[R]=F)}return{properties:a,measurements:u}}e.validateTelemetryData=o;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function v(h){if(!h)return"none";const a=(0,I.getRemoteName)(h);return l.has(a)?a:"other"}e.cleanRemoteAuthority=v;function E(h,a,u=0,g){if(!!h)for(const R of Object.getOwnPropertyNames(h)){const F=h[R],q=g?g+R:R;Array.isArray(F)?a[q]=(0,n.safeStringify)(F):F instanceof Date?a[q]=F.toISOString():(0,C.isObject)(F)?u<2?E(F,a,u+1,q+"."):a[q]=(0,n.safeStringify)(F):a[q]=F}}function P(h){if(!h)return[];const a=[];return p(a,"",h),a}function p(h,a,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(g=>p(h,a?`${a}.${g}`:g,u[g])):h.push(a)}function r(h,a){const u=h.msftInternalDomains||[],g=a.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(u)||g}e.isInternalTelemetry=r;function d(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}e.getPiiPathsFromEnvironment=d;function i(h,a){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let u=h;const g=[];for(const Z of a)for(;;){const x=Z.exec(h);if(!x)break;g.push([x.index,Z.lastIndex])}const R=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,F=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let q=0;for(u="";;){const Z=F.exec(h);if(!Z)break;const x=g.some(([N,$])=>Z.index<$&&N<F.lastIndex);!R.test(Z[0])&&!x&&(u+=h.substring(q,Z.index)+"<REDACTED: user-file-path>",q=F.lastIndex)}return q<h.length&&(u+=h.substr(q)),u}function c(h){if(!h)return h;const a=h.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of u)if(g.regex.test(a))return`<REDACTED: ${g.label}>`;return h}function t(h,a){return(0,n.cloneAndChange)(h,u=>{if(u instanceof k)return u.value;if(typeof u=="string"){let g=u.replaceAll("%20"," ");g=i(g,a);for(const R of a)g=g.replace(R,"");return g=c(g),g}})}e.cleanData=t}),define(Ie[166],Ce([1,0,10,90,25,20,2,11,49,50]),function(te,e,n,C,S,M,I,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function O(i,c){return i.uuid&&c.uuid?i.uuid===c.uuid:i.id===c.id?!0:(0,n.compareIgnoreCase)(i.id,c.id)===0}e.areSameExtensions=O;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(c){const t=c.manifest?c.manifest.version:c.version,h=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new m(c.identifier,t,h)}static parse(c){const t=w.exec(c);return t&&t[1]&&t[2]?new m({id:t[1]},t[2],t[4]||void 0):null}constructor(c,t,h="undefined"){this.version=t,this.targetPlatform=h,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof m?O(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=m;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(i){const c=b.exec(i);return c&&c[1]?[o(c[1]),c[2]]:[o(i),void 0]}e.getIdAndVersion=f;function s(i,c){return`${i}.${c}`}e.getExtensionId=s;function o(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=o;function l(i,c){return o(s(i,c))}e.getGalleryExtensionId=l;function v(i,c){const t=[],h=a=>{for(const u of t)if(u.some(g=>O(c(g),c(a))))return u;return null};for(const a of i){const u=h(a);u?u.push(a):t.push([a])}return t}e.groupByExtension=v;function E(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function P(i){return{id:new k.TelemetryTrustedValue(i.identifier.id),name:new k.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function p(i,c){const t=[],h=c.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const a=h.shift();if(a&&t.every(u=>!O(u.identifier,{id:a}))){const u=i.filter(g=>O(g.identifier,{id:a}));u.length===1&&(t.push(u[0]),h.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.getExtensionDependencies=p;async function r(i,c){if(!M.isLinux)return!1;let t;try{t=(await i.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await i.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){c.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=r;async function d(i,c){const t=await r(i,c),h=(0,C.getTargetPlatform)(t?"alpine":M.platform,y.arch);return c.debug("ComputeTargetPlatform:",h),h}e.computeTargetPlatform=d}),define(Ie[167],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function n(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=n;function C(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=C;function S(I){return Array.from(I.entries()).map(A=>[A[0],n(A[1].map)])}e.serializeEnvironmentVariableCollections=S;function M(I){return new Map(I.map(A=>[A[0],{map:C(A[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(Ie[168],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(S){this.b=S,this.a=new Map}dispose(){for(const S of this.a.values())S.dispose()}startBuffering(S,M,I=5){const A=M(y=>{const k=typeof y=="string"?y:y.data;let O=this.a.get(S);if(O){O.data.push(k);return}const w=setTimeout(()=>this.flushBuffer(S),I);O={data:[k],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(S),A.dispose()}},this.a.set(S,O)});return A}stopBuffering(S){this.a.get(S)?.dispose()}flushBuffer(S){const M=this.a.get(S);M&&(this.a.delete(S),this.b(S,M.data.join("")))}}e.TerminalDataBufferer=n}),define(Ie[169],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var n;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(n=e.ColorScheme||(e.ColorScheme={}));function C(M){return M===n.HIGH_CONTRAST_DARK||M===n.HIGH_CONTRAST_LIGHT}e.isHighContrast=C;function S(M){return M===n.DARK||M===n.HIGH_CONTRAST_DARK}e.isDark=S}),define(Ie[51],Ce([1,0,65,4,6,3,29,169]),function(te,e,n,C,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var y;(function(o){function l(v){return v&&typeof v=="object"&&typeof v.id=="string"}o.isThemeColor=l})(y=e.ThemeColor||(e.ThemeColor={}));function k(o){return{id:o}}e.themeColorFromId=k;var O;(function(o){function l(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||y.isThemeColor(c.color))}o.isThemeIcon=l;const v=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function E(c){const t=v.exec(c);if(!t)return;const[,h]=t;return{id:h}}o.fromString=E;function P(c){return{id:c}}o.fromId=P;function p(c,t){let h=c.id;const a=h.lastIndexOf("~");return a!==-1&&(h=h.substring(0,a)),t&&(h=`${h}~${t}`),{id:h}}o.modify=p;function r(c){const t=c.id.lastIndexOf("~");if(t!==-1)return c.id.substring(t+1)}o.getModifier=r;function d(c,t){return c.id===t.id&&c.color?.id===t.color?.id}o.isEqual=d;function i(c,t){return{id:c.id,color:t?k(t):void 0}}o.asThemeIcon=i,o.asClassNameArray=n.CSSIcon.asClassNameArray,o.asClassName=n.CSSIcon.asClassName,o.asCSSSelector=n.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function w(o){switch(o){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.a=[],this.a=[],this.b=new C.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,S.toDisposable)(()=>{const v=this.a.indexOf(l);this.a.splice(v,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const b=new m;I.Registry.add(e.Extensions.ThemingContribution,b);function f(o){return b.onColorThemeChange(o)}e.registerThemingParticipant=f;class s extends S.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(v=>this.n(v)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,v){let E=this.h.getColor(l);return E&&v&&(E=v(E,this.h)),E?E.toString():null}}e.Themable=s}),define(Ie[170],Ce([1,0,16,65,4,9,2,136,68,29,51]),function(te,e,n,C,S,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var w;(function(P){function p(r,d){let i=r.defaults;for(;O.ThemeIcon.isThemeIcon(i);){const c=f.getIcon(i.id);if(!c)return;i=c.defaults}return i}P.getDefinition=p})(w=e.IconContribution||(e.IconContribution={}));var m;(function(P){function p(d){return{weight:d.weight,style:d.style,src:d.src.map(i=>({format:i.format,location:i.location.toString()}))}}P.toJSONObject=p;function r(d){const i=c=>(0,M.isString)(c)?c:void 0;if(d&&Array.isArray(d.src)&&d.src.every(c=>(0,M.isString)(c.format)&&(0,M.isString)(c.location)))return{weight:i(d.weight),style:i(d.style),src:d.src.map(c=>({format:c.format,location:I.URI.parse(c.location)}))}}P.fromJSONObject=r})(m=e.IconFontDefinition||(e.IconFontDefinition={}));class b{constructor(){this.a=new S.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,r,d,i){const c=this.b[p];if(c){if(d&&!c.description){c.description=d,this.d.properties[p].markdownDescription=`${d} $(${p})`;const a=this.e.enum.indexOf(p);a!==-1&&(this.e.enumDescriptions[a]=d),this.a.fire()}return c}const t={id:p,description:d,defaults:r,deprecationMessage:i};this.b[p]=t;const h={$ref:"#/definitions/icons"};return i&&(h.deprecationMessage=i),d&&(h.markdownDescription=`${d}: $(${p})`),this.d.properties[p]=h,this.e.enum.push(p),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const r=this.e.enum.indexOf(p);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,r){const d=this.f[p];return d||(this.f[p]=r,this.a.fire(),r)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(c,t)=>c.id.localeCompare(t.id),r=c=>{for(;O.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const i=Object.keys(this.b).map(c=>this.b[c]);for(const c of i.filter(t=>!!t.description).sort(p))d.push(`|<i class="${r(c)}"></i>|${c.id}|${O.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const c of i.filter(t=>!O.ThemeIcon.isThemeIcon(t.defaults)).sort(p))d.push(`|<i class="${r(c)}"></i>|${c.id}|`);return d.join(`
`)}}const f=new b;k.Registry.add(e.Extensions.IconContribution,f);function s(P,p,r,d){return f.registerIcon(P,p,r,d)}e.registerIcon=s;function o(){return f}e.getIconRegistry=o;function l(){for(const P of C.Codicon.getAll())f.registerIcon(P.id,{fontCharacter:P.fontCharacter},P.description)}l(),e.iconsSchemaId="vscode://schemas/icons";const v=k.Registry.as(y.Extensions.JSONContribution);v.registerSchema(e.iconsSchemaId,f.getIconSchema());const E=new n.RunOnceScheduler(()=>v.notifySchemaChanged(e.iconsSchemaId),200);f.onDidChange(()=>{E.isScheduled()||E.schedule()}),e.widgetClose=s("widget-close",C.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=s("goto-previous-location",C.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=s("goto-next-location",C.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=O.ThemeIcon.modify(C.Codicon.sync,"spin"),e.spinningLoading=O.ThemeIcon.modify(C.Codicon.loading,"spin")}),define(Ie[171],Ce([1,0,4,41,3,12]),function(te,e,n,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,S.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,S.createDecorator)("sharedTunnelsService");var I;(function(s){s.Http="http",s.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}e.isAllInterfaces=w;function m(s,o,l,v){if(l===1)return!1;if(l===2&&w(o)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(E?.length===4&&parseInt(E[1])>=18)return!1}return s<1024}e.isPortPrivileged=m;class b{constructor(o,l,v){this.remoteAddress=o,this.localAddress=l,this.b=v,this.a=new n.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=b;let f=class{constructor(o,l){this.i=o,this.j=l,this.a=new n.Emitter,this.onTunnelOpened=this.a.event,this.b=new n.Emitter,this.onTunnelClosed=this.b.event,this.c=new n.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const o=this.j.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.e=o,o?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.f=o.elevation,this.g=o.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const o=[],l=Array.from(this.d.values());for(const v of l){const E=Array.from(v.values());for(const P of E){const p=await P.value;p&&o.push(p)}}return o}async dispose(){for(const o of this.d.values()){for(const{value:l}of o.values())await l.then(v=>v?.dispose());o.clear()}this.d.clear()}setEnvironmentTunnel(o,l,v,E,P){this.o(o,l,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:l,localAddress:v,privacy:E,protocol:P,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,l){(w(o)||O(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const v=this.q(o,l);if(v)return++v.refcount,v.value}openTunnel(o,l,v,E,P,p=!1,r,d){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${v} on local port ${P}.`),!o)return;if(l||(l="localhost"),E||(E=this.k),this.e&&this.h.has(v)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(o,l,v,E,P,p,r,d);return i?i.then(c=>{if(!c){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,v);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const t=this.m(c);return(c.tunnelRemoteHost!==l||c.tunnelRemotePort!==v)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(t),t}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const l=this.d.get(o.tunnelRemoteHost);if(l){const v=l.get(o.tunnelRemotePort);v&&(v.refcount--,await this.n(o.tunnelRemoteHost,o.tunnelRemotePort,v))}}}}async n(o,l,v){if(v.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${l}.`);const E=v.value.then(async P=>{P&&(await P.dispose(!0),this.b.fire({host:P.tunnelRemoteHost,port:P.tunnelRemotePort}))});return this.d.has(o)&&this.d.get(o).delete(l),E}}async closeTunnel(o,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${l} `);const v=this.d.get(o);if(v&&v.has(l)){const E=v.get(l);E.refcount=0,await this.n(o,l,E)}}o(o,l,v){this.d.has(o)||this.d.set(o,new Map),this.d.get(o).set(l,{refcount:1,value:v})}async p(o,l){const v=this.d.get(o);v&&(await v.get(l)||v.delete(l),v.size===0&&this.d.delete(o))}q(o,l){const v=[o];O(o)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):w(o)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const E=v.map(P=>this.d.get(P));for(const P of E){const p=P?.get(l);if(p)return p}}canTunnel(o){return!!k(o)}s(o,l,v,E,P,p,r){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${v} on local port ${E}.`);const d=v;this.h.add(d);const i=E===void 0?v:E,c={elevationRequired:P?this.isPortPrivileged(i):!1},t={remoteAddress:{host:l,port:v},localAddressPort:E,privacy:p,public:p?p!==A.Private:void 0,protocol:r},h=o.forwardPort(t,c);return h?(this.o(l,v,h),h.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(d)})):this.h.delete(d),h}};f=qe([Ve(0,M.ILogService),Ve(1,C.IConfigurationService)],f),e.AbstractTunnelService=f}),define(Ie[172],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,n.createDecorator)("editSessionIdentityService");var C;(function(S){S[S.Complete=100]="Complete",S[S.Partial=50]="Partial",S[S.None=0]="None"})(C=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ie[173],Ce([1,0,15]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function C(y){return y.scheme!==n.Schemas.file&&y.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=C;function S(y){if(y.folders.length)return y.folders.every(k=>C(k.uri))?y.folders[0].uri:void 0;if(y.configuration&&C(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=S;function M(y){return S(y)?.scheme}e.getVirtualWorkspaceScheme=M;function I(y){return S(y)?.authority}e.getVirtualWorkspaceAuthority=I;function A(y){return S(y)!==void 0}e.isVirtualWorkspace=A}),define(Ie[52],Ce([1,0,137,19,46,23,2,3,15]),function(te,e,n,C,S,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function k(i){const c=i;return typeof c?.id=="string"&&I.URI.isUri(c.uri)}e.isSingleFolderWorkspaceIdentifier=k;function O(i){return typeof i?.id=="string"&&!k(i)&&!m(i)}e.isEmptyWorkspaceIdentifier=O,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(i,c){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,C.basename)(i)}:c?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const t=i;return t.configuration?{id:t.id,configPath:t.configuration}:t.folders.length===1?{id:t.id,uri:t.folders[0].uri}:{id:t.id}}e.toWorkspaceIdentifier=w;function m(i){const c=i;return typeof c?.id=="string"&&I.URI.isUri(c.configPath)}e.isWorkspaceIdentifier=m;function b(i){const c=i;if(c?.uri)return{id:c.id,uri:I.URI.revive(c.uri)};const t=i;if(t?.configPath)return{id:t.id,configPath:I.URI.revive(t.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=b;var f;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function s(i){const c=i;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.isWorkspace=s;function o(i){const c=i;return!!(c&&typeof c=="object"&&I.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.isWorkspaceFolder=o;class l{constructor(c,t,h,a,u){this.h=c,this.j=h,this.k=a,this.l=u,this.c=S.TernarySearchTree.forUris(this.l,()=>!0),this.folders=t}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=S.TernarySearchTree.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class v{constructor(c,t){this.raw=t,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,M.joinPath)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=v;function E(i){return new v({uri:i,index:0,name:(0,M.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(i,c){return M.extUriBiasedIgnorePathCase.isEqualOrParent(i,c.untitledWorkspacesHome)}e.isUntitledWorkspace=P;function p(i){let c;return I.URI.isUri(i)?c=i:c=i.configuration,c?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=p;function r(i,c){return!P(i,c)&&!p(i)}e.isSavedWorkspace=r;function d(i){return(typeof i=="string"?(0,C.extname)(i):(0,M.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=d}),define(Ie[53],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(S){this.d=S,this.b=new Map,this.c=1}add(S){const M=this.c++;return this.b.set(M,S),this.e(),M}get(S,M){return this.b.has(S)?this.b.get(S)[M]:void 0}delete(S){this.b.delete(S),this.e()}e(){!n.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=n,n.a=!1}),define(Ie[37],Ce([1,0,15,23,3]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this.a=new Set(Object.keys(n.Schemas)),this.b=new Map,this.extUri=new C.ExtUri(A=>{const y=this.b.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this.b.delete(A.scheme):this.b.set(A.scheme,y)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,S.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[27],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(Ie[174],Ce([1,0,16]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class C{constructor(I,A,y){this.h=new Map,this.a=I,this.b=A,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new n.RunOnceScheduler(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of k.values())O.complete()}catch(O){for(const w of k.values())w.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this.d}get(I,A){let y=this.f[I];return typeof y>"u"&&(y=A),y}update(I,A){this.f[I]=A;const y=this.h.get(I);if(y!==void 0)return y.p;const k=new n.DeferredPromise;return this.h.set(I,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.ExtensionMemento=C;class S extends C{setKeysForSync(I){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},I)}constructor(I,A){super(I.identifier.value,!0,A),this.j=I}}e.ExtensionGlobalMemento=S}),define(Ie[175],Ce([1,0,4,2]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class S{constructor(I){this.c=I,this.a=new n.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new n.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(I,A,y,k){const w=this.c.getNotebookDocument(C.URI.revive(I)).acceptModelChanged(A.value,y,k);this.b.fire(w)}$acceptDirtyStateChanged(I,A){this.c.getNotebookDocument(C.URI.revive(I)).acceptDirty(A)}$acceptModelSaved(I){const A=this.c.getNotebookDocument(C.URI.revive(I));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=S}),define(Ie[17],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class C{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=C});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,n):S?S.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ie[176],Ce([1,0,25,4]),function(te,e,n,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(A,y){S.set(this,void 0),this.b=new C.Emitter,this.onDidChange=this.b.event,this.a=n.ExtensionIdentifier.toKey(A.identifier),Je(this,S,y,"f"),Oe(this,S,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(A){return Oe(this,S,"f").get(this.a,A)}store(A,y){return Oe(this,S,"f").store(this.a,A,y)}delete(A){return Oe(this,S,"f").delete(this.a,A)}}e.ExtensionSecrets=M,S=new WeakMap}),define(Ie[69],Ce([1,0,3,171,4,17]),function(te,e,n,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var I;(function(y){function k(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?C.TunnelPrivacyId.Public:C.TunnelPrivacyId.Private),protocol:w.protocol}}y.fromApiTunnel=k;function O(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==C.TunnelPrivacyId.ConstantPrivate&&w.privacy!==C.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}y.fromServiceTunnel=O})(I=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let A=class{constructor(k){this.onDidChangeTunnels=new S.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,O){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,O){return{dispose:()=>{}}}async $providePortAttributes(k,O,w,m,b){return[]}async $forwardPort(k,O){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=qe([Ve(0,M.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(Ie[54],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class C{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=C}),define(Ie[177],Ce([1,0,24]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(y){let k=this.buffers.indexOf(y);return k<0&&(k=this.buffers.length,this.buffers.push(y)),k}}function S(A,y){if(y.serializeBuffersForPostMessage){const k=new C,O=(b,f)=>{if(f instanceof ArrayBuffer){const s=k.add(f);return{$$vscode_array_buffer_reference$$:!0,index:s}}else if(ArrayBuffer.isView(f)){const s=M(f);if(s){const o=k.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:o,view:{type:s,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},w=JSON.stringify(A,O),m=k.buffers.map(b=>{const f=new Uint8Array(b);return n.VSBuffer.wrap(f)});return{message:w,buffers:m}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=S;function M(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(A,y){const k=y.map(m=>{const b=new ArrayBuffer(m.byteLength);return new Uint8Array(b).set(m.buffer),b}),O=y.length?(m,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const f=b,{index:s}=f,o=k[s];if(f.view)switch(f.view.type){case 1:return new Int8Array(o,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return b}:void 0;return{message:JSON.parse(A,O),arrayBuffers:k}}e.deserializeWebviewMessage=I}),define(Ie[95],Ce([1,0,145,9,2,6,3,29,36,15,39,123,30]),function(te,e,n,C,S,M,I,A,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var b;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(b=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var f;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(f=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function s(G){const H=G;return!!H&&typeof H.getSelection=="function"&&!!H.onDidChangeSelection}e.isEditorPaneWithSelection=s;function o(G,H,oe){for(const ve of oe.visibleEditorPanes)if(ve.group.id===H&&G.matches(ve.input))return ve.getViewState()}e.findViewStateForEditor=o;function l(G){if(u(G))return!1;const H=G;return S.URI.isUri(H?.resource)}e.isResourceEditorInput=l;function v(G){if(u(G))return!1;const H=G;return H?.original!==void 0&&H.modified!==void 0}e.isResourceDiffEditorInput=v;function E(G){if(u(G)||v(G))return!1;const H=G;return H?.primary!==void 0&&H.secondary!==void 0}e.isResourceSideBySideEditorInput=E;function P(G){if(u(G))return!1;const H=G;return H?H.resource===void 0||H.resource.scheme===k.Schemas.untitled||H.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=P;const p=/Untitled-\d+/;function r(G){return G.scheme===k.Schemas.untitled&&G.path.length>1&&!p.test(G.path)}e.isUntitledWithAssociatedResource=r;function d(G){if(u(G))return!1;const H=G;return S.URI.isUri(H?.base?.resource)&&S.URI.isUri(H?.input1?.resource)&&S.URI.isUri(H?.input2?.resource)&&S.URI.isUri(H?.result?.resource)}e.isResourceMergeEditorInput=d;var i;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(i=e.Verbosity||(e.Verbosity={}));var c;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));class t{constructor(){this.a=new Map}registerSource(H,oe){let ve=this.a.get(H);return ve||(ve={source:H,label:oe},this.a.set(H,ve)),ve.source}getSourceLabel(H){return this.a.get(H)?.label??H}}e.SaveSourceRegistry=new t;var h;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors"})(h=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends M.Disposable{}e.AbstractEditorInput=a;function u(G){return G instanceof a}e.isEditorInput=u;function g(G){const H=G;return S.URI.isUri(H?.preferredResource)}function R(G){const H=G;return u(H?.primary)&&u(H?.secondary)}e.isSideBySideEditorInput=R;function F(G){const H=G;return u(H?.modified)&&u(H?.original)}e.isDiffEditorInput=F;function q(G,H,oe,ve,Ae){return re(ve,[(0,w.toAction)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const Be={...oe,limits:{size:Number.MAX_VALUE}};G.openEditor(H,Be)}}),(0,w.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>Ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.createTooLargeFileError=q;function Z(G){return u(G?.editor)}e.isEditorInputWithOptions=Z;function x(G){const H=G;return Z(G)&&H?.group!==void 0}e.isEditorInputWithOptionsAndGroup=x;function N(G){const H=G;return typeof H?.groupId=="number"&&u(H.editor)}e.isEditorIdentifier=N;var $;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})($=e.EditorCloseContext||(e.EditorCloseContext={}));var T;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(T=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var L;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(L=e.SideBySideEditor||(e.SideBySideEditor={}));class V{getOriginalUri(H,oe){if(!H)return;if(d(H))return e.EditorResourceAccessor.getOriginalUri(H.result,oe);if(oe?.supportSideBySide){const{primary:Ae,secondary:Be}=this.a(H);if(Ae&&Be){if(oe?.supportSideBySide===L.BOTH)return{primary:this.getOriginalUri(Ae,{filterByScheme:oe.filterByScheme}),secondary:this.getOriginalUri(Be,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===L.ANY)return this.getOriginalUri(Ae,{filterByScheme:oe.filterByScheme})??this.getOriginalUri(Be,{filterByScheme:oe.filterByScheme});H=oe.supportSideBySide===L.PRIMARY?Ae:Be}}if(v(H)||E(H)||d(H))return;const ve=g(H)?H.preferredResource:H.resource;return!ve||!oe||!oe.filterByScheme?ve:this.b(ve,oe.filterByScheme)}a(H){return R(H)||E(H)?{primary:H.primary,secondary:H.secondary}:F(H)||v(H)?{primary:H.modified,secondary:H.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(H,oe){if(!H)return;if(d(H))return e.EditorResourceAccessor.getCanonicalUri(H.result,oe);if(oe?.supportSideBySide){const{primary:Ae,secondary:Be}=this.a(H);if(Ae&&Be){if(oe?.supportSideBySide===L.BOTH)return{primary:this.getCanonicalUri(Ae,{filterByScheme:oe.filterByScheme}),secondary:this.getCanonicalUri(Be,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===L.ANY)return this.getCanonicalUri(Ae,{filterByScheme:oe.filterByScheme})??this.getCanonicalUri(Be,{filterByScheme:oe.filterByScheme});H=oe.supportSideBySide===L.PRIMARY?Ae:Be}}if(v(H)||E(H)||d(H))return;const ve=H.resource;return!ve||!oe||!oe.filterByScheme?ve:this.b(ve,oe.filterByScheme)}b(H,oe){if(Array.isArray(oe)){if(oe.some(ve=>H.scheme===ve))return H}else if(oe===H.scheme)return H}}e.EditorResourceAccessor=new V;var j;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class le{constructor(){this.c=new Map,this.d=new Map}start(H){const oe=this.a=H.get(I.IInstantiationService);for(const[ve,Ae]of this.c)this.e(ve,Ae,oe);this.c.clear()}e(H,oe,ve){const Ae=ve.createInstance(oe);this.d.set(H,Ae)}registerFileEditorFactory(H){if(this.b)throw new Error("Can only register one file editor factory.");this.b=H}getFileEditorFactory(){return(0,C.assertIsDefined)(this.b)}registerEditorSerializer(H,oe){if(this.c.has(H)||this.d.has(H))throw new Error(`A editor serializer with type ID '${H}' was already registered.`);return this.a?this.e(H,oe,this.a):this.c.set(H,oe),(0,M.toDisposable)(()=>{this.c.delete(H),this.d.delete(H)})}getEditorSerializer(H){return this.d.get(typeof H=="string"?H:H.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new le);async function Y(G,H,oe){return!G||!G.length?[]:await Promise.all(G.map(async ve=>{const Ae=S.URI.revive(ve.fileUri);if(!Ae){oe.info("Cannot resolve the path because it is not valid.",ve);return}if(!await H.canHandleResource(Ae)){oe.info("Cannot resolve the path because it cannot be handled",ve);return}let xe=ve.exists,Te=ve.type;if(typeof xe!="boolean"||typeof Te!="number")try{Te=(await H.stat(Ae)).isDirectory?y.FileType.Directory:y.FileType.Unknown,xe=!0}catch(ke){oe.error(ke),xe=!1}if(!xe&&ve.openOnlyIfExists){oe.info("Cannot resolve the path because it does not exist",ve);return}if(Te===y.FileType.Directory){oe.info("Cannot resolve the path because it is a directory",ve);return}const Se={...ve.options,pinned:!0};return xe?{resource:Ae,options:Se}:{resource:Ae,options:Se,forceUntitled:!0}}))}e.pathsToEditors=Y;var pe;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(pe=e.EditorsOrder||(e.EditorsOrder={}));function ue(G){const H=G;if(!H)return!1;const oe=H;if(oe.modified)return ue(oe.modified);const ve=H;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}e.isTextEditorViewState=ue;function de(G){return(0,O.isErrorWithActions)(G)}e.isEditorOpenError=de;function re(G,H,oe){const ve=(0,O.createErrorWithActions)(G,H);return ve.forceMessage=oe?.forceMessage,ve.forceSeverity=oe?.forceSeverity,ve.allowDialog=oe?.allowDialog,ve}e.createEditorOpenError=re}),define(Ie[178],Ce([1,0,4,146,3,6,28,29,18,62,22,65,170]),function(te,e,n,C,S,M,I,A,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",w.Codicon.window,(0,C.localize)(0,null));var b;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(b=e.Extensions||(e.Extensions={}));var f;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(f=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function s(i){switch(i){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=s;class o extends M.Disposable{constructor(){super(...arguments),this.c=this.B(new n.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new n.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(c,t,h){const a=this.get(c.id);if(a)return a;const u=c;return u.openCommandActionDescriptor=h?.doNotRegisterOpenCommand?void 0:u.openCommandActionDescriptor??{id:u.id},(0,I.getOrSet)(this.g,t,[]).push(u),h?.isDefault&&this.h.push(u),this.c.fire({viewContainer:u,viewContainerLocation:t}),u}deregisterViewContainer(c){for(const t of this.g.keys()){const h=this.g.get(t),a=h?.indexOf(c);if(a!==-1){h?.splice(a,1),h.length===0&&this.g.delete(t),this.f.fire({viewContainer:c,viewContainerLocation:t});return}}}get(c){return this.all.filter(t=>t.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(t=>this.getViewContainers(t).filter(h=>h?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(t=>this.getViewContainerLocation(t)===c)}}A.Registry.add(b.ViewContainersRegistry,new o);var l;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function v(i,c){const t=i.group??l.More,h=c.group??l.More;return t!==h?t.localeCompare(h):(i.order??5)-(c.order??5)}class E extends M.Disposable{constructor(){super(...arguments),this.c=this.B(new n.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new n.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new n.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new n.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new k.SetMap}registerViews(c,t){this.registerViews2([{views:c,viewContainer:t}])}registerViews2(c){c.forEach(({views:t,viewContainer:h})=>this.l(t,h)),this.c.fire(c)}deregisterViews(c,t){const h=this.m(c,t);h.length&&this.f.fire({views:h,viewContainer:t})}moveViews(c,t){for(const h of this.j.keys())if(h!==t){const a=this.m(c,h);a.length&&(this.l(a,t),this.g.fire({views:a,from:h,to:t}))}}getViews(c){return this.j.get(c)||[]}getView(c){for(const t of this.i){const h=(this.j.get(t)||[]).filter(a=>a.id===c)[0];if(h)return h}return null}getViewContainer(c){for(const t of this.i)if((this.j.get(t)||[]).filter(a=>a.id===c)[0])return t;return null}registerViewWelcomeContent(c,t){return this.k.add(c,t),this.h.fire(c),(0,M.toDisposable)(()=>{this.k.delete(c,t),this.h.fire(c)})}registerViewWelcomeContent2(c,t){const h=new Map;for(const[a,u]of t)this.k.add(c,u),h.set(a,(0,M.toDisposable)(()=>{this.k.delete(c,u),this.h.fire(c)}));return this.h.fire(c),h}getViewWelcomeContent(c){const t=[];return this.k.forEach(c,h=>t.push(h)),t.sort(v)}l(c,t){let h=this.j.get(t);h||(h=[],this.j.set(t,h),this.i.push(t));for(const a of c){if(this.getView(a.id)!==null)throw new Error((0,C.localize)(1,null,a.id));h.push(a)}}m(c,t){const h=this.j.get(t);if(!h)return[];const a=[],u=[];for(const g of h)c.includes(g)?a.push(g):u.push(g);return a.length&&(u.length?this.j.set(t,u):(this.j.delete(t),this.i.splice(this.i.indexOf(t),1))),a}}A.Registry.add(b.ViewsRegistry,new E),e.IViewsService=(0,S.createDecorator)("viewsService"),e.IViewDescriptorService=(0,S.createDecorator)("viewDescriptorService");var P;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(P=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(c,t){this.c=!1,this.d=!1,(0,O.mixin)(this,c),this.d=!!t,this.resolve=async h=>{if(t&&!this.c){const a=await t(h);a&&(this.tooltip=this.tooltip??a.tooltip,this.command=this.command??a.command)}h.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r;class d extends Error{constructor(c){super((0,C.localize)(2,null,c))}}e.NoTreeViewError=d}),define(Ie[179],Ce([1,0,4,16,147]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new n.Emitter,this.n=new n.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,y,k,O){const w={command:A};if(y&&Object.keys(y).length>0&&(w.arguments=y),this.s("request",w),typeof O=="number"){const m=setTimeout(()=>{clearTimeout(m);const b=this.f.get(w.seq);if(b){this.f.delete(w.seq);const f={type:"response",seq:0,request_seq:w.seq,success:!1,command:A,message:(0,S.localize)(0,null,O,A)};b(f)}},O)}return k&&this.f.set(w.seq,k),w.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,y){return A.type!=="event"||y.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,C.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const y=A,k=this.f.get(y.request_seq);k&&(this.f.delete(y.request_seq),k(y));break}}}}s(A,y){y.type=A,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((y,k)=>A.set(k,y)),await(0,C.timeout)(500),A.forEach((y,k)=>{y({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=M}),define(Ie[180],Ce([1,0,148,42,3]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new C.RawContextKey("debugType",void 0,{type:"string",description:n.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new C.RawContextKey("debugConfigurationType",void 0,{type:"string",description:n.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new C.RawContextKey("debugState","inactive",{type:"string",description:n.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new C.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:n.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new C.RawContextKey("hasDebugged",!1,{type:"boolean",description:n.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new C.RawContextKey("inDebugMode",!1,{type:"boolean",description:n.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new C.RawContextKey("inDebugRepl",!1,{type:"boolean",description:n.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new C.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:n.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new C.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:n.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new C.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:n.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new C.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:n.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new C.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:n.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new C.RawContextKey("variablesFocused",!0,{type:"boolean",description:n.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new C.RawContextKey("expressionSelected",!1,{type:"boolean",description:n.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new C.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:n.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new C.RawContextKey("callStackItemType",void 0,{type:"string",description:n.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new C.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:n.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new C.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:n.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new C.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:n.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new C.RawContextKey("watchItemType",void 0,{type:"string",description:n.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new C.RawContextKey("canViewMemory",void 0,{type:"boolean",description:n.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new C.RawContextKey("breakpointItemType",void 0,{type:"string",description:n.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new C.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:n.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new C.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:n.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new C.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:n.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new C.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:n.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new C.RawContextKey("stepBackSupported",!1,{type:"boolean",description:n.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new C.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:n.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new C.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:n.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new C.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:n.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new C.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:n.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new C.RawContextKey("breakpointsExist",!1,{type:"boolean",description:n.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new C.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:n.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new C.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:n.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new C.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:n.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new C.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:n.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new C.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:n.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new C.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:n.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new C.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:n.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new C.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:n.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new C.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:n.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new C.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:n.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new C.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:n.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new C.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:n.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new C.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:n.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new C.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:n.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new C.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:n.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new C.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:n.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new C.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:n.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new C.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:n.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new C.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:n.localize(50,null)});const M=m=>n.localize(51,null,m);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:n.localize(52,null)};var I;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(I=e.State||(e.State={}));function A(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,S.createDecorator)("debugService");var w;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(w=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[181],Ce([1,0,10,2,19,22,15]),function(te,e,n,C,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(i,c,t){return i.replace(A,function(h,a){return c&&a.length>0&&a[0]!=="_"?h:t&&t.hasOwnProperty(a)?t[a]:h})}e.formatPII=y;function k(i){const c={};for(const t of Object.keys(i))t.startsWith("!")||(c[t]=i[t]);return c}e.filterExceptionsFromTelemetry=k;function O(i){return i.configuration.request==="attach"&&!w(i)&&(!i.parentSession||O(i.parentSession))}e.isSessionAttach=O;function w(i){let c=i.configuration.type;if(!!c)return c==="vslsShare"&&(c=i.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(c,"extensionhost")||(0,n.equalsIgnoreCase)(c,"pwa-extensionhost")?i:i.parentSession?w(i.parentSession):void 0}e.getExtensionHostDebugSession=w;function m(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=m;function b(i,c,t){let h,a=0;const u=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let g=null;for(;g=u.exec(i);){const R=g.index+1,F=R+g[0].length;if(R<=c&&F>=t){h=g[0],a=R;break}}if(h){const R=/\w+/g;let F=null;for(;(F=R.exec(h))&&!(F.index+1+a+F[0].length>=t););F&&(h=h.substring(0,R.lastIndex))}return h?{start:a,end:a+h.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(i){return!!(i&&i.match(f))}e.isUri=s;function o(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(s(i.path))return C.URI.parse(i.path);if((0,S.isAbsolute)(i.path))return C.URI.file(i.path)}return i.path}function l(i){if(typeof i.path=="object"){const c=C.URI.revive(i.path);if(c)return c.scheme===I.Schemas.file?c.fsPath:c.toString()}return i.path}function v(i,c){const t=c?o:l,h=(0,M.deepClone)(i);return P(h,(a,u)=>{a&&u&&(u.path=t(u))}),h}e.convertToDAPaths=v;function E(i,c){const t=c?o:l,h=(0,M.deepClone)(i);return P(h,(a,u)=>{!a&&u&&(u.path=t(u))}),h}e.convertToVSCPaths=E;function P(i,c){switch(i.type){case"event":{const t=i;switch(t.event){case"output":c(!1,t.body.source);break;case"loadedSource":c(!1,t.body.source);break;case"breakpoint":c(!1,t.body.breakpoint.source);break;default:break}break}case"request":{const t=i;switch(t.command){case"setBreakpoints":c(!0,t.arguments.source);break;case"breakpointLocations":c(!0,t.arguments.source);break;case"source":c(!0,t.arguments.source);break;case"gotoTargets":c(!0,t.arguments.source);break;case"launchVSCode":t.arguments.args.forEach(h=>c(!1,h));break;default:break}break}case"response":{const t=i;if(t.success&&t.body)switch(t.command){case"stackTrace":t.body.stackFrames.forEach(h=>c(!1,h.source));break;case"loadedSources":t.body.sources.forEach(h=>c(!1,h));break;case"scopes":t.body.scopes.forEach(h=>c(!1,h.source));break;case"setFunctionBreakpoints":t.body.breakpoints.forEach(h=>c(!1,h.source));break;case"setBreakpoints":t.body.breakpoints.forEach(h=>c(!1,h.source));break;case"disassemble":t.body?.instructions.forEach(a=>c(!1,a.location));break;default:break}break}}}function p(i){return i.filter(c=>!c.presentation?.hidden).sort((c,t)=>c.presentation?t.presentation?c.presentation.group?t.presentation.group?c.presentation.group!==t.presentation.group?c.presentation.group.localeCompare(t.presentation.group):r(c.presentation.order,t.presentation.order):-1:t.presentation.group?1:r(c.presentation.order,t.presentation.order):-1:t.presentation?1:0)}e.getVisibleAndSorted=p;function r(i,c){return typeof i!="number"?typeof c!="number"?0:1:typeof c!="number"?-1:i-c}async function d(i,c){const t=i.getValue("debug.saveBeforeStart",{overrideIdentifier:c.activeTextEditorLanguageId});if(t!=="none"&&(await c.saveAll(),t==="allEditorsInActiveGroup")){const h=c.activeEditorPane;h&&h.input.resource?.scheme===I.Schemas.untitled&&await c.save({editor:h.input,groupId:h.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=d}),define(Ie[70],Ce([1,0,24,35,182,64,15,19,20,42]),function(te,e,n,C,S,M,I,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function(L){L[L.Markup=1]="Markup",L[L.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var w;(function(L){L[L.Running=1]="Running",L[L.Idle=2]="Idle"})(w=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(L){L[L.Unconfirmed=1]="Unconfirmed",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var b;(function(L){L[L.WithHardKernelDependency=0]="WithHardKernelDependency",L[L.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",L[L.Pure=2]="Pure",L[L.Never=3]="Never"})(b=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(L){L.Always="always",L.Never="never",L.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var s;(function(L){L[L.ModelChange=1]="ModelChange",L[L.Move=2]="Move",L[L.ChangeCellLanguage=5]="ChangeCellLanguage",L[L.Initialize=6]="Initialize",L[L.ChangeCellMetadata=7]="ChangeCellMetadata",L[L.Output=8]="Output",L[L.OutputItem=9]="OutputItem",L[L.ChangeCellContent=10]="ChangeCellContent",L[L.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",L[L.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",L[L.ChangeCellMime=13]="ChangeCellMime",L[L.Unknown=100]="Unknown"})(s=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(L){L[L.Handle=0]="Handle",L[L.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(L){L[L.Replace=1]="Replace",L[L.Output=2]="Output",L[L.Metadata=3]="Metadata",L[L.CellLanguage=4]="CellLanguage",L[L.DocumentMetadata=5]="DocumentMetadata",L[L.Move=6]="Move",L[L.OutputItems=7]="OutputItems",L[L.PartialMetadata=8]="PartialMetadata",L[L.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var v;(function(L){L.scheme=I.Schemas.vscodeNotebookCell;const V=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${V.join("")}]+`),le=7;function Y(H,oe){const ve=oe.toString(le),Be=`${ve.length<V.length?V[ve.length-1]:"z"}${ve}s${(0,n.encodeBase64)(n.VSBuffer.fromString(H.scheme),!0,!0)}`;return H.with({scheme:L.scheme,fragment:Be})}L.generate=Y;function pe(H){if(H.scheme!==L.scheme)return;const oe=H.fragment.indexOf("s");if(oe<0)return;const ve=parseInt(H.fragment.substring(0,oe).replace(j,""),le),Ae=(0,n.decodeBase64)(H.fragment.substring(oe+1)).toString();if(!isNaN(ve))return{handle:ve,notebook:H.with({scheme:Ae,fragment:null})}}L.parse=pe;function ue(H,oe){return H.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`op${oe??""},${H.scheme!==I.Schemas.file?H.scheme:""}`})}L.generateCellOutputUri=ue;function de(H){if(H.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const oe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(H.fragment);if(!oe)return;const ve=oe[1]&&oe[1]!==""?oe[1]:void 0,Ae=oe[2];return{outputId:ve,notebook:H.with({scheme:Ae||I.Schemas.file,fragment:null})}}L.parseCellOutputUri=de;function re(H,oe,ve){return L.generate(H,oe).with({scheme:ve})}L.generateCellPropertyUri=re;function G(H,oe){if(H.scheme===oe)return L.parse(H.with({scheme:L.scheme}))}L.parseCellPropertyUri=G})(v=e.CellUri||(e.CellUri={}));const E=L=>y.isWindows?L.replace(/\//g,"\\"):L;class P{constructor(V=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(V)].map(le=>({pattern:le,matches:C.parse(E(le))}))}sort(V){const j=new Map(S.Iterable.map(V,Y=>[Y,E(Y)]));let le=[];for(const{matches:Y}of this.d)for(const[pe,ue]of j)if(Y(ue)){le.push(pe),j.delete(pe);break}return j.size&&(le=le.concat([...j.keys()].sort((Y,pe)=>this.e.indexOf(Y)-this.e.indexOf(pe)))),le}prioritize(V,j){const le=this.f(V);if(le===-1){this.d.unshift({pattern:V,matches:C.parse(E(V))});return}const Y=new Set(j.map(ue=>this.f(ue,le)));Y.delete(-1);const pe=Array.from(Y).sort();this.d.splice(le+1,0,...pe.map(ue=>this.d[ue]));for(let ue=pe.length-1;ue>=0;ue--)this.d.splice(pe[ue],1)}toArray(){return this.d.map(V=>V.pattern)}f(V,j=this.d.length){const le=E(V);for(let Y=0;Y<j;Y++)if(this.d[Y].matches(le))return Y;return-1}}e.MimeTypeDisplayOrder=P;function p(L,V,j,le=(Y,pe)=>Y===pe){const Y=[];function pe(re,G,H){if(G===0&&H.length===0)return;const oe=Y[Y.length-1];oe&&oe.start+oe.deleteCount===re?(oe.deleteCount+=G,oe.toInsert.push(...H)):Y.push({start:re,deleteCount:G,toInsert:H})}let ue=0,de=0;for(;;){if(ue===L.length){pe(ue,0,V.slice(de));break}if(de===V.length){pe(ue,L.length-ue,[]);break}const re=L[ue],G=V[de];if(le(re,G)){ue+=1,de+=1;continue}j(G)?(pe(ue,1,[]),ue+=1):(pe(ue,0,[G]),de+=1)}return Y}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(L){L.default="default",L.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(L){const V=L;return!!((typeof V.include=="string"||C.isRelativePattern(V.include))&&(typeof V.exclude=="string"||C.isRelativePattern(V.exclude)))}e.isDocumentExcludePattern=d;function i(L,V,j){if(Array.isArray(L.viewType)&&L.viewType.indexOf(V)>=0||L.viewType===V)return!0;if(L.filenamePattern){const le=d(L.filenamePattern)?L.filenamePattern.include:L.filenamePattern,Y=d(L.filenamePattern)?L.filenamePattern.exclude:void 0;if(C.match(le,(0,A.basename)(j.fsPath).toLowerCase()))return!(Y&&C.match(Y,(0,A.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var c;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(c=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class t{static create(V){return`${t.d}${V}`}static parse(V){if(V.startsWith(t.d))return V.substring(t.d.length)}}e.NotebookWorkingCopyTypeIdentifier=t,t.d="notebook/";function h(L){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(L)}e.isTextStreamMime=h;const a=new TextDecoder;function u(L){const V=[];let j=!1;for(const le of L)(V.length===0||j)&&(V.push(le),j=!0);return q(V),T(n.VSBuffer.concat(V.map(le=>n.VSBuffer.wrap(le))))}e.compressOutputItemStreams=u;const g=`${String.fromCharCode(27)}[A`,R=g.split("").map(L=>L.charCodeAt(0)),F=10;function q(L){L.forEach((V,j)=>{if(j===0||V.length<g.length)return;const le=L[j-1],Y=V.subarray(0,g.length);if(Y[0]===R[0]&&Y[1]===R[1]&&Y[2]===R[2]){const pe=le.lastIndexOf(F);if(pe===-1)return;L[j-1]=le.subarray(0,pe),L[j]=V.subarray(g.length)}})}function Z(L){let V=L;do L=V,V=L.replace(/[^\n]\x08/gm,"");while(V.length<L.length);return L}function x(L){for(L=L.replace(/\r+\n/gm,`
`);L.search(/\r[^$]/g)>-1;){const V=L.match(/^(.*)\r+/m)[1];let j=L.match(/\r+(.*)$/m)[1];j=j+V.slice(j.length,V.length),L=L.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return L}const N="\b".charCodeAt(0),$="\r".charCodeAt(0);function T(L){return!L.buffer.includes(N)&&!L.buffer.includes($)?L:n.VSBuffer.fromString(x(Z(a.decode(L.buffer))))}}),define(Ie[183],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var C;(function(S){S[S.Output=1]="Output",S[S.OutputItems=2]="OutputItems",S[S.ExecutionState=3]="ExecutionState"})(C=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(Ie[43],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(M){M.Delimiter="\0"})(n=e.TestIdPathParts||(e.TestIdPathParts={}));var C;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(C=e.TestPosition||(e.TestPosition={}));class S{static fromExtHostTestItem(I,A,y=I.parent){if(I._isRoot)return new S([A]);const k=[I.id];for(let O=y;O&&O.id!==A;O=O.parent)k.push(O.id);return k.push(A),new S(k.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const A=I.indexOf("\0");return A===-1?I:I.slice(0,A)}static fromString(I){return new S(I.split("\0"))}static join(I,A){return new S([...I.path,A])}static joinToString(I,A){return I.toString()+"\0"+A}static parentId(I){const A=I.lastIndexOf("\0");return A===-1?void 0:I.slice(0,A)}static localId(I){const A=I.lastIndexOf("\0");return A===-1?I:I.slice(A+1)}static compare(I,A){return I===A?0:A.startsWith(I+"\0")?2:I.startsWith(A+"\0")?3:1}constructor(I,A=I.length){if(this.path=I,this.d=A,I.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new S(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let I=1;I<=this.d;I++)yield new S(this.path,I)}*idsToRoot(){for(let I=this.d;I>0;I--)yield new S(this.path,I)}compare(I){if(typeof I=="string")return S.compare(this.toString(),I);for(let A=0;A<I.d&&A<this.d;A++)if(I.path[A]!==this.path[A])return 1;return I.d>this.d?2:I.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let I=1;I<this.d;I++)this.c+="\0",this.c+=this.path[I]}return this.c}}e.TestId=S}),define(Ie[55],Ce([1,0,2,56,43]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var M;(function(a){a[a.Unset=0]="Unset",a[a.Queued=1]="Queued",a[a.Running=2]="Running",a[a.Passed=3]="Passed",a[a.Failed=4]="Failed",a[a.Skipped=5]="Skipped",a[a.Errored=6]="Errored"})(M=e.TestResultState||(e.TestResultState={}));var I;(function(a){a[a.Run=2]="Run",a[a.Debug=4]="Debug",a[a.Coverage=8]="Coverage",a[a.HasNonDefaultProfile=16]="HasNonDefaultProfile",a[a.HasConfigurable=32]="HasConfigurable",a[a.SupportsContinuousRun=64]="SupportsContinuousRun"})(I=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const A=a=>"runIn"in a;e.isStartControllerTests=A;var y;(function(a){a.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),a.deserialize=u=>({range:C.Range.lift(u.range),uri:n.URI.revive(u.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var k;(function(a){a[a.Error=0]="Error",a[a.Output=1]="Output"})(k=e.TestMessageType||(e.TestMessageType={}));var O;(function(a){a.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,location:u.location&&y.serialize(u.location)}),a.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,location:u.location&&y.deserialize(u.location)})})(O=e.ITestErrorMessage||(e.ITestErrorMessage={}));const w=(a,u)=>`${u?"s":"e"}${a}`;e.getMarkId=w;var m;(function(a){a.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&y.serialize(u.location)}),a.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&y.deserialize(u.location)})})(m=e.ITestOutputMessage||(e.ITestOutputMessage={}));var b;(function(a){a.serialize=u=>u.type===0?O.serialize(u):m.serialize(u),a.deserialize=u=>u.type===0?O.deserialize(u):m.deserialize(u)})(b=e.ITestMessage||(e.ITestMessage={}));var f;(function(a){a.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),a.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(b.serialize)}),a.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(b.deserialize)})})(f=e.ITestTaskState||(e.ITestTaskState={}));const s="\0",o=(a,u)=>a+s+u;e.namespaceTestTag=o;const l=a=>{const u=a.indexOf(s);return{ctrlId:a.slice(0,u),tagId:a.slice(u+1)}};e.denamespaceTestTag=l;var v;(function(a){a.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),a.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?n.URI.revive(u.uri):void 0,range:u.range?C.Range.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(v=e.ITestItem||(e.ITestItem={}));var E;(function(a){a[a.NotExpandable=0]="NotExpandable",a[a.Expandable=1]="Expandable",a[a.BusyExpanding=2]="BusyExpanding",a[a.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));var P;(function(a){a.serialize=u=>({expand:u.expand,item:v.serialize(u.item)}),a.deserialize=u=>({controllerId:S.TestId.root(u.item.extId),expand:u.expand,item:v.deserialize(u.item)})})(P=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(a){a.serialize=u=>{let g;return u.item&&(g={},u.item.label!==void 0&&(g.label=u.item.label),u.item.tags!==void 0&&(g.tags=u.item.tags),u.item.busy!==void 0&&(g.busy=u.item.busy),u.item.uri!==void 0&&(g.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(g.range=u.item.range?.toJSON()),u.item.description!==void 0&&(g.description=u.item.description),u.item.error!==void 0&&(g.error=u.item.error),u.item.sortText!==void 0&&(g.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:g}},a.deserialize=u=>{let g;return u.item&&(g={},u.item.label!==void 0&&(g.label=u.item.label),u.item.tags!==void 0&&(g.tags=u.item.tags),u.item.busy!==void 0&&(g.busy=u.item.busy),u.item.range!==void 0&&(g.range=u.item.range?C.Range.lift(u.item.range):null),u.item.description!==void 0&&(g.description=u.item.description),u.item.error!==void 0&&(g.error=u.item.error),u.item.sortText!==void 0&&(g.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:g}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const r=(a,u)=>{u.expand!==void 0&&(a.expand=u.expand),u.item!==void 0&&(a.item=a.item?Object.assign(a.item,u.item):u.item)};e.applyTestItemUpdate=r;var d;(function(a){a.serializeWithoutMessages=u=>({...P.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.serializeWithoutMessages),retired:u.retired}),a.serialize=u=>({...P.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.serialize),retired:u.retired}),a.deserialize=u=>({...P.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.deserialize),retired:!0})})(d=e.TestResultItem||(e.TestResultItem={}));var i;(function(a){a[a.Function=0]="Function",a[a.Statement=1]="Statement"})(i=e.DetailType||(e.DetailType={}));var c;(function(a){a[a.Add=0]="Add",a[a.Update=1]="Update",a[a.DocumentSynced=2]="DocumentSynced",a[a.Remove=3]="Remove",a[a.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",a[a.Retire=5]="Retire",a[a.AddTag=6]="AddTag",a[a.RemoveTag=7]="RemoveTag"})(c=e.TestDiffOpType||(e.TestDiffOpType={}));var t;(function(a){a.deserialize=u=>u.op===0?{op:u.op,item:P.deserialize(u.item)}:u.op===1?{op:u.op,item:p.deserialize(u.item)}:u.op===2?{op:u.op,uri:n.URI.revive(u.uri),docv:u.docv}:u,a.serialize=u=>u.op===0?{op:u.op,item:P.serialize(u.item)}:u.op===1?{op:u.op,item:p.serialize(u.item)}:u})(t=e.TestsDiffOp||(e.TestsDiffOp={}));class h{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(u){const g=this.o();for(const R of u)switch(R.op){case 0:this.j(P.deserialize(R.item),g);break;case 1:this.k(p.deserialize(R.item),g);break;case 3:this.l(R.itemId,g);break;case 5:this.m(R.itemId);break;case 4:this.updatePendingRoots(R.amount);break;case 6:this.c.set(R.tag.id,R.tag);break;case 7:this.c.delete(R.id);break}g.complete?.()}j(u,g){const R=S.TestId.parentId(u.item.extId)?.toString();let F;if(!R)F=this.p(u),this.f.add(F),this.d.set(u.item.extId,F);else if(this.d.has(R)){const q=this.d.get(R);q.children.add(u.item.extId),F=this.p(u,q),this.d.set(u.item.extId,F)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return g.add?.(F),u.expand===2&&this.g++,F}k(u,g){const R=this.d.get(u.extId);if(!!R)return u.expand!==void 0&&(R.expand===2&&this.g--,u.expand===2&&this.g++),(0,e.applyTestItemUpdate)(R,u),g.update?.(R),R}l(u,g){const R=this.d.get(u);if(!R)return;const F=S.TestId.parentId(R.item.extId)?.toString();F?this.d.get(F).children.delete(R.item.extId):this.f.delete(R);const q=[[u]];for(;q.length;)for(const Z of q.pop()){const x=this.d.get(Z);x&&(q.push(x.children),this.d.delete(Z),g.remove?.(x,x!==R),x.expand===2&&this.g--)}}m(u){}updatePendingRoots(u){this.h+=u}o(){return{}}}e.AbstractIncrementalTestCollection=h}),define(Ie[71],Ce([1,0,16,4,6,47,55,43]),function(te,e,n,C,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(v){v[v.Upsert=0]="Upsert",v[v.SetTags=1]="SetTags",v[v.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",v[v.RemoveChild=3]="RemoveChild",v[v.SetProp=4]="SetProp",v[v.Bulk=5]="Bulk",v[v.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(v,E)=>v===E,w=Object.entries({range:(v,E)=>v===E?!0:!v||!E?!1:v.equalsRange(E),busy:k,label:k,description:k,error:k,sortText:k,tags:(v,E)=>!(v.length!==E.length||v.some(P=>!E.includes(P)))}),m=(v,E)=>{let P;for(const[p,r]of w)r(v[p],E[p])||(P?P[p]=E[p]:P={[p]:E[p]});return P};class b extends S.Disposable{get root(){return this.m.root}constructor(E){super(),this.m=E,this.f=this.B(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new C.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(E){this.h=E;for(const P of this.tree.values())this.G(P)}collectDiff(){const E=this.k;return this.k=[],E}pushDiff(E){switch(E.op){case 2:{for(const P of this.k)if(P.op===2&&P.uri===E.uri){P.docv=E.docv;return}break}case 1:{const P=this.k[this.k.length-1];if(P){if(P.op===1&&P.item.extId===E.item.extId){(0,I.applyTestItemUpdate)(P.item,E.item);return}if(P.op===0&&P.item.item.extId===E.item.extId){(0,I.applyTestItemUpdate)(P.item,E.item);return}}break}}this.k.push(E),this.f.isScheduled()||this.f.schedule()}expand(E,P){const p=this.tree.get(E);if(!!p){if((p.expandLevels===void 0||P>p.expandLevels)&&(p.expandLevels=P),p.expand===1){const r=this.I(p);return r.isOpen()?this.H(p,P-1):r.wait().then(()=>this.H(p,P-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.H(p,P-1)):this.H(p,P-1)}}dispose(){for(const E of this.tree.values())this.m.getApiFor(E.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(E,P){switch(P.op){case 3:this.L(A.TestId.joinToString(E.fullId,P.id));break;case 0:this.u(P.item,E);break;case 5:for(const p of P.ops)this.p(E,p);break;case 1:this.w(P.new,P.old,E.fullId.toString());break;case 2:this.G(E);break;case 4:this.pushDiff({op:1,item:{extId:E.fullId.toString(),item:P.update}});break;case 6:this.s(E.actual.uri);break;default:(0,M.assertNever)(P)}}s(E){E&&this.pushDiff({op:2,uri:E,docv:this.m.getDocumentVersion(E)})}u(E,P){const p=A.TestId.fromExtHostTestItem(E,this.root.id,P?.actual),r=this.m.getApiFor(E);r.parent&&r.parent!==P?.actual&&this.m.getChildren(r.parent).delete(E.id);let d=this.tree.get(p.toString());if(!d){d={fullId:p,actual:E,expandLevels:P?.expandLevels?P.expandLevels-1:void 0,expand:0},E.tags.forEach(this.y,this),this.tree.set(d.fullId.toString(),d),this.C(E,P),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:d.expand,item:this.m.toITestItem(E)}}),this.F(E,d,P);return}if(d.actual===E){this.D(E,d,P);return}if(d.actual.uri?.toString()!==E.uri?.toString())return this.L(p.toString()),this.u(E,P);const i=this.m.getChildren(d.actual),c=d.actual,t=m(this.m.toITestItem(c),this.m.toITestItem(E));this.m.getApiFor(c).listener=void 0,d.actual=E,d.expand=0,t&&(t.hasOwnProperty("tags")&&(this.w(E.tags,c.tags,p.toString()),delete t.tags),this.p(d,{op:4,update:t})),this.F(E,d,P);for(const[h,a]of i)this.m.getChildren(E).get(a.id)||this.L(A.TestId.joinToString(p,a.id));this.s(d.actual.uri)}w(E,P,p){const r=new Set(P.map(d=>d.id));for(const d of E)r.delete(d.id)||this.y(d);this.pushDiff({op:1,item:{extId:p,item:{tags:E.map(d=>(0,I.namespaceTestTag)(this.m.controllerId,d.id))}}}),r.forEach(this.z,this)}y(E){const P=this.j.get(E.id);P?P.refCount++:(this.j.set(E.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,I.namespaceTestTag)(this.m.controllerId,E.id)}}))}z(E){const P=this.j.get(E);P&&!--P.refCount&&(this.j.delete(E),this.pushDiff({op:7,id:(0,I.namespaceTestTag)(this.m.controllerId,E)}))}C(E,P){this.m.getApiFor(E).parent=P&&P.actual!==this.root?P.actual:void 0}D(E,P,p){this.C(E,p);const r=this.m.getApiFor(E);r.parent=p?.actual,r.listener=d=>this.p(P,d),this.G(P)}F(E,P,p){this.D(E,P,p);for(const[r,d]of this.m.getChildren(E))this.u(d,P)}G(E){let P;this.h?E.resolveBarrier?P=E.resolveBarrier.isOpen()?3:2:P=E.actual.canResolveChildren?1:0:P=0,P!==E.expand&&(E.expand=P,this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:P}}),P===1&&E.expandLevels!==void 0&&this.I(E))}H(E,P){if(P<0)return;const p=[];for(const[r,d]of this.m.getChildren(E.actual)){const i=this.expand(A.TestId.joinToString(E.fullId,d.id),P);(0,n.isThenable)(i)&&p.push(i)}if(p.length)return Promise.all(p).then(()=>{})}I(E){if(E.resolveBarrier)return E.resolveBarrier;if(!this.h){const d=new n.Barrier;return d.open(),d}E.expand=2,this.J(E);const P=E.resolveBarrier=new n.Barrier,p=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,d)};let r;try{r=this.h(E.actual===this.root?void 0:E.actual)}catch(d){p(d)}return(0,n.isThenable)(r)?r.catch(p).then(()=>{P.open(),this.G(E)}):(P.open(),this.G(E)),E.resolveBarrier}J(E){this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:E.expand}})}L(E){const P=this.tree.get(E);if(!P)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:E});const p=[P];for(;p.length;){const r=p.pop();if(!!r){this.m.getApiFor(r.actual).listener=void 0;for(const d of r.actual.tags)this.z(d.id);this.tree.delete(r.fullId.toString());for(const[d,i]of this.m.getChildren(r.actual))p.push(this.tree.get(A.TestId.joinToString(r.fullId,i.id)))}}}flushDiff(){const E=this.collectDiff();E.length&&this.g.fire(E)}}e.TestItemCollection=b;class f extends Error{constructor(E){super(`Attempted to insert a duplicate test item ID ${E}`)}}e.DuplicateTestItemError=f;class s extends Error{constructor(E){super(`TestItem with ID "${E}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=s;class o extends Error{constructor(E,P,p){super(`TestItem with ID "${E}" is from controller "${P}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=o;const l=(v,E,P)=>{let p=new Map;return{get size(){return p.size},forEach(r,d){for(const i of p.values())r.call(d,i,this)},[Symbol.iterator](){return p.entries()},replace(r){const d=new Map,i=new Set(p.keys()),c={op:5,ops:[]};for(const t of r){if(!(t instanceof P))throw new s(t.id);const h=E(t).controllerId;if(h!==v.controllerId)throw new o(t.id,h,v.controllerId);if(d.has(t.id))throw new f(t.id);d.set(t.id,t),i.delete(t.id),c.ops.push({op:0,item:t})}for(const t of i.keys())c.ops.push({op:3,id:t});v.listener?.(c),p=d},add(r){if(!(r instanceof P))throw new s(r.id);p.set(r.id,r),v.listener?.({op:0,item:r})},delete(r){p.delete(r)&&v.listener?.({op:3,id:r})},get(r){return p.get(r)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=l}),define(Ie[96],Ce([1,0,71]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const C=new WeakMap,S=(I,A)=>{const y={controllerId:A};return C.set(I,y),y};e.createPrivateApiFor=S;const M=I=>{const A=C.get(I);if(!A)throw new n.InvalidTestItemError(I?.id||"<unknown>");return A};e.getPrivateApiFor=M}),define(Ie[72],Ce([1,0,15,2]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function S(A,y){return A.scheme===n.Schemas.http||A.scheme===n.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===n.Schemas.file&&(A=C.URI.from({scheme:n.Schemas.vscodeRemote,authority:y.authority,path:A.path})),C.URI.from({scheme:n.Schemas.https,authority:`${A.scheme}+${M(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=S;function M(A){return A.replace(/./g,y=>{const k=y.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?y:"-"+k.toString(16).padStart(4,"0")})}function I(A){return A.replace(/-([0-9a-f]{4})/g,(y,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=I}),define(Ie[184],Ce([1,0,4,6,72]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(A,y,k){this.d=A,this.e=y,this.f=k,this.a=0,this.b=new C.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const O=y.getVisibleTextEditors();for(const w of this.c.values())O.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,y,k,O,w){let m;for(const E of this.e.getVisibleTextEditors(!0))if(E.value===A){m=E;break}if(!m)throw new Error("not a visible editor");const b=this,f=this.a++,s=new n.Emitter,o=new n.Emitter,l=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(E){return(0,S.asWebviewUri)(E,b.f)}get cspSource(){return S.webviewGenericCspSource}set options(E){this.b=E,b.d.$setOptions(f,E)}get options(){return this.b}set html(E){this.a=E,b.d.$setHtml(f,E)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(E){return b.d.$postMessage(f,E)}},v=new class{constructor(){this.editor=A,this.line=y,this.height=k,this.webview=l,this.onDidDispose=o.event}dispose(){b.c.has(f)&&(b.c.delete(f),b.d.$disposeEditorInset(f),o.fire(),o.dispose(),s.dispose())}};return this.d.$createEditorInset(f,m.id,m.value.document.uri,y+1,k,O||{},w.identifier,w.extensionLocation),this.c.set(f,{editor:A,inset:v,onDidReceiveMessage:s}),v}$onDidDispose(A){const y=this.c.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this.c.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=M}),define(Ie[185],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,n.createDecorator)("configurationResolverService");var C;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(C=e.VariableKind||(e.VariableKind={}));class S extends Error{constructor(I,A){super(A),this.variable=I}}e.VariableError=S}),define(Ie[186],Ce([1,0,19,49,9,22,20,87,151,185,10]),function(te,e,n,C,S,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class w{constructor(b,f,s,o){this.g=new Map,this.a=b,this.b=f,this.d=s,o&&(this.c=o.then(l=>this.h(l)))}h(b){if(I.isWindows){const f=Object.create(null);return Object.keys(b).forEach(s=>{f[s.toLowerCase()]=b[s]}),f}return b}resolveWithEnvironment(b,f,s){return this.j({env:this.h(b),userHome:void 0},f?f.uri:void 0,s)}async resolveAsync(b,f){const s={env:await this.c,userHome:await this.d};return this.j(s,b?b.uri:void 0,f)}async i(b,f,s,o){const l=M.deepClone(f);I.isWindows&&l.windows?Object.keys(l.windows).forEach(E=>l[E]=l.windows[E]):I.isMacintosh&&l.osx?Object.keys(l.osx).forEach(E=>l[E]=l.osx[E]):I.isLinux&&l.linux&&Object.keys(l.linux).forEach(E=>l[E]=l.linux[E]),delete l.windows,delete l.osx,delete l.linux;const v={env:await this.c,userHome:await this.d};return this.j(v,b?b.uri:void 0,l,s,o)}async resolveAnyAsync(b,f,s){return this.i(b,f,s)}async resolveAnyMap(b,f,s){const o=new Map;return{newConfig:await this.i(b,f,s,o),resolvedVariables:o}}resolveWithInteractionReplace(b,f,s,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,f,s,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,f){if(this.g.has(b))throw new Error("Variable "+b+" is contributed twice.");this.g.set(b,f)}async j(b,f,s,o,l){if(S.isString(s))return this.l(b,f,s,o,l);if(Array.isArray(s))return Promise.all(s.map(v=>this.j(b,f,v,o,l)));if(S.isObject(s)){const v=Object.create(null),E=await Promise.all(Object.keys(s).map(async P=>[await this.l(b,f,P,o,l),await this.j(b,f,s[P],o,l)]));for(const[P,p]of E)v[P]=p;return v}return s}l(b,f,s,o,l){return(0,O.replaceAsync)(s,w.VARIABLE_REGEXP,async(v,E)=>{if(E.includes(w.VARIABLE_LHS))return v;let P=await this.n(b,v,E,f,o);return l?.set(E,P),P!==v&&S.isString(P)&&P.match(w.VARIABLE_REGEXP)&&(P=await this.l(b,f,P,o,l)),P})}m(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async n(b,f,s,o,l){let v;const E=s.split(":");E.length>1&&(s=E[0],v=E[1]);const P=d=>{const i=this.a.getFilePath();if(i)return(0,A.normalizeDriveLetter)(i);throw new k.VariableError(d,(0,y.localize)(0,null,f))},p=d=>{const i=P(d);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,A.normalizeDriveLetter)(c)}throw new k.VariableError(d,(0,y.localize)(1,null,f,n.basename(i)))},r=d=>{if(v){const i=this.a.getFolderUri(v);if(i)return i;throw new k.VariableError(d,(0,y.localize)(2,null,f,v))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new k.VariableError(d,(0,y.localize)(3,null,f)):new k.VariableError(d,(0,y.localize)(4,null,f))};switch(s){case"env":if(v){if(b.env){const d=b.env[I.isWindows?v.toLowerCase():v];if(S.isString(d))return d}return""}throw new k.VariableError(k.VariableKind.Env,(0,y.localize)(5,null,f));case"config":if(v){const d=this.a.getConfigurationValue(o,v);if(S.isUndefinedOrNull(d))throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(6,null,f,v));if(S.isObject(d))throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(7,null,f,v));return d}throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(8,null,f));case"command":return this.o(k.VariableKind.Command,f,v,l,"command");case"input":return this.o(k.VariableKind.Input,f,v,l,"input");case"extensionInstallFolder":if(v){const d=await this.a.getExtension(v);if(!d)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,f,v));return this.m(d.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,f));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(r(k.VariableKind.WorkspaceFolder)));case"cwd":return o||v?(0,A.normalizeDriveLetter)(this.m(r(k.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(n.basename(this.m(r(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,y.localize)(11,null,f))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new k.VariableError(k.VariableKind.LineNumber,(0,y.localize)(12,null,f))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new k.VariableError(k.VariableKind.SelectedText,(0,y.localize)(13,null,f))}case"file":return P(k.VariableKind.File);case"fileWorkspaceFolder":return p(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||v?n.relative(this.m(r(k.VariableKind.RelativeFile)),P(k.VariableKind.RelativeFile)):P(k.VariableKind.RelativeFile);case"relativeFileDirname":{const d=n.dirname(P(k.VariableKind.RelativeFileDirname));if(o||v){const i=n.relative(this.m(r(k.VariableKind.RelativeFileDirname)),d);return i.length===0?".":i}return d}case"fileDirname":return n.dirname(P(k.VariableKind.FileDirname));case"fileExtname":return n.extname(P(k.VariableKind.FileExtname));case"fileBasename":return n.basename(P(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=n.basename(P(k.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-n.extname(d).length)}case"fileDirnameBasename":return n.basename(n.dirname(P(k.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||f}case"execInstallFolder":{const d=this.a.getAppRoot();return d||f}case"pathSeparator":return n.sep;default:try{const d=v?`${s}:${v}`:s;return this.o(k.VariableKind.Unknown,f,d,l,void 0)}catch{return f}}}}o(b,f,s,o,l){if(s&&o){const v=l===void 0?o[s]:o[l+":"+s];if(typeof v=="string")return v;throw new k.VariableError(b,(0,y.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=w,w.VARIABLE_LHS="${",w.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[97],Ce([1,0,3,95]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var S;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var M;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var A;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function k(f){const s=f;return(0,C.isEditorInput)(s?.editor)&&(0,C.isEditorInput)(s?.replacement)}e.isEditorReplacement=k;var O;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var w;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(w=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const s=f;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}e.isEditorGroup=m;function b(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(Ie[187],Ce([1,0,3,97]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(M){const I=M;return typeof M=="number"||(0,C.isEditorGroup)(I)}e.isPreferredGroup=S}),define(Ie[188],Ce([1,0,3,157]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(C.IEnvironmentService)}),define(Ie[98],Ce([1,0,25,4,19]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(w){this.removedDueToLooping=w}}e.DeltaExtensionsResult=M;class I{static isHostExtension(w,m,b){if(m.getExtensionDescription(w))return!1;const f=b.getExtensionDescription(w);return f?!!((f.main||f.browser)&&f.api==="none"):!1}constructor(w){this.c=new C.Emitter,this.onDidChange=this.c.event,this.d=w,this.h()}h(){this.d.sort(y),this.e=new Map,this.f=[],this.g=new Map;for(const w of this.d){if(this.e.has(n.ExtensionIdentifier.toKey(w.identifier))){console.error("Extension `"+w.identifier.value+"` is already registered");continue}if(this.e.set(n.ExtensionIdentifier.toKey(w.identifier),w),this.f.push(w),Array.isArray(w.activationEvents))for(let m of w.activationEvents)m==="onUri"&&(m=`onUri:${n.ExtensionIdentifier.toKey(w.identifier)}`),this.g.has(m)||this.g.set(m,[]),this.g.get(m).push(w)}}set(w){this.d=w,this.h(),this.c.fire(void 0)}deltaExtensions(w,m){this.d=k(this.d,m),this.d=this.d.concat(w);const b=I.j(this.d);return this.d=k(this.d,b.map(f=>f.identifier)),this.h(),this.c.fire(void 0),new M(b)}static j(w){const m=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(l){this.d.has(l)||(this.d.add(l),this.e.push(l))}addArc(l,v){this.addNode(l),this.addNode(v),this.c.has(l)?this.c.get(l).push(v):this.c.set(l,[v])}getArcs(l){return this.c.has(l)?this.c.get(l):[]}hasOnlyGoodArcs(l,v){const E=m.getArcs(l);for(let P=0;P<E.length;P++)if(!v.has(E[P]))return!1;return!0}getNodes(){return this.e}},b=new Map;for(const l of w){const v=n.ExtensionIdentifier.toKey(l.identifier);if(b.set(v,l),l.extensionDependencies)for(const E of l.extensionDependencies){const P=n.ExtensionIdentifier.toKey(E);m.addArc(v,P)}}const f=new Set;m.getNodes().filter(l=>m.getArcs(l).length===0).forEach(l=>f.add(l));const s=m.getNodes().filter(l=>!f.has(l));let o;do{o=!1;for(let l=0;l<s.length;l++){const v=s[l];m.hasOnlyGoodArcs(v,f)&&(s.splice(l,1),l--,f.add(v),o=!0)}}while(o);return s.map(l=>b.get(l))}containsActivationEvent(w){return this.g.has(w)}containsExtension(w){return this.e.has(n.ExtensionIdentifier.toKey(w))}getExtensionDescriptionsForActivationEvent(w){const m=this.g.get(w);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(w){const m=this.e.get(n.ExtensionIdentifier.toKey(w));return m||void 0}getExtensionDescriptionByUUID(w){for(const m of this.f)if(m.uuid===w)return m}getExtensionDescriptionByIdOrUUID(w,m){return this.getExtensionDescription(w)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=I;var A;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(A||(A={}));function y(O,w){const m=O.isBuiltin?0:O.isUnderDevelopment?2:1,b=w.isBuiltin?0:w.isUnderDevelopment?2:1;if(m!==b)return m-b;const f=S.posix.basename(O.extensionLocation.path),s=S.posix.basename(w.extensionLocation.path);return f<s?-1:f>s?1:0}function k(O,w){const m=new Set;return w.forEach(b=>m.add(n.ExtensionIdentifier.toKey(b))),O.filter(b=>!m.has(n.ExtensionIdentifier.toKey(b.identifier)))}}),define(Ie[73],Ce([1,0,24]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var S;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(S=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function I(k){const O=n.VSBuffer.alloc(1);switch(k){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=I;function A(k,O){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=A;var y;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[74],Ce([1,0,3,4,12,27,73,48,50,22,2]),function(te,e,n,C,S,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let w=class{constructor(s,o){this.i=s,this.a=new C.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new C.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=o.createLogger(O.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(s,o,l){const v=this.getTelemetryDetails(),E=new m(o,l,s,this.g,this.f,this.getBuiltInCommonProperties(s),{isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled});return this.h.set(s.identifier.value,E),E.apiTelemetryLogger}$initializeTelemetryLevel(s,o,l){this.d=s,this.f=o,this.c=l??{usage:!0,error:!0}}getBuiltInCommonProperties(s){const o={};switch(o["common.extname"]=`${s.publisher}.${s.name}`,o["common.extversion"]=s.version,o["common.vscodemachineid"]=this.i.telemetryInfo.machineId,o["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,o["common.vscodeversion"]=this.i.version,o["common.isnewappinstall"]=b(this.i.telemetryInfo.firstSessionDate),o["common.product"]=this.i.environment.appHost,this.i.uiKind){case I.UIKind.Web:o["common.uikind"]="web";break;case I.UIKind.Desktop:o["common.uikind"]="desktop";break;default:o["common.uikind"]="unknown"}return o["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.i.remote.authority)),o}$onDidChangeTelemetryLevel(s){this.e=this.getTelemetryConfiguration(),this.d=s;const o=this.getTelemetryDetails();this.h.forEach(l=>{l.updateTelemetryEnablements(o.isUsageEnabled,o.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(s,o){const l=this.h.get(s.value);return!l||l.ignoreUnhandledExtHostErrors?!1:(l.logError(o),!0)}};w=qe([Ve(0,M.IExtHostInitDataService),Ve(1,S.ILoggerService)],w),e.ExtHostTelemetry=w;class m{constructor(s,o,l,v,E,P,p){this.g=l,this.h=v,this.i=E,this.j=P,this.b=new C.Emitter,this.ignoreUnhandledExtHostErrors=o?.ignoreUnhandledErrors??!1,this.e=o?.ignoreBuiltInCommonProperties??!1,this.f=o?.additionalCommonProperties,this.a=s,this.c={isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}}updateTelemetryEnablements(s,o){this.d&&(this.c={isUsageEnabled:s,isErrorsEnabled:o},this.b.fire(this.d))}mixInCommonPropsAndCleanData(s){let o=s.properties??s;return o=(0,y.cleanData)(o,[]),this.f&&(o=(0,k.mixin)(o,this.f)),this.e||(o=(0,k.mixin)(o,this.j)),s.properties?s.properties=o:s=o,s}k(s,o){this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,o=this.mixInCommonPropsAndCleanData(o||{}),this.i||this.a.sendEventData(s,o),this.h.trace(s,o)}logUsage(s,o){!this.c.isUsageEnabled||this.k(s,o)}logError(s,o){!this.c.isErrorsEnabled||(typeof s=="string"?this.k(s,o):this.a.sendErrorData(s,o))}get apiTelemetryLogger(){if(!this.d){const s=this,o={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.c.isUsageEnabled},get isErrorsEnabled(){return s.c.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.b.event.bind(s)};this.d=Object.freeze(o)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=m;function b(f){const s=Date.now()-new Date(f).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.isNewAppInstall=b,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(Ie[26],Ce([1,0,4,2,3,25,166]),function(te,e,n,C,S,M,I){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class y{constructor(h){this.affinity=h,this.kind=1}equals(h){return this.kind===h.kind&&this.affinity===h.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class k{constructor(h){this.affinity=h,this.kind=2}equals(h){return this.kind===h.kind&&this.affinity===h.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class O{constructor(){this.kind=3,this.affinity=0}equals(h){return this.kind===h.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class w{constructor(h){this.dependency=h}}e.MissingExtensionDependency=w;var m;(function(t){t[t.LocalProcess=1]="LocalProcess",t[t.LocalWebWorker=2]="LocalWebWorker",t[t.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(t){if(t===null)return"None";switch(t){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=b;class f{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(h,a){const u=[],g=[],R=[],F=[],q=l(this.c),Z=l(h),x=(L,V)=>L.extensionLocation.toString()===V.extensionLocation.toString()||L.isBuiltin===V.isBuiltin||L.isUserBuiltin===V.isUserBuiltin||L.isUnderDevelopment===V.isUnderDevelopment;for(const L of this.c){const V=Z.get(M.ExtensionIdentifier.toKey(L.identifier));if(!V){u.push(L.identifier),q.delete(M.ExtensionIdentifier.toKey(L.identifier));continue}if(!x(L,V)){u.push(L.identifier),q.delete(M.ExtensionIdentifier.toKey(L.identifier));continue}}for(const L of h){const V=q.get(M.ExtensionIdentifier.toKey(L.identifier));if(!V){g.push(L);continue}if(!x(V,L)){u.push(V.identifier),q.delete(M.ExtensionIdentifier.toKey(V.identifier));continue}}const N=o(this.d),$=o(a);for(const L of this.d)$.has(M.ExtensionIdentifier.toKey(L))||R.push(L);for(const L of a)N.has(M.ExtensionIdentifier.toKey(L))||F.push(L);const T={toRemove:u,toAdd:g,myToRemove:R,myToAdd:F};return this.delta(T),T}delta(h){const{toRemove:a,toAdd:u,myToRemove:g,myToAdd:R}=h,F=o(a),q=o(g);for(let Z=0;Z<this.c.length;Z++)F.has(M.ExtensionIdentifier.toKey(this.c[Z].identifier))&&(this.c.splice(Z,1),Z--);for(let Z=0;Z<this.d.length;Z++)q.has(M.ExtensionIdentifier.toKey(this.d[Z]))&&(this.d.splice(Z,1),Z--);for(const Z of u)this.c.push(Z);for(const Z of R)this.d.push(Z)}containsExtension(h){for(const a of this.d)if(M.ExtensionIdentifier.equals(a,h))return!0;return!1}}e.ExtensionHostExtensions=f;class s{constructor(h){if(this[A]="ExtensionIdentifierSet",this.c=new Map,this.d=M.ExtensionIdentifier.toKey,h)for(const a of h)this.add(a)}get size(){return this.c.size}add(h){return this.c.set(this.d(h),h),this}clear(){this.c.clear()}delete(h){return this.c.delete(this.d(h))}has(h){return this.c.has(this.d(h))}forEach(h,a){this.c.forEach(u=>h.call(a,u,u,this))}*entries(){for(const[h,a]of this.c)yield[a,a]}keys(){return this.c.values()}values(){return this.c.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=s;function o(t){const h=new Set;for(const a of t)h.add(M.ExtensionIdentifier.toKey(a));return h}e.extensionIdentifiersArrayToSet=o;function l(t){const h=new Map;for(const a of t)h.set(M.ExtensionIdentifier.toKey(a.identifier),a);return h}function v(t,h){return t.enabledApiProposals?t.enabledApiProposals.includes(h):!1}e.isProposedApiEnabled=v;function E(t,h){if(!v(t,h))throw new Error(`Extension '${t.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${t.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${t.identifier.value}`)}e.checkProposedApiEnabled=E;class P{constructor(h,a,u,g){this.codeLoadingTime=h,this.activateCallTime=a,this.activateResolvedTime=u,this.activationReason=g}}e.ActivationTimes=P;class p{constructor(h,a){this.description=h,this.value=a}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var r;(function(t){t[t.Normal=0]="Normal",t[t.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function d(t){return{type:t.isBuiltin?0:1,isBuiltin:t.isBuiltin||t.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(t.publisher,t.name),uuid:t.uuid},manifest:t,location:t.extensionLocation,targetPlatform:t.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function i(t,h){return{identifier:new M.ExtensionIdentifier((0,I.getExtensionId)(t.manifest.publisher,t.manifest.name)),isBuiltin:t.type===0,isUserBuiltin:t.type===1&&t.isBuiltin,isUnderDevelopment:!!h,extensionLocation:t.location,...t.manifest,uuid:t.identifier.uuid,targetPlatform:t.targetPlatform,browserNlsBundleUris:t.browserNlsBundleUris}}e.toExtensionDescription=i;class c{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(h,a){return Promise.resolve(0)}getInspectPorts(h,a){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=c}),define(Ie[189],Ce([1,0,11,98,25,26,12,16]),function(te,e,n,C,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(l,v,E,P){this.startup=l,this.codeLoadingTime=v,this.activateCallTime=E,this.activateResolvedTime=P}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class k{constructor(l){this.a=l,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(l,v){return l===-1||v===-1?-1:v-l}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=k;class O{constructor(l,v,E,P,p,r){this.activationFailed=l,this.activationFailedError=v,this.activationTimes=E,this.module=P,this.exports=p,this.subscriptions=r}}e.ActivatedExtension=O;class w extends O{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=w;class m extends O{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=m;class b extends O{constructor(l){super(!0,l,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(l,v,E,P){this.g=P,this.a=l,this.b=v,this.c=E,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[l,v]of this.d)v.dispose()}isActivated(l){const v=this.d.get(S.ExtensionIdentifier.toKey(l));return Boolean(v&&v.value)}getActivatedExtension(l){const v=this.d.get(S.ExtensionIdentifier.toKey(l));if(!v||!v.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return v.value}async activateByEvent(l,v){if(this.f[l])return;const E=this.a.getExtensionDescriptionsForActivationEvent(l);await this.h(E.map(P=>({id:P.identifier,reason:{startup:v,extensionId:P.identifier,activationEvent:l}}))),this.f[l]=!0}activateById(l,v){const E=this.a.getExtensionDescription(l);if(!E)throw new Error(`Extension '${l}' is not known`);return this.h([{id:E.identifier,reason:v}])}async h(l){const v=l.filter(E=>!this.isActivated(E.id)).map(E=>this.j(E));await Promise.all(v.map(E=>E.wait()))}j(l){if(this.d.has(S.ExtensionIdentifier.toKey(l.id)))return this.d.get(S.ExtensionIdentifier.toKey(l.id));if(this.l(l.id))return this.k(l,null,[],null);const v=this.a.getExtensionDescription(l.id);if(!v){const p=new Error(`Cannot activate unknown extension '${l.id.value}'`),r=this.k(l,null,[],new b(p));return this.c.onExtensionActivationError(l.id,p,new M.MissingExtensionDependency(l.id.value)),r}const E=[],P=typeof v.extensionDependencies>"u"?[]:v.extensionDependencies;for(const p of P){if(this.m(p))continue;const r=this.d.get(S.ExtensionIdentifier.toKey(p));if(r){E.push(r);continue}if(this.l(p)){E.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:l.reason}));continue}const d=this.a.getExtensionDescription(p);if(d){if(!d.main&&!d.browser)continue;E.push(this.j({id:d.identifier,reason:l.reason}));continue}const i=v.displayName||v.identifier.value,c=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${p}'`),t=this.k(l,v.displayName,[],new b(c));return this.c.onExtensionActivationError(v.identifier,c,new M.MissingExtensionDependency(p)),t}return this.k(l,v.displayName,E,null)}k(l,v,E,P){const p=new s(l.id,v,l.reason,E,P,this.c,this.g);return this.d.set(S.ExtensionIdentifier.toKey(l.id),p),p}l(l){return C.ExtensionDescriptionRegistry.isHostExtension(l,this.a,this.b)}m(l){const v=this.b.getExtensionDescription(l);return v?!v.main&&!v.browser:!1}};f=qe([Ve(3,I.ILogService)],f),e.ExtensionsActivator=f;let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(l,v,E,P,p,r,d){this.c=l,this.d=v,this.f=E,this.g=P,this.h=p,this.j=r,this.k=d,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let l=0;l<this.g.length;l++){const v=this.g[l];if(v.value&&!v.value.activationFailed){this.g.splice(l,1),l--;continue}if(v.value&&v.value.activationFailed){const E=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${v.friendlyName}' failed to activate`);E.detail=v.value.activationFailedError,this.h=new b(E),this.j.onExtensionActivationError(this.c,E,null);return}}this.g.length>0&&await Promise.race(this.g.map(l=>l.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(l){const v=new Error;if(l&&l.name&&(v.name=l.name),l&&l.message?v.message=`Activating extension '${this.c.value}' failed: ${l.message}.`:v.message=`Activating extension '${this.c.value}' failed: ${l}.`,l&&l.stack&&(v.stack=l.stack),this.h=new b(v),this.b&&n.isCancellationError(l))return;this.j.onExtensionActivationError(this.c,v,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(l)}}};s=qe([Ve(6,I.ILogService)],s)}),define(Ie[190],Ce([1,0,12,27,26]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends n.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:S.ExtensionHostLogFileName}))}};M=qe([Ve(0,n.ILoggerService),Ve(1,C.IExtHostInitDataService)],M),e.ExtHostLogService=M});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,n):S?S.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ie[7],Ce([1,0,18,11,86,28,64,10,9,2,34,36,94,70,26]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f){"use strict";var s,o,l,v,E,P,p,r,d,i,c,t,h,a,u,g,R,F,q,Z,x,N,$;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function T(z){return Object.assign(z,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct(z,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[ie,...we]=arguments;return Reflect.construct(z,we,ie.constructor)}}})}var L;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(L=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var V;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(V=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let j=P=class{static from(...U){let ie=U;return new P(function(){if(ie){for(const we of ie)we&&typeof we.dispose=="function"&&we.dispose();ie=void 0}})}constructor(U){s.set(this,void 0),Je(this,s,U,"f")}dispose(){typeof Oe(this,s,"f")=="function"&&(Oe(this,s,"f").call(this),Je(this,s,void 0,"f"))}};s=new WeakMap,j=P=qe([T],j),e.Disposable=j;let le=p=class{static Min(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let we=1;we<U.length;we++){const Ke=U[we];Ke.isBefore(ie)&&(ie=Ke)}return ie}static Max(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let we=1;we<U.length;we++){const Ke=U[we];Ke.isAfter(ie)&&(ie=Ke)}return ie}static isPosition(U){if(!U)return!1;if(U instanceof p)return!0;const{line:ie,character:we}=U;return typeof ie=="number"&&typeof we=="number"}static of(U){if(U instanceof p)return U;if(this.isPosition(U))return new p(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,ie){if(U<0)throw(0,C.illegalArgument)("line must be non-negative");if(ie<0)throw(0,C.illegalArgument)("character must be non-negative");this.c=U,this.e=ie}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,ie=0){if(U===null||ie===null)throw(0,C.illegalArgument)();let we;return typeof U>"u"?we=0:typeof U=="number"?we=U:(we=typeof U.lineDelta=="number"?U.lineDelta:0,ie=typeof U.characterDelta=="number"?U.characterDelta:0),we===0&&ie===0?this:new p(this.line+we,this.character+ie)}with(U,ie=this.character){if(U===null||ie===null)throw(0,C.illegalArgument)();let we;return typeof U>"u"?we=this.line:typeof U=="number"?we=U:(we=typeof U.line=="number"?U.line:this.line,ie=typeof U.character=="number"?U.character:this.character),we===this.line&&ie===this.character?this:new p(we,ie)}toJSON(){return{line:this.line,character:this.character}}};le=p=qe([T],le),e.Position=le;let Y=r=class{static isRange(U){return U instanceof r?!0:U?le.isPosition(U.start)&&le.isPosition(U.end):!1}static of(U){if(U instanceof r)return U;if(this.isRange(U))return new r(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,ie,we,Ke){let Ye,ot;if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof Ke=="number"?(Ye=new le(U,ie),ot=new le(we,Ke)):le.isPosition(U)&&le.isPosition(ie)&&(Ye=le.of(U),ot=le.of(ie)),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this.c=Ye,this.e=ot):(this.c=ot,this.e=Ye)}contains(U){return r.isRange(U)?this.contains(U.start)&&this.contains(U.end):le.isPosition(U)?!(le.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const ie=le.Max(U.start,this.c),we=le.Min(U.end,this.e);if(!ie.isAfter(we))return new r(ie,we)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ie=le.Min(U.start,this.c),we=le.Max(U.end,this.end);return new r(ie,we)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,ie=this.end){if(U===null||ie===null)throw(0,C.illegalArgument)();let we;return U?le.isPosition(U)?we=U:(we=U.start||this.start,ie=U.end||this.end):we=this.start,we.isEqual(this.c)&&ie.isEqual(this.end)?this:new r(we,ie)}toJSON(){return[this.start,this.end]}};Y=r=qe([T],Y),e.Range=Y;let pe=d=class extends Y{static isSelection(U){return U instanceof d?!0:U?Y.isRange(U)&&le.isPosition(U.anchor)&&le.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,ie,we,Ke){let Ye,ot;if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof Ke=="number"?(Ye=new le(U,ie),ot=new le(we,Ke)):le.isPosition(U)&&le.isPosition(ie)&&(Ye=le.of(U),ot=le.of(ie)),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot),this.f=Ye,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};pe=d=qe([T],pe),e.Selection=pe;class ue{constructor(U,ie,we){if(typeof U!="string"||U.length===0)throw(0,C.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,C.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z_\-]+$/.test(we)))throw(0,C.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(ie),this.connectionToken=we}}e.ResolvedAuthority=ue;class de extends Error{static NotAvailable(U,ie){return new de(U,m.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(U){return new de(U,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,ie=m.RemoteAuthorityResolverErrorCode.Unknown,we){super(U),this._message=U,this._code=ie,this._detail=we,Object.setPrototypeOf(this,de.prototype)}}e.RemoteAuthorityResolverError=de;var re;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(re=e.EndOfLine||(e.EndOfLine={}));var G;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(G=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let H=i=class{static isTextEdit(U){return U instanceof i?!0:U?Y.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ie){return new i(U,ie)}static insert(U,ie){return i.replace(new Y(U,U),ie)}static delete(U){return i.replace(U,"")}static setEndOfLine(U){const ie=new i(new Y(new le(0,0),new le(0,0)),"");return ie.newEol=U,ie}get range(){return this.c}set range(U){if(U&&!Y.isRange(U))throw(0,C.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,C.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,C.illegalArgument)("newEol");this.f=U}constructor(U,ie){this.c=U,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};H=i=qe([T],H),e.TextEdit=H;let oe=c=class{static isNotebookCellEdit(U){return U instanceof c?!0:U?xt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,ie){return new c(U,ie)}static insertCells(U,ie){return new c(new xt(U,U),ie)}static deleteCells(U){return new c(U,[])}static updateCellMetadata(U,ie){const we=new c(new xt(U,U),[]);return we.newCellMetadata=ie,we}static updateNotebookMetadata(U){const ie=new c(new xt(0,0),[]);return ie.newNotebookMetadata=U,ie}constructor(U,ie){this.range=U,this.newCells=ie}};oe=c=qe([T],oe),e.NotebookEdit=oe;class ve{static isSnippetTextEdit(U){return U instanceof ve?!0:U?Y.isRange(U.range)&&xe.isSnippetString(U.snippet):!1}static replace(U,ie){return new ve(U,ie)}static insert(U,ie){return ve.replace(new Y(U,U),ie)}constructor(U,ie){this.range=U,this.snippet=ie}}e.SnippetTextEdit=ve;var Ae;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ae=e.FileEditType||(e.FileEditType={}));let Be=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,ie,we,Ke){this.c.push({_type:1,from:U,to:ie,options:we,metadata:Ke})}createFile(U,ie,we){this.c.push({_type:1,from:void 0,to:U,options:ie,metadata:we})}deleteFile(U,ie,we){this.c.push({_type:1,from:U,to:void 0,options:ie,metadata:we})}e(U,ie,we){this.c.push({_type:3,metadata:we,uri:U,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(U,ie,we,Ke){const Ye=ie.start,ot=ie.end;(Ye!==ot||we.length>0)&&this.c.push({_type:5,uri:U,index:Ye,count:ot-Ye,cells:we,metadata:Ke})}g(U,ie,we,Ke){this.c.push({_type:3,metadata:Ke,uri:U,edit:{editType:8,index:ie,metadata:we}})}replace(U,ie,we,Ke){this.c.push({_type:2,uri:U,edit:new H(ie,we),metadata:Ke})}insert(U,ie,we,Ke){this.replace(U,new Y(ie,ie),we,Ke)}delete(U,ie,we){this.replace(U,ie,"",we)}has(U){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===U.toString())}set(U,ie){if(ie)for(const we of ie){if(!we)continue;let Ke,Ye;Array.isArray(we)?(Ke=we[0],Ye=we[1]):Ke=we,oe.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(U,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(U,Ke.newNotebookMetadata,Ye):this.f(U,Ke.range,Ke.newCells,Ye):ve.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:U,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:U,edit:Ke,metadata:Ye})}else{for(let we=0;we<this.c.length;we++){const Ke=this.c[we];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===U.toString()&&(this.c[we]=void 0);break}}(0,n.coalesceInPlace)(this.c)}}get(U){const ie=[];for(const we of this.c)we._type===2&&we.uri.toString()===U.toString()&&ie.push(we.edit);return ie}entries(){const U=new M.ResourceMap;for(const ie of this.c)if(ie._type===2){let we=U.get(ie.uri);we||(we=[ie.uri,[]],U.set(ie.uri,we)),we[1].push(ie.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Be=qe([T],Be),e.WorkspaceEdit=Be;let xe=t=class{static isSnippetString(U){return U instanceof t?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=t.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ie=this.e++){if(typeof U=="function"){const we=new t;we.e=this.e,U(we),this.e=we.e,U=we.value}else U=t.c(U);return this.value+="${",this.value+=ie,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ie=this.e++){const we=U.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(U,ie){if(typeof ie=="function"){const we=new t;we.e=this.e,ie(we),this.e=we.e,ie=we.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};xe=t=qe([T],xe),e.SnippetString=xe;var Te;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Te=e.DiagnosticTag||(e.DiagnosticTag={}));var Se;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=h=class{static isLocation(U){return U instanceof h?!0:U?Y.isRange(U.range)&&k.URI.isUri(U.uri):!1}constructor(U,ie){if(this.uri=U,ie)if(Y.isRange(ie))this.range=Y.of(ie);else if(le.isPosition(ie))this.range=new Y(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=h=qe([T],ke),e.Location=ke;let se=class{static is(U){return U?typeof U.message=="string"&&U.location&&Y.isRange(U.location.range)&&k.URI.isUri(U.location.uri):!1}constructor(U,ie){this.location=U,this.message=ie}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.location.range.isEqual(ie.location.range)&&U.location.uri.toString()===ie.location.uri.toString()}};se=qe([T],se),e.DiagnosticRelatedInformation=se;let ce=class{constructor(U,ie,we=Se.Error){if(!Y.isRange(U))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=U,this.message=ie,this.severity=we}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.severity===ie.severity&&U.code===ie.code&&U.severity===ie.severity&&U.source===ie.source&&U.range.isEqual(ie.range)&&(0,n.equals)(U.tags,ie.tags)&&(0,n.equals)(U.relatedInformation,ie.relatedInformation,se.isEqual)}};ce=qe([T],ce),e.Diagnostic=ce;let J=class{constructor(U,ie){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ie}};J=qe([T],J),e.Hover=J;var D;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(D=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let B=class{constructor(U,ie=D.Text){this.range=U,this.kind=ie}toJSON(){return{range:this.range,kind:D[this.kind]}}};B=qe([T],B),e.DocumentHighlight=B;var W;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(W=e.SymbolKind||(e.SymbolKind={}));var K;(function(z){z[z.Deprecated=1]="Deprecated"})(K=e.SymbolTag||(e.SymbolTag={}));let ee=a=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,ie,we,Ke,Ye){this.name=U,this.kind=ie,this.containerName=Ye,typeof we=="string"&&(this.containerName=we),Ke instanceof ke?this.location=Ke:we instanceof Y&&(this.location=new ke(Ke,we)),a.validate(this)}toJSON(){return{name:this.name,kind:W[this.kind],location:this.location,containerName:this.containerName}}};ee=a=qe([T],ee),e.SymbolInformation=ee;let he=u=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(u.validate)}constructor(U,ie,we,Ke,Ye){this.name=U,this.detail=ie,this.kind=we,this.range=Ke,this.selectionRange=Ye,this.children=[],u.validate(this)}};he=u=qe([T],he),e.DocumentSymbol=he;var ye;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(U,ie){this.title=U,this.kind=ie}};ae=qe([T],ae),e.CodeAction=ae;let be=g=class{constructor(U){this.value=U}append(U){return new g(this.value?this.value+g.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+g.c)}};be.c=".",be=g=qe([T],be),e.CodeActionKind=be,be.Empty=new be(""),be.QuickFix=be.Empty.append("quickfix"),be.Refactor=be.Empty.append("refactor"),be.RefactorExtract=be.Refactor.append("extract"),be.RefactorInline=be.Refactor.append("inline"),be.RefactorMove=be.Refactor.append("move"),be.RefactorRewrite=be.Refactor.append("rewrite"),be.Source=be.Empty.append("source"),be.SourceOrganizeImports=be.Source.append("organizeImports"),be.SourceFixAll=be.Source.append("fixAll");let Ee=class{constructor(U,ie){if(this.range=U,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=qe([T],Ee),e.SelectionRange=Ee;class We{constructor(U,ie,we,Ke,Ye,ot){this.kind=U,this.name=ie,this.detail=we,this.uri=Ke,this.range=Ye,this.selectionRange=ot}}e.CallHierarchyItem=We;class He{constructor(U,ie){this.fromRanges=ie,this.from=U}}e.CallHierarchyIncomingCall=He;class tt{constructor(U,ie){this.fromRanges=ie,this.to=U}}e.CallHierarchyOutgoingCall=tt;var Xe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,ie){this.range=U,this.command=ie}get isResolved(){return!!this.command}};et=qe([T],et),e.CodeLens=et;let it=R=class{static isMarkdownString(U){return U instanceof R?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,ie=!1){o.set(this,void 0),Je(this,o,new S.MarkdownString(U,{supportThemeIcons:ie}),"f")}get value(){return Oe(this,o,"f").value}set value(U){Oe(this,o,"f").value=U}get isTrusted(){return Oe(this,o,"f").isTrusted}set isTrusted(U){Oe(this,o,"f").isTrusted=U}get supportThemeIcons(){return Oe(this,o,"f").supportThemeIcons}set supportThemeIcons(U){Oe(this,o,"f").supportThemeIcons=U}get supportHtml(){return Oe(this,o,"f").supportHtml}set supportHtml(U){Oe(this,o,"f").supportHtml=U}get baseUri(){return Oe(this,o,"f").baseUri}set baseUri(U){Oe(this,o,"f").baseUri=U}appendText(U){return Oe(this,o,"f").appendText(U),this}appendMarkdown(U){return Oe(this,o,"f").appendMarkdown(U),this}appendCodeblock(U,ie){return Oe(this,o,"f").appendCodeblock(ie??"",U),this}};o=new WeakMap,it=R=qe([T],it),e.MarkdownString=it;let dt=class{constructor(U,ie){this.label=U,this.documentation=ie}};dt=qe([T],dt),e.ParameterInformation=dt;let Fe=class{constructor(U,ie){this.label=U,this.documentation=ie,this.parameters=[]}};Fe=qe([T],Fe),e.SignatureInformation=Fe;let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};st=qe([T],st),e.SignatureHelp=st;var _;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(_=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Q;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Q=e.InlayHintKind||(e.InlayHintKind={}));let ge=class{constructor(U){this.value=U}};ge=qe([T],ge),e.InlayHintLabelPart=ge;let Le=class{constructor(U,ie,we){this.position=U,this.label=ie,this.kind=we}};Le=qe([T],Le),e.InlayHint=Le;var $e;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($e=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var _e;(function(z){z[z.Deprecated=1]="Deprecated"})(_e=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(U,ie){this.label=U,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=qe([T],nt),e.CompletionItem=nt;let wt=class{constructor(U=[],ie=!1){this.items=U,this.isIncomplete=ie}};wt=qe([T],wt),e.CompletionList=wt;let St=class{constructor(U,ie,we){this.insertText=U,this.range=ie,this.command=we}};St=qe([T],St),e.InlineSuggestion=St;let Ct=class{constructor(U){this.commands=void 0,this.items=U}};Ct=qe([T],Ct),e.InlineSuggestionList=Ct;var lt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(lt=e.ViewColumn||(e.ViewColumn={}));var at;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(at=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Bt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Bt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ot;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Ot=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Dt;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(Dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var $t;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})($t=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function U(ie){switch(ie){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Nt=class{constructor(U,ie){if(ie&&!k.URI.isUri(ie))throw(0,C.illegalArgument)("target");if(!Y.isRange(U)||U.isEmpty)throw(0,C.illegalArgument)("range");this.range=U,this.target=ie}};Nt=qe([T],Nt),e.DocumentLink=Nt;let Ge=class{constructor(U,ie,we,Ke){this.red=U,this.green=ie,this.blue=we,this.alpha=Ke}};Ge=qe([T],Ge),e.Color=Ge;let Lt=class{constructor(U,ie){if(ie&&!(ie instanceof Ge))throw(0,C.illegalArgument)("color");if(!Y.isRange(U)||U.isEmpty)throw(0,C.illegalArgument)("range");this.range=U,this.color=ie}};Lt=qe([T],Lt),e.ColorInformation=Lt;let Mt=class{constructor(U){if(!U||typeof U!="string")throw(0,C.illegalArgument)("label");this.label=U}};Mt=qe([T],Mt),e.ColorPresentation=Mt;var Ut;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Ut=e.ColorFormat||(e.ColorFormat={}));var gt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(gt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var kt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(kt=e.TerminalExitReason||(e.TerminalExitReason={}));class De{constructor(U,ie,we){if(this.startIndex=U,this.length=ie,this.tooltip=we,typeof U!="number"||U<0)throw(0,C.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,C.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,C.illegalArgument)("tooltip")}}e.TerminalLink=De;class Pe{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Pe;class me{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=me;var X;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(X=e.TerminalLocation||(e.TerminalLocation={}));class Re{constructor(U){if(this.options=U,typeof U!="object")throw(0,C.illegalArgument)("options")}}e.TerminalProfile=Re;var Me;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Me=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let ze=F=class{static from(U){switch(U){case"clean":return F.Clean;case"build":return F.Build;case"rebuild":return F.Rebuild;case"test":return F.Test;default:return}}constructor(U,ie){if(this.label=ie,typeof U!="string"||typeof ie!="string")throw(0,C.illegalArgument)("name");this.c=U}get id(){return this.c}};ze.Clean=new F("clean","Clean"),ze.Build=new F("build","Build"),ze.Rebuild=new F("rebuild","Rebuild"),ze.Test=new F("test","Test"),ze=F=qe([T],ze),e.TaskGroup=ze;function Ze(z){let U="";for(let ie=0;ie<z.length;ie++)U+=z[ie].replace(/,/g,",,")+",";return U}let bt=class{constructor(U,ie,we){if(typeof U!="string")throw(0,C.illegalArgument)("process");this.e=[],this.c=U,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=we):this.f=ie)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,C.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)U.push(ie);return Ze(U)}};bt=qe([T],bt),e.ProcessExecution=bt;let vt=class{constructor(U,ie,we){if(this.f=[],Array.isArray(ie)){if(!U)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,C.illegalArgument)("command");this.e=U,this.f=ie,this.g=we}else{if(typeof U!="string")throw(0,C.illegalArgument)("commandLine");this.c=U,this.g=ie}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,C.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,C.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)U.push(typeof ie=="string"?ie:ie.value);return Ze(U)}};vt=qe([T],vt),e.ShellExecution=vt;var At;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(At=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class It{constructor(U){this.c=U}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=It;let ht=q=class{constructor(U,ie,we,Ke,Ye,ot){this.j=!1,this.k=this.definition=U;let ut;typeof ie=="string"?(this.m=this.name=ie,this.t=this.source=we,this.execution=Ke,ut=Ye,this.j=!0):ie===pt.Global||ie===pt.Workspace?(this.target=ie,this.m=this.name=we,this.t=this.source=Ke,this.execution=Ye,ut=ot):(this.target=ie,this.m=this.name=we,this.t=this.source=Ke,this.execution=Ye,ut=ot),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof bt?this.k={type:q.e,id:this.n.computeId()}:this.n instanceof vt?this.k={type:q.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:q.c,id:this.n.computeId()}:this.k={type:q.g,id:(0,O.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,C.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const ie=this.k.type;(q.g===ie||q.e===ie||q.f===ie||q.c===ie)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};ht.c="customExecution",ht.e="process",ht.f="shell",ht.g="$empty",ht=q=qe([T],ht),e.Task=ht;var Kt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Kt=e.ProgressLocation||(e.ProgressLocation={}));var Vt;(function(z){function U(ie){const we=ie;return(0,y.isNumber)(we.value)?we.tooltip&&!(0,y.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}z.isViewBadge=U})(Vt=e.ViewBadge||(e.ViewBadge={}));let Et=Z=class{static isTreeItem(U,ie){if(U instanceof Z)return!0;const we=U;if(we.label!==void 0&&!(0,y.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,y.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,y.isString)(we.iconPath)&&!k.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,y.isString)(we.iconPath.id))){const Ke=we.iconPath;if(!Ke||!(0,y.isString)(Ke.light)&&!k.URI.isUri(Ke.light)&&!(0,y.isString)(Ke.dark)&&!k.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,y.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!k.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,y.isString)(we.tooltip)&&!(we.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<Qt.None&&we.collapsibleState>Qt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,y.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,f.checkProposedApiEnabled)(ie,"treeItemCheckbox");const Ke=(0,y.isNumber)(we.checkboxState)?we.checkboxState:(0,y.isObject)(we.checkboxState)&&(0,y.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,Ye=!(0,y.isNumber)(we.checkboxState)&&(0,y.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==ri.Checked&&Ke!==ri.Unchecked||Ye!==void 0&&!(0,y.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(U,ie=Qt.None){this.collapsibleState=ie,k.URI.isUri(U)?this.resourceUri=U:this.label=U}};Et=Z=qe([T],Et),e.TreeItem=Et;var Qt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(Qt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var ri;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(ri=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ei=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,ie){this.value=U,this.id=ie??(0,O.generateUuid)()}};ei=qe([T],ei),e.DataTransferItem=ei;let bi=class{constructor(U){l.set(this,new Map);for(const[ie,we]of U??[]){const Ke=Oe(this,l,"f").get(ie);Ke?Ke.push(we):Oe(this,l,"f").set(ie,[we])}}get(U){return Oe(this,l,"f").get(U)?.[0]}set(U,ie){Oe(this,l,"f").set(U,[ie])}forEach(U,ie){for(const[we,Ke]of Oe(this,l,"f"))for(const Ye of Ke)U.call(ie,Ye,we,this)}*[(l=new WeakMap,Symbol.iterator)](){for(const[U,ie]of Oe(this,l,"f"))for(const we of ie)yield[U,we]}};bi=qe([T],bi),e.DataTransfer=bi;let Tt=class{constructor(U){this.insertText=U}};Tt=qe([T],Tt),e.DocumentDropEdit=Tt;let si=class{constructor(U){this.insertText=U}};si=qe([T],si),e.DocumentPasteEdit=si;let jt=class{constructor(U,ie){this.id=U,this.color=ie}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};jt=qe([T],jt),e.ThemeIcon=jt,jt.File=new jt("file"),jt.Folder=new jt("folder");let ti=class{constructor(U){this.id=U}};ti=qe([T],ti),e.ThemeColor=ti;var oi;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(oi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ct=class{get base(){return this.c}set base(U){this.c=U,this.e=k.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,ie){if(typeof U!="string"&&(!U||!k.URI.isUri(U)&&!k.URI.isUri(U.uri)))throw(0,C.illegalArgument)("base");if(typeof ie!="string")throw(0,C.illegalArgument)("pattern");typeof U=="string"?this.baseUri=k.URI.file(U):k.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ct=qe([T],ct),e.RelativePattern=ct;const Oi=new WeakMap;function _t(z,U){Oi.set(z,U)}e.setBreakpointId=_t;let Wt=class{constructor(U,ie,we,Ke){this.enabled=typeof U=="boolean"?U:!0,typeof ie=="string"&&(this.condition=ie),typeof we=="string"&&(this.hitCondition=we),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=Oi.get(this)??(0,O.generateUuid)()),this.c}};Wt=qe([T],Wt),e.Breakpoint=Wt;let ai=class extends Wt{constructor(U,ie,we,Ke,Ye){if(super(ie,we,Ke,Ye),U===null)throw(0,C.illegalArgument)("location");this.location=U}};ai=qe([T],ai),e.SourceBreakpoint=ai;let Ei=class extends Wt{constructor(U,ie,we,Ke,Ye){super(ie,we,Ke,Ye),this.functionName=U}};Ei=qe([T],Ei),e.FunctionBreakpoint=Ei;let ci=class extends Wt{constructor(U,ie,we,Ke,Ye,ot,ut){if(super(Ke,Ye,ot,ut),!ie)throw(0,C.illegalArgument)("dataId");this.label=U,this.dataId=ie,this.canPersist=we}};ci=qe([T],ci),e.DataBreakpoint=ci;let wi=class{constructor(U,ie,we){this.command=U,this.args=ie||[],this.options=we}};wi=qe([T],wi),e.DebugAdapterExecutable=wi;let ui=class{constructor(U,ie){this.port=U,this.host=ie}};ui=qe([T],ui),e.DebugAdapterServer=ui;let ii=class{constructor(U){this.path=U}};ii=qe([T],ii),e.DebugAdapterNamedPipeServer=ii;let Si=class{constructor(U){this.implementation=U}};Si=qe([T],Si),e.DebugAdapterInlineImplementation=Si;let ni=class{constructor(U,ie){this.range=U,this.expression=ie}};ni=qe([T],ni),e.EvaluatableExpression=ni;var yi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(yi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Di=class{constructor(U,ie){this.range=U,this.text=ie}};Di=qe([T],Di),e.InlineValueText=Di;let Ii=class{constructor(U,ie,we=!0){this.range=U,this.variableName=ie,this.caseSensitiveLookup=we}};Ii=qe([T],Ii),e.InlineValueVariableLookup=Ii;let Yt=class{constructor(U,ie){this.range=U,this.expression=ie}};Yt=qe([T],Yt),e.InlineValueEvaluatableExpression=Yt;let Ci=class{constructor(U,ie){this.frameId=U,this.stoppedLocation=ie}};Ci=qe([T],Ci),e.InlineValueContext=Ci;var $i;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})($i=e.FileChangeType||(e.FileChangeType={}));let ki=x=class extends Error{static FileExists(U){return new x(U,w.FileSystemProviderErrorCode.FileExists,x.FileExists)}static FileNotFound(U){return new x(U,w.FileSystemProviderErrorCode.FileNotFound,x.FileNotFound)}static FileNotADirectory(U){return new x(U,w.FileSystemProviderErrorCode.FileNotADirectory,x.FileNotADirectory)}static FileIsADirectory(U){return new x(U,w.FileSystemProviderErrorCode.FileIsADirectory,x.FileIsADirectory)}static NoPermissions(U){return new x(U,w.FileSystemProviderErrorCode.NoPermissions,x.NoPermissions)}static Unavailable(U){return new x(U,w.FileSystemProviderErrorCode.Unavailable,x.Unavailable)}constructor(U,ie=w.FileSystemProviderErrorCode.Unknown,we){super(k.URI.isUri(U)?U.toString(!0):U),this.code=we?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,ie),Object.setPrototypeOf(this,x.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};ki=x=qe([T],ki),e.FileSystemError=ki;let Ti=class{constructor(U,ie,we){this.start=U,this.end=ie,this.kind=we}};Ti=qe([T],Ti),e.FoldingRange=Ti;var zi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Pi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Pi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Fi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Fi=e.CommentMode||(e.CommentMode={}));var Ni;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Ni=e.CommentThreadState||(e.CommentThreadState={}));class Ue{constructor(U,ie=[]){this.tokenTypes=U,this.tokenModifiers=ie}}e.SemanticTokensLegend=Ue;function Gt(z){return typeof z>"u"||(0,y.isStringArray)(z)}class li{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let ie=0,we=U.tokenTypes.length;ie<we;ie++)this.j.set(U.tokenTypes[ie],ie);for(let ie=0,we=U.tokenModifiers.length;ie<we;ie++)this.k.set(U.tokenModifiers[ie],ie)}}push(U,ie,we,Ke,Ye){if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(U,ie,we,Ke,Ye);if(Y.isRange(U)&&typeof ie=="string"&&Gt(we))return this.m(U,ie,we);throw(0,C.illegalArgument)()}m(U,ie,we){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,Ye=U.start.character,ot=U.end.character-U.start.character,ut=this.j.get(ie);let Rt=0;if(we)for(const Ht of we){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Ht);Rt|=1<<qt>>>0}this.n(Ke,Ye,ot,ut,Rt)}n(U,ie,we,Ke,Ye){if(this.f&&(U<this.c||U===this.c&&ie<this.e)){this.f=!1;const Rt=this.g.length/5|0;let Ht=0,qt=0;for(let Xt=0;Xt<Rt;Xt++){let Jt=this.g[5*Xt],Ai=this.g[5*Xt+1];Jt===0?(Jt=Ht,Ai+=qt):Jt+=Ht,this.g[5*Xt]=Jt,this.g[5*Xt+1]=Ai,Ht=Jt,qt=Ai}}let ot=U,ut=ie;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ut-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ut,this.g[this.h++]=we,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=U,this.e=ie}static o(U){const ie=[],we=U.length/5|0;for(let ut=0;ut<we;ut++)ie[ut]=ut;ie.sort((ut,Rt)=>{const Ht=U[5*ut],qt=U[5*Rt];if(Ht===qt){const Xt=U[5*ut+1],Jt=U[5*Rt+1];return Xt-Jt}return Ht-qt});const Ke=new Uint32Array(U.length);let Ye=0,ot=0;for(let ut=0;ut<we;ut++){const Rt=5*ie[ut],Ht=U[Rt+0],qt=U[Rt+1],Xt=U[Rt+2],Jt=U[Rt+3],Ai=U[Rt+4],nn=Ht-Ye,Rn=nn===0?qt-ot:qt,Ri=5*ut;Ke[Ri+0]=nn,Ke[Ri+1]=Rn,Ke[Ri+2]=Xt,Ke[Ri+3]=Jt,Ke[Ri+4]=Ai,Ye=Ht,ot=qt}return Ke}build(U){return this.f?new mt(new Uint32Array(this.g),U):new mt(li.o(this.g),U)}}e.SemanticTokensBuilder=li;class mt{constructor(U,ie){this.resultId=ie,this.data=U}}e.SemanticTokens=mt;class Wi{constructor(U,ie,we){this.start=U,this.deleteCount=ie,this.data=we}}e.SemanticTokensEdit=Wi;class Hi{constructor(U,ie){this.resultId=ie,this.edits=U}}e.SemanticTokensEdits=Hi;var Li;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Li=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new jt("arrow-left")},di=qe([T],di),e.QuickInputButtons=di;var hi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(hi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Vi;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(Vi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var ji;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(ji=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(U){if(typeof U.badge=="string"){let ie=(0,A.nextCharLength)(U.badge,0);if(ie<U.badge.length&&(ie+=(0,A.nextCharLength)(U.badge,ie)),U.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!jt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,ie,we){this.badge=U,this.tooltip=ie,this.color=we}}e.FileDecoration=qi;let fi=class{constructor(U){this.kind=U}};fi=qe([T],fi),e.ColorTheme=fi;var Ki;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ki=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{static isNotebookRange(U){return U instanceof xt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,ie){if(U<0)throw(0,C.illegalArgument)("start must be positive");if(ie<0)throw(0,C.illegalArgument)("end must be positive");U<=ie?(this.c=U,this.e=ie):(this.c=ie,this.e=U)}with(U){let ie=this.c,we=this.e;return U.start!==void 0&&(ie=U.start),U.end!==void 0&&(we=U.end),ie===this.c&&we===this.e?this:new xt(ie,we)}}e.NotebookRange=xt;class mi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ie=>mi.isNotebookCellData(ie))}static isNotebookCellData(U){return!0}constructor(U,ie,we,Ke,Ye,ot,ut){this.kind=U,this.value=ie,this.languageId=we,this.mime=Ke,this.outputs=Ye??[],this.metadata=ot,this.executionSummary=ut,mi.validate(this)}}e.NotebookCellData=mi;class Gi{constructor(U){this.cells=U}}e.NotebookData=Gi;class zt{static isNotebookCellOutputItem(U){return U instanceof zt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ie={name:U.name,message:U.message,stack:U.stack};return zt.json(ie,"application/vnd.code.notebook.error")}static stdout(U){return zt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return zt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ie="application/octet-stream"){return new zt(U,ie)}static text(U,ie=I.Mimes.text){const we=Oe(zt,v,"f",E).encode(String(U));return new zt(we,ie)}static json(U,ie="text/x-json"){const we=JSON.stringify(U,void 0,"	");return zt.text(we,ie)}constructor(U,ie){this.data=U,this.mime=ie;const we=(0,I.normalizeMimeType)(ie,!0);if(!we)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.NotebookCellOutputItem=zt,v=zt,E={value:new TextEncoder};class gi{static isNotebookCellOutput(U){return U instanceof gi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,ie=!1){const we=new Set,Ke=new Set;for(let Ye=0;Ye<U.length;Ye++){const ot=U[Ye],ut=(0,I.normalizeMimeType)(ot.mime);if(!we.has(ut)||(0,b.isTextStreamMime)(ut)){we.add(ut);continue}Ke.add(Ye),ie&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ke.size===0?U:U.filter((Ye,ot)=>!Ke.has(ot))}constructor(U,ie,we){this.items=gi.ensureUniqueMimeTypes(U,!0),typeof ie=="string"?(this.id=ie,this.metadata=we):(this.id=(0,O.generateUuid)(),this.metadata=ie??we)}}e.NotebookCellOutput=gi;var ne;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(ne=e.NotebookCellKind||(e.NotebookCellKind={}));var fe;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(fe=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ne;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Ne=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var rt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(rt=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class yt{constructor(U,ie){this.text=U,this.alignment=ie}}e.NotebookCellStatusBarItem=yt;var Pt;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(Pt=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var an;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(an=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class cn{constructor(U,ie=[]){this.uri=U,this.provides=(0,n.asArray)(ie)}}e.NotebookRendererScript=cn;class un{constructor(U){this.label=U}}e.NotebookKernelSourceAction=un;let xi=class{constructor(U,ie){this.label=U,this.timestamp=ie}};xi=qe([T],xi),e.TimelineItem=xi;var ln;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(ln=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(U,ie){this.ranges=U,this.wordPattern=ie}}e.LinkedEditingRanges=fn;class mn{constructor(U,ie){this.c=U,this.e=ie}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Mi=class{constructor(U=void 0,ie=void 0,we=void 0){this.include=U,this.exclude=ie,this.profile=we}};Mi=qe([T],Mi),e.TestRunRequest=Mi;let Xi=class extends Mi{constructor(U=void 0,ie=void 0,we=void 0,Ke=!1){super(U,ie,we),this.continuous=Ke}};Xi=qe([T],Xi),e.TestRunRequest2=Xi;let Qi=N=class{static diff(U,ie,we){const Ke=new N(U);return Ke.expectedOutput=ie,Ke.actualOutput=we,Ke}constructor(U){this.message=U}};Qi=N=qe([T],Qi),e.TestMessage=Qi;let _i=class{constructor(U){this.id=U}};_i=qe([T],_i),e.TestTag=_i;let pi=class{constructor(U,ie){this.covered=U,this.total=ie}};pi=qe([T],pi),e.CoveredCount=pi;let Yi=$=class{static fromDetails(U,ie){const we=new pi(0,0),Ke=new pi(0,0),Ye=new pi(0,0);for(const ut of ie)if("branches"in ut){we.total+=1,we.covered+=ut.executionCount>0?1:0;for(const Rt of ut.branches)Ke.total+=1,Ke.covered+=Rt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=ut.executionCount>0?1:0;const ot=new $(U,we,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ot.detailedCoverage=ie,ot}constructor(U,ie,we,Ke){this.uri=U,this.statementCoverage=ie,this.branchCoverage=we,this.functionCoverage=Ke}};Yi=$=qe([T],Yi),e.FileCoverage=Yi;let Ji=class{constructor(U,ie,we=[]){this.executionCount=U,this.location=ie,this.branches=we}};Ji=qe([T],Ji),e.StatementCoverage=Ji;let Zi=class{constructor(U,ie){this.executionCount=U,this.location=ie}};Zi=qe([T],Zi),e.BranchCoverage=Zi;let en=class{constructor(U,ie){this.executionCount=U,this.location=ie}};en=qe([T],en),e.FunctionCoverage=en;var vn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var En;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(En=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class wn{constructor(U,ie,we,Ke,Ye,ot){this.kind=U,this.name=ie,this.detail=we,this.uri=Ke,this.range=Ye,this.selectionRange=ot}}e.TypeHierarchyItem=wn;class Sn{constructor(U){this.uri=U}}e.TextTabInput=Sn;class yn{constructor(U,ie){this.original=U,this.modified=ie}}e.TextDiffTabInput=yn;class Dn{constructor(U,ie,we,Ke){this.base=U,this.input1=ie,this.input2=we,this.result=Ke}}e.TextMergeTabInput=Dn;class In{constructor(U,ie){this.uri=U,this.viewType=ie}}e.CustomEditorTabInput=In;class Cn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=Cn;class kn{constructor(U,ie){this.uri=U,this.notebookType=ie}}e.NotebookEditorTabInput=kn;class Tn{constructor(U,ie,we){this.original=U,this.modified=ie,this.notebookType=we}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(U,ie){this.uri=U,this.inputBoxUri=ie}}e.InteractiveWindowInput=An}),define(Ie[99],Ce([1,0,47,15,10,255,130,7,18]),function(te,e,n,C,S,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function O(f,s){s?k.set(f,s):k.delete(f)}e.setWordDefinitionFor=O;function w(f){return k.get(f)}class m extends M.MirrorTextModel{constructor(s,o,l,v,E,P,p,r){super(o,l,v,E),this.m=s,this.p=P,this.q=p,this.notebook=r,this.b=!1}dispose(){(0,n.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,y.equals)(this.d,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.c},get fileName(){return s.c.fsPath},get isUntitled(){return s.c.scheme===C.Schemas.untitled},get languageId(){return s.p},get version(){return s.g},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(o){return o?s.s(o):s.getText()},get eol(){return s.f===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return s.d.length},lineAt(o){return s.t(o)},offsetAt(o){return s.u(o)},positionAt(o){return s.v(o)},validateRange(o){return s.w(o)},validatePosition(o){return s.x(o)},getWordRangeAtPosition(o,l){return s.y(o,l)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,n.ok)(!this.b),this.p=s}_acceptIsDirty(s){(0,n.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(s){const o=this.w(s);if(o.isEmpty)return"";if(o.isSingleLine)return this.d[o.start.line].substring(o.start.character,o.end.character);const l=this.f,v=o.start.line,E=o.end.line,P=[];P.push(this.d[v].substring(o.start.character));for(let p=v+1;p<E;p++)P.push(this.d[p]);return P.push(this.d[E].substring(0,o.end.character)),P.join(l)}t(s){let o;if(s instanceof A.Position?o=s.line:typeof s=="number"&&(o=s),typeof o!="number"||o<0||o>=this.d.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new b(o,this.d[o],o===this.d.length-1)}u(s){return s=this.x(s),this.k(),this.h.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.k();const o=this.h.getIndexOf(s),l=this.d[o.index].length;return new A.Position(o.index,Math.min(o.remainder,l))}w(s){if(!(s instanceof A.Range))throw new Error("Invalid argument");const o=this.x(s.start),l=this.x(s.end);return o===s.start&&l===s.end?s:new A.Range(o.line,o.character,l.line,l.character)}x(s){if(!(s instanceof A.Position))throw new Error("Invalid argument");if(this.d.length===0)return s.with(0,0);let{line:o,character:l}=s,v=!1;if(o<0)o=0,l=0,v=!0;else if(o>=this.d.length)o=this.d.length-1,l=this.d[o].length,v=!0;else{const E=this.d[o].length;l<0?(l=0,v=!0):l>E&&(l=E,v=!0)}return v?new A.Position(o,l):s}y(s,o){const l=this.x(s);if(!o)o=w(this.p);else if((0,S.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const v=(0,I.getWordAtText)(l.character+1,(0,I.ensureValidWordDefinition)(o),this.d[l.line],0);if(v)return new A.Range(l.line,v.startColumn-1,l.line,v.endColumn-1)}}e.ExtHostDocumentData=m;class b{constructor(s,o,l){this.a=s,this.b=o,this.c=l}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=b}),define(Ie[191],Ce([1,0,7,17,4]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(A){this.a=new n.ColorTheme(n.ColorThemeKind.Dark),this.b=new S.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let y;switch(A){case"light":y=n.ColorThemeKind.Light;break;case"hcDark":y=n.ColorThemeKind.HighContrast;break;case"hcLight":y=n.ColorThemeKind.HighContrastLight;break;default:y=n.ColorThemeKind.Dark}this.a=new n.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};M=qe([Ve(0,C.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(Ie[8],Ce([1,0,18,24,115,192,86,28,112,85,64,22,9,2,56,75,91,96,95,70,43,55,187,7]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o,l,v,E,P,p,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(De){function Pe(X){const{selectionStartLineNumber:Re,selectionStartColumn:Me,positionLineNumber:Qe,positionColumn:ze}=X,Ze=new d.Position(Re-1,Me-1),bt=new d.Position(Qe-1,ze-1);return new d.Selection(Ze,bt)}De.to=Pe;function me(X){const{anchor:Re,active:Me}=X;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}De.from=me})(i=e.Selection||(e.Selection={}));var c;(function(De){function Pe(X){if(!X)return;const{start:Re,end:Me}=X;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}De.from=Pe;function me(X){if(!X)return;const{startLineNumber:Re,startColumn:Me,endLineNumber:Qe,endColumn:ze}=X;return new d.Range(Re-1,Me-1,Qe-1,ze-1)}De.to=me})(c=e.Range||(e.Range={}));var t;(function(De){function Pe(me){switch(me){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}De.to=Pe})(t=e.TokenType||(e.TokenType={}));var h;(function(De){function Pe(X){return new d.Position(X.lineNumber-1,X.column-1)}De.to=Pe;function me(X){return{lineNumber:X.line+1,column:X.character+1}}De.from=me})(h=e.Position||(e.Position={}));var a;(function(De){function Pe(Re,Me){return(0,n.coalesce)((0,n.asArray)(Re).map(Qe=>me(Qe,Me)))}De.from=Pe;function me(Re,Me){if(typeof Re=="string")return{$serialized:!0,language:Re};if(Re)return{$serialized:!0,language:Re.language,scheme:X(Re.scheme,Me),pattern:Q.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType}}function X(Re,Me){return Me&&typeof Re=="string"?Me.transformOutgoingScheme(Re):Re}})(a=e.DocumentSelector||(e.DocumentSelector={}));var u;(function(De){function Pe(X){switch(X){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}De.from=Pe;function me(X){switch(X){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}De.to=me})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(De){function Pe(X){let Re;return X.code&&((0,m.isString)(X.code)||(0,m.isNumber)(X.code)?Re=String(X.code):Re={value:String(X.code.value),target:X.code.target}),{...c.from(X.range),message:X.message,source:X.source,code:Re,severity:F.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(R.from),tags:Array.isArray(X.tags)?(0,n.coalesce)(X.tags.map(u.from)):void 0}}De.from=Pe;function me(X){const Re=new d.Diagnostic(c.to(X),X.message,F.to(X.severity));return Re.source=X.source,Re.code=(0,m.isString)(X.code)?X.code:X.code?.value,Re.relatedInformation=X.relatedInformation&&X.relatedInformation.map(R.to),Re.tags=X.tags&&(0,n.coalesce)(X.tags.map(u.to)),Re}De.to=me})(g=e.Diagnostic||(e.Diagnostic={}));var R;(function(De){function Pe(X){return{...c.from(X.location.range),message:X.message,resource:X.location.uri}}De.from=Pe;function me(X){return new d.DiagnosticRelatedInformation(new d.Location(X.resource,c.to(X)),X.message)}De.to=me})(R=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var F;(function(De){function Pe(X){switch(X){case d.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}De.from=Pe;function me(X){switch(X){case o.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}De.to=me})(F=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var q;(function(De){function Pe(X){return typeof X=="number"&&X>=d.ViewColumn.One?X-1:X===d.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}De.from=Pe;function me(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=me})(q=e.ViewColumn||(e.ViewColumn={}));function Z(De){return typeof De.range<"u"}function x(De){return De.length===0?!0:!!Z(De[0])}e.isDecorationOptionsArr=x;var N;(function(De){function Pe(ze){return ze.map(De.from)}De.fromMany=Pe;function me(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function X(ze){let Ze;if(me(ze)){const{language:pt,value:It}=ze;Ze={value:"```"+pt+`
`+It+"\n```\n"}}else d.MarkdownString.isMarkdownString(ze)?Ze={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?Ze={value:ze}:Ze={value:""};const bt=Object.create(null);Ze.uris=bt;const vt=pt=>{try{let It=b.URI.parse(pt,!0);It=It.with({query:Re(It.query,bt)}),bt[pt]=It}catch{}return""},At=new y.marked.Renderer;return At.link=vt,At.image=pt=>typeof pt=="string"?vt(I.parseHrefAndDimensions(pt).href):"",(0,y.marked)(Ze.value,{renderer:At}),Ze}De.from=X;function Re(ze,Ze){if(!ze)return ze;let bt;try{bt=(0,k.parse)(ze)}catch{}if(!bt)return ze;let vt=!1;return bt=(0,w.cloneAndChange)(bt,At=>{if(b.URI.isUri(At)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[pt]=At,vt=!0,pt}else return}),vt?JSON.stringify(bt):ze}function Me(ze){const Ze=new d.MarkdownString(ze.value,ze.supportThemeIcons);return Ze.isTrusted=ze.isTrusted,Ze.supportHtml=ze.supportHtml,Ze.baseUri=ze.baseUri?b.URI.from(ze.baseUri):void 0,Ze}De.to=Me;function Qe(ze){if(!!ze)return typeof ze=="string"?ze:De.from(ze)}De.fromStrict=Qe})(N=e.MarkdownString||(e.MarkdownString={}));function $(De){return x(De)?De.map(Pe=>({range:c.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?N.fromMany(Pe.hoverMessage):Pe.hoverMessage?N.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):De.map(Pe=>({range:c.from(Pe)}))}e.fromRangeOrRangeWithMessage=$;function T(De){return typeof De>"u"?De:typeof De=="string"?b.URI.file(De):De}e.pathOrURIToURI=T;var L;(function(De){function Pe(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?T(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}De.from=Pe})(L=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var V;(function(De){function Pe(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?T(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?L.from(me.before):void 0,after:me.after?L.from(me.after):void 0}}De.from=Pe})(V=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(De){function Pe(me){if(typeof me>"u")return me;switch(me){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}De.from=Pe})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var le;(function(De){function Pe(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?j.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?V.from(me.light):void 0,dark:me.dark?V.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?T(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?L.from(me.before):void 0,after:me.after?L.from(me.after):void 0}}De.from=Pe})(le=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Y;(function(De){function Pe(X){return{text:X.newText,eol:X.newEol&&it.from(X.newEol),range:c.from(X.range)}}De.from=Pe;function me(X){const Re=new d.TextEdit(c.to(X.range),X.text);return Re.newEol=typeof X.eol>"u"?void 0:it.to(X.eol),Re}De.to=me})(Y=e.TextEdit||(e.TextEdit={}));var pe;(function(De){function Pe(X,Re){const Me={edits:[]};if(X instanceof d.WorkspaceEdit){const Qe=new A.ResourceSet;for(const ze of X._allEntries())ze._type===1&&b.URI.isUri(ze.to)&&ze.from===void 0&&Qe.add(ze.to);for(const ze of X._allEntries())ze._type===1?Me.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contentsBase64:ze.options?.contents&&(0,C.encodeBase64)(C.VSBuffer.wrap(ze.options.contents))},metadata:ze.metadata}):ze._type===2?Me.edits.push({resource:ze.uri,textEdit:Y.from(ze.edit),versionId:Qe.has(ze.uri)?void 0:Re?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Me.edits.push({resource:ze.uri,textEdit:{range:c.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:Qe.has(ze.uri)?void 0:Re?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Me.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Me.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Re?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(wt.from)}})}return Me}De.from=Pe;function me(X){const Re=new d.WorkspaceEdit;for(const Me of X.edits)Me.textEdit?Re.replace(b.URI.revive(Me.resource),c.to(Me.textEdit.range),Me.textEdit.text):Re.renameFile(b.URI.revive(Me.oldResource),b.URI.revive(Me.newResource),Me.options);return Re}De.to=me})(pe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ue;(function(De){const Pe=Object.create(null);Pe[d.SymbolKind.File]=0,Pe[d.SymbolKind.Module]=1,Pe[d.SymbolKind.Namespace]=2,Pe[d.SymbolKind.Package]=3,Pe[d.SymbolKind.Class]=4,Pe[d.SymbolKind.Method]=5,Pe[d.SymbolKind.Property]=6,Pe[d.SymbolKind.Field]=7,Pe[d.SymbolKind.Constructor]=8,Pe[d.SymbolKind.Enum]=9,Pe[d.SymbolKind.Interface]=10,Pe[d.SymbolKind.Function]=11,Pe[d.SymbolKind.Variable]=12,Pe[d.SymbolKind.Constant]=13,Pe[d.SymbolKind.String]=14,Pe[d.SymbolKind.Number]=15,Pe[d.SymbolKind.Boolean]=16,Pe[d.SymbolKind.Array]=17,Pe[d.SymbolKind.Object]=18,Pe[d.SymbolKind.Key]=19,Pe[d.SymbolKind.Null]=20,Pe[d.SymbolKind.EnumMember]=21,Pe[d.SymbolKind.Struct]=22,Pe[d.SymbolKind.Event]=23,Pe[d.SymbolKind.Operator]=24,Pe[d.SymbolKind.TypeParameter]=25;function me(Re){return typeof Pe[Re]=="number"?Pe[Re]:6}De.from=me;function X(Re){for(const Me in Pe)if(Pe[Me]===Re)return Number(Me);return d.SymbolKind.Property}De.to=X})(ue=e.SymbolKind||(e.SymbolKind={}));var de;(function(De){function Pe(X){switch(X){case d.SymbolTag.Deprecated:return 1}}De.from=Pe;function me(X){switch(X){case 1:return d.SymbolTag.Deprecated}}De.to=me})(de=e.SymbolTag||(e.SymbolTag={}));var re;(function(De){function Pe(X){return{name:X.name,kind:ue.from(X.kind),tags:X.tags&&X.tags.map(de.from),containerName:X.containerName,location:Ae.from(X.location)}}De.from=Pe;function me(X){const Re=new d.SymbolInformation(X.name,ue.to(X.kind),X.containerName,Ae.to(X.location));return Re.tags=X.tags&&X.tags.map(de.to),Re}De.to=me})(re=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var G;(function(De){function Pe(X){const Re={name:X.name||"!!MISSING: name!!",detail:X.detail,range:c.from(X.range),selectionRange:c.from(X.selectionRange),kind:ue.from(X.kind),tags:X.tags?.map(de.from)??[]};return X.children&&(Re.children=X.children.map(Pe)),Re}De.from=Pe;function me(X){const Re=new d.DocumentSymbol(X.name,X.detail,ue.to(X.kind),c.to(X.range),c.to(X.selectionRange));return(0,n.isNonEmptyArray)(X.tags)&&(Re.tags=X.tags.map(de.to)),X.children&&(Re.children=X.children.map(me)),Re}De.to=me})(G=e.DocumentSymbol||(e.DocumentSymbol={}));var H;(function(De){function Pe(X){const Re=new d.CallHierarchyItem(ue.to(X.kind),X.name,X.detail||"",b.URI.revive(X.uri),c.to(X.range),c.to(X.selectionRange));return Re._sessionId=X._sessionId,Re._itemId=X._itemId,Re}De.to=Pe;function me(X,Re,Me){if(Re=Re??X._sessionId,Me=Me??X._itemId,Re===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Me,name:X.name,detail:X.detail,kind:ue.from(X.kind),uri:X.uri,range:c.from(X.range),selectionRange:c.from(X.selectionRange),tags:X.tags?.map(de.from)}}De.from=me})(H=e.CallHierarchyItem||(e.CallHierarchyItem={}));var oe;(function(De){function Pe(me){return new d.CallHierarchyIncomingCall(H.to(me.from),me.fromRanges.map(X=>c.to(X)))}De.to=Pe})(oe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ve;(function(De){function Pe(me){return new d.CallHierarchyOutgoingCall(H.to(me.to),me.fromRanges.map(X=>c.to(X)))}De.to=Pe})(ve=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ae;(function(De){function Pe(X){return{range:X.range&&c.from(X.range),uri:X.uri}}De.from=Pe;function me(X){return new d.Location(b.URI.revive(X.uri),c.to(X.range))}De.to=me})(Ae=e.location||(e.location={}));var Be;(function(De){function Pe(X){const Re=X,Me=X;return{originSelectionRange:Re.originSelectionRange?c.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Me.uri,range:c.from(Re.targetRange?Re.targetRange:Me.range),targetSelectionRange:Re.targetSelectionRange?c.from(Re.targetSelectionRange):void 0}}De.from=Pe;function me(X){return{targetUri:b.URI.revive(X.uri),targetRange:c.to(X.range),targetSelectionRange:X.targetSelectionRange?c.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?c.to(X.originSelectionRange):void 0}}De.to=me})(Be=e.DefinitionLink||(e.DefinitionLink={}));var xe;(function(De){function Pe(X){return{range:c.from(X.range),contents:N.fromMany(X.contents)}}De.from=Pe;function me(X){return new d.Hover(X.contents.map(N.to),c.to(X.range))}De.to=me})(xe=e.Hover||(e.Hover={}));var Te;(function(De){function Pe(X){return{range:c.from(X.range),expression:X.expression}}De.from=Pe;function me(X){return new d.EvaluatableExpression(c.to(X.range),X.expression)}De.to=me})(Te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(De){function Pe(X){if(X instanceof d.InlineValueText)return{type:"text",range:c.from(X.range),text:X.text};if(X instanceof d.InlineValueVariableLookup)return{type:"variable",range:c.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Pe;function me(X){switch(X.type){case"text":return{range:c.to(X.range),text:X.text};case"variable":return{range:c.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:c.to(X.range),expression:X.expression}}}De.to=me})(Se=e.InlineValue||(e.InlineValue={}));var ke;(function(De){function Pe(X){return{frameId:X.frameId,stoppedLocation:c.from(X.stoppedLocation)}}De.from=Pe;function me(X){return new d.InlineValueContext(X.frameId,c.to(X.stoppedLocation))}De.to=me})(ke=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(De){function Pe(X){return{range:c.from(X.range),kind:X.kind}}De.from=Pe;function me(X){return new d.DocumentHighlight(c.to(X.range),X.kind)}De.to=me})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(De){function Pe(me){switch(me){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}De.to=Pe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(De){function Pe(me){return{triggerKind:ce.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}De.to=Pe})(J=e.CompletionContext||(e.CompletionContext={}));var D;(function(De){function Pe(X){switch(X){case d.CompletionItemTag.Deprecated:return 1}}De.from=Pe;function me(X){switch(X){case 1:return d.CompletionItemTag.Deprecated}}De.to=me})(D=e.CompletionItemTag||(e.CompletionItemTag={}));var B;(function(De){const Pe=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function me(Me){return Pe.get(Me)??9}De.from=me;const X=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Re(Me){return X.get(Me)??d.CompletionItemKind.Property}De.to=Re})(B=e.CompletionItemKind||(e.CompletionItemKind={}));var W;(function(De){function Pe(me,X){const Re=new d.CompletionItem(me.label);return Re.insertText=me.insertText,Re.kind=B.to(me.kind),Re.tags=me.tags?.map(D.to),Re.detail=me.detail,Re.documentation=I.isMarkdownString(me.documentation)?N.to(me.documentation):me.documentation,Re.sortText=me.sortText,Re.filterText=me.filterText,Re.preselect=me.preselect,Re.commitCharacters=me.commitCharacters,f.Range.isIRange(me.range)?Re.range=c.to(me.range):typeof me.range=="object"&&(Re.range={inserting:c.to(me.range.insert),replacing:c.to(me.range.replace)}),Re.keepWhitespace=typeof me.insertTextRules>"u"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Re.insertText=new d.SnippetString(me.insertText):(Re.insertText=me.insertText,Re.textEdit=Re.range instanceof d.Range?new d.TextEdit(Re.range,Re.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Re.additionalTextEdits=me.additionalTextEdits.map(Me=>Y.to(Me))),Re.command=X&&me.command?X.fromInternal(me.command):void 0,Re}De.to=Pe})(W=e.CompletionItem||(e.CompletionItem={}));var K;(function(De){function Pe(X){if(typeof X.label!="string"&&!Array.isArray(X.label))throw new TypeError("Invalid label");return{label:X.label,documentation:N.fromStrict(X.documentation)}}De.from=Pe;function me(X){return{label:X.label,documentation:I.isMarkdownString(X.documentation)?N.to(X.documentation):X.documentation}}De.to=me})(K=e.ParameterInformation||(e.ParameterInformation={}));var ee;(function(De){function Pe(X){return{label:X.label,documentation:N.fromStrict(X.documentation),parameters:Array.isArray(X.parameters)?X.parameters.map(K.from):[],activeParameter:X.activeParameter}}De.from=Pe;function me(X){return{label:X.label,documentation:I.isMarkdownString(X.documentation)?N.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(K.to):[],activeParameter:X.activeParameter}}De.to=me})(ee=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(De){function Pe(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(ee.from):[]}}De.from=Pe;function me(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(ee.to):[]}}De.to=me})(he=e.SignatureHelp||(e.SignatureHelp={}));var ye;(function(De){function Pe(me,X){const Re=new d.InlayHint(h.to(X.position),typeof X.label=="string"?X.label:X.label.map(ae.to.bind(void 0,me)),X.kind&&be.to(X.kind));return Re.textEdits=X.textEdits&&X.textEdits.map(Y.to),Re.tooltip=I.isMarkdownString(X.tooltip)?N.to(X.tooltip):X.tooltip,Re.paddingLeft=X.paddingLeft,Re.paddingRight=X.paddingRight,Re}De.to=Pe})(ye=e.InlayHint||(e.InlayHint={}));var ae;(function(De){function Pe(me,X){const Re=new d.InlayHintLabelPart(X.label);return Re.tooltip=I.isMarkdownString(X.tooltip)?N.to(X.tooltip):X.tooltip,s.Command.is(X.command)&&(Re.command=me.fromInternal(X.command)),X.location&&(Re.location=Ae.to(X.location)),Re}De.to=Pe})(ae=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var be;(function(De){function Pe(X){return X}De.from=Pe;function me(X){return X}De.to=me})(be=e.InlayHintKind||(e.InlayHintKind={}));var Ee;(function(De){function Pe(X){return{range:c.from(X.range),url:X.target,tooltip:X.tooltip}}De.from=Pe;function me(X){let Re;if(X.url)try{Re=typeof X.url=="string"?b.URI.parse(X.url,!0):b.URI.revive(X.url)}catch{}return new d.DocumentLink(c.to(X.range),Re)}De.to=me})(Ee=e.DocumentLink||(e.DocumentLink={}));var We;(function(De){function Pe(X){const Re=new d.ColorPresentation(X.label);return X.textEdit&&(Re.textEdit=Y.to(X.textEdit)),X.additionalTextEdits&&(Re.additionalTextEdits=X.additionalTextEdits.map(Me=>Y.to(Me))),Re}De.to=Pe;function me(X){return{label:X.label,textEdit:X.textEdit?Y.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(Re=>Y.from(Re)):void 0}}De.from=me})(We=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(De){function Pe(X){return new d.Color(X[0],X[1],X[2],X[3])}De.to=Pe;function me(X){return[X.red,X.green,X.blue,X.alpha]}De.from=me})(He=e.Color||(e.Color={}));var tt;(function(De){function Pe(X){return{range:c.from(X.range)}}De.from=Pe;function me(X){return new d.SelectionRange(c.to(X.range))}De.to=me})(tt=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(De){function Pe(me){switch(me){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}De.to=Pe})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(De){function Pe(X){switch(X){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}De.from=Pe;function me(X){switch(X){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}De.to=me})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(De){function Pe(X){if(X===d.EndOfLine.CRLF)return 1;if(X===d.EndOfLine.LF)return 0}De.from=Pe;function me(X){if(X===1)return d.EndOfLine.CRLF;if(X===0)return d.EndOfLine.LF}De.to=me})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(De){function Pe(me){if(typeof me=="object")return me.viewId;switch(me){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}De.from=Pe})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(De){function Pe(me){const X={start:me.start+1,end:me.end+1};return me.kind&&(X.kind=st.from(me.kind)),X}De.from=Pe})(Fe=e.FoldingRange||(e.FoldingRange={}));var st;(function(De){function Pe(me){if(me)switch(me){case d.FoldingRangeKind.Comment:return s.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return s.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return s.FoldingRangeKind.Region}}De.from=Pe})(st=e.FoldingRangeKind||(e.FoldingRangeKind={}));var _;(function(De){function Pe(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?c.from(me.selection):void 0,override:typeof me.override=="boolean"?v.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}De.from=Pe})(_=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Q;(function(De){function Pe(Me){return Me instanceof d.RelativePattern?Me.toJSON():typeof Me=="string"?Me:me(Me)||X(Me)?new d.RelativePattern(Me.baseUri??Me.base,Me.pattern).toJSON():Me}De.from=Pe;function me(Me){const Qe=Me;return Qe?b.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function X(Me){const Qe=Me;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Re(Me){return typeof Me=="string"?Me:new d.RelativePattern(b.URI.revive(Me.baseUri),Me.pattern)}De.to=Re})(Q=e.GlobPattern||(e.GlobPattern={}));var ge;(function(De){function Pe(me){if(me){if(Array.isArray(me))return me.map(Pe);if(typeof me=="string")return me;{const X=me;return{language:X.language,scheme:X.scheme,pattern:Q.from(X.pattern),exclusive:X.exclusive,notebookType:X.notebookType}}}else return}De.from=Pe})(ge=e.LanguageSelector||(e.LanguageSelector={}));var Le;(function(De){function Pe(X){return{start:X.start,end:X.end}}De.from=Pe;function me(X){return new d.NotebookRange(X.start,X.end)}De.to=me})(Le=e.NotebookRange||(e.NotebookRange={}));var $e;(function(De){function Pe(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}De.to=Pe;function me(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}De.from=me})($e=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(De){function Pe(me){if(me===E.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;if(me===E.NotebookCellExecutionState.Pending)return;if(me===E.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}De.to=Pe})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var _e;(function(De){function Pe(X){switch(X){case d.NotebookCellKind.Markup:return E.CellKind.Markup;case d.NotebookCellKind.Code:default:return E.CellKind.Code}}De.from=Pe;function me(X){switch(X){case E.CellKind.Markup:return d.NotebookCellKind.Markup;case E.CellKind.Code:default:return d.NotebookCellKind.Code}}De.to=me})(_e=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(De){function Pe(X){const Re={metadata:X.metadata??Object.create(null),cells:[]};for(const Me of X.cells)d.NotebookCellData.validate(Me),Re.cells.push(wt.from(Me));return Re}De.from=Pe;function me(X){const Re=new d.NotebookData(X.cells.map(wt.to));return(0,m.isEmptyObject)(X.metadata)||(Re.metadata=X.metadata),Re}De.to=me})(nt=e.NotebookData||(e.NotebookData={}));var wt;(function(De){function Pe(X){return{cellKind:_e.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:$e.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(Ct.from):[]}}De.from=Pe;function me(X){return new d.NotebookCellData(_e.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(Ct.to):void 0,X.metadata,X.internalMetadata?$e.to(X.internalMetadata):void 0)}De.to=me})(wt=e.NotebookCellData||(e.NotebookCellData={}));var St;(function(De){function Pe(X){return{mime:X.mime,valueBytes:C.VSBuffer.wrap(X.data)}}De.from=Pe;function me(X){return new d.NotebookCellOutputItem(X.valueBytes.buffer,X.mime)}De.to=me})(St=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(De){function Pe(X){return{outputId:X.id,items:X.items.map(St.from),metadata:X.metadata}}De.from=Pe;function me(X){const Re=X.items.map(St.to);return new d.NotebookCellOutput(Re,X.outputId,X.metadata)}De.to=me})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var lt;(function(De){function Pe(Re){return X(Re)?{include:(0,m.withNullAsUndefined)(Q.from(Re.include)),exclude:(0,m.withNullAsUndefined)(Q.from(Re.exclude))}:(0,m.withNullAsUndefined)(Q.from(Re))}De.from=Pe;function me(Re){return X(Re)?{include:Q.to(Re.include),exclude:Q.to(Re.exclude)}:Q.to(Re)}De.to=me;function X(Re){const Me=Re;return Me?!(0,m.isUndefinedOrNull)(Me.include)&&!(0,m.isUndefinedOrNull)(Me.exclude):!1}})(lt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var at;(function(De){function Pe(me,X,Re){const Me=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Me,Re),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}De.from=Pe})(at=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Bt;(function(De){function Pe(me,X,Re){const Me=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:X.toInternal(Me,Re),label:me.label,description:me.description,detail:me.detail}}De.from=Pe})(Bt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ot;(function(De){function Pe(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}De.from=Pe})(Ot=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ft;(function(De){function Pe(X){return{uri:X.uri,provides:X.provides}}De.from=Pe;function me(X){return new d.NotebookRendererScript(b.URI.revive(X.uri),X.provides)}De.to=me})(Ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(De){function Pe(X){return{message:N.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location&&{range:c.from(X.location.range),uri:X.location.uri}}}De.from=Pe;function me(X){const Re=new d.TestMessage(typeof X.message=="string"?X.message:N.to(X.message));return Re.actualOutput=X.actual,Re.expectedOutput=X.expected,Re.location=X.location?Ae.to(X.location):void 0,Re}De.to=me})(ft=e.TestMessage||(e.TestMessage={}));var Dt;(function(De){De.namespace=p.namespaceTestTag,De.denamespace=p.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var $t;(function(De){function Pe(X){const Re=(0,l.getPrivateApiFor)(X).controllerId;return{extId:P.TestId.fromExtHostTestItem(X,Re).toString(),label:X.label,uri:b.URI.revive(X.uri),busy:X.busy,tags:X.tags.map(Me=>Dt.namespace(Re,Me.id)),range:f.Range.lift(c.from(X.range)),description:X.description||null,sortText:X.sortText||null,error:X.error&&N.fromStrict(X.error)||null}}De.from=Pe;function me(X){return{parent:void 0,error:void 0,id:P.TestId.fromString(X.extId).localId,label:X.label,uri:b.URI.revive(X.uri),tags:(X.tags||[]).map(Re=>{const{tagId:Me}=Dt.denamespace(Re);return new d.TestTag(Me)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(X.range||void 0),canResolveChildren:!1,busy:X.busy,description:X.description||void 0,sortText:X.sortText||void 0}}De.toPlain=me})($t=e.TestItem||(e.TestItem={})),function(De){function Pe(X){return{id:X.id}}De.from=Pe;function me(X){return new d.TestTag(X.id)}De.to=me}(Dt=e.TestTag||(e.TestTag={}));var Nt;(function(De){const Pe=(X,Re)=>{const Me=[];for(const[ze,Ze]of Re)P.TestId.compare(Ze.item.extId,ze)===2&&(Re.delete(ze),Me.push(Ze));const Qe={...$t.toPlain(X.item),parent:void 0,taskStates:X.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Ze=>Ze.type===0).map(ft.to)})),children:Me.map(ze=>Pe(ze,Re))};for(const ze of Qe.children)ze.parent=Qe;return Qe};function me(X){const Re=[],Me=new Map;for(const Qe of X.items){Me.set(Qe.item.extId,Qe);const ze=P.TestId.root(Qe.item.extId);X.request.targets.some(Ze=>Ze.controllerId===ze&&Ze.testIds.includes(Qe.item.extId))&&Re.push(Qe)}return{completedAt:X.completedAt,results:Re.map(Qe=>Pe(Qe,Me))}}De.to=me})(Nt=e.TestResults||(e.TestResults={}));var Ge;(function(De){function Pe(Me){return{covered:Me.covered,total:Me.covered}}function me(Me){return"line"in Me?h.from(Me):c.from(Me)}function X(Me){return"branches"in Me?{count:Me.executionCount,location:me(Me.location),type:1,branches:Me.branches.length?Me.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&me(Qe.location)})):void 0}:{type:0,count:Me.executionCount,location:me(Me.location)}}De.fromDetailed=X;function Re(Me){return{uri:Me.uri,statement:Pe(Me.statementCoverage),branch:Me.branchCoverage&&Pe(Me.branchCoverage),function:Me.functionCoverage&&Pe(Me.functionCoverage),details:Me.detailedCoverage?.map(X)}}De.fromFile=Re})(Ge=e.TestCoverage||(e.TestCoverage={}));var Lt;(function(De){function Pe(me){switch(me){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}De.to=Pe})(Lt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Mt;(function(De){function Pe(X){const Re=new d.TypeHierarchyItem(ue.to(X.kind),X.name,X.detail||"",b.URI.revive(X.uri),c.to(X.range),c.to(X.selectionRange));return Re._sessionId=X._sessionId,Re._itemId=X._itemId,Re}De.to=Pe;function me(X,Re,Me){if(Re=Re??X._sessionId,Me=Me??X._itemId,Re===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Me,kind:ue.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:c.from(X.range),selectionRange:c.from(X.selectionRange),tags:X.tags?.map(de.from)}}De.from=me})(Mt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ut;(function(De){function Pe(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}De.from=Pe})(Ut=e.ViewBadge||(e.ViewBadge={}));var gt;(function(De){function Pe(Me,Qe,ze){const Ze=Qe.fileData;return Ze?new class extends d.DataTransferItem{asFile(){return{name:Ze.name,uri:b.URI.revive(Ze.uri),data:(0,M.once)(()=>ze())}}}("",Qe.id):Me===O.Mimes.uriList&&Qe.uriListData?new d.DataTransferItem(Re(Qe.uriListData)):new d.DataTransferItem(Qe.asString)}De.to=Pe;async function me(Me,Qe){const ze=await Qe.asString();if(Me===O.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:X(ze)};const Ze=Qe.asFile();return{id:Qe.id,asString:ze,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}De.from=me;function X(Me){return S.UriList.split(Me).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return b.URI.parse(Qe)}catch{}return Qe})}function Re(Me){return S.UriList.create(Me.map(Qe=>typeof Qe=="string"?Qe:b.URI.revive(Qe)))}})(gt=e.DataTransferItem||(e.DataTransferItem={}));var kt;(function(De){function Pe(X,Re){const Me=X.items.map(([Qe,ze])=>[Qe,gt.to(Qe,ze,()=>Re(ze.id))]);return new d.DataTransfer(Me)}De.toDataTransfer=Pe;async function me(X){const Re={items:[]},Me=[];return X.forEach((Qe,ze)=>{Me.push((async()=>{Re.items.push([ze,await gt.from(ze,Qe)])})())}),await Promise.all(Me),Re}De.toDataTransferDTO=me})(kt=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[193],Ce([1,0,2,11,7,8,159]),function(te,e,n,C,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(k,O,w,m={timeout:1500,errors:3}){this.c=k,this.d=O,this.f=w,this.g=m,this.a=new I.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(O,w,m)=>{const f={dispose:this.a.push([O,w,k])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(k,O){const w=n.URI.revive(k);let m=!1;const b=setTimeout(()=>m=!0,this.g.timeout),f=[];try{for(const s of[...this.a]){if(m)break;const o=this.d.getDocument(w),l=await this.h(s,{document:o,reason:M.TextDocumentSaveReason.to(O)});f.push(l)}}finally{clearTimeout(b)}return f}h([k,O,w],m){const b=this.b.get(k);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(w,k,O,m).then(()=>!0,f=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this.c.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const s=this.b.get(k);this.b.set(k,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,O,w,m){const b=[],f=Date.now(),{document:s,reason:o}=m,{version:l}=s,v=Object.freeze({document:s,reason:o,waitUntil(E){if(Object.isFrozen(b))throw(0,C.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(E))}});try{O.apply(w,[v])}catch(E){return Promise.reject(E)}return Object.freeze(b),new Promise((E,P)=>{const p=setTimeout(()=>P(new Error("timeout")),this.g.timeout);return Promise.all(b).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(p),E(r)}).catch(r=>{clearTimeout(p),P(r)})}).then(E=>{const P={edits:[]};for(const p of E)if(Array.isArray(p)&&p.every(r=>r instanceof S.TextEdit))for(const{newText:r,newEol:d,range:i}of p)P.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:i&&M.Range.from(i),text:r,eol:d&&M.EndOfLine.from(d)}});if(P.edits.length!==0)return l===s.version?this.f.$tryApplyWorkspaceEdit(P):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ie[194],Ce([1,0,15,2,8,7,70]),function(te,e,n,C,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(w,m,b,f){this.start=w,this.deletedCount=m,this.deletedItems=b,this.items=f}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(w,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:w}}constructor(w,m,b){this.notebook=w,this.h=m,this.j=b,this.handle=b.handle,this.uri=C.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(S.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(S.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const w=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:S.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return w.g},set mime(f){w.g=f},get outputs(){return w.a.slice(0)},get metadata(){return w.b},get executionSummary(){return w.d}};this.f=Object.freeze(b)}return this.f}setOutputs(w){this.a=w.map(S.NotebookCellOutput.to)}setOutputItems(w,m,b){const f=b.map(S.NotebookCellOutputItem.to),s=this.a.find(o=>o.id===w);if(s&&(m||(s.items.length=0),s.items.push(...f),s.items.length>1&&s.items.every(o=>I.isTextStreamMime(o.mime)))){const o=new Map,l=[];s.items.forEach(v=>{let E;o.has(v.mime)?E=o.get(v.mime):(E=[],o.set(v.mime,E),l.push(v.mime)),E.push(v.data)}),s.items.length=0,l.forEach(v=>{const E=I.compressOutputItemStreams(o.get(v));s.items.push({mime:v,data:E.buffer})})}}setMetadata(w){this.b=Object.freeze(w)}setInternalMetadata(w){this.e=w,this.d=Object.freeze(S.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=y;class k{constructor(w,m,b,f,s){this.k=w,this.l=m,this.m=b,this.uri=f,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const w=this,m={get uri(){return w.uri},get version(){return w.g},get notebookType(){return w.d},get isDirty(){return w.h},get isUntitled(){return w.uri.scheme===n.Schemas.untitled},get isClosed(){return w.j},get metadata(){return w.f},get cellCount(){return w.b.length},cellAt(b){return b=w.n(b),w.b[b].apiCell},getCells(b){return(b?w.p(b):w.b).map(s=>s.apiCell)},save(){return w.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(w){w.metadata&&(this.f=Object.freeze({...this.f,...w.metadata}))}acceptDirty(w){this.h=w}acceptModelChanged(w,m,b){this.g=w.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:b});const f={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},s=[];for(const l of w.rawEvents)l.kind===I.NotebookCellsChangeType.ModelChange?this.r(l.changes,!1,f.contentChanges):l.kind===I.NotebookCellsChangeType.Move?this.s(l.index,l.length,l.newIdx,f.contentChanges):l.kind===I.NotebookCellsChangeType.Output?(this.t(l.index,l.outputs),s.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===I.NotebookCellsChangeType.OutputItem?(this.u(l.index,l.outputId,l.append,l.outputItems),s.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===I.NotebookCellsChangeType.ChangeCellLanguage?(this.v(l.index,l.language),s.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document})):l.kind===I.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document}):l.kind===I.NotebookCellsChangeType.ChangeCellMime?this.w(l.index,l.mime):l.kind===I.NotebookCellsChangeType.ChangeCellMetadata?(this.x(l.index,l.metadata),s.push({cell:this.b[l.index].apiCell,metadata:this.b[l.index].apiCell.metadata})):l.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(l.index,l.internalMetadata),s.push({cell:this.b[l.index].apiCell,executionSummary:this.b[l.index].apiCell.executionSummary}));const o=new Map;for(let l=0;l<s.length;l++){const v=s[l],E=o.get(v.cell);if(E===void 0){const P=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});o.set(v.cell,P-1)}else f.cellChanges[E]={...f.cellChanges[E],...v}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(w){return w=w|0,w<0?0:w>=this.b.length?this.b.length-1:w}o(w){let m=w.start|0,b=w.end|0;return m<0&&(m=0),b>this.b.length&&(b=this.b.length),w.with({start:m,end:b})}p(w){w=this.o(w);const m=[];for(let b=w.start;b<w.end;b++)m.push(this.b[b]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(w,m,b){if(this.j)return;const f=[],s=[],o=[];if(w.reverse().forEach(l=>{const E=l[2].map(r=>{const d=new y(this,this.l,r);return m||s.push(y.asModelAddData(this.apiNotebook,r)),d}),P=new A(l[0],l[1],[],E),p=this.b.splice(l[0],l[1],...E);for(const r of p)o.push(r.uri),P.deletedItems.push(r.apiCell);f.push(P)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:o}),b)for(const l of f)b.push(l.asApiEvent())}s(w,m,b,f){const s=this.b.splice(w,m);this.b.splice(b,0,...s);const o=[new A(w,m,s.map(l=>l.apiCell),[]),new A(b,0,[],s)];for(const l of o)f.push(l.asApiEvent())}t(w,m){this.b[w].setOutputs(m)}u(w,m,b,f){this.b[w].setOutputItems(m,b,f)}v(w,m){const b=this.b[w];b.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(b.uri,m)}w(w,m){const b=this.b[w];b.apiCell.mime=m}x(w,m){this.b[w].setMetadata(m)}y(w,m){this.b[w].setInternalMetadata(m)}getCellFromApiCell(w){return this.b.find(m=>m.apiCell===w)}getCellFromIndex(w){return this.b[w]}getCell(w){return this.b.find(m=>m.handle===w)}getCellIndex(w){return this.b.indexOf(w)}}e.ExtHostNotebookDocument=k,k.a=0}),define(Ie[100],Ce([1,0,11,8,7]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(A,y,k,O,w,m){this.id=A,this.f=y,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=w,this.b=O,this.c=m}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(y){this.selections=[y]},get selections(){return A.a},set selections(y){if(!Array.isArray(y)||!y.every(S.NotebookRange.isNotebookRange))throw(0,n.illegalArgument)("selections");A.a=y,A.g(y)},get visibleRanges(){return A.b},revealRange(y,k){A.f.$tryRevealRange(A.id,C.NotebookRange.from(y),k??S.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(C.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}e.ExtHostNotebookEditor=M,M.apiEditorsToExtHost=new WeakMap}),define(Ie[195],Ce([1,0,4,12,8]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(A,y){this.c=A,this.d=y,this.a=new n.Emitter,this.b=new n.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(A,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,y);const k=this.d.getEditorById(A);y.visibleRanges&&k._acceptVisibleRanges(y.visibleRanges.ranges.map(S.NotebookRange.to)),y.selections&&k._acceptSelections(y.selections.selections.map(S.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const y in A)this.d.getEditorById(y)._acceptViewColumn(S.ViewColumn.to(A[y]))}};M=qe([Ve(0,C.ILogService)],M),e.ExtHostNotebookEditors=M}),define(Ie[196],Ce([1,0,8,162,140,21,63,11]),function(te,e,n,C,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,b,f){const s=this.b++,{title:o,location:l,cancellable:v}=b,E={label:(0,S.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(s,{location:n.ProgressLocation.from(l),title:o,source:E,cancellable:v},m.isUnderDevelopment?void 0:m.identifier.value).catch(A.onUnexpectedExternalError),this.d(s,f,!!v)}d(m,b,f){let s;f&&(s=new M.CancellationTokenSource,this.c.set(m,s));const o=v=>{this.a.$progressEnd(v),this.c.delete(v),s?.dispose()};let l;try{l=b(new O(this.a,m),f&&s?s.token:M.CancellationToken.None)}catch(v){throw o(m),v}return l.then(v=>o(m),v=>o(m)),l}$acceptProgressCanceled(m){const b=this.c.get(m);b&&(b.cancel(),this.c.delete(m))}}e.ExtHostProgress=y;function k(w,m){return w.message=m.message,typeof m.increment=="number"&&(typeof w.increment=="number"?w.increment+=m.increment:w.increment=m.increment),w}class O extends C.Progress{constructor(m,b){super(f=>this.throttledReport(f)),this.c=m,this.d=b}throttledReport(m){this.c.$progressReport(this.d,m)}}qe([(0,I.throttle)(100,(w,m)=>k(w,m),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Ie[101],Ce([1,0,56,96,43,71,55,8,2]),function(te,e,n,C,S,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(E,P,p,r)=>{let d=P;return{enumerable:!0,configurable:!1,get(){return d},set(i){if(!p(d,i)){const c=d;d=i,E.listener?.(r(i,c))}}}},O=(E,P)=>E===P,w={range:(E,P)=>E===P?!0:!E||!P?!1:E.isEqual(P),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(E,P)=>!(E.length!==P.length||E.some(p=>!P.find(r=>p.id===r.id)))},m=E=>P=>({op:4,update:E(P)}),b=(E,P)=>({range:(()=>{let p;const r=m(d=>({range:n.Range.lift(A.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return p},set(d){E.listener?.({op:6}),w.range(p,d)||(p=d,E.listener?.(r(d)))}}})(),label:k(E,P,w.label,m(p=>({label:p}))),description:k(E,void 0,w.description,m(p=>({description:p}))),sortText:k(E,void 0,w.sortText,m(p=>({sortText:p}))),canResolveChildren:k(E,!1,w.canResolveChildren,p=>({op:2,state:p})),busy:k(E,!1,w.busy,m(p=>({busy:p}))),error:k(E,void 0,w.error,m(p=>({error:A.MarkdownString.fromStrict(p)||null}))),tags:k(E,[],w.tags,(p,r)=>({op:1,new:p.map(A.TestTag.from),old:r.map(A.TestTag.from)}))}),f=E=>{const P=S.TestId.fromString(E.extId),p=new o(P.controllerId,P.localId,E.label,y.URI.revive(E.uri)||void 0);return p.range=A.Range.to(E.range||void 0),p.description=E.description||void 0,p.sortText=E.sortText||void 0,p.tags=E.tags.map(r=>A.TestTag.to({id:(0,I.denamespaceTestTag)(r).tagId})),p},s=E=>{let P;for(const p of E.tests){const r=f(p.item);(0,C.getPrivateApiFor)(r).parent=P,P=r}return P};e.toItemFromContext=s;class o{constructor(P,p,r,d){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const i=(0,C.createPrivateApiFor)(this,P);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof l?void 0:i.parent}},children:{value:(0,M.createTestItemChildren)(i,C.getPrivateApiFor,o),enumerable:!0,writable:!1},...b(i,r)})}}e.TestItemImpl=o;class l extends o{constructor(P,p){super(P,P,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=l;class v extends M.TestItemCollection{constructor(P,p,r){super({controllerId:P,getDocumentVersion:d=>d&&r.getDocument(d)?.version,getApiFor:C.getPrivateApiFor,getChildren:d=>d.children,root:new l(P,p),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(Ie[102],Ce([1,0,47,11,83,8,7]),function(te,e,n,C,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(m,b,f){const s=A.c.nextId();m.$registerTextEditorDecorationType(b.identifier,s,M.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:s,dispose(){m.$removeTextEditorDecorationType(s)}})}}e.TextEditorDecorationType=A,A.c=new S.IdGenerator("TextEditorDecorationType");class y{constructor(m,b){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,b){this.k();let f=null;if(m instanceof I.Position)f=new I.Range(m,m);else if(m instanceof I.Range)f=m;else throw new Error("Unrecognized location");this.l(f,b,!1)}insert(m,b){this.k(),this.l(new I.Range(m,m),b,!0)}delete(m){this.k();let b=null;if(m instanceof I.Range)b=m;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(m,b,f){const s=this.c.validateRange(m);this.g.push({range:s,text:b,forceMoveMarkers:f})}setEndOfLine(m){if(this.k(),m!==I.EndOfLine.LF&&m!==I.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this.h=m}}class k{constructor(m,b,f,s){this.c=m,this.d=b,this._accept(f),this.e=s;const o=this;this.value={get tabSize(){return o.f},set tabSize(l){o.m(l)},get indentSize(){return o.g},set indentSize(l){o.o(l)},get insertSpaces(){return o.h},set insertSpaces(l){o.q(l)},get cursorStyle(){return o.j},set cursorStyle(l){o.s(l)},get lineNumbers(){return o.k},set lineNumbers(l){o.t(l)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.insertSpaces,this.j=m.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(m.lineNumbers)}l(m){if(m==="auto")return"auto";if(typeof m=="number"){const b=Math.floor(m);return b>0?b:null}if(typeof m=="string"){const b=parseInt(m,10);return isNaN(b)?null:b>0?b:null}return null}m(m){const b=this.l(m);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const b=Math.floor(m);return b>0?b:null}if(typeof m=="string"){const b=parseInt(m,10);return isNaN(b)?null:b>0?b:null}return null}o(m){const b=this.n(m);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}q(m){const b=this.p(m);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(m){this.j!==m&&(this.j=m,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}t(m){this.k!==m&&(this.k=m,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(m)})))}assign(m){const b={};let f=!1;if(typeof m.tabSize<"u"){const s=this.l(m.tabSize);s==="auto"?(f=!0,b.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,f=!0,b.tabSize=s)}if(typeof m.indentSize<"u"){const s=this.n(m.indentSize);s==="tabSize"?(f=!0,b.indentSize=s):typeof s=="number"&&this.g!==s&&(this.g=s,f=!0,b.indentSize=s)}if(typeof m.insertSpaces<"u"){const s=this.p(m.insertSpaces);s==="auto"?(f=!0,b.insertSpaces=s):this.h!==s&&(this.h=s,f=!0,b.insertSpaces=s)}typeof m.cursorStyle<"u"&&this.j!==m.cursorStyle&&(this.j=m.cursorStyle,f=!0,b.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.k!==m.lineNumbers&&(this.k=m.lineNumbers,f=!0,b.lineNumbers=M.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(m,b){b.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(f)})}}e.ExtHostTextEditorOptions=k;class O{constructor(m,b,f,s,o,l,v,E){this.id=m,this.j=b,this.k=f,this.g=!1,this.h=new Set,this.c=o,this.d=new k(this.j,this.id,l,f),this.e=v,this.f=E;const P=this;this.value=Object.freeze({get document(){return s.value},set document(p){throw(0,C.readonly)("document")},get selection(){return P.c&&P.c[0]},set selection(p){if(!(p instanceof I.Selection))throw(0,C.illegalArgument)("selection");P.c=[p],P.l()},get selections(){return P.c},set selections(p){if(!Array.isArray(p)||p.some(r=>!(r instanceof I.Selection)))throw(0,C.illegalArgument)("selections");P.c=p,P.l()},get visibleRanges(){return P.e},set visibleRanges(p){throw(0,C.readonly)("visibleRanges")},get options(){return P.d.value},set options(p){P.g||P.d.assign(p)},get viewColumn(){return P.f},set viewColumn(p){throw(0,C.readonly)("viewColumn")},edit(p,r={undoStopBefore:!0,undoStopAfter:!0}){if(P.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new y(s.value,r);return p(d),P.m(d)},insertSnippet(p,r,d={undoStopBefore:!0,undoStopAfter:!0}){if(P.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!r||Array.isArray(r)&&r.length===0)i=P.c.map(c=>M.Range.from(c));else if(r instanceof I.Position){const{lineNumber:c,column:t}=M.Position.from(r);i=[{startLineNumber:c,startColumn:t,endLineNumber:c,endColumn:t}]}else if(r instanceof I.Range)i=[M.Range.from(r)];else{i=[];for(const c of r)if(c instanceof I.Range)i.push(M.Range.from(c));else{const{lineNumber:t,column:h}=M.Position.from(c);i.push({startLineNumber:t,startColumn:h,endLineNumber:t,endColumn:h})}}return b.$tryInsertSnippet(m,s.value.version,p.value,i,d)},setDecorations(p,r){const d=r.length===0;d&&!P.h.has(p.key)||(d?P.h.delete(p.key):P.h.add(p.key),P.n(()=>{if(M.isDecorationOptionsArr(r))return b.$trySetDecorations(m,p.key,M.fromRangeOrRangeWithMessage(r));{const i=new Array(4*r.length);for(let c=0,t=r.length;c<t;c++){const h=r[c];i[4*c]=h.start.line+1,i[4*c+1]=h.start.character+1,i[4*c+2]=h.end.line+1,i[4*c+3]=h.end.character+1}return b.$trySetDecorationsFast(m,p.key,i)}}))},revealRange(p,r){P.n(()=>b.$tryRevealRange(m,M.Range.from(p),r||I.TextEditorRevealType.Default))},show(p){b.$tryShowEditor(m,M.ViewColumn.from(p))},hide(){b.$tryHideEditor(m)}})}dispose(){(0,n.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,n.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,n.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,n.ok)(!this.g),this.f=m}_acceptSelections(m){(0,n.ok)(!this.g),this.c=m}async l(){const m=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const b=m.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const f=b.edits.map(o=>o.range);f.sort((o,l)=>o.end.line===l.end.line?o.end.character===l.end.character?o.start.line===l.start.line?o.start.character-l.start.character:o.start.line-l.start.line:o.end.character-l.end.character:o.end.line-l.end.line);for(let o=0,l=f.length-1;o<l;o++){const v=f[o].end;if(f[o+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=b.edits.map(o=>({range:M.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,s,{setEndOfLine:typeof b.setEndOfLine=="number"?M.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.ExtHostTextEditor=O}),define(Ie[197],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[198],Ce([1,0,152,11,30,90,68,29,25,197,161,154]),function(te,e,n,C,S,M,I,A,y,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const m=A.Registry.as(I.Extensions.JSONContribution);class b{constructor(p,r,d){this.a=p,this.b=r,this.c=d}d(p,r){this.a({type:p,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(S.default.Error,p)}warn(p){this.d(S.default.Warning,p)}info(p){this.d(S.default.Info,p)}}e.ExtensionMessageCollector=b;class f{static a(p){const r=new Set;for(let d=0,i=p.length;d<i;d++)r.add(y.ExtensionIdentifier.toKey(p[d].description.identifier));return r}static compute(p,r){if(!p||!p.length)return new f(r,[]);if(!r||!r.length)return new f([],p);const d=this.a(p),i=this.a(r),c=r.filter(h=>!d.has(y.ExtensionIdentifier.toKey(h.description.identifier))),t=p.filter(h=>!i.has(y.ExtensionIdentifier.toKey(h.description.identifier)));return new f(c,t)}constructor(p,r){this.added=p,this.removed=r}}e.ExtensionPointUserDelta=f;class s{constructor(p,r){this.name=p,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=f.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,C.onUnexpectedError)(p)}}}e.ExtensionPoint=s;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"*",description:n.localize(42,null),body:"*"}]}},badges:{type:"array",description:n.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(44,null)},href:{type:"string",description:n.localize(45,null)},description:{type:"string",description:n.localize(46,null)}}}},markdown:{type:"string",description:n.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:n.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:n.localize(51,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(52,null)},{body:["workspace"],description:n.localize(53,null)},{body:["ui","workspace"],description:n.localize(54,null)},{body:["workspace","ui"],description:n.localize(55,null)},{body:[],description:n.localize(56,null)}]},capabilities:{description:n.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(60,null),n.localize(61,null),n.localize(62,null)]},description:{type:"string",markdownDescription:n.localize(63,null)}}},untrustedWorkspaces:{description:n.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(66,null),n.localize(67,null),n.localize(68,null)]},restrictedConfigurations:{description:n.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(70,null)}}}}},sponsor:{description:n.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(73,null),type:"string"},"vscode:uninstall":{description:n.localize(74,null),type:"string"}}},icon:{type:"string",description:n.localize(75,null)},l10n:{type:"string",description:n.localize(76,null)}}};class v{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const r=new s(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,r),p.activationEventsGenerator&&w.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,m.registerSchema(l,e.schema),r}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=v;const E={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(E.ExtensionsRegistry,new v),e.ExtensionsRegistry=A.Registry.as(E.ExtensionsRegistry),m.registerSchema(l,e.schema),m.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:n.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ie[199],Ce([1,0,149,9,22,198,42,4]),function(te,e,n,C,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:n.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:n.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:n.localize(2,null),default:""}}};var k;(function(m){function b(f,s,o){if(!f)return;const l=C.isString(f.type)?f.type:void 0;if(!l||l.length===0){o.error(n.localize(3,null));return}const v=[];if(Array.isArray(f.required))for(const E of f.required)C.isString(E)&&v.push(E);return{extensionId:s.value,taskType:l,required:v,properties:f.properties?S.deepClone(f.properties):{},when:f.when?I.ContextKeyExpr.deserialize(f.when):void 0}}m.from=b})(k||(k={}));const O=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:n.localize(4,null),type:"array",items:y}});class w{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,f)=>{O.setHandler((s,o)=>{this.c=void 0;try{for(const l of o.removed){const v=l.value;for(const E of v)this.a&&E.type&&this.a[E.type]&&delete this.a[E.type]}for(const l of o.added){const v=l.value;for(const E of v){const P=k.from(E,l.description.identifier,l.collector);P&&(this.a[P.taskType]=P)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const f of this.all()){const s={type:"object",additionalProperties:!1};f.required.length>0&&(s.required=f.required.slice(0)),f.properties!==void 0?s.properties=S.deepClone(f.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[f.taskType]},b.push(s)}this.c={oneOf:b}}return this.c}}e.TaskDefinitionRegistry=new w}),define(Ie[200],Ce([1,0,150,9,23,22,42,199]),function(te,e,n,C,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new I.RawContextKey("taskRunning",!1,n.localize(0,null)),e.TASKS_CATEGORY={value:n.localize(1,null),original:"Tasks"};var y;(function(T){T[T.Escape=1]="Escape",T[T.Strong=2]="Strong",T[T.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(T){function L(V){if(!V)return T.Strong;switch(V.toLowerCase()){case"escape":return T.Escape;case"strong":return T.Strong;case"weak":return T.Weak;default:return T.Strong}}T.from=L}(y=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(T){T.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var O;(function(T){T[T.Always=1]="Always",T[T.Silent=2]="Silent",T[T.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(T){function L(V){switch(V.toLowerCase()){case"always":return T.Always;case"silent":return T.Silent;case"never":return T.Never;default:return T.Always}}T.fromString=L}(O=e.RevealKind||(e.RevealKind={}));var w;(function(T){T[T.Never=1]="Never",T[T.OnProblem=2]="OnProblem",T[T.Always=3]="Always"})(w=e.RevealProblemKind||(e.RevealProblemKind={})),function(T){function L(V){switch(V.toLowerCase()){case"always":return T.Always;case"never":return T.Never;case"onproblem":return T.OnProblem;default:return T.OnProblem}}T.fromString=L}(w=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(T){T[T.Shared=1]="Shared",T[T.Dedicated=2]="Dedicated",T[T.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(T){function L(V){switch(V.toLowerCase()){case"shared":return T.Shared;case"dedicated":return T.Dedicated;case"new":return T.New;default:return T.Shared}}T.fromString=L}(m=e.PanelKind||(e.PanelKind={}));var b;(function(T){T.defaults={echo:!0,reveal:O.Always,revealProblems:w.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(b=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(T){T[T.Shell=1]="Shell",T[T.Process=2]="Process",T[T.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(T){function L(j){switch(j.toLowerCase()){case"shell":return T.Shell;case"process":return T.Process;case"customExecution":return T.CustomExecution;default:return T.Process}}T.fromString=L;function V(j){switch(j){case T.Shell:return"shell";case T.Process:return"process";case T.CustomExecution:return"customExecution";default:return"process"}}T.toString=V}(f=e.RuntimeType||(e.RuntimeType={}));var s;(function(T){function L(V){return C.isString(V)?V:V.value}T.value=L})(s=e.CommandString||(e.CommandString={}));var o;(function(T){T.Clean={_id:"clean",isDefault:!1},T.Build={_id:"build",isDefault:!1},T.Rebuild={_id:"rebuild",isDefault:!1},T.Test={_id:"test",isDefault:!1};function L(j){return j===T.Clean._id||j===T.Build._id||j===T.Rebuild._id||j===T.Test._id}T.is=L;function V(j){if(j!==void 0)return C.isString(j)?L(j)?{_id:j,isDefault:!1}:void 0:j}T.from=V})(o=e.TaskGroup||(e.TaskGroup={}));var l;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace",T[T.Folder=3]="Folder"})(l=e.TaskScope||(e.TaskScope={}));var v;(function(T){T.Workspace="workspace",T.Extension="extension",T.InMemory="inMemory",T.WorkspaceFile="workspaceFile",T.User="user";function L(V){switch(V){case T.User:return 2;case T.WorkspaceFile:return 5;default:return 6}}T.toConfigurationTarget=L})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var E;(function(T){T.parallel="parallel",T.sequence="sequence"})(E=e.DependsOrder||(e.DependsOrder={}));var P;(function(T){T[T.default=1]="default",T[T.folderOpen=2]="folderOpen"})(P=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(T){T.defaults={reevaluateOnRerun:!0,runOn:P.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class r{constructor(L,V,j,le,Y,pe){this._label="",this._id=L,V&&(this._label=V),j&&(this.type=j),this.runOptions=le,this.configurationProperties=Y,this._source=pe}getDefinition(L){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const L={folder:this.d(),id:this._id};return JSON.stringify(L)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(L,V=!1){if(L===void 0)return!1;if(C.isString(L))return L===this._label||L===this.configurationProperties.identifier||V&&L===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===L._key}getQualifiedLabel(){const L=this.getWorkspaceFolder();return L?`${this._label} (${L.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(L){this.c===void 0&&(this.c=[]),L&&(this.c=this.c.concat(L))}get taskLoadMessages(){return this.c}}e.CommonTask=r;class d extends r{constructor(L,V,j,le,Y,pe,ue,de){super(L,j,void 0,ue,de,V),this.command={},this._source=V,this.hasDefinedMatchers=pe,Y&&(this.command=Y)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(L=!1){if(L&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case f.Shell:V="shell";break;case f.Process:V="process";break;case f.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(L){return L instanceof d}getMapKey(){const L=this._source.config.workspaceFolder;return L?`${L.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const L=this.d();if(!L)return;let V=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(V+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:L,id:V};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(L){return new d(L._id,L._source,L._label,L.type,L.command,L.hasDefinedMatchers,L.runOptions,L.configurationProperties)}}e.CustomTask=d;class i extends r{constructor(L,V,j,le,Y,pe,ue){super(L,j,le,pe,ue,V),this._source=V,this.configures=Y}static is(L){return L instanceof i}f(L){return L}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const L=this.d();if(!L)return;let V=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(V+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:L,id:V};return JSON.stringify(j)}}e.ConfiguringTask=i;class c extends r{constructor(L,V,j,le,Y,pe,ue,de,re){super(L,j,le,de,re,V),this.defines=Y,this.hasDefinedMatchers=ue,this.command=pe,this.icon=re.icon,this.hide=re.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(L){return L instanceof c}getMapKey(){const L=this._source.workspaceFolder;return L?`${this._source.scope.toString()}|${L.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const L={type:"contributed",scope:this._source.scope,id:this._id};return L.folder=this.d(),JSON.stringify(L)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(L){return new c(L._id,L._source,L._label,L.type,L.defines,L.command,L.hasDefinedMatchers,L.runOptions,L.configurationProperties)}}e.ContributedTask=c;class t extends r{constructor(L,V,j,le,Y,pe){super(L,j,le,Y,pe,V),this._source=V}clone(){return new t(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(L){return L instanceof t}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(L){return new t(L._id,L._source,L._label,L.type,L.runOptions,L.configurationProperties)}}e.InMemoryTask=t;var h;(function(T){T[T.Process=1]="Process",T[T.Terminal=2]="Terminal"})(h=e.ExecutionEngine||(e.ExecutionEngine={})),function(T){T._default=T.Terminal}(h=e.ExecutionEngine||(e.ExecutionEngine={}));var a;(function(T){T[T.V0_1_0=1]="V0_1_0",T[T.V2_0_0=2]="V2_0_0"})(a=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class u{constructor(L){this.c=new Map;for(let V=0;V<L.length;V++)this.c.set(L[V].uri.toString(),V)}compare(L,V){const j=L.getWorkspaceFolder(),le=V.getWorkspaceFolder();if(j&&le){let Y=this.c.get(j.uri.toString());Y=Y===void 0?0:Y+1;let pe=this.c.get(le.uri.toString());return pe=pe===void 0?0:pe+1,Y===pe?L._label.localeCompare(V._label):Y-pe}else return!j&&le?-1:j&&!le?1:0}}e.TaskSorter=u;var g;(function(T){T.DependsOnStarted="dependsOnStarted",T.AcquiredInput="acquiredInput",T.Start="start",T.ProcessStarted="processStarted",T.Active="active",T.Inactive="inactive",T.Changed="changed",T.Terminated="terminated",T.ProcessEnded="processEnded",T.End="end"})(g=e.TaskEventKind||(e.TaskEventKind={}));var R;(function(T){T.SingleRun="singleRun",T.Background="background"})(R=e.TaskRunType||(e.TaskRunType={}));var F;(function(T){T[T.System=0]="System",T[T.User=1]="User",T[T.FolderOpen=2]="FolderOpen",T[T.ConfigurationChange=3]="ConfigurationChange",T[T.Reconnect=4]="Reconnect"})(F=e.TaskRunSource||(e.TaskRunSource={}));var q;(function(T){function L(V,j,le,Y){if(j){const pe={kind:V,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:le,__task:j};return V==="start"?pe.resolvedVariables=Y:V==="processStarted"?pe.processId=Y:V==="processEnded"&&(pe.exitCode=Y),Object.freeze(pe)}else return Object.freeze({kind:"changed"})}T.create=L})(q=e.TaskEvent||(e.TaskEvent={}));var Z;(function(T){function L(j){const le=Object.keys(j).sort();let Y="";for(const pe of le){let ue=j[pe];ue instanceof Object?ue=L(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),Y+=pe+","+ue+","}return Y}function V(j){const Y={_key:L(j),type:j.taskType};return Object.assign(Y,j),Y}T.create=V})(Z=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var x;(function(T){T.AutoDetect="task.autoDetect",T.SaveBeforeRun="task.saveBeforeRun",T.ShowDecorations="task.showDecorations",T.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",T.SlowProviderWarning="task.slowProviderWarning",T.QuickOpenHistory="task.quickOpen.history",T.QuickOpenDetail="task.quickOpen.detail",T.QuickOpenSkip="task.quickOpen.skip",T.QuickOpenShowAll="task.quickOpen.showAll",T.AllowAutomaticTasks="task.allowAutomaticTasks",T.Reconnection="task.reconnection"})(x=e.TaskSettingId||(e.TaskSettingId={}));var N;(function(T){T.Tasks="tasks",T.SuppressTaskName="tasks.suppressTaskName",T.Windows="tasks.windows",T.Osx="tasks.osx",T.Linux="tasks.linux",T.ShowOutput="tasks.showOutput",T.IsShellCommand="tasks.isShellCommand",T.ServiceTestSetting="tasks.service.testSetting"})(N=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var $;(function(T){function L(V,j){const le=A.TaskDefinitionRegistry.get(V.type);if(le===void 0){const de=M.deepClone(V);return delete de._key,Z.create(de)}const Y=Object.create(null);Y.type=le.taskType;const pe=new Set;le.required.forEach(de=>pe.add(de));const ue=le.properties;for(const de of Object.keys(ue)){const re=V[de];if(re!=null)Y[de]=re;else if(pe.has(de)){const G=ue[de];if(G.default!==void 0)Y[de]=M.deepClone(G.default);else switch(G.type){case"boolean":Y[de]=!1;break;case"number":case"integer":Y[de]=0;break;case"string":Y[de]="";break;default:j.error(n.localize(2,null,JSON.stringify(V,void 0,0),de));return}}}return Z.create(Y)}T.createTaskIdentifier=L})($=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[201],Ce([1,0,11]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class C{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((I,A)=>{this.b=I,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(I){this.f||this.h||(this.f=!0,this.g=I,this.a&&this.b(I))}resolveErr(I){this.f||this.h||(this.h=!0,this.i=I,this.a?this.d(I):(0,n.onUnexpectedError)(I))}then(I,A){return this.j().then(I,A)}catch(I){return this.j().then(void 0,I)}finally(I){return this.j().finally(I)}}e.LazyPromise=C;class S extends C{constructor(){super(),this.h=!0,this.i=new n.CancellationError}}e.CanceledLazyPromise=S}),define(Ie[44],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++n.count}}e.ProxyIdentifier=n,n.count=0;const C=[];function S(A){const y=new n(A);return C[y.nid]=y,y}e.createProxyIdentifier=S;function M(A){return C[A].sid}e.getStringIdentifierForProxy=M;class I{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=I}),define(Ie[5],Ce([1,0,44]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput"})(S=e.TabInputKind||(e.TabInputKind={}));var M;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var I;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class w{static mixin(o){return o._id=w.a++,o}}e.IdObject=w,w.a=0;var m;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var b;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(b=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,n.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,n.createProxyIdentifier)("ExtHostLocalization")}}),define(Ie[76],Ce([1,0,3,12,5,17]),function(te,e,n,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(y,k){this.c=k,this.a=new Set,this.b=y.getProxy(S.MainContext.MainThreadTelemetry)}report(y,k,O){const w=this.d(y,k);this.a.has(w)||(this.a.add(w),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:y}))}d(y,k){return`${y}-${k.identifier.value}`}};I=qe([Ve(0,M.IExtHostRpcService),Ve(1,C.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,k){}})}),define(Ie[202],Ce([1,0,4,5,7,25]),function(te,e,n,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(y){this.b=new Map,this.c=[],this.d=new n.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,k,O,w={}){const m=M.ExtensionIdentifier.toKey(y.identifier),b=this.f.get(m)||[],f=[...O].sort().join(" ");let s=b.find(o=>o.providerId===k&&o.scopes===f);if(s)return s.result;{const o=this.g(y,m,k,O,w);s={providerId:k,scopes:f,result:o},b.push(s),this.f.set(m,b);try{await o}finally{const l=b.findIndex(v=>v.providerId===k&&v.scopes===f);l>-1&&(b.splice(l),this.f.set(m,b))}return o}}async g(y,k,O,w,m={}){await this.a.$ensureProvider(O);const b=y.displayName||y.name;return this.a.$getSession(O,w,k,b,m)}async removeSession(y,k){const O=this.b.get(y);return O?O.provider.removeSession(k):this.a.$removeSession(y,k)}registerAuthenticationProvider(y,k,O,w){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:k,provider:O,options:w??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===y)||this.c.push({id:y,label:k});const m=O.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(y,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(y,k,w?.supportsMultipleAccounts??!1),new S.Disposable(()=>{m.dispose(),this.b.delete(y);const b=this.c.findIndex(f=>f.id===y);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,k){const O=this.b.get(y);if(O)return Promise.resolve(O.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,k){const O=this.b.get(y);if(O)return Promise.resolve(O.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,k){const O=this.b.get(y);if(O)return Promise.resolve(O.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,k){return this.d.fire({provider:{id:y,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(Ie[203],Ce([1,0,5,17,8]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(A,y){this.a=A.getProxy(n.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>y.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,k){const O=S.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,k?.isRefactoring??!1)}};M=qe([Ve(0,C.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(Ie[204],Ce([1,0,5]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(M){const I=M.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(A){return I.$writeText(A)}})}}e.ExtHostClipboard=C});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,n):S?S.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ie[38],Ce([1,0,9,7,8,22,5,18,12,85,56,256,2,6,3,17,101,24,44,39,77,50]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o,l,v,E,P,p){"use strict";var r,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let i=class{constructor(g,R){r.set(this,void 0),this.b=new Map,this.c=new Map,d.set(this,void 0),Je(this,r,g.getProxy(I.MainContext.MainThreadCommands),"f"),this.d=R,Je(this,d,g.getProxy(I.MainContext.MainThreadTelemetry),"f"),this.converter=new c(this,F=>{const q=this.c.get(F);return q?.result===h.Void?q:void 0},R),this.f=[{processArgument(F){return(0,k.revive)(F)}},{processArgument(F){return(0,M.cloneAndChange)(F,function(q){if(O.Range.isIRange(q))return S.Range.to(q);if(w.Position.isIPosition(q))return S.Position.to(q);if(O.Range.isIRange(q.range)&&m.URI.isUri(q.uri))return S.location.to(q);if(q instanceof l.VSBuffer)return q.buffer.buffer;if(!Array.isArray(q))return q})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const R=this.registerCommand(!1,g.id,async(...F)=>{const q=g.args.map((x,N)=>{if(!x.validate(F[N]))throw new Error(`Invalid argument '${x.name}' when running '${g.id}', received: ${F[N]}`);return x.convert(F[N])}),Z=await this.executeCommand(g.internalId,...q);return g.result.convert(Z,F,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new C.Disposable(()=>{R.dispose(),this.c.delete(g.id)})}registerCommand(g,R,F,q,Z,x){if(this.d.trace("ExtHostCommands#registerCommand",R),!R.trim().length)throw new Error("invalid id");if(this.b.has(R))throw new Error(`command '${R}' already exists`);return this.b.set(R,{callback:F,thisArg:q,description:Z,extension:x}),g&&Oe(this,r,"f").$registerCommand(R),new C.Disposable(()=>{this.b.delete(R)&&g&&Oe(this,r,"f").$unregisterCommand(R)})}executeCommand(g,...R){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,R,!0)}async g(g,R,F){if(this.b.has(g))return Oe(this,r,"f").$fireCommandActivationEvent(g),this.h(g,R,!1);{let q=!1;const Z=(0,M.cloneAndChange)(R,function(x){if(x instanceof C.Position)return S.Position.from(x);if(x instanceof C.Range)return S.Range.from(x);if(x instanceof C.Location)return S.location.from(x);if(C.NotebookRange.isNotebookRange(x))return S.NotebookRange.from(x);if(x instanceof ArrayBuffer)return q=!0,l.VSBuffer.wrap(new Uint8Array(x));if(x instanceof Uint8Array)return q=!0,l.VSBuffer.wrap(x);if(x instanceof l.VSBuffer)return q=!0,x;if(!Array.isArray(x))return x});try{const x=await Oe(this,r,"f").$executeCommand(g,q?new v.SerializableObjectWithBuffers(Z):Z,F);return(0,k.revive)(x)}catch(x){if(x instanceof Error&&x.message==="$executeCommand:retry")return this.g(g,R,!1);throw x}}}async h(g,R,F){const q=this.b.get(g);if(!q)throw new Error("Unknown command");const{callback:Z,thisArg:x,description:N}=q;if(N)for(let T=0;T<N.args.length;T++)try{(0,n.validateConstraint)(R[T],N.args[T].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${N.args[T].name}' - ${N.args[T].description}`)}const $=P.StopWatch.create();try{return await Z.apply(x,R)}catch(T){if(g===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...R);L&&(g=L.command)}throw this.d.error(T,g,q.extension?.identifier),F?new class extends Error{constructor(){super((0,E.toErrorMessage)(T)),this.id=g,this.source=q.extension?.displayName??q.extension?.name}}:T}finally{this.j(q,g,$.elapsed())}}j(g,R,F){!g.extension||Oe(this,d,"f").$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new p.TelemetryTrustedValue(R),duration:F})}$executeContributedCommand(g,...R){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const F=this.b.get(g);return F?(R=R.map(q=>this.f.reduce((Z,x)=>x.processArgument(Z,F.extension?.identifier),q)),this.h(g,R,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),Oe(this,r,"f").$getCommands().then(R=>(g&&(R=R.filter(F=>F[0]!=="_")),R))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(const[R,F]of this.b){const{description:q}=F;q&&(g[R]=q)}return Promise.resolve(g)}};r=new WeakMap,d=new WeakMap,i=qe([Ve(0,s.IExtHostRpcService),Ve(1,y.ILogService)],i),e.ExtHostCommands=i,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class c{constructor(g,R,F){this.d=g,this.f=R,this.g=F,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,R){if(!g)return;const F={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return F;const q=this.f(g.command);if(q)F.id=q.internalId,F.arguments=q.args.map((Z,x)=>Z.convert(g.arguments&&g.arguments[x]));else if((0,A.isNonEmptyArray)(g.arguments)){const Z=`${g.command}/${++this.c}`;this.b.set(Z,g),R.add((0,b.toDisposable)(()=>{this.b.delete(Z),this.g.trace("CommandsConverter#DISPOSE",Z)})),F.$ident=Z,F.id=this.delegatingCommandId,F.arguments=[Z],this.g.trace("CommandsConverter#CREATE",g.command,Z)}return F}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const R=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],R?R.command:"MISSING"),R?this.d.executeCommand(R.command,...R.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.CommandsConverter=c;class t{constructor(g,R,F,q){this.name=g,this.description=R,this.validate=F,this.convert=q}optional(){return new t(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,R){return new t(g??this.name,R??this.description,this.validate,this.convert)}}e.ApiCommandArgument=t,t.Uri=new t("uri","Uri of a text document",u=>m.URI.isUri(u),u=>u),t.Position=new t("position","A position in a text document",u=>C.Position.isPosition(u),S.Position.from),t.Range=new t("range","A range in a text document",u=>C.Range.isRange(u),S.Range.from),t.Selection=new t("selection","A selection in a text document",u=>C.Selection.isSelection(u),S.Selection.from),t.Number=new t("number","",u=>typeof u=="number",u=>u),t.String=new t("string","",u=>typeof u=="string",u=>u),t.CallHierarchyItem=new t("item","A call hierarchy item",u=>u instanceof C.CallHierarchyItem,S.CallHierarchyItem.from),t.TypeHierarchyItem=new t("item","A type hierarchy item",u=>u instanceof C.TypeHierarchyItem,S.TypeHierarchyItem.from),t.TestItem=new t("testItem","A VS Code TestItem",u=>u instanceof o.TestItemImpl,S.TestItem.from);class h{constructor(g,R){this.description=g,this.convert=R}}e.ApiCommandResult=h,h.Void=new h("no result",u=>u);class a{constructor(g,R,F,q,Z){this.id=g,this.internalId=R,this.description=F,this.args=q,this.result=Z}}e.ApiCommand=a}),define(Ie[205],Ce([1,0,2,8,7,75,38,18,88,92,15]),function(te,e,n,C,S,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const w=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",b(C.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,o)=>{if((0,A.isFalsyOrEmpty)(s))return;class l extends S.SymbolInformation{static to(E){const P=new l(E.name,C.SymbolKind.to(E.kind),E.containerName||"",new S.Location(o[0],C.Range.to(E.range)));return P.detail=E.detail,P.range=P.location.range,P.selectionRange=C.Range.to(E.selectionRange),P.children=E.children?E.children.map(l.to):[],P}}return s.map(l.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(C.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(C.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",s=>typeof s=="string",s=>s),new I.ApiCommandArgument("options","Formatting options",s=>!0,s=>s)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(C.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(C.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(C.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",s=>Array.isArray(s)&&s.every(o=>S.Position.isPosition(o)),s=>s.map(C.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",s=>s.map(o=>{let l;for(const v of o.reverse())l=new S.SelectionRange(C.Range.to(v),l);return l}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(C.WorkspaceSymbol.to))),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(C.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(C.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(C.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",s=>{if(!!s)return{range:C.Range.to(s.range),placeholder:s.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",s=>{if(!!s){if(s.rejectReason)throw new Error(s.rejectReason);return C.WorkspaceEdit.to(s)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(C.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new S.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,y.decodeSemanticTokensDto)(s);if(o.type==="full")return new S.SemanticTokens(o.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",s=>{if(!!s)return new S.SemanticTokensLegend(s.tokenTypes,s.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,y.decodeSemanticTokensDto)(s);if(o.type==="full")return new S.SemanticTokens(o.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(s,o,l)=>{if(!s)return new S.CompletionList([]);const v=s.suggestions.map(E=>C.CompletionItem.to(E,l));return new S.CompletionList(v,s.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",s=>{if(s)return C.SignatureHelp.to(s)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(s,o,l)=>b(v=>new S.CodeLens(C.Range.to(v.range),v.command&&l.fromInternal(v.command)))(s))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>S.Range.isRange(s),s=>S.Selection.isSelection(s)?C.Selection.from(s):C.Range.from(s)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(s,o,l)=>b(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(v.command)}else{const E=new S.CodeAction(v.title,v.kind?new S.CodeActionKind(v.kind):void 0);return v.edit&&(E.edit=C.WorkspaceEdit.to(v.edit)),v.command&&(E.command=l.fromInternal(v.command)),E.isPreferred=v.isPreferred,E}})(s))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(o=>new S.ColorInformation(C.Range.to(o.range),C.Color.to(o.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",s=>s instanceof S.Color,C.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:C.Range.from(s.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(C.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",(s,o,l)=>s.map(C.InlayHint.to.bind(void 0,l)))),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(o=>C.NotebookExclusiveDocumentPattern.to(o))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",s=>s.map(C.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new I.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",s=>n.URI.isUri(s)||typeof s=="string"&&(0,k.matchesSomeScheme)(s,O.Schemas.http,O.Schemas.https),s=>s),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[C.ViewColumn.from(s),void 0]:[C.ViewColumn.from(s.viewColumn),C.TextEditorOpenOptions.from(s)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[C.ViewColumn.from(s),void 0]:[C.ViewColumn.from(s.viewColumn),C.TextEditorOpenOptions.from(s)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[C.ViewColumn.from(s.viewColumn),C.TextEditorOpenOptions.from(s)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void),new I.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[I.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],I.ApiCommandResult.Void),new I.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[I.ApiCommandArgument.String.with("name","The context key name"),new I.ApiCommandArgument("value","The context key value",()=>!0,s=>s)],I.ApiCommandResult.Void)];class m{static register(o){w.forEach(o.registerApiCommand,o)}}e.ExtHostApiCommands=m;function b(s){return o=>{if(Array.isArray(o))return o.map(s)}}function f(s){if(!Array.isArray(s))return;const o=[];for(const l of s)M.isLocationLink(l)?o.push(C.DefinitionLink.to(l)):o.push(C.location.to(l));return o}}),define(Ie[206],Ce([1,0,16,63,4,6,2,75,25,8,7,5]),function(te,e,n,C,S,M,I,A,y,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function m(b,f,s){const o=b.getProxy(w.MainContext.MainThreadComments);class l{constructor(){this.b=new Map,this.c=new Map,f.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const h=this.b.get(t.handle);return h?h.value:t}else if(t&&t.$mid===7){const h=this.b.get(t.commentControlHandle);if(!h)return t;const a=h.getCommentThread(t.commentThreadHandle);return a?a.value:t}else if(t&&(t.$mid===9||t.$mid===8)){const h=this.b.get(t.thread.commentControlHandle);if(!h)return t;const a=h.getCommentThread(t.thread.commentThreadHandle);return a?t.$mid===8?a.value:{thread:a.value,text:t.text}:t}else if(t&&t.$mid===10){const h=this.b.get(t.thread.commentControlHandle);if(!h)return t;const a=h.getCommentThread(t.thread.commentThreadHandle);if(!a)return t;const u=t.commentUniqueId,g=a.getCommentByUniqueId(u);return g||t}else if(t&&t.$mid===11){const h=this.b.get(t.thread.commentControlHandle);if(!h)return t;const a=h.getCommentThread(t.thread.commentThreadHandle);if(!a)return t;const u=t.text,g=t.commentUniqueId,R=a.getCommentByUniqueId(g);return R?(typeof R.body=="string"?R.body=u:R.body=new O.MarkdownString(u),R):t}return t}})}createCommentController(t,h,a){const u=l.a++,g=new E(t,u,h,a);this.b.set(g.handle,g);const R=this.c.get(y.ExtensionIdentifier.toKey(t.identifier))||[];return R.push(g),this.c.set(y.ExtensionIdentifier.toKey(t.identifier),R),g.value}$createCommentThreadTemplate(t,h,a){const u=this.b.get(t);!u||u.$createCommentThreadTemplate(h,a)}async $updateCommentThreadTemplate(t,h,a){const u=this.b.get(t);!u||u.$updateCommentThreadTemplate(h,a)}$deleteCommentThread(t,h){this.b.get(t)?.$deleteCommentThread(h)}$provideCommentingRanges(t,h,a){const u=this.b.get(t);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const g=s.getDocument(I.URI.revive(h));return(0,n.asPromise)(()=>u.commentingRangeProvider.provideCommentingRanges(g,a)).then(R=>R?R.map(F=>k.Range.from(F)):void 0)}$toggleReaction(t,h,a,u,g){const R=this.b.get(t);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const F=R.getCommentThread(h);if(F){const q=F.getCommentByUniqueId(u.uniqueIdInThread);if(R!==void 0&&q&&R.reactionHandler)return R.reactionHandler(q,r(g))}return Promise.resolve(void 0)})}dispose(){}}l.a=0;class v{set threadId(t){this.n=t}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(t){t.isEqual(this.p)||(this.p=t,this.b.range=t,this.c.fire())}get range(){return this.p}set canReply(t){this.d!==t&&(this.d=t,this.b.canReply=t,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(t){this.e=t,this.b.label=t,this.c.fire()}get contextValue(){return this.f}set contextValue(t){this.f=t,this.b.contextValue=t,this.c.fire()}get comments(){return this.q}set comments(t){this.q=t,this.b.comments=t,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(t){this.g=t,this.b.collapsibleState=t,this.c.fire()}get state(){return this.h}set state(t){this.h=t,this.b.state=t,this.c.fire()}get isDisposed(){return this.j}constructor(t,h,a,u,g,R,F,q){this.m=h,this.n=a,this.o=u,this.p=g,this.q=R,this.extensionDescription=F,this.r=q,this.handle=v.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new S.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.MutableDisposable,this.l.value=new M.DisposableStore,this.n===void 0&&(this.n=`${t}.${this.handle}`),o.$createCommentThread(h,this.handle,this.n,this.o,k.Range.from(this.p),F.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this.i.push({dispose:()=>{o.$deleteCommentThread(h,this.handle)}});const Z=this;this.value={get uri(){return Z.uri},get range(){return Z.range},set range(x){Z.range=x},get comments(){return Z.comments},set comments(x){Z.comments=x},get collapsibleState(){return Z.collapsibleState},set collapsibleState(x){Z.collapsibleState=x},get canReply(){return Z.canReply},set canReply(x){Z.canReply=x},get contextValue(){return Z.contextValue},set contextValue(x){Z.contextValue=x},get label(){return Z.label},set label(x){Z.label=x},get state(){return Z.state},set state(x){Z.state=x},dispose:()=>{Z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.DisposableStore);const t=a=>Object.prototype.hasOwnProperty.call(this.b,a),h={};t("range")&&(h.range=k.Range.from(this.p)),t("label")&&(h.label=this.label),t("contextValue")&&(h.contextValue=this.contextValue??null),t("comments")&&(h.comments=this.q.map(a=>P(this,a,this.k))),t("collapsibleState")&&(h.collapseState=d(this.g)),t("canReply")&&(h.canReply=this.canReply),t("state")&&(h.state=i(this.h)),t("isTemplate")&&(h.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,h)}getCommentByUniqueId(t){for(const h of this.k){const a=h[0],u=h[1];if(t===u)return a}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(t=>t.dispose())}}v.a=0,qe([(0,C.debounce)(100)],v.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(t){this.b=t,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(t){this.c=t,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this.d}set options(t){this.d=t,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(t,h,a,u){this.f=t,this.g=h,this.h=a,this.i=u,this.a=new Map,o.$registerCommentController(this.handle,a,u);const g=this;this.value=Object.freeze({id:g.id,label:g.label,get options(){return g.options},set options(R){g.options=R},get commentingRangeProvider(){return g.commentingRangeProvider},set commentingRangeProvider(R){g.commentingRangeProvider=R},get reactionHandler(){return g.reactionHandler},set reactionHandler(R){g.reactionHandler=R},createCommentThread(R,F,q){return g.createCommentThread(R,F,q).value},dispose:()=>{g.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(t,h,a,u){if(typeof t=="string"){const g=new v(this.id,this.handle,t,h,a,u,this.f,!1);return this.a.set(g.handle,g),g}else{const g=new v(this.id,this.handle,void 0,t,h,a,this.f,!1);return this.a.set(g.handle,g),g}}$createCommentThreadTemplate(t,h){const a=new v(this.id,this.handle,void 0,I.URI.revive(t),k.Range.to(h),[],this.f,!0);return a.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(a.handle,a),a}$updateCommentThreadTemplate(t,h){const a=this.a.get(t);a&&(a.range=k.Range.to(h))}$deleteCommentThread(t){this.a.get(t)?.dispose(),this.a.delete(t)}getCommentThread(t){return this.a.get(t)}dispose(){this.a.forEach(t=>{t.dispose()}),this.e.forEach(t=>t.dispose())}}function P(c,t,h){let a=h.get(t);a||(a=++c.commentHandle,h.set(t,a));const u=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:a,body:typeof t.body=="string"?t.body:k.MarkdownString.from(t.body),userName:t.author.name,userIconPath:u,label:t.label,commentReactions:t.reactions?t.reactions.map(g=>p(g)):void 0,timestamp:t.timestamp?.toJSON()}}function p(c){return{label:c.label,iconPath:c.iconPath?k.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function r(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?I.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function d(c){if(c!==void 0)switch(c){case O.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function i(c){if(c!==void 0)switch(c){case O.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new l}e.createExtHostComments=m}),define(Ie[207],Ce([1,0,22,5,27,17]),function(te,e,n,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let I=class{constructor(O,w){this.a=O.getProxy(C.MainContext.MainThreadConsole),this.b=w.consoleForward.includeStack,this.c=w.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(O,w){const m=this,b=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){m.e(O,w,b,arguments)}})}e(O,w,m,b){this.a.$logExtensionHostMessage({type:"__$console",severity:w,arguments:y(b,this.b)}),this.c&&this.f(O,m,b)}};I=qe([Ve(0,M.IExtHostRpcService),Ve(1,S.IExtHostInitDataService)],I),e.AbstractExtHostConsoleForwarder=I;const A=1e5;function y(k,O){const w=[];if(k.length)for(let m=0;m<k.length;m++){let b=k[m];if(typeof b>"u")b="undefined";else if(b instanceof Error){const f=b;f.stack?b=f.stack:b=f.toString()}w.push(b)}if(O){const m=new Error().stack;m&&w.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,n.safeStringify)(w);return m.length>A?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ie[103],Ce([1,0,2,5,7,3,17,12,18,10,19,26]),function(te,e,n,C,S,M,I,A,y,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let m=class Ui{constructor(f,s){this.h=s,this.f=new Map,this.g=f.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,s){const o=Ui.c++;this.f.set(o,{provider:f,extensionDescription:s}),this.g.$registerDecorationProvider(o,s.identifier.value);const l=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(v=>{if(!v){this.g.$onDidChange(o,null);return}const E=(0,y.asArray)(v);if(E.length<=Ui.d){this.g.$onDidChange(o,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,E.length);const P=E.map(d=>({uri:d,rank:(0,k.count)(d.path,"/")})),p=(0,y.groupBy)(P,(d,i)=>d.rank-i.rank||(0,k.compare)(d.uri.path,i.uri.path)),r=[];e:for(const d of p){let i;for(const c of d){const t=(0,O.dirname)(c.uri.path);if(i!==t&&(i=t,r.push(c.uri)>=Ui.d))break e}}this.g.$onDidChange(o,r)});return new S.Disposable(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(f,s,o){if(!this.f.has(f))return Object.create(null);const l=Object.create(null),{provider:v,extensionDescription:E}=this.f.get(f);return await Promise.all(s.map(async P=>{try{const{uri:p,id:r}=P,d=await Promise.resolve(v.provideFileDecoration(n.URI.revive(p),o));if(!d)return;try{S.FileDecoration.validate(d),d.badge&&typeof d.badge!="string"&&(0,w.checkProposedApiEnabled)(E,"codiconDecoration"),l[r]=[d.propagate,d.tooltip,d.badge,d.color]}catch(i){this.h.warn(`INVALID decoration from extension '${E}': ${i}`)}}catch(p){this.h.error(p)}})),l}};m.c=0,m.d=250,m=qe([Ve(0,I.IExtHostRpcService),Ve(1,A.ILogService)],m),e.ExtHostDecorations=m,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,n):S?S.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ie[208],Ce([1,0,138,91,2,5,7,8,4,12,28,37]),function(te,e,n,C,S,M,I,A,y,k,O,w){"use strict";var m,b,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class s{constructor(v,E,P,p,r,d,i){this.d=v,this.e=E,this.f=P,this.g=p,m.set(this,void 0),b.set(this,void 0),f.set(this,void 0),this.c=!1,Je(this,f,new O.ResourceMap(c=>r.getComparisonKey(c)),"f"),Je(this,m,d,"f"),Je(this,b,i,"f")}dispose(){this.c||(Oe(this,b,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,m,"f")?.$clear(this.e),Oe(this,f,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(v,E){if(!v){this.clear();return}this.h();let P=[];if(S.URI.isUri(v)){if(!E){this.delete(v);return}Oe(this,f,"f").set(v,E.slice()),P=[v]}else if(Array.isArray(v)){P=[];let r;v=[...v].sort(s.j);for(const d of v){const[i,c]=d;if((!r||i.toString()!==r.toString())&&(r&&Oe(this,f,"f").get(r).length===0&&Oe(this,f,"f").delete(r),r=i,P.push(i),Oe(this,f,"f").set(i,[])),c)Oe(this,f,"f").get(i)?.push(...c);else{const t=Oe(this,f,"f").get(i);t&&(t.length=0)}}}if(Oe(this,b,"f").fire(P),!Oe(this,m,"f"))return;const p=[];for(const r of P){let d=[];const i=Oe(this,f,"f").get(r);if(i)if(i.length>this.f){d=[];const c=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(const h of i)if(h.severity===c[t]&&d.push({...A.Diagnostic.from(h),modelVersionId:this.g(r)})===this.f)break e;d.push({severity:C.MarkerSeverity.Info,message:(0,n.localize)(0,null,i.length-this.f),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=i.map(c=>({...A.Diagnostic.from(c),modelVersionId:this.g(r)}));p.push([r,d])}Oe(this,m,"f").$changeMany(this.e,p)}delete(v){this.h(),Oe(this,b,"f").fire([v]),Oe(this,f,"f").delete(v),Oe(this,m,"f")?.$changeMany(this.e,[[v,void 0]])}clear(){this.h(),Oe(this,b,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,m,"f")?.$clear(this.e)}forEach(v,E){this.h();for(const[P,p]of this)v.call(E,P,p,this)}*[(m=new WeakMap,b=new WeakMap,f=new WeakMap,Symbol.iterator)](){this.h();for(const v of Oe(this,f,"f").keys())yield[v,this.get(v)]}get(v){this.h();const E=Oe(this,f,"f").get(v);return Array.isArray(E)?Object.freeze(E.slice(0)):[]}has(v){return this.h(),Array.isArray(Oe(this,f,"f").get(v))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(v,E){return v[0].toString()<E[0].toString()?-1:v[0].toString()>E[0].toString()?1:0}}e.DiagnosticCollection=s;let o=class vi{static _mapper(v){const E=new O.ResourceMap;for(const P of v)E.set(P,P);return{uris:Object.freeze(Array.from(E.values()))}}constructor(v,E,P,p){this.h=E,this.j=P,this.k=p,this.f=new Map,this.g=new y.DebounceEmitter({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,vi._mapper),this.e=v.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(v,E){const{f:P,e:p,g:r,h:d,j:i,k:c}=this,t=new class{$changeMany(u,g){p.$changeMany(u,g),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,u,g.length===0?"CLEARING":g)}$clear(u){p.$clear(u),d.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,u)}dispose(){p.dispose()}};let h;if(!E)E="_generated_diagnostic_collection_name_#"+vi.c++,h=E;else if(!P.has(E))h=E;else{this.h.warn(`DiagnosticCollection with name '${E}' does already exist.`);do h=E+vi.c++;while(P.has(h))}return new class extends s{constructor(){super(E,h,vi.d,u=>c.getDocument(u)?.version,i.extUri,t,r),P.set(h,this)}dispose(){super.dispose(),P.delete(h)}}}getDiagnostics(v){if(v)return this.l(v);{const E=new Map,P=[];for(const p of this.f.values())p.forEach((r,d)=>{let i=E.get(r.toString());typeof i>"u"&&(i=P.length,E.set(r.toString(),i),P.push([r,[]])),P[i][1]=P[i][1].concat(...d)});return P}}l(v){let E=[];for(const P of this.f.values())P.has(v)&&(E=E.concat(P.get(v)));return E}$acceptMarkersChange(v){if(!this.m){const E="_generated_mirror",P=new s(E,E,vi.d,p=>{},this.j.extUri,void 0,this.g);this.f.set(E,P),this.m=P}for(const[E,P]of v)this.m.set(S.URI.revive(E),P.map(A.Diagnostic.to))}};o.c=0,o.d=1e3,o=qe([Ve(1,k.ILogService),Ve(2,w.IExtHostFileSystemInfo)],o),e.ExtHostDiagnostics=o}),define(Ie[209],Ce([1,0,2,5]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(I){this.a=I.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(I){return this.a.$showOpenDialog(I).then(A=>A?A.map(y=>n.URI.revive(y)):void 0)}showSaveDialog(I){return this.a.$showSaveDialog(I).then(A=>A?n.URI.revive(A):void 0)}}e.ExtHostDialogs=S}),define(Ie[210],Ce([1,0,11,2,7,5,15,21,10]),function(te,e,n,C,S,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(w,m,b){this.d=m,this.e=b,this.b=new Map,this.c=w.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,m){if(Object.keys(I.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const b=k.a++;this.b.set(b,m),this.c.$registerTextContentProvider(b,w);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(s=>{if(s.scheme!==w){this.e.warn(`Provider for scheme '${w}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}this.d.getDocument(s)&&this.$provideTextDocumentContent(b,s).then(o=>{if(!o&&typeof o!="string")return;const l=this.d.getDocument(s);if(!l)return;const v=(0,y.splitLines)(o);if(!l.equalLines(v))return this.c.$onVirtualDocumentChange(s,o)},n.onUnexpectedError)})),new S.Disposable(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(w,m){const b=this.b.get(w);return b?Promise.resolve(b.provideTextDocumentContent(C.URI.revive(m),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=k,k.a=0}),define(Ie[211],Ce([1,0,4,6,2,5,99,8,9,22,7]),function(te,e,n,C,S,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(b,f){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new C.DisposableStore,this.h=new Map,this.f=b.getProxy(M.MainContext.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(s=>{for(const o of s)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const o of s)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const f=this.g.getDocument(b);if(f)return f}getDocument(b){const f=this.getDocumentData(b);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return f.document}ensureDocumentData(b){const f=this.g.getDocument(b);if(f)return Promise.resolve(f);let s=this.h.get(b.toString());return s||(s=this.f.$tryOpenDocument(b).then(o=>{this.h.delete(b.toString());const l=S.URI.revive(o);return(0,y.assertIsDefined)(this.g.getDocument(l))},o=>(this.h.delete(b.toString()),Promise.reject(o))),this.h.set(b.toString(),s)),s}createDocumentData(b){return this.f.$tryCreateDocument(b).then(f=>S.URI.revive(f))}$acceptModelLanguageChanged(b,f){const s=S.URI.revive(b),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(f),this.a.fire(o.document)}$acceptModelSaved(b){const f=S.URI.revive(b),s=this.g.getDocument(f);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(b,f){const s=S.URI.revive(b),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(f),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,f,s){const o=S.URI.revive(b),l=this.g.getDocument(o);if(!l)throw new Error("unknown document");l._acceptIsDirty(s),l.onEvents(f);let v;f.isUndoing?v=O.TextDocumentChangeReason.Undo:f.isRedoing&&(v=O.TextDocumentChangeReason.Redo),this.c.fire((0,k.deepFreeze)({document:l.document,contentChanges:f.changes.map(E=>({range:A.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:v}))}setWordDefinitionFor(b,f){(0,I.setWordDefinitionFor)(b,f)}}e.ExtHostDocuments=w}),define(Ie[57],Ce([1,0,47,4,6,2,3,5,99,17,102,8,12,28,15,182,84]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class l{constructor(P){this.value=P,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let v=class{constructor(P,p){this.h=P,this.i=p,this.a=null,this.b=new Map,this.c=new b.ResourceMap,this.d=new C.Emitter,this.e=new C.Emitter,this.f=new C.Emitter,this.g=new C.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(P){this.acceptDocumentsAndEditorsDelta(P)}acceptDocumentsAndEditorsDelta(P){const p=[],r=[],d=[];if(P.removedDocuments)for(const i of P.removedDocuments){const c=M.URI.revive(i),t=this.c.get(c);t?.unref()&&(this.c.delete(c),p.push(t.value))}if(P.addedDocuments)for(const i of P.addedDocuments){const c=M.URI.revive(i.uri);let t=this.c.get(c);if(t&&c.scheme!==f.Schemas.vscodeNotebookCell&&c.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);t||(t=new l(new y.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),c,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this.c.set(c,t),r.push(t.value)),t.ref()}if(P.removedEditors)for(const i of P.removedEditors){const c=this.b.get(i);this.b.delete(i),c&&d.push(c)}if(P.addedEditors)for(const i of P.addedEditors){const c=M.URI.revive(i.documentUri);n.ok(this.c.has(c),`document '${c}' does not exist`),n.ok(!this.b.has(i.id),`editor '${i.id}' already exists!`);const t=this.c.get(c).value,h=new O.ExtHostTextEditor(i.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new o.Lazy(()=>t.document),i.selections.map(w.Selection.to),i.options,i.visibleRanges.map(a=>w.Range.to(a)),typeof i.editorPosition=="number"?w.ViewColumn.to(i.editorPosition):void 0);this.b.set(i.id,h)}P.newActiveEditor!==void 0&&(n.ok(P.newActiveEditor===null||this.b.has(P.newActiveEditor),`active editor '${P.newActiveEditor}' does not exist`),this.a=P.newActiveEditor),(0,S.dispose)(p),(0,S.dispose)(d),P.removedDocuments&&this.e.fire(p),P.addedDocuments&&this.d.fire(r),(P.removedEditors||P.addedEditors)&&this.f.fire(this.allEditors().map(i=>i.value)),P.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(P){return this.c.get(P)?.value}allDocuments(){return s.Iterable.map(this.c.values(),P=>P.value)}getEditor(P){return this.b.get(P)}activeEditor(P){if(!this.a)return;const p=this.b.get(this.a);return P?p:p?.value}allEditors(){return[...this.b.values()]}};v=qe([Ve(0,k.IExtHostRpcService),Ve(1,m.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[58],Ce([1,0,8,5,2,4,3,7,17,9,62]),function(te,e,n,C,S,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class w{constructor(o,l,v){this.e=v,this.d=l,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,l={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(l)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(S.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(S.URI.revive(this.b.input.original),S.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(S.URI.revive(this.b.input.base),S.URI.revive(this.b.input.input1),S.URI.revive(this.b.input.input2),S.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(S.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(S.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(S.URI.revive(this.b.input.original),S.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(S.URI.revive(this.b.input.uri),S.URI.revive(this.b.input.inputBoxUri));default:return}}}class m{constructor(o,l){this.c=[],this.d="",this.b=o,this.e=l;for(const v of o.tabs)v.isActive&&(this.d=v.id),this.c.push(new w(v,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,l={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return n.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(v=>v.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(v=>v.apiObject))}};this.a=Object.freeze(l)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const v=new w(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,v),o.tabDto.isActive&&(this.d=v.tabId),v}else if(o.kind===1){const v=this.c.splice(o.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return v.tabId===this.d&&(this.d=""),v}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this.c.splice(o.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,v),v}const l=this.c.find(v=>v.tabId===o.tabDto.id);if(!l)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),l.acceptDtoUpdate(o.tabDto),l}activeTabId(){return this.d}}let b=class{constructor(o){this.b=new M.Emitter,this.c=new M.Emitter,this.e=[],this.a=o.getProxy(C.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,l={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(v=>v.apiObject))},get activeTabGroup(){const v=o.d;return(0,k.assertIsDefined)(o.e.find(P=>P.groupId===v)?.apiObject)},close:async(v,E)=>{const P=Array.isArray(v)?v:[v];return P.length?f(P[0])?this.j(P,E):this.i(P,E):!0}};this.f=Object.freeze(l)}return this.f}$acceptEditorTabModel(o){const l=new Set(this.e.map(i=>i.groupId)),v=new Set(o.map(i=>i.groupId)),E=(0,O.diffSets)(l,v),P=this.e.filter(i=>E.removed.includes(i.groupId)).map(i=>i.apiObject),p=[],r=[];this.e=o.map(i=>{const c=new m(i,()=>this.d);return E.added.includes(c.groupId)?p.push(c.apiObject):r.push(c.apiObject),c});const d=(0,k.assertIsDefined)(o.find(i=>i.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:p,closed:P,changed:r}))}$acceptTabGroupUpdate(o){const l=this.e.find(v=>v.groupId===o.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const l=this.e.find(E=>E.groupId===o.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const v=l.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}g(o){for(const l of this.e)for(const v of l.tabs)if(v.apiObject===o)return v}h(o){return this.e.find(l=>l.apiObject===o)}async i(o,l){const v=[];for(const E of o){const P=this.g(E);if(!P)throw new Error("Tab close: Invalid tab not found!");v.push(P.tabId)}return this.a.$closeTab(v,l)}async j(o,l){const v=[];for(const E of o){const P=this.h(E);if(!P)throw new Error("Group close: Invalid group not found!");v.push(P.groupId)}return this.a.$closeGroup(v,l)}};b=qe([Ve(0,y.IExtHostRpcService)],b),e.ExtHostEditorTabs=b;function f(s){return s.tabs!==void 0}}),define(Ie[212],Ce([1,0,2,5,6,7,8,257,10,24,26]),function(te,e,n,C,S,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const s=this.a.indexOf(f);s>=0&&(this.a.splice(s,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),s=[];let o,l,v=14,E=14;for(const P of f){let p=o?(0,y.commonPrefixLength)(o,P):0;for(p===0?l=1:l=E;p<P.length;p++)p+1===P.length?(v=E,E=9):E+=1,s.push([l,P.toUpperCase().charCodeAt(p),E]),s.push([l,P.toLowerCase().charCodeAt(p),E]),l=E;o=P,E=v}s.push([9,58,10]),s.push([10,47,12]),this.b=new A.StateMachine(s)}}provideDocumentLinks(f){this.c();const s=[],o=A.LinkComputer.computeLinks({getLineContent(l){return f.lineAt(l-1).text},getLineCount(){return f.lineCount}},this.b);for(const l of o){const v=I.DocumentLink.to(l);v.target&&s.push(v)}return s}}class m{constructor(f,s){this.i=s,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,s,o,l={}){if(this.d.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const v=this.h++;this.b.add(s),this.d.add(s),this.c.set(v,o);let E=2;l.isCaseSensitive&&(E+=1024),l.isReadonly&&(E+=2048),typeof o.copy=="function"&&(E+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,O.checkProposedApiEnabled)(f,"fsChunks"),E+=4),this.a.$registerFileSystemProvider(v,s,E).catch(p=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${s}`),console.error(p)});const P=o.onDidChangeFile(p=>{const r=[];for(const d of p){const{uri:i,type:c}=d;if(i.scheme!==s)continue;let t;switch(c){case M.FileChangeType.Changed:t=0;break;case M.FileChangeType.Created:t=1;break;case M.FileChangeType.Deleted:t=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:i,type:t})}this.a.$onFileSystemChange(v,r)});return(0,S.toDisposable)(()=>{P.dispose(),this.b.delete(s),this.d.delete(s),this.c.delete(v),this.a.$unregisterProvider(v)})}static j(f){const{type:s,ctime:o,mtime:l,size:v,permissions:E}=f;return{type:s,ctime:o,mtime:l,size:v,permissions:E}}$stat(f,s){return Promise.resolve(this.k(f).stat(n.URI.revive(s))).then(o=>m.j(o))}$readdir(f,s){return Promise.resolve(this.k(f).readDirectory(n.URI.revive(s)))}$readFile(f,s){return Promise.resolve(this.k(f).readFile(n.URI.revive(s))).then(o=>k.VSBuffer.wrap(o))}$writeFile(f,s,o,l){return Promise.resolve(this.k(f).writeFile(n.URI.revive(s),o.buffer,l))}$delete(f,s,o){return Promise.resolve(this.k(f).delete(n.URI.revive(s),o))}$rename(f,s,o,l){return Promise.resolve(this.k(f).rename(n.URI.revive(s),n.URI.revive(o),l))}$copy(f,s,o,l){const v=this.k(f);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(n.URI.revive(s),n.URI.revive(o),l))}$mkdir(f,s){return Promise.resolve(this.k(f).createDirectory(n.URI.revive(s)))}$watch(f,s,o,l){const v=this.k(f).watch(n.URI.revive(o),l);this.f.set(s,v)}$unwatch(f,s){const o=this.f.get(s);o&&(o.dispose(),this.f.delete(s))}$open(f,s,o){const l=this.k(f);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(n.URI.revive(s),o))}$close(f,s){const o=this.k(f);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(s))}$read(f,s,o,l){const v=this.k(f);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const E=k.VSBuffer.alloc(l);return Promise.resolve(v.read(s,o,E.buffer,0,l)).then(P=>E.slice(0,P))}$write(f,s,o,l){const v=this.k(f);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(s,o,l.buffer,0,l.byteLength))}k(f){const s=this.c.get(f);if(!s){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return s}}e.ExtHostFileSystem=m}),define(Ie[59],Ce([1,0,5,36,7,24,3,17,37,6]),function(te,e,n,C,S,M,I,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Zt{constructor(m,b){this.b=new Map,this.a=m.getProxy(n.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(s){try{const o=f.b.get(s.scheme);if(!o)return await f.a.$stat(s);await f.a.$ensureActivation(s.scheme);const l=await o.stat(s);return{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions}}catch(o){Zt.c(o)}},async readDirectory(s){try{const o=f.b.get(s.scheme);return o?(await f.a.$ensureActivation(s.scheme),(await o.readDirectory(s)).slice()):await f.a.$readdir(s)}catch(o){return Zt.c(o)}},async createDirectory(s){try{return await f.a.$mkdir(s)}catch(o){return Zt.c(o)}},async readFile(s){try{const o=f.b.get(s.scheme);return o?(await f.a.$ensureActivation(s.scheme),(await o.readFile(s)).slice()):(await f.a.$readFile(s)).buffer}catch(o){return Zt.c(o)}},async writeFile(s,o){try{return await f.a.$writeFile(s,M.VSBuffer.wrap(o))}catch(l){return Zt.c(l)}},async delete(s,o){try{const l=f.b.get(s.scheme);return l?(await f.a.$ensureActivation(s.scheme),await l.delete(s,{recursive:!1,...o})):await f.a.$delete(s,{recursive:!1,useTrash:!1,...o})}catch(l){return Zt.c(l)}},async rename(s,o,l){try{return await f.a.$rename(s,o,{overwrite:!1,...l})}catch(v){return Zt.c(v)}},async copy(s,o,l){try{return await f.a.$copy(s,o,{overwrite:!1,...l})}catch(v){return Zt.c(v)}},isWritableFileSystem(s){const o=b.getCapabilities(s);if(typeof o=="number")return!(o&2048)}})}static c(m){if(m instanceof S.FileSystemError)throw m;if(!(m instanceof Error))throw new S.FileSystemError(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw S.FileSystemError.Unavailable(m.message);switch(m.name){case C.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(m.message);case C.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(m.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(m.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(m.message);case C.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(m.message);case C.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(m.message);default:throw new S.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,b){return this.b.set(m,b),(0,k.toDisposable)(()=>this.b.delete(m))}};O=qe([Ve(0,A.IExtHostRpcService),Ve(1,y.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[213],Ce([1,0,4,35,2,5,8,7]),function(te,e,n,C,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(w,m,b,f,s,o,l,v){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter;const E=this.h(w,b,s);this.g=0,o&&(this.g+=1),l&&(this.g+=2),v&&(this.g+=4);const P=(0,C.parse)(s),p=typeof s=="string",r=f(d=>{if(!o)for(const i of d.created){const c=S.URI.revive(i);P(c.fsPath)&&(!p||m.getWorkspaceFolder(c))&&this.a.fire(c)}if(!l)for(const i of d.changed){const c=S.URI.revive(i);P(c.fsPath)&&(!p||m.getWorkspaceFolder(c))&&this.b.fire(c)}if(!v)for(const i of d.deleted){const c=S.URI.revive(i);P(c.fsPath)&&(!p||m.getWorkspaceFolder(c))&&this.c.fire(c)}});this.d=A.Disposable.from(E,this.a,this.b,this.c,r)}h(w,m,b){const f=A.Disposable.from();if(typeof b=="string")return f;const s=w.getProxy(M.MainContext.MainThreadFileSystem);let o=!1;(b.pattern.includes(C.GLOBSTAR)||b.pattern.includes(C.GLOB_SPLIT))&&(o=!0);const l=Math.random();return s.$watch(m.identifier.value,l,b.baseUri,{recursive:o,excludes:[]}),A.Disposable.from({dispose:()=>s.$unwatch(l)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class k{constructor(w,m,b){this.j=w,this.k=m,this.l=b,this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.g=new n.AsyncEmitter,this.h=new n.AsyncEmitter,this.i=new n.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,m,b,f,s,o){return new y(this.j,w,m,this.a.event,I.GlobPattern.from(b),f,s,o)}$onFileEvent(w){this.a.fire(w)}$onDidRunFileOperation(w,m){switch(w){case 2:this.b.fire(Object.freeze({files:m.map(b=>({oldUri:S.URI.revive(b.source),newUri:S.URI.revive(b.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(b=>S.URI.revive(b.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(b=>S.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,m){return(b,f,s)=>{const o=function(v){b.call(f,v)};return o.extension=w,m.event(o,void 0,s)}}async $onWillRunFileOperation(w,m,b,f){switch(w){case 2:return await this.n(this.g,{files:m.map(s=>({oldUri:S.URI.revive(s.source),newUri:S.URI.revive(s.target)}))},b,f);case 1:return await this.n(this.i,{files:m.map(s=>S.URI.revive(s.target))},b,f);case 0:case 3:return await this.n(this.h,{files:m.map(s=>S.URI.revive(s.target))},b,f)}}async n(w,m,b,f){const s=new Set,o=[];if(await w.fireAsync(m,f,async(v,E)=>{const P=Date.now(),p=await Promise.resolve(v);p instanceof A.WorkspaceEdit&&(o.push([E.extension,p]),s.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-P>b&&this.k.warn("SLOW file-participant",E.extension.identifier)}),f.isCancellationRequested||o.length===0)return;const l={edits:[]};for(const[,v]of o){const{edits:E}=I.WorkspaceEdit.from(v,{getTextDocumentVersion:P=>this.l.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}});l.edits=l.edits.concat(E)}return{edit:l,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=k}),define(Ie[214],Ce([1,0,2,38]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class S{constructor(I,A,y,k,O){this.a=A,this.b=y,this.c=k;const w=new C.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new C.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new C.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new C.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new C.ApiCommandResult("Notebook and input URI",m=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const b=this.a.getEditorById(m.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:n.URI.revive(m.notebookUri),inputUri:n.URI.revive(m.inputUri),notebookEditor:b.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:n.URI.revive(m.notebookUri),inputUri:n.URI.revive(m.inputUri)}}));this.c.registerApiCommand(w)}$willAddInteractiveDocument(I,A,y,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:I,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(n.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=S}),define(Ie[215],Ce([1,0,6,5]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(I){this.b=0,this.a=I.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,I),(0,n.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=S}),define(Ie[216],Ce([1,0,2,22,8,7,75,5,10,56,18,9,258,21,6,88,83,53,77,11,16,26]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o,l,v,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class r{constructor(D,B){this.d=D,this.e=B}async provideDocumentSymbols(D,B){const W=this.d.getDocument(D),K=await this.e.provideDocumentSymbols(W,B);if(!(0,O.isFalsyOrEmpty)(K))return K[0]instanceof M.DocumentSymbol?K.map(S.DocumentSymbol.from):r.f(K)}static f(D){D=D.slice(0).sort((K,ee)=>{let he=K.location.range.start.compareTo(ee.location.range.start);return he===0&&(he=ee.location.range.end.compareTo(K.location.range.end)),he});const B=[],W=[];for(const K of D){const ee={name:K.name||"!!MISSING: name!!",kind:S.SymbolKind.from(K.kind),tags:K.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:S.Range.from(K.location.range),selectionRange:S.Range.from(K.location.range),children:[]};for(;;){if(W.length===0){W.push(ee),B.push(ee);break}const he=W[W.length-1];if(k.Range.containsRange(he.range,ee.range)&&!k.Range.equalsRange(he.range,ee.range)){he.children?.push(ee),W.push(ee);break}W.pop()}}return B}}class d{constructor(D,B,W){this.g=D,this.h=B,this.j=W,this.e=new l.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(D,B){const W=this.g.getDocument(D),K=await this.j.provideCodeLenses(W,B);if(!K||B.isCancellationRequested)return;const ee=this.e.add(K),he=new f.DisposableStore;this.f.set(ee,he);const ye={cacheId:ee,lenses:[]};for(let ae=0;ae<K.length;ae++)ye.lenses.push({cacheId:[ee,ae],range:S.Range.from(K[ae].range),command:this.h.toInternal(K[ae].command,he)});return ye}async resolveCodeLens(D,B){const W=D.cacheId&&this.e.get(...D.cacheId);if(!W)return;let K;if(typeof this.j.resolveCodeLens!="function"||W.isResolved?K=W:K=await this.j.resolveCodeLens(W,B),K||(K=W),B.isCancellationRequested)return;const ee=D.cacheId&&this.f.get(D.cacheId[0]);if(!!ee)return D.command=this.h.toInternal(K.command??d.d,ee),D}releaseCodeLenses(D){this.f.get(D)?.dispose(),this.f.delete(D),this.e.delete(D)}}d.d={command:"missing",title:"!!MISSING: command!!"};function i(J){return Array.isArray(J)?J.map(S.DefinitionLink.from):J?[S.DefinitionLink.from(J)]:[]}class c{constructor(D,B){this.d=D,this.e=B}async provideDefinition(D,B,W){const K=this.d.getDocument(D),ee=S.Position.to(B),he=await this.e.provideDefinition(K,ee,W);return i(he)}}class t{constructor(D,B){this.d=D,this.e=B}async provideDeclaration(D,B,W){const K=this.d.getDocument(D),ee=S.Position.to(B),he=await this.e.provideDeclaration(K,ee,W);return i(he)}}class h{constructor(D,B){this.d=D,this.e=B}async provideImplementation(D,B,W){const K=this.d.getDocument(D),ee=S.Position.to(B),he=await this.e.provideImplementation(K,ee,W);return i(he)}}class a{constructor(D,B){this.d=D,this.e=B}async provideTypeDefinition(D,B,W){const K=this.d.getDocument(D),ee=S.Position.to(B),he=await this.e.provideTypeDefinition(K,ee,W);return i(he)}}class u{constructor(D,B){this.d=D,this.e=B}async provideHover(D,B,W){const K=this.d.getDocument(D),ee=S.Position.to(B),he=await this.e.provideHover(K,ee,W);if(!(!he||(0,O.isFalsyOrEmpty)(he.contents)))return he.range||(he.range=K.getWordRangeAtPosition(ee)),he.range||(he.range=new M.Range(ee,ee)),S.Hover.from(he)}}class g{constructor(D,B){this.d=D,this.e=B}async provideEvaluatableExpression(D,B,W){const K=this.d.getDocument(D),ee=S.Position.to(B),he=await this.e.provideEvaluatableExpression(K,ee,W);if(he)return S.EvaluatableExpression.from(he)}}class R{constructor(D,B){this.d=D,this.e=B}async provideInlineValues(D,B,W,K){const ee=this.d.getDocument(D),he=await this.e.provideInlineValues(ee,S.Range.to(B),S.InlineValueContext.to(W),K);if(Array.isArray(he))return he.map(ye=>S.InlineValue.from(ye))}}class F{constructor(D,B){this.d=D,this.e=B}async provideDocumentHighlights(D,B,W){const K=this.d.getDocument(D),ee=S.Position.to(B),he=await this.e.provideDocumentHighlights(K,ee,W);if(Array.isArray(he))return he.map(S.DocumentHighlight.from)}}class q{constructor(D,B){this.d=D,this.e=B}async provideLinkedEditingRanges(D,B,W){const K=this.d.getDocument(D),ee=S.Position.to(B),he=await this.e.provideLinkedEditingRanges(K,ee,W);if(he&&Array.isArray(he.ranges))return{ranges:(0,O.coalesce)(he.ranges.map(S.Range.from)),wordPattern:he.wordPattern}}}class Z{constructor(D,B){this.d=D,this.e=B}async provideReferences(D,B,W,K){const ee=this.d.getDocument(D),he=S.Position.to(B),ye=await this.e.provideReferences(ee,he,W,K);if(Array.isArray(ye))return ye.map(S.location.from)}}class x{constructor(D,B,W,K,ee,he,ye){this.g=D,this.h=B,this.j=W,this.k=K,this.l=ee,this.m=he,this.n=ye,this.e=new l.Cache("CodeAction"),this.f=new Map}async provideCodeActions(D,B,W,K){const ee=this.g.getDocument(D),he=m.Selection.isISelection(B)?S.Selection.to(B):S.Range.to(B),ye=[];for(const tt of this.j.getDiagnostics(D))if(he.intersection(tt.range)&&ye.push(tt)>x.d)break;const ae={diagnostics:ye,only:W.only?new M.CodeActionKind(W.only):void 0,triggerKind:S.CodeActionTriggerKind.to(W.trigger)},be=await this.k.provideCodeActions(ee,he,ae,K);if(!(0,O.isNonEmptyArray)(be)||K.isCancellationRequested)return;const Ee=this.e.add(be),We=new f.DisposableStore;this.f.set(Ee,We);const He=[];for(let tt=0;tt<be.length;tt++){const Xe=be[tt];!Xe||(x.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,We)})):(ae.only&&(Xe.kind?ae.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[Ee,tt],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,We),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(S.Diagnostic.from),edit:Xe.edit&&S.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:Ee,actions:He}}async resolveCodeAction(D,B){const[W,K]=D,ee=this.e.get(W,K);if(!ee||x.o(ee)||!this.k.resolveCodeAction)return;const he=await this.k.resolveCodeAction(ee,B)??ee;return he?.edit?S.WorkspaceEdit.from(he.edit,void 0):void 0}releaseCodeActions(D){this.f.get(D)?.dispose(),this.f.delete(D),this.e.delete(D)}static o(D){return typeof D.command=="string"&&typeof D.title=="string"}}x.d=1e3;class N{constructor(D,B,W,K){this.d=D,this.e=B,this.f=W,this.g=K}async prepareDocumentPaste(D,B,W,K){if(!this.f.prepareDocumentPaste)return;const ee=this.e.getDocument(D),he=B.map(ae=>S.Range.to(ae)),ye=S.DataTransfer.toDataTransfer(W,()=>{throw new E.NotImplementedError});return await this.f.prepareDocumentPaste(ee,he,ye,K),S.DataTransfer.toDataTransferDTO(ye)}async providePasteEdits(D,B,W,K,ee){const he=this.e.getDocument(B),ye=W.map(Ee=>S.Range.to(Ee)),ae=S.DataTransfer.toDataTransfer(K,async Ee=>(await this.d.$resolvePasteFileData(this.g,D,Ee)).buffer),be=await this.f.provideDocumentPasteEdits(he,ye,ae,ee);if(!!be)return{insertText:typeof be.insertText=="string"?be.insertText:{snippet:be.insertText.value},additionalEdit:be.additionalEdit?S.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}}class ${constructor(D,B){this.d=D,this.e=B}async provideDocumentFormattingEdits(D,B,W){const K=this.d.getDocument(D),ee=await this.e.provideDocumentFormattingEdits(K,B,W);if(Array.isArray(ee))return ee.map(S.TextEdit.from)}}class T{constructor(D,B){this.d=D,this.e=B}async provideDocumentRangeFormattingEdits(D,B,W,K){const ee=this.d.getDocument(D),he=S.Range.to(B),ye=await this.e.provideDocumentRangeFormattingEdits(ee,he,W,K);if(Array.isArray(ye))return ye.map(S.TextEdit.from)}}class L{constructor(D,B){this.d=D,this.e=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(D,B,W,K,ee){const he=this.d.getDocument(D),ye=S.Position.to(B),ae=await this.e.provideOnTypeFormattingEdits(he,ye,W,K,ee);if(Array.isArray(ae))return ae.map(S.TextEdit.from)}}class V{constructor(D,B){this.e=D,this.f=B,this.d=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(D,B){const W=await this.e.provideWorkspaceSymbols(D,B);if(!(0,O.isNonEmptyArray)(W))return{symbols:[]};const K=this.d.add(W),ee={cacheId:K,symbols:[]};for(let he=0;he<W.length;he++){const ye=W[he];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}ee.symbols.push({...S.WorkspaceSymbol.from(ye),cacheId:[K,he]})}return ee}async resolveWorkspaceSymbol(D,B){if(typeof this.e.resolveWorkspaceSymbol!="function"||!D.cacheId)return D;const W=this.d.get(...D.cacheId);if(W){const K=await this.e.resolveWorkspaceSymbol(W,B);return K&&(0,C.mixin)(D,S.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(D){this.d.delete(D)}}class j{static supportsResolving(D){return typeof D.prepareRename=="function"}constructor(D,B,W){this.d=D,this.e=B,this.f=W}async provideRenameEdits(D,B,W,K){const ee=this.d.getDocument(D),he=S.Position.to(B);try{const ye=await this.e.provideRenameEdits(ee,he,W,K);return ye?S.WorkspaceEdit.from(ye):void 0}catch(ye){const ae=j.g(ye);return ae?{rejectReason:ae,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(D,B,W){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const K=this.d.getDocument(D),ee=S.Position.to(B);try{const he=await this.e.prepareRename(K,ee,W);let ye,ae;if(M.Range.isRange(he)?(ye=he,ae=K.getText(he)):(0,w.isObject)(he)&&(ye=he.range,ae=he.placeholder),!ye||!ae)return;if(ye.start.line>ee.line||ye.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(ye),text:ae}}catch(he){const ye=j.g(he);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(he)}}static g(D){return typeof D=="string"?D:D instanceof Error&&typeof D.message=="string"?D.message:void 0}}class le{constructor(D,B){this.resultId=D,this.tokens=B}}class Y{constructor(D,B){this.f=D,this.g=B,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(D,B,W){const K=this.f.getDocument(D),ee=B!==0?this.d.get(B):null;let he=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(K,ee.resultId,W):await this.g.provideDocumentSemanticTokens(K,W);return ee&&this.d.delete(B),he?(he=Y.h(he),this.o(Y.n(ee,he),he)):null}async releaseDocumentSemanticColoring(D){this.d.delete(D)}static h(D){return Y.j(D)?Y.k(D)?D:new M.SemanticTokens(new Uint32Array(D.data),D.resultId):Y.l(D)?Y.m(D)?D:new M.SemanticTokensEdits(D.edits.map(B=>new M.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),D.resultId):D}static j(D){return D&&!!D.data}static k(D){return D.data instanceof Uint32Array}static l(D){return D&&Array.isArray(D.edits)}static m(D){for(const B of D.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static n(D,B){if(!Y.j(B)||!D||!D.tokens)return B;const W=D.tokens,K=W.length,ee=B.data,he=ee.length;let ye=0;const ae=Math.min(K,he);for(;ye<ae&&W[ye]===ee[ye];)ye++;if(ye===K&&ye===he)return new M.SemanticTokensEdits([],B.resultId);let be=0;const Ee=ae-ye;for(;be<Ee&&W[K-be-1]===ee[he-be-1];)be++;return new M.SemanticTokensEdits([{start:ye,deleteCount:K-ye-be,data:ee.subarray(ye,he-be)}],B.resultId)}o(D,B){if(Y.j(D)){const W=this.e++;return this.d.set(W,new le(D.resultId,D.data)),(0,s.encodeSemanticTokensDto)({id:W,type:"full",data:D.data})}if(Y.l(D)){const W=this.e++;return Y.j(B)?this.d.set(W,new le(B.resultId,B.data)):this.d.set(W,new le(D.resultId)),(0,s.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(D.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class pe{constructor(D,B){this.d=D,this.e=B}async provideDocumentRangeSemanticTokens(D,B,W){const K=this.d.getDocument(D),ee=await this.e.provideDocumentRangeSemanticTokens(K,S.Range.to(B),W);return ee?this.f(ee):null}f(D){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:D.data})}}class ue{static supportsResolving(D){return typeof D.resolveCompletionItem=="function"}constructor(D,B,W,K,ee){this.f=D,this.g=B,this.h=W,this.j=K,this.k=ee,this.d=new l.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(D,B,W,K){const ee=this.f.getDocument(D),he=S.Position.to(B),ye=ee.getWordRangeAtPosition(he)||new M.Range(he,he),ae=ye.with({end:he}),be=new v.StopWatch(!0),Ee=await this.h.provideCompletionItems(ee,he,K,S.CompletionContext.to(W));if(!Ee||K.isCancellationRequested)return;const We=Array.isArray(Ee)?new M.CompletionList(Ee):Ee,He=ue.supportsResolving(this.h)?this.d.add(We.items):this.d.add([]),tt=new f.DisposableStore;this.e.set(He,tt);const Xe=[],et={x:He,b:Xe,a:{replace:S.Range.from(ye),insert:S.Range.from(ae)},c:We.isIncomplete||void 0,d:be.elapsed()};for(let it=0;it<We.items.length;it++){const dt=We.items[it],Fe=this.l(dt,[He,it],ae,ye);Xe.push(Fe)}return et}async resolveCompletionItem(D,B){if(typeof this.h.resolveCompletionItem!="function")return;const W=this.d.get(...D);if(!W)return;const K=await this.h.resolveCompletionItem(W,B);if(!!K)return this.l(K,D)}releaseCompletionItems(D){this.e.get(D)?.dispose(),this.e.delete(D),this.d.delete(D)}l(D,B,W,K){const ee=this.e.get(B[0]);if(!ee)throw Error("DisposableStore is missing...");const he=this.g.toInternal(D.command,ee),ye={x:B,a:D.label,b:D.kind!==void 0?S.CompletionItemKind.from(D.kind):void 0,m:D.tags&&D.tags.map(S.CompletionItemTag.from),c:D.detail,d:typeof D.documentation>"u"?void 0:S.MarkdownString.fromStrict(D.documentation),e:D.sortText!==D.label?D.sortText:void 0,f:D.filterText!==D.label?D.filterText:void 0,g:D.preselect||void 0,i:D.keepWhitespace?1:0,k:D.commitCharacters?.join(""),l:D.additionalTextEdits&&D.additionalTextEdits.map(S.TextEdit.from),n:he?.$ident,o:he?.id,p:he?.$ident?void 0:he?.arguments};D.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=D.textEdit.newText):typeof D.insertText=="string"?ye.h=D.insertText:D.insertText instanceof M.SnippetString&&(ye.h=D.insertText.value,ye.i|=4);let ae;return D.textEdit?ae=D.textEdit.range:D.range&&(ae=D.range),M.Range.isRange(ae)?ye.j=S.Range.from(ae):ae&&(!W?.isEqual(ae.inserting)||!K?.isEqual(ae.replacing))&&(ye.j={insert:S.Range.from(ae.inserting),replace:S.Range.from(ae.replacing)}),ye}}class de{async provideInlineCompletions(D,B,W,K){}disposeCompletions(D){}handleDidShowCompletionItem(D,B){}}class re extends de{constructor(D,B,W,K){super(),this.f=D,this.g=B,this.h=W,this.j=K,this.d=new G,this.e=(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[I.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[I.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(D,B,W,K){const ee=this.g.getDocument(D),he=S.Position.to(B),ye=await this.h.provideInlineCompletionItems(ee,he,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:S.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[W.triggerKind]},K);if(!ye||K.isCancellationRequested)return;const ae=Array.isArray(ye)?ye:ye.items,be=this.e?Array.isArray(ye)?[]:ye.commands||[]:[];let Ee;return{pid:this.d.createReferenceId({dispose(){Ee?.dispose()},items:ae}),items:ae.map((He,tt)=>{let Xe;He.command&&(Ee||(Ee=new f.DisposableStore),Xe=this.j.toInternal(He.command,Ee));const et=He.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:He.filterText,range:He.range?S.Range.from(He.range):void 0,command:Xe,idx:tt,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:be.map(He=>(Ee||(Ee=new f.DisposableStore),this.j.toInternal(He,Ee)))}}disposeCompletions(D){this.d.disposeReferenceId(D)?.dispose()}handleDidShowCompletionItem(D,B){const W=this.d.get(D)?.items[B];W&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(W)}}class G{constructor(){this.d=new Map,this.e=1}createReferenceId(D){const B=this.e++;return this.d.set(B,D),B}disposeReferenceId(D){const B=this.d.get(D);return this.d.delete(D),B}get(D){return this.d.get(D)}}class H{constructor(D,B){this.e=D,this.f=B,this.d=new l.Cache("SignatureHelp")}async provideSignatureHelp(D,B,W,K){const ee=this.e.getDocument(D),he=S.Position.to(B),ye=this.g(W),ae=await this.f.provideSignatureHelp(ee,he,K,ye);if(ae){const be=this.d.add([ae]);return{...S.SignatureHelp.from(ae),id:be}}}g(D){let B;if(D.activeSignatureHelp){const W=S.SignatureHelp.to(D.activeSignatureHelp),K=this.d.get(D.activeSignatureHelp.id,0);K?(B=K,B.activeSignature=W.activeSignature,B.activeParameter=W.activeParameter):B=W}return{...D,activeSignatureHelp:B}}releaseSignatureHelp(D){this.d.delete(D)}}class oe{constructor(D,B,W,K,ee){this.f=D,this.g=B,this.h=W,this.j=K,this.k=ee,this.d=new l.Cache("InlayHints"),this.e=new Map}async provideInlayHints(D,B,W){const K=this.f.getDocument(D),ee=S.Range.to(B),he=await this.h.provideInlayHints(K,ee,W);if(!Array.isArray(he)||he.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${B}`);return}if(W.isCancellationRequested)return;const ye=this.d.add(he);this.e.set(ye,new f.DisposableStore);const ae={hints:[],cacheId:ye};for(let be=0;be<he.length;be++)this.l(he[be],ee)&&ae.hints.push(this.m(he[be],[ye,be]));return this.j.trace(`[InlayHints] ${ae.hints.length} inlay hints from '${this.k.identifier.value}' for ${B}`),ae}async resolveInlayHint(D,B){if(typeof this.h.resolveInlayHint!="function")return;const W=this.d.get(...D);if(!W)return;const K=await this.h.resolveInlayHint(W,B);if(!!K&&!!this.l(K))return this.m(K,D)}releaseHints(D){this.e.get(D)?.dispose(),this.e.delete(D),this.d.delete(D)}l(D,B){return D.label.length===0||Array.isArray(D.label)&&D.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",D),!1):!(B&&!B.contains(D.position))}m(D,B){const W=this.e.get(B[0]);if(!W)throw Error("DisposableStore is missing...");const K={label:"",cacheId:B,tooltip:S.MarkdownString.fromStrict(D.tooltip),position:S.Position.from(D.position),textEdits:D.textEdits&&D.textEdits.map(S.TextEdit.from),kind:D.kind&&S.InlayHintKind.from(D.kind),paddingLeft:D.paddingLeft,paddingRight:D.paddingRight};return typeof D.label=="string"?K.label=D.label:K.label=D.label.map(ee=>{const he={label:ee.value};return he.tooltip=S.MarkdownString.fromStrict(ee.tooltip),M.Location.isLocation(ee.location)&&(he.location=S.location.from(ee.location)),ee.command&&(he.command=this.g.toInternal(ee.command,W)),he}),K}}class ve{constructor(D,B){this.e=D,this.f=B,this.d=new l.Cache("DocumentLink")}async provideLinks(D,B){const W=this.e.getDocument(D),K=await this.f.provideDocumentLinks(W,B);if(!(!Array.isArray(K)||K.length===0)&&!B.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:K.filter(ve.g).map(S.DocumentLink.from)};{const ee=this.d.add(K),he={links:[],cacheId:ee};for(let ye=0;ye<K.length;ye++){if(!ve.g(K[ye]))continue;const ae=S.DocumentLink.from(K[ye]);ae.cacheId=[ee,ye],he.links.push(ae)}return he}}}static g(D){return D.target&&D.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(D,B){if(typeof this.f.resolveDocumentLink!="function")return;const W=this.d.get(...D);if(!W)return;const K=await this.f.resolveDocumentLink(W,B);if(!(!K||!ve.g(K)))return S.DocumentLink.from(K)}releaseLinks(D){this.d.delete(D)}}class Ae{constructor(D,B){this.d=D,this.e=B}async provideColors(D,B){const W=this.d.getDocument(D),K=await this.e.provideDocumentColors(W,B);return Array.isArray(K)?K.map(he=>({color:S.Color.from(he.color),range:S.Range.from(he.range)})):[]}async provideColorPresentations(D,B,W){const K=this.d.getDocument(D),ee=S.Range.to(B.range),he=S.Color.to(B.color),ye=await this.e.provideColorPresentations(he,{document:K,range:ee},W);if(!!Array.isArray(ye))return ye.map(S.ColorPresentation.from)}}class Be{constructor(D,B){this.d=D,this.e=B}async provideFoldingRanges(D,B,W){const K=this.d.getDocument(D),ee=await this.e.provideFoldingRanges(K,B,W);if(!!Array.isArray(ee))return ee.map(S.FoldingRange.from)}}class xe{constructor(D,B,W){this.d=D,this.e=B,this.f=W}async provideSelectionRanges(D,B,W){const K=this.d.getDocument(D),ee=B.map(S.Position.to),he=await this.e.provideSelectionRanges(K,ee,W);if(!(0,O.isNonEmptyArray)(he))return[];if(he.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let ae=0;ae<ee.length;ae++){const be=[];ye.push(be);let Ee=ee[ae],We=he[ae];for(;;){if(!We.range.contains(Ee))throw new Error("INVALID selection range, must contain the previous range");if(be.push(S.SelectionRange.from(We)),!We.parent)break;Ee=We.range,We=We.parent}}return ye}}class Te{constructor(D,B){this.f=D,this.g=B,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(D,B,W){const K=this.f.getDocument(D),ee=S.Position.to(B),he=await this.g.prepareCallHierarchy(K,ee,W);if(!he)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(he)?he.map(ae=>this.h(ye,ae)):[this.h(ye,he)]}async provideCallsTo(D,B,W){const K=this.j(D,B);if(!K)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(K,W);if(!!ee)return ee.map(he=>({from:this.h(D,he.from),fromRanges:he.fromRanges.map(ye=>S.Range.from(ye))}))}async provideCallsFrom(D,B,W){const K=this.j(D,B);if(!K)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(K,W);if(!!ee)return ee.map(he=>({to:this.h(D,he.to),fromRanges:he.fromRanges.map(ye=>S.Range.from(ye))}))}releaseSession(D){this.e.delete(D)}h(D,B){const W=this.e.get(D),K=S.CallHierarchyItem.from(B,D,W.size.toString(36));return W.set(K._itemId,B),K}j(D,B){return this.e.get(D)?.get(B)}}class Se{constructor(D,B){this.f=D,this.g=B,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(D,B,W){const K=this.f.getDocument(D),ee=S.Position.to(B),he=await this.g.prepareTypeHierarchy(K,ee,W);if(!he)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(he)?he.map(ae=>this.h(ye,ae)):[this.h(ye,he)]}async provideSupertypes(D,B,W){const K=this.j(D,B);if(!K)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(K,W);if(!!ee)return ee.map(he=>this.h(D,he))}async provideSubtypes(D,B,W){const K=this.j(D,B);if(!K)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(K,W);if(!!ee)return ee.map(he=>this.h(D,he))}releaseSession(D){this.e.delete(D)}h(D,B){const W=this.e.get(D),K=S.TypeHierarchyItem.from(B,D,W.size.toString(36));return W.set(K._itemId,B),K}j(D,B){return this.e.get(D)?.get(B)}}class ke{constructor(D,B,W,K){this.d=D,this.e=B,this.f=W,this.g=K}async provideDocumentOnDropEdits(D,B,W,K,ee){const he=this.e.getDocument(B),ye=S.Position.to(W),ae=S.DataTransfer.toDataTransfer(K,async Ee=>(await this.d.$resolveDocumentOnDropFileData(this.g,D,Ee)).buffer),be=await this.f.provideDocumentDropEdits(he,ye,ae,ee);if(!!be)return{insertText:typeof be.insertText=="string"?be.insertText:{snippet:be.insertText.value},additionalEdit:be.additionalEdit?S.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}}class se{constructor(D,B){this.adapter=D,this.extension=B}}class ce{constructor(D,B,W,K,ee,he,ye,ae){this.g=B,this.h=W,this.j=K,this.k=ee,this.l=he,this.m=ye,this.n=ae,this.f=new Map,this.e=D.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(D){return S.DocumentSelector.from(D,this.g)}p(D){return new M.Disposable(()=>{this.f.delete(D),this.e.$unregister(D)})}q(){return ce.d++}async s(D,B,W,K,ee,he=!1){const ye=this.f.get(D);if(!ye||!(ye.adapter instanceof B))return K;const ae=Date.now();he||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const be=W(ye.adapter,ye.extension);return Promise.resolve(be).catch(Ee=>{(0,E.isCancellationError)(Ee)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(Ee),this.n.onExtensionError(ye.extension.identifier,Ee))}).finally(()=>{he||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-ae}ms`)}),b.CancellationToken.isCancellationToken(ee)?(0,P.raceCancellationError)(be,ee):be}t(D,B){const W=this.q();return this.f.set(W,new se(D,B)),W}static u(D){return D.displayName||D.name}registerDocumentSymbolProvider(D,B,W,K){const ee=this.t(new r(this.h,W),D),he=K&&K.label||ce.u(D);return this.e.$registerDocumentSymbolProvider(ee,this.o(B),he),this.p(ee)}$provideDocumentSymbols(D,B,W){return this.s(D,r,K=>K.provideDocumentSymbols(n.URI.revive(B),W),void 0,W)}registerCodeLensProvider(D,B,W){const K=this.q(),ee=typeof W.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(K,new se(new d(this.h,this.j.converter,W),D)),this.e.$registerCodeLensSupport(K,this.o(B),ee);let he=this.p(K);if(ee!==void 0){const ye=W.onDidChangeCodeLenses(ae=>this.e.$emitCodeLensEvent(ee));he=M.Disposable.from(he,ye)}return he}$provideCodeLenses(D,B,W){return this.s(D,d,K=>K.provideCodeLenses(n.URI.revive(B),W),void 0,W)}$resolveCodeLens(D,B,W){return this.s(D,d,K=>K.resolveCodeLens(B,W),void 0,void 0)}$releaseCodeLenses(D,B){this.s(D,d,W=>Promise.resolve(W.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(D,B,W){const K=this.t(new c(this.h,W),D);return this.e.$registerDefinitionSupport(K,this.o(B)),this.p(K)}$provideDefinition(D,B,W,K){return this.s(D,c,ee=>ee.provideDefinition(n.URI.revive(B),W,K),[],K)}registerDeclarationProvider(D,B,W){const K=this.t(new t(this.h,W),D);return this.e.$registerDeclarationSupport(K,this.o(B)),this.p(K)}$provideDeclaration(D,B,W,K){return this.s(D,t,ee=>ee.provideDeclaration(n.URI.revive(B),W,K),[],K)}registerImplementationProvider(D,B,W){const K=this.t(new h(this.h,W),D);return this.e.$registerImplementationSupport(K,this.o(B)),this.p(K)}$provideImplementation(D,B,W,K){return this.s(D,h,ee=>ee.provideImplementation(n.URI.revive(B),W,K),[],K)}registerTypeDefinitionProvider(D,B,W){const K=this.t(new a(this.h,W),D);return this.e.$registerTypeDefinitionSupport(K,this.o(B)),this.p(K)}$provideTypeDefinition(D,B,W,K){return this.s(D,a,ee=>ee.provideTypeDefinition(n.URI.revive(B),W,K),[],K)}registerHoverProvider(D,B,W,K){const ee=this.t(new u(this.h,W),D);return this.e.$registerHoverProvider(ee,this.o(B)),this.p(ee)}$provideHover(D,B,W,K){return this.s(D,u,ee=>ee.provideHover(n.URI.revive(B),W,K),void 0,K)}registerEvaluatableExpressionProvider(D,B,W,K){const ee=this.t(new g(this.h,W),D);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(B)),this.p(ee)}$provideEvaluatableExpression(D,B,W,K){return this.s(D,g,ee=>ee.provideEvaluatableExpression(n.URI.revive(B),W,K),void 0,K)}registerInlineValuesProvider(D,B,W,K){const ee=typeof W.onDidChangeInlineValues=="function"?this.q():void 0,he=this.t(new R(this.h,W),D);this.e.$registerInlineValuesProvider(he,this.o(B),ee);let ye=this.p(he);if(ee!==void 0){const ae=W.onDidChangeInlineValues(be=>this.e.$emitInlineValuesEvent(ee));ye=M.Disposable.from(ye,ae)}return ye}$provideInlineValues(D,B,W,K,ee){return this.s(D,R,he=>he.provideInlineValues(n.URI.revive(B),W,K,ee),void 0,ee)}registerDocumentHighlightProvider(D,B,W){const K=this.t(new F(this.h,W),D);return this.e.$registerDocumentHighlightProvider(K,this.o(B)),this.p(K)}$provideDocumentHighlights(D,B,W,K){return this.s(D,F,ee=>ee.provideDocumentHighlights(n.URI.revive(B),W,K),void 0,K)}registerLinkedEditingRangeProvider(D,B,W){const K=this.t(new q(this.h,W),D);return this.e.$registerLinkedEditingRangeProvider(K,this.o(B)),this.p(K)}$provideLinkedEditingRanges(D,B,W,K){return this.s(D,q,async ee=>{const he=await ee.provideLinkedEditingRanges(n.URI.revive(B),W,K);if(he)return{ranges:he.ranges,wordPattern:he.wordPattern?ce.w(he.wordPattern):void 0}},void 0,K)}registerReferenceProvider(D,B,W){const K=this.t(new Z(this.h,W),D);return this.e.$registerReferenceSupport(K,this.o(B)),this.p(K)}$provideReferences(D,B,W,K,ee){return this.s(D,Z,he=>he.provideReferences(n.URI.revive(B),W,K,ee),void 0,ee)}registerCodeActionProvider(D,B,W,K){const ee=new f.DisposableStore,he=this.t(new x(this.h,this.j.converter,this.k,W,this.l,D,this.m),D);return this.e.$registerQuickFixSupport(he,this.o(B),{providedKinds:K?.providedCodeActionKinds?.map(ye=>ye.value),documentation:K?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,ee)}))},ce.u(D),Boolean(W.resolveCodeAction)),ee.add(this.p(he)),ee}$provideCodeActions(D,B,W,K,ee){return this.s(D,x,he=>he.provideCodeActions(n.URI.revive(B),W,K,ee),void 0,ee)}$resolveCodeAction(D,B,W){return this.s(D,x,K=>K.resolveCodeAction(B,W),void 0,void 0)}$releaseCodeActions(D,B){this.s(D,x,W=>Promise.resolve(W.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(D,B,W){const K=this.t(new $(this.h,W),D);return this.e.$registerDocumentFormattingSupport(K,this.o(B),D.identifier,D.displayName||D.name),this.p(K)}$provideDocumentFormattingEdits(D,B,W,K){return this.s(D,$,ee=>ee.provideDocumentFormattingEdits(n.URI.revive(B),W,K),void 0,K)}registerDocumentRangeFormattingEditProvider(D,B,W){const K=this.t(new T(this.h,W),D);return this.e.$registerRangeFormattingSupport(K,this.o(B),D.identifier,D.displayName||D.name),this.p(K)}$provideDocumentRangeFormattingEdits(D,B,W,K,ee){return this.s(D,T,he=>he.provideDocumentRangeFormattingEdits(n.URI.revive(B),W,K,ee),void 0,ee)}registerOnTypeFormattingEditProvider(D,B,W,K){const ee=this.t(new L(this.h,W),D);return this.e.$registerOnTypeFormattingSupport(ee,this.o(B),K,D.identifier),this.p(ee)}$provideOnTypeFormattingEdits(D,B,W,K,ee,he){return this.s(D,L,ye=>ye.provideOnTypeFormattingEdits(n.URI.revive(B),W,K,ee,he),void 0,he)}registerWorkspaceSymbolProvider(D,B){const W=this.t(new V(B,this.l),D);return this.e.$registerNavigateTypeSupport(W,typeof B.resolveWorkspaceSymbol=="function"),this.p(W)}$provideWorkspaceSymbols(D,B,W){return this.s(D,V,K=>K.provideWorkspaceSymbols(B,W),{symbols:[]},W)}$resolveWorkspaceSymbol(D,B,W){return this.s(D,V,K=>K.resolveWorkspaceSymbol(B,W),void 0,void 0)}$releaseWorkspaceSymbols(D,B){this.s(D,V,W=>W.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(D,B,W){const K=this.t(new j(this.h,W,this.l),D);return this.e.$registerRenameSupport(K,this.o(B),j.supportsResolving(W)),this.p(K)}$provideRenameEdits(D,B,W,K,ee){return this.s(D,j,he=>he.provideRenameEdits(n.URI.revive(B),W,K,ee),void 0,ee)}$resolveRenameLocation(D,B,W,K){return this.s(D,j,ee=>ee.resolveRenameLocation(n.URI.revive(B),W,K),void 0,K)}registerDocumentSemanticTokensProvider(D,B,W,K){const ee=this.t(new Y(this.h,W),D),he=typeof W.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(B),K,he);let ye=this.p(ee);if(he){const ae=W.onDidChangeSemanticTokens(be=>this.e.$emitDocumentSemanticTokensEvent(he));ye=M.Disposable.from(ye,ae)}return ye}$provideDocumentSemanticTokens(D,B,W,K){return this.s(D,Y,ee=>ee.provideDocumentSemanticTokens(n.URI.revive(B),W,K),null,K)}$releaseDocumentSemanticTokens(D,B){this.s(D,Y,W=>W.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(D,B,W,K){const ee=this.t(new pe(this.h,W),D);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(B),K),this.p(ee)}$provideDocumentRangeSemanticTokens(D,B,W,K){return this.s(D,pe,ee=>ee.provideDocumentRangeSemanticTokens(n.URI.revive(B),W,K),null,K)}registerCompletionItemProvider(D,B,W,K){const ee=this.t(new ue(this.h,this.j.converter,W,this.m,D),D);return this.e.$registerCompletionsProvider(ee,this.o(B),K,ue.supportsResolving(W),`${D.identifier.value}(${K.join("")})`),this.p(ee)}$provideCompletionItems(D,B,W,K,ee){return this.s(D,ue,he=>he.provideCompletionItems(n.URI.revive(B),W,K,ee),void 0,ee)}$resolveCompletionItem(D,B,W){return this.s(D,ue,K=>K.resolveCompletionItem(B,W),void 0,W)}$releaseCompletionItems(D,B){this.s(D,ue,W=>W.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(D,B,W){const K=new re(D,this.h,W,this.j.converter),ee=this.t(K,D);return this.e.$registerInlineCompletionsSupport(ee,this.o(B),K.supportsHandleDidShowCompletionItem),this.p(ee)}$provideInlineCompletions(D,B,W,K,ee){return this.s(D,de,he=>he.provideInlineCompletions(n.URI.revive(B),W,K,ee),void 0,ee)}$handleInlineCompletionDidShow(D,B,W){this.s(D,de,async K=>{K.handleDidShowCompletionItem(B,W)},void 0,void 0)}$freeInlineCompletionsList(D,B){this.s(D,de,async W=>{W.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(D,B,W,K){const ee=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,he=this.t(new H(this.h,W),D);return this.e.$registerSignatureHelpProvider(he,this.o(B),ee),this.p(he)}$provideSignatureHelp(D,B,W,K,ee){return this.s(D,H,he=>he.provideSignatureHelp(n.URI.revive(B),W,K,ee),void 0,ee)}$releaseSignatureHelp(D,B){this.s(D,H,W=>W.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(D,B,W){const K=typeof W.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new oe(this.h,this.j.converter,W,this.l,D),D);this.e.$registerInlayHintsProvider(ee,this.o(B),typeof W.resolveInlayHint=="function",K,ce.u(D));let he=this.p(ee);if(K!==void 0){const ye=W.onDidChangeInlayHints(ae=>this.e.$emitInlayHintsEvent(K));he=M.Disposable.from(he,ye)}return he}$provideInlayHints(D,B,W,K){return this.s(D,oe,ee=>ee.provideInlayHints(n.URI.revive(B),W,K),void 0,K)}$resolveInlayHint(D,B,W){return this.s(D,oe,K=>K.resolveInlayHint(B,W),void 0,W)}$releaseInlayHints(D,B){this.s(D,oe,W=>W.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(D,B,W){const K=this.t(new ve(this.h,W),D);return this.e.$registerDocumentLinkProvider(K,this.o(B),typeof W.resolveDocumentLink=="function"),this.p(K)}$provideDocumentLinks(D,B,W){return this.s(D,ve,K=>K.provideLinks(n.URI.revive(B),W),void 0,W,B.scheme==="output")}$resolveDocumentLink(D,B,W){return this.s(D,ve,K=>K.resolveLink(B,W),void 0,void 0,!0)}$releaseDocumentLinks(D,B){this.s(D,ve,W=>W.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(D,B,W){const K=this.t(new Ae(this.h,W),D);return this.e.$registerDocumentColorProvider(K,this.o(B)),this.p(K)}$provideDocumentColors(D,B,W){return this.s(D,Ae,K=>K.provideColors(n.URI.revive(B),W),[],W)}$provideColorPresentations(D,B,W,K){return this.s(D,Ae,ee=>ee.provideColorPresentations(n.URI.revive(B),W,K),void 0,K)}registerFoldingRangeProvider(D,B,W){const K=this.q(),ee=typeof W.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(K,new se(new Be(this.h,W),D)),this.e.$registerFoldingRangeProvider(K,this.o(B),D.identifier,ee);let he=this.p(K);if(ee!==void 0){const ye=W.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));he=M.Disposable.from(he,ye)}return he}$provideFoldingRanges(D,B,W,K){return this.s(D,Be,ee=>ee.provideFoldingRanges(n.URI.revive(B),W,K),void 0,K)}registerSelectionRangeProvider(D,B,W){const K=this.t(new xe(this.h,W,this.l),D);return this.e.$registerSelectionRangeProvider(K,this.o(B)),this.p(K)}$provideSelectionRanges(D,B,W,K){return this.s(D,xe,ee=>ee.provideSelectionRanges(n.URI.revive(B),W,K),[],K)}registerCallHierarchyProvider(D,B,W){const K=this.t(new Te(this.h,W),D);return this.e.$registerCallHierarchyProvider(K,this.o(B)),this.p(K)}$prepareCallHierarchy(D,B,W,K){return this.s(D,Te,ee=>Promise.resolve(ee.prepareSession(n.URI.revive(B),W,K)),void 0,K)}$provideCallHierarchyIncomingCalls(D,B,W,K){return this.s(D,Te,ee=>ee.provideCallsTo(B,W,K),void 0,K)}$provideCallHierarchyOutgoingCalls(D,B,W,K){return this.s(D,Te,ee=>ee.provideCallsFrom(B,W,K),void 0,K)}$releaseCallHierarchy(D,B){this.s(D,Te,W=>Promise.resolve(W.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(D,B,W){const K=this.t(new Se(this.h,W),D);return this.e.$registerTypeHierarchyProvider(K,this.o(B)),this.p(K)}$prepareTypeHierarchy(D,B,W,K){return this.s(D,Se,ee=>Promise.resolve(ee.prepareSession(n.URI.revive(B),W,K)),void 0,K)}$provideTypeHierarchySupertypes(D,B,W,K){return this.s(D,Se,ee=>ee.provideSupertypes(B,W,K),void 0,K)}$provideTypeHierarchySubtypes(D,B,W,K){return this.s(D,Se,ee=>ee.provideSubtypes(B,W,K),void 0,K)}$releaseTypeHierarchy(D,B){this.s(D,Se,W=>Promise.resolve(W.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(D,B,W){const K=this.q();return this.f.set(K,new se(new ke(this.e,this.h,W,K),D)),this.e.$registerDocumentOnDropEditProvider(K,this.o(B)),this.p(K)}$provideDocumentOnDropEdits(D,B,W,K,ee,he){return this.s(D,ke,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(B,n.URI.revive(W),K,ee,he)),void 0,void 0)}registerDocumentPasteEditProvider(D,B,W,K){const ee=this.q();return this.f.set(ee,new se(new N(this.e,this.h,W,ee),D)),this.e.$registerPasteEditProvider(ee,this.o(B),!!W.prepareDocumentPaste,K.pasteMimeTypes),this.p(ee)}$prepareDocumentPaste(D,B,W,K,ee){return this.s(D,N,he=>he.prepareDocumentPaste(n.URI.revive(B),W,K,ee),void 0,ee)}$providePasteEdits(D,B,W,K,ee,he){return this.s(D,N,ye=>ye.providePasteEdits(B,n.URI.revive(W),K,ee,he),void 0,he)}static w(D){return{pattern:D.source,flags:(0,y.regExpFlags)(D)}}static y(D){return{decreaseIndentPattern:ce.w(D.decreaseIndentPattern),increaseIndentPattern:ce.w(D.increaseIndentPattern),indentNextLinePattern:D.indentNextLinePattern?ce.w(D.indentNextLinePattern):void 0,unIndentedLinePattern:D.unIndentedLinePattern?ce.w(D.unIndentedLinePattern):void 0}}static z(D){return{beforeText:ce.w(D.beforeText),afterText:D.afterText?ce.w(D.afterText):void 0,previousLineText:D.previousLineText?ce.w(D.previousLineText):void 0,action:D.action}}static B(D){return D.map(ce.z)}setLanguageConfiguration(D,B,W){const{wordPattern:K}=W;if(K&&(0,y.regExpLeadsToEndlessLoop)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this.h.setWordDefinitionFor(B,K):this.h.setWordDefinitionFor(B,void 0),W.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",D,"Do not use."),W.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",D,"Do not use.");const ee=this.q(),he={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?ce.w(W.wordPattern):void 0,indentationRules:W.indentationRules?ce.y(W.indentationRules):void 0,onEnterRules:W.onEnterRules?ce.B(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this.e.$setLanguageConfiguration(ee,B,he),this.p(ee)}$setWordDefinitions(D){for(const B of D)this.h.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=ce,ce.d=0}),define(Ie[217],Ce([1,0,5,8,7,30,16,6]),function(te,e,n,C,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(O,w,m,b){this.c=w,this.d=m,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=O.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this.b=O}async getLanguages(){return this.b.slice(0)}async changeLanguage(O,w){await this.a.$changeLanguage(O,w);const m=this.c.getDocumentData(O);if(!m)throw new Error(`document '${O.toString()}' NOT found`);return m.document}async tokenAtPosition(O,w){const m=O.version,b=C.Position.from(w),f=await this.a.$tokensAtPosition(O.uri,b),s={type:S.StandardTokenType.Other,range:O.getWordRangeAtPosition(w)??new S.Range(w.line,w.character,w.line,w.character)};if(!f)return s;const o={range:C.Range.to(f.range),type:C.TokenType.to(f.type)};return!o.range.contains(w)||m!==O.version?s:o}createLanguageStatusItem(O,w,m){const b=this.f++,f=this.a,s=this.g,o=`${O.identifier.value}/${w}`;if(s.has(o))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);s.add(o);const l={selector:m,id:w,name:O.displayName??O.name,severity:S.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const E=new A.DisposableStore,P=()=>{v?.dispose(),v=(0,I.disposableTimeout)(()=>{E.clear(),this.a.$setLanguageStatus(b,{id:o,name:l.name??O.displayName??O.name,source:O.displayName??O.name,selector:C.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===S.LanguageStatusSeverity.Error?M.default.Error:l.severity===S.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:l.command&&this.d.toInternal(l.command,E),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},p={dispose(){E.dispose(),v?.dispose(),f.$removeLanguageStatus(b),s.delete(o)},get id(){return l.id},get name(){return l.name},set name(r){l.name=r,P()},get selector(){return l.selector},set selector(r){l.selector=r,P()},get text(){return l.text},set text(r){l.text=r,P()},get detail(){return l.detail},set detail(r){l.detail=r,P()},get severity(){return l.severity},set severity(r){l.severity=r,P()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(r){l.accessibilityInformation=r,P()},get command(){return l.command},set command(r){l.command=r,P()},get busy(){return l.busy},set busy(r){l.busy=r,P()}};return P(),p}}e.ExtHostLanguages=y}),define(Ie[78],Ce([1,0,20,10,2,3,12,5,27,17]),function(te,e,n,C,S,M,I,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(m,b,f){this.f=f,this.d=new Map,this.a=b.getProxy(A.MainContext.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===n.LANGUAGE_DEFAULT}getMessage(m,b){const{message:f,args:s,comment:o}=b;if(this.c)return(0,C.format2)(f,s??{});let l=f;o&&o.length>0&&(l+=`/${Array.isArray(o)?o.join():o}`);const v=this.d.get(m)?.contents[l];return v||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,C.format2)(v??f,s??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let b;const f=await this.g(m);if(!f){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(f),o=JSON.parse(s);b=m.isBuiltin?o.contents?.bundle:o}catch(s){this.f.error(`Failed to load translations for ${m.identifier.value} from ${f}: ${s.message}`);return}b&&this.d.set(m.identifier.value,{contents:b,uri:f})}async g(m){if(m.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(m.identifier.value);return S.URI.revive(b)}return m.l10n?S.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};O=qe([Ve(0,y.IExtHostInitDataService),Ve(1,k.IExtHostRpcService),Ve(2,I.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(Ie[218],Ce([1,0,12,5,27,17,2,4,9]),function(te,e,n,C,S,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends n.AbstractLoggerService{constructor(m,b){super(b.logLevel,A.Event.None),this.g=m.getProxy(C.MainContext.MainThreadLogger)}$setLevel(m,b){b?this.setLevel(I.URI.revive(b),m):(0,y.isUndefined)(m)||this.setLevel(m)}f(m,b,f){return new O(this.g,m,b,f)}};k=qe([Ve(0,M.IExtHostRpcService),Ve(1,S.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class O extends n.AbstractMessageLogger{constructor(m,b,f,s){super(s?.always),this.m=m,this.n=b,this.k=!1,this.l=[],this.setLevel(f),this.m.$createLogger(b,s).then(()=>{this.r(this.l),this.k=!0})}g(m,b){const f=[[m,b]];this.k?this.r(f):this.l.push(...f)}r(m){this.m.$log(this.n,m)}}}),define(Ie[219],Ce([1,0,5,12,26]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(A){return A&&A.title}let I=class{constructor(y,k){this.b=k,this.a=y.getProxy(n.MainContext.MainThreadMessageService)}showMessage(y,k,O,w,m){const b={source:{identifier:y.identifier,label:y.displayName||y.name}};let f;typeof w=="string"||M(w)?f=[w,...m]:(b.modal=w?.modal,b.useCustom=w?.useCustom,b.detail=w?.detail,f=m),b.useCustom&&(0,S.checkProposedApiEnabled)(y,"resolvers");const s=[];for(let o=0;o<f.length;o++){const l=f[o];if(typeof l=="string")s.push({title:l,handle:o,isCloseAffordance:!1});else if(typeof l=="object"){const{title:v,isCloseAffordance:E}=l;s.push({title:v,isCloseAffordance:!!E,handle:o})}else this.b.warn("Invalid message item:",l)}return this.a.$showMessage(k,O,b,s).then(o=>{if(typeof o=="number")return f[o]})}};I=qe([Ve(1,C.ILogService)],I),e.ExtHostMessageService=I}),define(Ie[220],Ce([1,0,24,4,6,28,10,9,2,53,5,38,8,7,44,194,100]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class l{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,P,p,r){this.q=p,this.r=r,this.f=new Map,this.g=new M.ResourceMap,this.h=new Map,this.j=new C.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=E.getProxy(O.MainContext.MainThreadNotebook),this.c=E.getProxy(O.MainContext.MainThreadNotebookDocuments),this.d=E.getProxy(O.MainContext.MainThreadNotebookEditors),this.i=P.converter,P.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===13){const i=d.notebookEditor?.notebookUri,c=d.cell.handle,h=this.g.get(i)?.getCell(c);if(h)return h.apiCell}if(d&&d.$mid===14){const i=d.uri,c=this.g.get(i);if(c)return c.apiNotebook}return d}}),l.x(P)}getEditorById(E){const P=this.h.get(E);if(!P)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return P}getIdByEditor(E){for(const[P,p]of this.h)if(p.apiEditor===E)return P}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,P){const p=this.g.get(E);if(!p&&!P)throw new Error(`NO notebook document for '${E}'`);return p}static s(E,P){if(!P)return;const p=P.filenamePattern.map(r=>m.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(P.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${P.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:P.displayName,filenamePattern:p,exclusive:P.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,P,p){const r=l.a++,d=typeof p.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(r,p),this.b.$registerNotebookCellStatusBarItemProvider(r,d,P);let i;return d!==void 0&&(i=p.onDidChangeCellStatusBarItems(c=>this.b.$emitCellStatusBarEvent(d))),new b.Disposable(()=>{this.f.delete(r),this.b.$unregisterNotebookCellStatusBarItemProvider(r,d),i?.dispose()})}async createNotebookDocument(E){const P=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&m.NotebookData.from(E.content)});return y.URI.revive(P)}async openNotebookDocument(E){const P=this.g.get(E);if(P)return P.apiNotebook;const p=await this.c.$tryOpenNotebook(E),r=this.g.get(y.URI.revive(p));return(0,A.assertIsDefined)(r?.apiNotebook)}async showNotebookDocument(E,P){y.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let p;typeof P=="object"?p={position:m.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selections:P.selections&&P.selections.map(m.NotebookRange.from),pinned:typeof P.preview=="boolean"?!P.preview:void 0}:p={preserveFocus:!1};const r=await this.d.$tryShowNotebookDocument(E.uri,E.notebookType,p),d=r&&this.h.get(r)?.apiEditor;if(d)return d;throw r?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,P,p,r){const d=this.f.get(E),i=y.URI.revive(P),c=this.g.get(i);if(!c||!d)return;const t=c.getCellFromIndex(p);if(!t)return;const h=await d.provideCellStatusBarItems(t.apiCell,r);if(!h)return;const a=new S.DisposableStore,u=this.p.add([a]),R=(Array.isArray(h)?h:[h]).map(F=>m.NotebookStatusBarItem.from(F,this.i,a));return{cacheId:u,items:R}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,P,p,r,d){if((0,I.isFalsyOrWhitespace)(P))throw new Error("viewType cannot be empty or just whitespace");const i=this.t++;return this.u.set(i,p),this.b.$registerNotebookSerializer(i,{id:E.identifier,location:E.extensionLocation},P,m.NotebookDocumentContentOptions.from(r),l.s(E,d)),(0,S.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(i)})}async $dataToNotebook(E,P,p){const r=this.u.get(E);if(!r)throw new Error("NO serializer found");const d=await r.deserializeNotebook(P.buffer,p);return new f.SerializableObjectWithBuffers(m.NotebookData.from(d))}async $notebookToData(E,P,p){const r=this.u.get(E);if(!r)throw new Error("NO serializer found");const d=await r.serializeNotebook(m.NotebookData.to(P.value),p);return n.VSBuffer.wrap(d)}w(E,P,p){if(this.h.has(P))throw new Error(`editor with id ALREADY EXSIST: ${P}`);const r=new o.ExtHostNotebookEditor(P,this.d,E,p.visibleRanges.map(m.NotebookRange.to),p.selections.map(m.NotebookRange.to),typeof p.viewColumn=="number"?m.ViewColumn.to(p.viewColumn):void 0);this.h.set(P,r)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const p of E.value.removedDocuments){const r=y.URI.revive(p),d=this.g.get(r);d&&(d.dispose(),this.g.delete(r),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(i=>i.document.uri)}),this.n.fire(d.apiNotebook));for(const i of this.h.values())i.notebookData.uri.toString()===r.toString()&&this.h.delete(i.id)}if(E.value.addedDocuments){const p=[];for(const r of E.value.addedDocuments){const d=y.URI.revive(r.uri);if(this.g.has(d))throw new Error(`adding EXISTING notebook ${d} `);const i=new s.ExtHostNotebookDocument(this.c,this.q,this.r,d,r);p.push(...r.cells.map(c=>s.ExtHostCell.asModelAddData(i.apiNotebook,c))),this.g.get(d)?.dispose(),this.g.set(d,i),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this.m.fire(i.apiNotebook)}}if(E.value.addedEditors)for(const p of E.value.addedEditors){if(this.h.has(p.id))return;const r=y.URI.revive(p.documentUri),d=this.g.get(r);d&&this.w(d,p.id,p)}const P=[];if(E.value.removedEditors)for(const p of E.value.removedEditors){const r=this.h.get(p);r&&(this.h.delete(p),this.k?.id===r.id&&(this.k=void 0),P.push(r))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(r=>this.h.get(r)).filter(r=>!!r);const p=new Set;this.l.forEach(r=>p.add(r.id));for(const r of this.h.values()){const d=p.has(r.id);r._acceptVisibility(d)}this.l=[...this.h.values()].map(r=>r).filter(r=>r.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(E){const P=w.ApiCommandArgument.String.with("notebookType","A notebook type"),p=new w.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[P,new w.ApiCommandArgument("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>n.VSBuffer.wrap(d))],new w.ApiCommandResult("Notebook Data",d=>m.NotebookData.to(d.value))),r=new w.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[P,new w.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new f.SerializableObjectWithBuffers(m.NotebookData.from(d)))],new w.ApiCommandResult("Bytes",d=>d.buffer));E.registerApiCommand(p),E.registerApiCommand(r)}}e.ExtHostNotebookController=l,l.a=0}),define(Ie[221],Ce([1,0,18,16,21,4,6,28,2,25,12,53,5,38,8,7,72,183,26,44]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o,l,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let P=class{constructor(t,h,a,u,g){this.k=h,this.l=a,this.m=u,this.n=g,this.b=new A.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new w.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=t.getProxy(m.MainContext.MainThreadNotebookKernels);const R=new b.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.ApiCommandArgument("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const q=this.l.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:q}}else if(F&&"notebookEditor"in F){const q=this.l.getIdByEditor(F.notebookEditor);if(q===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:q}}return F})],b.ApiCommandResult.Void);this.m.registerApiCommand(R)}createNotebookController(t,h,a,u,g,R){for(const de of this.h.values())if(de.controller.id===h&&k.ExtensionIdentifier.equals(t.identifier,de.extensionId))throw new Error(`notebook controller with id '${h}' ALREADY exist`);const F=this.i++,q=this;this.n.trace(`NotebookController[${F}], CREATED by ${t.identifier.value}, ${h}`);const Z=()=>console.warn(`NO execute handler from notebook controller '${L.id}' of extension: '${t.identifier}'`);let x=!1;const N=new I.DisposableStore,$=new M.Emitter,T=new M.Emitter,L={id:i(t.identifier,h),notebookType:a,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:u||t.identifier.value,preloads:R?R.map(f.NotebookRendererScript.from):[]};let V=g??Z,j;this.a.$addKernel(F,L).catch(de=>{console.log(de),x=!0});let le=0;const Y=()=>{if(x)return;const de=++le;Promise.resolve().then(()=>{de===le&&this.a.$updateKernel(F,L)})},pe=new A.ResourceMap,ue={get id(){return h},get notebookType(){return L.notebookType},onDidChangeSelectedNotebooks:$.event,get label(){return L.label},set label(de){L.label=de??t.displayName??t.name,Y()},get detail(){return L.detail??""},set detail(de){L.detail=de,Y()},get description(){return L.description??""},set description(de){L.description=de,Y()},get kind(){return(0,v.checkProposedApiEnabled)(t,"notebookControllerKind"),L.kind??""},set kind(de){(0,v.checkProposedApiEnabled)(t,"notebookControllerKind"),L.kind=de,Y()},get supportedLanguages(){return L.supportedLanguages},set supportedLanguages(de){L.supportedLanguages=de,Y()},get supportsExecutionOrder(){return L.supportsExecutionOrder??!1},set supportsExecutionOrder(de){L.supportsExecutionOrder=de,Y()},get rendererScripts(){return L.preloads?L.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(de){V=de??Z},get interruptHandler(){return j},set interruptHandler(de){j=de,L.supportsInterrupt=Boolean(de),Y()},createNotebookCellExecution(de){if(x)throw new Error("notebook controller is DISPOSED");if(!pe.has(de.notebook.uri))throw q.n.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${de.notebook.uri.toString()}`);return q._createNotebookCellExecution(de,i(t.identifier,this.id))},dispose:()=>{x||(this.n.trace(`NotebookController[${F}], DISPOSED`),x=!0,this.h.delete(F),N.dispose(),$.dispose(),T.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(de,re){re===s.NotebookControllerAffinity2.Hidden&&(0,v.checkProposedApiEnabled)(t,"notebookControllerAffinityHidden"),q.a.$updateNotebookPriority(F,de.uri,re)},onDidReceiveMessage:T.event,postMessage(de,re){return(0,v.checkProposedApiEnabled)(t,"notebookMessaging"),q.a.$postMessage(F,re&&q.l.getIdByEditor(re),de)},asWebviewUri(de){return(0,v.checkProposedApiEnabled)(t,"notebookMessaging"),(0,o.asWebviewUri)(de,q.k.remote)}};return this.h.set(F,{extensionId:t.identifier,controller:ue,onDidReceiveMessage:T,onDidChangeSelection:$,associatedNotebooks:pe}),ue}getIdByController(t){for(const[h,a]of this.h)if(a.controller===t)return i(a.extensionId,t.id);return null}createNotebookControllerDetectionTask(t,h){const a=this.d++,u=this;this.n.trace(`NotebookControllerDetectionTask[${a}], CREATED by ${t.identifier.value}`),this.a.$addKernelDetectionTask(a,h);const g={dispose:()=>{this.c.delete(a),u.a.$removeKernelDetectionTask(a)}};return this.c.set(a,g),g}registerKernelSourceActionProvider(t,h,a){const u=this.f++,g=this;return this.e.set(u,a),this.n.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${t.identifier.value}`),this.a.$addKernelSourceActionProvider(u,h),{dispose:()=>{this.e.delete(u),g.a.$removeKernelSourceActionProvider(u)}}}async $provideKernelSourceActions(t,h){const a=this.e.get(t);if(a){const u=new I.DisposableStore;return this.g.add([u]),(await a.provideNotebookKernelSourceActions(h)??[]).map(R=>f.NotebookKernelSourceAction.from(R,this.m.converter,u))}return[]}$acceptNotebookAssociation(t,h,a){const u=this.h.get(t);if(u){const g=this.l.getNotebookDocument(y.URI.revive(h));a?u.associatedNotebooks.set(g.uri,!0):u.associatedNotebooks.delete(g.uri),this.n.trace(`NotebookController[${t}] ASSOCIATE notebook`,g.uri.toString(),a),u.onDidChangeSelection.fire({selected:a,notebook:g.apiNotebook})}}async $executeCells(t,h,a){const u=this.h.get(t);if(!u)return;const g=this.l.getNotebookDocument(y.URI.revive(h)),R=[];for(const F of a){const q=g.getCell(F);q&&R.push(q.apiCell)}try{this.n.trace(`NotebookController[${t}] EXECUTE cells`,g.uri.toString(),R.length),await u.controller.executeHandler.call(u.controller,R,g.apiNotebook,u.controller)}catch(F){this.n.error(`NotebookController[${t}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(t,h,a){const u=this.h.get(t);if(!u)return;const g=this.l.getNotebookDocument(y.URI.revive(h));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,g.apiNotebook);else for(const R of a){const F=g.getCell(R);F&&this.b.get(F.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,h,a){const u=this.h.get(t);if(!u)return;const g=this.l.getEditorById(h);u.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:a}))}$cellExecutionChanged(t,h,a){const g=this.l.getNotebookDocument(y.URI.revive(t)).getCell(h);if(g){const R=a?f.NotebookCellExecutionState.to(a):s.NotebookCellExecutionState.Idle;R!==void 0&&this.j.fire({cell:g.apiCell,state:R})}}_createNotebookCellExecution(t,h){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.l.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const g=new r(h,u,this.a);this.b.set(u.uri,g);const R=g.onDidChangeState(()=>{g.state===p.Resolved&&(g.dispose(),R.dispose(),this.b.delete(u.uri))});return g.asApiObject()}};P=qe([Ve(4,O.ILogService)],P),e.ExtHostNotebookKernels=P;var p;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(p||(p={}));class r extends I.Disposable{get state(){return this.f}constructor(t,h,a){super(),this.j=h,this.k=a,this.b=r.a++,this.c=new M.Emitter,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new S.CancellationTokenSource),this.h=new d(10,u=>this.m(u)),this.i=h.internalMetadata.executionOrder,this.k.$createExecution(this.b,t,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(t){await this.h.addItem(t)}async m(t){const h=Array.isArray(t)?t:[t];return this.k.$updateExecution(this.b,new E.SerializableObjectWithBuffers(h))}n(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(t){let h=this.j;if(t&&(h=this.j.notebook.getCellFromApiCell(t)),!h)throw new Error("INVALID cell");return h.handle}s(t){return t.map(h=>{const a=s.NotebookCellOutput.ensureUniqueMimeTypes(h.items,!0);return a===h.items?f.NotebookCellOutput.from(h):f.NotebookCellOutput.from({items:a,id:h.id,metadata:h.metadata})})}async t(t,h,a){const u=this.r(h),g=this.s((0,n.asArray)(t));return this.l({editType:l.CellExecutionUpdateType.Output,cellHandle:u,append:a,outputs:g})}async w(t,h,a){return t=s.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(t),!0),this.l({editType:l.CellExecutionUpdateType.OutputItems,items:t.map(f.NotebookCellOutputItem.from),outputId:h.id,append:a})}asApiObject(){const t=this;return Object.freeze({get token(){return t.g.token},get cell(){return t.j.apiCell},get executionOrder(){return t.i},set executionOrder(a){t.i=a,t.m([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:t.i}])},start(a){if(t.f===p.Resolved||t.f===p.Started)throw new Error("Cannot call start again");t.f=p.Started,t.c.fire(),t.m({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:a})},end(a,u){if(t.f===p.Resolved)throw new Error("Cannot call resolve twice");t.f=p.Resolved,t.c.fire(),t.h.flush(),t.k.$completeExecution(t.b,new E.SerializableObjectWithBuffers({runEndTime:u,lastRunSuccess:a}))},clearOutput(a){return t.n(),t.t([],a,!1)},appendOutput(a,u){return t.n(),t.t(a,u,!0)},replaceOutput(a,u){return t.n(),t.t(a,u,!1)},appendOutputItems(a,u){return t.n(),t.w(a,u,!0)},replaceOutputItems(a,u){return t.n(),t.w(a,u,!1)}})}}r.a=0;class d{constructor(t,h){this.d=t,this.e=h,this.a=[],this.b=Date.now()}addItem(t){return this.a.push(t),this.c||(this.c=new C.DeferredPromise,this.b=Date.now(),(0,C.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const t=this.c;this.c=void 0;const h=this.a;return this.a=[],this.e(h).finally(()=>t.complete())}}function i(c,t){return`${c.value}/${t}`}e.createKernelId=i}),define(Ie[222],Ce([1,0,4,5,100]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(A,y){this.c=y,this.a=new Map,this.b=A.getProxy(C.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,k){const O=this.c.getEditorById(A);this.a.get(y)?.fire({editor:O.apiEditor,message:k})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(O=>O.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(O,w,m)=>this.d(y).event(O,w,m),postMessage:(O,w)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,w]=[w,O]);const m=w&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.b.$postMessage(m?.id,y,O)}}}d(A){let y=this.a.get(A);return y||(y=new n.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(A)}}),this.a.set(A,y),y)}}e.ExtHostNotebookRenderers=M}),define(Ie[223],Ce([1,0,6,9,2,26,5]),function(te,e,n,C,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(k){this.b=new Map,this.a=k.getProxy(I.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(k,O,w){if((0,M.checkProposedApiEnabled)(k,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,w),this.a.$registerProfileContentHandler(O,w.name,w.description,k.identifier.value),(0,n.toDisposable)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(k,O,w,m){const b=this.b.get(k);if(!b)throw new Error(`Unknown handler with id: ${k}`);return b.saveProfile(O,w,m)}async $readProfile(k,O,w){const m=this.b.get(k);if(!m)throw new Error(`Unknown handler with id: ${k}`);return m.readProfile((0,C.isString)(O)?O:S.URI.revive(O),w)}}e.ExtHostProfileContentHandlers=A}),define(Ie[224],Ce([1,0,21,4,6,5,2,7,11,18,30,51]),function(te,e,n,C,S,M,I,A,y,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(b,f,s){const o=b.getProxy(M.MainContext.MainThreadQuickOpen);class l{constructor(t,h){this.e=new Map,this.f=0,this.a=t,this.b=h}showQuickPick(t,h,a=n.CancellationToken.None){this.c=void 0;const u=Promise.resolve(t),g=++this.f,R=o.$show(g,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},a),F={},q=R.then(()=>F);return Promise.race([q,u]).then(Z=>{if(Z!==F)return u.then(x=>{const N=[];for(let $=0;$<x.length;$++){const T=x[$];typeof T=="string"?N.push({label:T,handle:$}):T.kind===A.QuickPickItemKind.Separator?N.push({type:"separator",label:T.label}):N.push({label:T.label,description:T.description,detail:T.detail,picked:T.picked,alwaysShow:T.alwaysShow,handle:$})}return h&&typeof h.onDidSelectItem=="function"&&(this.c=$=>{h.onDidSelectItem(x[$])}),o.$setItems(g,N),R.then($=>{if(typeof $=="number")return x[$];if(Array.isArray($))return $.map(T=>x[T])})})}).then(void 0,Z=>{if(!(0,y.isCancellationError)(Z))return o.$setError(g,Z),Promise.reject(Z)})}$onItemSelected(t){this.c?.(t)}showInput(t,h=n.CancellationToken.None){return this.d=t?.validateInput,o.$input(t,typeof this.d=="function",h).then(void 0,a=>{if(!(0,y.isCancellationError)(a))return Promise.reject(a)})}async $validateInput(t){if(!this.d)return;const h=await this.d(t);if(!h||typeof h=="string")return h;let a;switch(h.severity){case A.InputBoxValidationSeverity.Info:a=O.default.Info;break;case A.InputBoxValidationSeverity.Warning:a=O.default.Warning;break;case A.InputBoxValidationSeverity.Error:a=O.default.Error;break;default:a=h.message?O.default.Error:O.default.Ignore;break}return{content:h.message,severity:a}}async showWorkspaceFolderPick(t,h=n.CancellationToken.None){const a=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[t]);if(!a)return;const u=await this.a.getWorkspaceFolders2();if(!!u)return u.find(g=>g.uri.toString()===a.uri.toString())}createQuickPick(t){const h=new d(t,()=>this.e.delete(h._id));return this.e.set(h._id,h),h}createInputBox(t){const h=new i(t,()=>this.e.delete(h._id));return this.e.set(h._id,h),h}$onDidChangeValue(t,h){this.e.get(t)?._fireDidChangeValue(h)}$onDidAccept(t){this.e.get(t)?._fireDidAccept()}$onDidChangeActive(t,h){const a=this.e.get(t);a instanceof d&&a._fireDidChangeActive(h)}$onDidChangeSelection(t,h){const a=this.e.get(t);a instanceof d&&a._fireDidChangeSelection(h)}$onDidTriggerButton(t,h){this.e.get(t)?._fireDidTriggerButton(h)}$onDidTriggerItemButton(t,h,a){const u=this.e.get(t);u instanceof d&&u._fireDidTriggerItemButton(h,a)}$onDidHide(t){this.e.get(t)?._fireDidHide()}}class v{constructor(t,h){this.x=t,this.y=h,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new C.Emitter,this.q=new C.Emitter,this.r=new C.Emitter,this.s=new C.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(t){this.b=t,this.z({title:t})}get step(){return this.c}set step(t){this.c=t,this.z({step:t})}get totalSteps(){return this.d}set totalSteps(t){this.d=t,this.z({totalSteps:t})}get enabled(){return this.g}set enabled(t){this.g=t,this.z({enabled:t})}get busy(){return this.j}set busy(t){this.j=t,this.z({busy:t})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(t){this.k=t,this.z({ignoreFocusOut:t})}get value(){return this.l}set value(t){this.l=t,this.z({value:t})}get placeholder(){return this.m}set placeholder(t){this.m=t,this.z({placeholder:t})}get buttons(){return this.n}set buttons(t){this.n=t.slice(),this.o.clear(),t.forEach((h,a)=>{const u=h===A.QuickInputButtons.Back?-1:a;this.o.set(u,h)}),this.z({buttons:t.map((h,a)=>({...r(h),tooltip:h.tooltip,handle:h===A.QuickInputButtons.Back?-1:a}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(t){this.l=t,this.q.fire(t)}_fireDidTriggerButton(t){const h=this.o.get(t);h&&this.r.fire(h)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,S.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),o.$dispose(this._id))}z(t){if(!this.v){for(const h of Object.keys(t)){const a=t[h];this.u[h]=a===void 0?null:a}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){o.$createOrUpdate(this.u),this.u={id:this._id}}}v.a=1;function E(c){if(c instanceof A.ThemeIcon)return{id:c.id};const t=p(c),h=P(c);return{dark:typeof t=="string"?I.URI.file(t):t,light:typeof h=="string"?I.URI.file(h):h}}function P(c){return typeof c=="object"&&"light"in c?c.light:c}function p(c){return typeof c=="object"&&"dark"in c?c.dark:c}function r(c){const t=E(c.iconPath);let h,a;return"id"in t?a=w.ThemeIcon.asClassName(t):h=t,{iconPath:h,iconClass:a}}class d extends v{constructor(t,h){super(t.identifier,h),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new C.Emitter,this.L=[],this.M=new C.Emitter,this.N=new C.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(t){this.B=t.slice(),this.C.clear(),this.D.clear(),t.forEach((a,u)=>{this.C.set(u,a),this.D.set(a,u)});const h=[];for(let a=0;a<t.length;a++){const u=t[a];u.kind===A.QuickPickItemKind.Separator?h.push({type:"separator",label:u.label}):h.push({handle:a,label:u.label,description:u.description,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons?.map((g,R)=>({...r(g),tooltip:g.tooltip,handle:R}))})}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(t){this.E=t,this.z({canSelectMany:t})}get matchOnDescription(){return this.F}set matchOnDescription(t){this.F=t,this.z({matchOnDescription:t})}get matchOnDetail(){return this.G}set matchOnDetail(t){this.G=t,this.z({matchOnDetail:t})}get sortByLabel(){return this.H}set sortByLabel(t){this.H=t,this.z({sortByLabel:t})}get keepScrollPosition(){return this.I}set keepScrollPosition(t){this.I=t,this.z({keepScrollPosition:t})}get activeItems(){return this.J}set activeItems(t){this.J=t.filter(h=>this.D.has(h)),this.z({activeItems:this.J.map(h=>this.D.get(h))})}get selectedItems(){return this.L}set selectedItems(t){this.L=t.filter(h=>this.D.has(h)),this.z({selectedItems:this.L.map(h=>this.D.get(h))})}_fireDidChangeActive(t){const h=(0,k.coalesce)(t.map(a=>this.C.get(a)));this.J=h,this.K.fire(h)}_fireDidChangeSelection(t){const h=(0,k.coalesce)(t.map(a=>this.C.get(a)));this.L=h,this.M.fire(h)}_fireDidTriggerItemButton(t,h){const a=this.C.get(t);if(!a||!a.buttons||!a.buttons.length)return;const u=a.buttons[h];u&&this.N.fire({button:u,item:a})}}class i extends v{constructor(t,h){super(t.identifier,h),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(t){this.B=t,this.z({password:t})}get prompt(){return this.C}set prompt(t){this.C=t,this.z({prompt:t})}get valueSelection(){return this.D}set valueSelection(t){this.D=t,this.z({valueSelection:t})}get validationMessage(){return this.E}set validationMessage(t){this.E=t,t?typeof t=="string"?this.z({validationMessage:t,severity:O.default.Error}):this.z({validationMessage:t.message,severity:t.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new l(f,s)}e.createExtHostQuickOpen=m});var Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,n):S?S.value=n:e.set(te,n),n};define(Ie[225],Ce([1,0,2,4,63,6,16,5,18,122,12,25,51,8,26]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f){"use strict";var s,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(u){if(u)return typeof u.iconPath=="string"?n.URI.file(u.iconPath):n.URI.isUri(u.iconPath)||m.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function v(u,g){if(!u.iconPath&&!g.iconPath)return 0;if(u.iconPath){if(!g.iconPath)return 1}else return-1;const R=typeof u.iconPath=="string"?u.iconPath:n.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,F=typeof g.iconPath=="string"?g.iconPath:n.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,k.comparePaths)(R,F)}function E(u,g){let R=0;if(u.strikeThrough!==g.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==g.faded)return u.faded?1:-1;if(u.tooltip!==g.tooltip)return(u.tooltip||"").localeCompare(g.tooltip||"");if(R=v(u,g),R!==0)return R;if(u.light&&g.light)R=v(u.light,g.light);else{if(u.light)return 1;if(g.light)return-1}if(R!==0)return R;if(u.dark&&g.dark)R=v(u.dark,g.dark);else{if(u.dark)return 1;if(g.dark)return-1}return R}function P(u,g){if(u.command!==g.command)return u.command<g.command?-1:1;if(u.title!==g.title)return u.title<g.title?-1:1;if(u.tooltip!==g.tooltip){if(u.tooltip!==void 0&&g.tooltip!==void 0)return u.tooltip<g.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(u.arguments===g.arguments)return 0;if(u.arguments)if(g.arguments){if(u.arguments.length!==g.arguments.length)return u.arguments.length-g.arguments.length}else return 1;else return-1;for(let R=0;R<u.arguments.length;R++){const F=u.arguments[R],q=g.arguments[R];if(F!==q)return F<q?-1:1}return 0}function p(u,g){let R=(0,k.comparePaths)(u.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(R!==0)return R;if(u.command&&g.command)R=P(u.command,g.command);else{if(u.command)return 1;if(g.command)return-1}if(R!==0)return R;if(u.decorations&&g.decorations)R=E(u.decorations,g.decorations);else{if(u.decorations)return 1;if(g.decorations)return-1}return R}function r(u,g){for(let R=0;R<u.length;R++)if(u[R]!==g[R])return!1;return!0}function d(u,g){return u.command===g.command&&u.title===g.title&&u.tooltip===g.tooltip&&(u.arguments&&g.arguments?r(u.arguments,g.arguments):u.arguments===g.arguments)}function i(u,g){return(0,y.equals)(u,g,d)}class c{get value(){return this.d}set value(g){g=g??"",Oe(this,s,"f").$setInputBoxValue(this.l,g),this.m(g)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(g){Oe(this,s,"f").$setInputBoxPlaceholder(this.l,g),this.f=g}get validateInput(){return(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(g){if((0,f.checkProposedApiEnabled)(this.k,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=g,Oe(this,s,"f").$setValidationProviderIsEnabled(this.l,!!g)}get enabled(){return this.h}set enabled(g){g=!!g,this.h!==g&&(this.h=g,Oe(this,s,"f").$setInputBoxEnablement(this.l,g))}get visible(){return this.j}set visible(g){g=!!g,this.j!==g&&(this.j=g,Oe(this,s,"f").$setInputBoxVisibility(this.l,g))}constructor(g,R,F){this.k=g,this.l=F,s.set(this,void 0),this.d="",this.e=new C.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,s,R,"f")}showValidationMessage(g,R){(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),Oe(this,s,"f").$showValidationMessage(this.l,g,R)}$onInputBoxValueChange(g){this.m(g)}m(g){this.d=g,this.e.fire(g)}}e.ExtHostSCMInputBox=c,s=new WeakMap;class t{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(g){this.v=g,this.q.$updateGroupLabel(this.t,this.handle,g)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(g){this.p=g,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(g){this.f=[...g],this.k.fire()}constructor(g,R,F,q,Z){this.q=g,this.s=R,this.t=F,this.u=q,this.v=Z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new C.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new C.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=t.d++}getResourceState(g){return this.g.get(g)}$executeResourceCommand(g,R){const F=this.h.get(g);return F?(0,I.asPromise)(()=>this.s.executeCommand(F.command,...F.arguments||[],R)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this.f].sort(p),F=(0,y.sortedDiff)(this.o,g,p).map(x=>{const N=x.toInsert.map($=>{const T=this.e++;this.g.set(T,$);const L=$.resourceUri;let V;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const oe=new M.DisposableStore;V=this.s.converter.toInternal($.command,oe),this.j.set(T,oe)}else this.h.set(T,$.command);const j=l($.decorations),le=$.decorations&&l($.decorations.light)||j,Y=$.decorations&&l($.decorations.dark)||j,pe=[le,Y],ue=$.decorations&&$.decorations.tooltip||"",de=$.decorations&&!!$.decorations.strikeThrough,re=$.decorations&&!!$.decorations.faded,G=$.contextValue||"";return{rawResource:[T,L,pe,ue,de,re,G,V],handle:T}});return{start:x.start,deleteCount:x.deleteCount,toInsert:N}}),q=F.map(({start:x,deleteCount:N,toInsert:$})=>[x,N,$.map(T=>T.rawResource)]),Z=F.reverse();for(const{start:x,deleteCount:N,toInsert:$}of Z){const T=$.map(V=>V.handle),L=this.n.splice(x,N,...T);for(const V of L)this.g.delete(V),this.h.delete(V),this.j.get(V)?.dispose(),this.j.delete(V)}return this.o=g,q}dispose(){this.l=!0,this.m.fire()}}t.d=0;class h{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(g){this.g!==g&&(this.g=g,Oe(this,o,"f").$updateSourceControl(this.t,{count:g}))}get quickDiffProvider(){return this.h}set quickDiffProvider(g){this.h=g,Oe(this,o,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this.j}set commitTemplate(g){g!==this.j&&(this.j=g,Oe(this,o,"f").$updateSourceControl(this.t,{commitTemplate:g}))}get acceptInputCommand(){return this.l}set acceptInputCommand(g){this.k.value=new M.DisposableStore,this.l=g;const R=this.v.converter.toInternal(g,this.k.value);Oe(this,o,"f").$updateSourceControl(this.t,{acceptInputCommand:R})}get actionButton(){return(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(g){(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new M.DisposableStore,this.n=g;const R=g!==void 0?{command:this.v.converter.toInternal(g.command,this.m.value),secondaryCommands:g.secondaryCommands?.map(F=>F.map(q=>this.v.converter.toInternal(q,this.m.value))),description:g.description,enabled:g.enabled}:void 0;Oe(this,o,"f").$updateSourceControl(this.t,{actionButton:R??null})}get statusBarCommands(){return this.p}set statusBarCommands(g){if(this.p&&g&&i(this.p,g))return;this.o.value=new M.DisposableStore,this.p=g;const R=(g||[]).map(F=>this.v.converter.toInternal(F,this.o.value));Oe(this,o,"f").$updateSourceControl(this.t,{statusBarCommands:R})}get selected(){return this.q}constructor(g,R,F,q,Z,x){this.u=g,this.v=F,this.w=q,this.x=Z,this.y=x,o.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new M.MutableDisposable,this.l=void 0,this.m=new M.MutableDisposable,this.o=new M.MutableDisposable,this.p=void 0,this.q=!1,this.s=new C.Emitter,this.onDidChangeSelection=this.s.event,this.t=h.d++,this.z=new Map,this.A=new Set,Je(this,o,R,"f"),this.f=new c(g,Oe(this,o,"f"),this.t),Oe(this,o,"f").$registerSourceControl(this.t,q,Z,x)}createResourceGroup(g,R){const F=new t(Oe(this,o,"f"),this.v,this.t,g,R),q=C.Event.once(F.onDidDispose)(()=>this.z.delete(F));return this.z.set(F,q),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const g=[],R=[];for(const[F,q]of this.z){q.dispose();const Z=F.onDidUpdateResourceStates(()=>{this.A.add(F),this.eventuallyUpdateResourceStates()});C.Event.once(F.onDidDispose)(()=>{this.A.delete(F),Z.dispose(),this.e.delete(F.handle),Oe(this,o,"f").$unregisterGroup(this.t,F.handle)}),g.push([F.handle,F.id,F.label,F.features]);const x=F._takeResourceStateSnapshot();x.length>0&&R.push([F.handle,x]),this.e.set(F.handle,F)}Oe(this,o,"f").$registerGroups(this.t,g,R),this.z.clear()}eventuallyUpdateResourceStates(){const g=[];this.A.forEach(R=>{const F=R._takeResourceStateSnapshot();F.length!==0&&g.push([R.handle,F])}),g.length>0&&Oe(this,o,"f").$spliceResourceStates(this.t,g),this.A.clear()}getResourceGroup(g){return this.e.get(g)}setSelectionState(g){this.q=g,this.s.fire(g)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(g=>g.dispose()),Oe(this,o,"f").$unregisterSourceControl(this.t)}}o=new WeakMap,h.d=0,qe([(0,S.debounce)(100)],h.prototype,"eventuallyAddResourceGroups",null),qe([(0,S.debounce)(100)],h.prototype,"eventuallyUpdateResourceStates",null);let a=class rn{get onDidChangeActiveProvider(){return this.j.event}constructor(g,R,F){this.l=R,this.m=F,this.g=new Map,this.h=new Map,this.j=new C.Emitter,this.e=g.getProxy(A.MainContext.MainThreadSCM),this.f=g.getProxy(A.MainContext.MainThreadTelemetry),R.registerArgumentProcessor({processArgument:q=>{if(q&&q.$mid===3){const Z=this.g.get(q.sourceControlHandle);if(!Z)return q;const x=Z.getResourceGroup(q.groupHandle);return x?x.getResourceState(q.handle):q}else if(q&&q.$mid===4){const Z=this.g.get(q.sourceControlHandle);return Z?Z.getResourceGroup(q.groupHandle):q}else if(q&&q.$mid===5){const Z=this.g.get(q.handle);return Z||q}return q}})}createSourceControl(g,R,F,q){this.m.trace("ExtHostSCM#createSourceControl",g.identifier.value,R,F,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const Z=rn.d++,x=new h(g,this.e,this.l,R,F,q);this.g.set(Z,x);const N=this.h.get(w.ExtensionIdentifier.toKey(g.identifier))||[];return N.push(x),this.h.set(w.ExtensionIdentifier.toKey(g.identifier),N),x}getLastInputBox(g){this.m.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const R=this.h.get(w.ExtensionIdentifier.toKey(g.identifier)),F=R&&R[R.length-1];return F&&F.inputBox}$provideOriginalResource(g,R,F){const q=n.URI.revive(R);this.m.trace("ExtHostSCM#$provideOriginalResource",g,q.toString());const Z=this.g.get(g);return!Z||!Z.quickDiffProvider||!Z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>Z.quickDiffProvider.provideOriginalResource(q,F)).then(x=>x||null)}$onInputBoxValueChange(g,R){this.m.trace("ExtHostSCM#$onInputBoxValueChange",g);const F=this.g.get(g);return F&&F.inputBox.$onInputBoxValueChange(R),Promise.resolve(void 0)}$executeResourceCommand(g,R,F,q){this.m.trace("ExtHostSCM#$executeResourceCommand",g,R,F);const Z=this.g.get(g);if(!Z)return Promise.resolve(void 0);const x=Z.getResourceGroup(R);return x?x.$executeResourceCommand(F,q):Promise.resolve(void 0)}$validateInput(g,R,F){this.m.trace("ExtHostSCM#$validateInput",g);const q=this.g.get(g);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>q.inputBox.validateInput(R,F)).then(Z=>{if(!Z)return Promise.resolve(void 0);const x=b.MarkdownString.fromStrict(Z.message);return x?Promise.resolve([x,Z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this.g.get(g)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=g,Promise.resolve(void 0)}};a.d=0,a=qe([Ve(2,O.ILogService)],a),e.ExtHostSCM=a}),define(Ie[79],Ce([1,0,5,4,3]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(A){this.b=new C.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,y){return this.a.$getPassword(A,y)}store(A,y,k){return this.a.$setPassword(A,y,k)}delete(A,y){return this.a.$deletePassword(A,y)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,n):S?S.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ie[226],Ce([1,0,7,5,141,6,8,9]),function(te,e,n,C,S,M,I,A){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(f,s,o,l,v=n.StatusBarAlignment.Left,E){y.set(this,void 0),k.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new M.DisposableStore,Je(this,y,f,"f"),Je(this,k,s,"f"),this.c=O.a++,this.e=o,this.f=l,this.g=v,this.h=this.u(E)}u(f){if(!!(0,A.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(f){this.k=f,this.v()}set name(f){this.m=f,this.v()}set tooltip(f){this.l=f,this.v()}set color(f){this.n=f,this.v()}set backgroundColor(f){f&&!O.b.has(f.id)&&(f=void 0),this.o=f,this.v()}set command(f){this.r?.fromApi!==f&&(this.p&&this.q.add(this.p),this.p=new M.DisposableStore,typeof f=="string"?this.r={fromApi:f,internal:Oe(this,k,"f").toInternal({title:"",command:f},this.p)}:f?this.r={fromApi:f,internal:Oe(this,k,"f").toInternal(f,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(f){this.t=f,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Oe(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let f;this.e?this.f?f=`${this.e.identifier.value}.${this.f}`:f=this.e.identifier.value:f=this.f;let s;this.m?s=this.m:s=(0,S.localize)(0,null,this.e.displayName||this.e.name);let o=this.n;this.o&&(o=O.b.get(this.o.id));const l=I.MarkdownString.fromStrict(this.l);Oe(this,y,"f").$setEntry(this.c,f,s,this.k,l,this.r?.internal,o,this.o,this.g===n.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=O,y=new WeakMap,k=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]);class w{constructor(f){this.b=[],this.a=f.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,S.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(f){const s={message:f};return this.b.unshift(s),this.c(),new n.Disposable(()=>{const o=this.b.indexOf(s);o>=0&&(this.b.splice(o,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class m{constructor(f,s){this.a=f.getProxy(C.MainContext.MainThreadStatusBar),this.b=s,this.c=new w(this)}createStatusBarEntry(f,s,o,l){return new O(this.a,this.b,f,s,o,l)}setStatusBarMessage(f,s){const o=this.c.setMessage(f);let l;return typeof s=="number"?l=setTimeout(()=>o.dispose(),s):typeof s<"u"&&s.then(()=>o.dispose(),()=>o.dispose()),new n.Disposable(()=>{o.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=m}),define(Ie[80],Ce([1,0,5,4,3]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(A,y){this.c=y,this.b=new C.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this.a.$registerExtensionStorageKeysToSync(A,y)}async initializeExtensionStorage(A,y,k){const O=await this.a.$initializeExtensionStorage(A,y);let w;return O&&(w=this.d(A,y,O)),w||k}setValue(A,y,k){return this.a.$setValue(A,y,k)}$acceptValue(A,y,k){const O=this.d(A,y,k);O&&this.b.fire({shared:A,key:y,value:O})}d(A,y,k){try{return JSON.parse(k)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${A}): ${O}`)}}}e.ExtHostStorage=M,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(Ie[81],Ce([1,0,3,27,12,59,2]),function(te,e,n,C,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let A=class{constructor(k,O,w){this.d=O,this.f=w,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(k){return I.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,O=await this.g(k);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(I.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:I.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(w){this.d.error("[ExtHostStorage]",w);return}}workspaceValue(k){if(this.c)return I.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return I.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=qe([Ve(0,C.IExtHostInitDataService),Ve(1,S.ILogService),Ve(2,M.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ie[60],Ce([1,0,4,5,3,2,17,6,7,142,11,167,21,34,168,51,9,16,8]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class E{constructor(a,u,g,R){this.k=a,this._id=u,this.l=g,this.m=R,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(q=>this.f=q);const F=this;this.value={get name(){return F.m||""},get processId(){return F.b},get creationOptions(){return F.l},get exitStatus(){return F.h},get state(){return F.j},sendText(q,Z=!0){F.o(),F.k.$sendText(F._id,q,Z)},show(q){F.o(),F.k.$show(F._id,q)},hide(){F.o(),F.k.$hide(F._id)},dispose(){F.a||(F.a=!0,F.k.$dispose(F._id))},get dimensions(){if(!(F.d===void 0||F.g===void 0))return{columns:F.d,rows:F.g}}}}async create(a,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:a.name,shellPath:(0,o.withNullAsUndefined)(a.shellPath),shellArgs:(0,o.withNullAsUndefined)(a.shellArgs),cwd:(0,o.withNullAsUndefined)(a.cwd),env:(0,o.withNullAsUndefined)(a.env),icon:(0,o.withNullAsUndefined)(c(a.iconPath)),color:s.ThemeColor.isThemeColor(a.color)?a.color.id:void 0,initialText:(0,o.withNullAsUndefined)(a.message),strictEnv:(0,o.withNullAsUndefined)(a.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(a.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(u?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(u?.useShellEnvironment),location:u?.location||this.n(a.location,u?.resolvedExtHostIdentifier),isTransient:(0,o.withNullAsUndefined)(a.isTransient)})}async createExtensionTerminal(a,u,g,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:g,color:s.ThemeColor.isThemeColor(R)?R.id:void 0,location:this.n(a,u),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(a,u){return typeof a=="object"?"parentTerminal"in a&&a.parentTerminal&&u?{parentTerminal:u}:"viewColumn"in a?{viewColumn:v.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus}:void 0:a}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(a){this.m=a}setExitStatus(a,u){this.h=Object.freeze({code:a,reason:u})}setDimensions(a,u){return a===this.d&&u===this.g||a===0||u===0?!1:(this.d=a,this.g=u,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(a){this.f?(this.f(a),this.f=void 0):this.b.then(u=>{u!==a&&(this.b=Promise.resolve(a))})}}e.ExtHostTerminal=E;class P{get onProcessReady(){return this.b.event}constructor(a){this.g=a,this.id=0,this.shouldPersist=!1,this.a=new n.Emitter,this.onProcessData=this.a.event,this.b=new n.Emitter,this.d=new n.Emitter,this.onDidChangeProperty=this.d.event,this.f=new n.Emitter,this.onProcessExit=this.f.event}refreshProperty(a){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${a}`)}updateProperty(a,u){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${a}, value: ${u}`)}async start(){}shutdown(){this.g.close()}input(a){this.g.handleInput?.(a)}resize(a,u){this.g.setDimensions?.({columns:a,rows:u})}async processBinary(a){}acknowledgeDataEvent(a){}async setUnicodeVersion(a){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(a){this.g.onDidWrite(u=>this.a.fire(u)),this.g.onDidClose?.((u=void 0)=>{this.f.fire(u===void 0?void 0:u)}),this.g.onDidOverrideDimensions?.(u=>{u&&this.d.fire({type:"overrideDimensions",value:{cols:u.columns,rows:u.rows}})}),this.g.onDidChangeName?.(u=>{this.d.fire({type:"title",value:u})}),this.g.open(a||void 0),a&&this.g.setDimensions?.(a),this.b.fire({pid:-1,cwd:""})}}let p=1,r=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(a=>a.value)}get onDidWriteTerminalData(){return this.I.event}constructor(a,u){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new n.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new n.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new n.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new n.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new n.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new n.Emitter,this.onDidChangeShell=this.J.event,this.a=u.getProxy(C.MainContext.MainThreadTerminalService),this.s=new f.TerminalDataBufferer(this.a.$sendProcessData),this.I=new n.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(a),this.B({dispose:()=>{for(const[g,R]of this.g)R.shutdown(!0)}})}getDefaultShell(a){return(a?this.n:this.m)?.path||""}getDefaultShellArgs(a){return(a?this.n:this.m)?.args||[]}createExtensionTerminal(a,u){const g=new E(this.a,(0,b.generateUuid)(),a,a.name),R=new P(a.pty);return g.createExtensionTerminal(a.location,this.L(a,u).resolvedExtHostIdentifier,c(a.iconPath),t(a.color)).then(F=>{const q=this.M(F,R);this.h[F]=q}),this.f.push(g),g.value}L(a,u){if(u=u||{},a.location&&typeof a.location=="object"&&"parentTerminal"in a.location){const g=a.location.parentTerminal;if(g){const R=this.f.find(F=>F.value===g);R&&(u.resolvedExtHostIdentifier=R._id)}}else a.location&&typeof a.location!="object"?u.location=a.location:u.location&&typeof u.location=="object"&&"splitActiveTerminal"in u.location&&(u.location={splitActiveTerminal:!0});return u}attachPtyToTerminal(a,u){if(!this.O(a))throw new Error(`Cannot resolve terminal with id ${a} for virtual process`);const R=new P(u),F=this.M(a,R);this.h[a]=F}async $acceptActiveTerminalChanged(a){const u=this.b;if(a===null){this.b=void 0,u!==this.b&&this.F.fire(this.b);return}const g=this.O(a);g&&(this.b=g,u!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(a,u){const g=this.O(a);g&&this.I.fire({terminal:g.value,data:u})}async $acceptTerminalDimensions(a,u,g){const R=this.O(a);R&&R.setDimensions(u,g)&&this.G.fire({terminal:R.value,dimensions:R.value.dimensions})}async $acceptTerminalMaximumDimensions(a,u,g){this.g.get(a)?.resize(u,g)}async $acceptTerminalTitleChange(a,u){const g=this.O(a);g&&(g.name=u)}async $acceptTerminalClosed(a,u,g){const R=this.Q(this.f,a);if(R!==null){const F=this.f.splice(R,1)[0];F.setExitStatus(u,g),this.C.fire(F.value)}}$acceptTerminalOpened(a,u,g,R){if(u){const Z=this.Q(this.f,u);if(Z!==null){this.f[Z]._id=a,this.D.fire(this.terminals[Z]),this.f[Z].isOpen=!0;return}}const F={name:R.name,shellPath:R.executable,shellArgs:R.args,cwd:typeof R.cwd=="string"?R.cwd:M.URI.revive(R.cwd),env:R.env,hideFromUser:R.hideFromUser},q=new E(this.a,a,F,g);this.f.push(q),this.D.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(a,u){this.O(a)?._setProcessId(u)}async $startExtensionTerminal(a,u){const g=this.O(a);if(!g)return{message:(0,k.localize)(0,null,a)};g.isOpen||await new Promise(F=>{const q=this.onDidOpenTerminal(async Z=>{Z===g.value&&(q.dispose(),F())})});const R=this.g.get(a);R?R.startSendingEvents(u):this.j[a]={initialDimensions:u}}M(a,u){const g=new A.DisposableStore;g.add(u.onProcessReady(F=>this.a.$sendProcessReady(a,F.pid,F.cwd))),g.add(u.onDidChangeProperty(F=>this.a.$sendProcessProperty(a,F))),this.s.startBuffering(a,u.onProcessData),g.add(u.onProcessExit(F=>this.N(a,F))),this.g.set(a,u);const R=this.j[a];return R&&u instanceof P&&(u.startSendingEvents(R.initialDimensions),delete this.j[a]),g}$acceptProcessAckDataEvent(a,u){this.g.get(a)?.acknowledgeDataEvent(u)}$acceptProcessInput(a,u){this.g.get(a)?.input(u)}$acceptTerminalInteraction(a){const u=this.O(a);u?.setInteractedWith()&&this.H.fire(u.value)}$acceptProcessResize(a,u,g){try{this.g.get(a)?.resize(u,g)}catch(R){if(R.code!=="EPIPE"&&R.code!=="ERR_IPC_CHANNEL_CLOSED")throw R}}$acceptProcessShutdown(a,u){this.g.get(a)?.shutdown(u)}$acceptProcessRequestInitialCwd(a){this.g.get(a)?.getInitialCwd().then(u=>this.a.$sendProcessProperty(a,{type:"initialCwd",value:u}))}$acceptProcessRequestCwd(a){this.g.get(a)?.getCwd().then(u=>this.a.$sendProcessProperty(a,{type:"cwd",value:u}))}$acceptProcessRequestLatency(a){return Promise.resolve(a)}registerLinkProvider(a){return this.u.add(a),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(a),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(a,u,g){if(this.v.has(u))throw new Error(`Terminal profile provider "${u}" already registered`);return this.v.set(u,g),this.a.$registerProfileProvider(u,a.identifier.value),new y.Disposable(()=>{this.v.delete(u),this.a.$unregisterProfileProvider(u)})}registerTerminalQuickFixProvider(a,u,g){if(this.w.has(a))throw new Error(`Terminal quick fix provider "${a}" is already registered`);return this.w.set(a,g),this.a.$registerQuickFixProvider(a,u),new y.Disposable(()=>{this.w.delete(a),this.a.$unregisterQuickFixProvider(a)})}async $provideTerminalQuickFixes(a,u){const g=new m.CancellationTokenSource().token;if(g.isCancellationRequested)return;const R=this.w.get(a);if(!R)return;const F=await R.provideTerminalQuickFixes(u,g);if(F!==null)return F}async $createContributedProfileTerminal(a,u){const g=new m.CancellationTokenSource().token;let R=await this.v.get(a)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(R&&!("options"in R)&&(R={options:R}),!R||!("options"in R))throw new Error(`No terminal profile options provided for id "${a}"`);if("pty"in R.options){this.createExtensionTerminal(R.options,u);return}this.createTerminalFromOptions(R.options,u)}}async $provideLinks(a,u){const g=this.O(a);if(!g)return[];this.y.delete(a),this.z.get(a)?.dispose(!0);const F=new m.CancellationTokenSource;this.z.set(a,F);const q=[],Z={terminal:g.value,line:u},x=[];for(const T of this.u)x.push(l.Promises.withAsyncBody(async L=>{F.token.onCancellationRequested(()=>L({provider:T,links:[]}));const V=await T.provideTerminalLinks(Z,F.token)||[];F.token.isCancellationRequested||L({provider:T,links:V})}));const N=await Promise.all(x);if(F.token.isCancellationRequested)return[];const $=new Map;for(const T of N)T&&T.links.length>0&&q.push(...T.links.map(L=>{const V={id:p++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return $.set(V.id,{provider:T.provider,link:L}),V}));return this.y.set(a,$),q}$activateLink(a,u){const g=this.y.get(a)?.get(u);!g||g.provider.handleTerminalLink(g.link)}N(a,u){this.s.stopBuffering(a),this.g.delete(a),delete this.j[a];const g=this.h[a];g&&(g.dispose(),delete this.h[a]),this.a.$sendProcessExit(a,u)}O(a){return this.P(this.f,a)}P(a,u){const g=this.Q(a,u);return g!==null?a[g]:null}Q(a,u){let g=null;return a.some((R,F)=>R._id===u?(g=F,!0):!1),g}getEnvironmentVariableCollection(a){let u=this.l.get(a.identifier.value);return u||(u=new d,this.S(a.identifier.value,u)),u}R(a,u){const g=(0,w.serializeEnvironmentVariableCollection)(u.map);this.a.$setEnvironmentVariableCollection(a,u.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(a){a.forEach(u=>{const g=u[0],R=new d(u[1]);this.S(g,R)})}$acceptDefaultProfile(a,u){const g=this.m;this.m=a,this.n=u,g?.path!==a.path&&this.J.fire(a.path)}S(a,u){this.l.set(a,u),u.onDidChangeCollection(()=>{this.R(a,u)})}};r=qe([Ve(1,I.IExtHostRpcService)],r),e.BaseExtHostTerminalService=r;class d{get persistent(){return this.a}set persistent(a){this.a=a,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(a){this.map=new Map,this.a=!0,this.b=new n.Emitter,this.map=new Map(a)}get size(){return this.map.size}replace(a,u){this.d(a,{value:u,type:y.EnvironmentVariableMutatorType.Replace})}append(a,u){this.d(a,{value:u,type:y.EnvironmentVariableMutatorType.Append})}prepend(a,u){this.d(a,{value:u,type:y.EnvironmentVariableMutatorType.Prepend})}d(a,u){const g=this.map.get(a);(!g||g.value!==u.value||g.type!==u.type)&&(this.map.set(a,u),this.b.fire())}get(a){return this.map.get(a)}forEach(a,u){this.map.forEach((g,R)=>a.call(u,R,g,this))}[Symbol.iterator](){return this.map.entries()}delete(a){this.map.delete(a),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let i=class extends r{constructor(a){super(!1,a)}createTerminal(a,u,g){throw new O.NotSupportedError}createTerminalFromOptions(a,u){throw new O.NotSupportedError}};i=qe([Ve(0,I.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function c(h){if(!(!h||typeof h=="string"))return"id"in h?{id:h.id,color:h.color}:h}function t(h){return s.ThemeColor.isThemeColor(h)?h:void 0}});var Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,n):S?S.value=n:e.set(te,n),n};define(Ie[227],Ce([1,0,18,16,24,21,4,192,228,6,22,9,34,5,17,101,8,7,43,71,55,26]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o,l,v,E,P,p){"use strict";var r,d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let i=class{constructor(T,L,V){this.j=V,this.c=new I.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=T.getProxy(b.MainContext.MainThreadTesting),this.h=new Z(this.f),this.g=new a(this.f),L.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const le=j,Y=le.tests[le.tests.length-1].item.extId;return this.d.get(v.TestId.root(Y))?.collection.tree.get(Y)?.actual??(0,s.toItemFromContext)(j)}})}createTestController(T,L,V,j){if(this.d.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const le=new k.DisposableStore,Y=le.add(new s.ExtHostTestItemCollection(L,V,this.j));Y.root.label=V;const pe=new Map,ue=this.f,de={items:Y.root.children,get label(){return V},set label(G){V=G,Y.root.label=G,ue.$updateController(L,{label:V})},get refreshHandler(){return j},set refreshHandler(G){j=G,ue.$updateController(L,{canRefresh:!!G})},get id(){return L},createRunProfile:(G,H,oe,ve,Ae,Be)=>{let xe=(0,y.hash)(G);for(;pe.has(xe);)xe++;return Be!==void 0&&(0,p.checkProposedApiEnabled)(T,"testContinuousRun"),new x(this.f,pe,L,xe,G,H,oe,ve,Ae,Be)},createTestItem(G,H,oe){return new s.TestItemImpl(L,G,H,oe)},createTestRun:(G,H,oe=!0)=>this.g.createTestRun(L,Y,G,H,oe),set resolveHandler(G){Y.resolveHandler=G},get resolveHandler(){return Y.resolveHandler},dispose:()=>{le.dispose()}};ue.$registerTestController(L,V,!!j),le.add((0,k.toDisposable)(()=>ue.$unregisterTestController(L)));const re={controller:de,collection:Y,profiles:pe};return this.d.set(L,re),le.add((0,k.toDisposable)(()=>this.d.delete(L))),le.add(Y.onDidGenerateDiff(G=>ue.$publishDiff(L,G.map(P.TestsDiffOp.serialize)))),de}createTestObserver(){return this.h.checkout()}async runTests(T,L=M.CancellationToken.None){const V=u(T);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(V.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(le=>v.TestId.fromExtHostTestItem(le,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:N[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:T.exclude?.map(le=>le.id)},L)}$syncTests(){for(const{collection:T}of this.d.values())T.flushDiff();return Promise.resolve()}$provideFileCoverage(T,L,V){return(0,n.mapFind)(this.g.trackers,le=>le.id===T?le.getCoverage(L):void 0)?.provideFileCoverage(V)??Promise.resolve([])}$resolveFileCoverage(T,L,V,j){return(0,n.mapFind)(this.g.trackers,Y=>Y.id===T?Y.getCoverage(L):void 0)?.resolveFileCoverage(V,j)??Promise.resolve([])}$configureRunProfile(T,L){this.d.get(T)?.profiles.get(L)?.configureHandler?.()}async $refreshTests(T,L){await this.d.get(T)?.controller.refreshHandler?.(L)}$publishTestResults(T){this.results=Object.freeze(T.map(L=>(0,O.deepFreeze)(o.TestResults.to(L))).concat(this.results).sort((L,V)=>V.completedAt-L.completedAt).slice(0,32)),this.c.fire()}async $expandTest(T,L){const V=this.d.get(v.TestId.fromString(T).controllerId)?.collection;V&&(await V.expand(T,L<0?1/0:L),V.flushDiff())}$acceptDiff(T){this.h.applyDiff(T.map(P.TestsDiffOp.deserialize))}async $runControllerTests(T,L){return Promise.all(T.map(V=>this.k(V,!1,L)))}async $startContinuousRun(T,L){const V=new M.CancellationTokenSource(L),j=await Promise.all(T.map(le=>this.k(le,!0,V.token)));return!L.isCancellationRequested&&!j.some(le=>le.error)&&await new Promise(le=>L.onCancellationRequested(le)),V.dispose(!0),j}async k(T,L,V){const j=this.d.get(T.controllerId);if(!j)return{};const{collection:le,profiles:Y}=j,pe=Y.get(T.profileId);if(!pe)return{};const ue=T.testIds.map(H=>le.tree.get(H)).filter(w.isDefined),de=T.excludeExtIds.map(H=>j.collection.tree.get(H)).filter(w.isDefined).filter(H=>ue.some(oe=>oe.fullId.compare(H.fullId)===2));if(!ue.length)return{};const re=new l.TestRunRequest2(ue.some(H=>H.actual instanceof s.TestItemRootImpl)?void 0:ue.map(H=>H.actual),de.map(H=>H.actual),pe,L),G=(0,P.isStartControllerTests)(T)&&this.g.prepareForMainThreadTestRun(re,g.fromInternal(T,j.collection),V);try{return await pe.runHandler(re,V),{}}catch(H){return{error:String(H)}}finally{G&&(G.hasRunningTasks&&!V.isCancellationRequested&&await I.Event.toPromise(G.onEnd),G.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.g.cancelAllRuns():this.g.cancelRunById(T)}};i=qe([Ve(0,f.IExtHostRpcService)],i),e.ExtHostTesting=i;const c=1e4;var t;(function($){$[$.Running=0]="Running",$[$.Cancelling=1]="Cancelling",$[$.Ended=2]="Ended"})(t||(t={}));class h extends k.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(T,L,V){super(),this.k=T,this.l=L,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new I.Emitter),this.onEnd=this.j.event,this.h=this.B(new M.CancellationTokenSource(V));const j=this.B(new C.RunOnceScheduler(()=>this.m(),c));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(T){return this.f.get(T)?.coverage}createRun(T){const L=this.k.id,V=this.k.controllerId,j=(0,m.generateUuid)(),le=new R(this.l,L,j),Y=re=>(G,...H)=>{if(ue){console.warn(`Setting the state of test "${G.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(G)||(this.s(G),re(G,...H))},pe=(re,G)=>{const H=G instanceof Array?G.map(o.TestMessage.from):[o.TestMessage.from(G)];if(re.uri&&re.range){const oe={range:o.Range.from(re.range),uri:re.uri};for(const ve of H)ve.location=ve.location||oe}this.l.$appendTestMessagesInRun(L,j,v.TestId.fromExtHostTestItem(re,V).toString(),H)};let ue=!1;const de={isPersisted:this.k.isPersisted,token:this.h.token,name:T,get coverageProvider(){return le.coverageProvider},set coverageProvider(re){le.coverageProvider=re},enqueued:Y(re=>{this.l.$updateTestStateInRun(L,j,v.TestId.fromExtHostTestItem(re,V).toString(),1)}),skipped:Y(re=>{this.l.$updateTestStateInRun(L,j,v.TestId.fromExtHostTestItem(re,V).toString(),5)}),started:Y(re=>{this.l.$updateTestStateInRun(L,j,v.TestId.fromExtHostTestItem(re,V).toString(),2)}),errored:Y((re,G,H)=>{pe(re,G),this.l.$updateTestStateInRun(L,j,v.TestId.fromExtHostTestItem(re,V).toString(),6,H)}),failed:Y((re,G,H)=>{pe(re,G),this.l.$updateTestStateInRun(L,j,v.TestId.fromExtHostTestItem(re,V).toString(),4,H)}),passed:Y((re,G)=>{this.l.$updateTestStateInRun(L,j,v.TestId.fromExtHostTestItem(re,this.k.controllerId).toString(),3,G)}),appendOutput:(re,G,H)=>{ue||(H&&(this.k.isIncluded(H)?this.s(H):H=void 0),this.l.$appendOutputToRun(L,j,S.VSBuffer.fromString(re),G&&o.location.from(G),H&&v.TestId.fromExtHostTestItem(H,V).toString()))},end:()=>{ue||(ue=!0,this.l.$finishedTestRunTask(L,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:de,coverage:le}),this.l.$startedTestRunTask(L,{id:j,name:T,running:!0}),de}m(){for(const{run:T}of this.f.values())T.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(T){if(!(T instanceof s.TestItemImpl))throw new E.InvalidTestItemError(T.id);if(this.g.has(v.TestId.fromExtHostTestItem(T,this.k.controllerId).toString()))return;const L=[],V=this.k.colllection.root;for(;;){const j=o.TestItem.from(T);if(L.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),T===V))break;T=T.parent||V}this.l.$addTestsToRun(this.k.controllerId,this.k.id,L)}}class a{get trackers(){return this.c.values()}constructor(T){this.d=T,this.c=new Map}prepareForMainThreadTestRun(T,L,V){return this.f(T,L,V)}cancelRunById(T){for(const L of this.c.values())if(L.id===T){L.cancel();return}}cancelAllRuns(){for(const T of this.c.values())T.cancel()}createTestRun(T,L,V,j,le){const Y=this.c.get(V);if(Y)return Y.createRun(j);const pe=g.fromPublic(T,L,V,le),ue=u(V);this.d.$startedExtensionTestRun({controllerId:T,continuous:!!V.continuous,profile:ue&&{group:N[ue.kind],id:ue.profileId},exclude:V.exclude?.map(re=>v.TestId.fromExtHostTestItem(re,L.root.id).toString())??[],id:pe.id,include:V.include?.map(re=>v.TestId.fromExtHostTestItem(re,L.root.id).toString())??[L.root.id],persist:le});const de=this.f(V,pe);return de.onEnd(()=>{this.d.$finishedExtensionTestRun(pe.id),de.dispose()}),de.createRun(j)}f(T,L,V){const j=new h(L,this.d,V);return this.c.set(T,j),j.onEnd(()=>this.c.delete(T)),j}}e.TestRunCoordinator=a;const u=$=>{if(!!$.profile){if(!($.profile instanceof x))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return $.profile}};class g{static fromPublic(T,L,V,j){return new g(T,(0,m.generateUuid)(),V.include?.map(le=>v.TestId.fromExtHostTestItem(le,T).toString())??[T],V.exclude?.map(le=>v.TestId.fromExtHostTestItem(le,T).toString())??[],j,L)}static fromInternal(T,L){return new g(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,L)}constructor(T,L,V,j,le,Y){this.controllerId=T,this.id=L,this.isPersisted=le,this.colllection=Y,this.c=V.map(pe=>pe+"\0"),this.d=j.map(pe=>pe+"\0")}isIncluded(T){const L=v.TestId.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const V of this.d)if(L===V||L.startsWith(V))return!1;for(const V of this.c)if(L===V||L.startsWith(V))return!0;return!1}}e.TestRunDto=g;class R{set coverageProvider(T){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!T||(this.c=T,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(T,L,V){this.f=T,this.g=L,this.h=V}async provideFileCoverage(T){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(T))());try{return(await this.d)?.map(o.TestCoverage.fromFile)??[]}catch(L){throw this.d=void 0,L}}async resolveFileCoverage(T,L){const V=await this.d;let j=V?.[T];return!this.c||!V||!j?[]:(j.detailedCoverage||(j=V[T]=await this.c.resolveFileCoverage?.(j,L)??j),j.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class F{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(T){this.h=T,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(T){this.c.add(T)}update(T){Object.assign(T.revived,o.TestItem.toPlain(T.item)),this.c.has(T)||this.d.add(T)}remove(T){if(this.c.has(T)){this.c.delete(T);return}this.d.delete(T);const L=v.TestId.parentId(T.item.extId);if(L&&this.g.has(L.toString())){this.g.add(T.item.extId);return}this.f.add(T)}getChangeEvent(){const{c:T,d:L,f:V}=this;return{get added(){return[...T].map(j=>j.revived)},get updated(){return[...L].map(j=>j.revived)},get removed(){return[...V].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class q extends P.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new I.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(T){return this.d.get(T)}getMirroredTestDataByReference(T){return this.d.get(T.id)}p(T,L){return{...T,revived:o.TestItem.toPlain(T.item),depth:L?L.depth+1:0,children:new Set}}o(){return new F(this.q)}}class Z{constructor(T){this.d=T}checkout(){this.c||(this.c=this.f());const T=this.c;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(L=>L.revived)},dispose:(0,A.once)(()=>{--T.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(T){return this.c?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.c?.tests.apply(T)}f(){const T=new q;return this.d.$subscribeToDiffs(),{observers:0,tests:T}}}class x{get label(){return this.d}set label(T){T!==this.d&&(this.d=T,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:T}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(T){T!==this.g&&(this.g=T,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:T}))}get isDefault(){return this.f}set isDefault(T){T!==this.f&&(this.f=T,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:T?o.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.c}set configureHandler(T){T!==this.c&&(this.c=T,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!T}))}constructor(T,L,V,j,le,Y,pe,ue=!1,de=void 0,re=!1){this.controllerId=V,this.profileId=j,this.d=le,this.kind=Y,this.runHandler=pe,this.f=ue,this._tag=de,this.g=re,r.set(this,void 0),d.set(this,void 0),Je(this,r,T,"f"),Je(this,d,L,"f"),L.set(j,this);const G=N[Y];if(typeof G!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);Oe(this,r,"f").$publishTestRunProfile({profileId:j,controllerId:V,tag:de?o.TestTag.namespace(this.controllerId,de.id):null,label:le,group:G,isDefault:ue,hasConfigurationHandler:!1,supportsContinuousRun:re})}dispose(){Oe(this,d,"f")?.delete(this.profileId)&&(Je(this,d,void 0,"f"),Oe(this,r,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=x,r=new WeakMap,d=new WeakMap;const N={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(Ie[229],Ce([1,0,18,4,5,102,8,7]),function(te,e,n,C,S,M,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(O,w){this.i=w,this.a=new C.Emitter,this.b=new C.Emitter,this.c=new C.Emitter,this.d=new C.Emitter,this.f=new C.Emitter,this.g=new C.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=O.getProxy(S.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(O){const w=this.i.allEditors();return O?w:w.map(m=>m.value)}async showTextDocument(O,w,m){let b;typeof w=="number"?b={position:I.ViewColumn.from(w),preserveFocus:m}:typeof w=="object"?b={position:I.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?I.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:b={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(O.uri,b),s=f&&this.i.getEditor(f);if(s)return s.value;throw f?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,w){return new M.TextEditorDecorationType(this.h,O,w).value}$acceptEditorPropertiesChanged(O,w){const m=this.i.getEditor(O);if(!m)throw new Error("unknown text editor");if(w.options&&m._acceptOptions(w.options),w.selections){const b=w.selections.selections.map(I.Selection.to);m._acceptSelections(b)}if(w.visibleRanges){const b=n.coalesce(w.visibleRanges.map(I.Range.to));m._acceptVisibleRanges(b)}if(w.options&&this.b.fire({textEditor:m.value,options:{...w.options,lineNumbers:I.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const b=A.TextEditorSelectionChangeKind.fromValue(w.selections.source),f=w.selections.selections.map(I.Selection.to);this.a.fire({textEditor:m.value,selections:f,kind:b})}if(w.visibleRanges){const b=n.coalesce(w.visibleRanges.map(I.Range.to));this.c.fire({textEditor:m.value,visibleRanges:b})}}$acceptEditorPositionData(O){for(const w in O){const m=this.i.getEditor(w);if(!m)throw new Error("Unknown text editor");const b=I.ViewColumn.to(O[w]);m.value.viewColumn!==b&&(m._acceptViewColumn(b),this.d.fire({textEditor:m.value,viewColumn:b}))}}getDiffInformation(O){return Promise.resolve(this.h.$getDiffInformation(O))}}e.ExtHostEditors=y}),define(Ie[230],Ce([1,0,2,3,5,6,7,8,25,9]),function(te,e,n,C,S,M,I,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class O{constructor(b,f){this.b=new Map,this.c=new Map,this.a=b.getProxy(S.MainContext.MainThreadTimeline),f.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&y.ExtensionIdentifier.equals(o,this.b.get(s.source)?.extension)){const l=s.uri===void 0?void 0:n.URI.revive(s.uri);return this.c.get(s.source)?.get(w(l))?.get(s.handle)}else return;return s}})}async $getTimeline(b,f,s,o){return this.b.get(b)?.provider.provideTimeline(n.URI.revive(f),s,o)}registerTimelineProvider(b,f,s,o){const l=new M.DisposableStore,v=this.d(f.id,o,l).bind(this);let E;f.onDidChange&&(E=f.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:f.id}),this));const P=this.c;return this.f({...f,scheme:b,onDidChange:void 0,async provideTimeline(p,r,d){r?.resetCache&&(l.clear(),P.get(f.id)?.clear());const i=await f.provideTimeline(p,r,d);if(i==null)return;const c=v(p,r);return{...i,source:f.id,items:i.items.map(c)}},dispose(){for(const p of P.values())p.get(f.id)?.clear();E?.dispose(),l.dispose()}},s)}d(b,f,s){return(o,l)=>{let v;if(l?.cacheResults){let E=this.c.get(b);E===void 0&&(E=new Map,this.c.set(b,E));const P=w(o);v=E.get(P),v===void 0&&(v=new Map,E.set(P,v))}return E=>{const{iconPath:P,...p}=E,r=`${b}|${E.id??E.timestamp}`;v?.set(r,E);let d,i,c;E.iconPath&&(P instanceof I.ThemeIcon?c={id:P.id,color:P.color}:n.URI.isUri(P)?(d=P,i=P):{light:d,dark:i}=P);let t;return I.MarkdownString.isMarkdownString(p.tooltip)?t=A.MarkdownString.from(p.tooltip):(0,k.isString)(p.tooltip)?t=p.tooltip:I.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),t=A.MarkdownString.from(p.detail)):(0,k.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),t=p.detail),{...p,id:p.id??void 0,handle:r,source:b,command:E.command?f.toInternal(E.command,s):void 0,icon:d,iconDark:i,themeIcon:c,tooltip:t,accessibilityInformation:E.accessibilityInformation}}}}f(b,f){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:f}),(0,M.toDisposable)(()=>{for(const o of this.c.values())o.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.ExtHostTimeline=O;function w(m){return m?.toString()}}),define(Ie[231],Ce([1,0,6,15,2,5]),function(te,e,n,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(y){this.c=new Map,this.b=y.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,k,O,w){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const m=w.schemes.find(b=>!I.a.has(b));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(k,O),this.b.$registerUriOpener(k,w.schemes,y,w.label),(0,n.toDisposable)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(y,k,O){const w=this.c.get(y);if(!w)throw new Error(`Unknown opener with id: ${y}`);const m=S.URI.revive(k);return w.canOpenExternalUri(m,O)}async $openUri(y,k,O){const w=this.c.get(y);if(!w)throw new Error(`Unknown opener id: '${y}'`);return w.openExternalUri(S.URI.revive(k.resolvedUri),{sourceUri:S.URI.revive(k.sourceUri)},O)}}e.ExtHostUriOpeners=I,I.a=new Set([C.Schemas.http,C.Schemas.https])}),define(Ie[232],Ce([1,0,5,2,6,11,25]),function(te,e,n,C,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(k){this.c=new Set,this.d=new Map,this.b=k.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(k,O){if(this.c.has(I.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const w=A.a++;return this.c.add(I.ExtensionIdentifier.toKey(k)),this.d.set(w,O),this.b.$registerUriHandler(w,k),(0,S.toDisposable)(()=>{this.c.delete(I.ExtensionIdentifier.toKey(k)),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(k,O){const w=this.d.get(k);if(!w)return Promise.resolve(void 0);try{w.handleUri(C.URI.revive(O))}catch(m){(0,M.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(k){return C.URI.revive(await this.b.$createAppUri(k))}}e.ExtHostUrls=A,A.a=0});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,n):S?S.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ie[61],Ce([1,0,4,15,22,2,155,177,72,5]),function(te,e,n,C,S,M,I,A,y,k){"use strict";var O,w,m,b,f,s,o,l,v,E,P,p,r;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(F,q,Z,x,N,$,T){O.set(this,void 0),w.set(this,void 0),m.set(this,void 0),b.set(this,void 0),f.set(this,void 0),s.set(this,void 0),o.set(this,""),l.set(this,void 0),v.set(this,!1),E.set(this,!1),P.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new n.Emitter),this._onDidDispose=Oe(this,r,"f").event,Je(this,O,F,"f"),Je(this,w,q,"f"),Je(this,l,Z,"f"),Je(this,b,x,"f"),Je(this,f,N,"f"),Je(this,s,$,"f"),Je(this,P,i($),"f"),Je(this,p,c($),"f"),Je(this,m,T,"f")}dispose(){Je(this,v,!0,"f"),Oe(this,r,"f").fire(),Oe(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(F){return Je(this,E,!0,"f"),(0,y.asWebviewUri)(F,Oe(this,b,"f"))}get cspSource(){const F=Oe(this,s,"f").extensionLocation;if(F.scheme===C.Schemas.https||F.scheme===C.Schemas.http){let q=F.toString();return q.endsWith("/")||(q+="/"),q+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Oe(this,o,"f")}set html(F){this.a(),Oe(this,o,"f")!==F&&(Je(this,o,F,"f"),Oe(this,p,"f")&&!Oe(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(F)&&(Je(this,E,!0,"f"),Oe(this,m,"f").report("Webview vscode-resource: uris",Oe(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,w,"f").$setHtml(Oe(this,O,"f"),this.b(F)))}get options(){return this.a(),Oe(this,l,"f")}set options(F){this.a(),S.equals(Oe(this,l,"f"),F)||Oe(this,w,"f").$setOptions(Oe(this,O,"f"),a(Oe(this,s,"f"),Oe(this,f,"f"),F)),Je(this,l,F,"f")}async postMessage(F){if(Oe(this,v,"f"))return!1;const q=(0,A.serializeWebviewMessage)(F,{serializeBuffersForPostMessage:Oe(this,P,"f")});return Oe(this,w,"f").$postMessage(Oe(this,O,"f"),q.message,...q.buffers)}a(){if(Oe(this,v,"f"))throw new Error("Webview is disposed")}b(F){if(!Oe(this,p,"f"))return F;const q=Oe(this,s,"f").extensionLocation?.scheme===C.Schemas.vscodeRemote,Z=Oe(this,s,"f").extensionLocation.scheme===C.Schemas.vscodeRemote?Oe(this,s,"f").extensionLocation.authority:void 0;return F.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,N,$,T,L,V)=>{const j=M.URI.from({scheme:T||"file",path:decodeURIComponent(L)}),le=(0,y.asWebviewUri)(j,{isRemote:q,authority:Z}).toString();return`${N}${le}${V}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,N,$,T,L,V)=>{const j=M.URI.from({scheme:T||"file",path:decodeURIComponent(L)}),le=(0,y.asWebviewUri)(j,{isRemote:q,authority:Z}).toString();return`${N}${le}${V}`})}}e.ExtHostWebview=d,O=new WeakMap,w=new WeakMap,m=new WeakMap,b=new WeakMap,f=new WeakMap,s=new WeakMap,o=new WeakMap,l=new WeakMap,v=new WeakMap,E=new WeakMap,P=new WeakMap,p=new WeakMap,r=new WeakMap;function i(R){try{const F=(0,I.normalizeVersion)((0,I.parseVersion)(R.engines.vscode));return!!F&&F.majorBase>=1&&F.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=i;function c(R){try{const F=(0,I.normalizeVersion)((0,I.parseVersion)(R.engines.vscode));return F?F.majorBase<1||F.majorBase===1&&F.minorBase<60:!1}catch{return!1}}class t{constructor(F,q,Z,x,N){this.c=q,this.d=Z,this.e=x,this.f=N,this.b=new Map,this.a=F.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(F,q,Z){const x=this.g(F);if(x){const{message:N}=(0,A.deserializeWebviewMessage)(q,Z.value);x._onMessageEmitter.fire(N)}}$onMissingCsp(F,q){this.e.warn(`${q} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(F,q,Z){const x=new d(F,this.a,u(q),this.c,this.d,Z,this.f);return this.b.set(F,x),x._onDidDispose(()=>{this.b.delete(F)}),x}deleteWebview(F){this.b.delete(F)}g(F){return this.b.get(F)}}e.ExtHostWebviews=t;function h(R){return{id:R.identifier,location:R.extensionLocation}}e.toExtensionData=h;function a(R,F,q){return{enableCommandUris:q.enableCommandUris,enableScripts:q.enableScripts,enableForms:q.enableForms,portMapping:q.portMapping,localResourceRoots:q.localResourceRoots||g(R,F)}}e.serializeWebviewOptions=a;function u(R){return{enableCommandUris:R.enableCommandUris,enableScripts:R.enableScripts,enableForms:R.enableForms,portMapping:R.portMapping,localResourceRoots:R.localResourceRoots?.map(F=>M.URI.from(F))}}function g(R,F){return[...(F?.getWorkspaceFolders()||[]).map(q=>q.uri),R.extensionLocation]}}),define(Ie[233],Ce([1,0,21,228,6,15,23,2,8,61,53,5,7]),function(te,e,n,C,S,M,I,A,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(d,i){this.document=d,this.b=i,this.a=1,this.c=new O.Cache("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,i){await this.f(d).undo(),i||this.disposeBackup()}async redo(d,i){await this.f(d).redo(),i||this.disposeBackup()}disposeEdits(d){for(const i of d)this.c.delete(i)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=p(this.document.uri)+this.a++;return(0,I.joinPath)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const i=this.c.get(d,0);if(!i)throw new Error("No edit found");return i}}class f{constructor(){this.a=new Map}get(d,i){return this.a.get(this.b(d,i))}add(d,i,c){const t=this.b(d,i.uri);if(this.a.has(t))throw new Error(`Document already exists for viewType:${d} resource:${i.uri}`);const h=new b(i,c);return this.a.set(t,h),h}delete(d,i){const c=this.b(d,i.uri);this.a.delete(c)}b(d,i){return`${d}@@@${i}`}}var s;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(s||(s={}));class o{constructor(){this.a=new Map}addTextProvider(d,i,c){return this.b(0,d,i,c)}addCustomProvider(d,i,c){return this.b(1,d,i,c)}get(d){return this.a.get(d)}b(d,i,c,t){if(this.a.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this.a.set(i,{type:d,extension:c,provider:t}),new m.Disposable(()=>this.a.delete(i))}}class l{constructor(d,i,c,t,h){this.d=i,this.f=c,this.g=t,this.h=h,this.b=new o,this.c=new f,this.a=d.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(d,i,c,t){const h=new S.DisposableStore;return E(c)?(h.add(this.b.addTextProvider(i,d,c)),this.a.$registerTextEditorProvider((0,k.toExtensionData)(d),i,t.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(d))):(h.add(this.b.addCustomProvider(i,d,c)),v(c)&&h.add(c.onDidChangeCustomDocument(a=>{const u=this.i(i,a.document.uri);if(P(a)){const g=u.addEdit(a);this.a.$onDidEdit(a.document.uri,i,g,a.label)}else this.a.$onContentChange(a.document.uri,i)})),this.a.$registerCustomEditorProvider((0,k.toExtensionData)(d),i,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(d))),m.Disposable.from(h,new m.Disposable(()=>{this.a.$unregisterEditorProvider(i)}))}async $createCustomDocument(d,i,c,t,h){const a=this.b.get(i);if(!a)throw new Error(`No provider found for '${i}'`);if(a.type!==1)throw new Error(`Invalid provide type for '${i}'`);const u=A.URI.revive(d),g=await a.provider.openCustomDocument(u,{backupId:c,untitledDocumentData:t?.buffer},h);let R;return v(a.provider)&&this.f&&(R=this.f.workspaceValue(a.extension)??this.f.globalValue(a.extension)),this.c.add(i,g,R),{editable:v(a.provider)}}async $disposeCustomDocument(d,i){const c=this.b.get(i);if(!c)throw new Error(`No provider found for '${i}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${i}'`);const t=A.URI.revive(d),{document:h}=this.i(i,t);this.c.delete(i,h),h.dispose()}async $resolveCustomEditor(d,i,c,t,h,a){console.log("xxxx");const u=this.b.get(c);if(!u)throw new Error(`No provider found for '${c}'`);const g=y.ViewColumn.to(h),R=this.g.createNewWebview(i,t.contentOptions,u.extension),F=this.h.createNewWebviewPanel(i,c,t.title,g,t.options,R,!0),q=A.URI.revive(d);switch(u.type){case 1:{const{document:Z}=this.i(c,q);return u.provider.resolveCustomEditor(Z,F,a)}case 0:{const Z=this.d.getDocument(q);return u.provider.resolveCustomTextEditor(Z,F,a)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,i,c){this.i(i,d).disposeEdits(c)}async $onMoveCustomEditor(d,i,c){const t=this.b.get(c);if(!t)throw new Error(`No provider found for '${c}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const h=this.h.getWebviewPanel(d);if(!h)throw new Error("No webview found");const a=A.URI.revive(i),u=this.d.getDocument(a);await t.provider.moveCustomTextEditor(u,h,n.CancellationToken.None)}async $undo(d,i,c,t){return this.i(i,d).undo(c,t)}async $redo(d,i,c,t){return this.i(i,d).redo(c,t)}async $revert(d,i,c){const t=this.i(i,d);await this.j(i).revertCustomDocument(t.document,c),t.disposeBackup()}async $onSave(d,i,c){const t=this.i(i,d);await this.j(i).saveCustomDocument(t.document,c),t.disposeBackup()}async $onSaveAs(d,i,c,t){const h=this.i(i,d);return this.j(i).saveCustomDocumentAs(h.document,A.URI.revive(c),t)}async $backup(d,i,c){const t=this.i(i,d),a=await this.j(i).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},c);return t.updateBackup(a),a.id}i(d,i){const c=this.c.get(d,A.URI.revive(i));if(!c)throw new Error("No custom document found");return c}j(d){const c=this.b.get(d)?.provider;if(!c||!v(c))throw new Error("Custom document is not editable");return c}}e.ExtHostCustomEditors=l;function v(r){return!!r.onDidChangeCustomDocument}function E(r){return typeof r.resolveCustomTextEditor=="function"}function P(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function p(r){const d=r.scheme===M.Schemas.file||r.scheme===M.Schemas.untitled?r.fsPath:r.toString();return(0,C.hash)(d)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,n):S?S.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ie[234],Ce([1,0,4,6,2,34,8,61,5,7]),function(te,e,n,C,S,M,I,A,y,k){"use strict";var O,w,m,b,f,s,o,l,v,E,P,p,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends C.Disposable{constructor(h,a,u,g){super(),O.set(this,void 0),w.set(this,void 0),m.set(this,void 0),b.set(this,void 0),f.set(this,void 0),s.set(this,void 0),o.set(this,void 0),l.set(this,void 0),v.set(this,!0),E.set(this,void 0),P.set(this,!1),p.set(this,this.B(new n.Emitter)),this.onDidDispose=Oe(this,p,"f").event,r.set(this,this.B(new n.Emitter)),this.onDidChangeViewState=Oe(this,r,"f").event,Je(this,O,h,"f"),Je(this,w,a,"f"),Je(this,b,u,"f"),Je(this,m,g.viewType,"f"),Je(this,f,g.panelOptions,"f"),Je(this,l,g.viewColumn,"f"),Je(this,s,g.title,"f"),Je(this,E,g.active,"f")}dispose(){Oe(this,P,"f")||(Je(this,P,!0,"f"),Oe(this,p,"f").fire(),Oe(this,w,"f").$disposeWebview(Oe(this,O,"f")),Oe(this,b,"f").dispose(),super.dispose())}get webview(){return this.c(),Oe(this,b,"f")}get viewType(){return this.c(),Oe(this,m,"f")}get title(){return this.c(),Oe(this,s,"f")}set title(h){this.c(),Oe(this,s,"f")!==h&&(Je(this,s,h,"f"),Oe(this,w,"f").$setTitle(Oe(this,O,"f"),h))}get iconPath(){return this.c(),Oe(this,o,"f")}set iconPath(h){this.c(),Oe(this,o,"f")!==h&&(Je(this,o,h,"f"),Oe(this,w,"f").$setIconPath(Oe(this,O,"f"),S.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.c(),!(typeof Oe(this,l,"f")=="number"&&Oe(this,l,"f")<0))return Oe(this,l,"f")}get active(){return this.c(),Oe(this,E,"f")}get visible(){return this.c(),Oe(this,v,"f")}_updateViewState(h){Oe(this,P,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(Je(this,E,h.active,"f"),Je(this,v,h.visible,"f"),Je(this,l,h.viewColumn,"f"),Oe(this,r,"f").fire({webviewPanel:this}))}reveal(h,a){this.c(),Oe(this,w,"f").$reveal(Oe(this,O,"f"),{viewColumn:typeof h>"u"?void 0:I.ViewColumn.from(h),preserveFocus:!!a})}c(){if(Oe(this,P,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,w=new WeakMap,m=new WeakMap,b=new WeakMap,f=new WeakMap,s=new WeakMap,o=new WeakMap,l=new WeakMap,v=new WeakMap,E=new WeakMap,P=new WeakMap,p=new WeakMap,r=new WeakMap;class i{static c(){return(0,M.generateUuid)()}constructor(h,a,u){this.g=a,this.h=u,this.e=new Map,this.f=new Map,this.d=h.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(h,a,u,g,R={}){const F=typeof g=="object"?g.viewColumn:g,q={viewColumn:I.ViewColumn.from(F),preserveFocus:typeof g=="object"&&!!g.preserveFocus},Z=(0,A.shouldSerializeBuffersForPostMessage)(h),x=i.c();this.d.$createWebviewPanel((0,A.toExtensionData)(h),x,a,{title:u,panelOptions:c(R),webviewOptions:(0,A.serializeWebviewOptions)(h,this.h,R),serializeBuffersForPostMessage:Z},q);const N=this.g.createNewWebview(x,R,h);return this.createNewWebviewPanel(x,a,u,F,R,N,!0)}$onDidChangeWebviewPanelViewStates(h){const a=Object.keys(h);a.sort((u,g)=>{const R=h[u],F=h[g];return R.active?1:F.active?-1:+R.visible-+F.visible});for(const u of a){const g=this.getWebviewPanel(u);if(!g)continue;const R=h[u];g._updateViewState({active:R.active,visible:R.visible,viewColumn:I.ViewColumn.to(R.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this.e.delete(h),this.g.deleteWebview(h)}registerWebviewPanelSerializer(h,a,u){if(this.f.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.f.set(a,{serializer:u,extension:h}),this.d.$registerSerializer(a,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(h)}),new k.Disposable(()=>{this.f.delete(a),this.d.$unregisterSerializer(a)})}async $deserializeWebviewPanel(h,a,u,g){const R=this.f.get(a);if(!R)throw new Error(`No serializer found for '${a}'`);const{serializer:F,extension:q}=R,Z=this.g.createNewWebview(h,u.webviewOptions,q),x=this.createNewWebviewPanel(h,a,u.title,g,u.panelOptions,Z,u.active);await F.deserializeWebviewPanel(x,u.state)}createNewWebviewPanel(h,a,u,g,R,F,q){const Z=new d(h,this.d,F,{viewType:a,title:u,viewColumn:g,panelOptions:R,active:q});return this.e.set(h,Z),Z}getWebviewPanel(h){return this.e.get(h)}}e.ExtHostWebviewPanels=i;function c(t){return{enableFindWidget:t.enableFindWidget,retainContextWhenHidden:t.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,n):S?S.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ie[235],Ce([1,0,4,6,61,8,5,7]),function(te,e,n,C,S,M,I,A){"use strict";var y,k,O,w,m,b,f,s,o,l,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class E extends C.Disposable{constructor(r,d,i,c,t,h){super(),y.set(this,void 0),k.set(this,void 0),O.set(this,void 0),w.set(this,void 0),m.set(this,!1),b.set(this,void 0),f.set(this,void 0),s.set(this,void 0),o.set(this,void 0),l.set(this,this.B(new n.Emitter)),this.onDidChangeVisibility=Oe(this,l,"f").event,v.set(this,this.B(new n.Emitter)),this.onDidDispose=Oe(this,v,"f").event,Je(this,O,i,"f"),Je(this,f,c,"f"),Je(this,y,r,"f"),Je(this,k,d,"f"),Je(this,w,t,"f"),Je(this,b,h,"f")}dispose(){Oe(this,m,"f")||(Je(this,m,!0,"f"),Oe(this,v,"f").fire(),Oe(this,w,"f").dispose(),super.dispose())}get title(){return this.a(),Oe(this,f,"f")}set title(r){this.a(),Oe(this,f,"f")!==r&&(Je(this,f,r,"f"),Oe(this,k,"f").$setWebviewViewTitle(Oe(this,y,"f"),r))}get description(){return this.a(),Oe(this,s,"f")}set description(r){this.a(),Oe(this,s,"f")!==r&&(Je(this,s,r,"f"),Oe(this,k,"f").$setWebviewViewDescription(Oe(this,y,"f"),r))}get visible(){return Oe(this,b,"f")}get webview(){return Oe(this,w,"f")}get viewType(){return Oe(this,O,"f")}_setVisible(r){r===Oe(this,b,"f")||Oe(this,m,"f")||(Je(this,b,r,"f"),Oe(this,l,"f").fire())}get badge(){return this.a(),Oe(this,o,"f")}set badge(r){this.a(),!(r?.value===Oe(this,o,"f")?.value&&r?.tooltip===Oe(this,o,"f")?.tooltip)&&(Je(this,o,M.ViewBadge.from(r),"f"),Oe(this,k,"f").$setWebviewViewBadge(Oe(this,y,"f"),r))}show(r){this.a(),Oe(this,k,"f").$show(Oe(this,y,"f"),!!r)}a(){if(Oe(this,m,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,k=new WeakMap,O=new WeakMap,w=new WeakMap,m=new WeakMap,b=new WeakMap,f=new WeakMap,s=new WeakMap,o=new WeakMap,l=new WeakMap,v=new WeakMap;class P{constructor(r,d){this.d=d,this.b=new Map,this.c=new Map,this.a=r.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,d,i,c){if(this.b.has(d))throw new Error(`View provider for '${d}' already registered`);return this.b.set(d,{provider:i,extension:r}),this.a.$registerWebviewViewProvider((0,S.toExtensionData)(r),d,{retainContextWhenHidden:c?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(r)}),new A.Disposable(()=>{this.b.delete(d),this.a.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(r,d,i,c,t){const h=this.b.get(d);if(!h)throw new Error(`No view provider found for '${d}'`);const{provider:a,extension:u}=h,g=this.d.createNewWebview(r,{},u),R=new E(r,this.a,d,i,g,!0);this.c.set(r,R),await a.resolveWebviewView(R,{state:c},t)}async $onDidChangeWebviewViewVisibility(r,d){this.e(r)._setVisible(d)}async $disposeWebviewView(r){const d=this.e(r);this.c.delete(r),d.dispose(),this.d.deleteWebview(r)}e(r){const d=this.c.get(r);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=P}),define(Ie[104],Ce([1,0,4,5,2,15,10,3,17]),function(te,e,n,C,S,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class sn{get state(){return this.d}constructor(w){this.c=new n.Emitter,this.onDidChangeWindowState=this.c.event,this.d=sn.a,this.b=w.getProxy(C.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}$onDidChangeWindowFocus(w){w!==this.d.focused&&(this.d={...this.d,focused:w},this.c.fire(this.d))}openUri(w,m){let b;if(typeof w=="string"){b=w;try{w=S.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,I.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,b,m)}async asExternalUri(w,m){if((0,I.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(w,m);return S.URI.from(b)}};k.a={focused:!0},k=qe([Ve(0,y.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ie[236],Ce([1,0,207,27,17]),function(te,e,n,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends n.AbstractExtHostConsoleForwarder{constructor(A,y){super(A,y)}f(A,y,k){y.apply(console,k)}};M=qe([Ve(0,S.IExtHostRpcService),Ve(1,C.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(Ie[237],Ce([1,0,16,24,21,11,4,6,126,201,44]),function(te,e,n,C,S,M,I,A,y,k,O){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(R,F){try{return JSON.stringify(R,F)}catch{return"null"}}const b="$$ref$$",f={[b]:-1};class s{constructor(F,q){this.jsonString=F,this.referencedBuffers=q}}function o(R,F=null,q=!1){const Z=[];return{jsonString:(q?m:JSON.stringify)(R,(N,$)=>{if(typeof $>"u")return f;if(typeof $=="object"){if($ instanceof C.VSBuffer){const T=Z.push($)-1;return{[b]:T}}if(F)return F(N,$)}return $}),referencedBuffers:Z}}e.stringifyJsonWithBufferRefs=o;function l(R,F,q){return JSON.parse(R,(Z,x)=>{if(x){const N=x[b];if(typeof N=="number")return F[N];if(q&&x.$mid===1)return q.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=l;function v(R,F){return JSON.stringify(R,F)}function E(R){return R?(F,q)=>q&&q.$mid===1?R.transformOutgoing(q):q:null}var P;(function(R){R[R.LocalSide=0]="LocalSide",R[R.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(R){R[R.Responsive=0]="Responsive",R[R.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},d=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class c extends A.Disposable{constructor(F,q=null,Z=null){super(),this[w]=!0,this.b=this.B(new I.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=F,this.f=q,this.g=Z,this.h=E(this.g),this.j=!1,this.k=[],this.l=[];for(let x=0,N=O.ProxyIdentifier.count;x<N;x++)this.k[x]=null,this.l[x]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new n.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(x=>this.G(x))}dispose(){this.j=!0,Object.keys(this.s).forEach(F=>{this.s[F].resolveErr(M.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(F){this.u===0&&(this.v=Date.now()+c.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(F){this.v=Date.now()+c.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(F){this.t!==F&&(this.t=F,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(F){return this.g?(0,y.transformIncomingURIs)(F,this.g):F}getProxy(F){const{nid:q,sid:Z}=F;return this.l[q]||(this.l[q]=this.F(q,Z)),this.l[q]}F(F,q){const Z={get:(x,N)=>(typeof N=="string"&&!x[N]&&N.charCodeAt(0)===36&&(x[N]=(...$)=>this.O(F,N,$)),N===i?q:x[N])};return new Proxy(Object.create(null),Z)}set(F,q){return this.k[F.nid]=q,q}assertRegistered(F){for(let q=0,Z=F.length;q<Z;q++){const x=F[q];if(!this.k[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}G(F){if(this.j)return;const q=F.byteLength,Z=t.read(F,0),x=Z.readUInt8(),N=Z.readUInt32();switch(x){case 1:case 2:{let{rpcId:$,method:T,args:L}=a.deserializeRequestJSONArgs(Z);this.g&&(L=(0,y.transformIncomingURIs)(L,this.g)),this.H(q,N,$,T,L,x===2);break}case 3:case 4:{let{rpcId:$,method:T,args:L}=a.deserializeRequestMixedArgs(Z);this.g&&(L=(0,y.transformIncomingURIs)(L,this.g)),this.H(q,N,$,T,L,x===4);break}case 5:{this.f?.logIncoming(q,N,0,"ack"),this.z(N);break}case 6:{this.I(q,N);break}case 7:{this.J(q,N,void 0);break}case 9:{let $=a.deserializeReplyOKJSON(Z);this.g&&($=(0,y.transformIncomingURIs)($,this.g)),this.J(q,N,$);break}case 10:{const $=a.deserializeReplyOKJSONWithBuffers(Z,this.g);this.J(q,N,$);break}case 8:{const $=a.deserializeReplyOKVSBuffer(Z);this.J(q,N,$);break}case 11:{let $=a.deserializeReplyErrError(Z);this.g&&($=(0,y.transformIncomingURIs)($,this.g)),this.L(q,N,$);break}case 12:{this.L(q,N,void 0);break}default:console.error("received unexpected message"),console.error(F)}}H(F,q,Z,x,N,$){this.f?.logIncoming(F,q,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(Z)}.${x}(`,N);const T=String(q);let L,V;if($){const le=new S.CancellationTokenSource;N.push(le.token),L=this.M(Z,x,N),V=()=>le.cancel()}else L=this.M(Z,x,N),V=r;this.p[T]=V;const j=a.serializeAcknowledged(q);this.f?.logOutgoing(j.byteLength,q,1,"ack"),this.c.send(j),L.then(le=>{delete this.p[T];const Y=a.serializeReplyOK(q,le,this.h);this.f?.logOutgoing(Y.byteLength,q,1,"reply:",le),this.c.send(Y)},le=>{delete this.p[T];const Y=a.serializeReplyErr(q,le);this.f?.logOutgoing(Y.byteLength,q,1,"replyErr:",le),this.c.send(Y)})}I(F,q){this.f?.logIncoming(F,q,1,"receiveCancel");const Z=String(q);this.p[Z]?.()}J(F,q,Z){this.f?.logIncoming(F,q,0,"receiveReply:",Z);const x=String(q);if(!this.s.hasOwnProperty(x))return;const N=this.s[x];delete this.s[x],N.resolveOk(Z)}L(F,q,Z){this.f?.logIncoming(F,q,0,"receiveReplyErr:",Z);const x=String(q);if(!this.s.hasOwnProperty(x))return;const N=this.s[x];delete this.s[x];let $;Z&&(Z.$isError?($=new Error,$.name=Z.name,$.message=Z.message,$.stack=Z.stack):$=Z),N.resolveErr($)}M(F,q,Z){try{return Promise.resolve(this.N(F,q,Z))}catch(x){return Promise.reject(x)}}N(F,q,Z){const x=this.k[F];if(!x)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(F));const N=x[q];if(typeof N!="function")throw new Error("Unknown method "+q+" on actor "+(0,O.getStringIdentifierForProxy)(F));return N.apply(x,Z)}O(F,q,Z){if(this.j)return new k.CanceledLazyPromise;let x=null;if(Z.length>0&&S.CancellationToken.isCancellationToken(Z[Z.length-1])&&(x=Z.pop()),x&&x.isCancellationRequested)return Promise.reject(M.canceled());const N=a.serializeRequestArguments(Z,this.h),$=++this.m,T=String($),L=new k.LazyPromise;x&&x.onCancellationRequested(()=>{const j=a.serializeCancel($);this.f?.logOutgoing(j.byteLength,$,0,"cancel"),this.c.send(a.serializeCancel($))}),this.s[T]=L,this.y($);const V=a.serializeRequest($,F,q,N,!!x);return this.f?.logOutgoing(V.byteLength,$,0,`request: ${(0,O.getStringIdentifierForProxy)(F)}.${q}(`,Z),this.c.send(V),L}}e.RPCProtocol=c,w=d,c.a=3*1e3;class t{static alloc(F,q,Z){const x=new t(C.VSBuffer.alloc(Z+1+4),0);return x.writeUInt8(F),x.writeUInt32(q),x}static read(F,q){return new t(F,q)}get buffer(){return this.a}constructor(F,q){this.a=F,this.b=q}static sizeUInt8(){return 1}writeUInt8(F){this.a.writeUInt8(F,this.b),this.b+=1}readUInt8(){const F=this.a.readUInt8(this.b);return this.b+=1,F}writeUInt32(F){this.a.writeUInt32BE(F,this.b),this.b+=4}readUInt32(){const F=this.a.readUInt32BE(this.b);return this.b+=4,F}static sizeShortString(F){return 1+F.byteLength}writeShortString(F){this.a.writeUInt8(F.byteLength,this.b),this.b+=1,this.a.set(F,this.b),this.b+=F.byteLength}readShortString(){const F=this.a.readUInt8(this.b);this.b+=1;const Z=this.a.slice(this.b,this.b+F).toString();return this.b+=F,Z}static sizeLongString(F){return 4+F.byteLength}writeLongString(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readLongString(){const F=this.a.readUInt32BE(this.b);this.b+=4;const Z=this.a.slice(this.b,this.b+F).toString();return this.b+=F,Z}writeBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}static sizeVSBuffer(F){return 4+F.byteLength}writeVSBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readVSBuffer(){const F=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+F);return this.b+=F,q}static sizeMixedArray(F){let q=0;q+=1;for(let Z=0,x=F.length;Z<x;Z++){const N=F[Z];switch(q+=1,N.type){case 1:q+=this.sizeLongString(N.value);break;case 2:q+=this.sizeVSBuffer(N.value);break;case 3:q+=this.sizeUInt32,q+=this.sizeLongString(N.value);for(let $=0;$<N.buffers.length;++$)q+=this.sizeVSBuffer(N.buffers[$]);break;case 4:break}}return q}writeMixedArray(F){this.a.writeUInt8(F.length,this.b),this.b+=1;for(let q=0,Z=F.length;q<Z;q++){const x=F[q];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let N=0;N<x.buffers.length;++N)this.writeBuffer(x.buffers[N]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const F=this.a.readUInt8(this.b);this.b+=1;const q=new Array(F);for(let Z=0;Z<F;Z++)switch(this.readUInt8()){case 1:q[Z]=this.readLongString();break;case 2:q[Z]=this.readVSBuffer();break;case 3:{const N=this.readUInt32(),$=this.readLongString(),T=[];for(let L=0;L<N;++L)T.push(this.readVSBuffer());q[Z]=new O.SerializableObjectWithBuffers(l($,T,null));break}case 4:q[Z]=void 0;break}return q}}t.sizeUInt32=4;var h;(function(R){R[R.Simple=0]="Simple",R[R.Mixed=1]="Mixed"})(h||(h={}));class a{static a(F){for(let q=0,Z=F.length;q<Z;q++)if(F[q]instanceof C.VSBuffer||F[q]instanceof O.SerializableObjectWithBuffers||typeof F[q]>"u")return!0;return!1}static serializeRequestArguments(F,q){if(this.a(F)){const Z=[];for(let x=0,N=F.length;x<N;x++){const $=F[x];if($ instanceof C.VSBuffer)Z[x]={type:2,value:$};else if(typeof $>"u")Z[x]={type:4};else if($ instanceof O.SerializableObjectWithBuffers){const{jsonString:T,referencedBuffers:L}=o($.value,q);Z[x]={type:3,value:C.VSBuffer.fromString(T),buffers:L}}else Z[x]={type:1,value:C.VSBuffer.fromString(v($,q))}}return{type:1,args:Z}}return{type:0,args:v(F,q)}}static serializeRequest(F,q,Z,x,N){switch(x.type){case 0:return this.b(F,q,Z,x.args,N);case 1:return this.c(F,q,Z,x.args,N)}}static b(F,q,Z,x,N){const $=C.VSBuffer.fromString(Z),T=C.VSBuffer.fromString(x);let L=0;L+=t.sizeUInt8(),L+=t.sizeShortString($),L+=t.sizeLongString(T);const V=t.alloc(N?2:1,F,L);return V.writeUInt8(q),V.writeShortString($),V.writeLongString(T),V.buffer}static deserializeRequestJSONArgs(F){const q=F.readUInt8(),Z=F.readShortString(),x=F.readLongString();return{rpcId:q,method:Z,args:JSON.parse(x)}}static c(F,q,Z,x,N){const $=C.VSBuffer.fromString(Z);let T=0;T+=t.sizeUInt8(),T+=t.sizeShortString($),T+=t.sizeMixedArray(x);const L=t.alloc(N?4:3,F,T);return L.writeUInt8(q),L.writeShortString($),L.writeMixedArray(x),L.buffer}static deserializeRequestMixedArgs(F){const q=F.readUInt8(),Z=F.readShortString(),x=F.readMixedArray(),N=new Array(x.length);for(let $=0,T=x.length;$<T;$++){const L=x[$];typeof L=="string"?N[$]=JSON.parse(L):N[$]=L}return{rpcId:q,method:Z,args:N}}static serializeAcknowledged(F){return t.alloc(5,F,0).buffer}static serializeCancel(F){return t.alloc(6,F,0).buffer}static serializeReplyOK(F,q,Z){if(typeof q>"u")return this.d(F);if(q instanceof C.VSBuffer)return this.e(F,q);if(q instanceof O.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:N}=o(q.value,Z,!0);return this.g(F,x,N)}else return this.f(F,m(q,Z))}static d(F){return t.alloc(7,F,0).buffer}static e(F,q){let Z=0;Z+=t.sizeVSBuffer(q);const x=t.alloc(8,F,Z);return x.writeVSBuffer(q),x.buffer}static deserializeReplyOKVSBuffer(F){return F.readVSBuffer()}static f(F,q){const Z=C.VSBuffer.fromString(q);let x=0;x+=t.sizeLongString(Z);const N=t.alloc(9,F,x);return N.writeLongString(Z),N.buffer}static g(F,q,Z){const x=C.VSBuffer.fromString(q);let N=0;N+=t.sizeUInt32,N+=t.sizeLongString(x);for(const T of Z)N+=t.sizeVSBuffer(T);const $=t.alloc(10,F,N);$.writeUInt32(Z.length),$.writeLongString(x);for(const T of Z)$.writeBuffer(T);return $.buffer}static deserializeReplyOKJSON(F){const q=F.readLongString();return JSON.parse(q)}static deserializeReplyOKJSONWithBuffers(F,q){const Z=F.readUInt32(),x=F.readLongString(),N=[];for(let $=0;$<Z;++$)N.push(F.readVSBuffer());return new O.SerializableObjectWithBuffers(l(x,N,q))}static serializeReplyErr(F,q){const Z=q?m(M.transformErrorForSerialization(q),null):void 0;if(typeof Z!="string")return this.h(F);const x=C.VSBuffer.fromString(Z);let N=0;N+=t.sizeLongString(x);const $=t.alloc(11,F,N);return $.writeLongString(x),$.buffer}static deserializeReplyErrError(F){const q=F.readLongString();return JSON.parse(q)}static h(F){return t.alloc(12,F,0).buffer}}var u;(function(R){R[R.RequestJSONArgs=1]="RequestJSONArgs",R[R.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",R[R.RequestMixedArgs=3]="RequestMixedArgs",R[R.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",R[R.Acknowledged=5]="Acknowledged",R[R.Cancel=6]="Cancel",R[R.ReplyOKEmpty=7]="ReplyOKEmpty",R[R.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",R[R.ReplyOKJSON=9]="ReplyOKJSON",R[R.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",R[R.ReplyErrError=11]="ReplyErrError",R[R.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var g;(function(R){R[R.String=1]="String",R[R.VSBuffer=2]="VSBuffer",R[R.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",R[R.Undefined=4]="Undefined"})(g||(g={}))}),define(Ie[238],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(M){const I=A=>{self.removeEventListener("message",I);const y=A.data;Object.defineProperties(self,{postMessage:{value(k,O){y.postMessage(k,O)}},onmessage:{get(){return y.onmessage},set(k){y.onmessage=k}}}),y.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",I)}.toString();class C extends EventTarget{constructor(M,I,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${n})('${I}'))`,k=new Blob([y],{type:"application/javascript"}),O=URL.createObjectURL(k),w=new MessageChannel,m=O,b={type:"_newWorker",id:m,port:w.port2,url:O,options:A};M(b,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{M({type:"_terminateWorker",id:m}),URL.revokeObjectURL(O),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(f){w.port1.onmessage=f}},onmessageerror:{get(){return w.port1.onmessageerror},set(f){w.port1.onmessageerror=f}}}),w.port1.addEventListener("messageerror",f=>{const s=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(s)}),w.port1.addEventListener("message",f=>{const s=new MessageEvent("message",{data:f.data});this.dispatchEvent(s)}),w.port1.start()}}e.NestedWorker=C}),define(Ie[239],Ce([1,0,4,29,42,3,36,11,16]),function(te,e,n,C,S,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new S.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new S.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new S.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(b){b[b.Append=1]="Append",b[b.Replace=2]="Replace",b[b.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new n.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new n.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(s=>f.push(s)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}C.Registry.add(e.Extensions.OutputChannels,new O);function w(b,f,s,o,l){return(0,y.createCancelablePromise)(async v=>{await(0,I.whenProviderRegistered)(s,o);const E=C.Registry.as(e.Extensions.OutputChannels);try{await m(s,1,o,l,v),E.registerChannel({id:b,label:f,file:s,log:!0})}catch(P){(0,A.isCancellationError)(P)||l.error("Error while registering log channel",s.toString(),(0,A.getErrorMessage)(P))}})}e.registerLogChannel=w;async function m(b,f,s,o,l){if(!await s.exists(b)){if(l.isCancellationRequested)throw new A.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");o.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",b.toString()),await(0,y.timeout)(1e3,l),await m(b,f+1,s,o,l)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new S.RawContextKey("activeOutputChannel","")}),define(Ie[105],Ce([1,0,5,3,17,25,12,239,59,27,37,120,24,9,36,4,6]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class l extends I.AbstractMessageLogger{get disposed(){return this.l}constructor(p,r,d,i,c){super(),this.id=p,this.name=r,this.m=d,this.n=i,this.extension=c,this.k=0,this.l=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(t=>this.setLevel(t)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,p)}replace(p){const r=this.k;this.info(p),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,r),this.visible&&this.m.flush()}show(p,r){this.m.flush(),this.n.$reveal(this.id,!!(typeof p=="boolean"?p:r))}hide(){this.n.$close(this.id)}g(p,r){this.k+=m.VSBuffer.fromString(r).byteLength,(0,I.log)(this.m,p,r),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class v extends l{appendLine(p){this.append(p)}}let E=class{constructor(p,r,d,i,c,t){this.i=r,this.j=d,this.k=i,this.l=c,this.m=t,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(n.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[r,d]of this.g)d.visible=r===this.h}createOutputChannel(p,r,d){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const i=typeof r=="object"&&r.log,c=(0,b.isString)(r)?r:void 0;if((0,b.isString)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let t;const h=this.i.environment.extensionLogLevel?.find(([u])=>M.ExtensionIdentifier.equals(d.identifier,u))?.[1];h&&(t=(0,I.parseLogLevel)(h));const a=i?this.o(p,t,d):this.n(p,c,d);return a.then(u=>{this.g.set(u.id,u),u.visible=u.id===this.h}),i?this.r(p,t??this.m.getLevel(),a):this.q(p,a)}async n(p,r,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const i=await this.c,c=this.k.extUri.joinPath(i,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),t=this.l.createLogger(c,{always:!0,donotRotate:!0,donotUseFormatters:!0}),h=await this.a.$register(p,c,!1,r,d.identifier.value);return new l(h,p,t,this.a,d)}async o(p,r,d){const i=await this.p(d),c=this.k.extUri.joinPath(i,`${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),t=this.l.createLogger(c,{name:p},r),h=await this.a.$register(p,c,!0,void 0,d.identifier.value);return new v(h,p,t,this.a,d)}p(p){let r=this.d.get(p.identifier.value);if(!r){const d=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(d)}catch(i){if((0,f.toFileSystemProviderErrorCode)(i)!==f.FileSystemProviderErrorCode.FileExists)throw i}return d})())}return r}q(p,r){let d=!1;const i=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return p},append(c){i(),r.then(t=>t.append(c))},appendLine(c){i(),r.then(t=>t.appendLine(c))},clear(){i(),r.then(c=>c.clear())},replace(c){i(),r.then(t=>t.replace(c))},show(c,t){i(),r.then(h=>h.show(c,t))},hide(){i(),r.then(c=>c.hide())},dispose(){d=!0,r.then(c=>c.dispose())}}}r(p,r,d){const i=new o.DisposableStore,c=()=>{if(i.isDisposed)throw new Error("Channel has been closed")},t=i.add(new s.Emitter);return d.then(h=>{i.add(h),i.add(h.onDidChangeLogLevel(a=>{r=a,t.fire(a)}))}),{...this.q(p,d),get logLevel(){return r},onDidChangeLogLevel:t.event,trace(h,...a){c(),d.then(u=>u.trace(h,...a))},debug(h,...a){c(),d.then(u=>u.debug(h,...a))},info(h,...a){c(),d.then(u=>u.info(h,...a))},warn(h,...a){c(),d.then(u=>u.warn(h,...a))},error(h,...a){c(),d.then(u=>u.error(h,...a))},dispose(){i.dispose()}}}};E=qe([Ve(0,S.IExtHostRpcService),Ve(1,k.IExtHostInitDataService),Ve(2,y.IExtHostConsumerFileSystem),Ve(3,O.IExtHostFileSystemInfo),Ve(4,I.ILoggerService),Ve(5,I.ILogService)],E),e.ExtHostOutputService=E,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(Ie[240],Ce([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(Ie[241],Ce([1,0,40,15,19,20,23,2,3,173,52,188,240]),function(te,e,n,C,S,M,I,A,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let b=class on{constructor(s,o,l,v){this.d=s,this.e=o,this.f=l,this.g=v,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??s})()}hasValidBasename(s,o,l){return typeof o=="string"||typeof o>"u"?this.a.then(v=>this.h(s,v,o)):this.h(s,o,l)}h(s,o,l){return s.scheme===C.Schemas.file||s.scheme===C.Schemas.vscodeRemote?(0,n.isValidBasename)(l??(0,I.basename)(s),o===1):!0}get defaultUriScheme(){return on.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,o){if(s.remoteAuthority)return C.Schemas.vscodeRemote;const l=(0,k.getVirtualWorkspaceScheme)(o.getWorkspace());if(l)return l;const v=o.getWorkspace().folders[0];if(v)return v.uri.scheme;const E=o.getWorkspace().configuration;return E?E.scheme:C.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===1?S.win32:S.posix)}async fileURI(s){let o="";if(await this.a===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const v=s.indexOf("/",2);v===-1?(o=s.substring(2),s="/"):(o=s.substring(2,v),s=s.substring(v)||"/")}return A.URI.from({scheme:C.Schemas.file,authority:o,path:s,query:"",fragment:""})}};b=qe([Ve(1,m.IRemoteAgentService),Ve(2,w.IWorkbenchEnvironmentService),Ve(3,O.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(Ie[106],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(I,A){this.line=I,this.character=A}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,A){return new n(0,0)}with(I){return new n(0,0)}}e.Position=n;class C{constructor(I,A,y,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(I,A),this.end=new n(y,k)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new C(0,0,0,0)}with(I){return new C(0,0,0,0)}}e.Range=C;var S;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[45],Ce([1,0,18,35,22,40,10,3,19,11,106,16]),function(te,e,n,C,S,M,I,A,y,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",b=" characters skipped \u27EB",f=(m.length+b.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var s;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text"})(s=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function l(ue){return!!ue.preview}e.resultIsMatch=l;function v(ue){return!!ue.resource}e.isFileMatch=v;function E(ue){return!!ue.message}e.isProgressMessage=E;var P;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(P=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=p;class r{constructor(de,re,G){this.ranges=re;const H=Array.isArray(re)?re:[re];if(G&&G.matchLines===1&&d(H)){de=(0,I.getNLines)(de,G.matchLines);let oe="",ve=0,Ae=0;const Be=Math.floor(G.charsPerLine/5),xe=[];for(const Te of H){const Se=Math.max(Te.startColumn-Be,0),ke=Te.startColumn+G.charsPerLine;if(Se>Ae+Be+f){const se=m+(Se-Ae)+b;oe+=se+de.slice(Se,ke),ve+=Se-(Ae+se.length)}else oe+=de.slice(Ae,ke);xe.push(new c(0,Te.startColumn-ve,Te.endColumn-ve)),Ae=ke}this.preview={text:oe,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const oe=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:de,matches:(0,n.mapArrayOrNot)(re,ve=>new i(ve.startLineNumber-oe,ve.startColumn,ve.endLineNumber-oe,ve.endColumn))}}}}e.TextSearchMatch=r;function d(ue){const de=ue[0].startLineNumber;for(const re of ue)if(re.startLineNumber!==de||re.endLineNumber!==de)return!1;return!0}class i{constructor(de,re,G,H){this.startLineNumber=de,this.startColumn=re,this.endLineNumber=G,this.endColumn=H}}e.SearchRange=i;class c extends i{constructor(de,re,G){super(de,re,de,G)}}e.OneLineRange=c;var t;(function(ue){ue.List="list",ue.Tree="tree"})(t=e.ViewMode||(e.ViewMode={}));var h;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(h=e.SearchSortOrder||(e.SearchSortOrder={}));function a(ue,de=!0){const re=ue&&ue.files&&ue.files.exclude,G=de&&ue&&ue.search&&ue.search.exclude;if(!re&&!G)return;if(!re||!G)return re||G;let H=Object.create(null);return H=S.mixin(H,S.deepClone(re)),H=S.mixin(H,S.deepClone(G),!0),H}e.getExcludes=a;function u(ue,de){return ue.excludePattern&&C.match(ue.excludePattern,de)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&C.match(ue.includePattern,de)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(re=>{const G=re.folder.fsPath;if(M.isEqualOrParent(de,G)){const H=y.relative(G,de);return!re.includePattern||!!C.match(re.includePattern,H)}else return!1}):!1:!0}e.pathIncludedInQuery=u;var g;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class R extends Error{constructor(de,re){super(de),this.code=re}}e.SearchError=R;function F(ue){const de=ue.message;if((0,k.isCancellationError)(ue))return new R(de,g.canceled);try{const re=JSON.parse(de);return new R(re.message,re.code)}catch{return new R(de,g.other)}}e.deserializeSearchError=F;function q(ue){const de={message:ue.message,code:ue.code};return new Error(JSON.stringify(de))}e.serializeSearchError=q;function Z(ue){return ue.type==="error"?!0:ue.type==="success"}e.isSerializedSearchComplete=Z;function x(ue){return ue.type==="success"}e.isSerializedSearchSuccess=x;function N(ue){return!!ue.path}e.isSerializedFileMatch=N;function $(ue,de){const re=ue.searchPath?ue.searchPath:ue.relativePath;return(0,I.fuzzyContains)(re,de)}e.isFilePatternMatch=$;class T{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=T;function L(ue,de){const re={...ue||{},...de||{}};return Object.keys(re).filter(G=>{const H=re[G];return typeof H=="boolean"&&H})}e.resolvePatternsForProvider=L;class V{constructor(de,re){this.c=null,this.a={...de.excludePattern||{},...re.excludePattern||{}},this.b=C.parse(this.a);let G=de.includePattern;re.includePattern&&(G?G={...G,...re.includePattern}:G=re.includePattern),G&&(this.c=C.parse(G))}matchesExcludesSync(de,re,G){return!!(this.b&&this.b(de,re,G))}includedInQuerySync(de,re,G){return!(this.b&&this.b(de,re,G)||this.c&&!this.c(de,re,G))}includedInQuery(de,re,G){const H=this.b(de,re,G),oe=()=>this.c?!!this.c(de,re,G):!0;return(0,w.isThenable)(H)?H.then(ve=>ve?!1:oe()):oe()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=V;function j(ue){for(const de in ue)if(typeof ue[de]!="boolean")return!0;return!1}function le(ue){if(!ue)return;let de;return re=>(de||(de=(ue()||Promise.resolve([])).then(G=>G?pe(G):{})),de.then(G=>!!G[re]))}e.hasSiblingPromiseFn=le;function Y(ue){if(!ue)return;let de;return re=>{if(!de){const G=ue();de=G?pe(G):{}}return!!de[re]}}e.hasSiblingFn=Y;function pe(ue){const de={};for(const re of ue)de[re]=!0;return de}}),define(Ie[31],Ce([1,0,18,16,21,4,6,46,15,113,23,10,9,2,144,3,12,160,52,37,27,17,8,7,54,45,5]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o,l,v,E,P,p,r,d,i,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function h(x,N,$){return new O.ExtUri(T=>R(T,$)).isEqual(x,N)}function a(x,N,$){return h(x.uri,N.uri,$)?0:(0,w.compare)(x.uri.toString(),N.uri.toString())}function u(x,N,$){return x.index!==N.index?x.index<N.index?-1:1:h(x.uri,N.uri,$)?(0,w.compare)(x.name,N.name):(0,w.compare)(x.uri.toString(),N.uri.toString())}function g(x,N,$,T){const L=x.slice(0).sort((j,le)=>$(j,le,T)),V=N.slice(0).sort((j,le)=>$(j,le,T));return(0,n.delta)(L,V,(j,le)=>$(j,le,T))}function R(x,N){const $=N.getCapabilities(x.scheme);return!($&&$&1024)}class F extends v.Workspace{static toExtHostWorkspace(N,$,T,L){if(!N)return{workspace:null,added:[],removed:[]};const{id:V,name:j,folders:le,configuration:Y,transient:pe,isUntitled:ue}=N,de=[],re=$;$?le.forEach((ve,Ae)=>{const Be=b.URI.revive(ve.uri),xe=F.e(T||$,Be,L);xe?(xe.name=ve.name,xe.index=ve.index,de.push(xe)):de.push({uri:Be,name:ve.name,index:Ae})}):de.push(...le.map(({uri:ve,name:Ae,index:Be})=>({uri:b.URI.revive(ve),name:Ae,index:Be}))),de.sort((ve,Ae)=>ve.index<Ae.index?-1:1);const G=new F(V,j,de,!!pe,Y?b.URI.revive(Y):null,!!ue,ve=>R(ve,L)),{added:H,removed:oe}=g(re?re.workspaceFolders:[],G.workspaceFolders,a,L);return{workspace:G,added:H,removed:oe}}static e(N,$,T){for(let L=0;L<N.folders.length;L++){const V=N.workspaceFolders[L];if(h(V.uri,$,T))return V}}constructor(N,$,T,L,V,j,le){super(N,T.map(Y=>new v.WorkspaceFolder(Y)),L,V,le),this.s=$,this.t=j,this.o=[],this.q=A.TernarySearchTree.forUris(le),T.forEach(Y=>{this.o.push(Y),this.q.set(Y.uri,Y)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(N,$){return $&&this.q.get(N)&&(N=(0,O.dirname)(N)),this.q.findSubstr(N)}resolveWorkspaceFolder(N){return this.q.get(N)}}let q=class{constructor(N,$,T,L,V){this.c=new M.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new M.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=L,this.q=T,this.s=V,this.h=new k.Counter,this.j=new C.Barrier,this.n=N.getProxy(t.MainContext.MainThreadWorkspace),this.o=N.getProxy(t.MainContext.MainThreadMessageService);const j=$.workspace;this.k=j?new F(j.id,j.name,[],!!j.transient,j.configuration?b.URI.revive(j.configuration):null,!!j.isUntitled,le=>R(le,T)):void 0}$initializeWorkspace(N,$){this.u=$,this.$acceptWorkspaceData(N),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?b.URI.from({scheme:y.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(N,$,T,...L){const V=[];if(Array.isArray(L)&&L.forEach(ue=>{b.URI.isUri(ue.uri)&&!V.some(de=>h(de.uri,ue.uri,this.q))&&V.push({uri:ue.uri,name:ue.name||(0,O.basenameOrAuthority)(ue.uri)})}),this.l||[$,T].some(ue=>typeof ue!="number"||ue<0)||T===0&&V.length===0)return!1;const j=this.w?this.w.workspaceFolders:[];if($+T>j.length)return!1;const le=j.slice(0);le.splice($,T,...V.map(ue=>({uri:ue.uri,name:ue.name||(0,O.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<le.length;ue++){const de=le[ue];if(le.some((re,G)=>G!==ue&&h(de.uri,re.uri,this.q)))return!1}le.forEach((ue,de)=>ue.index=de);const{added:Y,removed:pe}=g(j,le,u,this.q);if(Y.length===0&&pe.length===0)return!1;if(this.n){const ue=N.displayName||N.name;this.n.$updateWorkspaceFolders(ue,$,T,V).then(void 0,de=>{this.l=void 0;const re={source:{identifier:N.identifier,label:N.displayName||N.name}};this.o.$showMessage(l.Severity.Error,(0,f.localize)(0,null,ue,de.toString()),re,[])})}return this.x(le),!0}getWorkspaceFolder(N,$){if(!!this.w)return this.w.getWorkspaceFolder(N,$)}async getWorkspaceFolder2(N,$){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(N,$)}async resolveWorkspaceFolder(N){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(N)}getPath(){if(!this.w)return;const{folders:N}=this.w;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,$){let T,L="";if(typeof N=="string"?(T=b.URI.file(N),L=N):typeof N<"u"&&(T=N,L=N.fsPath),!T)return L;const V=this.getWorkspaceFolder(T,!0);if(!V)return L;typeof $>"u"&&this.w&&($=this.w.folders.length>1);let j=(0,O.relativePath)(V.uri,T);return $&&V.name&&(j=`${V.name}/${j}`),j}x(N){this.w&&(this.l=F.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:N,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:$,added:T,removed:L}=F.toExtHostWorkspace(N,this.k,this.l,this.q);this.k=$||void 0,this.l=void 0,this.c.fire(Object.freeze({added:T,removed:L}))}findFiles(N,$,T,L,V=S.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${L.value}, entryPoint: findFiles`);let j;if($===null?j=!1:$&&(typeof $=="string"?j=$:j=$.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:Y}=Z(r.GlobPattern.from(N));return this.n.$startFileSearch((0,m.withUndefinedAsNull)(le),(0,m.withUndefinedAsNull)(Y),(0,m.withUndefinedAsNull)(j),(0,m.withUndefinedAsNull)(T),V).then(pe=>Array.isArray(pe)?pe.map(ue=>b.URI.revive(ue)):[])}async findTextInFiles(N,$,T,L,V=S.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${L.value}, entryPoint: findTextInFiles`);const j=this.h.getNext(),le=typeof $.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:Y,folder:pe}=Z(r.GlobPattern.from($.include)),ue=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,de={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof $.useParentIgnoreFiles=="boolean"?!$.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:le,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:Y,excludePattern:ue},re=!1;if(this.t[j]=G=>{if(re)return;const H=b.URI.revive(G.resource);G.results.forEach(oe=>{(0,c.resultIsMatch)(oe)?T({uri:H,preview:{text:oe.preview.text,matches:(0,n.mapArrayOrNot)(oe.preview.matches,ve=>new d.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,n.mapArrayOrNot)(oe.ranges,ve=>new d.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):T({uri:H,text:oe.text,lineNumber:oe.lineNumber})})},V.isCancellationRequested)return{};try{const G=await this.n.$startTextSearch(N,(0,m.withUndefinedAsNull)(pe),de,j,V);return delete this.t[j],G||{}}catch(G){throw delete this.t[j],G}}$handleTextSearchResult(N,$){this.t[$]?.(N)}saveAll(N){return this.n.$saveAll(N)}resolveProxy(N){return this.n.$resolveProxy(N)}get trusted(){return this.u}requestWorkspaceTrust(N){return this.n.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(N,$){if(this.v.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.v.set(N,$);const T=this.s.transformOutgoingScheme(N),L=this.y++;return this.n.$registerEditSessionIdentityProvider(L,T),(0,I.toDisposable)(()=>{this.v.delete(N),this.n.$unregisterEditSessionIdentityProvider(L)})}async $getEditSessionIdentifier(N,$){this.g.info("Getting edit session identifier for workspaceFolder",N);const T=await this.resolveWorkspaceFolder(b.URI.revive(N));if(!T){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const L=this.v.get(T.uri.scheme);if(this.g.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!L),!L)return;const V=await L.provideEditSessionIdentity(T,$);if(this.g.info("Provider returned edit session identifier: ",V),!!V)return V}async $provideEditSessionIdentityMatch(N,$,T,L){this.g.info("Getting edit session identifier for workspaceFolder",N);const V=await this.resolveWorkspaceFolder(b.URI.revive(N));if(!V){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const j=this.v.get(V.uri.scheme);if(this.g.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!j),!j)return;const le=await j.provideEditSessionIdentityMatch?.($,T,L);if(this.g.info("Provider returned edit session identifier match result: ",le),!!le)return le}};q=qe([Ve(0,p.IExtHostRpcService),Ve(1,P.IExtHostInitDataService),Ve(2,E.IExtHostFileSystemInfo),Ve(3,o.ILogService),Ve(4,i.IURITransformerService)],q),e.ExtHostWorkspace=q,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function Z(x){let N,$;return x&&(typeof x=="string"?N=x:(N=x.pattern,$=b.URI.revive(x.baseUri))),{includePattern:N,folder:$}}}),define(Ie[32],Ce([1,0,22,4,31,5,7,163,93,9,16,3,17,12,2]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function s(d,i){if(i){const c=i.split(".");let t=d;for(let h=0;t&&h<c.length;h++)t=t[c[h]];return t}}function o(d){return d instanceof f.URI}function l(d){return d&&d.uri instanceof f.URI&&d.languageId&&typeof d.languageId=="string"}function v(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function E(d){return d&&d.uri instanceof f.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function P(d){if(o(d))return{resource:d};if(l(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(v(d))return{overrideIdentifier:d.languageId};if(E(d))return{resource:d.uri};if(d===null)return{resource:null}}let p=class{constructor(i,c,t){this.a=i.getProxy(M.MainContext.MainThreadConfiguration),this.c=c,this.b=t,this.d=new O.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(i=>this.e)}$initializeConfiguration(i){this.e=new r(this.a,this.c,i,this.b),this.d.open()}$acceptConfigurationChanged(i,c){this.getConfigProvider().then(t=>t.$acceptConfigurationChanged(i,c))}};p=qe([Ve(0,m.IExtHostRpcService),Ve(1,S.IExtHostWorkspace),Ve(2,b.ILogService)],p),e.ExtHostConfiguration=p;class r{constructor(i,c,t,h){this.a=new C.Emitter,this.b=i,this.f=h,this.c=c,this.e=A.Configuration.parse(t),this.d=this.k(t.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(i,c){const t={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(i),this.d=this.k(i.configurationScopes),this.a.fire(this.j(c,t))}getConfiguration(i,c,t){const h=P(c)||{},a=this.g(i?s(this.e.getValue(void 0,h,this.c.workspace),i):this.e.getValue(void 0,h,this.c.workspace));i&&this.h(i,h,t?.identifier);function u(R){if(R==null)return null;if(typeof R=="boolean")return R?2:5;switch(R){case I.ConfigurationTarget.Global:return 2;case I.ConfigurationTarget.Workspace:return 5;case I.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(R){return typeof s(a,R)<"u"},get:(R,F)=>{this.h(i?`${i}.${R}`:R,h,t?.identifier);let q=s(a,R);if(typeof q>"u")q=F;else{let Z;const x=(N,$)=>{let T;const L=()=>{Z=Z||(0,n.deepClone)(a),T=T||s(Z,$)};return(0,k.isObject)(N)?new Proxy(N,{get:(V,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return L(),()=>T;if(Z)return T=T||s(Z,$),T[j];const le=V[j];return typeof j=="string"?x(le,`${$}.${j}`):le},set:(V,j,le)=>(L(),T&&(T[j]=le),!0),deleteProperty:(V,j)=>(L(),T&&delete T[j],!0),defineProperty:(V,j,le)=>(L(),T&&Object.defineProperty(T,j,le),!0)}):N};q=x(q,R)}return q},update:(R,F,q,Z)=>{R=i?`${i}.${R}`:R;const x=u(q);return F!==void 0?this.b.$updateConfigurationOption(x,R,F,h,Z):this.b.$removeConfigurationOption(x,R,h,Z)},inspect:R=>{R=i?`${i}.${R}`:R;const F=this.e.inspect(R,h,this.c.workspace);if(F)return{key:R,defaultValue:(0,n.deepClone)(F.policy?.value??F.default?.value),globalValue:(0,n.deepClone)(F.user?.value??F.application?.value),workspaceValue:(0,n.deepClone)(F.workspace?.value),workspaceFolderValue:(0,n.deepClone)(F.workspaceFolder?.value),defaultLanguageValue:(0,n.deepClone)(F.default?.override),globalLanguageValue:(0,n.deepClone)(F.user?.override??F.application?.override),workspaceLanguageValue:(0,n.deepClone)(F.workspace?.override),workspaceFolderLanguageValue:(0,n.deepClone)(F.workspaceFolder?.override),languageIds:(0,n.deepClone)(F.overrideIdentifiers)}}};return typeof a=="object"&&(0,n.mixin)(g,a,!1),Object.freeze(g)}g(i){const c=t=>(0,k.isObject)(t)?new Proxy(t,{get:(h,a)=>c(h[a]),set:(h,a,u)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(a)}' of object`)},deleteProperty:(h,a)=>{throw new Error(`TypeError: Cannot delete read only property '${String(a)}' of object`)},defineProperty:(h,a)=>{throw new Error(`TypeError: Cannot define property '${String(a)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):t;return c(i)}h(i,c,t){const h=y.OVERRIDE_PROPERTY_REGEX.test(i)?4:this.d.get(i),a=t?`[${t.value}] `:"";if(h===4){typeof c?.resource>"u"&&this.f.warn(`${a}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){c?.resource&&this.f.warn(`${a}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(i,c){const t=new A.ConfigurationChangeEvent(i,c,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,a)=>t.affectsConfiguration(h,P(a))})}k(i){return i.reduce((c,t)=>(c.set(t[0],t[1]),c),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,n):S?S.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ie[107],Ce([1,0,2,16,4,5,7,31,57,32,21,60,17,27,3,15,20,12,76,200,11]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o,l,v,E,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var r;(function(N){function $(L){if(L!=null)return L}N.from=$;function T(L){if(L!=null)return L}N.to=T})(r||(r={}));var d;(function(N){function $(L){if(L!=null)return L}N.from=$;function T(L){if(L!=null)return L}N.to=T})(d||(d={}));var i;(function(N){function $(L){if(L!=null)return L}N.from=$;function T(L){if(L!=null)return L}N.to=T})(i||(i={}));var c;(function(N){function $(V){if(V){const j=V;return j&&!!j.process}else return!1}N.is=$;function T(V){if(V==null)return;const j={process:V.process,args:V.args};return V.options&&(j.options=i.from(V.options)),j}N.from=T;function L(V){if(V!=null)return new I.ProcessExecution(V.process,V.args,V.options)}N.to=L})(c||(c={}));var t;(function(N){function $(L){if(L!=null)return L}N.from=$;function T(L){if(L!=null)return L}N.to=T})(t||(t={}));var h;(function(N){function $(V){if(V){const j=V;return j&&(!!j.commandLine||!!j.command)}else return!1}N.is=$;function T(V){if(V==null)return;const j={};return V.commandLine!==void 0?j.commandLine=V.commandLine:(j.command=V.command,j.args=V.args),V.options&&(j.options=t.from(V.options)),j}N.from=T;function L(V){if(!(V==null||V.command===void 0&&V.commandLine===void 0))return V.commandLine?new I.ShellExecution(V.commandLine,V.options):new I.ShellExecution(V.command,V.args?V.args:[],V.options)}N.to=L})(h||(h={}));var a;(function(N){function $(V){if(V){const j=V;return j&&j.customExecution==="customExecution"}else return!1}N.is=$;function T(V){return{customExecution:"customExecution"}}N.from=T;function L(V,j){return j.get(V)}N.to=L})(a=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var u;(function(N){function $(T,L){let V;return T.scope!==void 0&&typeof T.scope!="number"?V=T.scope.uri:T.scope!==void 0&&typeof T.scope=="number"&&(T.scope===I.TaskScope.Workspace&&L&&L.workspaceFile?V=L.workspaceFile:V=E.USER_TASKS_GROUP_KEY),{id:T._id,workspaceFolder:V}}N.from=$})(u=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(N){function $(T){if(T!=null)return{_id:T.id,isDefault:T.isDefault}}N.from=$})(g||(g={}));var R;(function(N){function $(V,j){if(V==null)return[];const le=[];for(const Y of V){const pe=T(Y,j);pe&&le.push(pe)}return le}N.fromMany=$;function T(V,j){if(V==null)return;let le;V.execution instanceof I.ProcessExecution?le=c.from(V.execution):V.execution instanceof I.ShellExecution?le=h.from(V.execution):V.execution&&V.execution instanceof I.CustomExecution&&(le=a.from(V.execution));const Y=r.from(V.definition);let pe;return V.scope?typeof V.scope=="number"?pe=V.scope:pe=V.scope.uri:pe=I.TaskScope.Workspace,!Y||!pe?void 0:{_id:V._id,definition:Y,name:V.name,source:{extensionId:j.identifier.value,label:V.source,scope:pe},execution:le,isBackground:V.isBackground,group:g.from(V.group),presentationOptions:d.from(V.presentationOptions),problemMatchers:V.problemMatchers,hasDefinedMatchers:V.hasDefinedMatchers,runOptions:V.runOptions?V.runOptions:{reevaluateOnRerun:!0},detail:V.detail}}N.from=T;async function L(V,j,le){if(V==null)return;let Y;c.is(V.execution)?Y=c.to(V.execution):h.is(V.execution)?Y=h.to(V.execution):a.is(V.execution)&&(Y=a.to(V._id,le));const pe=r.to(V.definition);let ue;if(V.source&&(V.source.scope!==void 0?typeof V.source.scope=="number"?ue=V.source.scope:ue=await j.resolveWorkspaceFolder(n.URI.revive(V.source.scope)):ue=I.TaskScope.Workspace),!pe||!ue)return;const de=new I.Task(pe,ue,V.name,V.source.label,Y,V.problemMatchers);return V.isBackground!==void 0&&(de.isBackground=V.isBackground),V.group!==void 0&&(de.group=I.TaskGroup.from(V.group._id),de.group&&V.group.isDefault&&(de.group=new I.TaskGroup(de.group.id,de.group.label),V.group.isDefault===!0&&(de.group.isDefault=V.group.isDefault))),V.presentationOptions&&(de.presentationOptions=d.to(V.presentationOptions)),V._id&&(de._id=V._id),V.detail&&(de.detail=V.detail),de}N.to=L})(R=e.TaskDTO||(e.TaskDTO={}));var F;(function(N){function $(L){return L}N.from=$;function T(L){if(!!L)return Object.assign(Object.create(null),L)}N.to=T})(F||(F={}));class q{constructor($,T,L){this._id=T,this.a=L,p.set(this,void 0),Je(this,p,$,"f")}get task(){return this.a}terminate(){Oe(this,p,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}p=new WeakMap;let Z=class{constructor($,T,L,V,j,le,Y,pe){this.q=new S.Emitter,this.r=new S.Emitter,this.s=new S.Emitter,this.t=new S.Emitter,this.a=$.getProxy(M.MainContext.MainThreadTask),this.b=L,this.c=V,this.d=j,this.e=le,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Y,this.g=pe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider($,T,L){if(!L)return new I.Disposable(()=>{});const V=this.w();return this.j.set(V,{type:T,provider:L,extension:$}),this.a.$registerTaskProvider(V,T),new I.Disposable(()=>{this.j.delete(V),this.a.$unregisterTaskProvider(V)})}registerTaskSystem($,T){this.a.$registerTaskSystem($,T)}fetchTasks($){return this.a.$fetchTasks(F.from($)).then(async T=>{const L=[];for(const V of T){const j=await R.to(V,this.b,this.m);j&&L.push(j)}return L})}get taskExecutions(){const $=[];return this.k.forEach(T=>$.push(T)),$}terminateTask($){if(!($ instanceof q))throw new Error("No valid task execution provided");return this.a.$terminateTask($._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask($,T,L){const V=this.m.get($.id);V&&(this.o.set($.id,V),this.e.attachPtyToTerminal(T,await V.callback(L))),this.p=$.id,this.q.fire({execution:await this.y($)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask($){const T=await this.y($);this.l.delete($.id),this.k.delete($.id),this.A($),this.r.fire({execution:T})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess($){const T=await this.y($.id);this.s.fire({execution:T,processId:$.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess($){const T=await this.y($.id);this.t.fire({execution:T,exitCode:$.exitCode})}$provideTasks($,T){const L=this.j.get($);if(!L)return Promise.reject(new Error("no handler found"));const V=[],j=(0,C.asPromise)(()=>L.provider.provideTasks(O.CancellationToken.None)).then(le=>this.u(T,V,L,le));return new Promise(le=>{j.then(Y=>{Promise.all(V).then(()=>{le(Y)})})})}async $resolveTask($,T){const L=this.j.get($);if(!L)return Promise.reject(new Error("no handler found"));if(T.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${T.definition.type}] cannot be resolved by provider of type [${L.type}].`);const V=await R.to(T,this.b,this.m);if(!V)throw new Error("Unexpected: Task cannot be resolved.");const j=await L.provider.resolveTask(V,O.CancellationToken.None);if(!j)return;this.z(j,L);const le=R.from(j,L.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==V.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return a.is(le.execution)&&await this.x(le,j,!0),await this.v(le)}w(){return this.h++}async x($,T,L){const V=await this.a.$createTaskId($);!L&&!this.m.has(V)&&(this.n.add(V),this.o.set(V,T.execution)),this.m.set(V,T.execution)}async y($,T){if(typeof $=="string"){const j=this.l.get($);if(!j)throw new P.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const L=this.l.get($.id);if(L)return L;const V=new Promise((j,le)=>{function Y(pe,ue,de){de?j(new q(pe,ue.id,de)):le("Unexpected: Task does not exist.")}T?Y(this,$,T):R.to($.task,this.b,this.m).then(pe=>Y(this,$,pe))});return this.l.set($.id,V),V.then(j=>(this.k.set($.id,j),j),j=>Promise.reject(j))}z($,T){$._deprecated&&this.g.report("Task.constructor",T.extension,"Use the Task constructor that takes a `scope` instead.")}A($){this.o.get($.id)&&this.o.delete($.id),this.n.has($.id)&&this.p!==$.id&&(this.m.delete($.id),this.n.delete($.id));const L=this.n.values();let V=L.next();for(;!V.done;)!this.o.has(V.value)&&this.p!==V.value&&(this.m.delete(V.value),this.n.delete(V.value)),V=L.next()}};Z=qe([Ve(0,m.IExtHostRpcService),Ve(1,b.IExtHostInitDataService),Ve(2,A.IExtHostWorkspace),Ve(3,y.IExtHostDocumentsAndEditors),Ve(4,k.IExtHostConfiguration),Ve(5,w.IExtHostTerminalService),Ve(6,l.ILogService),Ve(7,v.IExtHostApiDeprecationService)],Z),e.ExtHostTaskBase=Z;let x=class extends Z{constructor($,T,L,V,j,le,Y,pe){super($,T,L,V,j,le,Y,pe),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask($,T){if(!T.execution)throw new Error("Tasks to execute must include an execution");const L=R.from(T,$);if(L===void 0)throw new Error("Task is not valid");if(a.is(L.execution))await this.x(L,T,!1);else throw new P.NotSupportedError;const V=await this.y(await this.a.$getTaskExecution(L),T);return this.a.$executeTask(L).catch(j=>{throw new Error(j)}),V}u($,T,L,V){const j=[];if(V)for(const le of V){this.z(le,L),(!le.definition||!$[le.definition.type])&&this.f.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const Y=R.from(le,L.extension);Y&&a.is(Y.execution)?(j.push(Y),T.push(this.x(Y,le,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:L.extension}}async v($){if(a.is($.execution))return $;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables($,T){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,T,L){}};x=qe([Ve(0,m.IExtHostRpcService),Ve(1,b.IExtHostInitDataService),Ve(2,A.IExtHostWorkspace),Ve(3,y.IExtHostDocumentsAndEditors),Ve(4,k.IExtHostConfiguration),Ve(5,w.IExtHostTerminalService),Ve(6,l.ILogService),Ve(7,v.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(Ie[242],Ce([1,0,19,21,39,35,23,77,45]),function(te,e,n,C,S,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(m,b,f){this.k=m,this.l=b,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&M.parse(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&M.parse(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const b=this.k.folderQueries||[];return new Promise((f,s)=>{const o=l=>{this.f++,m(l)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(l=>{const v=l.toString(),E=n.basename(v);this.j&&this.j(v,E)||this.v(o,{base:l,basename:E})}),Promise.all(b.map(l=>this.p(l,o))).then(l=>{f({limitHit:this.e,stats:l[0]||void 0})},l=>{s(new Error((0,S.toErrorMessage)(l)))})})}async p(m,b){const f=new C.CancellationTokenSource,s=this.q(m),o=this.r(),l=new y.QueryGlobTester(this.k,m),v=!l.hasSiblingExcludeClauses();let E;try{this.h.add(f),E=A.StopWatch.create();const P=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,f.token),p=E.elapsed(),r=A.StopWatch.create();return this.g&&!this.e||(P&&P.forEach(d=>{const i=n.posix.relative(m.folder.path,d.path);if(v){const c=n.basename(d.path);this.v(b,{base:m.folder,relativePath:i,basename:c});return}this.s(o,m.folder,i,b)}),this.g&&!this.e)?null:(this.u(o,l,b),{providerTime:p,postProcessTime:r.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(m){const b=(0,y.resolvePatternsForProvider)(this.k.includePattern,m.includePattern),f=(0,y.resolvePatternsForProvider)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:b,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},b,f,s){if(f===this.a){const l=n.basename(this.a);this.v(s,{base:b,relativePath:this.a,basename:l})}function o(l){const v=n.basename(l),E=n.dirname(l);let P=m[E];P||(P=m[E]=[],o(E)),P.push({base:b,relativePath:l,basename:v})}o(f)}u({rootEntries:m,pathToEntries:b},f,s){const o=this,l=this.a;function v(E){const P=(0,y.hasSiblingFn)(()=>E.map(p=>p.basename));for(let p=0,r=E.length;p<r;p++){const d=E[p],{relativePath:i,basename:c}=d;if(f.matchesExcludesSync(i,c,l!==c?P:void 0))continue;const t=b[i];if(t)v(t);else{if(i===l)continue;o.v(s,d)}if(o.e)break}}v(m)}v(m,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(b))}}class O{constructor(){this.b=new Map}fileSearch(m,b,f,s){const o=this.c(m.cacheKey),l=new k(m,b,o&&o.token);let v=0;const E=P=>{v+=P.length,f(P.map(p=>this.d(p)))};return this.e(l,O.a,E,s).then(P=>({limitHit:P.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:P.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(!!m)return this.b.has(m)||this.b.set(m,new C.CancellationTokenSource),this.b.get(m)}d(m){return m.relativePath?{resource:I.joinPath(m.base,m.relativePath)}:{resource:m.base}}e(m,b,f,s){s.onCancellationRequested(()=>{m.cancel()});const o=v=>{v&&(l.push(v),b>0&&l.length>=b&&(f(l),l=[]))};let l=[];return m.search(o).then(v=>(l.length&&f(l),v),v=>(l.length&&f(l),Promise.reject(v)))}}e.FileSearchManager=O,O.a=512}),define(Ie[243],Ce([1,0,18,62,35,87,28,15,19,23,10,9,2,259,153,41,12,52,97,241,45]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o,l,v,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(g,R,F,q,Z){this.a=g,this.b=R,this.c=F,this.d=q,this.e=Z}text(g,R,F={}){g=this.f(g,F);const q=this.a.getValue(),Z=R&&R.some(N=>!this.a.getValue({resource:N}).search.useRipgrep);return{...this.h(R?.map(l.toWorkspaceFolder),F),type:2,contentPattern:g,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:q.search.usePCRE2||Z||!1,beforeContext:F.beforeContext,afterContext:F.afterContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}f(g,R){const F=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const q={...g,wordSeparators:F.editor.wordSeparators};return this.j(g,R)&&(q.isCaseSensitive=!0),this.k(g)&&(q.isMultiline=!0),q}file(g,R={}){return{...this.h(g,R),type:1,filePattern:R.filePattern?R.filePattern.trim():R.filePattern,exists:R.exists,sortByScore:R.sortByScore,cacheKey:R.cacheKey}}g(g,R){return g?(g=Array.isArray(g)?g.map(t):t(g),R?this.parseSearchPaths(g):{pattern:d(...Array.isArray(g)?g:[g])}):{}}h(g=[],R={}){const F=this.g(R.includePattern,R.expandPatterns),q=this.g(R.excludePattern,R.expandPatterns),Z=g.length>1,x=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(T=>this.q(T,R,q)):g.map(T=>this.r(T,R,q,Z))).filter(T=>!!T),N={_reason:R._reason,folderQueries:x,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:R.extraFileResources,excludePattern:q.pattern,includePattern:F.pattern,onlyOpenEditors:R.onlyOpenEditors,maxResults:R.maxResults};if(R.onlyOpenEditors){const T=n.coalesce(n.flatten(this.c.groups.map(j=>j.editors.map(le=>le.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const L=T.filter(j=>(0,P.pathIncludedInQuery)(N,j.fsPath)),V=this.i(L);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...N,...V}}const $=R.extraFileResources&&R.extraFileResources.filter(T=>(0,P.pathIncludedInQuery)(N,T.fsPath));return N.extraFileResources=$&&$.length?$:void 0,N}i(g){const R=[],F=new I.ResourceMap,q={};let Z=!1;return g.forEach(x=>{if(x.scheme===A.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(x)){const $=this.b.getWorkspaceFolder(x)?.uri??x.with({path:y.dirname(x.fsPath)});let T=F.get($);T||(Z=!0,T={folder:$,includePattern:{}},R.push(T),F.set($,T));const L=y.relative($.fsPath,x.fsPath);(0,w.assertIsDefined)(T.includePattern)[L.replace(/\\/g,"/")]=!0}else x.fsPath&&(Z=!0,q[x.fsPath]=!0)}),{folderQueries:R,includePattern:q,usingSearchPaths:!0,excludePattern:Z?void 0:{"**/*":!0}}}j(g,R){if(R.isSmartCase){if(g.isRegExp){if(O.containsUppercaseCharacter(g.pattern,!0))return!0}else if(O.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,b.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const R=V=>y.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),q=(Array.isArray(g)?g:i(g)).map(V=>{const j=this.e.resolvedUserHome;return j?(0,M.untildify)(V,j.scheme===A.Schemas.file?j.fsPath:j.path):V}),Z=C.groupBy(q,V=>R(V)?"searchPaths":"exprSegments"),x=(Z.exprSegments||[]).map(V=>O.rtrim(V,"/")).map(V=>O.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),c(V))),N={},$=this.m(Z.searchPaths||[]);$&&$.length&&(N.searchPaths=$);const T=n.flatten(x),L=d(...T);return L&&(N.pattern=L),N}l(g,R){return R.disregardExcludeSettings?void 0:(0,P.getExcludes)(g,!R.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const R=g.flatMap(q=>{let{pathPortion:Z,globPortion:x}=r(q);return x&&(x=h(x)),this.n(Z).flatMap($=>this.o($,x))}),F=new Map;return R.forEach(q=>{const Z=q.searchPath.toString(),x=F.get(Z);x?q.pattern&&(x.pattern=x.pattern||{},x.pattern[q.pattern]=!0):F.set(Z,{searchPath:q.searchPath,pattern:q.pattern?d(q.pattern):void 0})}),Array.from(F.values())}n(g){if(y.isAbsolute(g)){const R=this.b.getWorkspace().folders;return R[0]&&R[0].uri.scheme!==A.Schemas.file?[{searchPath:R[0].uri.with({path:g})}]:[{searchPath:m.URI.file(y.normalize(g))}]}if(this.b.getWorkbenchState()===2){const R=this.b.getWorkspace().folders[0].uri;if(g=t(g),g.startsWith("../")||g===".."){const q=y.posix.resolve(R.path,g);return[{searchPath:R.with({path:q})}]}const F=h(g);return[{searchPath:R,pattern:F}]}else{if(g==="./"||g===".\\")return[];{const R=g.replace(/^\.[\/\\]/,""),q=this.b.getWorkspace().folders.map(Z=>{const x=R.match(new RegExp(`^${O.escapeRegExpCharacters(Z.name)}(?:/(.*)|$)`));return x?{match:x,folder:Z}:null}).filter(w.isDefined);if(q.length)return q.map(Z=>{const x=Z.match[1];return{searchPath:Z.folder.uri,pattern:x&&h(x)}});{const Z=g.match(/\.[\/\\](.+)[\/\\]?/),x=Z?Z[1]:g,N=f.localize(0,null,x);throw new Error(N)}}}}o(g,R){const F=g.pattern&&R?`${g.pattern}/${R}`:g.pattern||R,q=[{searchPath:g.searchPath,pattern:F}];return F&&!F.endsWith("**")&&q.push({searchPath:g.searchPath,pattern:F+"/**"}),q}q(g,R,F){const q=this.r((0,l.toWorkspaceFolder)(g.searchPath),R,F,!1);return q?{...q,includePattern:g.pattern}:null}r(g,R,F,q){let Z;const x=m.URI.isUri(g)?g:g.uri;if(F.searchPaths){const V=F.searchPaths.filter(j=>(0,k.isEqual)(j.searchPath,x))[0];if(V&&!V.pattern)return null;V&&(Z=V.pattern)}const N=this.a.getValue({resource:x}),T={...this.l(N,R)||{},...Z||{}},L=m.URI.isUri(g)?(0,k.basename)(g):g.name;return{folder:x,folderName:q?L:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof R.disregardIgnoreFiles=="boolean"?R.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof R.disregardGlobalIgnoreFiles=="boolean"?R.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof R.disregardParentIgnoreFiles=="boolean"?R.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof R.ignoreSymlinks=="boolean"?R.ignoreSymlinks:!N.search.followSymlinks}}};p=qe([Ve(0,s.IConfigurationService),Ve(1,l.IWorkspaceContextService),Ve(2,v.IEditorGroupsService),Ve(3,o.ILogService),Ve(4,E.IPathService)],p),e.QueryBuilder=p;function r(u){const g=u.match(/[\*\{\}\(\)\[\]\?]/);if(g){const R=g.index,F=u.substr(0,R).match(/[/|\\][^/\\]*$/);if(F){let q=u.substr(0,F.index);return q.match(/[/\\]/)||(q+="/"),{pathPortion:q,globPortion:u.substr((F.index||0)+1)}}}return{pathPortion:u}}function d(...u){return u.length?u.reduce((g,R)=>(g[R]=!0,g),Object.create(null)):void 0}function i(u){return S.splitGlobAware(u,",").map(g=>g.trim()).filter(g=>!!g.length)}function c(u){return[`**/${u}/**`,`**/${u}`].map(R=>R.replace(/\*\*\/\*\*/g,"**"))}function t(u){return u.replace(/\\/g,"/")}function h(u){return t(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function a(u,g){u=n.distinct(u,q=>q.toString());const R=[],F=g.getWorkspace();return u&&u.forEach(q=>{let Z;if(g.getWorkbenchState()===2)Z=(0,k.relativePath)(F.folders[0].uri,q),Z&&Z!=="."&&(Z="./"+Z);else{const x=g.getWorkspaceFolder(q);if(x){const N=x.name;if(F.folders.filter(T=>T.name===N).length===1){const T=(0,k.relativePath)(x.uri,q);T===""?Z=`./${x.name}`:Z=`./${x.name}/${T}`}else Z=q.fsPath}}Z&&R.push(Z)}),R}e.resolveResourcesForSearchIncludes=a}),define(Ie[244],Ce([1,0,23,2,21,11,3,243,45,52]),function(te,e,n,C,S,M,I,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function w(s,o){const l=o.activationEvents;if(!l)return Promise.resolve(void 0);const v=[],E=[];for(const c of l)if(/^workspaceContains:/.test(c)){const t=c.substr(18);t.indexOf("*")>=0||t.indexOf("?")>=0||s.forceUsingSearch?E.push(t):v.push(t)}if(v.length===0&&E.length===0)return Promise.resolve(void 0);let P;const p=new Promise((c,t)=>{P=c}),r=c=>P({activationEvent:c}),d=Promise.all(v.map(c=>m(s,c,r))).then(()=>{}),i=b(s,o.identifier,E,r);return Promise.all([d,i]).then(()=>{P(void 0)}),p}e.checkActivateWorkspaceContainsExtension=w;async function m(s,o,l){for(const v of s.folders)if(await s.exists(n.joinPath(C.URI.revive(v),o))){l(`workspaceContains:${o}`);return}}async function b(s,o,l,v){if(l.length===0)return Promise.resolve(void 0);const E=new S.CancellationTokenSource,P=s.checkExists(s.folders,l,E.token),p=setTimeout(async()=>{E.cancel(),s.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},O);let r=!1;try{r=await P}catch(d){M.isCancellationError(d)||M.onUnexpectedError(d)}E.dispose(),clearTimeout(p),r&&v(`workspaceContains:${l.join(",")}`)}function f(s,o,l,v){const E=s.get(I.IInstantiationService),P=s.get(y.ISearchService),r=E.createInstance(A.QueryBuilder).file(o.map(d=>(0,k.toWorkspaceFolder)(C.URI.revive(d))),{_reason:"checkExists",includePattern:l,exists:!0});return P.fileSearch(r,v).then(d=>!!d.limitHit,d=>M.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=f});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!S:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(te,n):S?S.value=n:e.set(te,n),n},Oe=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ie[33],Ce([1,0,139,19,82,23,16,6,46,2,12,5,32,189,80,31,26,98,11,25,24,174,7,94,3,27,81,17,67,69,60,4,244,79,176,15,78,77]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o,l,v,E,P,p,r,d,i,c,t,h,a,u,g,R,F,q,Z,x,N,$){"use strict";var T,L,V;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let j=class Bi extends A.Disposable{constructor(re,G,H,oe,ve,Ae,Be,xe,Te,Se,ke){super(),this.a=this.B(new R.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=G,this.g=H,this.f=Be,this.j=oe,this.k=ve,this.l=Ae,this.m=Te,this.p=Se,this.s=ke,this.t=this.g.getProxy(w.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(w.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(w.MainContext.MainThreadExtensionService),this.w=new I.Barrier,this.y=new I.Barrier,this.z=new I.Barrier,this.C=new I.Barrier,this.F=new l.ExtensionDescriptionRegistry(this.f.allExtensions);const se=(0,o.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new l.ExtensionDescriptionRegistry(pe(this.F,se)),this.G=new f.ExtHostStorage(this.g,this.l),this.H=new q.ExtHostSecretState(this.g),this.I=xe,this.h=re.createChild(new a.ServiceCollection([f.IExtHostStorage,this.G],[q.IExtHostSecretState,this.H])),this.J=this.B(new b.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ce,J,D)=>{this.v.$onExtensionActivationError(ce,v.transformErrorForSerialization(J),D)},actualActivateExtension:async(ce,J)=>{if(l.ExtensionDescriptionRegistry.isHostExtension(ce,this.D,this.F))return await this.v.$activateExtension(ce,J),new b.HostExtension;const D=this.D.getExtensionDescription(ce);return this.Y(D,J)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),S.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(re){v.onUnexpectedError(re)}}async Q(){this.I.onWillDeactivateAll();let re=[];try{re=this.D.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this.X(ve))}catch{}await Promise.all(re)}terminate(re,G=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${re}`),this.l.flush(),this.p.dispose(),this.J.dispose(),v.setUnexpectedErrorHandler(oe=>{this.l.error(oe)}),this.g.dispose();const H=this.Q();Promise.race([(0,I.timeout)(5e3),H]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${G}`):this.l.info(`Extension host exiting with code ${G}`),this.l.flush(),this.l.dispose(),this.c.exit(G)})}isActivated(re){return this.z.isOpen()?this.J.isActivated(re):!1}async getExtension(re){const G=await this.v.$getExtension(re);let H;if(G?.browserNlsBundleUris){H={};for(const oe of Object.keys(G.browserNlsBundleUris))H[oe]=k.URI.revive(G.browserNlsBundleUris[oe])}return G&&{...G,identifier:new E.ExtensionIdentifier(G.identifier.value),extensionLocation:k.URI.revive(G.extensionLocation),browserNlsBundleUris:H}}R(re,G){return this.J.activateByEvent(re,G)}S(re,G){return this.J.activateById(re,G)}activateByIdWithErrors(re,G){return this.S(re,G).then(()=>{const H=this.J.getActivatedExtension(re);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(re=>this.D)}getExtensionExports(re){return this.z.isOpen()?this.J.getActivatedExtension(re).exports:null}async U(re){if(re.scheme!==x.Schemas.file)return re;const G=await this.c.realpath(re.fsPath);return k.URI.file(G)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(re=>new ue(re))),this.L}async W(re){const G=y.TernarySearchTree.forUris(H=>M.extUriBiasedIgnorePathCase.ignorePathCasing(H));return await Promise.all(re.map(async H=>{if(this.ob(H)){const oe=await this.U(H.extensionLocation);G.set(oe,H)}})),G}X(re){let G=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(re))return G;const H=this.J.getActivatedExtension(re);if(!H)return G;try{typeof H.module.deactivate=="function"&&(G=Promise.resolve(H.module.deactivate()).then(void 0,oe=>(this.l.error(oe),Promise.resolve(void 0))))}catch(oe){this.l.error(`An error occurred when deactivating the extension '${re.value}':`),this.l.error(oe)}try{(0,A.dispose)(H.subscriptions)}catch(oe){this.l.error(`An error occurred when deactivating the subscriptions for extension '${re.value}':`),this.l.error(oe)}return G}async Y(re,G){return this.f.remote.isRemote?this.v.$onWillActivateExtension(re.identifier):await this.v.$onWillActivateExtension(re.identifier),this.ab(re,G).then(H=>{const oe=H.activationTimes;return this.v.$onDidActivateExtension(re.identifier,oe.codeLoadingTime,oe.activateCallTime,oe.activateResolvedTime,G),this.Z(re,G,"success",oe),H},H=>{throw this.Z(re,G,"failure"),H})}Z(re,G,H,oe){const ve=le(re,G);this.u.$publicLog2("extensionActivationTimes",{...ve,...oe||{},outcome:H})}ab(re,G){const H=le(re,G);this.u.$publicLog2("activatePlugin",H);const oe=this.ob(re);if(!oe)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${re.identifier.value}, startup: ${G.startup}, activationEvent: '${G.activationEvent}'${re.identifier.value!==G.extensionId.value?`, root cause: ${G.extensionId.value}`:""}`),this.l.flush();const ve=new b.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this.pb(re,(0,M.joinPath)(re.extensionLocation,oe),ve),this.bb(re)]).then(Ae=>(S.mark(`code/extHost/willActivateExtension/${re.identifier.value}`),Bi.cb(this.l,re.identifier,Ae[0],Ae[1],ve))).then(Ae=>(S.mark(`code/extHost/didActivateExtension/${re.identifier.value}`),Ae))}bb(re){const G=new p.ExtensionGlobalMemento(re,this.G),H=new p.ExtensionMemento(re.identifier.value,!1,this.G),oe=new Z.ExtensionSecrets(re,this.H),ve=re.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Ae=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${re.identifier.value}`),Promise.all([G.whenReady,H.whenReady,this.I.whenReady]).then(()=>{const Be=this;let xe,Te;const Se=(0,o.isProposedApiEnabled)(re,"ipc")?this.f.messagePorts?.get(E.ExtensionIdentifier.toKey(re.identifier)):void 0;return Object.freeze({globalState:G,workspaceState:H,secrets:oe,subscriptions:[],get extensionUri(){return re.extensionLocation},get extensionPath(){return re.extensionLocation.fsPath},asAbsolutePath(ke){return C.join(re.extensionLocation.fsPath,ke)},get storagePath(){return Be.I.workspaceValue(re)?.fsPath},get globalStoragePath(){return Be.I.globalValue(re).fsPath},get logPath(){return C.join(Be.f.logsLocation.fsPath,re.identifier.value)},get logUri(){return k.URI.joinPath(Be.f.logsLocation,re.identifier.value)},get storageUri(){return Be.I.workspaceValue(re)},get globalStorageUri(){return Be.I.globalValue(re)},get extensionMode(){return ve},get extension(){return xe===void 0&&(xe=new Y(Be,re.identifier,re,Ae,!1)),xe},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(re,"extensionRuntime"),Be.extensionRuntime},get environmentVariableCollection(){return Be.p.getEnvironmentVariableCollection(re)},get messagePassingProtocol(){if(!Te){if(!Se)return;const ke=R.Event.buffer(R.Event.fromDOMEventEmitter(Se,"message",se=>se.data));Se.start(),Te={onDidReceiveMessage:ke,postMessage:Se.postMessage.bind(Se)}}return Te}})})}static cb(re,G,H,oe,ve){return H=H||{activate:void 0,deactivate:void 0},this.db(re,G,H,oe,ve).then(Ae=>new b.ActivatedExtension(!1,null,ve.build(),H,Ae,oe.subscriptions))}static db(re,G,H,oe,ve){if(typeof H.activate=="function")try{ve.activateCallStart(),re.trace(`ExtensionService#_callActivateOptional ${G.value}`);const Ae=typeof global=="object"?global:self,Be=H.activate.apply(Ae,[oe]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Be).then(xe=>(ve.activateResolveStop(),xe))}catch(Ae){return Promise.reject(Ae)}else return Promise.resolve(H)}eb(re,G){this.S(re.identifier,{startup:!1,extensionId:re.identifier,activationEvent:G}).then(void 0,H=>{this.l.error(H)})}fb(){this.v.$setPerformanceMarks(S.getMarks());for(const re of this.D.getAllExtensionDescriptions())if(re.activationEvents)for(const G of re.activationEvents)G==="onStartupFinished"&&this.eb(re,G)}gb(){const re=this.R("*",!0).then(void 0,ve=>{this.l.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.hb(ve.added)));const G=this.j.workspace?this.j.workspace.folders:[],H=this.hb(G),oe=Promise.all([re,H]).then(()=>{});return Promise.race([oe,(0,I.timeout)(1e4)]).then(()=>{this.fb()}),oe}hb(re){return re.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(G=>this.ib(re,G))).then(()=>{})}async ib(re,G){if(this.isActivated(G.identifier))return;const H=!this.f.remote.isRemote&&!!this.f.remote.authority,oe={logService:this.l,folders:re.map(Ae=>Ae.uri),forceUsingSearch:H,exists:Ae=>this.c.exists(Ae.fsPath),checkExists:(Ae,Be,xe)=>this.t.$checkExists(Ae,Be,xe)},ve=await(0,F.checkActivateWorkspaceContainsExtension)(oe,G);if(!!ve)return this.S(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:ve.activationEvent}).then(void 0,Ae=>this.l.error(Ae))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(re){throw console.error(re),re}}async jb(){const{extensionDevelopmentLocationURI:re,extensionTestsLocationURI:G}=this.f.environment;if(!re||!G)throw new Error(n.localize(0,null));const H=await this.pb(null,G,new b.ExtensionActivationTimesBuilder(!1));if(!H||typeof H.run!="function")throw new Error(n.localize(1,null,G.toString()));return new Promise((oe,ve)=>{const Ae=(Te,Se)=>{Te?ve(Te):oe(typeof Se=="number"&&Se>0?1:0)},Be=(0,M.originalFSPath)(G),xe=H.run(Be,Ae);xe&&xe.then&&xe.then(()=>{oe(0)}).catch(Te=>{ve(Te instanceof Error&&Te.stack?Te.stack:String(Te))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(re,G){return this.M[re]=G,(0,A.toDisposable)(()=>{delete this.M[re]})}async lb(re){const G=re.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const H=re.substr(0,G);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this.M[H]}}async $resolveAuthority(re,G){const H=$.StopWatch.create(!1),oe=()=>`[resolveAuthority(${(0,d.getRemoteAuthorityPrefix)(re)},${G})][${H.elapsed()}ms] `,ve=Se=>this.l.info(`${oe()}${Se}`),Ae=(Se,ke=void 0)=>this.l.error(`${oe()}${Se}`,ke);ve("activating resolver...");const{authorityPrefix:Be,resolver:xe}=await this.lb(re);if(!xe)return Ae("no resolver"),{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Be}.`,detail:void 0}};const Te=new I.IntervalTimer;try{ve("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(xe)),Te.cancelAndSet(()=>ve("waiting..."),1e3),ve("invoking resolve()..."),S.mark(`code/extHost/willResolveAuthority/${Be}`);const Se=await xe.resolve(re,{resolveAttempt:G});S.mark(`code/extHost/didResolveAuthorityOK/${Be}`),Te.dispose(),ve(`returned ${Se.host}:${Se.port}`);const ke={authority:re,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},se={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ke,options:se,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(S.mark(`code/extHost/didResolveAuthorityError/${Be}`),Te.dispose(),Ae("returned an error",Se),Se instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(re,G){this.l.info(`$getCanonicalURI invoked for authority (${(0,d.getRemoteAuthorityPrefix)(re)})`);const{resolver:H}=await this.lb(re);if(!H)return null;const oe=k.URI.revive(G);if(typeof H.getCanonicalURI>"u")return oe;const ve=await(0,I.asPromise)(()=>H.getCanonicalURI(oe));return ve||oe}static mb(re,G,H){const oe=new l.ExtensionDescriptionRegistry(re.getAllExtensionDescriptions());oe.deltaExtensions(H.toAdd,H.toRemove);const ve=(0,o.extensionIdentifiersArrayToSet)(G.getAllExtensionDescriptions().map(Be=>Be.identifier));for(const Be of H.myToRemove)ve.delete(E.ExtensionIdentifier.toKey(Be));for(const Be of H.myToAdd)ve.add(E.ExtensionIdentifier.toKey(Be));const Ae=pe(oe,ve);return{globalRegistry:oe,myExtensions:Ae}}$startExtensionHost(re){re.toAdd.forEach(oe=>oe.extensionLocation=k.URI.revive(oe.extensionLocation));const{globalRegistry:G,myExtensions:H}=Bi.mb(this.F,this.D,re);return this.F.set(G.getAllExtensionDescriptions()),this.D.set(H),this.kb()}$activateByEvent(re,G){return G===1?this.R(re,!1):this.z.wait().then(H=>this.R(re,!1))}async $activate(re,G){return await this.z.wait(),this.D.getExtensionDescription(re)?(await this.S(re,G),!0):!1}async $deltaExtensions(re){re.toAdd.forEach(Ae=>Ae.extensionLocation=k.URI.revive(Ae.extensionLocation));const{globalRegistry:G,myExtensions:H}=Bi.mb(this.F,this.D,re),oe=await this.W(H);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.F.set(G.getAllExtensionDescriptions()),this.D.set(H),Promise.resolve(void 0)}async $test_latency(re){return re}async $test_up(re){return re.byteLength}async $test_down(re){const G=P.VSBuffer.alloc(re),H=Math.random()%256;for(let oe=0;oe<re;oe++)G.writeUInt8(H,oe);return G}async $updateRemoteConnectionData(re){this.P=re,this.a.fire()}};j=qe([Ve(0,i.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,h.IExtHostRpcService),Ve(3,s.IExtHostWorkspace),Ve(4,m.IExtHostConfiguration),Ve(5,O.ILogService),Ve(6,c.IExtHostInitDataService),Ve(7,t.IExtensionStoragePaths),Ve(8,u.IExtHostTunnelService),Ve(9,g.IExtHostTerminalService),Ve(10,N.IExtHostLocalizationService)],j),e.AbstractExtHostExtensionService=j;function le(de,re){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:re.activationEvent,reasonId:re.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class Y{constructor(re,G,H,oe,ve){T.set(this,void 0),L.set(this,void 0),V.set(this,void 0),Je(this,T,re,"f"),Je(this,L,G,"f"),Je(this,V,H.identifier,"f"),this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=C.normalize((0,M.originalFSPath)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=oe,this.isFromDifferentExtensionHost=ve}get isActive(){return Oe(this,T,"f").isActivated(Oe(this,V,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,T,"f").getExtensionExports(Oe(this,V,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,T,"f").activateByIdWithErrors(Oe(this,V,"f"),{startup:!1,extensionId:Oe(this,L,"f"),activationEvent:"api"}),this.exports}}e.Extension=Y,T=new WeakMap,L=new WeakMap,V=new WeakMap;function pe(de,re){return de.getAllExtensionDescriptions().filter(G=>re.has(E.ExtensionIdentifier.toKey(G.identifier)))}class ue{constructor(re){this.a=re}setSearchTree(re){this.a=re}findSubstr(re){return this.a.findSubstr(re)}forEach(re){return this.a.forEach(re)}}e.ExtensionPaths=ue}),define(Ie[245],Ce([1,0,82,2,5,32,26,25,17,27,3,33,49,12,10]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(p,r,d,i,c,t,h){this.c=p,this.d=r,this.e=d,this.f=i,this.g=c,this.h=t,this.i=h,this.a=new Map,this.b=[]}async install(){this.j(),n.mark("code/extHost/willWaitForConfig");const p=await this.f.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const r=await this.g.getExtensionPathIndex();this.register(new l(this.c,r,this.d,p,this.i)),this.register(this.e.createInstance(v,r)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(E,r,this.h.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const r of p.nodeModuleName)this.a.set(r,p);else this.a.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this.b.push(r=>p.alternativeModuleName(r))}};s=qe([Ve(2,O.IInstantiationService),Ve(3,M.IExtHostConfiguration),Ve(4,w.IExtHostExtensionService),Ve(5,k.IExtHostInitDataService),Ve(6,b.ILogService)],s),e.RequireInterceptor=s;let o=class tn{constructor(p){if(p.environment.appRoot&&tn.a.size){const r=(0,f.escapeRegExpCharacters)(this.c(p.environment.appRoot.fsPath)),d="[a-z0-9_.-]",i=`@${d}+\\/${d}+|${d}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${r}/${c}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(p){if(!this.b)return;const r=this.b.exec(this.c(p));if(!r)return;const[,d,i,c]=r,t=tn.a.get(i);if(t!==void 0)return console.warn(`${i} as been renamed to ${t}, please update your imports`),d+t+c}c(p){return p.replace(/\\/g,"/")}};o.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=qe([Ve(0,k.IExtHostInitDataService)],o);class l{constructor(p,r,d,i,c){this.c=p,this.d=r,this.e=d,this.f=i,this.g=c,this.nodeModuleName="vscode",this.a=new Map}load(p,r){const d=this.d.findSubstr(r);if(d){let i=this.a.get(A.ExtensionIdentifier.toKey(d.identifier));return i||(i=this.c(d,this.e,this.f),this.a.set(A.ExtensionIdentifier.toKey(d.identifier),i)),i}if(!this.b){let i="";this.d.forEach((c,t)=>i+=`	${t} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${i}`),this.b=this.c(I.nullExtensionDescription,this.e,this.f)}return this.b}}let v=class{constructor(p,r,d){this.d=p,this.nodeModuleName="keytar",this.a=r.getProxy(S.MainContext.MainThreadTelemetry);const{environment:i}=d,c=r.getProxy(S.MainContext.MainThreadKeytar);if(i.appRoot){let t=i.appRoot.fsPath;m.platform==="win32"&&(t=t.replace(/\\/g,"/")),t[t.length-1]==="/"&&(t=t.substr(0,t.length-1)),this.b=new Set,this.b.add(`${t}/node_modules.asar/keytar`),this.b.add(`${t}/node_modules/keytar`)}this.c={getPassword:(t,h)=>c.$getPassword(t,h),setPassword:(t,h,a)=>c.$setPassword(t,h,a),deletePassword:(t,h)=>c.$deletePassword(t,h),findPassword:t=>c.$findPassword(t),findCredentials(t){return c.$findCredentials(t)}}}load(p,r){const d=this.d.findSubstr(r);return this.a.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(p){const r=p.length;if(r<=7||!this.b)return;const d=r-7;if((p.charAt(d)==="/"||p.charAt(d)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.b.has(p)))return"keytar"}};v=qe([Ve(1,y.IExtHostRpcService),Ve(2,k.IExtHostInitDataService)],v);let E=class{constructor(p,r,d){this.e=p,this.f=r,this.nodeModuleName=["open","opn"],this.d=d.getProxy(S.MainContext.MainThreadTelemetry);const i=d.getProxy(S.MainContext.MainThreadWindow);this.c=(c,t)=>{const h=C.URI.parse(c);return t?this.g(c,t):h.scheme==="http"||h.scheme==="https"?i.$openUri(h,c,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this.f?i.$openUri(h,c,{}):this.g(c,t)}}load(p,r,d){const i=this.e.findSubstr(r);return i&&(this.a=i.identifier.value,this.h()),this.b=d(p),this.c}g(p,r){return this.i(),this.b(p,r)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};E=qe([Ve(2,y.IExtHostRpcService)],E)}),define(Ie[108],Ce([1,0,84,6,19,49,3,57,58,33,7,31,186,32]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,I.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(l,v,E,P,p,r,d){function i(){if(E){const c=E.activeEditor();if(c)return c.document.uri;const t=P.tabGroups.all.find(h=>h.isActive)?.activeTab;if(t!==void 0){if(t.input instanceof O.TextDiffTabInput||t.input instanceof O.NotebookDiffEditorTabInput)return t.input.modified;if(t.input instanceof O.TextTabInput||t.input instanceof O.NotebookEditorTabInput||t.input instanceof O.CustomEditorTabInput)return t.input.uri}}}super({getFolderUri:c=>{const t=r.folders.filter(h=>h.name===c);if(t&&t.length>0)return t[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(c,t)=>p.getConfiguration(void 0,c).get(t),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=i();if(c)return S.normalize(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const c=i();if(c){const t=v.getWorkspaceFolder(c);if(t)return S.normalize(t.uri.fsPath)}}},getSelectedText:()=>{if(E){const c=E.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(E){const c=E.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>l.getExtension(c)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(M.env))}}let s=class extends C.Disposable{constructor(l,v,E,P,p){super(),this.b=l,this.c=v,this.g=E,this.h=P,this.i=p,this.a=new n.Lazy(async()=>{const r=await this.h.getConfigProvider(),i={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{i.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.i,r,i,this.j())})}getResolver(){return this.a.value}j(){}};s=qe([Ve(0,k.IExtHostExtensionService),Ve(1,w.IExtHostWorkspace),Ve(2,A.IExtHostDocumentsAndEditors),Ve(3,b.IExtHostConfiguration),Ve(4,y.IExtHostEditorTabs)],s),e.ExtHostVariableResolverProviderService=s}),define(Ie[109],Ce([1,0,16,4,9,2,3,5,58,33,17,7,31,179,181,32,108]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,I.createDecorator)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(i,c,t,h,a,u){this.D=c,this.E=t,this.F=h,this.G=a,this.H=u,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new C.Emitter,this.n=new C.Emitter,this.o=new C.Emitter,this.u=new C.Emitter,this.k=i.getProxy(A.MainContext.MainThreadDebugService),this.z=new C.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new E(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(g=>{g.onDidChange(R=>{this.I(g)}),this.I(g)})}asDebugSourceUri(i,c){const t=i;if(typeof t.sourceReference=="number"&&t.sourceReference>0){let h=`debug:${encodeURIComponent(t.path||"")}`,a="?";return c&&(h+=`${a}session=${encodeURIComponent(c.id)}`,a="&"),h+=`${a}ref=${t.sourceReference}`,M.URI.parse(h)}else{if(t.path)return M.URI.file(t.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(i){const c=[];for(const t of i.getAllExtensionDescriptions())if(t.contributes){const h=t.contributes.debuggers;if(h&&h.length>0)for(const a of h)(0,f.isDebuggerMainContribution)(a)&&c.push(a.type)}this.k.$registerDebugTypes(c)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const i=[];return this.w.forEach(c=>i.push(c)),i}addBreakpoints(i){this.T();const c=i.filter(a=>{const u=a.id;return this.w.has(u)?!1:(this.w.set(u,a),!0)});this.U(c,[],[]);const t=[],h=new Map;for(const a of c)if(a instanceof w.SourceBreakpoint){let u=h.get(a.location.uri.toString());u||(u={type:"sourceMulti",uri:a.location.uri,lines:[]},h.set(a.location.uri.toString(),u),t.push(u)),u.lines.push({id:a.id,enabled:a.enabled,condition:a.condition,hitCondition:a.hitCondition,logMessage:a.logMessage,line:a.location.range.start.line,character:a.location.range.start.character})}else a instanceof w.FunctionBreakpoint&&t.push({type:"function",id:a.id,enabled:a.enabled,hitCondition:a.hitCondition,logMessage:a.logMessage,condition:a.condition,functionName:a.functionName});return this.k.$registerBreakpoints(t)}removeBreakpoints(i){this.T();const c=i.filter(u=>this.w.delete(u.id));this.U([],c,[]);const t=c.filter(u=>u instanceof w.SourceBreakpoint).map(u=>u.id),h=c.filter(u=>u instanceof w.FunctionBreakpoint).map(u=>u.id),a=c.filter(u=>u instanceof w.DataBreakpoint).map(u=>u.id);return this.k.$unregisterBreakpoints(t,h,a)}startDebugging(i,c,t){return this.k.$startDebugging(i?i.uri:void 0,c,{parentSessionID:t.parentSession?t.parentSession.id:void 0,lifecycleManagedByParent:t.lifecycleManagedByParent,repl:t.consoleMode===w.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:t.noDebug,compact:t.compact,suppressSaveBeforeStart:t.suppressSaveBeforeStart,suppressDebugStatusbar:t.suppressDebugStatusbar??t.debugUI?.simple,suppressDebugToolbar:t.suppressDebugToolbar??t.debugUI?.simple,suppressDebugView:t.suppressDebugView??t.debugUI?.simple})}stopDebugging(i){return this.k.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,c,t){if(!c)return new w.Disposable(()=>{});const h=this.d++;return this.f.push({type:i,handle:h,provider:c}),this.k.$registerDebugConfigurationProvider(i,t,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,h),new w.Disposable(()=>{this.f=this.f.filter(a=>a.provider!==c),this.k.$unregisterDebugConfigurationProvider(h)})}registerDebugAdapterDescriptorFactory(i,c,t){if(!t)return new w.Disposable(()=>{});if(!this.P(i,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.M(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const h=this.g++;return this.h.push({type:c,handle:h,factory:t}),this.k.$registerDebugAdapterDescriptorFactory(c,h),new w.Disposable(()=>{this.h=this.h.filter(a=>a.factory!==t),this.k.$unregisterDebugAdapterDescriptorFactory(h)})}registerDebugAdapterTrackerFactory(i,c){if(!c)return new w.Disposable(()=>{});const t=this.i++;return this.j.push({type:i,handle:t,factory:c}),new w.Disposable(()=>{this.j=this.j.filter(h=>h.factory!==c)})}async $runInTerminal(i,c){return Promise.resolve(void 0)}async $substituteVariables(i,c){let t;const h=await this.W(i);return h&&(t={uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(t,c)}J(i,c){if(i.type==="implementation")return new p(i.implementation)}K(){}async $startDASession(i,c){const t=this,h=await this.V(c);return this.R(this.M(h.type),h).then(a=>{if(!a)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}' (extension might have failed to activate)`);const u=this.L(a),g=this.J(u,h);if(!g)throw new Error(`Couldn't create a debug adapter for type '${h.type}'.`);const R=g;return this.A.set(i,R),this.Q(h).then(F=>(F&&this.B.set(i,F),R.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const Z=q,x={type:"response",seq:0,command:Z.command,request_seq:Z.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const N=await this.C.sign(Z.arguments.value);x.body={signature:N},R.sendResponse(x)}else throw new Error("no signer")}catch(N){x.success=!1,x.message=N.message,R.sendResponse(x)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(q),q=(0,f.convertToVSCPaths)(q,!0),t.k.$acceptDAMessage(i,q)}),R.onError(q=>{F&&F.onError&&F.onError(q),this.k.$acceptDAError(i,q.name,q.message,q.stack)}),R.onExit(q=>{F&&F.onExit&&F.onExit((0,S.withNullAsUndefined)(q),void 0),this.k.$acceptDAExit(i,(0,S.withNullAsUndefined)(q),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),R.startSession()))})}$sendDAMessage(i,c){c=(0,f.convertToDAPaths)(c,!1);const t=this.B.get(i);t&&t.onWillReceiveMessage&&t.onWillReceiveMessage(c),this.A.get(i)?.sendMessage(c)}$stopDASession(i){const c=this.B.get(i);this.B.delete(i),c&&c.onWillStopSession&&c.onWillStopSession();const t=this.A.get(i);return this.A.delete(i),t?t.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const c=[],t=[],h=[];if(i.added)for(const a of i.added){const u=a.id;if(u&&!this.w.has(u)){let g;if(a.type==="function")g=new w.FunctionBreakpoint(a.functionName,a.enabled,a.condition,a.hitCondition,a.logMessage);else if(a.type==="data")g=new w.DataBreakpoint(a.label,a.dataId,a.canPersist,a.enabled,a.hitCondition,a.condition,a.logMessage);else{const R=M.URI.revive(a.uri);g=new w.SourceBreakpoint(new w.Location(R,new w.Position(a.line,a.character)),a.enabled,a.condition,a.hitCondition,a.logMessage)}(0,w.setBreakpointId)(g,u),this.w.set(u,g),c.push(g)}}if(i.removed)for(const a of i.removed){const u=this.w.get(a);u&&(this.w.delete(a),t.push(u))}if(i.changed){for(const a of i.changed)if(a.id){const u=this.w.get(a.id);if(u){if(u instanceof w.FunctionBreakpoint&&a.type==="function"){const g=u;g.enabled=a.enabled,g.condition=a.condition,g.hitCondition=a.hitCondition,g.logMessage=a.logMessage,g.functionName=a.functionName}else if(u instanceof w.SourceBreakpoint&&a.type==="source"){const g=u;g.enabled=a.enabled,g.condition=a.condition,g.hitCondition=a.hitCondition,g.logMessage=a.logMessage,g.location=new w.Location(M.URI.revive(a.uri),new w.Position(a.line,a.character))}h.push(u)}}}this.U(c,t,h)}$provideDebugConfigurations(i,c,t){return(0,n.asPromise)(async()=>{const h=this.O(i);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const a=await this.W(c);return h.provideDebugConfigurations(a,t)}).then(h=>{if(!h)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return h})}$resolveDebugConfiguration(i,c,t,h){return(0,n.asPromise)(async()=>{const a=this.O(i);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const u=await this.W(c);return a.resolveDebugConfiguration(u,t,h)})}$resolveDebugConfigurationWithSubstitutedVariables(i,c,t,h){return(0,n.asPromise)(async()=>{const a=this.O(i);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const u=await this.W(c);return a.resolveDebugConfigurationWithSubstitutedVariables(u,t,h)})}async $provideDebugAdapter(i,c){const t=this.N(i);if(!t)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const h=await this.V(c);return this.R(t,h).then(a=>{if(!a)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}'`);return this.L(a)})}async $acceptDebugSessionStarted(i){const c=await this.V(i);this.m.fire(c)}async $acceptDebugSessionTerminated(i){const c=await this.V(i);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(i){this.q=i?await this.V(i):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(i,c){(await this.V(i))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(i,c){const h={session:await this.V(i),event:c.event,body:c.body};this.u.fire(h)}L(i){if(i instanceof w.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof w.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof w.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof w.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}M(i){const c=this.h.filter(t=>t.type===i);if(c.length>0)return c[0].factory}N(i){const c=this.h.filter(t=>t.handle===i);if(c.length>0)return c[0].factory}O(i){const c=this.f.filter(t=>t.handle===i);if(c.length>0)return c[0].provider}P(i,c){if(i.contributes){const t=i.contributes.debuggers;if(t&&t.length>0){for(const h of t)if(h.label&&h.type&&h.type===c)return!0}}return!1}Q(i){const t=i.configuration.type,h=this.j.filter(a=>a.type===t||a.type==="*").map(a=>(0,n.asPromise)(()=>a.factory.createDebugAdapterTracker(i)).then(u=>u,u=>null));return Promise.race([Promise.all(h).then(a=>{const u=a.filter(g=>!!g);if(u.length>0)return new P(u)}),new Promise(a=>setTimeout(()=>a(void 0),1e3))]).catch(a=>{})}async R(i,c){const t=c.configuration.debugServer;if(typeof t=="number")return Promise.resolve(new w.DebugAdapterServer(t));if(i){const a=await this.E.getExtensionRegistry();return(0,n.asPromise)(()=>i.createDebugAdapterDescriptor(c,this.S(c,a))).then(u=>{if(u)return u})}const h=await this.E.getExtensionRegistry();return Promise.resolve(this.S(c,h))}S(i,c){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(i,c,t){(i.length>0||c.length>0||t.length>0)&&this.z.fire(Object.freeze({added:i,removed:c,changed:t}))}async V(i){if(i)if(typeof i=="string"){const c=this.l.get(i);if(c)return c}else{let c=this.l.get(i.id);if(!c){const t=await this.W(i.folderUri),h=i.parent?this.l.get(i.parent):void 0;c=new v(this.k,i.id,i.type,i.name,t,i.configuration,h),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(i){if(i){const c=M.URI.revive(i);return this.D.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};l=qe([Ve(0,O.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,s.IExtHostConfiguration),Ve(4,y.IExtHostEditorTabs),Ve(5,o.IExtHostVariableResolverProvider)],l),e.ExtHostDebugServiceBase=l;class v{constructor(i,c,t,h,a,u,g){this.d=i,this.f=c,this.g=t,this.h=h,this.i=a,this.j=u,this.k=g}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(i){this.h=i,this.d.$setDebugSessionName(this.f,i)}get parentSession(){return this.k}_acceptNameChanged(i){this.h=i}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(i,c){return this.d.$customDebugAdapterRequest(this.f,i,c)}getDebugProtocolBreakpoint(i){return this.d.$getDebugProtocolBreakpoint(this.f,i.id)}}e.ExtHostDebugSession=v;class E{constructor(i){this.value=Object.freeze({append(c){i.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.ExtHostDebugConsole=E;class P{constructor(i){this.d=i}onWillStartSession(){this.d.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(i):void 0)}onWillStopSession(){this.d.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.d.forEach(c=>c.onError?c.onError(i):void 0)}onExit(i,c){this.d.forEach(t=>t.onExit?t.onExit(i,c):void 0)}}class p extends b.AbstractDebugAdapter{constructor(i){super(),this.h=i,i.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.h.handleMessage(i)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let r=class extends l{constructor(i,c,t,h,a,u){super(i,c,t,h,a,u)}};r=qe([Ve(0,O.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,s.IExtHostConfiguration),Ve(4,y.IExtHostEditorTabs),Ve(5,o.IExtHostVariableResolverProvider)],r),e.WorkerExtHostDebugService=r}),define(Ie[246],Ce([1,0,11,82,2,5,237,12,66,67,27,158,17,54,33,74]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class o{static async installEarlyHandler(E){const P=E.get(A.ILogService),r=E.get(m.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(d=>{P.error(d);const i=n.transformErrorForSerialization(d);r.$onUnexpectedError(i)})}static async installFullHandler(E){const P=E.get(A.ILogService),p=E.get(m.IExtHostRpcService),r=E.get(f.IExtHostExtensionService),d=E.get(s.IExtHostTelemetry),i=p.getProxy(M.MainContext.MainThreadExtensionService),c=p.getProxy(M.MainContext.MainThreadErrors),t=await r.getExtensionPathIndex(),h=new WeakMap;Error.prepareStackTrace=(a,u)=>{let g="",R,F;for(const q of u)g+=`
	at ${q.toString()}`,F=q.getFileName(),!R&&F&&(R=t.findSubstr(S.URI.file(F)));return h.set(a,R?.identifier),`${a.name||"Error"}: ${a.message||""}${g}`},n.setUnexpectedErrorHandler(a=>{P.error(a);const u=n.transformErrorForSerialization(a),g=h.get(a);if(!g){c.$onUnexpectedError(u);return}i.$onExtensionRuntimeError(g,u);const R=d.onExtensionError(g,a);P.trace("forwarded error to extension?",R,g)})}}Error.stackTraceLimit=100;class l{constructor(E,P,p,r,d){this.a=p,this.b=new I.RPCProtocol(E,null,r),P=l.e(P,this.b);const i=new k.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());i.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...P,messagePorts:d}),i.set(m.IExtHostRpcService,new m.ExtHostRpcService(this.b)),i.set(b.IURITransformerService,new b.URITransformerService(r)),i.set(f.IHostUtils,p);const c=new w.InstantiationService(i,!0);c.invokeFunction(o.installEarlyHandler),this.d=c.invokeFunction(t=>t.get(A.ILogService)),C.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",P),this.c=c.invokeFunction(t=>t.get(f.IExtHostExtensionService)),this.c.initialize(),c.invokeFunction(o.installFullHandler)}async asBrowserUri(E){const P=this.b.getProxy(M.MainContext.MainThreadExtensionService);return S.URI.revive(await P.$asBrowserUri(E))}terminate(E){this.c.terminate(E)}static e(E,P){E.allExtensions.forEach(r=>{r.extensionLocation=S.URI.revive(P.transformIncomingURIs(r.extensionLocation));const d={};r.browserNlsBundleUris&&(Object.keys(r.browserNlsBundleUris).forEach(i=>d[i]=S.URI.revive(P.transformIncomingURIs(r.browserNlsBundleUris[i]))),r.browserNlsBundleUris=d)}),E.environment.appRoot=S.URI.revive(P.transformIncomingURIs(E.environment.appRoot));const p=E.environment.extensionDevelopmentLocationURI;return p&&(E.environment.extensionDevelopmentLocationURI=p.map(r=>S.URI.revive(P.transformIncomingURIs(r)))),E.environment.extensionTestsLocationURI=S.URI.revive(P.transformIncomingURIs(E.environment.extensionTestsLocationURI)),E.environment.globalStorageHome=S.URI.revive(P.transformIncomingURIs(E.environment.globalStorageHome)),E.environment.workspaceStorageHome=S.URI.revive(P.transformIncomingURIs(E.environment.workspaceStorageHome)),E.environment.extensionTelemetryLogResource=S.URI.revive(P.transformIncomingURIs(E.environment.extensionTelemetryLogResource)),E.nlsBaseUrl=S.URI.revive(P.transformIncomingURIs(E.nlsBaseUrl)),E.logsLocation=S.URI.revive(P.transformIncomingURIs(E.logsLocation)),E.logFile=S.URI.revive(P.transformIncomingURIs(E.logFile)),E.workspace=P.transformIncomingURIs(E.workspace),E}}e.ExtensionHostMain=l}),define(Ie[247],Ce([1,0,18,16,21,39,15,19,23,2,45]),function(te,e,n,C,S,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class w{constructor(v,E,P,p){this.d=v,this.e=E,this.f=P,this.g=p,this.a=null,this.b=!1,this.c=0}search(v,E){const P=this.d.folderQueries||[],p=new S.CancellationTokenSource;return E.onCancellationRequested(()=>p.cancel()),new Promise((r,d)=>{this.a=new b(v);let i=!1;const c=(t,h)=>{if(!i&&!this.b){const a=this.h(t);s(t)&&typeof this.d.maxResults=="number"&&this.c+a>this.d.maxResults&&(this.b=!0,i=!0,p.cancel(),t=this.j(t,this.d.maxResults-this.c));const u=this.h(t);this.c+=u,(u>0||!s(t))&&this.a.add(t,h)}};Promise.all(P.map((t,h)=>this.k(t,a=>c(a,h),p.token))).then(t=>{p.dispose(),this.a.flush();const h=t.some(a=>!!a&&!!a.limitHit);r({limitHit:this.b||h,messages:(0,n.flatten)(t.map(a=>a?.message?Array.isArray(a.message)?a.message:[a.message]:[])),stats:{type:this.g}})},t=>{p.dispose();const h=(0,M.toErrorMessage)(t);d(new Error(h))})})}h(v){return s(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}j(v,E){const P=Array.isArray(v.ranges)?v.ranges:[v.ranges],p=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:P.slice(0,E),preview:{matches:p.slice(0,E),text:v.preview.text},uri:v.uri}}async k(v,E,P){const p=new O.QueryGlobTester(this.d,v),r=[],d={report:t=>{if(!this.l(t))return;const h=v.folder.scheme===I.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(t.uri))):void 0,a=y.relativePath(v.folder,t.uri);if(a){const u=p.includedInQuery(a,A.basename(a),h);(0,C.isThenable)(u)?r.push(u.then(g=>{g&&E(t)})):u&&E(t)}}},i=this.n(v),c=await this.e.provideTextSearchResults(m(this.d.contentPattern),i,d,P);return r.length&&await Promise.all(r),c}l(v){if(s(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(v){const E=(0,O.resolvePatternsForProvider)(this.d.includePattern,v.includePattern),P=(0,O.resolvePatternsForProvider)(this.d.excludePattern,v.excludePattern),p={folder:k.URI.from(v.folder),excludes:P,includes:E,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.f.toCanonicalName(v.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.TextSearchManager=w;function m(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class b{constructor(v){this.e=v,this.b=-1,this.d=null,this.a=new o(512,E=>this.g(E))}add(v,E){this.d&&(this.b!==E||!y.isEqual(this.c,v.uri))&&(this.f(),this.d=null),this.d||(this.b=E,this.d={resource:v.uri,results:[]}),this.d.results.push(f(v))}f(){const v=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,v)}flush(){this.f(),this.a.flush()}g(v){this.e(v)}}e.TextSearchResultsCollector=b;function f(l){return s(l)?{preview:{matches:(0,n.mapArrayOrNot)(l.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:l.preview.text},ranges:(0,n.mapArrayOrNot)(l.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function s(l){return!!l.preview}e.extensionResultIsMatch=s;class o{constructor(v,E){this.g=v,this.h=E,this.c=0,this.d=[],this.e=0}addItem(v,E){!v||this.j(v,E)}addItems(v,E){!v||this.k(v,E)}j(v,E){this.d.push(v),this.e+=E,this.l()}k(v,E){this.d=this.d.concat(v),this.e+=E,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=o,o.a=4e3,o.b=50}),define(Ie[110],Ce([1,0,6,5,3,242,17,54,12,2,247]),function(te,e,n,C,S,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let w=class{constructor(s,o,l){this.k=s,this.l=o,this.n=l,this.c=this.k.getProxy(C.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.FileSearchManager}o(s){return this.l.transformOutgoingScheme(s)}registerTextSearchProvider(s,o){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const l=this.d++;return this.e.set(l,o),this.c.$registerTextSearchProvider(l,this.o(s)),(0,n.toDisposable)(()=>{this.g.delete(s),this.e.delete(l),this.c.$unregisterProvider(l)})}registerFileSearchProvider(s,o){if(this.i.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.i.add(s);const l=this.d++;return this.h.set(l,o),this.c.$registerFileSearchProvider(l,this.o(s)),(0,n.toDisposable)(()=>{this.i.delete(s),this.h.delete(l),this.c.$unregisterProvider(l)})}$provideFileSearchResults(s,o,l,v){const E=m(l),P=this.h.get(s);if(P)return this.j.fileSearch(E,P,p=>{this.c.$handleFileMatch(s,o,p.map(r=>r.resource))},v);throw new Error("unknown provider: "+s)}$clearCache(s){return this.j.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,o,l,v){const E=this.e.get(s);if(!E||!E.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const P=m(l);return this.q(P,E).search(r=>this.c.$handleTextMatch(s,o,r),v)}$enableExtensionHostSearch(){}q(s,o){return new O.TextSearchManager(s,o,{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}};w=qe([Ve(0,I.IExtHostRpcService),Ve(1,A.IURITransformerService),Ve(2,y.ILogService)],w),e.ExtHostSearch=w;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(b),extraFileResources:f.extraFileResources&&f.extraFileResources.map(s=>k.URI.revive(s))}}e.reviveQuery=m;function b(f){return{...f,folder:k.URI.revive(f.folder)}}}),define(Ie[248],Ce([1,0,66,105,31,103,32,38,57,60,107,109,110,80,69,76,104,59,37,79,74,58,218,12,190,108,78]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o,l,v,E,P,p,r,d,i,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(t.IExtHostLocalizationService,t.ExtHostLocalizationService,1),(0,n.registerSingleton)(d.ILoggerService,r.ExtHostLoggerService,1),(0,n.registerSingleton)(d.ILogService,i.ExtHostLogService,1),(0,n.registerSingleton)(s.IExtHostApiDeprecationService,s.ExtHostApiDeprecationService,1),(0,n.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,n.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration,0),(0,n.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem,0),(0,n.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService,0),(0,n.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,n.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,n.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,0),(0,n.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService,1),(0,n.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,0),(0,n.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage,0),(0,n.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,n.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,n.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,0),(0,n.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,n.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace,0),(0,n.registerSingleton)(E.IExtHostSecretState,E.ExtHostSecretState,0),(0,n.registerSingleton)(P.IExtHostTelemetry,P.ExtHostTelemetry,0),(0,n.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,n.registerSingleton)(c.IExtHostVariableResolverProvider,c.ExtHostVariableResolverProviderService,0)}),define(Ie[249],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class n{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(S){if(S&&this.a.has(S)){const M=this.a.get(S);return this.a.delete(S),M}}addDragOperationTransfer(S,M){this.a.set(S,M)}getRenderedTreeElement(S){if(this.b.has(S))return this.b.get(S)}addRenderedTreeItemElement(S,M){this.b.set(S,M)}removeRenderedTreeItemElement(S){this.b.has(S)&&this.b.delete(S)}}e.TreeviewsService=n}),define(Ie[250],Ce([1,0,143,7,23,2,4,6,178,16,7,9,18,8,21,249,26]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(P,p){if((0,w.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let r;return Array.isArray(P.highlights)&&(r=P.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),r=r.length?r:void 0),{label:P.label,highlights:r}}}class v{constructor(p,r,d){this.d=p,this.e=r,this.f=d,this.a=new Map,this.b=new s.TreeviewsService;function i(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:c=>i(c)?this.i(c):Array.isArray(c)&&c.length>0?c.map(t=>i(t)?this.i(t):t):c})}registerTreeDataProvider(p,r,d){const i=this.createTreeView(p,{treeDataProvider:r},d);return{dispose:()=>i.dispose()}}createTreeView(p,r,d){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=r.dragAndDropController?.dropMimeTypes??[],c=r.dragAndDropController?.dragMimeTypes??[],t=!!r.dragAndDropController?.handleDrag,h=!!r.dragAndDropController?.handleDrop,a=this.h(p,r,d),u=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:i,dragMimeTypes:c,hasHandleDrag:t,hasHandleDrop:h});return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,o.checkProposedApiEnabled)(d,"treeItemCheckbox"),a.onDidChangeCheckboxState},get message(){return a.message},set message(g){a.message=g},get title(){return a.title},set title(g){a.title=g},get description(){return a.description},set description(g){a.description=g},get badge(){return a.badge},set badge(g){g!==void 0&&O.ViewBadge.isViewBadge(g)?a.badge={value:Math.floor(Math.abs(g.value)),tooltip:g.tooltip}:g===void 0&&(a.badge=void 0)},reveal:(g,R)=>a.reveal(g,R),dispose:async()=>{await u,this.a.delete(p),a.dispose()}}}$getChildren(p,r){const d=this.a.get(p);return d?d.getChildren(r):Promise.reject(new y.NoTreeViewError(p))}async $handleDrop(p,r,d,i,c,t,h,a){const u=this.a.get(p);if(!u)return Promise.reject(new y.NoTreeViewError(p));const g=b.DataTransfer.toDataTransfer(d,async R=>(await this.d.$resolveDropFileData(p,r,R)).buffer);return h===p&&a&&await this.g(g,u,a,c,t),u.onDrop(g,i,c)}async g(p,r,d,i,c){const t=this.b.removeDragOperationTransfer(c);if(t)(await t)?.forEach((h,a)=>{h&&p.set(a,h)});else if(c&&r.handleDrag){const h=r.handleDrag(d,p,i);this.b.addDragOperationTransfer(c,h),await h}return p}async $handleDrag(p,r,d,i){const c=this.a.get(p);if(!c)return Promise.reject(new y.NoTreeViewError(p));const t=await this.g(new C.DataTransfer,c,r,i,d);if(!!t)return b.DataTransfer.toDataTransferDTO(t)}async $hasResolve(p){const r=this.a.get(p);if(!r)throw new y.NoTreeViewError(p);return r.hasResolve}$resolve(p,r,d){const i=this.a.get(p);if(!i)throw new y.NoTreeViewError(p);return i.resolveTreeItem(r,d)}$setExpanded(p,r,d){const i=this.a.get(p);if(!i)throw new y.NoTreeViewError(p);i.setExpanded(r,d)}$setSelection(p,r){const d=this.a.get(p);if(!d)throw new y.NoTreeViewError(p);d.setSelection(r)}$setFocus(p,r){const d=this.a.get(p);if(!d)throw new y.NoTreeViewError(p);d.setFocus(r)}$setVisible(p,r){const d=this.a.get(p);if(!d)throw new y.NoTreeViewError(p);d.setVisible(r)}$changeCheckboxState(p,r){const d=this.a.get(p);if(!d)throw new y.NoTreeViewError(p);d.setCheckboxState(r)}h(p,r,d){const i=new E(p,r,this.d,this.e.converter,this.f,d);return this.a.set(p,i),i}i(p){const r=this.a.get(p.$treeViewId);return r&&"$treeItemHandle"in p?r.getExtensionElement(p.$treeItemHandle):r&&"$focusedTreeItem"in p&&p.$focusedTreeItem?r.focusedElement:null}}e.ExtHostTreeViews=v;class E extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,w.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,r,d,i,c,t){if(super(),this.C=p,this.D=d,this.F=i,this.G=c,this.H=t,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new I.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new I.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new I.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new I.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new I.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new I.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new f.CancellationTokenSource,t.contributes&&t.contributes.views)for(const u in t.contributes.views)for(const g of t.contributes.views[u])g.id===p&&(this.J=g.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.w.fire({message:!1,element:u})));let h,a;this.B(I.Event.debounce(this.w.event,(u,g)=>(u||(u={message:!1,elements:[]}),g.element!==!1&&(h||(h=new Promise(R=>a=R),this.y=this.y.then(()=>h)),Array.isArray(g.element)?u.elements.push(...g.element):u.elements.push(g.element)),g.message&&(u.message=!0),u),200,!0)(({message:u,elements:g})=>{g.length&&(this.z=this.z.then(()=>{const R=a;return h=null,this.U(g).then(()=>R())})),u&&this.D.$setMessage(this.C,this.I)}))}async getChildren(p){const r=p?this.getExtensionElement(p):void 0;if(p&&!r)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let d=this.Q(p);return d||(d=await this.R(r)),d?d.map(i=>i.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,r){r=r||{select:!0,focus:!1};const d=(0,w.isUndefinedOrNull)(r.select)?!0:r.select,i=(0,w.isUndefinedOrNull)(r.focus)?!1:r.focus,c=(0,w.isUndefinedOrNull)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.y.then(()=>this.N(p)).then(t=>this.P(p,t[t.length-1]).then(h=>this.D.$reveal(this.C,{item:h.item,parentChain:t.map(a=>a.item)},{select:d,focus:i,expand:c})),t=>this.G.error(t)):this.D.$reveal(this.C,void 0,{select:d,focus:i,expand:c})}get message(){return this.I}set message(p){this.I=p,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.D.$setTitle(this.C,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.D.$setTitle(this.C,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=b.ViewBadge.from(p),this.D.$setBadge(this.C,p))}setExpanded(p,r){const d=this.getExtensionElement(p);d&&(r?this.r.fire(Object.freeze({element:d})):this.s.fire(Object.freeze({element:d})))}setSelection(p){(0,m.equals)(this.l,p)||(this.l=p,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const r=(await Promise.all(p.map(async d=>{const i=this.getExtensionElement(d.treeItemHandle);return i?{extensionItem:i,treeItem:await this.f.getTreeItem(i),newState:d.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);r.forEach(d=>{d.treeItem.checkboxState=d.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}),this.v.fire({items:r.map(d=>[d.extensionItem,d.newState])})}async handleDrag(p,r,d){const i=[];for(const c of p){const t=this.getExtensionElement(c);t&&i.push(t)}if(!(!this.g?.handleDrag||i.length===0))return await this.g.handleDrag(i,r,d),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,r,d){const i=r?this.getExtensionElement(r):void 0;if(!(!i&&r||!this.g?.handleDrop))return(0,k.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(i,p,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,r){if(!this.f.resolveTreeItem)return;const d=this.i.get(p);if(d){const i=this.j.get(d);if(i){const c=await this.f.resolveTreeItem(i.extensionItem,d,r)??i.extensionItem;return this.db(c),i.item.tooltip=this.ab(c.tooltip),i.item.command=this.bb(i.disposableStore,c.command),i.item}}}N(p){return this.O(p).then(r=>r?this.N(r).then(d=>this.P(r,d[d.length-1]).then(i=>(d.push(i),d))):Promise.resolve([]))}O(p){const r=this.j.get(p);return r?Promise.resolve(r.parent?this.i.get(r.parent.item.handle):void 0):(0,k.asPromise)(()=>this.f.getParent(p))}P(p,r){const d=this.j.get(p);return d?Promise.resolve(d):(0,k.asPromise)(()=>this.f.getTreeItem(p)).then(i=>this.gb(p,i,r,!0)).then(i=>this.getChildren(r?r.item.handle:void 0).then(()=>{const c=this.getExtensionElement(i);if(c){const t=this.j.get(c);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}Q(p){if(p){let r;if(typeof p=="string"){const d=this.getExtensionElement(p);r=d?this.j.get(d):void 0}else r=p;return r&&r.children||void 0}return this.h}async R(p){this.nb(p);const r=new f.CancellationTokenSource(this.S.token);try{const d=p?this.j.get(p):void 0,i=await this.f.getChildren(p);if(r.token.isCancellationRequested)return;const c=await Promise.all((0,m.coalesce)(i||[]).map(async t=>{const h=await this.f.getTreeItem(t);return h&&!r.token.isCancellationRequested?this.Z(t,h,d):null}));return r.token.isCancellationRequested?void 0:(0,m.coalesce)(c)}finally{r.dispose()}}U(p){if(p.some(d=>!d))return this.S.dispose(!0),this.S=new f.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const d=this.W(p);if(d.length)return this.X(d)}return Promise.resolve(void 0)}W(p){const r=new Set,d=p.map(c=>this.j.get(c));for(const c of d)if(c&&!r.has(c.item.handle)){let t=c;for(;t&&t.parent&&d.findIndex(h=>t&&t.parent&&h&&h.item.handle===t.parent.item.handle)===-1;){const h=this.i.get(t.parent.item.handle);t=h?this.j.get(h):void 0}t&&!t.parent&&r.add(c.item.handle)}const i=[];return r.forEach(c=>{const t=this.i.get(c);if(t){const h=this.j.get(t);h&&(!h.parent||!r.has(h.parent.item.handle))&&i.push(c)}}),i}X(p){const r={};return Promise.all(p.map(d=>this.Y(d).then(i=>{i&&(r[d]=i.item)}))).then(()=>Object.keys(r).length?this.D.$refresh(this.C,r):void 0)}Y(p){const r=this.getExtensionElement(p);if(r){const d=this.j.get(r);if(d)return this.nb(r),(0,k.asPromise)(()=>this.f.getTreeItem(r)).then(i=>{if(i){const c=this.eb(r,i,d.parent);return this.lb(r,c,d,d.parent),d.dispose(),c}return null})}return Promise.resolve(null)}Z(p,r,d){const i=this.eb(p,r,d);if(r.id&&this.i.has(i.item.handle))throw new Error((0,n.localize)(0,null,r.id));return this.kb(p,i),this.mb(i,d),i}ab(p){return O.MarkdownString.isMarkdownString(p)?b.MarkdownString.from(p):p}bb(p,r){return r?{...this.F.toInternal(r,p),originalId:r.command}:void 0}cb(p){if(!p.checkboxState)return;let r,d;return typeof p.checkboxState=="number"?r=p.checkboxState:(r=p.checkboxState.state,d=p.checkboxState.tooltip),{isChecked:r===O.TreeItemCheckboxState.Checked,tooltip:d}}db(p){if(!O.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,r,d){this.db(r);const i=new A.DisposableStore,c=this.gb(p,r,d),t=this.hb(r);return{item:{handle:c,parentHandle:d?d.item.handle:void 0,label:l(r.label,this.H),description:r.description,resourceUri:r.resourceUri,tooltip:this.ab(r.tooltip),command:this.bb(i,r.command),contextValue:r.contextValue,icon:t,iconDark:this.ib(r)||t,themeIcon:this.fb(r),collapsibleState:(0,w.isUndefinedOrNull)(r.collapsibleState)?O.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.cb(r)},extensionItem:r,parent:d,children:void 0,disposableStore:i,dispose(){i.dispose()}}}fb(p){return p.iconPath instanceof O.ThemeIcon?p.iconPath:void 0}gb(p,{id:r,label:d,resourceUri:i},c,t){if(r)return`${E.b}/${r}`;const h=l(d,this.H),a=c?c.item.handle:E.a;let u=h?h.label:i?(0,S.basename)(i):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const g=this.j.has(p)?this.j.get(p).item.handle:void 0,R=this.Q(c)||[];let F,q=0;do{if(F=`${a}/${q}:${u}`,t||!this.i.has(F)||g===F)break;q++}while(q<=R.length);return F}hb(p){if(p.iconPath&&!(p.iconPath instanceof O.ThemeIcon))return typeof p.iconPath=="string"||M.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof O.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return M.URI.isUri(p)?p:M.URI.file(p)}kb(p,r){this.i.set(r.item.handle,p),this.j.set(p,r)}lb(p,r,d,i){this.i.delete(r.item.handle),this.j.delete(p),r.item.handle!==d.item.handle&&this.i.delete(d.item.handle),this.kb(p,r);const c=this.Q(i)||[],t=c.filter(h=>h.item.handle===d.item.handle)[0];t&&c.splice(c.indexOf(t),1,r)}mb(p,r){r?(r.children||(r.children=[]),r.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const r=this.j.get(p);if(r){if(r.children)for(const d of r.children){const i=this.i.get(d.item.handle);i&&this.ob(i)}r.children=void 0}}else this.pb()}ob(p){const r=this.j.get(p);if(r){if(r.children)for(const d of r.children){const i=this.i.get(d.item.handle);i&&this.ob(i)}this.j.delete(p),this.i.delete(r.item.handle),r.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}E.a="0",E.b="1"}),define(Ie[251],Ce([1,0,21,11,4,30,2,129,260,117,127,36,5,73,205,204,38,206,32,208,209,210,193,211,57,33,212,213,216,217,219,105,196,224,225,226,80,60,229,250,8,7,50,232,61,104,31,184,215,48,103,107,109,110,12,54,17,27,220,191,69,76,202,230,81,59,235,233,234,203,37,227,231,79,58,74,221,106,222,15,92,195,175,214,6,26,180,78,172,223]),function(te,e,n,C,S,M,I,A,y,k,O,w,m,b,f,s,o,l,v,E,P,p,r,d,i,c,t,h,a,u,g,R,F,q,Z,x,N,$,T,L,V,j,le,Y,pe,ue,de,re,G,H,oe,ve,Ae,Be,xe,Te,Se,ke,se,ce,J,D,B,W,K,ee,he,ye,ae,be,Ee,We,He,tt,Xe,et,it,dt,Fe,st,_,Q,ge,Le,$e,je,_e,nt,wt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ct(lt){const at=lt.get(ke.IExtHostInitDataService),Bt=lt.get(Ee.IExtHostFileSystemInfo),Ot=lt.get(ee.IExtHostConsumerFileSystem),Ft=lt.get(c.IExtHostExtensionService),ft=lt.get(de.IExtHostWorkspace),Dt=lt.get(et.IExtHostTelemetry),$t=lt.get(v.IExtHostConfiguration),Nt=lt.get(Te.IURITransformerService),Ge=lt.get(Se.IExtHostRpcService),Lt=lt.get(N.IExtHostStorage),Mt=lt.get(K.IExtensionStoragePaths),Ut=lt.get(xe.ILoggerService),gt=lt.get(xe.ILogService),kt=lt.get(J.IExtHostTunnelService),De=lt.get(D.IExtHostApiDeprecationService),Pe=lt.get(ue.IExtHostWindow),me=lt.get(tt.IExtHostSecretState),X=lt.get(Xe.IExtHostEditorTabs);Ge.set(m.ExtHostContext.ExtHostFileSystemInfo,Bt),Ge.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Ut),Ge.set(m.ExtHostContext.ExtHostWorkspace,ft),Ge.set(m.ExtHostContext.ExtHostConfiguration,$t),Ge.set(m.ExtHostContext.ExtHostExtensionService,Ft),Ge.set(m.ExtHostContext.ExtHostStorage,Lt),Ge.set(m.ExtHostContext.ExtHostTunnelService,kt),Ge.set(m.ExtHostContext.ExtHostWindow,Pe),Ge.set(m.ExtHostContext.ExtHostSecretState,me),Ge.set(m.ExtHostContext.ExtHostTelemetry,Dt),Ge.set(m.ExtHostContext.ExtHostEditorTabs,X);const Re=Ge.set(m.ExtHostContext.ExtHostDecorations,lt.get(oe.IExtHostDecorations)),Me=Ge.set(m.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(i.IExtHostDocumentsAndEditors)),Qe=Ge.set(m.ExtHostContext.ExtHostCommands,lt.get(o.IExtHostCommands)),ze=Ge.set(m.ExtHostContext.ExtHostTerminalService,lt.get($.IExtHostTerminalService)),Ze=Ge.set(m.ExtHostContext.ExtHostDebugService,lt.get(Ae.IExtHostDebugService)),bt=Ge.set(m.ExtHostContext.ExtHostSearch,lt.get(Be.IExtHostSearch)),vt=Ge.set(m.ExtHostContext.ExtHostTask,lt.get(ve.IExtHostTask)),At=Ge.set(m.ExtHostContext.ExtHostOutputService,lt.get(R.IExtHostOutputService)),pt=Ge.set(m.ExtHostContext.ExtHostLocalization,lt.get(nt.IExtHostLocalizationService)),It=Ge.set(m.ExtHostContext.ExtHostUrls,new Y.ExtHostUrls(Ge)),ht=Ge.set(m.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Ge,Me)),Kt=Ge.set(m.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Ge,Me,gt)),Vt=Ge.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(gt,ht,Ge.getProxy(m.MainContext.MainThreadBulkEdits))),Et=Ge.set(m.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(Ge,Qe,Me,ht)),Qt=Ge.set(m.ExtHostContext.ExtHostNotebookDocuments,new ge.ExtHostNotebookDocuments(Et)),ri=Ge.set(m.ExtHostContext.ExtHostNotebookEditors,new Q.ExtHostNotebookEditors(gt,Et)),ei=Ge.set(m.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(Ge,at,Et,Qe,gt)),bi=Ge.set(m.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(Ge,Et)),Tt=Ge.set(m.ExtHostContext.ExtHostEditors,new T.ExtHostEditors(Ge,Me)),si=Ge.set(m.ExtHostContext.ExtHostTreeViews,new L.ExtHostTreeViews(Ge.getProxy(m.MainContext.MainThreadTreeViews),Qe,gt)),jt=Ge.set(m.ExtHostContext.ExtHostEditorInsets,new re.ExtHostEditorInsets(Ge.getProxy(m.MainContext.MainThreadEditorInsets),Tt,at.remote)),ti=Ge.set(m.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Ge,gt,Bt,Me)),oi=Ge.set(m.ExtHostContext.ExtHostLanguages,new u.ExtHostLanguages(Ge,ht,Qe.converter,Nt)),ct=Ge.set(m.ExtHostContext.ExtHostLanguageFeatures,new a.ExtHostLanguageFeatures(Ge,Nt,ht,Qe,ti,gt,De,Dt)),Oi=Ge.set(m.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(Ge,ct)),_t=Ge.set(m.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(Ge,gt,Me)),Wt=Ge.set(m.ExtHostContext.ExtHostQuickOpen,(0,q.createExtHostQuickOpen)(Ge,ft,Qe)),ai=Ge.set(m.ExtHostContext.ExtHostSCM,new Z.ExtHostSCM(Ge,Qe,gt)),Ei=Ge.set(m.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(Ge,Qe,ht)),ci=Ge.set(m.ExtHostContext.ExtHostProgress,new F.ExtHostProgress(Ge.getProxy(m.MainContext.MainThreadProgress))),wi=Ge.set(m.ExtHostContext.ExtHosLabelService,new G.ExtHostLabelService(Ge)),ui=Ge.set(m.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Ge)),ii=Ge.set(m.ExtHostContext.ExtHostAuthentication,new B.ExtHostAuthentication(Ge)),Si=Ge.set(m.ExtHostContext.ExtHostTimeline,new W.ExtHostTimeline(Ge,Qe)),ni=Ge.set(m.ExtHostContext.ExtHostWebviews,new pe.ExtHostWebviews(Ge,at.remote,ft,gt,De)),yi=Ge.set(m.ExtHostContext.ExtHostWebviewPanels,new ae.ExtHostWebviewPanels(Ge,ni,ft)),Di=Ge.set(m.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(Ge,ht,Mt,ni,yi)),Ii=Ge.set(m.ExtHostContext.ExtHostWebviewViews,new he.ExtHostWebviewViews(Ge,ni)),Yt=Ge.set(m.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(Ge,Qe,Me)),Ci=Ge.set(m.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(Ge)),$i=Ge.set(m.ExtHostContext.ExtHostProfileContentHandlers,new St.ExtHostProfileContentHandlers(Ge));Ge.set(m.ExtHostContext.ExtHostInteractive,new Le.ExtHostInteractive(Ge,Et,Me,Qe,gt));const ki=Object.values(m.ExtHostContext);Ge.assertRegistered(ki);const Ti=new be.ExtHostBulkEdits(Ge,Me),zi=new s.ExtHostClipboard(Ge),Pi=new g.ExtHostMessageService(Ge,gt),Fi=new P.ExtHostDialogs(Ge),Ni=new x.ExtHostStatusBar(Ge,Qe.converter);return f.ExtHostApiCommands.register(Qe),function(Ue,Gt,li){const mt=function(){let ne=!Ue.isUnderDevelopment;function fe(){ne||(gt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Ne(rt){if(Array.isArray(rt))rt.forEach(Ne);else if(typeof rt=="string")fe();else{const yt=rt;typeof yt.scheme>"u"&&fe(),typeof yt.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return rt}}(),Wi={getSession(ne,fe,Ne){return ii.getSession(Ue,ne,fe,Ne)},async hasSession(ne,fe){return(0,je.checkProposedApiEnabled)(Ue,"authSession"),!!await ii.getSession(Ue,ne,fe,{silent:!0})},get onDidChangeSessions(){return ii.onDidChangeSessions},registerAuthenticationProvider(ne,fe,Ne,rt){return ii.registerAuthenticationProvider(ne,fe,Ne,rt)}},Hi={registerCommand(ne,fe,Ne){return Qe.registerCommand(!0,ne,fe,Ne,void 0,Ue)},registerTextEditorCommand(ne,fe,Ne){return Qe.registerCommand(!0,ne,(...rt)=>{const yt=Tt.getActiveTextEditor();if(!yt){gt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return yt.edit(Pt=>{fe.apply(Ne,[yt,Pt,...rt])}).then(Pt=>{Pt||gt.warn("Edits from command "+ne+" were not applied.")},Pt=>{gt.warn("An error occurred while running command "+ne,Pt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ne,fe,Ne)=>((0,je.checkProposedApiEnabled)(Ue,"diffCommand"),Qe.registerCommand(!0,ne,async(...rt)=>{const yt=Me.activeEditor(!0);if(!yt){gt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Pt=await Tt.getDiffInformation(yt.id);fe.apply(Ne,[Pt,...rt])},void 0,void 0,Ue)),executeCommand(ne,...fe){return Qe.executeCommand(ne,...fe)},getCommands(ne=!1){return Qe.getCommands(ne)}},Li={get machineId(){return at.telemetryInfo.machineId},get sessionId(){return at.telemetryInfo.sessionId},get language(){return at.environment.appLanguage},get appName(){return at.environment.appName},get appRoot(){return at.environment.appRoot?.fsPath??""},get appHost(){return at.environment.appHost},get uriScheme(){return at.environment.appUriScheme},get clipboard(){return zi.value},get shell(){return ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.checkProposedApiEnabled)(Ue,"envShellEvent"),ze.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(at.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return(0,je.checkProposedApiEnabled)(Ue,"telemetryLogger"),Dt.instantiateLogger(Ue,ne)},openExternal(ne,fe){return Pe.openUri(ne,{allowTunneling:!!at.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===at.environment.appUriScheme)return It.createAppUri(ne);try{return await Pe.asExternalUri(ne,{allowTunneling:!!at.remote.authority})}catch(fe){if((0,_.matchesScheme)(ne,st.Schemas.http)||(0,_.matchesScheme)(ne,st.Schemas.https))return ne;throw fe}},get remoteName(){return(0,H.getRemoteName)(at.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Ue,"resolvers"),at.remote.authority},get uiKind(){return at.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return gt.onDidChangeLogLevel}};at.environment.extensionTestsLocationURI||Object.freeze(Li);const di={createTestController(ne,fe,Ne){return Yt.createTestController(Ue,ne,fe,Ne)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),Yt.createTestObserver()},runTests(ne){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),Yt.runTests(ne)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),Yt.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),Yt.results}},hi=at.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,Vi={getExtension(ne,fe){(0,je.isProposedApiEnabled)(Ue,"extensionsAny")||(fe=!1);const Ne=Gt.mine.getExtensionDescription(ne);if(Ne)return new c.Extension(Ft,Ue.identifier,Ne,hi,!1);if(fe){const rt=Gt.all.getExtensionDescription(ne);if(rt)return new c.Extension(Ft,Ue.identifier,rt,hi,!0)}},get all(){const ne=[];for(const fe of Gt.mine.getAllExtensionDescriptions())ne.push(new c.Extension(Ft,Ue.identifier,fe,hi,!1));return ne},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)(Ue,"extensionsAny");const ne=new je.ExtensionIdentifierSet(Gt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),fe=[];for(const Ne of Gt.all.getAllExtensionDescriptions()){const rt=!ne.has(Ne.identifier);fe.push(new c.Extension(Ft,Ue.identifier,Ne,hi,rt))}return fe},get onDidChange(){return(0,je.isProposedApiEnabled)(Ue,"extensionsAny")?S.Event.any(Gt.mine.onDidChange,Gt.all.onDidChange):Gt.mine.onDidChange}},ji={createDiagnosticCollection(ne){return ti.createDiagnosticCollection(Ue.identifier,ne)},get onDidChangeDiagnostics(){return ti.onDidChangeDiagnostics},getDiagnostics:ne=>ti.getDiagnostics(ne),getLanguages(){return oi.getLanguages()},setTextDocumentLanguage(ne,fe){return oi.changeLanguage(ne.uri,fe)},match(ne,fe){const Ne=ht.getDocumentData(fe.uri)?.notebook;return(0,O.score)(V.LanguageSelector.from(ne),fe.uri,fe.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(ne,fe,Ne){return ct.registerCodeActionProvider(Ue,mt(ne),fe,Ne)},registerDocumentPasteEditProvider(ne,fe,Ne){return(0,je.checkProposedApiEnabled)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,mt(ne),fe,Ne)},registerCodeLensProvider(ne,fe){return ct.registerCodeLensProvider(Ue,mt(ne),fe)},registerDefinitionProvider(ne,fe){return ct.registerDefinitionProvider(Ue,mt(ne),fe)},registerDeclarationProvider(ne,fe){return ct.registerDeclarationProvider(Ue,mt(ne),fe)},registerImplementationProvider(ne,fe){return ct.registerImplementationProvider(Ue,mt(ne),fe)},registerTypeDefinitionProvider(ne,fe){return ct.registerTypeDefinitionProvider(Ue,mt(ne),fe)},registerHoverProvider(ne,fe){return ct.registerHoverProvider(Ue,mt(ne),fe,Ue.identifier)},registerEvaluatableExpressionProvider(ne,fe){return ct.registerEvaluatableExpressionProvider(Ue,mt(ne),fe,Ue.identifier)},registerInlineValuesProvider(ne,fe){return ct.registerInlineValuesProvider(Ue,mt(ne),fe,Ue.identifier)},registerDocumentHighlightProvider(ne,fe){return ct.registerDocumentHighlightProvider(Ue,mt(ne),fe)},registerLinkedEditingRangeProvider(ne,fe){return ct.registerLinkedEditingRangeProvider(Ue,mt(ne),fe)},registerReferenceProvider(ne,fe){return ct.registerReferenceProvider(Ue,mt(ne),fe)},registerRenameProvider(ne,fe){return ct.registerRenameProvider(Ue,mt(ne),fe)},registerDocumentSymbolProvider(ne,fe,Ne){return ct.registerDocumentSymbolProvider(Ue,mt(ne),fe,Ne)},registerWorkspaceSymbolProvider(ne){return ct.registerWorkspaceSymbolProvider(Ue,ne)},registerDocumentFormattingEditProvider(ne,fe){return ct.registerDocumentFormattingEditProvider(Ue,mt(ne),fe)},registerDocumentRangeFormattingEditProvider(ne,fe){return ct.registerDocumentRangeFormattingEditProvider(Ue,mt(ne),fe)},registerOnTypeFormattingEditProvider(ne,fe,Ne,...rt){return ct.registerOnTypeFormattingEditProvider(Ue,mt(ne),fe,[Ne].concat(rt))},registerDocumentSemanticTokensProvider(ne,fe,Ne){return ct.registerDocumentSemanticTokensProvider(Ue,mt(ne),fe,Ne)},registerDocumentRangeSemanticTokensProvider(ne,fe,Ne){return ct.registerDocumentRangeSemanticTokensProvider(Ue,mt(ne),fe,Ne)},registerSignatureHelpProvider(ne,fe,Ne,...rt){return typeof Ne=="object"?ct.registerSignatureHelpProvider(Ue,mt(ne),fe,Ne):ct.registerSignatureHelpProvider(Ue,mt(ne),fe,typeof Ne>"u"?[]:[Ne,...rt])},registerCompletionItemProvider(ne,fe,...Ne){return ct.registerCompletionItemProvider(Ue,mt(ne),fe,Ne)},registerInlineCompletionItemProvider(ne,fe){return fe.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,mt(ne),fe)},registerDocumentLinkProvider(ne,fe){return ct.registerDocumentLinkProvider(Ue,mt(ne),fe)},registerColorProvider(ne,fe){return ct.registerColorProvider(Ue,mt(ne),fe)},registerFoldingRangeProvider(ne,fe){return ct.registerFoldingRangeProvider(Ue,mt(ne),fe)},registerSelectionRangeProvider(ne,fe){return ct.registerSelectionRangeProvider(Ue,ne,fe)},registerCallHierarchyProvider(ne,fe){return ct.registerCallHierarchyProvider(Ue,ne,fe)},registerTypeHierarchyProvider(ne,fe){return ct.registerTypeHierarchyProvider(Ue,ne,fe)},setLanguageConfiguration:(ne,fe)=>ct.setLanguageConfiguration(Ue,ne,fe),getTokenInformationAtPosition(ne,fe){return(0,je.checkProposedApiEnabled)(Ue,"tokenInformation"),oi.tokenAtPosition(ne,fe)},registerInlayHintsProvider(ne,fe){return ct.registerInlayHintsProvider(Ue,ne,fe)},createLanguageStatusItem(ne,fe){return oi.createLanguageStatusItem(Ue,ne,fe)},registerDocumentDropEditProvider(ne,fe){return ct.registerDocumentOnDropEditProvider(Ue,ne,fe)}},qi={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ze.activeTerminal},get terminals(){return ze.terminals},async showTextDocument(ne,fe,Ne){const rt=await(I.URI.isUri(ne)?Promise.resolve(fi.openTextDocument(ne)):Promise.resolve(ne));return Tt.showTextDocument(rt,fe,Ne)},createTextEditorDecorationType(ne){return Tt.createTextEditorDecorationType(Ue,ne)},onDidChangeActiveTextEditor(ne,fe,Ne){return Tt.onDidChangeActiveTextEditor(ne,fe,Ne)},onDidChangeVisibleTextEditors(ne,fe,Ne){return Tt.onDidChangeVisibleTextEditors(ne,fe,Ne)},onDidChangeTextEditorSelection(ne,fe,Ne){return Tt.onDidChangeTextEditorSelection(ne,fe,Ne)},onDidChangeTextEditorOptions(ne,fe,Ne){return Tt.onDidChangeTextEditorOptions(ne,fe,Ne)},onDidChangeTextEditorVisibleRanges(ne,fe,Ne){return Tt.onDidChangeTextEditorVisibleRanges(ne,fe,Ne)},onDidChangeTextEditorViewColumn(ne,fe,Ne){return Tt.onDidChangeTextEditorViewColumn(ne,fe,Ne)},onDidCloseTerminal(ne,fe,Ne){return ze.onDidCloseTerminal(ne,fe,Ne)},onDidOpenTerminal(ne,fe,Ne){return ze.onDidOpenTerminal(ne,fe,Ne)},onDidChangeActiveTerminal(ne,fe,Ne){return ze.onDidChangeActiveTerminal(ne,fe,Ne)},onDidChangeTerminalDimensions(ne,fe,Ne){return(0,je.checkProposedApiEnabled)(Ue,"terminalDimensions"),ze.onDidChangeTerminalDimensions(ne,fe,Ne)},onDidChangeTerminalState(ne,fe,Ne){return ze.onDidChangeTerminalState(ne,fe,Ne)},onDidWriteTerminalData(ne,fe,Ne){return(0,je.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),ze.onDidWriteTerminalData(ne,fe,Ne)},get state(){return Pe.state},onDidChangeWindowState(ne,fe,Ne){return Pe.onDidChangeWindowState(ne,fe,Ne)},showInformationMessage(ne,...fe){return Pi.showMessage(Ue,M.default.Info,ne,fe[0],fe.slice(1))},showWarningMessage(ne,...fe){return Pi.showMessage(Ue,M.default.Warning,ne,fe[0],fe.slice(1))},showErrorMessage(ne,...fe){return Pi.showMessage(Ue,M.default.Error,ne,fe[0],fe.slice(1))},showQuickPick(ne,fe,Ne){return Wt.showQuickPick(ne,fe,Ne)},showWorkspaceFolderPick(ne){return Wt.showWorkspaceFolderPick(ne)},showInputBox(ne,fe){return Wt.showInput(ne,fe)},showOpenDialog(ne){return Fi.showOpenDialog(ne)},showSaveDialog(ne){return Fi.showSaveDialog(ne)},createStatusBarItem(ne,fe,Ne){let rt,yt,Pt;return typeof ne=="string"?(rt=ne,yt=fe,Pt=Ne):(yt=ne,Pt=fe),Ni.createStatusBarEntry(Ue,rt,yt,Pt)},setStatusBarMessage(ne,fe){return Ni.setStatusBarMessage(ne,fe)},withScmProgress(ne){return De.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),ci.withProgress(Ue,{location:j.ProgressLocation.SourceControl},(fe,Ne)=>ne({report(rt){}}))},withProgress(ne,fe){return ci.withProgress(Ue,ne,fe)},createOutputChannel(ne,fe){return At.createOutputChannel(ne,fe,Ue)},createWebviewPanel(ne,fe,Ne,rt){return yi.createWebviewPanel(Ue,ne,fe,Ne,rt)},createWebviewTextEditorInset(ne,fe,Ne,rt){return(0,je.checkProposedApiEnabled)(Ue,"editorInsets"),jt.createWebviewEditorInset(ne,fe,Ne,rt,Ue)},createTerminal(ne,fe,Ne){return typeof ne=="object"?"pty"in ne?ze.createExtensionTerminal(ne):ze.createTerminalFromOptions(ne):ze.createTerminal(ne,fe,Ne)},registerTerminalLinkProvider(ne){return ze.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,fe){return ze.registerProfileProvider(Ue,ne,fe)},registerTerminalQuickFixProvider(ne,fe){return(0,je.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),ze.registerTerminalQuickFixProvider(ne,Ue.identifier.value,fe)},registerTreeDataProvider(ne,fe){return si.registerTreeDataProvider(ne,fe,Ue)},createTreeView(ne,fe){return si.createTreeView(ne,fe,Ue)},registerWebviewPanelSerializer:(ne,fe)=>yi.registerWebviewPanelSerializer(Ue,ne,fe),registerCustomEditorProvider:(ne,fe,Ne={})=>Di.registerCustomEditorProvider(Ue,ne,fe,Ne),registerFileDecorationProvider(ne){return Re.registerFileDecorationProvider(ne,Ue)},registerUriHandler(ne){return It.registerUriHandler(Ue.identifier,ne)},createQuickPick(){return Wt.createQuickPick(Ue)},createInputBox(){return Wt.createInputBox(Ue)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(ne,fe,Ne){return ui.onDidChangeActiveColorTheme(ne,fe,Ne)},registerWebviewViewProvider(ne,fe,Ne){return Ii.registerWebviewViewProvider(Ue,ne,fe,Ne?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,fe,Ne){return Et.onDidChangeActiveNotebookEditor(ne,fe,Ne)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,fe,Ne){return ri.onDidChangeNotebookEditorSelection(ne,fe,Ne)},onDidChangeNotebookEditorVisibleRanges(ne,fe,Ne){return ri.onDidChangeNotebookEditorVisibleRanges(ne,fe,Ne)},showNotebookDocument(ne,fe){return Et.showNotebookDocument(ne,fe)},registerExternalUriOpener(ne,fe,Ne){return(0,je.checkProposedApiEnabled)(Ue,"externalUriOpener"),Ci.registerExternalUriOpener(Ue.identifier,ne,fe,Ne)},registerProfileContentHandler(ne,fe){return(0,je.checkProposedApiEnabled)(Ue,"profileContentHandlers"),$i.registrProfileContentHandler(Ue,ne,fe)},get tabGroups(){return X.tabGroups}},fi={get rootPath(){return De.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ne){throw C.readonly()},getWorkspaceFolder(ne){return ft.getWorkspaceFolder(ne)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ne){throw C.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ne){throw C.readonly()},updateWorkspaceFolders:(ne,fe,...Ne)=>ft.updateWorkspaceFolders(Ue,ne,fe||0,...Ne),onDidChangeWorkspaceFolders:function(ne,fe,Ne){return ft.onDidChangeWorkspace(ne,fe,Ne)},asRelativePath:(ne,fe)=>ft.getRelativePath(ne,fe),findFiles:(ne,fe,Ne,rt)=>ft.findFiles(ne,fe,Ne,Ue.identifier,rt),findTextInFiles:(ne,fe,Ne,rt)=>{(0,je.checkProposedApiEnabled)(Ue,"findTextInFiles");let yt,Pt;return typeof fe=="object"?(yt=fe,Pt=Ne):(yt={},Pt=fe,rt=Ne),ft.findTextInFiles(ne,yt||{},Pt,Ue.identifier,rt)},saveAll:ne=>ft.saveAll(ne),applyEdit(ne,fe){return Ti.applyWorkspaceEdit(ne,Ue,fe)},createFileSystemWatcher:(ne,fe,Ne,rt)=>_t.createFileSystemWatcher(ft,Ue,ne,fe,Ne,rt),get textDocuments(){return ht.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw C.readonly()},openTextDocument(ne){let fe;const Ne=ne;if(typeof ne=="string")fe=Promise.resolve(I.URI.file(ne));else if(I.URI.isUri(ne))fe=Promise.resolve(ne);else if(!Ne||typeof Ne=="object")fe=ht.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(rt=>ht.ensureDocumentData(rt).then(yt=>yt.document))},onDidOpenTextDocument:(ne,fe,Ne)=>ht.onDidAddDocument(ne,fe,Ne),onDidCloseTextDocument:(ne,fe,Ne)=>ht.onDidRemoveDocument(ne,fe,Ne),onDidChangeTextDocument:(ne,fe,Ne)=>ht.onDidChangeDocument(ne,fe,Ne),onDidSaveTextDocument:(ne,fe,Ne)=>ht.onDidSaveDocument(ne,fe,Ne),onWillSaveTextDocument:(ne,fe,Ne)=>Vt.getOnWillSaveTextDocumentEvent(Ue)(ne,fe,Ne),get notebookDocuments(){return Et.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,fe){let Ne;if(I.URI.isUri(ne))Ne=ne,await Et.openNotebookDocument(ne);else if(typeof ne=="string")Ne=I.URI.revive(await Et.createNotebookDocument({viewType:ne,content:fe}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ne,fe,Ne){return Qt.onDidSaveNotebookDocument(ne,fe,Ne)},onDidChangeNotebookDocument(ne,fe,Ne){return Qt.onDidChangeNotebookDocument(ne,fe,Ne)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ne,fe,Ne,rt){return Et.registerNotebookSerializer(Ue,ne,fe,Ne,(0,je.isProposedApiEnabled)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ne,fe,Ne)=>li.onDidChangeConfiguration(ne,fe,Ne),getConfiguration(ne,fe){return fe=arguments.length===1?void 0:fe,li.getConfiguration(ne,fe,Ue)},registerTextDocumentContentProvider(ne,fe){return Kt.registerTextDocumentContentProvider(ne,fe)},registerTaskProvider:(ne,fe)=>(De.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Ue,ne,fe)),registerFileSystemProvider(ne,fe,Ne){return(0,$e.combinedDisposable)(Oi.registerFileSystemProvider(Ue,ne,fe,Ne),Ot.addFileSystemProvider(ne,fe))},get fs(){return Ot.value},registerFileSearchProvider:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"fileSearchProvider"),bt.registerFileSearchProvider(ne,fe)),registerTextSearchProvider:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"textSearchProvider"),bt.registerTextSearchProvider(ne,fe)),registerRemoteAuthorityResolver:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),Ft.registerRemoteAuthorityResolver(ne,fe)),registerResourceLabelFormatter:ne=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),wi.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,fe,Ne)=>_t.onDidCreateFile(ne,fe,Ne),onDidDeleteFiles:(ne,fe,Ne)=>_t.onDidDeleteFile(ne,fe,Ne),onDidRenameFiles:(ne,fe,Ne)=>_t.onDidRenameFile(ne,fe,Ne),onWillCreateFiles:(ne,fe,Ne)=>_t.getOnWillCreateFileEvent(Ue)(ne,fe,Ne),onWillDeleteFiles:(ne,fe,Ne)=>_t.getOnWillDeleteFileEvent(Ue)(ne,fe,Ne),onWillRenameFiles:(ne,fe,Ne)=>_t.getOnWillRenameFileEvent(Ue)(ne,fe,Ne),openTunnel:ne=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),kt.openTunnel(Ue,ne).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,je.checkProposedApiEnabled)(Ue,"tunnels"),kt.getTunnels()},onDidChangeTunnels:(ne,fe,Ne)=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),kt.onDidChangeTunnels(ne,fe,Ne)),registerPortAttributesProvider:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"portsAttributes"),kt.registerPortsAttributesProvider(ne,fe)),registerTimelineProvider:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"timeline"),Si.registerTimelineProvider(ne,fe,Ue.identifier,Qe.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ne=>((0,je.checkProposedApiEnabled)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,fe,Ne)=>ft.onDidGrantWorkspaceTrust(ne,fe,Ne),registerEditSessionIdentityProvider:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ne,fe))},Ki={get inputBox(){return De.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ai.getLastInputBox(Ue)},createSourceControl(ne,fe,Ne){return ai.createSourceControl(Ue,ne,fe,Ne)}},xt={createCommentController(ne,fe){return Ei.createCommentController(Ue,ne,fe)}},mi={get activeDebugSession(){return Ze.activeDebugSession},get activeDebugConsole(){return Ze.activeDebugConsole},get breakpoints(){return Ze.breakpoints},onDidStartDebugSession(ne,fe,Ne){return Ze.onDidStartDebugSession(ne,fe,Ne)},onDidTerminateDebugSession(ne,fe,Ne){return Ze.onDidTerminateDebugSession(ne,fe,Ne)},onDidChangeActiveDebugSession(ne,fe,Ne){return Ze.onDidChangeActiveDebugSession(ne,fe,Ne)},onDidReceiveDebugSessionCustomEvent(ne,fe,Ne){return Ze.onDidReceiveDebugSessionCustomEvent(ne,fe,Ne)},onDidChangeBreakpoints(ne,fe,Ne){return Ze.onDidChangeBreakpoints(ne,fe,Ne)},registerDebugConfigurationProvider(ne,fe,Ne){return Ze.registerDebugConfigurationProvider(ne,fe,Ne||_e.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,fe){return Ze.registerDebugAdapterDescriptorFactory(Ue,ne,fe)},registerDebugAdapterTrackerFactory(ne,fe){return Ze.registerDebugAdapterTrackerFactory(ne,fe)},startDebugging(ne,fe,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?Ze.startDebugging(ne,fe,{parentSession:Ne}):Ze.startDebugging(ne,fe,Ne||{})},stopDebugging(ne){return Ze.stopDebugging(ne)},addBreakpoints(ne){return Ze.addBreakpoints(ne)},removeBreakpoints(ne){return Ze.removeBreakpoints(ne)},asDebugSourceUri(ne,fe){return Ze.asDebugSourceUri(ne,fe)}},Gi={registerTaskProvider:(ne,fe)=>vt.registerTaskProvider(Ue,ne,fe),fetchTasks:ne=>vt.fetchTasks(ne),executeTask:ne=>vt.executeTask(Ue,ne),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(ne,fe,Ne)=>vt.onDidStartTask(ne,fe,Ne),onDidEndTask:(ne,fe,Ne)=>vt.onDidEndTask(ne,fe,Ne),onDidStartTaskProcess:(ne,fe,Ne)=>vt.onDidStartTaskProcess(ne,fe,Ne),onDidEndTaskProcess:(ne,fe,Ne)=>vt.onDidEndTaskProcess(ne,fe,Ne)},zt={createNotebookController(ne,fe,Ne,rt,yt){return ei.createNotebookController(Ue,ne,fe,Ne,rt,(0,je.isProposedApiEnabled)(Ue,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,fe)=>Et.registerNotebookCellStatusBarItemProvider(Ue,ne,fe),createRendererMessaging(ne){return bi.createRendererMessaging(Ue,ne)},createNotebookControllerDetectionTask(ne){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),ei.createNotebookControllerDetectionTask(Ue,ne)},registerKernelSourceActionProvider(ne,fe){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),ei.registerKernelSourceActionProvider(Ue,ne,fe)},onDidChangeNotebookCellExecutionState(ne,fe,Ne){return(0,je.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),ei.onDidChangeNotebookCellExecutionState(ne,fe,Ne)}},gi={t(...ne){if(typeof ne[0]=="string"){const fe=ne.shift(),Ne=!ne||typeof ne[0]!="object"?ne:ne[0];return pt.getMessage(Ue.identifier.value,{message:fe,args:Ne})}return pt.getMessage(Ue.identifier.value,ne[0])},get bundle(){return pt.getBundle(Ue.identifier.value)},get uri(){return pt.getBundleUri(Ue.identifier.value)}};return{version:at.version,authentication:Wi,commands:Hi,comments:xt,debug:mi,env:Li,extensions:Vi,l10n:gi,languages:ji,notebooks:zt,scm:Ki,tasks:Gi,tests:di,window:qi,workspace:fi,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:C.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:_e.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:k.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:b.UIKind,Uri:I.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:le.TelemetryTrustedValue,LogLevel:xe.LogLevel,EditSessionIdentityMatch:wt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Ct}),define(Ie[252],Ce([1,0,251,33,2,245,7,16,236]),function(te,e,n,C,S,M,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class k extends M.RequireInterceptor{j(){}getModule(b,f){for(const s of this.b){const o=s(b);if(o){b=o;break}}if(this.a.has(b))return this.a.get(b).load(b,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Webworker}async nb(){this.h.createInstance(y.ExtHostConsoleForwarder);const b=this.h.invokeFunction(n.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(k,b,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.tb()}ob(b){return b.browser}async pb(b,f,s){f=f.with({path:w(f.path,".js")});const o=b?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const l=S.URI.revive(await this.v.$asBrowserUri(f)),v=await fetch(l.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),v.status!==200)throw new Error(v.statusText);const E=await v.text(),P=`${f.toString(!0)}#vscode-extension`,p=`${E}
//# sourceURL=${P}`;let r;try{r=new Function("module","exports","require",p)}catch(t){throw console.error(o?`Loading code for extension ${o} failed: ${t.message}`:`Loading code failed: ${t.message}`),console.error(`${f.toString(!0)}${typeof t.line=="number"?` line ${t.line}`:""}${typeof t.column=="number"?` column ${t.column}`:""}`),console.error(t),t}b&&await this.s.initializeLocalizedMessages(b);const d={},i={exports:d},c=t=>{const h=this.r.getModule(t,f);if(h===void 0)throw new Error(`Cannot load module '${t}'`);return h};try{return s.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),r(i,d,c),i.exports!==d?i.exports:d}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}}async $setRemoteEnvironment(b){}async tb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+b;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=O;function w(m,b){return m.endsWith(b)?m:m+b}}),define(Ie[253],Ce([1,0,66,33,81,252]),function(te,e,n,C,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(C.IExtHostExtensionService,M.ExtHostExtensionService,0),(0,n.registerSingleton)(S.IExtensionStoragePaths,S.ExtensionStoragePaths,0)}),define(Ie[261],Ce([1,0,24,4,73,246,238,19,82,15,2,248,253]),function(te,e,n,C,S,M,I,A,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(r){return/^(file|vscode-remote):/i.test(r)}const f=fetch.bind(self);function s(r){self.fetch=async function(d,i){return d instanceof Request||b(String(d))&&(d=(await r(O.URI.parse(String(d)))).toString(!0)),f(d,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,i,c,t,h){(async()=>(b(i.toString())&&(i=(await r(O.URI.parse(i.toString()))).toString(!0)),super.open(d,i,c??!0,t,h)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(d,i){if(/^file:/i.test(d.toString()))d=k.FileAccess.uriToBrowserUri(O.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const t=`(${function(g){function R(Z){return typeof Z=="string"||Z instanceof URL?String(Z).replace(/^file:\/\//i,"vscode-file://vscode-app"):Z}const F=fetch.bind(self);self.fetch=function(Z,x){return Z instanceof Request?F(Z,x):F(R(Z),x)},self.XMLHttpRequest=class extends XMLHttpRequest{open(Z,x,N,$,T){return super.open(Z,R(x),N??!0,$,T)}};const q=importScripts.bind(self);self.importScripts=(...Z)=>{q(...Z.map(R))},q(g)}.toString()}('${d}'))`;i=i||{},i.name=i.name||A.basename(d.toString());const h=new Blob([t],{type:"application/javascript"}),a=URL.createObjectURL(h);return new r(a,i)}}else self.Worker=class extends I.NestedWorker{constructor(r,d){super(m,r,{name:A.basename(r.toString()),...d})}};const o=new class{constructor(){this.pid=void 0}exit(r){w()}async exists(r){return!0}async realpath(r){return r}};class l{constructor(){const d=new MessageChannel,i=new C.Emitter;let c=!1;m(d.port2,[d.port2]),d.port1.onmessage=t=>{const{data:h}=t;if(!(h instanceof ArrayBuffer)){console.warn("UNKNOWN data received",h);return}const a=n.VSBuffer.wrap(new Uint8Array(h,0,h.byteLength));if((0,S.isMessageOfType)(a,2)){c=!0,E("received terminate message from renderer");return}i.fire(a)},this.protocol={onMessage:i.event,send:t=>{if(!c){const h=t.buffer.buffer.slice(t.buffer.byteOffset,t.buffer.byteOffset+t.buffer.byteLength);d.port1.postMessage(h,[h])}}}}}function v(r){return new Promise(d=>{const i=r.onMessage(c=>{i.dispose();const t=JSON.parse(c.toString());r.send((0,S.createMessageOfType)(0)),d({protocol:r,initData:t})});r.send((0,S.createMessageOfType)(1))})}let E=r=>w();function P(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function p(){y.mark("code/extHost/willConnectToRenderer");const r=new l;return{onmessage(d){!P(d)||v(r.protocol).then(i=>{y.mark("code/extHost/didWaitForInitData");const c=new M.ExtensionHostMain(i.protocol,i.initData,o,null,d.data);s(t=>c.asBrowserUri(t)),E=t=>c.terminate(t)})}}}e.create=p})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/89e427274e1c9e555f8bfa21bd1e9c50c0225403/core/vs/workbench/api/worker/extensionHostWorker.js.map
